/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/platform","vs/base/common/path","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/resources","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/log/common/log","vs/base/common/types","vs/base/common/network","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/strings","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/buffer","vs/base/common/objects","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/registry/common/platform","vs/base/common/json","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/platform/configuration/common/configurationRegistry","vs/base/common/map","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","child_process","vs/base/common/errorMessage","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/codicons","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","path","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(G){for(var e=[],v=0,R=G.length;v<R;v++)e[v]=Z[G[v]];return e};define(Z[88],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(R,L){if(!R)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=v}),define(Z[63],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const v=Object.prototype.hasOwnProperty;function R(n){const m=[];for(let h in n)v.call(n,h)&&m.push(n[h]);return m}e.values=R;function L(n,m){for(let h in n)if(v.call(n,h)&&m({key:h,value:n[h]},function(){delete n[h]})===!1)return}e.forEach=L;function k(n,m){const h=Object.create(null);for(const b of n){const f=m(b);let C=h[f];C||(C=h[f]=[]),C.push(b)}return h}e.groupBy=k;function O(n){const m=Object.create(null);return n&&n.forEach((h,b)=>{m[b]=h}),m}e.fromMap=O;function D(n,m){const h=[],b=[];for(let f of n)m.has(f)||h.push(f);for(let f of m)n.has(f)||b.push(f);return{removed:h,added:b}}e.diffSets=D;function y(n,m){const h=[],b=[];for(let[f,C]of n)m.has(f)||h.push(C);for(let[f,C]of m)n.has(f)||b.push(C);return{removed:h,added:b}}e.diffMaps=y;class S{constructor(){this.map=new Map}add(m,h){let b=this.map.get(m);b||(b=new Set,this.map.set(m,b)),b.add(h)}delete(m,h){const b=this.map.get(m);!b||(b.delete(h),b.size===0&&this.map.delete(m))}forEach(m,h){const b=this.map.get(m);!b||b.forEach(h)}}e.SetMap=S}),define(Z[64],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(O){return(D,y,S)=>{let n=null,m=null;if(typeof S.value=="function"?(n="value",m=S.value):typeof S.get=="function"&&(n="get",m=S.get),!m)throw new Error("not supported");S[n]=O(m,y)}}e.createDecorator=v;function R(O,D,y){let S=null,n=null;if(typeof y.value=="function"?(S="value",n=y.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(S="get",n=y.get),!n)throw new Error("not supported");const m=`$memoize$${D}`;y[S]=function(...h){return this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,h)}),this[m]}}e.memoize=R;function L(O,D,y){return v((S,n)=>{const m=`$debounce$${n}`,h=`$debounce$result$${n}`;return function(...b){this[h]||(this[h]=y?y():void 0),clearTimeout(this[m]),D&&(this[h]=D(this[h],...b),b=[this[h]]),this[m]=setTimeout(()=>{S.apply(this,b),this[h]=y?y():void 0},O)}})}e.debounce=L;function k(O,D,y){return v((S,n)=>{const m=`$throttle$timer$${n}`,h=`$throttle$result$${n}`,b=`$throttle$lastRun$${n}`,f=`$throttle$pending$${n}`;return function(...C){if(this[h]||(this[h]=y?y():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),D&&(this[h]=D(this[h],...C)),this[f])return;const P=this[b]+O;P<=Date.now()?(this[b]=Date.now(),S.apply(this,[this[h]]),this[h]=y?y():void 0):(this[f]=!0,this[m]=setTimeout(()=>{this[f]=!1,this[b]=Date.now(),S.apply(this,[this[h]]),this[h]=y?y():void 0},P-Date.now()))}})}e.throttle=k}),define(Z[11],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function R(s){e.errorHandler.setUnexpectedErrorHandler(s)}e.setUnexpectedErrorHandler=R;function L(s){y(s)||e.errorHandler.onUnexpectedError(s)}e.onUnexpectedError=L;function k(s){y(s)||e.errorHandler.onUnexpectedExternalError(s)}e.onUnexpectedExternalError=k;function O(s){if(s instanceof Error){let{name:t,message:r}=s;const i=s.stacktrace||s.stack;return{$isError:!0,name:t,message:r,stack:i}}return s}e.transformErrorForSerialization=O;const D="Canceled";function y(s){return s instanceof Error&&s.name===D&&s.message===D}e.isPromiseCanceledError=y;class S extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=S;function n(){const s=new Error(D);return s.name=s.message,s}e.canceled=n;function m(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}e.illegalArgument=m;function h(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}e.illegalState=h;function b(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function f(s){const t=new Error(`${s} has been disposed`);return t.name="DISPOSED",t}e.disposed=f;function C(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}e.getErrorMessage=C;class P extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=P;class E extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=E;class I extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=I;function d(s){const t=s;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=d;function c(s,t=Object.create(null)){const r=new Error(s);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=c}),define(Z[19],ee([0,1,11]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(_,T=0){return _[_.length-(1+T)]}e.tail=R;function L(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}e.tail2=L;function k(_,T,A=(M,N)=>M===N){if(_===T)return!0;if(!_||!T||_.length!==T.length)return!1;for(let M=0,N=_.length;M<N;M++)if(!A(_[M],T[M]))return!1;return!0}e.equals=k;function O(_,T,A){let M=0,N=_.length-1;for(;M<=N;){const B=(M+N)/2|0,W=A(_[B],T);if(W<0)M=B+1;else if(W>0)N=B-1;else return B}return-(M+1)}e.binarySearch=O;function D(_,T){let A=0,M=_.length;if(M===0)return 0;for(;A<M;){const N=Math.floor((A+M)/2);T(_[N])?M=N:A=N+1}return A}e.findFirstInSorted=D;function y(_,T,A){if(_=_|0,_>=T.length)throw new TypeError("invalid index");let M=T[Math.floor(T.length*Math.random())],N=[],B=[],W=[];for(let Q of T){const J=A(Q,M);J<0?N.push(Q):J>0?B.push(Q):W.push(Q)}return _<N.length?y(_,N,A):_<N.length+W.length?W[0]:y(_-(N.length+W.length),B,A)}e.quickSelect=y;function S(_,T){const A=[];let M;for(const N of _.slice(0).sort(T))!M||T(M[0],N)!==0?(M=[N],A.push(M)):M.push(N);return A}e.groupBy=S;function n(_,T,A){const M=[];function N(Q,J,ie){if(J===0&&ie.length===0)return;const ne=M[M.length-1];ne&&ne.start+ne.deleteCount===Q?(ne.deleteCount+=J,ne.toInsert.push(...ie)):M.push({start:Q,deleteCount:J,toInsert:ie})}let B=0,W=0;for(;;){if(B===_.length){N(B,0,T.slice(W));break}if(W===T.length){N(B,_.length-B,[]);break}const Q=_[B],J=T[W],ie=A(Q,J);ie===0?(B+=1,W+=1):ie<0?(N(B,1,[]),B+=1):ie>0&&(N(B,0,[J]),W+=1)}return M}e.sortedDiff=n;function m(_,T,A){const M=n(_,T,A),N=[],B=[];for(const W of M)N.push(..._.slice(W.start,W.start+W.deleteCount)),B.push(...W.toInsert);return{removed:N,added:B}}e.delta=m;function h(_,T,A){if(A===0)return[];const M=_.slice(0,A).sort(T);return f(_,T,M,A,_.length),M}e.top=h;function b(_,T,A,M,N){return A===0?Promise.resolve([]):new Promise((B,W)=>{(async()=>{const Q=_.length,J=_.slice(0,A).sort(T);for(let ie=A,ne=Math.min(A+M,Q);ie<Q;ie=ne,ne=Math.min(ne+M,Q)){if(ie>A&&await new Promise(ce=>setTimeout(ce)),N&&N.isCancellationRequested)throw v.canceled();f(_,T,J,ie,ne)}return J})().then(B,W)})}e.topAsync=b;function f(_,T,A,M,N){for(const B=A.length;M<N;M++){const W=_[M];if(T(W,A[B-1])<0){A.pop();const Q=D(A,J=>T(W,J)<0);A.splice(Q,0,W)}}}function C(_){return _.filter(T=>!!T)}e.coalesce=C;function P(_){let T=0;for(let A=0;A<_.length;A++)_[A]&&(_[T]=_[A],T+=1);_.length=T}e.coalesceInPlace=P;function E(_,T,A){_.splice(A,0,_.splice(T,1)[0])}e.move=E;function I(_){return!Array.isArray(_)||_.length===0}e.isFalsyOrEmpty=I;function d(_){return Array.isArray(_)&&_.length>0}e.isNonEmptyArray=d;function c(_,T){if(!T)return _.filter((M,N)=>_.indexOf(M)===N);const A=Object.create(null);return _.filter(M=>{const N=T(M);return A[N]?!1:(A[N]=!0,!0)})}e.distinct=c;function s(_){const T=new Set;return _.filter(A=>T.has(A)?!1:(T.add(A),!0))}e.distinctES6=s;function t(_){const T=Object.create(null);return A=>{const M=_(A);return T[M]?!1:(T[M]=!0,!0)}}e.uniqueFilter=t;function r(_,T){for(let A=_.length-1;A>=0;A--){const M=_[A];if(T(M))return A}return-1}e.lastIndex=r;function i(_,T){return _.length>0?_[0]:T}e.firstOrDefault=i;function a(_,T,A=(M,N)=>M===N){let M=0;for(let N=0,B=Math.min(_.length,T.length);N<B&&A(_[N],T[N]);N++)M++;return M}e.commonPrefixLength=a;function u(_){return[].concat(..._)}e.flatten=u;function o(_,T){let A=typeof T=="number"?_:0;typeof T=="number"?A=_:(A=0,T=_);const M=[];if(A<=T)for(let N=A;N<T;N++)M.push(N);else for(let N=A;N>T;N--)M.push(N);return M}e.range=o;function l(_,T,A){return _.reduce((M,N)=>(M[T(N)]=A?A(N):N,M),Object.create(null))}e.index=l;function p(_,T){return _.push(T),()=>w(_,T)}e.insert=p;function w(_,T){const A=_.indexOf(T);if(A>-1)return _.splice(A,1),T}e.remove=w;function g(_,T,A){const M=_.slice(0,T),N=_.slice(T);return M.concat(A,N)}e.arrayInsert=g;function U(_,T){let A;if(typeof T=="number"){let M=T;A=()=>{const N=Math.sin(M++)*179426549;return N-Math.floor(N)}}else A=Math.random;for(let M=_.length-1;M>0;M-=1){const N=Math.floor(A()*(M+1)),B=_[M];_[M]=_[N],_[N]=B}}e.shuffle=U;function F(_,T){const A=_.indexOf(T);A>-1&&(_.splice(A,1),_.unshift(T))}e.pushToStart=F;function j(_,T){const A=_.indexOf(T);A>-1&&(_.splice(A,1),_.push(T))}e.pushToEnd=j;function z(_,T){return Array.isArray(_)?_.map(T):T(_)}e.mapArrayOrNot=z;function V(_){return Array.isArray(_)?_:[_]}e.asArray=V;function q(_){return _[Math.floor(Math.random()*_.length)]}e.getRandomElement=q;function $(_,T){for(const A of _){const M=T(A);if(M!==void 0)return M}}e.mapFind=$;function H(_,T){let A=Number.MAX_SAFE_INTEGER,M=0;return _.forEach((N,B)=>{const W=T(N);W<A&&(A=W,M=B)}),M}e.minIndex=H;function X(_,T){let A=Number.MIN_SAFE_INTEGER,M=0;return _.forEach((N,B)=>{const W=T(N);W>A&&(A=W,M=B)}),M}e.maxIndex=X}),define(Z[65],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(R){const L=this;let k=!1,O;return function(){return k||(k=!0,O=R.apply(L,arguments)),O}}e.once=v}),define(Z[53],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(R){function L(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}R.is=L;const k=Object.freeze([]);function O(){return k}R.empty=O;function*D(s){yield s}R.single=D;function y(s){return s||k}R.from=y;function S(s){return!s||s[Symbol.iterator]().next().done===!0}R.isEmpty=S;function n(s){return s[Symbol.iterator]().next().value}R.first=n;function m(s,t){for(const r of s)if(t(r))return!0;return!1}R.some=m;function h(s,t){for(const r of s)if(t(r))return r}R.find=h;function*b(s,t){for(const r of s)t(r)&&(yield r)}R.filter=b;function*f(s,t){let r=0;for(const i of s)yield t(i,r++)}R.map=f;function*C(...s){for(const t of s)for(const r of t)yield r}R.concat=C;function*P(s){for(const t of s)for(const r of t)yield r}R.concatNested=P;function E(s,t,r){let i=r;for(const a of s)i=t(i,a);return i}R.reduce=E;function*I(s,t,r=s.length){for(t<0&&(t+=s.length),r<0?r+=s.length:r>s.length&&(r=s.length);t<r;t++)yield s[t]}R.slice=I;function d(s,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,s];const i=s[Symbol.iterator]();for(let a=0;a<t;a++){const u=i.next();if(u.done)return[r,R.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return i}}]}R.consume=d;function c(s,t,r=(i,a)=>i===a){const i=s[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const u=i.next(),o=a.next();if(u.done!==o.done)return!1;if(u.done)return!0;if(!r(u.value,o.value))return!1}}R.equals=c})(v=e.Iterable||(e.Iterable={}))}),define(Z[32],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function O(t,r=!1){let i=0,a=t.length,u="",o=0,l=16,p=0;function w(q){let $=0,H=0;for(;$<q;){const X=t.charCodeAt(i);if(X>=48&&X<=57)H=H*16+X-48;else if(X>=65&&X<=70)H=H*16+X-65+10;else if(X>=97&&X<=102)H=H*16+X-97+10;else break;i++,$++}return $<q&&(H=-1),H}function g(q){i=q,u="",o=0,l=16,p=0}function U(){const q=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&S(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&S(t.charCodeAt(i)))for(i++;i<t.length&&S(t.charCodeAt(i));)i++;else return p=3,t.substring(q,i);let $=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&S(t.charCodeAt(i))){for(i++;i<t.length&&S(t.charCodeAt(i));)i++;$=i}else p=3;return t.substring(q,$)}function F(){let q="",$=i;for(;;){if(i>=a){q+=t.substring($,i),p=2;break}const H=t.charCodeAt(i);if(H===34){q+=t.substring($,i),i++;break}if(H===92){if(q+=t.substring($,i),i++,i>=a){p=2;break}switch(t.charCodeAt(i++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:const _=w(4);_>=0?q+=String.fromCharCode(_):p=4;break;default:p=5}$=i;continue}if(H>=0&&H<=31)if(y(H)){q+=t.substring($,i),p=2;break}else p=6;i++}return q}function j(){if(u="",p=0,o=i,i>=a)return o=a,l=17;let q=t.charCodeAt(i);if(D(q)){do i++,u+=String.fromCharCode(q),q=t.charCodeAt(i);while(D(q));return l=15}if(y(q))return i++,u+=String.fromCharCode(q),q===13&&t.charCodeAt(i)===10&&(i++,u+=`
`),l=14;switch(q){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,u=F(),l=10;case 47:const $=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<a&&!y(t.charCodeAt(i));)i++;return u=t.substring($,i),l=12}if(t.charCodeAt(i+1)===42){i+=2;const H=a-1;let X=!1;for(;i<H;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,X=!0;break}i++}return X||(i++,p=1),u=t.substring($,i),l=13}return u+=String.fromCharCode(q),i++,l=16;case 45:if(u+=String.fromCharCode(q),i++,i===a||!S(t.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=U(),l=11;default:for(;i<a&&z(q);)i++,q=t.charCodeAt(i);if(o!==i){switch(u=t.substring(o,i),u){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return u+=String.fromCharCode(q),i++,l=16}}function z(q){if(D(q)||y(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let q;do q=j();while(q>=12&&q<=15);return q}return{setPosition:g,getPosition:()=>i,scan:r?V:j,getToken:()=>l,getTokenValue:()=>u,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>p}}e.createScanner=O;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function S(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function m(t,r){const i=[],a=new Object;let u;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function p(w,g,U,F){o.value=w,o.offset=g,o.length=U,o.type=F,o.colonOffset=void 0,u=o}try{d(t,{onObjectBegin:(w,g)=>{if(r<=w)throw a;u=void 0,l=r>w,i.push("")},onObjectProperty:(w,g,U)=>{if(r<g||(p(w,g,U,"property"),i[i.length-1]=w,r<=g+U))throw a},onObjectEnd:(w,g)=>{if(r<=w)throw a;u=void 0,i.pop()},onArrayBegin:(w,g)=>{if(r<=w)throw a;u=void 0,i.push(0)},onArrayEnd:(w,g)=>{if(r<=w)throw a;u=void 0,i.pop()},onLiteralValue:(w,g,U)=>{if(r<g||(p(w,g,U,s(w)),r<=g+U))throw a},onSeparator:(w,g,U)=>{if(r<=g)throw a;if(w===":"&&u&&u.type==="property")u.colonOffset=g,l=!1,u=void 0;else if(w===","){const F=i[i.length-1];typeof F=="number"?i[i.length-1]=F+1:(l=!0,i[i.length-1]=""),u=void 0}}})}catch(w){if(w!==a)throw w}return{path:i,previousNode:u,isAtPropertyKey:l,matches:w=>{let g=0;for(let U=0;g<w.length&&U<i.length;U++)if(w[g]===i[U]||w[g]==="*")g++;else if(w[g]!=="**")return!1;return g===w.length}}}e.getLocation=m;function h(t,r=[],i=k.DEFAULT){let a=null,u=[];const o=[];function l(w){Array.isArray(u)?u.push(w):a!==null&&(u[a]=w)}return d(t,{onObjectBegin:()=>{const w={};l(w),o.push(u),u=w,a=null},onObjectProperty:w=>{a=w},onObjectEnd:()=>{u=o.pop()},onArrayBegin:()=>{const w=[];l(w),o.push(u),u=w,a=null},onArrayEnd:()=>{u=o.pop()},onLiteralValue:l,onError:(w,g,U)=>{r.push({error:w,offset:g,length:U})}},i),u[0]}e.parse=h;function b(t,r=[],i=k.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(w){a.type==="property"&&(a.length=w-a.offset,a=a.parent)}function o(w){return a.children.push(w),w}d(t,{onObjectBegin:w=>{a=o({type:"object",offset:w,length:-1,parent:a,children:[]})},onObjectProperty:(w,g,U)=>{a=o({type:"property",offset:g,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:w,offset:g,length:U,parent:a})},onObjectEnd:(w,g)=>{a.length=w+g-a.offset,a=a.parent,u(w+g)},onArrayBegin:(w,g)=>{a=o({type:"array",offset:w,length:-1,parent:a,children:[]})},onArrayEnd:(w,g)=>{a.length=w+g-a.offset,a=a.parent,u(w+g)},onLiteralValue:(w,g,U)=>{o({type:s(w),offset:g,length:U,parent:a,value:w}),u(g+U)},onSeparator:(w,g,U)=>{a.type==="property"&&(w===":"?a.colonOffset=g:w===","&&u(g))},onError:(w,g,U)=>{r.push({error:w,offset:g,length:U})}},i);const p=a.children[0];return p&&delete p.parent,p}e.parseTree=b;function f(t,r){if(!t)return;let i=t;for(let a of r)if(typeof a=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let u=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===a){i=o.children[1],u=!0;break}if(!u)return}else{const u=a;if(i.type!=="array"||u<0||!Array.isArray(i.children)||u>=i.children.length)return;i=i.children[u]}return i}e.findNodeAtLocation=f;function C(t){if(!t.parent||!t.parent.children)return[];const r=C(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=C;function P(t){switch(t.type){case"array":return t.children.map(P);case"object":const r=Object.create(null);for(let i of t.children){const a=i.children[1];a&&(r[i.children[0].value]=P(a))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=P;function E(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=E;function I(t,r,i=!1){if(E(t,r,i)){const a=t.children;if(Array.isArray(a))for(let u=0;u<a.length&&a[u].offset<=r;u++){const o=I(a[u],r,i);if(o)return o}return t}}e.findNodeAtOffset=I;function d(t,r,i=k.DEFAULT){const a=O(t,!1);function u(W){return W?()=>W(a.getTokenOffset(),a.getTokenLength()):()=>!0}function o(W){return W?Q=>W(Q,a.getTokenOffset(),a.getTokenLength()):()=>!0}const l=u(r.onObjectBegin),p=o(r.onObjectProperty),w=u(r.onObjectEnd),g=u(r.onArrayBegin),U=u(r.onArrayEnd),F=o(r.onLiteralValue),j=o(r.onSeparator),z=u(r.onComment),V=o(r.onError),q=i&&i.disallowComments,$=i&&i.allowTrailingComma;function H(){for(;;){const W=a.scan();switch(a.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:q||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(W){case 12:case 13:q?X(10):z();break;case 16:X(1);break;case 15:case 14:break;default:return W}}}function X(W,Q=[],J=[]){if(V(W),Q.length+J.length>0){let ie=a.getToken();for(;ie!==17;){if(Q.indexOf(ie)!==-1){H();break}else if(J.indexOf(ie)!==-1)break;ie=H()}}}function _(W){const Q=a.getTokenValue();return W?F(Q):p(Q),H(),!0}function T(){switch(a.getToken()){case 11:let W=0;try{W=JSON.parse(a.getTokenValue()),typeof W!="number"&&(X(2),W=0)}catch(Q){X(2)}F(W);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return H(),!0}function A(){return a.getToken()!==10?(X(3,[],[2,5]),!1):(_(!1),a.getToken()===6?(j(":"),H(),B()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function M(){l(),H();let W=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(W||X(4,[],[]),j(","),H(),a.getToken()===2&&$)break}else W&&X(6,[],[]);A()||X(4,[],[2,5]),W=!0}return w(),a.getToken()!==2?X(7,[2],[]):H(),!0}function N(){g(),H();let W=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(W||X(4,[],[]),j(","),H(),a.getToken()===4&&$)break}else W&&X(6,[],[]);B()||X(4,[],[4,5]),W=!0}return U(),a.getToken()!==4?X(8,[4],[]):H(),!0}function B(){switch(a.getToken()){case 3:return N();case 1:return M();case 10:return _(!0);default:return T()}}return H(),a.getToken()===17?i.allowEmptyContent?!0:(X(4,[],[]),!1):B()?(a.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=d;function c(t,r){let i=O(t),a=[],u,o=0,l;do switch(l=i.getPosition(),u=i.scan(),u){case 12:case 13:case 17:o!==l&&a.push(t.substring(o,l)),r!==void 0&&a.push(i.getTokenValue().replace(/[^\r\n]/g,r)),o=i.getPosition();break}while(u!==17);return a.join("")}e.stripComments=c;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),define(Z[46],ee([0,1,32]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(y,S,n){let m,h,b,f,C;if(S){for(f=S.offset,C=f+S.length,b=f;b>0&&!D(y,b-1);)b--;let o=C;for(;o<y.length&&!D(y,o);)o++;h=y.substring(b,o),m=k(h,n)}else h=y,m=0,b=0,f=0,C=y.length;const P=O(n,y);let E=!1,I=0,d;n.insertSpaces?d=L(" ",n.tabSize||4):d="	";const c=v.createScanner(h,!1);let s=!1;function t(){return P+L(d,m+I)}function r(){let o=c.scan();for(E=!1;o===15||o===14;)E=E||o===14,o=c.scan();return s=o===16||c.getTokenError()!==0,o}const i=[];function a(o,l,p){!s&&l<C&&p>f&&y.substring(l,p)!==o&&i.push({offset:l,length:p-l,content:o})}let u=r();if(u!==17){const o=c.getTokenOffset()+b,l=L(d,m);a(l,b,o)}for(;u!==17;){let o=c.getTokenOffset()+c.getTokenLength()+b,l=r(),p="";for(;!E&&(l===12||l===13);){const g=c.getTokenOffset()+b;a(" ",o,g),o=c.getTokenOffset()+c.getTokenLength()+b,p=l===12?t():"",l=r()}if(l===2)u!==1&&(I--,p=t());else if(l===4)u!==3&&(I--,p=t());else{switch(u){case 3:case 1:I++,p=t();break;case 5:case 12:p=t();break;case 13:E?p=t():p=" ";break;case 6:p=" ";break;case 10:if(l===6){p="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?p=" ":l!==5&&l!==17&&(s=!0);break;case 16:s=!0;break}E&&(l===12||l===13)&&(p=t())}const w=c.getTokenOffset()+b;a(p,o,w),u=l}return i}e.format=R;function L(y,S){let n="";for(let m=0;m<S;m++)n+=y;return n}function k(y,S){let n=0,m=0;const h=S.tabSize||4;for(;n<y.length;){const b=y.charAt(n);if(b===" ")m++;else if(b==="	")m+=h;else break;n++}return Math.floor(m/h)}function O(y,S){for(let n=0;n<S.length;n++){const m=S.charAt(n);if(m==="\r")return n+1<S.length&&S.charAt(n+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=O;function D(y,S){return`\r
`.indexOf(y.charAt(S))!==-1}e.isEOL=D}),define(Z[40],ee([0,1,32,46]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(S,n,m){return k(S,n,void 0,m)}e.removeProperty=L;function k(S,n,m,h,b){const f=n.slice(),C=[],P=v.parseTree(S,C);let E,I;for(;f.length>0&&(I=f.pop(),E=v.findNodeAtLocation(P,f),E===void 0&&m!==void 0);)typeof I=="string"?m={[I]:m}:m=[m];if(E)if(E.type==="object"&&typeof I=="string"&&Array.isArray(E.children)){const d=v.findNodeAtLocation(E,[I]);if(d!==void 0)if(m===void 0){if(!d.parent)throw new Error("Malformed AST");const c=E.children.indexOf(d.parent);let s,t=d.parent.offset+d.parent.length;if(c>0){const r=E.children[c-1];s=r.offset+r.length}else s=E.offset+1,E.children.length>1&&(t=E.children[1].offset);return O(S,{offset:s,length:t-s,content:""},h)}else return O(S,{offset:d.offset,length:d.length,content:JSON.stringify(m)},h);else{if(m===void 0)return[];const c=`${JSON.stringify(I)}: ${JSON.stringify(m)}`,s=b?b(E.children.map(r=>r.children[0].value)):E.children.length;let t;if(s>0){const r=E.children[s-1];t={offset:r.offset+r.length,length:0,content:","+c}}else E.children.length===0?t={offset:E.offset+1,length:0,content:c}:t={offset:E.offset+1,length:0,content:c+","};return O(S,t,h)}}else if(E.type==="array"&&typeof I=="number"&&Array.isArray(E.children))if(m!==void 0){const d=`${JSON.stringify(m)}`;let c;if(E.children.length===0||I===0)c={offset:E.offset+1,length:0,content:E.children.length===0?d:d+","};else{const s=I===-1||I>E.children.length?E.children.length:I,t=E.children[s-1];c={offset:t.offset+t.length,length:0,content:","+d}}return O(S,c,h)}else{const d=I,c=E.children[d];let s;if(E.children.length===1)s={offset:E.offset+1,length:E.length-2,content:""};else if(E.children.length-1===d){const t=E.children[d-1],r=t.offset+t.length,i=E.offset+E.length;s={offset:r,length:i-2-r,content:""}}else s={offset:c.offset,length:E.children[d+1].offset-c.offset,content:""};return O(S,s,h)}else throw new Error(`Can not add ${typeof I!="number"?"index":"property"} to parent of type ${E.type}`);else{if(m===void 0)throw new Error("Can not delete in empty document");return O(S,{offset:P?P.offset:0,length:P?P.length:0,content:JSON.stringify(m)},h)}}e.setProperty=k;function O(S,n,m){let h=D(S,n),b=n.offset,f=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;b>0&&!R.isEOL(h,b-1);)b--;for(;f<h.length&&!R.isEOL(h,f);)f++}const C=R.format(h,{offset:b,length:f-b},m);for(let E=C.length-1;E>=0;E--){const I=C[E];h=D(h,I),b=Math.min(b,I.offset),f=Math.max(f,I.offset+I.length),f+=I.content.length-I.length}const P=S.length-(h.length-f)-b;return[{offset:b,length:P,content:h.substring(b,f)}]}e.withFormatting=O;function D(S,n){return S.substring(0,n.offset)+n.content+S.substring(n.offset+n.length)}e.applyEdit=D;function y(S,n){let m=n.slice(0).sort((b,f)=>{const C=b.offset-f.offset;return C===0?b.length-f.length:C}),h=S.length;for(let b=m.length-1;b>=0;b--){let f=m[b];if(f.offset+f.length<=h)S=D(S,f);else throw new Error("Overlapping edit");h=f.offset}return S}e.applyEdits=y}),define(Z[2],ee([0,1,65,53]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const L=!1;let k=null;function O(c){k=c}if(e.setDisposableTracker=O,L){const c="__is_disposable_tracked__";k=new class{trackDisposable(s){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[c]||console.log(t)},3e3)}markTracked(s){if(s&&s!==C.None)try{s[c]=!0}catch(t){}}}}function D(c){!k||k.markTracked(c)}function y(c){return k&&k.trackDisposable(c),c}e.trackDisposable=y;class S extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=S;function n(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=n;function m(c){if(R.Iterable.is(c)){let s=[];for(const t of c)if(t){D(t);try{t.dispose()}catch(r){s.push(r)}}if(s.length===1)throw s[0];if(s.length>1)throw new S(s);return Array.isArray(c)?[]:c}else if(c)return D(c),c.dispose(),c}e.dispose=m;function h(...c){return c.forEach(D),b(()=>m(c))}e.combinedDisposable=h;function b(c){const s=y({dispose:()=>{D(s),c()}});return s}e.toDisposable=b;class f{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{m(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return D(s),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class C{constructor(){this._store=new f,y(this)}dispose(){D(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=C,C.None=Object.freeze({dispose(){}});class P{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){var t;this._isDisposed||s===this._value||((t=this._value)===null||t===void 0||t.dispose(),s&&D(s),this._value=s)}clear(){this.value=void 0}dispose(){var s;this._isDisposed=!0,D(this),(s=this._value)===null||s===void 0||s.dispose(),this._value=void 0}}e.MutableDisposable=P;class E{constructor(){this.references=new Map}acquire(s,...t){let r=this.references.get(s);r||(r={counter:0,object:this.createReferencedObject(s,...t)},this.references.set(s,r));const{object:i}=r,a=v.once(()=>{--r.counter==0&&(this.destroyReferencedObject(s,r.object),this.references.delete(s))});return r.counter++,{object:i,dispose:a}}}e.ReferenceCollection=E;class I{constructor(s){this.referenceCollection=s}async acquire(s,...t){const r=this.referenceCollection.acquire(s,...t);try{return{object:await r.object,dispose:()=>r.dispose()}}catch(i){throw r.dispose(),i}}}e.AsyncReferenceCollection=I;class d{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=d}),define(Z[66],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(k){this.element=k,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class R{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let k=this._first;for(;k!==v.Undefined;){const O=k.next;k.prev=v.Undefined,k.next=v.Undefined,k=O}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,O){const D=new v(k);if(this._first===v.Undefined)this._first=D,this._last=D;else if(O){const S=this._last;this._last=D,D.prev=S,S.next=D}else{const S=this._first;this._first=D,D.next=S,S.prev=D}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(D))}}shift(){if(this._first!==v.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==v.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==v.Undefined&&k.next!==v.Undefined){const O=k.prev;O.next=k.next,k.next.prev=O}else k.prev===v.Undefined&&k.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):k.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):k.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==v.Undefined;)yield k.element,k=k.next}}e.LinkedList=R}),function(){function G(L){const k=[];typeof L=="number"&&k.push("code/timeOrigin",L);function O(y){k.push(y,Date.now())}function D(){const y=[];for(let S=0;S<k.length;S+=2)y.push({name:k[S],startTime:k[S+1]});return y}return{mark:O,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const O of performance.getEntriesByType("mark"))k.push({name:O.name,startTime:Math.round(L+O.startTime)});return k}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function v(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=v(R))}(),define(Z[7],ee([0,1]),function(G,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let L=!1,k=!1,O=!1,D=!1,y=!1,S=!1,n=!1,m,h=R,b,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let C;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?C=e.globals.vscode.process:typeof process!="undefined"&&(C=process);const P=typeof((v=C==null?void 0:C.versions)===null||v===void 0?void 0:v.electron)=="string"&&C.type==="renderer";if(e.isElectronSandboxed=P&&(C==null?void 0:C.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const a=C==null?void 0:C.env.VSCODE_BROWSER_CODE_LOADING;if(typeof a=="string")return a==="none"||a==="code"||a==="bypassHeatCheck"||a==="bypassHeatCheckAndEagerCompile"?a:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!P)f=navigator.userAgent,L=f.indexOf("Windows")>=0,k=f.indexOf("Macintosh")>=0,n=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=f.indexOf("Linux")>=0,S=!0,m=navigator.language,h=m;else if(typeof C=="object"){L=C.platform==="win32",k=C.platform==="darwin",O=C.platform==="linux",D=O&&!!C.env.SNAP&&!!C.env.SNAP_REVISION,m=R,h=R;const a=C.env.VSCODE_NLS_CONFIG;if(a)try{const u=JSON.parse(a),o=u.availableLanguages["*"];m=u.locale,h=o||R,b=u._translationsConfigFile}catch(u){}y=!0}else console.error("Unable to resolve platform.");var E;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function I(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=I;let d=0;k?d=1:L?d=3:O&&(d=2),e.isWindows=L,e.isMacintosh=k,e.isLinux=O,e.isLinuxSnap=D,e.isNative=y,e.isWeb=S,e.isIOS=n,e.platform=d,e.userAgent=f,e.language=h;var c;(function(a){function u(){return e.language}a.value=u;function o(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=o;function l(){return e.language==="en"}a.isDefault=l})(c=e.Language||(e.Language={})),e.locale=m,e.translationsConfigFile=b,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeSetImmediateId)for(let w=0,g=o.length;w<g;w++){const U=o[w];if(U.id===p.data.vscodeSetImmediateId){o.splice(w,1),U.callback();return}}});let l=0;return p=>{const w=++l;o.push({id:w,callback:p}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof(C==null?void 0:C.nextTick)=="function")return C.nextTick.bind(C);const u=Promise.resolve();return o=>u.then(o)}();var s;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||n?2:L?1:3;let t=!0,r=!1;function i(){if(!r){r=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,t=new Uint16Array(a.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=i}),define(Z[34],ee([0,1,7]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const L=v.globals.vscode.process;R={get platform(){return L.platform},get env(){return L.env},cwd(){return L.cwd()},nextTick(k){return v.setImmediate(k)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(L){return process.nextTick(L)}}:R={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(L){return v.setImmediate(L)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(Z[8],ee([0,1,34]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,L=97,k=90,O=122,D=46,y=47,S=92,n=58,m=63;class h extends Error{constructor(c,s,t){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const i=c.indexOf(".")!==-1?"property":"argument";let a=`The "${c}" ${i} ${r} of type ${s}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function b(d,c){if(typeof d!="string")throw new h(c,"string",d)}function f(d){return d===y||d===S}function C(d){return d===y}function P(d){return d>=R&&d<=k||d>=L&&d<=O}function E(d,c,s,t){let r="",i=0,a=-1,u=0,o=0;for(let l=0;l<=d.length;++l){if(l<d.length)o=d.charCodeAt(l);else{if(t(o))break;o=y}if(t(o)){if(!(a===l-1||u===1))if(u===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==D||r.charCodeAt(r.length-2)!==D){if(r.length>2){const p=r.lastIndexOf(s);p===-1?(r="",i=0):(r=r.slice(0,p),i=r.length-1-r.lastIndexOf(s)),a=l,u=0;continue}else if(r.length!==0){r="",i=0,a=l,u=0;continue}}c&&(r+=r.length>0?`${s}..`:"..",i=2)}else r.length>0?r+=`${s}${d.slice(a+1,l)}`:r=d.slice(a+1,l),i=l-a-1;a=l,u=0}else o===D&&u!==-1?++u:u=-1}return r}function I(d,c){if(c===null||typeof c!="object")throw new h("pathObject","Object",c);const s=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return s?s===c.root?`${s}${t}`:`${s}${d}${t}`:t}e.win32={resolve(...d){let c="",s="",t=!1;for(let r=d.length-1;r>=-1;r--){let i;if(r>=0){if(i=d[r],b(i,"path"),i.length===0)continue}else c.length===0?i=v.cwd():(i=v.env[`=${c}`]||v.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==c.toLowerCase()&&i.charCodeAt(2)===S)&&(i=`${c}\\`));const a=i.length;let u=0,o="",l=!1;const p=i.charCodeAt(0);if(a===1)f(p)&&(u=1,l=!0);else if(f(p))if(l=!0,f(i.charCodeAt(1))){let w=2,g=w;for(;w<a&&!f(i.charCodeAt(w));)w++;if(w<a&&w!==g){const U=i.slice(g,w);for(g=w;w<a&&f(i.charCodeAt(w));)w++;if(w<a&&w!==g){for(g=w;w<a&&!f(i.charCodeAt(w));)w++;(w===a||w!==g)&&(o=`\\\\${U}\\${i.slice(g,w)}`,u=w)}}}else u=1;else P(p)&&i.charCodeAt(1)===n&&(o=i.slice(0,2),u=2,a>2&&f(i.charCodeAt(2))&&(l=!0,u=3));if(o.length>0)if(c.length>0){if(o.toLowerCase()!==c.toLowerCase())continue}else c=o;if(t){if(c.length>0)break}else if(s=`${i.slice(u)}\\${s}`,t=l,l&&c.length>0)break}return s=E(s,!t,"\\",f),t?`${c}\\${s}`:`${c}${s}`||"."},normalize(d){b(d,"path");const c=d.length;if(c===0)return".";let s=0,t,r=!1;const i=d.charCodeAt(0);if(c===1)return C(i)?"\\":d;if(f(i))if(r=!0,f(d.charCodeAt(1))){let u=2,o=u;for(;u<c&&!f(d.charCodeAt(u));)u++;if(u<c&&u!==o){const l=d.slice(o,u);for(o=u;u<c&&f(d.charCodeAt(u));)u++;if(u<c&&u!==o){for(o=u;u<c&&!f(d.charCodeAt(u));)u++;if(u===c)return`\\\\${l}\\${d.slice(o)}\\`;u!==o&&(t=`\\\\${l}\\${d.slice(o,u)}`,s=u)}}}else s=1;else P(i)&&d.charCodeAt(1)===n&&(t=d.slice(0,2),s=2,c>2&&f(d.charCodeAt(2))&&(r=!0,s=3));let a=s<c?E(d.slice(s),!r,"\\",f):"";return a.length===0&&!r&&(a="."),a.length>0&&f(d.charCodeAt(c-1))&&(a+="\\"),t===void 0?r?`\\${a}`:a:r?`${t}\\${a}`:`${t}${a}`},isAbsolute(d){b(d,"path");const c=d.length;if(c===0)return!1;const s=d.charCodeAt(0);return f(s)||c>2&&P(s)&&d.charCodeAt(1)===n&&f(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let c,s;for(let i=0;i<d.length;++i){const a=d[i];b(a,"path"),a.length>0&&(c===void 0?c=s=a:c+=`\\${a}`)}if(c===void 0)return".";let t=!0,r=0;if(typeof s=="string"&&f(s.charCodeAt(0))){++r;const i=s.length;i>1&&f(s.charCodeAt(1))&&(++r,i>2&&(f(s.charCodeAt(2))?++r:t=!1))}if(t){for(;r<c.length&&f(c.charCodeAt(r));)r++;r>=2&&(c=`\\${c.slice(r)}`)}return e.win32.normalize(c)},relative(d,c){if(b(d,"from"),b(c,"to"),d===c)return"";const s=e.win32.resolve(d),t=e.win32.resolve(c);if(s===t||(d=s.toLowerCase(),c=t.toLowerCase(),d===c))return"";let r=0;for(;r<d.length&&d.charCodeAt(r)===S;)r++;let i=d.length;for(;i-1>r&&d.charCodeAt(i-1)===S;)i--;const a=i-r;let u=0;for(;u<c.length&&c.charCodeAt(u)===S;)u++;let o=c.length;for(;o-1>u&&c.charCodeAt(o-1)===S;)o--;const l=o-u,p=a<l?a:l;let w=-1,g=0;for(;g<p;g++){const F=d.charCodeAt(r+g);if(F!==c.charCodeAt(u+g))break;F===S&&(w=g)}if(g!==p){if(w===-1)return t}else{if(l>p){if(c.charCodeAt(u+g)===S)return t.slice(u+g+1);if(g===2)return t.slice(u+g)}a>p&&(d.charCodeAt(r+g)===S?w=g:g===2&&(w=3)),w===-1&&(w=0)}let U="";for(g=r+w+1;g<=i;++g)(g===i||d.charCodeAt(g)===S)&&(U+=U.length===0?"..":"\\..");return u+=w,U.length>0?`${U}${t.slice(u,o)}`:(t.charCodeAt(u)===S&&++u,t.slice(u,o))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const c=e.win32.resolve(d);if(c.length<=2)return d;if(c.charCodeAt(0)===S){if(c.charCodeAt(1)===S){const s=c.charCodeAt(2);if(s!==m&&s!==D)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(P(c.charCodeAt(0))&&c.charCodeAt(1)===n&&c.charCodeAt(2)===S)return`\\\\?\\${c}`;return d},dirname(d){b(d,"path");const c=d.length;if(c===0)return".";let s=-1,t=0;const r=d.charCodeAt(0);if(c===1)return f(r)?d:".";if(f(r)){if(s=t=1,f(d.charCodeAt(1))){let u=2,o=u;for(;u<c&&!f(d.charCodeAt(u));)u++;if(u<c&&u!==o){for(o=u;u<c&&f(d.charCodeAt(u));)u++;if(u<c&&u!==o){for(o=u;u<c&&!f(d.charCodeAt(u));)u++;if(u===c)return d;u!==o&&(s=t=u+1)}}}}else P(r)&&d.charCodeAt(1)===n&&(s=c>2&&f(d.charCodeAt(2))?3:2,t=s);let i=-1,a=!0;for(let u=c-1;u>=t;--u)if(f(d.charCodeAt(u))){if(!a){i=u;break}}else a=!1;if(i===-1){if(s===-1)return".";i=s}return d.slice(0,i)},basename(d,c){c!==void 0&&b(c,"ext"),b(d,"path");let s=0,t=-1,r=!0,i;if(d.length>=2&&P(d.charCodeAt(0))&&d.charCodeAt(1)===n&&(s=2),c!==void 0&&c.length>0&&c.length<=d.length){if(c===d)return"";let a=c.length-1,u=-1;for(i=d.length-1;i>=s;--i){const o=d.charCodeAt(i);if(f(o)){if(!r){s=i+1;break}}else u===-1&&(r=!1,u=i+1),a>=0&&(o===c.charCodeAt(a)?--a==-1&&(t=i):(a=-1,t=u))}return s===t?t=u:t===-1&&(t=d.length),d.slice(s,t)}for(i=d.length-1;i>=s;--i)if(f(d.charCodeAt(i))){if(!r){s=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":d.slice(s,t)},extname(d){b(d,"path");let c=0,s=-1,t=0,r=-1,i=!0,a=0;d.length>=2&&d.charCodeAt(1)===n&&P(d.charCodeAt(0))&&(c=t=2);for(let u=d.length-1;u>=c;--u){const o=d.charCodeAt(u);if(f(o)){if(!i){t=u+1;break}continue}r===-1&&(i=!1,r=u+1),o===D?s===-1?s=u:a!==1&&(a=1):s!==-1&&(a=-1)}return s===-1||r===-1||a===0||a===1&&s===r-1&&s===t+1?"":d.slice(s,r)},format:I.bind(null,"\\"),parse(d){b(d,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return c;const s=d.length;let t=0,r=d.charCodeAt(0);if(s===1)return f(r)?(c.root=c.dir=d,c):(c.base=c.name=d,c);if(f(r)){if(t=1,f(d.charCodeAt(1))){let w=2,g=w;for(;w<s&&!f(d.charCodeAt(w));)w++;if(w<s&&w!==g){for(g=w;w<s&&f(d.charCodeAt(w));)w++;if(w<s&&w!==g){for(g=w;w<s&&!f(d.charCodeAt(w));)w++;w===s?t=w:w!==g&&(t=w+1)}}}}else if(P(r)&&d.charCodeAt(1)===n){if(s<=2)return c.root=c.dir=d,c;if(t=2,f(d.charCodeAt(2))){if(s===3)return c.root=c.dir=d,c;t=3}}t>0&&(c.root=d.slice(0,t));let i=-1,a=t,u=-1,o=!0,l=d.length-1,p=0;for(;l>=t;--l){if(r=d.charCodeAt(l),f(r)){if(!o){a=l+1;break}continue}u===-1&&(o=!1,u=l+1),r===D?i===-1?i=l:p!==1&&(p=1):i!==-1&&(p=-1)}return u!==-1&&(i===-1||p===0||p===1&&i===u-1&&i===a+1?c.base=c.name=d.slice(a,u):(c.name=d.slice(a,i),c.base=d.slice(a,u),c.ext=d.slice(i,u))),a>0&&a!==t?c.dir=d.slice(0,a-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let c="",s=!1;for(let t=d.length-1;t>=-1&&!s;t--){const r=t>=0?d[t]:v.cwd();b(r,"path"),r.length!==0&&(c=`${r}/${c}`,s=r.charCodeAt(0)===y)}return c=E(c,!s,"/",C),s?`/${c}`:c.length>0?c:"."},normalize(d){if(b(d,"path"),d.length===0)return".";const c=d.charCodeAt(0)===y,s=d.charCodeAt(d.length-1)===y;return d=E(d,!c,"/",C),d.length===0?c?"/":s?"./":".":(s&&(d+="/"),c?`/${d}`:d)},isAbsolute(d){return b(d,"path"),d.length>0&&d.charCodeAt(0)===y},join(...d){if(d.length===0)return".";let c;for(let s=0;s<d.length;++s){const t=d[s];b(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(d,c){if(b(d,"from"),b(c,"to"),d===c||(d=e.posix.resolve(d),c=e.posix.resolve(c),d===c))return"";const s=1,t=d.length,r=t-s,i=1,a=c.length-i,u=r<a?r:a;let o=-1,l=0;for(;l<u;l++){const w=d.charCodeAt(s+l);if(w!==c.charCodeAt(i+l))break;w===y&&(o=l)}if(l===u)if(a>u){if(c.charCodeAt(i+l)===y)return c.slice(i+l+1);if(l===0)return c.slice(i+l)}else r>u&&(d.charCodeAt(s+l)===y?o=l:l===0&&(o=0));let p="";for(l=s+o+1;l<=t;++l)(l===t||d.charCodeAt(l)===y)&&(p+=p.length===0?"..":"/..");return`${p}${c.slice(i+o)}`},toNamespacedPath(d){return d},dirname(d){if(b(d,"path"),d.length===0)return".";const c=d.charCodeAt(0)===y;let s=-1,t=!0;for(let r=d.length-1;r>=1;--r)if(d.charCodeAt(r)===y){if(!t){s=r;break}}else t=!1;return s===-1?c?"/":".":c&&s===1?"//":d.slice(0,s)},basename(d,c){c!==void 0&&b(c,"ext"),b(d,"path");let s=0,t=-1,r=!0,i;if(c!==void 0&&c.length>0&&c.length<=d.length){if(c===d)return"";let a=c.length-1,u=-1;for(i=d.length-1;i>=0;--i){const o=d.charCodeAt(i);if(o===y){if(!r){s=i+1;break}}else u===-1&&(r=!1,u=i+1),a>=0&&(o===c.charCodeAt(a)?--a==-1&&(t=i):(a=-1,t=u))}return s===t?t=u:t===-1&&(t=d.length),d.slice(s,t)}for(i=d.length-1;i>=0;--i)if(d.charCodeAt(i)===y){if(!r){s=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":d.slice(s,t)},extname(d){b(d,"path");let c=-1,s=0,t=-1,r=!0,i=0;for(let a=d.length-1;a>=0;--a){const u=d.charCodeAt(a);if(u===y){if(!r){s=a+1;break}continue}t===-1&&(r=!1,t=a+1),u===D?c===-1?c=a:i!==1&&(i=1):c!==-1&&(i=-1)}return c===-1||t===-1||i===0||i===1&&c===t-1&&c===s+1?"":d.slice(c,t)},format:I.bind(null,"/"),parse(d){b(d,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return c;const s=d.charCodeAt(0)===y;let t;s?(c.root="/",t=1):t=0;let r=-1,i=0,a=-1,u=!0,o=d.length-1,l=0;for(;o>=t;--o){const p=d.charCodeAt(o);if(p===y){if(!u){i=o+1;break}continue}a===-1&&(u=!1,a=o+1),p===D?r===-1?r=o:l!==1&&(l=1):r!==-1&&(l=-1)}if(a!==-1){const p=i===0&&s?1:i;r===-1||l===0||l===1&&r===a-1&&r===i+1?c.base=c.name=d.slice(p,a):(c.name=d.slice(p,r),c.base=d.slice(p,a),c.ext=d.slice(r,a))}return i>0?c.dir=d.slice(0,i-1):s&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var R in v)(typeof exports=="object"?exports:G)[R]=v[R]}}(typeof self!="undefined"?self:this,function(){return function(G){var e={};function v(R){if(e[R])return e[R].exports;var L=e[R]={i:R,l:!1,exports:{}};return G[R].call(L.exports,L,L.exports,v),L.l=!0,L.exports}return v.m=G,v.c=e,v.d=function(R,L,k){v.o(R,L)||Object.defineProperty(R,L,{enumerable:!0,get:k})},v.r=function(R){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},v.t=function(R,L){if(1&L&&(R=v(R)),8&L||4&L&&typeof R=="object"&&R&&R.__esModule)return R;var k=Object.create(null);if(v.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:R}),2&L&&typeof R!="string")for(var O in R)v.d(k,O,function(D){return R[D]}.bind(null,O));return k},v.n=function(R){var L=R&&R.__esModule?function(){return R.default}:function(){return R};return v.d(L,"a",L),L},v.o=function(R,L){return Object.prototype.hasOwnProperty.call(R,L)},v.p="",v(v.s=0)}([function(G,e,v){(function(R){var L;e=G.exports=J,L=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],y=e.src=[],S=0,n=S++;y[n]="0|[1-9]\\d*";var m=S++;y[m]="[0-9]+";var h=S++;y[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=S++;y[b]="("+y[n]+")\\.("+y[n]+")\\.("+y[n]+")";var f=S++;y[f]="("+y[m]+")\\.("+y[m]+")\\.("+y[m]+")";var C=S++;y[C]="(?:"+y[n]+"|"+y[h]+")";var P=S++;y[P]="(?:"+y[m]+"|"+y[h]+")";var E=S++;y[E]="(?:-("+y[C]+"(?:\\."+y[C]+")*))";var I=S++;y[I]="(?:-?("+y[P]+"(?:\\."+y[P]+")*))";var d=S++;y[d]="[0-9A-Za-z-]+";var c=S++;y[c]="(?:\\+("+y[d]+"(?:\\."+y[d]+")*))";var s=S++,t="v?"+y[b]+y[E]+"?"+y[c]+"?";y[s]="^"+t+"$";var r="[v=\\s]*"+y[f]+y[I]+"?"+y[c]+"?",i=S++;y[i]="^"+r+"$";var a=S++;y[a]="((?:<|>)?=?)";var u=S++;y[u]=y[m]+"|x|X|\\*";var o=S++;y[o]=y[n]+"|x|X|\\*";var l=S++;y[l]="[v=\\s]*("+y[o]+")(?:\\.("+y[o]+")(?:\\.("+y[o]+")(?:"+y[E]+")?"+y[c]+"?)?)?";var p=S++;y[p]="[v=\\s]*("+y[u]+")(?:\\.("+y[u]+")(?:\\.("+y[u]+")(?:"+y[I]+")?"+y[c]+"?)?)?";var w=S++;y[w]="^"+y[a]+"\\s*"+y[l]+"$";var g=S++;y[g]="^"+y[a]+"\\s*"+y[p]+"$";var U=S++;y[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=S++;y[F]="(?:~>?)";var j=S++;y[j]="(\\s*)"+y[F]+"\\s+",D[j]=new RegExp(y[j],"g");var z=S++;y[z]="^"+y[F]+y[l]+"$";var V=S++;y[V]="^"+y[F]+y[p]+"$";var q=S++;y[q]="(?:\\^)";var $=S++;y[$]="(\\s*)"+y[q]+"\\s+",D[$]=new RegExp(y[$],"g");var H=S++;y[H]="^"+y[q]+y[l]+"$";var X=S++;y[X]="^"+y[q]+y[p]+"$";var _=S++;y[_]="^"+y[a]+"\\s*("+r+")$|^$";var T=S++;y[T]="^"+y[a]+"\\s*("+t+")$|^$";var A=S++;y[A]="(\\s*)"+y[a]+"\\s*("+r+"|"+y[l]+")",D[A]=new RegExp(y[A],"g");var M=S++;y[M]="^\\s*("+y[l]+")\\s+-\\s+("+y[l]+")\\s*$";var N=S++;y[N]="^\\s*("+y[p]+")\\s+-\\s+("+y[p]+")\\s*$";var B=S++;y[B]="(<|>)?=?\\s*\\*";for(var W=0;W<35;W++)L(W,y[W]),D[W]||(D[W]=new RegExp(y[W]));function Q(Y,re){if(Y instanceof J)return Y;if(typeof Y!="string"||Y.length>k||!(re?D[i]:D[s]).test(Y))return null;try{return new J(Y,re)}catch(se){return null}}function J(Y,re){if(Y instanceof J){if(Y.loose===re)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof J))return new J(Y,re);L("SemVer",Y,re),this.loose=re;var se=Y.trim().match(re?D[i]:D[s]);if(!se)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var Se=+me;if(Se>=0&&Se<O)return Se}return me}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=Q,e.valid=function(Y,re){var se=Q(Y,re);return se?se.version:null},e.clean=function(Y,re){var se=Q(Y.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=J,J.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},J.prototype.toString=function(){return this.version},J.prototype.compare=function(Y){return L("SemVer.compare",this.version,this.loose,Y),Y instanceof J||(Y=new J(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},J.prototype.compareMain=function(Y){return Y instanceof J||(Y=new J(Y,this.loose)),ne(this.major,Y.major)||ne(this.minor,Y.minor)||ne(this.patch,Y.patch)},J.prototype.comparePre=function(Y){if(Y instanceof J||(Y=new J(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],me=Y.prerelease[re];if(L("prerelease compare",re,se,me),se===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(se===void 0)return-1;if(se!==me)return ne(se,me)}while(++re)},J.prototype.inc=function(Y,re){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,re,se,me){typeof se=="string"&&(me=se,se=void 0);try{return new J(Y,se).inc(re,me).version}catch(Se){return null}},e.diff=function(Y,re){if(pe(Y,re))return null;var se=Q(Y),me=Q(re);if(se.prerelease.length||me.prerelease.length){for(var Se in se)if((Se==="major"||Se==="minor"||Se==="patch")&&se[Se]!==me[Se])return"pre"+Se;return"prerelease"}for(var Se in se)if((Se==="major"||Se==="minor"||Se==="patch")&&se[Se]!==me[Se])return Se},e.compareIdentifiers=ne;var ie=/^[0-9]+$/;function ne(Y,re){var se=ie.test(Y),me=ie.test(re);return se&&me&&(Y=+Y,re=+re),se&&!me?-1:me&&!se?1:Y<re?-1:Y>re?1:0}function ce(Y,re,se){return new J(Y,se).compare(new J(re,se))}function le(Y,re,se){return ce(Y,re,se)>0}function ve(Y,re,se){return ce(Y,re,se)<0}function pe(Y,re,se){return ce(Y,re,se)===0}function Ce(Y,re,se){return ce(Y,re,se)!==0}function Ae(Y,re,se){return ce(Y,re,se)>=0}function Me(Y,re,se){return ce(Y,re,se)<=0}function Oe(Y,re,se,me){var Se;switch(re){case"===":typeof Y=="object"&&(Y=Y.version),typeof se=="object"&&(se=se.version),Se=Y===se;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof se=="object"&&(se=se.version),Se=Y!==se;break;case"":case"=":case"==":Se=pe(Y,se,me);break;case"!=":Se=Ce(Y,se,me);break;case">":Se=le(Y,se,me);break;case">=":Se=Ae(Y,se,me);break;case"<":Se=ve(Y,se,me);break;case"<=":Se=Me(Y,se,me);break;default:throw new TypeError("Invalid operator: "+re)}return Se}function ke(Y,re){if(Y instanceof ke){if(Y.loose===re)return Y;Y=Y.value}if(!(this instanceof ke))return new ke(Y,re);L("comparator",Y,re),this.loose=re,this.parse(Y),this.semver===je?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(Y,re){return ne(re,Y)},e.major=function(Y,re){return new J(Y,re).major},e.minor=function(Y,re){return new J(Y,re).minor},e.patch=function(Y,re){return new J(Y,re).patch},e.compare=ce,e.compareLoose=function(Y,re){return ce(Y,re,!0)},e.rcompare=function(Y,re,se){return ce(re,Y,se)},e.sort=function(Y,re){return Y.sort(function(se,me){return e.compare(se,me,re)})},e.rsort=function(Y,re){return Y.sort(function(se,me){return e.rcompare(se,me,re)})},e.gt=le,e.lt=ve,e.eq=pe,e.neq=Ce,e.gte=Ae,e.lte=Me,e.cmp=Oe,e.Comparator=ke;var je={};function Ie(Y,re){if(Y instanceof Ie)return Y.loose===re?Y:new Ie(Y.raw,re);if(Y instanceof ke)return new Ie(Y.value,re);if(!(this instanceof Ie))return new Ie(Y,re);if(this.loose=re,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function Te(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function Ke(Y,re,se,me,Se,De,be,Ue,Pe,x,te,ae,oe){return((re=Te(se)?"":Te(me)?">="+se+".0.0":Te(Se)?">="+se+"."+me+".0":">="+re)+" "+(Ue=Te(Pe)?"":Te(x)?"<"+(+Pe+1)+".0.0":Te(te)?"<"+Pe+"."+(+x+1)+".0":ae?"<="+Pe+"."+x+"."+te+"-"+ae:"<="+Ue)).trim()}function Ye(Y,re){for(var se=0;se<Y.length;se++)if(!Y[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<Y.length;se++)if(L(Y[se].semver),Y[se].semver!==je&&Y[se].semver.prerelease.length>0){var me=Y[se].semver;if(me.major===re.major&&me.minor===re.minor&&me.patch===re.patch)return!0}return!1}return!0}function ze(Y,re,se){try{re=new Ie(re,se)}catch(me){return!1}return re.test(Y)}function qe(Y,re,se,me){var Se,De,be,Ue,Pe;switch(Y=new J(Y,me),re=new Ie(re,me),se){case">":Se=le,De=Me,be=ve,Ue=">",Pe=">=";break;case"<":Se=ve,De=Ae,be=le,Ue="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(Y,re,me))return!1;for(var x=0;x<re.set.length;++x){var te=re.set[x],ae=null,oe=null;if(te.forEach(function(he){he.semver===je&&(he=new ke(">=0.0.0")),ae=ae||he,oe=oe||he,Se(he.semver,ae.semver,me)?ae=he:be(he.semver,oe.semver,me)&&(oe=he)}),ae.operator===Ue||ae.operator===Pe||(!oe.operator||oe.operator===Ue)&&De(Y,oe.semver)||oe.operator===Pe&&be(Y,oe.semver))return!1}return!0}ke.prototype.parse=function(Y){var re=this.loose?D[_]:D[T],se=Y.match(re);if(!se)throw new TypeError("Invalid comparator: "+Y);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new J(se[2],this.loose):this.semver=je},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(Y){return L("Comparator.test",Y,this.loose),this.semver===je||(typeof Y=="string"&&(Y=new J(Y,this.loose)),Oe(Y,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(Y,re){if(!(Y instanceof ke))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new Ie(Y.value,re),ze(this.value,se,re);if(Y.operator==="")return se=new Ie(this.value,re),ze(Y.semver,se,re);var me=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),De=this.semver.version===Y.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),Ue=Oe(this.semver,"<",Y.semver,re)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),Pe=Oe(this.semver,">",Y.semver,re)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return me||Se||De&&be||Ue||Pe},e.Range=Ie,Ie.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},Ie.prototype.toString=function(){return this.range},Ie.prototype.parseRange=function(Y){var re=this.loose;Y=Y.trim(),L("range",Y,re);var se=re?D[N]:D[M];Y=Y.replace(se,Ke),L("hyphen replace",Y),Y=Y.replace(D[A],"$1$2$3"),L("comparator trim",Y,D[A]),Y=(Y=(Y=Y.replace(D[j],"$1~")).replace(D[$],"$1^")).split(/\s+/).join(" ");var me=re?D[_]:D[T],Se=Y.split(" ").map(function(De){return function(be,Ue){return L("comp",be),be=function(Pe,x){return Pe.trim().split(/\s+/).map(function(te){return function(ae,oe){L("caret",ae,oe);var he=oe?D[X]:D[H];return ae.replace(he,function(ge,fe,ye,we,Ee){var ue;return L("caret",ae,ge,fe,ye,we,Ee),Te(fe)?ue="":Te(ye)?ue=">="+fe+".0.0 <"+(+fe+1)+".0.0":Te(we)?ue=fe==="0"?">="+fe+"."+ye+".0 <"+fe+"."+(+ye+1)+".0":">="+fe+"."+ye+".0 <"+(+fe+1)+".0.0":Ee?(L("replaceCaret pr",Ee),Ee.charAt(0)!=="-"&&(Ee="-"+Ee),ue=fe==="0"?ye==="0"?">="+fe+"."+ye+"."+we+Ee+" <"+fe+"."+ye+"."+(+we+1):">="+fe+"."+ye+"."+we+Ee+" <"+fe+"."+(+ye+1)+".0":">="+fe+"."+ye+"."+we+Ee+" <"+(+fe+1)+".0.0"):(L("no pr"),ue=fe==="0"?ye==="0"?">="+fe+"."+ye+"."+we+" <"+fe+"."+ye+"."+(+we+1):">="+fe+"."+ye+"."+we+" <"+fe+"."+(+ye+1)+".0":">="+fe+"."+ye+"."+we+" <"+(+fe+1)+".0.0"),L("caret return",ue),ue})}(te,x)}).join(" ")}(be,Ue),L("caret",be),be=function(Pe,x){return Pe.trim().split(/\s+/).map(function(te){return function(ae,oe){var he=oe?D[V]:D[z];return ae.replace(he,function(ge,fe,ye,we,Ee){var ue;return L("tilde",ae,ge,fe,ye,we,Ee),Te(fe)?ue="":Te(ye)?ue=">="+fe+".0.0 <"+(+fe+1)+".0.0":Te(we)?ue=">="+fe+"."+ye+".0 <"+fe+"."+(+ye+1)+".0":Ee?(L("replaceTilde pr",Ee),Ee.charAt(0)!=="-"&&(Ee="-"+Ee),ue=">="+fe+"."+ye+"."+we+Ee+" <"+fe+"."+(+ye+1)+".0"):ue=">="+fe+"."+ye+"."+we+" <"+fe+"."+(+ye+1)+".0",L("tilde return",ue),ue})}(te,x)}).join(" ")}(be,Ue),L("tildes",be),be=function(Pe,x){return L("replaceXRanges",Pe,x),Pe.split(/\s+/).map(function(te){return function(ae,oe){ae=ae.trim();var he=oe?D[g]:D[w];return ae.replace(he,function(ge,fe,ye,we,Ee,ue){L("xRange",ae,ge,fe,ye,we,Ee,ue);var Re=Te(ye),Fe=Re||Te(we),_e=Fe||Te(Ee);return fe==="="&&_e&&(fe=""),Re?ge=fe===">"||fe==="<"?"<0.0.0":"*":fe&&_e?(Fe&&(we=0),_e&&(Ee=0),fe===">"?(fe=">=",Fe?(ye=+ye+1,we=0,Ee=0):_e&&(we=+we+1,Ee=0)):fe==="<="&&(fe="<",Fe?ye=+ye+1:we=+we+1),ge=fe+ye+"."+we+"."+Ee):Fe?ge=">="+ye+".0.0 <"+(+ye+1)+".0.0":_e&&(ge=">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0"),L("xRange return",ge),ge})}(te,x)}).join(" ")}(be,Ue),L("xrange",be),be=function(Pe,x){return L("replaceStars",Pe,x),Pe.trim().replace(D[B],"")}(be,Ue),L("stars",be),be}(De,re)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(De){return!!De.match(me)})),Se=Se.map(function(De){return new ke(De,re)})},Ie.prototype.intersects=function(Y,re){if(!(Y instanceof Ie))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(me){return Y.set.some(function(Se){return Se.every(function(De){return me.intersects(De,re)})})})})},e.toComparators=function(Y,re){return new Ie(Y,re).set.map(function(se){return se.map(function(me){return me.value}).join(" ").trim().split(" ")})},Ie.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new J(Y,this.loose));for(var re=0;re<this.set.length;re++)if(Ye(this.set[re],Y))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(Y,re,se){var me=null,Se=null;try{var De=new Ie(re,se)}catch(be){return null}return Y.forEach(function(be){De.test(be)&&(me&&Se.compare(be)!==-1||(Se=new J(me=be,se)))}),me},e.minSatisfying=function(Y,re,se){var me=null,Se=null;try{var De=new Ie(re,se)}catch(be){return null}return Y.forEach(function(be){De.test(be)&&(me&&Se.compare(be)!==1||(Se=new J(me=be,se)))}),me},e.validRange=function(Y,re){try{return new Ie(Y,re).range||"*"}catch(se){return null}},e.ltr=function(Y,re,se){return qe(Y,re,"<",se)},e.gtr=function(Y,re,se){return qe(Y,re,">",se)},e.outside=qe,e.prerelease=function(Y,re){var se=Q(Y,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(Y,re,se){return Y=new Ie(Y,se),re=new Ie(re,se),Y.intersects(re)},e.coerce=function(Y){if(Y instanceof J)return Y;if(typeof Y!="string")return null;var re=Y.match(D[U]);return re==null?null:Q((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,v(1))},function(G,e){var v,R,L=G.exports={};function k(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function D(P){if(v===setTimeout)return setTimeout(P,0);if((v===k||!v)&&setTimeout)return v=setTimeout,setTimeout(P,0);try{return v(P,0)}catch(E){try{return v.call(null,P,0)}catch(I){return v.call(this,P,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:k}catch(P){v=k}try{R=typeof clearTimeout=="function"?clearTimeout:O}catch(P){R=O}})();var y,S=[],n=!1,m=-1;function h(){n&&y&&(n=!1,y.length?S=y.concat(S):m=-1,S.length&&b())}function b(){if(!n){var P=D(h);n=!0;for(var E=S.length;E;){for(y=S,S=[];++m<E;)y&&y[m].run();m=-1,E=S.length}y=null,n=!1,function(I){if(R===clearTimeout)return clearTimeout(I);if((R===O||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(I);try{R(I)}catch(d){try{return R.call(null,I)}catch(c){return R.call(this,I)}}}(P)}}function f(P,E){this.fun=P,this.array=E}function C(){}L.nextTick=function(P){var E=new Array(arguments.length-1);if(arguments.length>1)for(var I=1;I<arguments.length;I++)E[I-1]=arguments[I];S.push(new f(P,E)),S.length!==1||n||D(b)},f.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=C,L.addListener=C,L.once=C,L.off=C,L.removeListener=C,L.removeAllListeners=C,L.emit=C,L.prependListener=C,L.prependOnceListener=C,L.listeners=function(P){return[]},L.binding=function(P){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(P){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(Z[89],ee([0,1,7]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=v.globals.performance&&typeof v.globals.performance.now=="function";class L{constructor(O){this._highResolution=R&&O,this._startTime=this._now(),this._stopTime=-1}static create(O=!0){return new L(O)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=L}),define(Z[3],ee([0,1,11,65,2,66,89]),function(G,e,v,R,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(I){I.None=()=>L.Disposable.None;function d(V){return(q,$=null,H)=>{let X=!1,_;return _=V(T=>{if(!X)return _?_.dispose():X=!0,q.call($,T)},null,H),X&&_.dispose(),_}}I.once=d;function c(V,q){return u(($,H=null,X)=>V(_=>$.call(H,q(_)),null,X))}I.map=c;function s(V,q){return u(($,H=null,X)=>V(_=>{q(_),$.call(H,_)},null,X))}I.forEach=s;function t(V,q){return u(($,H=null,X)=>V(_=>q(_)&&$.call(H,_),null,X))}I.filter=t;function r(V){return V}I.signal=r;function i(...V){return(q,$=null,H)=>L.combinedDisposable(...V.map(X=>X(_=>q.call($,_),null,H)))}I.any=i;function a(V,q,$){let H=$;return c(V,X=>(H=q(H,X),H))}I.reduce=a;function u(V){let q;const $=new h({onFirstListenerAdd(){q=V($.fire,$)},onLastListenerRemove(){q.dispose()}});return $.event}function o(V,q,$=100,H=!1,X){let _,T,A,M=0;const N=new h({leakWarningThreshold:X,onFirstListenerAdd(){_=V(B=>{M++,T=q(T,B),H&&!A&&(N.fire(T),T=void 0),clearTimeout(A),A=setTimeout(()=>{const W=T;T=void 0,A=void 0,(!H||M>1)&&N.fire(W),M=0},$)})},onLastListenerRemove(){_.dispose()}});return N.event}I.debounce=o;function l(V,q=($,H)=>$===H){let $=!0,H;return t(V,X=>{const _=$||!q(X,H);return $=!1,H=X,_})}I.latch=l;function p(V,q){return[I.filter(V,q),I.filter(V,$=>!q($))]}I.split=p;function w(V,q=!1,$=[]){let H=$.slice(),X=V(A=>{H?H.push(A):T.fire(A)});const _=()=>{H&&H.forEach(A=>T.fire(A)),H=null},T=new h({onFirstListenerAdd(){X||(X=V(A=>T.fire(A)))},onFirstListenerDidAdd(){H&&(q?setTimeout(_):_())},onLastListenerRemove(){X&&X.dispose(),X=null}});return T.event}I.buffer=w;class g{constructor(q){this.event=q}map(q){return new g(c(this.event,q))}forEach(q){return new g(s(this.event,q))}filter(q){return new g(t(this.event,q))}reduce(q,$){return new g(a(this.event,q,$))}latch(){return new g(l(this.event))}debounce(q,$=100,H=!1,X){return new g(o(this.event,q,$,H,X))}on(q,$,H){return this.event(q,$,H)}once(q,$,H){return d(this.event)(q,$,H)}}function U(V){return new g(V)}I.chain=U;function F(V,q,$=H=>H){const H=(...A)=>T.fire($(...A)),X=()=>V.on(q,H),_=()=>V.removeListener(q,H),T=new h({onFirstListenerAdd:X,onLastListenerRemove:_});return T.event}I.fromNodeEventEmitter=F;function j(V,q,$=H=>H){const H=(...A)=>T.fire($(...A)),X=()=>V.addEventListener(q,H),_=()=>V.removeEventListener(q,H),T=new h({onFirstListenerAdd:X,onLastListenerRemove:_});return T.event}I.fromDOMEventEmitter=j;function z(V){return new Promise(q=>d(V)(q))}I.toPromise=z})(D=e.Event||(e.Event={}));class y{constructor(d){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${d}_${y._idPool++}`}start(d){this._stopWatch=new O.StopWatch(!0),this._listenerCount=d}stop(){if(this._stopWatch){const d=this._stopWatch.elapsed();this._elapsedOverall+=d,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${d.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let S=-1;function n(I){const d=S;return S=I,{dispose(){S=d}}}e.setGlobalLeakWarningThreshold=n;class m{constructor(d,c=Math.random().toString(18).slice(2,5)){this.customThreshold=d,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(d){let c=S;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),c<=0||d<c)return;this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),t=this._stacks.get(s)||0;if(this._stacks.set(s,t+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let r,i=0;for(const[a,u]of this._stacks)(!r||i<u)&&(r=a,i=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${i}):`),console.warn(r)}return()=>{const r=this._stacks.get(s)||0;this._stacks.set(s,r-1)}}}class h{constructor(d){var c;this._disposed=!1,this._options=d,this._leakageMon=S>0?new m(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((c=this._options)===null||c===void 0?void 0:c._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(d,c,s)=>{var t;this._listeners||(this._listeners=new k.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(c?[d,c]:d);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,d,c);const a=(t=this._leakageMon)===null||t===void 0?void 0:t.check(this._listeners.size);let u;return u={dispose:()=>{a&&a(),u.dispose=h._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},s instanceof L.DisposableStore?s.add(u):Array.isArray(s)&&s.push(u),u}),this._event}fire(d){var c,s;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,d]);for((c=this._perfMon)===null||c===void 0||c.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,r]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,r):t[0].call(t[1],r)}catch(i){v.onUnexpectedError(i)}}(s=this._perfMon)===null||s===void 0||s.stop()}}dispose(){var d,c,s,t,r;this._disposed||(this._disposed=!0,(d=this._listeners)===null||d===void 0||d.clear(),(c=this._deliveryQueue)===null||c===void 0||c.clear(),(t=(s=this._options)===null||s===void 0?void 0:s.onLastListenerRemove)===null||t===void 0||t.call(s),(r=this._leakageMon)===null||r===void 0||r.dispose())}}e.Emitter=h,h._noop=function(){};class b extends h{constructor(d){super(d);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=d==null?void 0:d.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const d=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(d))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(d){this._listeners&&(this._isPaused!==0?this._eventQueue.push(d):super.fire(d))}}e.PauseableEmitter=b;class f extends b{constructor(d){var c;super(d);this._delay=(c=d.delay)!==null&&c!==void 0?c:100}fire(d){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(d)}}e.DebounceEmitter=f;class C{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(d){const c={event:d,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const s=()=>{this.hasListeners&&this.unhook(c);const t=this.events.indexOf(c);this.events.splice(t,1)};return L.toDisposable(R.once(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(d=>this.hook(d))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(d=>this.unhook(d))}hook(d){d.listener=d.event(c=>this.emitter.fire(c))}unhook(d){d.listener&&d.listener.dispose(),d.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=C;class P{constructor(){this.buffers=[]}wrapEvent(d){return(c,s,t)=>d(r=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>c.call(s,r)):c.call(s,r)},void 0,t)}bufferEvents(d){const c=[];this.buffers.push(c);const s=d();return this.buffers.pop(),c.forEach(t=>t()),s}}e.EventBufferer=P;class E{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=L.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(d){this.inputEvent=d,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=d(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(Z[29],ee([0,1,3]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(D,y){const S=setTimeout(D.bind(y),0);return{dispose(){clearTimeout(S)}}});var L;(function(D){function y(S){return S===D.None||S===D.Cancelled||S instanceof k?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}D.isCancellationToken=y,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(L=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class O{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=L.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=O}),define(Z[54],ee([0,1,3]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(m){const h=this._icons.get(m.id);h?m.description?h.description=m.description:console.error(`Duplicate registration of codicon ${m.id}`):(this._icons.set(m.id,m),this._onDidRegister.fire(m))}get(m){return this._icons.get(m)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const L=new R;e.iconRegistry=L;function k(n,m){return new D(n,m)}e.registerCodicon=k;function O(n){return n?n.replace(/\$\((.*?)\)/g,(m,h)=>` ${h} `).trim():""}e.getCodiconAriaLabel=O;class D{constructor(m,h,b){this.id=m,this.definition=h,this.description=b,L.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function y(n,m){const h=["codicon","codicon-"+n];return m&&h.push("codicon-modifier-"+m),h}e.getClassNamesArray=y;var S;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const m=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function h(C){if(C instanceof D)return["codicon","codicon-"+C.id];const P=m.exec(C.id);if(!P)return h(D.error);let[,E,I]=P;const d=["codicon","codicon-"+E];return I&&d.push("codicon-modifier-"+I.substr(1)),d}n.asClassNameArray=h;function b(C){return h(C).join(" ")}n.asClassName=b;function f(C){return"."+h(C).join(".")}n.asCSSSelector=f})(S=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(Z[47],ee([0,1,11,2]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(d){const c=d;return c?[c.on,c.pause,c.resume,c.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=L;function k(d){const c=d;return c?L(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=k;function O(d,c){return new D(d,c)}e.newWriteableStream=O;class D{constructor(c,s){this.reducer=c,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){var s;if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof((s=this.options)===null||s===void 0?void 0:s.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(s=>s(c))}emitError(c){this.listeners.error.length===0?v.onUnexpectedError(c):this.listeners.error.slice(0).forEach(s=>s(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,s){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(c,s){if(this.state.destroyed)return;let t;switch(c){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(s);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(d,c){const s=[];let t;for(;(t=d.read())!==null;)s.push(t);return c(s)}e.consumeReadable=y;function S(d,c,s){const t=[];let r;for(;(r=d.read())!==null&&t.length<s;)t.push(r);return r===null&&t.length>0?c(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return d.read()}}}e.peekReadable=S;function n(d,c){return new Promise((s,t)=>{const r=[];m(d,{onData:i=>{c&&r.push(i)},onError:i=>{c?t(i):s(void 0)},onEnd:()=>{s(c?c(r):void 0)}})})}e.consumeStream=n;function m(d,c){d.on("error",s=>c.onError(s)),d.on("end",()=>c.onEnd()),d.on("data",s=>c.onData(s))}e.listenStream=m;function h(d,c){return new Promise((s,t)=>{const r=new R.DisposableStore,i=[],a=l=>{if(i.push(l),i.length>c)return r.dispose(),d.pause(),s({stream:d,buffer:i,ended:!1})},u=l=>t(l),o=()=>s({stream:d,buffer:i,ended:!0});r.add(R.toDisposable(()=>d.removeListener("error",u))),d.on("error",u),r.add(R.toDisposable(()=>d.removeListener("end",o))),d.on("end",o),r.add(R.toDisposable(()=>d.removeListener("data",a))),d.on("data",a)})}e.peekStream=h;function b(d,c){const s=O(c);return s.end(d),s}e.toStream=b;function f(){const d=O(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=f;function C(d){let c=!1;return{read:()=>c?null:(c=!0,d)}}e.toReadable=C;function P(d,c,s){const t=O(s);return m(d,{onData:r=>t.write(c.data(r)),onError:r=>t.error(c.error?c.error(r):r),onEnd:()=>t.end()}),t}e.transform=P;function E(d,c,s){let t=!1;return{read:()=>{const r=c.read();return t?r:(t=!0,r!==null?s([d,r]):d)}}}e.prefixedReadable=E;function I(d,c,s){let t=!1;const r=O(s);return m(c,{onData:i=>t?r.write(i):(t=!0,r.write(s([d,i]))),onError:i=>r.error(i),onEnd:()=>{t||(t=!0,r.write(d)),r.end()}}),r}e.prefixedStream=I}),define(Z[20],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(x){return!x||typeof x!="string"?!0:x.trim().length===0}e.isFalsyOrWhitespace=v;const R=/{(\d+)}/g;function L(x,...te){return te.length===0?x:x.replace(R,function(ae,oe){const he=parseInt(oe,10);return isNaN(he)||he<0||he>=te.length?ae:te[he]})}e.format=L;function k(x){return x.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=k;function O(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=O;function D(x,te){let ae=0;const oe=te.charCodeAt(0);for(let he=x.length-1;he>=0;he--)x.charCodeAt(he)===oe&&ae++;return ae}e.count=D;function y(x,te,ae="\u2026"){return x.length<=te?x:`${x.substr(0,te)}${ae}`}e.truncate=y;function S(x,te=" "){const ae=n(x,te);return m(ae,te)}e.trim=S;function n(x,te){if(!x||!te)return x;const ae=te.length;if(ae===0||x.length===0)return x;let oe=0;for(;x.indexOf(te,oe)===oe;)oe=oe+ae;return x.substring(oe)}e.ltrim=n;function m(x,te){if(!x||!te)return x;const ae=te.length,oe=x.length;if(ae===0||oe===0)return x;let he=oe,ge=-1;for(;ge=x.lastIndexOf(te,he-1),!(ge===-1||ge+ae!==he);){if(ge===0)return"";he=ge}return x.substring(0,he)}e.rtrim=m;function h(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function b(x){return x.replace(/\*/g,"")}e.stripWildcards=b;function f(x,te,ae={}){if(!x)throw new Error("Cannot create regex from empty string");te||(x=O(x)),ae.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let oe="";return ae.global&&(oe+="g"),ae.matchCase||(oe+="i"),ae.multiline&&(oe+="m"),ae.unicode&&(oe+="u"),new RegExp(x,oe)}e.createRegExp=f;function C(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}e.regExpLeadsToEndlessLoop=C;function P(x){return!!x.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=P;function E(x){return(x.global?"g":"")+(x.ignoreCase?"i":"")+(x.multiline?"m":"")+(x.unicode?"u":"")}e.regExpFlags=E;function I(x){return x.split(/\r\n|\r|\n/)}e.splitLines=I;function d(x){for(let te=0,ae=x.length;te<ae;te++){const oe=x.charCodeAt(te);if(oe!==32&&oe!==9)return te}return-1}e.firstNonWhitespaceIndex=d;function c(x,te=0,ae=x.length){for(let oe=te;oe<ae;oe++){const he=x.charCodeAt(oe);if(he!==32&&he!==9)return x.substring(te,oe)}return x.substring(te,ae)}e.getLeadingWhitespace=c;function s(x,te=x.length-1){for(let ae=te;ae>=0;ae--){const oe=x.charCodeAt(ae);if(oe!==32&&oe!==9)return ae}return-1}e.lastNonWhitespaceIndex=s;function t(x,te){return x<te?-1:x>te?1:0}e.compare=t;function r(x,te,ae=0,oe=x.length,he=0,ge=te.length){for(;ae<oe&&he<ge;ae++,he++){let we=x.charCodeAt(ae),Ee=te.charCodeAt(he);if(we<Ee)return-1;if(we>Ee)return 1}const fe=oe-ae,ye=ge-he;return fe<ye?-1:fe>ye?1:0}e.compareSubstring=r;function i(x,te){return a(x,te,0,x.length,0,te.length)}e.compareIgnoreCase=i;function a(x,te,ae=0,oe=x.length,he=0,ge=te.length){for(;ae<oe&&he<ge;ae++,he++){let we=x.charCodeAt(ae),Ee=te.charCodeAt(he);if(we===Ee)continue;const ue=we-Ee;if(!(ue===32&&o(Ee))&&!(ue===-32&&o(we)))return u(we)&&u(Ee)?ue:r(x.toLowerCase(),te.toLowerCase(),ae,oe,he,ge)}const fe=oe-ae,ye=ge-he;return fe<ye?-1:fe>ye?1:0}e.compareSubstringIgnoreCase=a;function u(x){return x>=97&&x<=122}e.isLowerAsciiLetter=u;function o(x){return x>=65&&x<=90}e.isUpperAsciiLetter=o;function l(x){return u(x)||o(x)}function p(x,te){return x.length===te.length&&w(x,te)}e.equalsIgnoreCase=p;function w(x,te,ae=x.length){for(let oe=0;oe<ae;oe++){const he=x.charCodeAt(oe),ge=te.charCodeAt(oe);if(he!==ge){if(l(he)&&l(ge)){const fe=Math.abs(he-ge);if(fe!==0&&fe!==32)return!1}else if(String.fromCharCode(he).toLowerCase()!==String.fromCharCode(ge).toLowerCase())return!1}}return!0}function g(x,te){const ae=te.length;return te.length>x.length?!1:w(x,te,ae)}e.startsWithIgnoreCase=g;function U(x,te){let ae,oe=Math.min(x.length,te.length);for(ae=0;ae<oe;ae++)if(x.charCodeAt(ae)!==te.charCodeAt(ae))return ae;return oe}e.commonPrefixLength=U;function F(x,te){let ae,oe=Math.min(x.length,te.length);const he=x.length-1,ge=te.length-1;for(ae=0;ae<oe;ae++)if(x.charCodeAt(he-ae)!==te.charCodeAt(ge-ae))return ae;return oe}e.commonSuffixLength=F;function j(x){return 55296<=x&&x<=56319}e.isHighSurrogate=j;function z(x){return 56320<=x&&x<=57343}e.isLowSurrogate=z;function V(x,te){return(x-55296<<10)+(te-56320)+65536}e.computeCodePoint=V;function q(x,te,ae){const oe=x.charCodeAt(ae);if(j(oe)&&ae+1<te){const he=x.charCodeAt(ae+1);if(z(he))return V(oe,he)}return oe}e.getNextCodePoint=q;function $(x,te){const ae=x.charCodeAt(te-1);if(z(ae)&&te>1){const oe=x.charCodeAt(te-2);if(j(oe))return V(oe,ae)}return ae}function H(x,te){const ae=se.getInstance(),oe=te,he=x.length,ge=q(x,he,te);te+=ge>=65536?2:1;let fe=ae.getGraphemeBreakType(ge);for(;te<he;){const ye=q(x,he,te),we=ae.getGraphemeBreakType(ye);if(Y(fe,we))break;te+=ye>=65536?2:1,fe=we}return te-oe}e.nextCharLength=H;function X(x,te){const ae=se.getInstance(),oe=te,he=$(x,te);te-=he>=65536?2:1;let ge=ae.getGraphemeBreakType(he);for(;te>0;){const fe=$(x,te),ye=ae.getGraphemeBreakType(fe);if(Y(ye,ge))break;te-=fe>=65536?2:1,ge=ye}return oe-te}e.prevCharLength=X;function _(x,te){const ae=se.getInstance(),oe=x.length,he=te,ge=q(x,oe,te),fe=ae.getGraphemeBreakType(ge);te+=ge>=65536?2:1;let ye=fe;for(;te<oe;){const Ee=q(x,oe,te),ue=ae.getGraphemeBreakType(Ee);if(Y(ye,ue))break;te+=Ee>=65536?2:1,ye=ue}const we=te;for(te=he,ye=fe;te>0;){const Ee=$(x,te),ue=ae.getGraphemeBreakType(Ee);if(Y(ue,ye))break;te-=Ee>=65536?2:1,ye=ue}return[te,we]}function T(x,te){return te>0&&z(x.charCodeAt(te))?_(x,te-1):_(x,te)}e.getCharContainingOffset=T;function A(x){const te=x.length;let ae=0,oe=0;for(;oe<te;){const fe=q(x,te,oe);oe+=fe>=65536?2:1,fe<128?ae+=1:fe<2048?ae+=2:fe<65536?ae+=3:ae+=4}const he=new Uint8Array(ae);oe=0;let ge=0;for(;oe<te;){const fe=q(x,te,oe);oe+=fe>=65536?2:1,fe<128?he[ge++]=fe:fe<2048?(he[ge++]=192|(fe&1984)>>>6,he[ge++]=128|(fe&63)>>>0):fe<65536?(he[ge++]=224|(fe&61440)>>>12,he[ge++]=128|(fe&4032)>>>6,he[ge++]=128|(fe&63)>>>0):(he[ge++]=240|(fe&1835008)>>>18,he[ge++]=128|(fe&258048)>>>12,he[ge++]=128|(fe&4032)>>>6,he[ge++]=128|(fe&63)>>>0)}return he}e.encodeUTF8=A;function M(x){const te=x.byteLength,ae=[];let oe=0;for(;oe<te;){const he=x[oe];let ge;if(he>=240&&oe+3<te?ge=(x[oe++]&7)<<18>>>0|(x[oe++]&63)<<12>>>0|(x[oe++]&63)<<6>>>0|(x[oe++]&63)<<0>>>0:he>=224&&oe+2<te?ge=(x[oe++]&15)<<12>>>0|(x[oe++]&63)<<6>>>0|(x[oe++]&63)<<0>>>0:he>=192&&oe+1<te?ge=(x[oe++]&31)<<6>>>0|(x[oe++]&63)<<0>>>0:ge=x[oe++],ge>=0&&ge<=55295||ge>=57344&&ge<=65535)ae.push(String.fromCharCode(ge));else if(ge>=65536&&ge<=1114111){const fe=ge-65536,ye=55296+((fe&1047552)>>>10),we=56320+((fe&1023)>>>0);ae.push(String.fromCharCode(ye)),ae.push(String.fromCharCode(we))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=M;const N=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function B(x){return N.test(x)}e.containsRTL=B;const W=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Q(x){return W.test(x)}e.containsEmoji=Q;const J=/^[\t\n\r\x20-\x7E]*$/;function ie(x){return J.test(x)}e.isBasicASCII=ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ne(x){return e.UNUSUAL_LINE_TERMINATORS.test(x)}e.containsUnusualLineTerminators=ne;function ce(x){for(let te=0,ae=x.length;te<ae;te++)if(le(x.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=ce;function le(x){return x=+x,x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}e.isFullWidthCharacter=le;function ve(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129003||x>=129280&&x<=129535||x>=129648&&x<=129750}e.isEmojiImprecise=ve;function pe(x,te){if(x.length<te)return x;const ae=/\b/g;let oe=0;for(;ae.test(x)&&!(x.length-ae.lastIndex<te);)oe=ae.lastIndex,ae.lastIndex+=1;return x.substring(oe).replace(/^\s/,"")}e.lcut=pe;const Ce=/\x1B\x5B[12]?K/g,Ae=/\x1b\[\d+m/g,Me=/\x1b\[0?m/g;function Oe(x){return x&&(x=x.replace(Ce,""),x=x.replace(Ae,""),x=x.replace(Me,"")),x}e.removeAnsiEscapeCodes=Oe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function je(x){return ke(x)?x.substr(1):x}e.stripUTF8BOM=je;function Ie(x,te){if(!x||!te||x.length<te.length)return!1;const ae=te.length,oe=x.toLowerCase();let he=0,ge=-1;for(;he<ae;){const fe=oe.indexOf(te[he],ge+1);if(fe<0)return!1;ge=fe,he++}return!0}e.fuzzyContains=Ie;function Te(x,te=!1){return x?(te&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}e.containsUppercaseCharacter=Te;function Ke(x){return x.charAt(0).toUpperCase()+x.slice(1)}e.uppercaseFirstLetter=Ke;function Ye(x,te=1){if(te===0)return"";let ae=-1;do ae=x.indexOf(`
`,ae+1),te--;while(te>0&&ae>=0);return ae===-1?x:(x[ae-1]==="\r"&&ae--,x.substr(0,ae))}e.getNLines=Ye;function ze(x){const te=90-65+1;return x=x%(2*te),x<te?String.fromCharCode(97+x):String.fromCharCode(65+x-te)}e.singleLetterHash=ze;function qe(x){return se.getInstance().getGraphemeBreakType(x)}e.getGraphemeBreakType=qe;function Y(x,te){return x===0?te!==5&&te!==7:x===2&&te===3?!1:x===4||x===2||x===3||te===4||te===2||te===3?!0:!(x===8&&(te===8||te===9||te===11||te===12)||(x===11||x===9)&&(te===9||te===10)||(x===12||x===10)&&te===10||te===5||te===13||te===7||x===1||x===13&&te===14||x===6&&te===6)}e.breakBetweenGraphemeBreakType=Y;var re;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class se{constructor(){this._data=me()}static getInstance(){return se._INSTANCE||(se._INSTANCE=new se),se._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const ae=this._data,oe=ae.length/3;let he=1;for(;he<=oe;)if(te<ae[3*he])he=2*he;else if(te>ae[3*he+1])he=2*he+1;else return ae[3*he+2];return 0}}se._INSTANCE=null;function me(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(x,te){if(x===0)return 0;const ae=De(x,te);if(ae!==void 0)return ae;const oe=$(te,x);return x-=be(oe),x}e.getLeftDeleteOffset=Se;function De(x,te){let ae=$(te,x);for(x-=be(ae);Ue(ae)||ae===65039||ae===8419;){if(x===0)return;ae=$(te,x),x-=be(ae)}if(!!ve(ae)){if(x>=0){const oe=$(te,x);oe===8205&&(x-=be(oe))}return x}}function be(x){return x>=65536?2:1}function Ue(x){return 127995<=x&&x<=127999}var Pe;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(Pe||(Pe={}))}),define(Z[25],ee([0,1,20,47]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined",k=typeof TextEncoder!="undefined",O=typeof TextDecoder!="undefined";let D,y;class S{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return L?new S(Buffer.allocUnsafe(l)):new S(new Uint8Array(l))}static wrap(l){return L&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new S(l)}static fromString(l,p){return!((p==null?void 0:p.dontUseNodeBuffer)||!1)&&L?new S(Buffer.from(l)):k?(D||(D=new TextEncoder),new S(D.encode(l))):new S(v.encodeUTF8(l))}static concat(l,p){if(typeof p=="undefined"){p=0;for(let U=0,F=l.length;U<F;U++)p+=l[U].byteLength}const w=S.alloc(p);let g=0;for(let U=0,F=l.length;U<F;U++){const j=l[U];w.set(j,g),g+=j.byteLength}return w}toString(){return L?this.buffer.toString():O?(y||(y=new TextDecoder),y.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(l,p){return new S(this.buffer.subarray(l,p))}set(l,p){l instanceof S?this.buffer.set(l.buffer,p):this.buffer.set(l,p)}readUInt32BE(l){return h(this.buffer,l)}writeUInt32BE(l,p){b(this.buffer,l,p)}readUInt32LE(l){return f(this.buffer,l)}writeUInt32LE(l,p){C(this.buffer,l,p)}readUInt8(l){return P(this.buffer,l)}writeUInt8(l,p){E(this.buffer,l,p)}}e.VSBuffer=S;function n(o,l){return o[l+0]<<0>>>0|o[l+1]<<8>>>0}e.readUInt16LE=n;function m(o,l,p){o[p+0]=l&255,l=l>>>8,o[p+1]=l&255}e.writeUInt16LE=m;function h(o,l){return o[l]*2**24+o[l+1]*2**16+o[l+2]*2**8+o[l+3]}e.readUInt32BE=h;function b(o,l,p){o[p+3]=l,l=l>>>8,o[p+2]=l,l=l>>>8,o[p+1]=l,l=l>>>8,o[p]=l}e.writeUInt32BE=b;function f(o,l){return o[l+0]<<0>>>0|o[l+1]<<8>>>0|o[l+2]<<16>>>0|o[l+3]<<24>>>0}e.readUInt32LE=f;function C(o,l,p){o[p+0]=l&255,l=l>>>8,o[p+1]=l&255,l=l>>>8,o[p+2]=l&255,l=l>>>8,o[p+3]=l&255}e.writeUInt32LE=C;function P(o,l){return o[l]}e.readUInt8=P;function E(o,l,p){o[p]=l}e.writeUInt8=E;function I(o){return R.consumeReadable(o,l=>S.concat(l))}e.readableToBuffer=I;function d(o){return R.toReadable(o)}e.bufferToReadable=d;function c(o){return R.consumeStream(o,l=>S.concat(l))}e.streamToBuffer=c;async function s(o){return o.ended?S.concat(o.buffer):S.concat([...o.buffer,await c(o.stream)])}e.bufferedStreamToBuffer=s;function t(o){return R.toStream(o,l=>S.concat(l))}e.bufferToStream=t;function r(o){return R.transform(o,{data:l=>typeof l=="string"?S.fromString(l):S.wrap(l)},l=>S.concat(l))}e.streamToBufferReadableStream=r;function i(o){return R.newWriteableStream(l=>S.concat(l),o)}e.newWriteableBufferStream=i;function a(o,l){return R.prefixedReadable(o,l,p=>S.concat(p))}e.prefixedBufferReadable=a;function u(o,l){return R.prefixedStream(o,l,p=>S.concat(p))}e.prefixedBufferStream=u}),define(Z[16],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(l){return Array.isArray(l)}e.isArray=v;function R(l){return typeof l=="string"}e.isString=R;function L(l){return Array.isArray(l)&&l.every(p=>R(p))}e.isStringArray=L;function k(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=k;function O(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=O;function D(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=D;function y(l){return l===!0||l===!1}e.isBoolean=y;function S(l){return typeof l=="undefined"}e.isUndefined=S;function n(l){return!m(l)}e.isDefined=n;function m(l){return S(l)||l===null}e.isUndefinedOrNull=m;function h(l,p){if(!l)throw new Error(p?`Unexpected type, expected '${p}'`:"Unexpected type")}e.assertType=h;function b(l){if(m(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=b;function f(...l){const p=[];for(let w=0;w<l.length;w++){const g=l[w];if(m(g))throw new Error(`Assertion Failed: argument at index ${w} is undefined or null`);p.push(g)}return p}e.assertAllDefined=f;const C=Object.prototype.hasOwnProperty;function P(l){if(!k(l))return!1;for(let p in l)if(C.call(l,p))return!1;return!0}e.isEmptyObject=P;function E(l){return typeof l=="function"}e.isFunction=E;function I(...l){return l.length>0&&l.every(E)}e.areFunctions=I;function d(l,p){const w=Math.min(l.length,p.length);for(let g=0;g<w;g++)c(l[g],p[g])}e.validateConstraints=d;function c(l,p){if(R(p)){if(typeof l!==p)throw new Error(`argument does not match constraint: typeof ${p}`)}else if(E(p)){try{if(l instanceof p)return}catch(w){}if(!m(l)&&l.constructor===p||p.length===1&&p.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function s(l){let p=[],w=Object.getPrototypeOf(l);for(;Object.prototype!==w;)p=p.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return p}e.getAllPropertyNames=s;function t(l){const p=[];for(const w of s(l))typeof l[w]=="function"&&p.push(w);return p}e.getAllMethodNames=t;function r(l,p){const w=U=>function(){const F=Array.prototype.slice.call(arguments,0);return p(U,F)};let g={};for(const U of l)g[U]=w(U);return g}e.createProxyObject=r;function i(l){return l===null?void 0:l}e.withNullAsUndefined=i;function a(l){return typeof l=="undefined"?null:l}e.withUndefinedAsNull=a;function u(l){return class{constructor(){return new Proxy({},{get(p,w){if(p[w])return p[w];throw new Error(`Not Implemented: ${l}->${String(w)}`)}})}}}e.NotImplementedProxy=u;function o(l){throw new Error("Unreachable")}e.assertNever=o}),define(Z[41],ee([0,1,7,20,8,16]),function(G,e,v,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function O(i){return i===47||i===92}e.isPathSeparator=O;function D(i){return i.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=D;function y(i){return i.indexOf("/")===-1&&(i=D(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=y;function S(i,a=L.posix.sep){if(!i)return"";const u=i.length,o=i.charCodeAt(0);if(O(o)){if(O(i.charCodeAt(1))&&!O(i.charCodeAt(2))){let p=3;const w=p;for(;p<u&&!O(i.charCodeAt(p));p++);if(w!==p&&!O(i.charCodeAt(p+1))){for(p+=1;p<u;p++)if(O(i.charCodeAt(p)))return i.slice(0,p+1).replace(/[\\/]/g,a)}}return a}else if(E(o)&&i.charCodeAt(1)===58)return O(i.charCodeAt(2))?i.slice(0,2)+a:i.slice(0,2);let l=i.indexOf("://");if(l!==-1){for(l+=3;l<u;l++)if(O(i.charCodeAt(l)))return i.slice(0,l+1)}return""}e.getRoot=S;function n(i){if(!v.isWindows||!i||i.length<5)return!1;let a=i.charCodeAt(0);if(a!==92||(a=i.charCodeAt(1),a!==92))return!1;let u=2;const o=u;for(;u<i.length&&(a=i.charCodeAt(u),a!==92);u++);return!(o===u||(a=i.charCodeAt(u+1),isNaN(a)||a===92))}e.isUNC=n;const m=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(i,a=v.isWindows){const u=a?m:h;return!(!i||i.length===0||/^\s+$/.test(i)||(u.lastIndex=0,u.test(i))||a&&b.test(i)||i==="."||i===".."||a&&i[i.length-1]==="."||a&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=f;function C(i,a,u){const o=i===a;return!u||o?o:!i||!a?!1:R.equalsIgnoreCase(i,a)}e.isEqual=C;function P(i,a,u,o=L.sep){if(i===a)return!0;if(!i||!a||a.length>i.length)return!1;if(u){if(!R.startsWithIgnoreCase(i,a))return!1;if(a.length===i.length)return!0;let p=a.length;return a.charAt(a.length-1)===o&&p--,i.charAt(p)===o}return a.charAt(a.length-1)!==o&&(a+=o),i.indexOf(a)===0}e.isEqualOrParent=P;function E(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=E;function I(i,a){return v.isWindows&&i.endsWith(":")&&(i+=L.sep),L.isAbsolute(i)||(i=L.join(a,i)),i=L.normalize(i),v.isWindows?(i=R.rtrim(i,L.sep),i.endsWith(":")&&(i+=L.sep)):(i=R.rtrim(i,L.sep),i||(i=L.sep)),i}e.sanitizeFilePath=I;function d(i){const a=L.normalize(i);return v.isWindows?i.length>3?!1:c(a)&&(i.length===2||a.charCodeAt(2)===92):a===L.posix.sep}e.isRootOrDriveLetter=d;function c(i){return v.isWindows?E(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function s(i){return c(i)?i[0]:void 0}e.getDriveLetter=s;function t(i,a,u){return a.length>i.length?-1:i===a?0:(u&&(i=i.toLowerCase(),a=a.toLowerCase()),i.indexOf(a))}e.indexOfPath=t;function r(i){const a=i.split(":");let u,o,l;if(a.forEach(p=>{const w=Number(p);k.isNumber(w)?o===void 0?o=w:l===void 0&&(l=w):u=u?[u,p].join(":"):p}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:o!==void 0?o:void 0,column:l!==void 0?l:o!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(Z[26],ee([0,1,16]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(C){if(!C||typeof C!="object"||C instanceof RegExp)return C;const P=Array.isArray(C)?[]:{};return Object.keys(C).forEach(E=>{C[E]&&typeof C[E]=="object"?P[E]=R(C[E]):P[E]=C[E]}),P}e.deepClone=R;function L(C){if(!C||typeof C!="object")return C;const P=[C];for(;P.length>0;){const E=P.shift();Object.freeze(E);for(const I in E)if(k.call(E,I)){const d=E[I];typeof d=="object"&&!Object.isFrozen(d)&&P.push(d)}}return C}e.deepFreeze=L;const k=Object.prototype.hasOwnProperty;function O(C,P){return D(C,P,new Set)}e.cloneAndChange=O;function D(C,P,E){if(v.isUndefinedOrNull(C))return C;const I=P(C);if(typeof I!="undefined")return I;if(v.isArray(C)){const d=[];for(const c of C)d.push(D(c,P,E));return d}if(v.isObject(C)){if(E.has(C))throw new Error("Cannot clone recursive data-structure");E.add(C);const d={};for(let c in C)k.call(C,c)&&(d[c]=D(C[c],P,E));return E.delete(C),d}return C}function y(C,P,E=!0){return v.isObject(C)?(v.isObject(P)&&Object.keys(P).forEach(I=>{I in C?E&&(v.isObject(C[I])&&v.isObject(P[I])?y(C[I],P[I],E):C[I]=P[I]):C[I]=P[I]}),C):P}e.mixin=y;function S(C,P){if(C===P)return!0;if(C==null||P===null||P===void 0||typeof C!=typeof P||typeof C!="object"||Array.isArray(C)!==Array.isArray(P))return!1;let E,I;if(Array.isArray(C)){if(C.length!==P.length)return!1;for(E=0;E<C.length;E++)if(!S(C[E],P[E]))return!1}else{const d=[];for(I in C)d.push(I);d.sort();const c=[];for(I in P)c.push(I);if(c.sort(),!S(d,c))return!1;for(E=0;E<d.length;E++)if(!S(C[d[E]],P[d[E]]))return!1}return!0}e.equals=S;function n(C){const P=new Set;return JSON.stringify(C,(E,I)=>{if(v.isObject(I)||Array.isArray(I)){if(P.has(I))return"[Circular]";P.add(I)}return I})}e.safeStringify=n;function m(C,P,E){const I=P(C);return typeof I=="undefined"?E:I}e.getOrDefault=m;function h(C,P){const E=Object.create(null);return!C||!P||Object.keys(P).forEach(d=>{const c=C[d],s=P[d];S(c,s)||(E[d]=s)}),E}e.distinct=h;function b(C,P){const E=P.toLowerCase(),I=Object.keys(C).find(d=>d.toLowerCase()===E);return I?C[I]:C[P]}e.getCaseInsensitive=b;function f(C,P){const E=Object.create(null);for(const I of Object.keys(C))P(I,C[I])&&(E[I]=C[I]);return E}e.filter=f}),define(Z[5],ee([0,1,7,8]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,k=/^\//,O=/^\/\//;function D(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!k.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(i,a){return!i&&!a?"file":i}function S(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==m&&(a=m+a):a=m;break}return a}const n="",m="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(a,u,o,l,p,w=!1){typeof a=="object"?(this.scheme=a.scheme||n,this.authority=a.authority||n,this.path=a.path||n,this.query=a.query||n,this.fragment=a.fragment||n):(this.scheme=y(a,w),this.authority=u||n,this.path=S(this.scheme,o||n),this.query=l||n,this.fragment=p||n,D(this,w))}static isUri(a){return a instanceof b?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return d(this,!1)}with(a){if(!a)return this;let{scheme:u,authority:o,path:l,query:p,fragment:w}=a;return u===void 0?u=this.scheme:u===null&&(u=n),o===void 0?o=this.authority:o===null&&(o=n),l===void 0?l=this.path:l===null&&(l=n),p===void 0?p=this.query:p===null&&(p=n),w===void 0?w=this.fragment:w===null&&(w=n),u===this.scheme&&o===this.authority&&l===this.path&&p===this.query&&w===this.fragment?this:new C(u,o,l,p,w)}static parse(a,u=!1){const o=h.exec(a);return o?new C(o[2]||n,r(o[4]||n),r(o[5]||n),r(o[7]||n),r(o[9]||n),u):new C(n,n,n,n,n)}static file(a){let u=n;if(v.isWindows&&(a=a.replace(/\\/g,m)),a[0]===m&&a[1]===m){const o=a.indexOf(m,2);o===-1?(u=a.substring(2),a=m):(u=a.substring(2,o),a=a.substring(o)||m)}return new C("file",u,a,n,n)}static from(a){const u=new C(a.scheme,a.authority,a.path,a.query,a.fragment);return D(u,!0),u}static joinPath(a,...u){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return v.isWindows&&a.scheme==="file"?o=b.file(R.win32.join(d(a,!0),...u)).path:o=R.posix.join(a.path,...u),a.with({path:o})}toString(a=!1){return c(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof b)return a;{const u=new C(a);return u._formatted=a.external,u._fsPath=a._sep===f?a.fsPath:null,u}}else return a}}e.URI=b;const f=v.isWindows?1:void 0;class C extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(a=!1){return a?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=f),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const P={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(i,a){let u,o=-1;for(let l=0;l<i.length;l++){const p=i.charCodeAt(l);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||a&&p===47)o!==-1&&(u+=encodeURIComponent(i.substring(o,l)),o=-1),u!==void 0&&(u+=i.charAt(l));else{u===void 0&&(u=i.substr(0,l));const w=P[p];w!==void 0?(o!==-1&&(u+=encodeURIComponent(i.substring(o,l)),o=-1),u+=w):o===-1&&(o=l)}}return o!==-1&&(u+=encodeURIComponent(i.substring(o))),u!==void 0?u:i}function I(i){let a;for(let u=0;u<i.length;u++){const o=i.charCodeAt(u);o===35||o===63?(a===void 0&&(a=i.substr(0,u)),a+=P[o]):a!==void 0&&(a+=i[u])}return a!==void 0?a:i}function d(i,a){let u;return i.authority&&i.path.length>1&&i.scheme==="file"?u=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?u=i.path.substr(1):u=i.path[1].toLowerCase()+i.path.substr(2):u=i.path,v.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=d;function c(i,a){const u=a?I:E;let o="",{scheme:l,authority:p,path:w,query:g,fragment:U}=i;if(l&&(o+=l,o+=":"),(p||l==="file")&&(o+=m,o+=m),p){let F=p.indexOf("@");if(F!==-1){const j=p.substr(0,F);p=p.substr(F+1),F=j.indexOf(":"),F===-1?o+=u(j,!1):(o+=u(j.substr(0,F),!1),o+=":",o+=u(j.substr(F+1),!1)),o+="@"}p=p.toLowerCase(),F=p.indexOf(":"),F===-1?o+=u(p,!1):(o+=u(p.substr(0,F),!1),o+=p.substr(F))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const F=w.charCodeAt(1);F>=65&&F<=90&&(w=`/${String.fromCharCode(F+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const F=w.charCodeAt(0);F>=65&&F<=90&&(w=`${String.fromCharCode(F+32)}:${w.substr(2)}`)}o+=u(w,!0)}return g&&(o+="?",o+=u(g,!1)),U&&(o+="#",o+=a?U:E(U,!1)),o}function s(i){try{return decodeURIComponent(i)}catch(a){return i.length>3?i.substr(0,3)+s(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,a=>s(a)):i}}),define(Z[90],ee([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(S){const n=S;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=R;function L(S){const n=[];let m;try{const h=JSON.parse(S.arguments),b=h[h.length-1];b&&b.__$stack&&(h.pop(),m=b.__$stack),n.push(...h)}catch(h){n.push("Unable to log remote console arguments",S.arguments)}return{args:n,stack:m}}e.parse=L;function k(S){if(typeof S!="string")return k(L(S).stack);const n=S;if(n){const m=O(n),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(m||"");if(h&&h.length===4)return{uri:v.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}e.getFirstFrame=k;function O(S){if(!S)return S;const n=S.indexOf(`
`);return n===-1?S:S.substring(0,n)}function D(S,n){const{args:m,stack:h}=L(S),b=typeof m[0]=="string"&&m.length===1;let f=O(h);f&&(f=`(${f.trim()})`);let C=[];if(typeof m[0]=="string"?f&&b?C=[`%c[${n}] %c${m[0]} %c${f}`,y("blue"),y(""),y("grey")]:C=[`%c[${n}] %c${m[0]}`,y("blue"),y(""),...m.slice(1)]:C=[`%c[${n}]%`,y("blue"),...m],f&&!b&&C.push(f),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,C)}e.log=D;function y(S){return`color: ${S}`}});var ft=this&&this.__classPrivateFieldSet||function(G,e,v,R,L){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!L:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?L.call(G,v):L?L.value=v:e.set(G,v),v},$e=this&&this.__classPrivateFieldGet||function(G,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!R:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(G):R?R.value:e.get(G)};define(Z[38],ee([0,1,5,20]),function(G,e,v,R){"use strict";var L,k,O;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(t,r,i){let a=t.get(r);return a===void 0&&(a=i,t.set(r,a)),a}e.getOrSet=D;function y(t){const r=[];return t.forEach((i,a)=>{r.push(`${a} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=y;function S(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=S;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),a=this._value.charCodeAt(this._pos);return i-a}value(){return this._value[this._pos]}}e.StringIterator=n;class m{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?R.compareSubstring(r,this._value,0,r.length,this._from,this._to):R.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=m;class h{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?R.compareSubstring(r,this._value,0,r.length,this._from,this._to):R.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=h;var b;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(b||(b={}));class f{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new h(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return R.compareIgnoreCase(r,this._value.scheme);if(this._states[this._stateIdx]===2)return R.compareIgnoreCase(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return R.compare(r,this._value.query);if(this._states[this._stateIdx]===5)return R.compare(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class C{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class P{constructor(r){this._iter=r}static forUris(r=()=>!1){return new P(new f(r))}static forPaths(){return new P(new h)}static forStrings(){return new P(new n)}static forConfigKeys(){return new P(new m)}clear(){this._root=void 0}set(r,i){const a=this._iter.reset(r);let u;for(this._root||(this._root=new C,this._root.segment=a.value()),u=this._root;;){const l=a.cmp(u.segment);if(l>0)u.left||(u.left=new C,u.left.segment=a.value()),u=u.left;else if(l<0)u.right||(u.right=new C,u.right.segment=a.value()),u=u.right;else if(a.hasNext())a.next(),u.mid||(u.mid=new C,u.mid.segment=a.value()),u=u.mid;else break}const o=u.value;return u.value=i,u.key=r,o}get(r){var i;return(i=this._getNode(r))===null||i===void 0?void 0:i.value}_getNode(r){const i=this._iter.reset(r);let a=this._root;for(;a;){const u=i.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(i.hasNext())i.next(),a=a.mid;else break}return a}has(r){const i=this._getNode(r);return!((i==null?void 0:i.value)===void 0&&(i==null?void 0:i.mid)===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const a=this._iter.reset(r),u=[];let o=this._root;for(;o;){const l=a.cmp(o.segment);if(l>0)u.push([1,o]),o=o.left;else if(l<0)u.push([-1,o]),o=o.right;else if(a.hasNext())a.next(),u.push([0,o]),o=o.mid;else{for(i?(o.left=void 0,o.mid=void 0,o.right=void 0):o.value=void 0;u.length>0&&o.isEmpty();){let[p,w]=u.pop();switch(p){case 1:w.left=void 0;break;case 0:w.mid=void 0;break;case-1:w.right=void 0;break}o=w}break}}}findSubstr(r){const i=this._iter.reset(r);let a=this._root,u;for(;a;){const o=i.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(i.hasNext())i.next(),u=a.value||u,a=a.mid;else break}return a&&a.value||u}findSuperstr(r){const i=this._iter.reset(r);let a=this._root;for(;a;){const u=i.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(i.hasNext())i.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(r){for(const[i,a]of this)r(a,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const a=i.pop();a&&(a.value&&(yield[a.key,a.value]),a.left&&i.push(a.left),a.mid&&i.push(a.mid),a.right&&i.push(a.right))}}}e.TernarySearchTree=P;class E{constructor(r,i){this[L]="ResourceMap",r instanceof E?(this.map=new Map(r.map),this.toKey=i??E.defaultToKey):(this.map=new Map,this.toKey=r??E.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[a,u]of this.map)r(u,v.URI.parse(a),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield v.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[v.URI.parse(r[0]),r[1]]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[v.URI.parse(r[0]),r[1]]}}e.ResourceMap=E,E.defaultToKey=t=>t.toString();var I;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class d{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var r;return(r=this._head)===null||r===void 0?void 0:r.value}get last(){var r;return(r=this._tail)===null||r===void 0?void 0:r.value}has(r){return this._map.has(r)}get(r,i=0){const a=this._map.get(r);if(!!a)return i!==0&&this.touch(a,i),a.value}set(r,i,a=0){let u=this._map.get(r);if(u)u.value=i,a!==0&&this.touch(u,a);else{switch(u={key:r,value:i,next:void 0,previous:void 0},a){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const a=this._state;let u=this._head;for(;u;){if(i?r.bind(i)(u.value,u.key,this):r(u.value,u.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,i=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const o={value:a.key,done:!1};return a=a.next,o}else return{value:void 0,done:!0}}};return u}values(){const r=this,i=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const o={value:a.value,done:!1};return a=a.next,o}else return{value:void 0,done:!0}}};return u}entries(){const r=this,i=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const o={value:[a.key,a.value],done:!1};return a=a.next,o}else return{value:void 0,done:!0}}};return u}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,a=this.size;for(;i&&a>r;)this._map.delete(i.key),i=i.next,a--;this._head=i,this._size=a,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,a=r.previous;if(!i||!a)throw new Error("Invalid list");i.previous=a,a.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const a=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(a.previous=u,u.next=a),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const a=r.next,u=r.previous;r===this._head?(a.previous=void 0,this._head=a):(a.previous=u,u.next=a),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,a)=>{r.push([a,i])}),r}fromJSON(r){this.clear();for(const[i,a]of r)this.set(i,a)}}e.LinkedMap=d;class c extends d{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class s{constructor(r){O.set(this,void 0),ft(this,O,r,"f")}get size(){return $e(this,O,"f").size}forEach(r,i){$e(this,O,"f").forEach(r,i)}get(r){return $e(this,O,"f").get(r)}has(r){return $e(this,O,"f").has(r)}entries(){return $e(this,O,"f").entries()}keys(){return $e(this,O,"f").keys()}values(){return $e(this,O,"f").values()}[(O=new WeakMap,Symbol.iterator)](){return $e(this,O,"f").entries()}}e.ReadonlyMapView=s}),define(Z[91],ee([0,1,25,20,5]),function(G,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(S){return JSON.stringify(S,D)}e.stringify=k;function O(S){let n=JSON.parse(S);return n=y(n),n}e.parse=O;function D(S,n){return n instanceof RegExp?{$mid:2,source:n.source,flags:R.regExpFlags(n)}:n}function y(S,n=0){if(!S||n>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return L.URI.revive(S);case 2:return new RegExp(S.source,S.flags)}if(S instanceof v.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let m=0;m<S.length;++m)S[m]=y(S[m],n+1);else for(const m in S)Object.hasOwnProperty.call(S,m)&&(S[m]=y(S[m],n+1))}return S}e.revive=y}),define(Z[17],ee([0,1,5,7]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var L;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp"})(L=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,S,n){this._hosts[y]=S,this._ports[y]=n}setConnectionToken(y,S){this._connectionTokens[y]=S}rewrite(y){if(this._delegate)return this._delegate(y);const S=y.authority;let n=this._hosts[S];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const m=this._ports[S],h=this._connectionTokens[S];let b=`path=${encodeURIComponent(y.path)}`;return typeof h=="string"&&(b+=`&tkn=${encodeURIComponent(h)}`),v.URI.from({scheme:R.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${n}:${m}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new k;class O{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,S,n){const m=this.toUri(y,S);return m.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(m):R.isNative&&(n||R.isPreferringBrowserCodeLoad)&&m.scheme===L.file?m.with({scheme:L.vscodeFileResource,authority:m.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):m}asFileUri(y,S){const n=this.toUri(y,S);return n.scheme===L.vscodeFileResource?n.with({scheme:L.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(y,S){return v.URI.isUri(y)?y:v.URI.parse(S.toUrl(y))}}e.FileAccess=new O}),define(Z[67],ee([0,1,38]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new v.LRUCache(1e4);function L(S){return y(S,"NFC",R)}e.normalizeNFC=L;const k=new v.LRUCache(1e4);function O(S){return y(S,"NFD",k)}e.normalizeNFD=O;const D=/[^\u0000-\u0080]/;function y(S,n,m){if(!e.canNormalize||!S)return S;const h=m.get(S);if(h)return h;let b;return D.test(S)?b=S.normalize(n):b=S,m.set(S,b),b}e.removeAccents=function(){if(e.canNormalize){const S=/[\u0300-\u036f]/g;return function(n){return O(n).replace(S,"")}}else return function(S){return S}}()}),define(Z[12],ee([0,1,41,8,5,20,17,7]),function(G,e,v,R,L,k,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(b){return L.uriToFsPath(b,!0)}e.originalFSPath=y;class S{constructor(f){this._ignorePathCasing=f}compare(f,C,P=!1){return f===C?0:k.compare(this.getComparisonKey(f,P),this.getComparisonKey(C,P))}isEqual(f,C,P=!1){return f===C?!0:!f||!C?!1:this.getComparisonKey(f,P)===this.getComparisonKey(C,P)}getComparisonKey(f,C=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:C?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,C,P=!1){if(f.scheme===C.scheme){if(f.scheme===O.Schemas.file)return v.isEqualOrParent(y(f),y(C),this._ignorePathCasing(f))&&f.query===C.query&&(P||f.fragment===C.fragment);if(e.isEqualAuthority(f.authority,C.authority))return v.isEqualOrParent(f.path,C.path,this._ignorePathCasing(f),"/")&&f.query===C.query&&(P||f.fragment===C.fragment)}return!1}joinPath(f,...C){return L.URI.joinPath(f,...C)}basenameOrAuthority(f){return e.basename(f)||f.authority}basename(f){return R.posix.basename(f.path)}extname(f){return R.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let C;return f.scheme===O.Schemas.file?C=L.URI.file(R.dirname(y(f))).path:(C=R.posix.dirname(f.path),f.authority&&C.length&&C.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),C="/")),f.with({path:C})}normalizePath(f){if(!f.path.length)return f;let C;return f.scheme===O.Schemas.file?C=L.URI.file(R.normalize(y(f))).path:C=R.posix.normalize(f.path),f.with({path:C})}relativePath(f,C){if(f.scheme!==C.scheme||!e.isEqualAuthority(f.authority,C.authority))return;if(f.scheme===O.Schemas.file){const I=R.relative(y(f),y(C));return D.isWindows?v.toSlashes(I):I}let P=f.path||"/",E=C.path||"/";if(this._ignorePathCasing(f)){let I=0;for(const d=Math.min(P.length,E.length);I<d&&!(P.charCodeAt(I)!==E.charCodeAt(I)&&P.charAt(I).toLowerCase()!==E.charAt(I).toLowerCase());I++);P=E.substr(0,I)+P.substr(I)}return R.posix.relative(P,E)}resolvePath(f,C){if(f.scheme===O.Schemas.file){const P=L.URI.file(R.resolve(y(f),C));return f.with({authority:P.authority,path:P.path})}return C=v.toPosixPath(C),f.with({path:R.posix.resolve(f.path,C)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,C){return f===C||k.equalsIgnoreCase(f,C)}hasTrailingPathSeparator(f,C=R.sep){if(f.scheme===O.Schemas.file){const P=y(f);return P.length>v.getRoot(P).length&&P[P.length-1]===C}else{const P=f.path;return P.length>1&&P.charCodeAt(P.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,C=R.sep){return e.hasTrailingPathSeparator(f,C)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,C=R.sep){let P=!1;if(f.scheme===O.Schemas.file){const E=y(f);P=E!==void 0&&E.length===v.getRoot(E).length&&E[E.length-1]===C}else{C="/";const E=f.path;P=E.length===1&&E.charCodeAt(E.length-1)===47}return!P&&!e.hasTrailingPathSeparator(f,C)?f.with({path:f.path+"/"}):f}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(b=>b.scheme===O.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new S(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(b,f){const C=[];for(let P=0;P<b.length;P++){const E=f(b[P]);b.some((I,d)=>d===P?!1:e.isEqualOrParent(E,f(I)))||C.push(b[P])}return C}e.distinctParents=n;var m;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function f(C){const P=new Map;C.path.substring(C.path.indexOf(";")+1,C.path.lastIndexOf(";")).split(";").forEach(d=>{const[c,s]=d.split(":");c&&s&&P.set(c,s)});const I=C.path.substring(0,C.path.indexOf(";"));return I&&P.set(b.META_DATA_MIME,I),P}b.parseMetaData=f})(m=e.DataUri||(e.DataUri={}));function h(b,f,C){if(f){let P=b.path;return P&&P[0]!==R.posix.sep&&(P=R.posix.sep+P),b.with({scheme:C,authority:f,path:P})}return b.with({scheme:C})}e.toLocalResource=h}),define(Z[6],ee([0,1,29,11,3,2,66,12]),function(G,e,v,R,L,k,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(_){return!!_&&typeof _.then=="function"}e.isThenable=y;function S(_){const T=new v.CancellationTokenSource,A=_(T.token),M=new Promise((N,B)=>{T.token.onCancellationRequested(()=>{B(R.canceled())}),Promise.resolve(A).then(W=>{T.dispose(),N(W)},W=>{T.dispose(),B(W)})});return new class{cancel(){T.cancel()}then(N,B){return M.then(N,B)}catch(N){return this.then(void 0,N)}finally(N){return M.finally(N)}}}e.createCancelablePromise=S;function n(_,T,A){return Promise.race([_,new Promise(M=>T.onCancellationRequested(()=>M(A)))])}e.raceCancellation=n;async function m(_){let T=-1;const A=_.map((N,B)=>N.then(W=>(T=B,W))),M=await Promise.race(A);return _.forEach((N,B)=>{B!==T&&N.cancel()}),M}e.raceCancellablePromises=m;function h(_,T,A){let M;const N=setTimeout(()=>{M==null||M(void 0),A==null||A()},T);return Promise.race([_.finally(()=>clearTimeout(N)),new Promise(B=>M=B)])}e.raceTimeout=h;function b(_){return new Promise((T,A)=>{const M=_();y(M)?M.then(T,A):T(M)})}e.asPromise=b;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(T){if(this.activePromise){if(this.queuedPromiseFactory=T,!this.queuedPromise){const A=()=>{this.queuedPromise=null;const M=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,M};this.queuedPromise=new Promise(M=>{this.activePromise.then(A,A).then(M)})}return new Promise((A,M)=>{this.queuedPromise.then(A,M)})}return this.activePromise=T(),new Promise((A,M)=>{this.activePromise.then(N=>{this.activePromise=null,A(N)},N=>{this.activePromise=null,M(N)})})}}e.Throttler=f;class C{constructor(){this.current=Promise.resolve(null)}queue(T){return this.current=this.current.then(()=>T(),()=>T())}}e.Sequencer=C;class P{constructor(){this.promiseMap=new Map}queue(T,A){var M;const B=((M=this.promiseMap.get(T))!==null&&M!==void 0?M:Promise.resolve()).catch(()=>{}).then(A).finally(()=>{this.promiseMap.get(T)===B&&this.promiseMap.delete(T)});return this.promiseMap.set(T,B),B}}e.SequencerByKey=P;class E{constructor(T){this.defaultDelay=T,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(T,A=this.defaultDelay){return this.task=T,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((M,N)=>{this.doResolve=M,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const M=this.task;return this.task=null,M()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},A),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(R.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=E;class I{constructor(T){this.delayer=new E(T),this.throttler=new f}trigger(T,A){return this.delayer.trigger(()=>this.throttler.queue(T),A)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=I;class d{constructor(){this._isOpen=!1,this._promise=new Promise((T,A)=>{this._completePromise=T})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=d;class c extends d{constructor(T){super();this._timeout=setTimeout(()=>this.open(),T)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function s(_,T){return T?new Promise((A,M)=>{const N=setTimeout(A,_);T.onCancellationRequested(()=>{clearTimeout(N),M(R.canceled())})}):S(A=>s(_,A))}e.timeout=s;function t(_,T=0){const A=setTimeout(_,T);return k.toDisposable(()=>clearTimeout(A))}e.disposableTimeout=t;function r(_){return _.then(void 0,T=>{})}e.ignoreErrors=r;function i(_){const T=[];let A=0;const M=_.length;function N(){return A<M?_[A++]():null}function B(W){W!=null&&T.push(W);const Q=N();return Q?Q.then(B):Promise.resolve(T)}return Promise.resolve(null).then(B)}e.sequence=i;function a(_,T=M=>!!M,A=null){let M=0;const N=_.length,B=()=>{if(M>=N)return Promise.resolve(A);const W=_[M++];return Promise.resolve(W()).then(J=>T(J)?Promise.resolve(J):B())};return B()}e.first=a;function u(_,T=M=>!!M,A=null){if(_.length===0)return Promise.resolve(A);let M=_.length;const N=()=>{var B,W;M=-1;for(const Q of _)(W=(B=Q).cancel)===null||W===void 0||W.call(B)};return new Promise((B,W)=>{for(const Q of _)Q.then(J=>{--M>=0&&T(J)?(N(),B(J)):M===0&&B(A)}).catch(J=>{--M>=0&&(N(),W(J))})})}e.firstParallel=u;class o{constructor(T){this._size=0,this.maxDegreeOfParalellism=T,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(T){return this._size++,new Promise((A,M)=>{this.outstandingPromises.push({factory:T,c:A,e:M}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const T=this.outstandingPromises.shift();this.runningPromises++;const A=T.factory();A.then(T.c,T.e),A.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class l extends o{constructor(){super(1)}}e.Queue=l;class p{constructor(){this.queues=new Map}queueFor(T,A=D.extUri){const M=A.getComparisonKey(T);let N=this.queues.get(M);return N||(N=new l,L.Event.once(N.onFinished)(()=>{N==null||N.dispose(),this.queues.delete(M)}),this.queues.set(M,N)),N}dispose(){this.queues.forEach(T=>T.dispose()),this.queues.clear()}}e.ResourceQueue=p;class w{constructor(T,A){this._token=-1,typeof T=="function"&&typeof A=="number"&&this.setIfNotSet(T,A)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(T,A){this.cancel(),this._token=setTimeout(()=>{this._token=-1,T()},A)}setIfNotSet(T,A){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,T()},A))}}e.TimeoutTimer=w;class g{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(T,A){this.cancel(),this._token=setInterval(()=>{T()},A)}}e.IntervalTimer=g;class U{constructor(T,A){this.timeoutToken=-1,this.runner=T,this.timeout=A,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(T=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,T)}get delay(){return this.timeout}set delay(T){this.timeout=T}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=U;class F extends U{constructor(T,A){super(T,A);this.units=[]}work(T){this.units.push(T),this.isScheduled()||this.schedule()}doRun(){const T=this.units;this.units=[],this.runner&&this.runner(T)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const _=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=T=>{const A=setTimeout(()=>T(_));let M=!1;return{dispose(){M||(M=!0,clearTimeout(A))}}}}else e.runWhenIdle=(_,T)=>{const A=requestIdleCallback(_,typeof T=="number"?{timeout:T}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(A))}}}}();class j{constructor(T){this._didRun=!1,this._executor=()=>{try{this._value=T()}catch(A){this._error=A}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=j;async function z(_,T,A){let M;for(let N=0;N<A;N++)try{return await _()}catch(B){M=B,await s(T)}throw M}e.retry=z;class V{hasPending(T){return this._pending?typeof T=="number"?this._pending.taskId===T:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var T;(T=this._pending)===null||T===void 0||T.cancel()}setPending(T,A,M){return this._pending={taskId:T,cancel:()=>M==null?void 0:M(),promise:A},A.then(()=>this.donePending(T),()=>this.donePending(T)),A}donePending(T){this._pending&&T===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const T=this._next;this._next=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}setNext(T){if(this._next)this._next.run=T;else{let A,M;const N=new Promise((B,W)=>{A=B,M=W});this._next={run:T,promise:N,promiseResolve:A,promiseReject:M}}return this._next.promise}}e.TaskSequentializer=V;class q{constructor(T){this.interval=T,this.lastIncrementTime=0,this.value=0}increment(){const T=Date.now();return T-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=T,this.value=0),this.value++,this.value}}e.IntervalCounter=q;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((T,A)=>{this.completeCallback=T,this.errorCallback=A})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(T){return new Promise(A=>{this.completeCallback(T),this.resolved=!0,A()})}error(T){return new Promise(A=>{this.errorCallback(T),this.rejected=!0,A()})}cancel(){new Promise(T=>{this.errorCallback(R.canceled()),this.rejected=!0,T()})}}e.DeferredPromise=$;class H extends L.Emitter{async fireAsync(T,A,M){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new O.LinkedList);for(const N of this._listeners)this._asyncDeliveryQueue.push([N,T]);for(;this._asyncDeliveryQueue.size>0&&!A.isCancellationRequested;){const[N,B]=this._asyncDeliveryQueue.shift(),W=[],Q=Object.assign(Object.assign({},B),{waitUntil:J=>{if(Object.isFrozen(W))throw new Error("waitUntil can NOT be called asynchronous");M&&(J=M(J,typeof N=="function"?N:N[0])),W.push(J)}});try{typeof N=="function"?N.call(void 0,Q):N[0].call(N[1],Q)}catch(J){R.onUnexpectedError(J);continue}Object.freeze(W),await X.settled(W).catch(J=>R.onUnexpectedError(J))}}}}e.AsyncEmitter=H;var X;(function(_){async function T(B){return typeof Promise.allSettled=="function"?A(B):M(B)}_.allSettled=T;async function A(B){return Promise.allSettled(B)}async function M(B){return Promise.all(B.map(W=>W.then(Q=>({status:"fulfilled",value:Q}),Q=>({status:"rejected",reason:Q}))))}async function N(B){let W;const Q=await Promise.all(B.map(J=>J.then(ie=>ie,ie=>{W||(W=ie)})));if(typeof W!="undefined")throw W;return Q}_.settled=N})(X=e.Promises||(e.Promises={}))}),define(Z[68],ee([0,1,20,41,8,38,6]),function(G,e,v,R,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const y="**",S="/",n="[/\\\\]",m="[^/\\\\]",h=/\//g;function b(A){switch(A){case 0:return"";case 1:return`${m}*?`;default:return`(?:${n}|${m}+${n}|${n}${m}+)*?`}}function f(A,M){if(!A)return[];const N=[];let B=!1,W=!1,Q="";for(const J of A){switch(J){case M:if(!B&&!W){N.push(Q),Q="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":W=!0;break;case"]":W=!1;break}Q+=J}return Q&&N.push(Q),N}e.splitGlobAware=f;function C(A){if(!A)return"";let M="";const N=f(A,S);if(N.every(B=>B===y))M=".*";else{let B=!1;N.forEach((W,Q)=>{if(W===y){B||(M+=b(2),B=!0);return}let J=!1,ie="",ne=!1,ce="";for(const le of W){if(le!=="}"&&J){ie+=le;continue}if(ne&&(le!=="]"||!ce)){let ve;le==="-"?ve=le:(le==="^"||le==="!")&&!ce?ve="^":le===S?ve="":ve=v.escapeRegExpCharacters(le),ce+=ve;continue}switch(le){case"{":J=!0;continue;case"[":ne=!0;continue;case"}":M+=`(?:${f(ie,",").map(Ce=>C(Ce)).join("|")})`,J=!1,ie="";break;case"]":M+="["+ce+"]",ne=!1,ce="";break;case"?":M+=m;continue;case"*":M+=b(1);continue;default:M+=v.escapeRegExpCharacters(le)}}Q<N.length-1&&(N[Q+1]!==y||Q+2<N.length)&&(M+=n),B=!1})}return M}const P=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new k.LRUCache(1e4),r=function(){return!1},i=function(){return null};function a(A,M){if(!A)return i;let N;typeof A!="string"?N=A.pattern:N=A,N=N.trim();const B=`${N}_${!!M.trimForExclusions}`;let W=t.get(B);if(W)return u(W,A);let Q;if(P.test(N)){const J=N.substr(4);W=function(ie,ne){return typeof ie=="string"&&ie.endsWith(J)?N:null}}else(Q=E.exec(o(N,M)))?W=l(Q[1],N):(M.trimForExclusions?d:I).test(N)?W=p(N,M):(Q=c.exec(o(N,M)))?W=w(Q[1].substr(1),N,!0):(Q=s.exec(o(N,M)))?W=w(Q[1],N,!1):W=g(N);return t.set(B,W),u(W,A)}function u(A,M){return typeof M=="string"?A:function(N,B){return R.isEqualOrParent(N,M.base)?A(L.relative(M.base,N),B):null}}function o(A,M){return M.trimForExclusions&&A.endsWith("/**")?A.substr(0,A.length-2):A}function l(A,M){const N=`/${A}`,B=`\\${A}`,W=function(J,ie){return typeof J!="string"?null:ie?ie===A?M:null:J===A||J.endsWith(N)||J.endsWith(B)?M:null},Q=[A];return W.basenames=Q,W.patterns=[M],W.allBasenames=Q,W}function p(A,M){const N=T(A.slice(1,-1).split(",").map(ie=>a(ie,M)).filter(ie=>ie!==i),A),B=N.length;if(!B)return i;if(B===1)return N[0];const W=function(ie,ne){for(let ce=0,le=N.length;ce<le;ce++)if(N[ce](ie,ne))return A;return null},Q=N.find(ie=>!!ie.allBasenames);Q&&(W.allBasenames=Q.allBasenames);const J=N.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return J.length&&(W.allPaths=J),W}function w(A,M,N){const B=L.sep===L.posix.sep,W=B?A:A.replace(h,L.sep),Q=L.sep+W,J=L.posix.sep+A,ie=N?function(ne,ce){return typeof ne=="string"&&(ne===W||ne.endsWith(Q)||!B&&(ne===A||ne.endsWith(J)))?M:null}:function(ne,ce){return typeof ne=="string"&&(ne===W||!B&&ne===A)?M:null};return ie.allPaths=[(N?"*/":"./")+A],ie}function g(A){try{const M=new RegExp(`^${C(A)}$`);return function(N){return M.lastIndex=0,typeof N=="string"&&M.test(N)?A:null}}catch(M){return i}}function U(A,M,N){return!A||typeof M!="string"?!1:F(A)(M,void 0,N)}e.match=U;function F(A,M={}){if(!A)return r;if(typeof A=="string"||q(A)){const N=a(A,M);if(N===i)return r;const B=function(W,Q){return!!N(W,Q)};return N.allBasenames&&(B.allBasenames=N.allBasenames),N.allPaths&&(B.allPaths=N.allPaths),B}return X(A,M)}e.parse=F;function j(A){if(!A)return;let M;return N=>(M||(M=(A()||Promise.resolve([])).then(B=>B?V(B):{})),M.then(B=>!!B[N]))}e.hasSiblingPromiseFn=j;function z(A){if(!A)return;let M;return N=>{if(!M){const B=A();M=B?V(B):{}}return!!M[N]}}e.hasSiblingFn=z;function V(A){const M={};for(const N of A)M[N]=!0;return M}function q(A){const M=A;return M&&typeof M.base=="string"&&typeof M.pattern=="string"}e.isRelativePattern=q;function $(A){return A.allBasenames||[]}e.getBasenameTerms=$;function H(A){return A.allPaths||[]}e.getPathTerms=H;function X(A,M){const N=T(Object.getOwnPropertyNames(A).map(ie=>_(ie,A[ie],M)).filter(ie=>ie!==i)),B=N.length;if(!B)return i;if(!N.some(ie=>!!ie.requiresSiblings)){if(B===1)return N[0];const ie=function(le,ve){for(let pe=0,Ce=N.length;pe<Ce;pe++){const Ae=N[pe](le,ve);if(Ae)return Ae}return null},ne=N.find(le=>!!le.allBasenames);ne&&(ie.allBasenames=ne.allBasenames);const ce=N.reduce((le,ve)=>ve.allPaths?le.concat(ve.allPaths):le,[]);return ce.length&&(ie.allPaths=ce),ie}const W=function(ie,ne,ce){let le;for(let ve=0,pe=N.length;ve<pe;ve++){const Ce=N[ve];Ce.requiresSiblings&&ce&&(ne||(ne=L.basename(ie)),le||(le=ne.substr(0,ne.length-L.extname(ie).length)));const Ae=Ce(ie,ne,le,ce);if(Ae)return Ae}return null},Q=N.find(ie=>!!ie.allBasenames);Q&&(W.allBasenames=Q.allBasenames);const J=N.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return J.length&&(W.allPaths=J),W}function _(A,M,N){if(M===!1)return i;const B=a(A,N);if(B===i)return i;if(typeof M=="boolean")return B;if(M){const W=M.when;if(typeof W=="string"){const Q=(J,ie,ne,ce)=>{if(!ce||!B(J,ie))return null;const le=W.replace("$(basename)",ne),ve=ce(le);return O.isThenable(ve)?ve.then(pe=>pe?A:null):ve?A:null};return Q.requiresSiblings=!0,Q}}return B}function T(A,M){const N=A.filter(ie=>!!ie.basenames);if(N.length<2)return A;const B=N.reduce((ie,ne)=>{const ce=ne.basenames;return ce?ie.concat(ce):ie},[]);let W;if(M){W=[];for(let ie=0,ne=B.length;ie<ne;ie++)W.push(M)}else W=N.reduce((ie,ne)=>{const ce=ne.patterns;return ce?ie.concat(ce):ie},[]);const Q=function(ie,ne){if(typeof ie!="string")return null;if(!ne){let le;for(le=ie.length;le>0;le--){const ve=ie.charCodeAt(le-1);if(ve===47||ve===92)break}ne=ie.substr(le)}const ce=B.indexOf(ne);return ce!==-1?W[ce]:null};Q.basenames=B,Q.patterns=W,Q.allBasenames=B;const J=A.filter(ie=>!ie.basenames);return J.push(Q),J}}),define(Z[92],ee([0,1,8,20,68,17,12]),function(G,e,v,R,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var D;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(D=e.Mimes||(e.Mimes={}));let y=[],S=[],n=[];function m(r,i=!1){const a=h(r);y.push(a),a.userConfigured?n.push(a):S.push(a),i&&!a.userConfigured&&y.forEach(u=>{u.mime===a.mime||u.userConfigured||(a.extension&&u.extension===a.extension&&console.warn(`Overwriting extension <<${a.extension}>> to now point to mime <<${a.mime}>>`),a.filename&&u.filename===a.filename&&console.warn(`Overwriting filename <<${a.filename}>> to now point to mime <<${a.mime}>>`),a.filepattern&&u.filepattern===a.filepattern&&console.warn(`Overwriting filepattern <<${a.filepattern}>> to now point to mime <<${a.mime}>>`),a.firstline&&u.firstline===a.firstline&&console.warn(`Overwriting firstline <<${a.firstline}>> to now point to mime <<${a.mime}>>`))})}e.registerTextMime=m;function h(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(v.posix.sep)>=0:!1}}function b(r){r?(y=y.filter(i=>!i.userConfigured),n=[]):(y=[],S=[],n=[])}e.clearTextMimes=b;function f(r,i){let a;if(r)switch(r.scheme){case k.Schemas.file:a=r.fsPath;break;case k.Schemas.data:a=O.DataUri.parseMetaData(r).get(O.DataUri.META_DATA_LABEL);break;default:a=r.path}if(!a)return[D.unknown];a=a.toLowerCase();const u=v.basename(a),o=C(a,u,n);if(o)return[o,D.text];const l=C(a,u,S);if(l)return[l,D.text];if(i){const p=P(i);if(p)return[p,D.text]}return[D.unknown]}e.guessMimeTypes=f;function C(r,i,a){let u=null,o=null,l=null;for(let p=a.length-1;p>=0;p--){const w=a[p];if(i===w.filenameLowercase){u=w;break}if(w.filepattern&&(!o||w.filepattern.length>o.filepattern.length)){const g=w.filepatternOnPath?r:i;L.match(w.filepatternLowercase,g)&&(o=w)}w.extension&&(!l||w.extension.length>l.extension.length)&&i.endsWith(w.extensionLowercase)&&(l=w)}return u?u.mime:o?o.mime:l?l.mime:null}function P(r){if(R.startsWithUTF8BOM(r)&&(r=r.substr(1)),r.length>0)for(let i=y.length-1;i>=0;i--){const a=y[i];if(!a.firstline)continue;const u=r.match(a.firstline);if(u&&u.length>0)return a.mime}return null}function E(r){return r?typeof r=="string"?r===D.binary||r===D.text||r===D.unknown:r.length===1&&E(r[0]):!0}e.isUnspecific=E;const I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function d(r){const i=v.extname(r);return I[i.toLowerCase()]}e.getMediaMime=d;function c(r){for(const i in I)if(I[i]===r)return i}e.getExtensionForMimeType=c;const s=/^(.+)\/(.+?)(;.+)?$/;function t(r,i){var a;const u=s.exec(r);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${(a=u[3])!==null&&a!==void 0?a:""}`:i?void 0:r}e.normalizeMimeType=t}),define(Z[93],ee([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(n){return n.toJSON()}class L{constructor(m){this._uriTransformer=m}transformIncoming(m){const h=this._uriTransformer.transformIncoming(m);return h===m?m:R(v.URI.from(h))}transformOutgoing(m){const h=this._uriTransformer.transformOutgoing(m);return h===m?m:R(v.URI.from(h))}transformOutgoingURI(m){const h=this._uriTransformer.transformOutgoing(m);return h===m?m:v.URI.from(h)}transformOutgoingScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function k(n,m,h){if(!n||h>200)return null;if(typeof n=="object"){if(n instanceof v.URI)return m.transformOutgoing(n);for(let b in n)if(Object.hasOwnProperty.call(n,b)){const f=k(n[b],m,h+1);f!==null&&(n[b]=f)}}return null}function O(n,m){const h=k(n,m,0);return h===null?n:h}e.transformOutgoingURIs=O;function D(n,m,h,b){if(!n||b>200)return null;if(typeof n=="object"){if(n.$mid===1)return h?v.URI.revive(m.transformIncoming(n)):m.transformIncoming(n);for(let f in n)if(Object.hasOwnProperty.call(n,f)){const C=D(n[f],m,h,b+1);C!==null&&(n[f]=C)}}return null}function y(n,m){const h=D(n,m,!1,0);return h===null?n:h}e.transformIncomingURIs=y;function S(n,m){const h=D(n,m,!0,0);return h===null?n:h}e.transformAndReviveIncomingURIs=S}),define(Z[30],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(y){return v.test(y)}e.isUUID=R;const L=new Uint8Array(16),k=[];for(let y=0;y<256;y++)k.push(y.toString(16).padStart(2,"0"));let O;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?O=crypto.getRandomValues.bind(crypto):O=function(y){for(let S=0;S<y.length;S++)y[S]=Math.floor(Math.random()*256);return y};function D(){O(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let y=0,S="";return S+=k[L[y++]],S+=k[L[y++]],S+=k[L[y++]],S+=k[L[y++]],S+="-",S+=k[L[y++]],S+=k[L[y++]],S+="-",S+=k[L[y++]],S+=k[L[y++]],S+="-",S+=k[L[y++]],S+=k[L[y++]],S+="-",S+=k[L[y++]],S+=k[L[y++]],S+=k[L[y++]],S+=k[L[y++]],S+=k[L[y++]],S+=k[L[y++]],S}e.generateUuid=D}),define(Z[69],ee([0,1,207]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(k="utf8"){this.stringDecoder=new v.StringDecoder(k),this.remaining=null}write(k){const O=[],D=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(D.length<1)return O;let y=0,S,n=y;for(;n<D.length;)if(S=D.charCodeAt(n),S===13||S===10){if(O.push(D.substring(y,n)),n++,n<D.length){const m=S;S=D.charCodeAt(n),(m===13&&S===10||m===10&&S===13)&&n++}y=n}else n++;return this.remaining=y<D.length?D.substr(y):null,O}end(){return this.remaining}}e.LineDecoder=R}),define(Z[94],ee([0,1,35]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(D){const y=D.replace(/\-/g,":").toLowerCase();return!R.has(y)}function k(){return new Promise(async(D,y)=>{const S=setTimeout(()=>y("Unable to retrieve mac address (timeout after 10s)"),1e4);try{D(await O())}catch(n){y(n)}finally{clearTimeout(S)}})}e.getMac=k;function O(){return new Promise((D,y)=>{try{const S=v.networkInterfaces();for(let n in S){const m=S[n];if(m){for(const{mac:h}of m)if(L(h))return D(h)}}y("Unable to retrieve mac address (unexpected format)")}catch(S){y(S)}})}}),define(Z[95],ee([0,1,11,30,35,38,94]),function(G,e,v,R,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,m=0;const h=L.networkInterfaces();for(let b in h){const f=h[b];if(f)for(const{mac:C,internal:P}of f)P||(m+=1,this._isVirtualMachineMacAdress(C.toUpperCase())&&(n+=1))}this._value=m>0?n/m:0}return this._value}};let D;async function y(){return D||(D=(async()=>await S()||R.generateUuid())()),D}e.getMachineId=y;async function S(){try{const n=await new Promise((h,b)=>{G(["crypto"],h,b)}),m=await O.getMac();return n.createHash("sha256").update(m,"utf8").digest("hex")}catch(n){v.onUnexpectedError(n);return}}}),define(Z[18],ee([0,1,48,35,208,8,6,7,41,30,67,12,5]),function(G,e,v,R,L,k,O,D,y,S,n,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function f($,H=b.UNLINK){if(y.isRootOrDriveLetter($))throw new Error("rimraf - will refuse to recursively delete root");return H===b.UNLINK?P($):C($)}async function C($){try{const H=k.join(R.tmpdir(),S.generateUuid());try{await e.Promises.rename($,H)}catch(X){return P($)}P(H).catch(X=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function P($){return e.Promises.rmdir($,{recursive:!0,maxRetries:3})}function E($){if(y.isRootOrDriveLetter($))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync($,{recursive:!0})}e.rimrafSync=E;async function I($,H){return s(await(H?d($):L.promisify(v.readdir)($)))}async function d($){try{return await L.promisify(v.readdir)($,{withFileTypes:!0})}catch(_){console.warn("[node.js fs] readdir with filetypes failed with error: ",_)}const H=[],X=await I($);for(const _ of X){let T=!1,A=!1,M=!1;try{const N=await e.Promises.lstat(k.join($,_));T=N.isFile(),A=N.isDirectory(),M=N.isSymbolicLink()}catch(N){console.warn("[node.js fs] unexpected error from lstat after readdir: ",N)}H.push({name:_,isFile:()=>T,isDirectory:()=>A,isSymbolicLink:()=>M})}return H}function c($){return s(v.readdirSync($))}e.readdirSync=c;function s($){return $.map(H=>typeof H=="string"?D.isMacintosh?n.normalizeNFC(H):H:(H.name=D.isMacintosh?n.normalizeNFC(H.name):H.name,H))}async function t($){const H=await I($),X=[];for(const _ of H)await i.existsDirectory(k.join($,_))&&X.push(_);return X}function r($,H=1e3){return new Promise(X=>{let _=!1;const T=setInterval(()=>{_||(_=!0,v.access($,A=>{_=!1,A&&(clearInterval(T),X(void 0))}))},H)})}e.whenDeleted=r;var i;(function($){async function H(T){let A;try{if(A=await e.Promises.lstat(T),!A.isSymbolicLink())return{stat:A}}catch(M){}try{return{stat:await e.Promises.stat(T),symbolicLink:(A==null?void 0:A.isSymbolicLink())?{dangling:!1}:void 0}}catch(M){if(M.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};if(D.isWindows&&M.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(T)),symbolicLink:{dangling:!1}}}catch(N){if(N.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};throw N}throw M}}$.stat=H;async function X(T){try{const{stat:A,symbolicLink:M}=await $.stat(T);return A.isFile()&&(M==null?void 0:M.dangling)!==!0}catch(A){}return!1}$.existsFile=X;async function _(T){try{const{stat:A,symbolicLink:M}=await $.stat(T);return A.isDirectory()&&(M==null?void 0:M.dangling)!==!0}catch(A){}return!1}$.existsDirectory=_})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new O.ResourceQueue;function u($,H,X){return a.queueFor(h.URI.file($),m.extUriBiasedIgnorePathCase).queue(()=>{const _=w(X);return new Promise((T,A)=>l($,H,_,M=>M?A(M):T()))})}let o=!0;function l($,H,X,_){if(!o)return v.writeFile($,H,{mode:X.mode,flag:X.flag},_);v.open($,X.flag,X.mode,(T,A)=>{if(T)return _(T);v.writeFile(A,H,M=>{if(M)return v.close(A,()=>_(M));v.fdatasync(A,N=>(N&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",N),o=!1),v.close(A,B=>_(B))))})})}function p($,H,X){const _=w(X);if(!o)return v.writeFileSync($,H,{mode:_.mode,flag:_.flag});const T=v.openSync($,_.flag,_.mode);try{v.writeFileSync(T,H);try{v.fdatasyncSync(T)}catch(A){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",A),o=!1}}finally{v.closeSync(T)}}e.writeFileSync=p;function w($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function g($,H){if($===H)return;async function X(_){try{const T=await e.Promises.lstat(_);if(T.isDirectory()||T.isSymbolicLink())return;await e.Promises.utimes(_,T.atime,new Date)}catch(T){}}try{await e.Promises.rename($,H),await X(H)}catch(_){if($.toLowerCase()!==H.toLowerCase()&&_.code==="EXDEV"||$.endsWith("."))await U($,H,{preserveSymlinks:!1}),await f($,b.MOVE),await X(H);else throw _}}async function U($,H,X){return j($,H,{root:{source:$,target:H},options:X,handledSourcePaths:new Set})}const F=511;async function j($,H,X){if(X.handledSourcePaths.has($))return;X.handledSourcePaths.add($);const{stat:_,symbolicLink:T}=await i.stat($);if(T){if(X.options.preserveSymlinks)try{return await q($,H,X)}catch(A){console.warn("[node.js fs] copy of symlink failed: ",A)}if(T.dangling)return}return _.isDirectory()?z($,H,_.mode&F,X):V($,H,_.mode&F)}async function z($,H,X,_){await e.Promises.mkdir(H,{recursive:!0,mode:X});const T=await I($);for(const A of T)await j(k.join($,A),k.join(H,A),_)}async function V($,H,X){await e.Promises.copyFile($,H),await e.Promises.chmod(H,X)}async function q($,H,X){let _=await e.Promises.readlink($);y.isEqualOrParent(_,X.root.source,!D.isLinux)&&(_=k.join(X.root.target,_.substr(X.root.source.length+1))),await e.Promises.symlink(_,H)}e.Promises=new class{get access(){return L.promisify(v.access)}get stat(){return L.promisify(v.stat)}get lstat(){return L.promisify(v.lstat)}get utimes(){return L.promisify(v.utimes)}get read(){return L.promisify(v.read)}get readFile(){return L.promisify(v.readFile)}get write(){return L.promisify(v.write)}get appendFile(){return L.promisify(v.appendFile)}get fdatasync(){return L.promisify(v.fdatasync)}get truncate(){return L.promisify(v.truncate)}get rename(){return L.promisify(v.rename)}get copyFile(){return L.promisify(v.copyFile)}get open(){return L.promisify(v.open)}get close(){return L.promisify(v.close)}get symlink(){return L.promisify(v.symlink)}get readlink(){return L.promisify(v.readlink)}get chmod(){return L.promisify(v.chmod)}get mkdir(){return L.promisify(v.mkdir)}get unlink(){return L.promisify(v.unlink)}get rmdir(){return L.promisify(v.rmdir)}get realpath(){return L.promisify(v.realpath)}async exists($){try{return await e.Promises.access($),!0}catch(H){return!1}}get readdir(){return I}get readDirsInDir(){return t}get writeFile(){return u}get rm(){return f}get move(){return g}get copy(){return U}}}),define(Z[96],ee([0,1,48,20,8,18]),function(G,e,v,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function O(n){const m=L.dirname(n);if(n===m)return n;const h=(L.basename(n)||n).toLowerCase();try{const f=k.readdirSync(m).filter(C=>C.toLowerCase()===h);if(f.length===1){const C=O(m);if(C)return L.join(C,f[0])}else if(f.length>1){const C=f.indexOf(h);if(C>=0){const P=O(m);if(P)return L.join(P,f[C])}}}catch(b){}return null}e.realcaseSync=O;async function D(n){try{return await k.Promises.realpath(n)}catch(m){const h=S(n);return await k.Promises.access(h,v.constants.R_OK),h}}e.realpath=D;function y(n){try{return v.realpathSync(n)}catch(m){const h=S(n);return v.accessSync(h,v.constants.R_OK),h}}e.realpathSync=y;function S(n){return R.rtrim(L.normalize(n),L.sep)}});var Le=this&&this.__await||function(G){return this instanceof Le?(this.v=G,this):new Le(G)},lt=this&&this.__asyncGenerator||function(G,e,v){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var R=v.apply(G,e||[]),L,k=[];return L={},O("next"),O("throw"),O("return"),L[Symbol.asyncIterator]=function(){return this},L;function O(h){R[h]&&(L[h]=function(b){return new Promise(function(f,C){k.push([h,b,f,C])>1||D(h,b)})})}function D(h,b){try{y(R[h](b))}catch(f){m(k[0][3],f)}}function y(h){h.value instanceof Le?Promise.resolve(h.value.v).then(S,n):m(k[0][2],h)}function S(h){D("next",h)}function n(h){D("throw",h)}function m(h,b){h(b),k.shift(),k.length&&D(k[0][0],k[0][1])}},et=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],v;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),v={},R("next"),R("throw"),R("return"),v[Symbol.asyncIterator]=function(){return this},v);function R(k){v[k]=G[k]&&function(O){return new Promise(function(D,y){O=G[k](O),L(D,y,O.done,O.value)})}}function L(k,O,D,y){Promise.resolve(y).then(function(S){k({value:S,done:D})},O)}};define(Z[97],ee([0,1,18,35,8]),function(G,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,O=/^Microsoft.PowerShell_.*/,D=/^Microsoft.PowerShellPreview_.*/;var y;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(y||(y={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class m{constructor(s,t,r){this.exePath=s,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await v.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:c=!1}={}){return c?S===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:c=!1,findPreview:s=!1}={}){const t=h({useAlternateBitness:c});if(!t)return null;const r=L.join(t,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(r))return null;let i=-1,a=null;for(const l of await v.Promises.readdir(r)){let p=-1;if(s){const g=l.indexOf("-");if(g<0)continue;const U=l.substring(0,g);if(!k.test(U)||l.substring(g+1)!=="preview")continue;p=parseInt(U,10)}else{if(!k.test(l))continue;p=parseInt(l,10)}if(p<=i)continue;const w=L.join(r,l,"pwsh.exe");!await v.SymlinkSupport.existsFile(w)||(a=w,i=p)}if(!a)return null;const u=t.includes("x86")?" (x86)":"",o=s?" Preview":"";return new m(a,`PowerShell${o}${u}`,!0)}async function f({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const s=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=c?{pwshMsixDirRegex:D,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const i of await v.Promises.readdir(s))if(t.test(i)){const a=L.join(s,i,"pwsh.exe");return new m(a,r)}return null}function C(){const c=L.join(R.homedir(),".dotnet","tools","pwsh.exe");return new m(c,".NET Core PowerShell Global Tool")}function P(){const c=L.join(process.env.windir,S===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new m(c,"Windows PowerShell",!0)}function E(){return lt(this,arguments,function*(){let s=yield Le(b());s&&(yield yield Le(s)),s=yield Le(b({useAlternateBitness:!0})),s&&(yield yield Le(s)),s=yield Le(f()),s&&(yield yield Le(s)),s=C(),s&&(yield yield Le(s)),s=yield Le(b({findPreview:!0})),s&&(yield yield Le(s)),s=yield Le(f({findPreview:!0})),s&&(yield yield Le(s)),s=yield Le(b({useAlternateBitness:!0,findPreview:!0})),s&&(yield yield Le(s)),s=P(),s&&(yield yield Le(s))})}function I(){return lt(this,arguments,function*(){var s,t;try{for(var r=et(E()),i;i=yield Le(r.next()),!i.done;){const a=i.value;(yield Le(a.exists()))&&(yield yield Le(a))}}catch(a){s={error:a}}finally{try{i&&!i.done&&(t=r.return)&&(yield Le(t.call(r)))}finally{if(s)throw s.error}}})}e.enumeratePowerShellInstallations=I;async function d(){var c,s;try{for(var t=et(I()),r;r=await t.next(),!r.done;)return r.value}catch(i){c={error:i}}finally{try{r&&!r.done&&(s=t.return)&&await s.call(t)}finally{if(c)throw c.error}}return null}e.getFirstAvailablePowerShellInstallation=d}),define(Z[98],ee([0,1,42,17]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(O){return new Promise((D,y)=>{let S;const n=new Map;function m(b,f,C,P,E){const I=n.get(f);if(b===O||I){const d={name:h(C),cmd:C,pid:b,ppid:f,load:P,mem:E};n.set(b,d),b===O&&(S=d),I&&(I.children||(I.children=[]),I.children.push(d),I.children.length>1&&(I.children=I.children.sort((c,s)=>c.pid-s.pid)))}}function h(b){const f=/--disable-blink-features=Auxclick/,C=/\\watcher\\win32\\CodeHelper\.exe/,P=/--crashes-directory/,E=/\\pipe\\winpty-control/,I=/conhost\.exe/,d=/--type=([a-zA-Z-]+)/;if(C.exec(b))return"watcherService ";if(P.exec(b))return"electron-crash-reporter";if(E.exec(b))return"winpty-process";if(I.exec(b))return"console-window-host (Windows internal process)";let c=d.exec(b);if(c&&c.length===2)return c[1]==="renderer"?f.exec(b)?"shared-process":"window":c[1];const s=/[a-zA-Z-]+\.js/g;let t="";do c=s.exec(b),c&&(t+=c+" ");while(c);return t&&b.indexOf("node ")<0&&b.indexOf("node.exe")<0?`electron_node ${t}`:b}if(process.platform==="win32"){const b=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,C)=>{G(["windows-process-tree"],f,C)}).then(f=>{f.getProcessList(O,C=>{f.getProcessCpuUsage(C,P=>{const E=new Map;P.forEach(I=>{const d=b(I.commandLine||"");E.set(I.pid,{name:h(d),cmd:d,pid:I.pid,ppid:I.ppid,load:I.cpu||0,mem:I.memory||0})}),S=E.get(O),S?(E.forEach(I=>{const d=E.get(I.ppid);d&&(d.children||(d.children=[]),d.children.push(I))}),E.forEach(I=>{I.children&&(I.children=I.children.sort((d,c)=>d.pid-c.pid))}),D(S)):y(new Error(`Root process ${O} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let b=function(){let f=[S];const C=[];for(;f.length;){const E=f.shift();E&&(C.push(E.pid),E.children&&(f=f.concat(E.children)))}let P=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",G).fsPath);P+=" "+C.join(" "),v.exec(P,{},(E,I,d)=>{if(E||d)y(E||new Error(d.toString()));else{const c=I.toString().split(`
`);for(let s=0;s<C.length;s++){const t=n.get(C[s]);t.load=parseFloat(c[s])}if(!S){y(new Error(`Root process ${O} not found`));return}D(S)}})};v.exec("which ps",{},(f,C,P)=>{if(f||P)if(process.platform!=="linux")y(f||new Error(P.toString()));else{const E=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/ps.sh",G).fsPath);v.exec(E,{},(I,d,c)=>{I||c?y(I||new Error(c.toString())):(k(d,m),b())})}else{const E=C.toString().trim(),I="-ax -o pid=,ppid=,pcpu=,pmem=,command=";v.exec(`${E} ${I}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,c,s)=>{d||s&&!s.includes("screen size is bogus")?y(d||new Error(s.toString())):(k(c,m),process.platform==="linux"?b():S?D(S):y(new Error(`Root process ${O} not found`)))})}})}})}e.listProcesses=L;function k(O,D){const y=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=O.toString().split(`
`);for(const n of S){const m=y.exec(n.trim());m&&m.length===6&&D(parseInt(m[1]),parseInt(m[2]),m[5],parseFloat(m[3]),parseFloat(m[4]))}}}),define(Z[99],ee([0,1,8,48,7,67,2,18]),function(G,e,v,R,L,k,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function y(m,h,b){return n({path:m,isDirectory:!1},h,b)}e.watchFile=y;function S(m,h,b){return n({path:m,isDirectory:!0},h,b)}e.watchFolder=S,e.CHANGE_BUFFER_DELAY=100;function n(m,h,b){const f=v.basename(m.path),C=new Map;let P=!1,E=[O.toDisposable(()=>{C.forEach(I=>O.dispose(I)),C.clear()})];try{const I=R.watch(m.path);E.push(O.toDisposable(()=>{I.removeAllListeners(),I.close()}));const d=new Set;m.isDirectory&&D.Promises.readdir(m.path).then(c=>c.forEach(s=>d.add(s))),I.on("error",(c,s)=>{P||b(`Failed to watch ${m.path} for changes using fs.watch() (${c}, ${s})`)}),I.on("change",(c,s)=>{if(P)return;let t="";if(s&&(t=s.toString(),L.isMacintosh&&(t=k.normalizeNFC(t))),!t||c!=="change"&&c!=="rename")return;const r=m.isDirectory?v.join(m.path,t):m.path;if(m.isDirectory)if(c==="rename"){const i=C.get(r);i&&O.dispose(i);const a=setTimeout(async()=>{C.delete(r);const u=await D.Promises.exists(r);if(P)return;let o;u?d.has(t)?o="changed":(o="added",d.add(t)):(d.delete(t),o="deleted"),h(o,r)},e.CHANGE_BUFFER_DELAY);C.set(r,O.toDisposable(()=>clearTimeout(a)))}else{let i;d.has(t)?i="changed":(i="added",d.add(t)),h(i,r)}else if(c==="rename"||t!==f){const i=setTimeout(async()=>{const a=await D.Promises.exists(r);P||(a?(h("changed",r),E=[n(m,h,b)]):h("deleted",r))},e.CHANGE_BUFFER_DELAY);O.dispose(E),E=[O.toDisposable(()=>clearTimeout(i))]}else h("changed",r)})}catch(I){D.Promises.exists(m.path).then(d=>{d&&!P&&b(`Failed to watch ${m.path} for changes using fs.watch() (${I.toString()})`)})}return O.toDisposable(()=>{P=!0,E=O.dispose(E)})}});var de=this&&this.__decorate||function(G,e,v,R){var L=arguments.length,k=L<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,v):R,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(G,e,v,R);else for(var D=G.length-1;D>=0;D--)(O=G[D])&&(k=(L<3?O(k):L>3?O(e,v,k):O(e,v))||k);return L>3&&k&&Object.defineProperty(e,v,k),k};define(Z[36],ee([0,1,3,2,6,29,11,25,19,16,91,20,64]),function(G,e,v,R,L,k,O,D,y,S,n,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function f(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var C;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(C=e.ResponseType||(e.ResponseType={}));function P(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(E||(E={}));class I{constructor(A){this.buffer=A,this.pos=0}read(A){const M=this.buffer.slice(this.pos,this.pos+A);return this.pos+=M.byteLength,M}}class d{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var c;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object"})(c||(c={}));function s(T){const A=D.VSBuffer.alloc(4);return A.writeUInt32BE(T,0),A}function t(T){return T.read(4).readUInt32BE(0)}function r(T){const A=D.VSBuffer.alloc(1);return A.writeUInt8(T,0),A}const i={Undefined:r(c.Undefined),String:r(c.String),Buffer:r(c.Buffer),VSBuffer:r(c.VSBuffer),Array:r(c.Array),Object:r(c.Object)},a=typeof Buffer!="undefined";function u(T,A){if(typeof A=="undefined")T.write(i.Undefined);else if(typeof A=="string"){const M=D.VSBuffer.fromString(A);T.write(i.String),T.write(s(M.byteLength)),T.write(M)}else if(a&&Buffer.isBuffer(A)){const M=D.VSBuffer.wrap(A);T.write(i.Buffer),T.write(s(M.byteLength)),T.write(M)}else if(A instanceof D.VSBuffer)T.write(i.VSBuffer),T.write(s(A.byteLength)),T.write(A);else if(Array.isArray(A)){T.write(i.Array),T.write(s(A.length));for(const M of A)u(T,M)}else{const M=D.VSBuffer.fromString(JSON.stringify(A));T.write(i.Object),T.write(s(M.byteLength)),T.write(M)}}function o(T){switch(T.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return T.read(t(T)).toString();case c.Buffer:return T.read(t(T)).buffer;case c.VSBuffer:return T.read(t(T));case c.Array:{const M=t(T),N=[];for(let B=0;B<M;B++)N.push(o(T));return N}case c.Object:return JSON.parse(T.read(t(T)).toString())}}class l{constructor(A,M,N=null,B=1e3){this.protocol=A,this.ctx=M,this.logger=N,this.timeoutDelay=B,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(A,M){this.channels.set(A,M),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const M=this.send([A.type]);this.logger&&this.logger.logOutgoing(M,0,1,P(A.type));return}case 201:case 202:case 204:case 203:{const M=this.send([A.type,A.id],A.data);this.logger&&this.logger.logOutgoing(M,A.id,1,P(A.type),A.data);return}}}send(A,M=void 0){const N=new d;return u(N,A),u(N,M),this.sendBuffer(N.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch(M){return 0}}onRawMessage(A){const M=new I(A),N=o(M),B=o(M),W=N[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(A.byteLength,N[1],1,`${f(W)}: ${N[2]}.${N[3]}`,B),this.onPromise({type:W,id:N[1],channelName:N[2],name:N[3],arg:B});case 102:return this.logger&&this.logger.logIncoming(A.byteLength,N[1],1,`${f(W)}: ${N[2]}.${N[3]}`,B),this.onEventListen({type:W,id:N[1],channelName:N[2],name:N[3],arg:B});case 101:return this.logger&&this.logger.logIncoming(A.byteLength,N[1],1,`${f(W)}`),this.disposeActiveRequest({type:W,id:N[1]});case 103:return this.logger&&this.logger.logIncoming(A.byteLength,N[1],1,`${f(W)}`),this.disposeActiveRequest({type:W,id:N[1]})}}onPromise(A){const M=this.channels.get(A.channelName);if(!M){this.collectPendingRequest(A);return}const N=new k.CancellationTokenSource;let B;try{B=M.call(this.ctx,A.name,A.arg,N.token)}catch(J){B=Promise.reject(J)}const W=A.id;B.then(J=>{this.sendResponse({id:W,data:J,type:201}),this.activeRequests.delete(A.id)},J=>{J instanceof Error?this.sendResponse({id:W,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.sendResponse({id:W,data:J,type:203}),this.activeRequests.delete(A.id)});const Q=R.toDisposable(()=>N.cancel());this.activeRequests.set(A.id,Q)}onEventListen(A){const M=this.channels.get(A.channelName);if(!M){this.collectPendingRequest(A);return}const N=A.id,W=M.listen(this.ctx,A.name,A.arg)(Q=>this.sendResponse({id:N,data:Q,type:204}));this.activeRequests.set(A.id,W)}disposeActiveRequest(A){const M=this.activeRequests.get(A.id);M&&(M.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let M=this.pendingRequests.get(A.channelName);M||(M=[],this.pendingRequests.set(A.channelName,M));const N=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:A,timeoutTimer:N})}flushPendingRequests(A){const M=this.pendingRequests.get(A);if(M){for(const N of M)switch(clearTimeout(N.timeoutTimer),N.request.type){case 100:this.onPromise(N.request);break;case 102:this.onEventListen(N.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var p;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(A,M=null){this.protocol=A,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(N=>this.onBuffer(N)),this.logger=M}getChannel(A){const M=this;return{call(N,B,W){return M.isDisposed?Promise.reject(O.canceled()):M.requestPromise(A,N,B,W)},listen(N,B){return M.isDisposed?Promise.reject(O.canceled()):M.requestEvent(A,N,B)}}}requestPromise(A,M,N,B=k.CancellationToken.None){const W=this.lastRequestId++,J={id:W,type:100,channelName:A,name:M,arg:N};if(B.isCancellationRequested)return Promise.reject(O.canceled());let ie;return new Promise((ce,le)=>{if(B.isCancellationRequested)return le(O.canceled());const ve=()=>{const Me=Oe=>{switch(Oe.type){case 201:this.handlers.delete(W),ce(Oe.data);break;case 202:this.handlers.delete(W);const ke=new Error(Oe.data.message);ke.stack=Oe.data.stack,ke.name=Oe.data.name,le(ke);break;case 203:this.handlers.delete(W),le(Oe.data);break}};this.handlers.set(W,Me),this.sendRequest(J)};let pe=null;this.state===E.Idle?ve():(pe=L.createCancelablePromise(Me=>this.whenInitialized()),pe.then(()=>{pe=null,ve()}));const Ce=()=>{pe?(pe.cancel(),pe=null):this.sendRequest({id:W,type:101}),le(O.canceled())},Ae=B.onCancellationRequested(Ce);ie=R.combinedDisposable(R.toDisposable(Ce),Ae),this.activeRequests.add(ie)}).finally(()=>{this.activeRequests.delete(ie)})}requestEvent(A,M,N){const B=this.lastRequestId++,Q={id:B,type:102,channelName:A,name:M,arg:N};let J=null;const ie=new v.Emitter({onFirstListenerAdd:()=>{J=L.createCancelablePromise(ce=>this.whenInitialized()),J.then(()=>{J=null,this.activeRequests.add(ie),this.sendRequest(Q)})},onLastListenerRemove:()=>{J?(J.cancel(),J=null):(this.activeRequests.delete(ie),this.sendRequest({id:B,type:103}))}}),ne=ce=>ie.fire(ce.data);return this.handlers.set(B,ne),ie.event}sendRequest(A){switch(A.type){case 100:case 102:{const M=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger&&this.logger.logOutgoing(M,A.id,0,`${f(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const M=this.send([A.type,A.id]);this.logger&&this.logger.logOutgoing(M,A.id,0,f(A.type));return}}}send(A,M=void 0){const N=new d;return u(N,A),u(N,M),this.sendBuffer(N.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch(M){return 0}}onBuffer(A){const M=new I(A),N=o(M),B=o(M),W=N[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(A.byteLength,0,0,P(W)),this.onResponse({type:N[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(A.byteLength,N[1],0,P(W),B),this.onResponse({type:N[0],id:N[1],data:B})}}onResponse(A){if(A.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(A.id);M&&M(A)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===E.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}de([h.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class g{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:M,onDidClientDisconnect:N})=>{v.Event.once(M.onMessage)(W=>{const Q=new I(W),J=o(Q),ie=new l(M,J),ne=new w(M);this.channels.forEach((le,ve)=>ie.registerChannel(ve,le));const ce={channelServer:ie,channelClient:ne,ctx:J};this._connections.add(ce),this._onDidAddConnection.fire(ce),N(()=>{ie.dispose(),ne.dispose(),this._connections.delete(ce),this._onDidRemoveConnection.fire(ce)})})})}get connections(){const A=[];return this._connections.forEach(M=>A.push(M)),A}getChannel(A,M){const N=this;return{call(B,W,Q){let J;if(S.isFunction(M)){let ne=y.getRandomElement(N.connections.filter(M));J=ne?Promise.resolve(ne):v.Event.toPromise(v.Event.filter(N.onDidAddConnection,M))}else J=M.routeCall(N,B,W);const ie=J.then(ne=>ne.channelClient.getChannel(A));return F(ie).call(B,W,Q)},listen(B,W){if(S.isFunction(M))return N.getMulticastEvent(A,M,B,W);const Q=M.routeEvent(N,B,W).then(J=>J.channelClient.getChannel(A));return F(Q).listen(B,W)}}}getMulticastEvent(A,M,N,B){const W=this;let Q=new R.DisposableStore;const J=new v.Emitter({onFirstListenerAdd:()=>{Q=new R.DisposableStore;const ie=new v.EventMultiplexer,ne=new Map,ce=ve=>{const Ce=ve.channelClient.getChannel(A).listen(N,B),Ae=ie.add(Ce);ne.set(ve,Ae)},le=ve=>{const pe=ne.get(ve);!pe||(pe.dispose(),ne.delete(ve))};W.connections.filter(M).forEach(ce),v.Event.filter(W.onDidAddConnection,M)(ce,void 0,Q),W.onDidRemoveConnection(le,void 0,Q),ie.event(J.fire,J,Q),Q.add(ie)},onLastListenerRemove:()=>{Q.dispose()}});return J.event}registerChannel(A,M){this.channels.set(A,M),this._connections.forEach(N=>{N.channelServer.registerChannel(A,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=g;class U{constructor(A,M,N=null){const B=new d;u(B,M),A.send(B.buffer),this.channelClient=new w(A,N),this.channelServer=new l(A,M,N)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,M){this.channelServer.registerChannel(A,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function F(T){return{call(A,M,N){return T.then(B=>B.call(A,M,N))},listen(A,M){const N=new v.Relay;return T.then(B=>N.input=B.listen(A,M)),N.event}}}e.getDelayedChannel=F;function j(T){let A=!1;return{call(M,N,B){return A?T.call(M,N,B):L.timeout(0).then(()=>A=!0).then(()=>T.call(M,N,B))},listen(M,N){if(A)return T.listen(M,N);const B=new v.Relay;return L.timeout(0).then(()=>A=!0).then(()=>B.input=T.listen(M,N)),B.event}}}e.getNextTickChannel=j;class z{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const M of A.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await v.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=z;var V;(function(T){function A(B,W){const Q=B,J=W&&W.disableMarshalling,ie=new Map;for(const ne in Q)N(ne)&&ie.set(ne,v.Event.buffer(Q[ne],!0));return new class{listen(ne,ce){const le=ie.get(ce);if(le)return le;throw new Error(`Event not found: ${ce}`)}call(ne,ce,le){const ve=Q[ce];if(typeof ve=="function"){if(!J&&Array.isArray(le))for(let pe=0;pe<le.length;pe++)le[pe]=n.revive(le[pe]);return ve.apply(Q,le)}throw new Error(`Method not found: ${ce}`)}}}T.fromService=A;function M(B,W){const Q=W&&W.disableMarshalling;return new Proxy({},{get(J,ie){var ne;if(typeof ie=="string")return((ne=W==null?void 0:W.properties)===null||ne===void 0?void 0:ne.has(ie))?W.properties.get(ie):N(ie)?B.listen(ie):async function(...ce){let le;W&&!S.isUndefinedOrNull(W.context)?le=[W.context,...ce]:le=ce;const ve=await B.call(ie,le);return Q?ve:n.revive(ve)};throw new Error(`Property not found: ${String(ie)}`)}})}T.toService=M;function N(B){return B[0]==="o"&&B[1]==="n"&&m.isUpperAsciiLetter(B.charCodeAt(2))}})(V=e.ProxyChannel||(e.ProxyChannel={}));const q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){let A=T.toString();if(A!=="[object Object]")return A}return T}function H(T){return Array.isArray(T)?T.map($):$(T)}function X(T,A,M,N,B,W,Q){Q=H(Q);const J=q[B],ie=J[N%J.length];let ne=[`%c[${T}]%c[${String(A).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(N).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${ie}`];/\($/.test(W)?(ne=ne.concat(Q),ne.push(")")):ne.push(Q),console.log.apply(console,ne)}e.logWithColors=X;class _{constructor(A,M){this._outgoingPrefix=A,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,M,N,B,W){this._totalOutgoing+=A,X(this._outgoingPrefix,this._totalOutgoing,A,M,N,B,W)}logIncoming(A,M,N,B,W){this._totalIncoming+=A,X(this._incomingPrefix,this._totalIncoming,A,M,N,B,W)}}e.IPCLogger=_}),define(Z[100],ee([0,1,3,36,25]),function(G,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(y){this.port=y,this.onMessage=v.Event.fromDOMEventEmitter(this.port,"message",S=>L.VSBuffer.wrap(S.data)),y.start()}send(y){this.port.postMessage(y.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class O extends R.IPCClient{constructor(y,S){const n=new k(y);super(n,S);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=O}),define(Z[101],ee([0,1,102,3,36,100]),function(G,e,v,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class O extends L.IPCServer{static getOnDidClientConnect(){const y=R.Event.fromNodeEventEmitter(v.ipcRenderer,"vscode:createMessageChannel",(S,n)=>n);return R.Event.map(y,S=>{const{port1:n,port2:m}=new MessageChannel,b={protocol:new k.Protocol(n),onDidClientDisconnect:R.Event.fromDOMEventEmitter(n,"close")};return v.ipcRenderer.postMessage("vscode:createMessageChannelResult",S,[m]),b})}constructor(){super(O.getOnDidClientConnect())}}e.Server=O}),define(Z[103],ee([0,1,11,25]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(D,y){D.proxyAuthorization&&(D.headers=Object.assign(Object.assign({},D.headers||{}),{"Proxy-Authorization":D.proxyAuthorization}));const S=new XMLHttpRequest;return new Promise((n,m)=>{S.open(D.type||"GET",D.url||"",!0,D.user,D.password),k(S,D),S.responseType="arraybuffer",S.onerror=h=>m(new Error(S.statusText&&"XHR failed: "+S.statusText||"XHR failed")),S.onload=h=>{n({res:{statusCode:S.status,headers:O(S)},stream:R.bufferToStream(R.VSBuffer.wrap(new Uint8Array(S.response)))})},S.ontimeout=h=>m(new Error(`XHR timeout: ${D.timeout}ms`)),D.timeout&&(S.timeout=D.timeout),S.send(D.data),y.onCancellationRequested(()=>{S.abort(),m(v.canceled())})})}e.request=L;function k(D,y){if(y.headers){e:for(let S in y.headers){switch(S){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}D.setRequestHeader(S,y.headers[S])}}}function O(D){const y=Object.create(null);for(const S of D.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(S){const n=S.indexOf(":");y[S.substr(0,n).trim().toLowerCase()]=S.substr(n+1).trim()}return y}}),define(Z[70],ee([0,1,2,3,6,16]),function(G,e,v,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var O;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(O=e.StorageHint||(e.StorageHint={}));var D;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(D||(D={}));class y extends v.Disposable{constructor(m,h=Object.create(null)){super();this.database=m,this.options=h,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=D.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(y.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){var h,b;(h=m.changed)===null||h===void 0||h.forEach((f,C)=>this.accept(C,f)),(b=m.deleted)===null||b===void 0||b.forEach(f=>this.accept(f,void 0))}accept(m,h){if(this.state===D.Closed)return;let b=!1;k.isUndefinedOrNull(h)?b=this.cache.delete(m):this.cache.get(m)!==h&&(this.cache.set(m,h),b=!0),b&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===D.None&&(this.state=D.Initialized,this.options.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,h){const b=this.cache.get(m);return k.isUndefinedOrNull(b)?h:b}getBoolean(m,h){const b=this.get(m);return k.isUndefinedOrNull(b)?h:b==="true"}getNumber(m,h){const b=this.get(m);return k.isUndefinedOrNull(b)?h:parseInt(b,10)}async set(m,h){if(this.state===D.Closed)return;if(k.isUndefinedOrNull(h))return this.delete(m);const b=String(h);if(this.cache.get(m)!==b)return this.cache.set(m,b),this.pendingInserts.set(m,b),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}async delete(m){if(!(this.state===D.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=D.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(m){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{var h;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(h=this.whenFlushedCallbacks.pop())===null||h===void 0||h()})}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=y,y.DEFAULT_FLUSH_DELAY=100;class S{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert&&m.insert.forEach((h,b)=>this.items.set(b,h)),m.delete&&m.delete.forEach(h=>this.items.delete(h))}async close(){}}e.InMemoryStorageDatabase=S}),define(Z[104],ee([13,14]),function(G,e){return G.create("vs/base/common/date",e)}),define(Z[55],ee([0,1,104]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,L=R*60,k=L*24,O=k*7,D=k*30,y=k*365;function S(m,h){typeof m!="number"&&(m=m.getTime());const b=Math.round((new Date().getTime()-m)/1e3);if(b<-30)return v.localize(0,null,S(new Date().getTime()+b*1e3,!1));if(b<30)return v.localize(1,null);let f;return b<R?(f=b,h?f===1?v.localize(2,null,f):v.localize(3,null,f):f===1?v.localize(4,null,f):v.localize(5,null,f)):b<L?(f=Math.floor(b/R),h?f===1?v.localize(6,null,f):v.localize(7,null,f):f===1?v.localize(8,null,f):v.localize(9,null,f)):b<k?(f=Math.floor(b/L),h?f===1?v.localize(10,null,f):v.localize(11,null,f):f===1?v.localize(12,null,f):v.localize(13,null,f)):b<O?(f=Math.floor(b/k),h?f===1?v.localize(14,null,f):v.localize(15,null,f):f===1?v.localize(16,null,f):v.localize(17,null,f)):b<D?(f=Math.floor(b/O),h?f===1?v.localize(18,null,f):v.localize(19,null,f):f===1?v.localize(20,null,f):v.localize(21,null,f)):b<y?(f=Math.floor(b/D),h?f===1?v.localize(22,null,f):v.localize(23,null,f):f===1?v.localize(24,null,f):v.localize(25,null,f)):(f=Math.floor(b/y),h?f===1?v.localize(26,null,f):v.localize(27,null,f):f===1?v.localize(28,null,f):v.localize(29,null,f))}e.fromNow=S;function n(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(Z[105],ee([13,14]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(Z[43],ee([0,1,105,16,19]),function(G,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(S,n){return n&&(S.stack||S.stacktrace)?v.localize(0,null,D(S),O(S.stack)||O(S.stacktrace)):D(S)}function O(S){return Array.isArray(S)?S.join(`
`):S}function D(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?v.localize(1,null,S.message):S.message||v.localize(2,null)}function y(S=null,n=!1){if(!S)return v.localize(3,null);if(Array.isArray(S)){const m=L.coalesce(S),h=y(m[0],n);return m.length>1?v.localize(4,null,h,m.length):h}if(R.isString(S))return S;if(S.detail){const m=S.detail;if(m.error)return k(m.error,n);if(m.exception)return k(m.exception,n)}return S.stack?k(S,n):S.message?S.message:v.localize(5,null)}e.toErrorMessage=y}),define(Z[106],ee([13,14]),function(G,e){return G.create("vs/base/node/processes",e)}),define(Z[107],ee([0,1,8,18,42,106,34,16,26,41,7,69,17]),function(G,e,v,R,L,k,O,D,y,S,n,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function b(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function f(c,s){if(n.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};s&&(t.cwd=s);const r=L.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],t);return new Promise(i=>{r.once("error",a=>{i({success:!1,error:a})}),r.once("exit",(a,u)=>{i(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?b(t.status):1})}else if(n.isLinux||n.isMacintosh)try{const t=h.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(r=>{L.execFile(t,[c.pid.toString()],{encoding:"utf8",shell:!0},(i,a,u)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function C(c=O.env){return c.comspec||"cmd.exe"}e.getWindowsShell=C;class P{constructor(s,t,r,i){if(t!==void 0&&r!==void 0&&i!==void 0)this.cmd=s,this.args=t,this.shell=r,this.options=i;else{const a=s;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(O.env).forEach(u=>{a[u]=O.env[u]}),Object.keys(this.options.env).forEach(u=>{a[u]=this.options.env[u]}),this.options.env=a}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const t=s.lastIndexOf(v.sep);return t!==-1&&(s=s.substring(t+1)),P.WellKnowCommands[s]?s:"other"}start(s){return n.isWindows&&(this.options&&this.options.cwd&&S.isUNC(this.options.cwd)||!this.options&&S.isUNC(O.cwd()))?Promise.reject(new Error(k.localize(0,null))):this.useExec().then(t=>{let r,i;const a=new Promise((u,o)=>{r=u,i=o});if(t){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=L.exec(u,this.options,(o,l,p)=>{this.childProcess=null;const w=o;w&&w.killed?i({killed:this.terminateRequested,stdout:l.toString(),stderr:p.toString()}):this.handleExec(r,s,o,l,p)})}else{let u=null;const o=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,r,s,i);const p={terminated:this.terminateRequested};D.isNumber(l)&&(p.cmdCode=l),r(p)};if(this.shell&&n.isWindows){const l=y.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let p=!1,w=!1;const g=[];let U=this.ensureQuotes(this.cmd);g.push(U.value),p=U.quoted,this.args&&this.args.forEach(j=>{U=this.ensureQuotes(j),g.push(U.value),w=w&&U.quoted});const F=["/s","/c"];p?w?F.push('"'+g.join(" ")+'"'):g.length>1?F.push('"'+g[0]+'" '+g.slice(1).join(" ")):F.push('"'+g[0]+'"'):F.push(g.join(" ")),u=L.spawn(C(),F,l)}else this.cmd&&(u=L.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(D.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",l=>{this.childProcess=null,i({terminated:this.terminateRequested,error:l})}),u.pid&&(this.childProcess.on("close",o),this.handleSpawn(u,r,s,i,!0)))}return a})}handleClose(s,t,r,i){}ensureQuotes(s){return P.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,f(s,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!n.isWindows)return s(!1);const t=L.spawn(C(),["/s","/c"]);t.on("error",r=>s(!0)),t.on("exit",r=>s(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class E extends P{constructor(s,t,r,i){super(s,t,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,t,r,i,a){[i,a].forEach((u,o)=>{const l=new m.LineDecoder;l.write(u).forEach(g=>{t({line:g,source:o===0?0:1})});const w=l.end();w&&t({line:w,source:o===0?0:1})}),s({terminated:this.terminateRequested,error:r})}handleSpawn(s,t,r,i,a){const u=new m.LineDecoder,o=new m.LineDecoder;s.stdout.on("data",l=>{u.write(l).forEach(w=>r({line:w,source:0}))}),s.stderr.on("data",l=>{o.write(l).forEach(w=>r({line:w,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=o}handleClose(s,t,r,i){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&r({line:a,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&r({line:u,source:1})}}e.LineProcess=E;function I(c){let s=[],t=!1;const r=function(i){if(t){s.push(i);return}(!c.send(i,u=>{if(u&&console.error(u),t=!1,s.length>0){const o=s.slice(0);s=[],o.forEach(l=>r(l))}})||n.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=I;var d;(function(c){async function s(t,r,i){if(v.isAbsolute(t))return t;if(r===void 0&&(r=O.cwd()),v.dirname(t)!=="."||(i===void 0&&D.isString(O.env.PATH)&&(i=O.env.PATH.split(v.delimiter)),i===void 0||i.length===0))return v.join(r,t);async function u(o){return await R.Promises.exists(o)?!(await R.Promises.stat(o)).isDirectory():!1}for(let o of i){let l;if(v.isAbsolute(o)?l=v.join(o,t):l=v.join(r,o,t),await u(l))return l;let p=l+".com";if(await u(p)||(p=l+".exe",await u(p)))return p}return v.join(r,t)}c.findExecutable=s})(d=e.win32||(e.win32={}))}),define(Z[49],ee([0,1,42,2,6,26,3,107,36,90,29,11,25,7]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends y.ChannelServer{constructor(E){super({send:I=>{try{process.send&&process.send(I.buffer.toString("base64"))}catch(d){}},onMessage:O.Event.fromNodeEventEmitter(process,"message",I=>h.VSBuffer.wrap(Buffer.from(I,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=f;class C{constructor(E,I){this.modulePath=E,this.options=I,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new O.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const d=I&&I.timeout?I.timeout:6e4;this.disposeDelayer=new L.Delayer(d),this.child=null,this._client=null}getChannel(E){const I=this;return{call(d,c,s){return I.requestPromise(E,d,c,s)},listen(d,c){return I.requestEvent(E,d,c)}}}requestPromise(E,I,d,c=n.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(m.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(E),t=L.createCancelablePromise(a=>s.call(I,d,a)),r=c.onCancellationRequested(()=>t.cancel()),i=R.toDisposable(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(E,I,d){if(!this.disposeDelayer)return O.Event.None;this.disposeDelayer.cancel();let c;const s=new O.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(E).listen(I,d)(s.fire,s),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],I=Object.create(null);I.env=Object.assign(Object.assign({},k.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(I.env=Object.assign(Object.assign({},I.env),this.options.env)),this.options&&this.options.freshExecArgv&&(I.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(I.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(I.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),I.execArgv===void 0&&(I.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),b.isMacintosh&&I.env&&delete I.env.DYLD_LIBRARY_PATH,this.child=v.fork(this.modulePath,E,I);const d=new O.Emitter;O.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if(S.isRemoteConsoleLog(u)){S.log(u,`IPC Library: ${this.options.serverName}`);return}d.fire(h.VSBuffer.wrap(Buffer.from(u,"base64")))});const s=this.options.useQueue?D.createQueuedSender(this.child):this.child,t=u=>this.child&&this.child.connected&&s.send(u.buffer.toString("base64")),r=d.event,i={send:t,onMessage:r};this._client=new y.ChannelClient(i);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,o)=>{process.removeListener("exit",a),this.activeRequests.forEach(l=>R.dispose(l)),this.activeRequests.clear(),u!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:o})})}return this._client}getCachedChannel(E){let I=this.channels.get(E);return I||(I=this.client.getChannel(E),this.channels.set(E,I)),I}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=C}),define(Z[108],ee([13,14]),function(G,e){return G.create("vs/base/node/zip",e)}),define(Z[109],ee([13,14]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[110],ee([13,14]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[111],ee([13,14]),function(G,e){return G.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[112],ee([13,14]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[113],ee([13,14]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[114],ee([13,14]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[115],ee([13,14]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[116],ee([13,14]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(Z[117],ee([13,14]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(Z[118],ee([13,14]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(Z[119],ee([13,14]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[120],ee([13,14]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(Z[121],ee([13,14]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[122],ee([13,14]),function(G,e){return G.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Z[123],ee([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[124],ee([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[125],ee([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[126],ee([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[127],ee([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[128],ee([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(Z[129],ee([0,1,8,12,64,55,17,5,34]),function(G,e,v,R,L,k,O,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class S{constructor(f,C,P){this._args=f,this.paths=C,this.productService=P}get appRoot(){return v.dirname(O.FileAccess.asFileUri("",G).fsPath)}get userHome(){return D.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return D.URI.file(v.join(this.userDataPath,"User"))}get tmpDir(){return D.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return R.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return R.joinPath(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=k.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=v.join(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return D.URI.file(v.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return R.joinPath(D.URI.file(v.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return D.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return D.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return R.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return R.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=y.env.VSCODE_PORTABLE;return f?D.URI.file(v.join(f,"argv.json")):R.joinPath(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return R.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return D.URI.file(v.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return v.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?v.resolve(f):v.normalize(v.join(O.FileAccess.asFileUri("",G).fsPath,"..","extensions"))}get extensionsDownloadPath(){const f=this.args["extensions-download-dir"];return f?v.resolve(f):v.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return v.resolve(f);const C=y.env.VSCODE_EXTENSIONS;if(C)return C;const P=y.env.VSCODE_PORTABLE;return P?v.join(P,"extensions"):R.joinPath(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(C=>/^[^:/?#]+?:\/\//.test(C)?D.URI.parse(C):D.URI.file(v.normalize(C)))}get extensionDevelopmentKind(){var f;return(f=this.args.extensionDevelopmentKind)===null||f===void 0?void 0:f.map(C=>C==="ui"||C==="workspace"||C==="web"?C:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?D.URI.parse(f):D.URI.file(v.normalize(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!y.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return R.joinPath(D.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return D.URI.file(v.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([L.memoize],S.prototype,"appRoot",null),de([L.memoize],S.prototype,"userHome",null),de([L.memoize],S.prototype,"userDataPath",null),de([L.memoize],S.prototype,"appSettingsHome",null),de([L.memoize],S.prototype,"tmpDir",null),de([L.memoize],S.prototype,"userRoamingDataHome",null),de([L.memoize],S.prototype,"settingsResource",null),de([L.memoize],S.prototype,"userDataSyncHome",null),de([L.memoize],S.prototype,"userDataSyncLogResource",null),de([L.memoize],S.prototype,"sync",null),de([L.memoize],S.prototype,"machineSettingsResource",null),de([L.memoize],S.prototype,"globalStorageHome",null),de([L.memoize],S.prototype,"workspaceStorageHome",null),de([L.memoize],S.prototype,"keybindingsResource",null),de([L.memoize],S.prototype,"keyboardLayoutResource",null),de([L.memoize],S.prototype,"argvResource",null),de([L.memoize],S.prototype,"snippetsHome",null),de([L.memoize],S.prototype,"isExtensionDevelopment",null),de([L.memoize],S.prototype,"untitledWorkspacesHome",null),de([L.memoize],S.prototype,"installSourcePath",null),de([L.memoize],S.prototype,"builtinExtensionsPath",null),de([L.memoize],S.prototype,"extensionsPath",null),de([L.memoize],S.prototype,"extensionDevelopmentLocationURI",null),de([L.memoize],S.prototype,"extensionDevelopmentKind",null),de([L.memoize],S.prototype,"extensionTestsLocationURI",null),de([L.memoize],S.prototype,"debugExtensionHost",null),de([L.memoize],S.prototype,"serviceMachineIdResource",null),de([L.memoize],S.prototype,"telemetryLogResource",null),de([L.memoize],S.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=S;function n(b,f){return h(b["inspect-extensions"],b["inspect-brk-extensions"],5870,f,b.debugId)}e.parseExtensionHostPort=n;function m(b,f){return h(b["inspect-search"],b["inspect-brk-search"],5876,f)}e.parseSearchPort=m;function h(b,f,C,P,E){const d=Number(f||b)||(P?null:C),c=d?Boolean(!!f):!1;return{port:d,break:c,debugId:E}}}),function(){"use strict";function G(e,v,R,L){function k(D){const y=O(D),S=[y];return e.isAbsolute(y)||S.unshift(L),e.resolve(...S)}function O(D){const y=process.env.VSCODE_PORTABLE;if(y)return e.join(y,"user-data");const S=D["user-data-dir"];if(S)return S;let n=process.env.VSCODE_APPDATA;if(!n)switch(process.platform){case"win32":if(n=process.env.APPDATA,!n){const m=process.env.USERPROFILE;if(typeof m!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");n=e.join(m,"AppData","Roaming")}break;case"darwin":n=e.join(v.homedir(),"Library","Application Support");break;case"linux":n=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(n,R)}return{getUserDataPath:k}}if(typeof define=="function")define(Z[130],ee([0,209,35,17,12,34]),function(e,v,R,L,k,O){const D=k.dirname(L.FileAccess.asFileUri("",e)),y=e.__$__nodeRequire(k.joinPath(D,"package.json").fsPath);return G(v,R,y.name,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),R=require("os");module.exports=G(v,R,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[131],ee([0,1,35,130,129]),function(G,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends L.AbstractNativeEnvironmentService{constructor(D,y){super(D,{homeDir:v.homedir(),tmpDir:v.tmpdir(),userDataDir:R.getUserDataPath(D)},y)}}e.NativeEnvironmentService=k}),define(Z[132],ee([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const R=/^([^@:]+@)?([^:]+):/,L=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,O=/([^@:.]+\.[^@:.]+)(:\d+)?$/,D=/^\s*url\s*=\s*(.+\S)\s*$/mg,y=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function S(P){const E=P.match(O);return E?E[1]:null}function n(P){if(P.indexOf("://")===-1){const E=P.match(R);return E?S(E[2]):null}try{const E=v.URI.parse(P);if(E.authority)return S(E.authority)}catch(E){}return null}function m(P,E){const I=new Set;let d;for(;d=D.exec(P);){const s=n(d[1]);s&&I.add(s)}const c=new Set(E);return Array.from(I).map(s=>c.has(s)?s:s.replace(y,"a"))}e.getDomainsOfRemotes=m;function h(P){const E=P.match(k);return E?E[2]:null}function b(P,E,I){return P&&E?(I&&E.endsWith(".git")&&(E=E.substr(0,E.length-4)),E.indexOf("/")===0?`${P}${E}`:`${P}/${E}`):null}function f(P,E){if(P.indexOf("://")===-1){const I=P.match(L);if(I)return b(I[2],I[3],E)}try{const I=v.URI.parse(P);if(I.authority)return b(h(I.authority),I.path,E)}catch(I){}return null}function C(P,E=!1){const I=[];let d;for(;d=D.exec(P);){const c=f(d[1],E);c&&I.push(c)}return I}e.getRemotes=C}),define(Z[133],ee([0,1,3,5,93,26,2]),function(G,e,v,R,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function D(f,C){return R.URI.revive(C?C.transformIncoming(f):f)}function y(f,C){return C?C.transformOutgoingURI(f):f}function S(f,C){C=C||L.DefaultURITransformer;const P=f.manifest,E=L.transformAndReviveIncomingURIs(Object.assign(Object.assign({},f),{manifest:void 0}),C);return Object.assign(Object.assign({},E),{manifest:P})}function n(f,C){return C?k.cloneAndChange(f,P=>P instanceof R.URI?C.transformOutgoingURI(P):void 0):f}class m{constructor(C,P){this.service=C,this.getUriTransformer=P,this.onInstallExtension=v.Event.buffer(C.onInstallExtension,!0),this.onDidInstallExtension=v.Event.buffer(C.onDidInstallExtension,!0),this.onUninstallExtension=v.Event.buffer(C.onUninstallExtension,!0),this.onDidUninstallExtension=v.Event.buffer(C.onDidUninstallExtension,!0)}listen(C,P){const E=this.getUriTransformer(C);switch(P){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return v.Event.map(this.onDidInstallExtension,I=>Object.assign(Object.assign({},I),{local:I.local?n(I.local,E):I.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(C,P,E){const I=this.getUriTransformer(C);switch(P){case"zip":return this.service.zip(S(E[0],I)).then(d=>y(d,I));case"unzip":return this.service.unzip(D(E[0],I));case"install":return this.service.install(D(E[0],I),E[1]);case"getManifest":return this.service.getManifest(D(E[0],I));case"canInstall":return this.service.canInstall(E[0]);case"installFromGallery":return this.service.installFromGallery(E[0],E[1]);case"uninstall":return this.service.uninstall(S(E[0],I),E[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(S(E[0],I));case"getInstalled":return this.service.getInstalled(E[0]).then(d=>d.map(c=>n(c,I)));case"updateMetadata":return this.service.updateMetadata(S(E[0],I),E[1]).then(d=>n(d,I));case"updateExtensionScope":return this.service.updateExtensionScope(S(E[0],I),E[1]).then(d=>n(d,I));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=m;class h extends O.Disposable{constructor(C){super();this.channel=C,this._onInstallExtension=this._register(new v.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new v.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new v.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new v.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(P=>this._onInstallExtension.fire(P))),this._register(this.channel.listen("onDidInstallExtension")(P=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},P),{local:P.local?S(P.local,null):P.local})))),this._register(this.channel.listen("onUninstallExtension")(P=>this._onUninstallExtension.fire(P))),this._register(this.channel.listen("onDidUninstallExtension")(P=>this._onDidUninstallExtension.fire(P)))}zip(C){return Promise.resolve(this.channel.call("zip",[C]).then(P=>R.URI.revive(P)))}unzip(C){return Promise.resolve(this.channel.call("unzip",[C]))}install(C,P){return Promise.resolve(this.channel.call("install",[C,P])).then(E=>S(E,null))}getManifest(C){return Promise.resolve(this.channel.call("getManifest",[C]))}async canInstall(C){return!0}installFromGallery(C,P){return Promise.resolve(this.channel.call("installFromGallery",[C,P])).then(E=>S(E,null))}uninstall(C,P){return Promise.resolve(this.channel.call("uninstall",[C,P]))}reinstallFromGallery(C){return Promise.resolve(this.channel.call("reinstallFromGallery",[C]))}getInstalled(C=null){return Promise.resolve(this.channel.call("getInstalled",[C])).then(P=>P.map(E=>S(E,null)))}updateMetadata(C,P){return Promise.resolve(this.channel.call("updateMetadata",[C,P])).then(E=>S(E,null))}updateExtensionScope(C,P){return Promise.resolve(this.channel.call("updateExtensionScope",[C,P])).then(E=>S(E,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=h;class b{constructor(C){this.service=C}listen(C,P){throw new Error("Invalid listen")}call(C,P,E){switch(P){case"getConfigBasedTips":return this.service.getConfigBasedTips(R.URI.revive(E[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=b}),define(Z[134],ee([0,1,26]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const R=/^%([\w\d.-]+)%$/i;function L(k,O){const D=y=>{if(typeof y!="string")return;const S=R.exec(y);if(!!S)return O[S[1]]||y};return v.cloneAndChange(k,D)}e.localizeManifest=L}),define(Z[135],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class v{constructor(k){this.channel=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,O,D,y){return this.channel.call("promptImportantExtensionsInstallNotification",[k,O,D,y])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=v;class R{constructor(k){this.service=k}listen(k,O){throw new Error(`Event not found: ${O}`)}call(k,O,D){switch(O){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(D[0],D[1],D[2],D[3])}throw new Error(`Call not found: ${O}`)}}e.ExtensionRecommendationNotificationServiceChannel=R}),define(Z[71],ee([0,1,115]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,L=/^-(\d{4})(\d{2})(\d{2})$/;function k(h){return h=h.trim(),h==="*"||R.test(h)}e.isValidVersionStr=k;function O(h){if(!k(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=h.match(R);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=O;function D(h){if(!h)return null;let b=h.majorBase,f=h.majorMustEqual,C=h.minorBase,P=h.minorMustEqual,E=h.patchBase,I=h.patchMustEqual;h.hasCaret&&(b===0||(P=!1),I=!1);let d=0;if(h.preRelease){const c=L.exec(h.preRelease);if(c){const[,s,t,r]=c;d=Date.UTC(Number(s),Number(t)-1,Number(r))}}return{majorBase:b,majorMustEqual:f,minorBase:C,minorMustEqual:P,patchBase:E,patchMustEqual:I,isMinimum:h.hasGreaterEquals,notBefore:d}}e.normalizeVersion=D;function y(h,b,f){let C;typeof h=="string"?C=D(O(h)):C=h;let P;b instanceof Date?P=b.getTime():typeof b=="string"&&(P=new Date(b).getTime());let E;if(typeof f=="string"?E=D(O(f)):E=f,!C||!E)return!1;let I=C.majorBase,d=C.minorBase,c=C.patchBase,s=E.majorBase,t=E.minorBase,r=E.patchBase,i=E.notBefore,a=E.majorMustEqual,u=E.minorMustEqual,o=E.patchMustEqual;return E.isMinimum?I>s?!0:I<s?!1:d>t?!0:d<t||P&&P<i?!1:c>=r:(I===1&&s===0&&(!a||!u||!o)&&(s=1,t=0,r=0,a=!0,u=!1,o=!1),I<s?!1:I>s?!a:d<t?!1:d>t?!u:c<r?!1:c>r?!o:!(P&&P<i))}e.isValidVersion=y;function S(h,b,f,C){return f.isBuiltin||typeof f.main=="undefined"?!0:m(h,b,f.engines.vscode,C)}e.isValidExtensionVersion=S;function n(h,b,f){return h==="*"||m(b,f,h)}e.isEngineValid=n;function m(h,b,f,C=[]){let P=D(O(f));if(!P)return C.push(v.localize(0,null,f)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return C.push(v.localize(1,null,f)),!1}else if(!P.majorMustEqual)return C.push(v.localize(2,null,f)),!1;return y(h,b,P)?!0:(C.push(v.localize(3,null,h,f)),!1)}}),define(Z[136],ee([0,1,36,49,2,17]),function(G,e,v,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class O extends L.Disposable{constructor(y,S,n,m){super();this.folders=y,this.onDidFilesChange=S,this.onLogMessage=n,this.verboseLogging=m,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const y=this._register(new R.Client(k.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(y.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=O.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService(v.getNextTickChannel(y.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(S=>!this.isDisposed&&this.onDidFilesChange(S))),this._register(this.service.onDidLogMessage(S=>this.onLogMessage(S))),this.setFolders(this.folders)}setVerboseLogging(y){this.verboseLogging=y,!this.isDisposed&&this.service&&this.service.setVerboseLogging(y)}error(y){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${y}`})}setFolders(y){this.folders=y,this.service&&this.service.setRoots(y)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=O,O.MAX_RESTARTS=5}),define(Z[137],ee([0,1,36,49,2,17]),function(G,e,v,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class O extends L.Disposable{constructor(y,S,n,m,h={}){super();this.folders=y,this.onDidFilesChange=S,this.onLogMessage=n,this.verboseLogging=m,this.watcherOptions=h,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const y=this._register(new R.Client(k.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(y.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=O.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService(v.getNextTickChannel(y.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(S=>!this.isDisposed&&this.onDidFilesChange(S))),this._register(this.service.onDidLogMessage(S=>this.onLogMessage(S))),this.service.setRoots(this.folders)}error(y){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${y}`})}setVerboseLogging(y){this.verboseLogging=y,this.service&&this.service.setVerboseLogging(y)}setFolders(y){this.folders=y,this.service&&this.service.setRoots(y)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=O,O.MAX_RESTARTS=5}),define(Z[138],ee([0,1,42,69,68,17]),function(G,e,v,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class O{constructor(y,S,n,m,h){this.watchedFolder=y,this.eventCallback=n,this.logCallback=m,this.verboseLogging=h,this.restartCounter=0,Array.isArray(S)?this.ignored=S.map(b=>L.parse(b)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${y}`),this.startWatcher()}startWatcher(){const y=[this.watchedFolder];this.verboseLogging&&y.push("-verbose"),this.handle=v.spawn(k.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",G).fsPath,y);const S=new R.LineDecoder;this.handle.stdout.on("data",n=>{const m=[];S.write(n).forEach(h=>{const b=h.split("|");if(b.length===2){const f=Number(b[0]),C=b[1];if(f>=0&&f<3){if(this.ignored&&this.ignored.some(P=>P(C))){this.verboseLogging&&this.log(C);return}m.push({type:O.changeTypeMap[f],path:C})}else this.log(b[1])}}),m.length>0&&this.eventCallback(m)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,m)=>this.onExit(n,m))}onError(y){this.error("process error: "+y.toString())}onExit(y,S){this.handle&&(this.error(`terminated unexpectedly (code: ${y}, signal: ${S})`),this.restartCounter<=O.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(y){this.logCallback({type:"error",message:`[File Watcher (C#)] ${y}`})}log(y){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${y}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=O,O.MAX_RESTARTS=5,O.changeTypeMap=[0,1,2]}),define(Z[139],ee([0,1,138,8,20]),function(G,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k{constructor(D,y,S,n){this.onDidFilesChange=y,this.onLogMessage=S,this.verboseLogging=n,this.service=void 0,this.folder=D[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(R.posix.sep)&&(this.folder.path=L.rtrim(this.folder.path,R.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new v.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,D=>this.onFileEvents(D),D=>this.onLogMessage(D),this.verboseLogging)}setVerboseLogging(D){this.verboseLogging=D,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(D){this.isDisposed||D.length>0&&this.onDidFilesChange(D)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=k}),define(Z[50],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(k,O=[],D=!1){this.ctor=k,this.staticArguments=O,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=v;const R=(L,...k)=>new v(L,k);e.createSyncDescriptor=R}),define(Z[140],ee([0,1,50]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function L(O,D,y){D instanceof v.SyncDescriptor||(D=new v.SyncDescriptor(D,[],y)),R.push([O,D])}e.registerSingleton=L;function k(){return R}e.getSingletonServiceDescriptors=k}),define(Z[141],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=v;class R{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let O of this._nodes.values())O.outgoing.size===0&&k.push(O);return k}insertEdge(k,O){const D=this.lookupOrInsertNode(k),y=this.lookupOrInsertNode(O);D.outgoing.set(this._hashFn(O),y),y.incoming.set(this._hashFn(k),D)}removeNode(k){const O=this._hashFn(k);this._nodes.delete(O);for(let D of this._nodes.values())D.outgoing.delete(O),D.incoming.delete(O)}lookupOrInsertNode(k){const O=this._hashFn(k);let D=this._nodes.get(O);return D||(D=new v(k),this._nodes.set(O,D)),D}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[O,D]of this._nodes)k.push(`${O}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,O]of this._nodes){const D=new Set([k]),y=this._findCycle(O,D);if(y)return y}}_findCycle(k,O){for(let[D,y]of k.outgoing){if(O.has(D))return[...O,D].join(" -> ");O.add(D);const S=this._findCycle(y,O);if(S)return S;O.delete(D)}}}e.Graph=R}),define(Z[4],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function y(S){return S[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=y})(v=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function R(D,y,S,n){y[v.DI_TARGET]===y?y[v.DI_DEPENDENCIES].push({id:D,index:S,optional:n}):(y[v.DI_DEPENDENCIES]=[{id:D,index:S,optional:n}],y[v.DI_TARGET]=y)}function L(D){if(v.serviceIds.has(D))return v.serviceIds.get(D);const y=function(S,n,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(y,S,m,!1)};return y.toString=()=>D,v.serviceIds.set(D,y),y}e.createDecorator=L;function k(D){return D}e.refineServiceDecorator=k;function O(D){return function(y,S,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(D,y,n,!0)}}e.optional=O}),define(Z[142],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=v.createDecorator("checksumService")}),define(Z[143],ee([0,1,20,4,7]),function(G,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let k=L.userAgent||"";const O=new Map;O.set("false",!1),O.set("true",!0),O.set("isMac",L.isMacintosh),O.set("isLinux",L.isLinux),O.set("isWindows",L.isWindows),O.set("isWeb",L.isWeb),O.set("isMacNative",L.isMacintosh&&!L.isWeb),O.set("isEdge",k.indexOf("Edg/")>=0),O.set("isFirefox",k.indexOf("Firefox")>=0),O.set("isChrome",k.indexOf("Chrome")>=0),O.set("isSafari",k.indexOf("Safari")>=0);const D=Object.prototype.hasOwnProperty;var y;(function(w){w[w.False=0]="False",w[w.True=1]="True",w[w.Defined=2]="Defined",w[w.Not=3]="Not",w[w.Equals=4]="Equals",w[w.NotEquals=5]="NotEquals",w[w.And=6]="And",w[w.Regex=7]="Regex",w[w.NotRegex=8]="NotRegex",w[w.Or=9]="Or",w[w.In=10]="In",w[w.NotIn=11]="NotIn",w[w.Greater=12]="Greater",w[w.GreaterEquals=13]="GreaterEquals",w[w.Smaller=14]="Smaller",w[w.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return m.INSTANCE}static true(){return h.INSTANCE}static has(g){return b.create(g)}static equals(g,U){return f.create(g,U)}static notEquals(g,U){return E.create(g,U)}static regex(g,U){return r.create(g,U)}static in(g,U){return C.create(g,U)}static not(g){return I.create(g)}static and(...g){return a.create(g)}static or(...g){return u.create(g)}static greater(g,U){return d.create(g,U)}static less(g,U){return s.create(g,U)}static deserialize(g,U=!1){if(!!g)return this._deserializeOrExpression(g,U)}static _deserializeOrExpression(g,U){let F=g.split("||");return u.create(F.map(j=>this._deserializeAndExpression(j,U)))}static _deserializeAndExpression(g,U){let F=g.split("&&");return a.create(F.map(j=>this._deserializeOne(j,U)))}static _deserializeOne(g,U){if(g=g.trim(),g.indexOf("!=")>=0){let F=g.split("!=");return E.create(F[0].trim(),this._deserializeValue(F[1],U))}if(g.indexOf("==")>=0){let F=g.split("==");return f.create(F[0].trim(),this._deserializeValue(F[1],U))}if(g.indexOf("=~")>=0){let F=g.split("=~");return r.create(F[0].trim(),this._deserializeRegexValue(F[1],U))}if(g.indexOf(" in ")>=0){let F=g.split(" in ");return C.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(g)){const F=g.split(">=");return c.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(g)){const F=g.split(">");return d.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(g)){const F=g.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(g)){const F=g.split("<");return s.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(g)?I.create(g.substr(1).trim()):b.create(g)}static _deserializeValue(g,U){if(g=g.trim(),g==="true")return!0;if(g==="false")return!1;let F=/^'([^']*)'$/.exec(g);return F?F[1].trim():g}static _deserializeRegexValue(g,U){if(v.isFalsyOrWhitespace(g)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=g.indexOf("/"),j=g.lastIndexOf("/");if(F===j||F<0){if(U)throw new Error(`bad regexp-value '${g}', missing /-enclosure`);return console.warn(`bad regexp-value '${g}', missing /-enclosure`),null}let z=g.slice(F+1,j),V=g[j+1]==="i"?"i":"";try{return new RegExp(z,V)}catch(q){if(U)throw new Error(`bad regexp-value '${g}', parse error: ${q}`);return console.warn(`bad regexp-value '${g}', parse error: ${q}`),null}}}e.ContextKeyExpr=S;function n(w,g){return w.cmp(g)}class m{constructor(){this.type=0}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}evaluate(g){return!1}serialize(){return"false"}keys(){return[]}map(g){return this}negate(){return h.INSTANCE}}e.ContextKeyFalseExpr=m,m.INSTANCE=new m;class h{constructor(){this.type=1}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}evaluate(g){return!0}serialize(){return"true"}keys(){return[]}map(g){return this}negate(){return m.INSTANCE}}e.ContextKeyTrueExpr=h,h.INSTANCE=new h;class b{constructor(g){this.key=g,this.type=2}static create(g){const U=O.get(g);return typeof U=="boolean"?U?h.INSTANCE:m.INSTANCE:new b(g)}cmp(g){return g.type!==this.type?this.type-g.type:l(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}evaluate(g){return!!g.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(g){return g.mapDefined(this.key)}negate(){return I.create(this.key)}}e.ContextKeyDefinedExpr=b;class f{constructor(g,U){this.key=g,this.value=U,this.type=4}static create(g,U){if(typeof U=="boolean")return U?b.create(g):I.create(g);const F=O.get(g);return typeof F=="boolean"?U===(F?"true":"false")?h.INSTANCE:m.INSTANCE:new f(g,U)}cmp(g){return g.type!==this.type?this.type-g.type:p(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return g.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(g){return g.mapEquals(this.key,this.value)}negate(){return E.create(this.key,this.value)}}e.ContextKeyEqualsExpr=f;class C{constructor(g,U){this.key=g,this.valueKey=U,this.type=10}static create(g,U){return new C(g,U)}cmp(g){return g.type!==this.type?this.type-g.type:p(this.key,this.valueKey,g.key,g.valueKey)}equals(g){return g.type===this.type?this.key===g.key&&this.valueKey===g.valueKey:!1}evaluate(g){const U=g.getValue(this.valueKey),F=g.getValue(this.key);return Array.isArray(U)?U.indexOf(F)>=0:typeof F=="string"&&typeof U=="object"&&U!==null?D.call(U,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(g){return g.mapIn(this.key,this.valueKey)}negate(){return P.create(this)}}e.ContextKeyInExpr=C;class P{constructor(g){this._actual=g,this.type=11}static create(g){return new P(g)}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}evaluate(g){return!this._actual.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(g){return new P(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotInExpr=P;class E{constructor(g,U){this.key=g,this.value=U,this.type=5}static create(g,U){if(typeof U=="boolean")return U?I.create(g):b.create(g);const F=O.get(g);return typeof F=="boolean"?U===(F?"true":"false")?m.INSTANCE:h.INSTANCE:new E(g,U)}cmp(g){return g.type!==this.type?this.type-g.type:p(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return g.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(g){return g.mapNotEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=E;class I{constructor(g){this.key=g,this.type=3}static create(g){const U=O.get(g);return typeof U=="boolean"?U?m.INSTANCE:h.INSTANCE:new I(g)}cmp(g){return g.type!==this.type?this.type-g.type:l(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}evaluate(g){return!g.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(g){return g.mapNot(this.key)}negate(){return b.create(this.key)}}e.ContextKeyNotExpr=I;class d{constructor(g,U){this.key=g,this.value=U,this.type=12}static create(g,U){return new d(g,U)}cmp(g){return g.type!==this.type?this.type-g.type:p(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=d;class c{constructor(g,U){this.key=g,this.value=U,this.type=13}static create(g,U){return new c(g,U)}cmp(g){return g.type!==this.type?this.type-g.type:p(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreaterEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=c;class s{constructor(g,U){this.key=g,this.value=U,this.type=14}static create(g,U){return new s(g,U)}cmp(g){return g.type!==this.type?this.type-g.type:p(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmaller(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerExpr=s;class t{constructor(g,U){this.key=g,this.value=U,this.type=15}static create(g,U){return new t(g,U)}cmp(g){return g.type!==this.type?this.type-g.type:p(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmallerEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(g,U){this.key=g,this.regexp=U,this.type=7}static create(g,U){return new r(g,U)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.key<g.key)return-1;if(this.key>g.key)return 1;const U=this.regexp?this.regexp.source:"",F=g.regexp?g.regexp.source:"";return U<F?-1:U>F?1:0}equals(g){if(g.type===this.type){const U=this.regexp?this.regexp.source:"",F=g.regexp?g.regexp.source:"";return this.key===g.key&&U===F}return!1}evaluate(g){let U=g.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const g=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${g}`}keys(){return[this.key]}map(g){return g.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(g){this._actual=g,this.type=8}static create(g){return new i(g)}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}evaluate(g){return!this._actual.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(g){return new i(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class a{constructor(g){this.expr=g,this.type=6}static create(g){return a._normalizeArr(g)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const j=n(this.expr[U],g.expr[U]);if(j!==0)return j}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(g.expr[U]))return!1;return!0}return!1}evaluate(g){for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].evaluate(g))return!1;return!0}static _normalizeArr(g){const U=[];let F=!1;for(const j of g)if(!!j){if(j.type===1){F=!0;continue}if(j.type===0)return m.INSTANCE;if(j.type===6){U.push(...j.expr);continue}U.push(j)}if(U.length===0&&F)return h.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];for(U.sort(n);U.length>1;){const j=U[U.length-1];if(j.type!==9)break;U.pop();const z=U.pop(),V=u.create(j.expr.map(q=>a.create([q,z])));V&&(U.push(V),U.sort(n))}return U.length===1?U[0]:new a(U)}}serialize(){return this.expr.map(g=>g.serialize()).join(" && ")}keys(){const g=[];for(let U of this.expr)g.push(...U.keys());return g}map(g){return new a(this.expr.map(U=>U.map(g)))}negate(){let g=[];for(let U of this.expr)g.push(U.negate());return u.create(g)}}e.ContextKeyAndExpr=a;class u{constructor(g){this.expr=g,this.type=9}static create(g){const U=u._normalizeArr(g);if(U.length!==0)return U.length===1?U[0]:new u(U)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const j=n(this.expr[U],g.expr[U]);if(j!==0)return j}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(g.expr[U]))return!1;return!0}return!1}evaluate(g){for(let U=0,F=this.expr.length;U<F;U++)if(this.expr[U].evaluate(g))return!0;return!1}static _normalizeArr(g){let U=[],F=!1;if(g){for(let j=0,z=g.length;j<z;j++){const V=g[j];if(!!V){if(V.type===0){F=!0;continue}if(V.type===1)return[h.INSTANCE];if(V.type===9){U=U.concat(V.expr);continue}U.push(V)}}if(U.length===0&&F)return[m.INSTANCE];U.sort(n)}return U}serialize(){return this.expr.map(g=>g.serialize()).join(" || ")}keys(){const g=[];for(let U of this.expr)g.push(...U.keys());return g}map(g){return new u(this.expr.map(U=>U.map(g)))}negate(){let g=[];for(let F of this.expr)g.push(F.negate());const U=F=>F.type===9?F.expr:[F];for(;g.length>1;){const F=g.shift(),j=g.shift(),z=[];for(const V of U(F))for(const q of U(j))z.push(S.and(V,q));g.unshift(S.or(...z))}return g[0]}}e.ContextKeyOrExpr=u;class o extends b{constructor(g,U,F){super(g);this._defaultValue=U,typeof F=="object"?o._info.push(Object.assign(Object.assign({},F),{key:g})):F!==!0&&o._info.push({key:g,description:F,type:U!=null?typeof U:void 0})}static all(){return o._info.values()}bindTo(g){return g.createKey(this.key,this._defaultValue)}getValue(g){return g.getContextKeyValue(this.key)}toNegated(){return S.not(this.key)}isEqualTo(g){return S.equals(this.key,g)}notEqualsTo(g){return S.notEquals(this.key,g)}}e.RawContextKey=o,o._info=[],e.IContextKeyService=R.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function l(w,g){return w<g?-1:w>g?1:0}function p(w,g,U,F){return w<U?-1:w>U?1:g<F?-1:g>F?1:0}}),define(Z[72],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=v.createDecorator(e.ID);function R(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=R}),define(Z[73],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=v.createDecorator("downloadService")}),define(Z[9],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=v.createDecorator("environmentService"),e.INativeEnvironmentService=v.refineServiceDecorator(e.IEnvironmentService)}),define(Z[28],ee([0,1,110,4,17]),function(G,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function k(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=k;var O;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=5]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(O=e.SortBy||(e.SortBy={}));var D;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(D=e.SortOrder||(e.SortOrder={}));var y;(function(m){m.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var S;(function(m){m[m.None=0]="None",m[m.Install=1]="Install",m[m.Update=2]="Update"})(S=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=R.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(h,b){super(h);this.code=b}}e.ExtensionManagementError=n,e.IExtensionManagementService=R.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=R.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=R.createDecorator("IExtensionTipsService"),e.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=v.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=v.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=R.createDecorator("IExtensionManagementCLIService")});var K=this&&this.__param||function(G,e){return function(v,R){e(v,R,G)}};define(Z[144],ee([0,1,2,28]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let L=class extends v.Disposable{constructor(O){super();this.extensionManagementService=O,this._register(O),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};L=de([K(0,R.IExtensionManagementService)],L),e.DeprecatedExtensionsCleaner=L}),define(Z[74],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var R;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(R=e.RecommendationSource||(e.RecommendationSource={}));function L(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=L;var k;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=v.createDecorator("IExtensionRecommendationNotificationService")}),define(Z[75],ee([0,1,20,4]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function L(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkpaceSupportTypeMessage=L;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(O=e.ExtensionType||(e.ExtensionType={}));class D{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,h){if(typeof m=="undefined"||m===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof m=="string"||typeof h=="string"){let b=typeof m=="string"?m:m.value,f=typeof h=="string"?h:h.value;return v.equalsIgnoreCase(b,f)}return m._lower===h._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=D;function y(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function S(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=S,e.IBuiltinExtensionsScannerService=R.createDecorator("IBuiltinExtensionsScannerService")}),define(Z[33],ee([0,1,20,75]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(b,f){return b.uuid&&f.uuid?b.uuid===f.uuid:b.id===f.id?!0:v.compareIgnoreCase(b.id,f.id)===0}e.areSameExtensions=L;class k{constructor(f,C){this.version=C,this.id=f.id,this.uuid=f.uuid}key(){return`${this.id}-${this.version}`}equals(f){return f instanceof k?L(this,f)&&this.version===f.version:!1}}e.ExtensionIdentifierWithVersion=k;function O(b,f){return`${b}.${f}`}e.getExtensionId=O;function D(b){return b.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function y(b,f){return D(O(b,f))}e.getGalleryExtensionId=y;function S(b,f){const C=[],P=E=>{for(const I of C)if(I.some(d=>L(f(d),f(E))))return I;return null};for(const E of b){const I=P(E);I?I.push(E):C.push([E])}return C}e.groupByExtension=S;function n(b){return{id:b.identifier.id,name:b.manifest.name,galleryId:null,publisherId:b.publisherId,publisherName:b.manifest.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:b.manifest.extensionDependencies&&b.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function m(b){return Object.assign({id:b.identifier.id,name:b.name,galleryId:b.identifier.uuid,publisherId:b.publisherId,publisherName:b.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:!!(b.properties.dependencies&&b.properties.dependencies.length>0)},b.telemetryData)}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function h(b){const f=new Set;for(const C of b)C.malicious&&f.add(C.id.id);return f}e.getMaliciousExtensionsSet=h}),define(Z[145],ee([0,1,2,8,75,18]),function(G,e,v,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class O extends v.Disposable{constructor(y,S){super();this.environmentService=y,this.extensionsManifestCache=R.join(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(S.onDidInstallExtension(n=>this.onDidInstallExtension(n))),this._register(S.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtension(y){y.error||this.invalidate()}onDidUnInstallExtension(y){y.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=O}),define(Z[10],ee([0,1,117,8,5,4,20,16,38]),function(G,e,v,R,L,k,O,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=k.createDecorator("fileService");function S($){return $.create===!0}e.isFileOpenForWriteOptions=S;var n;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var m;(function($){$[$.Readonly=1]="Readonly"})(m=e.FilePermission||(e.FilePermission={}));var h;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock"})(h=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b($){return!!($.capabilities&2)}e.hasReadWriteCapability=b;function f($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=f;function C($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=C;function P($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=P;var E;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class I extends Error{constructor(H,X){super(H);this.code=X}}e.FileSystemProviderError=I;function d($,H){const X=new I($.toString(),H);return s(X,H),X}e.createFileSystemProviderError=d;function c($){return $||d(v.localize(0,null),E.Unknown)}e.ensureFileSystemProviderError=c;function s($,H){return $.name=H?`${H} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=s;function t($){if(!$)return E.Unknown;if($ instanceof I)return $.code;const H=/^(.+) \(FileSystemError\)$/.exec($.name);if(!H)return E.Unknown;switch(H[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=t;function r($){if($ instanceof p)return $.fileOperationResult;switch(t($)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class a{constructor(H,X,_){this.resource=H,this.operation=X,this.target=_}isOperation(H){return this.operation===H}}e.FileOperationEvent=a;var u;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class o{constructor(H,X){this.changes=H,this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const _ of H)switch(_.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>X)),this.added.set(_.resource,_);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>X)),this.updated.set(_.resource,_);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>X)),this.deleted.set(_.resource,_);break}}contains(H,...X){return this.doContains(H,{includeChildren:!1},...X)}affects(H,...X){return this.doContains(H,{includeChildren:!0},...X)}doContains(H,X,..._){var T,A,M,N,B,W;if(!H)return!1;const Q=_.length>0;return!!((!Q||_.includes(1))&&(((T=this.added)===null||T===void 0?void 0:T.get(H))||X.includeChildren&&((A=this.added)===null||A===void 0?void 0:A.findSuperstr(H)))||(!Q||_.includes(0))&&(((M=this.updated)===null||M===void 0?void 0:M.get(H))||X.includeChildren&&((N=this.updated)===null||N===void 0?void 0:N.findSuperstr(H)))||(!Q||_.includes(2))&&(((B=this.deleted)===null||B===void 0?void 0:B.findSubstr(H))||X.includeChildren&&((W=this.deleted)===null||W===void 0?void 0:W.findSuperstr(H))))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get raw(){return this.changes}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=o;function l($,H,X){return!$||!H||$===H||H.length>$.length?!1:(H.charAt(H.length-1)!==R.sep&&(H+=R.sep),X?O.startsWithIgnoreCase($,H):$.indexOf(H)===0)}e.isParent=l;class p extends Error{constructor(H,X,_){super(H);this.fileOperationResult=X,this.options=_}}e.FileOperationError=p;class w extends p{constructor(H,X,_){super(H,2,_);this.stat=X}}e.NotModifiedSinceFileOperationError=w;var g;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(g=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=F;async function j($,H){if(!H.canHandleResource(L.URI.from({scheme:$.scheme})))return new Promise(X=>{const _=H.onDidChangeFileSystemProviderRegistrations(T=>{T.scheme===$.scheme&&T.added&&(_.dispose(),X())})})}e.whenProviderRegistered=j,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(H){return D.isNumber(H)||(H=0),H<z.KB?v.localize(1,null,H.toFixed(0)):H<z.MB?v.localize(2,null,(H/z.KB).toFixed(2)):H<z.GB?v.localize(3,null,(H/z.MB).toFixed(2)):H<z.TB?v.localize(4,null,(H/z.GB).toFixed(2)):v.localize(5,null,(H/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var V;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function q($){return{maxFileSize:$===0?300*z.MB:16*z.GB,maxHeapSize:$===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=q}),define(Z[146],ee([0,1,147,47,10]),function(G,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(D){this.fileService=D}checksum(D){return new Promise(async(y,S)=>{const n=v.createHash("md5"),m=(await this.fileService.readFileStream(D)).value;R.listenStream(m,{onData:h=>n.update(h.buffer),onError:h=>S(h),onEnd:()=>y(n.digest("base64").replace(/=+$/,""))})})}};k=de([K(0,L.IFileService)],k),e.ChecksumService=k}),define(Z[76],ee([0,1,5,10,7]),function(G,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function k(y){return y.map(S=>({type:S.type,resource:v.URI.file(S.path)}))}e.toFileChanges=k;function O(y){const S=new D;for(const n of y)S.processEvent(n);return S.normalize()}e.normalizeFileChanges=O;class D{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(S){const n=this.mapPathToChange.get(S.path);if(n){const m=n.type,h=S.type;m===1&&h===2?(this.mapPathToChange.delete(S.path),this.normalized.splice(this.normalized.indexOf(n),1)):m===2&&h===1?n.type=0:m===1&&h===0||(n.type=h)}else this.normalized.push(S),this.mapPathToChange.set(S.path,S)}normalize(){const S=[],n=[];return this.normalized.filter(m=>m.type!==2?(S.push(m),!1):!0).sort((m,h)=>m.path.length-h.path.length).filter(m=>n.some(h=>R.isParent(m.path,h,!L.isLinux))?!1:(n.push(m.path),!0)).concat(S)}}}),define(Z[148],ee([0,1,76,2,18,96,99,6,8]),function(G,e,v,R,L,k,O,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class S extends R.Disposable{constructor(m,h,b,f){super();this.path=m,this.onDidFilesChange=h,this.onLogMessage=b,this.verboseLogging=f,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(O.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(m){this.verboseLogging=m}async startWatching(){try{const{stat:m,symbolicLink:h}=await L.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let b=this.path;if(h)try{b=await k.realpath(b)}catch(f){if(this.onError(f),h.dangling)return}m.isDirectory()?this._register(O.watchFolder(b,(f,C)=>{this.onFileChange({type:f==="changed"?0:f==="added"?1:2,path:y.join(this.path,y.basename(C))})},f=>this.onError(f))):this._register(O.watchFile(b,f=>{this.onFileChange({type:f==="changed"?0:2,path:this.path})},f=>this.onError(f)))}catch(m){m.code!=="ENOENT"&&this.onError(m)}}onFileChange(m){this.fileChangesBuffer.push(m),this.verboseLogging&&this.onVerbose(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`),this.fileChangesDelayer.trigger(async()=>{const h=this.fileChangesBuffer;this.fileChangesBuffer=[];const b=v.normalizeFileChanges(h);this.verboseLogging&&b.forEach(f=>{this.onVerbose(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`)}),b.length>0&&this.onDidFilesChange(b)})}onError(m){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${m}`})}onVerbose(m){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=S}),define(Z[77],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...L){this._entries=new Map;for(let[k,O]of L)this.set(k,O)}set(L,k){const O=this._entries.get(L);return this._entries.set(L,k),O}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=v}),define(Z[149],ee([0,1,11,141,50,4,77,6]),function(G,e,v,R,L,k,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class S extends Error{constructor(f){var C;super("cyclic dependency between services");this.message=(C=f.findCycleSlow())!==null&&C!==void 0?C:`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class n{constructor(f=new O.ServiceCollection,C=!1,P){this._activeInstantiations=new Set,this._services=f,this._strict=C,this._parent=P,this._services.set(k.IInstantiationService,this)}createChild(f){return new n(f,this._strict,this)}invokeFunction(f,...C){let P=h.traceInvocation(f),E=!1;try{return f({get:(d,c)=>{if(E)throw v.illegalState("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(d,P);if(!s&&c!==k.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return s}},...C)}finally{E=!0,P.stop()}}createInstance(f,...C){let P,E;return f instanceof L.SyncDescriptor?(P=h.traceCreation(f.ctor),E=this._createInstance(f.ctor,f.staticArguments.concat(C),P)):(P=h.traceCreation(f),E=this._createInstance(f,C,P)),P.stop(),E}_createInstance(f,C=[],P){let E=k._util.getServiceDependencies(f).sort((c,s)=>c.index-s.index),I=[];for(const c of E){let s=this._getOrCreateServiceInstance(c.id,P);if(!s&&this._strict&&!c.optional)throw new Error(`[createInstance] ${f.name} depends on UNKNOWN service ${c.id}.`);I.push(s)}let d=E.length>0?E[0].index:C.length;if(C.length!==d){console.warn(`[createInstance] First service dependency of ${f.name} at position ${d+1} conflicts with ${C.length} static arguments`);let c=d-C.length;c>0?C=C.concat(new Array(c)):C=C.slice(0,d)}return new f(...[...C,...I])}_setServiceInstance(f,C){if(this._services.get(f)instanceof L.SyncDescriptor)this._services.set(f,C);else if(this._parent)this._parent._setServiceInstance(f,C);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let C=this._services.get(f);return!C&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):C}_getOrCreateServiceInstance(f,C){let P=this._getServiceInstanceOrDescriptor(f);return P instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,P,C.branch(f,!0)):(C.branch(f,!1),P)}_safeCreateAndCacheServiceInstance(f,C,P){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,C,P)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,C,P){const E=new R.Graph(c=>c.id.toString());let I=0;const d=[{id:f,desc:C,_trace:P}];for(;d.length;){const c=d.pop();if(E.lookupOrInsertNode(c),I++>1e3)throw new S(E);for(let s of k._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(s.id);if(!t&&!s.optional&&console.warn(`[createInstance] ${f} depends on ${s.id} which is NOT registered.`),t instanceof L.SyncDescriptor){const r={id:s.id,desc:t,_trace:c._trace.branch(s.id,!0)};E.insertEdge(c,r),d.push(r)}}}for(;;){const c=E.roots();if(c.length===0){if(!E.isEmpty())throw new S(E);break}for(const{data:s}of c){if(this._getServiceInstanceOrDescriptor(s.id)instanceof L.SyncDescriptor){const r=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,r)}E.removeNode(s)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,C,P=[],E,I){if(this._services.get(f)instanceof L.SyncDescriptor)return this._createServiceInstance(C,P,E,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,C,P,E,I);throw new Error(`illegalState - creating UNKNOWN service instance ${C.name}`)}_createServiceInstance(f,C=[],P,E){if(P){const I=new D.IdleValue(()=>this._createInstance(f,C,E));return new Proxy(Object.create(null),{get(d,c){if(c in d)return d[c];let s=I.value,t=s[c];return typeof t!="function"||(t=t.bind(s),d[c]=t),t},set(d,c,s){return I.value[c]=s,!0}})}else return this._createInstance(f,C,E)}}e.InstantiationService=n;var m;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(m||(m={}));class h{constructor(f,C){this.type=f,this.name=C,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return y?new h(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(f){return y?new h(0,f.name):h._None}branch(f,C){let P=new h(2,f.toString());return this._dep.push([f,C,P]),P}stop(){let f=Date.now()-this._start;h._totals+=f;let C=!1;function P(I,d){let c=[],s=new Array(I+1).join("	");for(const[t,r,i]of d._dep)if(r&&i){C=!0,c.push(`${s}CREATES -> ${t}`);let a=P(I+1,i);a&&c.push(a)}else c.push(`${s}uses -> ${t}`);return c.join(`
`)}let E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${P(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(f>2||C)&&console.log(E.join(`
`))}}h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(Z[150],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class v{constructor(L,k){this.server=L,this.router=k}getChannel(L){return this.server.getChannel(L,this.router)}registerChannel(L,k){this.server.registerChannel(L,k)}}e.MessagePortMainProcessService=v}),define(Z[151],ee([0,1,36,50,140,4]),function(G,e,v,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class O{constructor(b,f,C){const P=C.getChannel(b);return D(f)?new f.channelClientCtor(P):v.ProxyChannel.toService(P,f==null?void 0:f.proxyOptions)}}function D(h){const b=h;return!!(b==null?void 0:b.channelClientCtor)}e.IMainProcessService=k.createDecorator("mainProcessService");let y=class extends O{constructor(b,f,C){super(b,f,C)}};y=de([K(2,e.IMainProcessService)],y);function S(h,b,f){L.registerSingleton(h,new R.SyncDescriptor(y,[b,f],f==null?void 0:f.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=S,e.ISharedProcessService=k.createDecorator("sharedProcessService");let n=class extends O{constructor(b,f,C){super(b,f,C)}};n=de([K(2,e.ISharedProcessService)],n);function m(h,b,f){L.registerSingleton(h,new R.SyncDescriptor(n,[b,f],f==null?void 0:f.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=m}),define(Z[56],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=v.createDecorator("localizationsService");function R(L){if(typeof L.languageId!="string"||!Array.isArray(L.translations)||L.translations.length===0)return!1;for(const k of L.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(L.languageName&&typeof L.languageName!="string"||L.localizedLanguageName&&typeof L.localizedLanguageName!="string")}e.isValidLocalization=R}),define(Z[152],ee([0,1,2,56]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let L=class extends v.Disposable{constructor(O){super();this.localizationsService=O,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};L=de([K(0,R.ILocalizationsService)],L),e.LocalizationsUpdater=L}),define(Z[15],ee([0,1,4,2,7,3,43]),function(G,e,v,R,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=v.createDecorator("logService"),e.ILoggerService=v.createDecorator("loggerService");function D(){return new Date().toISOString()}var y;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class S extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new k.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=S;class n extends S{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(y.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(y.Error,this.format(i))}else this.log(y.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let i=0;i<t.length;i++){let a=t[i];if(typeof a=="object")try{a=JSON.stringify(a)}catch(u){}r+=(i>0?" ":"")+a}return r}}e.AbstractMessageLogger=n;class m extends S{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!L.isWindows}trace(t,...r){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...r):console.log(`[main ${D()}]`,t,...r))}debug(t,...r){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...r):console.log(`[main ${D()}]`,t,...r))}info(t,...r){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...r):console.log(`[main ${D()}]`,t,...r))}warn(t,...r){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...r):console.warn(`[main ${D()}]`,t,...r))}error(t,...r){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...r):console.error(`[main ${D()}]`,t,...r))}critical(t,...r){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...r):console.error(`[main ${D()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class h extends S{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=h;class b extends S{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:O.toErrorMessage(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class f extends S{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const i of this.logServices)i.trace(t,...r)}debug(t,...r){for(const i of this.logServices)i.debug(t,...r)}info(t,...r){for(const i of this.logServices)i.info(t,...r)}warn(t,...r){for(const i of this.logServices)i.warn(t,...r)}error(t,...r){for(const i of this.logServices)i.error(t,...r)}critical(t,...r){for(const i of this.logServices)i.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=f;class C extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=C;class P extends R.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(i))}))}createLogger(t,r){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,(r==null?void 0:r.always)?y.Trace:this.logLevel,r),this.loggers.set(t.toString(),i),(r==null?void 0:r.always)||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class E{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=E;function I(s){if(s.verbose)return y.Trace;if(typeof s.logLevel=="string"){const t=d(s.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=I;function d(s){switch(s){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=d;function c(s){switch(s){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=c}),define(Z[153],ee([0,1,9,8,18,11,2,6,15]),function(G,e,v,R,L,k,O,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let S=class extends O.Disposable{constructor(m,h){super();this.environmentService=m,this.logService=h,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const m=R.basename(this.environmentService.logsPath),h=R.dirname(this.environmentService.logsPath),C=(await L.Promises.readdir(h)).filter(E=>/^\d{8}T\d{6}$/.test(E)).sort().filter(E=>E!==m),P=C.slice(0,Math.max(0,C.length-9));P.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${P.join(", ")}'`),await Promise.all(P.map(E=>L.Promises.rm(R.join(h,E)))))}catch(m){k.onUnexpectedError(m)}}};S=de([K(0,v.IEnvironmentService),K(1,y.ILogService)],S),e.LogsDataCleaner=S}),define(Z[154],ee([0,1,9,8,18,11,2,6,15]),function(G,e,v,R,L,k,O,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let S=class ht extends O.Disposable{constructor(m,h,b){super();this.backupWorkspacesPath=m,this.environmentService=h,this.logService=b,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const m=await L.Promises.readFile(this.backupWorkspacesPath,"utf8"),b=JSON.parse(m).emptyWorkspaceInfos.map(C=>C.backupFolder),f=await L.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(f.map(async C=>{C.length!==ht.NON_EMPTY_WORKSPACE_ID_LENGTH&&b.indexOf(C)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${C}.`),await L.Promises.rm(R.join(this.environmentService.workspaceStorageHome.fsPath,C)))}))}catch(m){k.onUnexpectedError(m)}}};S.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,S=de([K(1,v.INativeEnvironmentService),K(2,y.ILogService)],S),e.StorageDataCleaner=S}),define(Z[155],ee([0,1,18,2,10,28,9,5,12,33,15,30,57,7,6,11]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let E=class extends R.Disposable{constructor(d,c,s,t){super();this.fileService=c,this.extensionGalleryService=s,this.logService=t,this.extensionsDownloadDir=D.URI.file(d.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(d,c){await this.cleanUpPromise;const s=this.getName(d),t=y.joinPath(this.extensionsDownloadDir,s);if(!await this.fileService.exists(t)){const r=y.joinPath(this.extensionsDownloadDir,`.${m.generateUuid()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(d,r,c);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch(a){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",d.identifier.id);else throw this.logService.info(`Rename failed because of ${C.getErrorMessage(i)}. Deleted the vsix from downloaded location`,r.path),i}}return t}async delete(d){}async rename(d,c,s){try{await v.Promises.rename(d.fsPath,c.fsPath)}catch(t){if(b.isWindows&&t&&t.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${d} to ${c} with 'EPERM' error. Trying again...`),this.rename(d,c,s);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const d=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(d.children){const c=[],s=[];for(const i of d.children){const a=this.parse(i.name);a&&s.push([a,i])}const t=S.groupByExtension(s,([i])=>i),r=[];for(const i of t)i.sort((a,u)=>h.rcompare(a[0].version,u[0].version)),c.push(...i.slice(1).map(a=>a[1].resource)),r.push(i[0][1]);r.sort((i,a)=>i.mtime-a.mtime),c.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(i=>i.resource)),await f.Promises.settled(c.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(d){this.logService.error(d)}}getName(d){return this.cache?new S.ExtensionIdentifierWithVersion(d.identifier,d.version).key().toLowerCase():m.generateUuid()}parse(d){const c=P.exec(d);return c&&c[1]&&c[2]?new S.ExtensionIdentifierWithVersion({id:c[1]},c[2]):null}};E=de([K(0,O.INativeEnvironmentService),K(1,L.IFileService),K(2,k.IExtensionGalleryService),K(3,n.ILogService)],E),e.ExtensionsDownloader=E}),define(Z[156],ee([0,1,2,15,42,43,8,6,3,17,18,9]),function(G,e,v,R,L,k,O,D,y,S,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let h=class extends v.Disposable{constructor(f,C){super();this.environmentService=f,this.logService=C,this.processesLimiter=new D.Limiter(5)}async postUninstall(f){const C=this.parseScript(f,"uninstall");return C&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(C.script,"uninstall",C.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),P=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${P}`)))),n.Promises.rm(this.getExtensionStoragePath(f)).then(void 0,P=>this.logService.error("Error while removing extension storage path",P))}parseScript(f,C){const P=`vscode:${C}`;if(f.location.scheme===S.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[P]=="string"){const E=f.manifest.scripts[P].split(" ");return E.length<2||E[0]!=="node"||!E[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${P} should be a node script`),null):{script:O.join(f.location.fsPath,E[1]),args:E.slice(2)||[]}}return null}runLifecycleHook(f,C,P,E,I){return new Promise((d,c)=>{const s=this.start(f,C,P,I);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?c(i):d(void 0)};s.on("error",i=>{r(k.toErrorMessage(i)||"Unknown")}),s.on("exit",(i,a)=>{r(i?`post-${C} process exited with code ${i}`:void 0)}),E&&(t=setTimeout(()=>{t=null,s.kill(),c("timed out")},5e3))})}start(f,C,P,E){const I={silent:!0,execArgv:void 0},d=L.fork(f,[`--type=extension-post-${C}`,...P],I);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const c=y.Event.fromNodeEventEmitter(d.stdout,"data"),s=y.Event.fromNodeEventEmitter(d.stderr,"data");c(i=>this.logService.info(E.identifier.id,E.manifest.version,`post-${C}`,i)),s(i=>this.logService.error(E.identifier.id,E.manifest.version,`post-${C}`,i));const t=y.Event.any(y.Event.map(c,i=>({data:`%c${i}`,format:[""]})),y.Event.map(s,i=>({data:`%c${i}`,format:["color: red"]})));return y.Event.debounce(t,(i,a)=>i?{data:i.data+a.data,format:[...i.format,...a.format]}:{data:a.data,format:a.format},100)(i=>{console.group(E.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),d}getExtensionStoragePath(f){return O.join(this.environmentService.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};h=de([K(0,m.IEnvironmentService),K(1,R.ILogService)],h),e.ExtensionsLifecycle=h}),define(Z[157],ee([0,1,2,9,3,10,5,33,12,15]),function(G,e,v,R,L,k,O,D,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends v.Disposable{constructor(h,b,f,C){super();this.extensionsManagementService=h,this.logService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(I=>{this.installedExtensions=I.map(d=>d.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(I=>this.onInstallExtension(I))),this._register(h.onDidInstallExtension(I=>this.onDidInstallExtension(I))),this._register(h.onDidUninstallExtension(I=>this.onDidUninstallExtension(I)));const P=O.URI.file(f.extensionsPath),E=new y.ExtUri(I=>!b.hasCapability(I,1024));this._register(b.watch(P)),this._register(L.Event.filter(b.onDidFilesChange,I=>I.raw.some(d=>this.doesChangeAffects(d,P,E)))(()=>this.onDidChange()))}doesChangeAffects(h,b,f){return f.isEqual(f.dirname(h.resource),b)?f.isEqual(h.resource,f.joinPath(b,".obsolete"))?!0:!(h.type!==1&&h.type!==2||f.basename(h.resource).startsWith(".")):!1}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtension(h){this.removeInstallingExtension(h.identifier),h.error||this.addInstalledExtension(h.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(b=>!D.areSameExtensions(b,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(b=>!D.areSameExtensions(b,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(1),b=h.filter(C=>[...this.installingExtensions,...this.installedExtensions].some(P=>D.areSameExtensions(P,C.identifier))?!1:C.installedTimestamp&&C.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",C.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",C.identifier.id),!1)),f=this.installedExtensions.filter(C=>this.installingExtensions.some(P=>D.areSameExtensions(P,C))?!1:h.every(P=>!D.areSameExtensions(P.identifier,C))?(this.logService.info("Detected extension removed from another source",C.id),!0):!1);this.installedExtensions=h.map(C=>C.identifier),(b.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b,removed:f})}}};n=de([K(1,k.IFileService),K(2,R.INativeEnvironmentService),K(3,S.ILogService)],n),e.ExtensionsWatcher=n}),define(Z[158],ee([0,1,18,147,28,2,9,6,33,15,56,19,3,17,8]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let C=class extends k.Disposable{constructor(I,d,c){super();this.extensionManagementService=I,this.logService=c,this._onDidLanguagesChange=this._register(new h.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new P(d,c)),this._register(I.onDidInstallExtension(({local:s})=>this.onDidInstallExtension(s))),this._register(I.onDidUninstallExtension(({identifier:s})=>this.onDidUninstallExtension(s)))}getLanguageIds(){return this.cache.getLanguagePacks().then(I=>{const d=["en",...Object.keys(I)];return m.distinct(d)})}onDidInstallExtension(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",I.identifier.id),this.update().then(d=>{d&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(I){this.cache.getLanguagePacks().then(d=>{Object.keys(d).some(c=>d[c]&&d[c].extensions.some(s=>y.areSameExtensions(s.extensionIdentifier,I)))&&(this.logService.debug("Removing language packs from the extension",I.id),this.update().then(c=>{c&&this._onDidLanguagesChange.fire()}))})}async update(){const[I,d]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),c=await this.cache.update(d);return!m.equals(Object.keys(I),Object.keys(c))}};C=de([K(0,L.IExtensionManagementService),K(1,O.INativeEnvironmentService),K(2,S.ILogService)],C),e.LocalizationsService=C;let P=class extends k.Disposable{constructor(I,d){super();this.logService=d,this.languagePacks={},this.languagePacksFilePath=f.join(I.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(I){return this.withLanguagePacks(d=>{Object.keys(d).forEach(c=>delete d[c]),this.createLanguagePacksFromExtensions(d,...I)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(I,...d){for(const c of d)c&&c.manifest&&c.manifest.contributes&&c.manifest.contributes.localizations&&c.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(I,c);Object.keys(I).forEach(c=>this.updateHash(I[c]))}createLanguagePacksFromExtension(I,d){const c=d.identifier,s=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const t of s)if(d.location.scheme===b.Schemas.file&&n.isValidLocalization(t)){let r=I[t.languageId];r||(r={hash:"",extensions:[],translations:{}},I[t.languageId]=r);let i=r.extensions.filter(a=>y.areSameExtensions(a.extensionIdentifier,c))[0];i?i.version=d.manifest.version:r.extensions.push({extensionIdentifier:c,version:d.manifest.version});for(const a of t.translations)r.translations[a.id]=f.join(d.location.fsPath,a.path)}}updateHash(I){if(I){const d=R.createHash("md5");for(const c of I.extensions)d.update(c.extensionIdentifier.uuid||c.extensionIdentifier.id).update(c.version);I.hash=d.digest("hex")}}withLanguagePacks(I=()=>null){return this.languagePacksFileLimiter.queue(()=>{let d=null;return v.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,c=>c.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(c)).then(c=>{try{return JSON.parse(c)}catch(s){return{}}}).then(c=>(d=I(c),c)).then(c=>{for(const t of Object.keys(c))c[t]||delete c[t];this.languagePacks=c,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),v.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>d,c=>this.logService.error(c))})}};P=de([K(0,O.INativeEnvironmentService),K(1,S.ILogService)],P)}),define(Z[78],ee([0,1,15,3,5]),function(G,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(h){this.service=h,this.onDidChangeLogLevel=R.Event.buffer(h.onDidChangeLogLevel,!0)}listen(h,b){switch(b){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${b}`)}async call(h,b,f){switch(b){case"setLevel":return this.service.setLevel(f)}throw new Error(`Call not found: ${b}`)}}e.LogLevelChannel=k;class O{constructor(h){this.channel=h}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(h){O.setLevel(this.channel,h)}static setLevel(h,b){return h.call("setLevel",b)}}e.LogLevelChannelClient=O;class D{constructor(h){this.loggerService=h,this.loggers=new Map}listen(h,b){throw new Error(`Event not found: ${b}`)}async call(h,b,f){switch(b){case"createLogger":this.createLogger(L.URI.revive(f[0]),f[1]);return;case"log":return this.log(L.URI.revive(f[0]),f[1]);case"consoleLog":return this.consoleLog(f[0],f[1])}throw new Error(`Call not found: ${b}`)}createLogger(h,b){this.loggers.set(h.toString(),this.loggerService.createLogger(h,b))}consoleLog(h,b){let f=console.log;switch(h){case v.LogLevel.Error:f=console.error;break;case v.LogLevel.Warning:f=console.warn;break;case v.LogLevel.Info:f=console.info;break}f.call(console,...b)}log(h,b){const f=this.loggers.get(h.toString());if(!f)throw new Error("Create the logger before logging");for(const[C,P]of b)switch(C){case v.LogLevel.Trace:f.trace(P);break;case v.LogLevel.Debug:f.debug(P);break;case v.LogLevel.Info:f.info(P);break;case v.LogLevel.Warning:f.warn(P);break;case v.LogLevel.Error:f.error(P);break;case v.LogLevel.Critical:f.critical(P);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=D;class y extends v.AbstractLoggerService{constructor(h,b,f){super(h,b);this.channel=f}createConsoleMainLogger(){return new v.AdapterLogger({log:(h,b)=>{this.channel.call("consoleLog",[h,b])}})}doCreateLogger(h,b,f){return new S(this.channel,h,b,f)}}e.LoggerChannelClient=y;class S extends v.AbstractMessageLogger{constructor(h,b,f,C){super(C==null?void 0:C.always);this.channel=h,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[b,C]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(h,b){const f=[[h,b]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(h){this.channel.call("log",[this.file,h])}}class n extends v.LogService{constructor(h,b){super(b);this.parent=h,this._register(h.onDidChangeLogLevel(f=>b.setLevel(f)))}setLevel(h){super.setLevel(h),this.parent.setLevel(h)}}e.FollowerLogService=n}),define(Z[58],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=v.createDecorator("nativeHostService")}),define(Z[51],ee([0,1,17,7,34,12]),function(G,e,v,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const D=R.globals.vscode.context.configuration();if(D)O=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(G==null?void 0:G.__$__nodeRequire)=="function"){const D=k.dirname(v.FileAccess.asFileUri("",G));O=G.__$__nodeRequire(k.joinPath(D,"product.json").fsPath);const y=G.__$__nodeRequire(k.joinPath(D,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`}),Object.assign(O,{version:y.version})}else O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.58.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=O}),define(Z[79],ee([0,1,118,25,10,11,51]),function(G,e,v,R,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(m,h,b,f,C,P){let E;try{await y(m,h,b,f,C,P)}catch(I){E=I}finally{E&&C.errorTransformer&&(E=C.errorTransformer(E)),typeof E!="undefined"&&b.error(E),b.end()}}e.readFileIntoStream=D;async function y(m,h,b,f,C,P){S(P);const E=await m.open(h,{create:!1});try{S(P);let I=0,d=0,c=C&&typeof C.length=="number"?C.length:void 0,s=R.VSBuffer.alloc(Math.min(C.bufferSize,typeof c=="number"?c:C.bufferSize)),t=C&&typeof C.position=="number"?C.position:0,r=0;do d=await m.read(E,t,s.buffer,r,s.byteLength-r),t+=d,r+=d,I+=d,typeof c=="number"&&(c-=d),r===s.byteLength&&(await b.write(f(s)),s=R.VSBuffer.alloc(Math.min(C.bufferSize,typeof c=="number"?c:C.bufferSize)),r=0);while(d>0&&(typeof c!="number"||c>0)&&S(P)&&n(I,C));if(r>0){let i=r;typeof c=="number"&&(i=Math.min(r,c)),b.write(f(s.slice(0,i)))}}catch(I){throw L.ensureFileSystemProviderError(I)}finally{await m.close(E)}}function S(m){if(m.isCancellationRequested)throw k.canceled();return!0}function n(m,h){if(h==null?void 0:h.limits){if(typeof h.limits.memory=="number"&&m>h.limits.memory)throw L.createFileSystemProviderError(v.localize(0,null,O.default.nameShort),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof h.limits.size=="number"&&m>h.limits.size)throw L.createFileSystemProviderError(v.localize(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[159],ee([0,1,116,160,2,10,3,12,38,19,15,25,47,6,29,17,79,53]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b,f,C,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let I=class extends L.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new O.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new O.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new O.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new O.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new b.ResourceQueue)}registerProvider(c,s){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);R.mark(`code/registerFilesystem/${c}`),this.provider.set(c,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:s});const t=new L.DisposableStore;return t.add(s.onDidChangeFile(r=>this._onDidFilesChange.fire(new k.FileChangesEvent(r,!this.isPathCaseSensitive(s))))),t.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:c}))),typeof s.onDidErrorOccur=="function"&&t.add(s.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),L.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:s}),this.provider.delete(c),L.dispose(t)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(t){s.push(t)}}),!this.provider.has(c)&&await b.Promises.settled(s)}canHandleResource(c){return this.provider.has(c.scheme)}hasCapability(c,s){const t=this.provider.get(c.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return E.Iterable.map(this.provider,([c,s])=>({scheme:c,capabilities:s.capabilities}))}async withProvider(c){if(!D.isAbsolutePath(c))throw new k.FileOperationError(v.localize(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const s=this.provider.get(c.scheme);if(!s){const t=new Error;throw t.name="ENOPRO",t.message=v.localize(1,null,c.toString()),t}return s}async withReadProvider(c){const s=await this.withProvider(c);if(k.hasOpenReadWriteCloseCapability(s)||k.hasReadWriteCapability(s)||k.hasFileReadStreamCapability(s))return s;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const s=await this.withProvider(c);if(k.hasOpenReadWriteCloseCapability(s)||k.hasReadWriteCapability(s))return s;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,s){try{return await this.doResolveFile(c,s)}catch(t){throw k.toFileSystemProviderErrorCode(t)===k.FileSystemProviderErrorCode.FileNotFound?new k.FileOperationError(v.localize(2,null,this.resourceForError(c)),1):k.ensureFileSystemProviderError(t)}}async doResolveFile(c,s){const t=await this.withProvider(c),r=this.isPathCaseSensitive(t),i=s==null?void 0:s.resolveTo,a=s==null?void 0:s.resolveSingleChildDescendants,u=s==null?void 0:s.resolveMetadata,o=await t.stat(c);let l;return this.toFileStat(t,c,o,void 0,!!u,(p,w)=>(l||(l=y.TernarySearchTree.forUris(()=>!r),l.set(c,!0),S.isNonEmptyArray(i)&&i.forEach(g=>l.set(g,!0))),Boolean(l.findSuperstr(p.resource)||l.get(p.resource))?!0:p.isDirectory&&a?w===1:!1))}async toFileStat(c,s,t,r,i,a){var u;const{providerExtUri:o}=this.getExtUri(c),l={resource:s,name:o.basename(s),isFile:(t.type&k.FileType.File)!=0,isDirectory:(t.type&k.FileType.Directory)!=0,isSymbolicLink:(t.type&k.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean(((u=t.permissions)!==null&&u!==void 0?u:0)&k.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:k.etag({mtime:t.mtime,size:t.size})};if(l.isDirectory&&a(l,r)){try{const p=await c.readdir(s),w=await b.Promises.settled(p.map(async([g,U])=>{try{const F=o.joinPath(s,g),j=i?await c.stat(F):{type:U};return await this.toFileStat(c,F,j,p.length,i,a)}catch(F){return this.logService.trace(F),null}}));l.children=S.coalesce(w)}catch(p){this.logService.trace(p),l.children=[]}return l}return l}async resolveAll(c){return b.Promises.settled(c.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(c){const s=await this.withProvider(c);try{return!!await s.stat(c)}catch(t){return!1}}async canCreateFile(c,s){try{await this.doValidateCreateFile(c,s)}catch(t){return t}return!0}async doValidateCreateFile(c,s){if(!(s==null?void 0:s.overwrite)&&await this.exists(c))throw new k.FileOperationError(v.localize(3,null,this.resourceForError(c)),3,s)}async createFile(c,s=m.VSBuffer.fromString(""),t){await this.doValidateCreateFile(c,t);const r=await this.writeFile(c,s);return this._onDidRunOperation.fire(new k.FileOperationEvent(c,0,r)),r}async writeFile(c,s,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,c,t)||await this.mkdirp(r,i.dirname(c));let u;if(k.hasReadWriteCapability(r)&&!(s instanceof m.VSBuffer))if(h.isReadableStream(s)){const o=await h.peekStream(s,3);o.ended?u=m.VSBuffer.concat(o.buffer):u=o}else u=h.peekReadable(s,o=>m.VSBuffer.concat(o),3);else u=s;!k.hasOpenReadWriteCloseCapability(r)||k.hasReadWriteCapability(r)&&u instanceof m.VSBuffer?await this.doWriteUnbuffered(r,c,t,u):await this.doWriteBuffered(r,c,t,u instanceof m.VSBuffer?m.bufferToReadable(u):u)}catch(a){throw new k.FileOperationError(v.localize(4,null,this.resourceForError(c),k.ensureFileSystemProviderError(a).toString()),k.toFileOperationResult(a),t)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,s,t){if(!!(t==null?void 0:t.unlock)&&!(c.capabilities&8192))throw new Error(v.localize(5,null,this.resourceForError(s)));let i;try{i=await c.stat(s)}catch(a){return}if((i.type&k.FileType.Directory)!=0)throw new k.FileOperationError(v.localize(6,null,this.resourceForError(s)),0,t);if(this.throwIfFileIsReadonly(s,i),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==k.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&t.mtime<i.mtime&&t.etag!==k.etag({mtime:t.mtime,size:i.size}))throw new k.FileOperationError(v.localize(7,null),3,t);return i}async readFile(c,s){const t=await this.withReadProvider(c);return(s==null?void 0:s.atomic)?this.doReadFileAtomic(t,c,s):this.doReadFile(t,c,s)}async doReadFileAtomic(c,s,t){return new Promise((r,i)=>{this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(c,s,t);r(a)}catch(a){i(a)}})})}async doReadFile(c,s,t){const r=await this.doReadFileStream(c,s,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await m.streamToBuffer(r.value)})}async readFileStream(c,s){const t=await this.withReadProvider(c);return this.doReadFileStream(t,c,s)}async doReadFileStream(c,s,t){const r=new f.CancellationTokenSource,i=this.validateReadFile(s,t).then(u=>u,u=>{throw r.cancel(),u});let a;try{t&&typeof t.etag=="string"&&t.etag!==k.ETAG_DISABLED&&await i,!(k.hasOpenReadWriteCloseCapability(c)||k.hasFileReadStreamCapability(c))||k.hasReadWriteCapability(c)&&(t==null?void 0:t.preferUnbuffered)?a=this.readFileUnbuffered(c,s,t):k.hasFileReadStreamCapability(c)?a=this.readFileStreamed(c,s,r.token,t):a=this.readFileBuffered(c,s,r.token,t);const u=await i;return Object.assign(Object.assign({},u),{value:a})}catch(u){a&&await h.consumeStream(a);const o=v.localize(8,null,this.resourceForError(s),k.ensureFileSystemProviderError(u).toString());throw u instanceof k.NotModifiedSinceFileOperationError?new k.NotModifiedSinceFileOperationError(o,u.stat,t):new k.FileOperationError(o,k.toFileOperationResult(u),t)}}readFileStreamed(c,s,t,r=Object.create(null)){const i=c.readFileStream(s,r,t);return h.transform(i,{data:a=>a instanceof m.VSBuffer?a:m.VSBuffer.wrap(a),error:a=>new k.FileOperationError(v.localize(9,null,this.resourceForError(s),k.ensureFileSystemProviderError(a).toString()),k.toFileOperationResult(a),r)},a=>m.VSBuffer.concat(a))}readFileBuffered(c,s,t,r=Object.create(null)){const i=m.newWriteableBufferStream();return P.readFileIntoStream(c,s,i,a=>a,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new k.FileOperationError(v.localize(10,null,this.resourceForError(s),k.ensureFileSystemProviderError(a).toString()),k.toFileOperationResult(a),r)}),t),i}readFileUnbuffered(c,s,t){const r=h.newWriteableStream(i=>m.VSBuffer.concat(i));return(async()=>{try{let i=await c.readFile(s);t&&typeof t.position=="number"&&(i=i.slice(t.position)),t&&typeof t.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(s,i.byteLength,t),r.end(m.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(c,s){const t=await this.resolve(c,{resolveMetadata:!0});if(t.isDirectory)throw new k.FileOperationError(v.localize(11,null,this.resourceForError(c)),0,s);if(s&&typeof s.etag=="string"&&s.etag!==k.ETAG_DISABLED&&s.etag===t.etag)throw new k.NotModifiedSinceFileOperationError(v.localize(12,null),t,s);return this.validateReadFileLimits(c,t.size,s),t}validateReadFileLimits(c,s,t){if(t==null?void 0:t.limits){let r;if(typeof t.limits.memory=="number"&&s>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&s>t.limits.size&&(r=7),typeof r=="number")throw new k.FileOperationError(v.localize(13,null,this.resourceForError(c)),r)}}async canMove(c,s,t){return this.doCanMoveCopy(c,s,"move",t)}async canCopy(c,s,t){return this.doCanMoveCopy(c,s,"copy",t)}async doCanMoveCopy(c,s,t,r){if(c.toString()!==s.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(i,c,a,s,t,r)}catch(i){return i}return!0}async move(c,s,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),a=await this.doMoveCopy(r,c,i,s,"move",!!t),u=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(c,a==="move"?2:3,u)),u}async copy(c,s,t){const r=await this.withReadProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),a=await this.doMoveCopy(r,c,i,s,"copy",!!t),u=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(c,a==="copy"?3:2,u)),u}async doMoveCopy(c,s,t,r,i,a){if(s.toString()===r.toString())return i;const{exists:u,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(c,s,t,r,i,a);if(u&&!o&&a&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),i==="copy"){if(c===t&&k.hasFileFolderCopyCapability(c))await c.copy(s,r,{overwrite:a});else{const l=await this.resolve(s);l.isDirectory?await this.doCopyFolder(c,l,t,r):await this.doCopyFile(c,s,t,r)}return i}else return c===t?(await c.rename(s,r,{overwrite:a}),i):(await this.doMoveCopy(c,s,t,r,"copy",a),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(c,s,t,r){if(k.hasOpenReadWriteCloseCapability(c)&&k.hasOpenReadWriteCloseCapability(t))return this.doPipeBuffered(c,s,t,r);if(k.hasOpenReadWriteCloseCapability(c)&&k.hasReadWriteCapability(t))return this.doPipeBufferedToUnbuffered(c,s,t,r);if(k.hasReadWriteCapability(c)&&k.hasOpenReadWriteCloseCapability(t))return this.doPipeUnbufferedToBuffered(c,s,t,r);if(k.hasReadWriteCapability(c)&&k.hasReadWriteCapability(t))return this.doPipeUnbuffered(c,s,t,r)}async doCopyFolder(c,s,t,r){await t.mkdir(r),Array.isArray(s.children)&&await b.Promises.settled(s.children.map(async i=>{const a=this.getExtUri(t).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(c,await this.resolve(i.resource),t,a):this.doCopyFile(c,i.resource,t,a)}))}async doValidateMoveCopy(c,s,t,r,i,a){let u=!1;if(c===t){const{providerExtUri:l,isPathCaseSensitive:p}=this.getExtUri(c);if(p||(u=l.isEqual(s,r)),u&&i==="copy")throw new Error(v.localize(14,null,this.resourceForError(s),this.resourceForError(r)));if(!u&&l.isEqualOrParent(r,s))throw new Error(v.localize(15,null,this.resourceForError(s),this.resourceForError(r)))}const o=await this.exists(r);if(o&&!u){if(!a)throw new k.FileOperationError(v.localize(16,null,this.resourceForError(s),this.resourceForError(r)),4);if(c===t){const{providerExtUri:l}=this.getExtUri(c);if(l.isEqualOrParent(s,r))throw new Error(v.localize(17,null,this.resourceForError(s),this.resourceForError(r)))}}return{exists:o,isSameResourceWithDifferentPathCase:u}}getExtUri(c){const s=this.isPathCaseSensitive(c);return{providerExtUri:s?D.extUri:D.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(s,c);const t=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(c,0,t)),t}async mkdirp(c,s){const t=[],{providerExtUri:r}=this.getExtUri(c);for(;!r.isEqual(s,r.dirname(s));)try{if(((await c.stat(s)).type&k.FileType.Directory)==0)throw new Error(v.localize(18,null,this.resourceForError(s)));break}catch(i){if(k.toFileSystemProviderErrorCode(i)!==k.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(r.basename(s)),s=r.dirname(s)}for(let i=t.length-1;i>=0;i--){s=r.joinPath(s,t[i]);try{await c.mkdir(s)}catch(a){if(k.toFileSystemProviderErrorCode(a)!==k.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(c,s){try{await this.doValidateDelete(c,s)}catch(t){return t}return!0}async doValidateDelete(c,s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!(s==null?void 0:s.useTrash)&&!(t.capabilities&4096))throw new Error(v.localize(19,null,this.resourceForError(c)));let i;try{i=await t.stat(c)}catch(u){}if(i)this.throwIfFileIsReadonly(c,i);else throw new k.FileOperationError(v.localize(20,null,this.resourceForError(c)),1);if(!!!(s==null?void 0:s.recursive)){const u=await this.resolve(c);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error(v.localize(21,null,this.resourceForError(c)))}return t}async del(c,s){const t=await this.doValidateDelete(c,s),r=!!(s==null?void 0:s.useTrash),i=!!(s==null?void 0:s.recursive);await t.delete(c,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new k.FileOperationEvent(c,1))}watch(c,s={recursive:!1,excludes:[]}){let t=!1,r=()=>{t=!0};return this.doWatch(c,s).then(i=>{t?L.dispose(i):r=()=>L.dispose(i)},i=>this.logService.error(i)),L.toDisposable(()=>r())}async doWatch(c,s){const t=await this.withProvider(c),r=this.toWatchKey(t,c,s),i=this.activeWatchers.get(r)||{count:0,disposable:t.watch(c,s)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,i),i.count+=1,L.toDisposable(()=>{i.count--,i.count===0&&(L.dispose(i.disposable),this.activeWatchers.delete(r))})}toWatchKey(c,s,t){const{providerExtUri:r}=this.getExtUri(c);return[r.getComparisonKey(s),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(c=>L.dispose(c.disposable)),this.activeWatchers.clear()}async doWriteBuffered(c,s,t,r){return this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(async()=>{var i;const a=await c.open(s,{create:!0,unlock:(i=t==null?void 0:t.unlock)!==null&&i!==void 0?i:!1});try{h.isReadableStream(r)||h.isReadableBufferedStream(r)?await this.doWriteStreamBufferedQueued(c,a,r):await this.doWriteReadableBufferedQueued(c,a,r)}catch(u){throw k.ensureFileSystemProviderError(u)}finally{await c.close(a)}})}async doWriteStreamBufferedQueued(c,s,t){let r=0,i;if(h.isReadableBufferedStream(t)){if(t.buffer.length>0){const a=m.VSBuffer.concat(t.buffer);await this.doWriteBuffer(c,s,a,a.byteLength,r,0),r+=a.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(a,u)=>{h.listenStream(i,{onData:async o=>{i.pause();try{await this.doWriteBuffer(c,s,o,o.byteLength,r,0)}catch(l){return u(l)}r+=o.byteLength,setTimeout(()=>i.resume())},onError:o=>u(o),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(c,s,t){let r=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(c,s,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(c,s,t,r,i,a){let u=0;for(;u<r;)u+=await c.write(s,i+u,t.buffer,a+u,r-u)}async doWriteUnbuffered(c,s,t,r){return this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,s,t,r))}async doWriteUnbufferedQueued(c,s,t,r){var i;let a;r instanceof m.VSBuffer?a=r:h.isReadableStream(r)?a=await m.streamToBuffer(r):h.isReadableBufferedStream(r)?a=await m.bufferedStreamToBuffer(r):a=m.readableToBuffer(r),await c.writeFile(s,a.buffer,{create:!0,overwrite:!0,unlock:(i=t==null?void 0:t.unlock)!==null&&i!==void 0?i:!1})}async doPipeBuffered(c,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,s,t,r))}async doPipeBufferedQueued(c,s,t,r){let i,a;try{i=await c.open(s,{create:!1}),a=await t.open(r,{create:!0,unlock:!1});const u=m.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,l=0,p=0;do p=await c.read(i,o,u.buffer,l,u.byteLength-l),await this.doWriteBuffer(t,a,u,p,o,l),o+=p,l+=p,l===u.byteLength&&(l=0);while(p>0)}catch(u){throw k.ensureFileSystemProviderError(u)}finally{await b.Promises.settled([typeof i=="number"?c.close(i):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async doPipeUnbuffered(c,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,s,t,r))}async doPipeUnbufferedQueued(c,s,t,r){return t.writeFile(r,await c.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,s,t,r))}async doPipeUnbufferedToBufferedQueued(c,s,t,r){const i=await t.open(r,{create:!0,unlock:!1});try{const a=await c.readFile(s);await this.doWriteBuffer(t,i,m.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw k.ensureFileSystemProviderError(a)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(c,s,t,r){const i=await m.streamToBuffer(this.readFileBuffered(c,s,f.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,i)}throwIfFileSystemIsReadonly(c,s){if(c.capabilities&2048)throw new k.FileOperationError(v.localize(22,null,this.resourceForError(s)),6);return c}throwIfFileIsReadonly(c,s){var t;if(((t=s.permissions)!==null&&t!==void 0?t:0)&k.FilePermission.Readonly)throw new k.FileOperationError(v.localize(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===C.Schemas.file?c.fsPath:c.toString(!0)}};I=de([K(0,n.ILogService)],I),e.FileService=I}),define(Z[161],ee([0,1,2,10,3,7,18,8,12,41,6,15,119,76,137,139,136,148,47,79,19,25]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b,f,C,P,E,I,d,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends v.Disposable{constructor(i,a){var u;super();this.logService=i,this.options=a,this.BUFFER_SIZE=((u=this.options)===null||u===void 0?void 0:u.bufferSize)||64*1024,this.onDidChangeCapabilities=L.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new L.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:a,symbolicLink:u}=await O.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(a,u),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(i){try{const a=await O.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),u=[];return await Promise.all(a.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat(y.joinPath(i,o.name))).type:l=this.toType(o),u.push([o.name,l])}catch(l){this.logService.trace(l)}})),u}catch(a){throw this.toFileSystemProviderError(a)}}toType(i,a){let u;return(a==null?void 0:a.dangling)?u=R.FileType.Unknown:i.isFile()?u=R.FileType.File:i.isDirectory()?u=R.FileType.Directory:u=R.FileType.Unknown,a&&(u|=R.FileType.SymbolicLink),u}async readFile(i){try{const a=this.toFilePath(i);return await O.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(i,a,u){const o=I.newWriteableStream(l=>s.VSBuffer.concat(l.map(p=>s.VSBuffer.wrap(p))).buffer);return d.readFileIntoStream(this,i,o,l=>l.buffer,Object.assign(Object.assign({},a),{bufferSize:this.BUFFER_SIZE}),u),o}async writeFile(i,a,u){let o;try{const l=this.toFilePath(i);if(!u.create||!u.overwrite){if(await O.Promises.exists(l)){if(!u.overwrite)throw R.createFileSystemProviderError(h.localize(0,null),R.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw R.createFileSystemProviderError(h.localize(1,null),R.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:u.unlock}),await this.write(o,0,a,0,a.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(i,l)}finally{typeof o=="number"&&await this.close(o)}}async open(i,a){try{const u=this.toFilePath(i);if(R.isFileOpenForWriteOptions(a)&&a.unlock)try{const{stat:p}=await O.SymlinkSupport.stat(u);p.mode&128||await O.Promises.chmod(u,p.mode|128)}catch(p){this.logService.trace(p)}let o;if(R.isFileOpenForWriteOptions(a)){if(k.isWindows)try{await O.Promises.truncate(u,0),o="r+"}catch(p){p.code!=="ENOENT"&&this.logService.trace(p)}o||(o="w")}else o="r";const l=await O.Promises.open(u,o);return this.mapHandleToPos.set(l,0),R.isFileOpenForWriteOptions(a)&&this.writeHandles.set(l,i),l}catch(u){throw R.isFileOpenForWriteOptions(a)?await this.toFileSystemProviderWriteError(i,u):this.toFileSystemProviderError(u)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await O.Promises.fdatasync(i)}catch(a){this.canFlush=!1,this.logService.error(a)}return await O.Promises.close(i)}catch(a){throw this.toFileSystemProviderError(a)}}async read(i,a,u,o,l){const p=this.normalizePos(i,a);let w=null;try{const g=await O.Promises.read(i,u,o,l,p);return typeof g=="number"?w=g:w=g.bytesRead,w}catch(g){throw this.toFileSystemProviderError(g)}finally{this.updatePos(i,p,w)}}normalizePos(i,a){return a===this.mapHandleToPos.get(i)?null:a}updatePos(i,a,u){const o=this.mapHandleToPos.get(i);typeof o=="number"&&(typeof a=="number"||(typeof u=="number"?this.mapHandleToPos.set(i,o+u):this.mapHandleToPos.delete(i)))}async write(i,a,u,o,l){return n.retry(()=>this.doWrite(i,a,u,o,l),100,3)}async doWrite(i,a,u,o,l){const p=this.normalizePos(i,a);let w=null;try{const g=await O.Promises.write(i,u,o,l,p);return typeof g=="number"?w=g:w=g.bytesWritten,w}catch(g){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),g)}finally{this.updatePos(i,p,w)}}async mkdir(i){try{await O.Promises.mkdir(this.toFilePath(i))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(i,a){try{const u=this.toFilePath(i);await this.doDelete(u,a)}catch(u){throw this.toFileSystemProviderError(u)}}async doDelete(i,a){a.recursive?await O.Promises.rm(i,O.RimRafMode.MOVE):await O.Promises.unlink(i)}async rename(i,a,u){const o=this.toFilePath(i),l=this.toFilePath(a);if(o!==l)try{await this.validateTargetDeleted(i,a,"move",u.overwrite),await O.Promises.move(o,l)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error(h.localize(2,null,D.basename(o),D.basename(D.dirname(l)),p.toString()))),this.toFileSystemProviderError(p)}}async copy(i,a,u){const o=this.toFilePath(i),l=this.toFilePath(a);if(o!==l)try{await this.validateTargetDeleted(i,a,"copy",u.overwrite),await O.Promises.copy(o,l,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error(h.localize(3,null,D.basename(o),D.basename(D.dirname(l)),p.toString()))),this.toFileSystemProviderError(p)}}async validateTargetDeleted(i,a,u,o){const l=this.toFilePath(i),p=this.toFilePath(a);let w=!1;if(!!(this.capabilities&1024)||(w=S.isEqual(l,p,!0)),w&&u==="copy")throw R.createFileSystemProviderError(h.localize(4,null),R.FileSystemProviderErrorCode.FileExists);if(!w&&await O.Promises.exists(p)){if(!o)throw R.createFileSystemProviderError(h.localize(5,null),R.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(i,a){return a.recursive?this.watchRecursive(i,a.excludes):this.watchNonRecursive(i)}watchRecursive(i,a){const u={path:this.toFilePath(i),excludes:a},o=c.insert(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),v.toDisposable(()=>{o(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var i,a,u;if(this.recursiveWatcher instanceof P.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(v.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let o,l;((a=(i=this.options)===null||i===void 0?void 0:i.watcher)===null||a===void 0?void 0:a.usePolling)?(o=f.FileWatcher,l=(u=this.options)===null||u===void 0?void 0:u.watcher):this.recursiveFoldersToWatch.length===1?k.isWindows?o=C.FileWatcher:o=f.FileWatcher:o=P.FileWatcher,this.recursiveWatcher=new o(this.recursiveFoldersToWatch,p=>this._onDidChangeFile.fire(b.toFileChanges(p)),p=>{p.type==="error"&&this._onDidWatchErrorOccur.fire(p.message),this.logService[p.type](p.message)},this.logService.getLevel()===m.LogLevel.Trace,l),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))}}watchNonRecursive(i){const a=new E.FileWatcher(this.toFilePath(i),o=>this._onDidChangeFile.fire(b.toFileChanges(o)),o=>{o.type==="error"&&this._onDidWatchErrorOccur.fire(o.message),this.logService[o.type](o.message)},this.logService.getLevel()===m.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)});return v.combinedDisposable(a,u)}toFilePath(i){return D.normalize(i.fsPath)}toFileSystemProviderError(i){if(i instanceof R.FileSystemProviderError)return i;let a;switch(i.code){case"ENOENT":a=R.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=R.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=R.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=R.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=R.FileSystemProviderErrorCode.NoPermissions;break;default:a=R.FileSystemProviderErrorCode.Unknown}return R.createFileSystemProviderError(i,a)}async toFileSystemProviderWriteError(i,a){let u=this.toFileSystemProviderError(a);if(i&&u.code===R.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await O.SymlinkSupport.stat(this.toFilePath(i));o.mode&128||(u=R.createFileSystemProviderError(a,R.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return u}dispose(){super.dispose(),v.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,v.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(Z[27],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=v.createDecorator("productService")}),define(Z[162],ee([0,1,8,11,2,18,27,6,15]),function(G,e,v,R,L,k,O,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let S=class extends L.Disposable{constructor(m,h,b){super();this.productService=h,this.logService=b,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,m&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(m)},30*1e3)).schedule()}async cleanUpCodeCaches(m){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const h=Date.now(),b=v.dirname(m),f=v.basename(m),C=await k.Promises.readdir(b);await Promise.all(C.map(async P=>{if(P===f)return;const E=v.join(b,P),I=await k.Promises.stat(E);if(I.isDirectory()&&h-I.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${P}.`),k.Promises.rm(E)}))}catch(h){R.onUnexpectedError(h)}}};S=de([K(1,O.IProductService),K(2,y.ILogService)],S),e.CodeCacheCleaner=S}),define(Z[163],ee([0,1,8,18,27,2,11,15,9,6]),function(G,e,v,R,L,k,O,D,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let n=class extends k.Disposable{constructor(h,b,f){super();this.environmentService=h,this.logService=b,this.productService=f,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new S.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const h=Object.create(null),b=JSON.parse(await R.Promises.readFile(v.join(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let I of Object.keys(b)){const d=b[I];h[`${d.hash}.${I}`]=!0}const f=v.join(this.environmentService.userDataPath,"clp");if(!await R.Promises.exists(f))return;const P=await R.Promises.readdir(f);for(const I of P){if(h[I]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${I}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${I}`),await R.Promises.rm(v.join(f,I))}const E=Date.now();for(const I of Object.keys(h)){const d=v.join(f,I),c=await R.Promises.readdir(d);for(const s of c){if(s==="tcf.json")continue;const t=v.join(d,s),r=await R.Promises.stat(t);r.isDirectory()&&E-r.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${v.join(I,s)}`),await R.Promises.rm(t))}}}catch(h){O.onUnexpectedError(h)}}};n=de([K(0,y.INativeEnvironmentService),K(1,D.ILogService),K(2,L.IProductService)],n),e.LanguagePackCachedDataCleaner=n}),define(Z[31],ee([0,1,16,88]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(O,D){R.ok(v.isString(O)),R.ok(v.isObject(D)),R.ok(!this.data.has(O),"There is already an extension with this id"),this.data.set(O,D)}knows(O){return this.data.has(O)}as(O){return this.data.get(O)||null}}e.Registry=new L}),define(Z[80],ee([0,1,31,3]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class k{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,S){this.schemasById[L(y)]=S,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const O=new k;v.Registry.add(e.Extensions.JSONContribution,O)}),define(Z[37],ee([0,1,109,3,31,16,80]),function(G,e,v,R,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=L.Registry.as(O.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,I=!0){this.registerConfigurations([E],I)}registerConfigurations(E,I=!0){const d=[];E.forEach(c=>{d.push(...this.validateAndRegisterProperties(c,I,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterConfigurations(E){const I=[],d=c=>{if(c.properties)for(const s in c.properties)I.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,c.properties[s]);c.allOf&&c.allOf.forEach(s=>d(s))};for(const c of E){d(c);const s=this.configurationContributors.indexOf(c);s!==-1&&this.configurationContributors.splice(s,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}registerDefaultConfigurations(E){const I=[],d=[];for(const c of E)for(const s in c)if(I.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]=Object.assign(Object.assign({},this.defaultValues[s]||{}),c[s]);const t={type:"object",default:this.defaultValues[s],description:v.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};d.push(m(s)),this.configurationProperties[s]=t,this.defaultLanguageConfigurationOverridesNode.properties[s]=t}else{this.defaultValues[s]=c[s];const t=this.configurationProperties[s];t&&(this.updatePropertyDefaultValue(s,t),this.updateSchema(s,t))}this.registerOverrideIdentifiers(d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}deregisterDefaultConfigurations(E){const I=[];for(const d of E)for(const c in d)if(I.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const s=this.configurationProperties[c];s&&(this.updatePropertyDefaultValue(c,s),this.updateSchema(c,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const I of E)this.overrideIdentifiers.add(I);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,I=!0,d,c=3){var s;c=k.isUndefinedOrNull(E.scope)?c:E.scope;let t=[],r=E.properties;if(r)for(let a in r){if(I&&f(a)){delete r[a];continue}const u=r[a];if(this.updatePropertyDefaultValue(a,u),e.OVERRIDE_PROPERTY_PATTERN.test(a)?u.scope=void 0:(u.scope=k.isUndefinedOrNull(u.scope)?c:u.scope,u.restricted=k.isUndefinedOrNull(u.restricted)?!!((s=d==null?void 0:d.restrictedConfigurations)===null||s===void 0?void 0:s.includes(a)):u.restricted),r[a].hasOwnProperty("included")&&!r[a].included){this.excludedConfigurationProperties[a]=r[a],delete r[a];continue}else this.configurationProperties[a]=r[a];!r[a].deprecationMessage&&r[a].markdownDeprecationMessage&&(r[a].deprecationMessage=r[a].markdownDeprecationMessage),t.push(a)}let i=E.allOf;if(i)for(let a of i)t.push(...this.validateAndRegisterProperties(a,I,d,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const I=d=>{let c=d.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let s=d.allOf;s&&s.forEach(I)};I(E)}updateSchema(E,I){switch(e.allSettings.properties[E]=I,I.scope){case 1:e.applicationSettings.properties[E]=I;break;case 2:e.machineSettings.properties[E]=I;break;case 6:e.machineOverridableSettings.properties[E]=I;break;case 3:e.windowSettings.properties[E]=I;break;case 4:e.resourceSettings.properties[E]=I;break;case 5:e.resourceSettings.properties[E]=I,this.resourceLanguageSettingsSchema.properties[E]=I;break}}removeFromSchema(E,I){switch(delete e.allSettings.properties[E],I.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const I=`[${E}]`,d={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(I,d),e.allSettings.properties[I]=d,e.applicationSettings.properties[I]=d,e.machineSettings.properties[I]=d,e.machineOverridableSettings.properties[I]=d,e.windowSettings.properties[I]=d,e.resourceSettings.properties[I]=d}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,I){let d=this.defaultValues[E];k.isUndefined(d)&&(d=I.default),k.isUndefined(d)&&(d=h(I.type)),I.default=d}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function m(P){return P.substring(1,P.length-1)}e.overrideIdentifierFromKey=m;function h(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const b=new S;L.Registry.add(e.Extensions.Configuration,b);function f(P){return P.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(P)?v.localize(5,null,P):b.getConfigurationProperties()[P]!==void 0?v.localize(6,null,P):null:v.localize(4,null)}e.validateProperty=f;function C(){const P=[],E=b.getConfigurationProperties();for(const I of Object.keys(E))P.push([I,E[I].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.getScopes=C}),define(Z[23],ee([0,1,26,16,5,31,4,37]),function(G,e,v,R,L,k,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=O.createDecorator("configurationService");function y(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationOverrides=y;var S;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(S=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function m(r,i){const a=i?r?i.keys.filter(U=>r.keys.indexOf(U)===-1):[...i.keys]:[],u=r?i?r.keys.filter(U=>i.keys.indexOf(U)===-1):[...r.keys]:[],o=[];if(i&&r){for(const U of r.keys)if(i.keys.indexOf(U)!==-1){const F=E(r.contents,U),j=E(i.contents,U);v.equals(F,j)||o.push(U)}}const l=[],p=U=>{const F={};for(const j of U)for(const z of j.identifiers)F[s(z)]=j;return F},w=i?p(i.overrides):{},g=r?p(r.overrides):{};if(Object.keys(w).length)for(const U of a){const F=w[U];F&&l.push([D.overrideIdentifierFromKey(U),F.keys])}if(Object.keys(g).length)for(const U of u){const F=g[U];F&&l.push([D.overrideIdentifierFromKey(U),F.keys])}if(Object.keys(w).length&&Object.keys(g).length)for(const U of o){const F=g[U],j=w[U];if(F&&j){const z=m({contents:F.contents,keys:F.keys,overrides:[]},{contents:j.contents,keys:j.keys,overrides:[]});l.push([D.overrideIdentifierFromKey(U),[...z.added,...z.removed,...z.updated]])}}return{added:a,removed:u,updated:o,overrides:l}}e.compare=m;function h(r,i){const a=[];for(const u of Object.keys(r))if(D.OVERRIDE_PROPERTY_PATTERN.test(u)){const o={};for(const l in r[u])o[l]=r[u][l];a.push({identifiers:[D.overrideIdentifierFromKey(u).trim()],keys:Object.keys(o),contents:b(o,i)})}return a}e.toOverrides=h;function b(r,i){const a=Object.create(null);for(let u in r)f(a,u,r[u],i);return a}e.toValuesTree=b;function f(r,i,a,u){const o=i.split("."),l=o.pop();let p=r;for(let w=0;w<o.length;w++){let g=o[w],U=p[g];switch(typeof U){case"undefined":U=p[g]=Object.create(null);break;case"object":break;default:u(`Ignoring ${i} as ${o.slice(0,w+1).join(".")} is ${JSON.stringify(U)}`);return}p=U}if(typeof p=="object"&&p!==null)try{p[l]=a}catch(w){u(`Ignoring ${i} as ${o.join(".")} is ${JSON.stringify(p)}`)}else u(`Ignoring ${i} as ${o.join(".")} is ${JSON.stringify(p)}`)}e.addToValueTree=f;function C(r,i){const a=i.split(".");P(r,a)}e.removeFromValueTree=C;function P(r,i){const a=i.shift();if(i.length===0){delete r[a];return}if(Object.keys(r).indexOf(a)!==-1){const u=r[a];typeof u=="object"&&!Array.isArray(u)&&(P(u,i),Object.keys(u).length===0&&delete r[a])}}function E(r,i,a){function u(p,w){let g=p;for(const U of w){if(typeof g!="object"||g===null)return;g=g[U]}return g}const o=i.split("."),l=u(r,o);return typeof l=="undefined"?a:l}e.getConfigurationValue=E;function I(r,i,a){Object.keys(i).forEach(u=>{u!=="__proto__"&&(u in r?R.isObject(r[u])&&R.isObject(i[u])?I(r[u],i[u],a):a&&(r[u]=i[u]):r[u]=i[u])})}e.merge=I;function d(){const r=k.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=d;function c(){const r=Object.create(null),i=k.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let a in i){let u=i[a].default;f(r,a,u,o=>console.error(`Conflict in default settings: ${o}`))}return r}e.getDefaultValues=c;function s(r){return`[${r}]`}e.keyFromOverrideIdentifier=s;function t(r,i,a){const u=r.inspect(i),o=r.inspect(a);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:u.defaultValue}e.getMigratedSettingValue=t}),define(Z[164],ee([0,1,32,38,19,16,26,5,37,23,31,2,3]),function(G,e,v,R,L,k,O,D,y,S,n,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(t={},r=[],i=[]){this._contents=t,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?S.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,r){const i=this.getContentsForOverrideIdentifer(r);return i?t?S.getConfigurationValue(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const a of L.distinct([...Object.keys(this.contents),...Object.keys(r)])){let u=this.contents[a],o=r[a];o&&(typeof u=="object"&&typeof o=="object"?(u=O.deepClone(u),this.mergeContents(u,o)):u=o),i[a]=u}return new b(i,this.keys,this.overrides)}merge(...t){const r=O.deepClone(this.contents),i=O.deepClone(this.overrides),a=[...this.keys];for(const u of t){this.mergeContents(r,u.contents);for(const o of u.overrides){const[l]=i.filter(p=>L.equals(p.identifiers,o.identifiers));l?this.mergeContents(l.contents,o.contents):i.push(O.deepClone(o))}for(const o of u.keys)a.indexOf(o)===-1&&a.push(o)}return new b(r,a,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const i of Object.keys(r)){if(i in t&&k.isObject(t[i])&&k.isObject(r[i])){this.mergeContents(t[i],r[i]);continue}t[i]=O.deepClone(r[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?O.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),S.addToValueTree(this.contents,t,r,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&S.removeFromValueTree(this.contents,t)}addKey(t){let r=this.keys.length;for(let i=0;i<r;i++)t.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=b;class f extends b{constructor(){const t=S.getDefaultValues(),r=S.getConfigurationKeys(),i=[];for(const a of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(a)&&i.push({identifiers:[y.overrideIdentifierFromKey(a).trim()],keys:Object.keys(t[a]),contents:S.toValuesTree(t[a],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,r,i)}}e.DefaultConfigurationModel=f;class C{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!k.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:i,keys:a,overrides:u,restricted:o}=this.doParseRaw(t,r);this._configurationModel=new b(i,a,u),this._restrictedConfigurations=o||[]}doParseContent(t){let r={},i=null,a=[],u=[],o=[];function l(w){Array.isArray(a)?a.push(w):i&&(a[i]=w)}let p={onObjectBegin:()=>{let w={};l(w),u.push(a),a=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{a=u.pop()},onArrayBegin:()=>{let w=[];l(w),u.push(a),a=w,i=null},onArrayEnd:()=>{a=u.pop()},onLiteralValue:l,onError:(w,g,U)=>{o.push({error:w,offset:g,length:U})}};if(t)try{v.visit(t,p),r=a[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return r}doParseRaw(t,r){const i=n.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,i,!0,r);t=a.raw;const u=S.toValuesTree(t,p=>console.error(`Conflict in settings file ${this._name}: ${p}`)),o=Object.keys(t),l=S.toOverrides(t,p=>console.error(`Conflict in settings file ${this._name}: ${p}`));return{contents:u,keys:o,overrides:l,restricted:a.restricted}}filter(t,r,i,a){if(!(a==null?void 0:a.scopes)&&!(a==null?void 0:a.skipRestricted))return{raw:t,restricted:[]};const u={},o=[];for(let l in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(l)&&i){const p=this.filter(t[l],r,!1,a);u[l]=p.raw,o.push(...p.restricted)}else{const p=r[l],w=p?typeof p.scope!="undefined"?p.scope:3:void 0;(p==null?void 0:p.restricted)&&o.push(l),(w===void 0||a.scopes===void 0||a.scopes.includes(w))&&(a.skipRestricted&&(p==null?void 0:p.restricted)||(u[l]=t[l]))}return{raw:u,restricted:o}}}e.ConfigurationModelParser=C;class P extends m.Disposable{constructor(t,r,i,a){super();this.userSettingsResource=t,this.scopes=r,this.fileService=a,this._onDidChange=this._register(new h.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new C(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(h.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=P;class E{constructor(t,r,i=new b,a=new b,u=new R.ResourceMap,o=new b,l=new R.ResourceMap,p=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=a,this._folderConfigurations=u,this._memoryConfiguration=o,this._memoryConfigurationByResource=l,this._freeze=p,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(t)}updateValue(t,r,i={}){let a;i.resource?(a=this._memoryConfigurationByResource.get(i.resource),a||(a=new b,this._memoryConfigurationByResource.set(i.resource,a))):a=this._memoryConfiguration,r===void 0?a.removeValue(t):a.setValue(t,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,i){const a=this.getConsolidateConfigurationModel(r,i),u=this.getFolderConfigurationModelForResource(r.resource,i),o=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,l=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),p=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),w=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),g=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),U=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=u?r.overrideIdentifier?u.freeze().override(r.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,j=r.overrideIdentifier?o.override(r.overrideIdentifier).getValue(t):o.getValue(t),z=a.getValue(t),V=L.distinct(L.flatten(a.overrides.map(q=>q.identifiers))).filter(q=>a.getOverrideValue(t,q)!==void 0);return{defaultValue:l,userValue:p,userLocalValue:w,userRemoteValue:g,workspaceValue:U,workspaceFolderValue:F,memoryValue:j,value:z,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:p!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:w!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:g!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:u==null?void 0:u.freeze().getValue(t),override:r.overrideIdentifier?u==null?void 0:u.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:j!==void 0?{value:o.getValue(t),override:r.overrideIdentifier?o.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const i=r.filter(a=>y.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const u=y.overrideIdentifierFromKey(a),o=this._defaultConfiguration.getKeysForOverrideIdentifier(u),l=t.getKeysForOverrideIdentifier(u),p=[...l.filter(w=>o.indexOf(w)===-1),...o.filter(w=>l.indexOf(w)===-1),...o.filter(w=>!O.equals(this._defaultConfiguration.override(u).getValue(w),t.override(u).getValue(w)))];return[u,p]});return this.updateDefaultConfiguration(t),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:i,removed:a,overrides:u}=S.compare(this.localUserConfiguration,t),o=[...r,...i,...a];return o.length&&this.updateLocalUserConfiguration(t),{keys:o,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:i,removed:a,overrides:u}=S.compare(this.remoteUserConfiguration,t);let o=[...r,...i,...a];return o.length&&this.updateRemoteUserConfiguration(t),{keys:o,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:i,removed:a,overrides:u}=S.compare(this.workspaceConfiguration,t);let o=[...r,...i,...a];return o.length&&this.updateWorkspaceConfiguration(t),{keys:o,overrides:u}}compareAndUpdateFolderConfiguration(t,r){const i=this.folderConfigurations.get(t),{added:a,updated:u,removed:o,overrides:l}=S.compare(i,r);let p=[...a,...u,...o];return(p.length||!i)&&this.updateFolderConfiguration(t,r),{keys:p,overrides:l}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:a,removed:u,overrides:o}=S.compare(r,void 0);return{keys:[...i,...a,...u],overrides:o}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let i=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const a=r.getFolder(t);a&&(i=this.getFolderConsolidatedConfiguration(a.uri)||i);const u=this._memoryConfigurationByResource.get(t);u&&(i=i.merge(u))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(r=i.merge(a),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=i}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const i=r.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:i,overrides:a,keys:u}=this._folderConfigurations.get(r);return t.push([r,{contents:i,overrides:a,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((o,l)=>(o.set(D.URI.revive(l[0]),this.parseConfigurationModel(l[1])),o),new R.ResourceMap);return new E(r,i,new b,a,u,new b,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new b(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=E;function I(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,r=new Map;for(const a of s)a.keys.forEach(u=>t.add(u)),a.overrides.forEach(([u,o])=>{const l=R.getOrSet(r,u,new Set);o.forEach(p=>l.add(p))});const i=[];return r.forEach((a,u)=>i.push([u,[...a.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=I;class d{constructor(t,r,i,a){this.change=t,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=a,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(l=>u.add(l)),t.overrides.forEach(([,l])=>l.forEach(p=>u.add(p))),this.affectedKeys=[...u.values()];const o=new b;this.affectedKeys.forEach(l=>o.setValue(l,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var i;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(i=this.previous)===null||i===void 0?void 0:i.workspace):void 0,u=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!O.equals(a,u)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let i=S.toValuesTree({[r]:!0},()=>{}),a;for(;typeof i=="object"&&(a=Object.keys(i)[0]);){if(t=t[a],!t)return!1;i=i[a]}return!0}}e.ConfigurationChangeEvent=d;class c extends d{constructor(t,r,i,a){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=i,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=c}),define(Z[165],ee([0,1,31,37,2,23,164,3,6,12]),function(G,e,v,R,L,k,O,D,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends L.Disposable{constructor(h,b){super();this.settingsResource=h,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new O.UserSettings(this.settingsResource,void 0,S.extUriBiasedIgnorePathCase,b)),this.configuration=new O.Configuration(new O.DefaultConfigurationModel,new O.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new y.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(R.Extensions.Configuration).onDidUpdateConfiguration(f=>this.onDidDefaultConfigurationChange(f))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const h=await this.userConfiguration.loadConfiguration();this.configuration=new O.Configuration(new O.DefaultConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(h,b){const f=typeof h=="string"?h:void 0,C=k.isConfigurationOverrides(h)?h:k.isConfigurationOverrides(b)?b:{};return this.configuration.getValue(f,C,void 0)}updateValue(h,b,f,C){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const b=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(f,b,1)}onDidDefaultConfigurationChange(h){const b=this.configuration.toData(),f=this.configuration.compareAndUpdateDefaultConfiguration(new O.DefaultConfigurationModel,h);this.trigger(f,b,6)}trigger(h,b,f){const C=new O.ConfigurationChangeEvent(h,{data:b},this.configuration);C.source=f,C.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(C)}getTargetConfiguration(h){switch(h){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(Z[166],ee([0,1,23,15,103]),function(G,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(D,y){this.configurationService=D,this.logService=y}request(D,y){return this.logService.trace("RequestService#request",D.url),D.proxyAuthorization||(D.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),L.request(D,y)}async resolveProxy(D){}};k=de([K(0,v.IConfigurationService),K(1,R.ILogService)],k),e.RequestService=k}),define(Z[39],ee([0,1,120,4,37,31,25]),function(G,e,v,R,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=R.createDecorator("requestService");function D(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}e.isSuccess=D;function y(f){return f.res.statusCode===204}async function S(f){if(!D(f))throw new Error("Server returned "+f.res.statusCode);return y(f)?null:(await O.streamToBuffer(f.stream)).toString()}e.asText=S;async function n(f){if(!D(f))throw new Error("Server returned "+f.res.statusCode);if(y(f))return null;const P=(await O.streamToBuffer(f.stream)).toString();try{return JSON.parse(P)}catch(E){throw E.message+=`:
`+P,E}}e.asJson=n;function m(f){b(f)}e.updateProxyConfigurationsScope=m;let h;function b(f){const C=k.Registry.as(L.Extensions.Configuration);h&&C.deregisterConfigurations([h]),h={id:"http",order:15,title:v.localize(0,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:v.localize(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:v.localize(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:v.localize(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[v.localize(4,null),v.localize(5,null),v.localize(6,null),v.localize(7,null)],default:"override",description:v.localize(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:v.localize(9,null),restricted:!0}}},C.registerConfiguration(h)}b(2)}),define(Z[167],ee([0,1,39,29,10,17]),function(G,e,v,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let O=class{constructor(y,S){this.requestService=y,this.fileService=S}async download(y,S,n=R.CancellationToken.None){if(y.scheme===k.Schemas.file||y.scheme===k.Schemas.vscodeRemote){await this.fileService.copy(y,S);return}const m={type:"GET",url:y.toString()},h=await this.requestService.request(m,n);if(h.res.statusCode===200)await this.fileService.writeFile(S,h.stream);else{const b=await v.asText(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${b}`)}}};O=de([K(0,v.IRequestService),K(1,L.IFileService)],O),e.DownloadService=O}),define(Z[168],ee([0,1,27,10,19,63,39,29,15,12,132,2]),function(G,e,v,R,L,k,O,D,y,S,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let h=class extends m.Disposable{constructor(f,C,P,E){super();this.fileService=f,this.productService=C,this.requestService=P,this.logService=E,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&k.forEach(this.productService.configBasedExtensionTips,({value:I})=>this.allConfigBasedTips.set(I.configPath,I))}getConfigBasedTips(f){return this.getValidConfigBasedTips(f)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(f){const C=[];for(const[P,E]of this.allConfigBasedTips)try{const I=await this.fileService.readFile(S.joinPath(f,P)),d=new Map;k.forEach(E.recommendations,({key:s,value:t})=>{if(L.isNonEmptyArray(t.remotes))for(const r of t.remotes)d.set(r,{extensionId:s,extensionName:t.name,configName:E.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else C.push({extensionId:s,extensionName:t.name,configName:E.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const c=n.getDomainsOfRemotes(I.value.toString(),[...d.keys()]);for(const s of c){const t=d.get(s);t&&C.push(t)}}catch(I){}return C}async fetchWorkspacesTips(){var f,C;if(!((f=this.productService.extensionsGallery)===null||f===void 0?void 0:f.recommendationsUrl))return[];try{const P=await this.requestService.request({type:"GET",url:(C=this.productService.extensionsGallery)===null||C===void 0?void 0:C.recommendationsUrl},D.CancellationToken.None);if(P.res.statusCode!==200)return[];const E=await O.asJson(P);return E?E.workspaceRecommendations||[]:[]}catch(P){return this.logService.error(P),[]}}};h=de([K(0,R.IFileService),K(1,v.IProductService),K(2,O.IRequestService),K(3,y.ILogService)],h),e.ExtensionTipsService=h}),define(Z[44],ee([0,1,30,25]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(k,O,D){let y=D&&D.get("storage.serviceMachineId",0)||null;if(y)return y;try{const n=(await O.readFile(k.serviceMachineIdResource)).value.toString();y=v.isUUID(n)?n:null}catch(S){y=null}if(!y){y=v.generateUuid();try{await O.writeFile(k.serviceMachineIdResource,R.VSBuffer.fromString(y))}catch(S){}}return D&&D.store("storage.serviceMachineId",y,0,1),y}e.getServiceMachineId=L}),define(Z[21],ee([0,1,4,3,2,16,70,6]),function(G,e,v,R,L,k,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const y="__$__targetStorageMarker";e.IStorageService=v.createDecorator("storageService");var S;(function(C){C[C.NONE=0]="NONE",C[C.SHUTDOWN=1]="SHUTDOWN"})(S=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(C){C[C.GLOBAL=0]="GLOBAL",C[C.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var m;(function(C){C[C.USER=0]="USER",C[C.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));class h extends L.Disposable{constructor(P={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super();this.options=P,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=D.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){L.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(P,E){E===y?(P===0?this._globalKeyTargets=void 0:P===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:P})):this._onDidChangeValue.fire({scope:P,key:E,target:this.getKeyTargets(P)[E]})}emitWillSaveState(P){this._onWillSaveState.fire({reason:P})}get(P,E,I){var d;return(d=this.getStorage(E))===null||d===void 0?void 0:d.get(P,I)}getBoolean(P,E,I){var d;return(d=this.getStorage(E))===null||d===void 0?void 0:d.getBoolean(P,I)}getNumber(P,E,I){var d;return(d=this.getStorage(E))===null||d===void 0?void 0:d.getNumber(P,I)}store(P,E,I,d){if(k.isUndefinedOrNull(E)){this.remove(P,I);return}this.withPausedEmitters(()=>{var c;this.updateKeyTarget(P,I,d),(c=this.getStorage(I))===null||c===void 0||c.set(P,E)})}remove(P,E){this.withPausedEmitters(()=>{var I;this.updateKeyTarget(P,E,void 0),(I=this.getStorage(E))===null||I===void 0||I.delete(P)})}withPausedEmitters(P){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{P()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(P,E){const I=[],d=this.getKeyTargets(P);for(const c of Object.keys(d))d[c]===E&&I.push(c);return I}updateKeyTarget(P,E,I){var d,c;const s=this.getKeyTargets(E);typeof I=="number"?s[P]!==I&&(s[P]=I,(d=this.getStorage(E))===null||d===void 0||d.set(y,JSON.stringify(s))):typeof s[P]=="number"&&(delete s[P],(c=this.getStorage(E))===null||c===void 0||c.set(y,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(P){return P===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(P){const E=this.get(y,P);if(E)try{return JSON.parse(E)}catch(I){}return Object.create(null)}isNew(P){return this.getBoolean(e.IS_NEW_KEY,P)===!0}async flush(){var P,E,I,d;this._onWillSaveState.fire({reason:S.NONE}),await D.Promises.settled([(E=(P=this.getStorage(0))===null||P===void 0?void 0:P.whenFlushed())!==null&&E!==void 0?E:Promise.resolve(),(d=(I=this.getStorage(1))===null||I===void 0?void 0:I.whenFlushed())!==null&&d!==void 0?d:Promise.resolve()])}async logStorage(){var P,E,I,d,c,s;const t=(E=(P=this.getStorage(0))===null||P===void 0?void 0:P.items)!==null&&E!==void 0?E:new Map,r=(d=(I=this.getStorage(1))===null||I===void 0?void 0:I.items)!==null&&d!==void 0?d:new Map;return f(t,r,(c=this.getLogDetails(0))!==null&&c!==void 0?c:"",(s=this.getLogDetails(1))!==null&&s!==void 0?s:"")}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends h{constructor(){super();this.globalStorage=this._register(new O.Storage(new O.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new O.Storage(new O.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(P=>this.emitDidChangeValue(1,P))),this._register(this.globalStorage.onDidChangeStorage(P=>this.emitDidChangeValue(0,P)))}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(P){}}e.InMemoryStorageService=b;async function f(C,P,E,I){const d=u=>{try{return JSON.parse(u)}catch(o){return u}},c=new Map,s=new Map;C.forEach((u,o)=>{c.set(o,u),s.set(o,d(u))});const t=new Map,r=new Map;P.forEach((u,o)=>{t.set(o,u),r.set(o,d(u))}),console.group(`Storage: Global (path: ${E})`);let i=[];c.forEach((u,o)=>{i.push({key:o,value:u})}),console.table(i),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${I})`);let a=[];t.forEach((u,o)=>{a.push({key:o,value:u})}),console.table(a),console.groupEnd(),console.log(r)}e.logStorage=f}),define(Z[169],ee([0,1,3,2,28,33,21,16]),function(G,e,v,R,L,k,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let y=class extends R.Disposable{constructor(m){super();this._onDidChangeEnablement=new v.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new S(m)),this._register(this.storageManger.onDidChange(h=>this._onDidChangeEnablement.fire({extensions:h,source:"storage"})))}async enableExtension(m,h){return this._removeFromDisabledExtensions(m)?(this._onDidChangeEnablement.fire({extensions:[m],source:h}),!0):!1}async disableExtension(m,h){return this._addToDisabledExtensions(m)?(this._onDidChangeEnablement.fire({extensions:[m],source:h}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(m){let h=this.getDisabledExtensions();return h.every(b=>!k.areSameExtensions(b,m))?(h.push(m),this._setDisabledExtensions(h),!0):!1}_removeFromDisabledExtensions(m){let h=this.getDisabledExtensions();for(let b=0;b<h.length;b++){const f=h[b];if(k.areSameExtensions(f,m))return h.splice(b,1),this._setDisabledExtensions(h),!0}return!1}_setDisabledExtensions(m){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,m)}_getExtensions(m){return this.storageManger.get(m,0)}_setExtensions(m,h){this.storageManger.set(m,h,0)}};y=de([K(0,O.IStorageService)],y),e.GlobalExtensionEnablementService=y;class S extends R.Disposable{constructor(m){super();this.storageService=m,this.storage=Object.create(null),this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this._register(m.onDidChangeValue(h=>this.onDidStorageChange(h)))}get(m,h){let b;return h===0?(D.isUndefinedOrNull(this.storage[m])&&(this.storage[m]=this._get(m,h)),b=this.storage[m]):b=this._get(m,h),JSON.parse(b)}set(m,h,b){let f=JSON.stringify(h.map(({id:P,uuid:E})=>({id:P,uuid:E})));this._get(m,b)!==f&&(b===0&&(h.length?this.storage[m]=f:delete this.storage[m]),this._set(m,h.length?f:void 0,b))}onDidStorageChange(m){if(m.scope===0&&!D.isUndefinedOrNull(this.storage[m.key])&&this._get(m.key,m.scope)!==this.storage[m.key]){const b=this.get(m.key,m.scope);delete this.storage[m.key];const f=this.get(m.key,m.scope),C=b.filter(E=>!f.some(I=>k.areSameExtensions(E,I))),P=f.filter(E=>!b.some(I=>k.areSameExtensions(I,E)));(C.length||P.length)&&this._onDidChange.fire([...C,...P])}}_get(m,h){return this.storageService.get(m,h,"[]")}_set(m,h,b){h?this.storageService.store(m,h,b,1):this.storageService.remove(m,b)}}e.StorageManager=S}),define(Z[170],ee([0,1,3,2]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class L extends R.Disposable{constructor(S,n){super();this.channel=S,this.workspace=n}async getItems(){const S={workspace:this.workspace},n=await this.channel.call("getItems",S);return new Map(n)}updateItems(S){const n={workspace:this.workspace};return S.insert&&(n.insert=Array.from(S.insert.entries())),S.delete&&(n.delete=Array.from(S.delete.values())),this.channel.call("updateItems",n)}}class k extends L{constructor(S){super(S,void 0);this._onDidChangeItemsExternal=this._register(new v.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(S=>this.onDidChangeGlobalStorage(S)))}onDidChangeGlobalStorage(S){(Array.isArray(S.changed)||Array.isArray(S.deleted))&&this._onDidChangeItemsExternal.fire({changed:S.changed?new Map(S.changed):void 0,deleted:S.deleted?new Set(S.deleted):void 0})}async close(){this.dispose()}}class O extends L{constructor(S,n){super(S,n);this.onDidChangeItemsExternal=v.Event.None}async close(){const S={workspace:this.workspace};return this.channel.call("close",S)}}class D extends R.Disposable{constructor(S,n){super();this.channel=S,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new k(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new O(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=D}),define(Z[171],ee([0,1,2,21,70,6,160,170,12]),function(G,e,v,R,L,k,O,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class S extends R.AbstractStorageService{constructor(m,h,b){super();this.mainProcessService=h,this.environmentService=b,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new v.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(m)}createGlobalStorage(){const m=new D.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),h=new L.Storage(m.globalStorage);return this._register(h.onDidChangeStorage(b=>this.emitDidChangeValue(0,b))),h}createWorkspaceStorage(m){const h=new D.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),m);if(h.workspaceStorage){const b=new L.Storage(h.workspaceStorage);return this.workspaceStorageDisposable.value=b.onDidChangeStorage(f=>this.emitDidChangeValue(1,f)),this.workspaceStorageId=m==null?void 0:m.id,b}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){var m,h;O.mark("code/willInitStorage");try{await k.Promises.settled([this.globalStorage.init(),(h=(m=this.workspaceStorage)===null||m===void 0?void 0:m.init())!==null&&h!==void 0?h:Promise.resolve()])}finally{O.mark("code/didInitStorage")}}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${y.joinPath(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){var m,h;this.stopFlushWhenIdle(),this.emitWillSaveState(R.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.globalStorage.close(),(h=(m=this.workspaceStorage)===null||m===void 0?void 0:m.close())!==null&&h!==void 0?h:Promise.resolve()])}async migrate(m){var h;const b=this.workspaceStorage,f=(h=b==null?void 0:b.items)!==null&&h!==void 0?h:new Map;b&&(await b.close(),b.dispose()),this.workspaceStorage=this.createWorkspaceStorage(m),await this.workspaceStorage.init();for(const[C,P]of f)this.workspaceStorage.set(C,P)}}e.NativeStorageService=S}),define(Z[172],ee([0,1,7,34,30,5]),function(G,e,v,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(S){if(v.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}async function D(S,n,m,h,b,f,C,P,E,I){const d=Object.create(null);d["common.machineId"]=C,d.sessionID=L.generateUuid()+Date.now(),d.commitHash=b,d.version=f,d["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=v.PlatformToString(v.platform),d["common.nodePlatform"]=R.platform,d["common.nodeArch"]=h,d["common.product"]=I||"desktop";const c=y(P||[]);c&&(d["common.msftInternal"]=c);let s=0;const t=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),v.isLinuxSnap&&(d["common.snap"]="true");const r=O(m);r&&(d["common.platformDetail"]=r);try{const i=await S.readFile(k.URI.file(E));d["common.source"]=i.value.toString().slice(0,30)}catch(i){}return d}e.resolveCommonProperties=D;function y(S){const n=R.env.USERDNSDOMAIN;if(!n)return!1;const m=n.toLowerCase();return S.some(h=>m===h)}e.verifyMicrosoftInternalDomain=y}),define(Z[24],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=v.createDecorator("telemetryService"),e.ICustomEndpointTelemetryService=v.createDecorator("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[173],ee([0,1,35,95,72,8,32,98,27,7,5,24,53,17,10,18]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function P(s,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],i=new Map,a=new Map,u=2e4;function o(w,g,U,F){const j=g.substring(w.length+1);return new Promise(async z=>{var V,q,$;let H;try{H=await C.Promises.readdir(g,{withFileTypes:!0})}catch(T){z();return}if(F.count>=u){F.count+=H.length,F.maxReached=!0,z();return}let X=H.length;if(X===0){z();return}let _=H;F.count+H.length>u&&(F.maxReached=!0,X=u-F.count,_=H.slice(0,X)),F.count+=H.length;for(const T of _)if(T.isDirectory()){if(U.includes(T.name)||await o(w,k.join(g,T.name),U,F),--X==0){z();return}}else{const A=T.name.lastIndexOf(".");if(A>=0){const M=T.name.substring(A+1);M&&i.set(M,((V=i.get(M))!==null&&V!==void 0?V:0)+1)}for(const M of r)((q=M.relativePathPattern)===null||q===void 0?void 0:q.test(j))!==!1&&M.filePattern.test(T.name)&&a.set(M.tag,(($=a.get(M.tag))!==null&&$!==void 0?$:0)+1);if(--X==0){z();return}}})}const l={count:0,maxReached:!1};await o(s,s,t,l);const p=await d(s);return{configFiles:E(a),fileTypes:E(i),fileCount:l.count,maxFilesReached:l.maxReached,launchConfigFiles:p}}e.collectWorkspaceStats=P;function E(s){return[...h.Iterable.map(s.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function I(){const s={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(R.virtualMachineHint.value()*100)}%`},t=v.cpus();return t&&t.length>0&&(s.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),s}e.getMachineInfo=I;async function d(s){try{const t=new Map,r=k.join(s,".vscode","launch.json"),i=await C.Promises.readFile(r),a=[],u=O.parse(i.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if(O.getNodeType(u)==="object"&&u.configurations)for(const o of u.configurations){const l=o.type;l&&(t.has(l)?t.set(l,t.get(l)+1):t.set(l,1))}return E(t)}catch(t){return[]}}e.collectLaunchConfigs=d;let c=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const i=v.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(v.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),S.isWindows||r.push(`Load (avg):       ${v.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(R.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([D.listProcesses(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async i=>{let[a,u]=i,o=this.formatProcessList(t,a);return r.forEach(l=>{if(L.isRemoteDiagnosticError(l))o+=`
${l.errorMessage}`,u+=`
${l.errorMessage}`;else if(o+=`

Remote: ${l.hostName}`,l.processes&&(o+=`
${this.formatProcessList(t,l.processes)}`),l.workspaceMetadata){u+=`
|  Remote: ${l.hostName}`;for(const p of Object.keys(l.workspaceMetadata)){const w=l.workspaceMetadata[p];let g=`${w.fileCount} files`;w.maxFilesReached&&(g=`more than ${g}`),u+=`|    Folder (${p}): ${g}`,u+=this.formatWorkspaceStats(w)}}}),{processInfo:o,workspaceInfo:u}})}async getSystemInfo(t,r){const{memory:i,vmHint:a,os:u,cpus:o}=I(),l={os:u,memory:i,cpus:o,vmHint:a,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return S.isWindows||(l.load=`${v.loadavg().map(p=>Math.round(p)).join(", ")}`),S.isLinux&&(l.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(l)}async getDiagnostics(t,r){const i=[];return D.listProcesses(t.mainPID).then(async a=>(i.push(""),i.push(this.formatEnvironment(t)),i.push(""),i.push(this.formatProcessList(t,a)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(t))),r.forEach(u=>{if(L.isRemoteDiagnosticError(u))i.push(`
${u.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${u.hostName}`),i.push(this.formatMachineInfo(u.machineInfo)),u.processes&&i.push(this.formatProcessList(t,u.processes)),u.workspaceMetadata)for(const o of Object.keys(u.workspaceMetadata)){const l=u.workspaceMetadata[o];let p=`${l.fileCount} files`;l.maxFilesReached&&(p=`more than ${p}`),i.push(`Folder (${o}): ${p}`),i.push(this.formatWorkspaceStats(l))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(t){const r=[],i=60;let a=0;const u=(w,g)=>{const U=` ${w}(${g})`;a+U.length>i?(r.push(o),o="|                 ",a=o.length):a+=U.length,o+=U};let o="|      File types:";const l=10;let p=t.fileTypes.length>l?l:t.fileTypes.length;for(let w=0;w<p;w++){const g=t.fileTypes[w];u(g.name,g.count)}if(r.push(o),t.configFiles.length>=0&&(o="|      Conf files:",a=0,t.configFiles.forEach(w=>{u(w.name,w.count)}),r.push(o)),t.launchConfigFiles.length>0){let w="|      Launch Configs:";t.launchConfigFiles.forEach(g=>{w+=g.count>1?` ${g.name}(${g.count})`:` ${g.name}`}),r.push(w)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(i=>i.length));return Object.keys(t).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${t[i]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],i=[];return t.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(u=>{const o=n.URI.revive(u);if(o.scheme===b.Schemas.file){const l=o.fsPath;i.push(P(l,["node_modules",".git"]).then(p=>{let w=`${p.fileCount} files`;p.maxFilesReached&&(w=`more than ${w}`),r.push(`|    Folder (${k.basename(l)}): ${w}`),r.push(this.formatWorkspaceStats(p))}).catch(p=>{r.push(`|      Error: Unable to collect workspace stats for folder ${l} (${p.toString()})`)}))}else r.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(t,r){const i=new Map;t.windows.forEach(u=>i.set(u.pid,u.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,i,a,r,0),a.join(`
`)}formatProcessItem(t,r,i,a,u){const o=u===0;let l;o?l=a.pid===t?`${this.productService.applicationName} main`:"remote agent":(l=`${"  ".repeat(u)} ${a.name}`,a.name==="window"&&(l=`${l} (${r.get(a.pid)})`));const p=process.platform==="win32"?a.mem:v.totalmem()*(a.mem/100);i.push(`${a.load.toFixed(0).padStart(5," ")}	${(p/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${l}`),Array.isArray(a.children)&&a.children.forEach(w=>this.formatProcessItem(t,r,i,w,u+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const i=n.URI.revive(r);if(i.scheme!==b.Schemas.file)continue;const a=i.fsPath;try{const u=await P(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:o.name,count:o.count})}),u.launchConfigFiles.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:o.name,count:o.count})}),u.configFiles.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:o.name,count:o.count})})}catch(u){}}}};c=de([K(0,m.ITelemetryService),K(1,y.IProductService)],c),e.DiagnosticsService=c}),define(Z[174],ee([0,1,11,28,33,26,24,39,71,9,29,15,10,5,27,21,44,4,12]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b,f,C,P,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var d;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished"})(d||(d={}));function c(...T){return String(T.reduce((A,M)=>A|M,0))}var s;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:d.None,criteria:[],assetTypes:[]};class u{constructor(A=a){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,M=this.state.pageSize){return new u(Object.assign(Object.assign({},this.state),{pageNumber:A,pageSize:M}))}withFilter(A,...M){const N=[...this.state.criteria,...M.length?M.map(B=>({filterType:A,value:B})):[{filterType:A}]];return new u(Object.assign(Object.assign({},this.state),{criteria:N}))}withSortBy(A){return new u(Object.assign(Object.assign({},this.state),{sortBy:A}))}withSortOrder(A){return new u(Object.assign(Object.assign({},this.state),{sortOrder:A}))}withFlags(...A){return new u(Object.assign(Object.assign({},this.state),{flags:A.reduce((M,N)=>M|N,0)}))}withAssetTypes(...A){return new u(Object.assign(Object.assign({},this.state),{assetTypes:A}))}get raw(){const{criteria:A,pageNumber:M,pageSize:N,sortBy:B,sortOrder:W,flags:Q,assetTypes:J}=this.state;return{filters:[{criteria:A,pageNumber:M,pageSize:N,sortBy:B,sortOrder:W}],assetTypes:J,flags:Q}}get searchText(){const A=this.state.criteria.filter(M=>M.filterType===s.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function o(T,A){const M=(T||[]).filter(N=>N.statisticName===A)[0];return M?M.value:0}function l(T){const A="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(N=>N.assetType.indexOf(A)===0).reduce((N,B)=>{const W=U(T,B.assetType);return W&&N.push([B.assetType.substring(A.length),W]),N},[])}function p(T){if(T.properties){const A=T.properties.filter(B=>B.key===t.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),N=A.filter(B=>M.test(B.value))[0];return N?{uri:N.value,fallbackUri:N.value}:null}return U(T,t.Repository)}function w(T){return{uri:`${T.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${T.fallbackAssetUri}/${t.VSIX}`}}function g(T){const A=U(T,t.Icon);if(A)return A;const M=R.DefaultIconPath;return{uri:M,fallbackUri:M}}function U(T,A){return T.files.filter(N=>N.assetType===A)[0]?{uri:`${T.assetUri}/${A}`,fallbackUri:`${T.fallbackAssetUri}/${A}`}:null}function F(T,A){const M=T.properties?T.properties.filter(B=>B.key===A):[],N=M.length>0&&M[0].value;return N?N.split(",").map(B=>L.adoptToGalleryExtensionId(B)):[]}function j(T){const A=T.properties?T.properties.filter(M=>M.key===r.Engine):[];return A.length>0&&A[0].value||""}function z(T){const A=T.properties?T.properties.filter(N=>N.key===r.LocalizedLanguages):[],M=A.length>0&&A[0].value||"";return M?M.split(","):[]}function V(T){return T.indexOf("preview")!==-1}function q(T){const A=T.properties?T.properties.find(M=>M.key===r.WebExtension):void 0;return!!A&&A.value==="true"}function $(T){return T.files.some(A=>A.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?I.joinPath(b.URI.parse(T.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function H(T,A,M,N,B){const W={manifest:U(A,t.Manifest),readme:U(A,t.Details),changelog:U(A,t.Changelog),license:U(A,t.License),repository:p(A),download:w(A),icon:g(A),coreTranslations:l(A)};return{identifier:{id:L.getGalleryExtensionId(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:A.version,date:A.lastUpdated,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,description:T.shortDescription||"",installCount:o(T.statistics,"install"),rating:o(T.statistics,"averagerating"),ratingCount:o(T.statistics,"ratingcount"),assetUri:b.URI.parse(A.assetUri),webResource:$(A),assetTypes:A.files.map(({assetType:Q})=>Q),assets:W,properties:{dependencies:F(A,r.Dependency),extensionPack:F(A,r.ExtensionPack),engine:j(A),localizedLanguages:z(A),webExtension:q(A)},telemetryData:{index:(N.pageNumber-1)*N.pageSize+M,querySource:B},preview:V(T.flags)}}let X=class{constructor(A,M,N,B,W,Q,J){this.requestService=A,this.logService=M,this.environmentService=N,this.telemetryService=B,this.fileService=W,this.productService=Q;const ie=Q.extensionsGallery;this.extensionsGalleryUrl=ie&&ie.serviceUrl,this.extensionsControlUrl=ie&&ie.controlUrl,this.commonHeadersPromise=_(Q.version,this.environmentService,this.fileService,J)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,M){const N=[];let{total:B,firstPage:W,getPage:Q}=await this.query({names:A,pageSize:A.length},M);N.push(...W);for(let J=1;N.length<B&&(W=await Q(J,M),W.length);J++)N.push(...W);return N}async getCompatibleExtension(A,M){const N=await this.getCompatibleExtensionByEngine(A,M);return(N==null?void 0:N.properties.webExtension)?N.webResource?N:null:N}async getCompatibleExtensionByEngine(A,M){const N=R.isIExtensionIdentifier(A)?null:A;if(N&&N.properties.engine&&y.isEngineValid(N.properties.engine,this.productService.version,this.productService.date))return N;const{id:B,uuid:W}=N?N.identifier:A;let Q=new u().withFlags(d.IncludeAssetUri,d.IncludeStatistics,d.IncludeFiles,d.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");W?Q=Q.withFilter(s.ExtensionId,W):Q=Q.withFilter(s.ExtensionName,B);const{galleryExtensions:J}=await this.queryGallery(Q,n.CancellationToken.None),[ie]=J;if(!ie||!ie.versions.length)return null;if(M){const ce=ie.versions.filter(le=>le.version===M)[0];if(ce){const le=H(ie,ce,0,Q);if(le.properties.engine&&y.isEngineValid(le.properties.engine,this.productService.version,this.productService.date))return le}return null}const ne=await this.getLastValidExtensionVersion(ie,ie.versions);return ne?H(ie,ne,0,Q):null}async query(A,M){const N=n.CancellationToken.isCancellationToken(A)?{}:A,B=n.CancellationToken.isCancellationToken(A)?A:M;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let W=N.text||"";const Q=k.getOrDefault(N,ve=>ve.pageSize,50);let J=new u().withFlags(d.IncludeLatestVersionOnly,d.IncludeAssetUri,d.IncludeStatistics,d.IncludeFiles,d.IncludeVersionProperties).withPage(1,Q).withFilter(s.Target,"Microsoft.VisualStudio.Code");W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,pe,Ce)=>(J=J.withFilter(s.Category,Ce||pe),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,pe,Ce)=>(J=J.withFilter(s.Tag,Ce||pe),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(J=J.withFilter(s.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),J=J.withFilter(s.SearchText,W)),J=J.withSortBy(0)):N.ids?J=J.withFilter(s.ExtensionId,...N.ids):N.names?J=J.withFilter(s.ExtensionName,...N.names):J=J.withSortBy(4),typeof N.sortBy=="number"&&(J=J.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(J=J.withSortOrder(N.sortOrder));const{galleryExtensions:ie,total:ne}=await this.queryGallery(J,B),ce=ie.map((ve,pe)=>H(ve,ve.versions[0],pe,J,N.source)),le=async(ve,pe)=>{if(pe.isCancellationRequested)throw v.canceled();const Ce=J.withPage(ve+1),{galleryExtensions:Ae}=await this.queryGallery(Ce,pe);return Ae.map((Me,Oe)=>H(Me,Me.versions[0],Oe,Ce,N.source))};return{firstPage:ce,total:ne,pageSize:J.pageSize,getPage:le}}async queryGallery(A,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,d.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,c(d.Unpublished));const N=await this.commonHeadersPromise,B=JSON.stringify(A.raw),W=Object.assign(Object.assign({},N),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(B.length)}),Q=new Date().getTime();let J,ie,ne=0;try{if(J=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:B,headers:W},M),J.res.statusCode&&J.res.statusCode>=400&&J.res.statusCode<500)return{galleryExtensions:[],total:ne};const ce=await D.asJson(J);if(ce){const le=ce.results[0],ve=le.extensions,pe=le.resultMetadata&&le.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return ne=pe&&pe.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:ve,total:ne}}return{galleryExtensions:[],total:ne}}catch(ce){throw ie=ce,ce}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},A.telemetryData),{requestBodySize:String(B.length),duration:new Date().getTime()-Q,success:!!J&&D.isSuccess(J),responseBodySize:J==null?void 0:J.res.headers["Content-Length"],statusCode:J?String(J.res.statusCode):void 0,errorCode:ie?v.isPromiseCanceledError(ie)?"canceled":v.getErrorMessage(ie).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ne)}))}}async reportStatistic(A,M,N,B){if(!this.isEnabled())return;const W=await this.commonHeadersPromise,Q=Object.assign(Object.assign({},W),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${A}/extensions/${M}/${N}/stats?statType=${B}`),headers:Q},n.CancellationToken.None)}catch(J){}}async download(A,M,N){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const B=L.getGalleryExtensionTelemetryData(A),W=new Date().getTime(),Q=ce=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},B),{duration:ce})),J=N===1?"install":N===2?"update":"",ie=J?{uri:`${A.assets.download.uri}&${J}=true`,fallbackUri:`${A.assets.download.fallbackUri}?${J}=true`}:A.assets.download,ne=await this.getAsset(ie);await this.fileService.writeFile(M,ne.stream),Q(new Date().getTime()-W)}async getReadme(A,M){if(A.assets.readme){const N=await this.getAsset(A.assets.readme,{},M);return await D.asText(N)||""}return""}async getManifest(A,M){if(A.assets.manifest){const N=await this.getAsset(A.assets.manifest,{},M),B=await D.asText(N);return B?JSON.parse(B):null}return null}async getCoreTranslation(A,M){const N=A.assets.coreTranslations.filter(B=>B[0]===M.toUpperCase())[0];if(N){const B=await this.getAsset(N[1]),W=await D.asText(B);return W?JSON.parse(W):null}return null}async getChangelog(A,M){if(A.assets.changelog){const N=await this.getAsset(A.assets.changelog,{},M);return await D.asText(N)||""}return""}async getAllVersions(A,M){let N=new u().withFlags(d.IncludeVersions,d.IncludeFiles,d.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?N=N.withFilter(s.ExtensionId,A.identifier.uuid):N=N.withFilter(s.ExtensionName,A.identifier.id);const B=[],{galleryExtensions:W}=await this.queryGallery(N,n.CancellationToken.None);return W.length&&(M?await Promise.all(W[0].versions.map(async Q=>{let J;try{J=await this.getEngine(Q)}catch(ie){}J&&y.isEngineValid(J,this.productService.version,this.productService.date)&&B.push({version:Q.version,date:Q.lastUpdated})})):B.push(...W[0].versions.map(Q=>({version:Q.version,date:Q.lastUpdated})))),B}async getAsset(A,M={},N=n.CancellationToken.None){const B=await this.commonHeadersPromise,W={type:"GET"},Q=Object.assign(Object.assign({},B),M.headers||{});M=Object.assign(Object.assign(Object.assign({},M),W),{headers:Q});const J=A.uri,ie=A.fallbackUri,ne=Object.assign(Object.assign({},M),{url:J});try{const ce=await this.requestService.request(ne,N);if(ce.res.statusCode===200)return ce;const le=await D.asText(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${le}`)}catch(ce){if(v.isPromiseCanceledError(ce))throw ce;const le=v.getErrorMessage(ce);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:J,message:le});const ve=Object.assign(Object.assign({},M),{url:ie});return this.requestService.request(ve,N)}}async getLastValidExtensionVersion(A,M){const N=this.getLastValidExtensionVersionFromProperties(A,M);return N||this.getLastValidExtensionVersionRecursively(A,M)}getLastValidExtensionVersionFromProperties(A,M){for(const N of M){const B=j(N);if(!B)return null;if(y.isEngineValid(B,this.productService.version,this.productService.date))return N}return null}async getEngine(A){const M=j(A);if(M)return M;const N=U(A,t.Manifest);if(!N)throw new Error("Manifest was not found");const B={"Accept-Encoding":"gzip"},W=await this.getAsset(N,{headers:B}),Q=await D.asJson(W);if(Q)return Q.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(A,M){if(!M.length)return null;const N=M[0],B=await this.getEngine(N);return y.isEngineValid(B,this.productService.version,this.productService.date)?Object.assign(Object.assign({},N),{properties:[...N.properties||[],{key:r.Engine,value:B}]}):this.getLastValidExtensionVersionRecursively(A,M.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await D.asJson(A),N=new Map;if(M)for(const B of M.malicious){const W=N.get(B)||{id:{id:B},malicious:!0,slow:!1};W.malicious=!0,N.set(B,W)}return[...N.values()]}};X=de([K(0,D.IRequestService),K(1,m.ILogService),K(2,S.IEnvironmentService),K(3,O.ITelemetryService),K(4,h.IFileService),K(5,f.IProductService),K(6,E.optional(C.IStorageService))],X),e.ExtensionGalleryService=X;async function _(T,A,M,N){const B={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T}`},W=await P.getServiceMachineId(A,M,N);return B["X-Market-User-Id"]=W,B}e.resolveMarketplaceHeaders=_}),define(Z[175],ee([0,1,5,8,27,9,34,10,7,19,28,63,39,15,168,6,24,74,111,21,3,58]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b,f,C,P,E,I,d,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let i=class extends f.ExtensionTipsService{constructor(u,o,l,p,w,g,U,F,j,z){super(U,F,j,z);this.environmentService=u,this.telemetryService=o,this.extensionManagementService=l,this.storageService=p,this.nativeHostService=w,this.extensionRecommendationNotificationService=g,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,F.exeBasedExtensionTips&&m.forEach(F.exeBasedExtensionTips,({key:V,value:q})=>{const $=[],H=[],X=[];m.forEach(q.recommendations,({key:_,value:T})=>{T.important?q.important?$.push({extensionId:_,extensionName:T.name,isExtensionPack:!!T.isExtensionPack}):H.push({extensionId:_,extensionName:T.name,isExtensionPack:!!T.isExtensionPack}):X.push({extensionId:_,extensionName:T.name,isExtensionPack:!!T.isExtensionPack})}),$.length&&this.highImportanceExecutableTips.set(V,{exeFriendlyName:q.friendlyName,windowsPath:q.windowsPath,recommendations:$}),H.length&&this.mediumImportanceExecutableTips.set(V,{exeFriendlyName:q.friendlyName,windowsPath:q.windowsPath,recommendations:H}),X.length&&this.allOtherExecutableTips.set(V,{exeFriendlyName:q.friendlyName,windowsPath:q.windowsPath,recommendations:X})}),C.timeout(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...u,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(u,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,l)}groupImportantTipsByExe(u,o){const l=new Map;u.forEach(F=>l.set(F.extensionId.toLowerCase(),F));const{installed:p,uninstalled:w}=this.groupByInstalled([...l.keys()],o);for(const F of p){const j=l.get(F);j&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:F,exeName:R.basename(j.windowsPath)})}for(const F of w){const j=l.get(F);j&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:F,exeName:R.basename(j.windowsPath)})}const g=this.getPromptedExecutableTips(),U=new Map;for(const F of w){const j=l.get(F);if(j&&(!g[j.exeName]||!g[j.exeName].includes(j.extensionId))){let z=U.get(j.exeName);z||(z=[],U.set(j.exeName,z)),z.push(j)}}return U}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[u,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(u);break;case"incompatibleWindow":const p=c.Event.once(c.Event.latch(c.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(p(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const w=this._register(C.disposableTimeout(()=>{w.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const u=this.getLastPromptedMediumExeTime(),o=Date.now()-u,l=7*24*60*60*1e3;if(o<l){const g=this._register(C.disposableTimeout(()=>{g.dispose(),this.promptMediumImportanceExeBasedTip()},l-o));return}const[p,w]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(w).then(g=>{switch(g){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(p),this.addToRecommendedExecutables(w[0].exeName,w);const U=this._register(C.disposableTimeout(()=>{U.dispose(),this.promptMediumImportanceExeBasedTip()},l));break;case"ignored":this.mediumImportanceTipsByExe.delete(p),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const F=c.Event.once(c.Event.latch(c.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(F(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const j=this._register(C.disposableTimeout(()=>{j.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(u){const o=u.map(({extensionId:p})=>p.toLowerCase()),l=I.localize(0,null,u[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,l,`@exe:"${u[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let u=this.storageService.getNumber(r,0);return u||(u=Date.now(),this.updateLastPromptedMediumExeTime(u)),u}updateLastPromptedMediumExeTime(u){this.storageService.store(r,u,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(u,o){const l=this.getPromptedExecutableTips();l[u]=o.map(({extensionId:p})=>p.toLowerCase()),this.storageService.store(t,JSON.stringify(l),0,0)}groupByInstalled(u,o){const l=[],p=[],w=o.reduce((g,U)=>(g.add(U.identifier.id.toLowerCase()),g),new Set);return u.forEach(g=>{w.has(g.toLowerCase())?l.push(g):p.push(g)}),{installed:l,uninstalled:p}}async getValidExecutableBasedExtensionTips(u){const o=[],l=new Map;for(const p of u.keys()){const w=u.get(p);if(!w||!S.isNonEmptyArray(w.recommendations))continue;const g=[];y.isWindows?w.windowsPath&&g.push(w.windowsPath.replace("%USERPROFILE%",O.env.USERPROFILE).replace("%ProgramFiles(x86)%",O.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",O.env.ProgramFiles).replace("%APPDATA%",O.env.APPDATA).replace("%WINDIR%",O.env.WINDIR)):(g.push(R.join("/usr/local/bin",p)),g.push(R.join("/usr/bin",p)),g.push(R.join(this.environmentService.userHome.fsPath,p)));for(const U of g){let F=l.get(U);if(F===void 0&&(F=await this.fileService.exists(v.URI.file(U)),l.set(U,F)),F)for(const{extensionId:j,extensionName:z,isExtensionPack:V}of w.recommendations)o.push({extensionId:j,extensionName:z,isExtensionPack:V,exeName:p,exeFriendlyName:w.exeFriendlyName,windowsPath:w.windowsPath})}}return o}};i=de([K(0,k.INativeEnvironmentService),K(1,P.ITelemetryService),K(2,n.IExtensionManagementService),K(3,d.IStorageService),K(4,s.INativeHostService),K(5,E.IExtensionRecommendationNotificationService),K(6,D.IFileService),K(7,L.IProductService),K(8,h.IRequestService),K(9,b.ILogService)],i),e.ExtensionTipsService=i}),define(Z[81],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(k){this.appender=k}listen(k,O){throw new Error(`Event not found: ${O}`)}call(k,O,{eventName:D,data:y}){return this.appender.log(D,y),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class R{constructor(k){this.channel=k}log(k,O){return this.channel.call("log",{eventName:k,data:O}).then(void 0,D=>`Failed to log telemetry: ${console.warn(D)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=R}),define(Z[82],ee([0,1,51,121,20,4,23,37,2,26,31]),function(G,e,v,R,L,k,O,D,y,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(f,C){this._configurationService=C,this._experimentProperties={},this._disposables=new y.DisposableStore,this._cleanupPatterns=[],this._appender=f.appender,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp(L.escapeRegExpCharacters(P),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(P=>{const E=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!E})}))}setExperimentProperty(f,C){this._experimentProperties[f]=C}setEnabled(f){this._enabled=f}_updateUserOptIn(){var f;const C=(f=this._configurationService)===null||f===void 0?void 0:f.getValue(h);this._userOptIn=C?C.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const f=await this._commonProperties;let C=f.sessionID,P=f["common.instanceId"],E=f["common.machineId"],I=f["common.firstSessionDate"],d=f["common.msftInternal"];return{sessionId:C,instanceId:P,machineId:E,firstSessionDate:I,msftInternal:d}}dispose(){this._disposables.dispose()}publicLog(f,C,P){return this.isOptedIn?this._commonProperties.then(E=>{C=S.mixin(C,E),C=S.mixin(C,this._experimentProperties),C=S.cloneAndChange(C,I=>{if(typeof I=="string")return this._cleanupInfo(I,P)}),this._appender.log(f,C)},E=>{console.error(E)}):Promise.resolve(void 0)}publicLog2(f,C,P){return this.publicLog(f,C,P)}publicLogError(f,C){return this.sendErrorTelemetry?this.publicLog(f,C,!0):Promise.resolve(void 0)}publicLogError2(f,C){return this.publicLogError(f,C)}_cleanupInfo(f,C){let P=f;if(C){const E=[];for(let s of this._cleanupPatterns)for(;;){const t=s.exec(f);if(!t)break;E.push([t.index,s.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(P="";;){const s=d.exec(f);if(!s)break;!I.test(s[0])&&E.every(([t,r])=>s.index<t||s.index>=r)&&(P+=f.substring(c,s.index)+"<REDACTED: user-file-path>",c=d.lastIndex)}c<f.length&&(P+=f.substr(c))}for(let E of this._cleanupPatterns)P=P.replace(E,"");return P}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=de([K(1,k.optional(O.IConfigurationService))],m),e.TelemetryService=m;const h="telemetry";n.Registry.as(D.Extensions.Configuration).registerConfiguration({id:h,order:110,type:"object",title:R.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:v.default.privacyStatementUrl?R.localize(2,null,v.default.privacyStatementUrl):R.localize(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Z[59],ee([0,1,23,26,16,6]),function(G,e,v,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(f,C){return Promise.resolve(void 0)}publicLog2(f,C){return this.publicLog(f,C)}publicLogError(f,C){return Promise.resolve(void 0)}publicLogError2(f,C){return this.publicLogError(f,C)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class O{async publicLog(C,P,E){}async publicLogError(C,P,E){}}e.NullEndpointTelemetryService=O;function D(...f){return{log:(C,P)=>f.forEach(E=>E.log(C,P)),flush:()=>k.Promises.settled(f.map(C=>C.flush()))}}e.combinedAppender=D,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(f,C){return C.onDidChangeConfiguration(P=>{P.source!==6&&f.publicLog2("updateConfiguration",{configurationSource:v.ConfigurationTargetToString(P.source),configurationKeys:h(P.sourceConfig)})})}e.configurationTelemetry=y;function S(f){const C=Object.create(null),P=Object.create(null),E=Object.create(null);m(f,E);for(let I in E){I=I.length>150?I.substr(I.length-149):I;const d=E[I];typeof d=="number"?P[I]=d:typeof d=="boolean"?P[I]=d?1:0:typeof d=="string"?C[I]=d.substring(0,1023):typeof d!="undefined"&&d!==null&&(C[I]=d)}return{properties:C,measurements:P}}e.validateTelemetryData=S;function n(f){if(!f)return"none";let C="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(E=>{f.indexOf(`${E}+`)===0&&(C=E)}),C}e.cleanRemoteAuthority=n;function m(f,C,P=0,E){if(!!f)for(let I of Object.getOwnPropertyNames(f)){const d=f[I],c=E?E+I:I;Array.isArray(d)?C[c]=R.safeStringify(d):d instanceof Date?C[c]=d.toISOString():L.isObject(d)?P<2?m(d,C,P+1,c+"."):C[c]=R.safeStringify(d):C[c]=d}}function h(f){if(!f)return[];const C=[];return b(C,"",f),C}function b(f,C,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(E=>b(f,C?`${C}.${E}`:E,P[E])):f.push(C)}}),define(Z[176],ee([0,1,2,9,15,59]),function(G,e,v,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let O=class extends v.Disposable{constructor(y,S){super();this.logger=this._register(y.createLogger(S.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(y,S){this.logger.trace(`telemetry/${y}`,k.validateTelemetryData(S))}};O=de([K(0,L.ILoggerService),K(1,R.IEnvironmentService)],O),e.TelemetryLogAppender=O}),define(Z[177],ee([0,1,11,26,59]),function(G,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function k(D){const y=await new Promise((n,m)=>{G(["applicationinsights"],n,m)});let S;return y.defaultClient?(S=new y.TelemetryClient(D),S.channel.setUseDiskRetryCaching(!0)):(y.setup(D).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),S=y.defaultClient),D.indexOf("AIF-")===0&&(S.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),S}class O{constructor(y,S,n){this._eventPrefix=y,this._defaultData=S,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(y){if(!!this._aiClient){if(typeof this._aiClient!="string"){y(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=k(this._aiClient)),this._asyncAIClient.then(S=>{y(S)},S=>{v.onUnexpectedError(S),console.error(S)})}}log(y,S){!this._aiClient||(S=R.mixin(S,this._defaultData),S=L.validateTelemetryData(S),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+y,properties:S.properties,measurements:S.measurements})))}flush(){return this._aiClient?new Promise(y=>{this._withAIClient(S=>{S.flush({callback:()=>{this._aiClient=void 0,y(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=O}),define(Z[178],ee([0,1,49,81,17,82,23,24]),function(G,e,v,R,L,k,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let y=class{constructor(n,m){this.configurationService=n,this.telemetryService=m,this.customTelemetryServices=new Map}async getCustomTelemetryService(n){if(!this.customTelemetryServices.has(n.id)){const{machineId:m,sessionId:h}=await this.telemetryService.getTelemetryInfo(),b=Object.create(null);b["common.vscodemachineid"]=m,b["common.vscodesessionid"]=h;const f=[n.id,JSON.stringify(b),n.aiKey],P=new v.Client(L.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:f,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),E=new R.TelemetryAppenderClient(P);this.customTelemetryServices.set(n.id,new k.TelemetryService({appender:E,sendErrorTelemetry:n.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(n.id)}async publicLog(n,m,h){await(await this.getCustomTelemetryService(n)).publicLog(m,h)}async publicLogError(n,m,h){await(await this.getCustomTelemetryService(n)).publicLogError(m,h)}};y=de([K(0,O.IConfigurationService),K(1,D.ITelemetryService)],y),e.CustomEndpointTelemetryService=y}),define(Z[83],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var R;(function(h){h.Shell="terminal.integrated.shell.",h.ShellArgs="terminal.integrated.shellArgs.",h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(R=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var L;(function(h){h.ShellLinux="terminal.integrated.shell.linux",h.ShellMacOs="terminal.integrated.shell.osx",h.ShellWindows="terminal.integrated.shell.windows",h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationShellLinux="terminal.integrated.automationShell.linux",h.AutomationShellMacOs="terminal.integrated.automationShell.osx",h.AutomationShellWindows="terminal.integrated.automationShell.windows",h.ShellArgsLinux="terminal.integrated.shellArgs.linux",h.ShellArgsMacOs="terminal.integrated.shellArgs.osx",h.ShellArgsWindows="terminal.integrated.shellArgs.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.CreationTarget="terminal.integrated.creationTarget",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.EnableBell="terminal.integrated.enableBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.TitleMode="terminal.integrated.titleMode",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover"})(L=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var O;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence"})(O=e.TitleEventSource||(e.TitleEventSource={}));var D;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.Log="log",h.Heartbeat="heartbeat"})(D=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=v.createDecorator("localTerminalService"),e.IPtyService=v.createDecorator("ptyService");var y;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y=e.HeartbeatConstants||(e.HeartbeatConstants={}));var S;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(S=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var n;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(n=e.FlowControlConstants||(e.FlowControlConstants={}));var m;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})(m=e.ProfileSource||(e.ProfileSource={}))}),define(Z[179],ee([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=v.createDecorator("localPtyService")}),define(Z[180],ee([0,1,35,8,34,18,16,26,7]),function(G,e,v,R,L,k,O,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function S(){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(v.release());let h=0;return m&&m.length===4&&(h=parseInt(m[3])),h}e.getWindowsBuildNumber=S;async function n(m,h,b,f=L.env,C=k.Promises.exists){if(R.isAbsolute(m))return await C(m)?m:void 0;if(h===void 0&&(h=L.cwd()),R.dirname(m)!=="."){const d=R.join(h,m);return await C(d)?d:void 0}const E=D.getCaseInsensitive(f,"PATH");if(b===void 0&&O.isString(E)&&(b=E.split(R.delimiter)),b===void 0||b.length===0){const d=R.join(h,m);return await C(d)?d:void 0}for(let d of b){let c;if(R.isAbsolute(d)?c=R.join(d,m):c=R.join(h,d,m),await C(c))return c;if(y.isWindows){let s=c+".com";if(await C(s)||(s=c+".exe",await C(s)))return s}}const I=R.join(h,m);return await C(I)?I:void 0}e.findExecutable=n}),define(Z[181],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(Z[84],ee([0,1,4,2,31,3,181,54]),function(G,e,v,R,L,k,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=v.createDecorator("themeService");var y;(function(P){function E(I){return I&&typeof I=="object"&&typeof I.id=="string"}P.isThemeColor=E})(y=e.ThemeColor||(e.ThemeColor={}));function S(P){return{id:P}}e.themeColorFromId=S;var n;(function(P){function E(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||y.isThemeColor(r.color))}P.isThemeIcon=E;const I=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function d(r){const i=I.exec(r);if(!i)return;let[,a]=i;return{id:a}}P.fromString=d;function c(r,i){let a=r.id;const u=a.lastIndexOf("~");return u!==-1&&(a=a.substring(0,u)),i&&(a=`${a}~${i}`),{id:a}}P.modify=c;function s(r,i){var a,u;return r.id===i.id&&((a=r.color)===null||a===void 0?void 0:a.id)===((u=i.color)===null||u===void 0?void 0:u.id)}P.isEqual=s;function t(r){return{id:r.id}}P.asThemeIcon=t,P.asClassNameArray=D.CSSIcon.asClassNameArray,P.asClassName=D.CSSIcon.asClassName,P.asCSSSelector=D.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function m(P){switch(P){case O.ColorScheme.DARK:return"vs-dark";case O.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=m,e.Extensions={ThemingContribution:"base.contributions.theming"};class h{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new k.Emitter}onColorThemeChange(E){return this.themingParticipants.push(E),this.onThemingParticipantAddedEmitter.fire(E),R.toDisposable(()=>{const I=this.themingParticipants.indexOf(E);this.themingParticipants.splice(I,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new h;L.Registry.add(e.Extensions.ThemingContribution,b);function f(P){return b.onColorThemeChange(P)}e.registerThemingParticipant=f;class C extends R.Disposable{constructor(E){super();this.themeService=E,this.theme=E.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(I=>this.onThemeChange(I)))}onThemeChange(E){this.theme=E,this.updateStyles()}updateStyles(){}getColor(E,I){let d=this.theme.getColor(E);return d&&I&&(d=I(d,this.theme)),d?d.toString():null}}e.Themable=C}),define(Z[182],ee([0,1,37,122,31,54,84]),function(G,e,v,R,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const D={args:{description:R.localize(0,null),type:"array",items:{type:"string"}},overrideName:{description:R.localize(1,null),type:"boolean"},icon:{description:R.localize(2,null),type:"string",enum:Array.from(k.iconRegistry.all,E=>E.id),markdownEnumDescriptions:Array.from(k.iconRegistry.all,E=>`$(${E.id})`)},color:{description:R.localize(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:R.localize(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},y={type:"object",required:["path"],properties:Object.assign({path:{description:R.localize(5,null),type:["string","array"],items:{type:"string"}}},D)},S=R.localize(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=R.localize(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),m=R.localize(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),h={id:"terminal",order:100,title:R.localize(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:R.localize(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:R.localize(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:R.localize(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:R.localize(13,null),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:R.localize(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:R.localize(15,null),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:R.localize(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:S},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:R.localize(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:R.localize(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:R.localize(19,null)}},{type:"string",markdownDescription:R.localize(20,null)}],default:[],markdownDeprecationMessage:m},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:R.localize(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:Object.assign({source:{description:R.localize(22,null),enum:["PowerShell","Git Bash"]}},D)},{type:"null"},y]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:R.localize(23,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},y]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:R.localize(24,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},y]}},["terminal.integrated.useWslProfiles"]:{description:R.localize(25,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:R.localize(26,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:R.localize(27,null),type:"boolean",default:!0}}};function b(){L.Registry.as(v.Extensions.Configuration).registerConfiguration(h),C()}e.registerTerminalPlatformConfiguration=b;let f;function C(E){const I=L.Registry.as(v.Extensions.Configuration);f&&I.deregisterConfigurations([f]);let d,c;if(E){const s=E.profiles.map(t=>({name:t.profileName,description:P(t)}));d=s.map(t=>t.name),c=s.map(t=>t.description)}f={id:"terminal",order:100,title:R.localize(28,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:R.localize(29,null,"`#terminal.integrated.shell.linux#`","`#terminal.integrated.shellArgs.linux#`"),type:["string","null"],default:null,enum:(E==null?void 0:E.os)===3?d:void 0,markdownEnumDescriptions:(E==null?void 0:E.os)===3?c:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:R.localize(30,null,"`#terminal.integrated.shell.osx#`","`#terminal.integrated.shellArgs.osx#`"),type:["string","null"],default:null,enum:(E==null?void 0:E.os)===2?d:void 0,markdownEnumDescriptions:(E==null?void 0:E.os)===2?c:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:R.localize(31,null,"`#terminal.integrated.shell.windows#`","`#terminal.integrated.shellArgs.windows#`"),type:["string","null"],default:null,enum:(E==null?void 0:E.os)===1?d:void 0,markdownEnumDescriptions:(E==null?void 0:E.os)===1?c:void 0}}},I.registerConfiguration(f)}e.registerTerminalDefaultProfileConfiguration=C;function P(E){let I=`$(${O.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:k.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?I+=`
- args: "${E.args}"`:I+=`
- args: [${E.args.length===0?"":E.args.join("','")}]`),E.overrideName!==void 0&&(I+=`
- overrideName: ${E.overrideName}`),E.color&&(I+=`
- color: ${E.color}`),E.env&&(I+=`
- env: ${JSON.stringify(E.env)}`),I}});var et=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],v;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),v={},R("next"),R("throw"),R("return"),v[Symbol.asyncIterator]=function(){return this},v);function R(k){v[k]=G[k]&&function(O){return new Promise(function(D,y){O=G[k](O),L(D,y,O.done,O.value)})}}function L(k,O,D,y){Promise.resolve(y).then(function(S){k({value:S,done:D})},O)}};define(Z[183],ee([0,1,8,97,180,42,18,54,7,84]),function(G,e,v,R,L,k,O,D,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function m(s,t,r,i,a,u,o,l){return a=a||{existsFile:O.SymlinkSupport.existsFile,readFile:O.Promises.readFile},y.isWindows?h(r,a,u,i.getValue("terminal.integrated.useWslProfiles")!==!1,s&&typeof s=="object"?Object.assign({},s):i.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:i.getValue("terminal.integrated.defaultProfile.windows"),l,o):I(a,u,r,s&&typeof s=="object"?Object.assign({},s):i.getValue(y.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:i.getValue(y.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),l,o)}e.detectAvailableProfiles=m;async function h(s,t,r,i,a,u,o,l){const p=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${process.env.windir}\\${p?"Sysnative":"System32"}`;let g=!1;L.getWindowsBuildNumber()>=16299&&(g=!0),await f(o);const U=new Map;s&&(U.set("PowerShell",{source:"PowerShell",icon:D.Codicon.terminalPowershell,isAutoDetected:!0}),U.set("Windows PowerShell",{path:`${w}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:D.Codicon.terminalPowershell,isAutoDetected:!0}),U.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),U.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),U.set("Command Prompt",{path:`${w}\\cmd.exe`,icon:D.Codicon.terminalCmd,isAutoDetected:!0})),d(a,U);const F=await b(U.entries(),u,t,r,l);if(s||!s&&i)try{const j=await P(`${w}\\${g?"wsl":"bash"}.exe`,u);for(const z of j)(!a||!(z.profileName in a))&&F.push(z)}catch(j){r==null||r.info("WSL is not installed, so could not detect WSL profiles")}return F}async function b(s,t,r,i,a){const u=[];for(const[o,l]of s){if(l===null)continue;let p,w,g;if("source"in l){const j=n==null?void 0:n.get(l.source);if(!j)continue;p=j.paths,w=l.args||j.args,l.icon?g=l.icon:j.icon&&(g=j.icon)}else p=Array.isArray(l.path)?l.path:[l.path],w=y.isWindows||Array.isArray(l.args)?l.args:void 0,g=l.icon||void 0;const U=await(a==null?void 0:a(p))||p.slice(),F=await c(o,t,U,r,w,l.env,l.overrideName,l.isAutoDetected,i);F?(F.isAutoDetected=l.isAutoDetected,F.icon=g,F.color=l.color,u.push(F)):i==null||i.trace("profile not validated",o,p)}return u}async function f(s){n&&!s||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:s||await C(),icon:S.ThemeIcon.asThemeIcon(D.Codicon.terminalPowershell)}))}async function C(){var s,t;const r=[];try{for(var i=et(R.enumeratePowerShellInstallations()),a;a=await i.next(),!a.done;){const u=a.value;r.push(u.exePath)}}catch(u){s={error:u}}finally{try{a&&!a.done&&(t=i.return)&&await t.call(i)}finally{if(s)throw s.error}}return r}async function P(s,t){const r=[],i=await new Promise((o,l)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le"},(p,w)=>{if(p)return l("Problem occurred when getting wsl distros");o(w)})});if(!i)return[];const a=new RegExp(/[\r?\n]/),u=i.split(a).filter(o=>o.trim().length>0&&o!=="");for(const o of u){if(o===""||o.startsWith("docker-desktop"))continue;const l=`${o} (WSL)`,p={profileName:l,path:s,args:["-d",`${o}`],isDefault:l===t,icon:E(o)};r.push(p)}return r}function E(s){return s.includes("Ubuntu")?S.ThemeIcon.asThemeIcon(D.Codicon.terminalUbuntu):s.includes("Debian")?S.ThemeIcon.asThemeIcon(D.Codicon.terminalDebian):S.ThemeIcon.asThemeIcon(D.Codicon.terminalLinux)}async function I(s,t,r,i,a,u,o){const l=new Map;if(r){const p=(await s.readFile("/etc/shells")).toString(),w=u||p.split(`
`).filter(U=>U.trim().indexOf("#")!==0&&U.trim().length>0),g=new Map;for(const U of w){let F=v.basename(U),j=g.get(F)||0;j++,j>1&&(F=`${F} (${j})`),g.set(F,j),l.set(F,{path:U,isAutoDetected:!0})}}return d(i,l),await b(l.entries(),a,s,t,o)}function d(s,t){if(!!s)for(const[r,i]of Object.entries(s))i===null||!("path"in i)&&!("source"in i)?t.delete(r):t.set(r,i)}async function c(s,t,r,i,a,u,o,l,p){if(r.length===0)return Promise.resolve(void 0);const w=r.shift();if(w==="")return c(s,t,r,i,a,u,o,l);const g={profileName:s,path:w,args:a,env:u,overrideName:o,isAutoDetected:l,isDefault:s===t};if(v.basename(w)===w){const F=process.env.PATH?process.env.PATH.split(v.delimiter):void 0;return await L.findExecutable(w,void 0,F,void 0,i.existsFile)?g:c(s,t,r,i,a)}return await i.existsFile(v.normalize(w))?g:c(s,t,r,i,a,u,o,l)}}),define(Z[184],ee([0,1,2,15,83,49,17,36,3,78,24,183,23,182]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var f;(function(I){I[I.MaxRestarts=5]="MaxRestarts"})(f||(f={}));let C=0,P=0,E=class extends v.Disposable{constructor(d,c,s,t){super();this._reconnectConstants=d,this._configurationService=c,this._logService=s,this._telemetryService=t,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new y.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new y.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new y.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new y.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new y.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new y.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new y.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new y.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new y.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new y.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new y.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new y.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new y.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new y.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._pendingResolveVariablesRequests=new Map,b.registerTerminalPlatformConfiguration(),this._register(v.toDisposable(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const d=new k.Client(O.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:C,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.GraceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.ShortGraceTime}});this._onPtyHostStart.fire(),D.ProxyChannel.toService(d.getChannel(L.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(d.onDidProcessExit(r=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(r.code),this._isDisposed||(this._restartCount<=f.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const s=d.getChannel(L.TerminalIpcChannels.Log);S.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{S.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const t=D.ProxyChannel.toService(d.getChannel(L.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(r=>this._onProcessData.fire(r))),this._register(t.onProcessExit(r=>this._onProcessExit.fire(r))),this._register(t.onProcessReady(r=>this._onProcessReady.fire(r))),this._register(t.onProcessTitleChanged(r=>this._onProcessTitleChanged.fire(r))),this._register(t.onProcessShellTypeChanged(r=>this._onProcessShellTypeChanged.fire(r))),this._register(t.onProcessOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r))),this._register(t.onProcessResolvedShellLaunchConfig(r=>this._onProcessResolvedShellLaunchConfig.fire(r))),this._register(t.onProcessReplay(r=>this._onProcessReplay.fire(r))),this._register(t.onProcessOrphanQuestion(r=>this._onProcessOrphanQuestion.fire(r))),[d,t]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(d,c,s,t,r,i,a,u,o,l){const p=setTimeout(()=>this._handleUnresponsiveCreateProcess(),L.HeartbeatConstants.CreateProcessTimeout),w=await this._proxy.createProcess(d,c,s,t,r,i,a,u,o,l);return clearTimeout(p),C=Math.max(C,w),w}updateTitle(d,c,s){return this._proxy.updateTitle(d,c,s)}updateIcon(d,c,s){return this._proxy.updateIcon(d,c,s)}attachToProcess(d){return this._proxy.attachToProcess(d)}detachFromProcess(d){return this._proxy.detachFromProcess(d)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(d){return this._proxy.start(d)}shutdown(d,c){return this._proxy.shutdown(d,c)}input(d,c){return this._proxy.input(d,c)}processBinary(d,c){return this._proxy.processBinary(d,c)}resize(d,c,s){return this._proxy.resize(d,c,s)}acknowledgeDataEvent(d,c){return this._proxy.acknowledgeDataEvent(d,c)}getInitialCwd(d){return this._proxy.getInitialCwd(d)}getCwd(d){return this._proxy.getCwd(d)}getLatency(d){return this._proxy.getLatency(d)}orphanQuestionReply(d){return this._proxy.orphanQuestionReply(d)}getDefaultSystemShell(d){return this._proxy.getDefaultSystemShell(d)}async getProfiles(d,c,s=!1){return m.detectAvailableProfiles(d,c,s,this._configurationService,void 0,this._logService,this._resolveVariables.bind(this))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(d){return this._proxy.getWslPath(d)}setTerminalLayoutInfo(d){return this._proxy.setTerminalLayoutInfo(d)}async getTerminalLayoutInfo(d){return await this._proxy.getTerminalLayoutInfo(d)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier+L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${L.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(d){return new Promise(c=>{const s=++P;this._pendingResolveVariablesRequests.set(s,c),this._onPtyHostRequestResolveVariables.fire({id:s,originalText:d})})}async acceptPtyHostResolvedVariables(d,c){const s=this._pendingResolveVariablesRequests.get(d);s?(s(c),this._pendingResolveVariablesRequests.delete(d)):this._logService.warn(`Resolved variables received without matching request ${d}`)}};E=de([K(1,h.IConfigurationService),K(2,R.ILogService),K(3,n.ITelemetryService)],E),e.PtyHostService=E}),define(Z[52],ee([0,1,40]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function R(O,D,y,S){const n=v.setProperty(O,D,y,S)[0];return n&&(O=O.substring(0,n.offset)+n.content+O.substring(n.offset+n.length)),O}e.edit=R;function L(O,D,y){let S=y;for(;S>=0;){if(O.charAt(S)===D.charAt(D.length-1)&&D.length===1)return S+1;if(S--,D.length===2&&S>=0&&O.charAt(S)===D.charAt(0))return S+2}return 0}e.getLineStartOffset=L;function k(O,D,y){let S=y;for(;S>=0;)if(O.charAt(S)===D.charAt(D.length-1)&&D.length===1||(S++,D.length===2&&S>=0&&O.charAt(S)===D.charAt(1)))return S;return O.length-1}e.getLineEndOffset=k}),define(Z[185],ee([0,1,26,57]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(m,h,b,f,C){var P,E;const I=[],d=[],c=[];if(!h){const j=m.filter(({identifier:z})=>C.every(V=>V.toLowerCase()!==z.id.toLowerCase()));return{local:{added:I,removed:d,updated:c},remote:j.length>0?{added:j,updated:[],removed:[],all:j}:null}}m=m.map(S),h=h.map(S),b=b?b.map(S):null;const s=new Map,t=j=>{j.uuid&&s.set(j.id.toLowerCase(),j.uuid)};m.forEach(({identifier:j})=>t(j)),h.forEach(({identifier:j})=>t(j)),b&&b.forEach(({identifier:j})=>t(j));const r=j=>{const z=j.identifier.uuid||s.get(j.identifier.id.toLowerCase());return z?`uuid:${z}`:`id:${j.identifier.id.toLowerCase()}`},i=(j,z)=>(j.set(r(z),z),j),a=m.reduce(i,new Map),u=h.reduce(i,new Map),o=h.reduce((j,z)=>{const V=r(z);z=v.deepClone(z);const q=a.get(V);return q&&(q.installed&&(z.installed=!0),z.version||(z.version=q.version)),i(j,z)},new Map),l=b?b.reduce(i,new Map):null,p=f.reduce(i,new Map),w=C.reduce((j,z)=>{const V=s.get(z.toLowerCase());return j.add(V?`uuid:${V}`:`id:${z.toLowerCase()}`)},new Set),g=k(a,u,w);if(g.added.size>0||g.removed.size>0||g.updated.size>0){const j=k(l,a,w),z=k(l,u,w),V=(q,$)=>{const H=a.get(q);if(H){const X=u.get(q);return Object.assign(Object.assign({},$?X:H),{version:(X.version&&R.gt(X.version,H.version),H.version),state:O(H,X,l==null?void 0:l.get(q))})}};for(const q of z.removed.values()){const $=a.get(q);$&&d.push($.identifier)}for(const q of z.added.values())if(j.added.has(q)){if(g.updated.has(q)){const $=V(q,!0);$&&(c.push(n($,q)),o.set(q,$))}}else{const $=u.get(q);$.installed&&I.push(n($,q))}for(const q of z.updated.values()){const $=V(q,!0);$&&(c.push(n($,q)),o.set(q,$))}for(const q of j.added.values())z.added.has(q)||o.set(q,a.get(q));for(const q of j.updated.values())if(!z.removed.has(q)&&!z.updated.has(q)){const $=V(q,!1);$&&(((P=o.get(q))===null||P===void 0?void 0:P.installed)&&($.installed=!0),o.set(q,$))}for(const q of j.removed.values())!p.has(q)&&!z.updated.has(q)&&((E=l==null?void 0:l.get(q))===null||E===void 0?void 0:E.installed)&&o.delete(q)}const U=[],F=k(u,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(F.added.size>0||F.updated.size>0||F.removed.size>0)&&o.forEach((j,z)=>U.push(n(j,z))),{local:{added:I,removed:d,updated:c},remote:U.length?{added:[...F.added].map(j=>o.get(j)),updated:[...F.updated].map(j=>o.get(j)),removed:[...F.removed].map(j=>u.get(j)),all:U}:null}}e.merge=L;function k(m,h,b,{checkInstalledProperty:f,checkVersionProperty:C}={checkInstalledProperty:!1,checkVersionProperty:!1}){const P=m?[...m.keys()].filter(s=>!b.has(s)):[],E=[...h.keys()].filter(s=>!b.has(s)),I=E.filter(s=>P.indexOf(s)===-1).reduce((s,t)=>(s.add(t),s),new Set),d=P.filter(s=>E.indexOf(s)===-1).reduce((s,t)=>(s.add(t),s),new Set),c=new Set;for(const s of P){if(d.has(s))continue;const t=m.get(s),r=h.get(s);(!r||t.disabled!==r.disabled||!y(t.state,r.state)||C&&t.version!==r.version||f&&t.installed!==r.installed)&&c.add(s)}return{added:I,removed:d,updated:c}}function O(m,h,b){const f=m.state,C=h.state,P=b==null?void 0:b.state;if(!h.version||f&&R.gt(m.version,h.version))return f;if(C&&R.gt(h.version,m.version)||!f)return C;if(!C)return f;const E=v.deepClone(f),I=P?D(P,C):{added:Object.keys(C).reduce((c,s)=>(c.add(s),c),new Set),removed:new Set,updated:new Set},d=P?D(P,f):{added:Object.keys(f).reduce((c,s)=>(c.add(s),c),new Set),removed:new Set,updated:new Set};for(const c of[...I.added.values(),...I.updated.values()])E[c]=C[c];for(const c of I.removed.values())d.updated.has(c)||delete E[c];return E}function D(m,h){const b=Object.keys(m),f=Object.keys(h),C=f.filter(I=>b.indexOf(I)===-1).reduce((I,d)=>(I.add(d),I),new Set),P=b.filter(I=>f.indexOf(I)===-1).reduce((I,d)=>(I.add(d),I),new Set),E=new Set;for(const I of b){if(P.has(I))continue;const d=m[I],c=h[I];v.equals(d,c)||E.add(I)}return{added:C,removed:P,updated:E}}function y(m={},h={}){const{added:b,removed:f,updated:C}=D(m,h);return b.size===0&&f.size===0&&C.size===0}function S(m){return Object.assign(Object.assign({},m),{disabled:!!m.disabled,installed:!!m.installed})}function n(m,h){const b={identifier:{id:m.identifier.id,uuid:h.startsWith("uuid:")?h.substring("uuid:".length):void 0}};return m.version&&(b.version=m.version),m.disabled&&(b.disabled=!0),m.installed&&(b.installed=!0),m.state&&(b.state=m.state),b}}),define(Z[85],ee([0,1,19,3,2,33,4,27,21]),function(G,e,v,R,L,k,O,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=O.createDecorator("IExtensionsStorageSyncService");const S=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class Ze extends L.Disposable{constructor(h,b){super();this.storageService=h,this.productService=b,this._onDidChangeExtensionsStorage=this._register(new R.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(f=>this.onDidChangeStorageValue(f)))}static toKey(h){return`extensionKeys/${k.adoptToGalleryExtensionId(h.id)}@${h.version}`}static fromKey(h){const b=S.exec(h);if(b&&b[1])return{id:b[1],version:b[2]}}initialize(){const h=this.storageService.keys(0,1);for(const b of h){const f=Ze.fromKey(b);f&&this.extensionsWithKeysForSync.add(f.id.toLowerCase())}}onDidChangeStorageValue(h){if(h.scope!==0)return;if(this.extensionsWithKeysForSync.has(h.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const b=Ze.fromKey(h.key);if(b){this.extensionsWithKeysForSync.add(b.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(h,b){this.storageService.store(Ze.toKey(h),JSON.stringify(b),0,1)}getKeysForSync(h){var b;const f=(b=this.productService.extensionSyncedKeys)===null||b===void 0?void 0:b[h.id.toLowerCase()],C=this.storageService.get(Ze.toKey(h),0),P=C?JSON.parse(C):void 0;return P&&f?v.distinct([...P,...f]):P||f}};n=de([K(0,y.IStorageService),K(1,D.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(Z[86],ee([0,1,19,23,4]),function(G,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=L.createDecorator("IIgnoredExtensionsManagementService");let k=class{constructor(D){this.configurationService=D}hasToNeverSyncExtension(D){return this.getConfiguredIgnoredExtensions().includes(D.toLowerCase())}hasToAlwaysSyncExtension(D){return this.getConfiguredIgnoredExtensions().includes(`-${D.toLowerCase()}`)}updateIgnoredExtensions(D,y){let S=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return S=S.filter(n=>n!==D&&n!==`-${D}`),y&&S.push(D.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,1)}updateSynchronizedExtensions(D,y){let S=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return S=S.filter(n=>n!==D&&n!==`-${D}`),y&&S.push(`-${D.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,1)}getIgnoredExtensions(D){const y=D.filter(h=>h.isMachineScoped).map(h=>h.identifier.id.toLowerCase()),S=this.getConfiguredIgnoredExtensions().map(h=>h.toLowerCase()),n=[],m=[];if(Array.isArray(S))for(const h of S)h.startsWith("-")?m.push(h.substring(1)):n.push(h);return v.distinct([...y,...n].filter(h=>m.indexOf(h)===-1))}getConfiguredIgnoredExtensions(){let D=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return D!==void 0||(D=this.configurationService.inspect("sync.ignoredExtensions").userValue,D!==void 0)?D:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(y=>y.toLowerCase())}};k=de([K(0,R.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(Z[186],ee([0,1,26,32,19,143,52]),function(G,e,v,R,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function D(c){return R.parse(c)||[]}e.parseKeybindings=D;async function y(c,s,t,r,i){const a=D(c),u=D(s),o=t?D(t):null,l=[...a,...u,...o||[]].map(H=>H.key),p=await i.resolveUserBindings(l);let w=n(a,u,o,p);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const g=h(a),U=h(u),F=o?h(o):null,j=f(g,U,p),z=F?f(F,g,p):{added:[...g.keys()].reduce((H,X)=>(H.add(X),H),new Set),removed:new Set,updated:new Set},V=F?f(F,U,p):{added:[...U.keys()].reduce((H,X)=>(H.add(X),H),new Set),removed:new Set,updated:new Set},q=S(j,z,V);let $=c;for(const H of q.removed.values())q.conflicts.has(H)||($=I($,H,r));for(const H of q.added.values()){if(q.conflicts.has(H))continue;const X=U.get(H);if(X.some(_=>_.command!==`-${H}`&&w.conflicts.has(p[_.key]))){q.conflicts.add(H);continue}$=E($,X,r)}for(const H of q.updated.values()){if(q.conflicts.has(H))continue;const X=U.get(H);if(X.some(_=>_.command!==`-${H}`&&w.conflicts.has(p[_.key]))){q.conflicts.add(H);continue}$=d($,H,X,r)}return{mergeContent:$,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.merge=y;function S(c,s,t){const r=new Set,i=new Set,a=new Set,u=new Set;for(const o of s.removed.values())t.updated.has(o)&&u.add(o);for(const o of t.removed.values())u.has(o)||(s.updated.has(o)?u.add(o):i.add(o));for(const o of s.added.values())u.has(o)||t.added.has(o)&&c.updated.has(o)&&u.add(o);for(const o of t.added.values())u.has(o)||(s.added.has(o)?c.updated.has(o)&&u.add(o):r.add(o));for(const o of s.updated.values())u.has(o)||t.updated.has(o)&&c.updated.has(o)&&u.add(o);for(const o of t.updated.values())u.has(o)||(s.updated.has(o)?c.updated.has(o)&&u.add(o):a.add(o));return{added:r,removed:i,updated:a,conflicts:u}}function n(c,s,t,r){const i=new Set,a=m(c,r),u=m(s,r),o=t?m(t,r):null,l=b(a,u);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const p=o?b(o,a):{added:[...a.keys()].reduce((z,V)=>(z.add(V),z),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const w=o?b(o,u):{added:[...u.keys()].reduce((z,V)=>(z.add(V),z),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:g,removed:U,updated:F,conflicts:j}=S(l,p,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:g,removed:U,updated:F,conflicts:j}}function m(c,s){const t=new Map;for(const r of c){const i=s[r.key];let a=t.get(i);a||(a=[],t.set(i,a)),a.push(r)}return t}function h(c){const s=new Map;for(const t of c){const r=t.command[0]==="-"?t.command.substring(1):t.command;let i=s.get(r);i||(i=[],s.set(r,i)),i.push(t)}return s}function b(c,s){const t=[...c.keys()],r=[...s.keys()],i=r.filter(o=>t.indexOf(o)===-1).reduce((o,l)=>(o.add(l),o),new Set),a=t.filter(o=>r.indexOf(o)===-1).reduce((o,l)=>(o.add(l),o),new Set),u=new Set;for(const o of t){if(a.has(o))continue;const l=c.get(o).map(w=>Object.assign(Object.assign({},w),{key:o})),p=s.get(o).map(w=>Object.assign(Object.assign({},w),{key:o}));L.equals(l,p,(w,g)=>P(w,g))||u.add(o)}return{added:i,removed:a,updated:u}}function f(c,s,t){const r=[...c.keys()],i=[...s.keys()],a=i.filter(l=>r.indexOf(l)===-1).reduce((l,p)=>(l.add(p),l),new Set),u=r.filter(l=>i.indexOf(l)===-1).reduce((l,p)=>(l.add(p),l),new Set),o=new Set;for(const l of r){if(u.has(l))continue;const p=c.get(l).map(g=>Object.assign(Object.assign({},g),{key:t[g.key]})),w=s.get(l).map(g=>Object.assign(Object.assign({},g),{key:t[g.key]}));C(p,w)||o.add(l)}return{added:a,removed:u,updated:o}}function C(c,s){return!(!L.equals(c.filter(({command:t})=>t[0]!=="-"),s.filter(({command:t})=>t[0]!=="-"),(t,r)=>P(t,r))||!L.equals(c.filter(({command:t})=>t[0]==="-"),s.filter(({command:t})=>t[0]==="-"),(t,r)=>P(t,r)))}function P(c,s){if(c.command!==s.command||c.key!==s.key)return!1;const t=k.ContextKeyExpr.deserialize(c.when),r=k.ContextKeyExpr.deserialize(s.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!v.equals(c.args,s.args))}function E(c,s,t){for(const r of s)c=O.edit(c,[-1],r,t);return c}function I(c,s,t){const r=D(c);for(let i=r.length-1;i>=0;i--)(r[i].command===s||r[i].command===`-${s}`)&&(c=O.edit(c,[i],void 0,t));return c}function d(c,s,t,r){const i=D(c),a=i.findIndex(u=>u.command===s||u.command===`-${s}`);for(let u=i.length-1;u>=0;u--)(i[u].command===s||i[u].command===`-${s}`)&&(c=O.edit(c,[u],void 0,r));for(let u=t.length-1;u>=0;u--)c=O.edit(c,[a],t[u],r);return c}}),define(Z[187],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function v(k,O,D){const y={},S={},n=new Set;if(!O)return{local:{added:y,updated:S,removed:[...n.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const m=R(k,O);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{local:{added:y,updated:S,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const h=R(D,k),b=R(D,O),f={},C={},P=new Set,E=new Set;for(const I of h.removed.values())b.updated.has(I)?y[I]=O[I]:P.add(I);for(const I of b.removed.values())E.has(I)||(h.updated.has(I)?E.add(I):n.add(I));for(const I of h.updated.values())E.has(I)||(b.updated.has(I)?m.updated.has(I)&&E.add(I):C[I]=k[I]);for(const I of b.updated.values())E.has(I)||(h.updated.has(I)?m.updated.has(I)&&E.add(I):k[I]!==void 0&&(S[I]=O[I]));for(const I of h.added.values())E.has(I)||(b.added.has(I)?m.updated.has(I)&&E.add(I):f[I]=k[I]);for(const I of b.added.values())E.has(I)||(h.added.has(I)?m.updated.has(I)&&E.add(I):y[I]=O[I]);return{local:{added:y,removed:[...n.values()],updated:S},remote:{added:f,removed:[...P.values()],updated:C},conflicts:[...E.values()]}}e.merge=v;function R(k,O){const D=k?Object.keys(k):[],y=O?Object.keys(O):[],S=y.filter(h=>D.indexOf(h)===-1).reduce((h,b)=>(h.add(b),h),new Set),n=D.filter(h=>y.indexOf(h)===-1).reduce((h,b)=>(h.add(b),h),new Set),m=new Set;for(const h of D){if(n.has(h))continue;const b=k[h],f=O[h];b!==f&&m.add(h)}return{added:S,removed:n,updated:m}}function L(k,O){const{added:D,removed:y,updated:S}=R(k,O);return D.size===0&&y.size===0&&S.size===0}e.areSame=L}),define(Z[22],ee([0,1,4,28,31,37,127,80,12,19,16]),function(G,e,v,R,L,k,O,D,y,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function m(){const o=L.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(l=>!!o[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=m;function h(){const o=L.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(o).filter(g=>!!o[g].ignoreSync),p=Object.keys(o).filter(g=>o[g].scope===2||o[g].scope===6),w=m();return S.distinct([e.CONFIGURATION_SYNC_STORE_KEY,...l,...p,...w])}e.getDefaultIgnoredSettings=h;function b(){const o="vscode://schemas/ignoredSettings",l=L.Registry.as(k.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:O.localize(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:O.localize(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:O.localize(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:O.localize(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:O.localize(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const p=L.Registry.as(D.Extensions.JSONContribution),w=()=>{const g=m(),U=h().filter(V=>V!==e.CONFIGURATION_SYNC_STORE_KEY),F=Object.keys(k.allSettings.properties).filter(V=>U.indexOf(V)===-1),j=U.filter(V=>g.indexOf(V)===-1),z={items:{type:"string",enum:[...F,...j.map(V=>`-${V}`)]}};p.registerSchema(o,z)};return l.onDidUpdateConfiguration(()=>w())}e.registerConfiguration=b;function f(o){return o&&n.isObject(o)&&n.isString(o.id)&&n.isArray(o.scopes)}e.isAuthenticationProvider=f;var C;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Extensions="extensions",o.GlobalState="globalState"})(C=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function P(o,l,p){return p.joinPath(l.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=P,e.IUserDataSyncStoreManagementService=v.createDecorator("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=v.createDecorator("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=v.createDecorator("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function E(o){const l={};return l[e.HEADER_EXECUTION_ID]=o,l}e.createSyncHeaders=E;var I;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.NoRef="NoRef",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(I=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class d extends Error{constructor(l,p,w,g){super(l);this.code=p,this.resource=w,this.operationId=g,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=d;class c extends d{constructor(l,p,w,g){super(l,w,void 0,g);this.url=p}}e.UserDataSyncStoreError=c;class s extends d{constructor(l,p){super(l,p)}}e.UserDataAutoSyncError=s,function(o){function l(p){if(p instanceof o)return p;const w=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(p.name);if(w&&w[1]){const g=w[2]==="unknown"?void 0:w[2],U=w[3]==="unknown"?void 0:w[3];return new o(p.message,w[1],g,U)}return new o(p.message,I.Unknown)}o.toUserDataSyncError=l}(d=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var r;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var i;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function a(o){return`sync.enable.${o}`}e.getEnablementKey=a,e.IUserDataSyncResourceEnablementService=v.createDecorator("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=v.createDecorator("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=v.createDecorator("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=v.createDecorator("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=v.createDecorator("IUserDataSyncUtilService"),e.IUserDataSyncLogService=v.createDecorator("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function u(o,l){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:l.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(p=>y.isEqualOrParent(o,y.joinPath(l.userDataSyncHome,p,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=u}),define(Z[45],ee([0,1,2,10,25,5,22,9,12,6,3,24,32,123,23,16,20,19,44,21,29]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b,f,C,P,E,I,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function s(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}e.isSyncData=s;let t=class extends v.Disposable{constructor(o,l,p,w,g,U,F,j,z,V){super();this.resource=o,this.fileService=l,this.environmentService=p,this.userDataSyncStoreService=g,this.userDataSyncBackupStoreService=U,this.userDataSyncResourceEnablementService=F,this.telemetryService=j,this.logService=z,this.configurationService=V,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new n.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new n.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new S.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new n.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=P.uppercaseFirstLetter(this.resource),this.extUri=this.fileService.hasCapability(p.userDataSyncHome,1024)?y.extUri:y.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(p.userDataSyncHome,o),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,O.PREVIEW_DIR_NAME),this.lastSyncResource=O.getLastSyncResourceUri(o,p,this.extUri),this.currentMachineIdPromise=I.getServiceMachineId(p,l,w)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const o=await this.syncPreviewPromise;this.syncPreviewPromise=null;const l=await this.performSync(o.remoteUserData,o.lastSyncUserData,!0);this.setStatus(l)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const o=await this.getLastSyncUserData();(o?(await this.doGenerateSyncResourcePreview(o,o,!0,c.CancellationToken.None)).resourcePreviews.some(({remoteChange:p})=>p!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(o){if(this._status!==o){const l=this._status;o==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),l==="hasConflicts"&&o==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=o,this._onDidChangStatus.fire(o)}}async sync(o,l={}){await this._sync(o,!0,l)}async preview(o,l={}){return this._sync(o,!1,l)}async apply(o,l={}){try{this.syncHeaders=Object.assign({},l);const p=await this.doApply(o);return this.setStatus(p),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(o,l,p){try{if(this.syncHeaders=Object.assign({},p),!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let w="idle";try{const g=await this.getLastSyncUserData(),U=await this.getLatestRemoteUserData(o,g);return w=await this.performSync(U,g,l),w==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):w==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(w)}}finally{this.syncHeaders={}}}async replace(o){const l=await this.resolveContent(o);if(!l)return!1;const p=this.parseSyncData(l);if(!p)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const w=await this.getLastSyncUserData(),g=await this.getLatestRemoteUserData(null,w),U=await this.isRemoteDataFromCurrentMachine(g),F=await this.generateSyncPreview({ref:g.ref,syncData:p},w,U,c.CancellationToken.None),j=[];for(const z of F){const V=await this.getAcceptResult(z,z.remoteResource,void 0,c.CancellationToken.None),{remoteChange:q}=await this.getAcceptResult(z,z.previewResource,z.remoteContent,c.CancellationToken.None);j.push([z,Object.assign(Object.assign({},V),{remoteChange:q!==0?q:2})])}await this.applyResult(g,w,j,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(o){var l;const p=await this.currentMachineIdPromise;return!!((l=o.syncData)===null||l===void 0?void 0:l.machineId)&&o.syncData.machineId===p}async getLatestRemoteUserData(o,l){if(l){const p=o&&o.latest?o.latest[this.resource]:void 0;if(l.ref===p||p===void 0&&l.syncData===null)return l}return this.getRemoteUserData(l)}async performSync(o,l,p){if(o.syncData&&o.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new O.UserDataSyncError(b.localize(0,null,this.resource,this.version,o.syncData.version),O.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(o,l,p)}catch(w){if(w instanceof O.UserDataSyncError)switch(w.code){case O.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(o,l,p);case O.UserDataSyncErrorCode.Conflict:case O.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),o=await this.getRemoteUserData(null),l=await this.getLastSyncUserData(),this.performSync(o,l,p)}throw w}}async doSync(o,l,p){try{this.syncPreviewPromise||(this.syncPreviewPromise=S.createCancelablePromise(g=>this.doGenerateSyncResourcePreview(o,l,p,g)));const w=await this.syncPreviewPromise;return this.updateConflicts(w.resourcePreviews),w.resourcePreviews.some(({mergeState:g})=>g==="conflict")?"hasConflicts":p?await this.doApply(!1):"syncing"}catch(w){throw this.syncPreviewPromise=null,w}}async merge(o){return await this.updateSyncResourcePreview(o,async l=>{const p=await this.getMergeResult(l,c.CancellationToken.None);await this.fileService.writeFile(l.previewResource,L.VSBuffer.fromString((p==null?void 0:p.content)||""));const w=p&&!p.hasConflicts?await this.getAcceptResult(l,l.previewResource,void 0,c.CancellationToken.None):void 0;return l.acceptResult=w,l.mergeState=p.hasConflicts?"conflict":w?"accepted":"preview",l.localChange=w?w.localChange:p.localChange,l.remoteChange=w?w.remoteChange:p.remoteChange,l}),this.syncPreviewPromise}async accept(o,l){return await this.updateSyncResourcePreview(o,async p=>{const w=await this.getAcceptResult(p,o,l,c.CancellationToken.None);return p.acceptResult=w,p.mergeState="accepted",p.localChange=w.localChange,p.remoteChange=w.remoteChange,p}),this.syncPreviewPromise}async discard(o){return await this.updateSyncResourcePreview(o,async l=>{const p=await this.getMergeResult(l,c.CancellationToken.None);return await this.fileService.writeFile(l.previewResource,L.VSBuffer.fromString(p.content||"")),l.acceptResult=void 0,l.mergeState="preview",l.localChange=p.localChange,l.remoteChange=p.remoteChange,l}),this.syncPreviewPromise}async updateSyncResourcePreview(o,l){if(!this.syncPreviewPromise)return;let p=await this.syncPreviewPromise;const w=p.resourcePreviews.findIndex(({localResource:g,remoteResource:U,previewResource:F})=>this.extUri.isEqual(g,o)||this.extUri.isEqual(U,o)||this.extUri.isEqual(F,o));w!==-1&&(this.syncPreviewPromise=S.createCancelablePromise(async g=>{const U=[...p.resourcePreviews];return U[w]=await l(U[w]),Object.assign(Object.assign({},p),{resourcePreviews:U})}),p=await this.syncPreviewPromise,this.updateConflicts(p.resourcePreviews),p.resourcePreviews.some(({mergeState:g})=>g==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(o){if(!this.syncPreviewPromise)return"idle";const l=await this.syncPreviewPromise;return l.resourcePreviews.some(({mergeState:p})=>p==="conflict")?"hasConflicts":l.resourcePreviews.some(({mergeState:p})=>p!=="accepted")?"syncing":(await this.applyResult(l.remoteUserData,l.lastSyncUserData,l.resourcePreviews.map(p=>[p,p.acceptResult]),o),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(o){}}updateConflicts(o){const l=o.filter(({mergeState:p})=>p==="conflict");E.equals(this._conflicts,l,(p,w)=>this.extUri.isEqual(p.previewResource,w.previewResource))||(this._conflicts=l,this._onDidChangeConflicts.fire(l))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:l,ref:p})=>({created:l,uri:this.toRemoteBackupResource(p)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:l,ref:p})=>({created:l,uri:this.toLocalBackupResource(p)}))}toRemoteBackupResource(o){return k.URI.from({scheme:O.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${o}`})}toLocalBackupResource(o){return k.URI.from({scheme:O.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${o}`})}async getMachineId({uri:o}){const l=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(l))){const{content:p}=await this.getUserData(l);if(p){const w=this.parseSyncData(p);return w==null?void 0:w.machineId}}}async resolveContent(o){const l=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(l))){const{content:p}=await this.getUserData(l);return p}return this.extUri.isEqual(o,this.toLocalBackupResource(l))?this.userDataSyncBackupStoreService.resolveContent(this.resource,l):null}async resolvePreviewContent(o){const l=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(l)for(const p of l.resourcePreviews){if(this.extUri.isEqual(p.acceptedResource,o))return p.acceptResult?p.acceptResult.content:null;if(this.extUri.isEqual(p.remoteResource,o))return p.remoteContent;if(this.extUri.isEqual(p.localResource,o))return p.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(o){}}async doGenerateSyncResourcePreview(o,l,p,w){const g=await this.isRemoteDataFromCurrentMachine(o),U=await this.generateSyncPreview(o,l,g,w),F=[];for(const j of U){const z=j.previewResource.with({scheme:O.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(j.localChange===0&&j.remoteChange===0)F.push(Object.assign(Object.assign({},j),{acceptedResource:z,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"}));else{const V=p?await this.getMergeResult(j,w):void 0;if(w.isCancellationRequested)break;await this.fileService.writeFile(j.previewResource,L.VSBuffer.fromString((V==null?void 0:V.content)||""));const q=V&&!V.hasConflicts?await this.getAcceptResult(j,j.previewResource,void 0,w):void 0;F.push(Object.assign(Object.assign({},j),{acceptResult:q,mergeState:(V==null?void 0:V.hasConflicts)?"conflict":q?"accepted":"preview",localChange:q?q.localChange:V?V.localChange:j.localChange,remoteChange:q?q.remoteChange:V?V.remoteChange:j.remoteChange}))}}return{remoteUserData:o,lastSyncUserData:l,resourcePreviews:F,isLastSyncFromCurrentMachine:g}}async getLastSyncUserData(){try{const o=await this.fileService.readFile(this.lastSyncResource),l=JSON.parse(o.value.toString()),p=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=l.version&&p&&l.version!==p,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${l.version} is not compatible with current sync state version ${p}.`),await this.resetLocal(),null;const w=l;if(w.content===null)return{ref:l.ref,syncData:null};const g=JSON.parse(w.content);if(s(g))return Object.assign(Object.assign({},l),{syncData:g,content:void 0})}catch(o){o instanceof R.FileOperationError&&o.fileOperationResult===1||this.logService.error(o)}return null}async updateLastSyncUserData(o,l={}){if(l.ref||l.content||l.version)throw new Error("Cannot have core properties as additional");const p=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),w=Object.assign({ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,version:p},l);await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(w)))}async getRemoteUserData(o){const{ref:l,content:p}=await this.getUserData(o);let w=null;return p!==null&&(w=this.parseSyncData(p)),{ref:l,syncData:w}}parseSyncData(o){try{const l=JSON.parse(o);if(s(l))return l}catch(l){this.logService.error(l)}throw new O.UserDataSyncError(b.localize(1,null),O.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(o){if(C.isString(o)){const l=await this.userDataSyncStoreService.resolveContent(this.resource,o);return{ref:o,content:l}}else{const l=o?{ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,l,this.syncHeaders)}}async updateRemoteUserData(o,l){const p=await this.currentMachineIdPromise,w={version:this.version,machineId:p,content:o};return l=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(w),l,this.syncHeaders),{ref:l,syncData:w}}async backupLocal(o){const l={version:this.version,content:o};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(l))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=de([K(1,R.IFileService),K(2,D.IEnvironmentService),K(3,d.IStorageService),K(4,O.IUserDataSyncStoreService),K(5,O.IUserDataSyncBackupStoreService),K(6,O.IUserDataSyncResourceEnablementService),K(7,m.ITelemetryService),K(8,O.IUserDataSyncLogService),K(9,f.IConfigurationService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(o,l,p,w,g,U,F,j,z,V,q){super(l,p,w,g,U,F,j,z,V,q);this.file=o,this._register(this.fileService.watch(this.extUri.dirname(o))),this._register(this.fileService.onDidFilesChange($=>this.onFileChanges($)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(o){return null}}async updateLocalFileContent(o,l,p){try{l?await this.fileService.writeFile(this.file,L.VSBuffer.fromString(o),p?void 0:l):await this.fileService.createFile(this.file,L.VSBuffer.fromString(o),{overwrite:p})}catch(w){throw w instanceof R.FileOperationError&&w.fileOperationResult===1||w instanceof R.FileOperationError&&w.fileOperationResult===3?new O.UserDataSyncError(w.message,O.UserDataSyncErrorCode.LocalPreconditionFailed):w}}onFileChanges(o){!o.contains(this.file)||this.triggerLocalChange()}};r=de([K(2,R.IFileService),K(3,D.IEnvironmentService),K(4,d.IStorageService),K(5,O.IUserDataSyncStoreService),K(6,O.IUserDataSyncBackupStoreService),K(7,O.IUserDataSyncResourceEnablementService),K(8,m.ITelemetryService),K(9,O.IUserDataSyncLogService),K(10,f.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let i=class extends r{constructor(o,l,p,w,g,U,F,j,z,V,q,$){super(o,l,p,w,g,U,F,j,z,V,$);this.userDataSyncUtilService=q,this._formattingOptions=void 0}hasErrors(o){const l=[];return h.parse(o,l,{allowEmptyContent:!0,allowTrailingComma:!0}),l.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};i=de([K(2,R.IFileService),K(3,D.IEnvironmentService),K(4,d.IStorageService),K(5,O.IUserDataSyncStoreService),K(6,O.IUserDataSyncBackupStoreService),K(7,O.IUserDataSyncResourceEnablementService),K(8,m.ITelemetryService),K(9,O.IUserDataSyncLogService),K(10,O.IUserDataSyncUtilService),K(11,f.IConfigurationService)],i),e.AbstractJsonFileSynchroniser=i;let a=class{constructor(o,l,p,w){this.resource=o,this.environmentService=l,this.logService=p,this.fileService=w,this.extUri=this.fileService.hasCapability(l.userDataSyncHome,1024)?y.extUri:y.extUriIgnorePathCase,this.lastSyncResource=O.getLastSyncResourceUri(this.resource,l,y.extUri)}async initialize({ref:o,content:l}){if(!l){this.logService.info("Remote content does not exist.",this.resource);return}const p=this.parseSyncData(l);if(!p)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:o,syncData:p})}catch(g){this.logService.error(g)}}parseSyncData(o){try{const l=JSON.parse(o);if(s(l))return l}catch(l){this.logService.error(l)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(o,l={}){const p=Object.assign({ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null},l);await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(p)))}};a=de([K(1,D.IEnvironmentService),K(2,O.IUserDataSyncLogService),K(3,R.IFileService)],a),e.AbstractInitializer=a}),define(Z[188],ee([0,1,22,3,9,28,33,10,23,185,45,24,5,46,40,20,21,86,11,85,6]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b,f,C,P,E,I,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function s(u,o){const l=JSON.parse(u.content);if(u.version===1||u.version===2){const p=(await o.getInstalled(0)).filter(w=>w.isBuiltin);for(const w of l)u.version===1&&(w.enabled===!1&&(w.disabled=!0),delete w.enabled),u.version===2&&p.every(g=>!O.areSameExtensions(g.identifier,w.identifier))&&(w.installed=!0)}return l}function t(u,o,l){const p=l.get(O.getExtensionId(u,o),0)||"{}";return JSON.parse(p)}e.getExtensionStorageState=t;function r(u,o,l,p){p.store(O.getExtensionId(u,o),JSON.stringify(l),0,1)}e.storeExtensionStorageState=r;let i=class ot extends n.AbstractSynchroniser{constructor(o,l,p,w,g,U,F,j,z,V,q,$,H,X){super("extensions",l,o,p,w,g,$,H,z,q);this.storageService=p,this.extensionManagementService=U,this.extensionEnablementService=F,this.ignoredExtensionsManagementService=j,this.extensionGalleryService=V,this.extensionsStorageSyncService=X,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.debounce(R.Event.any(R.Event.filter(this.extensionManagementService.onDidInstallExtension,_=>!!_.gallery),R.Event.filter(this.extensionManagementService.onDidUninstallExtension,_=>!_.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(o,l){const p=o.syncData?await s(o.syncData,this.extensionManagementService):null,w=(l==null?void 0:l.skippedExtensions)||[],g=(l==null?void 0:l.syncData)?await s(l.syncData,this.extensionManagementService):null,U=await this.extensionManagementService.getInstalled(),F=this.getLocalExtensions(U),j=this.ignoredExtensionsManagementService.getIgnoredExtensions(U);p?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:V}=S.merge(F,p,g,w,j),q={local:z,remote:V,content:this.getPreviewContent(F,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:V!==null?2:0};return[{skippedExtensions:w,localResource:this.localResource,localContent:this.format(F),localExtensions:F,remoteResource:this.remoteResource,remoteContent:p?this.format(p):null,previewResource:this.previewResource,previewResult:q,localChange:q.localChange,remoteChange:q.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(o,l,p,w){const g=[...l,...p],U=new Set,F=j=>{U.add(j.id.toLowerCase()),j.uuid&&U.add(j.uuid)};g.forEach(({identifier:j})=>F(j)),w.forEach(F);for(const j of o)U.has(j.identifier.id.toLowerCase())||j.identifier.uuid&&U.has(j.identifier.uuid)||g.push(j);return this.format(g)}async getMergeResult(o,l){return Object.assign(Object.assign({},o.previewResult),{hasConflicts:!1})}async getAcceptResult(o,l,p,w){if(this.extUri.isEqual(l,this.localResource))return this.acceptLocal(o);if(this.extUri.isEqual(l,this.remoteResource))return this.acceptRemote(o);if(this.extUri.isEqual(l,this.previewResource))return o.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async acceptLocal(o){const l=await this.extensionManagementService.getInstalled(),p=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),w=S.merge(o.localExtensions,null,null,o.skippedExtensions,p),{local:g,remote:U}=w;return{content:o.localContent,local:g,remote:U,localChange:g.added.length>0||g.removed.length>0||g.updated.length>0?2:0,remoteChange:U!==null?2:0}}async acceptRemote(o){const l=await this.extensionManagementService.getInstalled(),p=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),w=o.remoteContent?JSON.parse(o.remoteContent):null;if(w!==null){const g=S.merge(o.localExtensions,w,o.localExtensions,[],p),{local:U,remote:F}=g;return{content:o.remoteContent,local:U,remote:F,localChange:U.added.length>0||U.removed.length>0||U.updated.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:o.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(o,l,p,w){let{skippedExtensions:g,localExtensions:U}=p[0][0],{local:F,remote:j,localChange:z,remoteChange:V}=p[0][1];if(z===0&&V===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),z!==0&&(await this.backupLocal(JSON.stringify(U)),g=await this.updateLocalExtensions(F.added,F.removed,F.updated,g)),j){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const q=JSON.stringify(j.all);o=await this.updateRemoteUserData(q,w?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${j.added.length?` Added: ${JSON.stringify(j.added.map($=>$.identifier.id))}.`:""}${j.updated.length?` Updated: ${JSON.stringify(j.updated.map($=>$.identifier.id))}.`:""}${j.removed.length?` Removed: ${JSON.stringify(j.removed.map($=>$.identifier.id))}.`:""}`)}(l==null?void 0:l.ref)!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(o,{skippedExtensions:g}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${g.length?` Skipped: ${JSON.stringify(g.map(q=>q.identifier.id))}.`:""}`))}async getAssociatedResources({uri:o}){return[{resource:this.extUri.joinPath(o,"extensions.json"),comparableResource:ot.EXTENSIONS_DATA_URI}]}async resolveContent(o){if(this.extUri.isEqual(o,ot.EXTENSIONS_DATA_URI)){const p=await this.extensionManagementService.getInstalled(),w=this.ignoredExtensionsManagementService.getIgnoredExtensions(p),g=this.getLocalExtensions(p).filter(U=>!w.some(F=>O.areSameExtensions({id:F},U.identifier)));return this.format(g)}if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o))return this.resolvePreviewContent(o);let l=await super.resolveContent(o);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(o)),l){const p=this.parseSyncData(l);if(p)switch(this.extUri.basename(o)){case"extensions.json":return this.format(this.parseExtensions(p))}}return null}format(o){o.sort((w,g)=>!w.identifier.uuid&&g.identifier.uuid?-1:w.identifier.uuid&&!g.identifier.uuid?1:C.compare(w.identifier.id,g.identifier.id));const l=JSON.stringify(o),p=b.format(l,void 0,{});return f.applyEdits(l,p)}async hasLocalData(){try{const o=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(o).some(p=>p.installed||p.disabled))return!0}catch(o){}return!1}async updateLocalExtensions(o,l,p,w){const g=[],U=[],F=await this.extensionManagementService.getInstalled();if(l.length){const z=F.filter(({identifier:V,isBuiltin:q})=>!q&&l.some($=>O.areSameExtensions(V,$)));await c.Promises.settled(z.map(async V=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,V.identifier.id),await this.extensionManagementService.uninstall(V,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,V.identifier.id),g.push(V.identifier)}))}(o.length||p.length)&&await c.Promises.settled([...o,...p].map(async z=>{const V=F.find($=>O.areSameExtensions($.identifier,z.identifier));if(V&&V.isBuiltin){z.state&&V.manifest.version===z.version&&this.updateExtensionState(z.state,V.manifest.publisher,V.manifest.name,V.manifest.version),z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id),await this.extensionEnablementService.disableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id),await this.extensionEnablementService.enableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id)),g.push(z.identifier);return}const q=await this.extensionGalleryService.getCompatibleExtension(z.identifier);if(z.state&&(V?V.manifest.version===z.version:!!q)){const $=V?V.manifest.publisher:q.publisher,H=V?V.manifest.name:q.name;this.updateExtensionState(z.state,$,H,V==null?void 0:V.manifest.version)}if(q)try{z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id,q.version),await this.extensionEnablementService.disableExtension(q.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id,q.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id,q.version),await this.extensionEnablementService.enableExtension(q.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id,q.version)),V||(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,z.identifier.id,q.version),await this.extensionManagementService.installFromGallery(q,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,z.identifier.id,q.version),g.push(q.identifier))}catch($){U.push(z),this.logService.error($),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,q.displayName||q.identifier.id)}else U.push(z)}));const j=[];for(const z of w)g.some(V=>O.areSameExtensions(V,z.identifier))||j.push(z);for(const z of U)j.some(V=>O.areSameExtensions(V.identifier,z.identifier))||j.push(z);return j}updateExtensionState(o,l,p,w){const g=t(l,p,this.storageService),U=w?this.extensionsStorageSyncService.getKeysForSync({id:O.getGalleryExtensionId(l,p),version:w}):void 0;U?U.forEach(F=>{g[F]=o[F]}):Object.keys(o).forEach(F=>g[F]=o[F]),r(l,p,g,this.storageService)}parseExtensions(o){return JSON.parse(o.content)}getLocalExtensions(o){const l=this.extensionEnablementService.getDisabledExtensions();return o.map(({identifier:p,isBuiltin:w,manifest:g})=>{const U={identifier:p,version:g.version};l.some(F=>O.areSameExtensions(F,p))&&(U.disabled=!0),w||(U.installed=!0);try{const F=this.extensionsStorageSyncService.getKeysForSync({id:p.id,version:g.version});if(F){const j=t(g.publisher,g.name,this.storageService);U.state=Object.keys(j).reduce((z,V)=>(F.includes(V)&&(z[V]=j[V]),z),{})}}catch(F){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,I.getErrorMessage(F))}return U})}};i.EXTENSIONS_DATA_URI=h.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=de([K(0,L.IEnvironmentService),K(1,D.IFileService),K(2,P.IStorageService),K(3,v.IUserDataSyncStoreService),K(4,v.IUserDataSyncBackupStoreService),K(5,k.IExtensionManagementService),K(6,k.IGlobalExtensionEnablementService),K(7,E.IIgnoredExtensionsManagementService),K(8,v.IUserDataSyncLogService),K(9,k.IExtensionGalleryService),K(10,y.IConfigurationService),K(11,v.IUserDataSyncResourceEnablementService),K(12,m.ITelemetryService),K(13,d.IExtensionsStorageSyncService)],i),e.ExtensionsSynchroniser=i;let a=class extends n.AbstractInitializer{constructor(o,l,p,w,g){super("extensions",w,g,p);this.extensionManagementService=o,this.ignoredExtensionsManagementService=l}async parseExtensions(o){return o.syncData?await s(o.syncData,this.extensionManagementService):null}generatePreview(o,l){const p=[],w=[],g=[];for(const U of o){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(U.identifier.id))continue;const F=l.find(j=>O.areSameExtensions(j.identifier,U.identifier));F?(p.push(F),U.disabled&&g.push(U.identifier)):U.installed&&(w.push(U.identifier),U.disabled&&g.push(U.identifier))}return{installedExtensions:p,newExtensions:w,disabledExtensions:g,remoteExtensions:o}}};a=de([K(0,k.IExtensionManagementService),K(1,E.IIgnoredExtensionsManagementService),K(2,D.IFileService),K(3,L.IEnvironmentService),K(4,v.IUserDataSyncLogService)],a),e.AbstractExtensionsInitializer=a}),define(Z[189],ee([0,1,26,22]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(D,y,S,n,m){if(!y)return{remote:Object.keys(D).length>0?D:null,local:{added:{},removed:[],updated:{}}};const h=k(D,y);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const b=S?k(S,y):{added:Object.keys(y).reduce((I,d)=>(I.add(d),I),new Set),removed:new Set,updated:new Set},f=S?k(S,D):{added:Object.keys(D).reduce((I,d)=>(I.add(d),I),new Set),removed:new Set,updated:new Set},C={added:{},removed:[],updated:{}},P=v.deepClone(y),E=!S;for(const I of f.added.values())I!==R.SYNC_SERVICE_URL_TYPE&&E&&b.added.has(I)||(P[I]=D[I]);for(const I of f.updated.values())P[I]=D[I];for(const I of f.removed.values())n.unregistered.includes(I)||delete P[I];for(const I of b.added.values()){const d=y[I];if(n.machine.includes(I)){m.info(`GlobalState: Skipped adding ${I} in local storage because it is declared as machine scoped.`);continue}if(S&&f.added.has(I))continue;const c=D[I];c&&c.value===d.value||I===R.SYNC_SERVICE_URL_TYPE&&E&&f.added.has(I)||(c?C.updated[I]=d:C.added[I]=d)}for(const I of b.updated.values()){const d=y[I];if(n.machine.includes(I)){m.info(`GlobalState: Skipped updating ${I} in local storage because it is declared as machine scoped.`);continue}if(f.updated.has(I)||f.removed.has(I))continue;const c=D[I];c&&c.value===d.value||(C.updated[I]=d)}for(const I of b.removed.values()){if(n.machine.includes(I)){m.trace(`GlobalState: Skipped removing ${I} in local storage because it is declared as machine scoped.`);continue}f.updated.has(I)||f.removed.has(I)||C.removed.push(I)}return{local:C,remote:O(P,y)?null:P}}e.merge=L;function k(D,y){const S=Object.keys(D),n=Object.keys(y),m=n.filter(f=>S.indexOf(f)===-1).reduce((f,C)=>(f.add(C),f),new Set),h=S.filter(f=>n.indexOf(f)===-1).reduce((f,C)=>(f.add(C),f),new Set),b=new Set;for(const f of S){if(h.has(f))continue;const C=D[f],P=y[f];v.equals(C,P)||b.add(f)}return{added:m,removed:h,updated:b}}function O(D,y){const{added:S,removed:n,updated:m}=k(D,y);return S.size===0&&n.size===0&&m.size===0}}),define(Z[190],ee([0,1,22,25,3,9,10,52,189,32,45,24,23,5,46,40,21,7,44,30,15]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b,f,C,P,E,I,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const s="globalState.argv.",t=["locale"];function r(l){const p=l.storage?Object.keys(l.storage).sort():[],w={};p.forEach(F=>w[F]=l.storage[F]),l.storage=w;const g=JSON.stringify(l),U=f.format(g,void 0,{});return C.applyEdits(g,U)}const i=1;let a=class ct extends n.AbstractSynchroniser{constructor(p,w,g,U,F,j,z,V,q){super("globalState",p,F,q,w,g,j,z,U,V);this.storageService=q,this.version=i,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(p.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(p.onDidFilesChange,$=>$.contains(this.environmentService.argvResource)),L.Event.filter(q.onDidChangeValue,$=>$.scope===0&&$.target!==void 0?$.target===0:q.keys(0,0).includes($.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(p,w,g,U){const F=p.syncData?JSON.parse(p.syncData.content):null;w=w===null&&g?p:w;const j=w&&w.syncData?JSON.parse(w.syncData.content):null,z=await this.getLocalGlobalState();F?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const V=this.getStorageKeys(j),{local:q,remote:$}=y.merge(z.storage,F?F.storage:null,j?j.storage:null,V,this.logService),H={content:null,local:q,remote:$,localChange:Object.keys(q.added).length>0||Object.keys(q.updated).length>0||q.removed.length>0?2:0,remoteChange:$!==null?2:0};return[{localResource:this.localResource,localContent:r(z),localUserData:z,remoteResource:this.remoteResource,remoteContent:F?r(F):null,previewResource:this.previewResource,previewResult:H,localChange:H.localChange,remoteChange:H.remoteChange,acceptedResource:this.acceptedResource,storageKeys:V}]}async getMergeResult(p,w){return Object.assign(Object.assign({},p.previewResult),{hasConflicts:!1})}async getAcceptResult(p,w,g,U){if(this.extUri.isEqual(w,this.localResource))return this.acceptLocal(p);if(this.extUri.isEqual(w,this.remoteResource))return this.acceptRemote(p);if(this.extUri.isEqual(w,this.previewResource))return p.previewResult;throw new Error(`Invalid Resource: ${w.toString()}`)}async acceptLocal(p){return{content:p.localContent,local:{added:{},removed:[],updated:{}},remote:p.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(p){if(p.remoteContent!==null){const w=JSON.parse(p.remoteContent),{local:g,remote:U}=y.merge(p.localUserData.storage,w.storage,null,p.storageKeys,this.logService);return{content:p.remoteContent,local:g,remote:U,localChange:Object.keys(g.added).length>0||Object.keys(g.updated).length>0||g.removed.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:p.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(p,w,g,U){let{localUserData:F}=g[0][0],{local:j,remote:z,localChange:V,remoteChange:q}=g[0][1];if(V===0&&q===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),V!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(F)),await this.writeLocalGlobalState(j),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),q!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const $=JSON.stringify({storage:z});p=await this.updateRemoteUserData($,U?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}(w==null?void 0:w.ref)!==p.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(p),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:p}){return[{resource:this.extUri.joinPath(p,"globalState.json"),comparableResource:ct.GLOBAL_STATE_DATA_URI}]}async resolveContent(p){if(this.extUri.isEqual(p,ct.GLOBAL_STATE_DATA_URI)){const g=await this.getLocalGlobalState();return r(g)}if(this.extUri.isEqual(this.remoteResource,p)||this.extUri.isEqual(this.localResource,p)||this.extUri.isEqual(this.acceptedResource,p))return this.resolvePreviewContent(p);let w=await super.resolveContent(p);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(p)),w){const g=this.parseSyncData(w);if(g)switch(this.extUri.basename(p)){case"globalState.json":return r(JSON.parse(g.content))}}return null}async hasLocalData(){var p;try{const{storage:w}=await this.getLocalGlobalState();if(Object.keys(w).length>1||((p=w[`${s}.locale`])===null||p===void 0?void 0:p.value)!=="en")return!0}catch(w){}return!1}async getLocalGlobalState(){const p={},w=await this.getLocalArgvContent(),g=S.parse(w);for(const U of t)g[U]!==void 0&&(p[`${s}${U}`]={version:1,value:g[U]});for(const U of this.storageService.keys(0,0)){const F=this.storageService.get(U,0);F&&(p[U]={version:1,value:F})}return{storage:p}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(p){}return"{}"}async writeLocalGlobalState({added:p,removed:w,updated:g}){const U={},F={},j=(V,q)=>{for(const $ of V){if($.startsWith(s)){U[$.substring(s.length)]=q?q[$].value:void 0;continue}if(q){const H=q[$];H.value!==String(this.storageService.get($,0))&&(F[$]=H.value)}else this.storageService.get($,0)!==void 0&&(F[$]=void 0)}};if(j(Object.keys(p),p),j(Object.keys(g),g),j(w),Object.keys(U).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(U),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(F).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const V of Object.keys(F))this.storageService.store(V,F[V],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(F))}}async updateArgv(p){const w=await this.getLocalArgvContent();let g=w;for(const U of Object.keys(p))g=D.edit(g,[U],p[U],{});w!==g&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(g)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(p){const w=this.storageService.keys(0,0),g=this.storageService.keys(0,1),U=[...w,...g],F=(p==null?void 0:p.storage)?Object.keys(p.storage).filter(j=>!j.startsWith(s)&&!U.includes(j)&&this.storageService.get(j,0)!==void 0):[];if(!E.isWeb){const j=[...v.ALL_SYNC_RESOURCES.map(z=>v.getEnablementKey(z)),v.SYNC_SERVICE_URL_TYPE];F.push(...j),g.push(...j)}return{user:w,machine:g,unregistered:F}}};a.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),a=de([K(0,O.IFileService),K(1,v.IUserDataSyncStoreService),K(2,v.IUserDataSyncBackupStoreService),K(3,v.IUserDataSyncLogService),K(4,k.IEnvironmentService),K(5,v.IUserDataSyncResourceEnablementService),K(6,m.ITelemetryService),K(7,h.IConfigurationService),K(8,P.IStorageService)],a),e.GlobalStateSynchroniser=a;let u=class extends n.AbstractInitializer{constructor(p,w,g,U){super("globalState",g,U,w);this.storageService=p}async doInitialize(p){const w=p.syncData?JSON.parse(p.syncData.content):null;if(!w){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const g={},U={};for(const F of Object.keys(w.storage))F.startsWith(s)?g[F.substring(s.length)]=w.storage[F].value:this.storageService.get(F,0)===void 0&&(U[F]=w.storage[F].value);if(Object.keys(g).length){let F="{}";try{F=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(j){}for(const j of Object.keys(g))F=D.edit(F,[j],g[j],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(F))}if(Object.keys(U).length)for(const F of Object.keys(U))this.storageService.store(F,U[F],0,0)}};u=de([K(0,P.IStorageService),K(1,O.IFileService),K(2,k.IEnvironmentService),K(3,v.IUserDataSyncLogService)],u),e.GlobalStateInitializer=u;let o=class{constructor(p,w,g,U,F){this.userDataSyncStoreClient=p,this.storageService=w,this.environmentService=g,this.fileService=U,this.logService=F}getSyncStoreType(p){var w;const g=this.parseGlobalState(p);return(w=g==null?void 0:g.storage[v.SYNC_SERVICE_URL_TYPE])===null||w===void 0?void 0:w.value}async sync(p){const w=v.createSyncHeaders(d.generateUuid());try{return await this.doSync(p,w)}catch(g){if(g instanceof v.UserDataSyncError)switch(g.code){case v.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(p,w)}throw g}}async doSync(p,w){const g=await this.userDataSyncStoreClient.read("globalState",null,w),U=this.parseGlobalState(g)||{storage:{}};U.storage[v.SYNC_SERVICE_URL_TYPE]={value:p,version:i};const F=await I.getServiceMachineId(this.environmentService,this.fileService,this.storageService),j={version:i,machineId:F,content:r(U)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(j),g.ref,w)}parseGlobalState({content:p}){if(!p)return null;const w=JSON.parse(p);if(n.isSyncData(w))return w?JSON.parse(w.content):null;throw new Error("Invalid remote data")}};o=de([K(1,P.IStorageService),K(2,k.IEnvironmentService),K(3,O.IFileService),K(4,c.ILogService)],o),e.UserDataSyncStoreTypeSynchronizer=o}),define(Z[191],ee([0,1,10,22,186,32,124,9,23,7,16,19,45,24,21,25,3]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b,f,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function E(c,s){const t=JSON.parse(c);if(!s)return n.isUndefined(t.all)?null:t.all;switch(S.OS){case 2:return n.isUndefined(t.mac)?null:t.mac;case 3:return n.isUndefined(t.linux)?null:t.linux;case 1:return n.isUndefined(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=E;let I=class extends h.AbstractJsonFileSynchroniser{constructor(s,t,r,i,a,u,o,l,p,w){super(o.keybindingsResource,"keybindings",u,o,l,s,t,a,w,r,p,i);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(P.Event.filter(i.onDidChangeConfiguration,g=>g.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(s,t,r,i){const a=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null;t=t===null&&r?s:t;const u=t?this.getKeybindingsContentFromLastSyncUserData(t):null,o=await this.getLocalFileContent(),l=await this.getFormattingOptions();let p=null,w=!1,g=!1,U=!1;if(a){let j=o?o.value.toString():"[]";if(j=j||"[]",this.hasErrors(j))throw new R.UserDataSyncError(O.localize(0,null),R.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!u||u!==j||u!==a){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const z=await L.merge(j,a,u,l,this.userDataSyncUtilService);z.hasChanges&&(p=z.mergeContent,U=z.hasConflicts,w=U||z.mergeContent!==j,g=U||z.mergeContent!==a)}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),p=o.value.toString(),g=!0);const F={content:p,localChange:w?o?2:1:0,remoteChange:g?2:0,hasConflicts:U};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:a,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async getMergeResult(s,t){return s.previewResult}async getAcceptResult(s,t,r,i){if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,r,i){var a;const{fileContent:u}=r[0][0];let{content:o,localChange:l,remoteChange:p}=r[0][1];if(l===0&&p===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o)))throw new R.UserDataSyncError(O.localize(1,null),R.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),u&&await this.backupLocal(this.toSyncContent(u.value.toString())),await this.updateLocalFileContent(o||"[]",u,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),p!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const w=this.toSyncContent(o||"[]",(a=s.syncData)===null||a===void 0?void 0:a.content);s=await this.updateRemoteUserData(w,i?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(w){}(t==null?void 0:t.ref)!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(s,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=k.parse(s.value.toString());if(m.isNonEmptyArray(t))return!0}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"keybindings.json"),comparableResource:t}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let t=await super.resolveContent(s);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(s)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(s)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(r.content)}}return null}getKeybindingsContentFromLastSyncUserData(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(s.syncData.content)}getKeybindingsContentFromSyncContent(s){try{return E(s,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(s,t){let r={};try{r=JSON.parse(t||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=s,S.OS){case 2:r.mac=s;break;case 3:r.linux=s;break;case 1:r.windows=s;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){let s=this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return s!==void 0||(s=this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,s!==void 0)?s:this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};I=de([K(0,R.IUserDataSyncStoreService),K(1,R.IUserDataSyncBackupStoreService),K(2,R.IUserDataSyncLogService),K(3,y.IConfigurationService),K(4,R.IUserDataSyncResourceEnablementService),K(5,v.IFileService),K(6,D.IEnvironmentService),K(7,f.IStorageService),K(8,R.IUserDataSyncUtilService),K(9,b.ITelemetryService)],I),e.KeybindingsSynchroniser=I;let d=class extends h.AbstractInitializer{constructor(s,t,r){super("keybindings",t,r,s)}async doInitialize(s){const t=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,C.VSBuffer.fromString(t)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.environmentService.settingsResource),t=k.parse(s.value.toString());return!m.isNonEmptyArray(t)}catch(s){return s.fileOperationResult===1}}getKeybindingsContentFromSyncContent(s){try{return E(s,!0)}catch(t){return this.logService.error(t),null}}};d=de([K(0,v.IFileService),K(1,D.IEnvironmentService),K(2,R.IUserDataSyncLogService)],d),e.KeybindingsInitializer=d}),define(Z[192],ee([0,1,26,32,40,46,52,22,19]),function(G,e,v,R,L,k,O,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function S(o,l,p){let w=[];p?w=m(p):w=n(l);const g=[],U=[...D.getDisallowedIgnoredSettings()];if(Array.isArray(w))for(const F of w)F.startsWith("-")?U.push(F.substring(1)):g.push(F);return y.distinct([...o,...g].filter(F=>U.indexOf(F)===-1))}e.getIgnoredSettings=S;function n(o){let l=o.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=o.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:o.getValue("settingsSync.ignoredSettings")||[]}function m(o){const l=R.parse(o);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function h(o,l,p,w){if(p.length){const g=u(l),U=R.parse(l),F=R.parse(o),j=[];for(const z of p){const V=U[z],q=F[z];V===void 0?o=O.edit(o,[z],void 0,w):q!==void 0?o=O.edit(o,[z],V,w):j.push(s(z,g))}j.sort((z,V)=>z.startOffset-V.startOffset),j.forEach(z=>o=E(z.setting.key,l,o,w))}return o}e.updateIgnoredSettings=h;function b(o,l,p,w,g,U){const F=h(o,l,w,U),j=p!==F,z=p!==l;if(!j&&!z)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(j&&!z)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(z&&!j)return{conflictsSettings:[],localContent:h(l,o,w,U),remoteContent:null,hasConflicts:!1};if(p===null&&C(o)){const ne=f(o,l,w)?null:h(l,o,w,U);return{conflictsSettings:[],localContent:ne,remoteContent:null,hasConflicts:!1}}let V=o,q=l;const $=R.parse(o),H=R.parse(l),X=p?R.parse(p):null,_=w.reduce((ne,ce)=>(ne.add(ce),ne),new Set),T=P($,H,_),A=P(X,$,_),M=P(X,H,_),N=new Map,B=new Set,W=ne=>{B.add(ne);const ce=g.filter(({key:le})=>le===ne)[0];ce?(V=O.edit(V,[ne],ce.value,U),q=O.edit(q,[ne],ce.value,U)):N.set(ne,{key:ne,localValue:$[ne],remoteValue:H[ne]})};for(const ne of A.removed.values())M.updated.has(ne)?W(ne):q=O.edit(q,[ne],void 0,U);for(const ne of M.removed.values())B.has(ne)||(A.updated.has(ne)?W(ne):V=O.edit(V,[ne],void 0,U));for(const ne of A.updated.values())B.has(ne)||(M.updated.has(ne)?T.updated.has(ne)&&W(ne):q=O.edit(q,[ne],$[ne],U));for(const ne of M.updated.values())B.has(ne)||(A.updated.has(ne)?T.updated.has(ne)&&W(ne):V=O.edit(V,[ne],H[ne],U));for(const ne of A.added.values())B.has(ne)||(M.added.has(ne)?T.updated.has(ne)&&W(ne):q=E(ne,V,q,U));for(const ne of M.added.values())B.has(ne)||(A.added.has(ne)?T.updated.has(ne)&&W(ne):V=E(ne,q,V,U));const Q=N.size>0||!f(V,q,w),J=Q||!f(V,o,[]),ie=Q||!f(q,l,[]);return{localContent:J?V:null,remoteContent:ie?q:null,conflictsSettings:[...N.values()],hasConflicts:Q}}e.merge=b;function f(o,l,p){if(o===l)return!0;const w=R.parse(o),g=R.parse(l),U=p.reduce((z,V)=>(z.add(V),z),new Set),F=u(o).filter(z=>!(z.setting&&U.has(z.setting.key))),j=u(l).filter(z=>!(z.setting&&U.has(z.setting.key)));if(F.length!==j.length)return!1;for(let z=0;z<F.length;z++){const V=F[z],q=j[z];if(V.setting&&q.setting){if(V.setting.key!==q.setting.key||!v.equals(w[V.setting.key],g[V.setting.key]))return!1}else if(!V.setting&&!q.setting){if(V.value!==q.value)return!1}else return!1}return!0}e.areSame=f;function C(o){return o?u(o).length===0:!0}e.isEmpty=C;function P(o,l,p){const w=o?Object.keys(o).filter(z=>!p.has(z)):[],g=Object.keys(l).filter(z=>!p.has(z)),U=g.filter(z=>w.indexOf(z)===-1).reduce((z,V)=>(z.add(V),z),new Set),F=w.filter(z=>g.indexOf(z)===-1).reduce((z,V)=>(z.add(V),z),new Set),j=new Set;if(o)for(const z of w){if(F.has(z))continue;const V=o[z],q=l[z];v.equals(V,q)||j.add(z)}return{added:U,removed:F,updated:j}}function E(o,l,p,w){const g=R.parse(l),U=u(l),F=u(p),j=I(o,U,F);return d(p,o,g[o],j,F,w)}e.addSetting=E;function I(o,l,p){const w=l.findIndex(U=>{var F;return((F=U.setting)===null||F===void 0?void 0:F.key)===o}),g=l[w-1];if(g){if(g.setting){const F=s(g.setting.key,p);if(F)return{index:p.indexOf(F),insertAfter:!0}}else{const F=t(w,l);if(F){const j=s(F.setting.key,p);if(j){const z=r(p.indexOf(j),p),V=i(l,F,l[w]);if(z){const q=i(p,j,z),$=a(V,q);return $?{index:p.indexOf($),insertAfter:!0}:{index:p.indexOf(z),insertAfter:!1}}else{const q=i(p,j,p[p.length-1]),$=a(V,q);return $?{index:p.indexOf($),insertAfter:!0}:{index:p.length-1,insertAfter:!0}}}}}const U=l[w+1];if(U)if(U.setting){const F=s(U.setting.key,p);if(F)return{index:p.indexOf(F),insertAfter:!1}}else{const F=r(w,l);if(F){const j=s(F.setting.key,p);if(j){const z=t(p.indexOf(j),p),V=i(l,l[w],F);if(z){const q=i(p,z,j),$=a(V.reverse(),q.reverse());return $?{index:p.indexOf($),insertAfter:!1}:{index:p.indexOf(z),insertAfter:!0}}else{const q=i(p,p[0],j),$=a(V.reverse(),q.reverse());return $?{index:p.indexOf($),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:p.length-1,insertAfter:!0}}function d(o,l,p,w,g,U){let F;return w.index===-1?F=L.setProperty(o,[l],p,U):F=c(o,l,p,w,g,U).map(j=>L.withFormatting(o,j,U)[0]),L.applyEdits(o,F)}function c(o,l,p,w,g,U){var F;const j=`${JSON.stringify(l)}: ${JSON.stringify(p)}`,z=k.getEOL(U,o),V=g[w.index];if(w.insertAfter){const q=[];if(V.setting)q.push({offset:V.endOffset,length:0,content:","+j});else{const $=r(w.index,g),H=t(w.index,g),X=(F=H==null?void 0:H.setting)===null||F===void 0?void 0:F.commaOffset;H&&X===void 0&&q.push({offset:H.endOffset,length:0,content:","});const _=X!==void 0&&X>V.endOffset;q.push({offset:_?X+1:V.endOffset,length:0,content:$?z+j+",":z+j})}return q}else{if(V.setting)return[{offset:V.startOffset,length:0,content:j+","}];const q=(g[w.index-1]&&!g[w.index-1].setting?z:"")+j+(r(w.index,g)?",":"")+z;return[{offset:V.startOffset,length:0,content:q}]}}function s(o,l){return l.filter(p=>{var w;return((w=p.setting)===null||w===void 0?void 0:w.key)===o})[0]}function t(o,l){for(let p=o-1;p>=0;p--)if(l[p].setting)return l[p]}function r(o,l){for(let p=o+1;p<l.length;p++)if(l[p].setting)return l[p]}function i(o,l,p){const w=o.indexOf(l),g=o.indexOf(p);return o.filter((U,F)=>w<F&&F<g)}function a(o,l){if(o.length&&l.length){let p=0;for(;p<l.length&&p<o.length;p++)if(o[p].value!==l[p].value)return l[p-1];return l[p-1]}}function u(o){const l=[];let p=-1,w,g;const U={onObjectBegin:F=>{p++},onObjectProperty:(F,j,z)=>{p===0&&(w=j,g=F)},onObjectEnd:(F,j)=>{p--,p===0&&l.push({startOffset:w,endOffset:F+j,value:o.substring(w,F+j),setting:{key:g,commaOffset:void 0}})},onArrayBegin:(F,j)=>{p++},onArrayEnd:(F,j)=>{p--,p===0&&l.push({startOffset:w,endOffset:F+j,value:o.substring(w,F+j),setting:{key:g,commaOffset:void 0}})},onLiteralValue:(F,j,z)=>{p===0&&l.push({startOffset:w,endOffset:j+z,value:o.substring(w,j+z),setting:{key:g,commaOffset:void 0}})},onSeparator:(F,j,z)=>{if(p===0&&F===","){let V=l.length-1;for(;V>=0&&!l[V].setting;V--);const q=l[V];q&&l.splice(V,1,{startOffset:q.startOffset,endOffset:q.endOffset,value:q.value,setting:{key:q.setting.key,commaOffset:j}})}},onComment:(F,j)=>{p===0&&l.push({startOffset:F,endOffset:F+j,value:o.substring(F,F+j)})}};return R.visit(o,U),l}}),define(Z[193],ee([0,1,10,22,25,125,3,9,23,192,52,45,24,28,21,40]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function P(s){return s&&s.settings&&typeof s.settings=="string"&&Object.keys(s).length===1}function E(s){const t=JSON.parse(s);return P(t)?t:{settings:s}}e.parseSettingsSyncContent=E;let I=class extends m.AbstractJsonFileSynchroniser{constructor(t,r,i,a,u,o,l,p,w,g,U){super(r.settingsResource,"settings",t,r,i,a,u,w,g,o,l,p);this.extensionManagementService=U,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,r,i,a){const u=await this.getLocalFileContent(),o=await this.getFormattingOptions(),l=this.getSettingsSyncContent(t);r=r===null&&i?t:r;const p=r?this.getSettingsSyncContent(r):null,w=await this.getIgnoredSettings();let g=null,U=!1,F=!1,j=!1;if(l){let V=u?u.value.toString().trim():"{}";V=V||"{}",this.validateContent(V),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const q=S.merge(V,l.settings,p?p.settings:null,w,[],o);g=q.localContent||q.remoteContent,U=q.localContent!==null,F=q.remoteContent!==null,j=q.hasConflicts}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),g=u.value.toString(),F=!0);const z={content:g,localChange:U?2:0,remoteChange:F?2:0,hasConflicts:j};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const i=await this.getFormattingOptions(),a=await this.getIgnoredSettings();return Object.assign(Object.assign({},t.previewResult),{content:t.previewResult.content?S.updateIgnoredSettings(t.previewResult.content,"{}",a,i):null})}async getAcceptResult(t,r,i,a){const u=await this.getFormattingOptions(),o=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?S.updateIgnoredSettings(t.fileContent.value.toString(),"{}",o,u):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?S.updateIgnoredSettings(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",o,u):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i!==null?S.updateIgnoredSettings(i,t.fileContent?t.fileContent.value.toString():"{}",o,u):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,i,a){const{fileContent:u}=i[0][0];let{content:o,localChange:l,remoteChange:p}=i[0][1];if(l===0&&p===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.validateContent(o),l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),u&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(u.value.toString()))),await this.updateLocalFileContent(o,u,a),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),p!==0){const w=await this.getFormattingOptions(),g=this.getSettingsSyncContent(t),U=await this.getIgnoredSettings(o);o=S.updateIgnoredSettings(o,g?g.settings:"{}",U,w),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(o)),a?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(w){}(r==null?void 0:r.ref)!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),i=n.edit(t.value.toString(),[R.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!S.isEmpty(i)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const i=this.parseSyncData(r);if(i){const a=this.parseSettingsSyncContent(i.content);if(a)switch(this.extUri.basename(t)){case"settings.json":return a.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const i=await this.getFormattingOptions(),a=await this.getIgnoredSettings();r=S.updateIgnoredSettings(r,"{}",a,i)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return E(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=O.Event.any(O.Event.filter(this.extensionManagementService.onDidInstallExtension,a=>!!a.gallery),O.Event.filter(this.extensionManagementService.onDidUninstallExtension,a=>!a.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return S.getIgnoredSettings(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new R.UserDataSyncError(k.localize(0,null),R.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!c(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const i=this.parseSettingsSyncContent(r.content);if(!i||!i.settings)return;let a=i.settings;const u=await this.getFormattingOptions();for(const o in r)if(["version","content","machineId"].indexOf(o)===-1&&r[o]!==void 0){const l=C.setProperty(a,[o],r[o],u);l.length&&(a=C.applyEdits(a,l))}await this.fileService.writeFile(this.file,L.VSBuffer.fromString(a))}catch(t){}}};I=de([K(0,v.IFileService),K(1,D.IEnvironmentService),K(2,f.IStorageService),K(3,R.IUserDataSyncStoreService),K(4,R.IUserDataSyncBackupStoreService),K(5,R.IUserDataSyncLogService),K(6,R.IUserDataSyncUtilService),K(7,y.IConfigurationService),K(8,R.IUserDataSyncResourceEnablementService),K(9,h.ITelemetryService),K(10,b.IExtensionManagementService)],I),e.SettingsSynchroniser=I;let d=class extends m.AbstractInitializer{constructor(t,r,i){super("settings",r,i,t)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,L.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return S.isEmpty(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return E(t)}catch(r){this.logService.error(r)}return null}};d=de([K(0,v.IFileService),K(1,D.IEnvironmentService),K(2,R.IUserDataSyncLogService)],d),e.SettingsInitializer=d;function c(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&s.machineId!==void 0&&typeof s.machineId=="string")}}),define(Z[194],ee([0,1,22,9,10,23,45,24,25,187,21,26,3]),function(G,e,v,R,L,k,O,D,y,S,n,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let b=class extends O.AbstractSynchroniser{constructor(P,E,I,d,c,s,t,r,i){super("snippets",E,P,I,d,c,r,i,s,t);this.version=1,this.snippetsFolder=P.snippetsHome,this._register(this.fileService.watch(P.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(h.Event.filter(this.fileService.onDidFilesChange,a=>a.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(P,E,I,d){const c=await this.getSnippetsFileContents(),s=this.toSnippetsContents(c),t=P.syncData?this.parseSnippets(P.syncData):null;E=E===null&&I?P:E;const r=E&&E.syncData?this.parseSnippets(E.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=S.merge(s,t,r);return this.getResourcePreviews(i,c,t||{})}async getMergeResult(P,E){return P.previewResult}async getAcceptResult(P,E,I,d){if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:P.fileContent?P.fileContent.value.toString():null,localChange:0,remoteChange:P.fileContent?P.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:P.remoteContent,localChange:P.remoteContent!==null?P.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder))return I===void 0?{content:P.previewResult.content,localChange:P.previewResult.localChange,remoteChange:P.previewResult.remoteChange}:{content:I,localChange:I===null?P.fileContent!==null?3:0:2,remoteChange:I===null?P.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${E.toString()}`)}async applyResult(P,E,I,d){const c=I.map(([s,t])=>Object.assign(Object.assign({},s),{acceptResult:t}));c.every(({localChange:s,remoteChange:t})=>s===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),c.some(({localChange:s})=>s!==0)&&(await this.updateLocalBackup(c),await this.updateLocalSnippets(c,d)),c.some(({remoteChange:s})=>s!==0)&&(P=await this.updateRemoteSnippets(c,P,d)),(E==null?void 0:E.ref)!==P.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(P),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:s}of c)try{await this.fileService.del(s)}catch(t){}}getResourcePreviews(P,E,I){const d=new Map;for(const c of Object.keys(P.local.added)){const s={content:P.local.added[c],hasConflicts:!1,localChange:1,remoteChange:0};d.set(c,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(P.local.updated)){const s={content:P.local.updated[c],hasConflicts:!1,localChange:2,remoteChange:0};d.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[c],localContent:E[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of P.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0};d.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[c],localContent:E[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(P.remote.added)){const s={content:P.remote.added[c],hasConflicts:!1,localChange:0,remoteChange:1};d.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[c],localContent:E[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(P.remote.updated)){const s={content:P.remote.updated[c],hasConflicts:!1,localChange:0,remoteChange:2};d.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[c],localContent:E[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of P.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};d.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of P.conflicts){const s={content:E[c]?E[c].value.toString():null,hasConflicts:!0,localChange:E[c]?2:1,remoteChange:I[c]?2:1};d.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[c]||null,localContent:E[c]?E[c].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[c]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(E))if(!d.has(c)){const s={content:E[c]?E[c].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};d.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[c]||null,localContent:E[c]?E[c].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[c]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...d.values()]}async getAssociatedResources({uri:P}){let E=await super.resolveContent(P);if(E){const I=this.parseSyncData(E);if(I){const d=this.parseSnippets(I),c=[];for(const s of Object.keys(d)){const t=this.extUri.joinPath(P,s),r=this.extUri.joinPath(this.snippetsFolder,s),i=await this.fileService.exists(r);c.push({resource:t,comparableResource:i?r:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"})})}return c}}return[]}async resolveContent(P){if(this.extUri.isEqualOrParent(P,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(P,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(P,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(P);let E=await super.resolveContent(P);if(E)return E;if(E=await super.resolveContent(this.extUri.dirname(P)),E){const I=this.parseSyncData(E);if(I)return this.parseSnippets(I)[this.extUri.basename(P)]||null}return null}async hasLocalData(){try{const P=await this.getSnippetsFileContents();if(Object.keys(P).length)return!0}catch(P){}return!1}async updateLocalBackup(P){const E={};for(const I of P)I.fileContent&&(E[this.extUri.basename(I.localResource)]=I.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(E)))}async updateLocalSnippets(P,E){for(const{fileContent:I,acceptResult:d,localResource:c,remoteResource:s,localChange:t}of P)if(t!==0){const r=s?this.extUri.basename(s):this.extUri.basename(c),i=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(i)),await this.fileService.del(i),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(i))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(i)),await this.fileService.createFile(i,y.VSBuffer.fromString(d.content),{overwrite:E}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(i))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(i)),await this.fileService.writeFile(i,y.VSBuffer.fromString(d.content),E?void 0:I),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(i)))}}async updateRemoteSnippets(P,E,I){const d=E.syncData?this.parseSnippets(E.syncData):{},c=m.deepClone(d);for(const{acceptResult:s,localResource:t,remoteResource:r,remoteChange:i}of P)if(i!==0){const a=t?this.extUri.basename(t):this.extUri.basename(r);i===3?delete c[a]:c[a]=s.content}return S.areSame(d,c)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),E=await this.updateRemoteUserData(JSON.stringify(c),I?null:E.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),E}parseSnippets(P){return JSON.parse(P.content)}toSnippetsContents(P){const E={};for(const I of Object.keys(P))E[I]=P[I].value.toString();return E}async getSnippetsFileContents(){const P={};let E;try{E=await this.fileService.resolve(this.snippetsFolder)}catch(I){if(I instanceof L.FileOperationError&&I.fileOperationResult===1)return P;throw I}for(const I of E.children||[]){const d=I.resource,c=this.extUri.extname(d);if(c===".json"||c===".code-snippets"){const s=this.extUri.relativePath(this.snippetsFolder,d),t=await this.fileService.readFile(d);P[s]=t}}return P}};b=de([K(0,R.IEnvironmentService),K(1,L.IFileService),K(2,n.IStorageService),K(3,v.IUserDataSyncStoreService),K(4,v.IUserDataSyncBackupStoreService),K(5,v.IUserDataSyncLogService),K(6,k.IConfigurationService),K(7,v.IUserDataSyncResourceEnablementService),K(8,D.ITelemetryService)],b),e.SnippetsSynchroniser=b;let f=class extends O.AbstractInitializer{constructor(P,E,I){super("snippets",E,I,P)}async doInitialize(P){const E=P.syncData?JSON.parse(P.syncData.content):null;if(!E){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const d of Object.keys(E)){const c=E[d];if(c){const s=this.extUri.joinPath(this.environmentService.snippetsHome,d);await this.fileService.createFile(s,y.VSBuffer.fromString(c)),this.logService.info("Created snippet",this.extUri.basename(s))}}await this.updateLastSyncUserData(P)}async isEmpty(){var P;try{return!((P=(await this.fileService.resolve(this.environmentService.snippetsHome)).children)===null||P===void 0?void 0:P.length)}catch(E){return E.fileOperationResult===1}}};f=de([K(0,L.IFileService),K(1,R.IEnvironmentService),K(2,v.IUserDataSyncLogService)],f),e.SnippetsInitializer=f}),define(Z[60],ee([0,1,4,3,2,22]),function(G,e,v,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=v.createDecorator("IUserDataSyncAccountService");let O=class extends L.Disposable{constructor(y){super();this.userDataSyncStoreService=y,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(y.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(y.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(y){(y&&this._account?y.token!==this._account.token||y.authenticationProviderId!==this._account.authenticationProviderId:y!==this._account)&&(this._account=y,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(y))}};O=de([K(0,k.IUserDataSyncStoreService)],O),e.UserDataSyncAccountService=O}),define(Z[195],ee([0,1,2,22,12,23,10,9,55,25,6]),function(G,e,v,R,L,k,O,D,y,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let m=class extends v.Disposable{constructor(b,f,C,P){super();this.environmentService=b,this.fileService=f,this.configurationService=C,this.logService=P,R.ALL_SYNC_RESOURCES.forEach(E=>this.cleanUpBackup(E))}async getAllRefs(b){const f=L.joinPath(this.environmentService.userDataSyncHome,b),C=await this.fileService.resolve(f);return C.children?C.children.filter(E=>E.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(E.name)).sort().reverse().map(E=>({ref:E.name,created:this.getCreationTime(E)})):[]}async resolveContent(b,f){if(!f){const C=await this.getAllRefs(b);C.length&&(f=C[C.length-1].ref)}if(f){const C=L.joinPath(this.environmentService.userDataSyncHome,b,f);return(await this.fileService.readFile(C)).value.toString()}return null}async backup(b,f){const C=L.joinPath(this.environmentService.userDataSyncHome,b),P=L.joinPath(C,`${y.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(P,S.VSBuffer.fromString(f))}catch(E){this.logService.error(E)}try{this.cleanUpBackup(b)}catch(E){}}async cleanUpBackup(b){const f=L.joinPath(this.environmentService.userDataSyncHome,b);try{try{if(!await this.fileService.exists(f))return}catch(P){return}const C=await this.fileService.resolve(f);if(C.children){const P=C.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),E=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let I=P.filter(c=>Date.now()-this.getCreationTime(c)>E);const d=P.length-I.length;d<10&&(I=I.slice(10-d)),await n.Promises.settled(I.map(async c=>{this.logService.info("Deleting from backup",c.resource.path),await this.fileService.del(c.resource)}))}}catch(C){this.logService.error(C)}}getCreationTime(b){return b.ctime||new Date(parseInt(b.name.substring(0,4)),parseInt(b.name.substring(4,6))-1,parseInt(b.name.substring(6,8)),parseInt(b.name.substring(9,11)),parseInt(b.name.substring(11,13)),parseInt(b.name.substring(13,15))).getTime()}};m=de([K(0,D.IEnvironmentService),K(1,O.IFileService),K(2,k.IConfigurationService),K(3,R.IUserDataSyncLogService)],m),e.UserDataSyncBackupStoreService=m}),define(Z[196],ee([0,1,5,2]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class L{constructor(h){this.service=h}listen(h,b){switch(b){case"onError":return this.service.onError}throw new Error(`Event not found: ${b}`)}call(h,b,f){switch(b){case"triggerSync":return this.service.triggerSync(f[0],f[1],f[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(f[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=L;class k{constructor(h){this.service=h}listen(h,b){throw new Error(`Event not found: ${b}`)}call(h,b,f){switch(b){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(f[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(v.URI.revive(f[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class O{constructor(h){this.channel=h}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(h){return this.channel.call("resolveUserKeybindings",[h])}async resolveFormattingOptions(h){return this.channel.call("resolveFormattingOptions",[h])}}e.UserDataSyncUtilServiceClient=O;class D{constructor(h){this.service=h}listen(h,b){switch(b){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${b}`)}async call(h,b,f){switch(b){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(f[0],f[1]);case"setEnablement":return this.service.setEnablement(f[0],f[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=D;class y{constructor(h){this.service=h}listen(h,b){switch(b){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${b}`)}call(h,b,f){switch(b){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(f)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=y;class S{constructor(h){this.service=h}listen(h,b){switch(b){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${b}`)}call(h,b,f){switch(b){case"switch":return this.service.switch(f[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;class n extends R.Disposable{constructor(h){super();this.channel=h,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(h){return this.channel.call("switch",[h])}async getPreviousUserDataSyncStore(){const h=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(h)}revive(h){return{url:v.URI.revive(h.url),type:h.type,defaultUrl:v.URI.revive(h.defaultUrl),insidersUrl:v.URI.revive(h.insidersUrl),stableUrl:v.URI.revive(h.stableUrl),canSwitch:h.canSwitch,authenticationProviders:h.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(Z[197],ee([0,1,15,9]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends v.AbstractLogger{constructor(O,D){super();this.logger=this._register(O.createLogger(D.userDataSyncLogResource,{name:"settingssync"}))}trace(O,...D){this.logger.trace(O,...D)}debug(O,...D){this.logger.debug(O,...D)}info(O,...D){this.logger.info(O,...D)}warn(O,...D){this.logger.warn(O,...D)}error(O,...D){this.logger.error(O,...D)}critical(O,...D){this.logger.critical(O,...D)}flush(){this.logger.flush()}};L=de([K(0,v.ILoggerService),K(1,R.IEnvironmentService)],L),e.UserDataSyncLogService=L}),define(Z[61],ee([0,1,4,2,44,9,10,21,22,128,27,7,20,3]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=v.createDecorator("IUserDataSyncMachinesService");const f="sync.currentMachineName";let C=class Ge extends R.Disposable{constructor(E,I,d,c,s,t){super();this.storageService=d,this.userDataSyncStoreService=c,this.logService=s,this.productService=t,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=L.getServiceMachineId(E,I,d)}async getMachines(E){const I=await this.currentMachineIdPromise;return(await this.readMachinesData(E)).machines.map(c=>Object.assign(Object.assign({},c),{isCurrent:c.id===I}))}async addCurrentMachine(E){const I=await this.currentMachineIdPromise,d=await this.readMachinesData(E);d.machines.some(({id:c})=>c===I)||(d.machines.push({id:I,name:this.computeCurrentMachineName(d.machines)}),await this.writeMachinesData(d))}async removeCurrentMachine(E){const I=await this.currentMachineIdPromise,d=await this.readMachinesData(E),c=d.machines.filter(({id:s})=>s!==I);c.length!==d.machines.length&&(d.machines=c,await this.writeMachinesData(d))}async renameMachine(E,I,d){const c=await this.currentMachineIdPromise,s=await this.readMachinesData(d),t=s.machines.find(({id:r})=>r===E);t&&(t.name=I,await this.writeMachinesData(s),s.machines.some(({id:r})=>r===c)&&this.storageService.store(f,I,0,1))}async setEnablement(E,I){const d=await this.readMachinesData(),c=d.machines.find(({id:s})=>s===E);c&&(c.disabled=I?void 0:!0,await this.writeMachinesData(d))}computeCurrentMachineName(E){const I=this.storageService.get(f,0);if(I)return I;const d=`${this.productService.nameLong} (${m.PlatformToString(m.isWeb?0:m.platform)})`,c=new RegExp(`${h.escapeRegExpCharacters(d)}\\s#(\\d+)`);let s=0;for(const t of E){const r=c.exec(t.name),i=r?parseInt(r[1]):0;s=i>s?i:s}return`${d} #${s+1}`}async readMachinesData(E){this.userData=await this.readUserData(E);const I=this.parse(this.userData);if(I.version!==Ge.VERSION)throw new Error(S.localize(0,null,this.productService.nameLong));return I}async writeMachinesData(E){var I;const d=JSON.stringify(E),c=await this.userDataSyncStoreService.write(Ge.RESOURCE,d,((I=this.userData)===null||I===void 0?void 0:I.ref)||null);this.userData={ref:c,content:d},this._onDidChange.fire()}async readUserData(E){if(this.userData){const I=E&&E.latest?E.latest[Ge.RESOURCE]:void 0;if(this.userData.ref===I)return this.userData;if(I===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ge.RESOURCE,this.userData)}parse(E){if(E.content!==null)try{return JSON.parse(E.content)}catch(I){this.logService.error(I)}return{version:Ge.VERSION,machines:[]}}};C.VERSION=1,C.RESOURCE="machines",C=de([K(0,k.IEnvironmentService),K(1,O.IFileService),K(2,D.IStorageService),K(3,y.IUserDataSyncStoreService),K(4,y.IUserDataSyncLogService),K(5,n.IProductService)],C),e.UserDataSyncMachinesService=C}),define(Z[87],ee([0,1,6,3,2,22,60,24,11,21,9,61,126,55,5,12,7,27]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b,f,C,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const I="sync.enable",d="sync.disableMachineEventually",c="sync.sessionId",s="sync.storeUrl",t="sync.productQuality";let r=class extends L.Disposable{constructor(o,l,p){super();this.storageService=o,this.environmentService=l,this.userDataSyncStoreManagementService=p,this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(o.onDidChangeValue(w=>this.onDidStorageChange(w)))}isEnabled(o){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(I,0,!!o)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(o){o&&!this.canToggleEnablement()||this.storageService.store(I,o,0,1)}onDidStorageChange(o){if(o.scope===0&&I===o.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};r=de([K(0,S.IStorageService),K(1,n.IEnvironmentService),K(2,k.IUserDataSyncStoreManagementService)],r),e.UserDataAutoSyncEnablementService=r;let i=class extends L.Disposable{constructor(o,l,p,w,g,U,F,j,z,V,q){var $;super();this.userDataSyncStoreManagementService=l,this.userDataSyncStoreService=p,this.userDataSyncResourceEnablementService=w,this.userDataSyncService=g,this.logService=U,this.userDataSyncAccountService=F,this.telemetryService=j,this.userDataSyncMachinesService=z,this.storageService=V,this.autoSync=this._register(new L.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=q,this.syncTriggerDelayer=this._register(new v.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=($=l.userDataSyncStore)===null||$===void 0?void 0:$.url,this.previousProductQuality=this.productQuality,this.productQuality=o.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(l.onDidChangeUserDataSyncStore(()=>{var H,X;C.isEqual(this.syncUrl,(H=l.userDataSyncStore)===null||H===void 0?void 0:H.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=(X=l.userDataSyncStore)===null||X===void 0?void 0:X.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(F.onDidChangeAccount(()=>this.updateAutoSync())),this._register(p.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(R.Event.debounce(g.onDidChangeLocal,(H,X)=>H?[...H,X]:[X],1e3)(H=>this.triggerSync(H,!1,!1))),this._register(R.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,H])=>H)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const o=this.storageService.get(s,0);return o?f.URI.parse(o):void 0}set syncUrl(o){o?this.storageService.store(s,o.toString(),0,1):this.storageService.remove(s,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(o){o?this.storageService.store(t,o,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:o,message:l}=this.isAutoSyncEnabled();o?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(p=>this.onDidFinishSync(p))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(l&&this.logService.info(l),this.autoSync.clear()):l&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(l))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${b.toLocalISOString(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(o,l,p){try{this.userDataSyncAccountService.account&&!p&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(c,0),o?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(w){if(l)this.logService.error(w),this.updateEnablement(!1);else throw w}}updateEnablement(o){this.userDataAutoSyncEnablementService.isEnabled()!==o&&(this.telemetryService.publicLog2(I,{enabled:o}),this.userDataAutoSyncEnablementService.setEnablement(o),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(o){if(!o){this.successiveFailures=0;return}const l=k.UserDataSyncError.toUserDataSyncError(o);l instanceof k.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:l.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),l.code===k.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):l.code===k.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):l.code===k.UserDataSyncErrorCode.LocalTooManyRequests||l.code===k.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):l.code===k.UserDataSyncErrorCode.UpgradeRequired||l.code===k.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):l.code===k.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${l.resource} content with newer version than of client. Requires client upgrade.`)):l.code===k.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${l.resource} content with older version than of client. Requires server reset.`)):l.code===k.UserDataSyncErrorCode.ServiceChanged||l.code===k.UserDataSyncErrorCode.DefaultServiceChanged?P.isWeb&&l.code===k.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(l),this.successiveFailures++),this._onError.fire(l)}async disableMachineEventually(){this.storageService.store(d,!0,0,1),await v.timeout(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(d,0,!1)}stopDisableMachineEventually(){this.storageService.remove(d,0)}async triggerSync(o,l,p){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(l&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...o),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",p)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};i=de([K(0,E.IProductService),K(1,k.IUserDataSyncStoreManagementService),K(2,k.IUserDataSyncStoreService),K(3,k.IUserDataSyncResourceEnablementService),K(4,k.IUserDataSyncService),K(5,k.IUserDataSyncLogService),K(6,O.IUserDataSyncAccountService),K(7,D.ITelemetryService),K(8,m.IUserDataSyncMachinesService),K(9,S.IStorageService),K(10,k.IUserDataAutoSyncEnablementService)],i),e.UserDataAutoSyncService=i;class a extends L.Disposable{constructor(o,l,p,w,g,U,F,j){super();this.lastSyncUrl=o,this.interval=l,this.userDataSyncStoreManagementService=p,this.userDataSyncStoreService=w,this.userDataSyncService=g,this.userDataSyncMachinesService=U,this.logService=F,this.storageService=j,this.intervalHandler=this._register(new L.MutableDisposable),this._onDidStartSync=this._register(new R.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new R.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register(L.toDisposable(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=v.disposableTimeout(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(o,l){const p=v.createCancelablePromise(async w=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(g){if(y.isPromiseCanceledError(g))return}return this.doSync(o,l,w)});return this.syncPromise=p,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){var o;return this.lastSyncUrl!==void 0&&!C.isEqual(this.lastSyncUrl,(o=this.userDataSyncStoreManagementService.userDataSyncStore)===null||o===void 0?void 0:o.url)}async hasDefaultServiceChanged(){const o=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),l=this.userDataSyncStoreManagementService.userDataSyncStore;return!!l&&!!o&&(!C.isEqual(l.defaultUrl,o.defaultUrl)||!C.isEqual(l.insidersUrl,o.insidersUrl)||!C.isEqual(l.stableUrl,o.stableUrl))}async doSync(o,l,p){this.logService.info(`Auto Sync: Triggered by ${o}`),this._onDidStartSync.fire();let w;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(l),p.isCancellationRequested)return;let g=this.syncTask.manifest;if(g===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new k.UserDataAutoSyncError(h.localize(0,null),k.UserDataSyncErrorCode.DefaultServiceChanged):new k.UserDataAutoSyncError(h.localize(1,null),k.UserDataSyncErrorCode.ServiceChanged):new k.UserDataAutoSyncError(h.localize(2,null),k.UserDataSyncErrorCode.TurnedOff);const U=this.storageService.get(c,0);if(U&&g&&U!==g.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new k.UserDataAutoSyncError(h.localize(3,null),k.UserDataSyncErrorCode.DefaultServiceChanged):new k.UserDataAutoSyncError(h.localize(4,null),k.UserDataSyncErrorCode.ServiceChanged):new k.UserDataAutoSyncError(h.localize(5,null),k.UserDataSyncErrorCode.SessionExpired);const F=await this.userDataSyncMachinesService.getMachines(g||void 0);if(p.isCancellationRequested)return;const j=F.find(z=>z.isCurrent);if(j==null?void 0:j.disabled)throw new k.UserDataAutoSyncError(h.localize(6,null),k.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),g===null&&(g=await this.userDataSyncStoreService.manifest()),g&&g.session!==U&&this.storageService.store(c,g.session,0,1),p.isCancellationRequested)return;j||await this.userDataSyncMachinesService.addCurrentMachine(g||void 0)}catch(g){this.logService.error(g),w=g}this._onDidFinishSync.fire(w)}register(o){return super._register(o)}}a.INTERVAL_SYNCING="Interval"}),define(Z[198],ee([0,1,22,2,3,21,24,7]),function(G,e,v,R,L,k,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let y=class extends R.Disposable{constructor(n,m){super();this.storageService=n,this.telemetryService=m,this._onDidChangeResourceEnablement=new L.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(h=>this.onDidStorageChange(h)))}isResourceEnabled(n){return this.storageService.getBoolean(v.getEnablementKey(n),0,!0)}setResourceEnablement(n,m){if(this.isResourceEnabled(n)!==m){const h=v.getEnablementKey(n);this.telemetryService.publicLog2(h,{enabled:m}),this.storeResourceEnablement(h,m)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,m){this.storageService.store(n,m,0,D.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const m=v.ALL_SYNC_RESOURCES.filter(h=>v.getEnablementKey(h)===n.key)[0];if(m){this._onDidChangeResourceEnablement.fire([m,this.isResourceEnabled(m)]);return}}}};y=de([K(0,k.IStorageService),K(1,O.ITelemetryService)],y),e.UserDataSyncResourceEnablementService=y}),define(Z[199],ee([0,1,22,2,4,3,188,191,190,43,24,19,21,193,12,194,30,6,11]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b,f,C,P,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const d="sync.lastSyncTime";let c=class extends R.Disposable{constructor(i,a,u,o,l,p){super();this.userDataSyncStoreService=i,this.userDataSyncStoreManagementService=a,this.instantiationService=u,this.logService=o,this.telemetryService=l,this.storageService=p,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(b.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(D.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(C.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(y.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(O.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(k.Event.any(...this.synchronisers.map(w=>k.Event.map(w.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(k.Event.any(...this.synchronisers.map(w=>k.Event.map(w.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(d,0,void 0),this.onDidChangeLocal=k.Event.any(...this.synchronisers.map(w=>k.Event.map(w.onDidChangeLocal,()=>w.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(i){await this.checkEnablement();const a=P.generateUuid();let u;try{const w=v.createSyncHeaders(a);i&&(w["Cache-Control"]="no-cache"),u=await this.userDataSyncStoreService.manifest(w)}catch(w){const g=v.UserDataSyncError.toUserDataSyncError(w);throw this.reportUserDataSyncError(g,a),g}let o=!1;const l=this;let p;return{manifest:u,run(){if(o)throw new Error("Can run a task only once");return p=E.createCancelablePromise(w=>l.sync(u,a,w)),p.finally(()=>p=void 0)},async stop(){if(p&&p.cancel(),l.status!=="idle")return l.stop()}}}async createManualSyncTask(){await this.checkEnablement();const i=P.generateUuid(),a=v.createSyncHeaders(i);let u;try{u=await this.userDataSyncStoreService.manifest(a)}catch(o){const l=v.UserDataSyncError.toUserDataSyncError(o);throw this.reportUserDataSyncError(l,i),l}return new s(i,u,a,this.synchronisers,this.logService)}async sync(i,a,u){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),u.isCancellationRequested)return;const o=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const l=v.createSyncHeaders(a);for(const p of this.synchronisers){if(u.isCancellationRequested)return;try{await p.sync(i,l)}catch(w){if(w instanceof v.UserDataSyncError)switch(w.code){case v.UserDataSyncErrorCode.TooLarge:throw new v.UserDataSyncError(w.message,w.code,p.resource);case v.UserDataSyncErrorCode.TooManyRequests:case v.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case v.UserDataSyncErrorCode.LocalTooManyRequests:case v.UserDataSyncErrorCode.Gone:case v.UserDataSyncErrorCode.UpgradeRequired:case v.UserDataSyncErrorCode.IncompatibleRemoteContent:case v.UserDataSyncErrorCode.IncompatibleLocalContent:throw w}const g=v.UserDataSyncError.toUserDataSyncError(w);this.reportUserDataSyncError(g,a),this.logService.error(w),this.logService.error(`${p.resource}: ${S.toErrorMessage(w)}`),this._syncErrors.push([p.resource,g])}}this.logService.info(`Sync done. Took ${new Date().getTime()-o}ms`),this.updateLastSyncTime()}catch(l){const p=v.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(p,a),p}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const i of this.synchronisers)try{i.status!=="idle"&&await i.stop()}catch(a){this.logService.error(a)}}async replace(i){await this.checkEnablement();for(const a of this.synchronisers)if(await a.replace(i))return}async accept(i,a,u,o){await this.checkEnablement();const l=this.getSynchroniser(i);await l.accept(a,u),o&&await l.apply(!1,v.createSyncHeaders(P.generateUuid()))}async resolveContent(i){for(const a of this.synchronisers){const u=await a.resolveContent(i);if(u)return u}return null}getRemoteSyncResourceHandles(i){return this.getSynchroniser(i).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(i){return this.getSynchroniser(i).getLocalSyncResourceHandles()}getAssociatedResources(i,a){return this.getSynchroniser(i).getAssociatedResources(a)}getMachineId(i,a){return this.getSynchroniser(i).getMachineId(a)}async hasLocalData(){const i=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const a of i)if(await a.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(i){this.logService.error(i)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(d,0);for(const i of this.synchronisers)try{await i.resetLocal()}catch(a){this.logService.error(`${i.resource}: ${S.toErrorMessage(a)}`),this.logService.error(a)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const i of this.synchronisers)if(await i.hasPreviouslySynced())return!0;return!1}setStatus(i){const a=this._status;this._status!==i&&(this._status=i,this._onDidChangeStatus.fire(i),a==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const i=this.computeStatus();this.setStatus(i)}updateConflicts(){const i=this.computeConflicts();m.equals(this._conflicts,i,([a,u],[o,l])=>a===a&&m.equals(u,l,(p,w)=>f.isEqual(p.previewResource,w.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(i))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(d,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(i,a){this.telemetryService.publicLog2("sync/error",{code:i.code,url:i instanceof v.UserDataSyncStoreError?i.url:void 0,resource:i.resource,executionId:a,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(i=>i.status==="hasConflicts").map(i=>[i.resource,i.conflicts.map(t)])}getSynchroniser(i){return this.synchronisers.find(a=>a.resource===i)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};c=de([K(0,v.IUserDataSyncStoreService),K(1,v.IUserDataSyncStoreManagementService),K(2,L.IInstantiationService),K(3,v.IUserDataSyncLogService),K(4,n.ITelemetryService),K(5,h.IStorageService)],c),e.UserDataSyncService=c;class s extends R.Disposable{constructor(i,a,u,o,l){super();this.id=i,this.manifest=a,this.syncHeaders=u,this.synchronisers=o,this.logService=l,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new k.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=E.createCancelablePromise(i=>this.getPreviews(i))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(i){throw this.logService.error(i),i}}async accept(i,a){try{return await this.performAction(i,u=>u.accept(i,a))}catch(u){throw this.logService.error(u),u}}async merge(i){try{return i?await this.performAction(i,a=>a.merge(i)):await this.mergeAll()}catch(a){throw this.logService.error(a),a}}async discard(i){try{return await this.performAction(i,a=>a.discard(i))}catch(a){throw this.logService.error(a),a}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const i=[];for(const[,a]of this.previews)for(const u of a.resourcePreviews)u.mergeState==="conflict"&&i.push(u.previewResource);for(const a of i)await this.discard(a);return this.previews}catch(i){throw this.logService.error(i),i}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const i=[];for(const[a,u]of this.previews){this.synchronizingResources.push([a,u.resourcePreviews.map(p=>p.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(p=>p.resource===a);for(const p of u.resourcePreviews)(p.localChange!==0||p.remoteChange!==0)&&p.mergeState==="preview"&&await o.merge(p.previewResource);const l=await o.apply(!1,this.syncHeaders);l&&i.push(this.toSyncResourcePreview(o.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(p=>p[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}catch(i){throw this.logService.error(i),i}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,a]of this.previews){this.synchronizingResources.push([i,a.resourcePreviews.map(o=>o.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(o=>o.resource===i);for(const o of a.resourcePreviews)await u.accept(o.remoteResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(o=>o[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,a]of this.previews){this.synchronizingResources.push([i,a.resourcePreviews.map(o=>o.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(o=>o.resource===i);for(const o of a.resourcePreviews)await u.accept(o.localResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(o=>o[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async stop(){for(const i of this.synchronisers)try{await i.stop()}catch(a){I.isPromiseCanceledError(a)||this.logService.error(a)}this.reset()}async performAction(i,a){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const u=this.previews.findIndex(([,j])=>j.resourcePreviews.some(({localResource:z,previewResource:V,remoteResource:q})=>f.isEqual(i,z)||f.isEqual(i,V)||f.isEqual(i,q)));if(u===-1)return this.previews;const[o,l]=this.previews[u],p=l.resourcePreviews.find(({localResource:j,remoteResource:z,previewResource:V})=>f.isEqual(j,i)||f.isEqual(z,i)||f.isEqual(V,i));if(!p)return this.previews;let w=this.synchronizingResources.find(j=>j[0]===o);w||(w=[o,[]],this.synchronizingResources.push(w)),w[1].some(j=>f.isEqual(j,p.localResource))||(w[1].push(p.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const g=this.synchronisers.find(j=>j.resource===this.previews[u][0]),U=await a(g);U?this.previews.splice(u,1,this.toSyncResourcePreview(g.resource,U)):this.previews.splice(u,1);const F=this.synchronizingResources.findIndex(j=>j[0]===o);return this.synchronizingResources[F][1].splice(w[1].findIndex(j=>f.isEqual(j,p.localResource)),1),w[1].length||(this.synchronizingResources.splice(F,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const i=[];for(const[a,u]of this.previews){this.synchronizingResources.push([a,u.resourcePreviews.map(p=>p.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(p=>p.resource===a);let l=u;for(const p of u.resourcePreviews)(p.localChange!==0||p.remoteChange!==0)&&p.mergeState==="preview"&&(l=await o.merge(p.previewResource));l&&i.push(this.toSyncResourcePreview(o.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(p=>p[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}async getPreviews(i){const a=[];for(const u of this.synchronisers){if(i.isCancellationRequested)return[];const o=await u.preview(this.manifest,this.syncHeaders);o&&a.push(this.toSyncResourcePreview(u.resource,o))}return a}toSyncResourcePreview(i,a){return[i,{isLastSyncFromCurrentMachine:a.isLastSyncFromCurrentMachine,resourcePreviews:a.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(Z[200],ee([0,1,3,22,5,2,16]),function(G,e,v,R,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class D{constructor(m,h){this.service=m,this.logService=h,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new v.Emitter}listen(m,h){switch(h){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${h}`)}async call(m,h,b){try{return await this._call(m,h,b)}catch(f){throw this.logService.error(f),f}}async _call(m,h,b){switch(h){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(L.URI.revive(b[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(b[0],L.URI.revive(b[1]),b[2],b[3]);case"resolveContent":return this.service.resolveContent(L.URI.revive(b[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(b[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(b[0]);case"getAssociatedResources":return this.service.getAssociatedResources(b[0],{created:b[1].created,uri:L.URI.revive(b[1].uri)});case"getMachineId":return this.service.getMachineId(b[0],{created:b[1].created,uri:L.URI.revive(b[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(h.startsWith("manualSync/")){const f=h.substring("manualSync/".length),C=b[0],P=this.getManualSyncTask(C);switch(b=b.slice(1),f){case"preview":return P.preview();case"accept":return P.accept(L.URI.revive(b[0]),b[1]);case"merge":return P.merge(L.URI.revive(b[0]));case"discard":return P.discard(L.URI.revive(b[0]));case"discardConflicts":return P.discardConflicts();case"apply":return P.apply();case"pull":return P.pull();case"push":return P.push();case"stop":return P.stop();case"_getStatus":return P.status;case"dispose":return this.disposeManualSyncTask(P)}}throw new Error("Invalid call")}getManualSyncTask(m){const h=this.manualSyncTasks.get(this.createKey(m));if(!h)throw new Error(`Manual sync taks not found: ${m}`);return h.manualSyncTask}async createManualSyncTask(){const m=new k.DisposableStore,h=m.add(await this.service.createManualSyncTask());return m.add(h.onSynchronizeResources(b=>this.onManualSynchronizeResources.fire({manualSyncTaskId:h.id,data:b}))),this.manualSyncTasks.set(this.createKey(h.id),{manualSyncTask:h,disposables:m}),{id:h.id,manifest:h.manifest,status:h.status}}disposeManualSyncTask(m){var h;m.dispose();const b=this.createKey(m.id);(h=this.manualSyncTasks.get(b))===null||h===void 0||h.disposables.dispose(),this.manualSyncTasks.delete(b)}createKey(m){return`manualSyncTask-${m}`}}e.UserDataSyncChannel=D;class y extends k.Disposable{constructor(m){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new v.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new v.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new v.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new v.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(h,b,f){return m.call(h,b,f).then(null,C=>{throw R.UserDataSyncError.toUserDataSyncError(C)})},listen(h,b){return m.listen(h,b)}},this.channel.call("_getInitialData").then(([h,b,f])=>{this.updateStatus(h),this.updateConflicts(b),f&&this.updateLastSyncTime(f),this._register(this.channel.listen("onDidChangeStatus")(C=>this.updateStatus(C))),this._register(this.channel.listen("onDidChangeLastSyncTime")(C=>this.updateLastSyncTime(C)))}),this._register(this.channel.listen("onDidChangeConflicts")(h=>this.updateConflicts(h))),this._register(this.channel.listen("onSyncErrors")(h=>this._onSyncErrors.fire(h.map(([b,f])=>[b,R.UserDataSyncError.toUserDataSyncError(f)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:m,manifest:h,status:b}=await this.channel.call("createManualSyncTask"),f=this,C=new S(m,h,b,{async call(P,E,I){return f.channel.call(`manualSync/${P}`,[m,...O.isArray(E)?E:[E]],I)},listen(P,E){return v.Event.map(v.Event.filter(f.channel.listen(`manualSync/${P}`,E),I=>!C.isDiposed()&&I.manualSyncTaskId===m),I=>I.data)}});return C}replace(m){return this.channel.call("replace",[m])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(m,h,b,f){return this.channel.call("accept",[m,h,b,f])}resolveContent(m){return this.channel.call("resolveContent",[m])}async getLocalSyncResourceHandles(m){return(await this.channel.call("getLocalSyncResourceHandles",[m])).map(({created:b,uri:f})=>({created:b,uri:L.URI.revive(f)}))}async getRemoteSyncResourceHandles(m){return(await this.channel.call("getRemoteSyncResourceHandles",[m])).map(({created:b,uri:f})=>({created:b,uri:L.URI.revive(f)}))}async getAssociatedResources(m,h){return(await this.channel.call("getAssociatedResources",[m,h])).map(({resource:f,comparableResource:C})=>({resource:L.URI.revive(f),comparableResource:L.URI.revive(C)}))}async getMachineId(m,h){return this.channel.call("getMachineId",[m,h])}async updateStatus(m){this._status=m,this._onDidChangeStatus.fire(m)}async updateConflicts(m){this._conflicts=m.map(([h,b])=>[h,b.map(f=>Object.assign(Object.assign({},f),{localResource:L.URI.revive(f.localResource),remoteResource:L.URI.revive(f.remoteResource),previewResource:L.URI.revive(f.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(m){this._lastSyncTime!==m&&(this._lastSyncTime=m,this._onDidChangeLastSyncTime.fire(m))}}e.UserDataSyncChannelClient=y;class S extends k.Disposable{constructor(m,h,b,f){super();this.id=m,this.manifest=h,this._disposed=!1,this._status=b;const C=this;this.channel={async call(P,E,I){try{const d=await f.call(P,E,I);return C.isDiposed()||(C._status=await f.call("_getStatus")),d}catch(d){throw R.UserDataSyncError.toUserDataSyncError(d)}},listen(P,E){return f.listen(P,E)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const m=await this.channel.call("preview");return this.deserializePreviews(m)}async accept(m,h){const b=await this.channel.call("accept",[m,h]);return this.deserializePreviews(b)}async merge(m){const h=await this.channel.call("merge",[m]);return this.deserializePreviews(h)}async discard(m){const h=await this.channel.call("discard",[m]);return this.deserializePreviews(h)}async discardConflicts(){const m=await this.channel.call("discardConflicts");return this.deserializePreviews(m)}async apply(){const m=await this.channel.call("apply");return this.deserializePreviews(m)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(m){return m.map(([h,b])=>[h,{isLastSyncFromCurrentMachine:b.isLastSyncFromCurrentMachine,resourcePreviews:b.resourcePreviews.map(f=>Object.assign(Object.assign({},f),{localResource:L.URI.revive(f.localResource),remoteResource:L.URI.revive(f.remoteResource),previewResource:L.URI.revive(f.previewResource),acceptedResource:L.URI.revive(f.acceptedResource)}))}])}}}),define(Z[201],ee([0,1,2,22,39,12,29,23,27,44,9,10,21,30,7,3,6,16,5,11,92]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b,f,C,P,E,I,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const s="sync.previous.store",t="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",a=100,u=1e3*60*5;let o=class extends v.Disposable{constructor(F,j,z){super();this.productService=F,this.configurationService=j,this.storageService=z,this._onDidChangeUserDataSyncStore=this._register(new C.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(C.Event.filter(z.onDidChangeValue,V=>{var q;return V.key===R.SYNC_SERVICE_URL_TYPE&&V.scope===0&&this.userDataSyncStoreType!==((q=this.userDataSyncStore)===null||q===void 0?void 0:q.type)})(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(R.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(F){this.storageService.store(R.SYNC_SERVICE_URL_TYPE,F,0,f.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[R.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(R.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(F,j){F=f.isWeb&&(F==null?void 0:F.web)?Object.assign(Object.assign({},F),F.web):F;const z=Object.assign(Object.assign({},F||{}),j||{});if(z&&E.isString(z.url)&&E.isObject(z.authenticationProviders)&&Object.keys(z.authenticationProviders).every(V=>E.isArray(z.authenticationProviders[V].scopes))){const V=z,q=!!V.canSwitch&&!(j==null?void 0:j.url),$=V.url===V.insidersUrl?"insiders":"stable",H=(q?this.userDataSyncStoreType:void 0)||$,X=(j==null?void 0:j.url)||(H==="insiders"?V.insidersUrl:H==="stable"?V.stableUrl:V.url);return{url:I.URI.parse(X),type:H,defaultType:$,defaultUrl:I.URI.parse(V.url),stableUrl:I.URI.parse(V.stableUrl),insidersUrl:I.URI.parse(V.insidersUrl),canSwitch:q,authenticationProviders:Object.keys(V.authenticationProviders).reduce((_,T)=>(_.push({id:T,scopes:V.authenticationProviders[T].scopes}),_),[])}}}};o=de([K(0,y.IProductService),K(1,D.IConfigurationService),K(2,h.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let l=class extends o{constructor(F,j,z){super(F,j,z);const V=this.storageService.get(s,0);V&&(this.previousConfigurationSyncStore=JSON.parse(V));const q=this.productService[R.CONFIGURATION_SYNC_STORE_KEY];q?this.storageService.store(s,JSON.stringify(q),0,1):this.storageService.remove(s,0)}async switch(F){F!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=F,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=de([K(0,y.IProductService),K(1,D.IConfigurationService),K(2,h.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let p=class extends v.Disposable{constructor(F,j,z,V,q,$,H){super();this.requestService=z,this.logService=V,this.storageService=H,this._onTokenFailed=this._register(new C.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new C.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new C.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(F),this.commonHeadersPromise=S.getServiceMachineId(q,$,H).then(X=>{const _={"X-Client-Name":`${j.applicationName}${f.isWeb?"-web":""}`,"X-Client-Version":j.version,"X-Machine-Id":X};return j.commit&&(_["X-Client-Commit"]=j.commit),_}),this.session=new g(a,u,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register(v.toDisposable(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(F,j){this.authToken={token:F,type:j}}updateUserDataSyncStoreUrl(F){this.userDataSyncStoreUrl=F?k.joinPath(F,"v1"):void 0}initDonotMakeRequestsUntil(){const F=this.storageService.getNumber(t,0);F&&Date.now()<F&&this.setDonotMakeRequestsUntil(new Date(F))}setDonotMakeRequestsUntil(F){var j;((j=this._donotMakeRequestsUntil)===null||j===void 0?void 0:j.getTime())!==(F==null?void 0:F.getTime())&&(this._donotMakeRequestsUntil=F,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=P.createCancelablePromise(z=>P.timeout(this._donotMakeRequestsUntil.getTime()-Date.now(),z).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,z=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=k.joinPath(this.userDataSyncStoreUrl,"resource",F),z={},V=await this.request(j.toString(),{type:"GET",headers:z},[],O.CancellationToken.None);return(await L.asJson(V)||[]).map(({url:$,created:H})=>({ref:k.relativePath(j,j.with({path:$})),created:H*1e3}))}async resolveContent(F,j){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=k.joinPath(this.userDataSyncStoreUrl,"resource",F,j).toString(),V={};V["Cache-Control"]="no-cache";const q=await this.request(z,{type:"GET",headers:V},[],O.CancellationToken.None);return await L.asText(q)}async delete(F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=k.joinPath(this.userDataSyncStoreUrl,"resource",F).toString(),z={};await this.request(j,{type:"DELETE",headers:z},[],O.CancellationToken.None)}async read(F,j,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const V=k.joinPath(this.userDataSyncStoreUrl,"resource",F,"latest").toString();z=Object.assign({},z),z["Cache-Control"]="no-cache",j&&(z["If-None-Match"]=j.ref);const q=await this.request(V,{type:"GET",headers:z},[304],O.CancellationToken.None);if(q.res.statusCode===304)return j;const $=q.res.headers.etag;if(!$)throw new R.UserDataSyncStoreError("Server did not return the ref",V,R.UserDataSyncErrorCode.NoRef,q.res.headers[R.HEADER_OPERATION_ID]);const H=await L.asText(q);return{ref:$,content:H}}async write(F,j,z,V={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=k.joinPath(this.userDataSyncStoreUrl,"resource",F).toString();V=Object.assign({},V),V["Content-Type"]=c.Mimes.text,z&&(V["If-Match"]=z);const $=await this.request(q,{type:"POST",data:j,headers:V},[],O.CancellationToken.None),H=$.res.headers.etag;if(!H)throw new R.UserDataSyncStoreError("Server did not return the ref",q,R.UserDataSyncErrorCode.NoRef,$.res.headers[R.HEADER_OPERATION_ID]);return H}async manifest(F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=k.joinPath(this.userDataSyncStoreUrl,"manifest").toString();F=Object.assign({},F),F["Content-Type"]="application/json";const z=await this.request(j,{type:"GET",headers:F},[],O.CancellationToken.None),V=await L.asJson(z),q=this.storageService.get(r,0);return q&&V&&q!==V.session&&this.clearSession(),V===null&&q&&this.clearSession(),V&&this.storageService.store(r,V.session,0,1),V}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=k.joinPath(this.userDataSyncStoreUrl,"resource").toString(),j={"Content-Type":c.Mimes.text};await this.request(F,{type:"DELETE",headers:j},[],O.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,0),this.storageService.remove(i,0)}async request(F,j,z,V){if(!this.authToken)throw new R.UserDataSyncStoreError("No Auth Token Available",F,R.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new R.UserDataSyncStoreError(`${j.type} request '${F}' failed because of too many requests (429).`,F,R.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const q=await this.commonHeadersPromise;j.headers=Object.assign(Object.assign(Object.assign({},j.headers||{}),q),{"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`}),this.addSessionHeaders(j.headers),this.logService.trace("Sending request to server",{url:F,type:j.type,headers:Object.assign(Object.assign({},j.headers),{authorization:void 0})});let $;try{$=await this.session.request(F,j,V)}catch(T){if(!(T instanceof R.UserDataSyncStoreError)){const A=d.isPromiseCanceledError(T)?R.UserDataSyncErrorCode.RequestCanceled:d.getErrorMessage(T).startsWith("XHR timeout")?R.UserDataSyncErrorCode.RequestTimeout:R.UserDataSyncErrorCode.RequestFailed;T=new R.UserDataSyncStoreError(`Connection refused for the request '${F}'.`,F,A,void 0)}throw this.logService.info("Request failed",F),T}const H=$.res.headers[R.HEADER_OPERATION_ID],X={url:F,status:$.res.statusCode,"execution-id":j.headers[R.HEADER_EXECUTION_ID],"operation-id":H},_=L.isSuccess($)||$.res.statusCode&&z.indexOf($.res.statusCode)!==-1;if(_?this.logService.trace("Request succeeded",X):this.logService.info("Request failed",X),$.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new R.UserDataSyncStoreError(`Request '${F}' failed because of Unauthorized (401).`,F,R.UserDataSyncErrorCode.Unauthorized,H);if(this._onTokenSucceed.fire(),$.res.statusCode===409)throw new R.UserDataSyncStoreError(`${j.type} request '${F}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,F,R.UserDataSyncErrorCode.Conflict,H);if($.res.statusCode===410)throw new R.UserDataSyncStoreError(`${j.type} request '${F}' failed because the requested resource is not longer available (410).`,F,R.UserDataSyncErrorCode.Gone,H);if($.res.statusCode===412)throw new R.UserDataSyncStoreError(`${j.type} request '${F}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,F,R.UserDataSyncErrorCode.PreconditionFailed,H);if($.res.statusCode===413)throw new R.UserDataSyncStoreError(`${j.type} request '${F}' failed because of too large payload (413).`,F,R.UserDataSyncErrorCode.TooLarge,H);if($.res.statusCode===426)throw new R.UserDataSyncStoreError(`${j.type} request '${F}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,F,R.UserDataSyncErrorCode.UpgradeRequired,H);if($.res.statusCode===429){const T=$.res.headers["retry-after"];throw T?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(T)*1e3)),new R.UserDataSyncStoreError(`${j.type} request '${F}' failed because of too many requests (429).`,F,R.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,H)):new R.UserDataSyncStoreError(`${j.type} request '${F}' failed because of too many requests (429).`,F,R.UserDataSyncErrorCode.TooManyRequests,H)}if(!_)throw new R.UserDataSyncStoreError("Server returned "+$.res.statusCode,F,R.UserDataSyncErrorCode.Unknown,H);return $}addSessionHeaders(F){let j=this.storageService.get(i,0);j===void 0&&(j=b.generateUuid(),this.storageService.store(i,j,0,1)),F["X-Machine-Session-Id"]=j;const z=this.storageService.get(r,0);z!==void 0&&(F["X-User-Session-Id"]=z)}};p=de([K(1,y.IProductService),K(2,L.IRequestService),K(3,R.IUserDataSyncLogService),K(4,n.IEnvironmentService),K(5,m.IFileService),K(6,h.IStorageService)],p),e.UserDataSyncStoreClient=p;let w=class extends p{constructor(F,j,z,V,q,$,H){var X;super((X=F.userDataSyncStore)===null||X===void 0?void 0:X.url,j,z,V,q,$,H);this._register(F.onDidChangeUserDataSyncStore(()=>{var _;return this.updateUserDataSyncStoreUrl((_=F.userDataSyncStore)===null||_===void 0?void 0:_.url)}))}};w=de([K(0,R.IUserDataSyncStoreManagementService),K(1,y.IProductService),K(2,L.IRequestService),K(3,R.IUserDataSyncLogService),K(4,n.IEnvironmentService),K(5,m.IFileService),K(6,h.IStorageService)],w),e.UserDataSyncStoreService=w;class g{constructor(F,j,z,V){this.limit=F,this.interval=j,this.requestService=z,this.logService=V,this.requests=[],this.startTime=void 0}request(F,j,z){if(this.isExpired()&&this.reset(),j.url=F,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new R.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,F,R.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(F),this.requestService.request(j,z)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=g}),define(Z[202],ee([0,1,22,3,58,87,60,24,21,61,27]),function(G,e,v,R,L,k,O,D,y,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let m=class extends k.UserDataAutoSyncService{constructor(b,f,C,P,E,I,d,c,s,t,r,i){super(b,f,C,P,E,d,c,s,t,r,i);this._register(R.Event.debounce(R.Event.any(R.Event.map(I.onDidFocusWindow,()=>"windowFocus"),R.Event.map(I.onDidOpenWindow,()=>"windowOpen")),(a,u)=>a?[...a,u]:[u],1e3)(a=>this.triggerSync(a,!0,!1)))}};m=de([K(0,n.IProductService),K(1,v.IUserDataSyncStoreManagementService),K(2,v.IUserDataSyncStoreService),K(3,v.IUserDataSyncResourceEnablementService),K(4,v.IUserDataSyncService),K(5,L.INativeHostService),K(6,v.IUserDataSyncLogService),K(7,O.IUserDataSyncAccountService),K(8,D.ITelemetryService),K(9,S.IUserDataSyncMachinesService),K(10,y.IStorageService),K(11,v.IUserDataAutoSyncEnablementService)],m),e.UserDataAutoSyncService=m}),define(Z[203],ee([0,1,3,2,6]),function(G,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends R.Disposable{constructor({onDidOpenWindow:D,onDidFocusWindow:y,getActiveWindowId:S}){super();this.disposables=this._register(new R.DisposableStore),v.Event.latch(v.Event.any(D,y))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=L.createCancelablePromise(()=>S()),(async()=>{try{const m=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:m}catch(m){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(D){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=D}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(Z[62],ee([0,1,108,8,48,6,18,210,211,16]),function(G,e,v,R,L,k,O,D,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=r}}e.ExtractError=n;function m(s){const t=s.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function h(s){if(s instanceof n)return s;let t;return/end of central directory record signature not found/.test(s.message)&&(t="CorruptZip"),new n(t,s)}function b(s,t,r,i,a,u){const o=R.dirname(t),l=R.join(i,o);if(!l.startsWith(i))return Promise.reject(new Error(v.localize(0,null,t)));const p=R.join(i,t);let w;return u.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(O.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((g,U)=>{if(!u.isCancellationRequested)try{w=L.createWriteStream(p,{mode:r}),w.once("close",()=>g()),w.once("error",U),s.once("error",U),s.pipe(w)}catch(F){U(F)}}))}function f(s,t,r,i){let a=k.createCancelablePromise(()=>Promise.resolve()),u=0;return i.onCancellationRequested(()=>{a.cancel(),s.close()}),new Promise((o,l)=>{const p=new k.Sequencer,w=g=>{g.isCancellationRequested||(u++,s.readEntry())};s.once("error",l),s.once("close",()=>a.then(()=>{i.isCancellationRequested||s.entryCount===u?o():l(new n("Incomplete",new Error(v.localize(1,null,u,s.entryCount))))},l)),s.readEntry(),s.on("entry",g=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(g.fileName)){w(i);return}const U=g.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(U)){const z=R.join(t,U);a=k.createCancelablePromise(V=>O.Promises.mkdir(z,{recursive:!0}).then(()=>w(V)).then(void 0,l));return}const F=P(s,g),j=m(g);a=k.createCancelablePromise(z=>p.queue(()=>F.then(V=>b(V,U,j,t,r,z).then(()=>w(z)))).then(null,l))})})}function C(s,t=!1){return new Promise((r,i)=>{D.open(s,t?{lazyEntries:!0}:void 0,(a,u)=>{a?i(h(a)):r(S.assertIsDefined(u))})})}function P(s,t){return new Promise((r,i)=>{s.openReadStream(t,(a,u)=>{a?i(h(a)):r(S.assertIsDefined(u))})})}function E(s,t){return new Promise((r,i)=>{const a=new y.ZipFile;t.forEach(o=>{o.contents?a.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&a.addFile(o.localPath,o.path)}),a.end();const u=L.createWriteStream(s);a.outputStream.pipe(u),a.outputStream.once("error",i),u.once("error",i),u.once("finish",()=>r(s))})}e.zip=E;function I(s,t,r={},i){const a=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let u=C(s,!0);return r.overwrite&&(u=u.then(o=>O.Promises.rm(t).then(()=>o))),u.then(o=>f(o,t,{sourcePathRegex:a},i))}e.extract=I;function d(s,t){return C(s).then(r=>new Promise((i,a)=>{r.on("entry",u=>{u.fileName===t&&P(r,u).then(o=>i(o),o=>a(o))}),r.once("close",()=>a(new Error(v.localize(2,null,t))))}))}function c(s,t){return d(s,t).then(r=>new Promise((i,a)=>{const u=[];r.once("error",a),r.on("data",o=>u.push(o)),r.on("end",()=>i(Buffer.concat(u)))}))}e.buffer=c}),define(Z[204],ee([0,1,62,113]),function(G,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(k){return v.buffer(k,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch(D){throw new Error(R.localize(0,null))}})}e.getManifest=L}),define(Z[205],ee([0,1,57,2,18,8,15,28,33,6,5,9,134,114,27,62,7,19,17,10,12,30,11]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b,f,C,P,E,I,d,c,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",i="scanningUser",a="extracting",u="deleting",o="renaming";let l=class extends R.Disposable{constructor(w,g,U,F,j){super();this.beforeRemovingExtension=w,this.fileService=g,this.logService=U,this.environmentService=F,this.productService=j,this._devSystemExtensionsPath=null,this.systemExtensionsPath=F.builtinExtensionsPath,this.extensionsPath=F.extensionsPath,this.uninstalledPath=k.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new S.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(w){const g=[];(w===null||w===0)&&g.push(this.scanSystemExtensions().then(null,U=>Promise.reject(new D.ExtensionManagementError(this.joinErrors(U).message,r)))),(w===null||w===1)&&g.push(this.scanUserExtensions(!0).then(null,U=>Promise.reject(new D.ExtensionManagementError(this.joinErrors(U).message,i))));try{const U=await Promise.all(g);return E.flatten(U)}catch(U){throw this.joinErrors(U)}}async scanUserExtensions(w){this.logService.trace("Started scanning user extensions");let[g,U]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return U=U.filter(F=>!g[new y.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()]),w&&(U=y.groupByExtension(U,j=>j.identifier).map(j=>j.sort((z,V)=>v.rcompare(z.manifest.version,V.manifest.version))[0])),this.logService.trace("Scanned user extensions:",U.length),U}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(w,g,U){const F=w.key(),j=k.join(this.extensionsPath,`.${s.generateUuid()}`),z=k.join(this.extensionsPath,F);try{await L.Promises.rm(z)}catch(q){try{await L.Promises.rm(z)}catch($){}throw new D.ExtensionManagementError(b.localize(0,null,z,w.id),u)}await this.extractAtLocation(w,g,j,U);let V=await this.scanExtension(n.URI.file(j),1);if(!V)throw new Error(b.localize(1,null,j));await this.storeMetadata(V,{installedTimestamp:Date.now()});try{await this.rename(w,j,z,Date.now()+2*60*1e3),this.logService.info("Renamed to",z)}catch(q){try{await L.Promises.rm(j)}catch($){}if(q.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",w.id);else throw this.logService.info(`Rename failed because of ${t.getErrorMessage(q)}. Deleted from extracted location`,j),q}try{V=await this.scanExtension(n.URI.file(z),1)}catch(q){}if(V)return V;throw new Error(b.localize(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(w,g){return this.setMetadata(w,g),await this.storeMetadata(w,Object.assign(Object.assign({},g),{installedTimestamp:w.installedTimestamp})),w}async storeMetadata(w,g){g.isMachineScoped=g.isMachineScoped||void 0,g.isBuiltin=g.isBuiltin||void 0,g.installedTimestamp=g.installedTimestamp||void 0;const U=k.join(w.location.fsPath,"package.json"),F=await L.Promises.readFile(U,"utf8"),{manifest:j}=await this.parseManifest(F);return j.__metadata=g,await L.Promises.writeFile(U,JSON.stringify(j,null,"	")),w}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...w){const g=w.map(U=>new y.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version));await this.withUninstalledExtensions(U=>{g.forEach(F=>U[F.key()]=!0)})}async setInstalled(w){await this.withUninstalledExtensions(F=>delete F[w.key()]);const U=(await this.scanExtensions(1)).find(F=>new y.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).equals(w))||null;return U?(await this.storeMetadata(U,{installedTimestamp:Date.now()}),this.scanExtension(U.location,1)):null}async withUninstalledExtensions(w){return this.uninstalledFileLimiter.queue(async()=>{let g;try{g=await L.Promises.readFile(this.uninstalledPath,"utf8")}catch(F){if(F.code!=="ENOENT")throw F}let U={};if(g)try{U=JSON.parse(g)}catch(F){}return w&&(w(U),Object.keys(U).length?await L.Promises.writeFile(this.uninstalledPath,JSON.stringify(U)):await L.Promises.rm(this.uninstalledPath)),U})}async removeExtension(w,g){this.logService.trace(`Deleting ${g} extension from disk`,w.identifier.id,w.location.fsPath),await L.Promises.rm(w.location.fsPath),this.logService.info("Deleted from disk",w.identifier.id,w.location.fsPath)}async removeUninstalledExtension(w){await this.removeExtension(w,"uninstalled"),await this.withUninstalledExtensions(g=>delete g[new y.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()])}async extractAtLocation(w,g,U,F){this.logService.trace(`Started extracting the extension from ${g} to ${U}`);try{await L.Promises.rm(U)}catch(j){throw new D.ExtensionManagementError(this.joinErrors(j).message,u)}try{await C.extract(g,U,{sourcePath:"extension",overwrite:!0},F),this.logService.info(`Extracted extension to ${U}:`,w.id)}catch(j){try{await L.Promises.rm(U)}catch(z){}throw new D.ExtensionManagementError(j.message,j instanceof C.ExtractError&&j.type?j.type:a)}}async rename(w,g,U,F){try{await L.Promises.rename(g,U)}catch(j){if(P.isWindows&&j&&j.code==="EPERM"&&Date.now()<F)return this.logService.info(`Failed renaming ${g} to ${U} with 'EPERM' error. Trying again...`,w.id),this.rename(w,g,U,F);throw new D.ExtensionManagementError(j.message||b.localize(3,null,g,U),j.code||o)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const w=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return w;const g=this.scanDevSystemExtensions(),[U,F]=await Promise.all([w,g]);return[...U,...F]}async scanExtensionsInDir(w,g){const U=new S.Limiter(10),F=await this.fileService.resolve(n.URI.file(w));return F.children?(await Promise.all(F.children.filter(z=>z.isDirectory).map(z=>U.queue(async()=>g===1&&c.basename(z.resource).indexOf(".")===0?null:this.scanExtension(z.resource,g))))).filter(z=>z&&z.identifier):[]}async scanExtension(w,g){var U,F;try{const j=await this.fileService.resolve(w);if(j.children){const{manifest:z,metadata:V}=await this.readManifest(w.fsPath),q=(U=j.children.find(({name:_})=>/^readme(\.txt|\.md|)$/i.test(_)))===null||U===void 0?void 0:U.resource,$=(F=j.children.find(({name:_})=>/^changelog(\.txt|\.md|)$/i.test(_)))===null||F===void 0?void 0:F.resource,H={id:y.getGalleryExtensionId(z.publisher,z.name)},X={type:g,identifier:H,manifest:z,location:w,readmeUrl:q,changelogUrl:$,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:g===0};return V&&(this.setMetadata(X,V),X.installedTimestamp=V.installedTimestamp),X}}catch(j){g!==0&&this.logService.trace(j)}return null}async scanDefaultSystemExtensions(){const w=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",w.length),w}async scanDevSystemExtensions(){const w=this.getDevSystemExtensionsList();if(w.length){const g=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",g.length),g.filter(U=>w.some(F=>y.areSameExtensions(U.identifier,{id:F})))}else return[]}setMetadata(w,g){w.publisherDisplayName=g.publisherDisplayName||null,w.publisherId=g.publisherId||null,w.identifier.uuid=g.id,w.isMachineScoped=!!g.isMachineScoped,w.isBuiltin=w.type===0||!!g.isBuiltin}async removeUninstalledExtensions(){const w=await this.getUninstalledExtensions(),g=await this.scanAllUserExtensions(),U=new Set;for(const z of g)w[new y.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]||U.add(z.identifier.id.toLowerCase());const F=y.groupByExtension(g,z=>z.identifier);await S.Promises.settled(F.map(async z=>{const V=z.sort((q,$)=>v.rcompare(q.manifest.version,$.manifest.version))[0];U.has(V.identifier.id.toLowerCase())||await this.beforeRemovingExtension(V)}));const j=g.filter(z=>w[new y.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]);await S.Promises.settled(j.map(z=>this.removeUninstalledExtension(z)))}async removeOutdatedExtensions(){const w=await this.scanAllUserExtensions(),g=[],U=y.groupByExtension(w,F=>F.identifier);g.push(...E.flatten(U.map(F=>F.sort((j,z)=>v.rcompare(j.manifest.version,z.manifest.version)).slice(1)))),await S.Promises.settled(g.map(F=>this.removeExtension(F,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(w=>w.name)}joinErrors(w){const g=Array.isArray(w)?w:[w];return g.length===1?g[0]instanceof Error?g[0]:new Error(g[0]):g.reduce((U,F)=>new Error(`${U.message}${U.message?",":""}${F instanceof Error?F.message:F}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=k.normalize(k.join(I.FileAccess.asFileUri("",G).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(w){const g=[L.Promises.readFile(k.join(w,"package.json"),"utf8").then(z=>this.parseManifest(z)),L.Promises.readFile(k.join(w,"package.nls.json"),"utf8").then(void 0,z=>z.code!=="ENOENT"?Promise.reject(z):"{}").then(z=>JSON.parse(z))],[{manifest:U,metadata:F},j]=await Promise.all(g);return{manifest:h.localizeManifest(U,j),metadata:F}}parseManifest(w){return new Promise((g,U)=>{try{const F=JSON.parse(w),j=F.__metadata||null;g({manifest:F,metadata:j})}catch(F){U(new Error(b.localize(4,null)))}})}};l=de([K(1,d.IFileService),K(2,O.ILogService),K(3,m.INativeEnvironmentService),K(4,f.IProductService)],l),e.ExtensionsScanner=l}),define(Z[206],ee([0,1,112,8,18,2,19,62,28,33,9,6,3,57,5,51,7,15,145,43,24,71,12,30,73,4,17,29,204,155,205,156,157,10]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b,f,C,P,E,I,d,c,s,t,r,i,a,u,o,l,p,w,g,U,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const j="unsetUninstalled",z="downloading",V="validating",q="local",$="unknown";let H=class extends k.Disposable{constructor(_,T,A,M,N,B,W){super();this.environmentService=_,this.galleryService=T,this.logService=A,this.downloadService=M,this.telemetryService=N,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new h.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new h.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new h.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new h.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const Q=this._register(B.createInstance(g.ExtensionsLifecycle));this.extensionsScanner=this._register(B.createInstance(w.ExtensionsScanner,ie=>Q.postUninstall(ie))),this.manifestCache=this._register(new I.ExtensionsManifestCache(_,this)),this.extensionsDownloader=this._register(B.createInstance(p.ExtensionsDownloader));const J=this._register(new U.ExtensionsWatcher(this,W,_,A));this._register(J.onDidChangeExtensionsByAnotherSource(({added:ie,removed:ne})=>{ie.forEach(ce=>this._onDidInstallExtension.fire({identifier:ce.identifier,operation:0,local:ce})),ne.forEach(ce=>this._onDidUninstallExtension.fire({identifier:ce}))})),this._register(k.toDisposable(()=>{this.installingExtensions.forEach(ie=>ie.cancel()),this.uninstallingExtensions.forEach(ie=>ie.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(_){this.logService.trace("ExtensionManagementService#zip",_.identifier.id);const T=await this.collectFiles(_),A=await D.zip(t.joinPath(this.environmentService.tmpDir,r.generateUuid()).fsPath,T);return f.URI.file(A)}async unzip(_){return this.logService.trace("ExtensionManagementService#unzip",_.toString()),(await this.install(_)).identifier}async getManifest(_){const T=await this.downloadVsix(_),A=R.resolve(T.fsPath);return l.getManifest(A)}async collectFiles(_){const T=async M=>{let N=await L.Promises.readdir(M);N=N.map(Q=>R.join(M,Q));const B=await Promise.all(N.map(Q=>L.Promises.stat(Q)));let W=Promise.resolve([]);return B.forEach((Q,J)=>{const ie=N[J];Q.isFile()&&(W=W.then(ne=>[...ne,ie])),Q.isDirectory()&&(W=W.then(ne=>T(ie).then(ce=>[...ne,...ce])))}),W};return(await T(_.location.fsPath)).map(M=>({path:`extension/${R.relative(_.location.fsPath,M)}`,localPath:M}))}async install(_,T={}){return this.logService.trace("ExtensionManagementService#install",_.toString()),m.createCancelablePromise(async A=>{const M=await this.downloadVsix(_),N=R.resolve(M.fsPath),B=await l.getManifest(N),W={id:S.getGalleryExtensionId(B.publisher,B.name)};let Q=1;if(B.engines&&B.engines.vscode&&!s.isEngineValid(B.engines.vscode,C.default.version,C.default.date))throw new Error(v.localize(0,null,W.id,C.default.version));const J=new S.ExtensionIdentifierWithVersion(W,B.version),ne=(await this.getInstalled(1)).find(le=>S.areSameExtensions(W,le.identifier));if(ne)if(T.isMachineScoped=T.isMachineScoped||ne.isMachineScoped,T.isBuiltin=T.isBuiltin||ne.isBuiltin,Q=2,J.equals(new S.ExtensionIdentifierWithVersion(ne.identifier,ne.manifest.version)))try{await this.extensionsScanner.removeExtension(ne,"existing")}catch(le){throw new Error(v.localize(1,null,B.displayName||B.name))}else b.gt(ne.manifest.version,B.version)&&await this.uninstallExtension(ne);else{const le=await this.unsetUninstalledAndGetLocal(J);if(le)try{await this.extensionsScanner.removeExtension(le,"existing")}catch(ve){throw new Error(v.localize(2,null,B.displayName||B.name))}}this.logService.info("Installing the extension:",W.id),this._onInstallExtension.fire({identifier:W,zipPath:N});let ce;try{ce=await this.getGalleryMetadata(S.getGalleryExtensionId(B.publisher,B.name))}catch(le){}try{const le=await this.installFromZipPath(J,N,T.installOnlyNewlyAddedFromExtensionPack?ne:void 0,Object.assign(Object.assign({},ce||{}),T),T,Q,A);return this.logService.info("Successfully installed the extension:",W.id),le}catch(le){throw this.logService.error("Failed to install the extension:",W.id,le.message),le}})}async downloadVsix(_){if(_.scheme===u.Schemas.file)return _;if(!this.downloadService)throw new Error("Download service is not available");const T=t.joinPath(this.environmentService.tmpDir,r.generateUuid());return await this.downloadService.download(_,T),T}async installFromZipPath(_,T,A,M,N,B,W){try{const Q=await this.installExtension({zipPath:T,identifierWithVersion:_,metadata:M},W);try{N.donotIncludePackAndDependencies||await this.installDependenciesAndPackExtensions(Q,A,N)}catch(J){O.isNonEmptyArray(Q.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",Q.identifier.id,J.message),O.isNonEmptyArray(Q.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",Q.identifier.id,J.message)}return this._onDidInstallExtension.fire({identifier:_,zipPath:T,local:Q,operation:B}),Q}catch(Q){throw this._onDidInstallExtension.fire({identifier:_,zipPath:T,operation:B,error:Q}),Q}}async canInstall(_){return!0}async installFromGallery(_,T={}){if(!this.galleryService.isEnabled())throw new Error(v.localize(3,null));try{_=await this.checkAndGetCompatibleVersion(_)}catch(N){const B=N&&N.code?N.code:$;throw this.logService.error("Failed to install extension:",_.identifier.id,N?N.message:B),this.reportTelemetry(this.getTelemetryEvent(1),S.getGalleryExtensionTelemetryData(_),void 0,N),N instanceof Error&&(N.name=B),N}const A=new S.ExtensionIdentifierWithVersion(_.identifier,_.version).key();let M=this.installingExtensions.get(A);return M||(M=m.createCancelablePromise(N=>this.doInstallFromGallery(_,T,N)),this.installingExtensions.set(A,M),M.finally(()=>this.installingExtensions.delete(A))),M}async doInstallFromGallery(_,T,A){const M=new Date().getTime();let N=1;this.logService.info("Installing extension:",_.identifier.id),this._onInstallExtension.fire({identifier:_.identifier,gallery:_});try{const W=(await this.getInstalled(1)).find(ie=>S.areSameExtensions(ie.identifier,_.identifier));W&&(N=2);const Q=await this.downloadInstallableExtension(_,N);Q.metadata.isMachineScoped=T.isMachineScoped||(W==null?void 0:W.isMachineScoped),Q.metadata.isBuiltin=T.isBuiltin||(W==null?void 0:W.isBuiltin);const J=await this.installExtension(Q,A);try{await this.extensionsDownloader.delete(f.URI.file(Q.zipPath))}catch(ie){}if(!T.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(J,W,T)}catch(ie){try{await this.uninstall(J)}catch(ne){}throw ie}return W&&b.neq(W.manifest.version,_.version)&&await this.extensionsScanner.setUninstalled(W),this.logService.info("Extensions installed successfully:",_.identifier.id),this._onDidInstallExtension.fire({identifier:_.identifier,gallery:_,local:J,operation:N}),this.reportTelemetry(this.getTelemetryEvent(N),S.getGalleryExtensionTelemetryData(_),new Date().getTime()-M,void 0),J}catch(B){const W=B&&B.code?B.code:$;throw this.logService.error("Failed to install extension:",_.identifier.id,B?B.message:W),this._onDidInstallExtension.fire({identifier:_.identifier,gallery:_,operation:N,error:W}),this.reportTelemetry(this.getTelemetryEvent(N),S.getGalleryExtensionTelemetryData(_),new Date().getTime()-M,B),B instanceof Error&&(B.name=W),B}}async checkAndGetCompatibleVersion(_){if(await this.isMalicious(_))throw new y.ExtensionManagementError(v.localize(4,null),y.INSTALL_ERROR_MALICIOUS);const T=await this.galleryService.getCompatibleExtension(_);if(!T)throw new y.ExtensionManagementError(v.localize(5,null,_.identifier.id,C.default.version),y.INSTALL_ERROR_INCOMPATIBLE);return T}async reinstallFromGallery(_){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",_.identifier.id),!this.galleryService.isEnabled())throw new Error(v.localize(6,null));const T=await this.findGalleryExtension(_);if(!T)throw new Error(v.localize(7,null));await this.extensionsScanner.setUninstalled(_);try{await this.extensionsScanner.removeUninstalledExtension(_)}catch(A){throw new Error(v.localize(8,null,d.toErrorMessage(A)))}await this.installFromGallery(T)}getTelemetryEvent(_){return _===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(_){const T=await this.getExtensionsReport();return S.getMaliciousExtensionsSet(T).has(_.identifier.id)}async downloadInstallableExtension(_,T){const A={id:_.identifier.uuid,publisherId:_.publisherId,publisherDisplayName:_.publisherDisplayName};let M;try{this.logService.trace("Started downloading extension:",_.identifier.id),M=(await this.extensionsDownloader.downloadExtension(_,T)).fsPath,this.logService.info("Downloaded extension:",_.identifier.id,M)}catch(N){throw new y.ExtensionManagementError(this.joinErrors(N).message,z)}try{const N=await l.getManifest(M);return{zipPath:M,identifierWithVersion:new S.ExtensionIdentifierWithVersion(_.identifier,N.version),metadata:A}}catch(N){throw new y.ExtensionManagementError(this.joinErrors(N).message,V)}}async installExtension(_,T){try{const A=await this.unsetUninstalledAndGetLocal(_.identifierWithVersion);if(A)return _.metadata?this.extensionsScanner.saveMetadataForLocalExtension(A,_.metadata):A}catch(A){throw P.isMacintosh?new y.ExtensionManagementError(v.localize(9,null),j):new y.ExtensionManagementError(v.localize(10,null),j)}return this.extractAndInstall(_,T)}async unsetUninstalledAndGetLocal(_){if(!await this.isUninstalled(_))return null;this.logService.trace("Removing the extension from uninstalled list:",_.id);const A=await this.extensionsScanner.setInstalled(_);return this.logService.info("Removed the extension from uninstalled list:",_.id),A}async extractAndInstall({zipPath:_,identifierWithVersion:T,metadata:A},M){let N=await this.extensionsScanner.extractUserExtension(T,_,M);return this.logService.info("Installation completed.",T.id),A&&(N=await this.extensionsScanner.saveMetadataForLocalExtension(N,A)),N}async installDependenciesAndPackExtensions(_,T,A){if(!this.galleryService.isEnabled())return;const M=_.manifest.extensionDependencies||[];if(_.manifest.extensionPack)for(const N of _.manifest.extensionPack)T&&T.manifest.extensionPack&&T.manifest.extensionPack.some(B=>S.areSameExtensions({id:B},{id:N}))||M.every(B=>!S.areSameExtensions({id:B},{id:N}))&&M.push(N);if(M.length){const N=await this.getInstalled(),B=M.filter(W=>N.every(({identifier:Q})=>!S.areSameExtensions(Q,{id:W})));if(B.length){const Q=(await this.galleryService.query({names:B,pageSize:M.length},o.CancellationToken.None)).firstPage;try{await m.Promises.settled(Q.map(J=>this.installFromGallery(J,A)))}catch(J){try{await this.rollback(Q)}catch(ie){}throw J}}}}async rollback(_){const A=(await this.getInstalled(1)).filter(M=>_.some(N=>new S.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).equals(new S.ExtensionIdentifierWithVersion(N.identifier,N.version))));await m.Promises.settled(A.map(M=>this.uninstall(M)))}async uninstall(_,T={}){this.logService.trace("ExtensionManagementService#uninstall",_.identifier.id);const A=await this.getInstalled(1),M=A.find(N=>S.areSameExtensions(N.identifier,_.identifier));if(!M)throw new Error(v.localize(11,null,_.manifest.displayName||_.manifest.name));try{await this.checkForDependenciesAndUninstall(M,A,T)}catch(N){throw this.joinErrors(N)}}async updateMetadata(_,T){return this.logService.trace("ExtensionManagementService#updateMetadata",_.identifier.id),_=await this.extensionsScanner.saveMetadataForLocalExtension(_,Object.assign(Object.assign({},_.manifest.__metadata||{}),T)),this.manifestCache.invalidate(),_}async updateExtensionScope(_,T){return this.logService.trace("ExtensionManagementService#updateExtensionScope",_.identifier.id),_=await this.extensionsScanner.saveMetadataForLocalExtension(_,Object.assign(Object.assign({},_.manifest.__metadata||{}),{isMachineScoped:T})),this.manifestCache.invalidate(),_}async getGalleryMetadata(_){const T=await this.findGalleryExtensionByName(_);return T?{id:T.identifier.uuid,publisherDisplayName:T.publisherDisplayName,publisherId:T.publisherId}:void 0}async findGalleryExtension(_){if(_.identifier.uuid){const T=await this.findGalleryExtensionById(_.identifier.uuid);return T||this.findGalleryExtensionByName(_.identifier.id)}return this.findGalleryExtensionByName(_.identifier.id)}async findGalleryExtensionById(_){return(await this.galleryService.query({ids:[_],pageSize:1},o.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(_){return(await this.galleryService.query({names:[_],pageSize:1},o.CancellationToken.None)).firstPage[0]}joinErrors(_){const T=Array.isArray(_)?_:[_];return T.length===1?T[0]instanceof Error?T[0]:new Error(T[0]):T.reduce((A,M)=>new Error(`${A.message}${A.message?",":""}${M instanceof Error?M.message:M}`),new Error(""))}async checkForDependenciesAndUninstall(_,T,A){try{await this.preUninstallExtension(_);const M=A.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(_,T);await this.uninstallExtensions(_,M,T,A)}catch(M){throw await this.postUninstallExtension(_,new y.ExtensionManagementError(M instanceof Error?M.message:M,q)),M}await this.postUninstallExtension(_)}async uninstallExtensions(_,T,A,M){const N=[_,...T];if(!M.donotCheckDependents)for(const B of N)this.checkForDependents(B,N,A,_);await m.Promises.settled([this.uninstallExtension(_),...T.map(B=>this.doUninstall(B))])}checkForDependents(_,T,A,M){const N=this.getDependents(_,A);if(N.length){const B=N.filter(W=>T.indexOf(W)===-1);if(B.length)throw new Error(this.getDependentsErrorMessage(_,B,M))}}getDependentsErrorMessage(_,T,A){return A===_?T.length===1?v.localize(12,null,A.manifest.displayName||A.manifest.name,T[0].manifest.displayName||T[0].manifest.name):T.length===2?v.localize(13,null,A.manifest.displayName||A.manifest.name,T[0].manifest.displayName||T[0].manifest.name,T[1].manifest.displayName||T[1].manifest.name):v.localize(14,null,A.manifest.displayName||A.manifest.name,T[0].manifest.displayName||T[0].manifest.name,T[1].manifest.displayName||T[1].manifest.name):T.length===1?v.localize(15,null,A.manifest.displayName||A.manifest.name,_.manifest.displayName||_.manifest.name,T[0].manifest.displayName||T[0].manifest.name):T.length===2?v.localize(16,null,A.manifest.displayName||A.manifest.name,_.manifest.displayName||_.manifest.name,T[0].manifest.displayName||T[0].manifest.name,T[1].manifest.displayName||T[1].manifest.name):v.localize(17,null,A.manifest.displayName||A.manifest.name,_.manifest.displayName||_.manifest.name,T[0].manifest.displayName||T[0].manifest.name,T[1].manifest.displayName||T[1].manifest.name)}getAllPackExtensionsToUninstall(_,T,A=[]){if(A.indexOf(_)!==-1)return[];A.push(_);const M=_.manifest.extensionPack?_.manifest.extensionPack:[];if(M.length){const N=T.filter(W=>!W.isBuiltin&&M.some(Q=>S.areSameExtensions({id:Q},W.identifier))),B=[];for(const W of N)B.push(...this.getAllPackExtensionsToUninstall(W,T,A));return[...N,...B]}return[]}getDependents(_,T){return T.filter(A=>A.manifest.extensionDependencies&&A.manifest.extensionDependencies.some(M=>S.areSameExtensions({id:M},_.identifier)))}async doUninstall(_){try{await this.preUninstallExtension(_),await this.uninstallExtension(_)}catch(T){throw await this.postUninstallExtension(_,new y.ExtensionManagementError(T instanceof Error?T.message:T,q)),T}await this.postUninstallExtension(_)}async preUninstallExtension(_){if(!await L.Promises.exists(_.location.fsPath))throw new Error(v.localize(18,null));this.logService.info("Uninstalling extension:",_.identifier.id),this._onUninstallExtension.fire(_.identifier)}async uninstallExtension(_){let T=this.uninstallingExtensions.get(_.identifier.id);return T||(T=m.createCancelablePromise(async()=>{const A=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...A.filter(M=>S.areSameExtensions(M.identifier,_.identifier)))}),this.uninstallingExtensions.set(_.identifier.id,T),T.finally(()=>this.uninstallingExtensions.delete(_.identifier.id))),T}async postUninstallExtension(_,T){if(T)this.logService.error("Failed to uninstall extension:",_.identifier.id,T.message);else if(this.logService.info("Successfully uninstalled extension:",_.identifier.id),_.identifier.uuid)try{await this.galleryService.reportStatistic(_.manifest.publisher,_.manifest.name,_.manifest.version,"uninstall")}catch(M){}this.reportTelemetry("extensionGallery:uninstall",S.getLocalExtensionTelemetryData(_),void 0,T);const A=T?T instanceof y.ExtensionManagementError?T.code:$:void 0;this._onDidUninstallExtension.fire({identifier:_.identifier,error:A})}getInstalled(_=null){return this.extensionsScanner.scanExtensions(_)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(_){return(await this.filterUninstalled(_)).length===1}async filterUninstalled(..._){const T=[],A=await this.extensionsScanner.getUninstalledExtensions();for(const M of _)A[M.key()]&&T.push(M.key());return T}getExtensionsReport(){const _=new Date().getTime();return(!this.reportedExtensions||_-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=_),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const _=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${_.length} reported extensions from service`),_}catch(_){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(_,T,A,M){const N=M?M instanceof y.ExtensionManagementError?M.code:$:void 0;this.telemetryService.publicLogError(_,Object.assign(Object.assign({},T),{success:!M,duration:A,errorcode:N}))}};H=de([K(0,n.INativeEnvironmentService),K(1,y.IExtensionGalleryService),K(2,E.ILogService),K(3,a.optional(i.IDownloadService)),K(4,c.ITelemetryService),K(5,a.IInstantiationService),K(6,F.IFileService)],H),e.ExtensionManagementService=H}),define(Z[212],ee([0,1,48,35,213,102,51,101,36,77,50,149,9,131,133,28,206,174,23,165,39,166,24,59,172,81,82,177,15,78,158,56,2,167,73,162,163,154,153,151,150,173,72,159,10,161,17,27,22,199,201,196,58,197,202,171,21,169,198,60,195,175,61,74,135,203,176,87,86,85,4,152,144,11,43,83,184,179,200,142,146,178,5,12]),function(G,e,v,R,L,k,O,D,y,S,n,m,h,b,f,C,P,E,I,d,c,s,t,r,i,a,u,o,l,p,w,g,U,F,j,z,V,q,$,H,X,_,T,A,M,N,B,W,Q,J,ie,ne,ce,le,ve,pe,Ce,Ae,Me,Oe,ke,je,Ie,Te,Ke,Ye,ze,qe,Y,re,se,me,Se,De,be,Ue,Pe,x,te,ae,oe,he,ge,fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ye extends U.Disposable{constructor(ue){super();this.configuration=ue,this.server=this._register(new D.Server),L.gracefulify(v),this.registerListeners()}registerListeners(){const ue=()=>this.dispose();process.once("exit",ue),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",ue)}async open(){const ue=await this.initServices();Q.registerConfiguration(),ue.invokeFunction(Re=>{const Fe=Re.get(l.ILogService);Fe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Re),this.registerErrorHandler(Fe)}),this._register(U.combinedDisposable(ue.createInstance(z.CodeCacheCleaner,this.configuration.codeCachePath),ue.createInstance(V.LanguagePackCachedDataCleaner),ue.createInstance(q.StorageDataCleaner,this.configuration.backupWorkspacesPath),ue.createInstance($.LogsDataCleaner),ue.createInstance(me.LocalizationsUpdater),ue.createInstance(Se.DeprecatedExtensionsCleaner)))}async initServices(){const ue=new S.ServiceCollection,Re=Object.assign({_serviceBrand:void 0},O.default);ue.set(W.IProductService,Re);const Fe=new y.StaticRouter(Be=>Be==="main"),_e=new X.MessagePortMainProcessService(this.server,Fe);ue.set(H.IMainProcessService,_e);const Ne=new b.NativeEnvironmentService(this.configuration.args,Re);ue.set(h.INativeEnvironmentService,Ne);const tt=new p.LogLevelChannelClient(this.server.getChannel("logLevel",Fe)),Je=new p.LoggerChannelClient(this.configuration.logLevel,tt.onDidChangeLogLevel,_e.getChannel("logger"));ue.set(l.ILoggerService,Je);const it=this._register(new l.MultiplexLogService([this._register(new l.ConsoleLogger(this.configuration.logLevel)),this._register(Je.createLogger(fe.joinPath(ge.URI.file(Ne.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),We=this._register(new p.FollowerLogService(tt,it));ue.set(l.ILogService,We);const Ve=this._register(new A.FileService(We));ue.set(M.IFileService,Ve);const rt=this._register(new N.DiskFileSystemProvider(We));Ve.registerProvider(B.Schemas.file,rt);const xe=this._register(new d.ConfigurationService(Ne.settingsResource,Ve));ue.set(I.IConfigurationService,xe),await xe.initialize();const Xe=new pe.NativeStorageService(void 0,_e,Ne);ue.set(Ce.IStorageService,Xe),await Xe.initialize(),this._register(U.toDisposable(()=>Xe.flush())),ue.set(c.IRequestService,new n.SyncDescriptor(s.RequestService)),ue.set(ae.IChecksumService,new n.SyncDescriptor(oe.ChecksumService));const nt=y.ProxyChannel.toService(_e.getChannel("nativeHost"),{context:this.configuration.windowId});ue.set(ce.INativeHostService,nt),ue.set(j.IDownloadService,new n.SyncDescriptor(F.DownloadService));const st=this._register(new Ye.ActiveWindowManager(nt)),dt=new y.StaticRouter(Be=>st.getActiveClientId().then(at=>Be===at));ue.set(Te.IExtensionRecommendationNotificationService,new Ke.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",dt)));let Qe,He;if(!Ne.isExtensionDevelopment&&!Ne.disableTelemetry&&Re.enableTelemetry){He=new ze.TelemetryLogAppender(Je,Ne);const{appRoot:Be,extensionsPath:at,isBuilt:mt,installSourcePath:vt}=Ne;if(Re.aiConfig&&Re.aiConfig.asimovKey&&mt){const ut=new o.AppInsightsAppender("monacoworkbench",null,Re.aiConfig.asimovKey);this._register(U.toDisposable(()=>ut.flush())),He=r.combinedAppender(ut,He)}Qe=new u.TelemetryService({appender:He,commonProperties:i.resolveCommonProperties(Ve,R.release(),R.hostname(),process.arch,Re.commit,Re.version,this.configuration.machineId,Re.msftInternalDomains,vt),sendErrorTelemetry:!0,piiPaths:[Be,at]},xe)}else Qe=r.NullTelemetryService,He=r.NullAppender;this.server.registerChannel("telemetryAppender",new a.TelemetryAppenderChannel(He)),ue.set(t.ITelemetryService,Qe);const gt=new he.CustomEndpointTelemetryService(xe,Qe);return ue.set(t.ICustomEndpointTelemetryService,gt),ue.set(C.IExtensionManagementService,new n.SyncDescriptor(P.ExtensionManagementService)),ue.set(C.IExtensionGalleryService,new n.SyncDescriptor(E.ExtensionGalleryService)),ue.set(C.IExtensionTipsService,new n.SyncDescriptor(je.ExtensionTipsService)),ue.set(g.ILocalizationsService,new n.SyncDescriptor(w.LocalizationsService)),ue.set(T.IDiagnosticsService,new n.SyncDescriptor(_.DiagnosticsService)),ue.set(Oe.IUserDataSyncAccountService,new n.SyncDescriptor(Oe.UserDataSyncAccountService)),ue.set(Q.IUserDataSyncLogService,new n.SyncDescriptor(le.UserDataSyncLogService)),ue.set(Q.IUserDataSyncUtilService,new ne.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Be=>Be.ctx!=="main"))),ue.set(C.IGlobalExtensionEnablementService,new n.SyncDescriptor(Ae.GlobalExtensionEnablementService)),ue.set(Y.IIgnoredExtensionsManagementService,new n.SyncDescriptor(Y.IgnoredExtensionsManagementService)),ue.set(re.IExtensionsStorageSyncService,new n.SyncDescriptor(re.ExtensionsStorageSyncService)),ue.set(Q.IUserDataSyncStoreManagementService,new n.SyncDescriptor(ie.UserDataSyncStoreManagementService)),ue.set(Q.IUserDataSyncStoreService,new n.SyncDescriptor(ie.UserDataSyncStoreService)),ue.set(Ie.IUserDataSyncMachinesService,new n.SyncDescriptor(Ie.UserDataSyncMachinesService)),ue.set(Q.IUserDataSyncBackupStoreService,new n.SyncDescriptor(ke.UserDataSyncBackupStoreService)),ue.set(Q.IUserDataAutoSyncEnablementService,new n.SyncDescriptor(qe.UserDataAutoSyncEnablementService)),ue.set(Q.IUserDataSyncResourceEnablementService,new n.SyncDescriptor(Me.UserDataSyncResourceEnablementService)),ue.set(Q.IUserDataSyncService,new n.SyncDescriptor(J.UserDataSyncService)),ue.set(x.ILocalPtyService,this._register(new Pe.PtyHostService({GraceTime:6e4,ShortGraceTime:6e3},xe,We,Qe))),new m.InstantiationService(ue)}initChannels(ue){const Re=new f.ExtensionManagementChannel(ue.get(C.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Re);const Fe=y.ProxyChannel.fromService(ue.get(g.ILocalizationsService));this.server.registerChannel("localizations",Fe);const _e=y.ProxyChannel.fromService(ue.get(T.IDiagnosticsService));this.server.registerChannel("diagnostics",_e);const Ne=new f.ExtensionTipsChannel(ue.get(C.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ne);const tt=y.ProxyChannel.fromService(ue.get(ae.IChecksumService));this.server.registerChannel("checksum",tt);const Je=new ne.UserDataSyncMachinesServiceChannel(ue.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Je);const it=y.ProxyChannel.fromService(ue.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",it);const We=new ne.UserDataSyncAccountServiceChannel(ue.get(Oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",We);const Ve=new ne.UserDataSyncStoreManagementServiceChannel(ue.get(Q.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ve);const rt=new te.UserDataSyncChannel(ue.get(Q.IUserDataSyncService),ue.get(l.ILogService));this.server.registerChannel("userDataSync",rt);const xe=this._register(ue.get(se.IInstantiationService).createInstance(ve.UserDataAutoSyncService)),Xe=new ne.UserDataAutoSyncChannel(xe);this.server.registerChannel("userDataAutoSync",Xe);const nt=ue.get(x.ILocalPtyService),st=y.ProxyChannel.fromService(nt);this.server.registerChannel(Ue.TerminalIpcChannels.LocalPty,st)}registerErrorHandler(ue){window.addEventListener("unhandledrejection",Re=>{De.onUnexpectedError(Re.reason),Re.preventDefault()}),De.setUnexpectedErrorHandler(Re=>{const Fe=be.toErrorMessage(Re,!0);!Fe||ue.error(`[uncaught exception in sharedProcess]: ${Fe}`)})}}async function we(Ee){const ue=new ye(Ee);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ue.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=we})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7dea6d7402b55671410a129661cad24b55aed9f4/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
