/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","os","vs/base/common/uuid","vs/platform/workspaces/common/workspaces","vs/base/common/extpath","vs/base/common/labels","fs","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/tunnel","vs/platform/sign/common/sign","vs/platform/webview/common/webviewManagerService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],Z=function($){for(var e=[],m=0,A=$.length;m<A;m++)e[m]=J[$[m]];return e};define(J[103],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(A,R){if(!A)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=m}),define(J[46],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(I){return(n,v,p)=>{let i=null,E=null;if(typeof p.value=="function"?(i="value",E=p.value):typeof p.get=="function"&&(i="get",E=p.get),!E)throw new Error("not supported");p[i]=I(E,v)}}e.createDecorator=m;function A(I,n,v){let p=null,i=null;if(typeof v.value=="function"?(p="value",i=v.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(p="get",i=v.get),!i)throw new Error("not supported");const E=`$memoize$${n}`;v[p]=function(...k){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,k)}),this[E]}}e.memoize=A;function R(I,n,v){return m((p,i)=>{const E=`$debounce$${i}`,k=`$debounce$result$${i}`;return function(...y){this[k]||(this[k]=v?v():void 0),clearTimeout(this[E]),n&&(this[k]=n(this[k],...y),y=[this[k]]),this[E]=setTimeout(()=>{p.apply(this,y),this[k]=v?v():void 0},I)}})}e.debounce=R;function b(I,n,v){return m((p,i)=>{const E=`$throttle$timer$${i}`,k=`$throttle$result$${i}`,y=`$throttle$lastRun$${i}`,d=`$throttle$pending$${i}`;return function(...g){if(this[k]||(this[k]=v?v():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),n&&(this[k]=n(this[k],...g)),this[d])return;const D=this[y]+I;D<=Date.now()?(this[y]=Date.now(),p.apply(this,[this[k]]),this[k]=v?v():void 0):(this[d]=!0,this[E]=setTimeout(()=>{this[d]=!1,this[y]=Date.now(),p.apply(this,[this[k]]),this[k]=v?v():void 0},D-Date.now()))}})}e.throttle=b}),define(J[16],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function A(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=A;function R(l){v(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=R;function b(l){v(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=b;function I(l){if(l instanceof Error){let{name:t,message:r}=l;const s=l.stacktrace||l.stack;return{$isError:!0,name:t,message:r,stack:s}}return l}e.transformErrorForSerialization=I;const n="Canceled";function v(l){return l instanceof Error&&l.name===n&&l.message===n}e.isPromiseCanceledError=v;class p extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=p;function i(){const l=new Error(n);return l.name=l.message,l}e.canceled=i;function E(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=E;function k(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=k;function y(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function d(l){const t=new Error(`${l} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function g(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=g;class D extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=D;class P extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=P;class c extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=c;function u(l){const t=l;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function o(l,t=Object.create(null)){const r=new Error(l);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=o}),define(J[36],Z([0,1,16]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function A(N,F=0){return N[N.length-(1+F)]}e.tail=A;function R(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=R;function b(N,F,T=(O,M)=>O===M){if(N===F)return!0;if(!N||!F||N.length!==F.length)return!1;for(let O=0,M=N.length;O<M;O++)if(!T(N[O],F[O]))return!1;return!0}e.equals=b;function I(N,F,T){let O=0,M=N.length-1;for(;O<=M;){const W=(O+M)/2|0,U=T(N[W],F);if(U<0)O=W+1;else if(U>0)M=W-1;else return W}return-(O+1)}e.binarySearch=I;function n(N,F){let T=0,O=N.length;if(O===0)return 0;for(;T<O;){const M=Math.floor((T+O)/2);F(N[M])?O=M:T=M+1}return T}e.findFirstInSorted=n;function v(N,F,T){if(N=N|0,N>=F.length)throw new TypeError("invalid index");let O=F[Math.floor(F.length*Math.random())],M=[],W=[],U=[];for(let V of F){const K=T(V,O);K<0?M.push(V):K>0?W.push(V):U.push(V)}return N<M.length?v(N,M,T):N<M.length+U.length?U[0]:v(N-(M.length+U.length),W,T)}e.quickSelect=v;function p(N,F){const T=[];let O;for(const M of N.slice(0).sort(F))!O||F(O[0],M)!==0?(O=[M],T.push(O)):O.push(M);return T}e.groupBy=p;function i(N,F,T){const O=[];function M(V,K,q){if(K===0&&q.length===0)return;const x=O[O.length-1];x&&x.start+x.deleteCount===V?(x.deleteCount+=K,x.toInsert.push(...q)):O.push({start:V,deleteCount:K,toInsert:q})}let W=0,U=0;for(;;){if(W===N.length){M(W,0,F.slice(U));break}if(U===F.length){M(W,N.length-W,[]);break}const V=N[W],K=F[U],q=T(V,K);q===0?(W+=1,U+=1):q<0?(M(W,1,[]),W+=1):q>0&&(M(W,0,[K]),U+=1)}return O}e.sortedDiff=i;function E(N,F,T){const O=i(N,F,T),M=[],W=[];for(const U of O)M.push(...N.slice(U.start,U.start+U.deleteCount)),W.push(...U.toInsert);return{removed:M,added:W}}e.delta=E;function k(N,F,T){if(T===0)return[];const O=N.slice(0,T).sort(F);return d(N,F,O,T,N.length),O}e.top=k;function y(N,F,T,O,M){return T===0?Promise.resolve([]):new Promise((W,U)=>{(async()=>{const V=N.length,K=N.slice(0,T).sort(F);for(let q=T,x=Math.min(T+O,V);q<V;q=x,x=Math.min(x+O,V)){if(q>T&&await new Promise(ne=>setTimeout(ne)),M&&M.isCancellationRequested)throw m.canceled();d(N,F,K,q,x)}return K})().then(W,U)})}e.topAsync=y;function d(N,F,T,O,M){for(const W=T.length;O<M;O++){const U=N[O];if(F(U,T[W-1])<0){T.pop();const V=n(T,K=>F(U,K)<0);T.splice(V,0,U)}}}function g(N){return N.filter(F=>!!F)}e.coalesce=g;function D(N){let F=0;for(let T=0;T<N.length;T++)N[T]&&(N[F]=N[T],F+=1);N.length=F}e.coalesceInPlace=D;function P(N,F,T){N.splice(T,0,N.splice(F,1)[0])}e.move=P;function c(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=c;function u(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=u;function o(N,F){if(!F)return N.filter((O,M)=>N.indexOf(O)===M);const T=Object.create(null);return N.filter(O=>{const M=F(O);return T[M]?!1:(T[M]=!0,!0)})}e.distinct=o;function l(N){const F=new Set;return N.filter(T=>F.has(T)?!1:(F.add(T),!0))}e.distinctES6=l;function t(N){const F=Object.create(null);return T=>{const O=N(T);return F[O]?!1:(F[O]=!0,!0)}}e.uniqueFilter=t;function r(N,F){for(let T=N.length-1;T>=0;T--){const O=N[T];if(F(O))return T}return-1}e.lastIndex=r;function s(N,F){return N.length>0?N[0]:F}e.firstOrDefault=s;function a(N,F,T=(O,M)=>O===M){let O=0;for(let M=0,W=Math.min(N.length,F.length);M<W&&T(N[M],F[M]);M++)O++;return O}e.commonPrefixLength=a;function h(N){return[].concat(...N)}e.flatten=h;function w(N,F){let T=typeof F=="number"?N:0;typeof F=="number"?T=N:(T=0,F=N);const O=[];if(T<=F)for(let M=T;M<F;M++)O.push(M);else for(let M=T;M>F;M--)O.push(M);return O}e.range=w;function f(N,F,T){return N.reduce((O,M)=>(O[F(M)]=T?T(M):M,O),Object.create(null))}e.index=f;function S(N,F){return N.push(F),()=>L(N,F)}e.insert=S;function L(N,F){const T=N.indexOf(F);if(T>-1)return N.splice(T,1),F}e.remove=L;function _(N,F,T){const O=N.slice(0,F),M=N.slice(F);return O.concat(T,M)}e.arrayInsert=_;function H(N,F){let T;if(typeof F=="number"){let O=F;T=()=>{const M=Math.sin(O++)*179426549;return M-Math.floor(M)}}else T=Math.random;for(let O=N.length-1;O>0;O-=1){const M=Math.floor(T()*(O+1)),W=N[O];N[O]=N[M],N[M]=W}}e.shuffle=H;function Q(N,F){const T=N.indexOf(F);T>-1&&(N.splice(T,1),N.unshift(F))}e.pushToStart=Q;function te(N,F){const T=N.indexOf(F);T>-1&&(N.splice(T,1),N.push(F))}e.pushToEnd=te;function B(N,F){return Array.isArray(N)?N.map(F):F(N)}e.mapArrayOrNot=B;function Y(N){return Array.isArray(N)?N:[N]}e.asArray=Y;function G(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=G;function C(N,F){for(const T of N){const O=F(T);if(O!==void 0)return O}}e.mapFind=C;function z(N,F){let T=Number.MAX_SAFE_INTEGER,O=0;return N.forEach((M,W)=>{const U=F(M);U<T&&(T=U,O=W)}),O}e.minIndex=z;function X(N,F){let T=Number.MIN_SAFE_INTEGER,O=0;return N.forEach((M,W)=>{const U=F(M);U>T&&(T=U,O=W)}),O}e.maxIndex=X}),define(J[43],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(A){const R=this;let b=!1,I;return function(){return b||(b=!0,I=A.apply(R,arguments)),I}}e.once=m}),define(J[63],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(A){function R(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}A.is=R;const b=Object.freeze([]);function I(){return b}A.empty=I;function*n(l){yield l}A.single=n;function v(l){return l||b}A.from=v;function p(l){return!l||l[Symbol.iterator]().next().done===!0}A.isEmpty=p;function i(l){return l[Symbol.iterator]().next().value}A.first=i;function E(l,t){for(const r of l)if(t(r))return!0;return!1}A.some=E;function k(l,t){for(const r of l)if(t(r))return r}A.find=k;function*y(l,t){for(const r of l)t(r)&&(yield r)}A.filter=y;function*d(l,t){let r=0;for(const s of l)yield t(s,r++)}A.map=d;function*g(...l){for(const t of l)for(const r of t)yield r}A.concat=g;function*D(l){for(const t of l)for(const r of t)yield r}A.concatNested=D;function P(l,t,r){let s=r;for(const a of l)s=t(s,a);return s}A.reduce=P;function*c(l,t,r=l.length){for(t<0&&(t+=l.length),r<0?r+=l.length:r>l.length&&(r=l.length);t<r;t++)yield l[t]}A.slice=c;function u(l,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,l];const s=l[Symbol.iterator]();for(let a=0;a<t;a++){const h=s.next();if(h.done)return[r,A.empty()];r.push(h.value)}return[r,{[Symbol.iterator](){return s}}]}A.consume=u;function o(l,t,r=(s,a)=>s===a){const s=l[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const h=s.next(),w=a.next();if(h.done!==w.done)return!1;if(h.done)return!0;if(!r(h.value,w.value))return!1}}A.equals=o})(m=e.Iterable||(e.Iterable={}))}),define(J[40],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var b;(function(t){t.DEFAULT={allowTrailingComma:!0}})(b=e.ParseOptions||(e.ParseOptions={}));function I(t,r=!1){let s=0,a=t.length,h="",w=0,f=16,S=0;function L(G){let C=0,z=0;for(;C<G;){const X=t.charCodeAt(s);if(X>=48&&X<=57)z=z*16+X-48;else if(X>=65&&X<=70)z=z*16+X-65+10;else if(X>=97&&X<=102)z=z*16+X-97+10;else break;s++,C++}return C<G&&(z=-1),z}function _(G){s=G,h="",w=0,f=16,S=0}function H(){const G=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&p(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&p(t.charCodeAt(s)))for(s++;s<t.length&&p(t.charCodeAt(s));)s++;else return S=3,t.substring(G,s);let C=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&p(t.charCodeAt(s))){for(s++;s<t.length&&p(t.charCodeAt(s));)s++;C=s}else S=3;return t.substring(G,C)}function Q(){let G="",C=s;for(;;){if(s>=a){G+=t.substring(C,s),S=2;break}const z=t.charCodeAt(s);if(z===34){G+=t.substring(C,s),s++;break}if(z===92){if(G+=t.substring(C,s),s++,s>=a){S=2;break}switch(t.charCodeAt(s++)){case 34:G+='"';break;case 92:G+="\\";break;case 47:G+="/";break;case 98:G+="\b";break;case 102:G+="\f";break;case 110:G+=`
`;break;case 114:G+="\r";break;case 116:G+="	";break;case 117:const N=L(4);N>=0?G+=String.fromCharCode(N):S=4;break;default:S=5}C=s;continue}if(z>=0&&z<=31)if(v(z)){G+=t.substring(C,s),S=2;break}else S=6;s++}return G}function te(){if(h="",S=0,w=s,s>=a)return w=a,f=17;let G=t.charCodeAt(s);if(n(G)){do s++,h+=String.fromCharCode(G),G=t.charCodeAt(s);while(n(G));return f=15}if(v(G))return s++,h+=String.fromCharCode(G),G===13&&t.charCodeAt(s)===10&&(s++,h+=`
`),f=14;switch(G){case 123:return s++,f=1;case 125:return s++,f=2;case 91:return s++,f=3;case 93:return s++,f=4;case 58:return s++,f=6;case 44:return s++,f=5;case 34:return s++,h=Q(),f=10;case 47:const C=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<a&&!v(t.charCodeAt(s));)s++;return h=t.substring(C,s),f=12}if(t.charCodeAt(s+1)===42){s+=2;const z=a-1;let X=!1;for(;s<z;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,X=!0;break}s++}return X||(s++,S=1),h=t.substring(C,s),f=13}return h+=String.fromCharCode(G),s++,f=16;case 45:if(h+=String.fromCharCode(G),s++,s===a||!p(t.charCodeAt(s)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=H(),f=11;default:for(;s<a&&B(G);)s++,G=t.charCodeAt(s);if(w!==s){switch(h=t.substring(w,s),h){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return h+=String.fromCharCode(G),s++,f=16}}function B(G){if(n(G)||v(G))return!1;switch(G){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Y(){let G;do G=te();while(G>=12&&G<=15);return G}return{setPosition:_,getPosition:()=>s,scan:r?Y:te,getToken:()=>f,getTokenValue:()=>h,getTokenOffset:()=>w,getTokenLength:()=>s-w,getTokenError:()=>S}}e.createScanner=I;function n(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function v(t){return t===10||t===13||t===8232||t===8233}function p(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function E(t,r){const s=[],a=new Object;let h;const w={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function S(L,_,H,Q){w.value=L,w.offset=_,w.length=H,w.type=Q,w.colonOffset=void 0,h=w}try{u(t,{onObjectBegin:(L,_)=>{if(r<=L)throw a;h=void 0,f=r>L,s.push("")},onObjectProperty:(L,_,H)=>{if(r<_||(S(L,_,H,"property"),s[s.length-1]=L,r<=_+H))throw a},onObjectEnd:(L,_)=>{if(r<=L)throw a;h=void 0,s.pop()},onArrayBegin:(L,_)=>{if(r<=L)throw a;h=void 0,s.push(0)},onArrayEnd:(L,_)=>{if(r<=L)throw a;h=void 0,s.pop()},onLiteralValue:(L,_,H)=>{if(r<_||(S(L,_,H,l(L)),r<=_+H))throw a},onSeparator:(L,_,H)=>{if(r<=_)throw a;if(L===":"&&h&&h.type==="property")h.colonOffset=_,f=!1,h=void 0;else if(L===","){const Q=s[s.length-1];typeof Q=="number"?s[s.length-1]=Q+1:(f=!0,s[s.length-1]=""),h=void 0}}})}catch(L){if(L!==a)throw L}return{path:s,previousNode:h,isAtPropertyKey:f,matches:L=>{let _=0;for(let H=0;_<L.length&&H<s.length;H++)if(L[_]===s[H]||L[_]==="*")_++;else if(L[_]!=="**")return!1;return _===L.length}}}e.getLocation=E;function k(t,r=[],s=b.DEFAULT){let a=null,h=[];const w=[];function f(L){Array.isArray(h)?h.push(L):a!==null&&(h[a]=L)}return u(t,{onObjectBegin:()=>{const L={};f(L),w.push(h),h=L,a=null},onObjectProperty:L=>{a=L},onObjectEnd:()=>{h=w.pop()},onArrayBegin:()=>{const L=[];f(L),w.push(h),h=L,a=null},onArrayEnd:()=>{h=w.pop()},onLiteralValue:f,onError:(L,_,H)=>{r.push({error:L,offset:_,length:H})}},s),h[0]}e.parse=k;function y(t,r=[],s=b.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(L){a.type==="property"&&(a.length=L-a.offset,a=a.parent)}function w(L){return a.children.push(L),L}u(t,{onObjectBegin:L=>{a=w({type:"object",offset:L,length:-1,parent:a,children:[]})},onObjectProperty:(L,_,H)=>{a=w({type:"property",offset:_,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:L,offset:_,length:H,parent:a})},onObjectEnd:(L,_)=>{a.length=L+_-a.offset,a=a.parent,h(L+_)},onArrayBegin:(L,_)=>{a=w({type:"array",offset:L,length:-1,parent:a,children:[]})},onArrayEnd:(L,_)=>{a.length=L+_-a.offset,a=a.parent,h(L+_)},onLiteralValue:(L,_,H)=>{w({type:l(L),offset:_,length:H,parent:a,value:L}),h(_+H)},onSeparator:(L,_,H)=>{a.type==="property"&&(L===":"?a.colonOffset=_:L===","&&h(_))},onError:(L,_,H)=>{r.push({error:L,offset:_,length:H})}},s);const S=a.children[0];return S&&delete S.parent,S}e.parseTree=y;function d(t,r){if(!t)return;let s=t;for(let a of r)if(typeof a=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let h=!1;for(const w of s.children)if(Array.isArray(w.children)&&w.children[0].value===a){s=w.children[1],h=!0;break}if(!h)return}else{const h=a;if(s.type!=="array"||h<0||!Array.isArray(s.children)||h>=s.children.length)return;s=s.children[h]}return s}e.findNodeAtLocation=d;function g(t){if(!t.parent||!t.parent.children)return[];const r=g(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=g;function D(t){switch(t.type){case"array":return t.children.map(D);case"object":const r=Object.create(null);for(let s of t.children){const a=s.children[1];a&&(r[s.children[0].value]=D(a))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=D;function P(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=P;function c(t,r,s=!1){if(P(t,r,s)){const a=t.children;if(Array.isArray(a))for(let h=0;h<a.length&&a[h].offset<=r;h++){const w=c(a[h],r,s);if(w)return w}return t}}e.findNodeAtOffset=c;function u(t,r,s=b.DEFAULT){const a=I(t,!1);function h(U){return U?()=>U(a.getTokenOffset(),a.getTokenLength()):()=>!0}function w(U){return U?V=>U(V,a.getTokenOffset(),a.getTokenLength()):()=>!0}const f=h(r.onObjectBegin),S=w(r.onObjectProperty),L=h(r.onObjectEnd),_=h(r.onArrayBegin),H=h(r.onArrayEnd),Q=w(r.onLiteralValue),te=w(r.onSeparator),B=h(r.onComment),Y=w(r.onError),G=s&&s.disallowComments,C=s&&s.allowTrailingComma;function z(){for(;;){const U=a.scan();switch(a.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:G||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(U){case 12:case 13:G?X(10):B();break;case 16:X(1);break;case 15:case 14:break;default:return U}}}function X(U,V=[],K=[]){if(Y(U),V.length+K.length>0){let q=a.getToken();for(;q!==17;){if(V.indexOf(q)!==-1){z();break}else if(K.indexOf(q)!==-1)break;q=z()}}}function N(U){const V=a.getTokenValue();return U?Q(V):S(V),z(),!0}function F(){switch(a.getToken()){case 11:let U=0;try{U=JSON.parse(a.getTokenValue()),typeof U!="number"&&(X(2),U=0)}catch(V){X(2)}Q(U);break;case 7:Q(null);break;case 8:Q(!0);break;case 9:Q(!1);break;default:return!1}return z(),!0}function T(){return a.getToken()!==10?(X(3,[],[2,5]),!1):(N(!1),a.getToken()===6?(te(":"),z(),W()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function O(){f(),z();let U=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(U||X(4,[],[]),te(","),z(),a.getToken()===2&&C)break}else U&&X(6,[],[]);T()||X(4,[],[2,5]),U=!0}return L(),a.getToken()!==2?X(7,[2],[]):z(),!0}function M(){_(),z();let U=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(U||X(4,[],[]),te(","),z(),a.getToken()===4&&C)break}else U&&X(6,[],[]);W()||X(4,[],[4,5]),U=!0}return H(),a.getToken()!==4?X(8,[4],[]):z(),!0}function W(){switch(a.getToken()){case 3:return M();case 1:return O();case 10:return N(!0);default:return F()}}return z(),a.getToken()===17?s.allowEmptyContent?!0:(X(4,[],[]),!1):W()?(a.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=u;function o(t,r){let s=I(t),a=[],h,w=0,f;do switch(f=s.getPosition(),h=s.scan(),h){case 12:case 13:case 17:w!==f&&a.push(t.substring(w,f)),r!==void 0&&a.push(s.getTokenValue().replace(/[^\r\n]/g,r)),w=s.getPosition();break}while(h!==17);return a.join("")}e.stripComments=o;function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(J[104],Z([0,1,40]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function A(v,p,i){let E,k,y,d,g;if(p){for(d=p.offset,g=d+p.length,y=d;y>0&&!n(v,y-1);)y--;let w=g;for(;w<v.length&&!n(v,w);)w++;k=v.substring(y,w),E=b(k,i)}else k=v,E=0,y=0,d=0,g=v.length;const D=I(i,v);let P=!1,c=0,u;i.insertSpaces?u=R(" ",i.tabSize||4):u="	";const o=m.createScanner(k,!1);let l=!1;function t(){return D+R(u,E+c)}function r(){let w=o.scan();for(P=!1;w===15||w===14;)P=P||w===14,w=o.scan();return l=w===16||o.getTokenError()!==0,w}const s=[];function a(w,f,S){!l&&f<g&&S>d&&v.substring(f,S)!==w&&s.push({offset:f,length:S-f,content:w})}let h=r();if(h!==17){const w=o.getTokenOffset()+y,f=R(u,E);a(f,y,w)}for(;h!==17;){let w=o.getTokenOffset()+o.getTokenLength()+y,f=r(),S="";for(;!P&&(f===12||f===13);){const _=o.getTokenOffset()+y;a(" ",w,_),w=o.getTokenOffset()+o.getTokenLength()+y,S=f===12?t():"",f=r()}if(f===2)h!==1&&(c--,S=t());else if(f===4)h!==3&&(c--,S=t());else{switch(h){case 3:case 1:c++,S=t();break;case 5:case 12:S=t();break;case 13:P?S=t():S=" ";break;case 6:S=" ";break;case 10:if(f===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?S=" ":f!==5&&f!==17&&(l=!0);break;case 16:l=!0;break}P&&(f===12||f===13)&&(S=t())}const L=o.getTokenOffset()+y;a(S,w,L),h=f}return s}e.format=A;function R(v,p){let i="";for(let E=0;E<p;E++)i+=v;return i}function b(v,p){let i=0,E=0;const k=p.tabSize||4;for(;i<v.length;){const y=v.charAt(i);if(y===" ")E++;else if(y==="	")E+=k;else break;i++}return Math.floor(E/k)}function I(v,p){for(let i=0;i<p.length;i++){const E=p.charAt(i);if(E==="\r")return i+1<p.length&&p.charAt(i+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return v&&v.eol||`
`}e.getEOL=I;function n(v,p){return`\r
`.indexOf(v.charAt(p))!==-1}e.isEOL=n}),define(J[78],Z([0,1,40,104]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(p,i,E){return b(p,i,void 0,E)}e.removeProperty=R;function b(p,i,E,k,y){const d=i.slice(),g=[],D=m.parseTree(p,g);let P,c;for(;d.length>0&&(c=d.pop(),P=m.findNodeAtLocation(D,d),P===void 0&&E!==void 0);)typeof c=="string"?E={[c]:E}:E=[E];if(P)if(P.type==="object"&&typeof c=="string"&&Array.isArray(P.children)){const u=m.findNodeAtLocation(P,[c]);if(u!==void 0)if(E===void 0){if(!u.parent)throw new Error("Malformed AST");const o=P.children.indexOf(u.parent);let l,t=u.parent.offset+u.parent.length;if(o>0){const r=P.children[o-1];l=r.offset+r.length}else l=P.offset+1,P.children.length>1&&(t=P.children[1].offset);return I(p,{offset:l,length:t-l,content:""},k)}else return I(p,{offset:u.offset,length:u.length,content:JSON.stringify(E)},k);else{if(E===void 0)return[];const o=`${JSON.stringify(c)}: ${JSON.stringify(E)}`,l=y?y(P.children.map(r=>r.children[0].value)):P.children.length;let t;if(l>0){const r=P.children[l-1];t={offset:r.offset+r.length,length:0,content:","+o}}else P.children.length===0?t={offset:P.offset+1,length:0,content:o}:t={offset:P.offset+1,length:0,content:o+","};return I(p,t,k)}}else if(P.type==="array"&&typeof c=="number"&&Array.isArray(P.children))if(E!==void 0){const u=`${JSON.stringify(E)}`;let o;if(P.children.length===0||c===0)o={offset:P.offset+1,length:0,content:P.children.length===0?u:u+","};else{const l=c===-1||c>P.children.length?P.children.length:c,t=P.children[l-1];o={offset:t.offset+t.length,length:0,content:","+u}}return I(p,o,k)}else{const u=c,o=P.children[u];let l;if(P.children.length===1)l={offset:P.offset+1,length:P.length-2,content:""};else if(P.children.length-1===u){const t=P.children[u-1],r=t.offset+t.length,s=P.offset+P.length;l={offset:r,length:s-2-r,content:""}}else l={offset:o.offset,length:P.children[u+1].offset-o.offset,content:""};return I(p,l,k)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${P.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return I(p,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(E)},k)}}e.setProperty=b;function I(p,i,E){let k=n(p,i),y=i.offset,d=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;y>0&&!A.isEOL(k,y-1);)y--;for(;d<k.length&&!A.isEOL(k,d);)d++}const g=A.format(k,{offset:y,length:d-y},E);for(let P=g.length-1;P>=0;P--){const c=g[P];k=n(k,c),y=Math.min(y,c.offset),d=Math.max(d,c.offset+c.length),d+=c.content.length-c.length}const D=p.length-(k.length-d)-y;return[{offset:y,length:D,content:k.substring(y,d)}]}e.withFormatting=I;function n(p,i){return p.substring(0,i.offset)+i.content+p.substring(i.offset+i.length)}e.applyEdit=n;function v(p,i){let E=i.slice(0).sort((y,d)=>{const g=y.offset-d.offset;return g===0?y.length-d.length:g}),k=p.length;for(let y=E.length-1;y>=0;y--){let d=E[y];if(d.offset+d.length<=k)p=n(p,d);else throw new Error("Overlapping edit");k=d.offset}return p}e.applyEdits=v}),define(J[57],Z([0,1,16]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var A;(function(c){c[c.DependsOnKbLayout=-1]="DependsOnKbLayout",c[c.Unknown=0]="Unknown",c[c.Backspace=1]="Backspace",c[c.Tab=2]="Tab",c[c.Enter=3]="Enter",c[c.Shift=4]="Shift",c[c.Ctrl=5]="Ctrl",c[c.Alt=6]="Alt",c[c.PauseBreak=7]="PauseBreak",c[c.CapsLock=8]="CapsLock",c[c.Escape=9]="Escape",c[c.Space=10]="Space",c[c.PageUp=11]="PageUp",c[c.PageDown=12]="PageDown",c[c.End=13]="End",c[c.Home=14]="Home",c[c.LeftArrow=15]="LeftArrow",c[c.UpArrow=16]="UpArrow",c[c.RightArrow=17]="RightArrow",c[c.DownArrow=18]="DownArrow",c[c.Insert=19]="Insert",c[c.Delete=20]="Delete",c[c.KEY_0=21]="KEY_0",c[c.KEY_1=22]="KEY_1",c[c.KEY_2=23]="KEY_2",c[c.KEY_3=24]="KEY_3",c[c.KEY_4=25]="KEY_4",c[c.KEY_5=26]="KEY_5",c[c.KEY_6=27]="KEY_6",c[c.KEY_7=28]="KEY_7",c[c.KEY_8=29]="KEY_8",c[c.KEY_9=30]="KEY_9",c[c.KEY_A=31]="KEY_A",c[c.KEY_B=32]="KEY_B",c[c.KEY_C=33]="KEY_C",c[c.KEY_D=34]="KEY_D",c[c.KEY_E=35]="KEY_E",c[c.KEY_F=36]="KEY_F",c[c.KEY_G=37]="KEY_G",c[c.KEY_H=38]="KEY_H",c[c.KEY_I=39]="KEY_I",c[c.KEY_J=40]="KEY_J",c[c.KEY_K=41]="KEY_K",c[c.KEY_L=42]="KEY_L",c[c.KEY_M=43]="KEY_M",c[c.KEY_N=44]="KEY_N",c[c.KEY_O=45]="KEY_O",c[c.KEY_P=46]="KEY_P",c[c.KEY_Q=47]="KEY_Q",c[c.KEY_R=48]="KEY_R",c[c.KEY_S=49]="KEY_S",c[c.KEY_T=50]="KEY_T",c[c.KEY_U=51]="KEY_U",c[c.KEY_V=52]="KEY_V",c[c.KEY_W=53]="KEY_W",c[c.KEY_X=54]="KEY_X",c[c.KEY_Y=55]="KEY_Y",c[c.KEY_Z=56]="KEY_Z",c[c.Meta=57]="Meta",c[c.ContextMenu=58]="ContextMenu",c[c.F1=59]="F1",c[c.F2=60]="F2",c[c.F3=61]="F3",c[c.F4=62]="F4",c[c.F5=63]="F5",c[c.F6=64]="F6",c[c.F7=65]="F7",c[c.F8=66]="F8",c[c.F9=67]="F9",c[c.F10=68]="F10",c[c.F11=69]="F11",c[c.F12=70]="F12",c[c.F13=71]="F13",c[c.F14=72]="F14",c[c.F15=73]="F15",c[c.F16=74]="F16",c[c.F17=75]="F17",c[c.F18=76]="F18",c[c.F19=77]="F19",c[c.NumLock=78]="NumLock",c[c.ScrollLock=79]="ScrollLock",c[c.US_SEMICOLON=80]="US_SEMICOLON",c[c.US_EQUAL=81]="US_EQUAL",c[c.US_COMMA=82]="US_COMMA",c[c.US_MINUS=83]="US_MINUS",c[c.US_DOT=84]="US_DOT",c[c.US_SLASH=85]="US_SLASH",c[c.US_BACKTICK=86]="US_BACKTICK",c[c.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",c[c.US_BACKSLASH=88]="US_BACKSLASH",c[c.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",c[c.US_QUOTE=90]="US_QUOTE",c[c.OEM_8=91]="OEM_8",c[c.OEM_102=92]="OEM_102",c[c.NUMPAD_0=93]="NUMPAD_0",c[c.NUMPAD_1=94]="NUMPAD_1",c[c.NUMPAD_2=95]="NUMPAD_2",c[c.NUMPAD_3=96]="NUMPAD_3",c[c.NUMPAD_4=97]="NUMPAD_4",c[c.NUMPAD_5=98]="NUMPAD_5",c[c.NUMPAD_6=99]="NUMPAD_6",c[c.NUMPAD_7=100]="NUMPAD_7",c[c.NUMPAD_8=101]="NUMPAD_8",c[c.NUMPAD_9=102]="NUMPAD_9",c[c.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",c[c.NUMPAD_ADD=104]="NUMPAD_ADD",c[c.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",c[c.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",c[c.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",c[c.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",c[c.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",c[c.ABNT_C1=110]="ABNT_C1",c[c.ABNT_C2=111]="ABNT_C2",c[c.MAX_VALUE=112]="MAX_VALUE"})(A=e.KeyCode||(e.KeyCode={}));class R{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(u,o){this._keyCodeToStr[u]=o,this._strToKeyCode[o.toLowerCase()]=u}keyCodeToStr(u){return this._keyCodeToStr[u]}strToKeyCode(u){return this._strToKeyCode[u.toLowerCase()]||0}}const b=new R,I=new R,n=new R;(function(){function c(u,o,l=o,t=l){b.define(u,o),I.define(u,l),n.define(u,t)}c(0,"unknown"),c(1,"Backspace"),c(2,"Tab"),c(3,"Enter"),c(4,"Shift"),c(5,"Ctrl"),c(6,"Alt"),c(7,"PauseBreak"),c(8,"CapsLock"),c(9,"Escape"),c(10,"Space"),c(11,"PageUp"),c(12,"PageDown"),c(13,"End"),c(14,"Home"),c(15,"LeftArrow","Left"),c(16,"UpArrow","Up"),c(17,"RightArrow","Right"),c(18,"DownArrow","Down"),c(19,"Insert"),c(20,"Delete"),c(21,"0"),c(22,"1"),c(23,"2"),c(24,"3"),c(25,"4"),c(26,"5"),c(27,"6"),c(28,"7"),c(29,"8"),c(30,"9"),c(31,"A"),c(32,"B"),c(33,"C"),c(34,"D"),c(35,"E"),c(36,"F"),c(37,"G"),c(38,"H"),c(39,"I"),c(40,"J"),c(41,"K"),c(42,"L"),c(43,"M"),c(44,"N"),c(45,"O"),c(46,"P"),c(47,"Q"),c(48,"R"),c(49,"S"),c(50,"T"),c(51,"U"),c(52,"V"),c(53,"W"),c(54,"X"),c(55,"Y"),c(56,"Z"),c(57,"Meta"),c(58,"ContextMenu"),c(59,"F1"),c(60,"F2"),c(61,"F3"),c(62,"F4"),c(63,"F5"),c(64,"F6"),c(65,"F7"),c(66,"F8"),c(67,"F9"),c(68,"F10"),c(69,"F11"),c(70,"F12"),c(71,"F13"),c(72,"F14"),c(73,"F15"),c(74,"F16"),c(75,"F17"),c(76,"F18"),c(77,"F19"),c(78,"NumLock"),c(79,"ScrollLock"),c(80,";",";","OEM_1"),c(81,"=","=","OEM_PLUS"),c(82,",",",","OEM_COMMA"),c(83,"-","-","OEM_MINUS"),c(84,".",".","OEM_PERIOD"),c(85,"/","/","OEM_2"),c(86,"`","`","OEM_3"),c(110,"ABNT_C1"),c(111,"ABNT_C2"),c(87,"[","[","OEM_4"),c(88,"\\","\\","OEM_5"),c(89,"]","]","OEM_6"),c(90,"'","'","OEM_7"),c(91,"OEM_8"),c(92,"OEM_102"),c(93,"NumPad0"),c(94,"NumPad1"),c(95,"NumPad2"),c(96,"NumPad3"),c(97,"NumPad4"),c(98,"NumPad5"),c(99,"NumPad6"),c(100,"NumPad7"),c(101,"NumPad8"),c(102,"NumPad9"),c(103,"NumPad_Multiply"),c(104,"NumPad_Add"),c(105,"NumPad_Separator"),c(106,"NumPad_Subtract"),c(107,"NumPad_Decimal"),c(108,"NumPad_Divide")})();var v;(function(c){function u(s){return b.keyCodeToStr(s)}c.toString=u;function o(s){return b.strToKeyCode(s)}c.fromString=o;function l(s){return I.keyCodeToStr(s)}c.toUserSettingsUS=l;function t(s){return n.keyCodeToStr(s)}c.toUserSettingsGeneral=t;function r(s){return I.strToKeyCode(s)||n.strToKeyCode(s)}c.fromUserSettings=r})(v=e.KeyCodeUtils||(e.KeyCodeUtils={}));var p;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl",c[c.KeyCode=255]="KeyCode"})(p||(p={}));var i;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl"})(i=e.KeyMod||(e.KeyMod={}));function E(c,u){const o=(u&65535)<<16>>>0;return(c|o)>>>0}e.KeyChord=E;function k(c,u){if(c===0)return null;const o=(c&65535)>>>0,l=(c&4294901760)>>>16;return l!==0?new g([y(o,u),y(l,u)]):new g([y(o,u)])}e.createKeybinding=k;function y(c,u){const o=!!(c&2048),l=!!(c&256),t=u===2?l:o,r=!!(c&1024),s=!!(c&512),a=u===2?o:l,h=c&255;return new d(t,r,s,a,h)}e.createSimpleKeybinding=y;class d{constructor(u,o,l,t,r){this.ctrlKey=u,this.shiftKey=o,this.altKey=l,this.metaKey=t,this.keyCode=r}equals(u){return this.ctrlKey===u.ctrlKey&&this.shiftKey===u.shiftKey&&this.altKey===u.altKey&&this.metaKey===u.metaKey&&this.keyCode===u.keyCode}getHashCode(){const u=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",l=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${u}${o}${l}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new g([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class g{constructor(u){if(u.length===0)throw m.illegalArgument("parts");this.parts=u}getHashCode(){let u="";for(let o=0,l=this.parts.length;o<l;o++)o!==0&&(u+=";"),u+=this.parts[o].getHashCode();return u}equals(u){if(u===null||this.parts.length!==u.parts.length)return!1;for(let o=0;o<this.parts.length;o++)if(!this.parts[o].equals(u.parts[o]))return!1;return!0}}e.ChordKeybinding=g;class D{constructor(u,o,l,t,r,s){this.ctrlKey=u,this.shiftKey=o,this.altKey=l,this.metaKey=t,this.keyLabel=r,this.keyAriaLabel=s}}e.ResolvedKeybindingPart=D;class P{}e.ResolvedKeybinding=P}),define(J[2],Z([0,1,43,63]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const R=!1;let b=null;function I(o){b=o}if(e.setDisposableTracker=I,R){const o="__is_disposable_tracked__";b=new class{trackDisposable(l){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[o]||console.log(t)},3e3)}markTracked(l){if(l&&l!==g.None)try{l[o]=!0}catch(t){}}}}function n(o){!b||b.markTracked(o)}function v(o){return b&&b.trackDisposable(o),o}e.trackDisposable=v;class p extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=p;function i(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=i;function E(o){if(A.Iterable.is(o)){let l=[];for(const t of o)if(t){n(t);try{t.dispose()}catch(r){l.push(r)}}if(l.length===1)throw l[0];if(l.length>1)throw new p(l);return Array.isArray(o)?[]:o}else if(o)return n(o),o.dispose(),o}e.dispose=E;function k(...o){return o.forEach(n),y(()=>E(o))}e.combinedDisposable=k;function y(o){const l=v({dispose:()=>{n(l),o()}});return l}e.toDisposable=y;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(n(this),this._isDisposed=!0,this.clear())}clear(){try{E(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return n(l),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new d,v(this)}dispose(){n(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class D{constructor(){this._isDisposed=!1,v(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var t;this._isDisposed||l===this._value||((t=this._value)===null||t===void 0||t.dispose(),l&&n(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,n(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=D;class P{constructor(){this.references=new Map}acquire(l,...t){let r=this.references.get(l);r||(r={counter:0,object:this.createReferencedObject(l,...t)},this.references.set(l,r));const{object:s}=r,a=m.once(()=>{--r.counter==0&&(this.destroyReferencedObject(l,r.object),this.references.delete(l))});return r.counter++,{object:s,dispose:a}}}e.ReferenceCollection=P;class c{constructor(l){this.referenceCollection=l}async acquire(l,...t){const r=this.referenceCollection.acquire(l,...t);try{return{object:await r.object,dispose:()=>r.dispose()}}catch(s){throw r.dispose(),s}}}e.AsyncReferenceCollection=c;class u{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=u}),define(J[79],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(b){this.element=b,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class A{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let b=this._first;for(;b!==m.Undefined;){const I=b.next;b.prev=m.Undefined,b.next=m.Undefined,b=I}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(b){return this._insert(b,!1)}push(b){return this._insert(b,!0)}_insert(b,I){const n=new m(b);if(this._first===m.Undefined)this._first=n,this._last=n;else if(I){const p=this._last;this._last=n,n.prev=p,p.next=n}else{const p=this._first;this._first=n,n.next=p,p.prev=n}this._size+=1;let v=!1;return()=>{v||(v=!0,this._remove(n))}}shift(){if(this._first!==m.Undefined){const b=this._first.element;return this._remove(this._first),b}}pop(){if(this._last!==m.Undefined){const b=this._last.element;return this._remove(this._last),b}}_remove(b){if(b.prev!==m.Undefined&&b.next!==m.Undefined){const I=b.prev;I.next=b.next,b.next.prev=I}else b.prev===m.Undefined&&b.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):b.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):b.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let b=this._first;for(;b!==m.Undefined;)yield b.element,b=b.next}}e.LinkedList=A}),function(){function $(R){const b=[];typeof R=="number"&&b.push("code/timeOrigin",R);function I(v){b.push(v,Date.now())}function n(){const v=[];for(let p=0;p<b.length;p+=2)v.push({name:b[p],startTime:b[p+1]});return v}return{mark:I,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const b=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const I of performance.getEntriesByType("mark"))b.push({name:I.name,startTime:Math.round(R+I.startTime)});return b}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function m(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=m(A))}(),define(J[3],Z([0,1]),function($,e){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const A="en";let R=!1,b=!1,I=!1,n=!1,v=!1,p=!1,i=!1,E,k=A,y,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?g=e.globals.vscode.process:typeof process!="undefined"&&(g=process);const D=typeof((m=g==null?void 0:g.versions)===null||m===void 0?void 0:m.electron)=="string"&&g.type==="renderer";if(e.isElectronSandboxed=D&&(g==null?void 0:g.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const a=g==null?void 0:g.env.VSCODE_BROWSER_CODE_LOADING;if(typeof a=="string")return a==="none"||a==="code"||a==="bypassHeatCheck"||a==="bypassHeatCheckAndEagerCompile"?a:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!D)d=navigator.userAgent,R=d.indexOf("Windows")>=0,b=d.indexOf("Macintosh")>=0,i=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=d.indexOf("Linux")>=0,p=!0,E=navigator.language,k=E;else if(typeof g=="object"){R=g.platform==="win32",b=g.platform==="darwin",I=g.platform==="linux",n=I&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,E=A,k=A;const a=g.env.VSCODE_NLS_CONFIG;if(a)try{const h=JSON.parse(a),w=h.availableLanguages["*"];E=h.locale,k=w||A,y=h._translationsConfigFile}catch(h){}v=!0}else console.error("Unable to resolve platform.");var P;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(P=e.Platform||(e.Platform={}));function c(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let u=0;b?u=1:R?u=3:I&&(u=2),e.isWindows=R,e.isMacintosh=b,e.isLinux=I,e.isLinuxSnap=n,e.isNative=v,e.isWeb=p,e.isIOS=i,e.platform=u,e.userAgent=d,e.language=k;var o;(function(a){function h(){return e.language}a.value=h;function w(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=w;function f(){return e.language==="en"}a.isDefault=f})(o=e.Language||(e.Language={})),e.locale=E,e.translationsConfigFile=y,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let w=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeSetImmediateId)for(let L=0,_=w.length;L<_;L++){const H=w[L];if(H.id===S.data.vscodeSetImmediateId){w.splice(L,1),H.callback();return}}});let f=0;return S=>{const L=++f;w.push({id:L,callback:S}),e.globals.postMessage({vscodeSetImmediateId:L},"*")}}if(typeof(g==null?void 0:g.nextTick)=="function")return g.nextTick.bind(g);const h=Promise.resolve();return w=>h.then(w)}();var l;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=b||i?2:R?1:3;let t=!0,r=!1;function s(){if(!r){r=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,t=new Uint16Array(a.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(J[33],Z([0,1,3]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let A;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const R=m.globals.vscode.process;A={get platform(){return R.platform},get env(){return R.env},cwd(){return R.cwd()},nextTick(b){return m.setImmediate(b)}}}else typeof process!="undefined"?A={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}}:A={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},nextTick(R){return m.setImmediate(R)},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.nextTick=A.nextTick}),define(J[8],Z([0,1,33]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,R=97,b=90,I=122,n=46,v=47,p=92,i=58,E=63;class k extends Error{constructor(o,l,t){let r;typeof l=="string"&&l.indexOf("not ")===0?(r="must not be",l=l.replace(/^not /,"")):r="must be";const s=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${s} ${r} of type ${l}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function y(u,o){if(typeof u!="string")throw new k(o,"string",u)}function d(u){return u===v||u===p}function g(u){return u===v}function D(u){return u>=A&&u<=b||u>=R&&u<=I}function P(u,o,l,t){let r="",s=0,a=-1,h=0,w=0;for(let f=0;f<=u.length;++f){if(f<u.length)w=u.charCodeAt(f);else{if(t(w))break;w=v}if(t(w)){if(!(a===f-1||h===1))if(h===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==n||r.charCodeAt(r.length-2)!==n){if(r.length>2){const S=r.lastIndexOf(l);S===-1?(r="",s=0):(r=r.slice(0,S),s=r.length-1-r.lastIndexOf(l)),a=f,h=0;continue}else if(r.length!==0){r="",s=0,a=f,h=0;continue}}o&&(r+=r.length>0?`${l}..`:"..",s=2)}else r.length>0?r+=`${l}${u.slice(a+1,f)}`:r=u.slice(a+1,f),s=f-a-1;a=f,h=0}else w===n&&h!==-1?++h:h=-1}return r}function c(u,o){if(o===null||typeof o!="object")throw new k("pathObject","Object",o);const l=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return l?l===o.root?`${l}${t}`:`${l}${u}${t}`:t}e.win32={resolve(...u){let o="",l="",t=!1;for(let r=u.length-1;r>=-1;r--){let s;if(r>=0){if(s=u[r],y(s,"path"),s.length===0)continue}else o.length===0?s=m.cwd():(s=m.env[`=${o}`]||m.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==o.toLowerCase()&&s.charCodeAt(2)===p)&&(s=`${o}\\`));const a=s.length;let h=0,w="",f=!1;const S=s.charCodeAt(0);if(a===1)d(S)&&(h=1,f=!0);else if(d(S))if(f=!0,d(s.charCodeAt(1))){let L=2,_=L;for(;L<a&&!d(s.charCodeAt(L));)L++;if(L<a&&L!==_){const H=s.slice(_,L);for(_=L;L<a&&d(s.charCodeAt(L));)L++;if(L<a&&L!==_){for(_=L;L<a&&!d(s.charCodeAt(L));)L++;(L===a||L!==_)&&(w=`\\\\${H}\\${s.slice(_,L)}`,h=L)}}}else h=1;else D(S)&&s.charCodeAt(1)===i&&(w=s.slice(0,2),h=2,a>2&&d(s.charCodeAt(2))&&(f=!0,h=3));if(w.length>0)if(o.length>0){if(w.toLowerCase()!==o.toLowerCase())continue}else o=w;if(t){if(o.length>0)break}else if(l=`${s.slice(h)}\\${l}`,t=f,f&&o.length>0)break}return l=P(l,!t,"\\",d),t?`${o}\\${l}`:`${o}${l}`||"."},normalize(u){y(u,"path");const o=u.length;if(o===0)return".";let l=0,t,r=!1;const s=u.charCodeAt(0);if(o===1)return g(s)?"\\":u;if(d(s))if(r=!0,d(u.charCodeAt(1))){let h=2,w=h;for(;h<o&&!d(u.charCodeAt(h));)h++;if(h<o&&h!==w){const f=u.slice(w,h);for(w=h;h<o&&d(u.charCodeAt(h));)h++;if(h<o&&h!==w){for(w=h;h<o&&!d(u.charCodeAt(h));)h++;if(h===o)return`\\\\${f}\\${u.slice(w)}\\`;h!==w&&(t=`\\\\${f}\\${u.slice(w,h)}`,l=h)}}}else l=1;else D(s)&&u.charCodeAt(1)===i&&(t=u.slice(0,2),l=2,o>2&&d(u.charCodeAt(2))&&(r=!0,l=3));let a=l<o?P(u.slice(l),!r,"\\",d):"";return a.length===0&&!r&&(a="."),a.length>0&&d(u.charCodeAt(o-1))&&(a+="\\"),t===void 0?r?`\\${a}`:a:r?`${t}\\${a}`:`${t}${a}`},isAbsolute(u){y(u,"path");const o=u.length;if(o===0)return!1;const l=u.charCodeAt(0);return d(l)||o>2&&D(l)&&u.charCodeAt(1)===i&&d(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let o,l;for(let s=0;s<u.length;++s){const a=u[s];y(a,"path"),a.length>0&&(o===void 0?o=l=a:o+=`\\${a}`)}if(o===void 0)return".";let t=!0,r=0;if(typeof l=="string"&&d(l.charCodeAt(0))){++r;const s=l.length;s>1&&d(l.charCodeAt(1))&&(++r,s>2&&(d(l.charCodeAt(2))?++r:t=!1))}if(t){for(;r<o.length&&d(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(u,o){if(y(u,"from"),y(o,"to"),u===o)return"";const l=e.win32.resolve(u),t=e.win32.resolve(o);if(l===t||(u=l.toLowerCase(),o=t.toLowerCase(),u===o))return"";let r=0;for(;r<u.length&&u.charCodeAt(r)===p;)r++;let s=u.length;for(;s-1>r&&u.charCodeAt(s-1)===p;)s--;const a=s-r;let h=0;for(;h<o.length&&o.charCodeAt(h)===p;)h++;let w=o.length;for(;w-1>h&&o.charCodeAt(w-1)===p;)w--;const f=w-h,S=a<f?a:f;let L=-1,_=0;for(;_<S;_++){const Q=u.charCodeAt(r+_);if(Q!==o.charCodeAt(h+_))break;Q===p&&(L=_)}if(_!==S){if(L===-1)return t}else{if(f>S){if(o.charCodeAt(h+_)===p)return t.slice(h+_+1);if(_===2)return t.slice(h+_)}a>S&&(u.charCodeAt(r+_)===p?L=_:_===2&&(L=3)),L===-1&&(L=0)}let H="";for(_=r+L+1;_<=s;++_)(_===s||u.charCodeAt(_)===p)&&(H+=H.length===0?"..":"\\..");return h+=L,H.length>0?`${H}${t.slice(h,w)}`:(t.charCodeAt(h)===p&&++h,t.slice(h,w))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const o=e.win32.resolve(u);if(o.length<=2)return u;if(o.charCodeAt(0)===p){if(o.charCodeAt(1)===p){const l=o.charCodeAt(2);if(l!==E&&l!==n)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(D(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===p)return`\\\\?\\${o}`;return u},dirname(u){y(u,"path");const o=u.length;if(o===0)return".";let l=-1,t=0;const r=u.charCodeAt(0);if(o===1)return d(r)?u:".";if(d(r)){if(l=t=1,d(u.charCodeAt(1))){let h=2,w=h;for(;h<o&&!d(u.charCodeAt(h));)h++;if(h<o&&h!==w){for(w=h;h<o&&d(u.charCodeAt(h));)h++;if(h<o&&h!==w){for(w=h;h<o&&!d(u.charCodeAt(h));)h++;if(h===o)return u;h!==w&&(l=t=h+1)}}}}else D(r)&&u.charCodeAt(1)===i&&(l=o>2&&d(u.charCodeAt(2))?3:2,t=l);let s=-1,a=!0;for(let h=o-1;h>=t;--h)if(d(u.charCodeAt(h))){if(!a){s=h;break}}else a=!1;if(s===-1){if(l===-1)return".";s=l}return u.slice(0,s)},basename(u,o){o!==void 0&&y(o,"ext"),y(u,"path");let l=0,t=-1,r=!0,s;if(u.length>=2&&D(u.charCodeAt(0))&&u.charCodeAt(1)===i&&(l=2),o!==void 0&&o.length>0&&o.length<=u.length){if(o===u)return"";let a=o.length-1,h=-1;for(s=u.length-1;s>=l;--s){const w=u.charCodeAt(s);if(d(w)){if(!r){l=s+1;break}}else h===-1&&(r=!1,h=s+1),a>=0&&(w===o.charCodeAt(a)?--a==-1&&(t=s):(a=-1,t=h))}return l===t?t=h:t===-1&&(t=u.length),u.slice(l,t)}for(s=u.length-1;s>=l;--s)if(d(u.charCodeAt(s))){if(!r){l=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":u.slice(l,t)},extname(u){y(u,"path");let o=0,l=-1,t=0,r=-1,s=!0,a=0;u.length>=2&&u.charCodeAt(1)===i&&D(u.charCodeAt(0))&&(o=t=2);for(let h=u.length-1;h>=o;--h){const w=u.charCodeAt(h);if(d(w)){if(!s){t=h+1;break}continue}r===-1&&(s=!1,r=h+1),w===n?l===-1?l=h:a!==1&&(a=1):l!==-1&&(a=-1)}return l===-1||r===-1||a===0||a===1&&l===r-1&&l===t+1?"":u.slice(l,r)},format:c.bind(null,"\\"),parse(u){y(u,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return o;const l=u.length;let t=0,r=u.charCodeAt(0);if(l===1)return d(r)?(o.root=o.dir=u,o):(o.base=o.name=u,o);if(d(r)){if(t=1,d(u.charCodeAt(1))){let L=2,_=L;for(;L<l&&!d(u.charCodeAt(L));)L++;if(L<l&&L!==_){for(_=L;L<l&&d(u.charCodeAt(L));)L++;if(L<l&&L!==_){for(_=L;L<l&&!d(u.charCodeAt(L));)L++;L===l?t=L:L!==_&&(t=L+1)}}}}else if(D(r)&&u.charCodeAt(1)===i){if(l<=2)return o.root=o.dir=u,o;if(t=2,d(u.charCodeAt(2))){if(l===3)return o.root=o.dir=u,o;t=3}}t>0&&(o.root=u.slice(0,t));let s=-1,a=t,h=-1,w=!0,f=u.length-1,S=0;for(;f>=t;--f){if(r=u.charCodeAt(f),d(r)){if(!w){a=f+1;break}continue}h===-1&&(w=!1,h=f+1),r===n?s===-1?s=f:S!==1&&(S=1):s!==-1&&(S=-1)}return h!==-1&&(s===-1||S===0||S===1&&s===h-1&&s===a+1?o.base=o.name=u.slice(a,h):(o.name=u.slice(a,s),o.base=u.slice(a,h),o.ext=u.slice(s,h))),a>0&&a!==t?o.dir=u.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let o="",l=!1;for(let t=u.length-1;t>=-1&&!l;t--){const r=t>=0?u[t]:m.cwd();y(r,"path"),r.length!==0&&(o=`${r}/${o}`,l=r.charCodeAt(0)===v)}return o=P(o,!l,"/",g),l?`/${o}`:o.length>0?o:"."},normalize(u){if(y(u,"path"),u.length===0)return".";const o=u.charCodeAt(0)===v,l=u.charCodeAt(u.length-1)===v;return u=P(u,!o,"/",g),u.length===0?o?"/":l?"./":".":(l&&(u+="/"),o?`/${u}`:u)},isAbsolute(u){return y(u,"path"),u.length>0&&u.charCodeAt(0)===v},join(...u){if(u.length===0)return".";let o;for(let l=0;l<u.length;++l){const t=u[l];y(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(u,o){if(y(u,"from"),y(o,"to"),u===o||(u=e.posix.resolve(u),o=e.posix.resolve(o),u===o))return"";const l=1,t=u.length,r=t-l,s=1,a=o.length-s,h=r<a?r:a;let w=-1,f=0;for(;f<h;f++){const L=u.charCodeAt(l+f);if(L!==o.charCodeAt(s+f))break;L===v&&(w=f)}if(f===h)if(a>h){if(o.charCodeAt(s+f)===v)return o.slice(s+f+1);if(f===0)return o.slice(s+f)}else r>h&&(u.charCodeAt(l+f)===v?w=f:f===0&&(w=0));let S="";for(f=l+w+1;f<=t;++f)(f===t||u.charCodeAt(f)===v)&&(S+=S.length===0?"..":"/..");return`${S}${o.slice(s+w)}`},toNamespacedPath(u){return u},dirname(u){if(y(u,"path"),u.length===0)return".";const o=u.charCodeAt(0)===v;let l=-1,t=!0;for(let r=u.length-1;r>=1;--r)if(u.charCodeAt(r)===v){if(!t){l=r;break}}else t=!1;return l===-1?o?"/":".":o&&l===1?"//":u.slice(0,l)},basename(u,o){o!==void 0&&y(o,"ext"),y(u,"path");let l=0,t=-1,r=!0,s;if(o!==void 0&&o.length>0&&o.length<=u.length){if(o===u)return"";let a=o.length-1,h=-1;for(s=u.length-1;s>=0;--s){const w=u.charCodeAt(s);if(w===v){if(!r){l=s+1;break}}else h===-1&&(r=!1,h=s+1),a>=0&&(w===o.charCodeAt(a)?--a==-1&&(t=s):(a=-1,t=h))}return l===t?t=h:t===-1&&(t=u.length),u.slice(l,t)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===v){if(!r){l=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":u.slice(l,t)},extname(u){y(u,"path");let o=-1,l=0,t=-1,r=!0,s=0;for(let a=u.length-1;a>=0;--a){const h=u.charCodeAt(a);if(h===v){if(!r){l=a+1;break}continue}t===-1&&(r=!1,t=a+1),h===n?o===-1?o=a:s!==1&&(s=1):o!==-1&&(s=-1)}return o===-1||t===-1||s===0||s===1&&o===t-1&&o===l+1?"":u.slice(o,t)},format:c.bind(null,"/"),parse(u){y(u,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return o;const l=u.charCodeAt(0)===v;let t;l?(o.root="/",t=1):t=0;let r=-1,s=0,a=-1,h=!0,w=u.length-1,f=0;for(;w>=t;--w){const S=u.charCodeAt(w);if(S===v){if(!h){s=w+1;break}continue}a===-1&&(h=!1,a=w+1),S===n?r===-1?r=w:f!==1&&(f=1):r!==-1&&(f=-1)}if(a!==-1){const S=s===0&&l?1:s;r===-1||f===0||f===1&&r===a-1&&r===s+1?o.base=o.name=u.slice(S,a):(o.name=u.slice(S,r),o.base=u.slice(S,a),o.ext=u.slice(r,a))}return s>0?o.dir=u.slice(0,s-1):l&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[105],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var A;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(A=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(b,...I){const n=I.reduce((i,E)=>(i[E]=!0,i),{}),v=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(i=>!n[i]).forEach(i=>{for(let E=0;E<v.length;E++)if(i.search(v[E])!==-1){delete b[i];break}})}e.sanitizeProcessEnvironment=R}),define(J[80],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var m;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(m=e.ScanCode||(e.ScanCode={}));const A=[],R=Object.create(null),b=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>b[n]||0,toEnum:n=>R[n]||0,toString:n=>A[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class I{constructor(v,p,i,E,k){this.ctrlKey=v,this.shiftKey=p,this.altKey=i,this.metaKey=E,this.scanCode=k}equals(v){return this.ctrlKey===v.ctrlKey&&this.shiftKey===v.shiftKey&&this.altKey===v.altKey&&this.metaKey===v.metaKey&&this.scanCode===v.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=I,function(){function n(v,p){A[v]=p,R[p]=v,b[p.toLowerCase()]=v}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let v=0;v<=193;v++)e.IMMUTABLE_CODE_TO_KEY_CODE[v]=-1;for(let v=0;v<=112;v++)e.IMMUTABLE_KEY_CODE_TO_CODE[v]=-1;function n(v,p){e.IMMUTABLE_CODE_TO_KEY_CODE[v]=p,p!==0&&p!==3&&p!==5&&p!==4&&p!==6&&p!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[p]=v)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(J[106],Z([0,1,57,80]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class R{static _readModifiers(I){I=I.toLowerCase().trim();let n=!1,v=!1,p=!1,i=!1,E;do E=!1,/^ctrl(\+|\-)/.test(I)&&(n=!0,I=I.substr("ctrl-".length),E=!0),/^shift(\+|\-)/.test(I)&&(v=!0,I=I.substr("shift-".length),E=!0),/^alt(\+|\-)/.test(I)&&(p=!0,I=I.substr("alt-".length),E=!0),/^meta(\+|\-)/.test(I)&&(i=!0,I=I.substr("meta-".length),E=!0),/^win(\+|\-)/.test(I)&&(i=!0,I=I.substr("win-".length),E=!0),/^cmd(\+|\-)/.test(I)&&(i=!0,I=I.substr("cmd-".length),E=!0);while(E);let k;const y=I.indexOf(" ");return y>0?(k=I.substring(0,y),I=I.substring(y)):(k=I,I=""),{remains:I,ctrl:n,shift:v,alt:p,meta:i,key:k}}static parseSimpleKeybinding(I){const n=this._readModifiers(I),v=m.KeyCodeUtils.fromUserSettings(n.key);return[new m.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,v),n.remains]}static parseKeybinding(I,n){if(!I)return null;const v=[];let p;do[p,I]=this.parseSimpleKeybinding(I),v.push(p);while(I.length>0);return new m.ChordKeybinding(v)}static parseSimpleUserBinding(I){const n=this._readModifiers(I),v=n.key.match(/^\[([^\]]+)\]$/);if(v){const i=v[1],E=A.ScanCodeUtils.lowerCaseToEnum(i);return[new A.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,E),n.remains]}const p=m.KeyCodeUtils.fromUserSettings(n.key);return[new m.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,p),n.remains]}static parseUserBinding(I){if(!I)return[];const n=[];let v;for(;I.length>0;)[v,I]=this.parseSimpleUserBinding(I),n.push(v);return n}}e.KeybindingParser=R}),define(J[107],Z([0,1,3]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=m.globals.performance&&typeof m.globals.performance.now=="function";class R{constructor(I){this._highResolution=A&&I,this._startTime=this._now(),this._stopTime=-1}static create(I=!0){return new R(I)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=R}),define(J[5],Z([0,1,16,43,2,79,107]),function($,e,m,A,R,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(c){c.None=()=>R.Disposable.None;function u(Y){return(G,C=null,z)=>{let X=!1,N;return N=Y(F=>{if(!X)return N?N.dispose():X=!0,G.call(C,F)},null,z),X&&N.dispose(),N}}c.once=u;function o(Y,G){return h((C,z=null,X)=>Y(N=>C.call(z,G(N)),null,X))}c.map=o;function l(Y,G){return h((C,z=null,X)=>Y(N=>{G(N),C.call(z,N)},null,X))}c.forEach=l;function t(Y,G){return h((C,z=null,X)=>Y(N=>G(N)&&C.call(z,N),null,X))}c.filter=t;function r(Y){return Y}c.signal=r;function s(...Y){return(G,C=null,z)=>R.combinedDisposable(...Y.map(X=>X(N=>G.call(C,N),null,z)))}c.any=s;function a(Y,G,C){let z=C;return o(Y,X=>(z=G(z,X),z))}c.reduce=a;function h(Y){let G;const C=new k({onFirstListenerAdd(){G=Y(C.fire,C)},onLastListenerRemove(){G.dispose()}});return C.event}function w(Y,G,C=100,z=!1,X){let N,F,T,O=0;const M=new k({leakWarningThreshold:X,onFirstListenerAdd(){N=Y(W=>{O++,F=G(F,W),z&&!T&&(M.fire(F),F=void 0),clearTimeout(T),T=setTimeout(()=>{const U=F;F=void 0,T=void 0,(!z||O>1)&&M.fire(U),O=0},C)})},onLastListenerRemove(){N.dispose()}});return M.event}c.debounce=w;function f(Y,G=(C,z)=>C===z){let C=!0,z;return t(Y,X=>{const N=C||!G(X,z);return C=!1,z=X,N})}c.latch=f;function S(Y,G){return[c.filter(Y,G),c.filter(Y,C=>!G(C))]}c.split=S;function L(Y,G=!1,C=[]){let z=C.slice(),X=Y(T=>{z?z.push(T):F.fire(T)});const N=()=>{z&&z.forEach(T=>F.fire(T)),z=null},F=new k({onFirstListenerAdd(){X||(X=Y(T=>F.fire(T)))},onFirstListenerDidAdd(){z&&(G?setTimeout(N):N())},onLastListenerRemove(){X&&X.dispose(),X=null}});return F.event}c.buffer=L;class _{constructor(G){this.event=G}map(G){return new _(o(this.event,G))}forEach(G){return new _(l(this.event,G))}filter(G){return new _(t(this.event,G))}reduce(G,C){return new _(a(this.event,G,C))}latch(){return new _(f(this.event))}debounce(G,C=100,z=!1,X){return new _(w(this.event,G,C,z,X))}on(G,C,z){return this.event(G,C,z)}once(G,C,z){return u(this.event)(G,C,z)}}function H(Y){return new _(Y)}c.chain=H;function Q(Y,G,C=z=>z){const z=(...T)=>F.fire(C(...T)),X=()=>Y.on(G,z),N=()=>Y.removeListener(G,z),F=new k({onFirstListenerAdd:X,onLastListenerRemove:N});return F.event}c.fromNodeEventEmitter=Q;function te(Y,G,C=z=>z){const z=(...T)=>F.fire(C(...T)),X=()=>Y.addEventListener(G,z),N=()=>Y.removeEventListener(G,z),F=new k({onFirstListenerAdd:X,onLastListenerRemove:N});return F.event}c.fromDOMEventEmitter=te;function B(Y){return new Promise(G=>u(Y)(G))}c.toPromise=B})(n=e.Event||(e.Event={}));class v{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${v._idPool++}`}start(u){this._stopWatch=new I.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}v._idPool=0;let p=-1;function i(c){const u=p;return p=c,{dispose(){p=u}}}e.setGlobalLeakWarningThreshold=i;class E{constructor(u,o=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let o=p;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||u<o)return;this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),t=this._stacks.get(l)||0;if(this._stacks.set(l,t+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let r,s=0;for(const[a,h]of this._stacks)(!r||s<h)&&(r=a,s=h);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${s}):`),console.warn(r)}return()=>{const r=this._stacks.get(l)||0;this._stacks.set(l,r-1)}}}class k{constructor(u){var o;this._disposed=!1,this._options=u,this._leakageMon=p>0?new E(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((o=this._options)===null||o===void 0?void 0:o._profName)?new v(this._options._profName):void 0}get event(){return this._event||(this._event=(u,o,l)=>{var t;this._listeners||(this._listeners=new b.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(o?[u,o]:u);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,o);const a=(t=this._leakageMon)===null||t===void 0?void 0:t.check(this._listeners.size);let h;return h={dispose:()=>{a&&a(),h.dispose=k._noop,this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof R.DisposableStore?l.add(h):Array.isArray(l)&&l.push(h),h}),this._event}fire(u){var o,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new b.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,u]);for((o=this._perfMon)===null||o===void 0||o.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,r]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,r):t[0].call(t[1],r)}catch(s){m.onUnexpectedError(s)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var u,o,l,t,r;this._disposed||(this._disposed=!0,(u=this._listeners)===null||u===void 0||u.clear(),(o=this._deliveryQueue)===null||o===void 0||o.clear(),(t=(l=this._options)===null||l===void 0?void 0:l.onLastListenerRemove)===null||t===void 0||t.call(l),(r=this._leakageMon)===null||r===void 0||r.dispose())}}e.Emitter=k,k._noop=function(){};class y extends k{constructor(u){super(u);this._isPaused=0,this._eventQueue=new b.LinkedList,this._mergeFn=u==null?void 0:u.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=y;class d extends y{constructor(u){var o;super(u);this._delay=(o=u.delay)!==null&&o!==void 0?o:100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=d;class g{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new k({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const o={event:u,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const l=()=>{this.hasListeners&&this.unhook(o);const t=this.events.indexOf(o);this.events.splice(t,1)};return R.toDisposable(A.once(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(o=>this.emitter.fire(o))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=g;class D{constructor(){this.buffers=[]}wrapEvent(u){return(o,l,t)=>u(r=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>o.call(l,r)):o.call(l,r)},void 0,t)}bufferEvents(u){const o=[];this.buffers.push(o);const l=u();return this.buffers.pop(),o.forEach(t=>t()),l}}e.EventBufferer=D;class P{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=R.Disposable.None,this.emitter=new k({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=P}),define(J[25],Z([0,1,5]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(n,v){const p=setTimeout(n.bind(v),0);return{dispose(){clearTimeout(p)}}});var R;(function(n){function v(p){return p===n.None||p===n.Cancelled||p instanceof b?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}n.isCancellationToken=v,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(R=e.CancellationToken||(e.CancellationToken={}));class b{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?A:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class I{constructor(v){this._token=void 0,this._parentListener=void 0,this._parentListener=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new b),this._token}cancel(){this._token?this._token instanceof b&&this._token.cancel():this._token=R.Cancelled}dispose(v=!1){v&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof b&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=I}),define(J[108],Z([0,1,5]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class A{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(E){const k=this._icons.get(E.id);k?E.description?k.description=E.description:console.error(`Duplicate registration of codicon ${E.id}`):(this._icons.set(E.id,E),this._onDidRegister.fire(E))}get(E){return this._icons.get(E)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new A;e.iconRegistry=R;function b(i,E){return new n(i,E)}e.registerCodicon=b;function I(i){return i?i.replace(/\$\((.*?)\)/g,(E,k)=>` ${k} `).trim():""}e.getCodiconAriaLabel=I;class n{constructor(E,k,y){this.id=E,this.definition=k,this.description=y,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function v(i,E){const k=["codicon","codicon-"+i];return E&&k.push("codicon-modifier-"+E),k}e.getClassNamesArray=v;var p;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const E=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function k(g){if(g instanceof n)return["codicon","codicon-"+g.id];const D=E.exec(g.id);if(!D)return k(n.error);let[,P,c]=D;const u=["codicon","codicon-"+P];return c&&u.push("codicon-modifier-"+c.substr(1)),u}i.asClassNameArray=k;function y(g){return k(g).join(" ")}i.asClassName=y;function d(g){return"."+k(g).join(".")}i.asCSSSelector=d})(p=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(J[64],Z([0,1,16,2]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(u){const o=u;return o?[o.on,o.pause,o.resume,o.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=R;function b(u){const o=u;return o?R(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=b;function I(u,o){return new n(u,o)}e.newWriteableStream=I;class n{constructor(o,l){this.reducer=o,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){var l;if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof((l=this.options)===null||l===void 0?void 0:l.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(l=>l(o))}emitError(o){this.listeners.error.length===0?m.onUnexpectedError(o):this.listeners.error.slice(0).forEach(l=>l(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,l){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(o,l){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(l);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function v(u,o){const l=[];let t;for(;(t=u.read())!==null;)l.push(t);return o(l)}e.consumeReadable=v;function p(u,o,l){const t=[];let r;for(;(r=u.read())!==null&&t.length<l;)t.push(r);return r===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return u.read()}}}e.peekReadable=p;function i(u,o){return new Promise((l,t)=>{const r=[];E(u,{onData:s=>{o&&r.push(s)},onError:s=>{o?t(s):l(void 0)},onEnd:()=>{l(o?o(r):void 0)}})})}e.consumeStream=i;function E(u,o){u.on("error",l=>o.onError(l)),u.on("end",()=>o.onEnd()),u.on("data",l=>o.onData(l))}e.listenStream=E;function k(u,o){return new Promise((l,t)=>{const r=new A.DisposableStore,s=[],a=f=>{if(s.push(f),s.length>o)return r.dispose(),u.pause(),l({stream:u,buffer:s,ended:!1})},h=f=>t(f),w=()=>l({stream:u,buffer:s,ended:!0});r.add(A.toDisposable(()=>u.removeListener("error",h))),u.on("error",h),r.add(A.toDisposable(()=>u.removeListener("end",w))),u.on("end",w),r.add(A.toDisposable(()=>u.removeListener("data",a))),u.on("data",a)})}e.peekStream=k;function y(u,o){const l=I(o);return l.end(u),l}e.toStream=y;function d(){const u=I(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=d;function g(u){let o=!1;return{read:()=>o?null:(o=!0,u)}}e.toReadable=g;function D(u,o,l){const t=I(l);return E(u,{onData:r=>t.write(o.data(r)),onError:r=>t.error(o.error?o.error(r):r),onEnd:()=>t.end()}),t}e.transform=D;function P(u,o,l){let t=!1;return{read:()=>{const r=o.read();return t?r:(t=!0,r!==null?l([u,r]):u)}}}e.prefixedReadable=P;function c(u,o,l){let t=!1;const r=I(l);return E(o,{onData:s=>t?r.write(s):(t=!0,r.write(l([u,s]))),onError:s=>r.error(s),onEnd:()=>{t||(t=!0,r.write(u)),r.end()}}),r}e.prefixedStream=c}),define(J[23],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function m(j){return!j||typeof j!="string"?!0:j.trim().length===0}e.isFalsyOrWhitespace=m;const A=/{(\d+)}/g;function R(j,...ie){return ie.length===0?j:j.replace(A,function(ae,ce){const fe=parseInt(ce,10);return isNaN(fe)||fe<0||fe>=ie.length?ae:ie[fe]})}e.format=R;function b(j){return j.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=b;function I(j){return j.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function n(j,ie){let ae=0;const ce=ie.charCodeAt(0);for(let fe=j.length-1;fe>=0;fe--)j.charCodeAt(fe)===ce&&ae++;return ae}e.count=n;function v(j,ie,ae="\u2026"){return j.length<=ie?j:`${j.substr(0,ie)}${ae}`}e.truncate=v;function p(j,ie=" "){const ae=i(j,ie);return E(ae,ie)}e.trim=p;function i(j,ie){if(!j||!ie)return j;const ae=ie.length;if(ae===0||j.length===0)return j;let ce=0;for(;j.indexOf(ie,ce)===ce;)ce=ce+ae;return j.substring(ce)}e.ltrim=i;function E(j,ie){if(!j||!ie)return j;const ae=ie.length,ce=j.length;if(ae===0||ce===0)return j;let fe=ce,Se=-1;for(;Se=j.lastIndexOf(ie,fe-1),!(Se===-1||Se+ae!==fe);){if(Se===0)return"";fe=Se}return j.substring(0,fe)}e.rtrim=E;function k(j){return j.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=k;function y(j){return j.replace(/\*/g,"")}e.stripWildcards=y;function d(j,ie,ae={}){if(!j)throw new Error("Cannot create regex from empty string");ie||(j=I(j)),ae.wholeWord&&(/\B/.test(j.charAt(0))||(j="\\b"+j),/\B/.test(j.charAt(j.length-1))||(j=j+"\\b"));let ce="";return ae.global&&(ce+="g"),ae.matchCase||(ce+="i"),ae.multiline&&(ce+="m"),ae.unicode&&(ce+="u"),new RegExp(j,ce)}e.createRegExp=d;function g(j){return j.source==="^"||j.source==="^$"||j.source==="$"||j.source==="^\\s*$"?!1:!!(j.exec("")&&j.lastIndex===0)}e.regExpLeadsToEndlessLoop=g;function D(j){return!!j.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function P(j){return(j.global?"g":"")+(j.ignoreCase?"i":"")+(j.multiline?"m":"")+(j.unicode?"u":"")}e.regExpFlags=P;function c(j){return j.split(/\r\n|\r|\n/)}e.splitLines=c;function u(j){for(let ie=0,ae=j.length;ie<ae;ie++){const ce=j.charCodeAt(ie);if(ce!==32&&ce!==9)return ie}return-1}e.firstNonWhitespaceIndex=u;function o(j,ie=0,ae=j.length){for(let ce=ie;ce<ae;ce++){const fe=j.charCodeAt(ce);if(fe!==32&&fe!==9)return j.substring(ie,ce)}return j.substring(ie,ae)}e.getLeadingWhitespace=o;function l(j,ie=j.length-1){for(let ae=ie;ae>=0;ae--){const ce=j.charCodeAt(ae);if(ce!==32&&ce!==9)return ae}return-1}e.lastNonWhitespaceIndex=l;function t(j,ie){return j<ie?-1:j>ie?1:0}e.compare=t;function r(j,ie,ae=0,ce=j.length,fe=0,Se=ie.length){for(;ae<ce&&fe<Se;ae++,fe++){let Ue=j.charCodeAt(ae),ze=ie.charCodeAt(fe);if(Ue<ze)return-1;if(Ue>ze)return 1}const Me=ce-ae,Fe=Se-fe;return Me<Fe?-1:Me>Fe?1:0}e.compareSubstring=r;function s(j,ie){return a(j,ie,0,j.length,0,ie.length)}e.compareIgnoreCase=s;function a(j,ie,ae=0,ce=j.length,fe=0,Se=ie.length){for(;ae<ce&&fe<Se;ae++,fe++){let Ue=j.charCodeAt(ae),ze=ie.charCodeAt(fe);if(Ue===ze)continue;const de=Ue-ze;if(!(de===32&&w(ze))&&!(de===-32&&w(Ue)))return h(Ue)&&h(ze)?de:r(j.toLowerCase(),ie.toLowerCase(),ae,ce,fe,Se)}const Me=ce-ae,Fe=Se-fe;return Me<Fe?-1:Me>Fe?1:0}e.compareSubstringIgnoreCase=a;function h(j){return j>=97&&j<=122}e.isLowerAsciiLetter=h;function w(j){return j>=65&&j<=90}e.isUpperAsciiLetter=w;function f(j){return h(j)||w(j)}function S(j,ie){return j.length===ie.length&&L(j,ie)}e.equalsIgnoreCase=S;function L(j,ie,ae=j.length){for(let ce=0;ce<ae;ce++){const fe=j.charCodeAt(ce),Se=ie.charCodeAt(ce);if(fe!==Se){if(f(fe)&&f(Se)){const Me=Math.abs(fe-Se);if(Me!==0&&Me!==32)return!1}else if(String.fromCharCode(fe).toLowerCase()!==String.fromCharCode(Se).toLowerCase())return!1}}return!0}function _(j,ie){const ae=ie.length;return ie.length>j.length?!1:L(j,ie,ae)}e.startsWithIgnoreCase=_;function H(j,ie){let ae,ce=Math.min(j.length,ie.length);for(ae=0;ae<ce;ae++)if(j.charCodeAt(ae)!==ie.charCodeAt(ae))return ae;return ce}e.commonPrefixLength=H;function Q(j,ie){let ae,ce=Math.min(j.length,ie.length);const fe=j.length-1,Se=ie.length-1;for(ae=0;ae<ce;ae++)if(j.charCodeAt(fe-ae)!==ie.charCodeAt(Se-ae))return ae;return ce}e.commonSuffixLength=Q;function te(j){return 55296<=j&&j<=56319}e.isHighSurrogate=te;function B(j){return 56320<=j&&j<=57343}e.isLowSurrogate=B;function Y(j,ie){return(j-55296<<10)+(ie-56320)+65536}e.computeCodePoint=Y;function G(j,ie,ae){const ce=j.charCodeAt(ae);if(te(ce)&&ae+1<ie){const fe=j.charCodeAt(ae+1);if(B(fe))return Y(ce,fe)}return ce}e.getNextCodePoint=G;function C(j,ie){const ae=j.charCodeAt(ie-1);if(B(ae)&&ie>1){const ce=j.charCodeAt(ie-2);if(te(ce))return Y(ce,ae)}return ae}function z(j,ie){const ae=Be.getInstance(),ce=ie,fe=j.length,Se=G(j,fe,ie);ie+=Se>=65536?2:1;let Me=ae.getGraphemeBreakType(Se);for(;ie<fe;){const Fe=G(j,fe,ie),Ue=ae.getGraphemeBreakType(Fe);if(He(Me,Ue))break;ie+=Fe>=65536?2:1,Me=Ue}return ie-ce}e.nextCharLength=z;function X(j,ie){const ae=Be.getInstance(),ce=ie,fe=C(j,ie);ie-=fe>=65536?2:1;let Se=ae.getGraphemeBreakType(fe);for(;ie>0;){const Me=C(j,ie),Fe=ae.getGraphemeBreakType(Me);if(He(Fe,Se))break;ie-=Me>=65536?2:1,Se=Fe}return ce-ie}e.prevCharLength=X;function N(j,ie){const ae=Be.getInstance(),ce=j.length,fe=ie,Se=G(j,ce,ie),Me=ae.getGraphemeBreakType(Se);ie+=Se>=65536?2:1;let Fe=Me;for(;ie<ce;){const ze=G(j,ce,ie),de=ae.getGraphemeBreakType(ze);if(He(Fe,de))break;ie+=ze>=65536?2:1,Fe=de}const Ue=ie;for(ie=fe,Fe=Me;ie>0;){const ze=C(j,ie),de=ae.getGraphemeBreakType(ze);if(He(de,Fe))break;ie-=ze>=65536?2:1,Fe=de}return[ie,Ue]}function F(j,ie){return ie>0&&B(j.charCodeAt(ie))?N(j,ie-1):N(j,ie)}e.getCharContainingOffset=F;function T(j){const ie=j.length;let ae=0,ce=0;for(;ce<ie;){const Me=G(j,ie,ce);ce+=Me>=65536?2:1,Me<128?ae+=1:Me<2048?ae+=2:Me<65536?ae+=3:ae+=4}const fe=new Uint8Array(ae);ce=0;let Se=0;for(;ce<ie;){const Me=G(j,ie,ce);ce+=Me>=65536?2:1,Me<128?fe[Se++]=Me:Me<2048?(fe[Se++]=192|(Me&1984)>>>6,fe[Se++]=128|(Me&63)>>>0):Me<65536?(fe[Se++]=224|(Me&61440)>>>12,fe[Se++]=128|(Me&4032)>>>6,fe[Se++]=128|(Me&63)>>>0):(fe[Se++]=240|(Me&1835008)>>>18,fe[Se++]=128|(Me&258048)>>>12,fe[Se++]=128|(Me&4032)>>>6,fe[Se++]=128|(Me&63)>>>0)}return fe}e.encodeUTF8=T;function O(j){const ie=j.byteLength,ae=[];let ce=0;for(;ce<ie;){const fe=j[ce];let Se;if(fe>=240&&ce+3<ie?Se=(j[ce++]&7)<<18>>>0|(j[ce++]&63)<<12>>>0|(j[ce++]&63)<<6>>>0|(j[ce++]&63)<<0>>>0:fe>=224&&ce+2<ie?Se=(j[ce++]&15)<<12>>>0|(j[ce++]&63)<<6>>>0|(j[ce++]&63)<<0>>>0:fe>=192&&ce+1<ie?Se=(j[ce++]&31)<<6>>>0|(j[ce++]&63)<<0>>>0:Se=j[ce++],Se>=0&&Se<=55295||Se>=57344&&Se<=65535)ae.push(String.fromCharCode(Se));else if(Se>=65536&&Se<=1114111){const Me=Se-65536,Fe=55296+((Me&1047552)>>>10),Ue=56320+((Me&1023)>>>0);ae.push(String.fromCharCode(Fe)),ae.push(String.fromCharCode(Ue))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=O;const M=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(j){return M.test(j)}e.containsRTL=W;const U=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function V(j){return U.test(j)}e.containsEmoji=V;const K=/^[\t\n\r\x20-\x7E]*$/;function q(j){return K.test(j)}e.isBasicASCII=q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function x(j){return e.UNUSUAL_LINE_TERMINATORS.test(j)}e.containsUnusualLineTerminators=x;function ne(j){for(let ie=0,ae=j.length;ie<ae;ie++)if(re(j.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=ne;function re(j){return j=+j,j>=11904&&j<=55215||j>=63744&&j<=64255||j>=65281&&j<=65374}e.isFullWidthCharacter=re;function se(j){return j>=127462&&j<=127487||j===8986||j===8987||j===9200||j===9203||j>=9728&&j<=10175||j===11088||j===11093||j>=127744&&j<=128591||j>=128640&&j<=128764||j>=128992&&j<=129003||j>=129280&&j<=129535||j>=129648&&j<=129750}e.isEmojiImprecise=se;function le(j,ie){if(j.length<ie)return j;const ae=/\b/g;let ce=0;for(;ae.test(j)&&!(j.length-ae.lastIndex<ie);)ce=ae.lastIndex,ae.lastIndex+=1;return j.substring(ce).replace(/^\s/,"")}e.lcut=le;const oe=/\x1B\x5B[12]?K/g,ue=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function be(j){return j&&(j=j.replace(oe,""),j=j.replace(ue,""),j=j.replace(me,"")),j}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function De(j){return!!(j&&j.length>0&&j.charCodeAt(0)===65279)}e.startsWithUTF8BOM=De;function Ie(j){return De(j)?j.substr(1):j}e.stripUTF8BOM=Ie;function we(j,ie){if(!j||!ie||j.length<ie.length)return!1;const ae=ie.length,ce=j.toLowerCase();let fe=0,Se=-1;for(;fe<ae;){const Me=ce.indexOf(ie[fe],Se+1);if(Me<0)return!1;Se=Me,fe++}return!0}e.fuzzyContains=we;function ye(j,ie=!1){return j?(ie&&(j=j.replace(/\\./g,"")),j.toLowerCase()!==j):!1}e.containsUppercaseCharacter=ye;function Le(j){return j.charAt(0).toUpperCase()+j.slice(1)}e.uppercaseFirstLetter=Le;function Te(j,ie=1){if(ie===0)return"";let ae=-1;do ae=j.indexOf(`
`,ae+1),ie--;while(ie>0&&ae>=0);return ae===-1?j:(j[ae-1]==="\r"&&ae--,j.substr(0,ae))}e.getNLines=Te;function $e(j){const ie=90-65+1;return j=j%(2*ie),j<ie?String.fromCharCode(97+j):String.fromCharCode(65+j-ie)}e.singleLetterHash=$e;function Ne(j){return Be.getInstance().getGraphemeBreakType(j)}e.getGraphemeBreakType=Ne;function He(j,ie){return j===0?ie!==5&&ie!==7:j===2&&ie===3?!1:j===4||j===2||j===3||ie===4||ie===2||ie===3?!0:!(j===8&&(ie===8||ie===9||ie===11||ie===12)||(j===11||j===9)&&(ie===9||ie===10)||(j===12||j===10)&&ie===10||ie===5||ie===13||ie===7||j===1||j===13&&ie===14||j===6&&ie===6)}e.breakBetweenGraphemeBreakType=He;var et;(function(j){j[j.Other=0]="Other",j[j.Prepend=1]="Prepend",j[j.CR=2]="CR",j[j.LF=3]="LF",j[j.Control=4]="Control",j[j.Extend=5]="Extend",j[j.Regional_Indicator=6]="Regional_Indicator",j[j.SpacingMark=7]="SpacingMark",j[j.L=8]="L",j[j.V=9]="V",j[j.T=10]="T",j[j.LV=11]="LV",j[j.LVT=12]="LVT",j[j.ZWJ=13]="ZWJ",j[j.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=st()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const ae=this._data,ce=ae.length/3;let fe=1;for(;fe<=ce;)if(ie<ae[3*fe])fe=2*fe;else if(ie>ae[3*fe+1])fe=2*fe+1;else return ae[3*fe+2];return 0}}Be._INSTANCE=null;function st(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function tt(j,ie){if(j===0)return 0;const ae=ut(j,ie);if(ae!==void 0)return ae;const ce=C(ie,j);return j-=Xe(ce),j}e.getLeftDeleteOffset=tt;function ut(j,ie){let ae=C(ie,j);for(j-=Xe(ae);ht(ae)||ae===65039||ae===8419;){if(j===0)return;ae=C(ie,j),j-=Xe(ae)}if(!!se(ae)){if(j>=0){const ce=C(ie,j);ce===8205&&(j-=Xe(ce))}return j}}function Xe(j){return j>=65536?2:1}function ht(j){return 127995<=j&&j<=127999}var ot;(function(j){j[j.zwj=8205]="zwj",j[j.emojiVariantSelector=65039]="emojiVariantSelector",j[j.enclosingKeyCap=8419]="enclosingKeyCap"})(ot||(ot={}))}),define(J[17],Z([0,1,23,64]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer!="undefined",b=typeof TextEncoder!="undefined",I=typeof TextDecoder!="undefined";let n,v;class p{constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}static alloc(f){return R?new p(Buffer.allocUnsafe(f)):new p(new Uint8Array(f))}static wrap(f){return R&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new p(f)}static fromString(f,S){return!((S==null?void 0:S.dontUseNodeBuffer)||!1)&&R?new p(Buffer.from(f)):b?(n||(n=new TextEncoder),new p(n.encode(f))):new p(m.encodeUTF8(f))}static concat(f,S){if(typeof S=="undefined"){S=0;for(let H=0,Q=f.length;H<Q;H++)S+=f[H].byteLength}const L=p.alloc(S);let _=0;for(let H=0,Q=f.length;H<Q;H++){const te=f[H];L.set(te,_),_+=te.byteLength}return L}toString(){return R?this.buffer.toString():I?(v||(v=new TextDecoder),v.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(f,S){return new p(this.buffer.subarray(f,S))}set(f,S){f instanceof p?this.buffer.set(f.buffer,S):this.buffer.set(f,S)}readUInt32BE(f){return k(this.buffer,f)}writeUInt32BE(f,S){y(this.buffer,f,S)}readUInt32LE(f){return d(this.buffer,f)}writeUInt32LE(f,S){g(this.buffer,f,S)}readUInt8(f){return D(this.buffer,f)}writeUInt8(f,S){P(this.buffer,f,S)}}e.VSBuffer=p;function i(w,f){return w[f+0]<<0>>>0|w[f+1]<<8>>>0}e.readUInt16LE=i;function E(w,f,S){w[S+0]=f&255,f=f>>>8,w[S+1]=f&255}e.writeUInt16LE=E;function k(w,f){return w[f]*2**24+w[f+1]*2**16+w[f+2]*2**8+w[f+3]}e.readUInt32BE=k;function y(w,f,S){w[S+3]=f,f=f>>>8,w[S+2]=f,f=f>>>8,w[S+1]=f,f=f>>>8,w[S]=f}e.writeUInt32BE=y;function d(w,f){return w[f+0]<<0>>>0|w[f+1]<<8>>>0|w[f+2]<<16>>>0|w[f+3]<<24>>>0}e.readUInt32LE=d;function g(w,f,S){w[S+0]=f&255,f=f>>>8,w[S+1]=f&255,f=f>>>8,w[S+2]=f&255,f=f>>>8,w[S+3]=f&255}e.writeUInt32LE=g;function D(w,f){return w[f]}e.readUInt8=D;function P(w,f,S){w[S]=f}e.writeUInt8=P;function c(w){return A.consumeReadable(w,f=>p.concat(f))}e.readableToBuffer=c;function u(w){return A.toReadable(w)}e.bufferToReadable=u;function o(w){return A.consumeStream(w,f=>p.concat(f))}e.streamToBuffer=o;async function l(w){return w.ended?p.concat(w.buffer):p.concat([...w.buffer,await o(w.stream)])}e.bufferedStreamToBuffer=l;function t(w){return A.toStream(w,f=>p.concat(f))}e.bufferToStream=t;function r(w){return A.transform(w,{data:f=>typeof f=="string"?p.fromString(f):p.wrap(f)},f=>p.concat(f))}e.streamToBufferReadableStream=r;function s(w){return A.newWriteableStream(f=>p.concat(f),w)}e.newWriteableBufferStream=s;function a(w,f){return A.prefixedReadable(w,f,S=>p.concat(S))}e.prefixedBufferReadable=a;function h(w,f){return A.prefixedStream(w,f,S=>p.concat(S))}e.prefixedBufferStream=h}),define(J[81],Z([0,1,23]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function A(P){return R(P,0)}e.hash=A;function R(P,c){switch(typeof P){case"object":return P===null?b(349,c):Array.isArray(P)?v(P,c):p(P,c);case"string":return n(P,c);case"boolean":return I(P,c);case"number":return b(P,c);case"undefined":return b(937,c);default:return b(617,c)}}e.doHash=R;function b(P,c){return(c<<5)-c+P|0}function I(P,c){return b(P?433:863,c)}function n(P,c){c=b(149417,c);for(let u=0,o=P.length;u<o;u++)c=b(P.charCodeAt(u),c);return c}e.stringHash=n;function v(P,c){return c=b(104579,c),P.reduce((u,o)=>R(o,u),c)}function p(P,c){return c=b(181387,c),Object.keys(P).sort().reduce((u,o)=>(u=n(o,u),R(P[o],u)),c)}class i{constructor(){this._value=0}get value(){return this._value}hash(c){return this._value=R(c,this._value),this._value}}e.Hasher=i;var E;(function(P){P[P.BLOCK_SIZE=64]="BLOCK_SIZE",P[P.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function k(P,c,u=32){const o=u-c,l=~((1<<o)-1);return(P<<c|(l&P)>>>o)>>>0}function y(P,c=0,u=P.byteLength,o=0){for(let l=0;l<u;l++)P[c+l]=o}function d(P,c,u="0"){for(;P.length<c;)P=u+P;return P}function g(P,c=32){return P instanceof ArrayBuffer?Array.from(new Uint8Array(P)).map(u=>u.toString(16).padStart(2,"0")).join(""):d((P>>>0).toString(16),c/4)}e.toHexString=g;class D{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const u=c.length;if(u===0)return;const o=this._buff;let l=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=c.charCodeAt(0),s=0);;){let a=r;if(m.isHighSurrogate(r))if(s+1<u){const h=c.charCodeAt(s+1);m.isLowSurrogate(h)?(s++,a=m.computeCodePoint(r,h)):a=65533}else{t=r;break}else m.isLowSurrogate(r)&&(a=65533);if(l=this._push(o,l,a),s++,s<u)r=c.charCodeAt(s);else break}this._buffLen=l,this._leftoverHighSurrogate=t}_push(c,u,o){return o<128?c[u++]=o:o<2048?(c[u++]=192|(o&1984)>>>6,c[u++]=128|(o&63)>>>0):o<65536?(c[u++]=224|(o&61440)>>>12,c[u++]=128|(o&4032)>>>6,c[u++]=128|(o&63)>>>0):(c[u++]=240|(o&1835008)>>>18,c[u++]=128|(o&258048)>>>12,c[u++]=128|(o&4032)>>>6,c[u++]=128|(o&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=D._bigBlock32,u=this._buffDV;for(let f=0;f<64;f+=4)c.setUint32(f,u.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)c.setUint32(f,k(c.getUint32(f-12,!1)^c.getUint32(f-32,!1)^c.getUint32(f-56,!1)^c.getUint32(f-64,!1),1),!1);let o=this._h0,l=this._h1,t=this._h2,r=this._h3,s=this._h4,a,h,w;for(let f=0;f<80;f++)f<20?(a=l&t|~l&r,h=1518500249):f<40?(a=l^t^r,h=1859775393):f<60?(a=l&t|l&r|t&r,h=2400959708):(a=l^t^r,h=3395469782),w=k(o,5)+a+s+h+c.getUint32(f*4,!1)&4294967295,s=r,r=t,t=k(l,30),l=o,o=w;this._h0=this._h0+o&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=D,D._bigBlock32=new DataView(new ArrayBuffer(320))}),define(J[13],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(f){return Array.isArray(f)}e.isArray=m;function A(f){return typeof f=="string"}e.isString=A;function R(f){return Array.isArray(f)&&f.every(S=>A(S))}e.isStringArray=R;function b(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=b;function I(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=I;function n(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=n;function v(f){return f===!0||f===!1}e.isBoolean=v;function p(f){return typeof f=="undefined"}e.isUndefined=p;function i(f){return!E(f)}e.isDefined=i;function E(f){return p(f)||f===null}e.isUndefinedOrNull=E;function k(f,S){if(!f)throw new Error(S?`Unexpected type, expected '${S}'`:"Unexpected type")}e.assertType=k;function y(f){if(E(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=y;function d(...f){const S=[];for(let L=0;L<f.length;L++){const _=f[L];if(E(_))throw new Error(`Assertion Failed: argument at index ${L} is undefined or null`);S.push(_)}return S}e.assertAllDefined=d;const g=Object.prototype.hasOwnProperty;function D(f){if(!b(f))return!1;for(let S in f)if(g.call(f,S))return!1;return!0}e.isEmptyObject=D;function P(f){return typeof f=="function"}e.isFunction=P;function c(...f){return f.length>0&&f.every(P)}e.areFunctions=c;function u(f,S){const L=Math.min(f.length,S.length);for(let _=0;_<L;_++)o(f[_],S[_])}e.validateConstraints=u;function o(f,S){if(A(S)){if(typeof f!==S)throw new Error(`argument does not match constraint: typeof ${S}`)}else if(P(S)){try{if(f instanceof S)return}catch(L){}if(!E(f)&&f.constructor===S||S.length===1&&S.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function l(f){let S=[],L=Object.getPrototypeOf(f);for(;Object.prototype!==L;)S=S.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return S}e.getAllPropertyNames=l;function t(f){const S=[];for(const L of l(f))typeof f[L]=="function"&&S.push(L);return S}e.getAllMethodNames=t;function r(f,S){const L=H=>function(){const Q=Array.prototype.slice.call(arguments,0);return S(H,Q)};let _={};for(const H of f)_[H]=L(H);return _}e.createProxyObject=r;function s(f){return f===null?void 0:f}e.withNullAsUndefined=s;function a(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=a;function h(f){return class{constructor(){return new Proxy({},{get(S,L){if(S[L])return S[L];throw new Error(`Not Implemented: ${f}->${String(L)}`)}})}}}e.NotImplementedProxy=h;function w(f){throw new Error("Unreachable")}e.assertNever=w}),define(J[29],Z([0,1,3,23,8,13]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(s){return s===47||s===92}e.isPathSeparator=I;function n(s){return s.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=n;function v(s){return s.indexOf("/")===-1&&(s=n(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=v;function p(s,a=R.posix.sep){if(!s)return"";const h=s.length,w=s.charCodeAt(0);if(I(w)){if(I(s.charCodeAt(1))&&!I(s.charCodeAt(2))){let S=3;const L=S;for(;S<h&&!I(s.charCodeAt(S));S++);if(L!==S&&!I(s.charCodeAt(S+1))){for(S+=1;S<h;S++)if(I(s.charCodeAt(S)))return s.slice(0,S+1).replace(/[\\/]/g,a)}}return a}else if(P(w)&&s.charCodeAt(1)===58)return I(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let f=s.indexOf("://");if(f!==-1){for(f+=3;f<h;f++)if(I(s.charCodeAt(f)))return s.slice(0,f+1)}return""}e.getRoot=p;function i(s){if(!m.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let h=2;const w=h;for(;h<s.length&&(a=s.charCodeAt(h),a!==92);h++);return!(w===h||(a=s.charCodeAt(h+1),isNaN(a)||a===92))}e.isUNC=i;const E=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,a=m.isWindows){const h=a?E:k;return!(!s||s.length===0||/^\s+$/.test(s)||(h.lastIndex=0,h.test(s))||a&&y.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function g(s,a,h){const w=s===a;return!h||w?w:!s||!a?!1:A.equalsIgnoreCase(s,a)}e.isEqual=g;function D(s,a,h,w=R.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(h){if(!A.startsWithIgnoreCase(s,a))return!1;if(a.length===s.length)return!0;let S=a.length;return a.charAt(a.length-1)===w&&S--,s.charAt(S)===w}return a.charAt(a.length-1)!==w&&(a+=w),s.indexOf(a)===0}e.isEqualOrParent=D;function P(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=P;function c(s,a){return m.isWindows&&s.endsWith(":")&&(s+=R.sep),R.isAbsolute(s)||(s=R.join(a,s)),s=R.normalize(s),m.isWindows?(s=A.rtrim(s,R.sep),s.endsWith(":")&&(s+=R.sep)):(s=A.rtrim(s,R.sep),s||(s=R.sep)),s}e.sanitizeFilePath=c;function u(s){const a=R.normalize(s);return m.isWindows?s.length>3?!1:o(a)&&(s.length===2||a.charCodeAt(2)===92):a===R.posix.sep}e.isRootOrDriveLetter=u;function o(s){return m.isWindows?P(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function l(s){return o(s)?s[0]:void 0}e.getDriveLetter=l;function t(s,a,h){return a.length>s.length?-1:s===a?0:(h&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=t;function r(s){const a=s.split(":");let h,w,f;if(a.forEach(S=>{const L=Number(S);b.isNumber(L)?w===void 0?w=L:f===void 0&&(f=L):h=h?[h,S].join(":"):S}),!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:w!==void 0?w:void 0,column:f!==void 0?f:w!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(J[44],Z([0,1,13]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const D=Array.isArray(g)?[]:{};return Object.keys(g).forEach(P=>{g[P]&&typeof g[P]=="object"?D[P]=A(g[P]):D[P]=g[P]}),D}e.deepClone=A;function R(g){if(!g||typeof g!="object")return g;const D=[g];for(;D.length>0;){const P=D.shift();Object.freeze(P);for(const c in P)if(b.call(P,c)){const u=P[c];typeof u=="object"&&!Object.isFrozen(u)&&D.push(u)}}return g}e.deepFreeze=R;const b=Object.prototype.hasOwnProperty;function I(g,D){return n(g,D,new Set)}e.cloneAndChange=I;function n(g,D,P){if(m.isUndefinedOrNull(g))return g;const c=D(g);if(typeof c!="undefined")return c;if(m.isArray(g)){const u=[];for(const o of g)u.push(n(o,D,P));return u}if(m.isObject(g)){if(P.has(g))throw new Error("Cannot clone recursive data-structure");P.add(g);const u={};for(let o in g)b.call(g,o)&&(u[o]=n(g[o],D,P));return P.delete(g),u}return g}function v(g,D,P=!0){return m.isObject(g)?(m.isObject(D)&&Object.keys(D).forEach(c=>{c in g?P&&(m.isObject(g[c])&&m.isObject(D[c])?v(g[c],D[c],P):g[c]=D[c]):g[c]=D[c]}),g):D}e.mixin=v;function p(g,D){if(g===D)return!0;if(g==null||D===null||D===void 0||typeof g!=typeof D||typeof g!="object"||Array.isArray(g)!==Array.isArray(D))return!1;let P,c;if(Array.isArray(g)){if(g.length!==D.length)return!1;for(P=0;P<g.length;P++)if(!p(g[P],D[P]))return!1}else{const u=[];for(c in g)u.push(c);u.sort();const o=[];for(c in D)o.push(c);if(o.sort(),!p(u,o))return!1;for(P=0;P<u.length;P++)if(!p(g[u[P]],D[u[P]]))return!1}return!0}e.equals=p;function i(g){const D=new Set;return JSON.stringify(g,(P,c)=>{if(m.isObject(c)||Array.isArray(c)){if(D.has(c))return"[Circular]";D.add(c)}return c})}e.safeStringify=i;function E(g,D,P){const c=D(g);return typeof c=="undefined"?P:c}e.getOrDefault=E;function k(g,D){const P=Object.create(null);return!g||!D||Object.keys(D).forEach(u=>{const o=g[u],l=D[u];p(o,l)||(P[u]=l)}),P}e.distinct=k;function y(g,D){const P=D.toLowerCase(),c=Object.keys(g).find(u=>u.toLowerCase()===P);return c?g[c]:g[D]}e.getCaseInsensitive=y;function d(g,D){const P=Object.create(null);for(const c of Object.keys(g))D(c,g[c])&&(P[c]=g[c]);return P}e.filter=d}),define(J[7],Z([0,1,3,8]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,b=/^\//,I=/^\/\//;function n(s,a){if(!s.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!R.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!b.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(s,a){return!s&&!a?"file":s}function p(s,a){switch(s){case"https":case"http":case"file":a?a[0]!==E&&(a=E+a):a=E;break}return a}const i="",E="/",k=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(a,h,w,f,S,L=!1){typeof a=="object"?(this.scheme=a.scheme||i,this.authority=a.authority||i,this.path=a.path||i,this.query=a.query||i,this.fragment=a.fragment||i):(this.scheme=v(a,L),this.authority=h||i,this.path=p(this.scheme,w||i),this.query=f||i,this.fragment=S||i,n(this,L))}static isUri(a){return a instanceof y?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return u(this,!1)}with(a){if(!a)return this;let{scheme:h,authority:w,path:f,query:S,fragment:L}=a;return h===void 0?h=this.scheme:h===null&&(h=i),w===void 0?w=this.authority:w===null&&(w=i),f===void 0?f=this.path:f===null&&(f=i),S===void 0?S=this.query:S===null&&(S=i),L===void 0?L=this.fragment:L===null&&(L=i),h===this.scheme&&w===this.authority&&f===this.path&&S===this.query&&L===this.fragment?this:new g(h,w,f,S,L)}static parse(a,h=!1){const w=k.exec(a);return w?new g(w[2]||i,r(w[4]||i),r(w[5]||i),r(w[7]||i),r(w[9]||i),h):new g(i,i,i,i,i)}static file(a){let h=i;if(m.isWindows&&(a=a.replace(/\\/g,E)),a[0]===E&&a[1]===E){const w=a.indexOf(E,2);w===-1?(h=a.substring(2),a=E):(h=a.substring(2,w),a=a.substring(w)||E)}return new g("file",h,a,i,i)}static from(a){const h=new g(a.scheme,a.authority,a.path,a.query,a.fragment);return n(h,!0),h}static joinPath(a,...h){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return m.isWindows&&a.scheme==="file"?w=y.file(A.win32.join(u(a,!0),...h)).path:w=A.posix.join(a.path,...h),a.with({path:w})}toString(a=!1){return o(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof y)return a;{const h=new g(a);return h._formatted=a.external,h._fsPath=a._sep===d?a.fsPath:null,h}}else return a}}e.URI=y;const d=m.isWindows?1:void 0;class g extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(a=!1){return a?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=d),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function P(s,a){let h,w=-1;for(let f=0;f<s.length;f++){const S=s.charCodeAt(f);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||a&&S===47)w!==-1&&(h+=encodeURIComponent(s.substring(w,f)),w=-1),h!==void 0&&(h+=s.charAt(f));else{h===void 0&&(h=s.substr(0,f));const L=D[S];L!==void 0?(w!==-1&&(h+=encodeURIComponent(s.substring(w,f)),w=-1),h+=L):w===-1&&(w=f)}}return w!==-1&&(h+=encodeURIComponent(s.substring(w))),h!==void 0?h:s}function c(s){let a;for(let h=0;h<s.length;h++){const w=s.charCodeAt(h);w===35||w===63?(a===void 0&&(a=s.substr(0,h)),a+=D[w]):a!==void 0&&(a+=s[h])}return a!==void 0?a:s}function u(s,a){let h;return s.authority&&s.path.length>1&&s.scheme==="file"?h=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?a?h=s.path.substr(1):h=s.path[1].toLowerCase()+s.path.substr(2):h=s.path,m.isWindows&&(h=h.replace(/\//g,"\\")),h}e.uriToFsPath=u;function o(s,a){const h=a?c:P;let w="",{scheme:f,authority:S,path:L,query:_,fragment:H}=s;if(f&&(w+=f,w+=":"),(S||f==="file")&&(w+=E,w+=E),S){let Q=S.indexOf("@");if(Q!==-1){const te=S.substr(0,Q);S=S.substr(Q+1),Q=te.indexOf(":"),Q===-1?w+=h(te,!1):(w+=h(te.substr(0,Q),!1),w+=":",w+=h(te.substr(Q+1),!1)),w+="@"}S=S.toLowerCase(),Q=S.indexOf(":"),Q===-1?w+=h(S,!1):(w+=h(S.substr(0,Q),!1),w+=S.substr(Q))}if(L){if(L.length>=3&&L.charCodeAt(0)===47&&L.charCodeAt(2)===58){const Q=L.charCodeAt(1);Q>=65&&Q<=90&&(L=`/${String.fromCharCode(Q+32)}:${L.substr(3)}`)}else if(L.length>=2&&L.charCodeAt(1)===58){const Q=L.charCodeAt(0);Q>=65&&Q<=90&&(L=`${String.fromCharCode(Q+32)}:${L.substr(2)}`)}w+=h(L,!0)}return _&&(w+="?",w+=h(_,!1)),H&&(w+="#",w+=a?H:P(H,!1)),w}function l(s){try{return decodeURIComponent(s)}catch(a){return s.length>3?s.substr(0,3)+l(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,a=>l(a)):s}}),define(J[109],Z([0,1,7]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(p){const i=p;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=A;function R(p){const i=[];let E;try{const k=JSON.parse(p.arguments),y=k[k.length-1];y&&y.__$stack&&(k.pop(),E=y.__$stack),i.push(...k)}catch(k){i.push("Unable to log remote console arguments",p.arguments)}return{args:i,stack:E}}e.parse=R;function b(p){if(typeof p!="string")return b(R(p).stack);const i=p;if(i){const E=I(i),k=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(k&&k.length===4)return{uri:m.URI.file(k[1]),line:Number(k[2]),column:Number(k[3])}}}e.getFirstFrame=b;function I(p){if(!p)return p;const i=p.indexOf(`
`);return i===-1?p:p.substring(0,i)}function n(p,i){const{args:E,stack:k}=R(p),y=typeof E[0]=="string"&&E.length===1;let d=I(k);d&&(d=`(${d.trim()})`);let g=[];if(typeof E[0]=="string"?d&&y?g=[`%c[${i}] %c${E[0]} %c${d}`,v("blue"),v(""),v("grey")]:g=[`%c[${i}] %c${E[0]}`,v("blue"),v(""),...E.slice(1)]:g=[`%c[${i}]%`,v("blue"),...E],d&&!y&&g.push(d),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,g)}e.log=n;function v(p){return`color: ${p}`}});var It=this&&this.__classPrivateFieldSet||function($,e,m,A,R){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?$!==e||!R:!e.has($))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?R.call($,m):R?R.value=m:e.set($,m),m},Ye=this&&this.__classPrivateFieldGet||function($,e,m,A){if(m==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?$!==e||!A:!e.has($))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?A:m==="a"?A.call($):A?A.value:e.get($)};define(J[37],Z([0,1,7,23]),function($,e,m,A){"use strict";var R,b,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function n(t,r,s){let a=t.get(r);return a===void 0&&(a=s,t.set(r,a)),a}e.getOrSet=n;function v(t){const r=[];return t.forEach((s,a)=>{r.push(`${a} => ${s}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=v;function p(t){const r=[];return t.forEach(s=>{r.push(s)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=p;class i{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),a=this._value.charCodeAt(this._pos);return s-a}value(){return this._value[this._pos]}}e.StringIterator=i;class E{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?A.compareSubstring(r,this._value,0,r.length,this._from,this._to):A.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class k{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?A.compareSubstring(r,this._value,0,r.length,this._from,this._to):A.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=k;var y;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(y||(y={}));class d{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new k(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return A.compareIgnoreCase(r,this._value.scheme);if(this._states[this._stateIdx]===2)return A.compareIgnoreCase(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return A.compare(r,this._value.query);if(this._states[this._stateIdx]===5)return A.compare(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class g{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class D{constructor(r){this._iter=r}static forUris(r=()=>!1){return new D(new d(r))}static forPaths(){return new D(new k)}static forStrings(){return new D(new i)}static forConfigKeys(){return new D(new E)}clear(){this._root=void 0}set(r,s){const a=this._iter.reset(r);let h;for(this._root||(this._root=new g,this._root.segment=a.value()),h=this._root;;){const f=a.cmp(h.segment);if(f>0)h.left||(h.left=new g,h.left.segment=a.value()),h=h.left;else if(f<0)h.right||(h.right=new g,h.right.segment=a.value()),h=h.right;else if(a.hasNext())a.next(),h.mid||(h.mid=new g,h.mid.segment=a.value()),h=h.mid;else break}const w=h.value;return h.value=s,h.key=r,w}get(r){var s;return(s=this._getNode(r))===null||s===void 0?void 0:s.value}_getNode(r){const s=this._iter.reset(r);let a=this._root;for(;a;){const h=s.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else break}return a}has(r){const s=this._getNode(r);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const a=this._iter.reset(r),h=[];let w=this._root;for(;w;){const f=a.cmp(w.segment);if(f>0)h.push([1,w]),w=w.left;else if(f<0)h.push([-1,w]),w=w.right;else if(a.hasNext())a.next(),h.push([0,w]),w=w.mid;else{for(s?(w.left=void 0,w.mid=void 0,w.right=void 0):w.value=void 0;h.length>0&&w.isEmpty();){let[S,L]=h.pop();switch(S){case 1:L.left=void 0;break;case 0:L.mid=void 0;break;case-1:L.right=void 0;break}w=L}break}}}findSubstr(r){const s=this._iter.reset(r);let a=this._root,h;for(;a;){const w=s.cmp(a.segment);if(w>0)a=a.left;else if(w<0)a=a.right;else if(s.hasNext())s.next(),h=a.value||h,a=a.mid;else break}return a&&a.value||h}findSuperstr(r){const s=this._iter.reset(r);let a=this._root;for(;a;){const h=s.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(r){for(const[s,a]of this)r(a,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const a=s.pop();a&&(a.value&&(yield[a.key,a.value]),a.left&&s.push(a.left),a.mid&&s.push(a.mid),a.right&&s.push(a.right))}}}e.TernarySearchTree=D;class P{constructor(r,s){this[R]="ResourceMap",r instanceof P?(this.map=new Map(r.map),this.toKey=s??P.defaultToKey):(this.map=new Map,this.toKey=r??P.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[a,h]of this.map)r(h,m.URI.parse(a),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield m.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[m.URI.parse(r[0]),r[1]]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[m.URI.parse(r[0]),r[1]]}}e.ResourceMap=P,P.defaultToKey=t=>t.toString();var c;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class u{constructor(){this[b]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var r;return(r=this._head)===null||r===void 0?void 0:r.value}get last(){var r;return(r=this._tail)===null||r===void 0?void 0:r.value}has(r){return this._map.has(r)}get(r,s=0){const a=this._map.get(r);if(!!a)return s!==0&&this.touch(a,s),a.value}set(r,s,a=0){let h=this._map.get(r);if(h)h.value=s,a!==0&&this.touch(h,a);else{switch(h={key:r,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(r,h),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const a=this._state;let h=this._head;for(;h;){if(s?r.bind(s)(h.value,h.key,this):r(h.value,h.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const r=this,s=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const w={value:a.key,done:!1};return a=a.next,w}else return{value:void 0,done:!0}}};return h}values(){const r=this,s=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const w={value:a.value,done:!1};return a=a.next,w}else return{value:void 0,done:!0}}};return h}entries(){const r=this,s=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const w={value:[a.key,a.value],done:!1};return a=a.next,w}else return{value:void 0,done:!0}}};return h}[(b=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>r;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,a=r.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const a=r.next,h=r.previous;r===this._tail?(h.next=void 0,this._tail=h):(a.previous=h,h.next=a),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const a=r.next,h=r.previous;r===this._head?(a.previous=void 0,this._head=a):(a.previous=h,h.next=a),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,a)=>{r.push([a,s])}),r}fromJSON(r){this.clear();for(const[s,a]of r)this.set(s,a)}}e.LinkedMap=u;class o extends u{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class l{constructor(r){I.set(this,void 0),It(this,I,r,"f")}get size(){return Ye(this,I,"f").size}forEach(r,s){Ye(this,I,"f").forEach(r,s)}get(r){return Ye(this,I,"f").get(r)}has(r){return Ye(this,I,"f").has(r)}entries(){return Ye(this,I,"f").entries()}keys(){return Ye(this,I,"f").keys()}values(){return Ye(this,I,"f").values()}[(I=new WeakMap,Symbol.iterator)](){return Ye(this,I,"f").entries()}}e.ReadonlyMapView=l}),define(J[110],Z([0,1,17,23,7]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function b(p){return JSON.stringify(p,n)}e.stringify=b;function I(p){let i=JSON.parse(p);return i=v(i),i}e.parse=I;function n(p,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:A.regExpFlags(i)}:i}function v(p,i=0){if(!p||i>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return R.URI.revive(p);case 2:return new RegExp(p.source,p.flags)}if(p instanceof m.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let E=0;E<p.length;++E)p[E]=v(p[E],i+1);else for(const E in p)Object.hasOwnProperty.call(p,E)&&(p[E]=v(p[E],i+1))}return p}e.revive=v}),define(J[10],Z([0,1,7,3]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractive="vscode-interactive",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(R=e.Schemas||(e.Schemas={}));class b{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(v){this._preferredWebSchema=v}setDelegate(v){this._delegate=v}set(v,p,i){this._hosts[v]=p,this._ports[v]=i}setConnectionToken(v,p){this._connectionTokens[v]=p}rewrite(v){if(this._delegate)return this._delegate(v);const p=v.authority;let i=this._hosts[p];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const E=this._ports[p],k=this._connectionTokens[p];let y=`path=${encodeURIComponent(v.path)}`;return typeof k=="string"&&(y+=`&tkn=${encodeURIComponent(k)}`),m.URI.from({scheme:A.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${i}:${E}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new b;class I{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(v,p,i){const E=this.toUri(v,p);return E.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(E):A.isNative&&(i||A.isPreferringBrowserCodeLoad)&&E.scheme===R.file?E.with({scheme:R.vscodeFileResource,authority:E.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):E}asFileUri(v,p){const i=this.toUri(v,p);return i.scheme===R.vscodeFileResource?i.with({scheme:R.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(v,p){return m.URI.isUri(v)?v:m.URI.parse(p.toUrl(v))}}e.FileAccess=new I}),define(J[65],Z([0,1,37]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const A=new m.LRUCache(1e4);function R(p){return v(p,"NFC",A)}e.normalizeNFC=R;const b=new m.LRUCache(1e4);function I(p){return v(p,"NFD",b)}e.normalizeNFD=I;const n=/[^\u0000-\u0080]/;function v(p,i,E){if(!e.canNormalize||!p)return p;const k=E.get(p);if(k)return k;let y;return n.test(p)?y=p.normalize(i):y=p,E.set(p,y),y}e.removeAccents=function(){if(e.canNormalize){const p=/[\u0300-\u036f]/g;return function(i){return I(i).replace(p,"")}}else return function(p){return p}}()}),define(J[15],Z([0,1,29,8,7,23,10,3]),function($,e,m,A,R,b,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function v(y){return R.uriToFsPath(y,!0)}e.originalFSPath=v;class p{constructor(d){this._ignorePathCasing=d}compare(d,g,D=!1){return d===g?0:b.compare(this.getComparisonKey(d,D),this.getComparisonKey(g,D))}isEqual(d,g,D=!1){return d===g?!0:!d||!g?!1:this.getComparisonKey(d,D)===this.getComparisonKey(g,D)}getComparisonKey(d,g=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,g,D=!1){if(d.scheme===g.scheme){if(d.scheme===I.Schemas.file)return m.isEqualOrParent(v(d),v(g),this._ignorePathCasing(d))&&d.query===g.query&&(D||d.fragment===g.fragment);if(e.isEqualAuthority(d.authority,g.authority))return m.isEqualOrParent(d.path,g.path,this._ignorePathCasing(d),"/")&&d.query===g.query&&(D||d.fragment===g.fragment)}return!1}joinPath(d,...g){return R.URI.joinPath(d,...g)}basenameOrAuthority(d){return e.basename(d)||d.authority}basename(d){return A.posix.basename(d.path)}extname(d){return A.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let g;return d.scheme===I.Schemas.file?g=R.URI.file(A.dirname(v(d))).path:(g=A.posix.dirname(d.path),d.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),g="/")),d.with({path:g})}normalizePath(d){if(!d.path.length)return d;let g;return d.scheme===I.Schemas.file?g=R.URI.file(A.normalize(v(d))).path:g=A.posix.normalize(d.path),d.with({path:g})}relativePath(d,g){if(d.scheme!==g.scheme||!e.isEqualAuthority(d.authority,g.authority))return;if(d.scheme===I.Schemas.file){const c=A.relative(v(d),v(g));return n.isWindows?m.toSlashes(c):c}let D=d.path||"/",P=g.path||"/";if(this._ignorePathCasing(d)){let c=0;for(const u=Math.min(D.length,P.length);c<u&&!(D.charCodeAt(c)!==P.charCodeAt(c)&&D.charAt(c).toLowerCase()!==P.charAt(c).toLowerCase());c++);D=P.substr(0,c)+D.substr(c)}return A.posix.relative(D,P)}resolvePath(d,g){if(d.scheme===I.Schemas.file){const D=R.URI.file(A.resolve(v(d),g));return d.with({authority:D.authority,path:D.path})}return g=m.toPosixPath(g),d.with({path:A.posix.resolve(d.path,g)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,g){return d===g||b.equalsIgnoreCase(d,g)}hasTrailingPathSeparator(d,g=A.sep){if(d.scheme===I.Schemas.file){const D=v(d);return D.length>m.getRoot(D).length&&D[D.length-1]===g}else{const D=d.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,g=A.sep){return e.hasTrailingPathSeparator(d,g)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,g=A.sep){let D=!1;if(d.scheme===I.Schemas.file){const P=v(d);D=P!==void 0&&P.length===m.getRoot(P).length&&P[P.length-1]===g}else{g="/";const P=d.path;D=P.length===1&&P.charCodeAt(P.length-1)===47}return!D&&!e.hasTrailingPathSeparator(d,g)?d.with({path:d.path+"/"}):d}}e.ExtUri=p,e.extUri=new p(()=>!1),e.extUriBiasedIgnorePathCase=new p(y=>y.scheme===I.Schemas.file?!n.isLinux:!0),e.extUriIgnorePathCase=new p(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(y,d){const g=[];for(let D=0;D<y.length;D++){const P=d(y[D]);y.some((c,u)=>u===D?!1:e.isEqualOrParent(P,d(c)))||g.push(y[D])}return g}e.distinctParents=i;var E;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function d(g){const D=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(u=>{const[o,l]=u.split(":");o&&l&&D.set(o,l)});const c=g.path.substring(0,g.path.indexOf(";"));return c&&D.set(y.META_DATA_MIME,c),D}y.parseMetaData=d})(E=e.DataUri||(e.DataUri={}));function k(y,d,g){if(d){let D=y.path;return D&&D[0]!==A.posix.sep&&(D=A.posix.sep+D),y.with({scheme:g,authority:d,path:D})}return y.with({scheme:g})}e.toLocalResource=k}),define(J[9],Z([0,1,25,16,5,2,79,15]),function($,e,m,A,R,b,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function v(N){return!!N&&typeof N.then=="function"}e.isThenable=v;function p(N){const F=new m.CancellationTokenSource,T=N(F.token),O=new Promise((M,W)=>{F.token.onCancellationRequested(()=>{W(A.canceled())}),Promise.resolve(T).then(U=>{F.dispose(),M(U)},U=>{F.dispose(),W(U)})});return new class{cancel(){F.cancel()}then(M,W){return O.then(M,W)}catch(M){return this.then(void 0,M)}finally(M){return O.finally(M)}}}e.createCancelablePromise=p;function i(N,F,T){return Promise.race([N,new Promise(O=>F.onCancellationRequested(()=>O(T)))])}e.raceCancellation=i;async function E(N){let F=-1;const T=N.map((M,W)=>M.then(U=>(F=W,U))),O=await Promise.race(T);return N.forEach((M,W)=>{W!==F&&M.cancel()}),O}e.raceCancellablePromises=E;function k(N,F,T){let O;const M=setTimeout(()=>{O==null||O(void 0),T==null||T()},F);return Promise.race([N.finally(()=>clearTimeout(M)),new Promise(W=>O=W)])}e.raceTimeout=k;function y(N){return new Promise((F,T)=>{const O=N();v(O)?O.then(F,T):F(O)})}e.asPromise=y;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const T=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(T,T).then(O)})}return new Promise((T,O)=>{this.queuedPromise.then(T,O)})}return this.activePromise=F(),new Promise((T,O)=>{this.activePromise.then(M=>{this.activePromise=null,T(M)},M=>{this.activePromise=null,O(M)})})}}e.Throttler=d;class g{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=g;class D{constructor(){this.promiseMap=new Map}queue(F,T){var O;const W=((O=this.promiseMap.get(F))!==null&&O!==void 0?O:Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(F)===W&&this.promiseMap.delete(F)});return this.promiseMap.set(F,W),W}}e.SequencerByKey=D;class P{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,T=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,M)=>{this.doResolve=O,this.doReject=M}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},T),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(A.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=P;class c{constructor(F){this.delayer=new P(F),this.throttler=new d}trigger(F,T){return this.delayer.trigger(()=>this.throttler.queue(F),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class u{constructor(){this._isOpen=!1,this._promise=new Promise((F,T)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class o extends u{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function l(N,F){return F?new Promise((T,O)=>{const M=setTimeout(T,N);F.onCancellationRequested(()=>{clearTimeout(M),O(A.canceled())})}):p(T=>l(N,T))}e.timeout=l;function t(N,F=0){const T=setTimeout(N,F);return b.toDisposable(()=>clearTimeout(T))}e.disposableTimeout=t;function r(N){return N.then(void 0,F=>{})}e.ignoreErrors=r;function s(N){const F=[];let T=0;const O=N.length;function M(){return T<O?N[T++]():null}function W(U){U!=null&&F.push(U);const V=M();return V?V.then(W):Promise.resolve(F)}return Promise.resolve(null).then(W)}e.sequence=s;function a(N,F=O=>!!O,T=null){let O=0;const M=N.length,W=()=>{if(O>=M)return Promise.resolve(T);const U=N[O++];return Promise.resolve(U()).then(K=>F(K)?Promise.resolve(K):W())};return W()}e.first=a;function h(N,F=O=>!!O,T=null){if(N.length===0)return Promise.resolve(T);let O=N.length;const M=()=>{var W,U;O=-1;for(const V of N)(U=(W=V).cancel)===null||U===void 0||U.call(W)};return new Promise((W,U)=>{for(const V of N)V.then(K=>{--O>=0&&F(K)?(M(),W(K)):O===0&&W(T)}).catch(K=>{--O>=0&&(M(),U(K))})})}e.firstParallel=h;class w{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((T,O)=>{this.outstandingPromises.push({factory:F,c:T,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const T=F.factory();T.then(F.c,F.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=w;class f extends w{constructor(){super(1)}}e.Queue=f;class S{constructor(){this.queues=new Map}queueFor(F,T=n.extUri){const O=T.getComparisonKey(F);let M=this.queues.get(O);return M||(M=new f,R.Event.once(M.onFinished)(()=>{M==null||M.dispose(),this.queues.delete(O)}),this.queues.set(O,M)),M}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=S;class L{constructor(F,T){this._token=-1,typeof F=="function"&&typeof T=="number"&&this.setIfNotSet(F,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},T)}setIfNotSet(F,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},T))}}e.TimeoutTimer=L;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,T){this.cancel(),this._token=setInterval(()=>{F()},T)}}e.IntervalTimer=_;class H{constructor(F,T){this.timeoutToken=-1,this.runner=F,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=H;class Q extends H{constructor(F,T){super(F,T);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Q,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const T=setTimeout(()=>F(N));let O=!1;return{dispose(){O||(O=!0,clearTimeout(T))}}}}else e.runWhenIdle=(N,F)=>{const T=requestIdleCallback(N,typeof F=="number"?{timeout:F}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(T))}}}}();class te{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(T){this._error=T}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=te;async function B(N,F,T){let O;for(let M=0;M<T;M++)try{return await N()}catch(W){O=W,await l(F)}throw O}e.retry=B;class Y{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var F;(F=this._pending)===null||F===void 0||F.cancel()}setPending(F,T,O){return this._pending={taskId:F,cancel:()=>O==null?void 0:O(),promise:T},T.then(()=>this.donePending(F),()=>this.donePending(F)),T}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let T,O;const M=new Promise((W,U)=>{T=W,O=U});this._next={run:F,promise:M,promiseResolve:T,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=Y;class G{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class C{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,T)=>{this.completeCallback=F,this.errorCallback=T})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(T=>{this.completeCallback(F),this.resolved=!0,T()})}error(F){return new Promise(T=>{this.errorCallback(F),this.rejected=!0,T()})}cancel(){new Promise(F=>{this.errorCallback(A.canceled()),this.rejected=!0,F()})}}e.DeferredPromise=C;class z extends R.Emitter{async fireAsync(F,T,O){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new I.LinkedList);for(const M of this._listeners)this._asyncDeliveryQueue.push([M,F]);for(;this._asyncDeliveryQueue.size>0&&!T.isCancellationRequested;){const[M,W]=this._asyncDeliveryQueue.shift(),U=[],V=Object.assign(Object.assign({},W),{waitUntil:K=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");O&&(K=O(K,typeof M=="function"?M:M[0])),U.push(K)}});try{typeof M=="function"?M.call(void 0,V):M[0].call(M[1],V)}catch(K){A.onUnexpectedError(K);continue}Object.freeze(U),await X.settled(U).catch(K=>A.onUnexpectedError(K))}}}}e.AsyncEmitter=z;var X;(function(N){async function F(W){return typeof Promise.allSettled=="function"?T(W):O(W)}N.allSettled=F;async function T(W){return Promise.allSettled(W)}async function O(W){return Promise.all(W.map(U=>U.then(V=>({status:"fulfilled",value:V}),V=>({status:"rejected",reason:V}))))}async function M(W){let U;const V=await Promise.all(W.map(K=>K.then(q=>q,q=>{U||(U=q)})));if(typeof U!="undefined")throw U;return V}N.settled=M})(X=e.Promises||(e.Promises={}))}),define(J[111],Z([0,1,23,29,8,37,9]),function($,e,m,A,R,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const v="**",p="/",i="[/\\\\]",E="[^/\\\\]",k=/\//g;function y(T){switch(T){case 0:return"";case 1:return`${E}*?`;default:return`(?:${i}|${E}+${i}|${i}${E}+)*?`}}function d(T,O){if(!T)return[];const M=[];let W=!1,U=!1,V="";for(const K of T){switch(K){case O:if(!W&&!U){M.push(V),V="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":U=!0;break;case"]":U=!1;break}V+=K}return V&&M.push(V),M}e.splitGlobAware=d;function g(T){if(!T)return"";let O="";const M=d(T,p);if(M.every(W=>W===v))O=".*";else{let W=!1;M.forEach((U,V)=>{if(U===v){W||(O+=y(2),W=!0);return}let K=!1,q="",x=!1,ne="";for(const re of U){if(re!=="}"&&K){q+=re;continue}if(x&&(re!=="]"||!ne)){let se;re==="-"?se=re:(re==="^"||re==="!")&&!ne?se="^":re===p?se="":se=m.escapeRegExpCharacters(re),ne+=se;continue}switch(re){case"{":K=!0;continue;case"[":x=!0;continue;case"}":O+=`(?:${d(q,",").map(oe=>g(oe)).join("|")})`,K=!1,q="";break;case"]":O+="["+ne+"]",x=!1,ne="";break;case"?":O+=E;continue;case"*":O+=y(1);continue;default:O+=m.escapeRegExpCharacters(re)}}V<M.length-1&&(M[V+1]!==v||V+2<M.length)&&(O+=i),W=!1})}return O}const D=/^\*\*\/\*\.[\w\.-]+$/,P=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new b.LRUCache(1e4),r=function(){return!1},s=function(){return null};function a(T,O){if(!T)return s;let M;typeof T!="string"?M=T.pattern:M=T,M=M.trim();const W=`${M}_${!!O.trimForExclusions}`;let U=t.get(W);if(U)return h(U,T);let V;if(D.test(M)){const K=M.substr(4);U=function(q,x){return typeof q=="string"&&q.endsWith(K)?M:null}}else(V=P.exec(w(M,O)))?U=f(V[1],M):(O.trimForExclusions?u:c).test(M)?U=S(M,O):(V=o.exec(w(M,O)))?U=L(V[1].substr(1),M,!0):(V=l.exec(w(M,O)))?U=L(V[1],M,!1):U=_(M);return t.set(W,U),h(U,T)}function h(T,O){return typeof O=="string"?T:function(M,W){return A.isEqualOrParent(M,O.base)?T(R.relative(O.base,M),W):null}}function w(T,O){return O.trimForExclusions&&T.endsWith("/**")?T.substr(0,T.length-2):T}function f(T,O){const M=`/${T}`,W=`\\${T}`,U=function(K,q){return typeof K!="string"?null:q?q===T?O:null:K===T||K.endsWith(M)||K.endsWith(W)?O:null},V=[T];return U.basenames=V,U.patterns=[O],U.allBasenames=V,U}function S(T,O){const M=F(T.slice(1,-1).split(",").map(q=>a(q,O)).filter(q=>q!==s),T),W=M.length;if(!W)return s;if(W===1)return M[0];const U=function(q,x){for(let ne=0,re=M.length;ne<re;ne++)if(M[ne](q,x))return T;return null},V=M.find(q=>!!q.allBasenames);V&&(U.allBasenames=V.allBasenames);const K=M.reduce((q,x)=>x.allPaths?q.concat(x.allPaths):q,[]);return K.length&&(U.allPaths=K),U}function L(T,O,M){const W=R.sep===R.posix.sep,U=W?T:T.replace(k,R.sep),V=R.sep+U,K=R.posix.sep+T,q=M?function(x,ne){return typeof x=="string"&&(x===U||x.endsWith(V)||!W&&(x===T||x.endsWith(K)))?O:null}:function(x,ne){return typeof x=="string"&&(x===U||!W&&x===T)?O:null};return q.allPaths=[(M?"*/":"./")+T],q}function _(T){try{const O=new RegExp(`^${g(T)}$`);return function(M){return O.lastIndex=0,typeof M=="string"&&O.test(M)?T:null}}catch(O){return s}}function H(T,O,M){return!T||typeof O!="string"?!1:Q(T)(O,void 0,M)}e.match=H;function Q(T,O={}){if(!T)return r;if(typeof T=="string"||G(T)){const M=a(T,O);if(M===s)return r;const W=function(U,V){return!!M(U,V)};return M.allBasenames&&(W.allBasenames=M.allBasenames),M.allPaths&&(W.allPaths=M.allPaths),W}return X(T,O)}e.parse=Q;function te(T){if(!T)return;let O;return M=>(O||(O=(T()||Promise.resolve([])).then(W=>W?Y(W):{})),O.then(W=>!!W[M]))}e.hasSiblingPromiseFn=te;function B(T){if(!T)return;let O;return M=>{if(!O){const W=T();O=W?Y(W):{}}return!!O[M]}}e.hasSiblingFn=B;function Y(T){const O={};for(const M of T)O[M]=!0;return O}function G(T){const O=T;return O&&typeof O.base=="string"&&typeof O.pattern=="string"}e.isRelativePattern=G;function C(T){return T.allBasenames||[]}e.getBasenameTerms=C;function z(T){return T.allPaths||[]}e.getPathTerms=z;function X(T,O){const M=F(Object.getOwnPropertyNames(T).map(q=>N(q,T[q],O)).filter(q=>q!==s)),W=M.length;if(!W)return s;if(!M.some(q=>!!q.requiresSiblings)){if(W===1)return M[0];const q=function(re,se){for(let le=0,oe=M.length;le<oe;le++){const ue=M[le](re,se);if(ue)return ue}return null},x=M.find(re=>!!re.allBasenames);x&&(q.allBasenames=x.allBasenames);const ne=M.reduce((re,se)=>se.allPaths?re.concat(se.allPaths):re,[]);return ne.length&&(q.allPaths=ne),q}const U=function(q,x,ne){let re;for(let se=0,le=M.length;se<le;se++){const oe=M[se];oe.requiresSiblings&&ne&&(x||(x=R.basename(q)),re||(re=x.substr(0,x.length-R.extname(q).length)));const ue=oe(q,x,re,ne);if(ue)return ue}return null},V=M.find(q=>!!q.allBasenames);V&&(U.allBasenames=V.allBasenames);const K=M.reduce((q,x)=>x.allPaths?q.concat(x.allPaths):q,[]);return K.length&&(U.allPaths=K),U}function N(T,O,M){if(O===!1)return s;const W=a(T,M);if(W===s)return s;if(typeof O=="boolean")return W;if(O){const U=O.when;if(typeof U=="string"){const V=(K,q,x,ne)=>{if(!ne||!W(K,q))return null;const re=U.replace("$(basename)",x),se=ne(re);return I.isThenable(se)?se.then(le=>le?T:null):se?T:null};return V.requiresSiblings=!0,V}}return W}function F(T,O){const M=T.filter(q=>!!q.basenames);if(M.length<2)return T;const W=M.reduce((q,x)=>{const ne=x.basenames;return ne?q.concat(ne):q},[]);let U;if(O){U=[];for(let q=0,x=W.length;q<x;q++)U.push(O)}else U=M.reduce((q,x)=>{const ne=x.patterns;return ne?q.concat(ne):q},[]);const V=function(q,x){if(typeof q!="string")return null;if(!x){let re;for(re=q.length;re>0;re--){const se=q.charCodeAt(re-1);if(se===47||se===92)break}x=q.substr(re)}const ne=W.indexOf(x);return ne!==-1?U[ne]:null};V.basenames=W,V.patterns=U,V.allBasenames=W;const K=T.filter(q=>!q.basenames);return K.push(V),K}}),define(J[30],Z([0,1,7,8,23,10,3,15,29]),function($,e,m,A,R,b,I,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function p(a,h,w){if(typeof a=="string"&&(a=m.URI.file(a)),w){const S=w.getWorkspaceFolder(a);if(S){const L=w.getWorkspace().folders.length>1;let _;if(n.isEqual(S.uri,a)?_="":_=n.relativePath(S.uri,a),L){const H=S.name?S.name:n.basename(S.uri);_=_?H+" \u2022 "+_:H}return _}}if(a.scheme!==b.Schemas.file&&a.scheme!==b.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if(v.hasDriveLetter(a.fsPath))return A.normalize(E(a.fsPath));let f=A.normalize(a.fsPath);return!I.isWindows&&(h==null?void 0:h.userHome)&&(f=y(f,h.userHome.fsPath)),f}e.getPathLabel=p;function i(a){if(!a)return;typeof a=="string"&&(a=m.URI.file(a));const h=n.basename(a)||(a.scheme===b.Schemas.file?a.fsPath:a.path);return I.isWindows&&v.isRootOrDriveLetter(h)?E(h):h}e.getBaseLabel=i;function E(a){return v.hasDriveLetter(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=E;let k=Object.create(null);function y(a,h){if(I.isWindows||!a||!h)return a;let w=k.original===h?k.normalized:void 0;return w||(w=`${R.rtrim(h,A.posix.sep)}${A.posix.sep}`,k={original:h,normalized:w}),(I.isLinux?a.startsWith(w):R.startsWithIgnoreCase(a,w))&&(a=`~/${a.substr(w.length)}`),a}e.tildify=y;function d(a,h){return a.replace(/^~($|\/|\\)/,`${h}$1`)}e.untildify=d;const g="\u2026",D="\\\\",P="~";function c(a,h=A.sep){const w=new Array(a.length);let f=!1;for(let S=0;S<a.length;S++){let L=a[S];if(L===""){w[S]=`.${h}`;continue}if(!L){w[S]=L;continue}f=!0;let _="";L.indexOf(D)===0?(_=L.substr(0,L.indexOf(D)+D.length),L=L.substr(L.indexOf(D)+D.length)):L.indexOf(h)===0?(_=L.substr(0,L.indexOf(h)+h.length),L=L.substr(L.indexOf(h)+h.length)):L.indexOf(P)===0&&(_=L.substr(0,L.indexOf(P)+P.length),L=L.substr(L.indexOf(P)+P.length));const H=L.split(h);for(let Q=1;f&&Q<=H.length;Q++)for(let te=H.length-Q;f&&te>=0;te--){f=!1;let B=H.slice(te,te+Q).join(h);for(let Y=0;!f&&Y<a.length;Y++)if(Y!==S&&a[Y]&&a[Y].indexOf(B)>-1){const G=te+Q===H.length,C=te>0&&a[Y].indexOf(h)>-1?h+B:B,z=a[Y].endsWith(C);f=!G||z}if(!f){let Y="";(H[0].endsWith(":")||_!=="")&&(te===1&&(te=0,Q++,B=H[0]+h+B),te>0&&(Y=H[0]+h),Y=_+Y),te>0&&(Y=Y+g+h),Y=Y+B,te+Q<H.length&&(Y=Y+h+g),w[S]=Y}}f&&(w[S]=L)}return w}e.shorten=c;var u;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function o(a,h=Object.create(null)){const w=[];let f=!1,S="";for(const L of a)if(L==="$"||f&&L==="{")S&&w.push({value:S,type:u.TEXT}),S="",f=!0;else if(L==="}"&&f){const _=h[S];if(typeof _=="string")_.length&&w.push({value:_,type:u.VARIABLE});else if(_){const H=w[w.length-1];(!H||H.type!==u.SEPARATOR)&&w.push({value:_.label,type:u.SEPARATOR})}S="",f=!1}else S+=L;return S&&!f&&w.push({value:S,type:u.TEXT}),w.filter((L,_)=>{if(L.type===u.SEPARATOR){const H=w[_-1],Q=w[_+1];return[H,Q].every(te=>te&&(te.type===u.VARIABLE||te.type===u.TEXT)&&te.value.length>0)}return!0}).map(L=>L.value).join("")}e.template=o;function l(a,h){return I.isMacintosh||h?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):a.replace(/&&|&/g,w=>w==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function t(a,h){return I.isMacintosh||h?a.replace(/\(&&\w\)|&&/g,""):I.isWindows?a.replace(/&&|&/g,w=>w==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(a){const h=a.indexOf("/")!==-1?A.posix:A.win32,w=h.basename(a),f=h.dirname(a);return w.length?{name:w,parentPath:f}:{name:f,parentPath:""}}e.splitName=s}),define(J[27],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(v){return m.test(v)}e.isUUID=A;const R=new Uint8Array(16),b=[];for(let v=0;v<256;v++)b.push(v.toString(16).padStart(2,"0"));let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(v){for(let p=0;p<v.length;p++)v[p]=Math.floor(Math.random()*256);return v};function n(){I(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let v=0,p="";return p+=b[R[v++]],p+=b[R[v++]],p+=b[R[v++]],p+=b[R[v++]],p+="-",p+=b[R[v++]],p+=b[R[v++]],p+="-",p+=b[R[v++]],p+=b[R[v++]],p+="-",p+=b[R[v++]],p+=b[R[v++]],p+="-",p+=b[R[v++]],p+=b[R[v++]],p+=b[R[v++]],p+=b[R[v++]],p+=b[R[v++]],p+=b[R[v++]],p}e.generateUuid=n}),define(J[112],Z([0,1,31,58,43]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function b(I,n){if(await new Promise((i,E)=>{const k=m.createReadStream(I),y=A.createHash("sha1");k.pipe(y);const d=R.once((g,D)=>{k.removeAllListeners(),y.removeAllListeners(),g?E(g):i(D)});k.once("error",d),k.once("end",d),y.once("error",d),y.once("data",g=>d(void 0,g.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=b}),define(J[82],Z([0,1,238]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class A{constructor(b="utf8"){this.stringDecoder=new m.StringDecoder(b),this.remaining=null}write(b){const I=[],n=this.remaining?this.remaining+this.stringDecoder.write(b):this.stringDecoder.write(b);if(n.length<1)return I;let v=0,p,i=v;for(;i<n.length;)if(p=n.charCodeAt(i),p===13||p===10){if(I.push(n.substring(v,i)),i++,i<n.length){const E=p;p=n.charCodeAt(i),(E===13&&p===10||E===10&&p===13)&&i++}v=i}else i++;return this.remaining=v<n.length?n.substr(v):null,I}end(){return this.remaining}}e.LineDecoder=A}),define(J[113],Z([0,1,26]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(n){const v=n.replace(/\-/g,":").toLowerCase();return!A.has(v)}function b(){return new Promise(async(n,v)=>{const p=setTimeout(()=>v("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await I())}catch(i){v(i)}finally{clearTimeout(p)}})}e.getMac=b;function I(){return new Promise((n,v)=>{try{const p=m.networkInterfaces();for(let i in p){const E=p[i];if(E){for(const{mac:k}of E)if(R(k))return n(k)}}v("Unable to retrieve mac address (unexpected format)")}catch(p){v(p)}})}}),define(J[66],Z([0,1,16,27,26,37,113]),function($,e,m,A,R,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=b.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,E=0;const k=R.networkInterfaces();for(let y in k){const d=k[y];if(d)for(const{mac:g,internal:D}of d)D||(E+=1,this._isVirtualMachineMacAdress(g.toUpperCase())&&(i+=1))}this._value=E>0?i/E:0}return this._value}};let n;async function v(){return n||(n=(async()=>await p()||A.generateUuid())()),n}e.getMachineId=v;async function p(){try{const i=await new Promise((k,y)=>{$(["crypto"],k,y)}),E=await I.getMac();return i.createHash("sha256").update(E,"utf8").digest("hex")}catch(i){m.onUnexpectedError(i);return}}}),define(J[18],Z([0,1,31,26,114,8,9,3,29,27,65,15,7]),function($,e,m,A,R,b,I,n,v,p,i,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(C){C[C.UNLINK=0]="UNLINK",C[C.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function d(C,z=y.UNLINK){if(v.isRootOrDriveLetter(C))throw new Error("rimraf - will refuse to recursively delete root");return z===y.UNLINK?D(C):g(C)}async function g(C){try{const z=b.join(A.tmpdir(),p.generateUuid());try{await e.Promises.rename(C,z)}catch(X){return D(C)}D(z).catch(X=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function D(C){return e.Promises.rmdir(C,{recursive:!0,maxRetries:3})}function P(C){if(v.isRootOrDriveLetter(C))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(C,{recursive:!0})}e.rimrafSync=P;async function c(C,z){return l(await(z?u(C):R.promisify(m.readdir)(C)))}async function u(C){try{return await R.promisify(m.readdir)(C,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const z=[],X=await c(C);for(const N of X){let F=!1,T=!1,O=!1;try{const M=await e.Promises.lstat(b.join(C,N));F=M.isFile(),T=M.isDirectory(),O=M.isSymbolicLink()}catch(M){console.warn("[node.js fs] unexpected error from lstat after readdir: ",M)}z.push({name:N,isFile:()=>F,isDirectory:()=>T,isSymbolicLink:()=>O})}return z}function o(C){return l(m.readdirSync(C))}e.readdirSync=o;function l(C){return C.map(z=>typeof z=="string"?n.isMacintosh?i.normalizeNFC(z):z:(z.name=n.isMacintosh?i.normalizeNFC(z.name):z.name,z))}async function t(C){const z=await c(C),X=[];for(const N of z)await s.existsDirectory(b.join(C,N))&&X.push(N);return X}function r(C,z=1e3){return new Promise(X=>{let N=!1;const F=setInterval(()=>{N||(N=!0,m.access(C,T=>{N=!1,T&&(clearInterval(F),X(void 0))}))},z)})}e.whenDeleted=r;var s;(function(C){async function z(F){let T;try{if(T=await e.Promises.lstat(F),!T.isSymbolicLink())return{stat:T}}catch(O){}try{return{stat:await e.Promises.stat(F),symbolicLink:(T==null?void 0:T.isSymbolicLink())?{dangling:!1}:void 0}}catch(O){if(O.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};if(n.isWindows&&O.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(M){if(M.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};throw M}throw O}}C.stat=z;async function X(F){try{const{stat:T,symbolicLink:O}=await C.stat(F);return T.isFile()&&(O==null?void 0:O.dangling)!==!0}catch(T){}return!1}C.existsFile=X;async function N(F){try{const{stat:T,symbolicLink:O}=await C.stat(F);return T.isDirectory()&&(O==null?void 0:O.dangling)!==!0}catch(T){}return!1}C.existsDirectory=N})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new I.ResourceQueue;function h(C,z,X){return a.queueFor(k.URI.file(C),E.extUriBiasedIgnorePathCase).queue(()=>{const N=L(X);return new Promise((F,T)=>f(C,z,N,O=>O?T(O):F()))})}let w=!0;function f(C,z,X,N){if(!w)return m.writeFile(C,z,{mode:X.mode,flag:X.flag},N);m.open(C,X.flag,X.mode,(F,T)=>{if(F)return N(F);m.writeFile(T,z,O=>{if(O)return m.close(T,()=>N(O));m.fdatasync(T,M=>(M&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",M),w=!1),m.close(T,W=>N(W))))})})}function S(C,z,X){const N=L(X);if(!w)return m.writeFileSync(C,z,{mode:N.mode,flag:N.flag});const F=m.openSync(C,N.flag,N.mode);try{m.writeFileSync(F,z);try{m.fdatasyncSync(F)}catch(T){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",T),w=!1}}finally{m.closeSync(F)}}e.writeFileSync=S;function L(C){return C?{mode:typeof C.mode=="number"?C.mode:438,flag:typeof C.flag=="string"?C.flag:"w"}:{mode:438,flag:"w"}}async function _(C,z){if(C===z)return;async function X(N){try{const F=await e.Promises.lstat(N);if(F.isDirectory()||F.isSymbolicLink())return;await e.Promises.utimes(N,F.atime,new Date)}catch(F){}}try{await e.Promises.rename(C,z),await X(z)}catch(N){if(C.toLowerCase()!==z.toLowerCase()&&N.code==="EXDEV"||C.endsWith("."))await H(C,z,{preserveSymlinks:!1}),await d(C,y.MOVE),await X(z);else throw N}}async function H(C,z,X){return te(C,z,{root:{source:C,target:z},options:X,handledSourcePaths:new Set})}const Q=511;async function te(C,z,X){if(X.handledSourcePaths.has(C))return;X.handledSourcePaths.add(C);const{stat:N,symbolicLink:F}=await s.stat(C);if(F){if(X.options.preserveSymlinks)try{return await G(C,z,X)}catch(T){console.warn("[node.js fs] copy of symlink failed: ",T)}if(F.dangling)return}return N.isDirectory()?B(C,z,N.mode&Q,X):Y(C,z,N.mode&Q)}async function B(C,z,X,N){await e.Promises.mkdir(z,{recursive:!0,mode:X});const F=await c(C);for(const T of F)await te(b.join(C,T),b.join(z,T),N)}async function Y(C,z,X){await e.Promises.copyFile(C,z),await e.Promises.chmod(z,X)}async function G(C,z,X){let N=await e.Promises.readlink(C);v.isEqualOrParent(N,X.root.source,!n.isLinux)&&(N=b.join(X.root.target,N.substr(X.root.source.length+1))),await e.Promises.symlink(N,z)}e.Promises=new class{get access(){return R.promisify(m.access)}get stat(){return R.promisify(m.stat)}get lstat(){return R.promisify(m.lstat)}get utimes(){return R.promisify(m.utimes)}get read(){return R.promisify(m.read)}get readFile(){return R.promisify(m.readFile)}get write(){return R.promisify(m.write)}get appendFile(){return R.promisify(m.appendFile)}get fdatasync(){return R.promisify(m.fdatasync)}get truncate(){return R.promisify(m.truncate)}get rename(){return R.promisify(m.rename)}get copyFile(){return R.promisify(m.copyFile)}get open(){return R.promisify(m.open)}get close(){return R.promisify(m.close)}get symlink(){return R.promisify(m.symlink)}get readlink(){return R.promisify(m.readlink)}get chmod(){return R.promisify(m.chmod)}get mkdir(){return R.promisify(m.mkdir)}get unlink(){return R.promisify(m.unlink)}get rmdir(){return R.promisify(m.rmdir)}get realpath(){return R.promisify(m.realpath)}async exists(C){try{return await e.Promises.access(C),!0}catch(z){return!1}}get readdir(){return c}get readDirsInDir(){return t}get writeFile(){return h}get rm(){return d}get move(){return _}get copy(){return H}}}),define(J[83],Z([0,1,31,23,8,18]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function I(i){const E=R.dirname(i);if(i===E)return i;const k=(R.basename(i)||i).toLowerCase();try{const d=b.readdirSync(E).filter(g=>g.toLowerCase()===k);if(d.length===1){const g=I(E);if(g)return R.join(g,d[0])}else if(d.length>1){const g=d.indexOf(k);if(g>=0){const D=I(E);if(D)return R.join(D,d[g])}}}catch(y){}return null}e.realcaseSync=I;async function n(i){try{return await b.Promises.realpath(i)}catch(E){const k=p(i);return await b.Promises.access(k,m.constants.R_OK),k}}e.realpath=n;function v(i){try{return m.realpathSync(i)}catch(E){const k=p(i);return m.accessSync(k,m.constants.R_OK),k}}e.realpathSync=v;function p(i){return A.rtrim(R.normalize(i),R.sep)}}),define(J[115],Z([0,1,59]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function A(n,v,p){let i=!1;return new Promise(E=>{const k=setTimeout(()=>{if(!i)return i=!0,E(0)},p);R(n,v,y=>{if(!i)return i=!0,clearTimeout(k),E(y)})})}e.findFreePort=A;function R(n,v,p){if(v===0)return p(0);const i=new m.Socket;i.once("connect",()=>(I(i),R(n+1,v-1,p))),i.once("data",()=>{}),i.once("error",E=>(I(i),E.code!=="ECONNREFUSED"?R(n+1,v-1,p):p(n))),i.connect(n,"127.0.0.1")}function b(n,v,p){let i=!1,E,k=1;const y=m.createServer({pauseOnConnect:!0});function d(g,D){i||(i=!0,y.removeAllListeners(),y.close(),E&&clearTimeout(E),D(g))}return new Promise(g=>{E=setTimeout(()=>{d(0,g)},p),y.on("listening",()=>{d(n,g)}),y.on("error",D=>{D&&(D.code==="EADDRINUSE"||D.code==="EACCES")&&k<v?(n++,k++,y.listen(n,"127.0.0.1")):d(0,g)}),y.on("close",()=>{d(0,g)}),y.listen(n,"127.0.0.1")})}e.findFreePortFaster=b;function I(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(v){console.error(v)}}});var Oe=this&&this.__await||function($){return this instanceof Oe?(this.v=$,this):new Oe($)},wt=this&&this.__asyncGenerator||function($,e,m){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var A=m.apply($,e||[]),R,b=[];return R={},I("next"),I("throw"),I("return"),R[Symbol.asyncIterator]=function(){return this},R;function I(k){A[k]&&(R[k]=function(y){return new Promise(function(d,g){b.push([k,y,d,g])>1||n(k,y)})})}function n(k,y){try{v(A[k](y))}catch(d){E(b[0][3],d)}}function v(k){k.value instanceof Oe?Promise.resolve(k.value.v).then(p,i):E(b[0][2],k)}function p(k){n("next",k)}function i(k){n("throw",k)}function E(k,y){k(y),b.shift(),b.length&&n(b[0][0],b[0][1])}},pt=this&&this.__asyncValues||function($){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=$[Symbol.asyncIterator],m;return e?e.call($):($=typeof __values=="function"?__values($):$[Symbol.iterator](),m={},A("next"),A("throw"),A("return"),m[Symbol.asyncIterator]=function(){return this},m);function A(b){m[b]=$[b]&&function(I){return new Promise(function(n,v){I=$[b](I),R(n,v,I.done,I.value)})}}function R(b,I,n,v){Promise.resolve(v).then(function(p){b({value:p,done:n})},I)}};define(J[116],Z([0,1,18,26,8]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const b=/^\d+$/,I=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var v;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(v||(v={}));let p;switch(process.arch){case"ia32":case"x32":p=1;break;case"arm":case"arm64":p=2;break;default:p=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class E{constructor(l,t,r){this.exePath=l,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await m.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function k({useAlternateBitness:o=!1}={}){return o?p===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:o=!1,findPreview:l=!1}={}){const t=k({useAlternateBitness:o});if(!t)return null;const r=R.join(t,"PowerShell");if(!await m.SymlinkSupport.existsDirectory(r))return null;let s=-1,a=null;for(const f of await m.Promises.readdir(r)){let S=-1;if(l){const _=f.indexOf("-");if(_<0)continue;const H=f.substring(0,_);if(!b.test(H)||f.substring(_+1)!=="preview")continue;S=parseInt(H,10)}else{if(!b.test(f))continue;S=parseInt(f,10)}if(S<=s)continue;const L=R.join(r,f,"pwsh.exe");!await m.SymlinkSupport.existsFile(L)||(a=L,s=S)}if(!a)return null;const h=t.includes("x86")?" (x86)":"",w=l?" Preview":"";return new E(a,`PowerShell${w}${h}`,!0)}async function d({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const l=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await m.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=o?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:I,pwshMsixName:"PowerShell (Store)"};for(const s of await m.Promises.readdir(l))if(t.test(s)){const a=R.join(l,s,"pwsh.exe");return new E(a,r)}return null}function g(){const o=R.join(A.homedir(),".dotnet","tools","pwsh.exe");return new E(o,".NET Core PowerShell Global Tool")}function D(){const o=R.join(process.env.windir,p===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(o,"Windows PowerShell",!0)}function P(){return wt(this,arguments,function*(){let l=yield Oe(y());l&&(yield yield Oe(l)),l=yield Oe(y({useAlternateBitness:!0})),l&&(yield yield Oe(l)),l=yield Oe(d()),l&&(yield yield Oe(l)),l=g(),l&&(yield yield Oe(l)),l=yield Oe(y({findPreview:!0})),l&&(yield yield Oe(l)),l=yield Oe(d({findPreview:!0})),l&&(yield yield Oe(l)),l=yield Oe(y({useAlternateBitness:!0,findPreview:!0})),l&&(yield yield Oe(l)),l=D(),l&&(yield yield Oe(l))})}function c(){return wt(this,arguments,function*(){var l,t;try{for(var r=pt(P()),s;s=yield Oe(r.next()),!s.done;){const a=s.value;(yield Oe(a.exists()))&&(yield yield Oe(a))}}catch(a){l={error:a}}finally{try{s&&!s.done&&(t=r.return)&&(yield Oe(t.call(r)))}finally{if(l)throw l.error}}})}e.enumeratePowerShellInstallations=c;async function u(){var o,l;try{for(var t=pt(c()),r;r=await t.next(),!r.done;)return r.value}catch(s){o={error:s}}finally{try{r&&!r.done&&(l=t.return)&&await l.call(t)}finally{if(o)throw o.error}}return null}e.getFirstAvailablePowerShellInstallation=u}),define(J[84],Z([0,1,41,10]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(I){return new Promise((n,v)=>{let p;const i=new Map;function E(y,d,g,D,P){const c=i.get(d);if(y===I||c){const u={name:k(g),cmd:g,pid:y,ppid:d,load:D,mem:P};i.set(y,u),y===I&&(p=u),c&&(c.children||(c.children=[]),c.children.push(u),c.children.length>1&&(c.children=c.children.sort((o,l)=>o.pid-l.pid)))}}function k(y){const d=/--disable-blink-features=Auxclick/,g=/\\watcher\\win32\\CodeHelper\.exe/,D=/--crashes-directory/,P=/\\pipe\\winpty-control/,c=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(g.exec(y))return"watcherService ";if(D.exec(y))return"electron-crash-reporter";if(P.exec(y))return"winpty-process";if(c.exec(y))return"console-window-host (Windows internal process)";let o=u.exec(y);if(o&&o.length===2)return o[1]==="renderer"?d.exec(y)?"shared-process":"window":o[1];const l=/[a-zA-Z-]+\.js/g;let t="";do o=l.exec(y),o&&(t+=o+" ");while(o);return t&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${t}`:y}if(process.platform==="win32"){const y=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,g)=>{$(["windows-process-tree"],d,g)}).then(d=>{d.getProcessList(I,g=>{d.getProcessCpuUsage(g,D=>{const P=new Map;D.forEach(c=>{const u=y(c.commandLine||"");P.set(c.pid,{name:k(u),cmd:u,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),p=P.get(I),p?(P.forEach(c=>{const u=P.get(c.ppid);u&&(u.children||(u.children=[]),u.children.push(c))}),P.forEach(c=>{c.children&&(c.children=c.children.sort((u,o)=>u.pid-o.pid))}),n(p)):v(new Error(`Root process ${I} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let y=function(){let d=[p];const g=[];for(;d.length;){const P=d.shift();P&&(g.push(P.pid),P.children&&(d=d.concat(P.children)))}let D=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",$).fsPath);D+=" "+g.join(" "),m.exec(D,{},(P,c,u)=>{if(P||u)v(P||new Error(u.toString()));else{const o=c.toString().split(`
`);for(let l=0;l<g.length;l++){const t=i.get(g[l]);t.load=parseFloat(o[l])}if(!p){v(new Error(`Root process ${I} not found`));return}n(p)}})};m.exec("which ps",{},(d,g,D)=>{if(d||D)if(process.platform!=="linux")v(d||new Error(D.toString()));else{const P=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/ps.sh",$).fsPath);m.exec(P,{},(c,u,o)=>{c||o?v(c||new Error(o.toString())):(b(u,E),y())})}else{const P=g.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";m.exec(`${P} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,o,l)=>{u||l&&!l.includes("screen size is bogus")?v(u||new Error(l.toString())):(b(o,E),process.platform==="linux"?y():p?n(p):v(new Error(`Root process ${I} not found`)))})}})}})}e.listProcesses=R;function b(I,n){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,p=I.toString().split(`
`);for(const i of p){const E=v.exec(i.trim());E&&E.length===6&&n(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(J[117],Z([0,1,8,31,3,65,2,18]),function($,e,m,A,R,b,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function v(E,k,y){return i({path:E,isDirectory:!1},k,y)}e.watchFile=v;function p(E,k,y){return i({path:E,isDirectory:!0},k,y)}e.watchFolder=p,e.CHANGE_BUFFER_DELAY=100;function i(E,k,y){const d=m.basename(E.path),g=new Map;let D=!1,P=[I.toDisposable(()=>{g.forEach(c=>I.dispose(c)),g.clear()})];try{const c=A.watch(E.path);P.push(I.toDisposable(()=>{c.removeAllListeners(),c.close()}));const u=new Set;E.isDirectory&&n.Promises.readdir(E.path).then(o=>o.forEach(l=>u.add(l))),c.on("error",(o,l)=>{D||y(`Failed to watch ${E.path} for changes using fs.watch() (${o}, ${l})`)}),c.on("change",(o,l)=>{if(D)return;let t="";if(l&&(t=l.toString(),R.isMacintosh&&(t=b.normalizeNFC(t))),!t||o!=="change"&&o!=="rename")return;const r=E.isDirectory?m.join(E.path,t):E.path;if(E.isDirectory)if(o==="rename"){const s=g.get(r);s&&I.dispose(s);const a=setTimeout(async()=>{g.delete(r);const h=await n.Promises.exists(r);if(D)return;let w;h?u.has(t)?w="changed":(w="added",u.add(t)):(u.delete(t),w="deleted"),k(w,r)},e.CHANGE_BUFFER_DELAY);g.set(r,I.toDisposable(()=>clearTimeout(a)))}else{let s;u.has(t)?s="changed":(s="added",u.add(t)),k(s,r)}else if(o==="rename"||t!==d){const s=setTimeout(async()=>{const a=await n.Promises.exists(r);D||(a?(k("changed",r),P=[i(E,k,y)]):k("deleted",r))},e.CHANGE_BUFFER_DELAY);I.dispose(P),P=[I.toDisposable(()=>clearTimeout(s))]}else k("changed",r)})}catch(c){n.Promises.exists(E.path).then(u=>{u&&!D&&y(`Failed to watch ${E.path} for changes using fs.watch() (${c.toString()})`)})}return I.toDisposable(()=>{D=!0,P=I.dispose(P)})}}),define(J[118],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[119],Z([0,1,14,118,13]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function b(){m.ipcMain.on(A.CONTEXT_MENU_CHANNEL,(n,v,p,i,E)=>{const k=I(n,i,p);k.popup({window:R.withNullAsUndefined(m.BrowserWindow.fromWebContents(n.sender)),x:E?E.x:void 0,y:E?E.y:void 0,positioningItem:E?E.positioningItem:void 0,callback:()=>{k&&n.sender.send(A.CONTEXT_MENU_CLOSE_CHANNEL,v)}})})}e.registerContextMenuListener=b;function I(n,v,p){const i=new m.Menu;return p.forEach(E=>{let k;E.type==="separator"?k=new m.MenuItem({type:E.type}):Array.isArray(E.submenu)?k=new m.MenuItem({submenu:I(n,v,E.submenu),label:E.label}):k=new m.MenuItem({label:E.label,type:E.type,accelerator:E.accelerator,checked:E.checked,enabled:E.enabled,visible:E.visible,click:(y,d,g)=>n.sender.send(v,E.id,g)}),i.append(k)}),i}});var he=this&&this.__decorate||function($,e,m,A){var R=arguments.length,b=R<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,m):A,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")b=Reflect.decorate($,e,m,A);else for(var n=$.length-1;n>=0;n--)(I=$[n])&&(b=(R<3?I(b):R>3?I(e,m,b):I(e,m))||b);return R>3&&b&&Object.defineProperty(e,m,b),b};define(J[34],Z([0,1,5,2,9,25,16,17,36,13,110,23,46]),function($,e,m,A,R,b,I,n,v,p,i,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function d(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function D(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var P;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(P||(P={}));class c{constructor(T){this.buffer=T,this.pos=0}read(T){const O=this.buffer.slice(this.pos,this.pos+T);return this.pos+=O.byteLength,O}}class u{constructor(){this.buffers=[]}get buffer(){return n.VSBuffer.concat(this.buffers)}write(T){this.buffers.push(T)}}var o;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(o||(o={}));function l(F){const T=n.VSBuffer.alloc(4);return T.writeUInt32BE(F,0),T}function t(F){return F.read(4).readUInt32BE(0)}function r(F){const T=n.VSBuffer.alloc(1);return T.writeUInt8(F,0),T}const s={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object)},a=typeof Buffer!="undefined";function h(F,T){if(typeof T=="undefined")F.write(s.Undefined);else if(typeof T=="string"){const O=n.VSBuffer.fromString(T);F.write(s.String),F.write(l(O.byteLength)),F.write(O)}else if(a&&Buffer.isBuffer(T)){const O=n.VSBuffer.wrap(T);F.write(s.Buffer),F.write(l(O.byteLength)),F.write(O)}else if(T instanceof n.VSBuffer)F.write(s.VSBuffer),F.write(l(T.byteLength)),F.write(T);else if(Array.isArray(T)){F.write(s.Array),F.write(l(T.length));for(const O of T)h(F,O)}else{const O=n.VSBuffer.fromString(JSON.stringify(T));F.write(s.Object),F.write(l(O.byteLength)),F.write(O)}}function w(F){switch(F.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return F.read(t(F)).toString();case o.Buffer:return F.read(t(F)).buffer;case o.VSBuffer:return F.read(t(F));case o.Array:{const O=t(F),M=[];for(let W=0;W<O;W++)M.push(w(F));return M}case o.Object:return JSON.parse(F.read(t(F)).toString())}}class f{constructor(T,O,M=null,W=1e3){this.protocol=T,this.ctx=O,this.logger=M,this.timeoutDelay=W,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(U=>this.onRawMessage(U)),this.sendResponse({type:200})}registerChannel(T,O){this.channels.set(T,O),setTimeout(()=>this.flushPendingRequests(T),0)}sendResponse(T){switch(T.type){case 200:{const O=this.send([T.type]);this.logger&&this.logger.logOutgoing(O,0,1,D(T.type));return}case 201:case 202:case 204:case 203:{const O=this.send([T.type,T.id],T.data);this.logger&&this.logger.logOutgoing(O,T.id,1,D(T.type),T.data);return}}}send(T,O=void 0){const M=new u;return h(M,T),h(M,O),this.sendBuffer(M.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch(O){return 0}}onRawMessage(T){const O=new c(T),M=w(O),W=w(O),U=M[0];switch(U){case 100:return this.logger&&this.logger.logIncoming(T.byteLength,M[1],1,`${d(U)}: ${M[2]}.${M[3]}`,W),this.onPromise({type:U,id:M[1],channelName:M[2],name:M[3],arg:W});case 102:return this.logger&&this.logger.logIncoming(T.byteLength,M[1],1,`${d(U)}: ${M[2]}.${M[3]}`,W),this.onEventListen({type:U,id:M[1],channelName:M[2],name:M[3],arg:W});case 101:return this.logger&&this.logger.logIncoming(T.byteLength,M[1],1,`${d(U)}`),this.disposeActiveRequest({type:U,id:M[1]});case 103:return this.logger&&this.logger.logIncoming(T.byteLength,M[1],1,`${d(U)}`),this.disposeActiveRequest({type:U,id:M[1]})}}onPromise(T){const O=this.channels.get(T.channelName);if(!O){this.collectPendingRequest(T);return}const M=new b.CancellationTokenSource;let W;try{W=O.call(this.ctx,T.name,T.arg,M.token)}catch(K){W=Promise.reject(K)}const U=T.id;W.then(K=>{this.sendResponse({id:U,data:K,type:201}),this.activeRequests.delete(T.id)},K=>{K instanceof Error?this.sendResponse({id:U,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.sendResponse({id:U,data:K,type:203}),this.activeRequests.delete(T.id)});const V=A.toDisposable(()=>M.cancel());this.activeRequests.set(T.id,V)}onEventListen(T){const O=this.channels.get(T.channelName);if(!O){this.collectPendingRequest(T);return}const M=T.id,U=O.listen(this.ctx,T.name,T.arg)(V=>this.sendResponse({id:M,data:V,type:204}));this.activeRequests.set(T.id,U)}disposeActiveRequest(T){const O=this.activeRequests.get(T.id);O&&(O.dispose(),this.activeRequests.delete(T.id))}collectPendingRequest(T){let O=this.pendingRequests.get(T.channelName);O||(O=[],this.pendingRequests.set(T.channelName,O));const M=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.sendResponse({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:T,timeoutTimer:M})}flushPendingRequests(T){const O=this.pendingRequests.get(T);if(O){for(const M of O)switch(clearTimeout(M.timeoutTimer),M.request.type){case 100:this.onPromise(M.request);break;case 102:this.onEventListen(M.request);break}this.pendingRequests.delete(T)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(T=>T.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var S;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(T,O=null){this.protocol=T,this.isDisposed=!1,this.state=P.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(M=>this.onBuffer(M)),this.logger=O}getChannel(T){const O=this;return{call(M,W,U){return O.isDisposed?Promise.reject(I.canceled()):O.requestPromise(T,M,W,U)},listen(M,W){return O.isDisposed?Promise.reject(I.canceled()):O.requestEvent(T,M,W)}}}requestPromise(T,O,M,W=b.CancellationToken.None){const U=this.lastRequestId++,K={id:U,type:100,channelName:T,name:O,arg:M};if(W.isCancellationRequested)return Promise.reject(I.canceled());let q;return new Promise((ne,re)=>{if(W.isCancellationRequested)return re(I.canceled());const se=()=>{const me=be=>{switch(be.type){case 201:this.handlers.delete(U),ne(be.data);break;case 202:this.handlers.delete(U);const De=new Error(be.data.message);De.stack=be.data.stack,De.name=be.data.name,re(De);break;case 203:this.handlers.delete(U),re(be.data);break}};this.handlers.set(U,me),this.sendRequest(K)};let le=null;this.state===P.Idle?se():(le=R.createCancelablePromise(me=>this.whenInitialized()),le.then(()=>{le=null,se()}));const oe=()=>{le?(le.cancel(),le=null):this.sendRequest({id:U,type:101}),re(I.canceled())},ue=W.onCancellationRequested(oe);q=A.combinedDisposable(A.toDisposable(oe),ue),this.activeRequests.add(q)}).finally(()=>{this.activeRequests.delete(q)})}requestEvent(T,O,M){const W=this.lastRequestId++,V={id:W,type:102,channelName:T,name:O,arg:M};let K=null;const q=new m.Emitter({onFirstListenerAdd:()=>{K=R.createCancelablePromise(ne=>this.whenInitialized()),K.then(()=>{K=null,this.activeRequests.add(q),this.sendRequest(V)})},onLastListenerRemove:()=>{K?(K.cancel(),K=null):(this.activeRequests.delete(q),this.sendRequest({id:W,type:103}))}}),x=ne=>q.fire(ne.data);return this.handlers.set(W,x),q.event}sendRequest(T){switch(T.type){case 100:case 102:{const O=this.send([T.type,T.id,T.channelName,T.name],T.arg);this.logger&&this.logger.logOutgoing(O,T.id,0,`${d(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const O=this.send([T.type,T.id]);this.logger&&this.logger.logOutgoing(O,T.id,0,d(T.type));return}}}send(T,O=void 0){const M=new u;return h(M,T),h(M,O),this.sendBuffer(M.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch(O){return 0}}onBuffer(T){const O=new c(T),M=w(O),W=w(O),U=M[0];switch(U){case 200:return this.logger&&this.logger.logIncoming(T.byteLength,0,0,D(U)),this.onResponse({type:M[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(T.byteLength,M[1],0,D(U),W),this.onResponse({type:M[0],id:M[1],data:W})}}onResponse(T){if(T.type===200){this.state=P.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(T.id);O&&O(T)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===P.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(T=>T.dispose()),this.activeRequests.clear()}}he([k.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class _{constructor(T){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,T(({protocol:O,onDidClientDisconnect:M})=>{m.Event.once(O.onMessage)(U=>{const V=new c(U),K=w(V),q=new f(O,K),x=new L(O);this.channels.forEach((re,se)=>q.registerChannel(se,re));const ne={channelServer:q,channelClient:x,ctx:K};this._connections.add(ne),this._onDidAddConnection.fire(ne),M(()=>{q.dispose(),x.dispose(),this._connections.delete(ne),this._onDidRemoveConnection.fire(ne)})})})}get connections(){const T=[];return this._connections.forEach(O=>T.push(O)),T}getChannel(T,O){const M=this;return{call(W,U,V){let K;if(p.isFunction(O)){let x=v.getRandomElement(M.connections.filter(O));K=x?Promise.resolve(x):m.Event.toPromise(m.Event.filter(M.onDidAddConnection,O))}else K=O.routeCall(M,W,U);const q=K.then(x=>x.channelClient.getChannel(T));return Q(q).call(W,U,V)},listen(W,U){if(p.isFunction(O))return M.getMulticastEvent(T,O,W,U);const V=O.routeEvent(M,W,U).then(K=>K.channelClient.getChannel(T));return Q(V).listen(W,U)}}}getMulticastEvent(T,O,M,W){const U=this;let V=new A.DisposableStore;const K=new m.Emitter({onFirstListenerAdd:()=>{V=new A.DisposableStore;const q=new m.EventMultiplexer,x=new Map,ne=se=>{const oe=se.channelClient.getChannel(T).listen(M,W),ue=q.add(oe);x.set(se,ue)},re=se=>{const le=x.get(se);!le||(le.dispose(),x.delete(se))};U.connections.filter(O).forEach(ne),m.Event.filter(U.onDidAddConnection,O)(ne,void 0,V),U.onDidRemoveConnection(re,void 0,V),q.event(K.fire,K,V),V.add(q)},onLastListenerRemove:()=>{V.dispose()}});return K.event}registerChannel(T,O){this.channels.set(T,O),this._connections.forEach(M=>{M.channelServer.registerChannel(T,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class H{constructor(T,O,M=null){const W=new u;h(W,O),T.send(W.buffer),this.channelClient=new L(T,M),this.channelServer=new f(T,O,M)}getChannel(T){return this.channelClient.getChannel(T)}registerChannel(T,O){this.channelServer.registerChannel(T,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=H;function Q(F){return{call(T,O,M){return F.then(W=>W.call(T,O,M))},listen(T,O){const M=new m.Relay;return F.then(W=>M.input=W.listen(T,O)),M.event}}}e.getDelayedChannel=Q;function te(F){let T=!1;return{call(O,M,W){return T?F.call(O,M,W):R.timeout(0).then(()=>T=!0).then(()=>F.call(O,M,W))},listen(O,M){if(T)return F.listen(O,M);const W=new m.Relay;return R.timeout(0).then(()=>T=!0).then(()=>W.input=F.listen(O,M)),W.event}}}e.getNextTickChannel=te;class B{constructor(T){this.fn=T}routeCall(T){return this.route(T)}routeEvent(T){return this.route(T)}async route(T){for(const O of T.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await m.Event.toPromise(T.onDidAddConnection),await this.route(T)}}e.StaticRouter=B;var Y;(function(F){function T(W,U){const V=W,K=U&&U.disableMarshalling,q=new Map;for(const x in V)M(x)&&q.set(x,m.Event.buffer(V[x],!0));return new class{listen(x,ne){const re=q.get(ne);if(re)return re;throw new Error(`Event not found: ${ne}`)}call(x,ne,re){const se=V[ne];if(typeof se=="function"){if(!K&&Array.isArray(re))for(let le=0;le<re.length;le++)re[le]=i.revive(re[le]);return se.apply(V,re)}throw new Error(`Method not found: ${ne}`)}}}F.fromService=T;function O(W,U){const V=U&&U.disableMarshalling;return new Proxy({},{get(K,q){var x;if(typeof q=="string")return((x=U==null?void 0:U.properties)===null||x===void 0?void 0:x.has(q))?U.properties.get(q):M(q)?W.listen(q):async function(...ne){let re;U&&!p.isUndefinedOrNull(U.context)?re=[U.context,...ne]:re=ne;const se=await W.call(q,re);return V?se:i.revive(se)};throw new Error(`Property not found: ${String(q)}`)}})}F.toService=O;function M(W){return W[0]==="o"&&W[1]==="n"&&E.isUpperAsciiLetter(W.charCodeAt(2))}})(Y=e.ProxyChannel||(e.ProxyChannel={}));const G=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function C(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let T=F.toString();if(T!=="[object Object]")return T}return F}function z(F){return Array.isArray(F)?F.map(C):C(F)}function X(F,T,O,M,W,U,V){V=z(V);const K=G[W],q=K[M%K.length];let x=[`%c[${F}]%c[${String(T).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(M).padStart(5," ")} - ${U}`,"color: darkgreen","color: grey","color: grey",`color: ${q}`];/\($/.test(U)?(x=x.concat(V),x.push(")")):x.push(V),console.log.apply(console,x)}e.logWithColors=X;class N{constructor(T,O){this._outgoingPrefix=T,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(T,O,M,W,U){this._totalOutgoing+=T,X(this._outgoingPrefix,this._totalOutgoing,T,O,M,W,U)}logIncoming(T,O,M,W,U){this._totalIncoming+=T,X(this._incomingPrefix,this._totalIncoming,T,O,M,W,U)}}e.IPCLogger=N}),define(J[120],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class m{constructor(R,b){this.sender=R,this.onMessage=b}send(R){try{this.sender.send("vscode:message",R.buffer)}catch(b){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=m}),define(J[121],Z([0,1,5,34,17]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class b{constructor(v){this.port=v,this.onMessage=m.Event.fromDOMEventEmitter(this.port,"message",p=>R.VSBuffer.wrap(p.data)),v.start()}send(v){this.port.postMessage(v.buffer)}disconnect(){this.port.close()}}e.Protocol=b;class I extends A.IPCClient{constructor(v,p){const i=new b(v);super(i,p);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=I}),define(J[85],Z([0,1,5,34,2,17,3,33]),function($,e,m,A,R,b,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var v;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v=e.SocketCloseEventType||(e.SocketCloseEventType={}));let p=null;function i(){return p||(p=b.VSBuffer.alloc(0)),p}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,h){if(a===0)return i();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const L=this._chunks[0];return h&&(this._chunks.shift(),this._totalLength-=a),L}if(this._chunks[0].byteLength>a){const L=this._chunks[0].slice(0,a);return h&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),L}let w=b.VSBuffer.alloc(a),f=0,S=0;for(;a>0;){const L=this._chunks[S];if(L.byteLength>a){const _=L.slice(0,a);w.set(_,f),f+=a,h&&(this._chunks[S]=L.slice(a),this._totalLength-=a),a-=a}else w.set(L,f),f+=L.byteLength,h?(this._chunks.shift(),this._totalLength-=L.byteLength):S++,a-=L.byteLength}return w}}e.ChunkStream=E;var k;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(k||(k={}));var y;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(y=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(a,h,w,f){this.type=a,this.id=h,this.ack=w,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends R.Disposable{constructor(a){super();this._onMessage=this._register(new m.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const h=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=h.readUInt32BE(9),this._state.messageType=h.readUInt8(0),this._state.id=h.readUInt32BE(1),this._state.ack=h.readUInt32BE(5);else{const w=this._state.messageType,f=this._state.id,S=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(w,f,S,h)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class D{constructor(a){this._isDisposed=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(a){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(a){if(this._isDisposed)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=b.VSBuffer.alloc(13);h.writeUInt8(a.type,0),h.writeUInt32BE(a.id,1),h.writeUInt32BE(a.ack,5),h.writeUInt32BE(a.data.byteLength,9),this._writeSoon(h,a.data)}_bufferAdd(a,h){const w=this._totalLength===0;return this._data.push(a,h),this._totalLength+=a.byteLength+h.byteLength,w}_bufferTake(){const a=b.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,h){this._bufferAdd(a,h)&&I.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class P extends R.Disposable{constructor(a){super();this._onMessage=new m.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new m.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new D(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(h=>{h.type===1&&this._onMessage.fire(h.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new d(1,0,0,a))}}e.Protocol=P;class c extends A.IPCClient{constructor(a,h,w=null){super(a,h,w);this.protocol=a}static fromSocket(a,h){return new c(new P(a),h)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=c;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new m.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,n.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class o{constructor(a){this.data=a,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let a=[],h=0,w=this._first;for(;w;)a[h++]=w.data,w=w.next;return a}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const h=new o(a);if(!this._first){this._first=h,this._last=h;return}this._last.next=h,this._last=h}}class t{constructor(){this.lastRuns=[];const a=Date.now();for(let h=0;h<t._HISTORY_LENGTH;h++)this.lastRuns[h]=a-1e3*h;setInterval(()=>{for(let h=t._HISTORY_LENGTH;h>=1;h--)this.lastRuns[h]=this.lastRuns[h-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const a=Date.now(),h=(1+t._HISTORY_LENGTH)*1e3;let w=0;for(let f=0;f<t._HISTORY_LENGTH;f++)a-this.lastRuns[f]<=h&&w++;return 1-w/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class r{constructor(a,h=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=a,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(w=>this._receiveMessage(w))),this._socketDisposables.push(this._socket.onClose(w=>this._onSocketClose.fire(w))),h&&this._socketReader.acceptChunk(h),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=R.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const a=new d(5,0,0,i());this._socketWriter.write(a),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const a=Date.now()-this._socketWriter.lastWriteTime;if(a>=5e3){const h=new d(4,0,0,i());this._socketWriter.write(h),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-a+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const a=Date.now()-this._socketReader.lastReadTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-a,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,h){this._isReconnecting=!0,this._socketDisposables=R.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=a,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(w=>this._receiveMessage(w))),this._socketDisposables.push(this._socket.onClose(w=>this._onSocketClose.fire(w))),this._socketReader.acceptChunk(h)}endAcceptReconnection(){this._isReconnecting=!1;const a=this._outgoingUnackMsg.toArray();for(let h=0,w=a.length;h<w;h++)this._socketWriter.write(a[h]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const h=this._outgoingUnackMsg.peek();if(h&&h.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(a.type===1){if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const h=Date.now();h-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=h,this._socketWriter.write(new d(6,0,0,i())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data)}else if(a.type===2)this._onControlMessage.fire(a.data);else if(a.type===5)this._onDidDispose.fire();else if(a.type===6){const h=this._outgoingUnackMsg.toArray();for(let w=0,f=h.length;w<f;w++)this._socketWriter.write(h[w]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const h=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const w=new d(1,h,this._incomingAckId,a);this._outgoingUnackMsg.push(w),this._isReconnecting||(this._socketWriter.write(w),this._recvAckCheck())}sendControl(a){const h=new d(2,0,0,a);this._socketWriter.write(h)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const a=Date.now()-this._incomingMsgLastTime;if(a>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-a+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const a=this._outgoingUnackMsg.peek(),h=Date.now()-a.writtenTime;if(h>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-h,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const a=new d(3,0,this._incomingAckId,i());this._socketWriter.write(a)}}e.PersistentProtocol=r}),define(J[122],Z([0,1,14,5,34,120,2,17]),function($,e,m,A,R,b,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function v(i,E){const k=A.Event.fromNodeEventEmitter(m.ipcMain,E,(d,g)=>({event:d,message:g})),y=A.Event.filter(k,({event:d})=>d.sender.id===i);return A.Event.map(y,({message:d})=>d&&n.VSBuffer.wrap(d))}class p extends R.IPCServer{constructor(){super(p.getOnDidClientConnect())}static getOnDidClientConnect(){const E=A.Event.fromNodeEventEmitter(m.ipcMain,"vscode:hello",({sender:k})=>k);return A.Event.map(E,k=>{const y=k.id,d=p.Clients.get(y);d&&d.dispose();const g=new A.Emitter;p.Clients.set(y,I.toDisposable(()=>g.fire()));const D=v(y,"vscode:message"),P=A.Event.any(A.Event.signal(v(y,"vscode:disconnect")),g.event);return{protocol:new b.Protocol(k,D),onDidClientDisconnect:P}})}}e.Server=p,p.Clients=new Map}),define(J[86],Z([0,1,14,5,27,121]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class I extends b.Client{constructor(p,i){super({addEventListener:(E,k)=>p.addListener(E,k),removeEventListener:(E,k)=>p.removeListener(E,k),postMessage:E=>p.postMessage(E),start:()=>p.start(),close:()=>p.close()},i)}}e.Client=I;async function n(v){if(v.isDestroyed()||v.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const p=R.generateUuid();v.webContents.send("vscode:createMessageChannel",p);const i=A.Event.fromNodeEventEmitter(m.ipcMain,"vscode:createMessageChannelResult",(k,y)=>({nonce:y,port:k.ports[0]})),{port:E}=await A.Event.toPromise(A.Event.once(A.Event.filter(i,k=>k.nonce===p)));return E}e.connect=n}),define(J[87],Z([0,1,2,5,9,13]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var I;(function(i){i[i.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(I=e.StorageHint||(e.StorageHint={}));var n;(function(i){i[i.None=0]="None",i[i.Initialized=1]="Initialized",i[i.Closed=2]="Closed"})(n||(n={}));class v extends m.Disposable{constructor(E,k=Object.create(null)){super();this.database=E,this.options=k,this._onDidChangeStorage=this._register(new A.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=n.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(v.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(E=>this.onDidChangeItemsExternal(E)))}onDidChangeItemsExternal(E){var k,y;(k=E.changed)===null||k===void 0||k.forEach((d,g)=>this.accept(g,d)),(y=E.deleted)===null||y===void 0||y.forEach(d=>this.accept(d,void 0))}accept(E,k){if(this.state===n.Closed)return;let y=!1;b.isUndefinedOrNull(k)?y=this.cache.delete(E):this.cache.get(E)!==k&&(this.cache.set(E,k),y=!0),y&&this._onDidChangeStorage.fire(E)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===n.None&&(this.state=n.Initialized,this.options.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(E,k){const y=this.cache.get(E);return b.isUndefinedOrNull(y)?k:y}getBoolean(E,k){const y=this.get(E);return b.isUndefinedOrNull(y)?k:y==="true"}getNumber(E,k){const y=this.get(E);return b.isUndefinedOrNull(y)?k:parseInt(y,10)}async set(E,k){if(this.state===n.Closed)return;if(b.isUndefinedOrNull(k))return this.delete(E);const y=String(k);if(this.cache.get(E)!==y)return this.cache.set(E,y),this.pendingInserts.set(E,y),this.pendingDeletes.delete(E),this._onDidChangeStorage.fire(E),this.flushDelayer.trigger(()=>this.flushPending())}async delete(E){if(!(this.state===n.Closed||!this.cache.delete(E)))return this.pendingDeletes.has(E)||this.pendingDeletes.add(E),this.pendingInserts.delete(E),this._onDidChangeStorage.fire(E),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=n.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(E){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const E={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(E).finally(()=>{var k;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(k=this.whenFlushedCallbacks.pop())===null||k===void 0||k()})}async whenFlushed(){if(!!this.hasPending)return new Promise(E=>this.whenFlushedCallbacks.push(E))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=v,v.DEFAULT_FLUSH_DELAY=100;class p{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(E){E.insert&&E.insert.forEach((k,y)=>this.items.set(y,k)),E.delete&&E.delete.forEach(k=>this.items.delete(k))}async close(){}}e.InMemoryStorageDatabase=p}),define(J[123],Z([0,1,5,9,37,8,18]),function($,e,m,A,R,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(i,E=Object.create(null)){this.path=i,this.options=E,this.name=b.basename(this.path),this.logger=new v(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return m.Event.None}async getItems(){const i=await this.whenConnected,E=new Map;return(await this.all(i,"SELECT * FROM ItemTable")).forEach(y=>E.set(y.key,y.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${E.size} rows`),E}async updateItems(i){const E=await this.whenConnected;return this.doUpdateItems(E,i)}doUpdateItems(i,E){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${E.insert?R.mapToString(E.insert):"0"}), delete(${E.delete?R.setToString(E.delete):"0"})`),this.transaction(i,()=>{const k=E.insert,y=E.delete;if(k&&k.size>0){const d=[];d.push([]);let g=0;k.forEach((D,P)=>{let c=d[g];c.length>n.MAX_HOST_PARAMETERS&&(g++,c=[],d.push(c)),c.push(P,D)}),d.forEach(D=>{this.prepare(i,`INSERT INTO ItemTable VALUES ${new Array(D.length/2).fill("(?,?)").join(",")}`,P=>P.run(D),()=>{const P=[];let c=0;return k.forEach((u,o)=>{P.push(o),c+=u.length}),`Keys: ${P.join(", ")} Length: ${c}`})})}if(y&&y.size){const d=[];d.push([]);let g=0;y.forEach(D=>{let P=d[g];P.length>n.MAX_HOST_PARAMETERS&&(g++,P=[],d.push(P)),P.push(D)}),d.forEach(D=>{this.prepare(i,`DELETE FROM ItemTable WHERE key IN (${new Array(D.length).fill("?").join(",")})`,P=>P.run(D),()=>{const P=[];return y.forEach(c=>{P.push(c)}),`Keys: ${P.join(", ")}`})})}})}async close(i){this.logger.trace(`[storage ${this.name}] close()`);const E=await this.whenConnected;return this.doClose(E,i)}doClose(i,E){return new Promise((k,y)=>{i.db.close(d=>(d&&this.handleSQLiteError(i,`[storage ${this.name}] close(): ${d}`),this.path===n.IN_MEMORY_PATH?k():!i.isErroneous&&!i.isInMemory?this.backup().then(k,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),k())):typeof E=="function"?I.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const D=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:E()}).then(()=>D(),P=>(D(),Promise.reject(P)))})).then(k,y):y(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const i=this.toBackupPath(this.path);return I.Promises.copy(this.path,i,{preserveSymlinks:!1})}toBackupPath(i){return`${i}.backup`}async checkIntegrity(i){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${i})`);const E=await this.whenConnected,k=await this.get(E,i?"PRAGMA integrity_check":"PRAGMA quick_check"),y=i?k.integrity_check:k.quick_check;return E.isErroneous?`${y} (last error: ${E.lastError})`:E.isInMemory?`${y} (in-memory!)`:y}async connect(i,E=!0){this.logger.trace(`[storage ${this.name}] open(${i}, retryOnBusy: ${E})`);try{return await this.doConnect(i)}catch(k){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${k}`),k.code==="SQLITE_BUSY"&&E)return await A.timeout(n.BUSY_OPEN_TIMEOUT),this.connect(i,!1);try{await I.Promises.unlink(i);try{await I.Promises.rename(this.toBackupPath(i),i)}catch(y){}return await this.doConnect(i)}catch(y){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${y}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(i,E){i.isErroneous=!0,i.lastError=E,this.logger.error(E)}doConnect(i){return new Promise((E,k)=>{new Promise((y,d)=>{$(["vscode-sqlite3"],y,d)}).then(y=>{const d={db:new(this.logger.isTracing?y.verbose().Database:y.Database)(i,g=>g?d.db?d.db.close(()=>k(g)):k(g):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>E(d),D=>d.db.close(()=>k(D)))),isInMemory:i===n.IN_MEMORY_PATH};d.db.on("error",g=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&d.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},k)})}exec(i,E){return new Promise((k,y)=>{i.db.exec(E,d=>d?(this.handleSQLiteError(i,`[storage ${this.name}] exec(): ${d}`),y(d)):k())})}get(i,E){return new Promise((k,y)=>{i.db.get(E,(d,g)=>d?(this.handleSQLiteError(i,`[storage ${this.name}] get(): ${d}`),y(d)):k(g))})}all(i,E){return new Promise((k,y)=>{i.db.all(E,(d,g)=>d?(this.handleSQLiteError(i,`[storage ${this.name}] all(): ${d}`),y(d)):k(g))})}transaction(i,E){return new Promise((k,y)=>{i.db.serialize(()=>{i.db.run("BEGIN TRANSACTION"),E(),i.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(i,`[storage ${this.name}] transaction(): ${d}`),y(d)):k())})})}prepare(i,E,k,y){const d=i.db.prepare(E),g=D=>{this.handleSQLiteError(i,`[storage ${this.name}] prepare(): ${D} (${E}). Details: ${y()}`)};d.on("error",g),k(d),d.finalize(D=>{D&&g(D),d.removeListener("error",g)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class v{constructor(i){i&&typeof i.logTrace=="function"&&process.env[v.VSCODE_TRACE_STORAGE]&&(this.logTrace=i.logTrace),i&&typeof i.logError=="function"&&(this.logError=i.logError)}get isTracing(){return!!this.logTrace}trace(i){this.logTrace&&this.logTrace(i)}error(i){this.logError&&this.logError(i)}}v.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[124],Z([12,11]),function($,e){return $.create("vs/base/common/date",e)}),define(J[125],Z([0,1,124]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,R=A*60,b=R*24,I=b*7,n=b*30,v=b*365;function p(E,k){typeof E!="number"&&(E=E.getTime());const y=Math.round((new Date().getTime()-E)/1e3);if(y<-30)return m.localize(0,null,p(new Date().getTime()+y*1e3,!1));if(y<30)return m.localize(1,null);let d;return y<A?(d=y,k?d===1?m.localize(2,null,d):m.localize(3,null,d):d===1?m.localize(4,null,d):m.localize(5,null,d)):y<R?(d=Math.floor(y/A),k?d===1?m.localize(6,null,d):m.localize(7,null,d):d===1?m.localize(8,null,d):m.localize(9,null,d)):y<b?(d=Math.floor(y/R),k?d===1?m.localize(10,null,d):m.localize(11,null,d):d===1?m.localize(12,null,d):m.localize(13,null,d)):y<I?(d=Math.floor(y/b),k?d===1?m.localize(14,null,d):m.localize(15,null,d):d===1?m.localize(16,null,d):m.localize(17,null,d)):y<n?(d=Math.floor(y/I),k?d===1?m.localize(18,null,d):m.localize(19,null,d):d===1?m.localize(20,null,d):m.localize(21,null,d)):y<v?(d=Math.floor(y/n),k?d===1?m.localize(22,null,d):m.localize(23,null,d):d===1?m.localize(24,null,d):m.localize(25,null,d)):(d=Math.floor(y/v),k?d===1?m.localize(26,null,d):m.localize(27,null,d):d===1?m.localize(28,null,d):m.localize(29,null,d))}e.fromNow=p;function i(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(J[126],Z([12,11]),function($,e){return $.create("vs/base/common/errorMessage",e)}),define(J[67],Z([0,1,126,13,36]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function b(p,i){return i&&(p.stack||p.stacktrace)?m.localize(0,null,n(p),I(p.stack)||I(p.stacktrace)):n(p)}function I(p){return Array.isArray(p)?p.join(`
`):p}function n(p){return typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?m.localize(1,null,p.message):p.message||m.localize(2,null)}function v(p=null,i=!1){if(!p)return m.localize(3,null);if(Array.isArray(p)){const E=R.coalesce(p),k=v(E[0],i);return E.length>1?m.localize(4,null,k,E.length):k}if(A.isString(p))return p;if(p.detail){const E=p.detail;if(E.error)return b(E.error,i);if(E.exception)return b(E.exception,i)}return p.stack?b(p,i):p.message?p.message:m.localize(5,null)}e.toErrorMessage=v}),define(J[127],Z([12,11]),function($,e){return $.create("vs/base/common/keybindingLabels",e)}),define(J[128],Z([0,1,127]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class A{constructor(I,n,v=n){this.modifierLabels=[null],this.modifierLabels[2]=I,this.modifierLabels[1]=n,this.modifierLabels[3]=v}toLabel(I,n,v){if(n.length===0)return null;const p=[];for(let i=0,E=n.length;i<E;i++){const k=n[i],y=v(k);if(y===null)return null;p[i]=R(k,y,this.modifierLabels[I])}return p.join(" ")}}e.ModifierLabelProvider=A,e.UILabelProvider=new A({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:m.localize(0,null),shiftKey:m.localize(1,null),altKey:m.localize(2,null),metaKey:m.localize(3,null),separator:"+"},{ctrlKey:m.localize(4,null),shiftKey:m.localize(5,null),altKey:m.localize(6,null),metaKey:m.localize(7,null),separator:"+"}),e.AriaLabelProvider=new A({ctrlKey:m.localize(8,null),shiftKey:m.localize(9,null),altKey:m.localize(10,null),metaKey:m.localize(11,null),separator:"+"},{ctrlKey:m.localize(12,null),shiftKey:m.localize(13,null),altKey:m.localize(14,null),metaKey:m.localize(15,null),separator:"+"},{ctrlKey:m.localize(16,null),shiftKey:m.localize(17,null),altKey:m.localize(18,null),metaKey:m.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new A({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new A({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function R(b,I,n){if(I===null)return"";const v=[];return b.ctrlKey&&v.push(n.ctrlKey),b.shiftKey&&v.push(n.shiftKey),b.altKey&&v.push(n.altKey),b.metaKey&&v.push(n.metaKey),I!==""&&v.push(I),v.join(n.separator)}}),define(J[129],Z([12,11]),function($,e){return $.create("vs/base/node/processes",e)}),define(J[68],Z([0,1,8,18,41,129,33,13,44,29,3,82,10]),function($,e,m,A,R,b,I,n,v,p,i,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function y(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(o,l){if(i.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};l&&(t.cwd=l);const r=R.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(s=>{r.once("error",a=>{s({success:!1,error:a})}),r.once("exit",(a,h)=>{s(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?y(t.status):1})}else if(i.isLinux||i.isMacintosh)try{const t=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(r=>{R.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(s,a,h)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function g(o=I.env){return o.comspec||"cmd.exe"}e.getWindowsShell=g;class D{constructor(l,t,r,s){if(t!==void 0&&r!==void 0&&s!==void 0)this.cmd=l,this.args=t,this.shell=r,this.options=s;else{const a=l;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(I.env).forEach(h=>{a[h]=I.env[h]}),Object.keys(this.options.env).forEach(h=>{a[h]=this.options.env[h]}),this.options.env=a}}getSanitizedCommand(){let l=this.cmd.toLowerCase();const t=l.lastIndexOf(m.sep);return t!==-1&&(l=l.substring(t+1)),D.WellKnowCommands[l]?l:"other"}start(l){return i.isWindows&&(this.options&&this.options.cwd&&p.isUNC(this.options.cwd)||!this.options&&p.isUNC(I.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(t=>{let r,s;const a=new Promise((h,w)=>{r=h,s=w});if(t){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=R.exec(h,this.options,(w,f,S)=>{this.childProcess=null;const L=w;L&&L.killed?s({killed:this.terminateRequested,stdout:f.toString(),stderr:S.toString()}):this.handleExec(r,l,w,f,S)})}else{let h=null;const w=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,r,l,s);const S={terminated:this.terminateRequested};n.isNumber(f)&&(S.cmdCode=f),r(S)};if(this.shell&&i.isWindows){const f=v.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let S=!1,L=!1;const _=[];let H=this.ensureQuotes(this.cmd);_.push(H.value),S=H.quoted,this.args&&this.args.forEach(te=>{H=this.ensureQuotes(te),_.push(H.value),L=L&&H.quoted});const Q=["/s","/c"];S?L?Q.push('"'+_.join(" ")+'"'):_.length>1?Q.push('"'+_[0]+'" '+_.slice(1).join(" ")):Q.push('"'+_[0]+'"'):Q.push(_.join(" ")),h=R.spawn(g(),Q,f)}else this.cmd&&(h=R.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(n.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",f=>{this.childProcess=null,s({terminated:this.terminateRequested,error:f})}),h.pid&&(this.childProcess.on("close",w),this.handleSpawn(h,r,l,s,!0)))}return a})}handleClose(l,t,r,s){}ensureQuotes(l){return D.regexp.test(l)?{value:'"'+l+'"',quoted:!0}:{value:l,quoted:l.length>0&&l[0]==='"'&&l[l.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(l=>l.pid,l=>-1):new Promise(l=>{this.pidResolve=l})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(l=>(this.terminateRequested=!0,d(l,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),l=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(l=>{if(!this.shell||!i.isWindows)return l(!1);const t=R.spawn(g(),["/s","/c"]);t.on("error",r=>l(!0)),t.on("exit",r=>l(!1))})}}e.AbstractProcess=D,D.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},D.regexp=/^[^"].* .*[^"]/;class P extends D{constructor(l,t,r,s){super(l,t,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(l,t,r,s,a){[s,a].forEach((h,w)=>{const f=new E.LineDecoder;f.write(h).forEach(_=>{t({line:_,source:w===0?0:1})});const L=f.end();L&&t({line:L,source:w===0?0:1})}),l({terminated:this.terminateRequested,error:r})}handleSpawn(l,t,r,s,a){const h=new E.LineDecoder,w=new E.LineDecoder;l.stdout.on("data",f=>{h.write(f).forEach(L=>r({line:L,source:0}))}),l.stderr.on("data",f=>{w.write(f).forEach(L=>r({line:L,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=w}handleClose(l,t,r,s){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&r({line:a,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&r({line:h,source:1})}}e.LineProcess=P;function c(o){let l=[],t=!1;const r=function(s){if(t){l.push(s);return}(!o.send(s,h=>{if(h&&console.error(h),t=!1,l.length>0){const w=l.slice(0);l=[],w.forEach(f=>r(f))}})||i.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=c;var u;(function(o){async function l(t,r,s){if(m.isAbsolute(t))return t;if(r===void 0&&(r=I.cwd()),m.dirname(t)!=="."||(s===void 0&&n.isString(I.env.PATH)&&(s=I.env.PATH.split(m.delimiter)),s===void 0||s.length===0))return m.join(r,t);async function h(w){return await A.Promises.exists(w)?!(await A.Promises.stat(w)).isDirectory():!1}for(let w of s){let f;if(m.isAbsolute(w)?f=m.join(w,t):f=m.join(r,w,t),await h(f))return f;let S=f+".com";if(await h(S)||(S=f+".exe",await h(S)))return S}return m.join(r,t)}o.findExecutable=l})(u=e.win32||(e.win32={}))}),define(J[130],Z([0,1,26,3,116,68]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function I(y,d){return y===1?A.isWindows?E():b.getWindowsShell(d):p(y,d)}e.getSystemShell=I;function n(y,d){return y===1?A.isWindows?k(d):b.getWindowsShell(d):p(y,d)}e.getSystemShellSync=n;let v=null;function p(y,d){if(A.isLinux&&y===2||A.isMacintosh&&y===3)return"/bin/bash";if(!v){let g;if(A.isWindows)g="/bin/bash";else{if(g=d.SHELL,!g)try{g=m.userInfo().shell}catch(D){}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}v=g}return v}let i=null;async function E(){return i||(i=(await R.getFirstAvailablePowerShellInstallation()).exePath),i}function k(y){if(i)return i;const d=A.isWindows&&parseFloat(m.release())>=10,g=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),D=`${y.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?D:b.getWindowsShell(y)}}),define(J[88],Z([0,1,41,2,9,44,5,68,34,109,25,16,17,3]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends v.ChannelServer{constructor(P){super({send:c=>{try{process.send&&process.send(c.buffer.toString("base64"))}catch(u){}},onMessage:I.Event.fromNodeEventEmitter(process,"message",c=>k.VSBuffer.wrap(Buffer.from(c,"base64")))},P);process.once("disconnect",()=>this.dispose())}}e.Server=d;class g{constructor(P,c){this.modulePath=P,this.options=c,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new I.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const u=c&&c.timeout?c.timeout:6e4;this.disposeDelayer=new R.Delayer(u),this.child=null,this._client=null}getChannel(P){const c=this;return{call(u,o,l){return c.requestPromise(P,u,o,l)},listen(u,o){return c.requestEvent(P,u,o)}}}requestPromise(P,c,u,o=i.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(P),t=R.createCancelablePromise(a=>l.call(c,u,a)),r=o.onCancellationRequested(()=>t.cancel()),s=A.toDisposable(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{r.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(P,c,u){if(!this.disposeDelayer)return I.Event.None;this.disposeDelayer.cancel();let o;const l=new I.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(P).listen(c,u)(l.fire,l),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const P=this.options&&this.options.args?this.options.args:[],c=Object.create(null);c.env=Object.assign(Object.assign({},b.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(c.env=Object.assign(Object.assign({},c.env),this.options.env)),this.options&&this.options.freshExecArgv&&(c.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h))),y.isMacintosh&&c.env&&delete c.env.DYLD_LIBRARY_PATH,this.child=m.fork(this.modulePath,P,c);const u=new I.Emitter;I.Event.fromNodeEventEmitter(this.child,"message",h=>h)(h=>{if(p.isRemoteConsoleLog(h)){p.log(h,`IPC Library: ${this.options.serverName}`);return}u.fire(k.VSBuffer.wrap(Buffer.from(h,"base64")))});const l=this.options.useQueue?n.createQueuedSender(this.child):this.child,t=h=>this.child&&this.child.connected&&l.send(h.buffer.toString("base64")),r=u.event,s={send:t,onMessage:r};this._client=new v.ChannelClient(s);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",h=>console.warn('IPC "'+this.options.serverName+'" errored with '+h)),this.child.on("exit",(h,w)=>{process.removeListener("exit",a),this.activeRequests.forEach(f=>A.dispose(f)),this.activeRequests.clear(),h!==0&&w!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+h+" and signal "+w),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:h,signal:w})})}return this._client}getCachedChannel(P){let c=this.channels.get(P);return c||(c=this.client.getChannel(P),this.channels.set(P,c)),c}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(J[131],Z([12,11]),function($,e){return $.create("vs/code/electron-main/app",e)}),define(J[132],Z([12,11]),function($,e){return $.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[133],Z([12,11]),function($,e){return $.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[134],Z([12,11]),function($,e){return $.create("vs/platform/environment/node/argv",e)}),define(J[135],Z([12,11]),function($,e){return $.create("vs/platform/environment/node/argvHelper",e)}),define(J[136],Z([12,11]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[137],Z([12,11]),function($,e){return $.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[138],Z([12,11]),function($,e){return $.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[139],Z([12,11]),function($,e){return $.create("vs/platform/files/common/fileService",e)}),define(J[140],Z([12,11]),function($,e){return $.create("vs/platform/files/common/files",e)}),define(J[141],Z([12,11]),function($,e){return $.create("vs/platform/files/common/io",e)}),define(J[142],Z([12,11]),function($,e){return $.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[143],Z([12,11]),function($,e){return $.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[144],Z([12,11]),function($,e){return $.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[145],Z([12,11]),function($,e){return $.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[146],Z([12,11]),function($,e){return $.create("vs/platform/request/common/request",e)}),define(J[147],Z([12,11]),function($,e){return $.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[148],Z([12,11]),function($,e){return $.create("vs/platform/update/common/update.config.contribution",e)}),define(J[149],Z([12,11]),function($,e){return $.create("vs/platform/windows/electron-main/window",e)}),define(J[150],Z([12,11]),function($,e){return $.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[151],Z([12,11]),function($,e){return $.create("vs/platform/workspaces/common/workspaces",e)}),define(J[152],Z([12,11]),function($,e){return $.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[153],Z([12,11]),function($,e){return $.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[154],Z([0,1,5,2]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class R{constructor(){this._onCloseEmitter=new m.Emitter,this._onReloadEmitter=new m.Emitter,this._onTerminateEmitter=new m.Emitter,this._onAttachEmitter=new m.Emitter}call(n,v,p){switch(v){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:p[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:p[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:p[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:p[0],port:p[1],subId:p[2]}))}throw new Error("Method not implemented.")}listen(n,v,p){switch(v){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=R,R.ChannelName="extensionhostdebugservice";class b extends A.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,v,p){this.channel.call("attach",[n,v,p])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,v){this.channel.call("terminate",[n,v])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,v,p){return this.channel.call("openExtensionDevelopmentHostWindow",[n,v||{},p])}}e.ExtensionHostDebugChannelClient=b}),define(J[155],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class m{constructor(I){this.driver=I}listen(I,n){throw new Error(`No event found: ${n}`)}call(I,n,v){switch(n){case"click":return this.driver.click(v[0],v[1],v[2]);case"doubleClick":return this.driver.doubleClick(v);case"setValue":return this.driver.setValue(v[0],v[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(v);case"getElements":return this.driver.getElements(v[0],v[1]);case"getElementXY":return this.driver.getElementXY(v[0],v[1],v[2]);case"typeInEditor":return this.driver.typeInEditor(v[0],v[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(v);case"writeInTerminal":return this.driver.writeInTerminal(v[0],v[1])}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=m;class A{constructor(I){this.channel=I}click(I,n,v){return this.channel.call("click",[I,n,v])}doubleClick(I){return this.channel.call("doubleClick",I)}setValue(I,n){return this.channel.call("setValue",[I,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(I){return this.channel.call("isActiveElement",I)}getElements(I,n){return this.channel.call("getElements",[I,n])}getElementXY(I,n,v){return this.channel.call("getElementXY",[I,n,v])}typeInEditor(I,n){return this.channel.call("typeInEditor",[I,n])}getTerminalBuffer(I){return this.channel.call("getTerminalBuffer",I)}writeInTerminal(I,n){return this.channel.call("writeInTerminal",[I,n])}}e.WindowDriverChannelClient=A;class R{constructor(I){this.channel=I}registerWindowDriver(I){return this.channel.call("registerWindowDriver",I)}reloadWindowDriver(I){return this.channel.call("reloadWindowDriver",I)}}e.WindowDriverRegistryChannelClient=R}),define(J[156],Z([0,1,8,15,46,125,10,7,33]),function($,e,m,A,R,b,I,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class p{constructor(d,g,D){this._args=d,this.paths=g,this.productService=D}get appRoot(){return m.dirname(I.FileAccess.asFileUri("",$).fsPath)}get userHome(){return n.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return n.URI.file(m.join(this.userDataPath,"User"))}get tmpDir(){return n.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return A.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return A.joinPath(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=b.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=m.join(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return n.URI.file(m.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return A.joinPath(n.URI.file(m.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return n.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return n.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return A.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return A.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=v.env.VSCODE_PORTABLE;return d?n.URI.file(m.join(d,"argv.json")):A.joinPath(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return A.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return n.URI.file(m.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return m.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?m.resolve(d):m.normalize(m.join(I.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?m.resolve(d):m.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return m.resolve(d);const g=v.env.VSCODE_EXTENSIONS;if(g)return g;const D=v.env.VSCODE_PORTABLE;return D?m.join(D,"extensions"):A.joinPath(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(g=>/^[^:/?#]+?:\/\//.test(g)?n.URI.parse(g):n.URI.file(m.normalize(g)))}get extensionDevelopmentKind(){var d;return(d=this.args.extensionDevelopmentKind)===null||d===void 0?void 0:d.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?n.URI.parse(d):n.URI.file(m.normalize(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!v.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return A.joinPath(n.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return n.URI.file(m.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([R.memoize],p.prototype,"appRoot",null),he([R.memoize],p.prototype,"userHome",null),he([R.memoize],p.prototype,"userDataPath",null),he([R.memoize],p.prototype,"appSettingsHome",null),he([R.memoize],p.prototype,"tmpDir",null),he([R.memoize],p.prototype,"userRoamingDataHome",null),he([R.memoize],p.prototype,"settingsResource",null),he([R.memoize],p.prototype,"userDataSyncHome",null),he([R.memoize],p.prototype,"userDataSyncLogResource",null),he([R.memoize],p.prototype,"sync",null),he([R.memoize],p.prototype,"machineSettingsResource",null),he([R.memoize],p.prototype,"globalStorageHome",null),he([R.memoize],p.prototype,"workspaceStorageHome",null),he([R.memoize],p.prototype,"keybindingsResource",null),he([R.memoize],p.prototype,"keyboardLayoutResource",null),he([R.memoize],p.prototype,"argvResource",null),he([R.memoize],p.prototype,"snippetsHome",null),he([R.memoize],p.prototype,"isExtensionDevelopment",null),he([R.memoize],p.prototype,"untitledWorkspacesHome",null),he([R.memoize],p.prototype,"installSourcePath",null),he([R.memoize],p.prototype,"builtinExtensionsPath",null),he([R.memoize],p.prototype,"extensionsPath",null),he([R.memoize],p.prototype,"extensionDevelopmentLocationURI",null),he([R.memoize],p.prototype,"extensionDevelopmentKind",null),he([R.memoize],p.prototype,"extensionTestsLocationURI",null),he([R.memoize],p.prototype,"debugExtensionHost",null),he([R.memoize],p.prototype,"serviceMachineIdResource",null),he([R.memoize],p.prototype,"telemetryLogResource",null),he([R.memoize],p.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=p;function i(y,d){return k(y["inspect-extensions"],y["inspect-brk-extensions"],5870,d,y.debugId)}e.parseExtensionHostPort=i;function E(y,d){return k(y["inspect-search"],y["inspect-brk-search"],5876,d)}e.parseSearchPort=E;function k(y,d,g,D,P){const u=Number(d||y)||(D?null:g),o=u?Boolean(!!d):!1;return{port:u,break:o,debugId:P}}}),define(J[89],Z([0,1,239,134,3]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const b={o:A.localize(0,null),e:A.localize(1,null),t:A.localize(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:A.localize(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:A.localize(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:A.localize(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:A.localize(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:A.localize(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:A.localize(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:A.localize(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:A.localize(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:A.localize(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:A.localize(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:A.localize(13,null)},"show-versions":{type:"boolean",cat:"e",description:A.localize(14,null)},category:{type:"string",cat:"e",description:A.localize(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:A.localize(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:A.localize(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:A.localize(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:A.localize(19,null)},verbose:{type:"boolean",cat:"t",description:A.localize(20,null)},log:{type:"string",cat:"t",args:"level",description:A.localize(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:A.localize(22,null)},"prof-startup":{type:"boolean",cat:"t",description:A.localize(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:A.localize(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:A.localize(25,null)},sync:{type:"string",cat:"t",description:A.localize(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:A.localize(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:A.localize(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:A.localize(29,null)},"max-memory":{type:"string",cat:"t",description:A.localize(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:A.localize(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const I={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(d,g,D=I){const P={},c=[],u=[];for(let r in g){const s=g[r];s.alias&&(P[r]=s.alias),s.type==="string"||s.type==="string[]"?(c.push(r),s.deprecates&&c.push(s.deprecates)):s.type==="boolean"&&(u.push(r),s.deprecates&&u.push(s.deprecates))}const o=m(d,{string:c,boolean:u,alias:P}),l={},t=o;l._=o._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in g){const s=g[r];s.alias&&delete t[s.alias];let a=t[r];s.deprecates&&t.hasOwnProperty(s.deprecates)&&(a||(a=t[s.deprecates]),delete t[s.deprecates]),typeof a!="undefined"&&(s.type==="string[]"?a&&!Array.isArray(a)&&(a=[a]):s.type==="string"&&Array.isArray(a)&&(a=a.pop(),D.onMultipleValues(r,a)),l[r]=a),delete t[r]}for(let r in t)D.onUnknownOption(r);return l}e.parseArgs=n;function v(d,g){let D="";return g.args&&(Array.isArray(g.args)?D=` <${g.args.join("> <")}>`:D=` <${g.args}>`),g.alias?`-${g.alias} --${d}${D}`:`--${d}${D}`}function p(d,g){let D=0,P=[];for(const l in d){const t=d[l],r=v(l,t);D=Math.max(D,r.length),P.push([r,t.description])}let c=D+2+1;if(g-c<25)return P.reduce((l,t)=>l.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let u=g-c-1,o=[];for(const l of P){let t=l[0],r=E(l[1],u),s=i(c-t.length-2);o.push("  "+t+s+r[0]);for(let a=1;a<r.length;a++)o.push(i(c)+r[a])}return o}e.formatOptions=p;function i(d){return" ".repeat(d)}function E(d,g){let D=[];for(;d.length;){let P=d.length<g?d.length:d.lastIndexOf(" ",g),c=d.slice(0,P).trim();d=d.slice(P),D.push(c)}return D}function k(d,g,D,P,c=!0){const u=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${d} ${D}`];o.push(""),o.push(`${A.localize(32,null)}: ${g} [${A.localize(33,null)}][${A.localize(34,null)}...]`),o.push(""),c&&(R.isWindows?o.push(A.localize(35,null,g)):o.push(A.localize(36,null,g)),o.push(""));const l={};for(const t in P){const r=P[t];if(r.description&&r.cat){let s=l[r.cat];s||(l[r.cat]=s={}),s[t]=r}}for(let t in l){const r=t;let s=l[r];s&&(o.push(b[r]),o.push(...p(s,u)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=k;function y(d,g){return`${d||A.localize(37,null)}
${g||A.localize(38,null)}
${process.arch}`}e.buildVersionMessage=y}),define(J[157],Z([0,1,89,59,154]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class b extends R.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,v,p){return v==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(p[0],p[1],p[2]):super.call(n,v,p)}async openExtensionDevelopmentHostWindow(n,v,p){const i=m.parseArgs(n,m.OPTIONS);i.debugRenderer=p;const E=i.extensionDevelopmentPath;if(!E)return{success:!1};let k;const y=Object.keys(v);for(let u of y){let o=v[u];o===null||(k||(k=Object.create(null)),k[u]=o)}const[d]=this.windowsMainService.openExtensionDevelopmentHostWindow(E,{context:5,cli:i,userEnv:k});if(!p)return{success:!0};const g=d.win;if(!g)return{success:!0};const D=g.webContents.debugger;let P=D.isAttached()?Infinity:0;const c=A.createServer(u=>{P++==0&&D.attach();let o=!1;const l=s=>{o||u.write(JSON.stringify(s)+"\0")},t=(s,a,h,w)=>l({method:a,params:h,sessionId:w});g.on("close",()=>{D.removeListener("message",t),u.end(),o=!0}),D.addListener("message",t);let r=Buffer.alloc(0);u.on("data",s=>{r=Buffer.concat([r,s]);for(let a=r.indexOf(0);a!==-1;a=r.indexOf(0)){let h;try{const w=r.slice(0,a).toString("utf8");r=r.slice(a+1),h=JSON.parse(w)}catch(w){console.error("error reading cdp line",w)}D.sendCommand(h.method,h.params,h.sessionId).then(w=>l({id:h.id,sessionId:h.sessionId,result:w})).catch(w=>l({id:h.id,sessionId:h.sessionId,error:{code:0,message:w.message}}))}}),u.on("error",s=>{console.error("error on cdp pipe:",s)}),u.on("close",()=>{o=!0,--P==0&&D.detach()})});return await new Promise(u=>c.listen(0,u)),g.on("close",()=>c.close()),{rendererDebugPort:c.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=b}),function(){"use strict";function $(e,m,A,R){function b(n){const v=I(n),p=[v];return e.isAbsolute(v)||p.unshift(R),e.resolve(...p)}function I(n){const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");const p=n["user-data-dir"];if(p)return p;let i=process.env.VSCODE_APPDATA;if(!i)switch(process.platform){case"win32":if(i=process.env.APPDATA,!i){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");i=e.join(E,"AppData","Roaming")}break;case"darwin":i=e.join(m.homedir(),"Library","Application Support");break;case"linux":i=process.env.XDG_CONFIG_HOME||e.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(i,A)}return{getUserDataPath:b}}if(typeof define=="function")define(J[158],Z([0,159,26,10,15,33]),function(e,m,A,R,b,I){const n=b.dirname(R.FileAccess.asFileUri("",e)),v=e.__$__nodeRequire(b.joinPath(n,"package.json").fsPath);return $(m,A,v.name,I.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),m=require("path"),A=require("os");module.exports=$(m,A,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[160],Z([0,1,26,158,156]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class b extends R.AbstractNativeEnvironmentService{constructor(n,v){super(n,{homeDir:m.homedir(),tmpDir:m.tmpdir(),userDataDir:A.getUserDataPath(n)},v)}}e.NativeEnvironmentService=b}),define(J[161],Z([0,1,31,26,8]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function b(I){const n=R.join(A.tmpdir(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return m.writeFileSync(n,""),I&&console.log(`Marker file for --wait created: ${n}`),n}catch(v){I&&console.error(`Failed to create marker file for --wait: ${v}`);return}}e.createWaitMarkerFile=b}),define(J[162],Z([0,1,137]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function b(k){return k=k.trim(),k==="*"||A.test(k)}e.isValidVersionStr=b;function I(k){if(!b(k))return null;if(k=k.trim(),k==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=k.match(A);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=I;function n(k){if(!k)return null;let y=k.majorBase,d=k.majorMustEqual,g=k.minorBase,D=k.minorMustEqual,P=k.patchBase,c=k.patchMustEqual;k.hasCaret&&(y===0||(D=!1),c=!1);let u=0;if(k.preRelease){const o=R.exec(k.preRelease);if(o){const[,l,t,r]=o;u=Date.UTC(Number(l),Number(t)-1,Number(r))}}return{majorBase:y,majorMustEqual:d,minorBase:g,minorMustEqual:D,patchBase:P,patchMustEqual:c,isMinimum:k.hasGreaterEquals,notBefore:u}}e.normalizeVersion=n;function v(k,y,d){let g;typeof k=="string"?g=n(I(k)):g=k;let D;y instanceof Date?D=y.getTime():typeof y=="string"&&(D=new Date(y).getTime());let P;if(typeof d=="string"?P=n(I(d)):P=d,!g||!P)return!1;let c=g.majorBase,u=g.minorBase,o=g.patchBase,l=P.majorBase,t=P.minorBase,r=P.patchBase,s=P.notBefore,a=P.majorMustEqual,h=P.minorMustEqual,w=P.patchMustEqual;return P.isMinimum?c>l?!0:c<l?!1:u>t?!0:u<t||D&&D<s?!1:o>=r:(c===1&&l===0&&(!a||!h||!w)&&(l=1,t=0,r=0,a=!0,h=!1,w=!1),c<l?!1:c>l?!a:u<t?!1:u>t?!h:o<r?!1:o>r?!w:!(D&&D<s))}e.isValidVersion=v;function p(k,y,d,g){return d.isBuiltin||typeof d.main=="undefined"?!0:E(k,y,d.engines.vscode,g)}e.isValidExtensionVersion=p;function i(k,y,d){return k==="*"||E(y,d,k)}e.isEngineValid=i;function E(k,y,d,g=[]){let D=n(I(d));if(!D)return g.push(m.localize(0,null,d)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return g.push(m.localize(1,null,d)),!1}else if(!D.majorMustEqual)return g.push(m.localize(2,null,d)),!1;return v(k,y,D)?!0:(g.push(m.localize(3,null,k,d)),!1)}}),define(J[163],Z([0,1,34,88,2,10]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends R.Disposable{constructor(v,p,i,E){super();this.folders=v,this.onDidFilesChange=p,this.onLogMessage=i,this.verboseLogging=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const v=this._register(new A.Client(b.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(v.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=I.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService(m.getNextTickChannel(v.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(p=>!this.isDisposed&&this.onDidFilesChange(p))),this._register(this.service.onDidLogMessage(p=>this.onLogMessage(p))),this.setFolders(this.folders)}setVerboseLogging(v){this.verboseLogging=v,!this.isDisposed&&this.service&&this.service.setVerboseLogging(v)}error(v){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${v}`})}setFolders(v){this.folders=v,this.service&&this.service.setRoots(v)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I,I.MAX_RESTARTS=5}),define(J[164],Z([0,1,34,88,2,10]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends R.Disposable{constructor(v,p,i,E,k={}){super();this.folders=v,this.onDidFilesChange=p,this.onLogMessage=i,this.verboseLogging=E,this.watcherOptions=k,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const v=this._register(new A.Client(b.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(v.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=I.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService(m.getNextTickChannel(v.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(p=>!this.isDisposed&&this.onDidFilesChange(p))),this._register(this.service.onDidLogMessage(p=>this.onLogMessage(p))),this.service.setRoots(this.folders)}error(v){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${v}`})}setVerboseLogging(v){this.verboseLogging=v,this.service&&this.service.setVerboseLogging(v)}setFolders(v){this.folders=v,this.service&&this.service.setRoots(v)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I,I.MAX_RESTARTS=5}),define(J[165],Z([0,1,41,82,111,10]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class I{constructor(v,p,i,E,k){this.watchedFolder=v,this.eventCallback=i,this.logCallback=E,this.verboseLogging=k,this.restartCounter=0,Array.isArray(p)?this.ignored=p.map(y=>R.parse(y)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${v}`),this.startWatcher()}startWatcher(){const v=[this.watchedFolder];this.verboseLogging&&v.push("-verbose"),this.handle=m.spawn(b.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,v);const p=new A.LineDecoder;this.handle.stdout.on("data",i=>{const E=[];p.write(i).forEach(k=>{const y=k.split("|");if(y.length===2){const d=Number(y[0]),g=y[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(D=>D(g))){this.verboseLogging&&this.log(g);return}E.push({type:I.changeTypeMap[d],path:g})}else this.log(y[1])}}),E.length>0&&this.eventCallback(E)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,E)=>this.onExit(i,E))}onError(v){this.error("process error: "+v.toString())}onExit(v,p){this.handle&&(this.error(`terminated unexpectedly (code: ${v}, signal: ${p})`),this.restartCounter<=I.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(v){this.logCallback({type:"error",message:`[File Watcher (C#)] ${v}`})}log(v){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${v}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=I,I.MAX_RESTARTS=5,I.changeTypeMap=[0,1,2]}),define(J[166],Z([0,1,165,8,23]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b{constructor(n,v,p,i){this.onDidFilesChange=v,this.onLogMessage=p,this.verboseLogging=i,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(A.posix.sep)&&(this.folder.path=R.rtrim(this.folder.path,A.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new m.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=b}),define(J[69],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class m{constructor(b,I=[],n=!1){this.ctor=b,this.staticArguments=I,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=m;const A=(R,...b)=>new m(R,b);e.createSyncDescriptor=A}),define(J[167],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(b){this.incoming=new Map,this.outgoing=new Map,this.data=b}}e.Node=m;class A{constructor(b){this._hashFn=b,this._nodes=new Map}roots(){const b=[];for(let I of this._nodes.values())I.outgoing.size===0&&b.push(I);return b}insertEdge(b,I){const n=this.lookupOrInsertNode(b),v=this.lookupOrInsertNode(I);n.outgoing.set(this._hashFn(I),v),v.incoming.set(this._hashFn(b),n)}removeNode(b){const I=this._hashFn(b);this._nodes.delete(I);for(let n of this._nodes.values())n.outgoing.delete(I),n.incoming.delete(I)}lookupOrInsertNode(b){const I=this._hashFn(b);let n=this._nodes.get(I);return n||(n=new m(b),this._nodes.set(I,n)),n}lookup(b){return this._nodes.get(this._hashFn(b))}isEmpty(){return this._nodes.size===0}toString(){let b=[];for(let[I,n]of this._nodes)b.push(`${I}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return b.join(`
`)}findCycleSlow(){for(let[b,I]of this._nodes){const n=new Set([b]),v=this._findCycle(I,n);if(v)return v}}_findCycle(b,I){for(let[n,v]of b.outgoing){if(I.has(n))return[...I,n].join(" -> ");I.add(n);const p=this._findCycle(v,I);if(p)return p;I.delete(n)}}}e.Graph=A}),define(J[4],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function v(p){return p[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=v})(m=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function A(n,v,p,i){v[m.DI_TARGET]===v?v[m.DI_DEPENDENCIES].push({id:n,index:p,optional:i}):(v[m.DI_DEPENDENCIES]=[{id:n,index:p,optional:i}],v[m.DI_TARGET]=v)}function R(n){if(m.serviceIds.has(n))return m.serviceIds.get(n);const v=function(p,i,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(v,p,E,!1)};return v.toString=()=>n,m.serviceIds.set(n,v),v}e.createDecorator=R;function b(n){return n}e.refineServiceDecorator=b;function I(n){return function(v,p,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");A(n,v,i,!0)}}e.optional=I}),define(J[70],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=m.createDecorator(e.ID);function A(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=A}),define(J[90],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=m.createDecorator("encryptionMainService");class A{constructor(b){this.machineId=b}encryption(){return new Promise((b,I)=>$(["vscode-encrypt"],b,I))}async encrypt(b){try{return(await this.encryption()).encrypt(this.machineId,b)}catch(I){return b}}async decrypt(b){try{return(await this.encryption()).decrypt(this.machineId,b)}catch(I){return b}}}e.EncryptionMainService=A}),define(J[47],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=m.createDecorator("environmentService"),e.INativeEnvironmentService=m.refineServiceDecorator(e.IEnvironmentService)}),define(J[168],Z([0,1,136,4,10]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function b(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=b;var I;(function(E){E[E.NoneOrRelevance=0]="NoneOrRelevance",E[E.LastUpdatedDate=1]="LastUpdatedDate",E[E.Title=2]="Title",E[E.PublisherName=3]="PublisherName",E[E.InstallCount=4]="InstallCount",E[E.PublishedDate=5]="PublishedDate",E[E.AverageRating=6]="AverageRating",E[E.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var n;(function(E){E[E.Default=0]="Default",E[E.Ascending=1]="Ascending",E[E.Descending=2]="Descending"})(n=e.SortOrder||(e.SortOrder={}));var v;(function(E){E.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var p;(function(E){E[E.None=0]="None",E[E.Install=1]="Install",E[E.Update=2]="Update"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=A.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(k,y){super(k);this.code=y}}e.ExtensionManagementError=i,e.IExtensionManagementService=A.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=A.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=A.createDecorator("IExtensionTipsService"),e.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),e.ExtensionsLabel=m.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=m.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=A.createDecorator("IExtensionManagementCLIService")}),define(J[169],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=m.createDecorator("extensionUrlTrustService")}),define(J[170],Z([0,1,23,4]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function R(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkpaceSupportTypeMessage=R;function b(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=b,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class n{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,k){if(typeof E=="undefined"||E===null)return typeof k=="undefined"||k===null;if(typeof k=="undefined"||k===null)return!1;if(typeof E=="string"||typeof k=="string"){let y=typeof E=="string"?E:E.value,d=typeof k=="string"?k:k.value;return m.equalsIgnoreCase(y,d)}return E._lower===k._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=n;function v(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function p(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=p,e.IBuiltinExtensionsScannerService=A.createDecorator("IBuiltinExtensionsScannerService")}),define(J[171],Z([0,1,23,170]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(y,d){return y.uuid&&d.uuid?y.uuid===d.uuid:y.id===d.id?!0:m.compareIgnoreCase(y.id,d.id)===0}e.areSameExtensions=R;class b{constructor(d,g){this.version=g,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof b?R(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=b;function I(y,d){return`${y}.${d}`}e.getExtensionId=I;function n(y){return y.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function v(y,d){return n(I(y,d))}e.getGalleryExtensionId=v;function p(y,d){const g=[],D=P=>{for(const c of g)if(c.some(u=>R(d(u),d(P))))return c;return null};for(const P of y){const c=D(P);c?c.push(P):g.push([P])}return g}e.groupByExtension=p;function i(y){return{id:y.identifier.id,name:y.manifest.name,galleryId:null,publisherId:y.publisherId,publisherName:y.manifest.publisher,publisherDisplayName:y.publisherDisplayName,dependencies:y.manifest.extensionDependencies&&y.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function E(y){return Object.assign({id:y.identifier.id,name:y.name,galleryId:y.identifier.uuid,publisherId:y.publisherId,publisherName:y.publisher,publisherDisplayName:y.publisherDisplayName,dependencies:!!(y.properties.dependencies&&y.properties.dependencies.length>0)},y.telemetryData)}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function k(y){const d=new Set;for(const g of y)g.malicious&&d.add(g.id.id);return d}e.getMaliciousExtensionsSet=k}),define(J[91],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=m.createDecorator("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=m.createDecorator("externalTerminal")}),define(J[172],Z([0,1,41,8,68,138,18,3,91,10,105]),function($,e,m,A,R,b,I,n,v,p,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const E=b.localize(0,null);class k{async getDefaultTerminalForPlatforms(){const o=await g.getDefaultTerminalLinuxReady();return{windows:y.getDefaultTerminalWindows(),linux:o,osx:"xterm"}}}class y extends k{openTerminal(o,l){return this.spawnTerminal(m,o,R.getWindowsShell(),l)}spawnTerminal(o,l,t,r){const s=l.windowsExec||y.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const a=A.basename(s).toLowerCase();if(a==="cmder"||a==="cmder.exe")return o.spawn(s,r?[r]:void 0),Promise.resolve(void 0);const h=["/c","start","/wait"];return s.indexOf(" ")>=0&&h.push('""'),h.push(s),(a==="wt"||a==="wt.exe")&&h.push("-d ."),new Promise((w,f)=>{const S=D(process),L=o.spawn(t,h,{cwd:r,env:S});L.on("error",f),L.on("exit",()=>w())})}runInTerminal(o,l,t,r,s){const a="windowsExec"in s&&s.windowsExec?s.windowsExec:y.getDefaultTerminalWindows();return new Promise((h,w)=>{const f=`"${l} - ${E}"`,S=`""${t.join('" "')}" & pause"`,L=["/c","start",f,"/wait",a,"/c",S],_=Object.assign({},D(process),r);Object.keys(_).filter(te=>_[te]===null).forEach(te=>delete _[te]);const H={cwd:l,env:_,windowsVerbatimArguments:!0};m.spawn(y.CMD,L,H).on("error",te=>{w(P(te))}),h(void 0)})}static getDefaultTerminalWindows(){if(!y._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return y._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=y,y.CMD="cmd.exe";class d extends k{openTerminal(o,l){return this.spawnTerminal(m,o,l)}runInTerminal(o,l,t,r,s){const a=s.osxExec||v.DEFAULT_TERMINAL_OSX;return new Promise((h,w)=>{if(a===v.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const f=a===v.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",L=[p.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${f}.scpt`,$).fsPath,"-t",o||E,"-w",l];for(let Q of t)L.push("-a"),L.push(Q);if(r)for(let Q in r){const te=r[Q];te===null?(L.push("-u"),L.push(Q)):(L.push("-e"),L.push(`${Q}=${te}`))}let _="";const H=m.spawn(d.OSASCRIPT,L);H.on("error",Q=>{w(P(Q))}),H.stderr.on("data",Q=>{_+=Q.toString()}),H.on("exit",Q=>{if(Q===0)h(void 0);else if(_){const te=_.split(`
`,1);w(new Error(te[0]))}else w(new Error(b.localize(1,null,f,Q)))})}else w(new Error(b.localize(2,null,a)))})}spawnTerminal(o,l,t){const r=l.osxExec||v.DEFAULT_TERMINAL_OSX;return new Promise((s,a)=>{const h=["-a",r];t&&h.push(t);const w=o.spawn("/usr/bin/open",h);w.on("error",a),w.on("exit",()=>s())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class g extends k{openTerminal(o,l){return this.spawnTerminal(m,o,l)}runInTerminal(o,l,t,r,s){const a=s.linuxExec?Promise.resolve(s.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((h,w)=>{let f=[];a.then(S=>{S.indexOf("gnome-terminal")>=0?f.push("-x"):f.push("-e"),f.push("bash"),f.push("-c");const L=`${c(t)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;f.push(`''${L}''`);const _=Object.assign({},process.env,r);Object.keys(_).filter(B=>_[B]===null).forEach(B=>delete _[B]);const H={cwd:l,env:_};let Q="";const te=m.spawn(S,f,H);te.on("error",B=>{w(P(B))}),te.stderr.on("data",B=>{Q+=B.toString()}),te.on("exit",B=>{if(B===0)h(void 0);else if(Q){const Y=Q.split(`
`,1);w(new Error(Y[0]))}else w(new Error(b.localize(4,null,S,B)))})})})}static async getDefaultTerminalLinuxReady(){return g._DEFAULT_TERMINAL_LINUX_READY||(g._DEFAULT_TERMINAL_LINUX_READY=new Promise(async o=>{n.isLinux?await I.Promises.exists("/etc/debian_version")?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm"):o("xterm")})),g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,l,t){const r=l.linuxExec?Promise.resolve(l.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{r.then(h=>{const w=D(process),f=o.spawn(h,[],{cwd:t,env:w});f.on("error",a),f.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=b.localize(3,null);function D(u){const o=u.env;return i.sanitizeProcessEnvironment(o),o}function P(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(b.localize(5,null,u.path)):u}function c(u){let o="";for(let l of u)l.indexOf(" ")>=0?o+='"'+l+'"':o+=l,o+=" ";return o}}),define(J[19],Z([0,1,140,8,7,4,23,13,37]),function($,e,m,A,R,b,I,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=b.createDecorator("fileService");function p(C){return C.create===!0}e.isFileOpenForWriteOptions=p;var i;(function(C){C[C.Unknown=0]="Unknown",C[C.File=1]="File",C[C.Directory=2]="Directory",C[C.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var E;(function(C){C[C.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var k;(function(C){C[C.FileReadWrite=2]="FileReadWrite",C[C.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",C[C.FileReadStream=16]="FileReadStream",C[C.FileFolderCopy=8]="FileFolderCopy",C[C.PathCaseSensitive=1024]="PathCaseSensitive",C[C.Readonly=2048]="Readonly",C[C.Trash=4096]="Trash",C[C.FileWriteUnlock=8192]="FileWriteUnlock"})(k=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(C){return!!(C.capabilities&2)}e.hasReadWriteCapability=y;function d(C){return!!(C.capabilities&8)}e.hasFileFolderCopyCapability=d;function g(C){return!!(C.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function D(C){return!!(C.capabilities&16)}e.hasFileReadStreamCapability=D;var P;(function(C){C.FileExists="EntryExists",C.FileNotFound="EntryNotFound",C.FileNotADirectory="EntryNotADirectory",C.FileIsADirectory="EntryIsADirectory",C.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",C.FileTooLarge="EntryTooLarge",C.FileWriteLocked="EntryWriteLocked",C.NoPermissions="NoPermissions",C.Unavailable="Unavailable",C.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(z,X){super(z);this.code=X}}e.FileSystemProviderError=c;function u(C,z){const X=new c(C.toString(),z);return l(X,z),X}e.createFileSystemProviderError=u;function o(C){return C||u(m.localize(0,null),P.Unknown)}e.ensureFileSystemProviderError=o;function l(C,z){return C.name=z?`${z} (FileSystemError)`:"FileSystemError",C}e.markAsFileSystemProviderError=l;function t(C){if(!C)return P.Unknown;if(C instanceof c)return C.code;const z=/^(.+) \(FileSystemError\)$/.exec(C.name);if(!z)return P.Unknown;switch(z[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=t;function r(C){if(C instanceof S)return C.fileOperationResult;switch(t(C)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(C){C[C.CREATE=0]="CREATE",C[C.DELETE=1]="DELETE",C[C.MOVE=2]="MOVE",C[C.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class a{constructor(z,X,N){this.resource=z,this.operation=X,this.target=N}isOperation(z){return this.operation===z}}e.FileOperationEvent=a;var h;(function(C){C[C.UPDATED=0]="UPDATED",C[C.ADDED=1]="ADDED",C[C.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class w{constructor(z,X){this.changes=z,this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const N of z)switch(N.type){case 1:this.added||(this.added=v.TernarySearchTree.forUris(()=>X)),this.added.set(N.resource,N);break;case 0:this.updated||(this.updated=v.TernarySearchTree.forUris(()=>X)),this.updated.set(N.resource,N);break;case 2:this.deleted||(this.deleted=v.TernarySearchTree.forUris(()=>X)),this.deleted.set(N.resource,N);break}}contains(z,...X){return this.doContains(z,{includeChildren:!1},...X)}affects(z,...X){return this.doContains(z,{includeChildren:!0},...X)}doContains(z,X,...N){var F,T,O,M,W,U;if(!z)return!1;const V=N.length>0;return!!((!V||N.includes(1))&&(((F=this.added)===null||F===void 0?void 0:F.get(z))||X.includeChildren&&((T=this.added)===null||T===void 0?void 0:T.findSuperstr(z)))||(!V||N.includes(0))&&(((O=this.updated)===null||O===void 0?void 0:O.get(z))||X.includeChildren&&((M=this.updated)===null||M===void 0?void 0:M.findSuperstr(z)))||(!V||N.includes(2))&&(((W=this.deleted)===null||W===void 0?void 0:W.findSubstr(z))||X.includeChildren&&((U=this.deleted)===null||U===void 0?void 0:U.findSuperstr(z))))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get raw(){return this.changes}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=w;function f(C,z,X){return!C||!z||C===z||z.length>C.length?!1:(z.charAt(z.length-1)!==A.sep&&(z+=A.sep),X?I.startsWithIgnoreCase(C,z):C.indexOf(z)===0)}e.isParent=f;class S extends Error{constructor(z,X,N){super(z);this.fileOperationResult=X,this.options=N}}e.FileOperationError=S;class L extends S{constructor(z,X,N){super(z,2,N);this.stat=X}}e.NotModifiedSinceFileOperationError=L;var _;(function(C){C[C.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",C[C.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",C[C.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",C[C.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",C[C.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",C[C.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",C[C.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",C[C.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",C[C.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",C[C.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",C[C.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",C[C.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var H;(function(C){C[C.FILE=0]="FILE",C[C.FOLDER=1]="FOLDER",C[C.ROOT_FOLDER=2]="ROOT_FOLDER"})(H=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function Q(C){if(!(typeof C.size!="number"||typeof C.mtime!="number"))return C.mtime.toString(29)+C.size.toString(31)}e.etag=Q;async function te(C,z){if(!z.canHandleResource(R.URI.from({scheme:C.scheme})))return new Promise(X=>{const N=z.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===C.scheme&&F.added&&(N.dispose(),X())})})}e.whenProviderRegistered=te,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(z){return n.isNumber(z)||(z=0),z<B.KB?m.localize(1,null,z.toFixed(0)):z<B.MB?m.localize(2,null,(z/B.KB).toFixed(2)):z<B.GB?m.localize(3,null,(z/B.MB).toFixed(2)):z<B.TB?m.localize(4,null,(z/B.GB).toFixed(2)):m.localize(5,null,(z/B.TB).toFixed(2))}}e.ByteSize=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;var Y;(function(C){C[C.IA32=0]="IA32",C[C.OTHER=1]="OTHER"})(Y=e.Arch||(e.Arch={}));function G(C){return{maxFileSize:C===0?300*B.MB:16*B.GB,maxHeapSize:C===0?700*B.MB:2*700*B.MB}}e.getPlatformLimits=G}),define(J[54],Z([0,1,240,135,19,89]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function I(k,y){const d={onUnknownOption:D=>{console.warn(A.localize(0,null,D))},onMultipleValues:(D,P)=>{console.warn(A.localize(1,null,D,P))}},g=b.parseArgs(k,b.OPTIONS,y?d:void 0);return g.goto&&g._.forEach(D=>m(/^(\w:)?[^:]+(:\d*){0,2}$/.test(D),A.localize(2,null))),g["max-memory"]&&m(parseInt(g["max-memory"])>=R.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${R.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function n(k){const y=k.findIndex(d=>!/^-/.test(d));if(y>-1)return[...k.slice(0,y),...k.slice(y+1)]}function v(k){let[,...y]=k;process.env.VSCODE_DEV&&(y=n(y)||[]);const d=!E(process.env);return I(y,d)}e.parseMainProcessArgv=v;function p(k){const[,,...y]=k;return I(y,!0)}e.parseCLIProcessArgv=p;function i(k,...y){const d=k.indexOf("--");return d===-1?k.push(...y):k.splice(d,0,...y),k}e.addArg=i;function E(k){return k.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),define(J[92],Z([0,1,159,41,27,3,54,67,130,25,16]),function($,e,m,A,R,b,I,n,v,p,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function E(d,g,D){return g["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):I.isLaunchedFromCli(D)&&!g["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):(I.isLaunchedFromCli(D)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),k||(k=new Promise(async P=>{const c=new p.CancellationTokenSource,u=setTimeout(()=>{d.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),c.dispose(!0),P({})},1e4);try{const o=await y(d,c.token);P(o)}catch(o){i.isPromiseCanceledError(o)||d.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),P({})}finally{clearTimeout(u),c.dispose()}})),k)}e.resolveShellEnv=E;let k;async function y(d,g){const D=new Promise(async(P,c)=>{const u=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",u);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",o);const l=R.generateUuid().replace(/-/g,"").substr(0,12),t=new RegExp(l+"(.*)"+l),r=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});d.trace("getUnixShellEnvironment#env",r);const s=await v.getSystemShell(b.OS,r);if(d.trace("getUnixShellEnvironment#shell",s),g.isCancellationRequested)return c(i.canceled);const a=m.basename(s);let h,w;/^pwsh(-preview)?$/.test(a)?(h=`& '${process.execPath}' -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,w=["-Login","-Command"]):(h=`'${process.execPath}' -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,w=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(w),h);const f=A.spawn(s,[...w,h],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});g.onCancellationRequested(()=>(f.kill(),c(i.canceled))),f.on("error",_=>{d.error("getUnixShellEnvironment#errorChildProcess",n.toErrorMessage(_)),P({})});const S=[];f.stdout.on("data",_=>S.push(_));const L=[];f.stderr.on("data",_=>L.push(_)),f.on("close",(_,H)=>{const Q=Buffer.concat(S).toString("utf8");d.trace("getUnixShellEnvironment#raw",Q);const te=Buffer.concat(L).toString("utf8");if(te.trim()&&d.trace("getUnixShellEnvironment#stderr",te),_||H)return c(new Error(`Failed to get environment (code ${_}, signal ${H})`));const B=t.exec(Q),Y=B?B[1]:"{}";try{const G=JSON.parse(Y);u?G.ELECTRON_RUN_AS_NODE=u:delete G.ELECTRON_RUN_AS_NODE,o?G.ELECTRON_NO_ATTACH_CONSOLE=o:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",G),P(G)}catch(G){d.error("getUnixShellEnvironment#errorCaught",n.toErrorMessage(G)),c(G)}})});try{return await D}catch(P){return d.error("getUnixShellEnvironment#error",n.toErrorMessage(P)),{}}}}),define(J[93],Z([0,1,7,19,3]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function b(v){return v.map(p=>({type:p.type,resource:m.URI.file(p.path)}))}e.toFileChanges=b;function I(v){const p=new n;for(const i of v)p.processEvent(i);return p.normalize()}e.normalizeFileChanges=I;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(p){const i=this.mapPathToChange.get(p.path);if(i){const E=i.type,k=p.type;E===1&&k===2?(this.mapPathToChange.delete(p.path),this.normalized.splice(this.normalized.indexOf(i),1)):E===2&&k===1?i.type=0:E===1&&k===0||(i.type=k)}else this.normalized.push(p),this.mapPathToChange.set(p.path,p)}normalize(){const p=[],i=[];return this.normalized.filter(E=>E.type!==2?(p.push(E),!1):!0).sort((E,k)=>E.path.length-k.path.length).filter(E=>i.some(k=>A.isParent(E.path,k,!R.isLinux))?!1:(i.push(E.path),!0)).concat(p)}}}),define(J[173],Z([0,1,93,2,18,83,117,9,8]),function($,e,m,A,R,b,I,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class p extends A.Disposable{constructor(E,k,y,d){super();this.path=E,this.onDidFilesChange=k,this.onLogMessage=y,this.verboseLogging=d,this.fileChangesDelayer=this._register(new n.ThrottledDelayer(I.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(E){this.verboseLogging=E}async startWatching(){try{const{stat:E,symbolicLink:k}=await R.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let y=this.path;if(k)try{y=await b.realpath(y)}catch(d){if(this.onError(d),k.dangling)return}E.isDirectory()?this._register(I.watchFolder(y,(d,g)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:v.join(this.path,v.basename(g))})},d=>this.onError(d))):this._register(I.watchFile(y,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(E){E.code!=="ENOENT"&&this.onError(E)}}onFileChange(E){this.fileChangesBuffer.push(E),this.verboseLogging&&this.onVerbose(`${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`),this.fileChangesDelayer.trigger(async()=>{const k=this.fileChangesBuffer;this.fileChangesBuffer=[];const y=m.normalizeFileChanges(k);this.verboseLogging&&y.forEach(d=>{this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`)}),y.length>0&&this.onDidFilesChange(y)})}onError(E){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${E}`})}onVerbose(E){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${E}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=p}),define(J[71],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...R){this._entries=new Map;for(let[b,I]of R)this.set(b,I)}set(R,b){const I=this._entries.get(R);return this._entries.set(R,b),I}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=m}),define(J[174],Z([0,1,16,167,69,4,71,9]),function($,e,m,A,R,b,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const v=!1;class p extends Error{constructor(d){var g;super("cyclic dependency between services");this.message=(g=d.findCycleSlow())!==null&&g!==void 0?g:`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class i{constructor(d=new I.ServiceCollection,g=!1,D){this._activeInstantiations=new Set,this._services=d,this._strict=g,this._parent=D,this._services.set(b.IInstantiationService,this)}createChild(d){return new i(d,this._strict,this)}invokeFunction(d,...g){let D=k.traceInvocation(d),P=!1;try{return d({get:(u,o)=>{if(P)throw m.illegalState("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(u,D);if(!l&&o!==b.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return l}},...g)}finally{P=!0,D.stop()}}createInstance(d,...g){let D,P;return d instanceof R.SyncDescriptor?(D=k.traceCreation(d.ctor),P=this._createInstance(d.ctor,d.staticArguments.concat(g),D)):(D=k.traceCreation(d),P=this._createInstance(d,g,D)),D.stop(),P}_createInstance(d,g=[],D){let P=b._util.getServiceDependencies(d).sort((o,l)=>o.index-l.index),c=[];for(const o of P){let l=this._getOrCreateServiceInstance(o.id,D);if(!l&&this._strict&&!o.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${o.id}.`);c.push(l)}let u=P.length>0?P[0].index:g.length;if(g.length!==u){console.warn(`[createInstance] First service dependency of ${d.name} at position ${u+1} conflicts with ${g.length} static arguments`);let o=u-g.length;o>0?g=g.concat(new Array(o)):g=g.slice(0,u)}return new d(...[...g,...c])}_setServiceInstance(d,g){if(this._services.get(d)instanceof R.SyncDescriptor)this._services.set(d,g);else if(this._parent)this._parent._setServiceInstance(d,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let g=this._services.get(d);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):g}_getOrCreateServiceInstance(d,g){let D=this._getServiceInstanceOrDescriptor(d);return D instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,D,g.branch(d,!0)):(g.branch(d,!1),D)}_safeCreateAndCacheServiceInstance(d,g,D){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,g,D)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,g,D){const P=new A.Graph(o=>o.id.toString());let c=0;const u=[{id:d,desc:g,_trace:D}];for(;u.length;){const o=u.pop();if(P.lookupOrInsertNode(o),c++>1e3)throw new p(P);for(let l of b._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(l.id);if(!t&&!l.optional&&console.warn(`[createInstance] ${d} depends on ${l.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const r={id:l.id,desc:t,_trace:o._trace.branch(l.id,!0)};P.insertEdge(o,r),u.push(r)}}}for(;;){const o=P.roots();if(o.length===0){if(!P.isEmpty())throw new p(P);break}for(const{data:l}of o){if(this._getServiceInstanceOrDescriptor(l.id)instanceof R.SyncDescriptor){const r=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,r)}P.removeNode(l)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,g,D=[],P,c){if(this._services.get(d)instanceof R.SyncDescriptor)return this._createServiceInstance(g,D,P,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,g,D,P,c);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(d,g=[],D,P){if(D){const c=new n.IdleValue(()=>this._createInstance(d,g,P));return new Proxy(Object.create(null),{get(u,o){if(o in u)return u[o];let l=c.value,t=l[o];return typeof t!="function"||(t=t.bind(l),u[o]=t),t},set(u,o,l){return c.value[o]=l,!0}})}else return this._createInstance(d,g,P)}}e.InstantiationService=i;var E;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(E||(E={}));class k{constructor(d,g){this.type=d,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return v?new k(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):k._None}static traceCreation(d){return v?new k(0,d.name):k._None}branch(d,g){let D=new k(2,d.toString());return this._dep.push([d,g,D]),D}stop(){let d=Date.now()-this._start;k._totals+=d;let g=!1;function D(c,u){let o=[],l=new Array(c+1).join("	");for(const[t,r,s]of u._dep)if(r&&s){g=!0,o.push(`${l}CREATES -> ${t}`);let a=D(c+1,s);a&&o.push(a)}else o.push(`${l}uses -> ${t}`);return o.join(`
`)}let P=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${k._totals.toFixed(2)}ms)`];(d>2||g)&&console.log(P.join(`
`))}}k._None=new class extends k{constructor(){super(-1,null)}stop(){}branch(){return this}},k._totals=0}),define(J[175],Z([0,1,16,128,57]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class b extends R.ResolvedKeybinding{constructor(n,v){super();if(v.length===0)throw m.illegalArgument("parts");this._os=n,this._parts=v}getLabel(){return A.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return A.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:A.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return A.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new R.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=b}),define(J[176],Z([0,1,57,175]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class R extends A.BaseResolvedKeybinding{constructor(I,n){super(n,I.parts)}_keyCodeToUILabel(I){if(this._os===2)switch(I){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return m.KeyCodeUtils.toString(I)}_getLabel(I){return I.isDuplicateModifierCase()?"":this._keyCodeToUILabel(I.keyCode)}_getAriaLabel(I){return I.isDuplicateModifierCase()?"":m.KeyCodeUtils.toString(I.keyCode)}_keyCodeToElectronAccelerator(I){if(I>=93&&I<=108)return null;switch(I){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return m.KeyCodeUtils.toString(I)}_getElectronAccelerator(I){return I.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(I.keyCode)}_getUserSettingsLabel(I){if(I.isDuplicateModifierCase())return"";const n=m.KeyCodeUtils.toUserSettingsUS(I.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(I){return R.getDispatchStr(I)}static getDispatchStr(I){if(I.isModifierKey())return null;let n="";return I.ctrlKey&&(n+="ctrl+"),I.shiftKey&&(n+="shift+"),I.altKey&&(n+="alt+"),I.metaKey&&(n+="meta+"),n+=m.KeyCodeUtils.toString(I.keyCode),n}_getSingleModifierDispatchPart(I){return I.keyCode===5&&!I.shiftKey&&!I.altKey&&!I.metaKey?"ctrl":I.keyCode===4&&!I.ctrlKey&&!I.altKey&&!I.metaKey?"shift":I.keyCode===6&&!I.ctrlKey&&!I.shiftKey&&!I.metaKey?"alt":I.keyCode===57&&!I.ctrlKey&&!I.shiftKey&&!I.altKey?"meta":null}}e.USLayoutResolvedKeybinding=R}),define(J[177],Z([0,1,9]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function A(R,b){if(R.length===0)return Promise.resolve(!1);const I=[];let n=!1;for(let v of R){if(v===!0)return Promise.resolve(!0);m.isThenable(v)&&I.push(v.then(p=>{p&&(n=!0)},p=>{b(p),n=!0}))}return m.Promises.settled(I).then(()=>n)}e.handleVetos=A}),define(J[6],Z([0,1,4,2,3,5,67]),function($,e,m,A,R,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=m.createDecorator("logService"),e.ILoggerService=m.createDecorator("loggerService");function n(){return new Date().toISOString()}var v;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;class p extends A.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new b.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=p;class i extends p{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(v.Trace)&&this.log(v.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(v.Debug)&&this.log(v.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(v.Info)&&this.log(v.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(v.Warning)&&this.log(v.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(v.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(v.Error,this.format(s))}else this.log(v.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(v.Critical)&&this.log(v.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let s=0;s<t.length;s++){let a=t[s];if(typeof a=="object")try{a=JSON.stringify(a)}catch(h){}r+=(s>0?" ":"")+a}return r}}e.AbstractMessageLogger=i;class E extends p{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!R.isWindows}trace(t,...r){this.getLevel()<=v.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}debug(t,...r){this.getLevel()<=v.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}info(t,...r){this.getLevel()<=v.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}warn(t,...r){this.getLevel()<=v.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,t,...r):console.warn(`[main ${n()}]`,t,...r))}error(t,...r){this.getLevel()<=v.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,t,...r):console.error(`[main ${n()}]`,t,...r))}critical(t,...r){this.getLevel()<=v.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,t,...r):console.error(`[main ${n()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class k extends p{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=v.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=v.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=v.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=v.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=v.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=v.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=k;class y extends p{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=v.Trace&&this.adapter.log(v.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=v.Debug&&this.adapter.log(v.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=v.Info&&this.adapter.log(v.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=v.Warning&&this.adapter.log(v.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=v.Error&&this.adapter.log(v.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=v.Critical&&this.adapter.log(v.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:I.toErrorMessage(t,this.getLevel()<=v.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class d extends p{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const s of this.logServices)s.trace(t,...r)}debug(t,...r){for(const s of this.logServices)s.debug(t,...r)}info(t,...r){for(const s of this.logServices)s.info(t,...r)}warn(t,...r){for(const s of this.logServices)s.warn(t,...r)}error(t,...r){for(const s of this.logServices)s.error(t,...r)}critical(t,...r){for(const s of this.logServices)s.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class g extends A.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=g;class D extends A.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(s))}))}createLogger(t,r){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(r==null?void 0:r.always)?v.Trace:this.logLevel,r),this.loggers.set(t.toString(),s),(r==null?void 0:r.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class P{constructor(){this.onDidChangeLogLevel=new b.Emitter().event}setLevel(t){}getLevel(){return v.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=P;function c(l){if(l.verbose)return v.Trace;if(typeof l.logLevel=="string"){const t=u(l.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function u(l){switch(l){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Critical;case"off":return v.Off}}e.parseLogLevel=u;function o(l){switch(l){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Critical:return"critical";case v.Off:return"off"}}e.LogLevelToString=o});var ee=this&&this.__param||function($,e){return function(m,A){e(m,A,$)}};define(J[178],Z([0,1,9,17,40,78,47,19,4,6]),function($,e,m,A,R,b,I,n,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var i;(function(k){k.ERROR_INVALID_FILE="ERROR_INVALID_FILE",k.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(i=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=v.createDecorator(e.UserConfigurationFileServiceId);let E=class{constructor(y,d,g){this.environmentService=y,this.fileService=d,this.logService=g,this.queue=new m.Queue}async updateSettings(y,d){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,y,d))}async doWrite(y,d,g){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,y.toString(),d);const{value:D,mtime:P,etag:c}=await this.fileService.readFile(y,{atomic:!0});let u=D.toString();const o=[];if(R.parse(u,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length)throw new Error("ERROR_INVALID_FILE");const l=this.getEdits(d,u,g)[0];if(l){u=u.substring(0,l.offset)+l.content+u.substring(l.offset+l.length);try{await this.fileService.writeFile(y,A.VSBuffer.fromString(u),{etag:c,mtime:P})}catch(t){if(t.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:y,path:d},g,D){return d.length?b.setProperty(g,d,y,D):[{content:JSON.stringify(y,null,D.insertSpaces&&D.tabSize?" ".repeat(D.tabSize):"	"),length:g.length,offset:0}]}};E=he([ee(0,I.IEnvironmentService),ee(1,n.IFileService),ee(2,p.ILogService)],E),e.UserConfigurationFileService=E}),define(J[94],Z([0,1,6]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function A(b,I){switch(I){case m.LogLevel.Trace:return b.trace;case m.LogLevel.Debug:return b.debug;case m.LogLevel.Info:return b.info;case m.LogLevel.Warning:return b.warn;case m.LogLevel.Error:return b.error;case m.LogLevel.Critical:return b.critical;default:throw new Error("Invalid log level")}}class R extends m.AbstractLogger{constructor(I=m.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(I),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(I){this._logger=I;for(const{level:n,args:v}of this.buffer)A(I,n).apply(I,v);this.buffer=[]}_log(I,...n){this._logger?A(this._logger,I).apply(this._logger,n):this.getLevel()<=I&&this.buffer.push({level:I,args:n})}trace(I,...n){this._log(m.LogLevel.Trace,I,...n)}debug(I,...n){this._log(m.LogLevel.Debug,I,...n)}info(I,...n){this._log(m.LogLevel.Info,I,...n)}warn(I,...n){this._log(m.LogLevel.Warning,I,...n)}error(I,...n){this._log(m.LogLevel.Error,I,...n)}critical(I,...n){this._log(m.LogLevel.Critical,I,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=R}),define(J[179],Z([0,1,6,19,9,17,15,4,94]),function($,e,m,A,R,b,I,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const p=5*A.ByteSize.MB;let i=class extends m.AbstractLogger{constructor(y,d,g,D){super();this.name=y,this.resource=d,this.fileService=D,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new R.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=m.LogLevel.Trace&&this._log(m.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=m.LogLevel.Debug&&this._log(m.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=m.LogLevel.Info&&this._log(m.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=m.LogLevel.Warning&&this._log(m.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=m.LogLevel.Error){const y=arguments[0];if(y instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=y.stack,this._log(m.LogLevel.Error,this.format(d))}else this._log(m.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=m.LogLevel.Critical&&this._log(m.LogLevel.Critical,this.format(arguments))}flush(){}log(y,d){this._log(y,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(y){if(y.fileOperationResult!==3)throw y}}_log(y,d){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>p&&(await this.fileService.writeFile(this.getBackupResource(),b.VSBuffer.fromString(g)),g=""),g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(y)}] ${d}
`,await this.fileService.writeFile(this.resource,b.VSBuffer.fromString(g))})}getCurrentTimestamp(){const y=D=>D<10?`0${D}`:D,d=D=>D<10?`00${D}`:D<100?`0${D}`:D,g=new Date;return`${g.getFullYear()}-${y(g.getMonth()+1)}-${y(g.getDate())} ${y(g.getHours())}:${y(g.getMinutes())}:${y(g.getSeconds())}.${d(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,I.joinPath(I.dirname(this.resource),`${I.basename(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(y){return""}}stringifyLogLevel(y){switch(y){case m.LogLevel.Critical:return"critical";case m.LogLevel.Debug:return"debug";case m.LogLevel.Error:return"error";case m.LogLevel.Info:return"info";case m.LogLevel.Trace:return"trace";case m.LogLevel.Warning:return"warning"}return""}format(y){let d="";for(let g=0;g<y.length;g++){let D=y[g];if(typeof D=="object")try{D=JSON.stringify(D)}catch(P){}d+=(g>0?" ":"")+D}return d}};i=he([ee(3,A.IFileService)],i),e.FileLogger=i;let E=class extends m.AbstractLoggerService{constructor(y,d,g){super(y.getLevel(),y.onDidChangeLogLevel);this.instantiationService=d,this.fileService=g}doCreateLogger(y,d){const g=new v.BufferLogService(d);return A.whenProviderRegistered(y,this.fileService).then(()=>g.logger=this.instantiationService.createInstance(i,I.basename(y),y,g.getLevel())),g}};E=he([ee(0,m.ILogService),ee(1,n.IInstantiationService),ee(2,A.IFileService)],E),e.FileLoggerService=E}),define(J[180],Z([0,1,6,5,7]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class b{constructor(k){this.service=k,this.onDidChangeLogLevel=A.Event.buffer(k.onDidChangeLogLevel,!0)}listen(k,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(k,y,d){switch(y){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=b;class I{constructor(k){this.channel=k}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(k){I.setLevel(this.channel,k)}static setLevel(k,y){return k.call("setLevel",y)}}e.LogLevelChannelClient=I;class n{constructor(k){this.loggerService=k,this.loggers=new Map}listen(k,y){throw new Error(`Event not found: ${y}`)}async call(k,y,d){switch(y){case"createLogger":this.createLogger(R.URI.revive(d[0]),d[1]);return;case"log":return this.log(R.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${y}`)}createLogger(k,y){this.loggers.set(k.toString(),this.loggerService.createLogger(k,y))}consoleLog(k,y){let d=console.log;switch(k){case m.LogLevel.Error:d=console.error;break;case m.LogLevel.Warning:d=console.warn;break;case m.LogLevel.Info:d=console.info;break}d.call(console,...y)}log(k,y){const d=this.loggers.get(k.toString());if(!d)throw new Error("Create the logger before logging");for(const[g,D]of y)switch(g){case m.LogLevel.Trace:d.trace(D);break;case m.LogLevel.Debug:d.debug(D);break;case m.LogLevel.Info:d.info(D);break;case m.LogLevel.Warning:d.warn(D);break;case m.LogLevel.Error:d.error(D);break;case m.LogLevel.Critical:d.critical(D);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class v extends m.AbstractLoggerService{constructor(k,y,d){super(k,y);this.channel=d}createConsoleMainLogger(){return new m.AdapterLogger({log:(k,y)=>{this.channel.call("consoleLog",[k,y])}})}doCreateLogger(k,y,d){return new p(this.channel,k,y,d)}}e.LoggerChannelClient=v;class p extends m.AbstractMessageLogger{constructor(k,y,d,g){super(g==null?void 0:g.always);this.channel=k,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[y,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(k,y){const d=[[k,y]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(k){this.channel.call("log",[this.file,k])}}class i extends m.LogService{constructor(k,y){super(y);this.parent=k,this._register(k.onDidChangeLogLevel(d=>y.setLevel(d)))}setLevel(k){super.setLevel(k),this.parent.setLevel(k)}}e.FollowerLogService=i}),define(J[95],Z([0,1,6,19]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function R(v,p,i,E){try{const k=await new Promise((y,d)=>{$(["spdlog"],y,d)});return k.setFlushOn(m.LogLevel.Trace),k.createAsyncRotatingLogger(v,p,i,E)}catch(k){console.error(k)}return null}function b(v,p,i,E){const k=$.__$__nodeRequire("spdlog");return k.setFlushOn(m.LogLevel.Trace),k.createRotatingLogger(v,p,i,E)}e.createRotatingLogger=b;function I(v,p,i){switch(p){case m.LogLevel.Trace:v.trace(i);break;case m.LogLevel.Debug:v.debug(i);break;case m.LogLevel.Info:v.info(i);break;case m.LogLevel.Warning:v.warn(i);break;case m.LogLevel.Error:v.error(i);break;case m.LogLevel.Critical:v.critical(i);break;default:throw new Error("Invalid log level")}}class n extends m.AbstractMessageLogger{constructor(p,i,E,k){super();this.name=p,this.filepath=i,this.rotating=E,this.buffer=[],this.setLevel(k),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}_createSpdLogLogger(){const p=this.rotating?6:1,i=30/p*A.ByteSize.MB;return R(this.name,this.filepath,i,p).then(E=>{if(E){this._logger=E,this._logger.setLevel(this.getLevel());for(const{level:k,message:y}of this.buffer)I(this._logger,k,y);this.buffer=[]}})}log(p,i){this._logger?I(this._logger,p,i):this.getLevel()<=p&&this.buffer.push({level:p,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(J[181],Z([0,1,6,15,10,179,95,19,27]),function($,e,m,A,R,b,I,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let p=class extends m.AbstractLoggerService{constructor(E,k){super(E.getLevel(),E.onDidChangeLogLevel);this.fileService=k}doCreateLogger(E,k,y){var d;if(E.scheme===R.Schemas.file){const g=new I.SpdLogLogger((y==null?void 0:y.name)||v.generateUuid(),E.fsPath,!(y==null?void 0:y.donotRotate),k);return(y==null?void 0:y.donotUseFormatters)&&g.clearFormatters(),g}else return new b.FileLogger((d=y==null?void 0:y.name)!==null&&d!==void 0?d:A.basename(E),E,k,this.fileService)}};p=he([ee(0,m.ILogService),ee(1,n.IFileService)],p),e.LoggerService=p}),define(J[182],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function m(I){return I.submenu!==void 0}e.isMenubarMenuItemSubmenu=m;function A(I){return I.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=A;function R(I){return I.uri!==void 0}e.isMenubarMenuItemRecentAction=R;function b(I){return!m(I)&&!A(I)&&!R(I)}e.isMenubarMenuItemAction=b}),define(J[48],Z([0,1,10,3,33,15]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let I;if(typeof A.globals.vscode!="undefined"&&typeof A.globals.vscode.context!="undefined"){const n=A.globals.vscode.context.configuration();if(n)I=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof($==null?void 0:$.__$__nodeRequire)=="function"){const n=b.dirname(m.FileAccess.asFileUri("",$));I=$.__$__nodeRequire(b.joinPath(n,"product.json").fsPath);const v=$.__$__nodeRequire(b.joinPath(n,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(I,{nameShort:`${I.nameShort} Dev`,nameLong:`${I.nameLong} Dev`,dataFolderName:`${I.dataFolderName}-dev`}),Object.assign(I,{version:v.version})}else I={},Object.keys(I).length===0&&Object.assign(I,{version:"1.58.0-dev",nameShort:A.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:A.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=I}),define(J[96],Z([0,1,141,17,19,16,48]),function($,e,m,A,R,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(E,k,y,d,g,D){let P;try{await v(E,k,y,d,g,D)}catch(c){P=c}finally{P&&g.errorTransformer&&(P=g.errorTransformer(P)),typeof P!="undefined"&&y.error(P),y.end()}}e.readFileIntoStream=n;async function v(E,k,y,d,g,D){p(D);const P=await E.open(k,{create:!1});try{p(D);let c=0,u=0,o=g&&typeof g.length=="number"?g.length:void 0,l=A.VSBuffer.alloc(Math.min(g.bufferSize,typeof o=="number"?o:g.bufferSize)),t=g&&typeof g.position=="number"?g.position:0,r=0;do u=await E.read(P,t,l.buffer,r,l.byteLength-r),t+=u,r+=u,c+=u,typeof o=="number"&&(o-=u),r===l.byteLength&&(await y.write(d(l)),l=A.VSBuffer.alloc(Math.min(g.bufferSize,typeof o=="number"?o:g.bufferSize)),r=0);while(u>0&&(typeof o!="number"||o>0)&&p(D)&&i(c,g));if(r>0){let s=r;typeof o=="number"&&(s=Math.min(r,o)),y.write(d(l.slice(0,s)))}}catch(c){throw R.ensureFileSystemProviderError(c)}finally{await E.close(P)}}function p(E){if(E.isCancellationRequested)throw b.canceled();return!0}function i(E,k){if(k==null?void 0:k.limits){if(typeof k.limits.memory=="number"&&E>k.limits.memory)throw R.createFileSystemProviderError(m.localize(0,null,I.default.nameShort),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof k.limits.size=="number"&&E>k.limits.size)throw R.createFileSystemProviderError(m.localize(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[183],Z([0,1,139,72,2,19,5,15,37,36,6,17,64,9,25,10,96,63]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d,g,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class extends R.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new I.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new I.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new I.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new I.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new I.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new y.ResourceQueue)}registerProvider(o,l){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);A.mark(`code/registerFilesystem/${o}`),this.provider.set(o,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:l});const t=new R.DisposableStore;return t.add(l.onDidChangeFile(r=>this._onDidFilesChange.fire(new b.FileChangesEvent(r,!this.isPathCaseSensitive(l))))),t.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:o}))),typeof l.onDidErrorOccur=="function"&&t.add(l.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),R.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:l}),this.provider.delete(o),R.dispose(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){l.push(t)}}),!this.provider.has(o)&&await y.Promises.settled(l)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,l){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&l)}listCapabilities(){return P.Iterable.map(this.provider,([o,l])=>({scheme:o,capabilities:l.capabilities}))}async withProvider(o){if(!n.isAbsolutePath(o))throw new b.FileOperationError(m.localize(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const l=this.provider.get(o.scheme);if(!l){const t=new Error;throw t.name="ENOPRO",t.message=m.localize(1,null,o.toString()),t}return l}async withReadProvider(o){const l=await this.withProvider(o);if(b.hasOpenReadWriteCloseCapability(l)||b.hasReadWriteCapability(l)||b.hasFileReadStreamCapability(l))return l;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const l=await this.withProvider(o);if(b.hasOpenReadWriteCloseCapability(l)||b.hasReadWriteCapability(l))return l;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,l){try{return await this.doResolveFile(o,l)}catch(t){throw b.toFileSystemProviderErrorCode(t)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError(m.localize(2,null,this.resourceForError(o)),1):b.ensureFileSystemProviderError(t)}}async doResolveFile(o,l){const t=await this.withProvider(o),r=this.isPathCaseSensitive(t),s=l==null?void 0:l.resolveTo,a=l==null?void 0:l.resolveSingleChildDescendants,h=l==null?void 0:l.resolveMetadata,w=await t.stat(o);let f;return this.toFileStat(t,o,w,void 0,!!h,(S,L)=>(f||(f=v.TernarySearchTree.forUris(()=>!r),f.set(o,!0),p.isNonEmptyArray(s)&&s.forEach(_=>f.set(_,!0))),Boolean(f.findSuperstr(S.resource)||f.get(S.resource))?!0:S.isDirectory&&a?L===1:!1))}async toFileStat(o,l,t,r,s,a){var h;const{providerExtUri:w}=this.getExtUri(o),f={resource:l,name:w.basename(l),isFile:(t.type&b.FileType.File)!=0,isDirectory:(t.type&b.FileType.Directory)!=0,isSymbolicLink:(t.type&b.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean(((h=t.permissions)!==null&&h!==void 0?h:0)&b.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:b.etag({mtime:t.mtime,size:t.size})};if(f.isDirectory&&a(f,r)){try{const S=await o.readdir(l),L=await y.Promises.settled(S.map(async([_,H])=>{try{const Q=w.joinPath(l,_),te=s?await o.stat(Q):{type:H};return await this.toFileStat(o,Q,te,S.length,s,a)}catch(Q){return this.logService.trace(Q),null}}));f.children=p.coalesce(L)}catch(S){this.logService.trace(S),f.children=[]}return f}return f}async resolveAll(o){return y.Promises.settled(o.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const l=await this.withProvider(o);try{return!!await l.stat(o)}catch(t){return!1}}async canCreateFile(o,l){try{await this.doValidateCreateFile(o,l)}catch(t){return t}return!0}async doValidateCreateFile(o,l){if(!(l==null?void 0:l.overwrite)&&await this.exists(o))throw new b.FileOperationError(m.localize(3,null,this.resourceForError(o)),3,l)}async createFile(o,l=E.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const r=await this.writeFile(o,l);return this._onDidRunOperation.fire(new b.FileOperationEvent(o,0,r)),r}async writeFile(o,l,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:s}=this.getExtUri(r);try{await this.validateWriteFile(r,o,t)||await this.mkdirp(r,s.dirname(o));let h;if(b.hasReadWriteCapability(r)&&!(l instanceof E.VSBuffer))if(k.isReadableStream(l)){const w=await k.peekStream(l,3);w.ended?h=E.VSBuffer.concat(w.buffer):h=w}else h=k.peekReadable(l,w=>E.VSBuffer.concat(w),3);else h=l;!b.hasOpenReadWriteCloseCapability(r)||b.hasReadWriteCapability(r)&&h instanceof E.VSBuffer?await this.doWriteUnbuffered(r,o,t,h):await this.doWriteBuffered(r,o,t,h instanceof E.VSBuffer?E.bufferToReadable(h):h)}catch(a){throw new b.FileOperationError(m.localize(4,null,this.resourceForError(o),b.ensureFileSystemProviderError(a).toString()),b.toFileOperationResult(a),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,l,t){if(!!(t==null?void 0:t.unlock)&&!(o.capabilities&8192))throw new Error(m.localize(5,null,this.resourceForError(l)));let s;try{s=await o.stat(l)}catch(a){return}if((s.type&b.FileType.Directory)!=0)throw new b.FileOperationError(m.localize(6,null,this.resourceForError(l)),0,t);if(this.throwIfFileIsReadonly(l,s),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==b.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==b.etag({mtime:t.mtime,size:s.size}))throw new b.FileOperationError(m.localize(7,null),3,t);return s}async readFile(o,l){const t=await this.withReadProvider(o);return(l==null?void 0:l.atomic)?this.doReadFileAtomic(t,o,l):this.doReadFile(t,o,l)}async doReadFileAtomic(o,l,t){return new Promise((r,s)=>{this.writeQueue.queueFor(l,this.getExtUri(o).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(o,l,t);r(a)}catch(a){s(a)}})})}async doReadFile(o,l,t){const r=await this.doReadFileStream(o,l,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await E.streamToBuffer(r.value)})}async readFileStream(o,l){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,l)}async doReadFileStream(o,l,t){const r=new d.CancellationTokenSource,s=this.validateReadFile(l,t).then(h=>h,h=>{throw r.cancel(),h});let a;try{t&&typeof t.etag=="string"&&t.etag!==b.ETAG_DISABLED&&await s,!(b.hasOpenReadWriteCloseCapability(o)||b.hasFileReadStreamCapability(o))||b.hasReadWriteCapability(o)&&(t==null?void 0:t.preferUnbuffered)?a=this.readFileUnbuffered(o,l,t):b.hasFileReadStreamCapability(o)?a=this.readFileStreamed(o,l,r.token,t):a=this.readFileBuffered(o,l,r.token,t);const h=await s;return Object.assign(Object.assign({},h),{value:a})}catch(h){a&&await k.consumeStream(a);const w=m.localize(8,null,this.resourceForError(l),b.ensureFileSystemProviderError(h).toString());throw h instanceof b.NotModifiedSinceFileOperationError?new b.NotModifiedSinceFileOperationError(w,h.stat,t):new b.FileOperationError(w,b.toFileOperationResult(h),t)}}readFileStreamed(o,l,t,r=Object.create(null)){const s=o.readFileStream(l,r,t);return k.transform(s,{data:a=>a instanceof E.VSBuffer?a:E.VSBuffer.wrap(a),error:a=>new b.FileOperationError(m.localize(9,null,this.resourceForError(l),b.ensureFileSystemProviderError(a).toString()),b.toFileOperationResult(a),r)},a=>E.VSBuffer.concat(a))}readFileBuffered(o,l,t,r=Object.create(null)){const s=E.newWriteableBufferStream();return D.readFileIntoStream(o,l,s,a=>a,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new b.FileOperationError(m.localize(10,null,this.resourceForError(l),b.ensureFileSystemProviderError(a).toString()),b.toFileOperationResult(a),r)}),t),s}readFileUnbuffered(o,l,t){const r=k.newWriteableStream(s=>E.VSBuffer.concat(s));return(async()=>{try{let s=await o.readFile(l);t&&typeof t.position=="number"&&(s=s.slice(t.position)),t&&typeof t.length=="number"&&(s=s.slice(0,t.length)),this.validateReadFileLimits(l,s.byteLength,t),r.end(E.VSBuffer.wrap(s))}catch(s){r.error(s),r.end()}})(),r}async validateReadFile(o,l){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new b.FileOperationError(m.localize(11,null,this.resourceForError(o)),0,l);if(l&&typeof l.etag=="string"&&l.etag!==b.ETAG_DISABLED&&l.etag===t.etag)throw new b.NotModifiedSinceFileOperationError(m.localize(12,null),t,l);return this.validateReadFileLimits(o,t.size,l),t}validateReadFileLimits(o,l,t){if(t==null?void 0:t.limits){let r;if(typeof t.limits.memory=="number"&&l>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&l>t.limits.size&&(r=7),typeof r=="number")throw new b.FileOperationError(m.localize(13,null,this.resourceForError(o)),r)}}async canMove(o,l,t){return this.doCanMoveCopy(o,l,"move",t)}async canCopy(o,l,t){return this.doCanMoveCopy(o,l,"copy",t)}async doCanMoveCopy(o,l,t,r){if(o.toString()!==l.toString())try{const s=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(s,o,a,l,t,r)}catch(s){return s}return!0}async move(o,l,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),a=await this.doMoveCopy(r,o,s,l,"move",!!t),h=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(o,a==="move"?2:3,h)),h}async copy(o,l,t){const r=await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),a=await this.doMoveCopy(r,o,s,l,"copy",!!t),h=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(o,a==="copy"?3:2,h)),h}async doMoveCopy(o,l,t,r,s,a){if(l.toString()===r.toString())return s;const{exists:h,isSameResourceWithDifferentPathCase:w}=await this.doValidateMoveCopy(o,l,t,r,s,a);if(h&&!w&&a&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),s==="copy"){if(o===t&&b.hasFileFolderCopyCapability(o))await o.copy(l,r,{overwrite:a});else{const f=await this.resolve(l);f.isDirectory?await this.doCopyFolder(o,f,t,r):await this.doCopyFile(o,l,t,r)}return s}else return o===t?(await o.rename(l,r,{overwrite:a}),s):(await this.doMoveCopy(o,l,t,r,"copy",a),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(o,l,t,r){if(b.hasOpenReadWriteCloseCapability(o)&&b.hasOpenReadWriteCloseCapability(t))return this.doPipeBuffered(o,l,t,r);if(b.hasOpenReadWriteCloseCapability(o)&&b.hasReadWriteCapability(t))return this.doPipeBufferedToUnbuffered(o,l,t,r);if(b.hasReadWriteCapability(o)&&b.hasOpenReadWriteCloseCapability(t))return this.doPipeUnbufferedToBuffered(o,l,t,r);if(b.hasReadWriteCapability(o)&&b.hasReadWriteCapability(t))return this.doPipeUnbuffered(o,l,t,r)}async doCopyFolder(o,l,t,r){await t.mkdir(r),Array.isArray(l.children)&&await y.Promises.settled(l.children.map(async s=>{const a=this.getExtUri(t).providerExtUri.joinPath(r,s.name);return s.isDirectory?this.doCopyFolder(o,await this.resolve(s.resource),t,a):this.doCopyFile(o,s.resource,t,a)}))}async doValidateMoveCopy(o,l,t,r,s,a){let h=!1;if(o===t){const{providerExtUri:f,isPathCaseSensitive:S}=this.getExtUri(o);if(S||(h=f.isEqual(l,r)),h&&s==="copy")throw new Error(m.localize(14,null,this.resourceForError(l),this.resourceForError(r)));if(!h&&f.isEqualOrParent(r,l))throw new Error(m.localize(15,null,this.resourceForError(l),this.resourceForError(r)))}const w=await this.exists(r);if(w&&!h){if(!a)throw new b.FileOperationError(m.localize(16,null,this.resourceForError(l),this.resourceForError(r)),4);if(o===t){const{providerExtUri:f}=this.getExtUri(o);if(f.isEqualOrParent(l,r))throw new Error(m.localize(17,null,this.resourceForError(l),this.resourceForError(r)))}}return{exists:w,isSameResourceWithDifferentPathCase:h}}getExtUri(o){const l=this.isPathCaseSensitive(o);return{providerExtUri:l?n.extUri:n.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(l,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(o,0,t)),t}async mkdirp(o,l){const t=[],{providerExtUri:r}=this.getExtUri(o);for(;!r.isEqual(l,r.dirname(l));)try{if(((await o.stat(l)).type&b.FileType.Directory)==0)throw new Error(m.localize(18,null,this.resourceForError(l)));break}catch(s){if(b.toFileSystemProviderErrorCode(s)!==b.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(r.basename(l)),l=r.dirname(l)}for(let s=t.length-1;s>=0;s--){l=r.joinPath(l,t[s]);try{await o.mkdir(l)}catch(a){if(b.toFileSystemProviderErrorCode(a)!==b.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,l){try{await this.doValidateDelete(o,l)}catch(t){return t}return!0}async doValidateDelete(o,l){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(l==null?void 0:l.useTrash)&&!(t.capabilities&4096))throw new Error(m.localize(19,null,this.resourceForError(o)));let s;try{s=await t.stat(o)}catch(h){}if(s)this.throwIfFileIsReadonly(o,s);else throw new b.FileOperationError(m.localize(20,null,this.resourceForError(o)),1);if(!!!(l==null?void 0:l.recursive)){const h=await this.resolve(o);if(h.isDirectory&&Array.isArray(h.children)&&h.children.length>0)throw new Error(m.localize(21,null,this.resourceForError(o)))}return t}async del(o,l){const t=await this.doValidateDelete(o,l),r=!!(l==null?void 0:l.useTrash),s=!!(l==null?void 0:l.recursive);await t.delete(o,{recursive:s,useTrash:r}),this._onDidRunOperation.fire(new b.FileOperationEvent(o,1))}watch(o,l={recursive:!1,excludes:[]}){let t=!1,r=()=>{t=!0};return this.doWatch(o,l).then(s=>{t?R.dispose(s):r=()=>R.dispose(s)},s=>this.logService.error(s)),R.toDisposable(()=>r())}async doWatch(o,l){const t=await this.withProvider(o),r=this.toWatchKey(t,o,l),s=this.activeWatchers.get(r)||{count:0,disposable:t.watch(o,l)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,s),s.count+=1,R.toDisposable(()=>{s.count--,s.count===0&&(R.dispose(s.disposable),this.activeWatchers.delete(r))})}toWatchKey(o,l,t){const{providerExtUri:r}=this.getExtUri(o);return[r.getComparisonKey(l),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>R.dispose(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,l,t,r){return this.writeQueue.queueFor(l,this.getExtUri(o).providerExtUri).queue(async()=>{var s;const a=await o.open(l,{create:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1});try{k.isReadableStream(r)||k.isReadableBufferedStream(r)?await this.doWriteStreamBufferedQueued(o,a,r):await this.doWriteReadableBufferedQueued(o,a,r)}catch(h){throw b.ensureFileSystemProviderError(h)}finally{await o.close(a)}})}async doWriteStreamBufferedQueued(o,l,t){let r=0,s;if(k.isReadableBufferedStream(t)){if(t.buffer.length>0){const a=E.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,l,a,a.byteLength,r,0),r+=a.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise(async(a,h)=>{k.listenStream(s,{onData:async w=>{s.pause();try{await this.doWriteBuffer(o,l,w,w.byteLength,r,0)}catch(f){return h(f)}r+=w.byteLength,setTimeout(()=>s.resume())},onError:w=>h(w),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(o,l,t){let r=0,s;for(;(s=t.read())!==null;)await this.doWriteBuffer(o,l,s,s.byteLength,r,0),r+=s.byteLength}async doWriteBuffer(o,l,t,r,s,a){let h=0;for(;h<r;)h+=await o.write(l,s+h,t.buffer,a+h,r-h)}async doWriteUnbuffered(o,l,t,r){return this.writeQueue.queueFor(l,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,l,t,r))}async doWriteUnbufferedQueued(o,l,t,r){var s;let a;r instanceof E.VSBuffer?a=r:k.isReadableStream(r)?a=await E.streamToBuffer(r):k.isReadableBufferedStream(r)?a=await E.bufferedStreamToBuffer(r):a=E.readableToBuffer(r),await o.writeFile(l,a.buffer,{create:!0,overwrite:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1})}async doPipeBuffered(o,l,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,l,t,r))}async doPipeBufferedQueued(o,l,t,r){let s,a;try{s=await o.open(l,{create:!1}),a=await t.open(r,{create:!0,unlock:!1});const h=E.VSBuffer.alloc(this.BUFFER_SIZE);let w=0,f=0,S=0;do S=await o.read(s,w,h.buffer,f,h.byteLength-f),await this.doWriteBuffer(t,a,h,S,w,f),w+=S,f+=S,f===h.byteLength&&(f=0);while(S>0)}catch(h){throw b.ensureFileSystemProviderError(h)}finally{await y.Promises.settled([typeof s=="number"?o.close(s):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async doPipeUnbuffered(o,l,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,l,t,r))}async doPipeUnbufferedQueued(o,l,t,r){return t.writeFile(r,await o.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,l,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,l,t,r))}async doPipeUnbufferedToBufferedQueued(o,l,t,r){const s=await t.open(r,{create:!0,unlock:!1});try{const a=await o.readFile(l);await this.doWriteBuffer(t,s,E.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw b.ensureFileSystemProviderError(a)}finally{await t.close(s)}}async doPipeBufferedToUnbuffered(o,l,t,r){const s=await E.streamToBuffer(this.readFileBuffered(o,l,d.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,s)}throwIfFileSystemIsReadonly(o,l){if(o.capabilities&2048)throw new b.FileOperationError(m.localize(22,null,this.resourceForError(l)),6);return o}throwIfFileIsReadonly(o,l){var t;if(((t=l.permissions)!==null&&t!==void 0?t:0)&b.FilePermission.Readonly)throw new b.FileOperationError(m.localize(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===g.Schemas.file?o.fsPath:o.toString(!0)}};c=he([ee(0,i.ILogService)],c),e.FileService=c}),define(J[184],Z([0,1,2,19,5,3,18,8,15,29,9,6,142,93,164,166,163,173,64,96,36,17]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d,g,D,P,c,u,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends m.Disposable{constructor(s,a){var h;super();this.logService=s,this.options=a,this.BUFFER_SIZE=((h=this.options)===null||h===void 0?void 0:h.bufferSize)||64*1024,this.onDidChangeCapabilities=R.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new R.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new i.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:a,symbolicLink:h}=await I.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(a,h),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(s){try{const a=await I.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),h=[];return await Promise.all(a.map(async w=>{try{let f;w.isSymbolicLink()?f=(await this.stat(v.joinPath(s,w.name))).type:f=this.toType(w),h.push([w.name,f])}catch(f){this.logService.trace(f)}})),h}catch(a){throw this.toFileSystemProviderError(a)}}toType(s,a){let h;return(a==null?void 0:a.dangling)?h=A.FileType.Unknown:s.isFile()?h=A.FileType.File:s.isDirectory()?h=A.FileType.Directory:h=A.FileType.Unknown,a&&(h|=A.FileType.SymbolicLink),h}async readFile(s){try{const a=this.toFilePath(s);return await I.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(s,a,h){const w=c.newWriteableStream(f=>l.VSBuffer.concat(f.map(S=>l.VSBuffer.wrap(S))).buffer);return u.readFileIntoStream(this,s,w,f=>f.buffer,Object.assign(Object.assign({},a),{bufferSize:this.BUFFER_SIZE}),h),w}async writeFile(s,a,h){let w;try{const f=this.toFilePath(s);if(!h.create||!h.overwrite){if(await I.Promises.exists(f)){if(!h.overwrite)throw A.createFileSystemProviderError(k.localize(0,null),A.FileSystemProviderErrorCode.FileExists)}else if(!h.create)throw A.createFileSystemProviderError(k.localize(1,null),A.FileSystemProviderErrorCode.FileNotFound)}w=await this.open(s,{create:!0,unlock:h.unlock}),await this.write(w,0,a,0,a.byteLength)}catch(f){throw await this.toFileSystemProviderWriteError(s,f)}finally{typeof w=="number"&&await this.close(w)}}async open(s,a){try{const h=this.toFilePath(s);if(A.isFileOpenForWriteOptions(a)&&a.unlock)try{const{stat:S}=await I.SymlinkSupport.stat(h);S.mode&128||await I.Promises.chmod(h,S.mode|128)}catch(S){this.logService.trace(S)}let w;if(A.isFileOpenForWriteOptions(a)){if(b.isWindows)try{await I.Promises.truncate(h,0),w="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}w||(w="w")}else w="r";const f=await I.Promises.open(h,w);return this.mapHandleToPos.set(f,0),A.isFileOpenForWriteOptions(a)&&this.writeHandles.set(f,s),f}catch(h){throw A.isFileOpenForWriteOptions(a)?await this.toFileSystemProviderWriteError(s,h):this.toFileSystemProviderError(h)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await I.Promises.fdatasync(s)}catch(a){this.canFlush=!1,this.logService.error(a)}return await I.Promises.close(s)}catch(a){throw this.toFileSystemProviderError(a)}}async read(s,a,h,w,f){const S=this.normalizePos(s,a);let L=null;try{const _=await I.Promises.read(s,h,w,f,S);return typeof _=="number"?L=_:L=_.bytesRead,L}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(s,S,L)}}normalizePos(s,a){return a===this.mapHandleToPos.get(s)?null:a}updatePos(s,a,h){const w=this.mapHandleToPos.get(s);typeof w=="number"&&(typeof a=="number"||(typeof h=="number"?this.mapHandleToPos.set(s,w+h):this.mapHandleToPos.delete(s)))}async write(s,a,h,w,f){return i.retry(()=>this.doWrite(s,a,h,w,f),100,3)}async doWrite(s,a,h,w,f){const S=this.normalizePos(s,a);let L=null;try{const _=await I.Promises.write(s,h,w,f,S);return typeof _=="number"?L=_:L=_.bytesWritten,L}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),_)}finally{this.updatePos(s,S,L)}}async mkdir(s){try{await I.Promises.mkdir(this.toFilePath(s))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(s,a){try{const h=this.toFilePath(s);await this.doDelete(h,a)}catch(h){throw this.toFileSystemProviderError(h)}}async doDelete(s,a){a.recursive?await I.Promises.rm(s,I.RimRafMode.MOVE):await I.Promises.unlink(s)}async rename(s,a,h){const w=this.toFilePath(s),f=this.toFilePath(a);if(w!==f)try{await this.validateTargetDeleted(s,a,"move",h.overwrite),await I.Promises.move(w,f)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error(k.localize(2,null,n.basename(w),n.basename(n.dirname(f)),S.toString()))),this.toFileSystemProviderError(S)}}async copy(s,a,h){const w=this.toFilePath(s),f=this.toFilePath(a);if(w!==f)try{await this.validateTargetDeleted(s,a,"copy",h.overwrite),await I.Promises.copy(w,f,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error(k.localize(3,null,n.basename(w),n.basename(n.dirname(f)),S.toString()))),this.toFileSystemProviderError(S)}}async validateTargetDeleted(s,a,h,w){const f=this.toFilePath(s),S=this.toFilePath(a);let L=!1;if(!!(this.capabilities&1024)||(L=p.isEqual(f,S,!0)),L&&h==="copy")throw A.createFileSystemProviderError(k.localize(4,null),A.FileSystemProviderErrorCode.FileExists);if(!L&&await I.Promises.exists(S)){if(!w)throw A.createFileSystemProviderError(k.localize(5,null),A.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(s,a){return a.recursive?this.watchRecursive(s,a.excludes):this.watchNonRecursive(s)}watchRecursive(s,a){const h={path:this.toFilePath(s),excludes:a},w=o.insert(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),m.toDisposable(()=>{w(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var s,a,h;if(this.recursiveWatcher instanceof D.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(m.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let w,f;((a=(s=this.options)===null||s===void 0?void 0:s.watcher)===null||a===void 0?void 0:a.usePolling)?(w=d.FileWatcher,f=(h=this.options)===null||h===void 0?void 0:h.watcher):this.recursiveFoldersToWatch.length===1?b.isWindows?w=g.FileWatcher:w=d.FileWatcher:w=D.FileWatcher,this.recursiveWatcher=new w(this.recursiveFoldersToWatch,S=>this._onDidChangeFile.fire(y.toFileChanges(S)),S=>{S.type==="error"&&this._onDidWatchErrorOccur.fire(S.message),this.logService[S.type](S.message)},this.logService.getLevel()===E.LogLevel.Trace,f),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))}}watchNonRecursive(s){const a=new P.FileWatcher(this.toFilePath(s),w=>this._onDidChangeFile.fire(y.toFileChanges(w)),w=>{w.type==="error"&&this._onDidWatchErrorOccur.fire(w.message),this.logService[w.type](w.message)},this.logService.getLevel()===E.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)});return m.combinedDisposable(a,h)}toFilePath(s){return n.normalize(s.fsPath)}toFileSystemProviderError(s){if(s instanceof A.FileSystemProviderError)return s;let a;switch(s.code){case"ENOENT":a=A.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=A.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=A.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=A.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=A.FileSystemProviderErrorCode.NoPermissions;break;default:a=A.FileSystemProviderErrorCode.Unknown}return A.createFileSystemProviderError(s,a)}async toFileSystemProviderWriteError(s,a){let h=this.toFileSystemProviderError(a);if(s&&h.code===A.FileSystemProviderErrorCode.NoPermissions)try{const{stat:w}=await I.SymlinkSupport.stat(this.toFilePath(s));w.mode&128||(h=A.createFileSystemProviderError(a,A.FileSystemProviderErrorCode.FileWriteLocked))}catch(w){this.logService.trace(w)}return h}dispose(){super.dispose(),m.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,m.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(J[20],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=m.createDecorator("productService")}),define(J[185],Z([0,1,58,6,20]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let b=class{constructor(n,v){this.productService=n,this.logService=v,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,v){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const p=/^(.*)#([^#]+)$/.exec(v);if(!p)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",v),!1;const[,i,E]=p;let k=this.trustedExtensionUrlPublicKeys.get(n);if(!k){if(k=this.productService.trustedExtensionUrlPublicKeys[n],!k||k.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...k])}const y=Buffer.from(decodeURIComponent(E),"base64");if(y.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",v),!1;const d=y.slice(0,6),g=y.readUIntBE(0,6),D=Date.now()-g;if(D<0||D>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",v),!1;const P=y.slice(6),c=m.createVerify("SHA256");c.write(d),c.write(Buffer.from(i)),c.end();for(let u=0;u<k.length;u++){let o=k[u];if(o!==null){if(typeof o=="string")try{o=m.createPublicKey({key:Buffer.from(o,"base64"),format:"der",type:"spki"}),k[u]=o}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${u+1} for ${n}:`,l),k[u]=null;continue}if(c.verify(o,P))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",v),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",v),!1}};b=he([ee(0,R.IProductService),ee(1,A.ILogService)],b),e.ExtensionUrlTrustService=b}),define(J[55],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=m.createDecorator("protocolMainService")}),define(J[186],Z([0,1,2,10,7,47,14,6,37,3,15,27]),function($,e,m,A,R,b,I,n,v,p,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let k=class extends m.Disposable{constructor(d,g){super();this.logService=g,this.validRoots=v.TernarySearchTree.forUris(()=>!p.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(R.URI.file(d.appRoot)),this.addValidFileRoot(R.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=I.session;d.protocol.registerFileProtocol(A.Schemas.vscodeFileResource,(g,D)=>this.handleResourceRequest(g,D)),d.protocol.interceptFileProtocol(A.Schemas.file,(g,D)=>this.handleFileRequest(g,D)),this._register(m.toDisposable(()=>{d.protocol.unregisterProtocol(A.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(A.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?m.Disposable.None:(this.validRoots.set(d,!0),m.toDisposable(()=>this.validRoots.delete(d)))}handleFileRequest(d,g){const D=R.URI.parse(d.url);return p.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${D.fsPath} from ${A.Schemas.file}: protocol (original URL: ${d.url})`),g({error:-3})):this.validRoots.findSubstr(D)?g({path:D.fsPath}):this.validExtensions.has(i.extname(D))?g({path:D.fsPath}):(this.logService.error(`${A.Schemas.file}: Refused to load resource ${D.fsPath} from ${A.Schemas.file}: protocol (original URL: ${d.url})`),g({error:-3}))}handleResourceRequest(d,g){const D=R.URI.parse(d.url),P=A.FileAccess.asFileUri(D);return this.validRoots.findSubstr(P)?g({path:P.fsPath}):this.validExtensions.has(i.extname(P))?g({path:P.fsPath}):(this.logService.error(`${A.Schemas.vscodeFileResource}: Refused to load resource ${P.fsPath} from ${A.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),g({error:-3}))}createIPCObjectUrl(){let d;const g=R.URI.from({scheme:"vscode",path:E.generateUuid()}),D=g.toString(),P=async()=>d;return I.ipcMain.handle(D,P),this.logService.trace(`IPC Object URL: Registered new channel ${D}.`),{resource:g,update:c=>d=c,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${D}.`),I.ipcMain.removeHandler(D)}}}};k=he([ee(0,b.INativeEnvironmentService),ee(1,n.ILogService)],k),e.ProtocolMainService=k}),define(J[38],Z([0,1,13,103]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(I,n){A.ok(m.isString(I)),A.ok(m.isObject(n)),A.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,n)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}e.Registry=new R}),define(J[187],Z([0,1,38,5]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class b{constructor(){this._onDidChangeSchema=new A.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(v,p){this.schemasById[R(v)]=p,this._onDidChangeSchema.fire(v)}notifySchemaChanged(v){this._onDidChangeSchema.fire(v)}getSchemaContributions(){return{schemas:this.schemasById}}}const I=new b;m.Registry.add(e.Extensions.JSONContribution,I)}),define(J[49],Z([0,1,132,5,38,13,187]),function($,e,m,A,R,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var n;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(n=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const v=R.Registry.as(I.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(P,c=!0){this.registerConfigurations([P],c)}registerConfigurations(P,c=!0){const u=[];P.forEach(o=>{u.push(...this.validateAndRegisterProperties(o,c,o.extensionInfo)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(P){const c=[],u=o=>{if(o.properties)for(const l in o.properties)c.push(l),delete this.configurationProperties[l],this.removeFromSchema(l,o.properties[l]);o.allOf&&o.allOf.forEach(l=>u(l))};for(const o of P){u(o);const l=this.configurationContributors.indexOf(o);l!==-1&&this.configurationContributors.splice(l,1)}v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}registerDefaultConfigurations(P){const c=[],u=[];for(const o of P)for(const l in o)if(c.push(l),e.OVERRIDE_PROPERTY_PATTERN.test(l)){this.defaultValues[l]=Object.assign(Object.assign({},this.defaultValues[l]||{}),o[l]);const t={type:"object",default:this.defaultValues[l],description:m.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId};u.push(E(l)),this.configurationProperties[l]=t,this.defaultLanguageConfigurationOverridesNode.properties[l]=t}else{this.defaultValues[l]=o[l];const t=this.configurationProperties[l];t&&(this.updatePropertyDefaultValue(l,t),this.updateSchema(l,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(P){const c=[];for(const u of P)for(const o in u)if(c.push(o),delete this.defaultValues[o],e.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const l=this.configurationProperties[o];l&&(this.updatePropertyDefaultValue(o,l),this.updateSchema(o,l))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...P){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(P){for(const c of P)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(P,c=!0,u,o=3){var l;o=b.isUndefinedOrNull(P.scope)?o:P.scope;let t=[],r=P.properties;if(r)for(let a in r){if(c&&d(a)){delete r[a];continue}const h=r[a];if(this.updatePropertyDefaultValue(a,h),e.OVERRIDE_PROPERTY_PATTERN.test(a)?h.scope=void 0:(h.scope=b.isUndefinedOrNull(h.scope)?o:h.scope,h.restricted=b.isUndefinedOrNull(h.restricted)?!!((l=u==null?void 0:u.restrictedConfigurations)===null||l===void 0?void 0:l.includes(a)):h.restricted),r[a].hasOwnProperty("included")&&!r[a].included){this.excludedConfigurationProperties[a]=r[a],delete r[a];continue}else this.configurationProperties[a]=r[a];!r[a].deprecationMessage&&r[a].markdownDeprecationMessage&&(r[a].deprecationMessage=r[a].markdownDeprecationMessage),t.push(a)}let s=P.allOf;if(s)for(let a of s)t.push(...this.validateAndRegisterProperties(a,c,u,o));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(P){const c=u=>{let o=u.properties;if(o)for(const t in o)this.updateSchema(t,o[t]);let l=u.allOf;l&&l.forEach(c)};c(P)}updateSchema(P,c){switch(e.allSettings.properties[P]=c,c.scope){case 1:e.applicationSettings.properties[P]=c;break;case 2:e.machineSettings.properties[P]=c;break;case 6:e.machineOverridableSettings.properties[P]=c;break;case 3:e.windowSettings.properties[P]=c;break;case 4:e.resourceSettings.properties[P]=c;break;case 5:e.resourceSettings.properties[P]=c,this.resourceLanguageSettingsSchema.properties[P]=c;break}}removeFromSchema(P,c){switch(delete e.allSettings.properties[P],c.scope){case 1:delete e.applicationSettings.properties[P];break;case 2:delete e.machineSettings.properties[P];break;case 6:delete e.machineOverridableSettings.properties[P];break;case 3:delete e.windowSettings.properties[P];break;case 4:case 5:delete e.resourceSettings.properties[P];break}}updateOverridePropertyPatternKey(){for(const P of this.overrideIdentifiers.values()){const c=`[${P}]`,u={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,u),e.allSettings.properties[c]=u,e.applicationSettings.properties[c]=u,e.machineSettings.properties[c]=u,e.machineOverridableSettings.properties[c]=u,e.windowSettings.properties[c]=u,e.resourceSettings.properties[c]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(P,c){let u=this.defaultValues[P];b.isUndefined(u)&&(u=c.default),b.isUndefined(u)&&(u=k(c.type)),c.default=u}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function E(D){return D.substring(1,D.length-1)}e.overrideIdentifierFromKey=E;function k(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=k;const y=new p;R.Registry.add(e.Extensions.Configuration,y);function d(D){return D.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(D)?m.localize(5,null,D):y.getConfigurationProperties()[D]!==void 0?m.localize(6,null,D):null:m.localize(4,null)}e.validateProperty=d;function g(){const D=[],P=y.getConfigurationProperties();for(const c of Object.keys(P))D.push([c,P[c].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=g}),define(J[21],Z([0,1,44,13,7,38,4,49]),function($,e,m,A,R,b,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=I.createDecorator("configurationService");function v(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof R.URI)}e.isConfigurationOverrides=v;var p;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(p=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function E(r,s){const a=s?r?s.keys.filter(H=>r.keys.indexOf(H)===-1):[...s.keys]:[],h=r?s?r.keys.filter(H=>s.keys.indexOf(H)===-1):[...r.keys]:[],w=[];if(s&&r){for(const H of r.keys)if(s.keys.indexOf(H)!==-1){const Q=P(r.contents,H),te=P(s.contents,H);m.equals(Q,te)||w.push(H)}}const f=[],S=H=>{const Q={};for(const te of H)for(const B of te.identifiers)Q[l(B)]=te;return Q},L=s?S(s.overrides):{},_=r?S(r.overrides):{};if(Object.keys(L).length)for(const H of a){const Q=L[H];Q&&f.push([n.overrideIdentifierFromKey(H),Q.keys])}if(Object.keys(_).length)for(const H of h){const Q=_[H];Q&&f.push([n.overrideIdentifierFromKey(H),Q.keys])}if(Object.keys(L).length&&Object.keys(_).length)for(const H of w){const Q=_[H],te=L[H];if(Q&&te){const B=E({contents:Q.contents,keys:Q.keys,overrides:[]},{contents:te.contents,keys:te.keys,overrides:[]});f.push([n.overrideIdentifierFromKey(H),[...B.added,...B.removed,...B.updated]])}}return{added:a,removed:h,updated:w,overrides:f}}e.compare=E;function k(r,s){const a=[];for(const h of Object.keys(r))if(n.OVERRIDE_PROPERTY_PATTERN.test(h)){const w={};for(const f in r[h])w[f]=r[h][f];a.push({identifiers:[n.overrideIdentifierFromKey(h).trim()],keys:Object.keys(w),contents:y(w,s)})}return a}e.toOverrides=k;function y(r,s){const a=Object.create(null);for(let h in r)d(a,h,r[h],s);return a}e.toValuesTree=y;function d(r,s,a,h){const w=s.split("."),f=w.pop();let S=r;for(let L=0;L<w.length;L++){let _=w[L],H=S[_];switch(typeof H){case"undefined":H=S[_]=Object.create(null);break;case"object":break;default:h(`Ignoring ${s} as ${w.slice(0,L+1).join(".")} is ${JSON.stringify(H)}`);return}S=H}if(typeof S=="object"&&S!==null)try{S[f]=a}catch(L){h(`Ignoring ${s} as ${w.join(".")} is ${JSON.stringify(S)}`)}else h(`Ignoring ${s} as ${w.join(".")} is ${JSON.stringify(S)}`)}e.addToValueTree=d;function g(r,s){const a=s.split(".");D(r,a)}e.removeFromValueTree=g;function D(r,s){const a=s.shift();if(s.length===0){delete r[a];return}if(Object.keys(r).indexOf(a)!==-1){const h=r[a];typeof h=="object"&&!Array.isArray(h)&&(D(h,s),Object.keys(h).length===0&&delete r[a])}}function P(r,s,a){function h(S,L){let _=S;for(const H of L){if(typeof _!="object"||_===null)return;_=_[H]}return _}const w=s.split("."),f=h(r,w);return typeof f=="undefined"?a:f}e.getConfigurationValue=P;function c(r,s,a){Object.keys(s).forEach(h=>{h!=="__proto__"&&(h in r?A.isObject(r[h])&&A.isObject(s[h])?c(r[h],s[h],a):a&&(r[h]=s[h]):r[h]=s[h])})}e.merge=c;function u(){const r=b.Registry.as(n.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=u;function o(){const r=Object.create(null),s=b.Registry.as(n.Extensions.Configuration).getConfigurationProperties();for(let a in s){let h=s[a].default;d(r,a,h,w=>console.error(`Conflict in default settings: ${w}`))}return r}e.getDefaultValues=o;function l(r){return`[${r}]`}e.keyFromOverrideIdentifier=l;function t(r,s,a){const h=r.inspect(s),w=r.inspect(a);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof w.userValue!="undefined"||typeof w.workspaceValue!="undefined"||typeof w.workspaceFolderValue!="undefined"?w.value:h.defaultValue}e.getMigratedSettingValue=t}),define(J[188],Z([0,1,40,37,36,13,44,7,49,21,38,2,5]),function($,e,m,A,R,b,I,n,v,p,i,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?p.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?p.getConfigurationValue(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const a of R.distinct([...Object.keys(this.contents),...Object.keys(r)])){let h=this.contents[a],w=r[a];w&&(typeof h=="object"&&typeof w=="object"?(h=I.deepClone(h),this.mergeContents(h,w)):h=w),s[a]=h}return new y(s,this.keys,this.overrides)}merge(...t){const r=I.deepClone(this.contents),s=I.deepClone(this.overrides),a=[...this.keys];for(const h of t){this.mergeContents(r,h.contents);for(const w of h.overrides){const[f]=s.filter(S=>R.equals(S.identifiers,w.identifiers));f?this.mergeContents(f.contents,w.contents):s.push(I.deepClone(w))}for(const w of h.keys)a.indexOf(w)===-1&&a.push(w)}return new y(r,a,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&b.isObject(t[s])&&b.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=I.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?I.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),p.addToValueTree(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&p.removeFromValueTree(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=y;class d extends y{constructor(){const t=p.getDefaultValues(),r=p.getConfigurationKeys(),s=[];for(const a of Object.keys(t))v.OVERRIDE_PROPERTY_PATTERN.test(a)&&s.push({identifiers:[v.overrideIdentifierFromKey(a).trim()],keys:Object.keys(t[a]),contents:p.toValuesTree(t[a],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,r,s)}}e.DefaultConfigurationModel=d;class g{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!b.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:s,keys:a,overrides:h,restricted:w}=this.doParseRaw(t,r);this._configurationModel=new y(s,a,h),this._restrictedConfigurations=w||[]}doParseContent(t){let r={},s=null,a=[],h=[],w=[];function f(L){Array.isArray(a)?a.push(L):s&&(a[s]=L)}let S={onObjectBegin:()=>{let L={};f(L),h.push(a),a=L,s=null},onObjectProperty:L=>{s=L},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{let L=[];f(L),h.push(a),a=L,s=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:f,onError:(L,_,H)=>{w.push({error:L,offset:_,length:H})}};if(t)try{m.visit(t,S),r=a[0]||{}}catch(L){console.error(`Error while parsing settings file ${this._name}: ${L}`),this._parseErrors=[L]}return r}doParseRaw(t,r){const s=i.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,s,!0,r);t=a.raw;const h=p.toValuesTree(t,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),w=Object.keys(t),f=p.toOverrides(t,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:h,keys:w,overrides:f,restricted:a.restricted}}filter(t,r,s,a){if(!(a==null?void 0:a.scopes)&&!(a==null?void 0:a.skipRestricted))return{raw:t,restricted:[]};const h={},w=[];for(let f in t)if(v.OVERRIDE_PROPERTY_PATTERN.test(f)&&s){const S=this.filter(t[f],r,!1,a);h[f]=S.raw,w.push(...S.restricted)}else{const S=r[f],L=S?typeof S.scope!="undefined"?S.scope:3:void 0;(S==null?void 0:S.restricted)&&w.push(f),(L===void 0||a.scopes===void 0||a.scopes.includes(L))&&(a.skipRestricted&&(S==null?void 0:S.restricted)||(h[f]=t[f]))}return{raw:h,restricted:w}}}e.ConfigurationModelParser=g;class D extends E.Disposable{constructor(t,r,s,a){super();this.userSettingsResource=t,this.scopes=r,this.fileService=a,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(k.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class P{constructor(t,r,s=new y,a=new y,h=new A.ResourceMap,w=new y,f=new A.ResourceMap,S=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=h,this._memoryConfiguration=w,this._memoryConfigurationByResource=f,this._freeze=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let a;s.resource?(a=this._memoryConfigurationByResource.get(s.resource),a||(a=new y,this._memoryConfigurationByResource.set(s.resource,a))):a=this._memoryConfiguration,r===void 0?a.removeValue(t):a.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const a=this.getConsolidateConfigurationModel(r,s),h=this.getFolderConfigurationModelForResource(r.resource,s),w=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,f=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),S=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),L=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),_=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),H=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,Q=h?r.overrideIdentifier?h.freeze().override(r.overrideIdentifier).getValue(t):h.freeze().getValue(t):void 0,te=r.overrideIdentifier?w.override(r.overrideIdentifier).getValue(t):w.getValue(t),B=a.getValue(t),Y=R.distinct(R.flatten(a.overrides.map(G=>G.identifiers))).filter(G=>a.getOverrideValue(t,G)!==void 0);return{defaultValue:f,userValue:S,userLocalValue:L,userRemoteValue:_,workspaceValue:H,workspaceFolderValue:Q,memoryValue:te,value:B,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:S!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:L!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:H!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:Q!==void 0?{value:h==null?void 0:h.freeze().getValue(t),override:r.overrideIdentifier?h==null?void 0:h.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:te!==void 0?{value:w.getValue(t),override:r.overrideIdentifier?w.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Y.length?Y:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(a=>v.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const h=v.overrideIdentifierFromKey(a),w=this._defaultConfiguration.getKeysForOverrideIdentifier(h),f=t.getKeysForOverrideIdentifier(h),S=[...f.filter(L=>w.indexOf(L)===-1),...w.filter(L=>f.indexOf(L)===-1),...w.filter(L=>!I.equals(this._defaultConfiguration.override(h).getValue(L),t.override(h).getValue(L)))];return[h,S]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:a,overrides:h}=p.compare(this.localUserConfiguration,t),w=[...r,...s,...a];return w.length&&this.updateLocalUserConfiguration(t),{keys:w,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:a,overrides:h}=p.compare(this.remoteUserConfiguration,t);let w=[...r,...s,...a];return w.length&&this.updateRemoteUserConfiguration(t),{keys:w,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:a,overrides:h}=p.compare(this.workspaceConfiguration,t);let w=[...r,...s,...a];return w.length&&this.updateWorkspaceConfiguration(t),{keys:w,overrides:h}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:a,updated:h,removed:w,overrides:f}=p.compare(s,r);let S=[...a,...h,...w];return(S.length||!s)&&this.updateFolderConfiguration(t,r),{keys:S,overrides:f}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:a,removed:h,overrides:w}=p.compare(r,void 0);return{keys:[...s,...a,...h],overrides:w}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const a=r.getFolder(t);a&&(s=this.getFolderConsolidatedConfiguration(a.uri)||s);const h=this._memoryConfigurationByResource.get(t);h&&(s=s.merge(h))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(r=s.merge(a),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:a,keys:h}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:a,keys:h}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),h=t.folders.reduce((w,f)=>(w.set(n.URI.revive(f[0]),this.parseConfigurationModel(f[1])),w),new A.ResourceMap);return new P(r,s,new y,a,h,new y,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new y(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=P;function c(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const t=new Set,r=new Map;for(const a of l)a.keys.forEach(h=>t.add(h)),a.overrides.forEach(([h,w])=>{const f=A.getOrSet(r,h,new Set);w.forEach(S=>f.add(S))});const s=[];return r.forEach((a,h)=>s.push([h,[...a.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=c;class u{constructor(t,r,s,a){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=a,this._previousConfiguration=void 0;const h=new Set;t.keys.forEach(f=>h.add(f)),t.overrides.forEach(([,f])=>f.forEach(S=>h.add(S))),this.affectedKeys=[...h.values()];const w=new y;this.affectedKeys.forEach(f=>w.setValue(f,{})),this.affectedKeysTree=w.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=P.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,h=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!I.equals(a,h)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=p.toValuesTree({[r]:!0},()=>{}),a;for(;typeof s=="object"&&(a=Object.keys(s)[0]);){if(t=t[a],!t)return!1;s=s[a]}return!0}}e.ConfigurationChangeEvent=u;class o extends u{constructor(t,r,s,a){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=o}),define(J[189],Z([0,1,38,49,2,21,188,5,9,15]),function($,e,m,A,R,b,I,n,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends R.Disposable{constructor(k,y){super();this.settingsResource=k,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,p.extUriBiasedIgnorePathCase,y)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(A.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const k=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,k)}getConfigurationData(){return this.configuration.toData()}getValue(k,y){const d=typeof k=="string"?k:void 0,g=b.isConfigurationOverrides(k)?k:b.isConfigurationOverrides(y)?y:{};return this.configuration.getValue(d,g,void 0)}updateValue(k,y,d,g){return Promise.reject(new Error("not supported"))}inspect(k){return this.configuration.inspect(k,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const k=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(k)}onDidChangeUserConfiguration(k){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(k);this.trigger(d,y,1)}onDidDefaultConfigurationChange(k){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,k);this.trigger(d,y,6)}trigger(k,y,d){const g=new I.ConfigurationChangeEvent(k,{data:y},this.configuration);g.source=d,g.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(k){switch(k){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(J[190],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=m.createDecorator("remoteAuthorityResolverService");var A;(function(b){b.Unknown="Unknown",b.NotAvailable="NotAvailable",b.TemporarilyNotAvailable="TemporarilyNotAvailable",b.NoResolverFound="NoResolverFound"})(A=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends Error{constructor(I,n=A.Unknown,v){super(I);this._message=I,this._code=n,this._detail=v,this.isHandled=n===A.NotAvailable&&v===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(I){return I instanceof R&&I._code===A.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof R&&I._code===A.NoResolverFound}static isHandled(I){return I instanceof R&&I.isHandled}}e.RemoteAuthorityResolverError=R}),define(J[191],Z([0,1,85,27,2,17,5,190,16,9,25]),function($,e,m,A,R,b,I,n,v,p,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var k;(function(M){M[M.Management=1]="Management",M[M.ExtensionHost=2]="ExtensionHost",M[M.Tunnel=3]="Tunnel"})(k=e.ConnectionType||(e.ConnectionType={}));function y(M){switch(M){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(M){const W=new i.CancellationTokenSource;return setTimeout(()=>W.cancel(),M),W.token}function g(M,W){if(M.isCancellationRequested||W.isCancellationRequested)return i.CancellationToken.Cancelled;const U=new i.CancellationTokenSource;return M.onCancellationRequested(()=>U.cancel()),W.onCancellationRequested(()=>U.cancel()),U.token}class D{constructor(W){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((U,V)=>{this._resolvePromise=U,this._rejectPromise=V}),W.isCancellationRequested?this._timeout():this._disposables.add(W.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(W){this._state==="pending"?this._disposables.add(W):W.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(W))}reject(W){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(W))}}function P(M,W){const U=new D(W);return U.registerDisposable(M.onControlMessage(V=>{const K=JSON.parse(V.toString()),q=X(K);q?U.reject(q):U.resolve(K)})),U.promise}function c(M,W,U,V,K,q){const x=new D(q);return W.connect(U,V,K,(ne,re)=>{x.didTimeout?(ne&&M.error(ne),re==null||re.dispose()):ne||!re?x.reject(ne):x.resolve(re)}),x.promise}function u(M,W){const U=new D(W);return M.then(V=>{U.didTimeout||U.resolve(V)},V=>{U.didTimeout||U.reject(V)}),U.promise}async function o(M,W,U,V){const K=T(M,W);M.logService.trace(`${K} 1/6. invoking socketFactory.connect().`);let q;try{q=await c(M.logService,M.socketFactory,M.host,M.port,`reconnectionToken=${M.reconnectionToken}&reconnection=${M.reconnectionProtocol?"true":"false"}`,V)}catch(se){throw M.logService.error(`${K} socketFactory.connect() failed or timed out. Error:`),M.logService.error(se),se}M.logService.trace(`${K} 2/6. socketFactory.connect() was successful.`);let x,ne;M.reconnectionProtocol?(M.reconnectionProtocol.beginAcceptReconnection(q,null),x=M.reconnectionProtocol,ne=!1):(x=new m.PersistentProtocol(q,null),ne=!0),M.logService.trace(`${K} 3/6. sending AuthRequest control message.`);const re={type:"auth",auth:M.connectionToken||"00000000000000000000"};x.sendControl(b.VSBuffer.fromString(JSON.stringify(re)));try{const se=await P(x,g(V,d(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const ue=new Error("Unexpected handshake message");throw ue.code="VSCODE_CONNECTION_ERROR",ue}M.logService.trace(`${K} 4/6. received SignRequest control message.`);const le=await u(M.signService.sign(se.data),V),oe={type:"connectionType",commit:M.commit,signedData:le,desiredConnectionType:W};return U&&(oe.args=U),M.logService.trace(`${K} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(b.VSBuffer.fromString(JSON.stringify(oe))),{protocol:x,ownsProtocol:ne}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(M.logService.error(`${K} the handshake timed out. Error:`),M.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(M.logService.error(`${K} received error control message when negotiating connection. Error:`),M.logService.error(se)),ne&&z(x),se}}async function l(M,W,U,V){const K=Date.now(),q=T(M,W),{protocol:x,ownsProtocol:ne}=await o(M,W,U,V),re=new D(V);return re.registerDisposable(x.onControlMessage(se=>{const le=JSON.parse(se.toString()),oe=X(le);oe?(M.logService.error(`${q} received error control message when negotiating connection. Error:`),M.logService.error(oe),ne&&z(x),re.reject(oe)):(M.reconnectionProtocol&&M.reconnectionProtocol.endAcceptReconnection(),M.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${O(K)}!`),re.resolve({protocol:x,firstMessage:le}))})),re.promise}async function t(M,W){const{protocol:U}=await l(M,1,void 0,W);return{protocol:U}}async function r(M,W,U){const{protocol:V,firstMessage:K}=await l(M,2,W,U),q=K&&K.debugPort;return{protocol:V,debugPort:q}}async function s(M,W,U){const V=Date.now(),K=T(M,3),{protocol:q}=await o(M,3,W,U);return M.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${O(V)}!`),q}async function a(M,W,U){const{host:V,port:K,connectionToken:q}=await M.addressProvider.getAddress();return{commit:M.commit,host:V,port:K,connectionToken:q,reconnectionToken:W,reconnectionProtocol:U,socketFactory:M.socketFactory,signService:M.signService,logService:M.logService}}async function h(M,W,U){try{const V=A.generateUuid(),K=await a(M,V,null),{protocol:q}=await t(K,i.CancellationToken.None);return new G(M,W,U,V,q)}catch(V){throw M.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),M.logService.error(V),Y.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(V)),V}}e.connectRemoteAgentManagement=h;async function w(M,W){try{const U=A.generateUuid(),V=await a(M,U,null),{protocol:K,debugPort:q}=await r(V,W,i.CancellationToken.None);return new C(M,W,U,K,q)}catch(U){throw M.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),M.logService.error(U),Y.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(U)),U}}e.connectRemoteAgentExtensionHost=w;async function f(M,W){const U=await a(M,A.generateUuid(),null);return await s(U,{port:W},i.CancellationToken.None)}e.connectRemoteAgentTunnel=f;function S(M){return p.createCancelablePromise(W=>new Promise((U,V)=>{const K=setTimeout(U,M*1e3);W.onCancellationRequested(()=>{clearTimeout(K),U()})}))}var L;(function(M){M[M.ConnectionLost=0]="ConnectionLost",M[M.ReconnectionWait=1]="ReconnectionWait",M[M.ReconnectionRunning=2]="ReconnectionRunning",M[M.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",M[M.ConnectionGain=4]="ConnectionGain"})(L=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class _{constructor(W,U){this.reconnectionToken=W,this.millisSinceLastIncomingData=U,this.type=0}}e.ConnectionLostEvent=_;class H{constructor(W,U,V,K){this.reconnectionToken=W,this.millisSinceLastIncomingData=U,this.durationSeconds=V,this.cancellableTimer=K,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=H;class Q{constructor(W,U,V){this.reconnectionToken=W,this.millisSinceLastIncomingData=U,this.attempt=V,this.type=2}}e.ReconnectionRunningEvent=Q;class te{constructor(W,U,V){this.reconnectionToken=W,this.millisSinceLastIncomingData=U,this.attempt=V,this.type=4}}e.ConnectionGainEvent=te;class B{constructor(W,U,V,K){this.reconnectionToken=W,this.millisSinceLastIncomingData=U,this.attempt=V,this.handled=K,this.type=3}}e.ReconnectionPermanentFailureEvent=B;class Y extends R.Disposable{constructor(W,U,V,K){super();this._connectionType=W,this._onDidStateChange=this._register(new I.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=U,this.reconnectionToken=V,this.protocol=K,this._isReconnecting=!1,this._onDidStateChange.fire(new te(this.reconnectionToken,0,0)),this._register(K.onSocketClose(q=>{const x=F(this._connectionType,this.reconnectionToken,!0);q?q.type===0?(this._options.logService.info(`${x} received socket close event (hadError: ${q.hadError}).`),q.error&&this._options.logService.error(q.error)):(this._options.logService.info(`${x} received socket close event (wasClean: ${q.wasClean}, code: ${q.code}, reason: ${q.reason}).`),q.event&&this._options.logService.error(q.event)):this._options.logService.info(`${x} received socket close event.`),this._beginReconnecting()})),this._register(K.onSocketTimeout(()=>{const q=F(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${q} received socket timeout event.`),this._beginReconnecting()})),Y._instances.push(this),Y._permanentFailure&&this._gotoPermanentFailure(Y._permanentFailureMillisSinceLastIncomingData,Y._permanentFailureAttempt,Y._permanentFailureHandled)}static triggerPermanentFailure(W,U,V){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=W,this._permanentFailureAttempt=U,this._permanentFailureHandled=V,this._instances.forEach(K=>K._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(Y._permanentFailure)return;const W=F(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let V=-1;do{V++;const K=V<U.length?U[V]:U[U.length-1];try{if(K>0){const x=S(K);this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K,x)),this._options.logService.info(`${W} waiting for ${K} seconds before reconnecting...`);try{await x}catch(ne){}}if(Y._permanentFailure){this._options.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V+1)),this._options.logService.info(`${W} resolving connection...`);const q=await a(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${W} connecting to ${q.host}:${q.port}...`),await this._reconnect(q,d(E)),this._options.logService.info(`${W} reconnected!`),this._onDidStateChange.fire(new te(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(q),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}if(V>360){this._options.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(q),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(q)){this._options.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this._options.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if(v.isPromiseCanceledError(q)){this._options.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if(q instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(q),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),V+1,n.RemoteAuthorityResolverError.isHandled(q));break}this._options.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(q),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}}while(!Y._permanentFailure)}_gotoPermanentFailure(W,U,V){this._onDidStateChange.fire(new B(this.reconnectionToken,W,U,V)),z(this.protocol)}}Y._permanentFailure=!1,Y._permanentFailureMillisSinceLastIncomingData=0,Y._permanentFailureAttempt=0,Y._permanentFailureHandled=!1,Y._instances=[];class G extends Y{constructor(W,U,V,K,q){super(1,W,K,q);this.client=this._register(new m.Client(q,{remoteAuthority:U,clientId:V},W.ipcLogger))}async _reconnect(W,U){await t(W,U)}}e.ManagementPersistentConnection=G;class C extends Y{constructor(W,U,V,K,q){super(2,W,V,K);this._startArguments=U,this.debugPort=q}async _reconnect(W,U){await r(W,this._startArguments,U)}}e.ExtensionHostPersistentConnection=C;function z(M){try{M.acceptDisconnect();const W=M.getSocket();M.dispose(),W.dispose()}catch(W){v.onUnexpectedError(W)}}function X(M){if(M&&M.type==="error"){const W=new Error(`Connection error: ${M.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function N(M,W){for(;M.length<W;)M+=" ";return M}function F(M,W,U){return`[remote-connection][${N(y(M),13)}][${W.substr(0,5)}\u2026][${U?"reconnect":"initial"}]`}function T(M,W){return`${F(W,M.reconnectionToken,!!M.reconnectionProtocol)}[${M.host}:${M.port}]`}function O(M){return`${Date.now()-M} ms`}}),define(J[73],Z([0,1,10]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function A(p){return p.scheme===m.Schemas.vscodeRemote?p.authority:void 0}e.getRemoteAuthority=A;function R(p){if(!p)return;const i=p.indexOf("+");return i<0?p:p.substr(0,i)}e.getRemoteName=R;function b(p){return p.scheme!==m.Schemas.file&&p.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=b;function I(p){if(p.folders.length)return p.folders.every(i=>b(i.uri))?p.folders[0].uri:void 0;if(p.configuration&&b(p.configuration))return p.configuration}e.getVirtualWorkspaceLocation=I;function n(p){var i;return(i=I(p))===null||i===void 0?void 0:i.scheme}e.getVirtualWorkspaceScheme=n;function v(p){return I(p)!==void 0}e.isVirtualWorkspace=v}),define(J[74],Z([0,1,5,3,4,6]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=R.createDecorator("tunnelService");var I;(function(y){y.Http="http",y.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var n;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(n=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function v(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=v,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function p(y){return e.LOCALHOST_ADDRESSES.indexOf(y)>=0}e.isLocalhost=p,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function i(y){return e.ALL_INTERFACES_ADDRESSES.indexOf(y)>=0}e.isAllInterfaces=i;function E(y,d){return d?d!==1&&y<1024:!A.isWindows&&y<1024}e.isPortPrivileged=E;let k=class{constructor(d){this.logService=d,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d,g){return this._tunnelProvider=d,d?(this._canElevate=g.elevation,this._canMakePublic=g.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async d=>{const g=[],D=Array.from(this._tunnels.values());for(let P of D){const c=Array.from(P.values());for(let u of c){const o=await u.value;o&&g.push(o)}}d(g)})}async dispose(){for(const d of this._tunnels.values()){for(const{value:g}of d.values())await g.then(D=>D==null?void 0:D.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,g,D,P,c=!1,u=!1,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${D} on local port ${P}.`),!d)return;g||(g="localhost");const l=this.retainOrCreateTunnel(d,g,D,P,c,u,o);return l?l.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,D);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(t);return(t.tunnelRemoteHost!==g||t.tunnelRemotePort!==D)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,public:d.public,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const g=this._tunnels.get(d.tunnelRemoteHost);if(g){const D=g.get(d.tunnelRemotePort);D&&(D.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,D))}}}}async tryDisposeTunnel(d,g,D){if(D.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${g}.`);const P=D.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(g),P}}async closeTunnel(d,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${g} `);const D=this._tunnels.get(d);if(D&&D.has(g)){const P=D.get(g);P.refcount=0,await this.tryDisposeTunnel(d,g,P)}}addTunnelToMap(d,g,D){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(g,{refcount:1,value:D})}async removeEmptyTunnelFromMap(d,g){const D=this._tunnels.get(d);D&&(await D.get(g)||D.delete(g),D.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,g){let D=[d];p(d)?(D.push(...e.LOCALHOST_ADDRESSES),D.push(...e.ALL_INTERFACES_ADDRESSES)):i(d)&&D.push(...e.ALL_INTERFACES_ADDRESSES);const P=D.map(c=>this._tunnels.get(c));for(const c of P){const u=c==null?void 0:c.get(g);if(u)return u}}canTunnel(d){return!!v(d)}createWithProvider(d,g,D,P,c,u,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${D} on local port ${P}.`);const t={elevationRequired:c?E(P===void 0?D:P):!1},r={remoteAddress:{host:g,port:D},localAddressPort:P,public:u,protocol:o},s=d.forwardPort(r,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),s&&this.addTunnelToMap(g,D,s),s}};k=he([ee(0,b.ILogService)],k),e.AbstractTunnelService=k}),define(J[50],Z([0,1,146,4,49,38,17]),function($,e,m,A,R,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=A.createDecorator("requestService");function n(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=n;function v(d){return d.res.statusCode===204}async function p(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);return v(d)?null:(await I.streamToBuffer(d.stream)).toString()}e.asText=p;async function i(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);if(v(d))return null;const D=(await I.streamToBuffer(d.stream)).toString();try{return JSON.parse(D)}catch(P){throw P.message+=`:
`+D,P}}e.asJson=i;function E(d){y(d)}e.updateProxyConfigurationsScope=E;let k;function y(d){const g=b.Registry.as(R.Extensions.Configuration);k&&g.deregisterConfigurations([k]),k={id:"http",order:15,title:m.localize(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:m.localize(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:m.localize(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:m.localize(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[m.localize(4,null),m.localize(5,null),m.localize(6,null),m.localize(7,null)],default:"override",description:m.localize(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:m.localize(9,null),restricted:!0}}},g.registerConfiguration(k)}y(2)}),define(J[192],Z([0,1,193,13]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function R(I,n){return I.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:I.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function b(I,n,v={}){const p=m.parse(I),i=v.proxyUrl||R(p,n);if(!i)return null;const E=m.parse(i);if(!/^https?:$/.test(E.protocol||""))return null;const k={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:A.isBoolean(v.strictSSL)?v.strictSSL:!0};return p.protocol==="http:"?new(await new Promise((y,d)=>{$(["http-proxy-agent"],y,d)}))(k):new(await new Promise((y,d)=>{$(["https-proxy-agent"],y,d)}))(k)}e.getProxyAgent=b}),define(J[194],Z([0,1,27,17]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(b,I,n){let v=n&&n.get("storage.serviceMachineId",0)||null;if(v)return v;try{const i=(await I.readFile(b.serviceMachineIdResource)).value.toString();v=m.isUUID(i)?i:null}catch(p){v=null}if(!v){v=m.generateUuid();try{await I.writeFile(b.serviceMachineIdResource,A.VSBuffer.fromString(v))}catch(p){}}return n&&n.store("storage.serviceMachineId",v,0,1),v}e.getServiceMachineId=R}),define(J[75],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=m.createDecorator(e.SIGN_SERVICE_ID)}),define(J[195],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{vsda(){return new Promise((R,b)=>$(["vsda"],R,b))}async sign(R){try{const b=await this.vsda(),I=new b.signer;if(I)return I.sign(R)}catch(b){}return R}}e.SignService=m}),define(J[39],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=m.createDecorator("stateMainService")}),define(J[22],Z([0,1,14,6,39,5,4,177,3,2,9,13,33]),function($,e,m,A,R,b,I,n,v,p,i,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=I.createDecorator("lifecycleMainService");var y;(function(D){D[D.CLOSE=1]="CLOSE",D[D.QUIT=2]="QUIT",D[D.RELOAD=3]="RELOAD",D[D.LOAD=4]="LOAD"})(y=e.UnloadReason||(e.UnloadReason={}));var d;(function(D){D[D.Starting=1]="Starting",D[D.Ready=2]="Ready",D[D.AfterWindowOpen=3]="AfterWindowOpen"})(d=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let g=class lt extends p.Disposable{constructor(P,c){super();this.logService=P,this.stateMainService=c,this._onBeforeShutdown=this._register(new b.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new b.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new b.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new b.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new b.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(lt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(lt.QUIT_AND_RESTART_KEY)}registerListeners(){const P=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),v.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};m.app.addListener("before-quit",P);const c=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!v.isMacintosh)&&m.app.quit()};m.app.addListener("window-all-closed",c),m.app.once("will-quit",u=>{this.logService.trace("Lifecycle#app.on(will-quit)"),u.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),m.app.removeListener("before-quit",P),m.app.removeListener("window-all-closed",c),m.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const P=[];return this._onWillShutdown.fire({join(c){P.push(c)}}),this.pendingWillShutdownPromise=(async()=>{try{await i.Promises.settled(P)}catch(c){this.logService.error(c)}try{await this.stateMainService.close()}catch(c){this.logService.error(c)}})(),this.pendingWillShutdownPromise}set phase(P){if(P<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===P)return;this.logService.trace(`lifecycle (main): phase changed (value: ${P})`),this._phase=P;const c=this.phaseWhen.get(this._phase);c&&(c.open(),this.phaseWhen.delete(this._phase))}async when(P){if(P<=this._phase)return;let c=this.phaseWhen.get(P);c||(c=new i.Barrier,this.phaseWhen.set(P,c)),await c.wait()}registerWindow(P){const c=new p.DisposableStore;this.windowCounter++,c.add(P.onWillLoad(o=>this._onWillLoadWindow.fire({window:P,workspace:o.workspace})));const u=E.assertIsDefined(P.win);u.on("close",o=>{const l=P.id;if(this.windowToCloseRequest.has(l)){this.windowToCloseRequest.delete(l);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${P.id}`),o.preventDefault(),this.unload(P,1).then(t=>{if(t){this.windowToCloseRequest.delete(l);return}this.windowToCloseRequest.add(l),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${l}`),this._onBeforeCloseWindow.fire(P),P.close()})}),u.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${P.id}`),this.windowCounter--,c.dispose(),this.windowCounter===0&&(!v.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(P,c){await this.unload(P,3)||P.reload(c)}async unload(P,c){if(!P.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${P.id}`);const u=this._quitRequested?2:c;let o=await this.onBeforeUnloadWindowInRenderer(P,u);return o?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${P.id})`),this.handleWindowUnloadVeto(o)):(o=await this.onBeforeUnloadWindowInMain(P,u),o?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${P.id})`),this.handleWindowUnloadVeto(o)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${P.id})`),await this.onWillUnloadWindowInRenderer(P,u),!1))}handleWindowUnloadVeto(P){return P?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(P){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(P),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(P,c){return new Promise(u=>{const o=this.oneTimeListenerTokenGenerator++,l=`vscode:ok${o}`,t=`vscode:cancel${o}`;m.ipcMain.once(l,()=>{u(!1)}),m.ipcMain.once(t,()=>{u(!0)}),P.send("vscode:onBeforeUnload",{okChannel:l,cancelChannel:t,reason:c})})}onBeforeUnloadWindowInMain(P,c){const u=[];return this._onBeforeUnloadWindow.fire({reason:c,window:P,veto(o){u.push(o)}}),n.handleVetos(u,o=>this.logService.error(o))}onWillUnloadWindowInRenderer(P,c){return new Promise(u=>{const l=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;m.ipcMain.once(l,()=>u()),P.send("vscode:onWillUnload",{replyChannel:l,reason:c})})}quit(P){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${P}`),P&&this.stateMainService.setItem(lt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(c=>{this.pendingQuitPromiseResolve=c,this.logService.trace("Lifecycle#quit() - calling app.quit()"),m.app.quit()}),this.pendingQuitPromise)}async relaunch(P){this.logService.trace("Lifecycle#relaunch()");const c=process.argv.slice(1);if((P==null?void 0:P.addArgs)&&c.push(...P.addArgs),P==null?void 0:P.removeArgs)for(const l of P.removeArgs){const t=c.indexOf(l);t>=0&&c.splice(t,1)}const u=()=>{try{if(v.isWindows){const l=k.cwd();l!==process.cwd()&&process.chdir(l)}}catch(l){this.logService.error(l)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),m.app.relaunch({args:c})};m.app.once("quit",u),await this.quit(!0)&&m.app.removeListener("quit",u)}async kill(P){this.logService.trace("Lifecycle#kill()"),await Promise.race([i.timeout(1e3),(async()=>{for(const c of m.BrowserWindow.getAllWindows())if(c&&!c.isDestroyed()){let u;c.webContents&&!c.webContents.isDestroyed()?u=new Promise(o=>c.once("closed",o)):u=Promise.resolve(),c.destroy(),await u}})()]),m.app.exit(P)}};g.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",g=he([ee(0,A.ILogService),ee(1,R.IStateMainService)],g),e.LifecycleMainService=g}),define(J[196],Z([0,1,4,5,2,22]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=m.createDecorator("keyboardLayoutMainService");let I=class extends R.Disposable{constructor(p){super();this._onDidChangeKeyboardLayout=this._register(new A.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,p.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const p=await new Promise((i,E)=>{$(["native-keymap"],i,E)});this._keyboardLayoutData=n(p),p.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(p),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};I=he([ee(0,b.ILifecycleMainService)],I),e.KeyboardLayoutMainService=I;function n(v){const p=v.getKeyMap(),i=v.getCurrentKeyboardLayout();return{keyboardMapping:p,keyboardLayoutInfo:i}}}),define(J[97],Z([0,1,4,5,2,13,87,9]),function($,e,m,A,R,b,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const v="__$__targetStorageMarker";e.IStorageService=m.createDecorator("storageService");var p;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(p=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var E;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(E=e.StorageTarget||(e.StorageTarget={}));class k extends R.Disposable{constructor(D={flushInterval:k.DEFAULT_FLUSH_INTERVAL}){super();this.options=D,this._onDidChangeValue=this._register(new A.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new A.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new A.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new n.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=n.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){R.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(D,P){P===v?(D===0?this._globalKeyTargets=void 0:D===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:D})):this._onDidChangeValue.fire({scope:D,key:P,target:this.getKeyTargets(D)[P]})}emitWillSaveState(D){this._onWillSaveState.fire({reason:D})}get(D,P,c){var u;return(u=this.getStorage(P))===null||u===void 0?void 0:u.get(D,c)}getBoolean(D,P,c){var u;return(u=this.getStorage(P))===null||u===void 0?void 0:u.getBoolean(D,c)}getNumber(D,P,c){var u;return(u=this.getStorage(P))===null||u===void 0?void 0:u.getNumber(D,c)}store(D,P,c,u){if(b.isUndefinedOrNull(P)){this.remove(D,c);return}this.withPausedEmitters(()=>{var o;this.updateKeyTarget(D,c,u),(o=this.getStorage(c))===null||o===void 0||o.set(D,P)})}remove(D,P){this.withPausedEmitters(()=>{var c;this.updateKeyTarget(D,P,void 0),(c=this.getStorage(P))===null||c===void 0||c.delete(D)})}withPausedEmitters(D){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{D()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(D,P){const c=[],u=this.getKeyTargets(D);for(const o of Object.keys(u))u[o]===P&&c.push(o);return c}updateKeyTarget(D,P,c){var u,o;const l=this.getKeyTargets(P);typeof c=="number"?l[D]!==c&&(l[D]=c,(u=this.getStorage(P))===null||u===void 0||u.set(v,JSON.stringify(l))):typeof l[D]=="number"&&(delete l[D],(o=this.getStorage(P))===null||o===void 0||o.set(v,JSON.stringify(l)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(D){return D===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(D){const P=this.get(v,D);if(P)try{return JSON.parse(P)}catch(c){}return Object.create(null)}isNew(D){return this.getBoolean(e.IS_NEW_KEY,D)===!0}async flush(){var D,P,c,u;this._onWillSaveState.fire({reason:p.NONE}),await n.Promises.settled([(P=(D=this.getStorage(0))===null||D===void 0?void 0:D.whenFlushed())!==null&&P!==void 0?P:Promise.resolve(),(u=(c=this.getStorage(1))===null||c===void 0?void 0:c.whenFlushed())!==null&&u!==void 0?u:Promise.resolve()])}async logStorage(){var D,P,c,u,o,l;const t=(P=(D=this.getStorage(0))===null||D===void 0?void 0:D.items)!==null&&P!==void 0?P:new Map,r=(u=(c=this.getStorage(1))===null||c===void 0?void 0:c.items)!==null&&u!==void 0?u:new Map;return d(t,r,(o=this.getLogDetails(0))!==null&&o!==void 0?o:"",(l=this.getLogDetails(1))!==null&&l!==void 0?l:"")}}e.AbstractStorageService=k,k.DEFAULT_FLUSH_INTERVAL=60*1e3;class y extends k{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(D=>this.emitDidChangeValue(1,D))),this._register(this.globalStorage.onDidChangeStorage(D=>this.emitDidChangeValue(0,D)))}getStorage(D){return D===0?this.globalStorage:this.workspaceStorage}getLogDetails(D){return D===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(D){}}e.InMemoryStorageService=y;async function d(g,D,P,c){const u=h=>{try{return JSON.parse(h)}catch(w){return h}},o=new Map,l=new Map;g.forEach((h,w)=>{o.set(w,h),l.set(w,u(h))});const t=new Map,r=new Map;D.forEach((h,w)=>{t.set(w,h),r.set(w,u(h))}),console.group(`Storage: Global (path: ${P})`);let s=[];o.forEach((h,w)=>{s.push({key:w,value:h})}),console.table(s),console.groupEnd(),console.log(l),console.group(`Storage: Workspace (path: ${c})`);let a=[];t.forEach((h,w)=>{a.push({key:w,value:h})}),console.table(a),console.groupEnd(),console.log(r)}e.logStorage=d}),define(J[197],Z([0,1,3,33,27,7]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function I(p){if(m.platform===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}async function n(p,i,E,k,y,d,g,D,P,c){const u=Object.create(null);u["common.machineId"]=g,u.sessionID=R.generateUuid()+Date.now(),u.commitHash=y,u.version=d,u["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=m.PlatformToString(m.platform),u["common.nodePlatform"]=A.platform,u["common.nodeArch"]=k,u["common.product"]=c||"desktop";const o=v(D||[]);o&&(u["common.msftInternal"]=o);let l=0;const t=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),m.isLinuxSnap&&(u["common.snap"]="true");const r=I(E);r&&(u["common.platformDetail"]=r);try{const s=await p.readFile(b.URI.file(P));u["common.source"]=s.value.toString().slice(0,30)}catch(s){}return u}e.resolveCommonProperties=n;function v(p){const i=A.env.USERDNSDOMAIN;if(!i)return!1;const E=i.toLowerCase();return p.some(k=>E===k)}e.verifyMicrosoftInternalDomain=v}),define(J[32],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=m.createDecorator("telemetryService"),e.ICustomEndpointTelemetryService=m.createDecorator("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(J[198],Z([0,1,26,66,70,8,40,84,20,3,7,32,63,10,19,18]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function D(l,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],s=new Map,a=new Map,h=2e4;function w(L,_,H,Q){const te=_.substring(L.length+1);return new Promise(async B=>{var Y,G,C;let z;try{z=await g.Promises.readdir(_,{withFileTypes:!0})}catch(F){B();return}if(Q.count>=h){Q.count+=z.length,Q.maxReached=!0,B();return}let X=z.length;if(X===0){B();return}let N=z;Q.count+z.length>h&&(Q.maxReached=!0,X=h-Q.count,N=z.slice(0,X)),Q.count+=z.length;for(const F of N)if(F.isDirectory()){if(H.includes(F.name)||await w(L,b.join(_,F.name),H,Q),--X==0){B();return}}else{const T=F.name.lastIndexOf(".");if(T>=0){const O=F.name.substring(T+1);O&&s.set(O,((Y=s.get(O))!==null&&Y!==void 0?Y:0)+1)}for(const O of r)((G=O.relativePathPattern)===null||G===void 0?void 0:G.test(te))!==!1&&O.filePattern.test(F.name)&&a.set(O.tag,((C=a.get(O.tag))!==null&&C!==void 0?C:0)+1);if(--X==0){B();return}}})}const f={count:0,maxReached:!1};await w(l,l,t,f);const S=await u(l);return{configFiles:P(a),fileTypes:P(s),fileCount:f.count,maxFilesReached:f.maxReached,launchConfigFiles:S}}e.collectWorkspaceStats=D;function P(l){return[...k.Iterable.map(l.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function c(){const l={os:`${m.type()} ${m.arch()} ${m.release()}`,memory:`${(m.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(A.virtualMachineHint.value()*100)}%`},t=m.cpus();return t&&t.length>0&&(l.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),l}e.getMachineInfo=c;async function u(l){try{const t=new Map,r=b.join(l,".vscode","launch.json"),s=await g.Promises.readFile(r),a=[],h=I.parse(s.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if(I.getNodeType(h)==="object"&&h.configurations)for(const w of h.configurations){const f=w.type;f&&(t.has(f)?t.set(f,t.get(f)+1):t.set(f,1))}return P(t)}catch(t){return[]}}e.collectLaunchConfigs=u;let o=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${m.type()} ${m.arch()} ${m.release()}`);const s=m.cpus();return s&&s.length>0&&r.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),r.push(`Memory (System):  ${(m.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),p.isWindows||r.push(`Load (avg):       ${m.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(A.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([n.listProcesses(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async s=>{let[a,h]=s,w=this.formatProcessList(t,a);return r.forEach(f=>{if(R.isRemoteDiagnosticError(f))w+=`
${f.errorMessage}`,h+=`
${f.errorMessage}`;else if(w+=`

Remote: ${f.hostName}`,f.processes&&(w+=`
${this.formatProcessList(t,f.processes)}`),f.workspaceMetadata){h+=`
|  Remote: ${f.hostName}`;for(const S of Object.keys(f.workspaceMetadata)){const L=f.workspaceMetadata[S];let _=`${L.fileCount} files`;L.maxFilesReached&&(_=`more than ${_}`),h+=`|    Folder (${S}): ${_}`,h+=this.formatWorkspaceStats(L)}}}),{processInfo:w,workspaceInfo:h}})}async getSystemInfo(t,r){const{memory:s,vmHint:a,os:h,cpus:w}=c(),f={os:h,memory:s,cpus:w,vmHint:a,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return p.isWindows||(f.load=`${m.loadavg().map(S=>Math.round(S)).join(", ")}`),p.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(t,r){const s=[];return n.listProcesses(t.mainPID).then(async a=>(s.push(""),s.push(this.formatEnvironment(t)),s.push(""),s.push(this.formatProcessList(t,a)),t.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(t))),r.forEach(h=>{if(R.isRemoteDiagnosticError(h))s.push(`
${h.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${h.hostName}`),s.push(this.formatMachineInfo(h.machineInfo)),h.processes&&s.push(this.formatProcessList(t,h.processes)),h.workspaceMetadata)for(const w of Object.keys(h.workspaceMetadata)){const f=h.workspaceMetadata[w];let S=`${f.fileCount} files`;f.maxFilesReached&&(S=`more than ${S}`),s.push(`Folder (${w}): ${S}`),s.push(this.formatWorkspaceStats(f))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(t){const r=[],s=60;let a=0;const h=(L,_)=>{const H=` ${L}(${_})`;a+H.length>s?(r.push(w),w="|                 ",a=w.length):a+=H.length,w+=H};let w="|      File types:";const f=10;let S=t.fileTypes.length>f?f:t.fileTypes.length;for(let L=0;L<S;L++){const _=t.fileTypes[L];h(_.name,_.count)}if(r.push(w),t.configFiles.length>=0&&(w="|      Conf files:",a=0,t.configFiles.forEach(L=>{h(L.name,L.count)}),r.push(w)),t.launchConfigFiles.length>0){let L="|      Launch Configs:";t.launchConfigFiles.forEach(_=>{L+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),r.push(L)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(s=>s.length));return Object.keys(t).map(s=>`${s}:  ${" ".repeat(r-s.length)}  ${t[s]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],s=[];return t.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(h=>{const w=i.URI.revive(h);if(w.scheme===y.Schemas.file){const f=w.fsPath;s.push(D(f,["node_modules",".git"]).then(S=>{let L=`${S.fileCount} files`;S.maxFilesReached&&(L=`more than ${L}`),r.push(`|    Folder (${b.basename(f)}): ${L}`),r.push(this.formatWorkspaceStats(S))}).catch(S=>{r.push(`|      Error: Unable to collect workspace stats for folder ${f} (${S.toString()})`)}))}else r.push(`|    Folder (${w.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(t,r){const s=new Map;t.windows.forEach(h=>s.set(h.pid,h.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,s,a,r,0),a.join(`
`)}formatProcessItem(t,r,s,a,h){const w=h===0;let f;w?f=a.pid===t?`${this.productService.applicationName} main`:"remote agent":(f=`${"  ".repeat(h)} ${a.name}`,a.name==="window"&&(f=`${f} (${r.get(a.pid)})`));const S=process.platform==="win32"?a.mem:m.totalmem()*(a.mem/100);s.push(`${a.load.toFixed(0).padStart(5," ")}	${(S/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(a.children)&&a.children.forEach(L=>this.formatProcessItem(t,r,s,L,h+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const s=i.URI.revive(r);if(s.scheme!==y.Schemas.file)continue;const a=s.fsPath;try{const h=await D(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),h.fileTypes.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:w.name,count:w.count})}),h.launchConfigFiles.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:w.name,count:w.count})}),h.configFiles.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:w.name,count:w.count})})}catch(h){}}}};o=he([ee(0,E.ITelemetryService),ee(1,v.IProductService)],o),e.DiagnosticsService=o}),define(J[199],Z([0,1,16,168,171,44,32,50,162,47,25,6,19,7,20,97,194,4,15]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d,g,D,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var u;(function(F){F[F.None=0]="None",F[F.IncludeVersions=1]="IncludeVersions",F[F.IncludeFiles=2]="IncludeFiles",F[F.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",F[F.IncludeSharedAccounts=8]="IncludeSharedAccounts",F[F.IncludeVersionProperties=16]="IncludeVersionProperties",F[F.ExcludeNonValidated=32]="ExcludeNonValidated",F[F.IncludeInstallationTargets=64]="IncludeInstallationTargets",F[F.IncludeAssetUri=128]="IncludeAssetUri",F[F.IncludeStatistics=256]="IncludeStatistics",F[F.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",F[F.Unpublished=4096]="Unpublished"})(u||(u={}));function o(...F){return String(F.reduce((T,O)=>T|O,0))}var l;(function(F){F[F.Tag=1]="Tag",F[F.ExtensionId=4]="ExtensionId",F[F.Category=5]="Category",F[F.ExtensionName=7]="ExtensionName",F[F.Target=8]="Target",F[F.Featured=9]="Featured",F[F.SearchText=10]="SearchText",F[F.ExcludeWithFlags=12]="ExcludeWithFlags"})(l||(l={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:u.None,criteria:[],assetTypes:[]};class h{constructor(T=a){this.state=T}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(T,O=this.state.pageSize){return new h(Object.assign(Object.assign({},this.state),{pageNumber:T,pageSize:O}))}withFilter(T,...O){const M=[...this.state.criteria,...O.length?O.map(W=>({filterType:T,value:W})):[{filterType:T}]];return new h(Object.assign(Object.assign({},this.state),{criteria:M}))}withSortBy(T){return new h(Object.assign(Object.assign({},this.state),{sortBy:T}))}withSortOrder(T){return new h(Object.assign(Object.assign({},this.state),{sortOrder:T}))}withFlags(...T){return new h(Object.assign(Object.assign({},this.state),{flags:T.reduce((O,M)=>O|M,0)}))}withAssetTypes(...T){return new h(Object.assign(Object.assign({},this.state),{assetTypes:T}))}get raw(){const{criteria:T,pageNumber:O,pageSize:M,sortBy:W,sortOrder:U,flags:V,assetTypes:K}=this.state;return{filters:[{criteria:T,pageNumber:O,pageSize:M,sortBy:W,sortOrder:U}],assetTypes:K,flags:V}}get searchText(){const T=this.state.criteria.filter(O=>O.filterType===l.SearchText)[0];return T&&T.value?T.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(T=>String(T.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function w(F,T){const O=(F||[]).filter(M=>M.statisticName===T)[0];return O?O.value:0}function f(F){const T="Microsoft.VisualStudio.Code.Translation.";return F.files.filter(M=>M.assetType.indexOf(T)===0).reduce((M,W)=>{const U=H(F,W.assetType);return U&&M.push([W.assetType.substring(T.length),U]),M},[])}function S(F){if(F.properties){const T=F.properties.filter(W=>W.key===t.Repository),O=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),M=T.filter(W=>O.test(W.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return H(F,t.Repository)}function L(F){return{uri:`${F.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${F.fallbackAssetUri}/${t.VSIX}`}}function _(F){const T=H(F,t.Icon);if(T)return T;const O=A.DefaultIconPath;return{uri:O,fallbackUri:O}}function H(F,T){return F.files.filter(M=>M.assetType===T)[0]?{uri:`${F.assetUri}/${T}`,fallbackUri:`${F.fallbackAssetUri}/${T}`}:null}function Q(F,T){const O=F.properties?F.properties.filter(W=>W.key===T):[],M=O.length>0&&O[0].value;return M?M.split(",").map(W=>R.adoptToGalleryExtensionId(W)):[]}function te(F){const T=F.properties?F.properties.filter(O=>O.key===r.Engine):[];return T.length>0&&T[0].value||""}function B(F){const T=F.properties?F.properties.filter(M=>M.key===r.LocalizedLanguages):[],O=T.length>0&&T[0].value||"";return O?O.split(","):[]}function Y(F){return F.indexOf("preview")!==-1}function G(F){const T=F.properties?F.properties.find(O=>O.key===r.WebExtension):void 0;return!!T&&T.value==="true"}function C(F){return F.files.some(T=>T.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?c.joinPath(y.URI.parse(F.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function z(F,T,O,M,W){const U={manifest:H(T,t.Manifest),readme:H(T,t.Details),changelog:H(T,t.Changelog),license:H(T,t.License),repository:S(T),download:L(T),icon:_(T),coreTranslations:f(T)};return{identifier:{id:R.getGalleryExtensionId(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},name:F.extensionName,version:T.version,date:T.lastUpdated,displayName:F.displayName,publisherId:F.publisher.publisherId,publisher:F.publisher.publisherName,publisherDisplayName:F.publisher.displayName,description:F.shortDescription||"",installCount:w(F.statistics,"install"),rating:w(F.statistics,"averagerating"),ratingCount:w(F.statistics,"ratingcount"),assetUri:y.URI.parse(T.assetUri),webResource:C(T),assetTypes:T.files.map(({assetType:V})=>V),assets:U,properties:{dependencies:Q(T,r.Dependency),extensionPack:Q(T,r.ExtensionPack),engine:te(T),localizedLanguages:B(T),webExtension:G(T)},telemetryData:{index:(M.pageNumber-1)*M.pageSize+O,querySource:W},preview:Y(F.flags)}}let X=class{constructor(T,O,M,W,U,V,K){this.requestService=T,this.logService=O,this.environmentService=M,this.telemetryService=W,this.fileService=U,this.productService=V;const q=V.extensionsGallery;this.extensionsGalleryUrl=q&&q.serviceUrl,this.extensionsControlUrl=q&&q.controlUrl,this.commonHeadersPromise=N(V.version,this.environmentService,this.fileService,K)}api(T=""){return`${this.extensionsGalleryUrl}${T}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(T,O){const M=[];let{total:W,firstPage:U,getPage:V}=await this.query({names:T,pageSize:T.length},O);M.push(...U);for(let K=1;M.length<W&&(U=await V(K,O),U.length);K++)M.push(...U);return M}async getCompatibleExtension(T,O){const M=await this.getCompatibleExtensionByEngine(T,O);return(M==null?void 0:M.properties.webExtension)?M.webResource?M:null:M}async getCompatibleExtensionByEngine(T,O){const M=A.isIExtensionIdentifier(T)?null:T;if(M&&M.properties.engine&&v.isEngineValid(M.properties.engine,this.productService.version,this.productService.date))return M;const{id:W,uuid:U}=M?M.identifier:T;let V=new h().withFlags(u.IncludeAssetUri,u.IncludeStatistics,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(l.Target,"Microsoft.VisualStudio.Code");U?V=V.withFilter(l.ExtensionId,U):V=V.withFilter(l.ExtensionName,W);const{galleryExtensions:K}=await this.queryGallery(V,i.CancellationToken.None),[q]=K;if(!q||!q.versions.length)return null;if(O){const ne=q.versions.filter(re=>re.version===O)[0];if(ne){const re=z(q,ne,0,V);if(re.properties.engine&&v.isEngineValid(re.properties.engine,this.productService.version,this.productService.date))return re}return null}const x=await this.getLastValidExtensionVersion(q,q.versions);return x?z(q,x,0,V):null}async query(T,O){const M=i.CancellationToken.isCancellationToken(T)?{}:T,W=i.CancellationToken.isCancellationToken(T)?T:O;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let U=M.text||"";const V=b.getOrDefault(M,se=>se.pageSize,50);let K=new h().withFlags(u.IncludeLatestVersionOnly,u.IncludeAssetUri,u.IncludeStatistics,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,V).withFilter(l.Target,"Microsoft.VisualStudio.Code");U?(U=U.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,le,oe)=>(K=K.withFilter(l.Category,oe||le),"")),U=U.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,le,oe)=>(K=K.withFilter(l.Tag,oe||le),"")),U=U.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(l.Featured),"")),U=U.trim(),U&&(U=U.length<200?U:U.substring(0,200),K=K.withFilter(l.SearchText,U)),K=K.withSortBy(0)):M.ids?K=K.withFilter(l.ExtensionId,...M.ids):M.names?K=K.withFilter(l.ExtensionName,...M.names):K=K.withSortBy(4),typeof M.sortBy=="number"&&(K=K.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(K=K.withSortOrder(M.sortOrder));const{galleryExtensions:q,total:x}=await this.queryGallery(K,W),ne=q.map((se,le)=>z(se,se.versions[0],le,K,M.source)),re=async(se,le)=>{if(le.isCancellationRequested)throw m.canceled();const oe=K.withPage(se+1),{galleryExtensions:ue}=await this.queryGallery(oe,le);return ue.map((me,be)=>z(me,me.versions[0],be,oe,M.source))};return{firstPage:ne,total:x,pageSize:K.pageSize,getPage:re}}async queryGallery(T,O){if(!this.isEnabled())throw new Error("No extension gallery service configured.");T=T.withFlags(T.flags,u.ExcludeNonValidated).withFilter(l.ExcludeWithFlags,o(u.Unpublished));const M=await this.commonHeadersPromise,W=JSON.stringify(T.raw),U=Object.assign(Object.assign({},M),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)}),V=new Date().getTime();let K,q,x=0;try{if(K=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:W,headers:U},O),K.res.statusCode&&K.res.statusCode>=400&&K.res.statusCode<500)return{galleryExtensions:[],total:x};const ne=await n.asJson(K);if(ne){const re=ne.results[0],se=re.extensions,le=re.resultMetadata&&re.resultMetadata.filter(oe=>oe.metadataType==="ResultCount")[0];return x=le&&le.metadataItems.filter(oe=>oe.name==="TotalCount")[0].count||0,{galleryExtensions:se,total:x}}return{galleryExtensions:[],total:x}}catch(ne){throw q=ne,ne}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},T.telemetryData),{requestBodySize:String(W.length),duration:new Date().getTime()-V,success:!!K&&n.isSuccess(K),responseBodySize:K==null?void 0:K.res.headers["Content-Length"],statusCode:K?String(K.res.statusCode):void 0,errorCode:q?m.isPromiseCanceledError(q)?"canceled":m.getErrorMessage(q).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(x)}))}}async reportStatistic(T,O,M,W){if(!this.isEnabled())return;const U=await this.commonHeadersPromise,V=Object.assign(Object.assign({},U),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${T}/extensions/${O}/${M}/stats?statType=${W}`),headers:V},i.CancellationToken.None)}catch(K){}}async download(T,O,M){this.logService.trace("ExtensionGalleryService#download",T.identifier.id);const W=R.getGalleryExtensionTelemetryData(T),U=new Date().getTime(),V=ne=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},W),{duration:ne})),K=M===1?"install":M===2?"update":"",q=K?{uri:`${T.assets.download.uri}&${K}=true`,fallbackUri:`${T.assets.download.fallbackUri}?${K}=true`}:T.assets.download,x=await this.getAsset(q);await this.fileService.writeFile(O,x.stream),V(new Date().getTime()-U)}async getReadme(T,O){if(T.assets.readme){const M=await this.getAsset(T.assets.readme,{},O);return await n.asText(M)||""}return""}async getManifest(T,O){if(T.assets.manifest){const M=await this.getAsset(T.assets.manifest,{},O),W=await n.asText(M);return W?JSON.parse(W):null}return null}async getCoreTranslation(T,O){const M=T.assets.coreTranslations.filter(W=>W[0]===O.toUpperCase())[0];if(M){const W=await this.getAsset(M[1]),U=await n.asText(W);return U?JSON.parse(U):null}return null}async getChangelog(T,O){if(T.assets.changelog){const M=await this.getAsset(T.assets.changelog,{},O);return await n.asText(M)||""}return""}async getAllVersions(T,O){let M=new h().withFlags(u.IncludeVersions,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(l.Target,"Microsoft.VisualStudio.Code");T.identifier.uuid?M=M.withFilter(l.ExtensionId,T.identifier.uuid):M=M.withFilter(l.ExtensionName,T.identifier.id);const W=[],{galleryExtensions:U}=await this.queryGallery(M,i.CancellationToken.None);return U.length&&(O?await Promise.all(U[0].versions.map(async V=>{let K;try{K=await this.getEngine(V)}catch(q){}K&&v.isEngineValid(K,this.productService.version,this.productService.date)&&W.push({version:V.version,date:V.lastUpdated})})):W.push(...U[0].versions.map(V=>({version:V.version,date:V.lastUpdated})))),W}async getAsset(T,O={},M=i.CancellationToken.None){const W=await this.commonHeadersPromise,U={type:"GET"},V=Object.assign(Object.assign({},W),O.headers||{});O=Object.assign(Object.assign(Object.assign({},O),U),{headers:V});const K=T.uri,q=T.fallbackUri,x=Object.assign(Object.assign({},O),{url:K});try{const ne=await this.requestService.request(x,M);if(ne.res.statusCode===200)return ne;const re=await n.asText(ne);throw new Error(`Expected 200, got back ${ne.res.statusCode} instead.

${re}`)}catch(ne){if(m.isPromiseCanceledError(ne))throw ne;const re=m.getErrorMessage(ne);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:K,message:re});const se=Object.assign(Object.assign({},O),{url:q});return this.requestService.request(se,M)}}async getLastValidExtensionVersion(T,O){const M=this.getLastValidExtensionVersionFromProperties(T,O);return M||this.getLastValidExtensionVersionRecursively(T,O)}getLastValidExtensionVersionFromProperties(T,O){for(const M of O){const W=te(M);if(!W)return null;if(v.isEngineValid(W,this.productService.version,this.productService.date))return M}return null}async getEngine(T){const O=te(T);if(O)return O;const M=H(T,t.Manifest);if(!M)throw new Error("Manifest was not found");const W={"Accept-Encoding":"gzip"},U=await this.getAsset(M,{headers:W}),V=await n.asJson(U);if(V)return V.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(T,O){if(!O.length)return null;const M=O[0],W=await this.getEngine(M);return v.isEngineValid(W,this.productService.version,this.productService.date)?Object.assign(Object.assign({},M),{properties:[...M.properties||[],{key:r.Engine,value:W}]}):this.getLastValidExtensionVersionRecursively(T,O.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const T=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},i.CancellationToken.None);if(T.res.statusCode!==200)throw new Error("Could not get extensions report.");const O=await n.asJson(T),M=new Map;if(O)for(const W of O.malicious){const U=M.get(W)||{id:{id:W},malicious:!0,slow:!1};U.malicious=!0,M.set(W,U)}return[...M.values()]}};X=he([ee(0,n.IRequestService),ee(1,E.ILogService),ee(2,p.IEnvironmentService),ee(3,I.ITelemetryService),ee(4,k.IFileService),ee(5,d.IProductService),ee(6,P.optional(g.IStorageService))],X),e.ExtensionGalleryService=X;async function N(F,T,O,M){const W={"X-Market-Client-Id":`VSCode ${F}`,"User-Agent":`VSCode ${F}`},U=await D.getServiceMachineId(T,O,M);return W["X-Market-User-Id"]=U,W}e.resolveMarketplaceHeaders=N}),define(J[200],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class m{constructor(b){this.appender=b}listen(b,I){throw new Error(`Event not found: ${I}`)}call(b,I,{eventName:n,data:v}){return this.appender.log(n,v),Promise.resolve(null)}}e.TelemetryAppenderChannel=m;class A{constructor(b){this.channel=b}log(b,I){return this.channel.call("log",{eventName:b,data:I}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=A}),define(J[201],Z([0,1,48,147,23,4,21,49,2,44,38]),function($,e,m,A,R,b,I,n,v,p,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(d,g){this._configurationService=g,this._experimentProperties={},this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appender=d.appender,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let D of this._piiPaths)this._cleanupPatterns.push(new RegExp(R.escapeRegExpCharacters(D),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(D=>{const P=/^[a-f0-9]+$/i.test(D["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!P})}))}setExperimentProperty(d,g){this._experimentProperties[d]=g}setEnabled(d){this._enabled=d}_updateUserOptIn(){var d;const g=(d=this._configurationService)===null||d===void 0?void 0:d.getValue(k);this._userOptIn=g?g.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const d=await this._commonProperties;let g=d.sessionID,D=d["common.instanceId"],P=d["common.machineId"],c=d["common.firstSessionDate"],u=d["common.msftInternal"];return{sessionId:g,instanceId:D,machineId:P,firstSessionDate:c,msftInternal:u}}dispose(){this._disposables.dispose()}publicLog(d,g,D){return this.isOptedIn?this._commonProperties.then(P=>{g=p.mixin(g,P),g=p.mixin(g,this._experimentProperties),g=p.cloneAndChange(g,c=>{if(typeof c=="string")return this._cleanupInfo(c,D)}),this._appender.log(d,g)},P=>{console.error(P)}):Promise.resolve(void 0)}publicLog2(d,g,D){return this.publicLog(d,g,D)}publicLogError(d,g){return this.sendErrorTelemetry?this.publicLog(d,g,!0):Promise.resolve(void 0)}publicLogError2(d,g){return this.publicLogError(d,g)}_cleanupInfo(d,g){let D=d;if(g){const P=[];for(let l of this._cleanupPatterns)for(;;){const t=l.exec(d);if(!t)break;P.push([t.index,l.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(D="";;){const l=u.exec(d);if(!l)break;!c.test(l[0])&&P.every(([t,r])=>l.index<t||l.index>=r)&&(D+=d.substring(o,l.index)+"<REDACTED: user-file-path>",o=u.lastIndex)}o<d.length&&(D+=d.substr(o))}for(let P of this._cleanupPatterns)D=D.replace(P,"");return D}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=he([ee(1,b.optional(I.IConfigurationService))],E),e.TelemetryService=E;const k="telemetry";i.Registry.as(n.Extensions.Configuration).registerConfiguration({id:k,order:110,type:"object",title:A.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?A.localize(2,null,m.default.privacyStatementUrl):A.localize(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(J[98],Z([0,1,21,44,13,9]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(d,g){return Promise.resolve(void 0)}publicLog2(d,g){return this.publicLog(d,g)}publicLogError(d,g){return Promise.resolve(void 0)}publicLogError2(d,g){return this.publicLogError(d,g)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class I{async publicLog(g,D,P){}async publicLogError(g,D,P){}}e.NullEndpointTelemetryService=I;function n(...d){return{log:(g,D)=>d.forEach(P=>P.log(g,D)),flush:()=>b.Promises.settled(d.map(g=>g.flush()))}}e.combinedAppender=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(d,g){return g.onDidChangeConfiguration(D=>{D.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:m.ConfigurationTargetToString(D.source),configurationKeys:k(D.sourceConfig)})})}e.configurationTelemetry=v;function p(d){const g=Object.create(null),D=Object.create(null),P=Object.create(null);E(d,P);for(let c in P){c=c.length>150?c.substr(c.length-149):c;const u=P[c];typeof u=="number"?D[c]=u:typeof u=="boolean"?D[c]=u?1:0:typeof u=="string"?g[c]=u.substring(0,1023):typeof u!="undefined"&&u!==null&&(g[c]=u)}return{properties:g,measurements:D}}e.validateTelemetryData=p;function i(d){if(!d)return"none";let g="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(P=>{d.indexOf(`${P}+`)===0&&(g=P)}),g}e.cleanRemoteAuthority=i;function E(d,g,D=0,P){if(!!d)for(let c of Object.getOwnPropertyNames(d)){const u=d[c],o=P?P+c:c;Array.isArray(u)?g[o]=A.safeStringify(u):u instanceof Date?g[o]=u.toISOString():R.isObject(u)?D<2?E(u,g,D+1,o+"."):g[o]=A.safeStringify(u):g[o]=u}}function k(d){if(!d)return[];const g=[];return y(g,"",d),g}function y(d,g,D){D&&typeof D=="object"&&!Array.isArray(D)?Object.keys(D).forEach(P=>y(d,g?`${g}.${P}`:P,D[P])):d.push(g)}}),define(J[202],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(J[203],Z([0,1,4,2,38,5,202,108]),function($,e,m,A,R,b,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=m.createDecorator("themeService");var v;(function(D){function P(c){return c&&typeof c=="object"&&typeof c.id=="string"}D.isThemeColor=P})(v=e.ThemeColor||(e.ThemeColor={}));function p(D){return{id:D}}e.themeColorFromId=p;var i;(function(D){function P(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||v.isThemeColor(r.color))}D.isThemeIcon=P;const c=new RegExp(`^\\$\\((${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?)\\)$`);function u(r){const s=c.exec(r);if(!s)return;let[,a]=s;return{id:a}}D.fromString=u;function o(r,s){let a=r.id;const h=a.lastIndexOf("~");return h!==-1&&(a=a.substring(0,h)),s&&(a=`${a}~${s}`),{id:a}}D.modify=o;function l(r,s){var a,h;return r.id===s.id&&((a=r.color)===null||a===void 0?void 0:a.id)===((h=s.color)===null||h===void 0?void 0:h.id)}D.isEqual=l;function t(r){return{id:r.id}}D.asThemeIcon=t,D.asClassNameArray=n.CSSIcon.asClassNameArray,D.asClassName=n.CSSIcon.asClassName,D.asCSSSelector=n.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function E(D){switch(D){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class k{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new b.Emitter}onColorThemeChange(P){return this.themingParticipants.push(P),this.onThemingParticipantAddedEmitter.fire(P),A.toDisposable(()=>{const c=this.themingParticipants.indexOf(P);this.themingParticipants.splice(c,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new k;R.Registry.add(e.Extensions.ThemingContribution,y);function d(D){return y.onColorThemeChange(D)}e.registerThemingParticipant=d;class g extends A.Disposable{constructor(P){super();this.themeService=P,this.theme=P.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(c=>this.onThemeChange(c)))}onThemeChange(P){this.theme=P,this.updateStyles()}updateStyles(){}getColor(P,c){let u=this.theme.getColor(P);return u&&c&&(u=c(u,this.theme)),u?u.toString():null}}e.Themable=g}),define(J[60],Z([0,1,14,3,39,4]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const I="#FFFFFF",n="#1E1E1E",v="#000000",p="theme",i="themeBackground",E="windowSplash";e.IThemeMainService=b.createDecorator("themeMainService");let k=class{constructor(d){this.stateMainService=d}getBackgroundColor(){if((A.isWindows||A.isMacintosh)&&m.nativeTheme.shouldUseInvertedColorScheme)return v;let d=this.stateMainService.getItem(i,null);if(!d){let g;(A.isWindows||A.isMacintosh)&&m.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(p,"vs-dark").split(" ")[0],d=g==="hc-black"?v:g==="vs"?I:n}return A.isMacintosh&&d.toUpperCase()===n&&(d="#171717"),d}saveWindowSplash(d,g){this.stateMainService.setItems([{key:p,data:g.baseTheme},{key:i,data:g.colorInfo.background},{key:E,data:g}]),typeof d=="number"&&this.updateBackgroundColor(d,g)}updateBackgroundColor(d,g){for(const D of m.BrowserWindow.getAllWindows())if(D.id===d){D.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(E)}};k=he([ee(0,R.IStateMainService)],k),e.ThemeMainService=k}),define(J[42],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var A;(function(b){b.Uninitialized="uninitialized",b.Idle="idle",b.CheckingForUpdates="checking for updates",b.AvailableForDownload="available for download",b.Downloading="downloading",b.Downloaded="downloaded",b.Updating="updating",b.Ready="ready"})(A=e.StateType||(e.StateType={}));var R;(function(b){b[b.Setup=0]="Setup",b[b.Archive=1]="Archive",b[b.Snap=2]="Snap"})(R=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(b,I)=>({type:"idle",updateType:b,error:I}),CheckingForUpdates:b=>({type:"checking for updates",explicit:b}),AvailableForDownload:b=>({type:"available for download",update:b}),Downloading:b=>({type:"downloading",update:b}),Downloaded:b=>({type:"downloaded",update:b}),Updating:b=>({type:"updating",update:b}),Ready:b=>({type:"ready",update:b})},e.IUpdateService=m.createDecorator("updateService")}),define(J[204],Z([0,1,38,49,148,3]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),m.Registry.as(A.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:R.localize(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:R.localize(1,null),tags:["usesOnlineServices"],enumDescriptions:[R.localize(2,null),R.localize(3,null),R.localize(4,null),R.localize(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:R.localize(6,null),deprecationMessage:R.localize(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:R.localize(8,null),description:R.localize(9,null),included:b.isWindows&&!b.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:R.localize(10,null),tags:["usesOnlineServices"]}}})}),define(J[205],Z([0,1,5,42]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class R{constructor(n){this.service=n}listen(n,v){switch(v){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${v}`)}call(n,v,p){switch(v){case"checkForUpdates":return this.service.checkForUpdates(p);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${v}`)}}e.UpdateChannel=R;class b{constructor(n){this.channel=n,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,this._state=A.State.Uninitialized,this.channel.listen("onStateChange")(v=>this.state=v),this.channel.call("_getInitialState").then(v=>this.state=v)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=b}),define(J[99],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=m.createDecorator("urlService")}),define(J[206],Z([0,1,7]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class A{constructor(n){this.handler=n}listen(n,v){throw new Error(`Event not found: ${v}`)}call(n,v,p){switch(v){case"handleURL":return this.handler.handleURL(m.URI.revive(p[0]),p[1])}throw new Error(`Call not found: ${v}`)}}e.URLHandlerChannel=A;class R{constructor(n){this.channel=n}handleURL(n,v){return this.channel.call("handleURL",[n.toJSON(),v])}}e.URLHandlerChannelClient=R;class b{constructor(n){this.next=n}async routeCall(n,v,p,i){if(v!=="handleURL")throw new Error(`Call not found: ${v}`);if(p){const E=m.URI.revive(p);if(E&&E.query){const k=/\bwindowId=(\d+)/.exec(E.query);if(k){const y=k[1],d=new RegExp(`window:${y}`),g=n.connections.find(D=>d.test(D.ctx));if(g)return g}}}return this.next.routeCall(n,v,p,i)}routeEvent(n,v){throw new Error(`Event not found: ${v}`)}}e.URLHandlerRouter=b}),define(J[207],Z([0,1,7,9,2,20]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class I extends R.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(p,i){const E=[...this.handlers.values()];return A.first(E.map(k=>()=>k.handleURL(p,i)),void 0,!1).then(k=>k||!1)}registerHandler(p){return this.handlers.add(p),R.toDisposable(()=>this.handlers.delete(p))}}e.AbstractURLService=I;let n=class extends I{constructor(p){super();this.productService=p}create(p){let{authority:i,path:E,query:k,fragment:y}=p||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return i&&E&&E.indexOf("/")!==0&&(E=`/${E}`),m.URI.from({scheme:this.productService.urlProtocol,authority:i,path:E,query:k,fragment:y})}};n=he([ee(0,b.IProductService)],n),e.NativeURLService=n}),define(J[208],Z([0,1,5,14,7,2,3,9]),function($,e,m,A,R,b,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function v(i){try{return R.URI.parse(i)}catch(E){return null}}class p{constructor(E,k,y,d,g){if(this.urlService=k,this.uris=[],this.retryCount=0,this.flushDisposable=b.Disposable.None,this.disposables=new b.DisposableStore,this.uris=E,I.isWindows){const c=d.isBuilt?[]:[`"${d.appRoot}"`];c.push("--open-url","--"),A.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,c)}const D=m.Event.map(m.Event.fromNodeEventEmitter(A.app,"open-url",(c,u)=>({event:c,url:u})),({event:c,url:u})=>(c.preventDefault(),u));this.disposables.add(D(c=>{const u=v(c);!u||this.urlService.open(u,{originalUrl:c})})),y.getWindows().filter(c=>c.isReady).length>0?this.flush():m.Event.once(y.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const E=[];for(const k of this.uris)await this.urlService.open(k.uri,{originalUrl:k.url})||E.push(k);E.length!==0&&(this.uris=E,this.flushDisposable=n.disposableTimeout(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=p}),define(J[76],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewPartitionId=e.IWebviewManagerService=void 0,e.IWebviewManagerService=m.createDecorator("webviewManagerService"),e.webviewPartitionId="webview"}),define(J[209],Z([0,1,14,2,10,7,76]),function($,e,m,A,R,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class n extends A.Disposable{constructor(){super();const p=m.session.fromPartition(I.webviewPartitionId),i=this.handleWebviewRequest.bind(this);m.protocol.registerFileProtocol(R.Schemas.vscodeWebview,i),p.protocol.registerFileProtocol(R.Schemas.vscodeWebview,i)}async handleWebviewRequest(p,i){try{const E=b.URI.parse(p.url),k=n.validWebviewFilePaths.get(E.path);if(typeof k=="string"){const y=E.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${k}`:`vs/workbench/contrib/webview/browser/pre/${k}`,d=R.FileAccess.asFileUri(y,$);return i(decodeURIComponent(d.fsPath))}}catch(E){}i({error:-10})}}e.WebviewProtocolProvider=n,n.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/electron-browser-index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"],["/service-worker.js","service-worker.js"]])}),define(J[61],Z([0,1,3]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function A(p){return!!p.workspaceUri}e.isWorkspaceToOpen=A;function R(p){return!!p.folderUri}e.isFolderToOpen=R;function b(p){return!!p.fileUri}e.isFileToOpen=b;function I(p){const i=n(p),E=p.getValue("window.menuBarVisibility");return E==="default"||i==="native"&&E==="compact"||m.isMacintosh&&m.isNative?"classic":E}e.getMenuBarVisibility=I;function n(p){if(m.isWeb)return"custom";const i=p.getValue("window");if(i){if(m.isMacintosh&&i.nativeTabs===!0||m.isMacintosh&&i.nativeFullScreen===!1)return"native";const y=i.titleBarStyle;if(y==="native"||y==="custom")return y}return m.isLinux?"native":"custom"}e.getTitleBarStyle=n;function v(p=0){return Math.pow(1.2,p)}e.zoomLevelToZoomFactor=v}),define(J[35],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=void 0;var A;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(A=e.OpenContext||(e.OpenContext={}));const R=function(n=1){return{width:1024,height:768,mode:n}};e.defaultWindowState=R;var b;(function(n){n[n.Maximized=0]="Maximized",n[n.Normal=1]="Normal",n[n.Minimized=2]="Minimized",n[n.Fullscreen=3]="Fullscreen"})(b=e.WindowMode||(e.WindowMode={}));var I;(function(n){n[n.UNRESPONSIVE=1]="UNRESPONSIVE",n[n.CRASHED=2]="CRASHED",n[n.LOAD=3]="LOAD"})(I=e.WindowError||(e.WindowError={})),e.IWindowsMainService=m.createDecorator("windowsMainService")}),define(J[210],Z([0,1,14,2,74,76,209,35]),function($,e,m,A,R,b,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let v=class extends A.Disposable{constructor(i,E){super();this.windowsMainService=E,this._register(new I.WebviewProtocolProvider);const k=m.session.fromPartition(b.webviewPartitionId);k.setPermissionRequestHandler((y,d,g)=>g(d==="clipboard-read")),k.setPermissionCheckHandler((y,d)=>d==="clipboard-read")}async setIgnoreMenuShortcuts(i,E){let k;if(typeof i.windowId=="number"){const{windowId:y}=i,d=this.windowsMainService.getWindowById(y);if(!(d==null?void 0:d.win))throw new Error(`Invalid windowId: ${y}`);k=d.win.webContents}else{const{webContentsId:y}=i;if(k=m.webContents.fromId(y),!k)throw new Error(`Invalid webContentsId: ${y}`)}k.isDestroyed()||k.setIgnoreMenuShortcuts(E)}};v=he([ee(0,R.ITunnelService),ee(1,n.IWindowsMainService)],v),e.WebviewMainService=v}),define(J[211],Z([0,1,5,2,9]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class b extends A.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:v,getActiveWindowId:p}){super();this.disposables=this._register(new A.DisposableStore),m.Event.latch(m.Event.any(n,v))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=R.createCancelablePromise(()=>p()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch(E){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=b}),define(J[212],Z([0,1,7,15,4,37]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=R.createDecorator("contextService");var I;(function(k){k[k.EMPTY=1]="EMPTY",k[k.FOLDER=2]="FOLDER",k[k.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function n(k){const y=k;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.isWorkspace=n;function v(k){const y=k;return!!(y&&typeof y=="object"&&m.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.isWorkspaceFolder=v;class p{constructor(y,d,g,D){this._id=y,this._configuration=g,this._ignorePathCasing=D,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(y){this._id=y.id,this._configuration=y.configuration,this._ignorePathCasing=y._ignorePathCasing,this.folders=y.folders}get folders(){return this._folders}set folders(y){this._folders=y,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(y){this._configuration=y}getFolder(y){return y&&this._foldersMap.findSubstr(y.with({scheme:y.scheme,authority:y.authority,path:y.path}))||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing);for(const y of this.folders)this._foldersMap.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=p;class i{constructor(y,d){this.raw=d,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return A.joinPath(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function E(k){return new i({uri:k,index:0,name:A.basenameOrAuthority(k)},{uri:k.toString()})}e.toWorkspaceFolder=E}),define(J[28],Z([0,1,4,151,212,7,3,8,15,78,40,10,30,29,73]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:A.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(C){return(typeof C=="string"?n.extname(C):v.extname(C))===g}e.hasWorkspaceFileExtension=D,e.IWorkspacesService=m.createDecorator("workspacesService");function P(C){return C.hasOwnProperty("workspace")}e.isRecentWorkspace=P;function c(C){return C.hasOwnProperty("folderUri")}e.isRecentFolder=c;function u(C){return C.hasOwnProperty("fileUri")}e.isRecentFile=u;function o(C){const z=C;return typeof(z==null?void 0:z.id)=="string"&&b.URI.isUri(z.uri)}e.isSingleFolderWorkspaceIdentifier=o;function l(C){if(C.configuration)return{id:C.id,configPath:C.configuration};if(C.folders.length===1)return{id:C.id,uri:C.folders[0].uri}}e.toWorkspaceIdentifier=l;function t(C){const z=C;return typeof(z==null?void 0:z.id)=="string"&&b.URI.isUri(z.configPath)}e.isWorkspaceIdentifier=t;function r(C){const z=C;if(z==null?void 0:z.uri)return{id:z.id,uri:b.URI.revive(z.uri)};const X=C;if(X==null?void 0:X.configPath)return{id:X.id,configPath:b.URI.revive(X.configPath)};if(C==null?void 0:C.id)return{id:C.id}}e.reviveIdentifier=r;function s(C,z){return v.extUriBiasedIgnorePathCase.isEqualOrParent(C,z.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function a(C){return h(C)||w(C)}e.isStoredWorkspaceFolder=a;function h(C){const z=C;return typeof(z==null?void 0:z.path)=="string"&&(!z.name||typeof z.name=="string")}e.isRawFileWorkspaceFolder=h;function w(C){const z=C;return typeof(z==null?void 0:z.uri)=="string"&&(!z.name||typeof z.name=="string")}e.isRawUriWorkspaceFolder=w;function f(C,z,X,N,F=!I.isWindows,T){if(C.scheme!==N.scheme)return{name:X,uri:C.toString(!0)};let O=z?void 0:T.relativePath(N,C);if(O!==void 0)O.length===0?O=".":I.isWindows&&C.scheme===E.Schemas.file&&!F&&(O=O.replace(/\//g,"\\"));else if(C.scheme===E.Schemas.file)O=C.fsPath,I.isWindows&&(O=k.normalizeDriveLetter(O),F&&(O=y.toSlashes(O)));else{if(!T.isEqualAuthority(C.authority,N.authority))return{name:X,uri:C.toString(!0)};O=C.path}return{name:X,path:O}}e.getStoredWorkspaceFolder=f;function S(C,z,X){let N=[],F=new Set;const T=X.dirname(z);for(let O of C){let M;if(h(O))O.path&&(M=X.resolvePath(T,O.path));else if(w(O))try{M=b.URI.parse(O.uri),M.path[0]!=="/"&&(M=M.with({path:"/"+M.path}))}catch(W){console.warn(W)}if(M){let W=X.getComparisonKey(M);if(!F.has(W)){F.add(W);const U=O.name||X.basenameOrAuthority(M);N.push(new R.WorkspaceFolder({uri:M,name:U,index:N.length},O))}}}return N}e.toWorkspaceFolders=S;function L(C,z,X,N,F){let T=_(z,C);const O=F.dirname(z),M=F.dirname(N),W=[],U=H(T.folders);for(const x of T.folders){const ne=h(x)?F.resolvePath(O,x.path):b.URI.parse(x.uri);let re;X?re=!1:re=!h(x)||n.isAbsolute(x.path),W.push(f(ne,re,x.name,M,U,F))}const V={insertSpaces:!1,tabSize:4,eol:I.isLinux||I.isMacintosh?`
`:`\r
`},K=p.setProperty(C,["folders"],W,V);let q=p.applyEdits(C,K);return T.remoteAuthority===d.getRemoteAuthority(N)&&(q=p.applyEdits(q,p.removeProperty(q,["remoteAuthority"],V))),q}e.rewriteWorkspaceFileForNewLocation=L;function _(C,z){let X=i.parse(z);if(X&&Array.isArray(X.folders))X.folders=X.folders.filter(N=>a(N));else throw new Error(`${C} looks like an invalid workspace file.`);return X}function H(C){return I.isWindows?C.some(z=>h(z)&&z.path.indexOf("/")>=0):!0}e.useSlashForPath=H;function Q(C){return C.workspace&&typeof C.workspace=="object"&&typeof C.workspace.id=="string"&&typeof C.workspace.configPath=="string"}function te(C){return typeof C.folderUri=="string"}function B(C){return typeof C.fileUri=="string"}function Y(C,z){const X={workspaces:[],files:[]};if(C){const N=function(T,O){for(let M=0;M<T.length;M++)try{O(T[M],M)}catch(W){z.warn(`Error restoring recent entry ${JSON.stringify(T[M])}: ${W.toString()}. Skip entry.`)}},F=C;if(Array.isArray(F.entries))N(F.entries,T=>{const O=T.label,M=T.remoteAuthority;Q(T)?X.workspaces.push({label:O,remoteAuthority:M,workspace:{id:T.workspace.id,configPath:b.URI.parse(T.workspace.configPath)}}):te(T)?X.workspaces.push({label:O,remoteAuthority:M,folderUri:b.URI.parse(T.folderUri)}):B(T)&&X.files.push({label:O,remoteAuthority:M,fileUri:b.URI.parse(T.fileUri)})});else{const T=C;Array.isArray(T.workspaces3)&&N(T.workspaces3,(O,M)=>{const W=Array.isArray(T.workspaceLabels)&&T.workspaceLabels[M]||void 0;typeof O=="object"&&typeof O.id=="string"&&typeof O.configURIPath=="string"?X.workspaces.push({label:W,workspace:{id:O.id,configPath:b.URI.parse(O.configURIPath)}}):typeof O=="string"&&X.workspaces.push({label:W,folderUri:b.URI.parse(O)})}),Array.isArray(T.files2)&&N(T.files2,(O,M)=>{const W=Array.isArray(T.fileLabels)&&T.fileLabels[M]||void 0;typeof O=="string"&&X.files.push({label:W,fileUri:b.URI.parse(O)})})}}return X}e.restoreRecentlyOpened=Y;function G(C){const z={entries:[]};for(const X of C.workspaces)c(X)?z.entries.push({folderUri:X.folderUri.toString(),label:X.label,remoteAuthority:X.remoteAuthority}):z.entries.push({workspace:{id:X.workspace.id,configPath:X.workspace.configPath.toString()},label:X.label,remoteAuthority:X.remoteAuthority});for(const X of C.files)z.entries.push({fileUri:X.fileUri.toString(),label:X.label,remoteAuthority:X.remoteAuthority});return z}e.toStoreData=G}),define(J[51],Z([0,1,4,28]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=m.createDecorator("backupMainService");function R(b){const I=b;return I&&A.isWorkspaceIdentifier(I.workspace)}e.isWorkspaceBackupInfo=R}),define(J[52],Z([0,1,4,14,9,39,3,8,65,18,13,133,28,30,2,81]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=m.createDecorator("dialogMainService");let D=class gt{constructor(c){this.stateMainService=c,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new R.Queue}pickFileFolder(c,u){return this.doPick(Object.assign(Object.assign({},c),{pickFolders:!0,pickFiles:!0,title:E.localize(0,null)}),u)}pickFolder(c,u){return this.doPick(Object.assign(Object.assign({},c),{pickFolders:!0,title:E.localize(1,null)}),u)}pickFile(c,u){return this.doPick(Object.assign(Object.assign({},c),{pickFiles:!0,title:E.localize(2,null)}),u)}pickWorkspace(c,u){const o=E.localize(3,null),l=y.mnemonicButtonLabel(E.localize(4,null)),t=k.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},c),{pickFiles:!0,title:o,filters:t,buttonLabel:l}),u)}async doPick(c,u){const o={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters};o.defaultPath=c.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(o.properties=void 0,c.pickFiles&&c.pickFolders&&(o.properties=["multiSelections","openDirectory","openFile","createDirectory"])),o.properties||(o.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),I.isMacintosh&&o.properties.push("treatPackageAsDirectory");const l=u||A.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(o,i.withNullAsUndefined(l));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,n.dirname(t.filePaths[0])),t.filePaths}getWindowDialogQueue(c){if(c){let u=this.windowDialogQueues.get(c.id);return u||(u=new R.Queue,this.windowDialogQueues.set(c.id,u)),u}else return this.noWindowDialogueQueue}showMessageBox(c,u){return this.getWindowDialogQueue(u).queue(async()=>u?A.dialog.showMessageBox(u,c):A.dialog.showMessageBox(c))}async showSaveDialog(c,u){const o=this.acquireFileDialogLock(c,u);if(!o)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(u).queue(async()=>{let l;return u?l=await A.dialog.showSaveDialog(u,c):l=await A.dialog.showSaveDialog(c),l.filePath=this.normalizePath(l.filePath),l})}finally{d.dispose(o)}}normalizePath(c){return c&&I.isMacintosh&&(c=v.normalizeNFC(c)),c}normalizePaths(c){return c.map(u=>this.normalizePath(u))}async showOpenDialog(c,u){c.defaultPath&&(await p.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const o=this.acquireFileDialogLock(c,u);if(!o)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(u).queue(async()=>{let l;return u?l=await A.dialog.showOpenDialog(u,c):l=await A.dialog.showOpenDialog(c),l.filePaths=this.normalizePaths(l.filePaths),l})}finally{d.dispose(o)}}acquireFileDialogLock(c,u){if(!u)return d.Disposable.None;let o=this.windowFileDialogLocks.get(u.id);o||(o=new Set,this.windowFileDialogLocks.set(u.id,o));const l=g.hash(c);if(!o.has(l))return o.add(l),d.toDisposable(()=>{o==null||o.delete(l),(o==null?void 0:o.size)===0&&this.windowFileDialogLocks.delete(u.id)})}};D.workingDirPickerStorageKey="pickerWorkingDir",D=he([ee(0,b.IStateMainService)],D),e.DialogMainService=D}),define(J[213],Z([0,1,5,2,28]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class b extends A.Disposable{constructor(n,v){super();this.logService=n,this.storageMainService=v,this._onDidChangeGlobalStorage=this._register(new m.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(m.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,v)=>(n?n.push(v):n=[v],n),b.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const v=new Map,p=new Set;return n.forEach(i=>{const E=this.storageMainService.globalStorage.get(i.key);typeof E=="string"?v.set(i.key,E):p.add(i.key)}),{changed:Array.from(v.entries()),deleted:Array.from(p.values())}}listen(n,v){switch(v){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${v}`)}async call(n,v,p){const i=R.reviveIdentifier(p.workspace),E=await this.withStorageInitialized(i);switch(v){case"getItems":return Array.from(E.items.entries());case"updateItems":{const k=p;if(k.insert)for(const[y,d]of k.insert)E.set(y,d);k.delete&&k.delete.forEach(y=>E.delete(y));break}case"close":{if(i)return E.close();break}default:throw new Error(`Call not found: ${v}`)}}async withStorageInitialized(n){const v=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await v.init()}catch(p){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${p}`)}return v}}e.StorageDatabaseChannel=b,b.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[214],Z([0,1,18,5,2,6,123,87,8,97,32,27,28]),function($,e,m,A,R,b,I,n,v,p,i,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class y extends R.Disposable{constructor(P){super();this.logService=P,this._onDidChangeStorage=this._register(new A.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new A.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const P=await this.doCreate();this.storage.dispose(),this.storage=P,this._register(P.onDidChangeStorage(u=>this._onDidChangeStorage.fire({key:u}))),await this.doInit(P);const c=P.getBoolean(p.IS_NEW_KEY);c===void 0?P.set(p.IS_NEW_KEY,!0):c&&P.set(p.IS_NEW_KEY,!1)}catch(P){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${P}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===b.LogLevel.Trace?P=>this.logService.trace(P):void 0,logError:P=>this.logService.error(P)}}doInit(P){return P.init()}get items(){return this.storage.items}get(P,c){return this.storage.get(P,c)}set(P,c){return this.storage.set(P,c)}delete(P){return this.storage.delete(P)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class d extends y{constructor(P,c,u){super(c);this.options=P,this.environmentService=u}async doCreate(){let P;return this.options.useInMemoryStorage?P=I.SQLiteStorageDatabase.IN_MEMORY_PATH:P=v.join(this.environmentService.globalStorageHome.fsPath,d.STORAGE_NAME),new n.Storage(new I.SQLiteStorageDatabase(P,{logging:this.createLogginOptions()}))}async doInit(P){await super.doInit(P),this.updateTelemetryState(P)}updateTelemetryState(P){P.get(i.instanceStorageKey,void 0)===void 0&&P.set(i.instanceStorageKey,E.generateUuid()),P.get(i.firstSessionDateStorageKey,void 0)===void 0&&P.set(i.firstSessionDateStorageKey,new Date().toUTCString());const o=P.get(i.currentSessionDateStorageKey,void 0),l=new Date().toUTCString();P.set(i.lastSessionDateStorageKey,typeof o=="undefined"?null:o),P.set(i.currentSessionDateStorageKey,l)}}e.GlobalStorageMain=d,d.STORAGE_NAME="state.vscdb";class g extends y{constructor(P,c,u,o){super(u);this.workspace=P,this.options=c,this.environmentService=o}async doCreate(){const{storageFilePath:P,wasCreated:c}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new I.SQLiteStorageDatabase(P,{logging:this.createLogginOptions()}),{hint:c?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:I.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const P=v.join(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),c=v.join(P,g.WORKSPACE_STORAGE_NAME);return await m.Promises.exists(P)?{storageFilePath:c,wasCreated:!1}:(await m.Promises.mkdir(P,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(P),{storageFilePath:c,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(P){let c;if(k.isSingleFolderWorkspaceIdentifier(this.workspace)?c={folder:this.workspace.uri.toString()}:k.isWorkspaceIdentifier(this.workspace)&&(c={workspace:this.workspace.configPath.toString()}),c)try{const u=v.join(P,g.WORKSPACE_META_NAME);await m.Promises.exists(u)||await m.Promises.writeFile(u,JSON.stringify(c,void 0,2))}catch(u){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${u}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(J[100],Z([0,1,43,2,47,4,22,6,214]),function($,e,m,A,R,b,I,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=b.createDecorator("storageMainService");let p=class extends A.Disposable{constructor(E,k,y){super();this.logService=E,this.environmentService=k,this.lifecycleMainService=y,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async E=>{E.workspace&&this.workspaceStorage(E.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(E=>{E.join(this.globalStorage.close());for(const[,k]of this.mapWorkspaceToStorage)E.join(k.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const E=new v.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return m.once(E.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),E}createWorkspaceStorage(E){return new v.WorkspaceStorageMain(E,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(E){let k=this.mapWorkspaceToStorage.get(E.id);return k||(this.logService.trace(`StorageMainService: creating workspace storage (${E.id})`),k=this.createWorkspaceStorage(E),this.mapWorkspaceToStorage.set(E.id,k),m.once(k.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${E.id})`),this.mapWorkspaceToStorage.delete(E.id)})),k}};p=he([ee(0,n.ILogService),ee(1,R.IEnvironmentService),ee(2,I.ILifecycleMainService)],p),e.StorageMainService=p}),define(J[101],Z([0,1,7,28,15]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function b(v,p,i){for(const k of v){const y=k.openedWorkspace;if(A.isWorkspaceIdentifier(y)){const d=i(y);if(d){if(d.folders.some(g=>R.extUriBiasedIgnorePathCase.isEqualOrParent(p,g.uri)))return k}else if(R.extUriBiasedIgnorePathCase.isEqualOrParent(p,y.configPath))return k}}const E=v.filter(k=>A.isSingleFolderWorkspaceIdentifier(k.openedWorkspace)&&R.extUriBiasedIgnorePathCase.isEqualOrParent(p,k.openedWorkspace.uri));if(E.length)return E.sort((k,y)=>-(k.openedWorkspace.uri.path.length-y.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=b;function I(v,p){for(const i of v)if(A.isWorkspaceIdentifier(i.openedWorkspace)&&R.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,p)||A.isSingleFolderWorkspaceIdentifier(i.openedWorkspace)&&R.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.uri,p))return i}e.findWindowOnWorkspaceOrFolder=I;function n(v,p){var i,E;const k=y=>p.some(d=>R.extUriBiasedIgnorePathCase.isEqual(m.URI.file(d),m.URI.file(y)));for(const y of v)if((E=(i=y.config)===null||i===void 0?void 0:i.extensionDevelopmentPath)===null||E===void 0?void 0:E.some(d=>k(d)))return y}e.findWindowOnExtensionDevelopmentPath=n}),define(J[215],Z([0,1,14,2,3,15,7,21,22,6,39,35,28]),function($,e,m,A,R,b,I,n,v,p,i,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=class mt extends A.Disposable{constructor(u,o,l,t,r){super();this.windowsMainService=u,this.stateMainService=o,this.lifecycleMainService=l,this.logService=t,this.configurationService=r,this._state=d(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){m.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),t&&(u.lastActiveWindow=this.toWindowState(t))}const o=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);o&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(o)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const l=D(u);this.stateMainService.setItem(mt.windowsStateStorageKey,l),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",l)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const o=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=o:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(l=>{var t;const r=k.isWorkspaceIdentifier(u.openedWorkspace)&&((t=l.workspace)===null||t===void 0?void 0:t.id)===u.openedWorkspace.id,s=k.isSingleFolderWorkspaceIdentifier(u.openedWorkspace)&&l.folderUri&&b.extUriBiasedIgnorePathCase.isEqual(l.folderUri,u.openedWorkspace.uri);(r||s)&&(l.uiState=o.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=o)}toWindowState(u){return{workspace:k.isWorkspaceIdentifier(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:k.isSingleFolderWorkspaceIdentifier(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const o=this.doGetNewWindowState(u),l=this.configurationService.getValue("window");let t;return o.hasDefaultState?t=!!((l==null?void 0:l.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0)||R.isMacintosh&&(l==null?void 0:l.nativeFullScreen)!==!1:(t=!!(this.lifecycleMainService.wasRestarted||(l==null?void 0:l.restoreFullscreen)),t&&R.isMacintosh&&this.windowsMainService.getWindows().some(r=>r.isFullScreen)&&(t=!1)),o.mode===3&&!t&&(o.mode=1),o}doGetNewWindowState(u){const o=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const h=u.workspace;if(k.isWorkspaceIdentifier(h)){const f=this.state.openedWindows.filter(S=>S.workspace&&S.workspace.id===h.id).map(S=>S.uiState);if(f.length)return f[0]}if(k.isSingleFolderWorkspaceIdentifier(h)){const f=this.state.openedWindows.filter(S=>S.folderUri&&b.extUriBiasedIgnorePathCase.isEqual(S.folderUri,h.uri)).map(S=>S.uiState);if(f.length)return f[0]}else if(u.backupPath){const f=this.state.openedWindows.filter(S=>S.backupPath===u.backupPath).map(S=>S.uiState);if(f.length)return f[0]}const w=this.lastClosedState||this.state.lastActiveWindow;if(!o&&w)return w.uiState}let l;const t=m.screen.getAllDisplays();if(t.length===1)l=t[0];else{if(R.isMacintosh){const h=m.screen.getCursorScreenPoint();l=m.screen.getDisplayNearestPoint(h)}!l&&o&&(l=m.screen.getDisplayMatching(o.getBounds())),l||(l=m.screen.getPrimaryDisplay()||t[0])}let r=E.defaultWindowState();r.x=Math.round(l.bounds.x+l.bounds.width/2-r.width/2),r.y=Math.round(l.bounds.y+l.bounds.height/2-r.height/2);const s=this.configurationService.getValue("window");let a=!0;if(R.isMacintosh&&(s==null?void 0:s.nativeFullScreen)!==!1&&(o==null?void 0:o.isFullScreen))r.mode=3;else if(s==null?void 0:s.newWindowDimensions){if(s.newWindowDimensions==="maximized")r.mode=0,a=!1;else if(s.newWindowDimensions==="fullscreen")r.mode=3,a=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&o){const h=o.serializeWindowState();h.mode===3?r.mode=3:r=h,a=r.mode!==3&&s.newWindowDimensions==="offset"}}return a&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const o=this.windowsMainService.getWindows().map(l=>l.getBounds());for(;o.some(l=>l.x===u.x||l.y===u.y);)u.x+=30,u.y+=30;return u}};y.windowsStateStorageKey="windowsState",y=he([ee(0,E.IWindowsMainService),ee(1,i.IStateMainService),ee(2,v.ILifecycleMainService),ee(3,p.ILogService),ee(4,n.IConfigurationService)],y),e.WindowsStateHandler=y;function d(c){const u={openedWindows:[]},o=c||{openedWindows:[]};return o.lastActiveWindow&&(u.lastActiveWindow=g(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=g(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(u.openedWindows=o.openedWindows.map(l=>g(l))),u}e.restoreWindowsState=d;function g(c){const u={uiState:c.uiState};return c.backupPath&&(u.backupPath=c.backupPath),c.remoteAuthority&&(u.remoteAuthority=c.remoteAuthority),c.folder&&(u.folderUri=I.URI.parse(c.folder)),c.workspaceIdentifier&&(u.workspace={id:c.workspaceIdentifier.id,configPath:I.URI.parse(c.workspaceIdentifier.configURIPath)}),u}function D(c){return{lastActiveWindow:c.lastActiveWindow&&P(c.lastActiveWindow),lastPluginDevelopmentHostWindow:c.lastPluginDevelopmentHostWindow&&P(c.lastPluginDevelopmentHostWindow),openedWindows:c.openedWindows.map(u=>P(u))}}e.getWindowsStateStoreData=D;function P(c){return{workspaceIdentifier:c.workspace&&{id:c.workspace.id,configURIPath:c.workspace.configPath.toString()},folder:c.folderUri&&c.folderUri.toString(),backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.uiState}}}),define(J[56],Z([0,1,58,59,216,5,34,8,26,27,2,17,85,16,3]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(f){this.socket=f,this._errorListener=S=>{if(S){if(S.code==="EPIPE")return;y.onUnexpectedError(S)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(f){const S=L=>f(E.VSBuffer.wrap(L));return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(f){const S=L=>{f({type:0,hadError:L,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(f){return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(f){if(!this.socket.destroyed)try{this.socket.write(f.buffer,S=>{if(S){if(S.code==="EPIPE")return;y.onUnexpectedError(S)}})}catch(S){if(S.code==="EPIPE")return;y.onUnexpectedError(S)}}end(){this.socket.end()}drain(){return new Promise((f,S)=>{if(this.socket.bufferSize===0){f();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),f()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.NodeSocket=g;var D;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize"})(D||(D={}));var P;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(P||(P={}));class c extends i.Disposable{constructor(f,S,L,_){super();this._onDidZlibFlush=this._register(new b.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new b.Emitter),this._onClose=this._register(new b.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=f,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=S,this._recordInflateBytes=_,S?(this._zlibInflate=R.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",H=>{console.error(H),y.onUnexpectedError(H),this._onClose.fire({type:0,hadError:!0,error:H})}),this._zlibInflate.on("data",H=>{this._pendingInflateData.push(H)}),L&&(this._zlibInflate.write(L.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=R.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",H=>{console.error(H),y.onUnexpectedError(H),this._onClose.fire({type:0,hadError:!0,error:H})}),this._zlibDeflate.on("data",H=>{this._pendingDeflateData.push(H)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new k.ChunkStream,this._register(this.socket.onData(H=>this._acceptChunk(H))),this._register(this.socket.onClose(H=>this._onClose.fire(H)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?E.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):E.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this._onData.event(f)}onClose(f){return this._onClose.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){this._totalOutgoingDataBytes+=f.byteLength,this._zlibDeflate?(this._zlibDeflate.write(f.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let S=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,S=S.slice(0,S.length-4),this._isEnded||this._write(E.VSBuffer.wrap(S),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(f,!1)}_write(f,S){let L=2;f.byteLength<126?L+=0:f.byteLength<2**16?L+=2:L+=8;const _=E.VSBuffer.alloc(L);if(S?_.writeUInt8(194,0):_.writeUInt8(130,0),f.byteLength<126)_.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){_.writeUInt8(126,1);let H=1;_.writeUInt8(f.byteLength>>>8&255,++H),_.writeUInt8(f.byteLength>>>0&255,++H)}else{_.writeUInt8(127,1);let H=1;_.writeUInt8(0,++H),_.writeUInt8(0,++H),_.writeUInt8(0,++H),_.writeUInt8(0,++H),_.writeUInt8(f.byteLength>>>24&255,++H),_.writeUInt8(f.byteLength>>>16&255,++H),_.writeUInt8(f.byteLength>>>8&255,++H),_.writeUInt8(f.byteLength>>>0&255,++H)}this._totalOutgoingWireBytes+=_.byteLength+f.byteLength,this.socket.write(E.VSBuffer.concat([_,f]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(f){if(f.byteLength!==0){for(this._totalIncomingWireBytes+=f.byteLength,this._incomingData.acceptChunk(f);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const S=this._incomingData.peek(this._state.readLen),_=(S.readUInt8(0)&128)>>>7,H=S.readUInt8(1),Q=(H&128)>>>7,te=H&127;this._state.state=2,this._state.readLen=2+(Q?4:0)+(te===126?2:0)+(te===127?8:0),this._state.fin=_,this._state.mask=0}else if(this._state.state===2){const S=this._incomingData.read(this._state.readLen),L=S.readUInt8(1),_=(L&128)>>>7;let H=L&127,Q=1;H===126?H=S.readUInt8(++Q)*2**8+S.readUInt8(++Q):H===127&&(H=S.readUInt8(++Q)*0+S.readUInt8(++Q)*0+S.readUInt8(++Q)*0+S.readUInt8(++Q)*0+S.readUInt8(++Q)*2**24+S.readUInt8(++Q)*2**16+S.readUInt8(++Q)*2**8+S.readUInt8(++Q));let te=0;_&&(te=S.readUInt8(++Q)*2**24+S.readUInt8(++Q)*2**16+S.readUInt8(++Q)*2**8+S.readUInt8(++Q)),this._state.state=3,this._state.readLen=H,this._state.mask=te}else if(this._state.state===3){const S=this._incomingData.read(this._state.readLen);u(S,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(S.buffer)),this._zlibInflate.write(S.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const L=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=L.length,this._onData.fire(E.VSBuffer.wrap(L))})):(this._totalIncomingDataBytes+=S.byteLength,this._onData.fire(S))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await b.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=c;function u(w,f){if(f===0)return;let S=w.byteLength>>>2;for(let B=0;B<S;B++){const Y=w.readUInt32BE(B*4);w.writeUInt32BE(Y^f,B*4)}let L=S*4,_=w.byteLength-L;const H=f>>>24&255,Q=f>>>16&255,te=f>>>8&255;_>=1&&w.writeUInt8(w.readUInt8(L)^H,L),_>=2&&w.writeUInt8(w.readUInt8(L+1)^Q,L+1),_>=3&&w.writeUInt8(w.readUInt8(L+2)^te,L+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function l(){const w=p.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;let f;return e.XDG_RUNTIME_DIR?f=n.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${w}.sock`):f=n.join(v.tmpdir(),`vscode-ipc-${w}.sock`),r(f),f}e.createRandomIPCHandle=l;function t(w,f,S){const L=m.createHash("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${S}-${f}-sock`;let _;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?_=n.join(e.XDG_RUNTIME_DIR,`vscode-${L.substr(0,8)}-${S}-${f}.sock`):_=n.join(w,`${S}-${f}.sock`),r(_),_}e.createStaticIPCHandle=t;function r(w){const f=o[d.platform];typeof f=="number"&&w.length>=f&&console.warn(`WARNING: IPC handle "${w}" is longer than ${f} chars, try a shorter --user-data-dir`)}class s extends I.IPCServer{constructor(f){super(s.toClientConnectionEvent(f));this.server=f}static toClientConnectionEvent(f){const S=b.Event.fromNodeEventEmitter(f,"connection");return b.Event.map(S,L=>({protocol:new k.Protocol(new g(L)),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(L,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function a(w){return new Promise((f,S)=>{const L=A.createServer();L.on("error",S),L.listen(w,()=>{L.removeListener("error",S),f(new s(L))})})}e.serve=a;function h(w,f){return new Promise((S,L)=>{const _=A.createConnection(w,()=>{_.removeListener("error",L),S(k.Client.fromSocket(new g(_),f))});_.once("error",L)})}e.connect=h}),define(J[217],Z([0,1,56]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class A{constructor(v){this.driver=v}listen(v,p){throw new Error("No event found")}call(v,p,i){switch(p){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(i);case"reloadWindow":return this.driver.reloadWindow(i);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(i[0],i[1]);case"click":return this.driver.click(i[0],i[1],i[2],i[3]);case"doubleClick":return this.driver.doubleClick(i[0],i[1]);case"setValue":return this.driver.setValue(i[0],i[1],i[2]);case"getTitle":return this.driver.getTitle(i[0]);case"isActiveElement":return this.driver.isActiveElement(i[0],i[1]);case"getElements":return this.driver.getElements(i[0],i[1],i[2]);case"getElementXY":return this.driver.getElementXY(i[0],i[1],i[2]);case"typeInEditor":return this.driver.typeInEditor(i[0],i[1],i[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(i[0],i[1]);case"writeInTerminal":return this.driver.writeInTerminal(i[0],i[1],i[2])}throw new Error(`Call not found: ${p}`)}}e.DriverChannel=A;class R{constructor(v){this.channel=v}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(v){return this.channel.call("capturePage",v)}reloadWindow(v){return this.channel.call("reloadWindow",v)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(v,p){return this.channel.call("dispatchKeybinding",[v,p])}click(v,p,i,E){return this.channel.call("click",[v,p,i,E])}doubleClick(v,p){return this.channel.call("doubleClick",[v,p])}setValue(v,p,i){return this.channel.call("setValue",[v,p,i])}getTitle(v){return this.channel.call("getTitle",[v])}isActiveElement(v,p){return this.channel.call("isActiveElement",[v,p])}getElements(v,p,i){return this.channel.call("getElements",[v,p,i])}getElementXY(v,p,i,E){return this.channel.call("getElementXY",[v,p,i,E])}typeInEditor(v,p,i){return this.channel.call("typeInEditor",[v,p,i])}getTerminalBuffer(v,p){return this.channel.call("getTerminalBuffer",[v,p])}writeInTerminal(v,p,i){return this.channel.call("writeInTerminal",[v,p,i])}}e.DriverChannelClient=R;class b{constructor(v){this.registry=v}listen(v,p){throw new Error(`Event not found: ${p}`)}call(v,p,i){switch(p){case"registerWindowDriver":return this.registry.registerWindowDriver(i);case"reloadWindowDriver":return this.registry.reloadWindowDriver(i)}throw new Error(`Call not found: ${p}`)}}e.WindowDriverRegistryChannel=b;async function I(n){const v=await m.connect(n,"driverClient"),p=v.getChannel("driver"),i=new R(p);return{client:v,driver:i}}e.connect=I}),define(J[24],Z([0,1,8,46,4,47,160,56]),function($,e,m,A,R,b,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=R.refineServiceDecorator(b.IEnvironmentService);class v extends I.NativeEnvironmentService{get cachedLanguagesPath(){return m.join(this.userDataPath,"clp")}get backupHome(){return m.join(this.userDataPath,"Backups")}get backupWorkspacesPath(){return m.join(this.backupHome,"workspaces.json")}get mainIPCHandle(){return n.createStaticIPCHandle(this.userDataPath,"main",this.productService.version)}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}}he([A.memoize],v.prototype,"cachedLanguagesPath",null),he([A.memoize],v.prototype,"backupHome",null),he([A.memoize],v.prototype,"backupWorkspacesPath",null),he([A.memoize],v.prototype,"mainIPCHandle",null),he([A.memoize],v.prototype,"sandbox",null),he([A.memoize],v.prototype,"driverVerbose",null),he([A.memoize],v.prototype,"disableUpdates",null),he([A.memoize],v.prototype,"disableKeytar",null),he([A.memoize],v.prototype,"codeCachePath",null),e.EnvironmentMainService=v}),define(J[218],Z([0,1,31,58,8,3,18,51,24,21,19,6,28,7,29,10,15]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let P=class{constructor(u,o,l){this.configurationService=o,this.logService=l,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=D.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,r)=>d.isEqual(t,r,!b.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await I.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let o=[];try{Array.isArray(u.rootURIWorkspaces)&&(o=u.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:y.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(o);let l=[];try{Array.isArray(u.folderURIWorkspaces)&&(l=u.folderURIWorkspaces.map(t=>y.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(l),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==i.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===i.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var u;const o=this.configurationService.getValue();return((u=o==null?void 0:o.files)===null||u===void 0?void 0:u.hotExit)||i.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,o){this.workspaces.some(t=>u.workspace.id===t.workspace.id)||(this.workspaces.push(u),this.saveSync());const l=this.getBackupPath(u.workspace.id);return o&&this.moveBackupFolderSync(l,o),l}moveBackupFolderSync(u,o){if(m.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),m.existsSync(o))try{m.renameSync(o,u)}catch(l){this.logService.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}unregisterWorkspaceBackupSync(u){const o=u.id,l=this.workspaces.findIndex(t=>t.workspace.id===o);l!==-1&&(this.workspaces.splice(l,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(o=>this.backupUriComparer.isEqual(u,o))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const o=this.folders.findIndex(l=>this.backupUriComparer.isEqual(u,l));o!==-1&&(this.folders.splice(o,1),this.saveSync())}registerEmptyWindowBackupSync(u,o){const l=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,l))||(this.emptyWindows.push({backupFolder:l,remoteAuthority:o}),this.saveSync()),this.getBackupPath(l)}unregisterEmptyWindowBackupSync(u){const o=this.emptyWindows.findIndex(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,u));o!==-1&&(this.emptyWindows.splice(o,1),this.saveSync())}getBackupPath(u){return R.join(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const o=new Set,l=[];for(let t of u){const r=t.workspace;if(!k.isWorkspaceIdentifier(r))return[];if(!o.has(r.id)){o.add(r.id);const s=this.getBackupPath(r.id);await this.doHasBackups(s)?r.configPath.scheme!==g.Schemas.file||await I.Promises.exists(r.configPath.fsPath)?l.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return l}async validateFolders(u){if(!Array.isArray(u))return[];const o=[],l=new Set;for(let t of u){const r=this.backupUriComparer.getComparisonKey(t);if(!l.has(r)){l.add(r);const s=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(s)?t.scheme!==g.Schemas.file||await I.Promises.exists(t.fsPath)?o.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return o}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const o=[],l=new Set;for(let t of u){const r=t.backupFolder;if(typeof r!="string")return[];if(!l.has(r)){l.add(r);const s=this.getBackupPath(r);await this.doHasBackups(s)?o.push(t):await this.deleteStaleBackup(s)}}return o}async deleteStaleBackup(u){try{await I.Promises.exists(u)&&await I.Promises.rm(u,I.RimRafMode.MOVE)}catch(o){this.logService.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}async convertToEmptyWindowBackup(u){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o));)o=this.getRandomEmptyWindowId();const l=this.getBackupPath(o);try{await I.Promises.rename(u,l)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}convertToEmptyWindowBackupSync(u){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o));)o=this.getRandomEmptyWindowId();const l=this.getBackupPath(o);try{m.renameSync(u,l)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}async getDirtyWorkspaces(){const u=[];for(const o of this.workspaces)await this.hasBackups(o)&&u.push(o.workspace);for(const o of this.folders)await this.hasBackups(o)&&u.push(o);return u}hasBackups(u){let o;return y.URI.isUri(u)?o=this.getBackupPath(this.getFolderHash(u)):n.isWorkspaceBackupInfo(u)?o=this.getBackupPath(u.workspace.id):o=u.backupFolder,this.doHasBackups(o)}async doHasBackups(u){try{const o=await I.Promises.readdir(u);for(const l of o)try{if((await I.Promises.readdir(R.join(u,l))).length>0)return!0}catch(t){}}catch(o){}return!1}saveSync(){try{I.writeFileSync(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await I.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderURIWorkspaces:this.folders.map(u=>u.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){let o;return u.scheme===g.Schemas.file?o=b.isLinux?u.fsPath:u.fsPath.toLowerCase():o=u.toString().toLowerCase(),A.createHash("md5").update(o).digest("hex")}};P=he([ee(0,v.IEnvironmentMainService),ee(1,p.IConfigurationService),ee(2,E.ILogService)],P),e.BackupMainService=P}),define(J[45],Z([0,1,41,114,145,83,5,35,14,22,3,24,52,18,7,32,4,26,66,6,8,20,46,2,60,30]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d,g,D,P,c,u,o,l,t,r,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=D.createDecorator("nativeHostMainService");let h=class ct extends r.Disposable{constructor(f,S,L,_,H,Q,te,B,Y){super();this.sharedProcess=f,this.windowsMainService=S,this.dialogMainService=L,this.lifecycleMainService=_,this.environmentMainService=H,this.telemetryService=Q,this.logService=te,this.productService=B,this.themeMainService=Y,this.onDidOpenWindow=I.Event.map(this.windowsMainService.onDidOpenWindow,G=>G.id),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(v.app,"browser-window-maximize",(G,C)=>C.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(v.app,"browser-window-unmaximize",(G,C)=>C.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(v.app,"browser-window-blur",(G,C)=>C.id),G=>!!this.windowsMainService.getWindowById(G)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),G=>!!G),G=>G.id),I.Event.filter(I.Event.fromNodeEventEmitter(v.app,"browser-window-focus",(G,C)=>C.id),G=>!!this.windowsMainService.getWindowById(G))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(v.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new I.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new I.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(v.screen,"display-metrics-changed",(G,C,z)=>z),G=>!(Array.isArray(G)&&G.length===1&&G[0]==="workArea")),I.Event.fromNodeEventEmitter(v.screen,"display-added"),I.Event.fromNodeEventEmitter(v.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){v.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors,dark:v.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(S=>{var L,_;return{id:S.id,workspace:S.openedWorkspace,title:(_=(L=S.win)===null||L===void 0?void 0:L.getTitle())!==null&&_!==void 0?_:"",filename:S.getRepresentedFilename(),dirty:S.isDocumentEdited()}})}async getWindowCount(f){return this.windowsMainService.getWindowCount()}async getActiveWindowId(f){const S=v.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(S)return S.id}openWindow(f,S,L){return Array.isArray(S)?this.doOpenWindow(f,S,L):this.doOpenEmptyWindow(f,S)}async doOpenWindow(f,S,L=Object.create(null)){S.length>0&&this.windowsMainService.open({context:5,contextWindowId:f,urisToOpen:S,cli:this.environmentMainService.args,forceNewWindow:L.forceNewWindow,forceReuseWindow:L.forceReuseWindow,preferNewWindow:L.preferNewWindow,diffMode:L.diffMode,addMode:L.addMode,gotoLineMode:L.gotoLineMode,noRecentEntry:L.noRecentEntry,waitMarkerFileURI:L.waitMarkerFileURI,remoteAuthority:L.remoteAuthority||void 0})}async doOpenEmptyWindow(f,S){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:f},S)}async toggleFullScreen(f){const S=this.windowById(f);S&&S.toggleFullScreen()}async handleTitleDoubleClick(f){const S=this.windowById(f);S&&S.handleTitleDoubleClick()}async isMaximized(f){const S=this.windowById(f);return(S==null?void 0:S.win)?S.win.isMaximized():!1}async maximizeWindow(f){const S=this.windowById(f);(S==null?void 0:S.win)&&S.win.maximize()}async unmaximizeWindow(f){const S=this.windowById(f);(S==null?void 0:S.win)&&S.win.unmaximize()}async minimizeWindow(f){const S=this.windowById(f);(S==null?void 0:S.win)&&S.win.minimize()}async focusWindow(f,S){var L;S&&typeof S.windowId=="number"&&(f=S.windowId);const _=this.windowById(f);_&&_.focus({force:(L=S==null?void 0:S.force)!==null&&L!==void 0?L:!1})}async setMinimumSize(f,S,L){const _=this.windowById(f);if(_==null?void 0:_.win){const[H,Q]=_.win.getSize(),[te,B]=_.win.getMinimumSize(),[Y,G]=[S??te,L??B],[C,z]=[Math.max(H,Y),Math.max(Q,G)];(te!==Y||B!==G)&&_.win.setMinimumSize(Y,G),(H!==C||Q!==z)&&_.win.setSize(C,z)}}async saveWindowSplash(f,S){this.themeMainService.saveWindowSplash(f,S)}async installShellCommand(f){const{source:S,target:L}=await this.getShellCommandLink();try{const{symbolicLink:_}=await y.SymlinkSupport.stat(S);if(_&&!_.dangling){const H=await b.realpath(S);if(L===H)return}await y.Promises.unlink(S)}catch(_){if(_.code!=="ENOENT")throw _}try{await y.Promises.symlink(L,S)}catch(_){if(_.code!=="EACCES"&&_.code!=="ENOENT")throw _;const{response:H}=await this.showMessageBox(f,{title:this.productService.nameLong,type:"info",message:R.localize(0,null,this.productService.nameShort),buttons:[a.mnemonicButtonLabel(R.localize(1,null)),a.mnemonicButtonLabel(R.localize(2,null))],noLink:!0,defaultId:0,cancelId:1});if(H===0)try{const Q=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${L}' '${S}'\\" with administrator privileges"`;await A.promisify(m.exec)(Q)}catch(Q){throw new Error(R.localize(3,null,S))}}}async uninstallShellCommand(f){const{source:S}=await this.getShellCommandLink();try{await y.Promises.unlink(S)}catch(L){switch(L.code){case"EACCES":const{response:_}=await this.showMessageBox(f,{title:this.productService.nameLong,type:"info",message:R.localize(4,null,this.productService.nameShort),buttons:[a.mnemonicButtonLabel(R.localize(5,null)),a.mnemonicButtonLabel(R.localize(6,null))],noLink:!0,defaultId:0,cancelId:1});if(_===0)try{const H=`osascript -e "do shell script \\"rm '${S}'\\" with administrator privileges"`;await A.promisify(m.exec)(H)}catch(H){throw new Error(R.localize(7,null,S))}break;case"ENOENT":break;default:throw L}}}async getShellCommandLink(){const f=o.resolve(this.environmentMainService.appRoot,"bin","code"),S=`/usr/local/bin/${this.productService.applicationName}`;if(!await y.Promises.exists(f))throw new Error(R.localize(8,null,f));return{source:S,target:f}}async showMessageBox(f,S){return this.dialogMainService.showMessageBox(S,this.toBrowserWindow(f))}async showSaveDialog(f,S){return this.dialogMainService.showSaveDialog(S,this.toBrowserWindow(f))}async showOpenDialog(f,S){return this.dialogMainService.showOpenDialog(S,this.toBrowserWindow(f))}toBrowserWindow(f){const S=this.windowById(f);if(S==null?void 0:S.win)return S.win}async pickFileFolderAndOpen(f,S){const L=await this.dialogMainService.pickFileFolder(S);L&&(this.sendPickerTelemetry(L,S.telemetryEventName||"openFileFolder",S.telemetryExtraData),this.doOpenPicked(await Promise.all(L.map(async _=>await y.SymlinkSupport.existsDirectory(_)?{folderUri:d.URI.file(_)}:{fileUri:d.URI.file(_)})),S,f))}async pickFolderAndOpen(f,S){const L=await this.dialogMainService.pickFolder(S);L&&(this.sendPickerTelemetry(L,S.telemetryEventName||"openFolder",S.telemetryExtraData),this.doOpenPicked(L.map(_=>({folderUri:d.URI.file(_)})),S,f))}async pickFileAndOpen(f,S){const L=await this.dialogMainService.pickFile(S);L&&(this.sendPickerTelemetry(L,S.telemetryEventName||"openFile",S.telemetryExtraData),this.doOpenPicked(L.map(_=>({fileUri:d.URI.file(_)})),S,f))}async pickWorkspaceAndOpen(f,S){const L=await this.dialogMainService.pickWorkspace(S);L&&(this.sendPickerTelemetry(L,S.telemetryEventName||"openWorkspace",S.telemetryExtraData),this.doOpenPicked(L.map(_=>({workspaceUri:d.URI.file(_)})),S,f))}doOpenPicked(f,S,L){this.windowsMainService.open({context:3,contextWindowId:L,cli:this.environmentMainService.args,urisToOpen:f,forceNewWindow:S.forceNewWindow})}sendPickerTelemetry(f,S,L){const _=f?f.length:0;this.telemetryService.publicLog(S,Object.assign(Object.assign({},L),{outcome:_?"success":"canceled",numberOfPaths:_}))}async showItemInFolder(f,S){v.shell.showItemInFolder(S)}async setRepresentedFilename(f,S){const L=this.windowById(f);L&&L.setRepresentedFilename(S)}async setDocumentEdited(f,S){const L=this.windowById(f);L&&L.setDocumentEdited(S)}async openExternal(f,S){return i.isLinuxSnap?this.safeSnapOpenExternal(S):v.shell.openExternal(S),!0}safeSnapOpenExternal(f){const S=process.env.GDK_PIXBUF_MODULE_FILE,L=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,v.shell.openExternal(f),process.env.GDK_PIXBUF_MODULE_FILE=S,process.env.GDK_PIXBUF_MODULEDIR=L}moveItemToTrash(f,S){return v.shell.trashItem(S)}async isAdmin(){let f;return i.isWindows?f=(await new Promise((S,L)=>{$(["native-is-elevated"],S,L)}))():f=process.getuid()===0,f}async writeElevated(f,S,L,_){const H=await new Promise((Q,te)=>{$(["sudo-prompt"],Q,te)});return new Promise((Q,te)=>{const B=[`"${this.cliPath}"`];(_==null?void 0:_.unlock)&&B.push("--file-chmod"),B.push("--file-write",`"${S.fsPath}"`,`"${L.fsPath}"`);const Y={name:this.productService.nameLong.replace("-",""),icns:i.isMacintosh&&this.environmentMainService.isBuilt?o.join(o.dirname(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};H.exec(B.join(" "),Y,(G,C,z)=>{C&&this.logService.trace(`[sudo-prompt] received stdout: ${C}`),z&&this.logService.trace(`[sudo-prompt] received stderr: ${z}`),G?te(G):Q(void 0)})})}get cliPath(){return i.isWindows?this.environmentMainService.isBuilt?o.join(o.dirname(process.execPath),"bin",`${this.productService.applicationName}.cmd`):o.join(this.environmentMainService.appRoot,"scripts","code-cli.bat"):i.isLinux?this.environmentMainService.isBuilt?o.join(o.dirname(process.execPath),"bin",`${this.productService.applicationName}`):o.join(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?o.join(this.environmentMainService.appRoot,"bin","code"):o.join(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:P.totalmem(),freemem:P.freemem(),loadavg:P.loadavg()}}async getOSProperties(){return{arch:P.arch(),platform:P.platform(),release:P.release(),type:P.type(),cpus:P.cpus()}}async getOSVirtualMachineHint(){return c.virtualMachineHint.value()}async killProcess(f,S,L){process.kill(S,L)}async readClipboardText(f,S){return v.clipboard.readText(S)}async writeClipboardText(f,S,L){return v.clipboard.writeText(S,L)}async readClipboardFindText(f){return v.clipboard.readFindText()}async writeClipboardFindText(f,S){return v.clipboard.writeFindText(S)}async writeClipboardBuffer(f,S,L,_){return v.clipboard.writeBuffer(S,Buffer.from(L),_)}async readClipboardBuffer(f,S){return v.clipboard.readBuffer(S)}async hasClipboard(f,S,L){return v.clipboard.has(S,L)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){v.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){v.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){v.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){v.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){v.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(f,S){const L=this.windowById(f);L&&L.updateTouchBar(S)}async notifyReady(f){const S=this.windowById(f);S&&S.setReady()}async relaunch(f,S){return this.lifecycleMainService.relaunch(S)}async reload(f,S){const L=this.windowById(f);if(L)return this.lifecycleMainService.reload(L,(S==null?void 0:S.disableExtensions)!==void 0?{_:[],"disable-extensions":S==null?void 0:S.disableExtensions}:void 0)}async closeWindow(f){this.closeWindowById(f,f)}async closeWindowById(f,S){const L=this.windowById(S);if(L==null?void 0:L.win)return L.win.close()}async quit(f){const S=this.windowsMainService.getLastActiveWindow();(S==null?void 0:S.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1&&S.win?S.win.close():this.lifecycleMainService.quit()}async exit(f,S){await this.lifecycleMainService.kill(S)}async resolveProxy(f,S){var L,_;const H=this.windowById(f),Q=(_=(L=H==null?void 0:H.win)===null||L===void 0?void 0:L.webContents)===null||_===void 0?void 0:_.session;if(Q)return Q.resolveProxy(S)}async openDevTools(f,S){const L=this.windowById(f);(L==null?void 0:L.win)&&L.win.webContents.openDevTools(S)}async toggleDevTools(f){const S=this.windowById(f);(S==null?void 0:S.win)&&S.win.webContents.toggleDevTools()}async sendInputEvent(f,S){const L=this.windowById(f);(L==null?void 0:L.win)&&(S.type==="mouseDown"||S.type==="mouseUp")&&L.win.webContents.sendInputEvent(S)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(f,S,L,_){if(!i.isWindows)return;const H=await new Promise((Q,te)=>{$(["vscode-windows-registry"],Q,te)});try{return H.GetStringRegKey(S,L,_)}catch(Q){return}}async getPassword(f,S,L){const _=await this.withKeytar(),H=await _.getPassword(S,L);if(H)try{let{content:Q,hasNextChunk:te}=JSON.parse(H);if(!Q||!te)return H;let B=1;for(;te;){const Y=await _.getPassword(S,`${L}-${B}`),G=JSON.parse(Y);Q+=G.content,te=G.hasNextChunk}return Q}catch(Q){return H}return H}async setPassword(f,S,L,_){const H=await this.withKeytar(),Q=3,te=async(B,Y,G)=>{let C=0,z;for(;C<Q;)try{await H.setPassword(B,Y,G);return}catch(X){z=X,this.logService.warn("Error attempting to set a password: ",X),C++,await new Promise(N=>setTimeout(N,200))}throw z};if(i.isWindows&&_.length>ct.MAX_PASSWORD_LENGTH){let B=0,Y=0,G=!0;for(;G;){const C=_.substring(B,B+ct.PASSWORD_CHUNK_SIZE);B+=ct.PASSWORD_CHUNK_SIZE,G=_.length-B>0;const z={content:C,hasNextChunk:G};await te(S,Y?`${L}-${Y}`:L,JSON.stringify(z)),Y++}}else await te(S,L,_);this._onDidChangePassword.fire({service:S,account:L})}async deletePassword(f,S,L){const H=await(await this.withKeytar()).deletePassword(S,L);return H&&this._onDidChangePassword.fire({service:S,account:L}),H}async findPassword(f,S){return(await this.withKeytar()).findPassword(S)}async findCredentials(f,S){return(await this.withKeytar()).findCredentials(S)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((f,S)=>{$(["keytar"],f,S)})}windowById(f){if(typeof f=="number")return this.windowsMainService.getWindowById(f)}};h.MAX_PASSWORD_LENGTH=2500,h.PASSWORD_CHUNK_SIZE=h.MAX_PASSWORD_LENGTH-100,he([t.memoize],h.prototype,"cliPath",null),h=he([ee(1,n.IWindowsMainService),ee(2,k.IDialogMainService),ee(3,p.ILifecycleMainService),ee(4,E.IEnvironmentMainService),ee(5,g.ITelemetryService),ee(6,u.ILogService),ee(7,l.IProductService),ee(8,s.IThemeMainService)],h),e.NativeHostMainService=h}),define(J[219],Z([0,1,2,5,81,14,6,35,45,90,27,20,25]),function($,e,m,A,R,b,I,n,v,p,i,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var y;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let d=class extends m.Disposable{constructor(D,P,c,u,o){super();this.logService=D,this.windowsMainService=P,this.nativeHostMainService=c,this.encryptionMainService=u,this.productService=o,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=y.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const D=A.Event.fromNodeEventEmitter(b.app,"login",(P,c,u,o,l)=>({event:P,webContents:c,req:u,authInfo:o,callback:l}));this._register(D(this.onLogin,this))}async onLogin({event:D,authInfo:P,req:c,callback:u}){if(!P.isProxy)return;if(!this.pendingProxyResolve&&this.state===y.LoginDialogShown&&c.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}D.preventDefault();let o;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),o=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(P);try{o=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}u(o==null?void 0:o.username,o==null?void 0:o.password)}async resolveProxyCredentials(D){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const P=await this.doResolveProxyCredentials(D);if(P)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),P;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(D){var P,c,u,o;this.logService.trace("auth#doResolveProxyCredentials - enter",D);const l=String(R.hash({scheme:D.scheme,host:D.host,port:D.port}));let t,r;try{const w=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,l);if(w){const f=JSON.parse(await this.encryptionMainService.decrypt(w));t=f.username,r=f.password}}catch(w){this.logService.error(w)}if(this.state!==y.StoredCredentialsUsed&&typeof t=="string"&&typeof r=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=y.StoredCredentialsUsed,{username:t,password:r};const s=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!s){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${s.id} to handle proxy login`);const a={authInfo:D,username:(c=(P=this.sessionCredentials)===null||P===void 0?void 0:P.username)!==null&&c!==void 0?c:t,password:(o=(u=this.sessionCredentials)===null||u===void 0?void 0:u.password)!==null&&o!==void 0?o:r,replyChannel:`vscode:proxyAuthResponse:${i.generateUuid()}`};s.sendWhenReady("vscode:openProxyAuthenticationDialog",k.CancellationToken.None,a),this.state=y.LoginDialogShown;const h=await new Promise(w=>{var f;const S=async(L,_,H)=>{var Q;if(_===a.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${s.id}`),(Q=s.win)===null||Q===void 0||Q.webContents.off("ipc-message",S),H){const te={username:H.username,password:H.password};try{if(H.remember){const B=await this.encryptionMainService.encrypt(JSON.stringify(te));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,l,B)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,l)}catch(B){this.logService.error(B)}w({username:te.username,password:te.password})}else w(void 0)};(f=s.win)===null||f===void 0||f.webContents.on("ipc-message",S)});return this.sessionCredentials=h,h}};d=he([ee(0,I.ILogService),ee(1,n.IWindowsMainService),ee(2,v.INativeHostMainService),ee(3,p.IEncryptionMainService),ee(4,E.IProductService)],d),e.ProxyAuthHandler=d}),define(J[220],Z([0,1,217,155,35,56,2,34,57,176,3,5,80,106,9,22,45]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function P(o){return o<21}let c=class{constructor(l,t,r,s,a){this.windowServer=l,this.options=t,this.windowsMainService=r,this.lifecycleMainService=s,this.nativeHostMainService=a,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new E.Emitter}async registerWindowDriver(l){return this.registeredWindowIds.add(l),this.reloadingWindowIds.delete(l),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(l){this.reloadingWindowIds.add(l)}async getWindowIds(){return this.windowsMainService.getWindows().map(l=>l.id).filter(l=>this.registeredWindowIds.has(l)&&!this.reloadingWindowIds.has(l))}async capturePage(l){await this.whenUnfrozen(l);const t=this.windowsMainService.getWindowById(l);if(!(t==null?void 0:t.win))throw new Error("Invalid window");return(await t.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(l){await this.whenUnfrozen(l);const t=this.windowsMainService.getWindowById(l);if(!t)throw new Error("Invalid window");this.reloadingWindowIds.add(l),this.lifecycleMainService.reload(t)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(l,t){await this.whenUnfrozen(l);const r=y.KeybindingParser.parseUserBinding(t);for(let s of r)await this._dispatchKeybinding(l,s)}async _dispatchKeybinding(l,t){if(t instanceof k.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const r=this.windowsMainService.getWindowById(l);if(!(r==null?void 0:r.win))throw new Error("Invalid window");const s=r.win.webContents,a=new v.SimpleKeybinding(!1,!1,!1,!1,t.keyCode),w=new p.USLayoutResolvedKeybinding(a.toChord(),i.OS).getElectronAccelerator(),f=[];t.ctrlKey&&f.push("ctrl"),t.metaKey&&f.push("meta"),t.shiftKey&&f.push("shift"),t.altKey&&f.push("alt"),s.sendInputEvent({type:"keyDown",keyCode:w,modifiers:f}),P(t.keyCode)||s.sendInputEvent({type:"char",keyCode:w,modifiers:f}),s.sendInputEvent({type:"keyUp",keyCode:w,modifiers:f}),await d.timeout(100)}async click(l,t,r,s){await(await this.getWindowDriver(l)).click(t,r,s)}async doubleClick(l,t){await(await this.getWindowDriver(l)).doubleClick(t)}async setValue(l,t,r){await(await this.getWindowDriver(l)).setValue(t,r)}async getTitle(l){return await(await this.getWindowDriver(l)).getTitle()}async isActiveElement(l,t){return await(await this.getWindowDriver(l)).isActiveElement(t)}async getElements(l,t,r){return await(await this.getWindowDriver(l)).getElements(t,r)}async getElementXY(l,t,r,s){return await(await this.getWindowDriver(l)).getElementXY(t,r,s)}async typeInEditor(l,t,r){await(await this.getWindowDriver(l)).typeInEditor(t,r)}async getTerminalBuffer(l,t){return await(await this.getWindowDriver(l)).getTerminalBuffer(t)}async writeInTerminal(l,t,r){await(await this.getWindowDriver(l)).writeInTerminal(t,r)}async getWindowDriver(l){await this.whenUnfrozen(l);const t=`window:${l}`,r=new n.StaticRouter(a=>a===t),s=this.windowServer.getChannel("windowDriver",r);return new A.WindowDriverChannelClient(s)}async whenUnfrozen(l){for(;this.reloadingWindowIds.has(l);)await E.Event.toPromise(this.onDidReloadingChange.event)}};c=he([ee(2,R.IWindowsMainService),ee(3,g.ILifecycleMainService),ee(4,D.INativeHostMainService)],c),e.Driver=c;async function u(o,l,t,r){const s=t.driverVerbose,a=r.createInstance(c,o,{verbose:s}),h=new m.WindowDriverRegistryChannel(a);o.registerChannel("windowDriverRegistry",h);const w=await b.serve(l),f=new m.DriverChannel(a);return w.registerChannel("driver",f),I.combinedDisposable(w,o)}e.serve=u}),define(J[221],Z([0,1,59,56]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,b,I,n){const v=i=>n(i,void 0),p=m.createConnection({host:R,port:b},()=>{p.removeListener("error",v);const i=Buffer.alloc(16);for(let d=0;d<16;d++)i[d]=Math.round(Math.random()*256);const E=i.toString("base64");let k=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${b}/?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`];p.write(k.join(`\r
`)+`\r
\r
`);const y=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(p.off("data",y),n(void 0,new A.NodeSocket(p)))};p.on("data",y)});p.once("error",v)}}}),define(J[222],Z([0,1,59,9,2,115,21,6,20,191,74,221,75]),function($,e,m,A,R,b,I,n,v,p,i,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function y(P,c,u,o,l){return new d(P,c,u,o,l).waitForReady()}class d extends R.Disposable{constructor(c,u,o,l,t){super();this.defaultTunnelHost=u,this.suggestedLocalPort=t,this.public=!1,this._socketsDispose=new Map,this._options=c,this._server=m.createServer(),this._barrier=new A.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=l,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(u=>{u()})}async waitForReady(){var c;let u=await b.findFreePortFaster((c=this.suggestedLocalPort)!==null&&c!==void 0?c:this.tunnelRemotePort,2,1e3),o=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),o=this._server.address(),o||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),o=this._server.address()),this.tunnelLocalPort=o.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${o.port}`,this}async _onConnection(c){c.pause();const u=await p.connectRemoteAgentTunnel(this._options,this.tunnelRemotePort),o=u.getSocket().socket,l=u.readEntireBuffer();u.dispose(),l.byteLength>0&&c.write(l.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),o.end()}),c.on("close",()=>o.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),o.destroy()}),o.on("end",()=>c.end()),o.on("close",()=>c.end()),o.on("error",()=>{c.destroy()}),c.pipe(o),o.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),o.end()})}}let g=class extends i.AbstractTunnelService{constructor(c,u,o,l,t){super(u);this.socketFactory=c,this.signService=o,this.productService=l,this.configurationService=t}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,u,o,l,t,r,s){const a=this.getTunnelFromMap(u,o);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,u,o,l,t,r,s);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${o} on local port ${l}.`);const h={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},w=y(h,this.defaultTunnelHost,u,o,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(u,o,w),w}}};g=he([ee(1,n.ILogService),ee(2,k.ISignService),ee(3,v.IProductService),ee(4,I.IConfigurationService)],g),e.BaseTunnelService=g;let D=class extends g{constructor(c,u,o,l){super(E.nodeSocketFactory,c,u,o,l)}};D=he([ee(0,n.ILogService),ee(1,k.ISignService),ee(2,v.IProductService),ee(3,I.IConfigurationService)],D),e.TunnelService=D}),define(J[223],Z([0,1,216,193,2,13,16,192,21,6,17,47,92]),function($,e,m,A,R,b,I,n,v,p,i,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let y=class extends R.Disposable{constructor(g,D,P){super();this.environmentService=D,this.logService=P,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,D){this.logService.trace("RequestService#request",g.url);const{proxyUrl:P,strictSSL:c}=this,u=Object.assign(Object.assign({},process.env),await k.resolveShellEnv(this.logService,this.environmentService.args,process.env)),o=g.agent?g.agent:await n.getProxyAgent(g.url||"",u,{proxyUrl:P,strictSSL:c});return g.agent=o,g.strictSSL=c,this.authorization&&(g.headers=Object.assign(Object.assign({},g.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(g,D)}async getNodeRequest(g){return(A.parse(g.url).protocol==="https:"?await new Promise((c,u)=>{$(["https"],c,u)}):await new Promise((c,u)=>{$(["http"],c,u)})).request}_request(g,D){return new Promise(async(P,c)=>{let u;const o=A.parse(g.url),l=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),t={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:b.isBoolean(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(t.auth=g.user+":"+g.password),u=l(t,r=>{const s=b.isNumber(g.followRedirects)?g.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&s>0&&r.headers.location)this._request(Object.assign(Object.assign({},g),{url:r.headers.location,followRedirects:s-1}),D).then(P,c);else{let a=r;r.headers["content-encoding"]==="gzip"&&(a=r.pipe(m.createGunzip())),P({res:r,stream:i.streamToBufferReadableStream(a)})}}),u.on("error",c),g.timeout&&u.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&u.write(g.data),u.end(),D.onCancellationRequested(()=>{u.abort(),c(I.canceled())})})}async resolveProxy(g){}};y=he([ee(0,v.IConfigurationService),ee(1,E.INativeEnvironmentService),ee(2,p.ILogService)],y),e.RequestService=y}),define(J[224],Z([0,1,223,14]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function R(I){return A.net.request}class b extends m.RequestService{request(n,v){return super.request(Object.assign(Object.assign({},n||{}),{getRawRequest:R}),v)}}e.RequestMainService=b}),define(J[225],Z([0,1,48,14,24,9,6,22,60,10,3,2,86,13,5,55]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let D=class extends E.Disposable{constructor(c,u,o,l,t,r,s){super();this.machineId=c,this.userEnv=u,this.environmentMainService=o,this.lifecycleMainService=l,this.logService=t,this.themeMainService=r,this.protocolMainService=s,this.firstWindowConnectionBarrier=new b.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new d.Emitter),this.onDidError=d.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),A.ipcMain.on("vscode:createSharedProcessMessageChannel",async(c,u)=>this.onWindowConnection(c,u))}async onWindowConnection(c,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const o=await this.connect();if(c.sender.isDestroyed())return o.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[o])}onWillShutdown(){const c=this.window;!c||(!c.isDestroyed()&&!c.webContents.isDestroyed()&&c.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{c.close()}catch(u){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(c=>A.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),c()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(c=>A.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),c()}))})()),this._whenIpcReady}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new A.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:p.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`],v8CacheOptions:i.browserCodeLoadingCacheStrategy,nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),c.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:m.default}),this.window.loadURL(p.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",$).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=c=>{var u;this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),((u=this.window)===null||u===void 0?void 0:u.isVisible())&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(c,u,o)=>this._onDidError.fire({type:3,details:{reason:o,exitCode:u}})))}async connect(){await this.whenIpcReady;const c=y.assertIsDefined(this.window);return k.connect(c)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){var c,u;return(u=(c=this.window)===null||c===void 0?void 0:c.isVisible())!==null&&u!==void 0?u:!1}};D=he([ee(2,R.IEnvironmentMainService),ee(3,n.ILifecycleMainService),ee(4,I.ILogService),ee(5,v.IThemeMainService),ee(6,g.IProtocolMainService)],D),e.SharedProcess=D}),define(J[226],Z([0,1,7,8,13,6,24,9,19,17]),function($,e,m,A,R,b,I,n,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class i{constructor(y,d,g){this.storagePath=y,this.logService=d,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new n.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}}getItem(y,d){const g=this.storage[y];return R.isUndefinedOrNull(g)?d:g}setItem(y,d){this.setItems([{key:y,data:d}])}setItems(y){let d=!1;for(const{key:g,data:D}of y)this.storage[g]!==D&&(R.isUndefinedOrNull(D)?R.isUndefined(this.storage[g])||(this.storage[g]=void 0,d=!0):(this.storage[g]=D,d=!0));d&&this.save()}removeItem(y){R.isUndefined(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(y){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),y)}async doSave(){if(!this.initializing)return;await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,p.VSBuffer.fromString(y)),this.lastSavedStorageContents=y}catch(d){this.logService.error(d)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=i;let E=class bt{constructor(y,d,g){this.fileStorage=new i(m.URI.file(A.join(y.userDataPath,bt.STATE_FILE)),d,g)}async init(){return this.fileStorage.init()}getItem(y,d){return this.fileStorage.getItem(y,d)}setItem(y,d){this.fileStorage.setItem(y,d)}setItems(y){this.fileStorage.setItems(y)}removeItem(y){this.fileStorage.removeItem(y)}close(){return this.fileStorage.close()}};E.STATE_FILE="storage.json",E=he([ee(0,I.IEnvironmentMainService),ee(1,b.ILogService),ee(2,v.IFileService)],E),e.StateMainService=E}),define(J[77],Z([0,1,5,9,21,22,20,42,24,6,50,25]),function($,e,m,A,R,b,I,n,v,p,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function k(d,g,D){return`${D.updateUrl}/api/update/${d}/${g}/${D.commit}`}e.createUpdateURL=k;let y=class{constructor(g,D,P,c,u,o){this.lifecycleMainService=g,this.configurationService=D,this.environmentMainService=P,this.requestService=c,this.logService=u,this.productService=o,this._state=n.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=R.getMigratedSettingValue(this.configurationService,"update.mode","update.channel"),D=this.getProductQuality(g);if(!D){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(D),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(n.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,P=>this.logService.error(P))}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return A.timeout(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},E.CancellationToken.None).then(g=>g.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};y=he([ee(0,b.ILifecycleMainService),ee(1,R.IConfigurationService),ee(2,v.IEnvironmentMainService),ee(3,i.IRequestService),ee(4,p.ILogService),ee(5,I.IProductService)],y),e.AbstractUpdateService=y}),define(J[227],Z([0,1,14,2,5,46,21,22,42,32,24,6,77,50,20]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends k.AbstractUpdateService{constructor(P,c,u,o,l,t,r){super(P,c,o,l,t,r);this.telemetryService=u,this.disposables=new A.DisposableStore}get onRawError(){return R.Event.fromNodeEventEmitter(m.autoUpdater,"error",(P,c)=>c)}get onRawUpdateNotAvailable(){return R.Event.fromNodeEventEmitter(m.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return R.Event.fromNodeEventEmitter(m.autoUpdater,"update-available",(P,c,u)=>({url:c,version:u,productVersion:u}))}get onRawUpdateDownloaded(){return R.Event.fromNodeEventEmitter(m.autoUpdater,"update-downloaded",(P,c,u,o)=>({releaseNotes:c,version:u,productVersion:u,date:o}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(P){this.logService.error("UpdateService error:",P);const u=(this.state.type==="checking for updates"?this.state.explicit:!0)?P:void 0;this.setState(v.State.Idle(1,u))}buildUpdateFeedUrl(P){let c;this.productService.darwinUniversalAssetId?c=this.productService.darwinUniversalAssetId:c=process.arch==="x64"?"darwin":"darwin-arm64";const u=k.createUpdateURL(c,P,this.productService);try{m.autoUpdater.setFeedURL({url:u})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return u}doCheckForUpdates(P){this.setState(v.State.CheckingForUpdates(P)),m.autoUpdater.checkForUpdates()}onUpdateAvailable(P){this.state.type==="checking for updates"&&this.setState(v.State.Downloading(P))}onUpdateDownloaded(P){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:P.version}),this.setState(v.State.Ready(P)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(v.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),m.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([b.memoize],g.prototype,"onRawError",null),he([b.memoize],g.prototype,"onRawUpdateNotAvailable",null),he([b.memoize],g.prototype,"onRawUpdateAvailable",null),he([b.memoize],g.prototype,"onRawUpdateDownloaded",null),g=he([ee(0,n.ILifecycleMainService),ee(1,I.IConfigurationService),ee(2,p.ITelemetryService),ee(3,i.IEnvironmentMainService),ee(4,y.IRequestService),ee(5,E.ILogService),ee(6,d.IProductService)],g),e.DarwinUpdateService=g}),define(J[228],Z([0,1,20,21,22,42,32,24,6,77,50,25,45]),function($,e,m,A,R,b,I,n,v,p,i,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let y=class extends p.AbstractUpdateService{constructor(g,D,P,c,u,o,l,t){super(g,D,c,u,o,t);this.telemetryService=P,this.nativeHostMainService=l}buildUpdateFeedUrl(g){return p.createUpdateURL(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(b.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},E.CancellationToken.None).then(i.asJson).then(D=>{!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(b.State.Idle(1))):this.setState(b.State.AvailableForDownload(D))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const P=g?D.message||D:void 0;this.setState(b.State.Idle(1,P))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(b.State.Idle(1))}};y=he([ee(0,R.ILifecycleMainService),ee(1,A.IConfigurationService),ee(2,I.ITelemetryService),ee(3,n.IEnvironmentMainService),ee(4,i.IRequestService),ee(5,v.ILogService),ee(6,k.INativeHostMainService),ee(7,m.IProductService)],y),e.LinuxUpdateService=y}),define(J[229],Z([0,1,5,9,22,42,24,6,8,31,41,32]),function($,e,m,A,R,b,I,n,v,p,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let k=class{constructor(g,D,P){if(this.lifecycleMainService=g,this.logService=P,this._state=b.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,D.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(b.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,c=>this.logService.error(c))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return A.timeout(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};k=he([ee(0,R.ILifecycleMainService),ee(1,I.IEnvironmentMainService),ee(2,n.ILogService)],k);let y=class extends k{constructor(g,D,P,c,u,o){super(P,c,u);this.snap=g,this.snapRevision=D,this.telemetryService=o;const l=p.watch(v.dirname(this.snap)),t=m.Event.fromNodeEventEmitter(l,"change",(h,w)=>w),r=m.Event.filter(t,h=>h==="current"),a=m.Event.debounce(r,(h,w)=>w,2e3)(()=>this.checkForUpdates(!1));P.onWillShutdown(()=>{a.dispose(),l.close()})}doCheckForUpdates(){this.setState(b.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(b.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),i.spawn("sleep 3 && "+v.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((P,c)=>p.realpath(`${v.dirname(this.snap)}/current`,(u,o)=>u?c(u):P(o))),D=v.basename(g);return this.snapRevision!==D}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};y=he([ee(2,R.ILifecycleMainService),ee(3,I.IEnvironmentMainService),ee(4,n.ILogService),ee(5,E.ITelemetryService)],y),e.SnapUpdateService=y}),define(J[230],Z([0,1,31,8,18,46,21,22,20,42,32,24,6,77,50,112,26,41,25,9,19,7,45]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d,g,D,P,c,u,o,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(w,f=1e3){for(;!w();)await u.timeout(f)}let s;function a(){return typeof s=="undefined"&&(s=m.existsSync(A.join(A.dirname(process.execPath),"unins000.exe"))?0:1),s}let h=class extends y.AbstractUpdateService{constructor(f,S,L,_,H,Q,te,B,Y){super(f,S,_,H,Q,Y);this.telemetryService=L,this.fileService=te,this.nativeHostMainService=B}get cachePath(){const f=A.join(D.tmpdir(),`vscode-update-${this.productService.target}-${process.arch}`);return R.Promises.mkdir(f,{recursive:!0}).then(()=>f)}initialize(){super.initialize(),a()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(f){let S="win32";return process.arch!=="ia32"&&(S+=`-${process.arch}`),a()===1?S+="-archive":this.productService.target==="user"&&(S+="-user"),y.createUpdateURL(S,f,this.productService)}doCheckForUpdates(f){!this.url||(this.setState(p.State.CheckingForUpdates(f)),this.requestService.request({url:this.url},c.CancellationToken.None).then(d.asJson).then(S=>{const L=a();return!S||!S.url||!S.version||!S.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!f}),this.setState(p.State.Idle(L)),Promise.resolve(null)):L===1?(this.setState(p.State.AvailableForDownload(S)),Promise.resolve(null)):(this.setState(p.State.Downloading(S)),this.cleanup(S.version).then(()=>this.getUpdatePackagePath(S.version).then(_=>R.Promises.exists(_).then(H=>{if(H)return Promise.resolve(_);const Q=S.url,te=S.hash,B=`${_}.tmp`;return this.requestService.request({url:Q},c.CancellationToken.None).then(Y=>this.fileService.writeFile(l.URI.file(B),Y.stream)).then(te?()=>g.checksum(B,S.hash):()=>{}).then(()=>R.Promises.rename(B,_)).then(()=>_)})).then(_=>{const H=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:_},H&&S.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(p.State.Downloaded(S)):this.setState(p.State.Ready(S))})))}).then(void 0,S=>{this.logService.error(S),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!f});const L=f?S.message||S:void 0;this.setState(p.State.Idle(a(),L))}))}async doDownloadUpdate(f){f.update.url&&this.nativeHostMainService.openExternal(void 0,f.update.url),this.setState(p.State.Idle(a()))}async getUpdatePackagePath(f){const S=await this.cachePath;return A.join(S,`CodeSetup-${this.productService.quality}-${f}.exe`)}async cleanup(f=null){const S=f?Q=>!new RegExp(`${this.productService.quality}-${f}\\.exe$`).test(Q):()=>!0,L=await this.cachePath,H=(await R.Promises.readdir(L)).filter(S).map(async Q=>{try{await R.Promises.unlink(A.join(L,Q))}catch(te){}});await Promise.all(H)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const f=this.state.update;this.setState(p.State.Updating(f));const S=await this.cachePath;this.availableUpdate.updateFilePath=A.join(S,`CodeSetup-${this.productService.quality}-${f.version}.flag`),await R.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),P.spawn(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(p.State.Idle(a()))});const _=`${this.productService.win32MutexName}-ready`,H=await new Promise((Q,te)=>{$(["windows-mutex"],Q,te)});r(()=>H.isActive(_)).then(()=>this.setState(p.State.Ready(f)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?m.unlinkSync(this.availableUpdate.updateFilePath):P.spawn(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return a()}};he([b.memoize],h.prototype,"cachePath",null),h=he([ee(0,n.ILifecycleMainService),ee(1,I.IConfigurationService),ee(2,i.ITelemetryService),ee(3,E.IEnvironmentMainService),ee(4,d.IRequestService),ee(5,k.ILogService),ee(6,o.IFileService),ee(7,t.INativeHostMainService),ee(8,v.IProductService)],h),e.Win32UpdateService=h}),define(J[53],Z([0,1,28,24,8,18,31,3,5,6,58,40,10,2,15,4,153,20,14,13,51,52,101,30]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d,g,D,P,c,u,o,l,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=g.createDecorator("workspacesManagementMainService");let s=class extends y.Disposable{constructor(f,S,L,_,H){super();this.environmentMainService=f,this.logService=S,this.backupMainService=L,this.dialogMainService=_,this.productService=H,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new v.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new v.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(f){if(!this.isWorkspacePath(f)||f.scheme!==k.Schemas.file)return;let S;try{S=I.readFileSync(f.fsPath,"utf8")}catch(L){return}return this.doResolveWorkspace(f,S)}isWorkspacePath(f){return m.isUntitledWorkspace(f,this.environmentMainService)||m.hasWorkspaceFileExtension(f)}doResolveWorkspace(f,S){try{const L=this.doParseStoredWorkspace(f,S),_=a(f);return{id:_.id,configPath:_.configPath,folders:m.toWorkspaceFolders(L.folders,_.configPath,d.extUriBiasedIgnorePathCase),remoteAuthority:L.remoteAuthority}}catch(L){this.logService.warn(L.toString())}}doParseStoredWorkspace(f,S){const L=E.parse(S);if(L&&Array.isArray(L.folders))L.folders=L.folders.filter(_=>m.isStoredWorkspaceFolder(_));else throw new Error(`${f.toString(!0)} looks like an invalid workspace file.`);return L}async createUntitledWorkspace(f,S){const{workspace:L,storedWorkspace:_}=this.newUntitledWorkspace(f,S),H=L.configPath.fsPath;return await b.Promises.mkdir(R.dirname(H),{recursive:!0}),await b.Promises.writeFile(H,JSON.stringify(_,null,"	")),L}createUntitledWorkspaceSync(f,S){const{workspace:L,storedWorkspace:_}=this.newUntitledWorkspace(f,S),H=L.configPath.fsPath;return I.mkdirSync(R.dirname(H),{recursive:!0}),b.writeFileSync(H,JSON.stringify(_,null,"	")),L}newUntitledWorkspace(f=[],S){const L=(Date.now()+Math.round(Math.random()*1e3)).toString(),_=d.joinPath(this.untitledWorkspacesHome,L),H=d.joinPath(_,m.UNTITLED_WORKSPACE_NAME),Q=[];for(const te of f)Q.push(m.getStoredWorkspaceFolder(te.uri,!0,te.name,_,!n.isWindows,d.extUriBiasedIgnorePathCase));return{workspace:a(H),storedWorkspace:{folders:Q,remoteAuthority:S}}}async getWorkspaceIdentifier(f){return a(f)}isUntitledWorkspace(f){return m.isUntitledWorkspace(f.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(f){!this.isUntitledWorkspace(f)||(this.doDeleteUntitledWorkspaceSync(f),this._onDidDeleteUntitledWorkspace.fire(f))}async deleteUntitledWorkspace(f){this.deleteUntitledWorkspaceSync(f)}doDeleteUntitledWorkspaceSync(f){const S=d.originalFSPath(f.configPath);try{b.rimrafSync(R.dirname(S));const L=R.join(this.environmentMainService.workspaceStorageHome.fsPath,f.id);I.existsSync(L)&&b.writeFileSync(R.join(L,"obsolete"),"")}catch(L){this.logService.warn(`Unable to delete untitled workspace ${S} (${L}).`)}}getUntitledWorkspacesSync(){const f=[];try{const S=b.readdirSync(this.untitledWorkspacesHome.fsPath).map(L=>d.joinPath(this.untitledWorkspacesHome,L,m.UNTITLED_WORKSPACE_NAME));for(const L of S){const _=a(L),H=this.resolveLocalWorkspaceSync(L);H?f.push({workspace:_,remoteAuthority:H.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(_)}}catch(S){S.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${S}).`)}return f}async enterWorkspace(f,S,L){if(!f||!f.win||!f.isReady||!await this.isValidTargetWorkspacePath(f,S,L))return;const H=this.doEnterWorkspace(f,a(L));if(!!H)return this._onDidEnterWorkspace.fire({window:f,workspace:H.workspace}),H}async isValidTargetWorkspacePath(f,S,L){if(!L)return!0;if(m.isWorkspaceIdentifier(f.openedWorkspace)&&d.extUriBiasedIgnorePathCase.isEqual(f.openedWorkspace.configPath,L))return!1;if(t.findWindowOnWorkspaceOrFolder(S,L)){const _={title:this.productService.nameLong,type:"info",buttons:[r.mnemonicButtonLabel(D.localize(0,null))],message:D.localize(1,null,d.basename(L)),detail:D.localize(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(_,u.withNullAsUndefined(c.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(f,S){if(!f.config)return;f.focus();let L;return f.config.extensionDevelopmentPath||(L=this.backupMainService.registerWorkspaceBackupSync({workspace:S,remoteAuthority:f.remoteAuthority},f.config.backupPath)),m.isWorkspaceIdentifier(f.openedWorkspace)&&this.isUntitledWorkspace(f.openedWorkspace)&&this.deleteUntitledWorkspaceSync(f.openedWorkspace),f.config.workspace=S,f.config.backupPath=L,{workspace:S,backupPath:L}}};s=he([ee(0,A.IEnvironmentMainService),ee(1,p.ILogService),ee(2,o.IBackupMainService),ee(3,l.IDialogMainService),ee(4,P.IProductService)],s),e.WorkspacesManagementMainService=s;function a(w){function f(){let S=w.scheme===k.Schemas.file?d.originalFSPath(w):w.toString();return n.isLinux||(S=S.toLowerCase()),i.createHash("md5").update(S).digest("hex")}return{id:f(),configPath:w}}e.getWorkspaceIdentifier=a;function h(w,f){function S(){if(w.scheme!==k.Schemas.file)return i.createHash("md5").update(w.toString()).digest("hex");if(!f)try{f=I.statSync(w.fsPath)}catch(H){return}let _;return n.isLinux?_=f.ino:n.isMacintosh?_=f.birthtime.getTime():n.isWindows&&(typeof f.birthtimeMs=="number"?_=Math.floor(f.birthtimeMs):_=f.birthtime.getTime()),i.createHash("md5").update(w.fsPath).update(_?String(_):"").digest("hex")}const L=S();if(typeof L=="string")return{id:L,uri:w}}e.getSingleFolderWorkspaceIdentifier=h}),define(J[102],Z([0,1,6,99,3,4,35,18,53,21,7,14,36,54,25,28,13]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=b.createDecorator(e.ID);let P=class{constructor(u,o,l,t,r){this.logService=u,this.windowsMainService=o,this.urlService=l,this.workspacesManagementMainService=t,this.configurationService=r}async start(u,o){this.logService.trace("Received data from other instance: ",u,o),R.isMacintosh&&E.app.focus({steal:!0});const l=this.parseOpenUrl(u);if(l.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:r,url:s}of l)this.urlService.open(r,{originalUrl:s})})}else return this.startOpenWindow(u,o)}parseOpenUrl(u){return u["open-url"]&&u._urls&&u._urls.length>0?k.coalesce(u._urls.map(o=>{try{return{uri:i.URI.parse(o),url:o}}catch(l){return null}})):[]}async startOpenWindow(u,o){const l=y.isLaunchedFromCli(o)?0:4;let t=[];const r=u.wait&&u.waitMarkerFilePath?i.URI.file(u.waitMarkerFilePath):void 0,s=u.remote||void 0;if(u.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(u.extensionDevelopmentPath,{context:l,cli:u,userEnv:o,waitMarkerFileURI:r,remoteAuthority:s});else if(!u._.length&&!u["folder-uri"]&&!u["file-uri"]){let a=!1;if(u["new-window"]||u["unity-launch"])a=!0;else if(u["reuse-window"])a=!1;else{const h=this.configurationService.getValue("window");switch((h==null?void 0:h.openWithoutArgumentsInNewWindow)||"default"){case"on":a=!0;break;case"off":a=!1;break;default:a=!R.isMacintosh}}if(a)t=this.windowsMainService.open({context:l,cli:u,userEnv:o,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:r,remoteAuthority:s});else{const h=this.windowsMainService.getLastActiveWindow();h?(h.focus(),t=[h]):t=this.windowsMainService.open({context:l,cli:u,forceEmpty:!0,remoteAuthority:s})}}else t=this.windowsMainService.open({context:l,cli:u,userEnv:o,forceNewWindow:u["new-window"],preferNewWindow:!u["reuse-window"]&&!u.wait,forceReuseWindow:u["reuse-window"],diffMode:u.diff,addMode:u.add,noRecentEntry:!!u["skip-add-to-recently-opened"],waitMarkerFileURI:r,gotoLineMode:u.goto,remoteAuthority:s});if(r&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,n.whenDeleted(r.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const u=[];return E.BrowserWindow.getAllWindows().forEach(o=>{const l=this.windowsMainService.getWindowById(o.id);l?u.push(this.codeWindowToInfo(l)):u.push(this.browserWindowToInfo(o))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(u){const o=this.windowsMainService.getWindows();return(await Promise.all(o.map(t=>new Promise(r=>{const s=t.remoteAuthority;if(s){const a=`vscode:getDiagnosticInfoResponse${t.id}`,h={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",d.CancellationToken.None,{replyChannel:a,args:h}),E.ipcMain.once(a,(w,f)=>{f||r({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),r(f)}),setTimeout(()=>{r({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else r(void 0)})))).filter(t=>!!t)}getFolderURIs(u){const o=[],l=u.openedWorkspace;if(g.isSingleFolderWorkspaceIdentifier(l))o.push(l.uri);else if(g.isWorkspaceIdentifier(l)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(l.configPath);t&&t.folders.forEach(s=>{o.push(s.uri)})}return o}codeWindowToInfo(u){const o=this.getFolderURIs(u),l=D.assertIsDefined(u.win);return this.browserWindowToInfo(l,o,u.remoteAuthority)}browserWindowToInfo(u,o=[],l){return{pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:o,remoteAuthority:l}}};P=he([ee(0,m.ILogService),ee(1,I.IWindowsMainService),ee(2,A.IURLService),ee(3,v.IWorkspacesManagementMainService),ee(4,p.IConfigurationService)],P),e.LaunchMainService=P}),define(J[231],Z([0,1,143,26,48,14,102,70,24,3,6,84,52,4,61,10,45,55,2,30,20]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d,g,D,P,c,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=y.createDecorator("issueMainService");let l=class Et{constructor(r,s,a,h,w,f,S,L,_){this.userEnv=r,this.environmentMainService=s,this.launchMainService=a,this.logService=h,this.diagnosticsService=w,this.dialogMainService=f,this.nativeHostMainService=S,this.protocolMainService=L,this.productService=_,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){b.ipcMain.on("vscode:issueSystemInfoRequest",async r=>{const[s,a]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),h=await this.diagnosticsService.getSystemInfo(s,a);this.safeSend(r,"vscode:issueSystemInfoResponse",h)}),b.ipcMain.on("vscode:listProcesses",async r=>{const s=[];try{const a=await this.launchMainService.getMainProcessId();s.push({name:m.localize(0,null),rootProcess:await E.listProcesses(a)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(w=>{n.isRemoteDiagnosticError(w)?s.push({name:w.hostName,rootProcess:w}):w.processes&&s.push({name:w.hostName,rootProcess:w.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(r,"vscode:listProcessesResponse",s)}),b.ipcMain.on("vscode:issueReporterClipboard",async r=>{const s={title:this.productService.nameLong,message:m.localize(1,null),type:"warning",buttons:[u.mnemonicButtonLabel(m.localize(2,null)),u.mnemonicButtonLabel(m.localize(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const a=await this.dialogMainService.showMessageBox(s,this.issueReporterWindow);this.safeSend(r,"vscode:issueReporterClipboardResponse",a.response===0)}}),b.ipcMain.on("vscode:issuePerformanceInfoRequest",async r=>{const s=await this.getPerformanceInfo();this.safeSend(r,"vscode:issuePerformanceInfoResponse",s)}),b.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const r={title:this.productService.nameLong,message:m.localize(4,null),type:"warning",buttons:[u.mnemonicButtonLabel(m.localize(5,null)),u.mnemonicButtonLabel(m.localize(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(r,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),b.ipcMain.on("vscode:workbenchCommand",(r,s)=>{const{id:a,from:h,args:w}=s;let f;switch(h){case"issueReporter":f=this.issueReporterParentWindow;break;case"processExplorer":f=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${h}`)}f&&f.webContents.send("vscode:runAction",{id:a,from:h,args:w})}),b.ipcMain.on("vscode:openExternal",(r,s)=>{this.nativeHostMainService.openExternal(void 0,s)}),b.ipcMain.on("vscode:closeIssueReporter",r=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),b.ipcMain.on("vscode:closeProcessExplorer",r=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),b.ipcMain.on("vscode:windowsInfoRequest",async r=>{const s=await this.launchMainService.getMainProcessInfo();this.safeSend(r,"vscode:windowsInfoResponse",s.windows)})}safeSend(r,s,...a){r.sender.isDestroyed()||r.sender.send(s,...a)}async openReporter(r){var s;if(!this.issueReporterWindow&&(this.issueReporterParentWindow=b.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const a=new c.DisposableStore,h=a.add(this.protocolMainService.createIPCObjectUrl()),w=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(w,h,{backgroundColor:r.styles.backgroundColor,title:m.localize(7,null),zoomLevel:r.zoomLevel,alwaysOnTop:!1}),h.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:r,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:A.type(),arch:A.arch(),release:A.release()},product:R.default}),this.issueReporterWindow.loadURL(g.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",$,!0).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,a.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,a.dispose())})}(s=this.issueReporterWindow)===null||s===void 0||s.focus()}async openProcessExplorer(r){var s;if(!this.processExplorerWindow&&(this.processExplorerParentWindow=b.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const a=new c.DisposableStore,h=a.add(this.protocolMainService.createIPCObjectUrl()),w=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(w,h,{backgroundColor:r.styles.backgroundColor,title:m.localize(8,null),zoomLevel:r.zoomLevel,alwaysOnTop:!0}),h.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:r,product:R.default}),this.processExplorerWindow.loadURL(g.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",$,!0).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,a.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,a.dispose())})}(s=this.processExplorerWindow)===null||s===void 0||s.focus()}createBrowserWindow(r,s,a){const h=new b.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,title:a.title,backgroundColor:a.backgroundColor||Et.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:g.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:[`--vscode-window-config=${s.resource.toString()}`,"--context-isolation"],v8CacheOptions:p.browserCodeLoadingCacheStrategy,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:d.zoomLevelToZoomFactor(a.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:a.alwaysOnTop});return h.setMenuBarVisibility(!1),h}async getSystemStatus(){const[r,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(r,s)}getWindowPosition(r,s,a){let h;const w=b.screen.getAllDisplays();if(w.length===1)h=w[0];else{if(p.isMacintosh){const L=b.screen.getCursorScreenPoint();h=b.screen.getDisplayNearestPoint(L)}!h&&r&&(h=b.screen.getDisplayMatching(r.getBounds())),h||(h=b.screen.getPrimaryDisplay()||w[0])}const f={width:s,height:a},S=h.bounds;return f.x=S.x+S.width/2-f.width/2,f.y=S.y+S.height/2-f.height/2,S.width>0&&S.height>0&&(f.x<S.x&&(f.x=S.x),f.y<S.y&&(f.y=S.y),f.x>S.x+S.width&&(f.x=S.x),f.y>S.y+S.height&&(f.y=S.y),f.width>S.width&&(f.width=S.width),f.height>S.height&&(f.height=S.height)),f}async getPerformanceInfo(){try{const[r,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(r,s)}catch(r){throw this.logService.warn("issueService#getPerformanceInfo ",r.message),r}}};l.DEFAULT_BACKGROUND_COLOR="#1E1E1E",l=he([ee(1,v.IEnvironmentMainService),ee(2,I.ILaunchMainService),ee(3,i.ILogService),ee(4,n.IDiagnosticsService),ee(5,k.IDialogMainService),ee(6,D.INativeHostMainService),ee(7,P.IProtocolMainService),ee(8,o.IProductService)],l),e.IssueMainService=l}),define(J[232],Z([0,1,8,149,72,5,7,14,24,6,21,20,61,2,3,35,28,53,51,199,60,32,52,30,203,22,100,19,10,54,25,55]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d,g,D,P,c,u,o,l,t,r,s,a,h,w,f,S,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var H;(function(te){te[te.NONE=0]="NONE",te[te.LOADING=1]="LOADING",te[te.NAVIGATING=2]="NAVIGATING",te[te.READY=3]="READY"})(H||(H={}));let Q=class extends y.Disposable{constructor(B,Y,G,C,z,X,N,F,T,O,M,W,U,V){super();this.logService=Y,this.environmentMainService=G,this.fileService=C,this.configurationService=X,this.themeMainService=N,this.workspacesManagementMainService=F,this.backupMainService=T,this.telemetryService=O,this.dialogMainService=M,this.lifecycleMainService=W,this.productService=U,this.protocolMainService=V,this._onWillLoad=this._register(new b.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new b.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new b.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new b.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this._lastFocusTime=-1,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.readyState=0;{const[K,q]=this.restoreWindowState(B.state);this.windowState=K,this.logService.trace("window#ctor: using window state",K);const x=this.windowState.mode===0||this.windowState.mode===3,ne=this.configurationService.getValue("window"),re={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:k.WindowMinimumSize.WIDTH,minHeight:k.WindowMinimumSize.HEIGHT,show:!x,title:this.productService.nameLong,webPreferences:Object.assign({preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:this.environmentMainService.sandbox?[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`,"--context-isolation"]:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:d.browserCodeLoadingCacheStrategy,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:k.zoomLevelToZoomFactor(ne==null?void 0:ne.zoomLevel)},this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1})};d.browserCodeLoadingCacheStrategy?this.logService.info(`window: using vscode-file:// protocol and V8 cache options: ${d.browserCodeLoadingCacheStrategy}`):this.logService.info("window: vscode-file:// protocol is explicitly disabled"),d.isLinux?re.icon=m.join(this.environmentMainService.appRoot,"resources/linux/code.png"):d.isWindows&&!this.environmentMainService.isBuilt&&(re.icon=m.join(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),d.isMacintosh&&!this.useNativeFullScreen()&&(re.fullscreenable=!1),d.isMacintosh&&(re.acceptFirstMouse=!0,(ne==null?void 0:ne.clickThroughInactive)===!1&&(re.acceptFirstMouse=!1));const se=d.isMacintosh&&(ne==null?void 0:ne.nativeTabs)===!0;se&&(re.tabbingIdentifier=this.productService.nameShort);const le=k.getTitleBarStyle(this.configurationService)==="custom";if(le&&(re.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,d.isMacintosh||(re.frame=!1)),R.mark("code/willCreateCodeBrowserWindow"),this._win=new n.BrowserWindow(re),R.mark("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),d.isMacintosh&&le&&this._win.setSheetOffset(22),d.isMacintosh&&q&&(!se||n.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(oe=>typeof oe=="number")){const oe=this.windowState;this._win.setBounds({width:oe.width,height:oe.height,x:oe.x,y:oe.y})}x&&(R.mark("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),R.mark("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=u.resolveMarketplaceHeaders(this.productService.version,this.environmentMainService,this.fileService,{get:K=>z.globalStorage.get(K),store:(K,q)=>z.globalStorage.set(K,q)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.backupPath}get openedWorkspace(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.workspace}get remoteAuthority(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var B;return!!((B=this.currentConfig)===null||B===void 0?void 0:B.extensionDevelopmentPath)}get isExtensionTestHost(){var B;return!!((B=this.currentConfig)===null||B===void 0?void 0:B.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var B;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!((B=this.currentConfig)===null||B===void 0?void 0:B.debugId)}setRepresentedFilename(B){d.isMacintosh?this._win.setRepresentedFilename(B):this.representedFilename=B}getRepresentedFilename(){return d.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(B){d.isMacintosh&&this._win.setDocumentEdited(B),this.documentEdited=B}isDocumentEdited(){return d.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(B){d.isMacintosh&&(B==null?void 0:B.force)&&n.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(B=>{if(this.isReady)return B(this);this.whenReadyCallbacks.push(B)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(B=>{function Y(){G.dispose(),C.dispose(),B()}const G=this.onDidClose(()=>Y()),C=this.onWillLoad(()=>Y())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(z,X)=>this.onWindowError(2,X)),this._win.webContents.on("did-fail-load",(z,X,N)=>this.onWindowError(3,{reason:N,exitCode:X})),this._win.webContents.on("will-prevent-unload",z=>{z.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const B=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),Y=z=>{for(let X=z;X;X=X.parent)if(X.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},G=z=>z.resourceType==="xhr"||Y(z.frame);this._win.webContents.session.webRequest.onBeforeRequest((z,X)=>{const N=I.URI.parse(z.url);return N.path.endsWith(".svg")&&!(B.has(N.scheme)||N.path.includes(f.Schemas.vscodeRemoteResource))?X({cancel:!G(z)}):X({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((z,X)=>{const N=z.responseHeaders,F=N["content-type"]||N["Content-Type"];if(F&&Array.isArray(F)){const T=I.URI.parse(z.url);if(T.path.endsWith(".svg")&&B.has(T.scheme))return N["Content-Type"]=["image/svg+xml"],X({cancel:!1,responseHeaders:N});if(!T.path.includes(f.Schemas.vscodeRemoteResource)&&F.some(O=>O.toLowerCase().includes("image/svg")))return X({cancel:!G(z)})}return X({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",z=>{this.currentConfig&&(this.currentConfig.maximized=!0),n.app.emit("browser-window-maximize",z,this._win)}),this._win.on("unmaximize",z=>{this.currentConfig&&(this.currentConfig.maximized=!1),n.app.emit("browser-window-unmaximize",z,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",L.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",L.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(z=>this.onDidDeleteUntitledWorkspace(z)));const C=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:C},async(z,X)=>{const N=await this.marketplaceHeadersPromise;X({cancel:!1,requestHeaders:Object.assign(z.requestHeaders,N)})})}async onWindowError(B,Y){var G;switch(B){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${(Y==null?void 0:Y.reason)||"<unknown>"}, code: ${(Y==null?void 0:Y.exitCode)||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load workbench window (reason: ${(Y==null?void 0:Y.reason)||"<unknown>"}, code: ${(Y==null?void 0:Y.exitCode)||"<unknown>"})`);break}if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.telemetryService.publicLog2("windowerror",{type:B,reason:Y==null?void 0:Y.reason,code:Y==null?void 0:Y.exitCode}),B===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const C=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[r.mnemonicButtonLabel(A.localize(0,null)),r.mnemonicButtonLabel(A.localize(1,null)),r.mnemonicButtonLabel(A.localize(2,null))],message:A.localize(3,null),detail:A.localize(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;C.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):C.response===2&&this.destroyWindow()}else if(B===2){let C;Y?C=A.localize(6,null,Y.reason,(G=Y.exitCode)!==null&&G!==void 0?G:"<unknown>"):C=A.localize(5,null);const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[r.mnemonicButtonLabel(A.localize(7,null)),r.mnemonicButtonLabel(A.localize(8,null))],message:C,detail:A.localize(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;z.response===0?this.reload():z.response===1&&this.destroyWindow()}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(B){var Y;((Y=this.openedWorkspace)===null||Y===void 0?void 0:Y.id)===B.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const B=this.getMenuBarVisibility();B!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=B,this.setMenuBarVisibility(B));let Y=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;(Y==null?void 0:Y.endsWith("/"))&&(Y=Y.substr(0,Y.length-1));const G=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((Y||"").indexOf("@")===-1&&(Y!==this.currentHttpProxy||G!==this.currentNoProxy)){this.currentHttpProxy=Y,this.currentNoProxy=G;const C=Y||"",z=G?`${G},<local>`:"<local>";this.logService.trace(`Setting proxy to '${C}', bypassing '${z}'`),this._win.webContents.session.setProxy({proxyRules:C,proxyBypassRules:z,pacScript:""})}}addTabbedWindow(B){d.isMacintosh&&B.win&&this._win.addTabbedWindow(B.win)}load(B,Y=Object.create(null)){this.isDocumentEdited()&&(!Y.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),Y.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(B,Y),this.readyState===0?this.currentConfig=B:(this.pendingLoadConfig=B,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",$).toString(!0)),!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onWillLoad.fire({workspace:B.workspace})}updateConfiguration(B,Y){var G,C;const z=(C=(G=this.currentConfig)!==null&&G!==void 0?G:this.pendingLoadConfig)===null||C===void 0?void 0:C.userEnv;z&&S.isLaunchedFromCli(z)&&!S.isLaunchedFromCli(B.userEnv)&&(B.userEnv=Object.assign(Object.assign({},z),B.userEnv)),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(B.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),Y.disableExtensions!==void 0&&(B["disable-extensions"]=Y.disableExtensions),B.fullscreen=this.isFullScreen,B.maximized=this._win.isMaximized(),B.partsSplash=this.themeMainService.getWindowSplash(),R.mark("code/willOpenNewWindow"),B.perfMarks=R.getMarks(),this.configObjectUrl.update(B)}async reload(B){const Y=Object.assign({},this.currentConfig);Y.workspace=await this.validateWorkspace(Y),delete Y.filesToOpenOrCreate,delete Y.filesToDiff,delete Y.filesToWait,this.isExtensionDevelopmentHost&&B&&(Y.verbose=B.verbose,Y.debugId=B.debugId,Y["inspect-extensions"]=B["inspect-extensions"],Y["inspect-brk-extensions"]=B["inspect-brk-extensions"],Y["extensions-dir"]=B["extensions-dir"]),Y.isInitialStartup=!1,this.load(Y,{isReload:!0,disableExtensions:B==null?void 0:B["disable-extensions"]})}async validateWorkspace(B){if(D.isWorkspaceIdentifier(B.workspace)){const Y=B.workspace.configPath;if(Y.scheme===f.Schemas.file&&!await this.fileService.exists(Y))return}else if(D.isSingleFolderWorkspaceIdentifier(B.workspace)){const Y=B.workspace.uri;if(Y.scheme===f.Schemas.file&&!await this.fileService.exists(Y))return}return B.workspace}serializeWindowState(){if(!this._win)return g.defaultWindowState();if(this.isFullScreen){let G;try{G=n.screen.getDisplayMatching(this.getBounds())}catch(X){}const C=g.defaultWindowState();return{mode:3,display:G?G.id:void 0,width:this.windowState.width||C.width,height:this.windowState.height||C.height,x:this.windowState.x||0,y:this.windowState.y||0}}const B=Object.create(null);let Y;if(!d.isMacintosh&&this._win.isMaximized()?Y=0:Y=1,Y===0?B.mode=0:B.mode=1,Y===1||Y===0){let G;Y===1?G=this.getBounds():G=this._win.getNormalBounds(),B.x=G.x,B.y=G.y,B.width=G.width,B.height=G.height}return B}restoreWindowState(B){R.mark("code/willRestoreCodeWindowState");let Y=!1;if(B)try{const G=n.screen.getAllDisplays();Y=G.length>1,B=this.validateWindowState(B,G)}catch(G){this.logService.warn(`Unexpected error validating window state: ${G}
${G.stack}`)}return R.mark("code/didRestoreCodeWindowState"),[B||g.defaultWindowState(),Y]}validateWindowState(B,Y){var G,C;if(this.logService.trace(`window#validateWindowState: validating window state on ${Y.length} display(s)`,B),typeof B.x!="number"||typeof B.y!="number"||typeof B.width!="number"||typeof B.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(B.width<=0||B.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(Y.length===1){const N=this.getWorkingArea(Y[0]);if(N){let F=function(){!B||typeof B.x!="number"||typeof B.y!="number"||!N||(B.x<N.x&&(B.x=N.x),B.y<N.y&&(B.y=N.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",N),F(),B.width>N.width&&(B.width=N.width),B.height>N.height&&(B.height=N.height),B.x>N.x+N.width-128&&(B.x=N.x+N.width-B.width),B.y>N.y+N.height-128&&(B.y=N.y+N.height-B.height),F()}return B}if(B.display&&B.mode===3){const N=Y.find(F=>F.id===B.display);if(N&&typeof((G=N.bounds)===null||G===void 0?void 0:G.x)=="number"&&typeof((C=N.bounds)===null||C===void 0?void 0:C.y)=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const F=g.defaultWindowState(3);return F.x=N.bounds.x,F.y=N.bounds.y,F}}let z,X;try{z=n.screen.getDisplayMatching({x:B.x,y:B.y,width:B.width,height:B.height}),X=this.getWorkingArea(z)}catch(N){}if(z&&X&&B.x+B.width>X.x&&B.y+B.height>X.y&&B.x<X.x+X.width&&B.y<X.y+X.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",X),B}getWorkingArea(B){if(B.workArea.width>0&&B.workArea.height>0)return B.workArea;if(B.bounds.width>0&&B.bounds.height>0)return B.bounds}getBounds(){const[B,Y]=this._win.getPosition(),[G,C]=this._win.getSize();return{x:B,y:Y,width:G,height:C}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(B){this.useNativeFullScreen()?this.setNativeFullScreen(B):this.setSimpleFullScreen(B),this.sendWhenReady(B?"vscode:enterFullScreen":"vscode:leaveFullScreen",L.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(B){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(B)}setSimpleFullScreen(B){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(B),this._win.webContents.focus()}useNativeFullScreen(){const B=this.configurationService.getValue("window");return!B||typeof B.nativeFullScreen!="boolean"||B.nativeTabs?!0:B.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let B=k.getMenuBarVisibility(this.configurationService);return["visible","toggle","hidden"].indexOf(B)<0&&(B="classic"),B}setMenuBarVisibility(B,Y=!0){d.isMacintosh||(B==="toggle"&&Y&&this.send("vscode:showInfoMessage",A.localize(10,null)),B==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(B)}):this.doSetMenuBarVisibility(B))}doSetMenuBarVisibility(B){const Y=this.isFullScreen;switch(B){case"classic":this._win.setMenuBarVisibility(!Y),this._win.autoHideMenuBar=Y;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(d.isMacintosh)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(B,Y,...G){this.isReady?this.send(B,...G):this.ready().then(()=>{Y.isCancellationRequested||this.send(B,...G)})}send(B,...Y){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${B} for window that is destroyed`);return}this._win.webContents.send(B,...Y)}}updateTouchBar(B){!d.isMacintosh||this.touchBarGroups.forEach((Y,G)=>{const C=B[G];Y.segments=this.createTouchBarGroupSegments(C)})}createTouchBar(){if(!!d.isMacintosh){for(let B=0;B<10;B++){const Y=this.createTouchBarGroup();this.touchBarGroups.push(Y)}this._win.setTouchBar(new n.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(B=[]){const Y=this.createTouchBarGroupSegments(B),G=new n.TouchBar.TouchBarSegmentedControl({segments:Y,mode:"buttons",segmentStyle:"automatic",change:C=>{this.sendWhenReady("vscode:runAction",L.CancellationToken.None,{id:G.segments[C].id,from:"touchbar"})}});return G}createTouchBarGroupSegments(B=[]){return B.map(G=>{var C,z;let X;G.icon&&!s.ThemeIcon.isThemeIcon(G.icon)&&((z=(C=G.icon)===null||C===void 0?void 0:C.dark)===null||z===void 0?void 0:z.scheme)===f.Schemas.file&&(X=n.nativeImage.createFromPath(I.URI.revive(G.icon.dark).fsPath),X.isEmpty()&&(X=void 0));let N;return typeof G.title=="string"?N=G.title:N=G.title.value,{id:G.id,label:X?void 0:N,icon:X}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};Q=he([ee(1,p.ILogService),ee(2,v.IEnvironmentMainService),ee(3,w.IFileService),ee(4,h.IStorageMainService),ee(5,i.IConfigurationService),ee(6,o.IThemeMainService),ee(7,P.IWorkspacesManagementMainService),ee(8,c.IBackupMainService),ee(9,l.ITelemetryService),ee(10,t.IDialogMainService),ee(11,a.ILifecycleMainService),ee(12,E.IProductService),ee(13,_.IProtocolMainService)],Q),e.CodeWindow=Q}),define(J[62],Z([0,1,152,36,39,14,6,30,5,3,28,53,9,15,7,10,18,22,4,2]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d,g,D,P,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=c.createDecorator("workspacesHistoryMainService");let o=class Ke extends u.Disposable{constructor(w,f,S,L){super();this.stateMainService=w,this.logService=f,this.workspacesManagementMainService=S,this.lifecycleMainService=L,this._onDidChangeRecentlyOpened=this._register(new v.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(w=>this.addRecentlyOpened([{workspace:w.workspace}])))}handleWindowsJumpList(){!p.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(w){const f=[],S=[];for(let L of w)if(i.isRecentWorkspace(L))!this.workspacesManagementMainService.isUntitledWorkspace(L.workspace)&&r(f,L.workspace)===-1&&f.push(L);else if(i.isRecentFolder(L))s(f,L.folderUri)===-1&&f.push(L);else{const _=a(S,L.fileUri)>=0,H=L.fileUri.scheme===g.Schemas.file&&Ke.COMMON_FILES_FILTER.indexOf(y.basename(L.fileUri))>=0;!_&&!H&&(S.push(L),p.isWindows&&L.fileUri.scheme===g.Schemas.file&&b.app.addRecentDocument(L.fileUri.fsPath))}this.addEntriesFromStorage(f,S),f.length>Ke.MAX_TOTAL_RECENT_ENTRIES&&(f.length=Ke.MAX_TOTAL_RECENT_ENTRIES),S.length>Ke.MAX_TOTAL_RECENT_ENTRIES&&(S.length=Ke.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:f,files:S}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(w){const f=H=>{const Q=t(H);for(const te of w)if(y.extUriBiasedIgnorePathCase.isEqual(te,Q))return!1;return!0},S=this.getRecentlyOpened(),L=S.workspaces.filter(f),_=S.files.filter(f);(L.length!==S.workspaces.length||_.length!==S.files.length)&&(this.saveRecentlyOpened({files:_,workspaces:L}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!p.isMacintosh)return;b.app.clearRecentDocuments();const w=this.getRecentlyOpened(),f=[];let S=0;for(let _=0;_<w.workspaces.length&&S<Ke.MAX_MACOS_DOCK_RECENT_WORKSPACES;_++){const H=t(w.workspaces[_]);if(H.scheme===g.Schemas.file){const Q=y.originalFSPath(H);await D.Promises.exists(Q)&&(f.push(Q),S++)}}const L=[];for(let _=0;_<w.files.length&&S<Ke.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;_++){const H=t(w.files[_]);if(H.scheme===g.Schemas.file){const Q=y.originalFSPath(H);if(Ke.COMMON_FILES_FILTER.includes(y.basename(H))||f.includes(Q))continue;await D.Promises.exists(Q)&&(L.push(Q),S++)}}L.reverse().forEach(_=>b.app.addRecentDocument(_)),f.reverse().forEach(_=>b.app.addRecentDocument(_))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),b.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(w){var f,S;const L=[],_=[],H=(f=w==null?void 0:w.config)===null||f===void 0?void 0:f.workspace;i.isWorkspaceIdentifier(H)&&!this.workspacesManagementMainService.isUntitledWorkspace(H)?L.push({workspace:H}):i.isSingleFolderWorkspaceIdentifier(H)&&L.push({folderUri:H.uri});const Q=(S=w==null?void 0:w.config)===null||S===void 0?void 0:S.filesToOpenOrCreate;if(Q)for(let te of Q){const B=te.fileUri;B&&a(_,B)===-1&&_.push({fileUri:B})}return this.addEntriesFromStorage(L,_),{workspaces:L,files:_}}addEntriesFromStorage(w,f){let S=this.getRecentlyOpenedFromStorage();for(let L of S.workspaces){let _=i.isRecentFolder(L)?s(w,L.folderUri):r(w,L.workspace);_>=0?w[_].label=w[_].label||L.label:w.push(L)}for(let L of S.files){let _=a(f,L.fileUri);_>=0?f[_].label=f[_].label||L.label:f.push(L)}}getRecentlyOpenedFromStorage(){const w=this.stateMainService.getItem(Ke.recentlyOpenedStorageKey);return i.restoreRecentlyOpened(w,this.logService)}saveRecentlyOpened(w){const f=i.toStoreData(w);this.stateMainService.setItem(Ke.recentlyOpenedStorageKey,f)}updateWindowsJumpList(){if(!p.isWindows)return;const w=[];if(w.push({type:"tasks",items:[{type:"task",title:m.localize(0,null),description:m.localize(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let f=[];for(let _ of b.app.getJumpListSettings().removedItems){const H=_.args;if(H){const Q=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(H);Q&&f.push(d.URI.parse(Q[2]))}}this.removeRecentlyOpened(f);let S=!1;const L=A.coalesce(this.getRecentlyOpened().workspaces.slice(0,7).map(_=>{const H=i.isRecentWorkspace(_)?_.workspace:_.folderUri,{title:Q,description:te}=this.getWindowsJumpListLabel(H,_.label);let B;return d.URI.isUri(H)?B=`--folder-uri "${H.toString()}"`:(S=!0,B=`--file-uri "${H.configPath.toString()}"`),{type:"task",title:Q.substr(0,255),description:te.substr(0,255),program:process.execPath,args:B,iconPath:"explorer.exe",iconIndex:0}}));L.length>0&&w.push({type:"custom",name:S?m.localize(2,null):m.localize(3,null),items:L})}w.push({type:"recent"});try{b.app.setJumpList(w)}catch(f){this.logService.warn("updateWindowsJumpList#setJumpList",f)}}getWindowsJumpListLabel(w,f){if(f)return{title:n.splitName(f).name,description:f};if(d.URI.isUri(w))return{title:y.basename(w),description:l(w)};if(this.workspacesManagementMainService.isUntitledWorkspace(w))return{title:m.localize(4,null),description:""};let S=y.basename(w.configPath);return S.endsWith(i.WORKSPACE_EXTENSION)&&(S=S.substr(0,S.length-i.WORKSPACE_EXTENSION.length-1)),{title:m.localize(5,null,S),description:l(w.configPath)}}};o.MAX_TOTAL_RECENT_ENTRIES=100,o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o.recentlyOpenedStorageKey="openedPathsList",o=he([ee(0,R.IStateMainService),ee(1,I.ILogService),ee(2,E.IWorkspacesManagementMainService),ee(3,P.ILifecycleMainService)],o),e.WorkspacesHistoryMainService=o;function l(h){return h.scheme==="file"?n.normalizeDriveLetter(h.fsPath):h.toString()}function t(h){return i.isRecentFolder(h)?h.folderUri:i.isRecentFile(h)?h.fileUri:h.workspace.configPath}function r(h,w){return h.findIndex(f=>i.isRecentWorkspace(f)&&f.workspace.id===w.id)}function s(h,w){return h.findIndex(f=>i.isRecentFolder(f)&&y.extUriBiasedIgnorePathCase.isEqual(f.folderUri,w))}function a(h,w){return h.findIndex(f=>y.extUriBiasedIgnorePathCase.isEqual(f.fileUri,w))}}),define(J[233],Z([0,1,144,3,24,14,61,21,32,42,20,9,6,30,35,62,182,7,39,22,45,25]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d,g,D,P,c,u,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let r=class vt{constructor(h,w,f,S,L,_,H,Q,te,B,Y){this.updateService=h,this.configurationService=w,this.windowsMainService=f,this.environmentMainService=S,this.telemetryService=L,this.workspacesHistoryMainService=_,this.stateMainService=H,this.lifecycleMainService=Q,this.logService=te,this.nativeHostMainService=B,this.productService=Y,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new E.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new E.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(A.isMacintosh||I.getTitleBarStyle(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const h=this.stateMainService.getItem(vt.lastKnownMenubarStorageKey);h&&(h.menus&&(this.menubarMenus=h.menus),h.keybindings&&(this.keybindings=h.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(_,H,Q)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:H==null?void 0:H.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(_,H,Q)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:H==null?void 0:H.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(_,H,Q)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(Q),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(_,H,Q)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(Q),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const h=this.productService.twitterUrl;h&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(h,"openTwitterUrl"));const w=this.productService.requestFeatureUrl;w&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(w,"openUserVoiceUrl"));const f=this.productService.reportIssueUrl;f&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(f,"openReportIssues"));const S=this.productService.licenseUrl;S&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(A.language){const _=S.indexOf("?")>0?"&":"?";this.openUrl(`${S}${_}lang=${A.language}`,"openLicenseUrl")}else this.openUrl(S,"openLicenseUrl")});const L=this.productService.privacyStatementUrl;L&&S&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(A.language){const _=S.indexOf("?")>0?"&":"?";this.openUrl(`${L}${_}lang=${A.language}`,"openPrivacyStatement")}else this.openUrl(L,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(h=>this.onDidChangeWindowsCount(h)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let h=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof h!="boolean"&&(h=!0),h}get currentEnableNativeTabs(){if(!A.isMacintosh)return!1;let h=this.configurationService.getValue("window.nativeTabs");return typeof h!="boolean"&&(h=!1),h}updateMenu(h,w){this.menubarMenus=h.menus,this.keybindings=h.keybindings,this.stateMainService.setItem(vt.lastKnownMenubarStorageKey,h),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(h){!A.isMacintosh||(h.oldCount===0&&h.newCount>0||h.oldCount>0&&h.newCount===0)&&(this.closedLastWindow=h.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!A.isMacintosh||(this.noActiveWindow=!b.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const h=b.Menu.getApplicationMenu();if(h&&this.oldMenus.push(h),Object.keys(this.menubarMenus).length===0){b.Menu.setApplicationMenu(A.isMacintosh?new b.Menu:null);return}const w=new b.Menu;let f;if(A.isMacintosh){const L=new b.Menu;f=new b.MenuItem({label:this.productService.nameShort,submenu:L}),this.setMacApplicationMenu(L),w.append(f)}if(A.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const L=new b.Menu;L.append(new b.MenuItem({label:this.mnemonicLabel(m.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),b.app.dock.setMenu(L)}if(this.shouldDrawMenu("File")){const L=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(m.localize(1,null)),submenu:L});this.setMenuById(L,"File"),w.append(_)}if(this.shouldDrawMenu("Edit")){const L=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(m.localize(2,null)),submenu:L});this.setMenuById(L,"Edit"),w.append(_)}if(this.shouldDrawMenu("Selection")){const L=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(m.localize(3,null)),submenu:L});this.setMenuById(L,"Selection"),w.append(_)}if(this.shouldDrawMenu("View")){const L=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(m.localize(4,null)),submenu:L});this.setMenuById(L,"View"),w.append(_)}if(this.shouldDrawMenu("Go")){const L=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(m.localize(5,null)),submenu:L});this.setMenuById(L,"Go"),w.append(_)}if(this.shouldDrawMenu("Run")){const L=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(m.localize(6,null)),submenu:L});this.setMenuById(L,"Run"),w.append(_)}if(this.shouldDrawMenu("Terminal")){const L=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(m.localize(7,null)),submenu:L});this.setMenuById(L,"Terminal"),w.append(_)}let S;if(this.shouldDrawMenu("Window")){const L=new b.Menu;S=new b.MenuItem({label:this.mnemonicLabel(m.localize(8,null)),submenu:L,role:"window"}),this.setMacWindowMenu(L)}if(S&&w.append(S),this.shouldDrawMenu("Help")){const L=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(m.localize(9,null)),submenu:L,role:"help"});this.setMenuById(L,"Help"),w.append(_)}w.items&&w.items.length>0?b.Menu.setApplicationMenu(w):b.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(h){const w=this.createMenuItem(m.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),f=this.getUpdateMenuItems();let S;if(this.shouldDrawMenu("Preferences")){const G=new b.Menu;this.setMenuById(G,"Preferences"),S=new b.MenuItem({label:this.mnemonicLabel(m.localize(11,null)),submenu:G})}const L=new b.Menu,_=new b.MenuItem({label:m.localize(12,null),role:"services",submenu:L}),H=new b.MenuItem({label:m.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),Q=new b.MenuItem({label:m.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),te=new b.MenuItem({label:m.localize(15,null),role:"unhide"}),B=new b.MenuItem(this.likeAction("workbench.action.quit",{label:m.localize(16,null,this.productService.nameLong),click:()=>{const G=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!b.BrowserWindow.getFocusedWindow()||(G==null?void 0:G.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),Y=[w];Y.push(...f),S&&Y.push(s(),S),Y.push(s(),_,s(),H,Q,te,s(),B),Y.forEach(G=>h.append(G))}shouldDrawMenu(h){if(!A.isMacintosh&&I.getTitleBarStyle(this.configurationService)==="custom")return!1;switch(h){case"File":case"Help":if(A.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[h];case"Window":if(A.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[h]}}setMenu(h,w){w.forEach(f=>{if(D.isMenubarMenuItemSeparator(f))h.append(s());else if(D.isMenubarMenuItemSubmenu(f)){const S=new b.Menu,L=new b.MenuItem({label:this.mnemonicLabel(f.label),submenu:S});this.setMenu(S,f.submenu.items),h.append(L)}else D.isMenubarMenuItemRecentAction(f)?h.append(this.createOpenRecentMenuItem(f)):D.isMenubarMenuItemAction(f)&&(f.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(h),A.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[f.id]?h.append(new b.MenuItem(this.likeAction(f.id,{label:this.mnemonicLabel(f.label),click:this.fallbackMenuHandlers[f.id]}))):h.append(this.createMenuItem(f.label,f.id,!1,f.checked)):h.append(this.createMenuItem(f.label,f.id,f.enabled!==!1,!!f.checked)):h.append(this.createMenuItem(f.label,f.id,f.enabled!==!1,!!f.checked)))})}setMenuById(h,w){this.menubarMenus&&this.menubarMenus[w]&&this.setMenu(h,this.menubarMenus[w].items)}insertCheckForUpdatesItems(h){const w=this.getUpdateMenuItems();w.length&&(w.forEach(f=>h.append(f)),h.append(s()))}createOpenRecentMenuItem(h){const w=P.URI.revive(h.uri),f=h.id,S=f==="openRecentFile"?{fileUri:w}:f==="openRecentWorkspace"?{workspaceUri:w}:{folderUri:w};return new b.MenuItem(this.likeAction(f,{label:h.label,click:(L,_,H)=>{const Q=this.isOptionClick(H);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[S],forceNewWindow:Q,gotoLineMode:!1,remoteAuthority:h.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([w])}},!1))}isOptionClick(h){return!!(h&&(!A.isMacintosh&&(h.ctrlKey||h.shiftKey)||A.isMacintosh&&(h.metaKey||h.altKey)))}createRoleMenuItem(h,w,f){const S={label:this.mnemonicLabel(h),role:f,enabled:!0};return new b.MenuItem(this.withKeybinding(w,S))}setMacWindowMenu(h){const w=new b.MenuItem({label:m.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),f=new b.MenuItem({label:m.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),S=new b.MenuItem({label:m.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),L=this.createMenuItem(m.localize(20,null),"workbench.action.switchWindow"),_=[];this.currentEnableNativeTabs&&(_.push(s()),_.push(this.createMenuItem(m.localize(21,null),"workbench.action.newWindowTab")),_.push(this.createRoleMenuItem(m.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),_.push(this.createRoleMenuItem(m.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),_.push(this.createRoleMenuItem(m.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),_.push(this.createRoleMenuItem(m.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[w,f,s(),L,..._,s(),S].forEach(H=>h.append(H))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new b.MenuItem({label:this.mnemonicLabel(m.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new b.MenuItem({label:m.localize(27,null),enabled:!1})];case"available for download":return[new b.MenuItem({label:this.mnemonicLabel(m.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new b.MenuItem({label:m.localize(29,null),enabled:!1})];case"downloaded":return[new b.MenuItem({label:this.mnemonicLabel(m.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new b.MenuItem({label:m.localize(31,null),enabled:!1})];case"ready":return[new b.MenuItem({label:this.mnemonicLabel(m.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(h,w,f,S){const L=this.mnemonicLabel(h),_=typeof w=="function"?w:(Y,G,C)=>{const z=Y?Y.userSettingsLabel:null;let X=w;Array.isArray(w)&&(X=this.isOptionClick(C)?w[1]:w[0]),z&&C.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:z}):this.runActionInRenderer({type:"commandId",commandId:X})},H=typeof f=="boolean"?f:this.windowsMainService.getWindowCount()>0,Q=typeof S=="boolean"?S:!1,te={label:L,click:_,enabled:H};Q&&(te.type="checkbox",te.checked=Q);let B;return typeof w=="string"?B=w:Array.isArray(w)&&(B=w[0]),A.isMacintosh&&(B==="editor.action.clipboardCutAction"?te.role="cut":B==="editor.action.clipboardCopyAction"?te.role="copy":B==="editor.action.clipboardPasteAction"&&(te.role="paste"),B==="undo"?te.click=this.makeContextAwareClickHandler(_,{inDevTools:Y=>Y.undo(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("undo:")}):B==="redo"?te.click=this.makeContextAwareClickHandler(_,{inDevTools:Y=>Y.redo(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("redo:")}):B==="editor.action.selectAll"&&(te.click=this.makeContextAwareClickHandler(_,{inDevTools:Y=>Y.selectAll(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("selectAll:")}))),new b.MenuItem(this.withKeybinding(B,te))}makeContextAwareClickHandler(h,w){return(f,S,L)=>{const _=b.BrowserWindow.getFocusedWindow();if(!_)return w.inNoWindow();if(_.webContents.isDevToolsFocused()&&_.webContents.devToolsWebContents)return w.inDevTools(_.webContents.devToolsWebContents);h(f,S||_,L)}}runActionInRenderer(h){let w=b.BrowserWindow.getFocusedWindow();if(!w){const S=this.windowsMainService.getLastActiveWindow();(S==null?void 0:S.isMinimized())&&(w=S.win)}const f=w?this.windowsMainService.getWindowById(w.id):void 0;if(f){if(this.logService.trace("menubar#runActionInRenderer",h),A.isMacintosh&&!this.environmentMainService.isBuilt&&!f.isReady&&(h.type==="commandId"&&h.commandId==="workbench.action.toggleDevTools"||h.type!=="commandId"&&h.userSettingsLabel==="alt+cmd+i"))return;if(h.type==="commandId"){const S={id:h.commandId,from:"menu"};f.sendWhenReady("vscode:runAction",l.CancellationToken.None,S)}else{const S={userSettingsLabel:h.userSettingsLabel};f.sendWhenReady("vscode:runKeybinding",l.CancellationToken.None,S)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",h)}withKeybinding(h,w){const f=typeof h=="string"?this.keybindings[h]:void 0;if(f==null?void 0:f.label){if(f.isNative!==!1)w.accelerator=f.label,w.userSettingsLabel=f.userSettingsLabel;else if(typeof w.label=="string"){const S=w.label.indexOf("[");S>=0?w.label=`${w.label.substr(0,S)} [${f.label}]`:w.label=`${w.label} [${f.label}]`}}else w.accelerator=void 0;return w}likeAction(h,w,f=!w.accelerator){f&&(w=this.withKeybinding(h,w));const S=w.click;return w.click=(L,_,H)=>{this.reportMenuActionTelemetry(h),S&&S(L,_,H)},w}openUrl(h,w){this.nativeHostMainService.openExternal(void 0,h),this.reportMenuActionTelemetry(w)}reportMenuActionTelemetry(h){this.telemetryService.publicLog2("workbenchActionExecuted",{id:h,from:t})}mnemonicLabel(h){return y.mnemonicMenuLabel(h,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=he([ee(0,p.IUpdateService),ee(1,n.IConfigurationService),ee(2,d.IWindowsMainService),ee(3,R.IEnvironmentMainService),ee(4,v.ITelemetryService),ee(5,g.IWorkspacesHistoryMainService),ee(6,c.IStateMainService),ee(7,u.ILifecycleMainService),ee(8,k.ILogService),ee(9,o.INativeHostMainService),ee(10,i.IProductService)],r),e.Menubar=r;function s(){return new b.MenuItem({type:"separator"})}}),define(J[234],Z([0,1,233,6,4,22]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=R.createDecorator("menubarMainService");let I=class{constructor(v,p,i){this.instantiationService=v,this.lifecycleMainService=p,this.logService=i,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(m.Menubar)}async updateMenubar(v,p){this.logService.trace("menubarService#updateMenubar",v),(await this.menubar).updateMenu(p,v)}};I=he([ee(0,R.IInstantiationService),ee(1,b.ILifecycleMainService),ee(2,A.ILogService)],I),e.MenubarMainService=I}),define(J[235],Z([0,1,31,26,48,72,8,150,36,51,24,39,232,14,22,21,6,61,101,5,20,62,3,28,4,10,7,15,73,215,53,43,2,52,13,29,30,25,19,33,55]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d,g,D,P,c,u,o,l,t,r,s,a,h,w,f,S,L,_,H,Q,te,B,Y,G,C,z,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function N(O){return r.isWorkspaceIdentifier(O==null?void 0:O.workspace)}function F(O){return r.isSingleFolderWorkspaceIdentifier(O==null?void 0:O.workspace)}let T=class xe extends H.Disposable{constructor(M,W,U,V,K,q,x,ne,re,se,le,oe,ue,me,be){super();this.machineId=M,this.initialUserEnv=W,this.logService=U,this.stateMainService=V,this.environmentMainService=K,this.lifecycleMainService=q,this.backupMainService=x,this.configurationService=ne,this.workspacesHistoryMainService=re,this.workspacesManagementMainService=se,this.instantiationService=le,this.dialogMainService=oe,this.fileService=ue,this.productService=me,this.protocolMainService=be,this._onDidOpenWindow=this._register(new u.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new u.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new u.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new u.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new S.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(M=>this._onDidSignalReadyWindow.fire(M.window))),this._register(this.onDidSignalReadyWindow(M=>{var W,U;if(((W=M.config)===null||W===void 0?void 0:W.extensionDevelopmentPath)||((U=M.config)===null||U===void 0?void 0:U.extensionTestsPath)){const V=new H.DisposableStore;if(V.add(u.Event.any(M.onDidClose,M.onDidDestroy)(()=>V.dispose())),M.config.extensionDevelopmentPath)for(const K of M.config.extensionDevelopmentPath)V.add(this.protocolMainService.addValidFileRoot(h.URI.file(K)));M.config.extensionTestsPath&&V.add(this.protocolMainService.addValidFileRoot(h.URI.file(M.config.extensionTestsPath)))}}))}openEmptyWindow(M,W){let U=this.environmentMainService.args;const V=(W==null?void 0:W.remoteAuthority)||void 0,K=!0,q=W==null?void 0:W.forceReuseWindow,x=!q;return this.open(Object.assign(Object.assign({},M),{cli:U,forceEmpty:K,forceNewWindow:x,forceReuseWindow:q,remoteAuthority:V}))}open(M){this.logService.trace("windowsManager#open"),M.addMode&&(M.initialStartup||!this.getLastActiveWindow())&&(M.addMode=!1);const W=[],U=[],V=[],K=[],q=[];let x,ne=0;const re=this.getPathsToOpen(M);this.logService.trace("windowsManager#open pathsToOpen",re);for(const me of re)F(me)?M.addMode?W.push(me):U.push(me):N(me)?V.push(me):me.fileUri?(x||(x={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:me.remoteAuthority}),x.filesToOpenOrCreate.push(me)):me.backupPath?q.push({backupFolder:I.basename(me.backupPath),remoteAuthority:me.remoteAuthority}):ne++;M.diffMode&&(x==null?void 0:x.filesToOpenOrCreate.length)===2&&(x.filesToDiff=x.filesToOpenOrCreate,x.filesToOpenOrCreate=[]),x&&M.waitMarkerFileURI&&(x.filesToWait={paths:[...x.filesToDiff,...x.filesToOpenOrCreate],waitMarkerFileUri:M.waitMarkerFileURI}),M.initialStartup?(K.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),V.push(...K),q.push(...this.backupMainService.getEmptyWindowBackupPaths())):q.length=0;const{windows:se,filesOpenedInWindow:le}=this.doOpen(M,V,U,q,ne,x,W);if(this.logService.trace(`windowsManager#open used window count ${se.length} (workspacesToOpen: ${V.length}, foldersToOpen: ${U.length}, emptyToRestore: ${q.length}, emptyToOpen: ${ne})`),se.length>1)if(le)le.focus();else{const me=this.windowsStateHandler.state.lastActiveWindow&&!M.forceEmpty&&!M.cli._.length&&!M.cli["file-uri"]&&!M.cli["folder-uri"]&&!(M.urisToOpen&&M.urisToOpen.length);let be=!0,De=!0;if(me){const Ie=se.filter(we=>this.windowsStateHandler.state.lastActiveWindow&&we.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ie.length&&(Ie[0].focus(),be=!1,De=!1)}if(be)for(let Ie=se.length-1;Ie>=0;Ie--){const we=se[Ie];if(!(we.openedWorkspace&&K.some(ye=>we.openedWorkspace&&ye.workspace.id===we.openedWorkspace.id)||we.backupPath&&q.some(ye=>we.backupPath&&ye.backupFolder===I.basename(we.backupPath)))){we.focus(),De=!1;break}}De&&se[se.length-1].focus()}const oe=x&&x.filesToDiff.length>0;if(!se.some(me=>me.isExtensionDevelopmentHost)&&!oe&&!M.noRecentEntry){const me=[];for(const be of re)N(be)?me.push({label:be.label,workspace:be.workspace,remoteAuthority:be.remoteAuthority}):F(be)?me.push({label:be.label,folderUri:be.workspace.uri,remoteAuthority:be.remoteAuthority}):be.fileUri&&me.push({label:be.label,fileUri:be.fileUri,remoteAuthority:be.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(me)}const ue=M.waitMarkerFileURI;return M.context===0&&ue&&se.length===1&&se[0]&&(async()=>{await se[0].whenClosedOrLoaded;try{await this.fileService.del(ue)}catch(me){}})(),se}doOpen(M,W,U,V,K,q,x){const ne=[];let re;function se(Ie,we){ne.push(Ie),we&&(re=Ie,q=void 0)}let{openFolderInNewWindow:le,openFilesInNewWindow:oe}=this.shouldOpenNewWindow(M);if(!M.initialStartup&&x.length>0){const Ie=x[0].remoteAuthority,we=this.getLastActiveWindowForAuthority(Ie);we&&se(this.doAddFoldersToExistingWindow(we,x.map(ye=>ye.workspace.uri)))}const ue=U.length+W.length+V.length;if(q&&ue===0){const Ie=q.filesToOpenOrCreate[0]||q.filesToDiff[0],we=this.getWindows().filter(Le=>q&&Le.remoteAuthority===q.remoteAuthority);let ye;(Ie==null?void 0:Ie.fileUri)&&!oe&&((M.context===4||M.context===0||M.context===1)&&(ye=c.findWindowOnFile(we,Ie.fileUri,Le=>Le.configPath.scheme===a.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Le.configPath):void 0)),ye||(ye=this.doGetLastActiveWindow(we))),ye?r.isWorkspaceIdentifier(ye.openedWorkspace)?W.push({workspace:ye.openedWorkspace,remoteAuthority:ye.remoteAuthority}):r.isSingleFolderWorkspaceIdentifier(ye.openedWorkspace)?U.push({workspace:ye.openedWorkspace,remoteAuthority:ye.remoteAuthority}):se(this.doOpenFilesInExistingWindow(M,ye,q),!0):se(this.openInBrowserWindow({userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,filesToOpen:q,forceNewWindow:!0,remoteAuthority:q.remoteAuthority,forceNewTabbedWindow:M.forceNewTabbedWindow}),!0)}const me=v.distinct(W,Ie=>Ie.workspace.id);if(me.length>0){const Ie=v.coalesce(me.map(we=>c.findWindowOnWorkspaceOrFolder(this.getWindows(),we.workspace.configPath)));if(Ie.length>0){const we=Ie[0],ye=(q==null?void 0:q.remoteAuthority)===we.remoteAuthority?q:void 0;se(this.doOpenFilesInExistingWindow(M,we,ye),!!ye),le=!0}me.forEach(we=>{if(Ie.some(Te=>Te.openedWorkspace&&Te.openedWorkspace.id===we.workspace.id))return;const ye=we.remoteAuthority,Le=(q==null?void 0:q.remoteAuthority)===ye?q:void 0;se(this.doOpenFolderOrWorkspace(M,we,le,Le),!!Le),le=!0})}const be=v.distinct(U,Ie=>w.extUriBiasedIgnorePathCase.getComparisonKey(Ie.workspace.uri));if(be.length>0){const Ie=v.coalesce(be.map(we=>c.findWindowOnWorkspaceOrFolder(this.getWindows(),we.workspace.uri)));if(Ie.length>0){const we=Ie[0],ye=(q==null?void 0:q.remoteAuthority)===we.remoteAuthority?q:void 0;se(this.doOpenFilesInExistingWindow(M,we,ye),!!ye),le=!0}be.forEach(we=>{if(Ie.some(Te=>r.isSingleFolderWorkspaceIdentifier(Te.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(Te.openedWorkspace.uri,we.workspace.uri)))return;const ye=we.remoteAuthority,Le=(q==null?void 0:q.remoteAuthority)===ye?q:void 0;se(this.doOpenFolderOrWorkspace(M,we,le,Le),!!Le),le=!0})}const De=v.distinct(V,Ie=>Ie.backupFolder);if(De.length>0&&De.forEach(Ie=>{const we=Ie.remoteAuthority,ye=(q==null?void 0:q.remoteAuthority)===we?q:void 0;se(this.openInBrowserWindow({userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,filesToOpen:ye,remoteAuthority:we,forceNewWindow:!0,forceNewTabbedWindow:M.forceNewTabbedWindow,emptyWindowBackupInfo:Ie}),!!ye),le=!0}),ne.length===0||q){q&&!K&&K++;const Ie=q?q.remoteAuthority:M.remoteAuthority;for(let we=0;we<K;we++)se(this.doOpenEmpty(M,le,Ie,q),!!q),le=!0}return{windows:v.distinct(ne),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(M,W,U){var V;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),W.focus();const K={filesToOpenOrCreate:U==null?void 0:U.filesToOpenOrCreate,filesToDiff:U==null?void 0:U.filesToDiff,filesToWait:U==null?void 0:U.filesToWait,termProgram:(V=M==null?void 0:M.userEnv)===null||V===void 0?void 0:V.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",G.CancellationToken.None,K),W}doAddFoldersToExistingWindow(M,W){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),M.focus();const U={foldersToAdd:W};return M.sendWhenReady("vscode:addFolders",G.CancellationToken.None,U),M}doOpenEmpty(M,W,U,V,K){return!W&&!K&&typeof M.contextWindowId=="number"&&(K=this.getWindowById(M.contextWindowId)),this.openInBrowserWindow({userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,remoteAuthority:U,forceNewWindow:W,forceNewTabbedWindow:M.forceNewTabbedWindow,filesToOpen:V,windowToUse:K})}doOpenFolderOrWorkspace(M,W,U,V,K){return!U&&!K&&typeof M.contextWindowId=="number"&&(K=this.getWindowById(M.contextWindowId)),this.openInBrowserWindow({workspace:W.workspace,userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:U,forceNewTabbedWindow:M.forceNewTabbedWindow,filesToOpen:V,windowToUse:K})}getPathsToOpen(M){var W;let U,V=!1,K=!1;if(M.urisToOpen&&M.urisToOpen.length>0?(U=this.doExtractPathsFromAPI(M),V=!0):M.forceEmpty?U=[Object.create(null)]:M.cli._.length||M.cli["folder-uri"]||M.cli["file-uri"]?(U=this.doExtractPathsFromCLI(M.cli),U.length===0&&U.push(Object.create(null)),V=!0):(U=this.doGetPathsFromLastSession(),U.length===0&&U.push(Object.create(null)),K=!0),!M.addMode&&V){const q=U.filter(x=>F(x));if(q.length>1){const x=q[0].remoteAuthority;if(q.every(ne=>ne.remoteAuthority===x)){const ne=this.workspacesManagementMainService.createUntitledWorkspaceSync(q.map(re=>({uri:re.workspace.uri})));U.push({workspace:ne,remoteAuthority:x}),U=U.filter(re=>!F(re))}}}return M.initialStartup&&!K&&((W=this.configurationService.getValue("window"))===null||W===void 0?void 0:W.restoreWindows)==="preserve"&&U.unshift(...this.doGetPathsFromLastSession().filter(q=>N(q)||F(q)||q.backupPath)),U}doExtractPathsFromAPI(M){const W=[],U={gotoLineMode:M.gotoLineMode,remoteAuthority:M.remoteAuthority};for(const V of v.coalesce(M.urisToOpen||[])){const K=this.resolveOpenable(V,U);if(K)K.label=V.label,W.push(K);else{const q=this.resourceFromOpenable(V),x={title:this.productService.nameLong,type:"info",buttons:[Y.mnemonicButtonLabel(n.localize(0,null))],defaultId:0,message:q.scheme===a.Schemas.file?n.localize(1,null):n.localize(2,null),detail:q.scheme===a.Schemas.file?n.localize(3,null,Y.getPathLabel(q.fsPath,this.environmentMainService)):n.localize(4,null,q.toString()),noLink:!0};this.dialogMainService.showMessageBox(x,te.withNullAsUndefined(y.BrowserWindow.getFocusedWindow()))}}return W}doExtractPathsFromCLI(M){const W=[],U={ignoreFileNotFound:!0,gotoLineMode:M.goto,remoteAuthority:M.remote||void 0,forceOpenWorkspaceAsFile:!1},V=M["folder-uri"];if(V)for(const x of V){const ne=this.cliArgToUri(x);if(ne){const re=this.resolveOpenable({folderUri:ne},U);re&&W.push(re)}}const K=M["file-uri"];if(K)for(const x of K){const ne=this.cliArgToUri(x);if(ne){const re=this.resolveOpenable(r.hasWorkspaceFileExtension(x)?{workspaceUri:ne}:{fileUri:ne},U);re&&W.push(re)}}const q=M._;for(const x of q){const ne=U.remoteAuthority?this.doResolvePathRemote(x,U):this.doResolveFilePath(x,U);ne&&W.push(ne)}return W}cliArgToUri(M){try{const W=h.URI.parse(M);if(!W.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${M}`);return}return W}catch(W){this.logService.error(`Invalid URI input string: ${M}, ${W.message}`)}}doGetPathsFromLastSession(){const M=this.getRestoreWindowsSetting();switch(M){case"none":return[];case"one":case"all":case"preserve":case"folders":const W=[];M!=="one"&&W.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&W.push(this.windowsStateHandler.state.lastActiveWindow);const U=[];for(const V of W)if(V.workspace){const K=this.resolveOpenable({workspaceUri:V.workspace.configPath},{remoteAuthority:V.remoteAuthority});N(K)&&U.push(K)}else if(V.folderUri){const K=this.resolveOpenable({folderUri:V.folderUri},{remoteAuthority:V.remoteAuthority});F(K)&&U.push(K)}else M!=="folders"&&V.backupPath&&U.push({backupPath:V.backupPath,remoteAuthority:V.remoteAuthority});return U}}getRestoreWindowsSetting(){let M;if(this.lifecycleMainService.wasRestarted)M="all";else{const W=this.configurationService.getValue("window");M=(W==null?void 0:W.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(M)||(M="all")}return M}resolveOpenable(M,W={}){let U=this.resourceFromOpenable(M);return U.scheme===a.Schemas.file?(P.isFileToOpen(M)&&(W=Object.assign(Object.assign({},W),{forceOpenWorkspaceAsFile:!0})),this.doResolveFilePath(U.fsPath,W)):this.doResolveRemoteOpenable(M,W)}doResolveRemoteOpenable(M,W){let U=this.resourceFromOpenable(M);const V=f.getRemoteAuthority(U)||W.remoteAuthority;if(U=w.removeTrailingPathSeparator(w.normalizePath(U)),P.isFileToOpen(M)){if(W.gotoLineMode){const{path:K,line:q,column:x}=B.parseLineAndColumnAware(U.path);return{fileUri:U.with({path:K}),lineNumber:q,columnNumber:x,remoteAuthority:V}}return{fileUri:U,remoteAuthority:V}}else if(P.isWorkspaceToOpen(M))return{workspace:L.getWorkspaceIdentifier(U),remoteAuthority:V};return{workspace:L.getSingleFolderWorkspaceIdentifier(U),remoteAuthority:V}}resourceFromOpenable(M){return P.isWorkspaceToOpen(M)?M.workspaceUri:P.isFolderToOpen(M)?M.folderUri:M.fileUri}doResolveFilePath(M,W){let U,V;W.gotoLineMode&&({path:M,line:U,column:V}=B.parseLineAndColumnAware(M)),M=B.sanitizeFilePath(I.normalize(M),z.cwd());try{const K=m.statSync(M);if(K.isFile()){if(!W.forceOpenWorkspaceAsFile){const q=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(M));if(q)return{workspace:{id:q.id,configPath:q.configPath},remoteAuthority:q.remoteAuthority,exists:!0}}return{fileUri:h.URI.file(M),lineNumber:U,columnNumber:V,exists:!0}}else if(K.isDirectory())return{workspace:L.getSingleFolderWorkspaceIdentifier(h.URI.file(M),K),exists:!0}}catch(K){const q=h.URI.file(M);if(this.workspacesHistoryMainService.removeRecentlyOpened([q]),W.ignoreFileNotFound)return{fileUri:q,exists:!1}}}doResolvePathRemote(M,W){const U=M.charCodeAt(0),V=W.remoteAuthority;let K,q;W.gotoLineMode&&({path:M,line:K,column:q}=B.parseLineAndColumnAware(M)),U!==47&&(B.isWindowsDriveLetter(U)&&M.charCodeAt(M.charCodeAt(1))===58&&(M=B.toSlashes(M)),M=`/${M}`);const x=h.URI.from({scheme:a.Schemas.vscodeRemote,authority:V,path:M});if(M.charCodeAt(M.length-1)!==47){if(r.hasWorkspaceFileExtension(M))return W.forceOpenWorkspaceAsFile?{fileUri:x,lineNumber:K,columnNumber:q,remoteAuthority:W.remoteAuthority}:{workspace:L.getWorkspaceIdentifier(x),remoteAuthority:V};if(W.gotoLineMode||I.posix.basename(M).indexOf(".")!==-1)return{fileUri:x,lineNumber:K,columnNumber:q,remoteAuthority:V}}return{workspace:L.getSingleFolderWorkspaceIdentifier(x),remoteAuthority:V}}shouldOpenNewWindow(M){const W=this.configurationService.getValue("window"),U=(W==null?void 0:W.openFoldersInNewWindow)||"default",V=(W==null?void 0:W.openFilesInNewWindow)||"off";let K=(M.preferNewWindow||M.forceNewWindow)&&!M.forceReuseWindow;!M.forceNewWindow&&!M.forceReuseWindow&&(U==="on"||U==="off")&&(K=U==="on");let q=!1;return M.forceNewWindow||M.forceReuseWindow?q=!!M.forceNewWindow&&!M.forceReuseWindow:(t.isMacintosh?M.context===1&&(q=!0):M.context!==3&&M.context!==2&&!(M.userEnv&&M.userEnv.TERM_PROGRAM==="vscode")&&(q=!0),!M.cli.extensionDevelopmentPath&&(V==="on"||V==="off")&&(q=V==="on")),{openFolderInNewWindow:!!K,openFilesInNewWindow:q}}openExtensionDevelopmentHostWindow(M,W){const U=c.findWindowOnExtensionDevelopmentPath(this.getWindows(),M);if(U)return this.lifecycleMainService.reload(U,W.cli),U.focus(),[U];let V=W.cli["folder-uri"]||[],K=W.cli["file-uri"]||[],q=W.cli._;if(!q.length&&!V.length&&!K.length&&!W.cli.extensionTestsPath){const se=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,le=se&&(se.workspace||se.folderUri);le&&(h.URI.isUri(le)?le.scheme===a.Schemas.file?q=[le.fsPath]:V=[le.toString()]:le.configPath.scheme===a.Schemas.file?q=[w.originalFSPath(le.configPath)]:K=[le.configPath.toString()])}let x=W.remoteAuthority;for(const se of M)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const le=h.URI.parse(se),oe=f.getRemoteAuthority(le);oe&&(x?oe!==x&&this.logService.error("more than one extension development path authority"):x=oe)}q=q.filter(se=>{const le=h.URI.file(se);return c.findWindowOnWorkspaceOrFolder(this.getWindows(),le)?!1:f.getRemoteAuthority(le)===x}),V=V.filter(se=>{const le=this.cliArgToUri(se);return le&&!!c.findWindowOnWorkspaceOrFolder(this.getWindows(),le)?!1:le?f.getRemoteAuthority(le)===x:!1}),K=K.filter(se=>{const le=this.cliArgToUri(se);return le&&!!c.findWindowOnWorkspaceOrFolder(this.getWindows(),le)?!1:le?f.getRemoteAuthority(le)===x:!1}),W.cli._=q,W.cli["folder-uri"]=V,W.cli["file-uri"]=K;const ne=!q.length&&!V.length&&!K.length,re={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:ne,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:x};return this.open(re)}openInBrowserWindow(M){var W,U,V,K,q;const x=this.configurationService.getValue("window"),ne=Object.assign(Object.assign(Object.assign({},this.environmentMainService.args),M.cli),{machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:M.emptyWindowBackupInfo?I.join(this.environmentMainService.backupHome,M.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:M.remoteAuthority,workspace:M.workspace,userEnv:Object.assign(Object.assign({},this.initialUserEnv),M.userEnv),filesToOpenOrCreate:(W=M.filesToOpen)===null||W===void 0?void 0:W.filesToOpenOrCreate,filesToDiff:(U=M.filesToOpen)===null||U===void 0?void 0:U.filesToDiff,filesToWait:(V=M.filesToOpen)===null||V===void 0?void 0:V.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:R.default,isInitialStartup:M.initialStartup,perfMarks:b.getMarks(),os:{release:A.release(),hostname:A.hostname()},zoomLevel:typeof(x==null?void 0:x.zoomLevel)=="number"?x.zoomLevel:void 0,autoDetectHighContrast:(K=x==null?void 0:x.autoDetectHighContrast)!==null&&K!==void 0?K:!0,accessibilitySupport:y.app.accessibilitySupportEnabled,colorScheme:{dark:y.nativeTheme.shouldUseDarkColors,highContrast:y.nativeTheme.shouldUseInvertedColorScheme||y.nativeTheme.shouldUseHighContrastColors}});let re;if(!M.forceNewWindow&&!M.forceNewTabbedWindow&&(re=M.windowToUse||this.getLastActiveWindow(),re&&re.focus()),re){const se=re.config;!ne.extensionDevelopmentPath&&se&&!!se.extensionDevelopmentPath&&(ne.extensionDevelopmentPath=se.extensionDevelopmentPath,ne.verbose=se.verbose,ne["inspect-brk-extensions"]=se["inspect-brk-extensions"],ne.debugId=se.debugId,ne["inspect-extensions"]=se["inspect-extensions"],ne["extensions-dir"]=se["extensions-dir"])}else{const se=this.windowsStateHandler.getNewWindowState(ne);b.mark("code/willCreateCodeWindow");const le=re=this.instantiationService.createInstance(k.CodeWindow,{state:se,extensionDevelopmentPath:ne.extensionDevelopmentPath,isExtensionTestHost:!!ne.extensionTestsPath});if(b.mark("code/didCreateCodeWindow"),M.forceNewTabbedWindow){const ue=this.getLastActiveWindow();ue&&ue.addTabbedWindow(le)}xe.WINDOWS.push(le),this._onDidOpenWindow.fire(le),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),_.once(le.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(le)),_.once(le.onDidClose)(()=>this.onWindowClosed(le)),_.once(le.onDidDestroy)(()=>this._onDidDestroyWindow.fire(le));const oe=te.assertIsDefined((q=le.win)===null||q===void 0?void 0:q.webContents);oe.removeAllListeners("devtools-reload-page"),oe.on("devtools-reload-page",()=>this.lifecycleMainService.reload(le)),this.lifecycleMainService.registerWindow(le)}return ne.windowId=re.id,re.isReady?this.lifecycleMainService.unload(re,4).then(se=>{se||this.doOpenInBrowserWindow(re,ne,M)}):this.doOpenInBrowserWindow(re,ne,M),re}doOpenInBrowserWindow(M,W,U){if(!W.extensionDevelopmentPath)if(r.isWorkspaceIdentifier(W.workspace))W.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:W.workspace,remoteAuthority:W.remoteAuthority});else if(r.isSingleFolderWorkspaceIdentifier(W.workspace))W.backupPath=this.backupMainService.registerFolderBackupSync(W.workspace.uri);else{const V=U.emptyWindowBackupInfo&&U.emptyWindowBackupInfo.backupFolder;W.backupPath=this.backupMainService.registerEmptyWindowBackupSync(V,W.remoteAuthority)}M.load(W)}onWindowClosed(M){const W=xe.WINDOWS.indexOf(M);xe.WINDOWS.splice(W,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const M=y.BrowserWindow.getFocusedWindow();if(M)return this.getWindowById(M.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(M){return this.doGetLastActiveWindow(this.getWindows().filter(W=>W.remoteAuthority===M))}doGetLastActiveWindow(M){const W=Math.max.apply(Math,M.map(U=>U.lastFocusTime));return M.find(U=>U.lastFocusTime===W)}sendToFocused(M,...W){const U=this.getFocusedWindow()||this.getLastActiveWindow();U&&U.sendWhenReady(M,G.CancellationToken.None,...W)}sendToAll(M,W,U){for(const V of this.getWindows())U&&U.indexOf(V.id)>=0||V.sendWhenReady(M,G.CancellationToken.None,W)}getWindows(){return xe.WINDOWS}getWindowCount(){return xe.WINDOWS.length}getWindowById(M){const W=this.getWindows().filter(U=>U.id===M);return v.firstOrDefault(W)}getWindowByWebContents(M){const W=y.BrowserWindow.fromWebContents(M);if(!!W)return this.getWindowById(W.id)}};T.WINDOWS=[],T=he([ee(2,D.ILogService),ee(3,E.IStateMainService),ee(4,i.IEnvironmentMainService),ee(5,d.ILifecycleMainService),ee(6,p.IBackupMainService),ee(7,g.IConfigurationService),ee(8,l.IWorkspacesHistoryMainService),ee(9,L.IWorkspacesManagementMainService),ee(10,s.IInstantiationService),ee(11,Q.IDialogMainService),ee(12,C.IFileService),ee(13,o.IProductService),ee(14,X.IProtocolMainService)],T),e.WindowsMainService=T}),define(J[236],Z([0,1,53,35,62,51]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let I=class{constructor(v,p,i,E){this.workspacesManagementMainService=v,this.windowsMainService=p,this.workspacesHistoryMainService=i,this.backupMainService=E,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(v,p){const i=this.windowsMainService.getWindowById(v);if(i)return this.workspacesManagementMainService.enterWorkspace(i,this.windowsMainService.getWindows(),p)}createUntitledWorkspace(v,p,i){return this.workspacesManagementMainService.createUntitledWorkspace(p,i)}deleteUntitledWorkspace(v,p){return this.workspacesManagementMainService.deleteUntitledWorkspace(p)}getWorkspaceIdentifier(v,p){return this.workspacesManagementMainService.getWorkspaceIdentifier(p)}async getRecentlyOpened(v){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(v))}async addRecentlyOpened(v,p){return this.workspacesHistoryMainService.addRecentlyOpened(p)}async removeRecentlyOpened(v,p){return this.workspacesHistoryMainService.removeRecentlyOpened(p)}async clearRecentlyOpened(v){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};I=he([ee(0,m.IWorkspacesManagementMainService),ee(1,A.IWindowsMainService),ee(2,R.IWorkspacesHistoryMainService),ee(3,b.IBackupMainService)],I),e.WorkspacesMainService=I}),define(J[237],Z([0,1,26,31,14,3,235,22,92,42,205,34,122,86,225,102,4,71,69,6,39,24,21,99,206,32,98,200,201,197,20,219,2,35,7,28,236,66,230,228,227,231,180,16,208,220,234,119,8,15,131,10,229,100,213,218,51,62,207,53,70,157,45,52,13,30,210,76,19,40,27,17,90,211,196,54,29,169,185,43,73,75,91,172,178]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d,g,D,P,c,u,o,l,t,r,s,a,h,w,f,S,L,_,H,Q,te,B,Y,G,C,z,X,N,F,T,O,M,W,U,V,K,q,x,ne,re,se,le,oe,ue,me,be,De,Ie,we,ye,Le,Te,$e,Ne,He,et,Be,st,tt,ut,Xe,ht,ot,j,ie,ae,ce,fe,Se,Me,Fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ue=class extends H.Disposable{constructor(de,pe,ve,ge,Ee,ke,Ae,Re,Pe,Ce){super();this.mainProcessNodeIpcServer=de,this.userEnv=pe,this.mainInstantiationService=ve,this.logService=ge,this.environmentMainService=Ee,this.lifecycleMainService=ke,this.configurationService=Ae,this.stateMainService=Re,this.fileService=Pe,this.productService=Ce,this.configureSession(),this.registerListeners()}configureSession(){const de=ve=>ve.startsWith(`${x.Schemas.vscodeWebview}://`);R.session.defaultSession.setPermissionRequestHandler((ve,ge,Ee,ke)=>de(ke.requestingUrl)?Ee(ge==="clipboard-read"):Ee(!1)),R.session.defaultSession.setPermissionCheckHandler((ve,ge,Ee,ke)=>de(ke.requestingUrl)?ge==="clipboard-read":!1);const pe=R.session.defaultSession;typeof pe.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&pe.setCodeCachePath(V.join(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){T.setUnexpectedErrorHandler(ve=>this.onUnexpectedError(ve)),process.on("uncaughtException",ve=>this.onUnexpectedError(ve)),process.on("unhandledRejection",ve=>T.onUnexpectedError(ve)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),U.registerContextMenuListener(),R.app.on("accessibility-support-changed",(ve,ge)=>{var Ee;(Ee=this.windowsMainService)===null||Ee===void 0||Ee.sendToAll("vscode:accessibilitySupportChanged",ge)}),R.app.on("activate",(ve,ge)=>{var Ee;this.logService.trace("app#activate"),ge||(Ee=this.windowsMainService)===null||Ee===void 0||Ee.openEmptyWindow({context:1})}),R.app.on("web-contents-created",(ve,ge)=>{ge.on("will-attach-webview",(Ee,ke,Ae)=>{const Re=Pe=>{if(!Pe)return!1;const Ce=te.URI.parse(Pe);if(Ce.scheme===x.Schemas.vscodeWebview)return Ce.path==="/index.html"||Ce.path==="/electron-browser-index.html";const je=Ce.fsPath.toLowerCase(),qe=te.URI.file(this.environmentMainService.appRoot).fsPath.toLowerCase();return je.startsWith(qe+V.sep)};delete ke.preload,ke.nodeIntegration=!1,!(Re(Ae.src)&&Re(ke.preloadURL))&&(delete ke.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),Ee.preventDefault())}),ge.on("will-navigate",Ee=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ee.preventDefault()}),ge.setWindowOpenHandler(({url:Ee})=>{var ke;return(ke=this.nativeHostMainService)===null||ke===void 0||ke.openExternal(void 0,Ee),{action:"deny"}})});let de=[],pe;R.app.on("open-file",(ve,ge)=>{this.logService.trace("app#open-file: ",ge),ve.preventDefault(),de.push(this.getWindowOpenableFromPathSync(ge)),pe!==void 0&&(clearTimeout(pe),pe=void 0),pe=setTimeout(()=>{var Ee;(Ee=this.windowsMainService)===null||Ee===void 0||Ee.open({context:1,cli:this.environmentMainService.args,urisToOpen:de,gotoLineMode:!1,preferNewWindow:!0}),de=[],pe=void 0},100)}),R.app.on("new-window-for-tab",()=>{var ve;(ve=this.windowsMainService)===null||ve===void 0||ve.openEmptyWindow({context:4})}),R.ipcMain.handle("vscode:fetchShellEnv",ve=>{var ge;const Ee=(ge=this.windowsMainService)===null||ge===void 0?void 0:ge.getWindowByWebContents(ve.sender);let ke,Ae;return(Ee==null?void 0:Ee.config)?(ke=Ee.config,Ae=Object.assign(Object.assign({},process.env),Ee.config.userEnv)):(ke=this.environmentMainService.args,Ae=process.env),v.resolveShellEnv(this.logService,ke,Ae)}),R.ipcMain.handle("vscode:writeNlsFile",(ve,ge,Ee)=>{const ke=this.validateNlsPath([ge]);if(!ke||typeof Ee!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(ke,st.VSBuffer.fromString(Ee))}),R.ipcMain.handle("vscode:readNlsFile",async(ve,...ge)=>{const Ee=this.validateNlsPath(ge);if(!Ee)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ee)).value.toString()}),R.ipcMain.on("vscode:toggleDevTools",ve=>ve.sender.toggleDevTools()),R.ipcMain.on("vscode:openDevTools",ve=>ve.sender.openDevTools()),R.ipcMain.on("vscode:reloadWindow",ve=>ve.sender.reload())}validateNlsPath(de){let pe;for(const ve of de)typeof ve=="string"&&(typeof pe!="string"?pe=ve:pe=V.join(pe,ve));if(!(typeof pe!="string"||!V.isAbsolute(pe)||!ot.isEqualOrParent(pe,this.environmentMainService.cachedLanguagesPath,!b.isLinux)))return te.URI.file(pe)}onUnexpectedError(de){var pe;if(de){const ve={message:`[uncaught exception in main]: ${de.message}`,stack:de.stack};(pe=this.windowsMainService)===null||pe===void 0||pe.sendToFocused("vscode:reportError",JSON.stringify(ve))}this.logService.error(`[uncaught exception in main]: ${de}`),de.stack&&this.logService.error(de.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const de=this.productService.win32AppUserModelId;b.isWindows&&de&&R.app.setAppUserModelId(de);try{b.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!R.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&R.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Pe){this.logService.error(Pe)}const pe=new k.Server;this.logService.trace("Resolving machine identifier...");const ve=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ve}`);const{sharedProcess:ge,sharedProcessReady:Ee,sharedProcessClient:ke}=this.setupSharedProcess(ve),Ae=await this.initServices(ve,ge,Ee);if(this.environmentMainService.driverHandle){const Pe=await M.serve(pe,this.environmentMainService.driverHandle,this.environmentMainService,Ae);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Pe)}this._register(Ae.createInstance(_.ProxyAuthHandler)),Ae.invokeFunction(Pe=>this.initChannels(Pe,pe,ke));const Re=Ae.invokeFunction(Pe=>this.openFirstWindow(Pe,pe));Ae.invokeFunction(Pe=>this.afterWindowOpen(Pe,ge)),this.environmentMainService.args.trace&&Ae.invokeFunction(Pe=>this.stopTracingEventually(Pe,Re))}async resolveMachineId(){let de=this.stateMainService.getItem(a.machineIdKey);return(!de||b.isMacintosh&&de==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(de=await G.getMachineId(),this.stateMainService.setItem(a.machineIdKey,de)),de}setupSharedProcess(de){const pe=this._register(this.mainInstantiationService.createInstance(d.SharedProcess,de,this.userEnv)),ve=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ee=await pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new y.Client(Ee,"main")})(),ge=(async()=>(await pe.whenReady(),ve))();return{sharedProcess:pe,sharedProcessReady:ge,sharedProcessClient:ve}}async initServices(de,pe,ve){const ge=new P.ServiceCollection;switch(process.platform){case"win32":ge.set(p.IUpdateService,new c.SyncDescriptor(C.Win32UpdateService));break;case"linux":b.isLinuxSnap?ge.set(p.IUpdateService,new c.SyncDescriptor(ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ge.set(p.IUpdateService,new c.SyncDescriptor(z.LinuxUpdateService));break;case"darwin":ge.set(p.IUpdateService,new c.SyncDescriptor(X.DarwinUpdateService));break}ge.set(Q.IWindowsMainService,new c.SyncDescriptor(I.WindowsMainService,[de,this.userEnv])),ge.set(ye.IDialogMainService,new c.SyncDescriptor(ye.DialogMainService)),ge.set(g.ILaunchMainService,new c.SyncDescriptor(g.LaunchMainService)),ge.set(De.IDiagnosticsService,E.ProxyChannel.toService(E.getDelayedChannel(ve.then(ke=>ke.getChannel("diagnostics"))))),ge.set(N.IIssueMainService,new c.SyncDescriptor(N.IssueMainService,[this.userEnv])),ge.set(tt.IEncryptionMainService,new c.SyncDescriptor(tt.EncryptionMainService,[de])),ge.set(Xe.IKeyboardLayoutMainService,new c.SyncDescriptor(Xe.KeyboardLayoutMainService)),ge.set(we.INativeHostMainService,new c.SyncDescriptor(we.NativeHostMainService,[pe])),ge.set(Ne.IWebviewManagerService,new c.SyncDescriptor($e.WebviewMainService)),ge.set(B.IWorkspacesService,new c.SyncDescriptor(Y.WorkspacesMainService)),ge.set(be.IWorkspacesManagementMainService,new c.SyncDescriptor(be.WorkspacesManagementMainService)),ge.set(ue.IWorkspacesHistoryMainService,new c.SyncDescriptor(ue.WorkspacesHistoryMainService)),ge.set(W.IMenubarMainService,new c.SyncDescriptor(W.MenubarMainService)),ge.set(j.IExtensionUrlTrustService,new c.SyncDescriptor(ie.ExtensionUrlTrustService)),ge.set(re.IStorageMainService,new c.SyncDescriptor(re.StorageMainService)),b.isWindows?ge.set(Se.IExternalTerminalMainService,new c.SyncDescriptor(Me.WindowsExternalTerminalService)):b.isMacintosh?ge.set(Se.IExternalTerminalMainService,new c.SyncDescriptor(Me.MacExternalTerminalService)):b.isLinux&&ge.set(Se.IExternalTerminalMainService,new c.SyncDescriptor(Me.LinuxExternalTerminalService));const Ee=new le.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ge.set(oe.IBackupMainService,Ee),ge.set(r.IURLService,new c.SyncDescriptor(me.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const ke=E.getDelayedChannel(ve.then(je=>je.getChannel("telemetryAppender"))),Ae=new w.TelemetryAppenderClient(ke),Re=S.resolveCommonProperties(this.fileService,m.release(),m.hostname(),process.arch,this.productService.commit,this.productService.version,de,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Pe=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Ce={appender:Ae,commonProperties:Re,piiPaths:Pe,sendErrorTelemetry:!0};ge.set(a.ITelemetryService,new c.SyncDescriptor(f.TelemetryService,[Ce]))}else ge.set(a.ITelemetryService,h.NullTelemetryService);return await Ee.initialize(),this.mainInstantiationService.createChild(ge)}initChannels(de,pe,ve){const ge=E.ProxyChannel.fromService(de.get(g.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ge),pe.registerChannel(Fe.UserConfigurationFileServiceId,E.ProxyChannel.fromService(new Fe.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const Ee=new i.UpdateChannel(de.get(p.IUpdateService));pe.registerChannel("update",Ee);const ke=E.ProxyChannel.fromService(de.get(N.IIssueMainService));pe.registerChannel("issue",ke);const Ae=E.ProxyChannel.fromService(de.get(tt.IEncryptionMainService));pe.registerChannel("encryption",Ae);const Re=E.ProxyChannel.fromService(de.get(fe.ISignService));pe.registerChannel("sign",Re);const Pe=E.ProxyChannel.fromService(de.get(Xe.IKeyboardLayoutMainService));pe.registerChannel("keyboardLayout",Pe),this.nativeHostMainService=de.get(we.INativeHostMainService);const Ce=E.ProxyChannel.fromService(this.nativeHostMainService);pe.registerChannel("nativeHost",Ce),ve.then(Ve=>Ve.registerChannel("nativeHost",Ce));const je=E.ProxyChannel.fromService(de.get(B.IWorkspacesService));pe.registerChannel("workspaces",je);const qe=E.ProxyChannel.fromService(de.get(W.IMenubarMainService));pe.registerChannel("menubar",qe);const Ge=E.ProxyChannel.fromService(de.get(r.IURLService));pe.registerChannel("url",Ge);const Qe=E.ProxyChannel.fromService(de.get(j.IExtensionUrlTrustService));pe.registerChannel("extensionUrlTrust",Qe);const _e=E.ProxyChannel.fromService(de.get(Ne.IWebviewManagerService));pe.registerChannel("webview",_e);const it=this._register(new se.StorageDatabaseChannel(this.logService,de.get(re.IStorageMainService)));pe.registerChannel("storage",it),ve.then(Ve=>Ve.registerChannel("storage",it));const nt=E.ProxyChannel.fromService(de.get(Se.IExternalTerminalMainService));pe.registerChannel("externalTerminal",nt);const Ze=new F.LogLevelChannel(de.get(u.ILogService));pe.registerChannel("logLevel",Ze),ve.then(Ve=>Ve.registerChannel("logLevel",Ze));const rt=new F.LoggerChannel(de.get(u.ILoggerService));pe.registerChannel("logger",rt),ve.then(Ve=>Ve.registerChannel("logger",rt));const at=new Ie.ElectronExtensionHostDebugBroadcastChannel(de.get(Q.IWindowsMainService));pe.registerChannel("extensionhostdebugservice",at)}openFirstWindow(de,pe){const ve=this.windowsMainService=de.get(Q.IWindowsMainService),ge=de.get(r.IURLService),Ee=de.get(we.INativeHostMainService);this.lifecycleMainService.phase=2;const ke=[],Ae=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(We=>{try{return{uri:te.URI.parse(We),url:We}}catch(Je){return}}).filter(We=>{if(!We||this.shouldBlockURI(We.uri))return!1;const Je=this.getWindowOpenableFromProtocolLink(We.uri);return Je?(ke.push(Je),!1):!0}),Re=this,Pe=this.environmentMainService,Ce=this.productService;ge.registerHandler({async handleURL(We,Je){if(We.scheme===Ce.urlProtocol&&We.path==="workspace"&&(We=We.with({authority:"file",path:te.URI.parse(We.query).path,query:""})),Re.shouldBlockURI(We))return!0;const St=Re.getWindowOpenableFromProtocolLink(We);if(St){const[ft]=ve.open({context:5,cli:Object.assign({},Pe.args),urisToOpen:[St],gotoLineMode:!0});return ft.focus(),!0}if(b.isMacintosh&&ve.getWindowCount()===0){const[ft]=ve.open({context:5,cli:Object.assign({},Pe.args),forceEmpty:!0,gotoLineMode:!0,remoteAuthority:ce.getRemoteAuthority(We)});return await ft.ready(),ge.open(We,Je)}return!1}});const je=this._register(new ut.ActiveWindowManager({onDidOpenWindow:Ee.onDidOpenWindow,onDidFocusWindow:Ee.onDidFocusWindow,getActiveWindowId:()=>Ee.getActiveWindowId(-1)})),qe=new E.StaticRouter(We=>je.getActiveClientId().then(Je=>We===Je)),Ge=new s.URLHandlerRouter(qe),Qe=pe.getChannel("urlHandler",Ge);ge.registerHandler(new s.URLHandlerChannelClient(Qe)),this._register(new O.ElectronURLListener(Ae,ge,ve,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,it=global.macOpenFiles,nt=ht.isLaunchedFromCli(process.env)?0:4,Ze=_e._.length,rt=!!_e["folder-uri"],at=!!_e["file-uri"],Ve=_e["skip-add-to-recently-opened"]===!0,dt=_e.wait&&_e.waitMarkerFilePath?te.URI.file(_e.waitMarkerFilePath):void 0,yt=_e.remote||void 0;return ke.length>0?ve.open({context:nt,cli:_e,urisToOpen:ke,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!Ze&&!rt&&!at?ve.open({context:nt,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ve,waitMarkerFileURI:dt,initialStartup:!0,remoteAuthority:yt}):it.length&&!Ze&&!rt&&!at?ve.open({context:1,cli:_e,urisToOpen:it.map(We=>this.getWindowOpenableFromPathSync(We)),noRecentEntry:Ve,waitMarkerFileURI:dt,initialStartup:!0}):ve.open({context:nt,cli:_e,forceNewWindow:_e["new-window"]||!Ze&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:Ve,waitMarkerFileURI:dt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:yt})}shouldBlockURI(de){return!!(de.authority===x.Schemas.file&&b.isWindows&&R.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[Te.mnemonicButtonLabel(q.localize(0,null)),Te.mnemonicButtonLabel(q.localize(1,null))],defaultId:0,cancelId:1,message:q.localize(2,null,Te.getPathLabel(de.fsPath,this.environmentMainService),this.productService.nameShort),detail:q.localize(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(de){if(!!de.path){if(de.authority===x.Schemas.file)return{fileUri:te.URI.file(de.fsPath)};if(de.authority===x.Schemas.vscodeRemote){const pe=de.path.indexOf(V.posix.sep,1);if(pe!==-1){const ve=de.path.substring(1,pe),ge=de.path.substring(pe),Ee=te.URI.from({scheme:x.Schemas.vscodeRemote,authority:ve,path:ge,query:de.query,fragment:de.fragment});return B.hasWorkspaceFileExtension(ge)?{workspaceUri:Ee}:/:[\d]+$/.test(ge)?{fileUri:Ee}:{folderUri:Ee}}}}}getWindowOpenableFromPathSync(de){try{if(A.statSync(de).isDirectory())return{folderUri:te.URI.file(de)};if(B.hasWorkspaceFileExtension(de))return{workspaceUri:te.URI.file(de)}}catch(pe){}return{fileUri:te.URI.file(de)}}async afterWindowOpen(de,pe){var ve;this.lifecycleMainService.phase=3;let ge=!1;ae.once(this.lifecycleMainService.onWillShutdown)(()=>ge=!0);const Ee=de.get(a.ITelemetryService);this._register(pe.onDidError(({type:Re,details:Pe})=>{var Ce,je,qe,Ge;let Qe;switch(Re){case 1:Qe="SharedProcess: detected unresponsive window";break;case 2:Qe=`SharedProcess: crashed (detail: ${(Ce=Pe==null?void 0:Pe.reason)!==null&&Ce!==void 0?Ce:"<unknown>"}, code: ${(je=Pe==null?void 0:Pe.exitCode)!==null&&je!==void 0?je:"<unknown>"})`;break;case 3:Qe=`SharedProcess: failed to load (detail: ${(qe=Pe==null?void 0:Pe.reason)!==null&&qe!==void 0?qe:"<unknown>"}, code: ${(Ge=Pe==null?void 0:Pe.exitCode)!==null&&Ge!==void 0?Ge:"<unknown>"})`;break}T.onUnexpectedError(new Error(Qe)),Ee.publicLog2("sharedprocesserror",{type:Re,reason:Pe==null?void 0:Pe.reason,code:Pe==null?void 0:Pe.exitCode,visible:pe.isVisible(),shuttingdown:ge})}));const ke=this.productService.win32MutexName;if(b.isWindows&&ke)try{const Re=$.__$__nodeRequire("windows-mutex").Mutex,Pe=new Re(ke);ae.once(this.lifecycleMainService.onWillShutdown)(()=>Pe.release())}catch(Re){this.logService.error(Re)}R.protocol.registerHttpProtocol(x.Schemas.vscodeRemoteResource,(Re,Pe)=>{Pe({url:Re.url.replace(/^vscode-remote-resource:/,"http:"),method:Re.method})});const Ae=de.get(p.IUpdateService);(Ae instanceof C.Win32UpdateService||Ae instanceof z.LinuxUpdateService||Ae instanceof X.DarwinUpdateService)&&Ae.initialize(),v.resolveShellEnv(this.logService,this.environmentMainService.args,process.env);try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse(et.stripComments(Pe))["enable-crash-reporter"]===void 0){const je=(ve=this.configurationService.getValue("telemetry.enableCrashReporter"))!==null&&ve!==void 0?ve:!0,qe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${je},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${Be.generateUuid()}"`,"}"],Ge=Pe.substring(0,Pe.length-2).concat(`,
`,qe.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,st.VSBuffer.fromString(Ge))}}catch(Re){this.logService.error(Re)}}stopTracingEventually(de,pe){this.logService.info("Tracing: waiting for windows to get ready...");const ve=de.get(ye.IDialogMainService);let ge=!1;const Ee=async Ae=>{if(ge)return;ge=!0;const Re=await R.contentTracing.stopRecording(K.joinPath(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Ae?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Re}`):ve.showMessageBox({title:this.productService.nameLong,type:"info",message:q.localize(4,null),detail:q.localize(5,null,Re),buttons:[Te.mnemonicButtonLabel(q.localize(6,null))],defaultId:0,noLink:!0},Le.withNullAsUndefined(R.BrowserWindow.getFocusedWindow()))},ke=setTimeout(()=>Ee(!0),3e4);Promise.all(pe.map(Ae=>Ae.ready())).then(()=>{clearTimeout(ke),Ee(!1)})}};Ue=he([ee(2,D.IInstantiationService),ee(3,u.ILogService),ee(4,l.IEnvironmentMainService),ee(5,n.ILifecycleMainService),ee(6,t.IConfigurationService),ee(7,o.IStateMainService),ee(8,He.IFileService),ee(9,L.IProductService)],Ue),e.CodeApplication=Ue}),define(J[241],Z([0,1,14,31,18,11,3,72,48,54,161,22,34,56,174,71,69,6,226,39,21,189,50,224,237,30,95,94,16,60,43,75,195,198,183,184,10,19,74,222,20,29,23,8,36,24,67,98,181,33,55,186,9,204]),function($,e,m,A,R,b,I,n,v,p,i,E,k,y,d,g,D,P,c,u,o,l,t,r,s,a,h,w,f,S,L,_,H,Q,te,B,Y,G,C,z,X,N,F,T,O,M,W,U,V,K,q,x,ne){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class re{main(){try{this.startup()}catch(oe){console.error(oe.message),m.app.exit(1)}}async startup(){f.setUnexpectedErrorHandler(ye=>console.error(ye));const[oe,ue,me,be,De,Ie,we]=this.createServices();try{try{await this.initServices(me,be,De)}catch(ye){throw this.handleStartupDataDirError(me,we.nameLong,ye),ye}await oe.invokeFunction(async ye=>{const Le=ye.get(P.ILogService),Te=ye.get(E.ILifecycleMainService),$e=ye.get(G.IFileService),Ne=await this.claimInstance(Le,me,Te,oe,we,!0);return Ie.logger=new h.SpdLogLogger("main",T.join(me.logsPath,"main.log"),!0,Ie.getLevel()),L.once(Te.onWillShutdown)(()=>{$e.dispose(),be.dispose()}),oe.createInstance(s.CodeApplication,Ne,ue).startup()})}catch(ye){oe.invokeFunction(this.quit,ye)}}createServices(){const oe=new g.ServiceCollection,ue=Object.assign({_serviceBrand:void 0},v.default);oe.set(X.IProductService,ue);const me=new M.EnvironmentMainService(this.resolveArgs(),ue),be=this.patchEnvironment(me);oe.set(M.IEnvironmentMainService,me);const De=new w.BufferLogService,Ie=new P.MultiplexLogService([new P.ConsoleMainLogger(P.getLogLevel(me)),De]);process.once("exit",()=>Ie.dispose()),oe.set(P.ILogService,Ie);const we=new te.FileService(Ie);oe.set(G.IFileService,we);const ye=new B.DiskFileSystemProvider(Ie);we.registerProvider(Y.Schemas.file,ye),oe.set(P.ILoggerService,new V.LoggerService(Ie,we));const Le=new l.ConfigurationService(me.settingsResource,we);oe.set(o.IConfigurationService,Le),oe.set(E.ILifecycleMainService,new D.SyncDescriptor(E.LifecycleMainService));const Te=new c.StateMainService(me,Ie,we);return oe.set(u.IStateMainService,Te),oe.set(t.IRequestService,new D.SyncDescriptor(r.RequestMainService)),oe.set(S.IThemeMainService,new D.SyncDescriptor(S.ThemeMainService)),oe.set(_.ISignService,new D.SyncDescriptor(H.SignService)),oe.set(C.ITunnelService,new D.SyncDescriptor(z.TunnelService)),oe.set(q.IProtocolMainService,new D.SyncDescriptor(x.ProtocolMainService)),[new d.InstantiationService(oe,!0),be,me,Le,Te,De,ue]}patchEnvironment(oe){const ue={VSCODE_IPC_HOOK:oe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(me=>{const be=process.env[me];typeof be=="string"&&(ue[me]=be)}),Object.assign(process.env,ue),ue}initServices(oe,ue,me){return ne.Promises.settled([Promise.all([oe.extensionsPath,oe.codeCachePath,oe.logsPath,oe.globalStorageHome.fsPath,oe.workspaceStorageHome.fsPath,oe.backupHome].map(be=>be?R.Promises.mkdir(be,{recursive:!0}):void 0)),ue.initialize(),me.init()])}async claimInstance(oe,ue,me,be,De,Ie){let we;try{n.mark("code/willStartMainServer"),we=await y.serve(ue.mainIPCHandle),n.mark("code/didStartMainServer"),L.once(me.onWillShutdown)(()=>we.dispose())}catch(ye){if(ye.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ue,De.nameLong,ye),ye;let Le;try{Le=await y.connect(ue.mainIPCHandle,"main")}catch(Ne){if(!Ie||I.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog(b.localize(0,null,De.nameShort),b.localize(1,null),De.nameLong),Ne;try{A.unlinkSync(ue.mainIPCHandle)}catch(He){throw oe.warn("Could not delete obsolete instance handle",He),He}return this.claimInstance(oe,ue,me,be,De,!1)}if(ue.extensionTestsLocationURI&&!ue.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw oe.error(Ne),Le.dispose(),new Error(Ne)}let Te;!ue.args.wait&&!ue.args.status&&(Te=setTimeout(()=>{this.showStartupWarningDialog(b.localize(2,null,De.nameShort),b.localize(3,null),De.nameLong)},1e4));const $e=k.ProxyChannel.toService(Le.getChannel("launch"),{disableMarshalling:!0});if(ue.args.status)return be.invokeFunction(async()=>{const Ne=new Q.DiagnosticsService(U.NullTelemetryService,De),He=await $e.getMainProcessInfo(),et=await $e.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ne.getDiagnostics(He,et);throw console.log(Be),new f.ExpectedError});throw I.isWindows&&await this.windowsAllowSetForegroundWindow($e,oe),oe.trace("Sending env to running instance..."),await $e.start(ue.args,process.env),Le.dispose(),Te&&clearTimeout(Te),new f.ExpectedError("Sent env to running instance. Terminating...")}if(ue.args.status)throw oe.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),we}handleStartupDataDirError(oe,ue,me){if(me.code==="EACCES"||me.code==="EPERM"){const be=O.coalesce([oe.userDataPath,oe.extensionsPath,y.XDG_RUNTIME_DIR]).map(De=>a.getPathLabel(De,oe));this.showStartupWarningDialog(b.localize(4,null),b.localize(5,null,W.toErrorMessage(me),be.join(`
`)),ue)}}showStartupWarningDialog(oe,ue,me){m.dialog.showMessageBoxSync({title:me,type:"warning",buttons:[a.mnemonicButtonLabel(b.localize(6,null))],message:oe,detail:ue,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(oe,ue){if(I.isWindows){const me=await oe.getMainProcessId();ue.trace("Sending some foreground love to the running instance:",me);try{(await new Promise((be,De)=>{$(["windows-foreground-love"],be,De)})).allowSetForegroundWindow(me)}catch(be){ue.error(be)}}}quit(oe,ue){const me=oe.get(P.ILogService),be=oe.get(E.ILifecycleMainService);let De=0;ue&&(ue.isExpected?ue.message&&me.trace(ue.message):(De=1,ue.stack?me.error(ue.stack):me.error(`Startup error: ${ue.toString()}`))),be.kill(De)}resolveArgs(){const oe=this.validatePaths(p.parseMainProcessArgv(process.argv));if(oe.wait&&!oe.waitMarkerFilePath){const ue=i.createWaitMarkerFile(oe.verbose);ue&&(p.addArg(process.argv,"--waitMarkerFilePath",ue),oe.waitMarkerFilePath=ue)}return oe}validatePaths(oe){if(oe["open-url"]&&(oe._urls=oe._,oe._=[]),!oe.remote){const ue=this.doValidatePaths(oe._,oe.goto);oe._=ue}return oe}doValidatePaths(oe,ue){const me=K.cwd(),be=oe.map(we=>{let ye=String(we),Le;ue&&(Le=N.parseLineAndColumnAware(ye),ye=Le.path),ye&&(ye=this.preparePath(me,ye));const Te=N.sanitizeFilePath(ye,me),$e=T.basename(Te);return $e&&!N.isValidBasename($e)?null:ue&&Le?(Le.path=Te,this.toPath(Le)):Te}),De=I.isWindows||I.isMacintosh,Ie=O.distinct(be,we=>we&&De?we.toLowerCase():we||"");return O.coalesce(Ie)}preparePath(oe,ue){return I.isWindows&&(ue=F.rtrim(ue,'"')),ue=F.trim(F.trim(ue," "),"	"),I.isWindows&&(ue=T.resolve(oe,ue),ue=F.rtrim(ue,".")),ue}toPath(oe){const ue=[oe.path];return typeof oe.line=="number"&&ue.push(String(oe.line)),typeof oe.column=="number"&&ue.push(String(oe.column)),ue.join(":")}}new re().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7dea6d7402b55671410a129661cad24b55aed9f4/core/vs/code/electron-main/main.js.map
