/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/errors","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/platform/log/common/log","vs/base/common/network","vs/base/common/arrays","vs/base/common/cancellation","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/platform","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/editor/common/core/range","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/process","vs/base/common/severity","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/numbers","vs/base/common/codicons","vs/base/common/uint","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/markers/common/markers","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(ee){for(var e=[],g=0,T=ee.length;g<T;g++)e[g]=we[ee[g]];return e};define(we[39],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(T,S){if(!T)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=g}),define(we[76],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function T(i){const I=[];for(let o in i)g.call(i,o)&&I.push(i[o]);return I}e.values=T;function S(i,I){for(let o in i)if(g.call(i,o)&&I({key:o,value:i[o]},function(){delete i[o]})===!1)return}e.forEach=S;function E(i,I){const o=Object.create(null);for(const f of i){const c=I(f);let d=o[c];d||(d=o[c]=[]),d.push(f)}return o}e.groupBy=E;function k(i){const I=Object.create(null);return i&&i.forEach((o,f)=>{I[f]=o}),I}e.fromMap=k;function D(i,I){const o=[],f=[];for(let c of i)I.has(c)||o.push(c);for(let c of I)i.has(c)||f.push(c);return{removed:o,added:f}}e.diffSets=D;function _(i,I){const o=[],f=[];for(let[c,d]of i)I.has(c)||o.push(d);for(let[c,d]of I)i.has(c)||f.push(d);return{removed:o,added:f}}e.diffMaps=_;class C{constructor(){this.map=new Map}add(I,o){let f=this.map.get(I);f||(f=new Set,this.map.set(I,f)),f.add(o)}delete(I,o){const f=this.map.get(I);!f||(f.delete(o),f.size===0&&this.map.delete(I))}forEach(I,o){const f=this.map.get(I);!f||f.forEach(o)}}e.SetMap=C}),define(we[48],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(k){return(D,_,C)=>{let i=null,I=null;if(typeof C.value=="function"?(i="value",I=C.value):typeof C.get=="function"&&(i="get",I=C.get),!I)throw new Error("not supported");C[i]=k(I,_)}}e.createDecorator=g;function T(k,D,_){let C=null,i=null;if(typeof _.value=="function"?(C="value",i=_.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(C="get",i=_.get),!i)throw new Error("not supported");const I=`$memoize$${D}`;_[C]=function(...o){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,o)}),this[I]}}e.memoize=T;function S(k,D,_){return g((C,i)=>{const I=`$debounce$${i}`,o=`$debounce$result$${i}`;return function(...f){this[o]||(this[o]=_?_():void 0),clearTimeout(this[I]),D&&(this[o]=D(this[o],...f),f=[this[o]]),this[I]=setTimeout(()=>{C.apply(this,f),this[o]=_?_():void 0},k)}})}e.debounce=S;function E(k,D,_){return g((C,i)=>{const I=`$throttle$timer$${i}`,o=`$throttle$result$${i}`,f=`$throttle$lastRun$${i}`,c=`$throttle$pending$${i}`;return function(...d){if(this[o]||(this[o]=_?_():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),D&&(this[o]=D(this[o],...d)),this[c])return;const y=this[f]+k;y<=Date.now()?(this[f]=Date.now(),C.apply(this,[this[o]]),this[o]=_?_():void 0):(this[c]=!0,this[I]=setTimeout(()=>{this[c]=!1,this[f]=Date.now(),C.apply(this,[this[o]]),this[o]=_?_():void 0},y-Date.now()))}})}e.throttle=E}),define(we[11],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=g,e.errorHandler=new g;function T(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=T;function S(m){_(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=S;function E(m){_(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=E;function k(m){if(m instanceof Error){let{name:t,message:n}=m;const s=m.stacktrace||m.stack;return{$isError:!0,name:t,message:n,stack:s}}return m}e.transformErrorForSerialization=k;const D="Canceled";function _(m){return m instanceof Error&&m.name===D&&m.message===D}e.isPromiseCanceledError=_;class C extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=C;function i(){const m=new Error(D);return m.name=m.message,m}e.canceled=i;function I(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=I;function o(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=o;function f(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function c(m){const t=new Error(`${m} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function d(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=d;class y extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=y;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class v extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=v;function l(m){const t=m;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=l;function h(m,t=Object.create(null)){const n=new Error(m);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=h}),define(we[17],_e([0,1,11]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function T(q,N=0){return q[q.length-(1+N)]}e.tail=T;function S(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=S;function E(q,N,W=(U,B)=>U===B){if(q===N)return!0;if(!q||!N||q.length!==N.length)return!1;for(let U=0,B=q.length;U<B;U++)if(!W(q[U],N[U]))return!1;return!0}e.equals=E;function k(q,N,W){let U=0,B=q.length-1;for(;U<=B;){const J=(U+B)/2|0,he=W(q[J],N);if(he<0)U=J+1;else if(he>0)B=J-1;else return J}return-(U+1)}e.binarySearch=k;function D(q,N){let W=0,U=q.length;if(U===0)return 0;for(;W<U;){const B=Math.floor((W+U)/2);N(q[B])?U=B:W=B+1}return W}e.findFirstInSorted=D;function _(q,N,W){if(q=q|0,q>=N.length)throw new TypeError("invalid index");let U=N[Math.floor(N.length*Math.random())],B=[],J=[],he=[];for(let De of N){const Oe=W(De,U);Oe<0?B.push(De):Oe>0?J.push(De):he.push(De)}return q<B.length?_(q,B,W):q<B.length+he.length?he[0]:_(q-(B.length+he.length),J,W)}e.quickSelect=_;function C(q,N){const W=[];let U;for(const B of q.slice(0).sort(N))!U||N(U[0],B)!==0?(U=[B],W.push(U)):U.push(B);return W}e.groupBy=C;function i(q,N,W){const U=[];function B(De,Oe,Me){if(Oe===0&&Me.length===0)return;const He=U[U.length-1];He&&He.start+He.deleteCount===De?(He.deleteCount+=Oe,He.toInsert.push(...Me)):U.push({start:De,deleteCount:Oe,toInsert:Me})}let J=0,he=0;for(;;){if(J===q.length){B(J,0,N.slice(he));break}if(he===N.length){B(J,q.length-J,[]);break}const De=q[J],Oe=N[he],Me=W(De,Oe);Me===0?(J+=1,he+=1):Me<0?(B(J,1,[]),J+=1):Me>0&&(B(J,0,[Oe]),he+=1)}return U}e.sortedDiff=i;function I(q,N,W){const U=i(q,N,W),B=[],J=[];for(const he of U)B.push(...q.slice(he.start,he.start+he.deleteCount)),J.push(...he.toInsert);return{removed:B,added:J}}e.delta=I;function o(q,N,W){if(W===0)return[];const U=q.slice(0,W).sort(N);return c(q,N,U,W,q.length),U}e.top=o;function f(q,N,W,U,B){return W===0?Promise.resolve([]):new Promise((J,he)=>{(async()=>{const De=q.length,Oe=q.slice(0,W).sort(N);for(let Me=W,He=Math.min(W+U,De);Me<De;Me=He,He=Math.min(He+U,De)){if(Me>W&&await new Promise(Ye=>setTimeout(Ye)),B&&B.isCancellationRequested)throw g.canceled();c(q,N,Oe,Me,He)}return Oe})().then(J,he)})}e.topAsync=f;function c(q,N,W,U,B){for(const J=W.length;U<B;U++){const he=q[U];if(N(he,W[J-1])<0){W.pop();const De=D(W,Oe=>N(he,Oe)<0);W.splice(De,0,he)}}}function d(q){return q.filter(N=>!!N)}e.coalesce=d;function y(q){let N=0;for(let W=0;W<q.length;W++)q[W]&&(q[N]=q[W],N+=1);q.length=N}e.coalesceInPlace=y;function w(q,N,W){q.splice(W,0,q.splice(N,1)[0])}e.move=w;function v(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=v;function l(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=l;function h(q,N){if(!N)return q.filter((U,B)=>q.indexOf(U)===B);const W=Object.create(null);return q.filter(U=>{const B=N(U);return W[B]?!1:(W[B]=!0,!0)})}e.distinct=h;function m(q){const N=new Set;return q.filter(W=>N.has(W)?!1:(N.add(W),!0))}e.distinctES6=m;function t(q){const N=Object.create(null);return W=>{const U=q(W);return N[U]?!1:(N[U]=!0,!0)}}e.uniqueFilter=t;function n(q,N){for(let W=q.length-1;W>=0;W--){const U=q[W];if(N(U))return W}return-1}e.lastIndex=n;function s(q,N){return q.length>0?q[0]:N}e.firstOrDefault=s;function r(q,N,W=(U,B)=>U===B){let U=0;for(let B=0,J=Math.min(q.length,N.length);B<J&&W(q[B],N[B]);B++)U++;return U}e.commonPrefixLength=r;function u(q){return[].concat(...q)}e.flatten=u;function b(q,N){let W=typeof N=="number"?q:0;typeof N=="number"?W=q:(W=0,N=q);const U=[];if(W<=N)for(let B=W;B<N;B++)U.push(B);else for(let B=W;B>N;B--)U.push(B);return U}e.range=b;function p(q,N,W){return q.reduce((U,B)=>(U[N(B)]=W?W(B):B,U),Object.create(null))}e.index=p;function P(q,N){return q.push(N),()=>A(q,N)}e.insert=P;function A(q,N){const W=q.indexOf(N);if(W>-1)return q.splice(W,1),N}e.remove=A;function a(q,N,W){const U=q.slice(0,N),B=q.slice(N);return U.concat(W,B)}e.arrayInsert=a;function R(q,N){let W;if(typeof N=="number"){let U=N;W=()=>{const B=Math.sin(U++)*179426549;return B-Math.floor(B)}}else W=Math.random;for(let U=q.length-1;U>0;U-=1){const B=Math.floor(W()*(U+1)),J=q[U];q[U]=q[B],q[B]=J}}e.shuffle=R;function M(q,N){const W=q.indexOf(N);W>-1&&(q.splice(W,1),q.unshift(N))}e.pushToStart=M;function H(q,N){const W=q.indexOf(N);W>-1&&(q.splice(W,1),q.push(N))}e.pushToEnd=H;function ue(q,N){return Array.isArray(q)?q.map(N):N(q)}e.mapArrayOrNot=ue;function fe(q){return Array.isArray(q)?q:[q]}e.asArray=fe;function Y(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=Y;function j(q,N){for(const W of q){const U=N(W);if(U!==void 0)return U}}e.mapFind=j;function Z(q,N){let W=Number.MAX_SAFE_INTEGER,U=0;return q.forEach((B,J)=>{const he=N(B);he<W&&(W=he,U=J)}),U}e.minIndex=Z;function L(q,N){let W=Number.MIN_SAFE_INTEGER,U=0;return q.forEach((B,J)=>{const he=N(B);he>W&&(W=he,U=J)}),U}e.maxIndex=L}),define(we[49],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(T){const S=this;let E=!1,k;return function(){return E||(E=!0,k=T.apply(S,arguments)),k}}e.once=g}),define(we[50],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(we[40],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(T){function S(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}T.is=S;const E=Object.freeze([]);function k(){return E}T.empty=k;function*D(m){yield m}T.single=D;function _(m){return m||E}T.from=_;function C(m){return!m||m[Symbol.iterator]().next().done===!0}T.isEmpty=C;function i(m){return m[Symbol.iterator]().next().value}T.first=i;function I(m,t){for(const n of m)if(t(n))return!0;return!1}T.some=I;function o(m,t){for(const n of m)if(t(n))return n}T.find=o;function*f(m,t){for(const n of m)t(n)&&(yield n)}T.filter=f;function*c(m,t){let n=0;for(const s of m)yield t(s,n++)}T.map=c;function*d(...m){for(const t of m)for(const n of t)yield n}T.concat=d;function*y(m){for(const t of m)for(const n of t)yield n}T.concatNested=y;function w(m,t,n){let s=n;for(const r of m)s=t(s,r);return s}T.reduce=w;function*v(m,t,n=m.length){for(t<0&&(t+=m.length),n<0?n+=m.length:n>m.length&&(n=m.length);t<n;t++)yield m[t]}T.slice=v;function l(m,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,m];const s=m[Symbol.iterator]();for(let r=0;r<t;r++){const u=s.next();if(u.done)return[n,T.empty()];n.push(u.value)}return[n,{[Symbol.iterator](){return s}}]}T.consume=l;function h(m,t,n=(s,r)=>s===r){const s=m[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const u=s.next(),b=r.next();if(u.done!==b.done)return!1;if(u.done)return!0;if(!n(u.value,b.value))return!1}}T.equals=h})(g=e.Iterable||(e.Iterable={}))}),define(we[107],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var E;(function(t){t.DEFAULT={allowTrailingComma:!0}})(E=e.ParseOptions||(e.ParseOptions={}));function k(t,n=!1){let s=0,r=t.length,u="",b=0,p=16,P=0;function A(Y){let j=0,Z=0;for(;j<Y;){const L=t.charCodeAt(s);if(L>=48&&L<=57)Z=Z*16+L-48;else if(L>=65&&L<=70)Z=Z*16+L-65+10;else if(L>=97&&L<=102)Z=Z*16+L-97+10;else break;s++,j++}return j<Y&&(Z=-1),Z}function a(Y){s=Y,u="",b=0,p=16,P=0}function R(){const Y=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&C(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&C(t.charCodeAt(s)))for(s++;s<t.length&&C(t.charCodeAt(s));)s++;else return P=3,t.substring(Y,s);let j=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&C(t.charCodeAt(s))){for(s++;s<t.length&&C(t.charCodeAt(s));)s++;j=s}else P=3;return t.substring(Y,j)}function M(){let Y="",j=s;for(;;){if(s>=r){Y+=t.substring(j,s),P=2;break}const Z=t.charCodeAt(s);if(Z===34){Y+=t.substring(j,s),s++;break}if(Z===92){if(Y+=t.substring(j,s),s++,s>=r){P=2;break}switch(t.charCodeAt(s++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:const q=A(4);q>=0?Y+=String.fromCharCode(q):P=4;break;default:P=5}j=s;continue}if(Z>=0&&Z<=31)if(_(Z)){Y+=t.substring(j,s),P=2;break}else P=6;s++}return Y}function H(){if(u="",P=0,b=s,s>=r)return b=r,p=17;let Y=t.charCodeAt(s);if(D(Y)){do s++,u+=String.fromCharCode(Y),Y=t.charCodeAt(s);while(D(Y));return p=15}if(_(Y))return s++,u+=String.fromCharCode(Y),Y===13&&t.charCodeAt(s)===10&&(s++,u+=`
`),p=14;switch(Y){case 123:return s++,p=1;case 125:return s++,p=2;case 91:return s++,p=3;case 93:return s++,p=4;case 58:return s++,p=6;case 44:return s++,p=5;case 34:return s++,u=M(),p=10;case 47:const j=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<r&&!_(t.charCodeAt(s));)s++;return u=t.substring(j,s),p=12}if(t.charCodeAt(s+1)===42){s+=2;const Z=r-1;let L=!1;for(;s<Z;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,L=!0;break}s++}return L||(s++,P=1),u=t.substring(j,s),p=13}return u+=String.fromCharCode(Y),s++,p=16;case 45:if(u+=String.fromCharCode(Y),s++,s===r||!C(t.charCodeAt(s)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=R(),p=11;default:for(;s<r&&ue(Y);)s++,Y=t.charCodeAt(s);if(b!==s){switch(u=t.substring(b,s),u){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return u+=String.fromCharCode(Y),s++,p=16}}function ue(Y){if(D(Y)||_(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function fe(){let Y;do Y=H();while(Y>=12&&Y<=15);return Y}return{setPosition:a,getPosition:()=>s,scan:n?fe:H,getToken:()=>p,getTokenValue:()=>u,getTokenOffset:()=>b,getTokenLength:()=>s-b,getTokenError:()=>P}}e.createScanner=k;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function _(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,n){const s=[],r=new Object;let u;const b={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function P(A,a,R,M){b.value=A,b.offset=a,b.length=R,b.type=M,b.colonOffset=void 0,u=b}try{l(t,{onObjectBegin:(A,a)=>{if(n<=A)throw r;u=void 0,p=n>A,s.push("")},onObjectProperty:(A,a,R)=>{if(n<a||(P(A,a,R,"property"),s[s.length-1]=A,n<=a+R))throw r},onObjectEnd:(A,a)=>{if(n<=A)throw r;u=void 0,s.pop()},onArrayBegin:(A,a)=>{if(n<=A)throw r;u=void 0,s.push(0)},onArrayEnd:(A,a)=>{if(n<=A)throw r;u=void 0,s.pop()},onLiteralValue:(A,a,R)=>{if(n<a||(P(A,a,R,m(A)),n<=a+R))throw r},onSeparator:(A,a,R)=>{if(n<=a)throw r;if(A===":"&&u&&u.type==="property")u.colonOffset=a,p=!1,u=void 0;else if(A===","){const M=s[s.length-1];typeof M=="number"?s[s.length-1]=M+1:(p=!0,s[s.length-1]=""),u=void 0}}})}catch(A){if(A!==r)throw A}return{path:s,previousNode:u,isAtPropertyKey:p,matches:A=>{let a=0;for(let R=0;a<A.length&&R<s.length;R++)if(A[a]===s[R]||A[a]==="*")a++;else if(A[a]!=="**")return!1;return a===A.length}}}e.getLocation=I;function o(t,n=[],s=E.DEFAULT){let r=null,u=[];const b=[];function p(A){Array.isArray(u)?u.push(A):r!==null&&(u[r]=A)}return l(t,{onObjectBegin:()=>{const A={};p(A),b.push(u),u=A,r=null},onObjectProperty:A=>{r=A},onObjectEnd:()=>{u=b.pop()},onArrayBegin:()=>{const A=[];p(A),b.push(u),u=A,r=null},onArrayEnd:()=>{u=b.pop()},onLiteralValue:p,onError:(A,a,R)=>{n.push({error:A,offset:a,length:R})}},s),u[0]}e.parse=o;function f(t,n=[],s=E.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(A){r.type==="property"&&(r.length=A-r.offset,r=r.parent)}function b(A){return r.children.push(A),A}l(t,{onObjectBegin:A=>{r=b({type:"object",offset:A,length:-1,parent:r,children:[]})},onObjectProperty:(A,a,R)=>{r=b({type:"property",offset:a,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:A,offset:a,length:R,parent:r})},onObjectEnd:(A,a)=>{r.length=A+a-r.offset,r=r.parent,u(A+a)},onArrayBegin:(A,a)=>{r=b({type:"array",offset:A,length:-1,parent:r,children:[]})},onArrayEnd:(A,a)=>{r.length=A+a-r.offset,r=r.parent,u(A+a)},onLiteralValue:(A,a,R)=>{b({type:m(A),offset:a,length:R,parent:r,value:A}),u(a+R)},onSeparator:(A,a,R)=>{r.type==="property"&&(A===":"?r.colonOffset=a:A===","&&u(a))},onError:(A,a,R)=>{n.push({error:A,offset:a,length:R})}},s);const P=r.children[0];return P&&delete P.parent,P}e.parseTree=f;function c(t,n){if(!t)return;let s=t;for(let r of n)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let u=!1;for(const b of s.children)if(Array.isArray(b.children)&&b.children[0].value===r){s=b.children[1],u=!0;break}if(!u)return}else{const u=r;if(s.type!=="array"||u<0||!Array.isArray(s.children)||u>=s.children.length)return;s=s.children[u]}return s}e.findNodeAtLocation=c;function d(t){if(!t.parent||!t.parent.children)return[];const n=d(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;n.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&n.push(s)}return n}e.getNodePath=d;function y(t){switch(t.type){case"array":return t.children.map(y);case"object":const n=Object.create(null);for(let s of t.children){const r=s.children[1];r&&(n[s.children[0].value]=y(r))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=y;function w(t,n,s=!1){return n>=t.offset&&n<t.offset+t.length||s&&n===t.offset+t.length}e.contains=w;function v(t,n,s=!1){if(w(t,n,s)){const r=t.children;if(Array.isArray(r))for(let u=0;u<r.length&&r[u].offset<=n;u++){const b=v(r[u],n,s);if(b)return b}return t}}e.findNodeAtOffset=v;function l(t,n,s=E.DEFAULT){const r=k(t,!1);function u(he){return he?()=>he(r.getTokenOffset(),r.getTokenLength()):()=>!0}function b(he){return he?De=>he(De,r.getTokenOffset(),r.getTokenLength()):()=>!0}const p=u(n.onObjectBegin),P=b(n.onObjectProperty),A=u(n.onObjectEnd),a=u(n.onArrayBegin),R=u(n.onArrayEnd),M=b(n.onLiteralValue),H=b(n.onSeparator),ue=u(n.onComment),fe=b(n.onError),Y=s&&s.disallowComments,j=s&&s.allowTrailingComma;function Z(){for(;;){const he=r.scan();switch(r.getTokenError()){case 4:L(14);break;case 5:L(15);break;case 3:L(13);break;case 1:Y||L(11);break;case 2:L(12);break;case 6:L(16);break}switch(he){case 12:case 13:Y?L(10):ue();break;case 16:L(1);break;case 15:case 14:break;default:return he}}}function L(he,De=[],Oe=[]){if(fe(he),De.length+Oe.length>0){let Me=r.getToken();for(;Me!==17;){if(De.indexOf(Me)!==-1){Z();break}else if(Oe.indexOf(Me)!==-1)break;Me=Z()}}}function q(he){const De=r.getTokenValue();return he?M(De):P(De),Z(),!0}function N(){switch(r.getToken()){case 11:let he=0;try{he=JSON.parse(r.getTokenValue()),typeof he!="number"&&(L(2),he=0)}catch(De){L(2)}M(he);break;case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return Z(),!0}function W(){return r.getToken()!==10?(L(3,[],[2,5]),!1):(q(!1),r.getToken()===6?(H(":"),Z(),J()||L(4,[],[2,5])):L(5,[],[2,5]),!0)}function U(){p(),Z();let he=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(he||L(4,[],[]),H(","),Z(),r.getToken()===2&&j)break}else he&&L(6,[],[]);W()||L(4,[],[2,5]),he=!0}return A(),r.getToken()!==2?L(7,[2],[]):Z(),!0}function B(){a(),Z();let he=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(he||L(4,[],[]),H(","),Z(),r.getToken()===4&&j)break}else he&&L(6,[],[]);J()||L(4,[],[4,5]),he=!0}return R(),r.getToken()!==4?L(8,[4],[]):Z(),!0}function J(){switch(r.getToken()){case 3:return B();case 1:return U();case 10:return q(!0);default:return N()}}return Z(),r.getToken()===17?s.allowEmptyContent?!0:(L(4,[],[]),!1):J()?(r.getToken()!==17&&L(9,[],[]),!0):(L(4,[],[]),!1)}e.visit=l;function h(t,n){let s=k(t),r=[],u,b=0,p;do switch(p=s.getPosition(),u=s.scan(),u){case 12:case 13:case 17:b!==p&&r.push(t.substring(b,p)),n!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,n)),b=s.getPosition();break}while(u!==17);return r.join("")}e.stripComments=h;function m(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(we[108],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(S){this.executor=S,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(S){this._error=S}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(S){return new g(()=>S(this.getValue()))}}e.Lazy=g}),define(we[7],_e([0,1,49,40]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const S=!1;let E=null;function k(h){E=h}if(e.setDisposableTracker=k,S){const h="__is_disposable_tracked__";E=new class{trackDisposable(m){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[h]||console.log(t)},3e3)}markTracked(m){if(m&&m!==d.None)try{m[h]=!0}catch(t){}}}}function D(h){!E||E.markTracked(h)}function _(h){return E&&E.trackDisposable(h),h}e.trackDisposable=_;class C extends Error{constructor(m){super(`Encountered errors while disposing of store. Errors: [${m.join(", ")}]`);this.errors=m}}e.MultiDisposeError=C;function i(h){return typeof h.dispose=="function"&&h.dispose.length===0}e.isDisposable=i;function I(h){if(T.Iterable.is(h)){let m=[];for(const t of h)if(t){D(t);try{t.dispose()}catch(n){m.push(n)}}if(m.length===1)throw m[0];if(m.length>1)throw new C(m);return Array.isArray(h)?[]:h}else if(h)return D(h),h.dispose(),h}e.dispose=I;function o(...h){return h.forEach(D),f(()=>I(h))}e.combinedDisposable=o;function f(h){const m=_({dispose:()=>{D(m),h()}});return m}e.toDisposable=f;class c{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return D(m),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(m),m}}e.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this._store=new c,_(this)}dispose(){D(this),this._store.dispose()}_register(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(m)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class y{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(m){var t;this._isDisposed||m===this._value||((t=this._value)===null||t===void 0||t.dispose(),m&&D(m),this._value=m)}clear(){this.value=void 0}dispose(){var m;this._isDisposed=!0,D(this),(m=this._value)===null||m===void 0||m.dispose(),this._value=void 0}}e.MutableDisposable=y;class w{constructor(){this.references=new Map}acquire(m,...t){let n=this.references.get(m);n||(n={counter:0,object:this.createReferencedObject(m,...t)},this.references.set(m,n));const{object:s}=n,r=g.once(()=>{--n.counter==0&&(this.destroyReferencedObject(m,n.object),this.references.delete(m))});return n.counter++,{object:s,dispose:r}}}e.ReferenceCollection=w;class v{constructor(m){this.referenceCollection=m}async acquire(m,...t){const n=this.referenceCollection.acquire(m,...t);try{return{object:await n.object,dispose:()=>n.dispose()}}catch(s){throw n.dispose(),s}}}e.AsyncReferenceCollection=v;class l{constructor(m){this.object=m}dispose(){}}e.ImmortalReference=l}),define(we[51],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(E){this.element=E,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class T{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let E=this._first;for(;E!==g.Undefined;){const k=E.next;E.prev=g.Undefined,E.next=g.Undefined,E=k}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(E){return this._insert(E,!1)}push(E){return this._insert(E,!0)}_insert(E,k){const D=new g(E);if(this._first===g.Undefined)this._first=D,this._last=D;else if(k){const C=this._last;this._last=D,D.prev=C,C.next=D}else{const C=this._first;this._first=D,D.next=C,C.prev=D}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(D))}}shift(){if(this._first!==g.Undefined){const E=this._first.element;return this._remove(this._first),E}}pop(){if(this._last!==g.Undefined){const E=this._last.element;return this._remove(this._last),E}}_remove(E){if(E.prev!==g.Undefined&&E.next!==g.Undefined){const k=E.prev;k.next=E.next,E.next.prev=k}else E.prev===g.Undefined&&E.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):E.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):E.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let E=this._first;for(;E!==g.Undefined;)yield E.element,E=E.next}}e.LinkedList=T}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,ee.marked=e())}(this,function(){"use strict";function ee(Ee,be){for(var Ce=0;Ce<be.length;Ce++){var se=be[Ce];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Ee,se.key,se)}}function e(Ee,be,Ce){return be&&ee(Ee.prototype,be),Ce&&ee(Ee,Ce),Ee}function g(Ee,be){if(!!Ee){if(typeof Ee=="string")return T(Ee,be);var Ce=Object.prototype.toString.call(Ee).slice(8,-1);if(Ce==="Object"&&Ee.constructor&&(Ce=Ee.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Ee);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return T(Ee,be)}}function T(Ee,be){(be==null||be>Ee.length)&&(be=Ee.length);for(var Ce=0,se=new Array(be);Ce<be;Ce++)se[Ce]=Ee[Ce];return se}function S(Ee,be){var Ce;if(typeof Symbol=="undefined"||Ee[Symbol.iterator]==null){if(Array.isArray(Ee)||(Ce=g(Ee))||be&&Ee&&typeof Ee.length=="number"){Ce&&(Ee=Ce);var se=0;return function(){return se>=Ee.length?{done:!0}:{done:!1,value:Ee[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Ce=Ee[Symbol.iterator](),Ce.next.bind(Ce)}function E(Ee){var be={exports:{}};return Ee(be,be.exports),be.exports}var k=E(function(Ee){function be(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Ce(se){Ee.exports.defaults=se}Ee.exports={defaults:be(),getDefaults:be,changeDefaults:Ce}}),D=/[&<>"']/,_=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},o=function(be){return I[be]};function f(Ee,be){if(be){if(D.test(Ee))return Ee.replace(_,o)}else if(C.test(Ee))return Ee.replace(i,o);return Ee}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(Ee){return Ee.replace(c,function(be,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var y=/(^|[^\[])\^/g;function w(Ee,be){Ee=Ee.source||Ee,be=be||"";var Ce={replace:function(de,O){return O=O.source||O,O=O.replace(y,"$1"),Ee=Ee.replace(de,O),Ce},getRegex:function(){return new RegExp(Ee,be)}};return Ce}var v=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ee,be,Ce){if(Ee){var se;try{se=decodeURIComponent(d(Ce)).replace(v,"").toLowerCase()}catch(de){return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}be&&!l.test(Ce)&&(Ce=r(be,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(de){return null}return Ce}var m={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Ee,be){m[" "+Ee]||(t.test(Ee)?m[" "+Ee]=Ee+"/":m[" "+Ee]=P(Ee,"/",!0)),Ee=m[" "+Ee];var Ce=Ee.indexOf(":")===-1;return be.substring(0,2)==="//"?Ce?be:Ee.replace(n,"$1")+be:be.charAt(0)==="/"?Ce?be:Ee.replace(s,"$1")+be:Ee+be}var u={exec:function(){}};function b(Ee){for(var be=1,Ce,se;be<arguments.length;be++){Ce=arguments[be];for(se in Ce)Object.prototype.hasOwnProperty.call(Ce,se)&&(Ee[se]=Ce[se])}return Ee}function p(Ee,be){var Ce=Ee.replace(/\|/g,function(O,Q,le){for(var ke=!1,Pe=Q;--Pe>=0&&le[Pe]==="\\";)ke=!ke;return ke?"|":" |"}),se=Ce.split(/ \|/),de=0;if(se.length>be)se.splice(be);else for(;se.length<be;)se.push("");for(;de<se.length;de++)se[de]=se[de].trim().replace(/\\\|/g,"|");return se}function P(Ee,be,Ce){var se=Ee.length;if(se===0)return"";for(var de=0;de<se;){var O=Ee.charAt(se-de-1);if(O===be&&!Ce)de++;else if(O!==be&&Ce)de++;else break}return Ee.substr(0,se-de)}function A(Ee,be){if(Ee.indexOf(be[1])===-1)return-1;for(var Ce=Ee.length,se=0,de=0;de<Ce;de++)if(Ee[de]==="\\")de++;else if(Ee[de]===be[0])se++;else if(Ee[de]===be[1]&&(se--,se<0))return de;return-1}function a(Ee){Ee&&Ee.sanitize&&!Ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Ee,be){if(be<1)return"";for(var Ce="";be>1;)be&1&&(Ce+=Ee),be>>=1,Ee+=Ee;return Ce+Ee}var M={escape:f,unescape:d,edit:w,cleanUrl:h,resolveUrl:r,noopTest:u,merge:b,splitCells:p,rtrim:P,findClosingBracket:A,checkSanitizeDeprecation:a,repeatString:R},H=k.defaults,ue=M.rtrim,fe=M.splitCells,Y=M.escape,j=M.findClosingBracket;function Z(Ee,be,Ce){var se=be.href,de=be.title?Y(be.title):null,O=Ee[1].replace(/\\([\[\]])/g,"$1");return Ee[0].charAt(0)!=="!"?{type:"link",raw:Ce,href:se,title:de,text:O}:{type:"image",raw:Ce,href:se,title:de,text:Y(O)}}function L(Ee,be){var Ce=Ee.match(/^(\s+)(?:```)/);if(Ce===null)return be;var se=Ce[1];return be.split(`
`).map(function(de){var O=de.match(/^\s+/);if(O===null)return de;var Q=O[0];return Q.length>=se.length?de.slice(se.length):de}).join(`
`)}var q=function(){function Ee(Ce){this.options=Ce||H}var be=Ee.prototype;return be.space=function(se){var de=this.rules.block.newline.exec(se);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},be.code=function(se){var de=this.rules.block.code.exec(se);if(de){var O=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?O:ue(O,`
`)}}},be.fences=function(se){var de=this.rules.block.fences.exec(se);if(de){var O=de[0],Q=L(O,de[3]||"");return{type:"code",raw:O,lang:de[2]?de[2].trim():de[2],text:Q}}},be.heading=function(se){var de=this.rules.block.heading.exec(se);if(de){var O=de[2].trim();if(/#$/.test(O)){var Q=ue(O,"#");(this.options.pedantic||!Q||/ $/.test(Q))&&(O=Q.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:O}}},be.nptable=function(se){var de=this.rules.block.nptable.exec(se);if(de){var O={type:"table",header:fe(de[1].replace(/^ *| *\| *$/g,"")),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:de[3]?de[3].replace(/\n$/,"").split(`
`):[],raw:de[0]};if(O.header.length===O.align.length){var Q=O.align.length,le;for(le=0;le<Q;le++)/^ *-+: *$/.test(O.align[le])?O.align[le]="right":/^ *:-+: *$/.test(O.align[le])?O.align[le]="center":/^ *:-+ *$/.test(O.align[le])?O.align[le]="left":O.align[le]=null;for(Q=O.cells.length,le=0;le<Q;le++)O.cells[le]=fe(O.cells[le],O.header.length);return O}}},be.hr=function(se){var de=this.rules.block.hr.exec(se);if(de)return{type:"hr",raw:de[0]}},be.blockquote=function(se){var de=this.rules.block.blockquote.exec(se);if(de){var O=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],text:O}}},be.list=function(se){var de=this.rules.block.list.exec(se);if(de){var O=de[0],Q=de[2],le=Q.length>1,ke={type:"list",raw:O,ordered:le,start:le?+Q.slice(0,-1):"",loose:!1,items:[]},Pe=de[0].match(this.rules.block.item),Ue=!1,We,Ze,rt,Ke,Je,ft,ve,ye,ae=Pe.length;rt=this.rules.block.listItemStart.exec(Pe[0]);for(var z=0;z<ae;z++){if(We=Pe[z],O=We,z!==ae-1){if(Ke=this.rules.block.listItemStart.exec(Pe[z+1]),this.options.pedantic?Ke[1].length>rt[1].length:Ke[1].length>rt[0].length||Ke[1].length>3){Pe.splice(z,2,Pe[z]+`
`+Pe[z+1]),z--,ae--;continue}else(!this.options.pedantic||this.options.smartLists?Ke[2][Ke[2].length-1]!==Q[Q.length-1]:le===(Ke[2].length===1))&&(Je=Pe.slice(z+1).join(`
`),ke.raw=ke.raw.substring(0,ke.raw.length-Je.length),z=ae-1);rt=Ke}Ze=We.length,We=We.replace(/^ *([*+-]|\d+[.)]) ?/,""),~We.indexOf(`
 `)&&(Ze-=We.length,We=this.options.pedantic?We.replace(/^ {1,4}/gm,""):We.replace(new RegExp("^ {1,"+Ze+"}","gm"),"")),ft=Ue||/\n\n(?!\s*$)/.test(We),z!==ae-1&&(Ue=We.charAt(We.length-1)===`
`,ft||(ft=Ue)),ft&&(ke.loose=!0),this.options.gfm&&(ve=/^\[[ xX]\] /.test(We),ye=void 0,ve&&(ye=We[1]!==" ",We=We.replace(/^\[[ xX]\] +/,""))),ke.items.push({type:"list_item",raw:O,task:ve,checked:ye,loose:ft,text:We})}return ke}},be.html=function(se){var de=this.rules.block.html.exec(se);if(de)return{type:this.options.sanitize?"paragraph":"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):Y(de[0]):de[0]}},be.def=function(se){var de=this.rules.block.def.exec(se);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var O=de[1].toLowerCase().replace(/\s+/g," ");return{tag:O,raw:de[0],href:de[2],title:de[3]}}},be.table=function(se){var de=this.rules.block.table.exec(se);if(de){var O={type:"table",header:fe(de[1].replace(/^ *| *\| *$/g,"")),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(O.header.length===O.align.length){O.raw=de[0];var Q=O.align.length,le;for(le=0;le<Q;le++)/^ *-+: *$/.test(O.align[le])?O.align[le]="right":/^ *:-+: *$/.test(O.align[le])?O.align[le]="center":/^ *:-+ *$/.test(O.align[le])?O.align[le]="left":O.align[le]=null;for(Q=O.cells.length,le=0;le<Q;le++)O.cells[le]=fe(O.cells[le].replace(/^ *\| *| *\| *$/g,""),O.header.length);return O}}},be.lheading=function(se){var de=this.rules.block.lheading.exec(se);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1]}},be.paragraph=function(se){var de=this.rules.block.paragraph.exec(se);if(de)return{type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1]}},be.text=function(se){var de=this.rules.block.text.exec(se);if(de)return{type:"text",raw:de[0],text:de[0]}},be.escape=function(se){var de=this.rules.inline.escape.exec(se);if(de)return{type:"escape",raw:de[0],text:Y(de[1])}},be.tag=function(se,de,O){var Q=this.rules.inline.tag.exec(se);if(Q)return!de&&/^<a /i.test(Q[0])?de=!0:de&&/^<\/a>/i.test(Q[0])&&(de=!1),!O&&/^<(pre|code|kbd|script)(\s|>)/i.test(Q[0])?O=!0:O&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Q[0])&&(O=!1),{type:this.options.sanitize?"text":"html",raw:Q[0],inLink:de,inRawBlock:O,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):Y(Q[0]):Q[0]}},be.link=function(se){var de=this.rules.inline.link.exec(se);if(de){var O=de[2].trim();if(!this.options.pedantic&&/^</.test(O)){if(!/>$/.test(O))return;var Q=ue(O.slice(0,-1),"\\");if((O.length-Q.length)%2==0)return}else{var le=j(de[2],"()");if(le>-1){var ke=de[0].indexOf("!")===0?5:4,Pe=ke+de[1].length+le;de[2]=de[2].substring(0,le),de[0]=de[0].substring(0,Pe).trim(),de[3]=""}}var Ue=de[2],We="";if(this.options.pedantic){var Ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ue);Ze&&(Ue=Ze[1],We=Ze[3])}else We=de[3]?de[3].slice(1,-1):"";return Ue=Ue.trim(),/^</.test(Ue)&&(this.options.pedantic&&!/>$/.test(O)?Ue=Ue.slice(1):Ue=Ue.slice(1,-1)),Z(de,{href:Ue&&Ue.replace(this.rules.inline._escapes,"$1"),title:We&&We.replace(this.rules.inline._escapes,"$1")},de[0])}},be.reflink=function(se,de){var O;if((O=this.rules.inline.reflink.exec(se))||(O=this.rules.inline.nolink.exec(se))){var Q=(O[2]||O[1]).replace(/\s+/g," ");if(Q=de[Q.toLowerCase()],!Q||!Q.href){var le=O[0].charAt(0);return{type:"text",raw:le,text:le}}return Z(O,Q,O[0])}},be.emStrong=function(se,de,O){O===void 0&&(O="");var Q=this.rules.inline.emStrong.lDelim.exec(se);if(!!Q&&!(Q[3]&&O.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var le=Q[1]||Q[2]||"";if(!le||le&&(O===""||this.rules.inline.punctuation.exec(O))){var ke=Q[0].length-1,Pe,Ue,We=ke,Ze=0,rt=Q[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,de=de.slice(-1*se.length+ke);(Q=rt.exec(de))!=null;)if(Pe=Q[1]||Q[2]||Q[3]||Q[4]||Q[5]||Q[6],!!Pe){if(Ue=Pe.length,Q[3]||Q[4]){We+=Ue;continue}else if((Q[5]||Q[6])&&ke%3&&!((ke+Ue)%3)){Ze+=Ue;continue}if(We-=Ue,!(We>0)){if(We+Ze-Ue<=0&&!de.slice(rt.lastIndex).match(rt)&&(Ue=Math.min(Ue,Ue+We+Ze)),Math.min(ke,Ue)%2)return{type:"em",raw:se.slice(0,ke+Q.index+Ue+1),text:se.slice(1,ke+Q.index+Ue)};if(Math.min(ke,Ue)%2==0)return{type:"strong",raw:se.slice(0,ke+Q.index+Ue+1),text:se.slice(2,ke+Q.index+Ue-1)}}}}}},be.codespan=function(se){var de=this.rules.inline.code.exec(se);if(de){var O=de[2].replace(/\n/g," "),Q=/[^ ]/.test(O),le=/^ /.test(O)&&/ $/.test(O);return Q&&le&&(O=O.substring(1,O.length-1)),O=Y(O,!0),{type:"codespan",raw:de[0],text:O}}},be.br=function(se){var de=this.rules.inline.br.exec(se);if(de)return{type:"br",raw:de[0]}},be.del=function(se){var de=this.rules.inline.del.exec(se);if(de)return{type:"del",raw:de[0],text:de[2]}},be.autolink=function(se,de){var O=this.rules.inline.autolink.exec(se);if(O){var Q,le;return O[2]==="@"?(Q=Y(this.options.mangle?de(O[1]):O[1]),le="mailto:"+Q):(Q=Y(O[1]),le=Q),{type:"link",raw:O[0],text:Q,href:le,tokens:[{type:"text",raw:Q,text:Q}]}}},be.url=function(se,de){var O;if(O=this.rules.inline.url.exec(se)){var Q,le;if(O[2]==="@")Q=Y(this.options.mangle?de(O[0]):O[0]),le="mailto:"+Q;else{var ke;do ke=O[0],O[0]=this.rules.inline._backpedal.exec(O[0])[0];while(ke!==O[0]);Q=Y(O[0]),O[1]==="www."?le="http://"+Q:le=Q}return{type:"link",raw:O[0],text:Q,href:le,tokens:[{type:"text",raw:Q,text:Q}]}}},be.inlineText=function(se,de,O){var Q=this.rules.inline.text.exec(se);if(Q){var le;return de?le=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):Y(Q[0]):Q[0]:le=Y(this.options.smartypants?O(Q[0]):Q[0]),{type:"text",raw:Q[0],text:le}}},Ee}(),N=M.noopTest,W=M.edit,U=M.merge,B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:N,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=W(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,B.item=W(B.item,"gm").replace(/bull/g,B.bullet).getRegex(),B.listItemStart=W(/^( *)(bull)/).replace("bull",B.bullet).getRegex(),B.list=W(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=W(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=W(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.blockquote=W(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=U({},B),B.gfm=U({},B.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.nptable=W(B.gfm.nptable).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.gfm.table=W(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.pedantic=U({},B.normal,{html:W(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:W(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var J={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};J._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",J.punctuation=W(J.punctuation).replace(/punctuation/g,J._punctuation).getRegex(),J.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,J.escapedEmSt=/\\\*|\\_/g,J._comment=W(B._comment).replace("(?:-->|$)","-->").getRegex(),J.emStrong.lDelim=W(J.emStrong.lDelim).replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimAst=W(J.emStrong.rDelimAst,"g").replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimUnd=W(J.emStrong.rDelimUnd,"g").replace(/punct/g,J._punctuation).getRegex(),J._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,J._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,J._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,J.autolink=W(J.autolink).replace("scheme",J._scheme).replace("email",J._email).getRegex(),J._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,J.tag=W(J.tag).replace("comment",J._comment).replace("attribute",J._attribute).getRegex(),J._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,J._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,J._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,J.link=W(J.link).replace("label",J._label).replace("href",J._href).replace("title",J._title).getRegex(),J.reflink=W(J.reflink).replace("label",J._label).getRegex(),J.reflinkSearch=W(J.reflinkSearch,"g").replace("reflink",J.reflink).replace("nolink",J.nolink).getRegex(),J.normal=U({},J),J.pedantic=U({},J.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:W(/^!?\[(label)\]\((.*?)\)/).replace("label",J._label).getRegex(),reflink:W(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",J._label).getRegex()}),J.gfm=U({},J.normal,{escape:W(J.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),J.gfm.url=W(J.gfm.url,"i").replace("email",J.gfm._extended_email).getRegex(),J.breaks=U({},J.gfm,{br:W(J.br).replace("{2,}","*").getRegex(),text:W(J.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var he={block:B,inline:J},De=k.defaults,Oe=he.block,Me=he.inline,He=M.repeatString;function Ye(Ee){return Ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function qe(Ee){var be="",Ce,se,de=Ee.length;for(Ce=0;Ce<de;Ce++)se=Ee.charCodeAt(Ce),Math.random()>.5&&(se="x"+se.toString(16)),be+="&#"+se+";";return be}var Xe=function(){function Ee(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||De,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var se={block:Oe.normal,inline:Me.normal};this.options.pedantic?(se.block=Oe.pedantic,se.inline=Me.pedantic):this.options.gfm&&(se.block=Oe.gfm,this.options.breaks?se.inline=Me.breaks:se.inline=Me.gfm),this.tokenizer.rules=se}Ee.lex=function(se,de){var O=new Ee(de);return O.lex(se)},Ee.lexInline=function(se,de){var O=new Ee(de);return O.inlineTokens(se)};var be=Ee.prototype;return be.lex=function(se){return se=se.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(se,this.tokens,!0),this.inline(this.tokens),this.tokens},be.blockTokens=function(se,de,O){de===void 0&&(de=[]),O===void 0&&(O=!0),this.options.pedantic&&(se=se.replace(/^ +$/gm,""));for(var Q,le,ke,Pe;se;){if(Q=this.tokenizer.space(se)){se=se.substring(Q.raw.length),Q.type&&de.push(Q);continue}if(Q=this.tokenizer.code(se)){se=se.substring(Q.raw.length),Pe=de[de.length-1],Pe&&Pe.type==="paragraph"?(Pe.raw+=`
`+Q.raw,Pe.text+=`
`+Q.text):de.push(Q);continue}if(Q=this.tokenizer.fences(se)){se=se.substring(Q.raw.length),de.push(Q);continue}if(Q=this.tokenizer.heading(se)){se=se.substring(Q.raw.length),de.push(Q);continue}if(Q=this.tokenizer.nptable(se)){se=se.substring(Q.raw.length),de.push(Q);continue}if(Q=this.tokenizer.hr(se)){se=se.substring(Q.raw.length),de.push(Q);continue}if(Q=this.tokenizer.blockquote(se)){se=se.substring(Q.raw.length),Q.tokens=this.blockTokens(Q.text,[],O),de.push(Q);continue}if(Q=this.tokenizer.list(se)){for(se=se.substring(Q.raw.length),ke=Q.items.length,le=0;le<ke;le++)Q.items[le].tokens=this.blockTokens(Q.items[le].text,[],!1);de.push(Q);continue}if(Q=this.tokenizer.html(se)){se=se.substring(Q.raw.length),de.push(Q);continue}if(O&&(Q=this.tokenizer.def(se))){se=se.substring(Q.raw.length),this.tokens.links[Q.tag]||(this.tokens.links[Q.tag]={href:Q.href,title:Q.title});continue}if(Q=this.tokenizer.table(se)){se=se.substring(Q.raw.length),de.push(Q);continue}if(Q=this.tokenizer.lheading(se)){se=se.substring(Q.raw.length),de.push(Q);continue}if(O&&(Q=this.tokenizer.paragraph(se))){se=se.substring(Q.raw.length),de.push(Q);continue}if(Q=this.tokenizer.text(se)){se=se.substring(Q.raw.length),Pe=de[de.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+Q.raw,Pe.text+=`
`+Q.text):de.push(Q);continue}if(se){var Ue="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Ue);break}else throw new Error(Ue)}}return de},be.inline=function(se){var de,O,Q,le,ke,Pe,Ue=se.length;for(de=0;de<Ue;de++)switch(Pe=se[de],Pe.type){case"paragraph":case"text":case"heading":{Pe.tokens=[],this.inlineTokens(Pe.text,Pe.tokens);break}case"table":{for(Pe.tokens={header:[],cells:[]},le=Pe.header.length,O=0;O<le;O++)Pe.tokens.header[O]=[],this.inlineTokens(Pe.header[O],Pe.tokens.header[O]);for(le=Pe.cells.length,O=0;O<le;O++)for(ke=Pe.cells[O],Pe.tokens.cells[O]=[],Q=0;Q<ke.length;Q++)Pe.tokens.cells[O][Q]=[],this.inlineTokens(ke[Q],Pe.tokens.cells[O][Q]);break}case"blockquote":{this.inline(Pe.tokens);break}case"list":{for(le=Pe.items.length,O=0;O<le;O++)this.inline(Pe.items[O].tokens);break}}return se},be.inlineTokens=function(se,de,O,Q){de===void 0&&(de=[]),O===void 0&&(O=!1),Q===void 0&&(Q=!1);var le,ke,Pe=se,Ue,We,Ze;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Ue=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)rt.includes(Ue[0].slice(Ue[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Ue.index)+"["+He("a",Ue[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ue=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Ue.index)+"["+He("a",Ue[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ue=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Ue.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;){if(We||(Ze=""),We=!1,le=this.tokenizer.escape(se)){se=se.substring(le.raw.length),de.push(le);continue}if(le=this.tokenizer.tag(se,O,Q)){se=se.substring(le.raw.length),O=le.inLink,Q=le.inRawBlock;var Ke=de[de.length-1];Ke&&le.type==="text"&&Ke.type==="text"?(Ke.raw+=le.raw,Ke.text+=le.text):de.push(le);continue}if(le=this.tokenizer.link(se)){se=se.substring(le.raw.length),le.type==="link"&&(le.tokens=this.inlineTokens(le.text,[],!0,Q)),de.push(le);continue}if(le=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(le.raw.length);var Je=de[de.length-1];le.type==="link"?(le.tokens=this.inlineTokens(le.text,[],!0,Q),de.push(le)):Je&&le.type==="text"&&Je.type==="text"?(Je.raw+=le.raw,Je.text+=le.text):de.push(le);continue}if(le=this.tokenizer.emStrong(se,Pe,Ze)){se=se.substring(le.raw.length),le.tokens=this.inlineTokens(le.text,[],O,Q),de.push(le);continue}if(le=this.tokenizer.codespan(se)){se=se.substring(le.raw.length),de.push(le);continue}if(le=this.tokenizer.br(se)){se=se.substring(le.raw.length),de.push(le);continue}if(le=this.tokenizer.del(se)){se=se.substring(le.raw.length),le.tokens=this.inlineTokens(le.text,[],O,Q),de.push(le);continue}if(le=this.tokenizer.autolink(se,qe)){se=se.substring(le.raw.length),de.push(le);continue}if(!O&&(le=this.tokenizer.url(se,qe))){se=se.substring(le.raw.length),de.push(le);continue}if(le=this.tokenizer.inlineText(se,Q,Ye)){se=se.substring(le.raw.length),le.raw.slice(-1)!=="_"&&(Ze=le.raw.slice(-1)),We=!0,ke=de[de.length-1],ke&&ke.type==="text"?(ke.raw+=le.raw,ke.text+=le.text):de.push(le);continue}if(se){var ft="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(ft);break}else throw new Error(ft)}}return de},e(Ee,null,[{key:"rules",get:function(){return{block:Oe,inline:Me}}}]),Ee}(),$=k.defaults,G=M.cleanUrl,te=M.escape,re=function(){function Ee(Ce){this.options=Ce||$}var be=Ee.prototype;return be.code=function(se,de,O){var Q=(de||"").match(/\S*/)[0];if(this.options.highlight){var le=this.options.highlight(se,Q);le!=null&&le!==se&&(O=!0,se=le)}return se=se.replace(/\n$/,"")+`
`,Q?'<pre><code class="'+this.options.langPrefix+te(Q,!0)+'">'+(O?se:te(se,!0))+`</code></pre>
`:"<pre><code>"+(O?se:te(se,!0))+`</code></pre>
`},be.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},be.html=function(se){return se},be.heading=function(se,de,O,Q){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+Q.slug(O)+'">'+se+"</h"+de+`>
`:"<h"+de+">"+se+"</h"+de+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(se,de,O){var Q=de?"ol":"ul",le=de&&O!==1?' start="'+O+'"':"";return"<"+Q+le+`>
`+se+"</"+Q+`>
`},be.listitem=function(se){return"<li>"+se+`</li>
`},be.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(se){return"<p>"+se+`</p>
`},be.table=function(se,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+de+`</table>
`},be.tablerow=function(se){return`<tr>
`+se+`</tr>
`},be.tablecell=function(se,de){var O=de.header?"th":"td",Q=de.align?"<"+O+' align="'+de.align+'">':"<"+O+">";return Q+se+"</"+O+`>
`},be.strong=function(se){return"<strong>"+se+"</strong>"},be.em=function(se){return"<em>"+se+"</em>"},be.codespan=function(se){return"<code>"+se+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(se){return"<del>"+se+"</del>"},be.link=function(se,de,O){if(se=G(this.options.sanitize,this.options.baseUrl,se),se===null)return O;var Q='<a href="'+te(se)+'"';return de&&(Q+=' title="'+de+'"'),Q+=">"+O+"</a>",Q},be.image=function(se,de,O){if(se=G(this.options.sanitize,this.options.baseUrl,se),se===null)return O;var Q='<img src="'+se+'" alt="'+O+'"';return de&&(Q+=' title="'+de+'"'),Q+=this.options.xhtml?"/>":">",Q},be.text=function(se){return se},Ee}(),K=function(){function Ee(){}var be=Ee.prototype;return be.strong=function(se){return se},be.em=function(se){return se},be.codespan=function(se){return se},be.del=function(se){return se},be.html=function(se){return se},be.text=function(se){return se},be.link=function(se,de,O){return""+O},be.image=function(se,de,O){return""+O},be.br=function(){return""},Ee}(),oe=function(){function Ee(){this.seen={}}var be=Ee.prototype;return be.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(se,de){var O=se,Q=0;if(this.seen.hasOwnProperty(O)){Q=this.seen[se];do Q++,O=se+"-"+Q;while(this.seen.hasOwnProperty(O))}return de||(this.seen[se]=Q,this.seen[O]=0),O},be.slug=function(se,de){de===void 0&&(de={});var O=this.serialize(se);return this.getNextSafeSlug(O,de.dryrun)},Ee}(),me=k.defaults,Ae=M.unescape,$e=function(){function Ee(Ce){this.options=Ce||me,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new K,this.slugger=new oe}Ee.parse=function(se,de){var O=new Ee(de);return O.parse(se)},Ee.parseInline=function(se,de){var O=new Ee(de);return O.parseInline(se)};var be=Ee.prototype;return be.parse=function(se,de){de===void 0&&(de=!0);var O="",Q,le,ke,Pe,Ue,We,Ze,rt,Ke,Je,ft,ve,ye,ae,z,xe,Te,Re,it=se.length;for(Q=0;Q<it;Q++)switch(Je=se[Q],Je.type){case"space":continue;case"hr":{O+=this.renderer.hr();continue}case"heading":{O+=this.renderer.heading(this.parseInline(Je.tokens),Je.depth,Ae(this.parseInline(Je.tokens,this.textRenderer)),this.slugger);continue}case"code":{O+=this.renderer.code(Je.text,Je.lang,Je.escaped);continue}case"table":{for(rt="",Ze="",Pe=Je.header.length,le=0;le<Pe;le++)Ze+=this.renderer.tablecell(this.parseInline(Je.tokens.header[le]),{header:!0,align:Je.align[le]});for(rt+=this.renderer.tablerow(Ze),Ke="",Pe=Je.cells.length,le=0;le<Pe;le++){for(We=Je.tokens.cells[le],Ze="",Ue=We.length,ke=0;ke<Ue;ke++)Ze+=this.renderer.tablecell(this.parseInline(We[ke]),{header:!1,align:Je.align[ke]});Ke+=this.renderer.tablerow(Ze)}O+=this.renderer.table(rt,Ke);continue}case"blockquote":{Ke=this.parse(Je.tokens),O+=this.renderer.blockquote(Ke);continue}case"list":{for(ft=Je.ordered,ve=Je.start,ye=Je.loose,Pe=Je.items.length,Ke="",le=0;le<Pe;le++)z=Je.items[le],xe=z.checked,Te=z.task,ae="",z.task&&(Re=this.renderer.checkbox(xe),ye?z.tokens.length>0&&z.tokens[0].type==="text"?(z.tokens[0].text=Re+" "+z.tokens[0].text,z.tokens[0].tokens&&z.tokens[0].tokens.length>0&&z.tokens[0].tokens[0].type==="text"&&(z.tokens[0].tokens[0].text=Re+" "+z.tokens[0].tokens[0].text)):z.tokens.unshift({type:"text",text:Re}):ae+=Re),ae+=this.parse(z.tokens,ye),Ke+=this.renderer.listitem(ae,Te,xe);O+=this.renderer.list(Ke,ft,ve);continue}case"html":{O+=this.renderer.html(Je.text);continue}case"paragraph":{O+=this.renderer.paragraph(this.parseInline(Je.tokens));continue}case"text":{for(Ke=Je.tokens?this.parseInline(Je.tokens):Je.text;Q+1<it&&se[Q+1].type==="text";)Je=se[++Q],Ke+=`
`+(Je.tokens?this.parseInline(Je.tokens):Je.text);O+=de?this.renderer.paragraph(Ke):Ke;continue}default:{var ot='Token with "'+Je.type+'" type was not found.';if(this.options.silent){console.error(ot);return}else throw new Error(ot)}}return O},be.parseInline=function(se,de){de=de||this.renderer;var O="",Q,le,ke=se.length;for(Q=0;Q<ke;Q++)switch(le=se[Q],le.type){case"escape":{O+=de.text(le.text);break}case"html":{O+=de.html(le.text);break}case"link":{O+=de.link(le.href,le.title,this.parseInline(le.tokens,de));break}case"image":{O+=de.image(le.href,le.title,le.text);break}case"strong":{O+=de.strong(this.parseInline(le.tokens,de));break}case"em":{O+=de.em(this.parseInline(le.tokens,de));break}case"codespan":{O+=de.codespan(le.text);break}case"br":{O+=de.br();break}case"del":{O+=de.del(this.parseInline(le.tokens,de));break}case"text":{O+=de.text(le.text);break}default:{var Pe='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}return O},Ee}(),pe=M.merge,Ge=M.checkSanitizeDeprecation,V=M.escape,ie=k.getDefaults,ge=k.changeDefaults,Fe=k.defaults;function Ne(Ee,be,Ce){if(typeof Ee=="undefined"||Ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");if(typeof be=="function"&&(Ce=be,be=null),be=pe({},Ne.defaults,be||{}),Ge(be),Ce){var se=be.highlight,de;try{de=Xe.lex(Ee,be)}catch(ke){return Ce(ke)}var O=function(Pe){var Ue;if(!Pe)try{Ue=$e.parse(de,be)}catch(We){Pe=We}return be.highlight=se,Pe?Ce(Pe):Ce(null,Ue)};if(!se||se.length<3||(delete be.highlight,!de.length))return O();var Q=0;Ne.walkTokens(de,function(ke){ke.type==="code"&&(Q++,setTimeout(function(){se(ke.text,ke.lang,function(Pe,Ue){if(Pe)return O(Pe);Ue!=null&&Ue!==ke.text&&(ke.text=Ue,ke.escaped=!0),Q--,Q===0&&O()})},0))}),Q===0&&O();return}try{var le=Xe.lex(Ee,be);return be.walkTokens&&Ne.walkTokens(le,be.walkTokens),$e.parse(le,be)}catch(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+V(ke.message+"",!0)+"</pre>";throw ke}}Ne.options=Ne.setOptions=function(Ee){return pe(Ne.defaults,Ee),ge(Ne.defaults),Ne},Ne.getDefaults=ie,Ne.defaults=Fe,Ne.use=function(Ee){var be=pe({},Ee);if(Ee.renderer&&function(){var se=Ne.defaults.renderer||new re,de=function(le){var ke=se[le];se[le]=function(){for(var Pe=arguments.length,Ue=new Array(Pe),We=0;We<Pe;We++)Ue[We]=arguments[We];var Ze=Ee.renderer[le].apply(se,Ue);return Ze===!1&&(Ze=ke.apply(se,Ue)),Ze}};for(var O in Ee.renderer)de(O);be.renderer=se}(),Ee.tokenizer&&function(){var se=Ne.defaults.tokenizer||new q,de=function(le){var ke=se[le];se[le]=function(){for(var Pe=arguments.length,Ue=new Array(Pe),We=0;We<Pe;We++)Ue[We]=arguments[We];var Ze=Ee.tokenizer[le].apply(se,Ue);return Ze===!1&&(Ze=ke.apply(se,Ue)),Ze}};for(var O in Ee.tokenizer)de(O);be.tokenizer=se}(),Ee.walkTokens){var Ce=Ne.defaults.walkTokens;be.walkTokens=function(se){Ee.walkTokens(se),Ce&&Ce(se)}}Ne.setOptions(be)},Ne.walkTokens=function(Ee,be){for(var Ce=S(Ee),se;!(se=Ce()).done;){var de=se.value;switch(be(de),de.type){case"table":{for(var O=S(de.tokens.header),Q;!(Q=O()).done;){var le=Q.value;Ne.walkTokens(le,be)}for(var ke=S(de.tokens.cells),Pe;!(Pe=ke()).done;)for(var Ue=Pe.value,We=S(Ue),Ze;!(Ze=We()).done;){var rt=Ze.value;Ne.walkTokens(rt,be)}break}case"list":{Ne.walkTokens(de.items,be);break}default:de.tokens&&Ne.walkTokens(de.tokens,be)}}},Ne.parseInline=function(Ee,be){if(typeof Ee=="undefined"||Ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");be=pe({},Ne.defaults,be||{}),Ge(be);try{var Ce=Xe.lexInline(Ee,be);return be.walkTokens&&Ne.walkTokens(Ce,be.walkTokens),$e.parseInline(Ce,be)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+V(se.message+"",!0)+"</pre>";throw se}},Ne.Parser=$e,Ne.parser=$e.parse,Ne.Renderer=re,Ne.TextRenderer=K,Ne.Lexer=Xe,Ne.lexer=Xe.lex,Ne.Tokenizer=q,Ne.Slugger=oe,Ne.parse=Ne;var Qe=Ne;return Qe}),define(we[77],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(k,D,_){return Math.min(Math.max(k,D),_)}e.clamp=g;function T(k,D){return(D+k%D)%D}e.rot=T;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class E{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=E}),function(){function ee(S){const E=[];typeof S=="number"&&E.push("code/timeOrigin",S);function k(_){E.push(_,Date.now())}function D(){const _=[];for(let C=0;C<E.length;C+=2)_.push({name:E[C],startTime:E[C+1]});return _}return{mark:k,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const E=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const k of performance.getEntriesByType("mark"))E.push({name:k.name,startTime:Math.round(S+k.startTime)});return E}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function g(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=g(T))}(),define(we[21],_e([0,1]),function(ee,e){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const T="en";let S=!1,E=!1,k=!1,D=!1,_=!1,C=!1,i=!1,I,o=T,f,c;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const y=typeof((g=d==null?void 0:d.versions)===null||g===void 0?void 0:g.electron)=="string"&&d.type==="renderer";if(e.isElectronSandboxed=y&&(d==null?void 0:d.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=d==null?void 0:d.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!y)c=navigator.userAgent,S=c.indexOf("Windows")>=0,E=c.indexOf("Macintosh")>=0,i=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=c.indexOf("Linux")>=0,C=!0,I=navigator.language,o=I;else if(typeof d=="object"){S=d.platform==="win32",E=d.platform==="darwin",k=d.platform==="linux",D=k&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,I=T,o=T;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const u=JSON.parse(r),b=u.availableLanguages["*"];I=u.locale,o=b||T,f=u._translationsConfigFile}catch(u){}_=!0}else console.error("Unable to resolve platform.");var w;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function v(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=v;let l=0;E?l=1:S?l=3:k&&(l=2),e.isWindows=S,e.isMacintosh=E,e.isLinux=k,e.isLinuxSnap=D,e.isNative=_,e.isWeb=C,e.isIOS=i,e.platform=l,e.userAgent=c,e.language=o;var h;(function(r){function u(){return e.language}r.value=u;function b(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=b;function p(){return e.language==="en"}r.isDefault=p})(h=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=f,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let b=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeSetImmediateId)for(let A=0,a=b.length;A<a;A++){const R=b[A];if(R.id===P.data.vscodeSetImmediateId){b.splice(A,1),R.callback();return}}});let p=0;return P=>{const A=++p;b.push({id:A,callback:P}),e.globals.postMessage({vscodeSetImmediateId:A},"*")}}if(typeof(d==null?void 0:d.nextTick)=="function")return d.nextTick.bind(d);const u=Promise.resolve();return b=>u.then(b)}();var m;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(m=e.OperatingSystem||(e.OperatingSystem={})),e.OS=E||i?2:S?1:3;let t=!0,n=!1;function s(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(we[41],_e([0,1,21]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let T;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const S=g.globals.vscode.process;T={get platform(){return S.platform},get env(){return S.env},cwd(){return S.cwd()},nextTick(E){return g.setImmediate(E)}}}else typeof process!="undefined"?T={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(S){return process.nextTick(S)}}:T={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},nextTick(S){return g.setImmediate(S)},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.nextTick=T.nextTick}),define(we[14],_e([0,1,41]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,S=97,E=90,k=122,D=46,_=47,C=92,i=58,I=63;class o extends Error{constructor(h,m,t){let n;typeof m=="string"&&m.indexOf("not ")===0?(n="must not be",m=m.replace(/^not /,"")):n="must be";const s=h.indexOf(".")!==-1?"property":"argument";let r=`The "${h}" ${s} ${n} of type ${m}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function f(l,h){if(typeof l!="string")throw new o(h,"string",l)}function c(l){return l===_||l===C}function d(l){return l===_}function y(l){return l>=T&&l<=E||l>=S&&l<=k}function w(l,h,m,t){let n="",s=0,r=-1,u=0,b=0;for(let p=0;p<=l.length;++p){if(p<l.length)b=l.charCodeAt(p);else{if(t(b))break;b=_}if(t(b)){if(!(r===p-1||u===1))if(u===2){if(n.length<2||s!==2||n.charCodeAt(n.length-1)!==D||n.charCodeAt(n.length-2)!==D){if(n.length>2){const P=n.lastIndexOf(m);P===-1?(n="",s=0):(n=n.slice(0,P),s=n.length-1-n.lastIndexOf(m)),r=p,u=0;continue}else if(n.length!==0){n="",s=0,r=p,u=0;continue}}h&&(n+=n.length>0?`${m}..`:"..",s=2)}else n.length>0?n+=`${m}${l.slice(r+1,p)}`:n=l.slice(r+1,p),s=p-r-1;r=p,u=0}else b===D&&u!==-1?++u:u=-1}return n}function v(l,h){if(h===null||typeof h!="object")throw new o("pathObject","Object",h);const m=h.dir||h.root,t=h.base||`${h.name||""}${h.ext||""}`;return m?m===h.root?`${m}${t}`:`${m}${l}${t}`:t}e.win32={resolve(...l){let h="",m="",t=!1;for(let n=l.length-1;n>=-1;n--){let s;if(n>=0){if(s=l[n],f(s,"path"),s.length===0)continue}else h.length===0?s=g.cwd():(s=g.env[`=${h}`]||g.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==h.toLowerCase()&&s.charCodeAt(2)===C)&&(s=`${h}\\`));const r=s.length;let u=0,b="",p=!1;const P=s.charCodeAt(0);if(r===1)c(P)&&(u=1,p=!0);else if(c(P))if(p=!0,c(s.charCodeAt(1))){let A=2,a=A;for(;A<r&&!c(s.charCodeAt(A));)A++;if(A<r&&A!==a){const R=s.slice(a,A);for(a=A;A<r&&c(s.charCodeAt(A));)A++;if(A<r&&A!==a){for(a=A;A<r&&!c(s.charCodeAt(A));)A++;(A===r||A!==a)&&(b=`\\\\${R}\\${s.slice(a,A)}`,u=A)}}}else u=1;else y(P)&&s.charCodeAt(1)===i&&(b=s.slice(0,2),u=2,r>2&&c(s.charCodeAt(2))&&(p=!0,u=3));if(b.length>0)if(h.length>0){if(b.toLowerCase()!==h.toLowerCase())continue}else h=b;if(t){if(h.length>0)break}else if(m=`${s.slice(u)}\\${m}`,t=p,p&&h.length>0)break}return m=w(m,!t,"\\",c),t?`${h}\\${m}`:`${h}${m}`||"."},normalize(l){f(l,"path");const h=l.length;if(h===0)return".";let m=0,t,n=!1;const s=l.charCodeAt(0);if(h===1)return d(s)?"\\":l;if(c(s))if(n=!0,c(l.charCodeAt(1))){let u=2,b=u;for(;u<h&&!c(l.charCodeAt(u));)u++;if(u<h&&u!==b){const p=l.slice(b,u);for(b=u;u<h&&c(l.charCodeAt(u));)u++;if(u<h&&u!==b){for(b=u;u<h&&!c(l.charCodeAt(u));)u++;if(u===h)return`\\\\${p}\\${l.slice(b)}\\`;u!==b&&(t=`\\\\${p}\\${l.slice(b,u)}`,m=u)}}}else m=1;else y(s)&&l.charCodeAt(1)===i&&(t=l.slice(0,2),m=2,h>2&&c(l.charCodeAt(2))&&(n=!0,m=3));let r=m<h?w(l.slice(m),!n,"\\",c):"";return r.length===0&&!n&&(r="."),r.length>0&&c(l.charCodeAt(h-1))&&(r+="\\"),t===void 0?n?`\\${r}`:r:n?`${t}\\${r}`:`${t}${r}`},isAbsolute(l){f(l,"path");const h=l.length;if(h===0)return!1;const m=l.charCodeAt(0);return c(m)||h>2&&y(m)&&l.charCodeAt(1)===i&&c(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let h,m;for(let s=0;s<l.length;++s){const r=l[s];f(r,"path"),r.length>0&&(h===void 0?h=m=r:h+=`\\${r}`)}if(h===void 0)return".";let t=!0,n=0;if(typeof m=="string"&&c(m.charCodeAt(0))){++n;const s=m.length;s>1&&c(m.charCodeAt(1))&&(++n,s>2&&(c(m.charCodeAt(2))?++n:t=!1))}if(t){for(;n<h.length&&c(h.charCodeAt(n));)n++;n>=2&&(h=`\\${h.slice(n)}`)}return e.win32.normalize(h)},relative(l,h){if(f(l,"from"),f(h,"to"),l===h)return"";const m=e.win32.resolve(l),t=e.win32.resolve(h);if(m===t||(l=m.toLowerCase(),h=t.toLowerCase(),l===h))return"";let n=0;for(;n<l.length&&l.charCodeAt(n)===C;)n++;let s=l.length;for(;s-1>n&&l.charCodeAt(s-1)===C;)s--;const r=s-n;let u=0;for(;u<h.length&&h.charCodeAt(u)===C;)u++;let b=h.length;for(;b-1>u&&h.charCodeAt(b-1)===C;)b--;const p=b-u,P=r<p?r:p;let A=-1,a=0;for(;a<P;a++){const M=l.charCodeAt(n+a);if(M!==h.charCodeAt(u+a))break;M===C&&(A=a)}if(a!==P){if(A===-1)return t}else{if(p>P){if(h.charCodeAt(u+a)===C)return t.slice(u+a+1);if(a===2)return t.slice(u+a)}r>P&&(l.charCodeAt(n+a)===C?A=a:a===2&&(A=3)),A===-1&&(A=0)}let R="";for(a=n+A+1;a<=s;++a)(a===s||l.charCodeAt(a)===C)&&(R+=R.length===0?"..":"\\..");return u+=A,R.length>0?`${R}${t.slice(u,b)}`:(t.charCodeAt(u)===C&&++u,t.slice(u,b))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const h=e.win32.resolve(l);if(h.length<=2)return l;if(h.charCodeAt(0)===C){if(h.charCodeAt(1)===C){const m=h.charCodeAt(2);if(m!==I&&m!==D)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(y(h.charCodeAt(0))&&h.charCodeAt(1)===i&&h.charCodeAt(2)===C)return`\\\\?\\${h}`;return l},dirname(l){f(l,"path");const h=l.length;if(h===0)return".";let m=-1,t=0;const n=l.charCodeAt(0);if(h===1)return c(n)?l:".";if(c(n)){if(m=t=1,c(l.charCodeAt(1))){let u=2,b=u;for(;u<h&&!c(l.charCodeAt(u));)u++;if(u<h&&u!==b){for(b=u;u<h&&c(l.charCodeAt(u));)u++;if(u<h&&u!==b){for(b=u;u<h&&!c(l.charCodeAt(u));)u++;if(u===h)return l;u!==b&&(m=t=u+1)}}}}else y(n)&&l.charCodeAt(1)===i&&(m=h>2&&c(l.charCodeAt(2))?3:2,t=m);let s=-1,r=!0;for(let u=h-1;u>=t;--u)if(c(l.charCodeAt(u))){if(!r){s=u;break}}else r=!1;if(s===-1){if(m===-1)return".";s=m}return l.slice(0,s)},basename(l,h){h!==void 0&&f(h,"ext"),f(l,"path");let m=0,t=-1,n=!0,s;if(l.length>=2&&y(l.charCodeAt(0))&&l.charCodeAt(1)===i&&(m=2),h!==void 0&&h.length>0&&h.length<=l.length){if(h===l)return"";let r=h.length-1,u=-1;for(s=l.length-1;s>=m;--s){const b=l.charCodeAt(s);if(c(b)){if(!n){m=s+1;break}}else u===-1&&(n=!1,u=s+1),r>=0&&(b===h.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=u))}return m===t?t=u:t===-1&&(t=l.length),l.slice(m,t)}for(s=l.length-1;s>=m;--s)if(c(l.charCodeAt(s))){if(!n){m=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":l.slice(m,t)},extname(l){f(l,"path");let h=0,m=-1,t=0,n=-1,s=!0,r=0;l.length>=2&&l.charCodeAt(1)===i&&y(l.charCodeAt(0))&&(h=t=2);for(let u=l.length-1;u>=h;--u){const b=l.charCodeAt(u);if(c(b)){if(!s){t=u+1;break}continue}n===-1&&(s=!1,n=u+1),b===D?m===-1?m=u:r!==1&&(r=1):m!==-1&&(r=-1)}return m===-1||n===-1||r===0||r===1&&m===n-1&&m===t+1?"":l.slice(m,n)},format:v.bind(null,"\\"),parse(l){f(l,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return h;const m=l.length;let t=0,n=l.charCodeAt(0);if(m===1)return c(n)?(h.root=h.dir=l,h):(h.base=h.name=l,h);if(c(n)){if(t=1,c(l.charCodeAt(1))){let A=2,a=A;for(;A<m&&!c(l.charCodeAt(A));)A++;if(A<m&&A!==a){for(a=A;A<m&&c(l.charCodeAt(A));)A++;if(A<m&&A!==a){for(a=A;A<m&&!c(l.charCodeAt(A));)A++;A===m?t=A:A!==a&&(t=A+1)}}}}else if(y(n)&&l.charCodeAt(1)===i){if(m<=2)return h.root=h.dir=l,h;if(t=2,c(l.charCodeAt(2))){if(m===3)return h.root=h.dir=l,h;t=3}}t>0&&(h.root=l.slice(0,t));let s=-1,r=t,u=-1,b=!0,p=l.length-1,P=0;for(;p>=t;--p){if(n=l.charCodeAt(p),c(n)){if(!b){r=p+1;break}continue}u===-1&&(b=!1,u=p+1),n===D?s===-1?s=p:P!==1&&(P=1):s!==-1&&(P=-1)}return u!==-1&&(s===-1||P===0||P===1&&s===u-1&&s===r+1?h.base=h.name=l.slice(r,u):(h.name=l.slice(r,s),h.base=l.slice(r,u),h.ext=l.slice(s,u))),r>0&&r!==t?h.dir=l.slice(0,r-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let h="",m=!1;for(let t=l.length-1;t>=-1&&!m;t--){const n=t>=0?l[t]:g.cwd();f(n,"path"),n.length!==0&&(h=`${n}/${h}`,m=n.charCodeAt(0)===_)}return h=w(h,!m,"/",d),m?`/${h}`:h.length>0?h:"."},normalize(l){if(f(l,"path"),l.length===0)return".";const h=l.charCodeAt(0)===_,m=l.charCodeAt(l.length-1)===_;return l=w(l,!h,"/",d),l.length===0?h?"/":m?"./":".":(m&&(l+="/"),h?`/${l}`:l)},isAbsolute(l){return f(l,"path"),l.length>0&&l.charCodeAt(0)===_},join(...l){if(l.length===0)return".";let h;for(let m=0;m<l.length;++m){const t=l[m];f(t,"path"),t.length>0&&(h===void 0?h=t:h+=`/${t}`)}return h===void 0?".":e.posix.normalize(h)},relative(l,h){if(f(l,"from"),f(h,"to"),l===h||(l=e.posix.resolve(l),h=e.posix.resolve(h),l===h))return"";const m=1,t=l.length,n=t-m,s=1,r=h.length-s,u=n<r?n:r;let b=-1,p=0;for(;p<u;p++){const A=l.charCodeAt(m+p);if(A!==h.charCodeAt(s+p))break;A===_&&(b=p)}if(p===u)if(r>u){if(h.charCodeAt(s+p)===_)return h.slice(s+p+1);if(p===0)return h.slice(s+p)}else n>u&&(l.charCodeAt(m+p)===_?b=p:p===0&&(b=0));let P="";for(p=m+b+1;p<=t;++p)(p===t||l.charCodeAt(p)===_)&&(P+=P.length===0?"..":"/..");return`${P}${h.slice(s+b)}`},toNamespacedPath(l){return l},dirname(l){if(f(l,"path"),l.length===0)return".";const h=l.charCodeAt(0)===_;let m=-1,t=!0;for(let n=l.length-1;n>=1;--n)if(l.charCodeAt(n)===_){if(!t){m=n;break}}else t=!1;return m===-1?h?"/":".":h&&m===1?"//":l.slice(0,m)},basename(l,h){h!==void 0&&f(h,"ext"),f(l,"path");let m=0,t=-1,n=!0,s;if(h!==void 0&&h.length>0&&h.length<=l.length){if(h===l)return"";let r=h.length-1,u=-1;for(s=l.length-1;s>=0;--s){const b=l.charCodeAt(s);if(b===_){if(!n){m=s+1;break}}else u===-1&&(n=!1,u=s+1),r>=0&&(b===h.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=u))}return m===t?t=u:t===-1&&(t=l.length),l.slice(m,t)}for(s=l.length-1;s>=0;--s)if(l.charCodeAt(s)===_){if(!n){m=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":l.slice(m,t)},extname(l){f(l,"path");let h=-1,m=0,t=-1,n=!0,s=0;for(let r=l.length-1;r>=0;--r){const u=l.charCodeAt(r);if(u===_){if(!n){m=r+1;break}continue}t===-1&&(n=!1,t=r+1),u===D?h===-1?h=r:s!==1&&(s=1):h!==-1&&(s=-1)}return h===-1||t===-1||s===0||s===1&&h===t-1&&h===m+1?"":l.slice(h,t)},format:v.bind(null,"/"),parse(l){f(l,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return h;const m=l.charCodeAt(0)===_;let t;m?(h.root="/",t=1):t=0;let n=-1,s=0,r=-1,u=!0,b=l.length-1,p=0;for(;b>=t;--b){const P=l.charCodeAt(b);if(P===_){if(!u){s=b+1;break}continue}r===-1&&(u=!1,r=b+1),P===D?n===-1?n=b:p!==1&&(p=1):n!==-1&&(p=-1)}if(r!==-1){const P=s===0&&m?1:s;n===-1||p===0||p===1&&n===r-1&&n===s+1?h.base=h.name=l.slice(P,r):(h.name=l.slice(P,n),h.base=l.slice(P,r),h.ext=l.slice(n,r))}return s>0?h.dir=l.slice(0,s-1):m&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[52],_e([0,1,21]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const T=g.globals.performance&&typeof g.globals.performance.now=="function";class S{constructor(k){this._highResolution=T&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new S(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=S}),define(we[3],_e([0,1,11,49,7,51,52]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(v){v.None=()=>S.Disposable.None;function l(fe){return(Y,j=null,Z)=>{let L=!1,q;return q=fe(N=>{if(!L)return q?q.dispose():L=!0,Y.call(j,N)},null,Z),L&&q.dispose(),q}}v.once=l;function h(fe,Y){return u((j,Z=null,L)=>fe(q=>j.call(Z,Y(q)),null,L))}v.map=h;function m(fe,Y){return u((j,Z=null,L)=>fe(q=>{Y(q),j.call(Z,q)},null,L))}v.forEach=m;function t(fe,Y){return u((j,Z=null,L)=>fe(q=>Y(q)&&j.call(Z,q),null,L))}v.filter=t;function n(fe){return fe}v.signal=n;function s(...fe){return(Y,j=null,Z)=>S.combinedDisposable(...fe.map(L=>L(q=>Y.call(j,q),null,Z)))}v.any=s;function r(fe,Y,j){let Z=j;return h(fe,L=>(Z=Y(Z,L),Z))}v.reduce=r;function u(fe){let Y;const j=new o({onFirstListenerAdd(){Y=fe(j.fire,j)},onLastListenerRemove(){Y.dispose()}});return j.event}function b(fe,Y,j=100,Z=!1,L){let q,N,W,U=0;const B=new o({leakWarningThreshold:L,onFirstListenerAdd(){q=fe(J=>{U++,N=Y(N,J),Z&&!W&&(B.fire(N),N=void 0),clearTimeout(W),W=setTimeout(()=>{const he=N;N=void 0,W=void 0,(!Z||U>1)&&B.fire(he),U=0},j)})},onLastListenerRemove(){q.dispose()}});return B.event}v.debounce=b;function p(fe,Y=(j,Z)=>j===Z){let j=!0,Z;return t(fe,L=>{const q=j||!Y(L,Z);return j=!1,Z=L,q})}v.latch=p;function P(fe,Y){return[v.filter(fe,Y),v.filter(fe,j=>!Y(j))]}v.split=P;function A(fe,Y=!1,j=[]){let Z=j.slice(),L=fe(W=>{Z?Z.push(W):N.fire(W)});const q=()=>{Z&&Z.forEach(W=>N.fire(W)),Z=null},N=new o({onFirstListenerAdd(){L||(L=fe(W=>N.fire(W)))},onFirstListenerDidAdd(){Z&&(Y?setTimeout(q):q())},onLastListenerRemove(){L&&L.dispose(),L=null}});return N.event}v.buffer=A;class a{constructor(Y){this.event=Y}map(Y){return new a(h(this.event,Y))}forEach(Y){return new a(m(this.event,Y))}filter(Y){return new a(t(this.event,Y))}reduce(Y,j){return new a(r(this.event,Y,j))}latch(){return new a(p(this.event))}debounce(Y,j=100,Z=!1,L){return new a(b(this.event,Y,j,Z,L))}on(Y,j,Z){return this.event(Y,j,Z)}once(Y,j,Z){return l(this.event)(Y,j,Z)}}function R(fe){return new a(fe)}v.chain=R;function M(fe,Y,j=Z=>Z){const Z=(...W)=>N.fire(j(...W)),L=()=>fe.on(Y,Z),q=()=>fe.removeListener(Y,Z),N=new o({onFirstListenerAdd:L,onLastListenerRemove:q});return N.event}v.fromNodeEventEmitter=M;function H(fe,Y,j=Z=>Z){const Z=(...W)=>N.fire(j(...W)),L=()=>fe.addEventListener(Y,Z),q=()=>fe.removeEventListener(Y,Z),N=new o({onFirstListenerAdd:L,onLastListenerRemove:q});return N.event}v.fromDOMEventEmitter=H;function ue(fe){return new Promise(Y=>l(fe)(Y))}v.toPromise=ue})(D=e.Event||(e.Event={}));class _{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${_._idPool++}`}start(l){this._stopWatch=new k.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let C=-1;function i(v){const l=C;return C=v,{dispose(){C=l}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(l,h=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=h,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let h=C;if(typeof this.customThreshold=="number"&&(h=this.customThreshold),h<=0||l<h)return;this._stacks||(this._stacks=new Map);const m=new Error().stack.split(`
`).slice(3).join(`
`),t=this._stacks.get(m)||0;if(this._stacks.set(m,t+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=h*.5;let n,s=0;for(const[r,u]of this._stacks)(!n||s<u)&&(n=r,s=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${s}):`),console.warn(n)}return()=>{const n=this._stacks.get(m)||0;this._stacks.set(m,n-1)}}}class o{constructor(l){var h;this._disposed=!1,this._options=l,this._leakageMon=C>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((h=this._options)===null||h===void 0?void 0:h._profName)?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(l,h,m)=>{var t;this._listeners||(this._listeners=new E.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(h?[l,h]:l);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,h);const r=(t=this._leakageMon)===null||t===void 0?void 0:t.check(this._listeners.size);let u;return u={dispose:()=>{r&&r(),u.dispose=o._noop,this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},m instanceof S.DisposableStore?m.add(u):Array.isArray(m)&&m.push(u),u}),this._event}fire(l){var h,m;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new E.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,l]);for((h=this._perfMon)===null||h===void 0||h.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,n]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,n):t[0].call(t[1],n)}catch(s){g.onUnexpectedError(s)}}(m=this._perfMon)===null||m===void 0||m.stop()}}dispose(){var l,h,m,t,n;this._disposed||(this._disposed=!0,(l=this._listeners)===null||l===void 0||l.clear(),(h=this._deliveryQueue)===null||h===void 0||h.clear(),(t=(m=this._options)===null||m===void 0?void 0:m.onLastListenerRemove)===null||t===void 0||t.call(m),(n=this._leakageMon)===null||n===void 0||n.dispose())}}e.Emitter=o,o._noop=function(){};class f extends o{constructor(l){super(l);this._isPaused=0,this._eventQueue=new E.LinkedList,this._mergeFn=l==null?void 0:l.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=f;class c extends f{constructor(l){var h;super(l);this._delay=(h=l.delay)!==null&&h!==void 0?h:100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=c;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new o({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const h={event:l,listener:null};this.events.push(h),this.hasListeners&&this.hook(h);const m=()=>{this.hasListeners&&this.unhook(h);const t=this.events.indexOf(h);this.events.splice(t,1)};return S.toDisposable(T.once(m))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(h=>this.emitter.fire(h))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=d;class y{constructor(){this.buffers=[]}wrapEvent(l){return(h,m,t)=>l(n=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>h.call(m,n)):h.call(m,n)},void 0,t)}bufferEvents(l){const h=[];this.buffers.push(h);const m=l();return this.buffers.pop(),h.forEach(t=>t()),m}}e.EventBufferer=y;class w{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=S.Disposable.None,this.emitter=new o({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(we[18],_e([0,1,3]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(D,_){const C=setTimeout(D.bind(_),0);return{dispose(){clearTimeout(C)}}});var S;(function(D){function _(C){return C===D.None||C===D.Cancelled||C instanceof E?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}D.isCancellationToken=_,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(S=e.CancellationToken||(e.CancellationToken={}));class E{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new E),this._token}cancel(){this._token?this._token instanceof E&&this._token.cancel():this._token=S.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof E&&this._token.dispose():this._token=S.None}}e.CancellationTokenSource=k}),define(we[78],_e([0,1,3]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class T{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(I){const o=this._icons.get(I.id);o?I.description?o.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const S=new T;e.iconRegistry=S;function E(i,I){return new D(i,I)}e.registerCodicon=E;function k(i){return i?i.replace(/\$\((.*?)\)/g,(I,o)=>` ${o} `).trim():""}e.getCodiconAriaLabel=k;class D{constructor(I,o,f){this.id=I,this.definition=o,this.description=f,S.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function _(i,I){const o=["codicon","codicon-"+i];return I&&o.push("codicon-modifier-"+I),o}e.getClassNamesArray=_;var C;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function o(d){if(d instanceof D)return["codicon","codicon-"+d.id];const y=I.exec(d.id);if(!y)return o(D.error);let[,w,v]=y;const l=["codicon","codicon-"+w];return v&&l.push("codicon-modifier-"+v.substr(1)),l}i.asClassNameArray=o;function f(d){return o(d).join(" ")}i.asClassName=f;function c(d){return"."+o(d).join(".")}i.asCSSSelector=c})(C=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(we[109],_e([0,1,11,7]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function S(l){const h=l;return h?[h.on,h.pause,h.resume,h.destroy].every(m=>typeof m=="function"):!1}e.isReadableStream=S;function E(l){const h=l;return h?S(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=E;function k(l,h){return new D(l,h)}e.newWriteableStream=k;class D{constructor(h,m){this.reducer=h,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){var m;if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof((m=this.options)===null||m===void 0?void 0:m.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(m=>m(h))}emitError(h){this.listeners.error.length===0?g.onUnexpectedError(h):this.listeners.error.slice(0).forEach(m=>m(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,m){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(h,m){if(this.state.destroyed)return;let t;switch(h){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(m);n>=0&&t.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(l,h){const m=[];let t;for(;(t=l.read())!==null;)m.push(t);return h(m)}e.consumeReadable=_;function C(l,h,m){const t=[];let n;for(;(n=l.read())!==null&&t.length<m;)t.push(n);return n===null&&t.length>0?h(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const s=n;return n=void 0,s}return l.read()}}}e.peekReadable=C;function i(l,h){return new Promise((m,t)=>{const n=[];I(l,{onData:s=>{h&&n.push(s)},onError:s=>{h?t(s):m(void 0)},onEnd:()=>{m(h?h(n):void 0)}})})}e.consumeStream=i;function I(l,h){l.on("error",m=>h.onError(m)),l.on("end",()=>h.onEnd()),l.on("data",m=>h.onData(m))}e.listenStream=I;function o(l,h){return new Promise((m,t)=>{const n=new T.DisposableStore,s=[],r=p=>{if(s.push(p),s.length>h)return n.dispose(),l.pause(),m({stream:l,buffer:s,ended:!1})},u=p=>t(p),b=()=>m({stream:l,buffer:s,ended:!0});n.add(T.toDisposable(()=>l.removeListener("error",u))),l.on("error",u),n.add(T.toDisposable(()=>l.removeListener("end",b))),l.on("end",b),n.add(T.toDisposable(()=>l.removeListener("data",r))),l.on("data",r)})}e.peekStream=o;function f(l,h){const m=k(h);return m.end(l),m}e.toStream=f;function c(){const l=k(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=c;function d(l){let h=!1;return{read:()=>h?null:(h=!0,l)}}e.toReadable=d;function y(l,h,m){const t=k(m);return I(l,{onData:n=>t.write(h.data(n)),onError:n=>t.error(h.error?h.error(n):n),onEnd:()=>t.end()}),t}e.transform=y;function w(l,h,m){let t=!1;return{read:()=>{const n=h.read();return t?n:(t=!0,n!==null?m([l,n]):l)}}}e.prefixedReadable=w;function v(l,h,m){let t=!1;const n=k(m);return I(h,{onData:s=>t?n.write(s):(t=!0,n.write(m([l,s]))),onError:s=>n.error(s),onEnd:()=>{t||(t=!0,n.write(l)),n.end()}}),n}e.prefixedStream=v}),define(we[8],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function g(O){return!O||typeof O!="string"?!0:O.trim().length===0}e.isFalsyOrWhitespace=g;const T=/{(\d+)}/g;function S(O,...Q){return Q.length===0?O:O.replace(T,function(le,ke){const Pe=parseInt(ke,10);return isNaN(Pe)||Pe<0||Pe>=Q.length?le:Q[Pe]})}e.format=S;function E(O){return O.replace(/[<>&]/g,function(Q){switch(Q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Q}})}e.escape=E;function k(O){return O.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function D(O,Q){let le=0;const ke=Q.charCodeAt(0);for(let Pe=O.length-1;Pe>=0;Pe--)O.charCodeAt(Pe)===ke&&le++;return le}e.count=D;function _(O,Q,le="\u2026"){return O.length<=Q?O:`${O.substr(0,Q)}${le}`}e.truncate=_;function C(O,Q=" "){const le=i(O,Q);return I(le,Q)}e.trim=C;function i(O,Q){if(!O||!Q)return O;const le=Q.length;if(le===0||O.length===0)return O;let ke=0;for(;O.indexOf(Q,ke)===ke;)ke=ke+le;return O.substring(ke)}e.ltrim=i;function I(O,Q){if(!O||!Q)return O;const le=Q.length,ke=O.length;if(le===0||ke===0)return O;let Pe=ke,Ue=-1;for(;Ue=O.lastIndexOf(Q,Pe-1),!(Ue===-1||Ue+le!==Pe);){if(Ue===0)return"";Pe=Ue}return O.substring(0,Pe)}e.rtrim=I;function o(O){return O.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=o;function f(O){return O.replace(/\*/g,"")}e.stripWildcards=f;function c(O,Q,le={}){if(!O)throw new Error("Cannot create regex from empty string");Q||(O=k(O)),le.wholeWord&&(/\B/.test(O.charAt(0))||(O="\\b"+O),/\B/.test(O.charAt(O.length-1))||(O=O+"\\b"));let ke="";return le.global&&(ke+="g"),le.matchCase||(ke+="i"),le.multiline&&(ke+="m"),le.unicode&&(ke+="u"),new RegExp(O,ke)}e.createRegExp=c;function d(O){return O.source==="^"||O.source==="^$"||O.source==="$"||O.source==="^\\s*$"?!1:!!(O.exec("")&&O.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function y(O){return!!O.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=y;function w(O){return(O.global?"g":"")+(O.ignoreCase?"i":"")+(O.multiline?"m":"")+(O.unicode?"u":"")}e.regExpFlags=w;function v(O){return O.split(/\r\n|\r|\n/)}e.splitLines=v;function l(O){for(let Q=0,le=O.length;Q<le;Q++){const ke=O.charCodeAt(Q);if(ke!==32&&ke!==9)return Q}return-1}e.firstNonWhitespaceIndex=l;function h(O,Q=0,le=O.length){for(let ke=Q;ke<le;ke++){const Pe=O.charCodeAt(ke);if(Pe!==32&&Pe!==9)return O.substring(Q,ke)}return O.substring(Q,le)}e.getLeadingWhitespace=h;function m(O,Q=O.length-1){for(let le=Q;le>=0;le--){const ke=O.charCodeAt(le);if(ke!==32&&ke!==9)return le}return-1}e.lastNonWhitespaceIndex=m;function t(O,Q){return O<Q?-1:O>Q?1:0}e.compare=t;function n(O,Q,le=0,ke=O.length,Pe=0,Ue=Q.length){for(;le<ke&&Pe<Ue;le++,Pe++){let rt=O.charCodeAt(le),Ke=Q.charCodeAt(Pe);if(rt<Ke)return-1;if(rt>Ke)return 1}const We=ke-le,Ze=Ue-Pe;return We<Ze?-1:We>Ze?1:0}e.compareSubstring=n;function s(O,Q){return r(O,Q,0,O.length,0,Q.length)}e.compareIgnoreCase=s;function r(O,Q,le=0,ke=O.length,Pe=0,Ue=Q.length){for(;le<ke&&Pe<Ue;le++,Pe++){let rt=O.charCodeAt(le),Ke=Q.charCodeAt(Pe);if(rt===Ke)continue;const Je=rt-Ke;if(!(Je===32&&b(Ke))&&!(Je===-32&&b(rt)))return u(rt)&&u(Ke)?Je:n(O.toLowerCase(),Q.toLowerCase(),le,ke,Pe,Ue)}const We=ke-le,Ze=Ue-Pe;return We<Ze?-1:We>Ze?1:0}e.compareSubstringIgnoreCase=r;function u(O){return O>=97&&O<=122}e.isLowerAsciiLetter=u;function b(O){return O>=65&&O<=90}e.isUpperAsciiLetter=b;function p(O){return u(O)||b(O)}function P(O,Q){return O.length===Q.length&&A(O,Q)}e.equalsIgnoreCase=P;function A(O,Q,le=O.length){for(let ke=0;ke<le;ke++){const Pe=O.charCodeAt(ke),Ue=Q.charCodeAt(ke);if(Pe!==Ue){if(p(Pe)&&p(Ue)){const We=Math.abs(Pe-Ue);if(We!==0&&We!==32)return!1}else if(String.fromCharCode(Pe).toLowerCase()!==String.fromCharCode(Ue).toLowerCase())return!1}}return!0}function a(O,Q){const le=Q.length;return Q.length>O.length?!1:A(O,Q,le)}e.startsWithIgnoreCase=a;function R(O,Q){let le,ke=Math.min(O.length,Q.length);for(le=0;le<ke;le++)if(O.charCodeAt(le)!==Q.charCodeAt(le))return le;return ke}e.commonPrefixLength=R;function M(O,Q){let le,ke=Math.min(O.length,Q.length);const Pe=O.length-1,Ue=Q.length-1;for(le=0;le<ke;le++)if(O.charCodeAt(Pe-le)!==Q.charCodeAt(Ue-le))return le;return ke}e.commonSuffixLength=M;function H(O){return 55296<=O&&O<=56319}e.isHighSurrogate=H;function ue(O){return 56320<=O&&O<=57343}e.isLowSurrogate=ue;function fe(O,Q){return(O-55296<<10)+(Q-56320)+65536}e.computeCodePoint=fe;function Y(O,Q,le){const ke=O.charCodeAt(le);if(H(ke)&&le+1<Q){const Pe=O.charCodeAt(le+1);if(ue(Pe))return fe(ke,Pe)}return ke}e.getNextCodePoint=Y;function j(O,Q){const le=O.charCodeAt(Q-1);if(ue(le)&&Q>1){const ke=O.charCodeAt(Q-2);if(H(ke))return fe(ke,le)}return le}function Z(O,Q){const le=Ne.getInstance(),ke=Q,Pe=O.length,Ue=Y(O,Pe,Q);Q+=Ue>=65536?2:1;let We=le.getGraphemeBreakType(Ue);for(;Q<Pe;){const Ze=Y(O,Pe,Q),rt=le.getGraphemeBreakType(Ze);if(ge(We,rt))break;Q+=Ze>=65536?2:1,We=rt}return Q-ke}e.nextCharLength=Z;function L(O,Q){const le=Ne.getInstance(),ke=Q,Pe=j(O,Q);Q-=Pe>=65536?2:1;let Ue=le.getGraphemeBreakType(Pe);for(;Q>0;){const We=j(O,Q),Ze=le.getGraphemeBreakType(We);if(ge(Ze,Ue))break;Q-=We>=65536?2:1,Ue=Ze}return ke-Q}e.prevCharLength=L;function q(O,Q){const le=Ne.getInstance(),ke=O.length,Pe=Q,Ue=Y(O,ke,Q),We=le.getGraphemeBreakType(Ue);Q+=Ue>=65536?2:1;let Ze=We;for(;Q<ke;){const Ke=Y(O,ke,Q),Je=le.getGraphemeBreakType(Ke);if(ge(Ze,Je))break;Q+=Ke>=65536?2:1,Ze=Je}const rt=Q;for(Q=Pe,Ze=We;Q>0;){const Ke=j(O,Q),Je=le.getGraphemeBreakType(Ke);if(ge(Je,Ze))break;Q-=Ke>=65536?2:1,Ze=Je}return[Q,rt]}function N(O,Q){return Q>0&&ue(O.charCodeAt(Q))?q(O,Q-1):q(O,Q)}e.getCharContainingOffset=N;function W(O){const Q=O.length;let le=0,ke=0;for(;ke<Q;){const We=Y(O,Q,ke);ke+=We>=65536?2:1,We<128?le+=1:We<2048?le+=2:We<65536?le+=3:le+=4}const Pe=new Uint8Array(le);ke=0;let Ue=0;for(;ke<Q;){const We=Y(O,Q,ke);ke+=We>=65536?2:1,We<128?Pe[Ue++]=We:We<2048?(Pe[Ue++]=192|(We&1984)>>>6,Pe[Ue++]=128|(We&63)>>>0):We<65536?(Pe[Ue++]=224|(We&61440)>>>12,Pe[Ue++]=128|(We&4032)>>>6,Pe[Ue++]=128|(We&63)>>>0):(Pe[Ue++]=240|(We&1835008)>>>18,Pe[Ue++]=128|(We&258048)>>>12,Pe[Ue++]=128|(We&4032)>>>6,Pe[Ue++]=128|(We&63)>>>0)}return Pe}e.encodeUTF8=W;function U(O){const Q=O.byteLength,le=[];let ke=0;for(;ke<Q;){const Pe=O[ke];let Ue;if(Pe>=240&&ke+3<Q?Ue=(O[ke++]&7)<<18>>>0|(O[ke++]&63)<<12>>>0|(O[ke++]&63)<<6>>>0|(O[ke++]&63)<<0>>>0:Pe>=224&&ke+2<Q?Ue=(O[ke++]&15)<<12>>>0|(O[ke++]&63)<<6>>>0|(O[ke++]&63)<<0>>>0:Pe>=192&&ke+1<Q?Ue=(O[ke++]&31)<<6>>>0|(O[ke++]&63)<<0>>>0:Ue=O[ke++],Ue>=0&&Ue<=55295||Ue>=57344&&Ue<=65535)le.push(String.fromCharCode(Ue));else if(Ue>=65536&&Ue<=1114111){const We=Ue-65536,Ze=55296+((We&1047552)>>>10),rt=56320+((We&1023)>>>0);le.push(String.fromCharCode(Ze)),le.push(String.fromCharCode(rt))}else le.push(String.fromCharCode(65533))}return le.join("")}e.decodeUTF8=U;const B=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function J(O){return B.test(O)}e.containsRTL=J;const he=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function De(O){return he.test(O)}e.containsEmoji=De;const Oe=/^[\t\n\r\x20-\x7E]*$/;function Me(O){return Oe.test(O)}e.isBasicASCII=Me,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function He(O){return e.UNUSUAL_LINE_TERMINATORS.test(O)}e.containsUnusualLineTerminators=He;function Ye(O){for(let Q=0,le=O.length;Q<le;Q++)if(qe(O.charCodeAt(Q)))return!0;return!1}e.containsFullWidthCharacter=Ye;function qe(O){return O=+O,O>=11904&&O<=55215||O>=63744&&O<=64255||O>=65281&&O<=65374}e.isFullWidthCharacter=qe;function Xe(O){return O>=127462&&O<=127487||O===8986||O===8987||O===9200||O===9203||O>=9728&&O<=10175||O===11088||O===11093||O>=127744&&O<=128591||O>=128640&&O<=128764||O>=128992&&O<=129003||O>=129280&&O<=129535||O>=129648&&O<=129750}e.isEmojiImprecise=Xe;function $(O,Q){if(O.length<Q)return O;const le=/\b/g;let ke=0;for(;le.test(O)&&!(O.length-le.lastIndex<Q);)ke=le.lastIndex,le.lastIndex+=1;return O.substring(ke).replace(/^\s/,"")}e.lcut=$;const G=/\x1B\x5B[12]?K/g,te=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function K(O){return O&&(O=O.replace(G,""),O=O.replace(te,""),O=O.replace(re,"")),O}e.removeAnsiEscapeCodes=K,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function oe(O){return!!(O&&O.length>0&&O.charCodeAt(0)===65279)}e.startsWithUTF8BOM=oe;function me(O){return oe(O)?O.substr(1):O}e.stripUTF8BOM=me;function Ae(O,Q){if(!O||!Q||O.length<Q.length)return!1;const le=Q.length,ke=O.toLowerCase();let Pe=0,Ue=-1;for(;Pe<le;){const We=ke.indexOf(Q[Pe],Ue+1);if(We<0)return!1;Ue=We,Pe++}return!0}e.fuzzyContains=Ae;function $e(O,Q=!1){return O?(Q&&(O=O.replace(/\\./g,"")),O.toLowerCase()!==O):!1}e.containsUppercaseCharacter=$e;function pe(O){return O.charAt(0).toUpperCase()+O.slice(1)}e.uppercaseFirstLetter=pe;function Ge(O,Q=1){if(Q===0)return"";let le=-1;do le=O.indexOf(`
`,le+1),Q--;while(Q>0&&le>=0);return le===-1?O:(O[le-1]==="\r"&&le--,O.substr(0,le))}e.getNLines=Ge;function V(O){const Q=90-65+1;return O=O%(2*Q),O<Q?String.fromCharCode(97+O):String.fromCharCode(65+O-Q)}e.singleLetterHash=V;function ie(O){return Ne.getInstance().getGraphemeBreakType(O)}e.getGraphemeBreakType=ie;function ge(O,Q){return O===0?Q!==5&&Q!==7:O===2&&Q===3?!1:O===4||O===2||O===3||Q===4||Q===2||Q===3?!0:!(O===8&&(Q===8||Q===9||Q===11||Q===12)||(O===11||O===9)&&(Q===9||Q===10)||(O===12||O===10)&&Q===10||Q===5||Q===13||Q===7||O===1||O===13&&Q===14||O===6&&Q===6)}e.breakBetweenGraphemeBreakType=ge;var Fe;(function(O){O[O.Other=0]="Other",O[O.Prepend=1]="Prepend",O[O.CR=2]="CR",O[O.LF=3]="LF",O[O.Control=4]="Control",O[O.Extend=5]="Extend",O[O.Regional_Indicator=6]="Regional_Indicator",O[O.SpacingMark=7]="SpacingMark",O[O.L=8]="L",O[O.V=9]="V",O[O.T=10]="T",O[O.LV=11]="LV",O[O.LVT=12]="LVT",O[O.ZWJ=13]="ZWJ",O[O.Extended_Pictographic=14]="Extended_Pictographic"})(Fe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ne{constructor(){this._data=Qe()}static getInstance(){return Ne._INSTANCE||(Ne._INSTANCE=new Ne),Ne._INSTANCE}getGraphemeBreakType(Q){if(Q<32)return Q===10?3:Q===13?2:4;if(Q<127)return 0;const le=this._data,ke=le.length/3;let Pe=1;for(;Pe<=ke;)if(Q<le[3*Pe])Pe=2*Pe;else if(Q>le[3*Pe+1])Pe=2*Pe+1;else return le[3*Pe+2];return 0}}Ne._INSTANCE=null;function Qe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ee(O,Q){if(O===0)return 0;const le=be(O,Q);if(le!==void 0)return le;const ke=j(Q,O);return O-=Ce(ke),O}e.getLeftDeleteOffset=Ee;function be(O,Q){let le=j(Q,O);for(O-=Ce(le);se(le)||le===65039||le===8419;){if(O===0)return;le=j(Q,O),O-=Ce(le)}if(!!Xe(le)){if(O>=0){const ke=j(Q,O);ke===8205&&(O-=Ce(ke))}return O}}function Ce(O){return O>=65536?2:1}function se(O){return 127995<=O&&O<=127999}var de;(function(O){O[O.zwj=8205]="zwj",O[O.emojiVariantSelector=65039]="emojiVariantSelector",O[O.enclosingKeyCap=8419]="enclosingKeyCap"})(de||(de={}))}),define(we[23],_e([0,1,8,109]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const S=typeof Buffer!="undefined",E=typeof TextEncoder!="undefined",k=typeof TextDecoder!="undefined";let D,_;class C{constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}static alloc(p){return S?new C(Buffer.allocUnsafe(p)):new C(new Uint8Array(p))}static wrap(p){return S&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new C(p)}static fromString(p,P){return!((P==null?void 0:P.dontUseNodeBuffer)||!1)&&S?new C(Buffer.from(p)):E?(D||(D=new TextEncoder),new C(D.encode(p))):new C(g.encodeUTF8(p))}static concat(p,P){if(typeof P=="undefined"){P=0;for(let R=0,M=p.length;R<M;R++)P+=p[R].byteLength}const A=C.alloc(P);let a=0;for(let R=0,M=p.length;R<M;R++){const H=p[R];A.set(H,a),a+=H.byteLength}return A}toString(){return S?this.buffer.toString():k?(_||(_=new TextDecoder),_.decode(this.buffer)):g.decodeUTF8(this.buffer)}slice(p,P){return new C(this.buffer.subarray(p,P))}set(p,P){p instanceof C?this.buffer.set(p.buffer,P):this.buffer.set(p,P)}readUInt32BE(p){return o(this.buffer,p)}writeUInt32BE(p,P){f(this.buffer,p,P)}readUInt32LE(p){return c(this.buffer,p)}writeUInt32LE(p,P){d(this.buffer,p,P)}readUInt8(p){return y(this.buffer,p)}writeUInt8(p,P){w(this.buffer,p,P)}}e.VSBuffer=C;function i(b,p){return b[p+0]<<0>>>0|b[p+1]<<8>>>0}e.readUInt16LE=i;function I(b,p,P){b[P+0]=p&255,p=p>>>8,b[P+1]=p&255}e.writeUInt16LE=I;function o(b,p){return b[p]*2**24+b[p+1]*2**16+b[p+2]*2**8+b[p+3]}e.readUInt32BE=o;function f(b,p,P){b[P+3]=p,p=p>>>8,b[P+2]=p,p=p>>>8,b[P+1]=p,p=p>>>8,b[P]=p}e.writeUInt32BE=f;function c(b,p){return b[p+0]<<0>>>0|b[p+1]<<8>>>0|b[p+2]<<16>>>0|b[p+3]<<24>>>0}e.readUInt32LE=c;function d(b,p,P){b[P+0]=p&255,p=p>>>8,b[P+1]=p&255,p=p>>>8,b[P+2]=p&255,p=p>>>8,b[P+3]=p&255}e.writeUInt32LE=d;function y(b,p){return b[p]}e.readUInt8=y;function w(b,p,P){b[P]=p}e.writeUInt8=w;function v(b){return T.consumeReadable(b,p=>C.concat(p))}e.readableToBuffer=v;function l(b){return T.toReadable(b)}e.bufferToReadable=l;function h(b){return T.consumeStream(b,p=>C.concat(p))}e.streamToBuffer=h;async function m(b){return b.ended?C.concat(b.buffer):C.concat([...b.buffer,await h(b.stream)])}e.bufferedStreamToBuffer=m;function t(b){return T.toStream(b,p=>C.concat(p))}e.bufferToStream=t;function n(b){return T.transform(b,{data:p=>typeof p=="string"?C.fromString(p):C.wrap(p)},p=>C.concat(p))}e.streamToBufferReadableStream=n;function s(b){return T.newWriteableStream(p=>C.concat(p),b)}e.newWriteableBufferStream=s;function r(b,p){return T.prefixedReadable(b,p,P=>C.concat(P))}e.prefixedBufferReadable=r;function u(b,p){return T.prefixedStream(b,p,P=>C.concat(P))}e.prefixedBufferStream=u}),define(we[53],_e([0,1,8]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function T(w){return S(w,0)}e.hash=T;function S(w,v){switch(typeof w){case"object":return w===null?E(349,v):Array.isArray(w)?_(w,v):C(w,v);case"string":return D(w,v);case"boolean":return k(w,v);case"number":return E(w,v);case"undefined":return E(937,v);default:return E(617,v)}}e.doHash=S;function E(w,v){return(v<<5)-v+w|0}function k(w,v){return E(w?433:863,v)}function D(w,v){v=E(149417,v);for(let l=0,h=w.length;l<h;l++)v=E(w.charCodeAt(l),v);return v}e.stringHash=D;function _(w,v){return v=E(104579,v),w.reduce((l,h)=>S(h,l),v)}function C(w,v){return v=E(181387,v),Object.keys(w).sort().reduce((l,h)=>(l=D(h,l),S(w[h],l)),v)}class i{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=S(v,this._value),this._value}}e.Hasher=i;var I;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function o(w,v,l=32){const h=l-v,m=~((1<<h)-1);return(w<<v|(m&w)>>>h)>>>0}function f(w,v=0,l=w.byteLength,h=0){for(let m=0;m<l;m++)w[v+m]=h}function c(w,v,l="0"){for(;w.length<v;)w=l+w;return w}function d(w,v=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(l=>l.toString(16).padStart(2,"0")).join(""):c((w>>>0).toString(16),v/4)}e.toHexString=d;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const l=v.length;if(l===0)return;const h=this._buff;let m=this._buffLen,t=this._leftoverHighSurrogate,n,s;for(t!==0?(n=t,s=-1,t=0):(n=v.charCodeAt(0),s=0);;){let r=n;if(g.isHighSurrogate(n))if(s+1<l){const u=v.charCodeAt(s+1);g.isLowSurrogate(u)?(s++,r=g.computeCodePoint(n,u)):r=65533}else{t=n;break}else g.isLowSurrogate(n)&&(r=65533);if(m=this._push(h,m,r),s++,s<l)n=v.charCodeAt(s);else break}this._buffLen=m,this._leftoverHighSurrogate=t}_push(v,l,h){return h<128?v[l++]=h:h<2048?(v[l++]=192|(h&1984)>>>6,v[l++]=128|(h&63)>>>0):h<65536?(v[l++]=224|(h&61440)>>>12,v[l++]=128|(h&4032)>>>6,v[l++]=128|(h&63)>>>0):(v[l++]=240|(h&1835008)>>>18,v[l++]=128|(h&258048)>>>12,v[l++]=128|(h&4032)>>>6,v[l++]=128|(h&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=y._bigBlock32,l=this._buffDV;for(let p=0;p<64;p+=4)v.setUint32(p,l.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)v.setUint32(p,o(v.getUint32(p-12,!1)^v.getUint32(p-32,!1)^v.getUint32(p-56,!1)^v.getUint32(p-64,!1),1),!1);let h=this._h0,m=this._h1,t=this._h2,n=this._h3,s=this._h4,r,u,b;for(let p=0;p<80;p++)p<20?(r=m&t|~m&n,u=1518500249):p<40?(r=m^t^n,u=1859775393):p<60?(r=m&t|m&n|t&n,u=2400959708):(r=m^t^n,u=3395469782),b=o(h,5)+r+s+u+v.getUint32(p*4,!1)&4294967295,s=n,n=t,t=o(m,30),m=h,h=b;this._h0=this._h0+h&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),define(we[42],_e([0,1,8]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(T||(T={})),function(S){const E="error",k="warning",D="warn",_="info",C="ignore";function i(o){return o?g.equalsIgnoreCase(E,o)?S.Error:g.equalsIgnoreCase(k,o)||g.equalsIgnoreCase(D,o)?S.Warning:g.equalsIgnoreCase(_,o)?S.Info:S.Ignore:S.Ignore}S.fromValue=i;function I(o){switch(o){case S.Error:return E;case S.Warning:return k;case S.Info:return _;default:return C}}S.toString=I}(T||(T={})),e.default=T}),define(we[10],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(p){return Array.isArray(p)}e.isArray=g;function T(p){return typeof p=="string"}e.isString=T;function S(p){return Array.isArray(p)&&p.every(P=>T(P))}e.isStringArray=S;function E(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}e.isObject=E;function k(p){return typeof p=="number"&&!isNaN(p)}e.isNumber=k;function D(p){return!!p&&typeof p[Symbol.iterator]=="function"}e.isIterable=D;function _(p){return p===!0||p===!1}e.isBoolean=_;function C(p){return typeof p=="undefined"}e.isUndefined=C;function i(p){return!I(p)}e.isDefined=i;function I(p){return C(p)||p===null}e.isUndefinedOrNull=I;function o(p,P){if(!p)throw new Error(P?`Unexpected type, expected '${P}'`:"Unexpected type")}e.assertType=o;function f(p){if(I(p))throw new Error("Assertion Failed: argument is undefined or null");return p}e.assertIsDefined=f;function c(...p){const P=[];for(let A=0;A<p.length;A++){const a=p[A];if(I(a))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);P.push(a)}return P}e.assertAllDefined=c;const d=Object.prototype.hasOwnProperty;function y(p){if(!E(p))return!1;for(let P in p)if(d.call(p,P))return!1;return!0}e.isEmptyObject=y;function w(p){return typeof p=="function"}e.isFunction=w;function v(...p){return p.length>0&&p.every(w)}e.areFunctions=v;function l(p,P){const A=Math.min(p.length,P.length);for(let a=0;a<A;a++)h(p[a],P[a])}e.validateConstraints=l;function h(p,P){if(T(P)){if(typeof p!==P)throw new Error(`argument does not match constraint: typeof ${P}`)}else if(w(P)){try{if(p instanceof P)return}catch(A){}if(!I(p)&&p.constructor===P||P.length===1&&P.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function m(p){let P=[],A=Object.getPrototypeOf(p);for(;Object.prototype!==A;)P=P.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return P}e.getAllPropertyNames=m;function t(p){const P=[];for(const A of m(p))typeof p[A]=="function"&&P.push(A);return P}e.getAllMethodNames=t;function n(p,P){const A=R=>function(){const M=Array.prototype.slice.call(arguments,0);return P(R,M)};let a={};for(const R of p)a[R]=A(R);return a}e.createProxyObject=n;function s(p){return p===null?void 0:p}e.withNullAsUndefined=s;function r(p){return typeof p=="undefined"?null:p}e.withUndefinedAsNull=r;function u(p){return class{constructor(){return new Proxy({},{get(P,A){if(P[A])return P[A];throw new Error(`Not Implemented: ${p}->${String(A)}`)}})}}}e.NotImplementedProxy=u;function b(p){throw new Error("Unreachable")}e.assertNever=b}),define(we[43],_e([0,1,21,8,14,10]),function(ee,e,g,T,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(s){return s===47||s===92}e.isPathSeparator=k;function D(s){return s.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=D;function _(s){return s.indexOf("/")===-1&&(s=D(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=_;function C(s,r=S.posix.sep){if(!s)return"";const u=s.length,b=s.charCodeAt(0);if(k(b)){if(k(s.charCodeAt(1))&&!k(s.charCodeAt(2))){let P=3;const A=P;for(;P<u&&!k(s.charCodeAt(P));P++);if(A!==P&&!k(s.charCodeAt(P+1))){for(P+=1;P<u;P++)if(k(s.charCodeAt(P)))return s.slice(0,P+1).replace(/[\\/]/g,r)}}return r}else if(w(b)&&s.charCodeAt(1)===58)return k(s.charCodeAt(2))?s.slice(0,2)+r:s.slice(0,2);let p=s.indexOf("://");if(p!==-1){for(p+=3;p<u;p++)if(k(s.charCodeAt(p)))return s.slice(0,p+1)}return""}e.getRoot=C;function i(s){if(!g.isWindows||!s||s.length<5)return!1;let r=s.charCodeAt(0);if(r!==92||(r=s.charCodeAt(1),r!==92))return!1;let u=2;const b=u;for(;u<s.length&&(r=s.charCodeAt(u),r!==92);u++);return!(b===u||(r=s.charCodeAt(u+1),isNaN(r)||r===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(s,r=g.isWindows){const u=r?I:o;return!(!s||s.length===0||/^\s+$/.test(s)||(u.lastIndex=0,u.test(s))||r&&f.test(s)||s==="."||s===".."||r&&s[s.length-1]==="."||r&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=c;function d(s,r,u){const b=s===r;return!u||b?b:!s||!r?!1:T.equalsIgnoreCase(s,r)}e.isEqual=d;function y(s,r,u,b=S.sep){if(s===r)return!0;if(!s||!r||r.length>s.length)return!1;if(u){if(!T.startsWithIgnoreCase(s,r))return!1;if(r.length===s.length)return!0;let P=r.length;return r.charAt(r.length-1)===b&&P--,s.charAt(P)===b}return r.charAt(r.length-1)!==b&&(r+=b),s.indexOf(r)===0}e.isEqualOrParent=y;function w(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=w;function v(s,r){return g.isWindows&&s.endsWith(":")&&(s+=S.sep),S.isAbsolute(s)||(s=S.join(r,s)),s=S.normalize(s),g.isWindows?(s=T.rtrim(s,S.sep),s.endsWith(":")&&(s+=S.sep)):(s=T.rtrim(s,S.sep),s||(s=S.sep)),s}e.sanitizeFilePath=v;function l(s){const r=S.normalize(s);return g.isWindows?s.length>3?!1:h(r)&&(s.length===2||r.charCodeAt(2)===92):r===S.posix.sep}e.isRootOrDriveLetter=l;function h(s){return g.isWindows?w(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function m(s){return h(s)?s[0]:void 0}e.getDriveLetter=m;function t(s,r,u){return r.length>s.length?-1:s===r?0:(u&&(s=s.toLowerCase(),r=r.toLowerCase()),s.indexOf(r))}e.indexOfPath=t;function n(s){const r=s.split(":");let u,b,p;if(r.forEach(P=>{const A=Number(P);E.isNumber(A)?b===void 0?b=A:p===void 0&&(p=A):u=u?[u,P].join(":"):P}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:b!==void 0?b:void 0,column:p!==void 0?p:b!==void 0?1:void 0}}e.parseLineAndColumnAware=n}),define(we[24],_e([0,1,10]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const y=Array.isArray(d)?[]:{};return Object.keys(d).forEach(w=>{d[w]&&typeof d[w]=="object"?y[w]=T(d[w]):y[w]=d[w]}),y}e.deepClone=T;function S(d){if(!d||typeof d!="object")return d;const y=[d];for(;y.length>0;){const w=y.shift();Object.freeze(w);for(const v in w)if(E.call(w,v)){const l=w[v];typeof l=="object"&&!Object.isFrozen(l)&&y.push(l)}}return d}e.deepFreeze=S;const E=Object.prototype.hasOwnProperty;function k(d,y){return D(d,y,new Set)}e.cloneAndChange=k;function D(d,y,w){if(g.isUndefinedOrNull(d))return d;const v=y(d);if(typeof v!="undefined")return v;if(g.isArray(d)){const l=[];for(const h of d)l.push(D(h,y,w));return l}if(g.isObject(d)){if(w.has(d))throw new Error("Cannot clone recursive data-structure");w.add(d);const l={};for(let h in d)E.call(d,h)&&(l[h]=D(d[h],y,w));return w.delete(d),l}return d}function _(d,y,w=!0){return g.isObject(d)?(g.isObject(y)&&Object.keys(y).forEach(v=>{v in d?w&&(g.isObject(d[v])&&g.isObject(y[v])?_(d[v],y[v],w):d[v]=y[v]):d[v]=y[v]}),d):y}e.mixin=_;function C(d,y){if(d===y)return!0;if(d==null||y===null||y===void 0||typeof d!=typeof y||typeof d!="object"||Array.isArray(d)!==Array.isArray(y))return!1;let w,v;if(Array.isArray(d)){if(d.length!==y.length)return!1;for(w=0;w<d.length;w++)if(!C(d[w],y[w]))return!1}else{const l=[];for(v in d)l.push(v);l.sort();const h=[];for(v in y)h.push(v);if(h.sort(),!C(l,h))return!1;for(w=0;w<l.length;w++)if(!C(d[l[w]],y[l[w]]))return!1}return!0}e.equals=C;function i(d){const y=new Set;return JSON.stringify(d,(w,v)=>{if(g.isObject(v)||Array.isArray(v)){if(y.has(v))return"[Circular]";y.add(v)}return v})}e.safeStringify=i;function I(d,y,w){const v=y(d);return typeof v=="undefined"?w:v}e.getOrDefault=I;function o(d,y){const w=Object.create(null);return!d||!y||Object.keys(y).forEach(l=>{const h=d[l],m=y[l];C(h,m)||(w[l]=m)}),w}e.distinct=o;function f(d,y){const w=y.toLowerCase(),v=Object.keys(d).find(l=>l.toLowerCase()===w);return v?d[v]:d[y]}e.getCaseInsensitive=f;function c(d,y){const w=Object.create(null);for(const v of Object.keys(d))y(v,d[v])&&(w[v]=d[v]);return w}e.filter=c}),define(we[79],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(E){E[E.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",E[E.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",E[E.MAX_UINT_8=255]="MAX_UINT_8",E[E.MAX_UINT_16=65535]="MAX_UINT_16",E[E.MAX_UINT_32=4294967295]="MAX_UINT_32",E[E.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function T(E){return E<0?0:E>255?255:E|0}e.toUint8=T;function S(E){return E<0?0:E>4294967295?4294967295:E|0}e.toUint32=S}),define(we[2],_e([0,1,21,14]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const S=/^\w[\w\d+.-]*$/,E=/^\//,k=/^\/\//;function D(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!S.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!E.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(s,r){return!s&&!r?"file":s}function C(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==I&&(r=I+r):r=I;break}return r}const i="",I="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(r,u,b,p,P,A=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=_(r,A),this.authority=u||i,this.path=C(this.scheme,b||i),this.query=p||i,this.fragment=P||i,D(this,A))}static isUri(r){return r instanceof f?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return l(this,!1)}with(r){if(!r)return this;let{scheme:u,authority:b,path:p,query:P,fragment:A}=r;return u===void 0?u=this.scheme:u===null&&(u=i),b===void 0?b=this.authority:b===null&&(b=i),p===void 0?p=this.path:p===null&&(p=i),P===void 0?P=this.query:P===null&&(P=i),A===void 0?A=this.fragment:A===null&&(A=i),u===this.scheme&&b===this.authority&&p===this.path&&P===this.query&&A===this.fragment?this:new d(u,b,p,P,A)}static parse(r,u=!1){const b=o.exec(r);return b?new d(b[2]||i,n(b[4]||i),n(b[5]||i),n(b[7]||i),n(b[9]||i),u):new d(i,i,i,i,i)}static file(r){let u=i;if(g.isWindows&&(r=r.replace(/\\/g,I)),r[0]===I&&r[1]===I){const b=r.indexOf(I,2);b===-1?(u=r.substring(2),r=I):(u=r.substring(2,b),r=r.substring(b)||I)}return new d("file",u,r,i,i)}static from(r){const u=new d(r.scheme,r.authority,r.path,r.query,r.fragment);return D(u,!0),u}static joinPath(r,...u){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return g.isWindows&&r.scheme==="file"?b=f.file(T.win32.join(l(r,!0),...u)).path:b=T.posix.join(r.path,...u),r.with({path:b})}toString(r=!1){return h(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof f)return r;{const u=new d(r);return u._formatted=r.external,u._fsPath=r._sep===c?r.fsPath:null,u}}else return r}}e.URI=f;const c=g.isWindows?1:void 0;class d extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(r=!1){return r?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=c),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(s,r){let u,b=-1;for(let p=0;p<s.length;p++){const P=s.charCodeAt(p);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||r&&P===47)b!==-1&&(u+=encodeURIComponent(s.substring(b,p)),b=-1),u!==void 0&&(u+=s.charAt(p));else{u===void 0&&(u=s.substr(0,p));const A=y[P];A!==void 0?(b!==-1&&(u+=encodeURIComponent(s.substring(b,p)),b=-1),u+=A):b===-1&&(b=p)}}return b!==-1&&(u+=encodeURIComponent(s.substring(b))),u!==void 0?u:s}function v(s){let r;for(let u=0;u<s.length;u++){const b=s.charCodeAt(u);b===35||b===63?(r===void 0&&(r=s.substr(0,u)),r+=y[b]):r!==void 0&&(r+=s[u])}return r!==void 0?r:s}function l(s,r){let u;return s.authority&&s.path.length>1&&s.scheme==="file"?u=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?u=s.path.substr(1):u=s.path[1].toLowerCase()+s.path.substr(2):u=s.path,g.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=l;function h(s,r){const u=r?v:w;let b="",{scheme:p,authority:P,path:A,query:a,fragment:R}=s;if(p&&(b+=p,b+=":"),(P||p==="file")&&(b+=I,b+=I),P){let M=P.indexOf("@");if(M!==-1){const H=P.substr(0,M);P=P.substr(M+1),M=H.indexOf(":"),M===-1?b+=u(H,!1):(b+=u(H.substr(0,M),!1),b+=":",b+=u(H.substr(M+1),!1)),b+="@"}P=P.toLowerCase(),M=P.indexOf(":"),M===-1?b+=u(P,!1):(b+=u(P.substr(0,M),!1),b+=P.substr(M))}if(A){if(A.length>=3&&A.charCodeAt(0)===47&&A.charCodeAt(2)===58){const M=A.charCodeAt(1);M>=65&&M<=90&&(A=`/${String.fromCharCode(M+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===58){const M=A.charCodeAt(0);M>=65&&M<=90&&(A=`${String.fromCharCode(M+32)}:${A.substr(2)}`)}b+=u(A,!0)}return a&&(b+="?",b+=u(a,!1)),R&&(b+="#",b+=r?R:w(R,!1)),b}function m(s){try{return decodeURIComponent(s)}catch(r){return s.length>3?s.substr(0,3)+m(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(t)?s.replace(t,r=>m(r)):s}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Be=this&&this.__classPrivateFieldGet||function(ee,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[22],_e([0,1,2,8]),function(ee,e,g,T){"use strict";var S,E,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(t,n,s){let r=t.get(n);return r===void 0&&(r=s,t.set(n,r)),r}e.getOrSet=D;function _(t){const n=[];return t.forEach((s,r)=>{n.push(`${r} => ${s}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=_;function C(t){const n=[];return t.forEach(s=>{n.push(s)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=C;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),r=this._value.charCodeAt(this._pos);return s-r}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?T.compareSubstring(n,this._value,0,n.length,this._from,this._to):T.compareSubstringIgnoreCase(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class o{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?T.compareSubstring(n,this._value,0,n.length,this._from,this._to):T.compareSubstringIgnoreCase(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=o;var f;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(f||(f={}));class c{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new o(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return T.compareIgnoreCase(n,this._value.scheme);if(this._states[this._stateIdx]===2)return T.compareIgnoreCase(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return T.compare(n,this._value.query);if(this._states[this._stateIdx]===5)return T.compare(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class d{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class y{constructor(n){this._iter=n}static forUris(n=()=>!1){return new y(new c(n))}static forPaths(){return new y(new o)}static forStrings(){return new y(new i)}static forConfigKeys(){return new y(new I)}clear(){this._root=void 0}set(n,s){const r=this._iter.reset(n);let u;for(this._root||(this._root=new d,this._root.segment=r.value()),u=this._root;;){const p=r.cmp(u.segment);if(p>0)u.left||(u.left=new d,u.left.segment=r.value()),u=u.left;else if(p<0)u.right||(u.right=new d,u.right.segment=r.value()),u=u.right;else if(r.hasNext())r.next(),u.mid||(u.mid=new d,u.mid.segment=r.value()),u=u.mid;else break}const b=u.value;return u.value=s,u.key=n,b}get(n){var s;return(s=this._getNode(n))===null||s===void 0?void 0:s.value}_getNode(n){const s=this._iter.reset(n);let r=this._root;for(;r;){const u=s.cmp(r.segment);if(u>0)r=r.left;else if(u<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else break}return r}has(n){const s=this._getNode(n);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const r=this._iter.reset(n),u=[];let b=this._root;for(;b;){const p=r.cmp(b.segment);if(p>0)u.push([1,b]),b=b.left;else if(p<0)u.push([-1,b]),b=b.right;else if(r.hasNext())r.next(),u.push([0,b]),b=b.mid;else{for(s?(b.left=void 0,b.mid=void 0,b.right=void 0):b.value=void 0;u.length>0&&b.isEmpty();){let[P,A]=u.pop();switch(P){case 1:A.left=void 0;break;case 0:A.mid=void 0;break;case-1:A.right=void 0;break}b=A}break}}}findSubstr(n){const s=this._iter.reset(n);let r=this._root,u;for(;r;){const b=s.cmp(r.segment);if(b>0)r=r.left;else if(b<0)r=r.right;else if(s.hasNext())s.next(),u=r.value||u,r=r.mid;else break}return r&&r.value||u}findSuperstr(n){const s=this._iter.reset(n);let r=this._root;for(;r;){const u=s.cmp(r.segment);if(u>0)r=r.left;else if(u<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(n){for(const[s,r]of this)n(r,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){if(!n)return;const s=[n];for(;s.length>0;){const r=s.pop();r&&(r.value&&(yield[r.key,r.value]),r.left&&s.push(r.left),r.mid&&s.push(r.mid),r.right&&s.push(r.right))}}}e.TernarySearchTree=y;class w{constructor(n,s){this[S]="ResourceMap",n instanceof w?(this.map=new Map(n.map),this.toKey=s??w.defaultToKey):(this.map=new Map,this.toKey=n??w.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),s),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(let[r,u]of this.map)n(u,g.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield g.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[g.URI.parse(n[0]),n[1]]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[g.URI.parse(n[0]),n[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var v;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class l{constructor(){this[E]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,s=0){const r=this._map.get(n);if(!!r)return s!==0&&this.touch(r,s),r.value}set(n,s,r=0){let u=this._map.get(n);if(u)u.value=s,r!==0&&this.touch(u,r);else{switch(u={key:n,value:s,next:void 0,previous:void 0},r){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(n,u),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const r=this._state;let u=this._head;for(;u;){if(s?n.bind(s)(u.value,u.key,this):n(u.value,u.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const n=this,s=this._state;let r=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const b={value:r.key,done:!1};return r=r.next,b}else return{value:void 0,done:!0}}};return u}values(){const n=this,s=this._state;let r=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const b={value:r.value,done:!1};return r=r.next,b}else return{value:void 0,done:!0}}};return u}entries(){const n=this,s=this._state;let r=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const b={value:[r.key,r.value],done:!1};return r=r.next,b}else return{value:void 0,done:!0}}};return u}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,r=this.size;for(;s&&r>n;)this._map.delete(s.key),s=s.next,r--;this._head=s,this._size=r,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,r=n.previous;if(!s||!r)throw new Error("Invalid list");s.previous=r,r.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const r=n.next,u=n.previous;n===this._tail?(u.next=void 0,this._tail=u):(r.previous=u,u.next=r),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const r=n.next,u=n.previous;n===this._head?(r.previous=void 0,this._head=r):(r.previous=u,u.next=r),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,r)=>{n.push([r,s])}),n}fromJSON(n){this.clear();for(const[s,r]of n)this.set(s,r)}}e.LinkedMap=l;class h extends l{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=h;class m{constructor(n){k.set(this,void 0),nt(this,k,n,"f")}get size(){return Be(this,k,"f").size}forEach(n,s){Be(this,k,"f").forEach(n,s)}get(n){return Be(this,k,"f").get(n)}has(n){return Be(this,k,"f").has(n)}entries(){return Be(this,k,"f").entries()}keys(){return Be(this,k,"f").keys()}values(){return Be(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Be(this,k,"f").entries()}}e.ReadonlyMapView=m}),define(we[110],_e([0,1,22,8]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...K){return function(oe,me){for(let Ae=0,$e=K.length;Ae<$e;Ae++){const pe=K[Ae](oe,me);if(pe)return pe}return null}}e.or=S,e.matchesStrictPrefix=E.bind(void 0,!1),e.matchesPrefix=E.bind(void 0,!0);function E(K,oe,me){if(!me||me.length<oe.length)return null;let Ae;return K?Ae=T.startsWithIgnoreCase(me,oe):Ae=me.indexOf(oe)===0,Ae?oe.length>0?[{start:0,end:oe.length}]:[]:null}function k(K,oe){const me=oe.toLowerCase().indexOf(K.toLowerCase());return me===-1?null:[{start:me,end:me+K.length}]}e.matchesContiguousSubString=k;function D(K,oe){return _(K.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=D;function _(K,oe,me,Ae){if(me===K.length)return[];if(Ae===oe.length)return null;if(K[me]===oe[Ae]){let $e=null;return($e=_(K,oe,me+1,Ae+1))?w({start:Ae,end:Ae+1},$e):null}return _(K,oe,me,Ae+1)}function C(K){return 97<=K&&K<=122}function i(K){return 65<=K&&K<=90}e.isUpper=i;function I(K){return 48<=K&&K<=57}function o(K){return K===32||K===9||K===10||K===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(K=>f.add(K.charCodeAt(0)));function c(K){return o(K)||f.has(K)}function d(K,oe){return K===oe||c(K)&&c(oe)}function y(K){return C(K)||i(K)||I(K)}function w(K,oe){return oe.length===0?oe=[K]:K.end===oe[0].start?oe[0].start=K.start:oe.unshift(K),oe}function v(K,oe){for(let me=oe;me<K.length;me++){const Ae=K.charCodeAt(me);if(i(Ae)||I(Ae)||me>0&&!y(K.charCodeAt(me-1)))return me}return K.length}function l(K,oe,me,Ae){if(me===K.length)return[];if(Ae===oe.length)return null;if(K[me]!==oe[Ae].toLowerCase())return null;{let $e=null,pe=Ae+1;for($e=l(K,oe,me+1,Ae+1);!$e&&(pe=v(oe,pe))<oe.length;)$e=l(K,oe,me+1,pe),pe++;return $e===null?null:w({start:Ae,end:Ae+1},$e)}}function h(K){let oe=0,me=0,Ae=0,$e=0,pe=0;for(let Fe=0;Fe<K.length;Fe++)pe=K.charCodeAt(Fe),i(pe)&&oe++,C(pe)&&me++,y(pe)&&Ae++,I(pe)&&$e++;const Ge=oe/K.length,V=me/K.length,ie=Ae/K.length,ge=$e/K.length;return{upperPercent:Ge,lowerPercent:V,alphaPercent:ie,numericPercent:ge}}function m(K){const{upperPercent:oe,lowerPercent:me}=K;return me===0&&oe>.6}function t(K){const{upperPercent:oe,lowerPercent:me,alphaPercent:Ae,numericPercent:$e}=K;return me>.2&&oe<.8&&Ae>.6&&$e<.2}function n(K){let oe=0,me=0,Ae=0,$e=0;for(let pe=0;pe<K.length;pe++)Ae=K.charCodeAt(pe),i(Ae)&&oe++,C(Ae)&&me++,o(Ae)&&$e++;return(oe===0||me===0)&&$e===0?K.length<=30:oe<=5}function s(K,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!n(K)||oe.length>60)return null;const me=h(oe);if(!t(me)){if(!m(me))return null;oe=oe.toLowerCase()}let Ae=null,$e=0;for(K=K.toLowerCase();$e<oe.length&&(Ae=l(K,oe,0,$e))===null;)$e=v(oe,$e+1);return Ae}e.matchesCamelCase=s;function r(K,oe,me=!1){if(!oe||oe.length===0)return null;let Ae=null,$e=0;for(K=K.toLowerCase(),oe=oe.toLowerCase();$e<oe.length&&(Ae=u(K,oe,0,$e,me))===null;)$e=b(oe,$e+1);return Ae}e.matchesWords=r;function u(K,oe,me,Ae,$e){if(me===K.length)return[];if(Ae===oe.length)return null;if(d(K.charCodeAt(me),oe.charCodeAt(Ae))){let pe=null,Ge=Ae+1;if(pe=u(K,oe,me+1,Ae+1,$e),!$e)for(;!pe&&(Ge=b(oe,Ge))<oe.length;)pe=u(K,oe,me+1,Ge,$e),Ge++;return pe===null?null:w({start:Ae,end:Ae+1},pe)}else return null}function b(K,oe){for(let me=oe;me<K.length;me++)if(c(K.charCodeAt(me))||me>0&&c(K.charCodeAt(me-1)))return me;return K.length}const p=S(e.matchesPrefix,s,k),P=S(e.matchesPrefix,s,D),A=new g.LRUCache(1e4);function a(K,oe,me=!1){if(typeof K!="string"||typeof oe!="string")return null;let Ae=A.get(K);Ae||(Ae=new RegExp(T.convertSimple2RegExpPattern(K),"i"),A.set(K,Ae));const $e=Ae.exec(oe);return $e?[{start:$e.index,end:$e.index+$e[0].length}]:me?P(K,oe):p(K,oe)}e.matchesFuzzy=a;function R(K,oe){const me=Ye(K,K.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return me?H(me):null}e.matchesFuzzy2=R;function M(K,oe,me,Ae,$e,pe){const Ge=Math.min(13,K.length);for(;me<Ge;me++){const V=Ye(K,oe,me,Ae,$e,pe,!1);if(V)return V}return[0,pe]}e.anyScore=M;function H(K){if(typeof K=="undefined")return[];const oe=[],me=K[1];for(let Ae=K.length-1;Ae>1;Ae--){const $e=K[Ae]+me,pe=oe[oe.length-1];pe&&pe.end===$e?pe.end=$e+1:oe.push({start:$e,end:$e+1})}return oe}e.createMatches=H;const ue=128;function fe(){const K=[],oe=[];for(let me=0;me<=ue;me++)oe[me]=0;for(let me=0;me<=ue;me++)K.push(oe.slice(0));return K}function Y(K){const oe=[];for(let me=0;me<=K;me++)oe[me]=0;return oe}const j=Y(2*ue),Z=Y(2*ue),L=fe(),q=fe(),N=fe(),W=!1;function U(K,oe,me,Ae,$e){function pe(V,ie,ge=" "){for(;V.length<ie;)V=ge+V;return V}let Ge=` |   |${Ae.split("").map(V=>pe(V,3)).join("|")}
`;for(let V=0;V<=me;V++)V===0?Ge+=" |":Ge+=`${oe[V-1]}|`,Ge+=K[V].slice(0,$e+1).map(ie=>pe(ie.toString(),3)).join("|")+`
`;return Ge}function B(K,oe,me,Ae){K=K.substr(oe),me=me.substr(Ae),console.log(U(q,K,K.length,me,me.length)),console.log(U(N,K,K.length,me,me.length)),console.log(U(L,K,K.length,me,me.length))}function J(K,oe){if(oe<0||oe>=K.length)return!1;const me=K.codePointAt(oe);switch(me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise(me)}}function he(K,oe){if(oe<0||oe>=K.length)return!1;switch(K.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function De(K,oe,me){return oe[K]!==me[K]}function Oe(K,oe,me,Ae,$e,pe,Ge=!1){for(;oe<me&&$e<pe;)K[oe]===Ae[$e]&&(Ge&&(j[oe]=$e),oe+=1),$e+=1;return oe===me}e.isPatternInWord=Oe;var Me;(function(K){K[K.Diag=1]="Diag",K[K.Left=2]="Left",K[K.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var He;(function(K){K.Default=[-100,0];function oe(me){return!me||me.length===2&&me[0]===-100&&me[1]===0}K.isDefault=oe})(He=e.FuzzyScore||(e.FuzzyScore={}));function Ye(K,oe,me,Ae,$e,pe,Ge){const V=K.length>ue?ue:K.length,ie=Ae.length>ue?ue:Ae.length;if(me>=V||pe>=ie||V-me>ie-pe||!Oe(oe,me,V,$e,pe,ie,!0))return;qe(V,ie,me,pe,oe,$e);let ge=1,Fe=1,Ne=me,Qe=pe;const Ee=[!1];for(ge=1,Ne=me;Ne<V;ge++,Ne++){const O=j[Ne],Q=Z[Ne],le=Ne+1<V?Z[Ne+1]:ie;for(Fe=O-pe+1,Qe=O;Qe<le;Fe++,Qe++){let ke=Number.MIN_SAFE_INTEGER,Pe=!1;Qe<=Q&&(ke=Xe(K,oe,Ne,me,Ae,$e,Qe,ie,pe,L[ge-1][Fe-1]===0,Ee));let Ue=0;ke!==Number.MAX_SAFE_INTEGER&&(Pe=!0,Ue=ke+q[ge-1][Fe-1]);const We=Qe>O,Ze=We?q[ge][Fe-1]+(L[ge][Fe-1]>0?-5:0):0,rt=Qe>O+1&&L[ge][Fe-1]>0,Ke=rt?q[ge][Fe-2]+(L[ge][Fe-2]>0?-5:0):0;if(rt&&(!We||Ke>=Ze)&&(!Pe||Ke>=Ue))q[ge][Fe]=Ke,N[ge][Fe]=3,L[ge][Fe]=0;else if(We&&(!Pe||Ze>=Ue))q[ge][Fe]=Ze,N[ge][Fe]=2,L[ge][Fe]=0;else if(Pe)q[ge][Fe]=Ue,N[ge][Fe]=1,L[ge][Fe]=L[ge-1][Fe-1]+1;else throw new Error("not possible")}}if(W&&B(K,me,Ae,pe),!Ee[0]&&!Ge)return;ge--,Fe--;const be=[q[ge][Fe],pe];let Ce=0,se=0;for(;ge>=1;){let O=Fe;do{const Q=N[ge][O];if(Q===3)O=O-2;else if(Q===2)O=O-1;else break}while(O>=1);Ce>1&&oe[me+ge-1]===$e[pe+Fe-1]&&!De(O+pe-1,Ae,$e)&&Ce+1>L[ge][O]&&(O=Fe),O===Fe?Ce++:Ce=1,se||(se=O),ge--,Fe=O-1,be.push(Fe)}ie===V&&(be[0]+=2);const de=se-V;return be[0]-=de,be}e.fuzzyScore=Ye;function qe(K,oe,me,Ae,$e,pe){let Ge=K-1,V=oe-1;for(;Ge>=me&&V>=Ae;)$e[Ge]===pe[V]&&(Z[Ge]=V,Ge--),V--}function Xe(K,oe,me,Ae,$e,pe,Ge,V,ie,ge,Fe){if(oe[me]!==pe[Ge])return Number.MIN_SAFE_INTEGER;let Ne=1,Qe=!1;return Ge===me-Ae?Ne=K[me]===$e[Ge]?7:5:De(Ge,$e,pe)&&(Ge===0||!De(Ge-1,$e,pe))?(Ne=K[me]===$e[Ge]?7:5,Qe=!0):J(pe,Ge)&&(Ge===0||!J(pe,Ge-1))?Ne=5:(J(pe,Ge-1)||he(pe,Ge-1))&&(Ne=5,Qe=!0),Ne>1&&me===Ae&&(Fe[0]=!0),Qe||(Qe=De(Ge,$e,pe)||J(pe,Ge-1)||he(pe,Ge-1)),me===Ae?Ge>ie&&(Ne-=Qe?3:5):ge?Ne+=Qe?2:0:Ne+=Qe?0:1,Ge+1===V&&(Ne-=Qe?3:5),Ne}function $(K,oe,me,Ae,$e,pe,Ge){return te(K,oe,me,Ae,$e,pe,!0,Ge)}e.fuzzyScoreGracefulAggressive=$;function G(K,oe,me,Ae,$e,pe,Ge){return te(K,oe,me,Ae,$e,pe,!1,Ge)}e.fuzzyScoreGraceful=G;function te(K,oe,me,Ae,$e,pe,Ge,V){let ie=Ye(K,oe,me,Ae,$e,pe,V);if(ie&&!Ge)return ie;if(K.length>=3){const ge=Math.min(7,K.length-1);for(let Fe=me+1;Fe<ge;Fe++){const Ne=re(K,Fe);if(Ne){const Qe=Ye(Ne,Ne.toLowerCase(),me,Ae,$e,pe,V);Qe&&(Qe[0]-=3,(!ie||Qe[0]>ie[0])&&(ie=Qe))}}}return ie}function re(K,oe){if(oe+1>=K.length)return;const me=K[oe],Ae=K[oe+1];if(me!==Ae)return K.slice(0,oe)+Ae+me+K.slice(oe+2)}}),define(we[111],_e([0,1,78,110,8]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const E=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${E.source}`,"g");function D(d){return d.replace(k,(y,w)=>w?y:`\\${y}`)}e.escapeIcons=D;const _=new RegExp(`\\\\${E.source}`,"g");function C(d){return d.replace(_,y=>`\\${y}`)}e.markdownEscapeEscapedIcons=C;const i=new RegExp(`(\\s)?(\\\\)?${E.source}(\\s)?`,"g");function I(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(i,(y,w,v,l)=>v?y:w||l||"")}e.stripIcons=I;function o(d){const y=d.indexOf(e.iconStartMarker);return y===-1?{text:d}:f(d,y)}e.parseLabelWithIcons=o;function f(d,y){const w=[];let v="";function l(b){if(b){v+=b;for(const p of b)w.push(t)}}let h=-1,m="",t=0,n,s,r=y;const u=d.length;for(l(d.substr(0,y));r<u;)n=d[r],s=d[r+1],n===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(h=r,l(m),m=e.iconStartMarker,r++):n===")"&&h!==-1?(t+=r-h+1,h=-1,m=""):h!==-1?/^[a-z0-9\-]$/i.test(n)?m+=n:(l(m),h=-1,m=""):l(n),r++;return l(m),{text:v,iconOffsets:w}}function c(d,y,w=!1){const{text:v,iconOffsets:l}=y;if(!l||l.length===0)return T.matchesFuzzy(d,v,w);const h=S.ltrim(v," "),m=v.length-h.length,t=T.matchesFuzzy(d,h,w);if(t)for(const n of t){const s=l[n.start+m]+m;n.start+=s,n.end+=s}return t}e.matchesFuzzyIconAware=c}),define(we[80],_e([0,1,111,11]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(S=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(f="",c=!1){var d,y;if(this.value=f,typeof this.value!="string")throw T.illegalArgument("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1):(this.isTrusted=(d=c.isTrusted)!==null&&d!==void 0?d:void 0,this.supportThemeIcons=(y=c.supportThemeIcons)!==null&&y!==void 0?y:!1)}appendText(f,c=0){return this.value+=C(this.supportThemeIcons?g.escapeIcons(f):f).replace(/([ \t]+)/g,(d,y)=>"&nbsp;".repeat(y.length)).replace(/^>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,c){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}}e.MarkdownString=E;function k(o){return D(o)?!o.value:Array.isArray(o)?o.every(k):!0}e.isEmptyMarkdownString=k;function D(o){return o instanceof E?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function _(o,f){return o===f?!0:!o||!f?!1:o.value===f.value&&o.isTrusted===f.isTrusted&&o.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=_;function C(o){return o.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function i(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=i;function I(o){const f=[],c=o.split("|").map(y=>y.trim());o=c[0];const d=c[1];if(d){const y=/height=(\d+)/.exec(d),w=/width=(\d+)/.exec(d),v=y?y[1]:"",l=w?w[1]:"",h=isFinite(parseInt(l)),m=isFinite(parseInt(v));h&&f.push(`width="${l}"`),m&&f.push(`height="${v}"`)}return{href:o,dimensions:f}}e.parseHrefAndDimensions=I}),define(we[54],_e([0,1,23,8,2]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function E(C){return JSON.stringify(C,D)}e.stringify=E;function k(C){let i=JSON.parse(C);return i=_(i),i}e.parse=k;function D(C,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:T.regExpFlags(i)}:i}function _(C,i=0){if(!C||i>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return S.URI.revive(C);case 2:return new RegExp(C.source,C.flags)}if(C instanceof g.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let I=0;I<C.length;++I)C[I]=_(C[I],i+1);else for(const I in C)Object.hasOwnProperty.call(C,I)&&(C[I]=_(C[I],i+1))}return C}e.revive=_}),define(we[16],_e([0,1,2,21]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var S;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp"})(S=e.Schemas||(e.Schemas={}));class E{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,C,i){this._hosts[_]=C,this._ports[_]=i}setConnectionToken(_,C){this._connectionTokens[_]=C}rewrite(_){if(this._delegate)return this._delegate(_);const C=_.authority;let i=this._hosts[C];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[C],o=this._connectionTokens[C];let f=`path=${encodeURIComponent(_.path)}`;return typeof o=="string"&&(f+=`&tkn=${encodeURIComponent(o)}`),g.URI.from({scheme:T.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new E;class k{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(_,C,i){const I=this.toUri(_,C);return I.scheme===S.vscodeRemote?e.RemoteAuthorities.rewrite(I):T.isNative&&(i||T.isPreferringBrowserCodeLoad)&&I.scheme===S.file?I.with({scheme:S.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(_,C){const i=this.toUri(_,C);return i.scheme===S.vscodeFileResource?i.with({scheme:S.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(_,C){return g.URI.isUri(_)?_:g.URI.parse(C.toUrl(_))}}e.FileAccess=new k}),define(we[25],_e([0,1,43,14,2,8,16,21]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(f){return S.uriToFsPath(f,!0)}e.originalFSPath=_;class C{constructor(c){this._ignorePathCasing=c}compare(c,d,y=!1){return c===d?0:E.compare(this.getComparisonKey(c,y),this.getComparisonKey(d,y))}isEqual(c,d,y=!1){return c===d?!0:!c||!d?!1:this.getComparisonKey(c,y)===this.getComparisonKey(d,y)}getComparisonKey(c,d=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,d,y=!1){if(c.scheme===d.scheme){if(c.scheme===k.Schemas.file)return g.isEqualOrParent(_(c),_(d),this._ignorePathCasing(c))&&c.query===d.query&&(y||c.fragment===d.fragment);if(e.isEqualAuthority(c.authority,d.authority))return g.isEqualOrParent(c.path,d.path,this._ignorePathCasing(c),"/")&&c.query===d.query&&(y||c.fragment===d.fragment)}return!1}joinPath(c,...d){return S.URI.joinPath(c,...d)}basenameOrAuthority(c){return e.basename(c)||c.authority}basename(c){return T.posix.basename(c.path)}extname(c){return T.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let d;return c.scheme===k.Schemas.file?d=S.URI.file(T.dirname(_(c))).path:(d=T.posix.dirname(c.path),c.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),d="/")),c.with({path:d})}normalizePath(c){if(!c.path.length)return c;let d;return c.scheme===k.Schemas.file?d=S.URI.file(T.normalize(_(c))).path:d=T.posix.normalize(c.path),c.with({path:d})}relativePath(c,d){if(c.scheme!==d.scheme||!e.isEqualAuthority(c.authority,d.authority))return;if(c.scheme===k.Schemas.file){const v=T.relative(_(c),_(d));return D.isWindows?g.toSlashes(v):v}let y=c.path||"/",w=d.path||"/";if(this._ignorePathCasing(c)){let v=0;for(const l=Math.min(y.length,w.length);v<l&&!(y.charCodeAt(v)!==w.charCodeAt(v)&&y.charAt(v).toLowerCase()!==w.charAt(v).toLowerCase());v++);y=w.substr(0,v)+y.substr(v)}return T.posix.relative(y,w)}resolvePath(c,d){if(c.scheme===k.Schemas.file){const y=S.URI.file(T.resolve(_(c),d));return c.with({authority:y.authority,path:y.path})}return d=g.toPosixPath(d),c.with({path:T.posix.resolve(c.path,d)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,d){return c===d||E.equalsIgnoreCase(c,d)}hasTrailingPathSeparator(c,d=T.sep){if(c.scheme===k.Schemas.file){const y=_(c);return y.length>g.getRoot(y).length&&y[y.length-1]===d}else{const y=c.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,d=T.sep){return e.hasTrailingPathSeparator(c,d)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,d=T.sep){let y=!1;if(c.scheme===k.Schemas.file){const w=_(c);y=w!==void 0&&w.length===g.getRoot(w).length&&w[w.length-1]===d}else{d="/";const w=c.path;y=w.length===1&&w.charCodeAt(w.length-1)===47}return!y&&!e.hasTrailingPathSeparator(c,d)?c.with({path:c.path+"/"}):c}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(f=>f.scheme===k.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new C(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(f,c){const d=[];for(let y=0;y<f.length;y++){const w=c(f[y]);f.some((v,l)=>l===y?!1:e.isEqualOrParent(w,c(v)))||d.push(f[y])}return d}e.distinctParents=i;var I;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function c(d){const y=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(l=>{const[h,m]=l.split(":");h&&m&&y.set(h,m)});const v=d.path.substring(0,d.path.indexOf(";"));return v&&y.set(f.META_DATA_MIME,v),y}f.parseMetaData=c})(I=e.DataUri||(e.DataUri={}));function o(f,c,d){if(c){let y=f.path;return y&&y[0]!==T.posix.sep&&(y=T.posix.sep+y),f.with({scheme:d,authority:c,path:y})}return f.with({scheme:d})}e.toLocalResource=o}),define(we[12],_e([0,1,18,11,3,7,51,25]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function _(q){return!!q&&typeof q.then=="function"}e.isThenable=_;function C(q){const N=new g.CancellationTokenSource,W=q(N.token),U=new Promise((B,J)=>{N.token.onCancellationRequested(()=>{J(T.canceled())}),Promise.resolve(W).then(he=>{N.dispose(),B(he)},he=>{N.dispose(),J(he)})});return new class{cancel(){N.cancel()}then(B,J){return U.then(B,J)}catch(B){return this.then(void 0,B)}finally(B){return U.finally(B)}}}e.createCancelablePromise=C;function i(q,N,W){return Promise.race([q,new Promise(U=>N.onCancellationRequested(()=>U(W)))])}e.raceCancellation=i;async function I(q){let N=-1;const W=q.map((B,J)=>B.then(he=>(N=J,he))),U=await Promise.race(W);return q.forEach((B,J)=>{J!==N&&B.cancel()}),U}e.raceCancellablePromises=I;function o(q,N,W){let U;const B=setTimeout(()=>{U==null||U(void 0),W==null||W()},N);return Promise.race([q.finally(()=>clearTimeout(B)),new Promise(J=>U=J)])}e.raceTimeout=o;function f(q){return new Promise((N,W)=>{const U=q();_(U)?U.then(N,W):N(U)})}e.asPromise=f;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const W=()=>{this.queuedPromise=null;const U=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,U};this.queuedPromise=new Promise(U=>{this.activePromise.then(W,W).then(U)})}return new Promise((W,U)=>{this.queuedPromise.then(W,U)})}return this.activePromise=N(),new Promise((W,U)=>{this.activePromise.then(B=>{this.activePromise=null,W(B)},B=>{this.activePromise=null,U(B)})})}}e.Throttler=c;class d{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=d;class y{constructor(){this.promiseMap=new Map}queue(N,W){var U;const J=((U=this.promiseMap.get(N))!==null&&U!==void 0?U:Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(N)===J&&this.promiseMap.delete(N)});return this.promiseMap.set(N,J),J}}e.SequencerByKey=y;class w{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,W=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,B)=>{this.doResolve=U,this.doReject=B}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},W),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(T.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=w;class v{constructor(N){this.delayer=new w(N),this.throttler=new c}trigger(N,W){return this.delayer.trigger(()=>this.throttler.queue(N),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=v;class l{constructor(){this._isOpen=!1,this._promise=new Promise((N,W)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class h extends l{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function m(q,N){return N?new Promise((W,U)=>{const B=setTimeout(W,q);N.onCancellationRequested(()=>{clearTimeout(B),U(T.canceled())})}):C(W=>m(q,W))}e.timeout=m;function t(q,N=0){const W=setTimeout(q,N);return E.toDisposable(()=>clearTimeout(W))}e.disposableTimeout=t;function n(q){return q.then(void 0,N=>{})}e.ignoreErrors=n;function s(q){const N=[];let W=0;const U=q.length;function B(){return W<U?q[W++]():null}function J(he){he!=null&&N.push(he);const De=B();return De?De.then(J):Promise.resolve(N)}return Promise.resolve(null).then(J)}e.sequence=s;function r(q,N=U=>!!U,W=null){let U=0;const B=q.length,J=()=>{if(U>=B)return Promise.resolve(W);const he=q[U++];return Promise.resolve(he()).then(Oe=>N(Oe)?Promise.resolve(Oe):J())};return J()}e.first=r;function u(q,N=U=>!!U,W=null){if(q.length===0)return Promise.resolve(W);let U=q.length;const B=()=>{var J,he;U=-1;for(const De of q)(he=(J=De).cancel)===null||he===void 0||he.call(J)};return new Promise((J,he)=>{for(const De of q)De.then(Oe=>{--U>=0&&N(Oe)?(B(),J(Oe)):U===0&&J(W)}).catch(Oe=>{--U>=0&&(B(),he(Oe))})})}e.firstParallel=u;class b{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new S.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((W,U)=>{this.outstandingPromises.push({factory:N,c:W,e:U}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const W=N.factory();W.then(N.c,N.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=b;class p extends b{constructor(){super(1)}}e.Queue=p;class P{constructor(){this.queues=new Map}queueFor(N,W=D.extUri){const U=W.getComparisonKey(N);let B=this.queues.get(U);return B||(B=new p,S.Event.once(B.onFinished)(()=>{B==null||B.dispose(),this.queues.delete(U)}),this.queues.set(U,B)),B}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=P;class A{constructor(N,W){this._token=-1,typeof N=="function"&&typeof W=="number"&&this.setIfNotSet(N,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},W)}setIfNotSet(N,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},W))}}e.TimeoutTimer=A;class a{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,W){this.cancel(),this._token=setInterval(()=>{N()},W)}}e.IntervalTimer=a;class R{constructor(N,W){this.timeoutToken=-1,this.runner=N,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class M extends R{constructor(N,W){super(N,W);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=M,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const q=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=N=>{const W=setTimeout(()=>N(q));let U=!1;return{dispose(){U||(U=!0,clearTimeout(W))}}}}else e.runWhenIdle=(q,N)=>{const W=requestIdleCallback(q,typeof N=="number"?{timeout:N}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(W))}}}}();class H{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=H;async function ue(q,N,W){let U;for(let B=0;B<W;B++)try{return await q()}catch(J){U=J,await m(N)}throw U}e.retry=ue;class fe{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var N;(N=this._pending)===null||N===void 0||N.cancel()}setPending(N,W,U){return this._pending={taskId:N,cancel:()=>U==null?void 0:U(),promise:W},W.then(()=>this.donePending(N),()=>this.donePending(N)),W}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let W,U;const B=new Promise((J,he)=>{W=J,U=he});this._next={run:N,promise:B,promiseResolve:W,promiseReject:U}}return this._next.promise}}e.TaskSequentializer=fe;class Y{constructor(N){this.interval=N,this.lastIncrementTime=0,this.value=0}increment(){const N=Date.now();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=Y;class j{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,W)=>{this.completeCallback=N,this.errorCallback=W})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(W=>{this.completeCallback(N),this.resolved=!0,W()})}error(N){return new Promise(W=>{this.errorCallback(N),this.rejected=!0,W()})}cancel(){new Promise(N=>{this.errorCallback(T.canceled()),this.rejected=!0,N()})}}e.DeferredPromise=j;class Z extends S.Emitter{async fireAsync(N,W,U){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const B of this._listeners)this._asyncDeliveryQueue.push([B,N]);for(;this._asyncDeliveryQueue.size>0&&!W.isCancellationRequested;){const[B,J]=this._asyncDeliveryQueue.shift(),he=[],De=Object.assign(Object.assign({},J),{waitUntil:Oe=>{if(Object.isFrozen(he))throw new Error("waitUntil can NOT be called asynchronous");U&&(Oe=U(Oe,typeof B=="function"?B:B[0])),he.push(Oe)}});try{typeof B=="function"?B.call(void 0,De):B[0].call(B[1],De)}catch(Oe){T.onUnexpectedError(Oe);continue}Object.freeze(he),await L.settled(he).catch(Oe=>T.onUnexpectedError(Oe))}}}}e.AsyncEmitter=Z;var L;(function(q){async function N(J){return typeof Promise.allSettled=="function"?W(J):U(J)}q.allSettled=N;async function W(J){return Promise.allSettled(J)}async function U(J){return Promise.all(J.map(he=>he.then(De=>({status:"fulfilled",value:De}),De=>({status:"rejected",reason:De}))))}async function B(J){let he;const De=await Promise.all(J.map(Oe=>Oe.then(Me=>Me,Me=>{he||(he=Me)})));if(typeof he!="undefined")throw he;return De}q.settled=B})(L=e.Promises||(e.Promises={}))}),define(we[112],_e([0,1,14,12]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new T.IdleValue(()=>{const A=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:A,collatorIsNumeric:A.resolvedOptions().numeric}}),E=new T.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new T.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(A,a,R=!1){const M=A||"",H=a||"",ue=S.value.collator.compare(M,H);return S.value.collatorIsNumeric&&ue===0&&M!==H?M<H?-1:1:ue}e.compareFileNames=D;function _(A,a){const R=E.value.collator;return A=A||"",a=a||"",m(R,A,a)}e.compareFileNamesDefault=_;function C(A,a){const R=E.value.collator;return A=A||"",a=a||"",r(A,a)||m(R,A,a)}e.compareFileNamesUpper=C;function i(A,a){const R=E.value.collator;return A=A||"",a=a||"",s(A,a)||m(R,A,a)}e.compareFileNamesLower=i;function I(A,a){return A=A||"",a=a||"",A===a?0:A<a?-1:1}e.compareFileNamesUnicode=I;function o(A,a,R=!1){R||(A=A&&A.toLowerCase(),a=a&&a.toLowerCase());const[M,H]=l(A),[ue,fe]=l(a);return M!==ue?M<ue?-1:1:H===fe?0:H<fe?-1:1}e.noIntlCompareFileNames=o;function f(A,a){const[R,M]=l(A),[H,ue]=l(a);let fe=S.value.collator.compare(M,ue);if(fe===0){if(S.value.collatorIsNumeric&&M!==ue)return M<ue?-1:1;if(fe=S.value.collator.compare(R,H),S.value.collatorIsNumeric&&fe===0&&R!==H)return R<H?-1:1}return fe}e.compareFileExtensions=f;function c(A,a){A=A||"",a=a||"";const R=h(A),M=h(a),H=E.value.collator,ue=k.value.collator;return m(ue,R,M)||m(H,A,a)}e.compareFileExtensionsDefault=c;function d(A,a){A=A||"",a=a||"";const R=h(A),M=h(a),H=E.value.collator,ue=k.value.collator;return m(ue,R,M)||r(A,a)||m(H,A,a)}e.compareFileExtensionsUpper=d;function y(A,a){A=A||"",a=a||"";const R=h(A),M=h(a),H=E.value.collator,ue=k.value.collator;return m(ue,R,M)||s(A,a)||m(H,A,a)}e.compareFileExtensionsLower=y;function w(A,a){A=A||"",a=a||"";const R=h(A).toLowerCase(),M=h(a).toLowerCase();return R!==M?R<M?-1:1:A!==a?A<a?-1:1:0}e.compareFileExtensionsUnicode=w;const v=/^(.*?)(\.([^.]*))?$/;function l(A,a=!1){const R=A?v.exec(A):[];let M=[R&&R[1]||"",R&&R[3]||""];return a&&(!M[0]&&M[1]||M[0]&&M[0].charAt(0)===".")&&(M=[M[0]+"."+M[1],""]),M}function h(A){const a=A?v.exec(A):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function m(A,a,R){let M=A.compare(a,R);return M!==0?M:a.length!==R.length?a.length<R.length?-1:1:0}function t(A){const a=A.charAt(0);return a.toLocaleUpperCase()!==a}function n(A){const a=A.charAt(0);return a.toLocaleLowerCase()!==a}function s(A,a){return t(A)&&n(a)?-1:n(A)&&t(a)?1:0}function r(A,a){return n(A)&&t(a)?-1:t(A)&&n(a)?1:0}function u(A,a,R=!1){return R||(A=A&&A.toLowerCase(),a=a&&a.toLowerCase()),A===a?0:A<a?-1:1}function b(A,a,R=!1){const M=A.split(g.sep),H=a.split(g.sep),ue=M.length-1,fe=H.length-1;let Y,j;for(let Z=0;;Z++){if(Y=ue===Z,j=fe===Z,Y&&j)return D(M[Z],H[Z],R);if(Y)return-1;if(j)return 1;const L=u(M[Z],H[Z],R);if(L!==0)return L}}e.comparePaths=b;function p(A,a,R){const M=A.toLowerCase(),H=a.toLowerCase(),ue=P(A,a,R);if(ue)return ue;const fe=M.endsWith(R),Y=H.endsWith(R);if(fe!==Y)return fe?-1:1;const j=D(M,H);return j!==0?j:M.localeCompare(H)}e.compareAnything=p;function P(A,a,R){const M=A.toLowerCase(),H=a.toLowerCase(),ue=M.startsWith(R),fe=H.startsWith(R);if(ue!==fe)return ue?-1:1;if(ue&&fe){if(M.length<H.length)return-1;if(M.length>H.length)return 1}return 0}e.compareByPrefix=P}),define(we[27],_e([0,1,8,43,14,22,12]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const _="**",C="/",i="[/\\\\]",I="[^/\\\\]",o=/\//g;function f(W){switch(W){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function c(W,U){if(!W)return[];const B=[];let J=!1,he=!1,De="";for(const Oe of W){switch(Oe){case U:if(!J&&!he){B.push(De),De="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":he=!0;break;case"]":he=!1;break}De+=Oe}return De&&B.push(De),B}e.splitGlobAware=c;function d(W){if(!W)return"";let U="";const B=c(W,C);if(B.every(J=>J===_))U=".*";else{let J=!1;B.forEach((he,De)=>{if(he===_){J||(U+=f(2),J=!0);return}let Oe=!1,Me="",He=!1,Ye="";for(const qe of he){if(qe!=="}"&&Oe){Me+=qe;continue}if(He&&(qe!=="]"||!Ye)){let Xe;qe==="-"?Xe=qe:(qe==="^"||qe==="!")&&!Ye?Xe="^":qe===C?Xe="":Xe=g.escapeRegExpCharacters(qe),Ye+=Xe;continue}switch(qe){case"{":Oe=!0;continue;case"[":He=!0;continue;case"}":U+=`(?:${c(Me,",").map(G=>d(G)).join("|")})`,Oe=!1,Me="";break;case"]":U+="["+Ye+"]",He=!1,Ye="";break;case"?":U+=I;continue;case"*":U+=f(1);continue;default:U+=g.escapeRegExpCharacters(qe)}}De<B.length-1&&(B[De+1]!==_||De+2<B.length)&&(U+=i),J=!1})}return U}const y=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new E.LRUCache(1e4),n=function(){return!1},s=function(){return null};function r(W,U){if(!W)return s;let B;typeof W!="string"?B=W.pattern:B=W,B=B.trim();const J=`${B}_${!!U.trimForExclusions}`;let he=t.get(J);if(he)return u(he,W);let De;if(y.test(B)){const Oe=B.substr(4);he=function(Me,He){return typeof Me=="string"&&Me.endsWith(Oe)?B:null}}else(De=w.exec(b(B,U)))?he=p(De[1],B):(U.trimForExclusions?l:v).test(B)?he=P(B,U):(De=h.exec(b(B,U)))?he=A(De[1].substr(1),B,!0):(De=m.exec(b(B,U)))?he=A(De[1],B,!1):he=a(B);return t.set(J,he),u(he,W)}function u(W,U){return typeof U=="string"?W:function(B,J){return T.isEqualOrParent(B,U.base)?W(S.relative(U.base,B),J):null}}function b(W,U){return U.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function p(W,U){const B=`/${W}`,J=`\\${W}`,he=function(Oe,Me){return typeof Oe!="string"?null:Me?Me===W?U:null:Oe===W||Oe.endsWith(B)||Oe.endsWith(J)?U:null},De=[W];return he.basenames=De,he.patterns=[U],he.allBasenames=De,he}function P(W,U){const B=N(W.slice(1,-1).split(",").map(Me=>r(Me,U)).filter(Me=>Me!==s),W),J=B.length;if(!J)return s;if(J===1)return B[0];const he=function(Me,He){for(let Ye=0,qe=B.length;Ye<qe;Ye++)if(B[Ye](Me,He))return W;return null},De=B.find(Me=>!!Me.allBasenames);De&&(he.allBasenames=De.allBasenames);const Oe=B.reduce((Me,He)=>He.allPaths?Me.concat(He.allPaths):Me,[]);return Oe.length&&(he.allPaths=Oe),he}function A(W,U,B){const J=S.sep===S.posix.sep,he=J?W:W.replace(o,S.sep),De=S.sep+he,Oe=S.posix.sep+W,Me=B?function(He,Ye){return typeof He=="string"&&(He===he||He.endsWith(De)||!J&&(He===W||He.endsWith(Oe)))?U:null}:function(He,Ye){return typeof He=="string"&&(He===he||!J&&He===W)?U:null};return Me.allPaths=[(B?"*/":"./")+W],Me}function a(W){try{const U=new RegExp(`^${d(W)}$`);return function(B){return U.lastIndex=0,typeof B=="string"&&U.test(B)?W:null}}catch(U){return s}}function R(W,U,B){return!W||typeof U!="string"?!1:M(W)(U,void 0,B)}e.match=R;function M(W,U={}){if(!W)return n;if(typeof W=="string"||Y(W)){const B=r(W,U);if(B===s)return n;const J=function(he,De){return!!B(he,De)};return B.allBasenames&&(J.allBasenames=B.allBasenames),B.allPaths&&(J.allPaths=B.allPaths),J}return L(W,U)}e.parse=M;function H(W){if(!W)return;let U;return B=>(U||(U=(W()||Promise.resolve([])).then(J=>J?fe(J):{})),U.then(J=>!!J[B]))}e.hasSiblingPromiseFn=H;function ue(W){if(!W)return;let U;return B=>{if(!U){const J=W();U=J?fe(J):{}}return!!U[B]}}e.hasSiblingFn=ue;function fe(W){const U={};for(const B of W)U[B]=!0;return U}function Y(W){const U=W;return U&&typeof U.base=="string"&&typeof U.pattern=="string"}e.isRelativePattern=Y;function j(W){return W.allBasenames||[]}e.getBasenameTerms=j;function Z(W){return W.allPaths||[]}e.getPathTerms=Z;function L(W,U){const B=N(Object.getOwnPropertyNames(W).map(Me=>q(Me,W[Me],U)).filter(Me=>Me!==s)),J=B.length;if(!J)return s;if(!B.some(Me=>!!Me.requiresSiblings)){if(J===1)return B[0];const Me=function(qe,Xe){for(let $=0,G=B.length;$<G;$++){const te=B[$](qe,Xe);if(te)return te}return null},He=B.find(qe=>!!qe.allBasenames);He&&(Me.allBasenames=He.allBasenames);const Ye=B.reduce((qe,Xe)=>Xe.allPaths?qe.concat(Xe.allPaths):qe,[]);return Ye.length&&(Me.allPaths=Ye),Me}const he=function(Me,He,Ye){let qe;for(let Xe=0,$=B.length;Xe<$;Xe++){const G=B[Xe];G.requiresSiblings&&Ye&&(He||(He=S.basename(Me)),qe||(qe=He.substr(0,He.length-S.extname(Me).length)));const te=G(Me,He,qe,Ye);if(te)return te}return null},De=B.find(Me=>!!Me.allBasenames);De&&(he.allBasenames=De.allBasenames);const Oe=B.reduce((Me,He)=>He.allPaths?Me.concat(He.allPaths):Me,[]);return Oe.length&&(he.allPaths=Oe),he}function q(W,U,B){if(U===!1)return s;const J=r(W,B);if(J===s)return s;if(typeof U=="boolean")return J;if(U){const he=U.when;if(typeof he=="string"){const De=(Oe,Me,He,Ye)=>{if(!Ye||!J(Oe,Me))return null;const qe=he.replace("$(basename)",He),Xe=Ye(qe);return k.isThenable(Xe)?Xe.then($=>$?W:null):Xe?W:null};return De.requiresSiblings=!0,De}}return J}function N(W,U){const B=W.filter(Me=>!!Me.basenames);if(B.length<2)return W;const J=B.reduce((Me,He)=>{const Ye=He.basenames;return Ye?Me.concat(Ye):Me},[]);let he;if(U){he=[];for(let Me=0,He=J.length;Me<He;Me++)he.push(U)}else he=B.reduce((Me,He)=>{const Ye=He.patterns;return Ye?Me.concat(Ye):Me},[]);const De=function(Me,He){if(typeof Me!="string")return null;if(!He){let qe;for(qe=Me.length;qe>0;qe--){const Xe=Me.charCodeAt(qe-1);if(Xe===47||Xe===92)break}He=Me.substr(qe)}const Ye=J.indexOf(He);return Ye!==-1?he[Ye]:null};De.basenames=J,De.patterns=he,De.allBasenames=J;const Oe=W.filter(Me=>!Me.basenames);return Oe.push(De),Oe}}),define(we[81],_e([0,1,2,14,8,16,21,25,43]),function(ee,e,g,T,S,E,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(r,u,b){if(typeof r=="string"&&(r=g.URI.file(r)),b){const P=b.getWorkspaceFolder(r);if(P){const A=b.getWorkspace().folders.length>1;let a;if(D.isEqual(P.uri,r)?a="":a=D.relativePath(P.uri,r),A){const R=P.name?P.name:D.basename(P.uri);a=a?R+" \u2022 "+a:R}return a}}if(r.scheme!==E.Schemas.file&&r.scheme!==E.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if(_.hasDriveLetter(r.fsPath))return T.normalize(I(r.fsPath));let p=T.normalize(r.fsPath);return!k.isWindows&&(u==null?void 0:u.userHome)&&(p=f(p,u.userHome.fsPath)),p}e.getPathLabel=C;function i(r){if(!r)return;typeof r=="string"&&(r=g.URI.file(r));const u=D.basename(r)||(r.scheme===E.Schemas.file?r.fsPath:r.path);return k.isWindows&&_.isRootOrDriveLetter(u)?I(u):u}e.getBaseLabel=i;function I(r){return _.hasDriveLetter(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=I;let o=Object.create(null);function f(r,u){if(k.isWindows||!r||!u)return r;let b=o.original===u?o.normalized:void 0;return b||(b=`${S.rtrim(u,T.posix.sep)}${T.posix.sep}`,o={original:u,normalized:b}),(k.isLinux?r.startsWith(b):S.startsWithIgnoreCase(r,b))&&(r=`~/${r.substr(b.length)}`),r}e.tildify=f;function c(r,u){return r.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=c;const d="\u2026",y="\\\\",w="~";function v(r,u=T.sep){const b=new Array(r.length);let p=!1;for(let P=0;P<r.length;P++){let A=r[P];if(A===""){b[P]=`.${u}`;continue}if(!A){b[P]=A;continue}p=!0;let a="";A.indexOf(y)===0?(a=A.substr(0,A.indexOf(y)+y.length),A=A.substr(A.indexOf(y)+y.length)):A.indexOf(u)===0?(a=A.substr(0,A.indexOf(u)+u.length),A=A.substr(A.indexOf(u)+u.length)):A.indexOf(w)===0&&(a=A.substr(0,A.indexOf(w)+w.length),A=A.substr(A.indexOf(w)+w.length));const R=A.split(u);for(let M=1;p&&M<=R.length;M++)for(let H=R.length-M;p&&H>=0;H--){p=!1;let ue=R.slice(H,H+M).join(u);for(let fe=0;!p&&fe<r.length;fe++)if(fe!==P&&r[fe]&&r[fe].indexOf(ue)>-1){const Y=H+M===R.length,j=H>0&&r[fe].indexOf(u)>-1?u+ue:ue,Z=r[fe].endsWith(j);p=!Y||Z}if(!p){let fe="";(R[0].endsWith(":")||a!=="")&&(H===1&&(H=0,M++,ue=R[0]+u+ue),H>0&&(fe=R[0]+u),fe=a+fe),H>0&&(fe=fe+d+u),fe=fe+ue,H+M<R.length&&(fe=fe+u+d),b[P]=fe}}p&&(b[P]=A)}return b}e.shorten=v;var l;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function h(r,u=Object.create(null)){const b=[];let p=!1,P="";for(const A of r)if(A==="$"||p&&A==="{")P&&b.push({value:P,type:l.TEXT}),P="",p=!0;else if(A==="}"&&p){const a=u[P];if(typeof a=="string")a.length&&b.push({value:a,type:l.VARIABLE});else if(a){const R=b[b.length-1];(!R||R.type!==l.SEPARATOR)&&b.push({value:a.label,type:l.SEPARATOR})}P="",p=!1}else P+=A;return P&&!p&&b.push({value:P,type:l.TEXT}),b.filter((A,a)=>{if(A.type===l.SEPARATOR){const R=b[a-1],M=b[a+1];return[R,M].every(H=>H&&(H.type===l.VARIABLE||H.type===l.TEXT)&&H.value.length>0)}return!0}).map(A=>A.value).join("")}e.template=h;function m(r,u){return k.isMacintosh||u?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):r.replace(/&&|&/g,b=>b==="&"?"&&":"&")}e.mnemonicMenuLabel=m;function t(r,u){return k.isMacintosh||u?r.replace(/\(&&\w\)|&&/g,""):k.isWindows?r.replace(/&&|&/g,b=>b==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(r){const u=r.indexOf("/")!==-1?T.posix:T.win32,b=u.basename(r),p=u.dirname(r);return b.length?{name:b,parentPath:p}:{name:p,parentPath:""}}e.splitName=s}),define(we[82],_e([0,1,14,8,27,16,25]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var D;(function(n){n.text="text/plain",n.binary="application/octet-stream",n.unknown="application/unknown",n.markdown="text/markdown"})(D=e.Mimes||(e.Mimes={}));let _=[],C=[],i=[];function I(n,s=!1){const r=o(n);_.push(r),r.userConfigured?i.push(r):C.push(r),s&&!r.userConfigured&&_.forEach(u=>{u.mime===r.mime||u.userConfigured||(r.extension&&u.extension===r.extension&&console.warn(`Overwriting extension <<${r.extension}>> to now point to mime <<${r.mime}>>`),r.filename&&u.filename===r.filename&&console.warn(`Overwriting filename <<${r.filename}>> to now point to mime <<${r.mime}>>`),r.filepattern&&u.filepattern===r.filepattern&&console.warn(`Overwriting filepattern <<${r.filepattern}>> to now point to mime <<${r.mime}>>`),r.firstline&&u.firstline===r.firstline&&console.warn(`Overwriting firstline <<${r.firstline}>> to now point to mime <<${r.mime}>>`))})}e.registerTextMime=I;function o(n){return{id:n.id,mime:n.mime,filename:n.filename,extension:n.extension,filepattern:n.filepattern,firstline:n.firstline,userConfigured:n.userConfigured,filenameLowercase:n.filename?n.filename.toLowerCase():void 0,extensionLowercase:n.extension?n.extension.toLowerCase():void 0,filepatternLowercase:n.filepattern?n.filepattern.toLowerCase():void 0,filepatternOnPath:n.filepattern?n.filepattern.indexOf(g.posix.sep)>=0:!1}}function f(n){n?(_=_.filter(s=>!s.userConfigured),i=[]):(_=[],C=[],i=[])}e.clearTextMimes=f;function c(n,s){let r;if(n)switch(n.scheme){case E.Schemas.file:r=n.fsPath;break;case E.Schemas.data:r=k.DataUri.parseMetaData(n).get(k.DataUri.META_DATA_LABEL);break;default:r=n.path}if(!r)return[D.unknown];r=r.toLowerCase();const u=g.basename(r),b=d(r,u,i);if(b)return[b,D.text];const p=d(r,u,C);if(p)return[p,D.text];if(s){const P=y(s);if(P)return[P,D.text]}return[D.unknown]}e.guessMimeTypes=c;function d(n,s,r){let u=null,b=null,p=null;for(let P=r.length-1;P>=0;P--){const A=r[P];if(s===A.filenameLowercase){u=A;break}if(A.filepattern&&(!b||A.filepattern.length>b.filepattern.length)){const a=A.filepatternOnPath?n:s;S.match(A.filepatternLowercase,a)&&(b=A)}A.extension&&(!p||A.extension.length>p.extension.length)&&s.endsWith(A.extensionLowercase)&&(p=A)}return u?u.mime:b?b.mime:p?p.mime:null}function y(n){if(T.startsWithUTF8BOM(n)&&(n=n.substr(1)),n.length>0)for(let s=_.length-1;s>=0;s--){const r=_[s];if(!r.firstline)continue;const u=n.match(r.firstline);if(u&&u.length>0)return r.mime}return null}function w(n){return n?typeof n=="string"?n===D.binary||n===D.text||n===D.unknown:n.length===1&&w(n[0]):!0}e.isUnspecific=w;const v={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function l(n){const s=g.extname(n);return v[s.toLowerCase()]}e.getMediaMime=l;function h(n){for(const s in v)if(v[s]===n)return s}e.getExtensionForMimeType=h;const m=/^(.+)\/(.+?)(;.+)?$/;function t(n,s){var r;const u=m.exec(n);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${(r=u[3])!==null&&r!==void 0?r:""}`:s?void 0:n}e.normalizeMimeType=t}),define(we[113],_e([0,1,2]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(i){return i.toJSON()}class S{constructor(I){this._uriTransformer=I}transformIncoming(I){const o=this._uriTransformer.transformIncoming(I);return o===I?I:T(g.URI.from(o))}transformOutgoing(I){const o=this._uriTransformer.transformOutgoing(I);return o===I?I:T(g.URI.from(o))}transformOutgoingURI(I){const o=this._uriTransformer.transformOutgoing(I);return o===I?I:g.URI.from(o)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function E(i,I,o){if(!i||o>200)return null;if(typeof i=="object"){if(i instanceof g.URI)return I.transformOutgoing(i);for(let f in i)if(Object.hasOwnProperty.call(i,f)){const c=E(i[f],I,o+1);c!==null&&(i[f]=c)}}return null}function k(i,I){const o=E(i,I,0);return o===null?i:o}e.transformOutgoingURIs=k;function D(i,I,o,f){if(!i||f>200)return null;if(typeof i=="object"){if(i.$mid===1)return o?g.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let c in i)if(Object.hasOwnProperty.call(i,c)){const d=D(i[c],I,o,f+1);d!==null&&(i[c]=d)}}return null}function _(i,I){const o=D(i,I,!1,0);return o===null?i:o}e.transformIncomingURIs=_;function C(i,I){const o=D(i,I,!0,0);return o===null?i:o}e.transformAndReviveIncomingURIs=C}),define(we[34],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(_){return g.test(_)}e.isUUID=T;const S=new Uint8Array(16),E=[];for(let _=0;_<256;_++)E.push(_.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(_){for(let C=0;C<_.length;C++)_[C]=Math.floor(Math.random()*256);return _};function D(){k(S),S[6]=S[6]&15|64,S[8]=S[8]&63|128;let _=0,C="";return C+=E[S[_++]],C+=E[S[_++]],C+=E[S[_++]],C+=E[S[_++]],C+="-",C+=E[S[_++]],C+=E[S[_++]],C+="-",C+=E[S[_++]],C+=E[S[_++]],C+="-",C+=E[S[_++]],C+=E[S[_++]],C+="-",C+=E[S[_++]],C+=E[S[_++]],C+=E[S[_++]],C+=E[S[_++]],C+=E[S[_++]],C+=E[S[_++]],C}e.generateUuid=D}),define(we[83],_e([0,1,79]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class T{constructor(D){let _=g.toUint8(D);this._defaultValue=_,this._asciiMap=T._createAsciiMap(_),this._map=new Map}static _createAsciiMap(D){let _=new Uint8Array(256);for(let C=0;C<256;C++)_[C]=D;return _}set(D,_){let C=g.toUint8(_);D>=0&&D<256?this._asciiMap[D]=C:this._map.set(D,C)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=T;var S;(function(k){k[k.False=0]="False",k[k.True=1]="True"})(S||(S={}));class E{constructor(){this._actual=new T(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=E}),define(we[114],_e([0,1,83]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var T;(function(k){k[k.Regular=0]="Regular",k[k.Whitespace=1]="Whitespace",k[k.WordSeparator=2]="WordSeparator"})(T=e.WordCharacterClass||(e.WordCharacterClass={}));class S extends g.CharacterClassifier{constructor(D){super(0);for(let _=0,C=D.length;_<C;_++)this.set(D.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=S;function E(k){let D={};return _=>(D.hasOwnProperty(_)||(D[_]=k(_)),D[_])}e.getMapForWordSeparators=E(k=>new S(k))}),define(we[35],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(S,E){this.lineNumber=S,this.column=E}with(S=this.lineNumber,E=this.column){return S===this.lineNumber&&E===this.column?this:new g(S,E)}delta(S=0,E=0){return this.with(this.lineNumber+S,this.column+E)}equals(S){return g.equals(this,S)}static equals(S,E){return!S&&!E?!0:!!S&&!!E&&S.lineNumber===E.lineNumber&&S.column===E.column}isBefore(S){return g.isBefore(this,S)}static isBefore(S,E){return S.lineNumber<E.lineNumber?!0:E.lineNumber<S.lineNumber?!1:S.column<E.column}isBeforeOrEqual(S){return g.isBeforeOrEqual(this,S)}static isBeforeOrEqual(S,E){return S.lineNumber<E.lineNumber?!0:E.lineNumber<S.lineNumber?!1:S.column<=E.column}static compare(S,E){let k=S.lineNumber|0,D=E.lineNumber|0;if(k===D){let _=S.column|0,C=E.column|0;return _-C}return k-D}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(S){return new g(S.lineNumber,S.column)}static isIPosition(S){return S&&typeof S.lineNumber=="number"&&typeof S.column=="number"}}e.Position=g}),define(we[31],_e([0,1,35]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class T{constructor(E,k,D,_){E>D||E===D&&k>_?(this.startLineNumber=D,this.startColumn=_,this.endLineNumber=E,this.endColumn=k):(this.startLineNumber=E,this.startColumn=k,this.endLineNumber=D,this.endColumn=_)}isEmpty(){return T.isEmpty(this)}static isEmpty(E){return E.startLineNumber===E.endLineNumber&&E.startColumn===E.endColumn}containsPosition(E){return T.containsPosition(this,E)}static containsPosition(E,k){return!(k.lineNumber<E.startLineNumber||k.lineNumber>E.endLineNumber||k.lineNumber===E.startLineNumber&&k.column<E.startColumn||k.lineNumber===E.endLineNumber&&k.column>E.endColumn)}containsRange(E){return T.containsRange(this,E)}static containsRange(E,k){return!(k.startLineNumber<E.startLineNumber||k.endLineNumber<E.startLineNumber||k.startLineNumber>E.endLineNumber||k.endLineNumber>E.endLineNumber||k.startLineNumber===E.startLineNumber&&k.startColumn<E.startColumn||k.endLineNumber===E.endLineNumber&&k.endColumn>E.endColumn)}strictContainsRange(E){return T.strictContainsRange(this,E)}static strictContainsRange(E,k){return!(k.startLineNumber<E.startLineNumber||k.endLineNumber<E.startLineNumber||k.startLineNumber>E.endLineNumber||k.endLineNumber>E.endLineNumber||k.startLineNumber===E.startLineNumber&&k.startColumn<=E.startColumn||k.endLineNumber===E.endLineNumber&&k.endColumn>=E.endColumn)}plusRange(E){return T.plusRange(this,E)}static plusRange(E,k){let D,_,C,i;return k.startLineNumber<E.startLineNumber?(D=k.startLineNumber,_=k.startColumn):k.startLineNumber===E.startLineNumber?(D=k.startLineNumber,_=Math.min(k.startColumn,E.startColumn)):(D=E.startLineNumber,_=E.startColumn),k.endLineNumber>E.endLineNumber?(C=k.endLineNumber,i=k.endColumn):k.endLineNumber===E.endLineNumber?(C=k.endLineNumber,i=Math.max(k.endColumn,E.endColumn)):(C=E.endLineNumber,i=E.endColumn),new T(D,_,C,i)}intersectRanges(E){return T.intersectRanges(this,E)}static intersectRanges(E,k){let D=E.startLineNumber,_=E.startColumn,C=E.endLineNumber,i=E.endColumn,I=k.startLineNumber,o=k.startColumn,f=k.endLineNumber,c=k.endColumn;return D<I?(D=I,_=o):D===I&&(_=Math.max(_,o)),C>f?(C=f,i=c):C===f&&(i=Math.min(i,c)),D>C||D===C&&_>i?null:new T(D,_,C,i)}equalsRange(E){return T.equalsRange(this,E)}static equalsRange(E,k){return!!E&&!!k&&E.startLineNumber===k.startLineNumber&&E.startColumn===k.startColumn&&E.endLineNumber===k.endLineNumber&&E.endColumn===k.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(E){return new g.Position(E.endLineNumber,E.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(E){return new g.Position(E.startLineNumber,E.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(E,k){return new T(this.startLineNumber,this.startColumn,E,k)}setStartPosition(E,k){return new T(E,k,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(E){return new T(E.startLineNumber,E.startColumn,E.startLineNumber,E.startColumn)}static fromPositions(E,k=E){return new T(E.lineNumber,E.column,k.lineNumber,k.column)}static lift(E){return E?new T(E.startLineNumber,E.startColumn,E.endLineNumber,E.endColumn):null}static isIRange(E){return E&&typeof E.startLineNumber=="number"&&typeof E.startColumn=="number"&&typeof E.endLineNumber=="number"&&typeof E.endColumn=="number"}static areIntersectingOrTouching(E,k){return!(E.endLineNumber<k.startLineNumber||E.endLineNumber===k.startLineNumber&&E.endColumn<k.startColumn||k.endLineNumber<E.startLineNumber||k.endLineNumber===E.startLineNumber&&k.endColumn<E.startColumn)}static areIntersecting(E,k){return!(E.endLineNumber<k.startLineNumber||E.endLineNumber===k.startLineNumber&&E.endColumn<=k.startColumn||k.endLineNumber<E.startLineNumber||k.endLineNumber===E.startLineNumber&&k.endColumn<=E.startColumn)}static compareRangesUsingStarts(E,k){if(E&&k){const C=E.startLineNumber|0,i=k.startLineNumber|0;if(C===i){const I=E.startColumn|0,o=k.startColumn|0;if(I===o){const f=E.endLineNumber|0,c=k.endLineNumber|0;if(f===c){const d=E.endColumn|0,y=k.endColumn|0;return d-y}return f-c}return I-o}return C-i}return(E?1:0)-(k?1:0)}static compareRangesUsingEnds(E,k){return E.endLineNumber===k.endLineNumber?E.endColumn===k.endColumn?E.startLineNumber===k.startLineNumber?E.startColumn-k.startColumn:E.startLineNumber-k.startLineNumber:E.endColumn-k.endColumn:E.endLineNumber-k.endLineNumber}static spansMultipleLines(E){return E.endLineNumber>E.startLineNumber}}e.Range=T}),define(we[115],_e([0,1,35,31]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var S;(function(k){k[k.LTR=0]="LTR",k[k.RTL=1]="RTL"})(S=e.SelectionDirection||(e.SelectionDirection={}));class E extends T.Range{constructor(D,_,C,i){super(D,_,C,i);this.selectionStartLineNumber=D,this.selectionStartColumn=_,this.positionLineNumber=C,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return E.selectionsEqual(this,D)}static selectionsEqual(D,_){return D.selectionStartLineNumber===_.selectionStartLineNumber&&D.selectionStartColumn===_.selectionStartColumn&&D.positionLineNumber===_.positionLineNumber&&D.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,_){return this.getDirection()===0?new E(this.startLineNumber,this.startColumn,D,_):new E(D,_,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(D,_){return this.getDirection()===0?new E(D,_,this.endLineNumber,this.endColumn):new E(this.endLineNumber,this.endColumn,D,_)}static fromPositions(D,_=D){return new E(D.lineNumber,D.column,_.lineNumber,_.column)}static liftSelection(D){return new E(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,_){if(D&&!_||!D&&_)return!1;if(!D&&!_)return!0;if(D.length!==_.length)return!1;for(let C=0,i=D.length;C<i;C++)if(!this.selectionsEqual(D[C],_[C]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,_,C,i,I){return I===0?new E(D,_,C,i):new E(C,i,D,_)}}e.Selection=E}),define(we[84],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var g;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(g=e.OverviewRulerLane||(e.OverviewRulerLane={}));var T;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(T=e.MinimapPosition||(e.MinimapPosition={}));var S;(function(c){c[c.TextDefined=0]="TextDefined",c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(S=e.EndOfLinePreference||(e.EndOfLinePreference={}));var E;(function(c){c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(E=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(c){c[c.LF=0]="LF",c[c.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(d){this.tabSize=Math.max(1,d.tabSize|0),this.indentSize=d.tabSize|0,this.insertSpaces=Boolean(d.insertSpaces),this.defaultEOL=d.defaultEOL|0,this.trimAutoWhitespace=Boolean(d.trimAutoWhitespace)}equals(d){return this.tabSize===d.tabSize&&this.indentSize===d.indentSize&&this.insertSpaces===d.insertSpaces&&this.defaultEOL===d.defaultEOL&&this.trimAutoWhitespace===d.trimAutoWhitespace}createChangeEvent(d){return{tabSize:this.tabSize!==d.tabSize,indentSize:this.indentSize!==d.indentSize,insertSpaces:this.insertSpaces!==d.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==d.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class _{constructor(d,y){this.range=d,this.matches=y}}e.FindMatch=_;var C;(function(c){c[c.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",c[c.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",c[c.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",c[c.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(c){c[c.Left=0]="Left",c[c.Right=1]="Right"})(i=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var I;(function(c){c[c.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class o{constructor(d,y,w,v,l,h){this.identifier=d,this.range=y,this.text=w,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=l,this._isTracked=h}}e.ValidAnnotatedEditOperation=o;class f{constructor(d,y,w){this.reverseEdits=d,this.changes=y,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=f}),define(we[116],_e([0,1,8,114,35,31,84]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class _{constructor(l,h,m,t){this.searchString=l,this.isRegex=h,this.matchCase=m,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let l;this.isRegex?l=C(this.searchString):l=this.searchString.indexOf(`
`)>=0;let h=null;try{h=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:l,global:!0,unicode:!0})}catch(t){return null}if(!h)return null;let m=!this.isRegex&&!l;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new i(h,this.wordSeparators?T.getMapForWordSeparators(this.wordSeparators):null,m?this.searchString:null)}}e.SearchParams=_;function C(v){if(!v||v.length===0)return!1;for(let l=0,h=v.length;l<h;l++)if(v.charCodeAt(l)===92){if(l++,l>=h)break;const t=v.charCodeAt(l);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=C;class i{constructor(l,h,m){this.regex=l,this.wordSeparators=h,this.simpleSearch=m}}e.SearchData=i;function I(v,l,h){if(!h)return new k.FindMatch(v,null);let m=[];for(let t=0,n=l.length;t<n;t++)m[t]=l[t];return new k.FindMatch(v,m)}e.createFindMatch=I;class o{constructor(l){let h=[],m=0;for(let t=0,n=l.length;t<n;t++)l.charCodeAt(t)===10&&(h[m++]=t);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(l){const h=this._lineFeedsOffsets;let m=0,t=h.length-1;if(t===-1||l<=h[0])return 0;for(;m<t;){const n=m+((t-m)/2>>0);h[n]>=l?t=n-1:h[n+1]>=l?(m=n,t=n):m=n+1}return m+1}}class f{static findMatches(l,h,m,t,n){const s=h.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(l,m,new w(s.wordSeparators,s.regex),t,n):this._doFindMatchesLineByLine(l,m,s,t,n):[]}static _getMultilineMatchRange(l,h,m,t,n,s){let r,u=0;t?(u=t.findLineFeedCountBeforeOffset(n),r=h+n+u):r=h+n;let b;if(t){let a=t.findLineFeedCountBeforeOffset(n+s.length)-u;b=r+s.length+a}else b=r+s.length;const p=l.getPositionAt(r),P=l.getPositionAt(b);return new E.Range(p.lineNumber,p.column,P.lineNumber,P.column)}static _doFindMatchesMultiline(l,h,m,t,n){const s=l.getOffsetAt(h.getStartPosition()),r=l.getValueInRange(h,1),u=l.getEOL()===`\r
`?new o(r):null,b=[];let p=0,P;for(m.reset(0);P=m.next(r);)if(b[p++]=I(this._getMultilineMatchRange(l,s,r,u,P.index,P[0]),P,t),p>=n)return b;return b}static _doFindMatchesLineByLine(l,h,m,t,n){const s=[];let r=0;if(h.startLineNumber===h.endLineNumber){const b=l.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return r=this._findMatchesInLine(m,b,h.startLineNumber,h.startColumn-1,r,s,t,n),s}const u=l.getLineContent(h.startLineNumber).substring(h.startColumn-1);r=this._findMatchesInLine(m,u,h.startLineNumber,h.startColumn-1,r,s,t,n);for(let b=h.startLineNumber+1;b<h.endLineNumber&&r<n;b++)r=this._findMatchesInLine(m,l.getLineContent(b),b,0,r,s,t,n);if(r<n){const b=l.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);r=this._findMatchesInLine(m,b,h.endLineNumber,0,r,s,t,n)}return s}static _findMatchesInLine(l,h,m,t,n,s,r,u){const b=l.wordSeparators;if(!r&&l.simpleSearch){const A=l.simpleSearch,a=A.length,R=h.length;let M=-a;for(;(M=h.indexOf(A,M+a))!==-1;)if((!b||y(b,h,R,M,a))&&(s[n++]=new k.FindMatch(new E.Range(m,M+1+t,m,M+1+a+t),null),n>=u))return n;return n}const p=new w(l.wordSeparators,l.regex);let P;p.reset(0);do if(P=p.next(h),P&&(s[n++]=I(new E.Range(m,P.index+1+t,m,P.index+1+P[0].length+t),P,r),n>=u))return n;while(P);return n}static findNextMatch(l,h,m,t){const n=h.parseSearchRequest();if(!n)return null;const s=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(l,m,s,t):this._doFindNextMatchLineByLine(l,m,s,t)}static _doFindNextMatchMultiline(l,h,m,t){const n=new S.Position(h.lineNumber,1),s=l.getOffsetAt(n),r=l.getLineCount(),u=l.getValueInRange(new E.Range(n.lineNumber,n.column,r,l.getLineMaxColumn(r)),1),b=l.getEOL()===`\r
`?new o(u):null;m.reset(h.column-1);let p=m.next(u);return p?I(this._getMultilineMatchRange(l,s,u,b,p.index,p[0]),p,t):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(l,new S.Position(1,1),m,t):null}static _doFindNextMatchLineByLine(l,h,m,t){const n=l.getLineCount(),s=h.lineNumber,r=l.getLineContent(s),u=this._findFirstMatchInLine(m,r,s,h.column,t);if(u)return u;for(let b=1;b<=n;b++){const p=(s+b-1)%n,P=l.getLineContent(p+1),A=this._findFirstMatchInLine(m,P,p+1,1,t);if(A)return A}return null}static _findFirstMatchInLine(l,h,m,t,n){l.reset(t-1);const s=l.next(h);return s?I(new E.Range(m,s.index+1,m,s.index+1+s[0].length),s,n):null}static findPreviousMatch(l,h,m,t){const n=h.parseSearchRequest();if(!n)return null;const s=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(l,m,s,t):this._doFindPreviousMatchLineByLine(l,m,s,t)}static _doFindPreviousMatchMultiline(l,h,m,t){const n=this._doFindMatchesMultiline(l,new E.Range(1,1,h.lineNumber,h.column),m,t,10*D);if(n.length>0)return n[n.length-1];const s=l.getLineCount();return h.lineNumber!==s||h.column!==l.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(l,new S.Position(s,l.getLineMaxColumn(s)),m,t):null}static _doFindPreviousMatchLineByLine(l,h,m,t){const n=l.getLineCount(),s=h.lineNumber,r=l.getLineContent(s).substring(0,h.column-1),u=this._findLastMatchInLine(m,r,s,t);if(u)return u;for(let b=1;b<=n;b++){const p=(n+s-b-1)%n,P=l.getLineContent(p+1),A=this._findLastMatchInLine(m,P,p+1,t);if(A)return A}return null}static _findLastMatchInLine(l,h,m,t){let n=null,s;for(l.reset(0);s=l.next(h);)n=I(new E.Range(m,s.index+1,m,s.index+1+s[0].length),s,t);return n}}e.TextModelSearch=f;function c(v,l,h,m,t){if(m===0)return!0;const n=l.charCodeAt(m-1);if(v.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=l.charCodeAt(m);if(v.get(s)!==0)return!0}return!1}function d(v,l,h,m,t){if(m+t===h)return!0;const n=l.charCodeAt(m+t);if(v.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=l.charCodeAt(m+t-1);if(v.get(s)!==0)return!0}return!1}function y(v,l,h,m,t){return c(v,l,h,m,t)&&d(v,l,h,m,t)}e.isValidMatch=y;class w{constructor(l,h){this._wordSeparators=l,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(l){this._searchRegex.lastIndex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(l){const h=l.length;let m;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(m=this._searchRegex.exec(l),!m))return null;const t=m.index,n=m[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){g.getNextCodePoint(l,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||y(this._wordSeparators,l,h,t,n))return m}while(m);return null}}e.Searcher=w}),define(we[85],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(D=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)D.indexOf(C)>=0||(_+="\\"+C);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=g();function T(D){let _=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)_=D;else{let C="g";D.ignoreCase&&(C+="i"),D.multiline&&(C+="m"),D.unicode&&(C+="u"),_=new RegExp(D.source,C)}return _.lastIndex=0,_}e.ensureValidWordDefinition=T;const S={maxLen:1e3,windowSize:15,timeBudget:150};function E(D,_,C,i,I=S){if(C.length>I.maxLen){let y=D-I.maxLen/2;return y<0?y=0:i+=y,C=C.substring(y,D+I.maxLen/2),E(D,_,C,i,I)}const o=Date.now(),f=D-1-i;let c=-1,d=null;for(let y=1;!(Date.now()-o>=I.timeBudget);y++){const w=f-I.windowSize*y;_.lastIndex=Math.max(0,w);const v=k(_,C,f,c);if(!v&&d||(d=v,w<=0))break;c=w}if(d){let y={word:d[0],startColumn:i+1+d.index,endColumn:i+1+d.index+d[0].length};return _.lastIndex=0,y}return null}e.getWordAtText=E;function k(D,_,C,i){let I;for(;I=D.exec(_);){const o=I.index||0;if(o<=C&&D.lastIndex>=C)return I;if(i>0&&o>i)return null}return null}}),define(we[117],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(k){k[k.None=0]="None",k[k.Indent=1]="Indent",k[k.IndentOutdent=2]="IndentOutdent",k[k.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class T{constructor(D){if(this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let _=0,C=D.notIn.length;_<C;_++)switch(D.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}}e.StandardAutoClosingPairConditional=T;class S{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of D)E(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),E(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),E(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),E(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&E(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=S;function E(k,D,_){k.has(D)?k.get(D).push(_):k.set(D,[_])}}),define(we[55],_e([0,1,27,14]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(E,k,D,_){if(Array.isArray(E)){let C=0;for(const i of E){const I=S(i,k,D,_);if(I===10)return I;I>C&&(C=I)}return C}else{if(typeof E=="string")return _?E==="*"?5:E===D?10:0:0;if(E){const{language:C,pattern:i,scheme:I,hasAccessToAllModels:o}=E;if(!_&&!o)return 0;let f=0;if(I)if(I===k.scheme)f=10;else if(I==="*")f=5;else return 0;if(C)if(C===D)f=10;else if(C==="*")f=Math.max(f,5);else return 0;if(i){let c;if(typeof i=="string"?c=i:c=Object.assign(Object.assign({},i),{base:T.normalize(i.base)}),c===k.fsPath||g.match(c,k.fsPath))f=10;else return 0}return f}else return 0}}e.score=S}),define(we[118],_e([0,1,83]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var T;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(T=e.State||(e.State={}));class S{constructor(c,d,y){const w=new Uint8Array(c*d);for(let v=0,l=c*d;v<l;v++)w[v]=y;this._data=w,this.rows=c,this.cols=d}get(c,d){return this._data[c*this.cols+d]}set(c,d,y){this._data[c*this.cols+d]=y}}e.Uint8Matrix=S;class E{constructor(c){let d=0,y=0;for(let v=0,l=c.length;v<l;v++){let[h,m,t]=c[v];m>d&&(d=m),h>y&&(y=h),t>y&&(y=t)}d++,y++;let w=new S(y,d,0);for(let v=0,l=c.length;v<l;v++){let[h,m,t]=c[v];w.set(h,m,t)}this._states=w,this._maxCharCode=d}nextState(c,d){return d<0||d>=this._maxCharCode?0:this._states.get(c,d)}}e.StateMachine=E;let k=null;function D(){return k===null&&(k=new E([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),k}var _;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let C=null;function i(){if(C===null){C=new g.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<f.length;d++)C.set(f.charCodeAt(d),1);const c=".,;";for(let d=0;d<c.length;d++)C.set(c.charCodeAt(d),2)}return C}class I{static _createLink(c,d,y,w,v){let l=v-1;do{const h=d.charCodeAt(l);if(c.get(h)!==2)break;l--}while(l>w);if(w>0){const h=d.charCodeAt(w-1),m=d.charCodeAt(l);(h===40&&m===41||h===91&&m===93||h===123&&m===125)&&l--}return{range:{startLineNumber:y,startColumn:w+1,endLineNumber:y,endColumn:l+2},url:d.substring(w,l+1)}}static computeLinks(c,d=D()){const y=i();let w=[];for(let v=1,l=c.getLineCount();v<=l;v++){const h=c.getLineContent(v),m=h.length;let t=0,n=0,s=0,r=1,u=!1,b=!1,p=!1,P=!1;for(;t<m;){let A=!1;const a=h.charCodeAt(t);if(r===13){let R;switch(a){case 40:u=!0,R=0;break;case 41:R=u?0:1;break;case 91:p=!0,b=!0,R=0;break;case 93:p=!1,R=b?0:1;break;case 123:P=!0,R=0;break;case 125:R=P?0:1;break;case 39:R=s===34||s===96?0:1;break;case 34:R=s===39||s===96?0:1;break;case 96:R=s===39||s===34?0:1;break;case 42:R=s===42?1:0;break;case 124:R=s===124?1:0;break;case 32:R=p?0:1;break;default:R=y.get(a)}R===1&&(w.push(I._createLink(y,h,v,n,t)),A=!0)}else if(r===12){let R;a===91?(b=!0,R=0):R=y.get(a),R===1?A=!0:r=13}else r=d.nextState(r,a),r===0&&(A=!0);A&&(r=1,u=!1,b=!1,P=!1,n=t+1,s=a),t++}r===13&&w.push(I._createLink(y,h,v,n,m))}return w}}e.LinkComputer=I;function o(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:I.computeLinks(f)}e.computeLinks=o}),define(we[119],_e([0,1,3,7]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class S{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,D){return this._map.set(k,D),this.fire([k]),T.toDisposable(()=>{this._map.get(k)===D&&(this._map.delete(k),this.fire([k]))})}registerPromise(k,D){let _=null,C=!1;return this._promises.set(k,D.then(i=>{this._promises.delete(k),!(C||!i)&&(_=this.register(k,i))})),T.toDisposable(()=>{C=!0,_&&_.dispose()})}getPromise(k){const D=this.get(k);if(D)return Promise.resolve(D);const _=this._promises.get(k);return _?_.then(C=>this.get(k)):null}get(k){return this._map.get(k)||null}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=S}),define(we[86],_e([0,1,23,21]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(S||(S={}));function E(I){for(let o=0,f=I.length;o<f;o+=4){const c=I[o+0],d=I[o+1],y=I[o+2],w=I[o+3];I[o+0]=w,I[o+1]=y,I[o+2]=d,I[o+3]=c}}function k(I){const o=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return T.isLittleEndian()||E(o),g.VSBuffer.wrap(o)}function D(I){const o=I.buffer;if(T.isLittleEndian()||E(o),o.byteOffset%4==0)return new Uint32Array(o.buffer,o.byteOffset,o.length/4);{const f=new Uint8Array(o.byteLength);return f.set(o),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function _(I){const o=new Uint32Array(C(I));let f=0;if(o[f++]=I.id,I.type==="full")o[f++]=1,o[f++]=I.data.length,o.set(I.data,f),f+=I.data.length;else{o[f++]=2,o[f++]=I.deltas.length;for(const c of I.deltas)o[f++]=c.start,o[f++]=c.deleteCount,c.data?(o[f++]=c.data.length,o.set(c.data,f),f+=c.data.length):o[f++]=0}return k(o)}e.encodeSemanticTokensDto=_;function C(I){let o=0;if(o+=1+1,I.type==="full")o+=1+I.data.length;else{o+=1,o+=(1+1+1)*I.deltas.length;for(const f of I.deltas)f.data&&(o+=f.data.length)}return o}function i(I){const o=D(I);let f=0;const c=o[f++];if(o[f++]===1){const v=o[f++],l=o.subarray(f,f+v);return f+=v,{id:c,type:"full",data:l}}const y=o[f++];let w=[];for(let v=0;v<y;v++){const l=o[f++],h=o[f++],m=o[f++];let t;m>0&&(t=o.subarray(f,f+m),f+=m),w[v]={start:l,deleteCount:h,data:t}}return{id:c,type:"delta",deltas:w}}e.decodeSemanticTokensDto=i}),define(we[87],_e([0,1,79]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class T{constructor(k,D){this.index=k,this.remainder=D}}e.PrefixSumIndexOfResult=T;class S{constructor(k){this.values=k,this.prefixSum=new Uint32Array(k.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(k,D){k=g.toUint32(k);const _=this.values,C=this.prefixSum,i=D.length;return i===0?!1:(this.values=new Uint32Array(_.length+i),this.values.set(_.subarray(0,k),0),this.values.set(_.subarray(k),k+i),this.values.set(D,k),k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(k,D){return k=g.toUint32(k),D=g.toUint32(D),this.values[k]===D?!1:(this.values[k]=D,k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),!0)}removeValues(k,D){k=g.toUint32(k),D=g.toUint32(D);const _=this.values,C=this.prefixSum;if(k>=_.length)return!1;let i=_.length-k;return D>=i&&(D=i),D===0?!1:(this.values=new Uint32Array(_.length-D),this.values.set(_.subarray(0,k),0),this.values.set(_.subarray(k+D),k),this.prefixSum=new Uint32Array(this.values.length),k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(k){return k<0?0:(k=g.toUint32(k),this._getPrefixSum(k))}_getPrefixSum(k){if(k<=this.prefixSumValidIndex[0])return this.prefixSum[k];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),k>=this.values.length&&(k=this.values.length-1);for(let _=D;_<=k;_++)this.prefixSum[_]=this.prefixSum[_-1]+this.values[_];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],k),this.prefixSum[k]}getIndexOf(k){k=Math.floor(k),this.getTotalSum();let D=0,_=this.values.length-1,C=0,i=0,I=0;for(;D<=_;)if(C=D+(_-D)/2|0,i=this.prefixSum[C],I=i-this.values[C],k<I)_=C-1;else if(k>=i)D=C+1;else break;return new T(C,k-I)}}e.PrefixSumComputer=S}),define(we[120],_e([0,1,8,35,87]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class E{constructor(D,_,C,i){this._uri=D,this._lines=_,this._eol=C,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const _=D.changes;for(const C of _)this._acceptDeleteRange(C.range),this._acceptInsertText(new T.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,_=this._lines.length,C=new Uint32Array(_);for(let i=0;i<_;i++)C[i]=this._lines[i].length+D;this._lineStarts=new S.PrefixSumComputer(C)}}_setLineText(D,_){this._lines[D]=_,this._lineStarts&&this._lineStarts.changeValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,_){if(_.length===0)return;let C=g.splitLines(_);if(C.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+C[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}C[C.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+C[0]);let i=new Uint32Array(C.length-1);for(let I=1;I<C.length;I++)this._lines.splice(D.lineNumber+I-1,0,C[I]),i[I-1]=C[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,i)}}e.MirrorTextModel=E}),define(we[121],_e([19,20]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(we[56],_e([0,1,121,10,17]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function E(C,i){return i&&(C.stack||C.stacktrace)?g.localize(0,null,D(C),k(C.stack)||k(C.stacktrace)):D(C)}function k(C){return Array.isArray(C)?C.join(`
`):C}function D(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?g.localize(1,null,C.message):C.message||g.localize(2,null)}function _(C=null,i=!1){if(!C)return g.localize(3,null);if(Array.isArray(C)){const I=S.coalesce(C),o=_(I[0],i);return I.length>1?g.localize(4,null,o,I.length):o}if(T.isString(C))return C;if(C.detail){const I=C.detail;if(I.error)return E(I.error,i);if(I.exception)return E(I.exception,i)}return C.stack?E(C,i):C.message?C.message:g.localize(5,null)}e.toErrorMessage=_}),define(we[122],_e([19,20]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(we[123],_e([0,1,122,21,85]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=k;class D{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,ge){this._values[ie]=ge}}e.ValidatedEditorOptions=D;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class C{constructor(ie,ge,Fe,Ne){this.id=ie,this.name=ge,this.defaultValue=Fe,this.schema=Ne}compute(ie,ge,Fe){return Fe}}class i{constructor(ie,ge=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=ge}validate(ie){return this.defaultValue}}class I{constructor(ie,ge,Fe,Ne){this.id=ie,this.name=ge,this.defaultValue=Fe,this.schema=Ne}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,ge,Fe){return Fe}}function o(V,ie){return typeof V=="undefined"?ie:V==="false"?!1:Boolean(V)}e.boolean=o;class f extends I{constructor(ie,ge,Fe,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="boolean",Ne.default=Fe),super(ie,ge,Fe,Ne)}validate(ie){return o(ie,this.defaultValue)}}class c extends I{constructor(ie,ge,Fe,Ne,Qe,Ee=void 0){typeof Ee!="undefined"&&(Ee.type="integer",Ee.default=Fe,Ee.minimum=Ne,Ee.maximum=Qe),super(ie,ge,Fe,Ee),this.minimum=Ne,this.maximum=Qe}static clampedInt(ie,ge,Fe,Ne){if(typeof ie=="undefined")return ge;let Qe=parseInt(ie,10);return isNaN(Qe)?ge:(Qe=Math.max(Fe,Qe),Qe=Math.min(Ne,Qe),Qe|0)}validate(ie){return c.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class d extends I{constructor(ie,ge,Fe,Ne,Qe){typeof Qe!="undefined"&&(Qe.type="number",Qe.default=Fe),super(ie,ge,Fe,Qe),this.validationFn=Ne}static clamp(ie,ge,Fe){return ie<ge?ge:ie>Fe?Fe:ie}static float(ie,ge){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return ge;const Fe=parseFloat(ie);return isNaN(Fe)?ge:Fe}validate(ie){return this.validationFn(d.float(ie,this.defaultValue))}}class y extends I{static string(ie,ge){return typeof ie!="string"?ge:ie}constructor(ie,ge,Fe,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="string",Ne.default=Fe),super(ie,ge,Fe,Ne)}validate(ie){return y.string(ie,this.defaultValue)}}function w(V,ie,ge){return typeof V!="string"||ge.indexOf(V)===-1?ie:V}e.stringSet=w;class v extends I{constructor(ie,ge,Fe,Ne,Qe=void 0){typeof Qe!="undefined"&&(Qe.type="string",Qe.enum=Ne,Qe.default=Fe),super(ie,ge,Fe,Qe),this._allowedValues=Ne}validate(ie){return w(ie,this.defaultValue,this._allowedValues)}}class l extends C{constructor(ie,ge,Fe,Ne,Qe,Ee,be=void 0){typeof be!="undefined"&&(be.type="string",be.enum=Qe,be.default=Ne),super(ie,ge,Fe,be),this._allowedValues=Qe,this._convert=Ee}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function h(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,ge,Fe){return Fe===0?ie.accessibilitySupport:Fe}}class t extends C{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:g.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{insertSpace:o(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function u(V){switch(V){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=u;function b(V){switch(V){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class p extends i{constructor(){super(125,[63,31])}compute(ie,ge,Fe){const Ne=["monaco-editor"];return ge.get(31)&&Ne.push(ge.get(31)),ie.extraEditorClassName&&Ne.push(ie.extraEditorClassName),ge.get(63)==="default"?Ne.push("mouse-default"):ge.get(63)==="copy"&&Ne.push("mouse-copy"),ge.get(98)&&Ne.push("showUnused"),ge.get(123)&&Ne.push("showDeprecated"),Ne.join(" ")}}class P extends f{constructor(){super(30,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(ie,ge,Fe){return Fe&&ie.emptySelectionClipboard}}class A extends C{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ie.seedSearchStringFromSelection,description:g.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[g.localize(9,null),g.localize(10,null),g.localize(11,null)],description:g.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:g.localize(13,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:g.localize(14,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:g.localize(15,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{cursorMoveOnType:o(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:o(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":w(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(ge.loop,this.defaultValue.loop)}}}class a extends C{constructor(){super(41,"fontLigatures",a.OFF,{anyOf:[{type:"boolean",description:g.localize(16,null)},{type:"string",description:g.localize(17,null)}],description:g.localize(18,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?a.OFF:ie==="true"?a.ON:ie:Boolean(ie)?a.ON:a.OFF}}e.EditorFontLigatures=a,a.OFF='"liga" off, "calt" off',a.ON='"liga" on, "calt" on';class R extends i{constructor(){super(40)}compute(ie,ge,Fe){return ie.fontInfo}}class M extends I{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(19,null)})}validate(ie){let ge=d.float(ie,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(ge,6,100)}compute(ie,ge,Fe){return ie.fontInfo.fontSize}}class H extends C{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.MINIMUM_VALUE,maximum:H.MAXIMUM_VALUE,errorMessage:g.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(21,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(c.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,H.MINIMUM_VALUE,H.MAXIMUM_VALUE))}}H.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],H.MINIMUM_VALUE=1,H.MAXIMUM_VALUE=1e3;class ue extends C{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[g.localize(22,null),g.localize(23,null),g.localize(24,null)]},Fe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:g.localize(26,null)},ge),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:g.localize(27,null)},ge),"editor.gotoLocation.multipleDeclarations":Object.assign({description:g.localize(28,null)},ge),"editor.gotoLocation.multipleImplementations":Object.assign({description:g.localize(29,null)},ge),"editor.gotoLocation.multipleReferences":Object.assign({description:g.localize(30,null)},ge),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:Fe,description:g.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:Fe,description:g.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:Fe,description:g.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:Fe,description:g.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:Fe,description:g.localize(35,null)}})}validate(ie){var ge,Fe,Ne,Qe,Ee;if(!ie||typeof ie!="object")return this.defaultValue;const be=ie;return{multiple:w(be.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ge=be.multipleDefinitions)!==null&&ge!==void 0?ge:w(be.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Fe=be.multipleTypeDefinitions)!==null&&Fe!==void 0?Fe:w(be.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Ne=be.multipleDeclarations)!==null&&Ne!==void 0?Ne:w(be.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Qe=be.multipleImplementations)!==null&&Qe!==void 0?Qe:w(be.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ee=be.multipleReferences)!==null&&Ee!==void 0?Ee:w(be.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:y.string(be.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:y.string(be.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:y.string(be.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:y.string(be.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:y.string(be.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class fe extends C{constructor(){const ie={enabled:!0,delay:300,sticky:!0};super(50,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:g.localize(36,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:g.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:g.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{enabled:o(ge.enabled,this.defaultValue.enabled),delay:c.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:o(ge.sticky,this.defaultValue.sticky)}}}var Y;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(Y=e.RenderMinimap||(e.RenderMinimap={}));class j extends i{constructor(){super(128,[46,55,35,62,90,57,58,92,115,118,119,120,2])}compute(ie,ge,Fe){return j.computeLayout(ge,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const ge=ie.height/ie.lineHeight,Fe=ie.scrollBeyondLastLine?ge-1:0,Ne=(ie.viewLineCount+Fe)/(ie.pixelRatio*ie.height),Qe=Math.floor(ie.viewLineCount/Ne);return{typicalViewportLineCount:ge,extraLinesBeyondLastLine:Fe,desiredRatio:Ne,minimapLineCount:Qe}}static _computeMinimapLayout(ie,ge){const Fe=ie.outerWidth,Ne=ie.outerHeight,Qe=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Qe*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const Ee=ge.stableMinimapLayoutInput,be=Ee&&ie.outerHeight===Ee.outerHeight&&ie.lineHeight===Ee.lineHeight&&ie.typicalHalfwidthCharacterWidth===Ee.typicalHalfwidthCharacterWidth&&ie.pixelRatio===Ee.pixelRatio&&ie.scrollBeyondLastLine===Ee.scrollBeyondLastLine&&ie.minimap.enabled===Ee.minimap.enabled&&ie.minimap.side===Ee.minimap.side&&ie.minimap.size===Ee.minimap.size&&ie.minimap.showSlider===Ee.minimap.showSlider&&ie.minimap.renderCharacters===Ee.minimap.renderCharacters&&ie.minimap.maxColumn===Ee.minimap.maxColumn&&ie.minimap.scale===Ee.minimap.scale&&ie.verticalScrollbarWidth===Ee.verticalScrollbarWidth&&ie.isViewportWrapping===Ee.isViewportWrapping,Ce=ie.lineHeight,se=ie.typicalHalfwidthCharacterWidth,de=ie.scrollBeyondLastLine,O=ie.minimap.renderCharacters;let Q=Qe>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const le=ie.minimap.maxColumn,ke=ie.minimap.size,Pe=ie.minimap.side,Ue=ie.verticalScrollbarWidth,We=ie.viewLineCount,Ze=ie.remainingWidth,rt=ie.isViewportWrapping,Ke=O?2:3;let Je=Math.floor(Qe*Ne);const ft=Je/Qe;let ve=!1,ye=!1,ae=Ke*Q,z=Q/Qe,xe=1;if(ke==="fill"||ke==="fit"){const{typicalViewportLineCount:gt,extraLinesBeyondLastLine:pt,desiredRatio:wt,minimapLineCount:Tt}=j.computeContainedMinimapLineCount({viewLineCount:We,scrollBeyondLastLine:de,height:Ne,lineHeight:Ce,pixelRatio:Qe});if(We/Tt>1)ve=!0,ye=!0,Q=1,ae=1,z=Q/Qe;else{let Et=!1,ut=Q+1;if(ke==="fit"){const mt=Math.ceil((We+pt)*ae);rt&&be&&Ze<=ge.stableFitRemainingWidth?(Et=!0,ut=ge.stableFitMaxMinimapScale):Et=mt>Je}if(ke==="fill"||Et){ve=!0;const mt=Q;ae=Math.min(Ce*Qe,Math.max(1,Math.floor(1/wt))),rt&&be&&Ze<=ge.stableFitRemainingWidth&&(ut=ge.stableFitMaxMinimapScale),Q=Math.min(ut,Math.max(1,Math.floor(ae/Ke))),Q>mt&&(xe=Math.min(2,Q/mt)),z=Q/Qe/xe,Je=Math.ceil(Math.max(gt,We+pt)*ae),rt?(ge.stableMinimapLayoutInput=ie,ge.stableFitRemainingWidth=Ze,ge.stableFitMaxMinimapScale=Q):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const Te=Math.floor(le*z),Re=Math.min(Te,Math.max(0,Math.floor((Ze-Ue-2)*z/(se+z)))+e.MINIMAP_GUTTER_WIDTH);let it=Math.floor(Qe*Re);const ot=it/Qe;it=Math.floor(it*xe);const tt=O?1:2,vt=Pe==="left"?0:Fe-Re-Ue;return{renderMinimap:tt,minimapLeft:vt,minimapWidth:Re,minimapHeightIsEditorHeight:ve,minimapIsSampling:ye,minimapScale:Q,minimapLineHeight:ae,minimapCanvasInnerWidth:it,minimapCanvasInnerHeight:Je,minimapCanvasOuterWidth:ot,minimapCanvasOuterHeight:ft}}static computeLayout(ie,ge){const Fe=ge.outerWidth|0,Ne=ge.outerHeight|0,Qe=ge.lineHeight|0,Ee=ge.lineNumbersDigitCount|0,be=ge.typicalHalfwidthCharacterWidth,Ce=ge.maxDigitWidth,se=ge.pixelRatio,de=ge.viewLineCount,O=ie.get(120),Q=O==="inherit"?ie.get(119):O,le=Q==="inherit"?ie.get(115):Q,ke=ie.get(118),Pe=ie.get(2),Ue=ge.isDominatedByLongLines,We=ie.get(46),Ze=ie.get(57).renderType!==0,rt=ie.get(58),Ke=ie.get(92),Je=ie.get(62),ft=ie.get(90),ve=ft.verticalScrollbarSize,ye=ft.verticalHasArrows,ae=ft.arrowSize,z=ft.horizontalScrollbarSize,xe=ie.get(55),Te=ie.get(35);let Re;if(typeof xe=="string"&&/^\d+(\.\d+)?ch$/.test(xe)){const yt=parseFloat(xe.substr(0,xe.length-2));Re=c.clampedInt(yt*be,0,0,1e3)}else Re=c.clampedInt(xe,0,0,1e3);Te&&(Re+=16);let it=0;if(Ze){const yt=Math.max(Ee,rt);it=Math.round(yt*Ce)}let ot=0;We&&(ot=Qe);let tt=0,vt=tt+ot,gt=vt+it,pt=gt+Re;const wt=Fe-ot-it-Re;let Tt=!1,Pt=!1,Et=-1;Pe!==2&&(Q==="inherit"&&Ue?(Tt=!0,Pt=!0):le==="on"||le==="bounded"?Pt=!0:le==="wordWrapColumn"&&(Et=ke));const ut=j._computeMinimapLayout({outerWidth:Fe,outerHeight:Ne,lineHeight:Qe,typicalHalfwidthCharacterWidth:be,pixelRatio:se,scrollBeyondLastLine:Ke,minimap:Je,verticalScrollbarWidth:ve,viewLineCount:de,remainingWidth:wt,isViewportWrapping:Pt},ge.memory||new _);ut.renderMinimap!==0&&ut.minimapLeft===0&&(tt+=ut.minimapWidth,vt+=ut.minimapWidth,gt+=ut.minimapWidth,pt+=ut.minimapWidth);const mt=wt-ut.minimapWidth,_t=Math.max(1,Math.floor((mt-ve-2)/be)),Ft=ye?ae:0;return Pt&&(Et=Math.max(1,_t),le==="bounded"&&(Et=Math.min(Et,ke))),{width:Fe,height:Ne,glyphMarginLeft:tt,glyphMarginWidth:ot,lineNumbersLeft:vt,lineNumbersWidth:it,decorationsLeft:gt,decorationsWidth:Re,contentLeft:pt,contentWidth:mt,minimap:ut,viewportColumn:_t,isWordWrapMinified:Tt,isViewportWrapping:Pt,wrappingColumn:Et,verticalScrollbarWidth:ve,horizontalScrollbarHeight:z,overviewRuler:{top:Ft,width:ve,height:Ne-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=j;class Z extends C{constructor(){const ie={enabled:!0};super(54,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:g.localize(39,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:o(ie.enabled,this.defaultValue.enabled)}}}class L extends C{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(124,"inlayHints",ie,{"editor.inlayHints.enabled":{type:"boolean",default:ie.enabled,description:g.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ie.fontSize,markdownDescription:g.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ie.fontFamily,description:g.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{enabled:o(ge.enabled,this.defaultValue.enabled),fontSize:c.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:y.string(ge.fontFamily,this.defaultValue.fontFamily)}}}class q extends d{constructor(){super(56,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ie=>d.clamp(ie,0,150),{markdownDescription:g.localize(43,null)})}compute(ie,ge,Fe){return ie.fontInfo.lineHeight}}class N extends C{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(62,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:g.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(45,null),g.localize(46,null),g.localize(47,null)],default:ie.size,description:g.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:g.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:g.localize(50,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:g.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:g.localize(53,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{enabled:o(ge.enabled,this.defaultValue.enabled),size:w(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(ge.side,this.defaultValue.side,["right","left"]),showSlider:w(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(ge.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(ge.scale,1,1,3),maxColumn:c.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function W(V){return V==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class U extends C{constructor(){super(72,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(55,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{top:c.clampedInt(ge.top,0,0,1e3),bottom:c.clampedInt(ge.bottom,0,0,1e3)}}}class B extends C{constructor(){const ie={enabled:!0,cycle:!1};super(73,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:g.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:g.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{enabled:o(ge.enabled,this.defaultValue.enabled),cycle:o(ge.cycle,this.defaultValue.cycle)}}}class J extends i{constructor(){super(126)}compute(ie,ge,Fe){return ie.pixelRatio}}class he extends C{constructor(){const ie={other:!0,comments:!1,strings:!1};super(76,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:g.localize(58,null)},comments:{type:"boolean",default:ie.comments,description:g.localize(59,null)},other:{type:"boolean",default:ie.other,description:g.localize(60,null)}}}],default:ie,description:g.localize(61,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const ge=ie,Fe={other:o(ge.other,this.defaultValue.other),comments:o(ge.comments,this.defaultValue.comments),strings:o(ge.strings,this.defaultValue.strings)};return Fe.other&&Fe.comments&&Fe.strings?!0:!Fe.other&&!Fe.comments&&!Fe.strings?!1:Fe}return this.defaultValue}}var De;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(De=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Oe extends C{constructor(){super(57,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(62,null),g.localize(63,null),g.localize(64,null),g.localize(65,null)],default:"on",description:g.localize(66,null)})}validate(ie){let ge=this.defaultValue.renderType,Fe=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(ge=4,Fe=ie):ie==="interval"?ge=3:ie==="relative"?ge=2:ie==="on"?ge=1:ge=0),{renderType:ge,renderFn:Fe}}}function Me(V){const ie=V.get(85);return ie==="editable"?V.get(78):ie!=="on"}e.filterValidationDecorations=Me;class He extends C{constructor(){const ie=[],ge={type:"number",description:g.localize(67,null)};super(89,"rulers",ie,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:g.localize(68,null),format:"color-hex"}}}]},default:ie,description:g.localize(69,null)})}validate(ie){if(Array.isArray(ie)){let ge=[];for(let Fe of ie)if(typeof Fe=="number")ge.push({column:c.clampedInt(Fe,0,0,1e4),color:null});else if(Fe&&typeof Fe=="object"){const Ne=Fe;ge.push({column:c.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return ge.sort((Fe,Ne)=>Fe.column-Ne.column),ge}return this.defaultValue}}function Ye(V,ie){if(typeof V!="string")return ie;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class qe extends C{constructor(){super(90,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie,Fe=c.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=c.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ye(ge.vertical,this.defaultValue.vertical),horizontal:Ye(ge.horizontal,this.defaultValue.horizontal),useShadows:o(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Fe,horizontalSliderSize:c.clampedInt(ge.horizontalSliderSize,Fe,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:c.clampedInt(ge.verticalSliderSize,Ne,0,1e3),scrollByPage:o(ge.scrollByPage,this.defaultValue.scrollByPage)}}}class Xe extends C{constructor(){const ie={enabled:!1,mode:"prefix"};super(52,"inlineSuggest",ie,{"editor.inlineSuggest.enabled":{type:"boolean",default:ie.enabled,description:g.localize(70,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subwordDiff"],enumDescriptions:[g.localize(71,null),g.localize(72,null)],default:ie.mode,description:g.localize(73,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{enabled:o(ge.enabled,this.defaultValue.enabled),mode:w(ge.mode,this.defaultValue.mode,["prefix","subwordDiff"])}}}class $ extends C{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordDiff",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(104,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(74,null),g.localize(75,null)],default:ie.insertMode,description:g.localize(76,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:g.localize(77,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:g.localize(78,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:g.localize(79,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:g.localize(80,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:g.localize(81,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:g.localize(82,null)},"editor.suggest.preview":{type:"boolean",default:ie.preview,description:g.localize(83,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subwordDiff"],enumDescriptions:[g.localize(84,null),g.localize(85,null)],default:ie.previewMode,description:g.localize(86,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:g.localize(87,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(88,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(89,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(90,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(91,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(92,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(93,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(94,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(95,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(96,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(97,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(98,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(99,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(100,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(101,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(102,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(103,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(104,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(105,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(106,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(107,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(108,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(109,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(110,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ge=ie;return{insertMode:w(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:o(ge.showIcons,this.defaultValue.showIcons),showStatusBar:o(ge.showStatusBar,this.defaultValue.showStatusBar),preview:o(ge.preview,this.defaultValue.preview),previewMode:w(ge.previewMode,this.defaultValue.previewMode,["prefix","subwordDiff"]),showInlineDetails:o(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(ge.showMethods,this.defaultValue.showMethods),showFunctions:o(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:o(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(ge.showDeprecated,this.defaultValue.showDeprecated),showFields:o(ge.showFields,this.defaultValue.showFields),showVariables:o(ge.showVariables,this.defaultValue.showVariables),showClasses:o(ge.showClasses,this.defaultValue.showClasses),showStructs:o(ge.showStructs,this.defaultValue.showStructs),showInterfaces:o(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:o(ge.showModules,this.defaultValue.showModules),showProperties:o(ge.showProperties,this.defaultValue.showProperties),showEvents:o(ge.showEvents,this.defaultValue.showEvents),showOperators:o(ge.showOperators,this.defaultValue.showOperators),showUnits:o(ge.showUnits,this.defaultValue.showUnits),showValues:o(ge.showValues,this.defaultValue.showValues),showConstants:o(ge.showConstants,this.defaultValue.showConstants),showEnums:o(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:o(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(ge.showKeywords,this.defaultValue.showKeywords),showWords:o(ge.showWords,this.defaultValue.showWords),showColors:o(ge.showColors,this.defaultValue.showColors),showFiles:o(ge.showFiles,this.defaultValue.showFiles),showReferences:o(ge.showReferences,this.defaultValue.showReferences),showFolders:o(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:o(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(ge.showSnippets,this.defaultValue.showSnippets),showUsers:o(ge.showUsers,this.defaultValue.showUsers),showIssues:o(ge.showIssues,this.defaultValue.showIssues)}}}class G extends C{constructor(){super(100,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(119,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class te extends i{constructor(){super(127,[78])}compute(ie,ge,Fe){return ge.get(78)?!0:ie.tabFocusMode}}var re;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(re=e.WrappingIndent||(e.WrappingIndent={}));function K(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class oe extends i{constructor(){super(129,[128])}compute(ie,ge,Fe){const Ne=ge.get(128);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}const me="Consolas, 'Courier New', monospace",Ae="Menlo, Monaco, 'Courier New', monospace",$e="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?Ae:T.isLinux?$e:me,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function pe(V){return e.editorOptionsRegistry[V.id]=V,V}var Ge;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.codeLens=12]="codeLens",V[V.codeLensFontFamily=13]="codeLensFontFamily",V[V.codeLensFontSize=14]="codeLensFontSize",V[V.colorDecorators=15]="colorDecorators",V[V.columnSelection=16]="columnSelection",V[V.comments=17]="comments",V[V.contextmenu=18]="contextmenu",V[V.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",V[V.cursorBlinking=20]="cursorBlinking",V[V.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",V[V.cursorStyle=22]="cursorStyle",V[V.cursorSurroundingLines=23]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",V[V.cursorWidth=25]="cursorWidth",V[V.disableLayerHinting=26]="disableLayerHinting",V[V.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",V[V.domReadOnly=28]="domReadOnly",V[V.dragAndDrop=29]="dragAndDrop",V[V.emptySelectionClipboard=30]="emptySelectionClipboard",V[V.extraEditorClassName=31]="extraEditorClassName",V[V.fastScrollSensitivity=32]="fastScrollSensitivity",V[V.find=33]="find",V[V.fixedOverflowWidgets=34]="fixedOverflowWidgets",V[V.folding=35]="folding",V[V.foldingStrategy=36]="foldingStrategy",V[V.foldingHighlight=37]="foldingHighlight",V[V.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=39]="fontFamily",V[V.fontInfo=40]="fontInfo",V[V.fontLigatures=41]="fontLigatures",V[V.fontSize=42]="fontSize",V[V.fontWeight=43]="fontWeight",V[V.formatOnPaste=44]="formatOnPaste",V[V.formatOnType=45]="formatOnType",V[V.glyphMargin=46]="glyphMargin",V[V.gotoLocation=47]="gotoLocation",V[V.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",V[V.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",V[V.hover=50]="hover",V[V.inDiffEditor=51]="inDiffEditor",V[V.inlineSuggest=52]="inlineSuggest",V[V.letterSpacing=53]="letterSpacing",V[V.lightbulb=54]="lightbulb",V[V.lineDecorationsWidth=55]="lineDecorationsWidth",V[V.lineHeight=56]="lineHeight",V[V.lineNumbers=57]="lineNumbers",V[V.lineNumbersMinChars=58]="lineNumbersMinChars",V[V.linkedEditing=59]="linkedEditing",V[V.links=60]="links",V[V.matchBrackets=61]="matchBrackets",V[V.minimap=62]="minimap",V[V.mouseStyle=63]="mouseStyle",V[V.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=65]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",V[V.multiCursorModifier=67]="multiCursorModifier",V[V.multiCursorPaste=68]="multiCursorPaste",V[V.occurrencesHighlight=69]="occurrencesHighlight",V[V.overviewRulerBorder=70]="overviewRulerBorder",V[V.overviewRulerLanes=71]="overviewRulerLanes",V[V.padding=72]="padding",V[V.parameterHints=73]="parameterHints",V[V.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",V[V.quickSuggestions=76]="quickSuggestions",V[V.quickSuggestionsDelay=77]="quickSuggestionsDelay",V[V.readOnly=78]="readOnly",V[V.renameOnType=79]="renameOnType",V[V.renderControlCharacters=80]="renderControlCharacters",V[V.renderIndentGuides=81]="renderIndentGuides",V[V.renderFinalNewline=82]="renderFinalNewline",V[V.renderLineHighlight=83]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=85]="renderValidationDecorations",V[V.renderWhitespace=86]="renderWhitespace",V[V.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",V[V.roundedSelection=88]="roundedSelection",V[V.rulers=89]="rulers",V[V.scrollbar=90]="scrollbar",V[V.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=92]="scrollBeyondLastLine",V[V.scrollPredominantAxis=93]="scrollPredominantAxis",V[V.selectionClipboard=94]="selectionClipboard",V[V.selectionHighlight=95]="selectionHighlight",V[V.selectOnLineNumbers=96]="selectOnLineNumbers",V[V.showFoldingControls=97]="showFoldingControls",V[V.showUnused=98]="showUnused",V[V.snippetSuggestions=99]="snippetSuggestions",V[V.smartSelect=100]="smartSelect",V[V.smoothScrolling=101]="smoothScrolling",V[V.stickyTabStops=102]="stickyTabStops",V[V.stopRenderingLineAfter=103]="stopRenderingLineAfter",V[V.suggest=104]="suggest",V[V.suggestFontSize=105]="suggestFontSize",V[V.suggestLineHeight=106]="suggestLineHeight",V[V.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",V[V.suggestSelection=108]="suggestSelection",V[V.tabCompletion=109]="tabCompletion",V[V.tabIndex=110]="tabIndex",V[V.unusualLineTerminators=111]="unusualLineTerminators",V[V.useShadowDOM=112]="useShadowDOM",V[V.useTabStops=113]="useTabStops",V[V.wordSeparators=114]="wordSeparators",V[V.wordWrap=115]="wordWrap",V[V.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=118]="wordWrapColumn",V[V.wordWrapOverride1=119]="wordWrapOverride1",V[V.wordWrapOverride2=120]="wordWrapOverride2",V[V.wrappingIndent=121]="wrappingIndent",V[V.wrappingStrategy=122]="wrappingStrategy",V[V.showDeprecated=123]="showDeprecated",V[V.inlayHints=124]="inlayHints",V[V.editorClassName=125]="editorClassName",V[V.pixelRatio=126]="pixelRatio",V[V.tabFocusMode=127]="tabFocusMode",V[V.layoutInfo=128]="layoutInfo",V[V.wrappingInfo=129]="wrappingInfo"})(Ge=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:pe(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(120,null)})),acceptSuggestionOnEnter:pe(new v(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(121,null),""],markdownDescription:g.localize(122,null)})),accessibilitySupport:pe(new m),accessibilityPageSize:pe(new c(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(123,null)})),ariaLabel:pe(new y(4,"ariaLabel",g.localize(124,null))),autoClosingBrackets:pe(new v(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(125,null),g.localize(126,null),""],description:g.localize(127,null)})),autoClosingDelete:pe(new v(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(128,null),""],description:g.localize(129,null)})),autoClosingOvertype:pe(new v(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(130,null),""],description:g.localize(131,null)})),autoClosingQuotes:pe(new v(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(132,null),g.localize(133,null),""],description:g.localize(134,null)})),autoIndent:pe(new l(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],h,{enumDescriptions:[g.localize(135,null),g.localize(136,null),g.localize(137,null),g.localize(138,null),g.localize(139,null)],description:g.localize(140,null)})),automaticLayout:pe(new f(10,"automaticLayout",!1)),autoSurround:pe(new v(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(141,null),g.localize(142,null),g.localize(143,null),""],description:g.localize(144,null)})),stickyTabStops:pe(new f(102,"stickyTabStops",!1,{description:g.localize(145,null)})),codeLens:pe(new f(12,"codeLens",!0,{description:g.localize(146,null)})),codeLensFontFamily:pe(new y(13,"codeLensFontFamily","",{description:g.localize(147,null)})),codeLensFontSize:pe(new c(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(148,null)})),colorDecorators:pe(new f(15,"colorDecorators",!0,{description:g.localize(149,null)})),columnSelection:pe(new f(16,"columnSelection",!1,{description:g.localize(150,null)})),comments:pe(new t),contextmenu:pe(new f(18,"contextmenu",!0)),copyWithSyntaxHighlighting:pe(new f(19,"copyWithSyntaxHighlighting",!0,{description:g.localize(151,null)})),cursorBlinking:pe(new l(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:g.localize(152,null)})),cursorSmoothCaretAnimation:pe(new f(21,"cursorSmoothCaretAnimation",!1,{description:g.localize(153,null)})),cursorStyle:pe(new l(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],b,{description:g.localize(154,null)})),cursorSurroundingLines:pe(new c(23,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(155,null)})),cursorSurroundingLinesStyle:pe(new v(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(156,null),g.localize(157,null)],description:g.localize(158,null)})),cursorWidth:pe(new c(25,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(159,null)})),disableLayerHinting:pe(new f(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:pe(new f(27,"disableMonospaceOptimizations",!1)),domReadOnly:pe(new f(28,"domReadOnly",!1)),dragAndDrop:pe(new f(29,"dragAndDrop",!0,{description:g.localize(160,null)})),emptySelectionClipboard:pe(new P),extraEditorClassName:pe(new y(31,"extraEditorClassName","")),fastScrollSensitivity:pe(new d(32,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:g.localize(161,null)})),find:pe(new A),fixedOverflowWidgets:pe(new f(34,"fixedOverflowWidgets",!1)),folding:pe(new f(35,"folding",!0,{description:g.localize(162,null)})),foldingStrategy:pe(new v(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(163,null),g.localize(164,null)],description:g.localize(165,null)})),foldingHighlight:pe(new f(37,"foldingHighlight",!0,{description:g.localize(166,null)})),unfoldOnClickAfterEndOfLine:pe(new f(38,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(167,null)})),fontFamily:pe(new y(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(168,null)})),fontInfo:pe(new R),fontLigatures2:pe(new a),fontSize:pe(new M),fontWeight:pe(new H),formatOnPaste:pe(new f(44,"formatOnPaste",!1,{description:g.localize(169,null)})),formatOnType:pe(new f(45,"formatOnType",!1,{description:g.localize(170,null)})),glyphMargin:pe(new f(46,"glyphMargin",!0,{description:g.localize(171,null)})),gotoLocation:pe(new ue),hideCursorInOverviewRuler:pe(new f(48,"hideCursorInOverviewRuler",!1,{description:g.localize(172,null)})),highlightActiveIndentGuide:pe(new f(49,"highlightActiveIndentGuide",!0,{description:g.localize(173,null)})),hover:pe(new fe),inDiffEditor:pe(new f(51,"inDiffEditor",!1)),letterSpacing:pe(new d(53,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>d.clamp(V,-5,20),{description:g.localize(174,null)})),lightbulb:pe(new Z),lineDecorationsWidth:pe(new I(55,"lineDecorationsWidth",10)),lineHeight:pe(new q),lineNumbers:pe(new Oe),lineNumbersMinChars:pe(new c(58,"lineNumbersMinChars",5,1,300)),linkedEditing:pe(new f(59,"linkedEditing",!1,{description:g.localize(175,null)})),links:pe(new f(60,"links",!0,{description:g.localize(176,null)})),matchBrackets:pe(new v(61,"matchBrackets","always",["always","near","never"],{description:g.localize(177,null)})),minimap:pe(new N),mouseStyle:pe(new v(63,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:pe(new d(64,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:g.localize(178,null)})),mouseWheelZoom:pe(new f(65,"mouseWheelZoom",!1,{markdownDescription:g.localize(179,null)})),multiCursorMergeOverlapping:pe(new f(66,"multiCursorMergeOverlapping",!0,{description:g.localize(180,null)})),multiCursorModifier:pe(new l(67,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],W,{markdownEnumDescriptions:[g.localize(181,null),g.localize(182,null)],markdownDescription:g.localize(183,null)})),multiCursorPaste:pe(new v(68,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(184,null),g.localize(185,null)],markdownDescription:g.localize(186,null)})),occurrencesHighlight:pe(new f(69,"occurrencesHighlight",!0,{description:g.localize(187,null)})),overviewRulerBorder:pe(new f(70,"overviewRulerBorder",!0,{description:g.localize(188,null)})),overviewRulerLanes:pe(new c(71,"overviewRulerLanes",3,0,3)),padding:pe(new U),parameterHints:pe(new B),peekWidgetDefaultFocus:pe(new v(74,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(189,null),g.localize(190,null)],description:g.localize(191,null)})),definitionLinkOpensInPeek:pe(new f(75,"definitionLinkOpensInPeek",!1,{description:g.localize(192,null)})),quickSuggestions:pe(new he),quickSuggestionsDelay:pe(new c(77,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(193,null)})),readOnly:pe(new f(78,"readOnly",!1)),renameOnType:pe(new f(79,"renameOnType",!1,{description:g.localize(194,null),markdownDeprecationMessage:g.localize(195,null)})),renderControlCharacters:pe(new f(80,"renderControlCharacters",!1,{description:g.localize(196,null)})),renderIndentGuides:pe(new f(81,"renderIndentGuides",!0,{description:g.localize(197,null)})),renderFinalNewline:pe(new f(82,"renderFinalNewline",!0,{description:g.localize(198,null)})),renderLineHighlight:pe(new v(83,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(199,null)],description:g.localize(200,null)})),renderLineHighlightOnlyWhenFocus:pe(new f(84,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(201,null)})),renderValidationDecorations:pe(new v(85,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:pe(new v(86,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(202,null),g.localize(203,null),g.localize(204,null),""],description:g.localize(205,null)})),revealHorizontalRightPadding:pe(new c(87,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:pe(new f(88,"roundedSelection",!0,{description:g.localize(206,null)})),rulers:pe(new He),scrollbar:pe(new qe),scrollBeyondLastColumn:pe(new c(91,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(207,null)})),scrollBeyondLastLine:pe(new f(92,"scrollBeyondLastLine",!0,{description:g.localize(208,null)})),scrollPredominantAxis:pe(new f(93,"scrollPredominantAxis",!0,{description:g.localize(209,null)})),selectionClipboard:pe(new f(94,"selectionClipboard",!0,{description:g.localize(210,null),included:T.isLinux})),selectionHighlight:pe(new f(95,"selectionHighlight",!0,{description:g.localize(211,null)})),selectOnLineNumbers:pe(new f(96,"selectOnLineNumbers",!0)),showFoldingControls:pe(new v(97,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(212,null),g.localize(213,null)],description:g.localize(214,null)})),showUnused:pe(new f(98,"showUnused",!0,{description:g.localize(215,null)})),showDeprecated:pe(new f(123,"showDeprecated",!0,{description:g.localize(216,null)})),inlayHints:pe(new L),snippetSuggestions:pe(new v(99,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(217,null),g.localize(218,null),g.localize(219,null),g.localize(220,null)],description:g.localize(221,null)})),smartSelect:pe(new G),smoothScrolling:pe(new f(101,"smoothScrolling",!1,{description:g.localize(222,null)})),stopRenderingLineAfter:pe(new c(103,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:pe(new $),inlineSuggest:pe(new Xe),suggestFontSize:pe(new c(105,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(223,null)})),suggestLineHeight:pe(new c(106,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(224,null)})),suggestOnTriggerCharacters:pe(new f(107,"suggestOnTriggerCharacters",!0,{description:g.localize(225,null)})),suggestSelection:pe(new v(108,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(226,null),g.localize(227,null),g.localize(228,null)],description:g.localize(229,null)})),tabCompletion:pe(new v(109,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(230,null),g.localize(231,null),g.localize(232,null)],description:g.localize(233,null)})),tabIndex:pe(new c(110,"tabIndex",0,-1,1073741824)),unusualLineTerminators:pe(new v(111,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(234,null),g.localize(235,null),g.localize(236,null)],description:g.localize(237,null)})),useShadowDOM:pe(new f(112,"useShadowDOM",!0)),useTabStops:pe(new f(113,"useTabStops",!0,{description:g.localize(238,null)})),wordSeparators:pe(new y(114,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:g.localize(239,null)})),wordWrap:pe(new v(115,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(240,null),g.localize(241,null),g.localize(242,null),g.localize(243,null)],description:g.localize(244,null)})),wordWrapBreakAfterCharacters:pe(new y(116,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:pe(new y(117,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:pe(new c(118,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(245,null)})),wordWrapOverride1:pe(new v(119,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:pe(new v(120,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:pe(new l(121,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],K,{enumDescriptions:[g.localize(246,null),g.localize(247,null),g.localize(248,null),g.localize(249,null)],description:g.localize(250,null)})),wrappingStrategy:pe(new v(122,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(251,null),g.localize(252,null)],description:g.localize(253,null)})),editorClassName:pe(new p),pixelRatio:pe(new J),tabFocusMode:pe(new te),layoutInfo:pe(new j),wrappingInfo:pe(new oe)}}),define(we[124],_e([19,20]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[125],_e([19,20]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[126],_e([19,20]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(we[127],_e([19,20]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(we[128],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[129],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[130],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(we[131],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[132],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[133],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[134],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[135],_e([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[136],_e([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[137],_e([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[138],_e([19,20]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[139],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var g;(function(k){k[k.ACTIVATE=0]="ACTIVATE",k[k.RESTORE=1]="RESTORE",k[k.PRESERVE=2]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var T;(function(k){k[k.PICK=1]="PICK",k[k.DISABLED=2]="DISABLED"})(T=e.EditorOverride||(e.EditorOverride={}));var S;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(S=e.EditorOpenContext||(e.EditorOpenContext={}));var E;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(E=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[140],_e([0,1,125]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function E(o){return o=o.trim(),o==="*"||T.test(o)}e.isValidVersionStr=E;function k(o){if(!E(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=o.match(T);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=k;function D(o){if(!o)return null;let f=o.majorBase,c=o.majorMustEqual,d=o.minorBase,y=o.minorMustEqual,w=o.patchBase,v=o.patchMustEqual;o.hasCaret&&(f===0||(y=!1),v=!1);let l=0;if(o.preRelease){const h=S.exec(o.preRelease);if(h){const[,m,t,n]=h;l=Date.UTC(Number(m),Number(t)-1,Number(n))}}return{majorBase:f,majorMustEqual:c,minorBase:d,minorMustEqual:y,patchBase:w,patchMustEqual:v,isMinimum:o.hasGreaterEquals,notBefore:l}}e.normalizeVersion=D;function _(o,f,c){let d;typeof o=="string"?d=D(k(o)):d=o;let y;f instanceof Date?y=f.getTime():typeof f=="string"&&(y=new Date(f).getTime());let w;if(typeof c=="string"?w=D(k(c)):w=c,!d||!w)return!1;let v=d.majorBase,l=d.minorBase,h=d.patchBase,m=w.majorBase,t=w.minorBase,n=w.patchBase,s=w.notBefore,r=w.majorMustEqual,u=w.minorMustEqual,b=w.patchMustEqual;return w.isMinimum?v>m?!0:v<m?!1:l>t?!0:l<t||y&&y<s?!1:h>=n:(v===1&&m===0&&(!r||!u||!b)&&(m=1,t=0,n=0,r=!0,u=!1,b=!1),v<m?!1:v>m?!r:l<t?!1:l>t?!u:h<n?!1:h>n?!b:!(y&&y<s))}e.isValidVersion=_;function C(o,f,c,d){return c.isBuiltin||typeof c.main=="undefined"?!0:I(o,f,c.engines.vscode,d)}e.isValidExtensionVersion=C;function i(o,f,c){return o==="*"||I(f,c,o)}e.isEngineValid=i;function I(o,f,c,d=[]){let y=D(k(c));if(!y)return d.push(g.localize(0,null,c)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return d.push(g.localize(1,null,c)),!1}else if(!y.majorMustEqual)return d.push(g.localize(2,null,c)),!1;return _(o,f,y)?!0:(d.push(g.localize(3,null,o,c)),!1)}}),define(we[88],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class g{constructor(E,k=[],D=!1){this.ctor=E,this.staticArguments=k,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=g;const T=(S,...E)=>new g(S,E);e.createSyncDescriptor=T}),define(we[57],_e([0,1,88]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const T=[];function S(k,D,_){D instanceof g.SyncDescriptor||(D=new g.SyncDescriptor(D,[],_)),T.push([k,D])}e.registerSingleton=S;function E(){return T}e.getSingletonServiceDescriptors=E}),define(we[141],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(E){this.incoming=new Map,this.outgoing=new Map,this.data=E}}e.Node=g;class T{constructor(E){this._hashFn=E,this._nodes=new Map}roots(){const E=[];for(let k of this._nodes.values())k.outgoing.size===0&&E.push(k);return E}insertEdge(E,k){const D=this.lookupOrInsertNode(E),_=this.lookupOrInsertNode(k);D.outgoing.set(this._hashFn(k),_),_.incoming.set(this._hashFn(E),D)}removeNode(E){const k=this._hashFn(E);this._nodes.delete(k);for(let D of this._nodes.values())D.outgoing.delete(k),D.incoming.delete(k)}lookupOrInsertNode(E){const k=this._hashFn(E);let D=this._nodes.get(k);return D||(D=new g(E),this._nodes.set(k,D)),D}lookup(E){return this._nodes.get(this._hashFn(E))}isEmpty(){return this._nodes.size===0}toString(){let E=[];for(let[k,D]of this._nodes)E.push(`${k}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return E.join(`
`)}findCycleSlow(){for(let[E,k]of this._nodes){const D=new Set([E]),_=this._findCycle(k,D);if(_)return _}}_findCycle(E,k){for(let[D,_]of E.outgoing){if(k.has(D))return[...k,D].join(" -> ");k.add(D);const C=this._findCycle(_,k);if(C)return C;k.delete(D)}}}e.Graph=T}),define(we[4],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function _(C){return C[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=_})(g=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function T(D,_,C,i){_[g.DI_TARGET]===_?_[g.DI_DEPENDENCIES].push({id:D,index:C,optional:i}):(_[g.DI_DEPENDENCIES]=[{id:D,index:C,optional:i}],_[g.DI_TARGET]=_)}function S(D){if(g.serviceIds.has(D))return g.serviceIds.get(D);const _=function(C,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(_,C,I,!1)};return _.toString=()=>D,g.serviceIds.set(D,_),_}e.createDecorator=S;function E(D){return D}e.refineServiceDecorator=E;function k(D){return function(_,C,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");T(D,_,i,!0)}}e.optional=k}),define(we[142],_e([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=g.createDecorator("modelService");function T(S){return!S.isTooLargeForSyncing()&&!S.isForSimpleWidget}e.shouldSynchronizeModel=T}),define(we[143],_e([0,1,3,53,7,22,77,55,142]),function(ee,e,g,T,S,E,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(o){return typeof o=="string"?!1:Array.isArray(o)?o.every(C):!!o.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(f,c){let d={selector:f,provider:c,_score:-1,_time:this._clock++};return this._entries.push(d),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),S.toDisposable(()=>{if(d){let y=this._entries.indexOf(d);y>=0&&(this._entries.splice(y,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),d=void 0)}})}has(f){return this.all(f).length>0}all(f){if(!f)return[];this._updateScores(f);const c=[];for(let d of this._entries)d._score>0&&c.push(d.provider);return c}ordered(f){const c=[];return this._orderedForEach(f,d=>c.push(d.provider)),c}orderedGroups(f){const c=[];let d,y;return this._orderedForEach(f,w=>{d&&y===w._score?d.push(w.provider):(y=w._score,d=[w.provider],c.push(d))}),c}_orderedForEach(f,c){if(!!f){this._updateScores(f);for(const d of this._entries)d._score>0&&c(d)}}_updateScores(f){let c={uri:f.uri.toString(),language:f.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===c.language&&this._lastCandidate.uri===c.uri)){this._lastCandidate=c;for(let d of this._entries)if(d._score=D.score(d.selector,f.uri,f.getLanguageIdentifier().language,_.shouldSynchronizeModel(f)),C(d.selector)&&d._score>0){for(let y of this._entries)y._score=0;d._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(f,c){return f._score<c._score?1:f._score>c._score?-1:f._time<c._time?1:f._time>c._time?-1:0}}e.LanguageFeatureRegistry=i;class I{constructor(f,c,d=Number.MAX_SAFE_INTEGER){this._registry=f,this.min=c,this.max=d,this._cache=new E.LRUCache(50,.7)}_key(f){return f.id+T.hash(this._registry.all(f))}_clamp(f){return f===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(f*1.3)))}get(f){const c=this._key(f),d=this._cache.get(c);return this._clamp(d==null?void 0:d.value)}update(f,c){const d=this._key(f);let y=this._cache.get(d);return y||(y=new k.MovingAverage,this._cache.set(d,y)),y.update(c),this.get(f)}}e.LanguageFeatureRequestDelays=I}),define(we[58],_e([0,1,2,31,143,119,78]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var D;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));class _{constructor(R,M){this.language=R,this.id=M}}e.LanguageIdentifier=_;var C;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var i;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var I;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var o;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(o=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(R){return(R&255)>>>0}static getTokenType(R){return(R&1792)>>>8}static getFontStyle(R){return(R&14336)>>>11}static getForeground(R){return(R&8372224)>>>14}static getBackground(R){return(R&4286578688)>>>23}static getClassNameFromMetadata(R){let M=this.getForeground(R),H="mtk"+M,ue=this.getFontStyle(R);return ue&1&&(H+=" mtki"),ue&2&&(H+=" mtkb"),ue&4&&(H+=" mtku"),H}static getInlineStyleFromMetadata(R,M){const H=this.getForeground(R),ue=this.getFontStyle(R);let fe=`color: ${M[H]};`;return ue&1&&(fe+="font-style: italic;"),ue&2&&(fe+="font-weight: bold;"),ue&4&&(fe+="text-decoration: underline;"),fe}}e.TokenMetadata=f;var c;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(c=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let a=Object.create(null);return a[0]="symbol-method",a[1]="symbol-function",a[2]="symbol-constructor",a[3]="symbol-field",a[4]="symbol-variable",a[5]="symbol-class",a[6]="symbol-struct",a[7]="symbol-interface",a[8]="symbol-module",a[9]="symbol-property",a[10]="symbol-event",a[11]="symbol-operator",a[12]="symbol-unit",a[13]="symbol-value",a[14]="symbol-constant",a[15]="symbol-enum",a[16]="symbol-enum-member",a[17]="symbol-keyword",a[27]="symbol-snippet",a[18]="symbol-text",a[19]="symbol-color",a[20]="symbol-file",a[21]="symbol-reference",a[22]="symbol-customcolor",a[23]="symbol-folder",a[24]="symbol-type-parameter",a[25]="account",a[26]="issues",function(R){const M=a[R];let H=M&&k.iconRegistry.get(M);return H||(console.info("No codicon found for CompletionItemKind "+R),H=k.Codicon.symbolProperty),H.classNames}}(),e.completionKindFromString=function(){let a=Object.create(null);return a.method=0,a.function=1,a.constructor=2,a.field=3,a.variable=4,a.class=5,a.struct=6,a.interface=7,a.module=8,a.property=9,a.event=10,a.operator=11,a.unit=12,a.value=13,a.constant=14,a.enum=15,a["enum-member"]=16,a.enumMember=16,a.keyword=17,a.snippet=27,a.text=18,a.color=19,a.file=20,a.reference=21,a.customcolor=22,a.folder=23,a["type-parameter"]=24,a.typeParameter=24,a.account=25,a.issue=26,function(R,M){let H=a[R];return typeof H=="undefined"&&!M&&(H=9),H}}();var d;(function(a){a[a.Deprecated=1]="Deprecated"})(d=e.CompletionItemTag||(e.CompletionItemTag={}));var y;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(y=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var v;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(v=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var l;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(l=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var m;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(m=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(a){return a&&g.URI.isUri(a.uri)&&T.Range.isIRange(a.range)&&(T.Range.isIRange(a.originSelectionRange)||T.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=t;var n;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(n=e.SymbolKind||(e.SymbolKind={}));var s;(function(a){a[a.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var r;(function(a){const R=new Map;R.set("file",0),R.set("module",1),R.set("namespace",2),R.set("package",3),R.set("class",4),R.set("method",5),R.set("property",6),R.set("field",7),R.set("constructor",8),R.set("enum",9),R.set("interface",10),R.set("function",11),R.set("variable",12),R.set("constant",13),R.set("string",14),R.set("number",15),R.set("boolean",16),R.set("array",17),R.set("object",18),R.set("key",19),R.set("null",20),R.set("enum-member",21),R.set("struct",22),R.set("event",23),R.set("operator",24),R.set("type-parameter",25);const M=new Map;M.set(0,"file"),M.set(1,"module"),M.set(2,"namespace"),M.set(3,"package"),M.set(4,"class"),M.set(5,"method"),M.set(6,"property"),M.set(7,"field"),M.set(8,"constructor"),M.set(9,"enum"),M.set(10,"interface"),M.set(11,"function"),M.set(12,"variable"),M.set(13,"constant"),M.set(14,"string"),M.set(15,"number"),M.set(16,"boolean"),M.set(17,"array"),M.set(18,"object"),M.set(19,"key"),M.set(20,"null"),M.set(21,"enum-member"),M.set(22,"struct"),M.set(23,"event"),M.set(24,"operator"),M.set(25,"type-parameter");function H(Y){return R.get(Y)}a.fromString=H;function ue(Y){return M.get(Y)}a.toString=ue;function fe(Y,j){const Z=M.get(Y);let L=Z&&k.iconRegistry.get("symbol-"+Z);return L||(console.info("No codicon found for SymbolKind "+Y),L=k.Codicon.symbolProperty),`${j?"inline":"block"} ${L.classNames}`}a.toCssClassName=fe})(r=e.SymbolKinds||(e.SymbolKinds={}));class u{constructor(R){this.value=R}}e.FoldingRangeKind=u,u.Comment=new u("comment"),u.Imports=new u("imports"),u.Region=new u("region");var b;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(b=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var p;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(p=e.CommentMode||(e.CommentMode={}));var P;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(P=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new S.LanguageFeatureRegistry,e.RenameProviderRegistry=new S.LanguageFeatureRegistry,e.CompletionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new S.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new S.LanguageFeatureRegistry,e.HoverProviderRegistry=new S.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new S.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new S.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new S.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new S.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new S.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.LinkProviderRegistry=new S.LanguageFeatureRegistry,e.ColorProviderRegistry=new S.LanguageFeatureRegistry,e.SelectionRangeRegistry=new S.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.TokenizationRegistry=new E.TokenizationRegistryImpl;var A;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(A=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[89],_e([0,1,8,4,21]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let E=S.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",S.isMacintosh),k.set("isLinux",S.isLinux),k.set("isWindows",S.isWindows),k.set("isWeb",S.isWeb),k.set("isMacNative",S.isMacintosh&&!S.isWeb),k.set("isEdge",E.indexOf("Edg/")>=0),k.set("isFirefox",E.indexOf("Firefox")>=0),k.set("isChrome",E.indexOf("Chrome")>=0),k.set("isSafari",E.indexOf("Safari")>=0);const D=Object.prototype.hasOwnProperty;var _;(function(A){A[A.False=0]="False",A[A.True=1]="True",A[A.Defined=2]="Defined",A[A.Not=3]="Not",A[A.Equals=4]="Equals",A[A.NotEquals=5]="NotEquals",A[A.And=6]="And",A[A.Regex=7]="Regex",A[A.NotRegex=8]="NotRegex",A[A.Or=9]="Or",A[A.In=10]="In",A[A.NotIn=11]="NotIn",A[A.Greater=12]="Greater",A[A.GreaterEquals=13]="GreaterEquals",A[A.Smaller=14]="Smaller",A[A.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return I.INSTANCE}static true(){return o.INSTANCE}static has(a){return f.create(a)}static equals(a,R){return c.create(a,R)}static notEquals(a,R){return w.create(a,R)}static regex(a,R){return n.create(a,R)}static in(a,R){return d.create(a,R)}static not(a){return v.create(a)}static and(...a){return r.create(a)}static or(...a){return u.create(a)}static greater(a,R){return l.create(a,R)}static less(a,R){return m.create(a,R)}static deserialize(a,R=!1){if(!!a)return this._deserializeOrExpression(a,R)}static _deserializeOrExpression(a,R){let M=a.split("||");return u.create(M.map(H=>this._deserializeAndExpression(H,R)))}static _deserializeAndExpression(a,R){let M=a.split("&&");return r.create(M.map(H=>this._deserializeOne(H,R)))}static _deserializeOne(a,R){if(a=a.trim(),a.indexOf("!=")>=0){let M=a.split("!=");return w.create(M[0].trim(),this._deserializeValue(M[1],R))}if(a.indexOf("==")>=0){let M=a.split("==");return c.create(M[0].trim(),this._deserializeValue(M[1],R))}if(a.indexOf("=~")>=0){let M=a.split("=~");return n.create(M[0].trim(),this._deserializeRegexValue(M[1],R))}if(a.indexOf(" in ")>=0){let M=a.split(" in ");return d.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(a)){const M=a.split(">=");return h.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(a)){const M=a.split(">");return l.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(a)){const M=a.split("<=");return t.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(a)){const M=a.split("<");return m.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(a)?v.create(a.substr(1).trim()):f.create(a)}static _deserializeValue(a,R){if(a=a.trim(),a==="true")return!0;if(a==="false")return!1;let M=/^'([^']*)'$/.exec(a);return M?M[1].trim():a}static _deserializeRegexValue(a,R){if(g.isFalsyOrWhitespace(a)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=a.indexOf("/"),H=a.lastIndexOf("/");if(M===H||M<0){if(R)throw new Error(`bad regexp-value '${a}', missing /-enclosure`);return console.warn(`bad regexp-value '${a}', missing /-enclosure`),null}let ue=a.slice(M+1,H),fe=a[H+1]==="i"?"i":"";try{return new RegExp(ue,fe)}catch(Y){if(R)throw new Error(`bad regexp-value '${a}', parse error: ${Y}`);return console.warn(`bad regexp-value '${a}', parse error: ${Y}`),null}}}e.ContextKeyExpr=C;function i(A,a){return A.cmp(a)}class I{constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class o{constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=o,o.INSTANCE=new o;class f{constructor(a){this.key=a,this.type=2}static create(a){const R=k.get(a);return typeof R=="boolean"?R?o.INSTANCE:I.INSTANCE:new f(a)}cmp(a){return a.type!==this.type?this.type-a.type:p(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return v.create(this.key)}}e.ContextKeyDefinedExpr=f;class c{constructor(a,R){this.key=a,this.value=R,this.type=4}static create(a,R){if(typeof R=="boolean")return R?f.create(a):v.create(a);const M=k.get(a);return typeof M=="boolean"?R===(M?"true":"false")?o.INSTANCE:I.INSTANCE:new c(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(a){return a.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class d{constructor(a,R){this.key=a,this.valueKey=R,this.type=10}static create(a,R){return new d(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.valueKey,a.key,a.valueKey)}equals(a){return a.type===this.type?this.key===a.key&&this.valueKey===a.valueKey:!1}evaluate(a){const R=a.getValue(this.valueKey),M=a.getValue(this.key);return Array.isArray(R)?R.indexOf(M)>=0:typeof M=="string"&&typeof R=="object"&&R!==null?D.call(R,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(a){return a.mapIn(this.key,this.valueKey)}negate(){return y.create(this)}}e.ContextKeyInExpr=d;class y{constructor(a){this._actual=a,this.type=11}static create(a){return new y(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new y(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotInExpr=y;class w{constructor(a,R){this.key=a,this.value=R,this.type=5}static create(a,R){if(typeof R=="boolean")return R?v.create(a):f.create(a);const M=k.get(a);return typeof M=="boolean"?R===(M?"true":"false")?I.INSTANCE:o.INSTANCE:new w(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(a){return a.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class v{constructor(a){this.key=a,this.type=3}static create(a){const R=k.get(a);return typeof R=="boolean"?R?I.INSTANCE:o.INSTANCE:new v(a)}cmp(a){return a.type!==this.type?this.type-a.type:p(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!a.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(a){return a.mapNot(this.key)}negate(){return f.create(this.key)}}e.ContextKeyNotExpr=v;class l{constructor(a,R){this.key=a,this.value=R,this.type=12}static create(a,R){return new l(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=l;class h{constructor(a,R){this.key=a,this.value=R,this.type=13}static create(a,R){return new h(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreaterEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=h;class m{constructor(a,R){this.key=a,this.value=R,this.type=14}static create(a,R){return new m(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmaller(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeySmallerExpr=m;class t{constructor(a,R){this.key=a,this.value=R,this.type=15}static create(a,R){return new t(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmallerEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(a,R){this.key=a,this.regexp=R,this.type=7}static create(a,R){return new n(a,R)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.key<a.key)return-1;if(this.key>a.key)return 1;const R=this.regexp?this.regexp.source:"",M=a.regexp?a.regexp.source:"";return R<M?-1:R>M?1:0}equals(a){if(a.type===this.type){const R=this.regexp?this.regexp.source:"",M=a.regexp?a.regexp.source:"";return this.key===a.key&&R===M}return!1}evaluate(a){let R=a.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const a=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${a}`}keys(){return[this.key]}map(a){return a.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=n;class s{constructor(a){this._actual=a,this.type=8}static create(a){return new s(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new s(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class r{constructor(a){this.expr=a,this.type=6}static create(a){return r._normalizeArr(a)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let R=0,M=this.expr.length;R<M;R++){const H=i(this.expr[R],a.expr[R]);if(H!==0)return H}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let R=0,M=this.expr.length;R<M;R++)if(!this.expr[R].equals(a.expr[R]))return!1;return!0}return!1}evaluate(a){for(let R=0,M=this.expr.length;R<M;R++)if(!this.expr[R].evaluate(a))return!1;return!0}static _normalizeArr(a){const R=[];let M=!1;for(const H of a)if(!!H){if(H.type===1){M=!0;continue}if(H.type===0)return I.INSTANCE;if(H.type===6){R.push(...H.expr);continue}R.push(H)}if(R.length===0&&M)return o.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(i);R.length>1;){const H=R[R.length-1];if(H.type!==9)break;R.pop();const ue=R.pop(),fe=u.create(H.expr.map(Y=>r.create([Y,ue])));fe&&(R.push(fe),R.sort(i))}return R.length===1?R[0]:new r(R)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(let R of this.expr)a.push(...R.keys());return a}map(a){return new r(this.expr.map(R=>R.map(a)))}negate(){let a=[];for(let R of this.expr)a.push(R.negate());return u.create(a)}}e.ContextKeyAndExpr=r;class u{constructor(a){this.expr=a,this.type=9}static create(a){const R=u._normalizeArr(a);if(R.length!==0)return R.length===1?R[0]:new u(R)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let R=0,M=this.expr.length;R<M;R++){const H=i(this.expr[R],a.expr[R]);if(H!==0)return H}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let R=0,M=this.expr.length;R<M;R++)if(!this.expr[R].equals(a.expr[R]))return!1;return!0}return!1}evaluate(a){for(let R=0,M=this.expr.length;R<M;R++)if(this.expr[R].evaluate(a))return!0;return!1}static _normalizeArr(a){let R=[],M=!1;if(a){for(let H=0,ue=a.length;H<ue;H++){const fe=a[H];if(!!fe){if(fe.type===0){M=!0;continue}if(fe.type===1)return[o.INSTANCE];if(fe.type===9){R=R.concat(fe.expr);continue}R.push(fe)}}if(R.length===0&&M)return[I.INSTANCE];R.sort(i)}return R}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(let R of this.expr)a.push(...R.keys());return a}map(a){return new u(this.expr.map(R=>R.map(a)))}negate(){let a=[];for(let M of this.expr)a.push(M.negate());const R=M=>M.type===9?M.expr:[M];for(;a.length>1;){const M=a.shift(),H=a.shift(),ue=[];for(const fe of R(M))for(const Y of R(H))ue.push(C.and(fe,Y));a.unshift(C.or(...ue))}return a[0]}}e.ContextKeyOrExpr=u;class b extends f{constructor(a,R,M){super(a);this._defaultValue=R,typeof M=="object"?b._info.push(Object.assign(Object.assign({},M),{key:a})):M!==!0&&b._info.push({key:a,description:M,type:R!=null?typeof R:void 0})}static all(){return b._info.values()}bindTo(a){return a.createKey(this.key,this._defaultValue)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return C.not(this.key)}isEqualTo(a){return C.equals(this.key,a)}notEqualsTo(a){return C.notEquals(this.key,a)}}e.RawContextKey=b,b._info=[],e.IContextKeyService=T.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(A,a){return A<a?-1:A>a?1:0}function P(A,a,R,M){return A<R?-1:A>R?1:a<M?-1:a>M?1:0}}),define(we[144],_e([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=g.createDecorator("environmentService"),e.INativeEnvironmentService=g.refineServiceDecorator(e.IEnvironmentService)}),define(we[26],_e([0,1,8,4]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function S(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkpaceSupportTypeMessage=S;function E(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=E,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class D{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,o){if(typeof I=="undefined"||I===null)return typeof o=="undefined"||o===null;if(typeof o=="undefined"||o===null)return!1;if(typeof I=="string"||typeof o=="string"){let f=typeof I=="string"?I:I.value,c=typeof o=="string"?o:o.value;return g.equalsIgnoreCase(f,c)}return I._lower===o._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=D;function _(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function C(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=C,e.IBuiltinExtensionsScannerService=T.createDecorator("IBuiltinExtensionsScannerService")}),define(we[145],_e([0,1,8,26]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function S(f,c){return f.uuid&&c.uuid?f.uuid===c.uuid:f.id===c.id?!0:g.compareIgnoreCase(f.id,c.id)===0}e.areSameExtensions=S;class E{constructor(c,d){this.version=d,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof E?S(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=E;function k(f,c){return`${f}.${c}`}e.getExtensionId=k;function D(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function _(f,c){return D(k(f,c))}e.getGalleryExtensionId=_;function C(f,c){const d=[],y=w=>{for(const v of d)if(v.some(l=>S(c(l),c(w))))return v;return null};for(const w of f){const v=y(w);v?v.push(w):d.push([w])}return d}e.groupByExtension=C;function i(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(f){return Object.assign({id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0)},f.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function o(f){const c=new Set;for(const d of f)d.malicious&&c.add(d.id.id);return c}e.getMaliciousExtensionsSet=o}),define(we[59],_e([0,1,126,14,2,4,8,10,22]),function(ee,e,g,T,S,E,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=E.createDecorator("fileService");function C(j){return j.create===!0}e.isFileOpenForWriteOptions=C;var i;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(j){j[j.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var o;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock"})(o=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=f;function c(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=c;function d(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function y(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=y;var w;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(Z,L){super(Z);this.code=L}}e.FileSystemProviderError=v;function l(j,Z){const L=new v(j.toString(),Z);return m(L,Z),L}e.createFileSystemProviderError=l;function h(j){return j||l(g.localize(0,null),w.Unknown)}e.ensureFileSystemProviderError=h;function m(j,Z){return j.name=Z?`${Z} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=m;function t(j){if(!j)return w.Unknown;if(j instanceof v)return j.code;const Z=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!Z)return w.Unknown;switch(Z[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function n(j){if(j instanceof P)return j.fileOperationResult;switch(t(j)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var s;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class r{constructor(Z,L,q){this.resource=Z,this.operation=L,this.target=q}isOperation(Z){return this.operation===Z}}e.FileOperationEvent=r;var u;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class b{constructor(Z,L){this.changes=Z,this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const q of Z)switch(q.type){case 1:this.added||(this.added=_.TernarySearchTree.forUris(()=>L)),this.added.set(q.resource,q);break;case 0:this.updated||(this.updated=_.TernarySearchTree.forUris(()=>L)),this.updated.set(q.resource,q);break;case 2:this.deleted||(this.deleted=_.TernarySearchTree.forUris(()=>L)),this.deleted.set(q.resource,q);break}}contains(Z,...L){return this.doContains(Z,{includeChildren:!1},...L)}affects(Z,...L){return this.doContains(Z,{includeChildren:!0},...L)}doContains(Z,L,...q){var N,W,U,B,J,he;if(!Z)return!1;const De=q.length>0;return!!((!De||q.includes(1))&&(((N=this.added)===null||N===void 0?void 0:N.get(Z))||L.includeChildren&&((W=this.added)===null||W===void 0?void 0:W.findSuperstr(Z)))||(!De||q.includes(0))&&(((U=this.updated)===null||U===void 0?void 0:U.get(Z))||L.includeChildren&&((B=this.updated)===null||B===void 0?void 0:B.findSuperstr(Z)))||(!De||q.includes(2))&&(((J=this.deleted)===null||J===void 0?void 0:J.findSubstr(Z))||L.includeChildren&&((he=this.deleted)===null||he===void 0?void 0:he.findSuperstr(Z))))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get raw(){return this.changes}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=b;function p(j,Z,L){return!j||!Z||j===Z||Z.length>j.length?!1:(Z.charAt(Z.length-1)!==T.sep&&(Z+=T.sep),L?k.startsWithIgnoreCase(j,Z):j.indexOf(Z)===0)}e.isParent=p;class P extends Error{constructor(Z,L,q){super(Z);this.fileOperationResult=L,this.options=q}}e.FileOperationError=P;class A extends P{constructor(Z,L,q){super(Z,2,q);this.stat=L}}e.NotModifiedSinceFileOperationError=A;var a;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(a=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function M(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=M;async function H(j,Z){if(!Z.canHandleResource(S.URI.from({scheme:j.scheme})))return new Promise(L=>{const q=Z.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===j.scheme&&N.added&&(q.dispose(),L())})})}e.whenProviderRegistered=H,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ue{static formatSize(Z){return D.isNumber(Z)||(Z=0),Z<ue.KB?g.localize(1,null,Z.toFixed(0)):Z<ue.MB?g.localize(2,null,(Z/ue.KB).toFixed(2)):Z<ue.GB?g.localize(3,null,(Z/ue.MB).toFixed(2)):Z<ue.TB?g.localize(4,null,(Z/ue.GB).toFixed(2)):g.localize(5,null,(Z/ue.TB).toFixed(2))}}e.ByteSize=ue,ue.KB=1024,ue.MB=ue.KB*ue.KB,ue.GB=ue.MB*ue.KB,ue.TB=ue.GB*ue.KB;var fe;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(fe=e.Arch||(e.Arch={}));function Y(j){return{maxFileSize:j===0?300*ue.MB:16*ue.GB,maxHeapSize:j===0?700*ue.MB:2*700*ue.MB}}e.getPlatformLimits=Y}),define(we[60],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...S){this._entries=new Map;for(let[E,k]of S)this.set(E,k)}set(S,E){const k=this._entries.get(S);return this._entries.set(S,E),k}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=g}),define(we[146],_e([0,1,11,141,88,4,60,12]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class C extends Error{constructor(c){var d;super("cyclic dependency between services");this.message=(d=c.findCycleSlow())!==null&&d!==void 0?d:`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class i{constructor(c=new k.ServiceCollection,d=!1,y){this._activeInstantiations=new Set,this._services=c,this._strict=d,this._parent=y,this._services.set(E.IInstantiationService,this)}createChild(c){return new i(c,this._strict,this)}invokeFunction(c,...d){let y=o.traceInvocation(c),w=!1;try{return c({get:(l,h)=>{if(w)throw g.illegalState("service accessor is only valid during the invocation of its target method");const m=this._getOrCreateServiceInstance(l,y);if(!m&&h!==E.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return m}},...d)}finally{w=!0,y.stop()}}createInstance(c,...d){let y,w;return c instanceof S.SyncDescriptor?(y=o.traceCreation(c.ctor),w=this._createInstance(c.ctor,c.staticArguments.concat(d),y)):(y=o.traceCreation(c),w=this._createInstance(c,d,y)),y.stop(),w}_createInstance(c,d=[],y){let w=E._util.getServiceDependencies(c).sort((h,m)=>h.index-m.index),v=[];for(const h of w){let m=this._getOrCreateServiceInstance(h.id,y);if(!m&&this._strict&&!h.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${h.id}.`);v.push(m)}let l=w.length>0?w[0].index:d.length;if(d.length!==l){console.warn(`[createInstance] First service dependency of ${c.name} at position ${l+1} conflicts with ${d.length} static arguments`);let h=l-d.length;h>0?d=d.concat(new Array(h)):d=d.slice(0,l)}return new c(...[...d,...v])}_setServiceInstance(c,d){if(this._services.get(c)instanceof S.SyncDescriptor)this._services.set(c,d);else if(this._parent)this._parent._setServiceInstance(c,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let d=this._services.get(c);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):d}_getOrCreateServiceInstance(c,d){let y=this._getServiceInstanceOrDescriptor(c);return y instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,y,d.branch(c,!0)):(d.branch(c,!1),y)}_safeCreateAndCacheServiceInstance(c,d,y){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,d,y)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,d,y){const w=new T.Graph(h=>h.id.toString());let v=0;const l=[{id:c,desc:d,_trace:y}];for(;l.length;){const h=l.pop();if(w.lookupOrInsertNode(h),v++>1e3)throw new C(w);for(let m of E._util.getServiceDependencies(h.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(m.id);if(!t&&!m.optional&&console.warn(`[createInstance] ${c} depends on ${m.id} which is NOT registered.`),t instanceof S.SyncDescriptor){const n={id:m.id,desc:t,_trace:h._trace.branch(m.id,!0)};w.insertEdge(h,n),l.push(n)}}}for(;;){const h=w.roots();if(h.length===0){if(!w.isEmpty())throw new C(w);break}for(const{data:m}of h){if(this._getServiceInstanceOrDescriptor(m.id)instanceof S.SyncDescriptor){const n=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,n)}w.removeNode(m)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,d,y=[],w,v){if(this._services.get(c)instanceof S.SyncDescriptor)return this._createServiceInstance(d,y,w,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,d,y,w,v);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(c,d=[],y,w){if(y){const v=new D.IdleValue(()=>this._createInstance(c,d,w));return new Proxy(Object.create(null),{get(l,h){if(h in l)return l[h];let m=v.value,t=m[h];return typeof t!="function"||(t=t.bind(m),l[h]=t),t},set(l,h,m){return v.value[h]=m,!0}})}else return this._createInstance(c,d,w)}}e.InstantiationService=i;var I;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(I||(I={}));class o{constructor(c,d){this.type=c,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return _?new o(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):o._None}static traceCreation(c){return _?new o(0,c.name):o._None}branch(c,d){let y=new o(2,c.toString());return this._dep.push([c,d,y]),y}stop(){let c=Date.now()-this._start;o._totals+=c;let d=!1;function y(v,l){let h=[],m=new Array(v+1).join("	");for(const[t,n,s]of l._dep)if(n&&s){d=!0,h.push(`${m}CREATES -> ${t}`);let r=y(v+1,s);r&&h.push(r)}else h.push(`${m}uses -> ${t}`);return h.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${o._totals.toFixed(2)}ms)`];(c>2||d)&&console.log(w.join(`
`))}}o._None=new class extends o{constructor(){super(-1,null)}stop(){}branch(){return this}},o._totals=0}),define(we[15],_e([0,1,4,7,21,3,56]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=g.createDecorator("logService"),e.ILoggerService=g.createDecorator("loggerService");function D(){return new Date().toISOString()}var _;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;class C extends T.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new E.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class i extends C{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(_.Trace)&&this.log(_.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(_.Debug)&&this.log(_.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(_.Info)&&this.log(_.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(_.Warning)&&this.log(_.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(_.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(_.Error,this.format(s))}else this.log(_.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(_.Critical)&&this.log(_.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let s=0;s<t.length;s++){let r=t[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(u){}n+=(s>0?" ":"")+r}return n}}e.AbstractMessageLogger=i;class I extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!S.isWindows}trace(t,...n){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}debug(t,...n){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}info(t,...n){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}warn(t,...n){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...n):console.warn(`[main ${D()}]`,t,...n))}error(t,...n){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...n):console.error(`[main ${D()}]`,t,...n))}critical(t,...n){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...n):console.error(`[main ${D()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class o extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=o;class f extends C{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:k.toErrorMessage(t,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class c extends C{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const s of this.logServices)s.trace(t,...n)}debug(t,...n){for(const s of this.logServices)s.debug(t,...n)}info(t,...n){for(const s of this.logServices)s.info(t,...n)}warn(t,...n){for(const s of this.logServices)s.warn(t,...n)}error(t,...n){for(const s of this.logServices)s.error(t,...n)}critical(t,...n){for(const s of this.logServices)s.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=c;class d extends T.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=d;class y extends T.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}createLogger(t,n){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(n==null?void 0:n.always)?_.Trace:this.logLevel,n),this.loggers.set(t.toString(),s),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=y;class w{constructor(){this.onDidChangeLogLevel=new E.Emitter().event}setLevel(t){}getLevel(){return _.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=w;function v(m){if(m.verbose)return _.Trace;if(typeof m.logLevel=="string"){const t=l(m.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=v;function l(m){switch(m){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=l;function h(m){switch(m){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=h}),define(we[90],_e([0,1,4,127,42]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var E;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(E=e.MarkerTag||(e.MarkerTag={}));var k;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function C(c,d){return d-c}_.compare=C;const i=Object.create(null);i[_.Error]=T.localize(0,null),i[_.Warning]=T.localize(1,null),i[_.Info]=T.localize(2,null);function I(c){return i[c]||""}_.toString=I;function o(c){switch(c){case S.default.Error:return _.Error;case S.default.Warning:return _.Warning;case S.default.Info:return _.Info;case S.default.Ignore:return _.Hint}}_.fromSeverity=o;function f(c){switch(c){case _.Error:return S.default.Error;case _.Warning:return S.default.Warning;case _.Info:return S.default.Info;case _.Hint:return S.default.Ignore}}_.toSeverity=f}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(_){const C="";function i(o){return I(o,!0)}_.makeKey=i;function I(o,f){let c=[C];return o.source?c.push(o.source.replace("\xA6","\\\xA6")):c.push(C),o.code?typeof o.code=="string"?c.push(o.code.replace("\xA6","\\\xA6")):c.push(o.code.value.replace("\xA6","\\\xA6")):c.push(C),o.severity!==void 0&&o.severity!==null?c.push(k.toString(o.severity)):c.push(C),o.message&&f?c.push(o.message.replace("\xA6","\\\xA6")):c.push(C),o.startLineNumber!==void 0&&o.startLineNumber!==null?c.push(o.startLineNumber.toString()):c.push(C),o.startColumn!==void 0&&o.startColumn!==null?c.push(o.startColumn.toString()):c.push(C),o.endLineNumber!==void 0&&o.endLineNumber!==null?c.push(o.endLineNumber.toString()):c.push(C),o.endColumn!==void 0&&o.endColumn!==null?c.push(o.endColumn.toString()):c.push(C),c.push(C),c.join("\xA6")}_.makeKeyOptionalMessage=I})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=g.createDecorator("markerService")}),define(we[147],_e([0,1,42,4,3]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=g.default,e.INotificationService=T.createDecorator("notificationService");var E;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(E=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new _,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=D;class _{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=_}),define(we[148],_e([0,1,7,8,2,4]),function(ee,e,g,T,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=E.createDecorator("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(D){return{resolved:D,dispose(){}}}});function k(D,_){return S.URI.isUri(D)?T.equalsIgnoreCase(D.scheme,_):T.startsWithIgnoreCase(D,_+":")}e.matchesScheme=k});var Ve=this&&this.__decorate||function(ee,e,g,T){var S=arguments.length,E=S<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,g):T,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")E=Reflect.decorate(ee,e,g,T);else for(var D=ee.length-1;D>=0;D--)(k=ee[D])&&(E=(S<3?k(E):S>3?k(e,g,E):k(e,g))||E);return S>3&&E&&Object.defineProperty(e,g,E),E},ze=this&&this.__param||function(ee,e){return function(g,T){e(g,T,ee)}};define(we[149],_e([0,1,4,18,7,12]),function(ee,e,g,T,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=g.createDecorator("progressService");var k;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(k=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let _=class extends S.Disposable{constructor(I,o){super();this.deferred=new E.DeferredPromise,o.withProgress(I,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register(S.toDisposable(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};_=Ve([ze(1,e.IProgressService)],_),e.UnmanagedProgress=_;class C extends S.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(I){this.stop();const o=++this.currentOperationId,f=new T.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{o===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add(S.toDisposable(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add(S.toDisposable(()=>f.cancel())),this.currentOperationDisposables.add(S.toDisposable(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:o,token:f.token,stop:()=>this.doStop(o),isCurrent:()=>this.currentOperationId===o}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=g.createDecorator("editorProgressService")}),define(we[44],_e([0,1,10,39]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(k,D){T.ok(g.isString(k)),T.ok(g.isObject(D)),T.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,D)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new S}),define(we[150],_e([0,1,44,3]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class E{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,C){this.schemasById[S(_)]=C,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new E;g.Registry.add(e.Extensions.JSONContribution,k)}),define(we[61],_e([0,1,124,3,44,10,150]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const _=S.Registry.as(k.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:g.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,v=!0){this.registerConfigurations([w],v)}registerConfigurations(w,v=!0){const l=[];w.forEach(h=>{l.push(...this.validateAndRegisterProperties(h,v,h.extensionInfo)),this.configurationContributors.push(h),this.registerJSONConfiguration(h)}),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterConfigurations(w){const v=[],l=h=>{if(h.properties)for(const m in h.properties)v.push(m),delete this.configurationProperties[m],this.removeFromSchema(m,h.properties[m]);h.allOf&&h.allOf.forEach(m=>l(m))};for(const h of w){l(h);const m=this.configurationContributors.indexOf(h);m!==-1&&this.configurationContributors.splice(m,1)}_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}registerDefaultConfigurations(w){const v=[],l=[];for(const h of w)for(const m in h)if(v.push(m),e.OVERRIDE_PROPERTY_PATTERN.test(m)){this.defaultValues[m]=Object.assign(Object.assign({},this.defaultValues[m]||{}),h[m]);const t={type:"object",default:this.defaultValues[m],description:g.localize(1,null,m),$ref:e.resourceLanguageSettingsSchemaId};l.push(I(m)),this.configurationProperties[m]=t,this.defaultLanguageConfigurationOverridesNode.properties[m]=t}else{this.defaultValues[m]=h[m];const t=this.configurationProperties[m];t&&(this.updatePropertyDefaultValue(m,t),this.updateSchema(m,t))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterDefaultConfigurations(w){const v=[];for(const l of w)for(const h in l)if(v.push(h),delete this.defaultValues[h],e.OVERRIDE_PROPERTY_PATTERN.test(h))delete this.configurationProperties[h],delete this.defaultLanguageConfigurationOverridesNode.properties[h];else{const m=this.configurationProperties[h];m&&(this.updatePropertyDefaultValue(h,m),this.updateSchema(h,m))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const v of w)this.overrideIdentifiers.add(v);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,v=!0,l,h=3){var m;h=E.isUndefinedOrNull(w.scope)?h:w.scope;let t=[],n=w.properties;if(n)for(let r in n){if(v&&c(r)){delete n[r];continue}const u=n[r];if(this.updatePropertyDefaultValue(r,u),e.OVERRIDE_PROPERTY_PATTERN.test(r)?u.scope=void 0:(u.scope=E.isUndefinedOrNull(u.scope)?h:u.scope,u.restricted=E.isUndefinedOrNull(u.restricted)?!!((m=l==null?void 0:l.restrictedConfigurations)===null||m===void 0?void 0:m.includes(r)):u.restricted),n[r].hasOwnProperty("included")&&!n[r].included){this.excludedConfigurationProperties[r]=n[r],delete n[r];continue}else this.configurationProperties[r]=n[r];!n[r].deprecationMessage&&n[r].markdownDeprecationMessage&&(n[r].deprecationMessage=n[r].markdownDeprecationMessage),t.push(r)}let s=w.allOf;if(s)for(let r of s)t.push(...this.validateAndRegisterProperties(r,v,l,h));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const v=l=>{let h=l.properties;if(h)for(const t in h)this.updateSchema(t,h[t]);let m=l.allOf;m&&m.forEach(v)};v(w)}updateSchema(w,v){switch(e.allSettings.properties[w]=v,v.scope){case 1:e.applicationSettings.properties[w]=v;break;case 2:e.machineSettings.properties[w]=v;break;case 6:e.machineOverridableSettings.properties[w]=v;break;case 3:e.windowSettings.properties[w]=v;break;case 4:e.resourceSettings.properties[w]=v;break;case 5:e.resourceSettings.properties[w]=v,this.resourceLanguageSettingsSchema.properties[w]=v;break}}removeFromSchema(w,v){switch(delete e.allSettings.properties[w],v.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const v=`[${w}]`,l={type:"object",description:g.localize(2,null),errorMessage:g.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(v,l),e.allSettings.properties[v]=l,e.applicationSettings.properties[v]=l,e.machineSettings.properties[v]=l,e.machineOverridableSettings.properties[v]=l,e.windowSettings.properties[v]=l,e.resourceSettings.properties[v]=l}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,v){let l=this.defaultValues[w];E.isUndefined(l)&&(l=v.default),E.isUndefined(l)&&(l=o(v.type)),v.default=l}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function I(y){return y.substring(1,y.length-1)}e.overrideIdentifierFromKey=I;function o(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const f=new C;S.Registry.add(e.Extensions.Configuration,f);function c(y){return y.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(y)?g.localize(5,null,y):f.getConfigurationProperties()[y]!==void 0?g.localize(6,null,y):null:g.localize(4,null)}e.validateProperty=c;function d(){const y=[],w=f.getConfigurationProperties();for(const v of Object.keys(w))y.push([v,w[v].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.getScopes=d}),define(we[91],_e([0,1,24,10,2,44,4,61]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=k.createDecorator("configurationService");function _(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof S.URI)}e.isConfigurationOverrides=_;var C;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(n,s){const r=s?n?s.keys.filter(R=>n.keys.indexOf(R)===-1):[...s.keys]:[],u=n?s?n.keys.filter(R=>s.keys.indexOf(R)===-1):[...n.keys]:[],b=[];if(s&&n){for(const R of n.keys)if(s.keys.indexOf(R)!==-1){const M=w(n.contents,R),H=w(s.contents,R);g.equals(M,H)||b.push(R)}}const p=[],P=R=>{const M={};for(const H of R)for(const ue of H.identifiers)M[m(ue)]=H;return M},A=s?P(s.overrides):{},a=n?P(n.overrides):{};if(Object.keys(A).length)for(const R of r){const M=A[R];M&&p.push([D.overrideIdentifierFromKey(R),M.keys])}if(Object.keys(a).length)for(const R of u){const M=a[R];M&&p.push([D.overrideIdentifierFromKey(R),M.keys])}if(Object.keys(A).length&&Object.keys(a).length)for(const R of b){const M=a[R],H=A[R];if(M&&H){const ue=I({contents:M.contents,keys:M.keys,overrides:[]},{contents:H.contents,keys:H.keys,overrides:[]});p.push([D.overrideIdentifierFromKey(R),[...ue.added,...ue.removed,...ue.updated]])}}return{added:r,removed:u,updated:b,overrides:p}}e.compare=I;function o(n,s){const r=[];for(const u of Object.keys(n))if(D.OVERRIDE_PROPERTY_PATTERN.test(u)){const b={};for(const p in n[u])b[p]=n[u][p];r.push({identifiers:[D.overrideIdentifierFromKey(u).trim()],keys:Object.keys(b),contents:f(b,s)})}return r}e.toOverrides=o;function f(n,s){const r=Object.create(null);for(let u in n)c(r,u,n[u],s);return r}e.toValuesTree=f;function c(n,s,r,u){const b=s.split("."),p=b.pop();let P=n;for(let A=0;A<b.length;A++){let a=b[A],R=P[a];switch(typeof R){case"undefined":R=P[a]=Object.create(null);break;case"object":break;default:u(`Ignoring ${s} as ${b.slice(0,A+1).join(".")} is ${JSON.stringify(R)}`);return}P=R}if(typeof P=="object"&&P!==null)try{P[p]=r}catch(A){u(`Ignoring ${s} as ${b.join(".")} is ${JSON.stringify(P)}`)}else u(`Ignoring ${s} as ${b.join(".")} is ${JSON.stringify(P)}`)}e.addToValueTree=c;function d(n,s){const r=s.split(".");y(n,r)}e.removeFromValueTree=d;function y(n,s){const r=s.shift();if(s.length===0){delete n[r];return}if(Object.keys(n).indexOf(r)!==-1){const u=n[r];typeof u=="object"&&!Array.isArray(u)&&(y(u,s),Object.keys(u).length===0&&delete n[r])}}function w(n,s,r){function u(P,A){let a=P;for(const R of A){if(typeof a!="object"||a===null)return;a=a[R]}return a}const b=s.split("."),p=u(n,b);return typeof p=="undefined"?r:p}e.getConfigurationValue=w;function v(n,s,r){Object.keys(s).forEach(u=>{u!=="__proto__"&&(u in n?T.isObject(n[u])&&T.isObject(s[u])?v(n[u],s[u],r):r&&(n[u]=s[u]):n[u]=s[u])})}e.merge=v;function l(){const n=E.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=l;function h(){const n=Object.create(null),s=E.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let r in s){let u=s[r].default;c(n,r,u,b=>console.error(`Conflict in default settings: ${b}`))}return n}e.getDefaultValues=h;function m(n){return`[${n}]`}e.keyFromOverrideIdentifier=m;function t(n,s,r){const u=n.inspect(s),b=n.inspect(r);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof b.userValue!="undefined"||typeof b.workspaceValue!="undefined"||typeof b.workspaceFolderValue!="undefined"?b.value:u.defaultValue}e.getMigratedSettingValue=t}),define(we[151],_e([0,1,107,22,17,10,24,2,61,91,44,7,3]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},n=[],s=[]){this._contents=t,this._keys=n,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?C.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,n){const s=this.getContentsForOverrideIdentifer(n);return s?t?C.getConfigurationValue(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const r of S.distinct([...Object.keys(this.contents),...Object.keys(n)])){let u=this.contents[r],b=n[r];b&&(typeof u=="object"&&typeof b=="object"?(u=k.deepClone(u),this.mergeContents(u,b)):u=b),s[r]=u}return new f(s,this.keys,this.overrides)}merge(...t){const n=k.deepClone(this.contents),s=k.deepClone(this.overrides),r=[...this.keys];for(const u of t){this.mergeContents(n,u.contents);for(const b of u.overrides){const[p]=s.filter(P=>S.equals(P.identifiers,b.identifiers));p?this.mergeContents(p.contents,b.contents):s.push(k.deepClone(b))}for(const b of u.keys)r.indexOf(b)===-1&&r.push(b)}return new f(n,r,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const s of Object.keys(n)){if(s in t&&E.isObject(t[s])&&E.isObject(n[s])){this.mergeContents(t[s],n[s]);continue}t[s]=k.deepClone(n[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?k.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),C.addToValueTree(this.contents,t,n,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&C.removeFromValueTree(this.contents,t)}addKey(t){let n=this.keys.length;for(let s=0;s<n;s++)t.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=f;class c extends f{constructor(){const t=C.getDefaultValues(),n=C.getConfigurationKeys(),s=[];for(const r of Object.keys(t))_.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[_.overrideIdentifierFromKey(r).trim()],keys:Object.keys(t[r]),contents:C.toValuesTree(t[r],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,n,s)}}e.DefaultConfigurationModel=c;class d{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!E.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:s,keys:r,overrides:u,restricted:b}=this.doParseRaw(t,n);this._configurationModel=new f(s,r,u),this._restrictedConfigurations=b||[]}doParseContent(t){let n={},s=null,r=[],u=[],b=[];function p(A){Array.isArray(r)?r.push(A):s&&(r[s]=A)}let P={onObjectBegin:()=>{let A={};p(A),u.push(r),r=A,s=null},onObjectProperty:A=>{s=A},onObjectEnd:()=>{r=u.pop()},onArrayBegin:()=>{let A=[];p(A),u.push(r),r=A,s=null},onArrayEnd:()=>{r=u.pop()},onLiteralValue:p,onError:(A,a,R)=>{b.push({error:A,offset:a,length:R})}};if(t)try{g.visit(t,P),n=r[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return n}doParseRaw(t,n){const s=i.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,s,!0,n);t=r.raw;const u=C.toValuesTree(t,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),b=Object.keys(t),p=C.toOverrides(t,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:u,keys:b,overrides:p,restricted:r.restricted}}filter(t,n,s,r){if(!(r==null?void 0:r.scopes)&&!(r==null?void 0:r.skipRestricted))return{raw:t,restricted:[]};const u={},b=[];for(let p in t)if(_.OVERRIDE_PROPERTY_PATTERN.test(p)&&s){const P=this.filter(t[p],n,!1,r);u[p]=P.raw,b.push(...P.restricted)}else{const P=n[p],A=P?typeof P.scope!="undefined"?P.scope:3:void 0;(P==null?void 0:P.restricted)&&b.push(p),(A===void 0||r.scopes===void 0||r.scopes.includes(A))&&(r.skipRestricted&&(P==null?void 0:P.restricted)||(u[p]=t[p]))}return{raw:u,restricted:b}}}e.ConfigurationModelParser=d;class y extends I.Disposable{constructor(t,n,s,r){super();this.userSettingsResource=t,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new o.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(o.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class w{constructor(t,n,s=new f,r=new f,u=new T.ResourceMap,b=new f,p=new T.ResourceMap,P=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=u,this._memoryConfiguration=b,this._memoryConfigurationByResource=p,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(t)}updateValue(t,n,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new f,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(t):r.setValue(t,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,s){const r=this.getConsolidateConfigurationModel(n,s),u=this.getFolderConfigurationModelForResource(n.resource,s),b=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,p=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),P=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),A=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),a=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,M=u?n.overrideIdentifier?u.freeze().override(n.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,H=n.overrideIdentifier?b.override(n.overrideIdentifier).getValue(t):b.getValue(t),ue=r.getValue(t),fe=S.distinct(S.flatten(r.overrides.map(Y=>Y.identifiers))).filter(Y=>r.getOverrideValue(t,Y)!==void 0);return{defaultValue:p,userValue:P,userLocalValue:A,userRemoteValue:a,workspaceValue:R,workspaceFolderValue:M,memoryValue:H,value:ue,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:a!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:M!==void 0?{value:u==null?void 0:u.freeze().getValue(t),override:n.overrideIdentifier?u==null?void 0:u.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:H!==void 0?{value:b.getValue(t),override:n.overrideIdentifier?b.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:fe.length?fe:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=n.filter(r=>_.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const u=_.overrideIdentifierFromKey(r),b=this._defaultConfiguration.getKeysForOverrideIdentifier(u),p=t.getKeysForOverrideIdentifier(u),P=[...p.filter(A=>b.indexOf(A)===-1),...b.filter(A=>p.indexOf(A)===-1),...b.filter(A=>!k.equals(this._defaultConfiguration.override(u).getValue(A),t.override(u).getValue(A)))];return[u,P]});return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:r,overrides:u}=C.compare(this.localUserConfiguration,t),b=[...n,...s,...r];return b.length&&this.updateLocalUserConfiguration(t),{keys:b,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:r,overrides:u}=C.compare(this.remoteUserConfiguration,t);let b=[...n,...s,...r];return b.length&&this.updateRemoteUserConfiguration(t),{keys:b,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:r,overrides:u}=C.compare(this.workspaceConfiguration,t);let b=[...n,...s,...r];return b.length&&this.updateWorkspaceConfiguration(t),{keys:b,overrides:u}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:r,updated:u,removed:b,overrides:p}=C.compare(s,n);let P=[...r,...u,...b];return(P.length||!s)&&this.updateFolderConfiguration(t,n),{keys:P,overrides:p}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:r,removed:u,overrides:b}=C.compare(n,void 0);return{keys:[...s,...r,...u],overrides:b}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let s=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const r=n.getFolder(t);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const u=this._memoryConfigurationByResource.get(t);u&&(s=s.merge(u))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(n=s.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=s}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:s,overrides:r,keys:u}=this._folderConfigurations.get(n);return t.push([n,{contents:s,overrides:r,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((b,p)=>(b.set(D.URI.revive(p[0]),this.parseConfigurationModel(p[1])),b),new T.ResourceMap);return new w(n,s,new f,r,u,new f,new T.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function v(...m){if(m.length===0)return{keys:[],overrides:[]};if(m.length===1)return m[0];const t=new Set,n=new Map;for(const r of m)r.keys.forEach(u=>t.add(u)),r.overrides.forEach(([u,b])=>{const p=T.getOrSet(n,u,new Set);b.forEach(P=>p.add(P))});const s=[];return n.forEach((r,u)=>s.push([u,[...r.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=v;class l{constructor(t,n,s,r){this.change=t,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(p=>u.add(p)),t.overrides.forEach(([,p])=>p.forEach(P=>u.add(P))),this.affectedKeys=[...u.values()];const b=new f;this.affectedKeys.forEach(p=>b.setValue(p,{})),this.affectedKeysTree=b.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,u=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!k.equals(r,u)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let s=C.toValuesTree({[n]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(t=t[r],!t)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=l;class h extends l{constructor(t,n,s,r){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=h}),define(we[92],_e([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=g.createDecorator("remoteAuthorityResolverService");var T;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class S extends Error{constructor(k,D=T.Unknown,_){super(k);this._message=k,this._code=D,this._detail=_,this.isHandled=D===T.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype)}static isTemporarilyNotAvailable(k){return k instanceof S&&k._code===T.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof S&&k._code===T.NoResolverFound}static isHandled(k){return k instanceof S&&k.isHandled}}e.RemoteAuthorityResolverError=S}),define(we[93],_e([0,1,16]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function T(C){return C.scheme===g.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=T;function S(C){if(!C)return;const i=C.indexOf("+");return i<0?C:C.substr(0,i)}e.getRemoteName=S;function E(C){return C.scheme!==g.Schemas.file&&C.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=E;function k(C){if(C.folders.length)return C.folders.every(i=>E(i.uri))?C.folders[0].uri:void 0;if(C.configuration&&E(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=k;function D(C){var i;return(i=k(C))===null||i===void 0?void 0:i.scheme}e.getVirtualWorkspaceScheme=D;function _(C){return k(C)!==void 0}e.isVirtualWorkspace=_}),define(we[152],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,E,k=5){let D;return D=E(_=>{const C=typeof _=="string"?_:_.data;let i=this._terminalBufferMap.get(S);if(i){i.data.push(C);return}const I=setTimeout(()=>this.flushBuffer(S),k);i={data:[C],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(S),D.dispose()}},this._terminalBufferMap.set(S,i)}),D}stopBuffering(S){const E=this._terminalBufferMap.get(S);E&&E.dispose()}flushBuffer(S){const E=this._terminalBufferMap.get(S);E&&(this._terminalBufferMap.delete(S),this._callback(S,E.data.join("")))}}e.TerminalDataBufferer=g}),define(we[45],_e([0,1,2,25,4,22]),function(ee,e,g,T,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=S.createDecorator("contextService");var k;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function D(o){const f=o;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=D;function _(o){const f=o;return!!(f&&typeof f=="object"&&g.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=_;class C{constructor(f,c,d,y){this._id=f,this._configuration=d,this._ignorePathCasing=y,this._foldersMap=E.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=E.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=C;class i{constructor(f,c){this.raw=c,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return T.joinPath(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(o){return new i({uri:o,index:0,name:T.basenameOrAuthority(o)},{uri:o.toString()})}e.toWorkspaceFolder=I}),define(we[62],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const E=this._idPool++;return this._data.set(E,S),this.logDebugInfo(),E}get(S,E){return this._data.has(S)?this._data.get(S)[E]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(we[63],_e([0,1,2,3,4]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=S.createDecorator("IExtHostEditorTabs");class E{constructor(){this._onDidChangeTabs=new T.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(D){this._tabs=D.map(_=>({name:_.name,group:_.group,resource:g.URI.revive(_.resource),isActive:_.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=E}),define(we[46],_e([0,1,16,4]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class S{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(k,D){D===null?this._providerInfo.delete(k):this._providerInfo.set(k,D)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=S,e.IExtHostFileSystemInfo=T.createDecorator("IExtHostFileSystemInfo")}),define(we[28],_e([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=g.createDecorator("IExtHostInitDataService")}),define(we[153],_e([0,1,12]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(k,D,_){this._deferredPromises=new Map,this._id=k,this._shared=D,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of C.values())i.complete()}catch(i){for(const I of C.values())I.error(i)}})()},0)}get keys(){var k;return Object.entries((k=this._value)!==null&&k!==void 0?k:{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this._init}get(k,D){let _=this._value[k];return typeof _=="undefined"&&(_=D),_}update(k,D){this._value[k]=D;let _=this._deferredPromises.get(k);if(_!==void 0)return _.p;const C=new g.DeferredPromise;return this._deferredPromises.set(k,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=T;class S extends T{constructor(k,D){super(k.identifier.value,!0,D);this._extension=k}setKeysForSync(k){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},k)}}e.ExtensionGlobalMemento=S}),define(we[154],_e([0,1,3,2,15]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let E=class{constructor(D,_){this._logService=D,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(D,_,C){this._notebooksAndEditors.getNotebookDocument(T.URI.revive(D)).acceptModelChanged(_,C)}$acceptDirtyStateChanged(D,_){this._notebooksAndEditors.getNotebookDocument(T.URI.revive(D)).acceptDirty(_)}$acceptModelSaved(D){const _=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(D));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(D,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",D.path,_);const C=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(D));C.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:C.apiNotebook})}};E=Ve([ze(0,S.ILogService)],E),e.ExtHostNotebookDocuments=E}),define(we[13],_e([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=g.createDecorator("IExtHostRpcService");class T{constructor(E){this.getProxy=E.getProxy.bind(E),this.set=E.set.bind(E),this.assertRegistered=E.assertRegistered.bind(E),this.drain=E.drain.bind(E)}}e.ExtHostRpcService=T});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Be=this&&this.__classPrivateFieldGet||function(ee,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[155],_e([0,1,26,3]),function(ee,e,g,T){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class E{constructor(D,_){S.set(this,void 0),this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(D.identifier),nt(this,S,_,"f"),Be(this,S,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(D){return Be(this,S,"f").get(this._id,D)}store(D,_){return Be(this,S,"f").store(this._id,D,_)}delete(D){return Be(this,S,"f").delete(this._id,D)}}e.ExtensionSecrets=E,S=new WeakMap}),define(we[94],_e([0,1,4,3]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class S{constructor(){this._onDidChangeTelemetryEnabled=new T.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(k){this._enabled=k}$onDidChangeTelemetryEnabled(k){this._enabled=k,this._onDidChangeTelemetryEnabled.fire(k)}}e.ExtHostTelemetry=S,e.IExtHostTelemetry=g.createDecorator("IExtHostTelemetry")}),define(we[64],_e([0,1,3]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var T;(function(k){k[k.NewChild=0]="NewChild",k[k.Disposed=1]="Disposed",k[k.Invalidated=2]="Invalidated",k[k.SetProp=3]="SetProp"})(T=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const S=new WeakMap,E=k=>{let D=S.get(k);return D||(D={children:new Map,bus:new g.Emitter},S.set(k,D)),D};e.getPrivateApiFor=E}),define(we[65],_e([0,1,4,3,13]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var E;(function(D){function _(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,protocol:i.protocol}}D.fromApiTunnel=_;function C(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public,protocol:i.protocol}}D.fromServiceTunnel=C})(E=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=g.createDecorator("IExtHostTunnelService");let k=class{constructor(_){this.onDidChangeTunnels=new T.Emitter().event}async $applyCandidateFilter(_){return _}async openTunnel(_,C){}async getTunnels(){return[]}async setTunnelExtensionFunctions(_){return{dispose:()=>{}}}registerPortsAttributesProvider(_,C){return{dispose:()=>{}}}async $providePortAttributes(_,C,i,I,o){return[]}async $forwardPort(_,C){}async $closeTunnel(_){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=Ve([ze(0,S.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Be=this&&this.__classPrivateFieldGet||function(ee,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[6],_e([0,1,17,11,80,22,82,10,2,34,59,92,64]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o){"use strict";var f,c,d,y,w,v,l,h,m,t,n,s,r,u,b,p,P,A;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function a(x){function F(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(F,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(F,x),Object.setPrototypeOf(F.prototype,x.prototype),F}let R=w=class{constructor(F){f.set(this,void 0),nt(this,f,F,"f")}static from(...F){let ne=F;return new w(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}dispose(){typeof Be(this,f,"f")=="function"&&(Be(this,f,"f").call(this),nt(this,f,void 0,"f"))}};f=new WeakMap,R=w=Ve([a],R),e.Disposable=R;let M=v=class{constructor(F,ne){if(F<0)throw T.illegalArgument("line must be non-negative");if(ne<0)throw T.illegalArgument("character must be non-negative");this._line=F,this._character=ne}static Min(...F){if(F.length===0)throw new TypeError;let ne=F[0];for(let Se=1;Se<F.length;Se++){const je=F[Se];je.isBefore(ne)&&(ne=je)}return ne}static Max(...F){if(F.length===0)throw new TypeError;let ne=F[0];for(let Se=1;Se<F.length;Se++){const je=F[Se];je.isAfter(ne)&&(ne=je)}return ne}static isPosition(F){if(!F)return!1;if(F instanceof v)return!0;let{line:ne,character:Se}=F;return typeof ne=="number"&&typeof Se=="number"}get line(){return this._line}get character(){return this._character}isBefore(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<F._character}isBeforeOrEqual(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<=F._character}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this._line===F._line&&this._character===F._character}compareTo(F){return this._line<F._line?-1:this._line>F.line?1:this._character<F._character?-1:this._character>F._character?1:0}translate(F,ne=0){if(F===null||ne===null)throw T.illegalArgument();let Se;return typeof F=="undefined"?Se=0:typeof F=="number"?Se=F:(Se=typeof F.lineDelta=="number"?F.lineDelta:0,ne=typeof F.characterDelta=="number"?F.characterDelta:0),Se===0&&ne===0?this:new v(this.line+Se,this.character+ne)}with(F,ne=this.character){if(F===null||ne===null)throw T.illegalArgument();let Se;return typeof F=="undefined"?Se=this.line:typeof F=="number"?Se=F:(Se=typeof F.line=="number"?F.line:this.line,ne=typeof F.character=="number"?F.character:this.character),Se===this.line&&ne===this.character?this:new v(Se,ne)}toJSON(){return{line:this.line,character:this.character}}};M=v=Ve([a],M),e.Position=M;let H=l=class{constructor(F,ne,Se,je){let et,at;if(typeof F=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof je=="number"?(et=new M(F,ne),at=new M(Se,je)):F instanceof M&&ne instanceof M&&(et=F,at=ne),!et||!at)throw new Error("Invalid arguments");et.isBefore(at)?(this._start=et,this._end=at):(this._start=at,this._end=et)}static isRange(F){return F instanceof l?!0:F?M.isPosition(F.start)&&M.isPosition(F.end):!1}get start(){return this._start}get end(){return this._end}contains(F){return F instanceof l?this.contains(F._start)&&this.contains(F._end):F instanceof M?!(F.isBefore(this._start)||this._end.isBefore(F)):!1}isEqual(F){return this._start.isEqual(F._start)&&this._end.isEqual(F._end)}intersection(F){const ne=M.Max(F.start,this._start),Se=M.Min(F.end,this._end);if(!ne.isAfter(Se))return new l(ne,Se)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const ne=M.Min(F.start,this._start),Se=M.Max(F.end,this.end);return new l(ne,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(F,ne=this.end){if(F===null||ne===null)throw T.illegalArgument();let Se;return F?M.isPosition(F)?Se=F:(Se=F.start||this.start,ne=F.end||this.end):Se=this.start,Se.isEqual(this._start)&&ne.isEqual(this.end)?this:new l(Se,ne)}toJSON(){return[this.start,this.end]}};H=l=Ve([a],H),e.Range=H;let ue=h=class extends H{constructor(F,ne,Se,je){let et,at;if(typeof F=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof je=="number"?(et=new M(F,ne),at=new M(Se,je)):F instanceof M&&ne instanceof M&&(et=F,at=ne),!et||!at)throw new Error("Invalid arguments");super(et,at);this._anchor=et,this._active=at}static isSelection(F){return F instanceof h?!0:F?H.isRange(F)&&M.isPosition(F.anchor)&&M.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ue=h=Ve([a],ue),e.Selection=ue;class fe{constructor(F,ne,Se){if(typeof F!="string"||F.length===0)throw T.illegalArgument("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw T.illegalArgument("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw T.illegalArgument("connectionToken");this.host=F,this.port=Math.round(ne),this.connectionToken=Se}}e.ResolvedAuthority=fe;class Y extends Error{constructor(F,ne=I.RemoteAuthorityResolverErrorCode.Unknown,Se){super(F);this._message=F,this._code=ne,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,Y.prototype)}static NotAvailable(F,ne){return new Y(F,I.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(F){return new Y(F,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=Y;var j;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(j=e.EndOfLine||(e.EndOfLine={}));var Z;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(Z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let L=m=class{constructor(F,ne){this._range=F,this._newText=ne}static isTextEdit(F){return F instanceof m?!0:F?H.isRange(F)&&typeof F.newText=="string":!1}static replace(F,ne){return new m(F,ne)}static insert(F,ne){return m.replace(new H(F,F),ne)}static delete(F){return m.replace(F,"")}static setEndOfLine(F){const ne=new m(new H(new M(0,0),new M(0,0)),"");return ne.newEol=F,ne}get range(){return this._range}set range(F){if(F&&!H.isRange(F))throw T.illegalArgument("range");this._range=F}get newText(){return this._newText||""}set newText(F){if(F&&typeof F!="string")throw T.illegalArgument("newText");this._newText=F}get newEol(){return this._newEol}set newEol(F){if(F&&typeof F!="number")throw T.illegalArgument("newEol");this._newEol=F}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};L=m=Ve([a],L),e.TextEdit=L;var q;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace"})(q=e.FileEditType||(e.FileEditType={}));let N=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(F,ne,Se,je){this._edits.push({_type:1,from:F,to:ne,options:Se,metadata:je})}createFile(F,ne,Se){this._edits.push({_type:1,from:void 0,to:F,options:ne,metadata:Se})}deleteFile(F,ne,Se){this._edits.push({_type:1,from:F,to:void 0,options:ne,metadata:Se})}replaceNotebookMetadata(F,ne,Se){this._edits.push({_type:3,metadata:Se,uri:F,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(F,ne,Se,je,et){let at,lt,Dt=[],kt;if(Ht.isNotebookRange(ne)&&Nt.isNotebookCellDataArray(Se)&&!Nt.isNotebookCellDataArray(je)?(at=ne.start,lt=ne.end,Dt=Se,kt=je):typeof ne=="number"&&typeof Se=="number"&&Nt.isNotebookCellDataArray(je)&&(at=ne,lt=Se,Dt=je,kt=et),at===void 0||lt===void 0)throw new Error("Invalid arguments");(at!==lt||Dt.length>0)&&this._edits.push({_type:5,uri:F,index:at,count:lt-at,cells:Dt,metadata:kt})}replaceNotebookCellMetadata(F,ne,Se,je){this._edits.push({_type:3,metadata:je,uri:F,edit:{editType:8,index:ne,metadata:Se}})}replace(F,ne,Se,je){this._edits.push({_type:2,uri:F,edit:new L(ne,Se),metadata:je})}insert(F,ne,Se,je){this.replace(F,new H(ne,ne),Se,je)}delete(F,ne,Se){this.replace(F,ne,"",Se)}has(F){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===F.toString())}set(F,ne){if(ne)for(const Se of ne)Se&&this._edits.push({_type:2,uri:F,edit:Se});else{for(let Se=0;Se<this._edits.length;Se++){const je=this._edits[Se];je._type===2&&je.uri.toString()===F.toString()&&(this._edits[Se]=void 0)}g.coalesceInPlace(this._edits)}}get(F){const ne=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===F.toString()&&ne.push(Se.edit);return ne}entries(){const F=new E.ResourceMap;for(let ne of this._edits)if(ne._type===2){let Se=F.get(ne.uri);Se||(Se=[ne.uri,[]],F.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};N=Ve([a],N),e.WorkspaceEdit=N;let W=t=class{constructor(F){this._tabstop=1,this.value=F||""}static isSnippetString(F){return F instanceof t?!0:F?typeof F.value=="string":!1}static _escape(F){return F.replace(/\$|}|\\/g,"\\$&")}appendText(F){return this.value+=t._escape(F),this}appendTabstop(F=this._tabstop++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,ne=this._tabstop++){if(typeof F=="function"){const Se=new t;Se._tabstop=this._tabstop,F(Se),this._tabstop=Se._tabstop,F=Se.value}else F=t._escape(F);return this.value+="${",this.value+=ne,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,ne=this._tabstop++){const Se=F.map(je=>je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(F,ne){if(typeof ne=="function"){const Se=new t;Se._tabstop=this._tabstop,ne(Se),this._tabstop=Se._tabstop,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};W=t=Ve([a],W),e.SnippetString=W;var U;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(U=e.DiagnosticTag||(e.DiagnosticTag={}));var B;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(B=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let J=n=class{constructor(F,ne){if(this.uri=F,ne)if(ne instanceof H)this.range=ne;else if(ne instanceof M)this.range=new H(ne,ne);else throw new Error("Illegal argument")}static isLocation(F){return F instanceof n?!0:F?H.isRange(F.range)&&_.URI.isUri(F.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};J=n=Ve([a],J),e.Location=J;let he=class{constructor(F,ne){this.location=F,this.message=ne}static is(F){return F?typeof F.message=="string"&&F.location&&H.isRange(F.location.range)&&_.URI.isUri(F.location.uri):!1}static isEqual(F,ne){return F===ne?!0:!F||!ne?!1:F.message===ne.message&&F.location.range.isEqual(ne.location.range)&&F.location.uri.toString()===ne.location.uri.toString()}};he=Ve([a],he),e.DiagnosticRelatedInformation=he;let De=class{constructor(F,ne,Se=B.Error){if(!H.isRange(F))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=F,this.message=ne,this.severity=Se}toJSON(){return{severity:B[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,ne){return F===ne?!0:!F||!ne?!1:F.message===ne.message&&F.severity===ne.severity&&F.code===ne.code&&F.severity===ne.severity&&F.source===ne.source&&F.range.isEqual(ne.range)&&g.equals(F.tags,ne.tags)&&g.equals(F.relatedInformation,ne.relatedInformation,he.isEqual)}};De=Ve([a],De),e.Diagnostic=De;let Oe=class{constructor(F,ne){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=ne}};Oe=Ve([a],Oe),e.Hover=Oe;var Me;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(Me=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let He=class{constructor(F,ne=Me.Text){this.range=F,this.kind=ne}toJSON(){return{range:this.range,kind:Me[this.kind]}}};He=Ve([a],He),e.DocumentHighlight=He;var Ye;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(Ye=e.SymbolKind||(e.SymbolKind={}));var qe;(function(x){x[x.Deprecated=1]="Deprecated"})(qe=e.SymbolTag||(e.SymbolTag={}));let Xe=s=class{constructor(F,ne,Se,je,et){this.name=F,this.kind=ne,this.containerName=et,typeof Se=="string"&&(this.containerName=Se),je instanceof J?this.location=je:Se instanceof H&&(this.location=new J(je,Se)),s.validate(this)}static validate(F){if(!F.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ye[this.kind],location:this.location,containerName:this.containerName}}};Xe=s=Ve([a],Xe),e.SymbolInformation=Xe;let $=r=class{constructor(F,ne,Se,je,et){this.name=F,this.detail=ne,this.kind=Se,this.range=je,this.selectionRange=et,this.children=[],r.validate(this)}static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children&&F.children.forEach(r.validate)}};$=r=Ve([a],$),e.DocumentSymbol=$;var G;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(G=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let te=class{constructor(F,ne){this.title=F,this.kind=ne}};te=Ve([a],te),e.CodeAction=te;let re=u=class{constructor(F){this.value=F}append(F){return new u(this.value?this.value+u.sep+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+u.sep)}};re.sep=".",re=u=Ve([a],re),e.CodeActionKind=re,re.Empty=new re(""),re.QuickFix=re.Empty.append("quickfix"),re.Refactor=re.Empty.append("refactor"),re.RefactorExtract=re.Refactor.append("extract"),re.RefactorInline=re.Refactor.append("inline"),re.RefactorRewrite=re.Refactor.append("rewrite"),re.Source=re.Empty.append("source"),re.SourceOrganizeImports=re.Source.append("organizeImports"),re.SourceFixAll=re.Source.append("fixAll");let K=class{constructor(F,ne){if(this.range=F,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};K=Ve([a],K),e.SelectionRange=K;class oe{constructor(F,ne,Se,je,et,at){this.kind=F,this.name=ne,this.detail=Se,this.uri=je,this.range=et,this.selectionRange=at}}e.CallHierarchyItem=oe;class me{constructor(F,ne){this.fromRanges=ne,this.from=F}}e.CallHierarchyIncomingCall=me;class Ae{constructor(F,ne){this.fromRanges=ne,this.to=F}}e.CallHierarchyOutgoingCall=Ae;let $e=class{constructor(F,ne){this.range=F,this.command=ne}get isResolved(){return!!this.command}};$e=Ve([a],$e),e.CodeLens=$e;let pe=b=class{constructor(F,ne=!1){c.set(this,void 0),nt(this,c,new S.MarkdownString(F,{supportThemeIcons:ne}),"f")}static isMarkdownString(F){return F instanceof b?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}get value(){return Be(this,c,"f").value}set value(F){Be(this,c,"f").value=F}get isTrusted(){return Be(this,c,"f").isTrusted}set isTrusted(F){Be(this,c,"f").isTrusted=F}get supportThemeIcons(){return Be(this,c,"f").supportThemeIcons}set supportThemeIcons(F){Be(this,c,"f").supportThemeIcons=F}appendText(F){return Be(this,c,"f").appendText(F),this}appendMarkdown(F){return Be(this,c,"f").appendMarkdown(F),this}appendCodeblock(F,ne){return Be(this,c,"f").appendCodeblock(ne??"",F),this}};c=new WeakMap,pe=b=Ve([a],pe),e.MarkdownString=pe;let Ge=class{constructor(F,ne){this.label=F,this.documentation=ne}};Ge=Ve([a],Ge),e.ParameterInformation=Ge;let V=class{constructor(F,ne){this.label=F,this.documentation=ne,this.parameters=[]}};V=Ve([a],V),e.SignatureInformation=V;let ie=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ie=Ve([a],ie),e.SignatureHelp=ie;var ge;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(ge=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Fe;(function(x){x[x.Other=0]="Other",x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(Fe=e.InlayHintKind||(e.InlayHintKind={}));let Ne=class{constructor(F,ne,Se){this.text=F,this.position=ne,this.kind=Se}};Ne=Ve([a],Ne),e.InlayHint=Ne;var Qe;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ee;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Ee=e.CompletionItemKind||(e.CompletionItemKind={}));var be;(function(x){x[x.Deprecated=1]="Deprecated"})(be=e.CompletionItemTag||(e.CompletionItemTag={}));let Ce=class{constructor(F,ne){this.label=F,this.kind=ne}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Ee[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ce=Ve([a],Ce),e.CompletionItem=Ce;let se=class{constructor(F=[],ne=!1){this.items=F,this.isIncomplete=ne}};se=Ve([a],se),e.CompletionList=se;let de=class{constructor(F,ne,Se){this.text=F,this.range=ne,this.command=Se}};de=Ve([a],de),e.InlineSuggestion=de;let O=class{constructor(F){this.items=F}};O=Ve([a],O),e.InlineSuggestions=O;var Q;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Q=e.ViewColumn||(e.ViewColumn={}));var le;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(le=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ke;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(ke=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ue;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Ue=e.TextEditorRevealType||(e.TextEditorRevealType={}));var We;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(We=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ze;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(Ze=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function F(ne){switch(ne){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=F}(We=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let rt=class{constructor(F,ne){if(ne&&!_.URI.isUri(ne))throw T.illegalArgument("target");if(!H.isRange(F)||F.isEmpty)throw T.illegalArgument("range");this.range=F,this.target=ne}};rt=Ve([a],rt),e.DocumentLink=rt;let Ke=class{constructor(F,ne,Se,je){this.red=F,this.green=ne,this.blue=Se,this.alpha=je}};Ke=Ve([a],Ke),e.Color=Ke;let Je=class{constructor(F,ne){if(ne&&!(ne instanceof Ke))throw T.illegalArgument("color");if(!H.isRange(F)||F.isEmpty)throw T.illegalArgument("range");this.range=F,this.color=ne}};Je=Ve([a],Je),e.ColorInformation=Je;let ft=class{constructor(F){if(!F||typeof F!="string")throw T.illegalArgument("label");this.label=F}};ft=Ve([a],ft),e.ColorPresentation=ft;var ve;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(ve=e.ColorFormat||(e.ColorFormat={}));var ye;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(ye=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ae{constructor(F,ne,Se){if(this.startIndex=F,this.length=ne,this.tooltip=Se,typeof F!="number"||F<0)throw T.illegalArgument("startIndex");if(typeof ne!="number"||ne<1)throw T.illegalArgument("length");if(Se!==void 0&&typeof Se!="string")throw T.illegalArgument("tooltip")}}e.TerminalLink=ae;class z{constructor(F){this.options=F,typeof F!="object"&&T.illegalArgument("options")}}e.TerminalProfile=z;var xe;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(xe=e.TaskRevealKind||(e.TaskRevealKind={}));var Te;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(Te=e.TaskPanelKind||(e.TaskPanelKind={}));let Re=p=class{constructor(F,ne){if(typeof F!="string"||typeof ne!="string")throw T.illegalArgument("name");this._id=F}static from(F){switch(F){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}get id(){return this._id}};Re.Clean=new p("clean","Clean"),Re.Build=new p("build","Build"),Re.Rebuild=new p("rebuild","Rebuild"),Re.Test=new p("test","Test"),Re=p=Ve([a],Re),e.TaskGroup=Re;function it(x){let F="";for(let ne=0;ne<x.length;ne++)F+=x[ne].replace(/,/g,",,")+",";return F}let ot=class{constructor(F,ne,Se){if(typeof F!="string")throw T.illegalArgument("process");this._args=[],this._process=F,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=Se):this._options=ne)}get process(){return this._process}set process(F){if(typeof F!="string")throw T.illegalArgument("process");this._process=F}get args(){return this._args}set args(F){Array.isArray(F)||(F=[]),this._args=F}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("process"),this._process!==void 0&&F.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)F.push(ne);return it(F)}};ot=Ve([a],ot),e.ProcessExecution=ot;let tt=class{constructor(F,ne,Se){if(this._args=[],Array.isArray(ne)){if(!F)throw T.illegalArgument("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw T.illegalArgument("command");this._command=F,this._args=ne,this._options=Se}else{if(typeof F!="string")throw T.illegalArgument("commandLine");this._commandLine=F,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(F){if(typeof F!="string")throw T.illegalArgument("commandLine");this._commandLine=F}get command(){return this._command?this._command:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw T.illegalArgument("command");this._command=F}get args(){return this._args}set args(F){this._args=F||[]}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("shell"),this._commandLine!==void 0&&F.push(this._commandLine),this._command!==void 0&&F.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)F.push(typeof ne=="string"?ne:ne.value);return it(F)}};tt=Ve([a],tt),e.ShellExecution=tt;var vt;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(vt=e.ShellQuoting||(e.ShellQuoting={}));var gt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(gt=e.TaskScope||(e.TaskScope={}));class pt{constructor(F){this._callback=F}computeId(){return"customExecution"+C.generateUuid()}set callback(F){this._callback=F}get callback(){return this._callback}}e.CustomExecution=pt;let wt=P=class{constructor(F,ne,Se,je,et,at){this.__deprecated=!1,this._definition=this.definition=F;let lt;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=Se,this.execution=je,lt=et,this.__deprecated=!0):ne===gt.Global||ne===gt.Workspace?(this.target=ne,this._name=this.name=Se,this._source=this.source=je,this.execution=et,lt=at):(this.target=ne,this._name=this.name=Se,this._source=this.source=je,this.execution=et,lt=at),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(F){this.__id=F}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ot?this._definition={type:P.ProcessType,id:this._execution.computeId()}:this._execution instanceof tt?this._definition={type:P.ShellType,id:this._execution.computeId()}:this._execution instanceof pt?this._definition={type:P.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:P.EmptyType,id:C.generateUuid()}}get definition(){return this._definition}set definition(F){if(F==null)throw T.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=F}get scope(){return this._scope}set target(F){this.clear(),this._scope=F}get name(){return this._name}set name(F){if(typeof F!="string")throw T.illegalArgument("name");this.clear(),this._name=F}get execution(){return this._execution}set execution(F){F===null&&(F=void 0),this.clear(),this._execution=F;const ne=this._definition.type;(P.EmptyType===ne||P.ProcessType===ne||P.ShellType===ne||P.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(F){if(Array.isArray(F))this.clear(),this._problemMatchers=F,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.clear(),this._isBackground=F}get source(){return this._source}set source(F){if(typeof F!="string"||F.length===0)throw T.illegalArgument("source must be a string of length > 0");this.clear(),this._source=F}get group(){return this._group}set group(F){F===null&&(F=void 0),this.clear(),this._group=F}get detail(){return this._detail}set detail(F){F===null&&(F=void 0),this._detail=F}get presentationOptions(){return this._presentationOptions}set presentationOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._presentationOptions=F}get runOptions(){return this._runOptions}set runOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._runOptions=F}};wt.ExtensionCallbackType="customExecution",wt.ProcessType="process",wt.ShellType="shell",wt.EmptyType="$empty",wt=P=Ve([a],wt),e.Task=wt;var Tt;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(Tt=e.ProgressLocation||(e.ProgressLocation={}));let Pt=class{constructor(F,ne=Et.None){this.collapsibleState=ne,_.URI.isUri(F)?this.resourceUri=F:this.label=F}};Pt=Ve([a],Pt),e.TreeItem=Pt;var Et;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(Et=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ut=class{constructor(F,ne){this.id=F,this.color=ne}};ut=Ve([a],ut),e.ThemeIcon=ut,ut.File=new ut("file"),ut.Folder=new ut("folder");let mt=class{constructor(F){this.id=F}};mt=Ve([a],mt),e.ThemeColor=mt;var _t;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(_t=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ft=class{constructor(F,ne){if(typeof F!="string"&&(!F||!_.URI.isUri(F)&&!_.URI.isUri(F.uri)))throw T.illegalArgument("base");if(typeof ne!="string")throw T.illegalArgument("pattern");typeof F=="string"?(this.baseFolder=_.URI.file(F),this.base=F):_.URI.isUri(F)?(this.baseFolder=F,this.base=F.fsPath):(this.baseFolder=F.uri,this.base=F.uri.fsPath),this.pattern=ne}};Ft=Ve([a],Ft),e.RelativePattern=Ft;let yt=class{constructor(F,ne,Se,je){this.enabled=typeof F=="boolean"?F:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof je=="string"&&(this.logMessage=je)}get id(){return this._id||(this._id=C.generateUuid()),this._id}};yt=Ve([a],yt),e.Breakpoint=yt;let Zt=class extends yt{constructor(F,ne,Se,je,et){super(ne,Se,je,et);if(F===null)throw T.illegalArgument("location");this.location=F}};Zt=Ve([a],Zt),e.SourceBreakpoint=Zt;let qt=class extends yt{constructor(F,ne,Se,je,et){super(ne,Se,je,et);this.functionName=F}};qt=Ve([a],qt),e.FunctionBreakpoint=qt;let St=class extends yt{constructor(F,ne,Se,je,et,at,lt){super(je,et,at,lt);if(!ne)throw T.illegalArgument("dataId");this.label=F,this.dataId=ne,this.canPersist=Se}};St=Ve([a],St),e.DataBreakpoint=St;let ei=class{constructor(F,ne,Se){this.command=F,this.args=ne||[],this.options=Se}};ei=Ve([a],ei),e.DebugAdapterExecutable=ei;let ti=class{constructor(F,ne){this.port=F,this.host=ne}};ti=Ve([a],ti),e.DebugAdapterServer=ti;let ht=class{constructor(F){this.path=F}};ht=Ve([a],ht),e.DebugAdapterNamedPipeServer=ht;let Gt=class{constructor(F){this.implementation=F}};Gt=Ve([a],Gt),e.DebugAdapterInlineImplementation=Gt;let $t=class{constructor(F,ne){this.range=F,this.expression=ne}};$t=Ve([a],$t),e.EvaluatableExpression=$t;var Di;(function(x){x[x.Automatic=0]="Automatic",x[x.Explicit=1]="Explicit"})(Di=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ii=class{constructor(F,ne){this.range=F,this.text=ne}};ii=Ve([a],ii),e.InlineValueText=ii;let Ct=class{constructor(F,ne,Se=!0){this.range=F,this.variableName=ne,this.caseSensitiveLookup=Se}};Ct=Ve([a],Ct),e.InlineValueVariableLookup=Ct;let Kt=class{constructor(F,ne){this.range=F,this.expression=ne}};Kt=Ve([a],Kt),e.InlineValueEvaluatableExpression=Kt;let ni=class{constructor(F,ne){this.frameId=F,this.stoppedLocation=ne}};ni=Ve([a],ni),e.InlineValueContext=ni;var Qt;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Qt=e.FileChangeType||(e.FileChangeType={}));let ct=A=class extends Error{constructor(F,ne=i.FileSystemProviderErrorCode.Unknown,Se){var je;super(_.URI.isUri(F)?F.toString(!0):F);this.code=(je=Se==null?void 0:Se.name)!==null&&je!==void 0?je:"Unknown",i.markAsFileSystemProviderError(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists(F){return new A(F,i.FileSystemProviderErrorCode.FileExists,A.FileExists)}static FileNotFound(F){return new A(F,i.FileSystemProviderErrorCode.FileNotFound,A.FileNotFound)}static FileNotADirectory(F){return new A(F,i.FileSystemProviderErrorCode.FileNotADirectory,A.FileNotADirectory)}static FileIsADirectory(F){return new A(F,i.FileSystemProviderErrorCode.FileIsADirectory,A.FileIsADirectory)}static NoPermissions(F){return new A(F,i.FileSystemProviderErrorCode.NoPermissions,A.NoPermissions)}static Unavailable(F){return new A(F,i.FileSystemProviderErrorCode.Unavailable,A.Unavailable)}};ct=A=Ve([a],ct),e.FileSystemError=ct;let ri=class{constructor(F,ne,Se){this.start=F,this.end=ne,this.kind=Se}};ri=Ve([a],ri),e.FoldingRange=ri;var Mt;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(Mt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wt;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(Wt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var gi;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(gi=e.CommentMode||(e.CommentMode={}));class Ci{constructor(F,ne=[]){this.tokenTypes=F,this.tokenModifiers=ne}}e.SemanticTokensLegend=Ci;function pi(x){return typeof x=="undefined"||D.isStringArray(x)}class si{constructor(F){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,F){this._hasLegend=!0;for(let ne=0,Se=F.tokenTypes.length;ne<Se;ne++)this._tokenTypeStrToInt.set(F.tokenTypes[ne],ne);for(let ne=0,Se=F.tokenModifiers.length;ne<Se;ne++)this._tokenModifierStrToInt.set(F.tokenModifiers[ne],ne)}}push(F,ne,Se,je,et){if(typeof F=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof je=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(F,ne,Se,je,et);if(H.isRange(F)&&typeof ne=="string"&&pi(Se))return this._push(F,ne,Se);throw T.illegalArgument()}_push(F,ne,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const je=F.start.line,et=F.start.character,at=F.end.character-F.start.character,lt=this._tokenTypeStrToInt.get(ne);let Dt=0;if(Se)for(const kt of Se){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const At=this._tokenModifierStrToInt.get(kt);Dt|=1<<At>>>0}this._pushEncoded(je,et,at,lt,Dt)}_pushEncoded(F,ne,Se,je,et){if(this._dataIsSortedAndDeltaEncoded&&(F<this._prevLine||F===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let kt=0,At=0;for(let Rt=0;Rt<Dt;Rt++){let Ot=this._data[5*Rt],fi=this._data[5*Rt+1];Ot===0?(Ot=kt,fi+=At):Ot+=kt,this._data[5*Rt]=Ot,this._data[5*Rt+1]=fi,kt=Ot,At=fi}}let at=F,lt=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=je,this._data[this._dataLen++]=et,this._prevLine=F,this._prevChar=ne}static _sortAndDeltaEncode(F){let ne=[];const Se=F.length/5|0;for(let lt=0;lt<Se;lt++)ne[lt]=lt;ne.sort((lt,Dt)=>{const kt=F[5*lt],At=F[5*Dt];if(kt===At){const Rt=F[5*lt+1],Ot=F[5*Dt+1];return Rt-Ot}return kt-At});const je=new Uint32Array(F.length);let et=0,at=0;for(let lt=0;lt<Se;lt++){const Dt=5*ne[lt],kt=F[Dt+0],At=F[Dt+1],Rt=F[Dt+2],Ot=F[Dt+3],fi=F[Dt+4],Ni=kt-et,$i=Ni===0?At-at:At,mi=5*lt;je[mi+0]=Ni,je[mi+1]=$i,je[mi+2]=Rt,je[mi+3]=Ot,je[mi+4]=fi,et=kt,at=At}return je}build(F){return this._dataIsSortedAndDeltaEncoded?new Yt(new Uint32Array(this._data),F):new Yt(si._sortAndDeltaEncode(this._data),F)}}e.SemanticTokensBuilder=si;class Yt{constructor(F,ne){this.resultId=ne,this.data=F}}e.SemanticTokens=Yt;class xt{constructor(F,ne,Se){this.start=F,this.deleteCount=ne,this.data=Se}}e.SemanticTokensEdit=xt;class ki{constructor(F,ne){this.resultId=ne,this.edits=F}}e.SemanticTokensEdits=ki;var oi;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(oi=e.DebugConsoleMode||(e.DebugConsoleMode={}));var ai;(function(x){x[x.Initial=1]="Initial",x[x.Dynamic=2]="Dynamic"})(ai=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Jt=class{constructor(){}};Jt.Back={iconPath:new ut("arrow-left")},Jt=Ve([a],Jt),e.QuickInputButtons=Jt;var Ii;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(Ii=e.ExtensionKind||(e.ExtensionKind={}));class Lt{constructor(F,ne,Se){this.badge=F,this.tooltip=ne,this.color=Se}static validate(F){if(F.badge&&F.badge.length!==1&&F.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Lt;let li=class{constructor(F){this.kind=F}};li=Ve([a],li),e.ColorTheme=li;var Pi;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast"})(Pi=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{constructor(F,ne){if(F<0)throw T.illegalArgument("start must be positive");if(ne<0)throw T.illegalArgument("end must be positive");F<=ne?(this._start=F,this._end=ne):(this._start=ne,this._end=F)}static isNotebookRange(F){return F instanceof Ht?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(F){let ne=this._start,Se=this._end;return F.start!==void 0&&(ne=F.start),F.end!==void 0&&(Se=F.end),ne===this._start&&Se===this._end?this:new Ht(ne,Se)}}e.NotebookRange=Ht;class Nt{constructor(F,ne,Se,je,et,at,lt){this.kind=F,this.value=ne,this.languageId=Se,this.mime=je,this.outputs=et??[],this.metadata=at,this.executionSummary=lt,Nt.validate(this)}static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(ne=>Nt.isNotebookCellData(ne))}static isNotebookCellData(F){return!0}}e.NotebookCellData=Nt;class ui{constructor(F){this.cells=F}}e.NotebookData=ui;class It{constructor(F,ne){this.data=F,this.mime=ne;const Se=k.normalizeMimeType(ne,!0);if(!Se)throw new Error("INVALID mime type, must not be empty or falsy: "+ne);this.mime=Se}static isNotebookCellOutputItem(F){return F instanceof It?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const ne={name:F.name,message:F.message,stack:F.stack};return It.json(ne,"application/vnd.code.notebook.error")}static stdout(F){return It.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return It.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,ne="application/octet-stream"){return new It(F,ne)}static text(F,ne=k.Mimes.text){const Se=Be(It,d,"f",y).encode(String(F));return new It(Se,ne)}static json(F,ne="application/json"){const Se=JSON.stringify(F,void 0,"	");return It.text(Se,ne)}}e.NotebookCellOutputItem=It,d=It,y={value:new TextEncoder};class zt{constructor(F,ne,Se){this.items=zt.ensureUniqueMimeTypes(F,!0),typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=C.generateUuid(),this.metadata=ne??Se)}static isNotebookCellOutput(F){return F instanceof zt?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&D.isArray(F.items)}static ensureUniqueMimeTypes(F,ne=!1){const Se=new Set,je=new Set;for(let et=0;et<F.length;et++){const at=F[et],lt=k.normalizeMimeType(at.mime);if(!Se.has(lt)){Se.add(lt);continue}je.add(et),ne&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return je.size===0?F:F.filter((et,at)=>!je.has(at))}}e.NotebookCellOutput=zt;var ci;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(ci=e.NotebookCellKind||(e.NotebookCellKind={}));var Le;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(Le=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var di;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(di=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var vi;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(vi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class dt{constructor(F,ne){this.text=F,this.alignment=ne}}e.NotebookCellStatusBarItem=dt;var Ai;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ti{constructor(F,ne=[]){this.uri=F,this.provides=g.asArray(ne)}}e.NotebookRendererScript=Ti;let Xt=class{constructor(F,ne){this.label=F,this.timestamp=ne}};Xt=Ve([a],Xt),e.TimelineItem=Xt;var bi;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(bi=e.ExtensionMode||(e.ExtensionMode={}));var hi;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(hi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ri;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=4]="RegEx"})(Ri=e.StandardTokenType||(e.StandardTokenType={}));class Fi{constructor(F,ne){this.ranges=F,this.wordPattern=ne}}e.LinkedEditingRanges=Fi;class Mi{constructor(F,ne){this._port=F,this._autoForwardAction=ne}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mi;var wi;(function(x){x[x.Unset=0]="Unset",x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(wi=e.TestResultState||(e.TestResultState={}));var _i;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information",x[x.Hint=3]="Hint"})(_i=e.TestMessageSeverity||(e.TestMessageSeverity={}));var Ei;(function(x){x[x.Pending=0]="Pending",x[x.Resolved=1]="Resolved"})(Ei=e.TestItemStatus||(e.TestItemStatus={}));const Bt=(x,F,ne,Se)=>{let je=ne;return{enumerable:!0,configurable:!1,get(){return je},set(et){Se(je,et)||(je=et,x.bus.fire([3,F,et]))}}},Vt=(x,F)=>x===F,Li=(x,F)=>x===F?!0:!x||!F?!1:x.isEqual(F);class X{constructor(F,ne,Se,je){this.label=ne,this.data=je;const et=o.getPrivateApiFor(this);Object.defineProperties(this,{id:{value:F,enumerable:!0,writable:!1},uri:{value:Se,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>et.parent},children:{value:new E.ReadonlyMapView(et.children),enumerable:!0,writable:!1},range:Bt(et,"range",void 0,Li),description:Bt(et,"description",void 0,Vt),runnable:Bt(et,"runnable",!0,Vt),debuggable:Bt(et,"debuggable",!1,Vt),status:Bt(et,"status",Ei.Resolved,Vt),error:Bt(et,"error",void 0,Vt)})}invalidate(){o.getPrivateApiFor(this).bus.fire([2])}dispose(){const F=o.getPrivateApiFor(this);F.parent&&o.getPrivateApiFor(F.parent).children.delete(this.id),F.bus.fire([1])}addChild(F){if(!(F instanceof X))throw new Error("Test child must be created through vscode.test.createTestItem()");const ne=o.getPrivateApiFor(this);if(ne.children.has(F.id))throw new Error(`Attempted to insert a duplicate test item ID ${F.id}`);ne.children.set(F.id,F),o.getPrivateApiFor(F).parent=this,ne.bus.fire([0,F])}}e.TestItemImpl=X;class ce{constructor(F){this.message=F,this.severity=_i.Error}static diff(F,ne,Se){const je=new ce(F);return je.expectedOutput=ne,je.actualOutput=Se,je}}e.TestMessage=ce;var Ie;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(Ie=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var st;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(st=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var bt;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(bt=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(we[95],_e([0,1,39,16,8,120,85,6,17]),function(ee,e,g,T,S,E,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function i(c,d){d?C.set(c,d):C.delete(c)}e.setWordDefinitionFor=i;function I(c){return C.get(c)}e.getWordDefinitionFor=I;class o extends E.MirrorTextModel{constructor(d,y,w,v,l,h,m,t){super(y,w,v,l);this._proxy=d,this._languageId=h,this._isDirty=m,this._notebook=t,this._isDisposed=!1}dispose(){g.ok(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return _.equals(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===T.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(y){return y?d._getTextInRange(y):d.getText()},get eol(){return d._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(y){return d._lineAt(y)},offsetAt(y){return d._offsetAt(y)},positionAt(y){return d._positionAt(y)},validateRange(y){return d._validateRange(y)},validatePosition(y){return d._validatePosition(y)},getWordRangeAtPosition(y,w){return d._getWordRangeAtPosition(y,w)}}}return Object.freeze(this._document)}_acceptLanguageId(d){g.ok(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){g.ok(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const y=this._validateRange(d);if(y.isEmpty)return"";if(y.isSingleLine)return this._lines[y.start.line].substring(y.start.character,y.end.character);const w=this._eol,v=y.start.line,l=y.end.line,h=[];h.push(this._lines[v].substring(y.start.character));for(let m=v+1;m<l;m++)h.push(this._lines[m]);return h.push(this._lines[l].substring(0,y.end.character)),h.join(w)}_lineAt(d){let y;if(d instanceof D.Position?y=d.line:typeof d=="number"&&(y=d),typeof y!="number"||y<0||y>=this._lines.length||Math.floor(y)!==y)throw new Error("Illegal value for `line`");return new f(y,this._lines[y],y===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getPrefixSum(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const y=this._lineStarts.getIndexOf(d),w=this._lines[y.index].length;return new D.Position(y.index,Math.min(y.remainder,w))}_validateRange(d){if(!(d instanceof D.Range))throw new Error("Invalid argument");const y=this._validatePosition(d.start),w=this._validatePosition(d.end);return y===d.start&&w===d.end?d:new D.Range(y.line,y.character,w.line,w.character)}_validatePosition(d){if(!(d instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:y,character:w}=d,v=!1;if(y<0)y=0,w=0,v=!0;else if(y>=this._lines.length)y=this._lines.length-1,w=this._lines[y].length,v=!0;else{const l=this._lines[y].length;w<0?(w=0,v=!0):w>l&&(w=l,v=!0)}return v?new D.Position(y,w):d}_getWordRangeAtPosition(d,y){const w=this._validatePosition(d);if(!y)y=I(this._languageId);else if(S.regExpLeadsToEndlessLoop(y))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${y.source}' because it matches the empty string.`);const v=k.getWordAtText(w.character+1,k.ensureValidWordDefinition(y),this._lines[w.line],0);if(v)return new D.Range(w.line,v.startColumn-1,w.line,v.endColumn-1)}}e.ExtHostDocumentData=o;class f{constructor(d,y,w){this._line=d,this._text=y,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(we[156],_e([0,1,6,3,87,7,55,22,2,34]),function(ee,e,g,T,S,E,k,D,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(o,f,c,d){this._notebook=c,this._selector=d,this._disposables=new E.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:C.generateUuid()}),this._init(),this._disposables.add(f.onDidChangeDocument(w=>{const v=this._cellUris.get(w.document.uri);v!==void 0&&(this._cellLengths.changeValue(v,this._cells[v].document.getText().length+1),this._cellLines.changeValue(v,this._cells[v].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const y=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(o.onDidChangeNotebookCells(w=>y(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const o=[],f=[];for(const c of this._notebook.getCells())c.kind===g.NotebookCellKind.Code&&(!this._selector||k.score(this._selector,c.document.uri,c.document.languageId,!0))&&(this._cellUris.set(c.document.uri,this._cells.length),this._cells.push(c),o.push(c.document.getText().length+1),f.push(c.document.lineCount));this._cellLengths=new S.PrefixSumComputer(new Uint32Array(o)),this._cellLines=new S.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(o){var f,c;if(!o){let l="";for(const h of this._cells)l+=h.document.getText()+`
`;return l=l.slice(0,-1),l}if(o.isEmpty)return"";const d=this.locationAt(o.start),y=this.locationAt(o.end),w=this._cells[(f=this._cellUris.get(d.uri))!==null&&f!==void 0?f:-1],v=this._cells[(c=this._cellUris.get(y.uri))!==null&&c!==void 0?c:-1];if(!w||!v)return"";if(w===v)return w.document.getText(new g.Range(d.range.start,y.range.end));{const l=w.document.getText(new g.Range(d.range.start,new g.Position(w.document.lineCount,0))),h=v.document.getText(new g.Range(new g.Position(0,0),y.range.end));return l+`
`+h}}offsetAt(o){const f=this._cellLines.getIndexOf(o.line),c=this._cellLengths.getPrefixSum(f.index-1),d=this._cells[f.index].document.offsetAt(o.with(f.remainder));return c+d}positionAt(o){if(typeof o=="number"){const c=this._cellLengths.getIndexOf(o),d=this._cellLines.getPrefixSum(c.index-1);return this._cells[c.index].document.positionAt(c.remainder).translate(d)}const f=this._cellUris.get(o.uri);if(f!==void 0){const c=this._cellLines.getPrefixSum(f-1);return new g.Position(c+o.range.start.line,o.range.start.character)}return new g.Position(0,0)}locationAt(o){g.Range.isRange(o)||(o=new g.Range(o,o));const f=this._cellLines.getIndexOf(o.start.line);let c=f;o.isEmpty||(c=this._cellLines.getIndexOf(o.end.line));const d=new g.Position(f.remainder,o.start.character),y=new g.Position(c.remainder,o.end.character),w=new g.Range(d,y),v=this._cells[f.index];return new g.Location(v.document.uri,v.document.validateRange(w))}contains(o){return this._cellUris.has(o)}validateRange(o){const f=this.validatePosition(o.start),c=this.validatePosition(o.end);return o.with(f,c)}validatePosition(o){const f=this._cellLines.getIndexOf(o.line),c=new g.Position(f.remainder,o.character),d=this._cells[f.index].document.validatePosition(c),y=this._cellLines.getPrefixSum(f.index-1);return new g.Position(y+d.line,d.character)}}e.ExtHostNotebookConcatDocument=i}),define(we[157],_e([0,1,6,13,3]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let E=class{constructor(D){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let _=D==="light"?g.ColorThemeKind.Light:D==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};E=Ve([ze(0,T.IExtHostRpcService)],E),e.ExtHostTheming=E}),define(we[66],_e([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=g.createDecorator("IURITransformerService");class T{constructor(E){E?(this.transformIncoming=E.transformIncoming.bind(E),this.transformOutgoing=E.transformOutgoing.bind(E),this.transformOutgoingURI=E.transformOutgoingURI.bind(E),this.transformOutgoingScheme=E.transformOutgoingScheme.bind(E)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=T}),define(we[158],_e([0,1,23]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(_){let C=this.buffers.indexOf(_);return C<0&&(C=this.buffers.length,this.buffers.push(_)),C}}function S(D,_){if(_.serializeBuffersForPostMessage){const C=new T,i=(f,c)=>{if(c instanceof ArrayBuffer){const d=C.add(c);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(c)){const d=E(c);if(d){const y=C.add(c.buffer);return{$$vscode_array_buffer_reference$$:!0,index:y,view:{type:d,byteLength:c.byteLength,byteOffset:c.byteOffset}}}}return c},I=JSON.stringify(D,i),o=C.buffers.map(f=>{const c=new Uint8Array(f);return g.VSBuffer.wrap(c)});return{message:I,buffers:o}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=S;function E(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function k(D,_){const C=_.map(o=>{const f=new ArrayBuffer(o.byteLength);return new Uint8Array(f).set(o.buffer),f}),i=_.length?(o,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const c=f,{index:d}=c,y=C[d];if(c.view)switch(c.view.type){case 1:return new Int8Array(y,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(y,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(y,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(y,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(y,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(y,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(y,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(y,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(y,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(y,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(y,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return y}return f}:void 0;return{message:JSON.parse(D,i),arrayBuffers:C}}e.deserializeWebviewMessage=k}),define(we[67],_e([0,1,16,2]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function S(E,k){return E.scheme===g.Schemas.http||E.scheme===g.Schemas.https?E:(k&&k.authority&&k.isRemote&&E.scheme===g.Schemas.file&&(E=T.URI.from({scheme:g.Schemas.vscodeRemote,authority:k.authority,path:E.path})),T.URI.from({scheme:g.Schemas.https,authority:`${E.scheme}+${E.authority}.${e.webviewRootResourceAuthority}`,path:E.path,fragment:E.fragment,query:E.query}))}e.asWebviewUri=S}),define(we[159],_e([0,1,3,7,67]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class E{constructor(D,_,C){this._proxy=D,this._editors=_,this._initData=C,this._handlePool=0,this._disposables=new T.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const i=_.getVisibleTextEditors();for(const I of this._insets.values())i.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,_,C,i,I){let o;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===D){o=l;break}if(!o)throw new Error("not a visible editor");const f=this,c=this._handlePool++,d=new g.Emitter,y=new g.Emitter,w=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(l){return S.asWebviewUri(l,f._initData.remote)}get cspSource(){return S.webviewGenericCspSource}set options(l){this._options=l,f._proxy.$setOptions(c,l)}get options(){return this._options}set html(l){this._html=l,f._proxy.$setHtml(c,l)}get html(){return this._html}get onDidReceiveMessage(){return d.event}postMessage(l){return f._proxy.$postMessage(c,l)}},v=new class{constructor(){this.editor=D,this.line=_,this.height=C,this.webview=w,this.onDidDispose=y.event}dispose(){f._insets.has(c)&&(f._insets.delete(c),f._proxy.$disposeEditorInset(c),y.fire(),y.dispose(),d.dispose())}};return this._proxy.$createEditorInset(c,o.id,o.value.document.uri,_+1,C,i||{},I.identifier,I.extensionLocation),this._insets.set(c,{editor:D,inset:v,onDidReceiveMessage:d}),v}$onDidDispose(D){const _=this._insets.get(D);_&&_.inset.dispose()}$onDidReceiveMessage(D,_){const C=this._insets.get(D);C&&C.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=E}),define(we[160],_e([0,1,3,12,135]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class E{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,_,C,i){const I={command:D};if(_&&Object.keys(_).length>0&&(I.arguments=_),this.internalSend("request",I),typeof i=="number"){const o=setTimeout(()=>{clearTimeout(o);const f=this.pendingRequests.get(I.seq);if(f){this.pendingRequests.delete(I.seq);const c={type:"response",seq:0,request_seq:I.seq,success:!1,command:D,message:S.localize(0,null,i,D)};f(c)}},i)}return C&&this.pendingRequests.set(I.seq,C),I.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,_){return D.type!=="event"||_.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await T.timeout(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const _=D,C=this.pendingRequests.get(_.request_seq);C&&(this.pendingRequests.delete(_.request_seq),C(_));break}}}internalSend(D,_){_.type=D,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((_,C)=>D.set(C,_)),await T.timeout(500),D.forEach((_,C)=>{_({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=E}),define(we[161],_e([0,1,8,2,14,24,16]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function _(n,s,r){return n.replace(D,function(u,b){return s&&b.length>0&&b[0]!=="_"?u:r&&r.hasOwnProperty(b)?r[b]:u})}e.formatPII=_;function C(n){const s={};for(const r of Object.keys(n))r.startsWith("!")||(s[r]=n[r]);return s}e.filterExceptionsFromTelemetry=C;function i(n){return n.configuration.request==="attach"&&!I(n)&&(!n.parentSession||i(n.parentSession))}e.isSessionAttach=i;function I(n){let s=n.configuration.type;if(!!s)return s==="vslsShare"&&(s=n.configuration.adapterProxy.configuration.type),g.equalsIgnoreCase(s,"extensionhost")||g.equalsIgnoreCase(s,"pwa-extensionhost")?n:n.parentSession?I(n.parentSession):void 0}e.getExtensionHostDebugSession=I;function o(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=o;function f(n,s,r){let u,b=0,p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,P=null;for(;P=p.exec(n);){let A=P.index+1,a=A+P[0].length;if(A<=s&&a>=r){u=P[0],b=A;break}}if(u){let A=/\w+/g,a=null;for(;(a=A.exec(u))&&!(a.index+1+b+a[0].length>=r););a&&(u=u.substring(0,A.lastIndex))}return u?{start:b,end:b+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(n){return!!(n&&n.match(c))}e.isUri=d;function y(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(d(n.path))return T.URI.parse(n.path);if(S.isAbsolute(n.path))return T.URI.file(n.path)}return n.path}function w(n){if(typeof n.path=="object"){const s=T.URI.revive(n.path);if(s)return s.scheme===k.Schemas.file?s.fsPath:s.toString()}return n.path}function v(n,s){const r=s?y:w,u=E.deepClone(n);return h(u,(b,p)=>{b&&p&&(p.path=r(p))}),u}e.convertToDAPaths=v;function l(n,s){const r=s?y:w,u=E.deepClone(n);return h(u,(b,p)=>{!b&&p&&(p.path=r(p))}),u}e.convertToVSCPaths=l;function h(n,s){switch(n.type){case"event":const r=n;switch(r.event){case"output":s(!1,r.body.source);break;case"loadedSource":s(!1,r.body.source);break;case"breakpoint":s(!1,r.body.breakpoint.source);break;default:break}break;case"request":const u=n;switch(u.command){case"setBreakpoints":s(!0,u.arguments.source);break;case"breakpointLocations":s(!0,u.arguments.source);break;case"source":s(!0,u.arguments.source);break;case"gotoTargets":s(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(p=>s(!1,p));break;default:break}break;case"response":const b=n;if(b.success&&b.body)switch(b.command){case"stackTrace":b.body.stackFrames.forEach(p=>s(!1,p.source));break;case"loadedSources":b.body.sources.forEach(p=>s(!1,p));break;case"scopes":b.body.scopes.forEach(p=>s(!1,p.source));break;case"setFunctionBreakpoints":b.body.breakpoints.forEach(p=>s(!1,p.source));break;case"setBreakpoints":b.body.breakpoints.forEach(p=>s(!1,p.source));break;default:break}break}}function m(n){return n.filter(s=>{var r;return!((r=s.presentation)===null||r===void 0?void 0:r.hidden)}).sort((s,r)=>s.presentation?r.presentation?s.presentation.group?r.presentation.group?s.presentation.group!==r.presentation.group?s.presentation.group.localeCompare(r.presentation.group):t(s.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(s.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=m;function t(n,s){return typeof n!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:n-s}}),define(we[68],_e([0,1,27,82,16,14,21,89]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var _;(function(a){a[a.Markup=1]="Markup",a[a.Code=2]="Code"})(_=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",T.Mimes.markdown,"image/png","image/jpeg",T.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[T.Mimes.markdown,"application/json",T.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var C;(function(a){a[a.Running=1]="Running",a[a.Idle=2]="Idle"})(C=e.NotebookRunState||(e.NotebookRunState={}));var i;(function(a){a[a.Pending=2]="Pending",a[a.Executing=3]="Executing"})(i=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(a){a[a.WithHardKernelDependency=0]="WithHardKernelDependency",a[a.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",a[a.Pure=2]="Pure",a[a.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var o;(function(a){a.Always="always",a.Never="never",a.Optional="optional"})(o=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(a){a[a.ModelChange=1]="ModelChange",a[a.Move=2]="Move",a[a.ChangeLanguage=5]="ChangeLanguage",a[a.Initialize=6]="Initialize",a[a.ChangeCellMetadata=7]="ChangeCellMetadata",a[a.Output=8]="Output",a[a.OutputItem=9]="OutputItem",a[a.ChangeCellContent=10]="ChangeCellContent",a[a.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",a[a.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",a[a.ChangeCellMime=13]="ChangeCellMime",a[a.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(a){a[a.Handle=0]="Handle",a[a.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(a){a[a.Replace=1]="Replace",a[a.Output=2]="Output",a[a.Metadata=3]="Metadata",a[a.CellLanguage=4]="CellLanguage",a[a.DocumentMetadata=5]="DocumentMetadata",a[a.Move=6]="Move",a[a.OutputItems=7]="OutputItems",a[a.PartialMetadata=8]="PartialMetadata",a[a.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var y;(function(a){a.scheme=S.Schemas.vscodeNotebookCell;const R=/^ch(\d{7,})/;function M(j,Z){return j.with({scheme:a.scheme,fragment:`ch${Z.toString().padStart(7,"0")}${j.scheme!==S.Schemas.file?j.scheme:""}`})}a.generate=M;function H(j){if(j.scheme!==a.scheme)return;const Z=R.exec(j.fragment);return Z?{handle:Number(Z[1]),notebook:j.with({scheme:j.fragment.substr(Z[0].length)||S.Schemas.file,fragment:null})}:void 0}a.parse=H;function ue(j){if(j.scheme!==S.Schemas.vscodeNotebookCellMetadata)return;const Z=R.exec(j.fragment);return Z?{handle:Number(Z[1]),notebook:j.with({scheme:j.fragment.substr(Z[0].length)||S.Schemas.file,fragment:null})}:void 0}a.parseCellMetadataUri=ue;function fe(j,Z,L){return j.with({scheme:L,fragment:`ch${Z.toString().padStart(7,"0")}${j.scheme!==S.Schemas.file?j.scheme:""}`})}a.generateCellUri=fe;function Y(j,Z){if(j.scheme!==Z)return;const L=R.exec(j.fragment);return L?{handle:Number(L[1]),notebook:j.with({scheme:j.fragment.substr(L[0].length)||S.Schemas.file,fragment:null})}:void 0}a.parseCellUri=Y})(y=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[T.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[T.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function v(a){var R,M;return(M=(R=w.get(a))===null||R===void 0?void 0:R.alwaysSecure)!==null&&M!==void 0?M:!1}e.mimeTypeIsAlwaysSecure=v;function l(a){var R,M;return(M=(R=w.get(a))===null||R===void 0?void 0:R.supportedByCore)!==null&&M!==void 0?M:!1}e.mimeTypeSupportedByCore=l;function h(a){var R,M;return(M=(R=w.get(a))===null||R===void 0?void 0:R.mergeable)!==null&&M!==void 0?M:!1}e.mimeTypeIsMergeable=h;function m(a,R){return k.isWindows&&(a=a.replace(/\//g,"\\"),R=R.replace(/\//g,"\\")),g.match(a,R)}function t(a,R,M){let H=0;for(let ue=0;ue<R.length;ue++){if(m(R[ue],a))return H;H++}for(let ue=0;ue<M.length;ue++){if(m(M[ue],a))return H;H++}return H}function n(a,R,M){return a.sort((H,ue)=>t(H,R,M)-t(ue,R,M))}e.sortMimeTypes=n;function s(a,R,M,H=(ue,fe)=>ue===fe){const ue=[];function fe(Z,L,q){if(L===0&&q.length===0)return;const N=ue[ue.length-1];N&&N.start+N.deleteCount===Z?(N.deleteCount+=L,N.toInsert.push(...q)):ue.push({start:Z,deleteCount:L,toInsert:q})}let Y=0,j=0;for(;;){if(Y===a.length){fe(Y,0,R.slice(j));break}if(j===R.length){fe(Y,a.length-Y,[]);break}const Z=a[Y],L=R[j];if(H(Z,L)){Y+=1,j+=1;continue}M(L)?(fe(Y,1,[]),Y+=1):(fe(Y,0,[L]),j+=1)}return ue}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(a){a.default="default",a.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(a){const R=a;return!!((typeof R.include=="string"||g.isRelativePattern(R.include))&&(typeof R.exclude=="string"||g.isRelativePattern(R.exclude)))}e.isDocumentExcludePattern=u;function b(a,R,M){if(Array.isArray(a.viewType)&&a.viewType.indexOf(R)>=0||a.viewType===R)return!0;if(a.filenamePattern){let H=u(a.filenamePattern)?a.filenamePattern.include:a.filenamePattern,ue=u(a.filenamePattern)?a.filenamePattern.exclude:void 0;if(g.match(H,E.basename(M.fsPath).toLowerCase()))return!(ue&&g.match(ue,E.basename(M.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=b;class p{constructor(R){this.textModel=R}getElements(){const R=new Int32Array(this.textModel.cells.length);for(let M=0;M<this.textModel.cells.length;M++)R[M]=this.textModel.cells[M].getHashValue();return R}}e.CellSequence=p,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var P;(function(a){a[a.Left=1]="Left",a[a.Right=2]="Right"})(P=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class A{static create(R){return`${A._prefix}${R}`}static parse(R){if(R.startsWith(A._prefix))return R.substr(A._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=A,A._prefix="notebook/"}),define(we[162],_e([0,1,137,4,89]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new S.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new S.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new S.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=T.createDecorator("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[163],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=g;function T(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=T}),define(we[96],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var g;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(g=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(_,C)=>{C.expand!==void 0&&(_.expand=C.expand),C.item!==void 0&&(_.item=_.item?Object.assign(_.item,C.item):C.item)};e.applyTestItemUpdate=T;var S;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));const E=(_,C)=>`${_}:${C.toString()}`;e.getTestSubscriptionKey=E;class k{add(C){}update(C){}remove(C,i){}complete(){}}e.IncrementalChangeCollector=k;class D{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(C){const i=this.createChangeCollector();for(const I of C)switch(I[0]){case 0:{const o=I[1];if(o.parent){if(this.items.has(o.parent)){const f=this.items.get(o.parent);f.children.add(o.item.extId);const c=this.createItem(o,f);this.items.set(o.item.extId,c),i.add(c)}}else{this.roots.add(o.item.extId);const f=this.createItem(o);this.items.set(o.item.extId,f),i.add(f)}o.expand===2&&this.busyControllerCount++;break}case 1:{const o=I[1],f=this.items.get(o.extId);if(!f)break;o.expand!==void 0&&(f.expand===2&&this.busyControllerCount--,o.expand===2&&this.busyControllerCount++),e.applyTestItemUpdate(f,o),i.update(f);break}case 2:{const o=this.items.get(I[1]);if(!o)break;o.parent?this.items.get(o.parent).children.delete(o.item.extId):this.roots.delete(o.item.extId);const f=[[I[1]]];for(;f.length;)for(const c of f.pop()){const d=this.items.get(c);d&&(f.push(d.children),this.items.delete(c),i.remove(d,d!==o),d.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(I[1]);break;case 3:this.updatePendingRoots(I[1]);break}i.complete()}retireTest(C){}updatePendingRoots(C){this.pendingRootCount+=C}createChangeCollector(){return new k}}e.AbstractIncrementalTestCollection=D}),define(we[164],_e([0,1,14,41,10,24,21,81,138]),function(ee,e,g,T,S,E,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(I,o,f){this._contributedVariables=new Map,this._context=I,this._labelService=o,f&&(this._envVariablesPromise=f.then(c=>this.prepareEnv(c)))}prepareEnv(I){if(k.isWindows){const o=Object.create(null);return Object.keys(I).forEach(f=>{o[f.toLowerCase()]=I[f]}),o}return I}resolveWithEnvironment(I,o,f){return this.recursiveResolve(this.prepareEnv(I),o?o.uri:void 0,f)}async resolveAsync(I,o){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,o)}async resolveAnyBase(I,o,f,c){const d=E.deepClone(o);return k.isWindows&&d.windows?Object.keys(d.windows).forEach(y=>d[y]=d.windows[y]):k.isMacintosh&&d.osx?Object.keys(d.osx).forEach(y=>d[y]=d.osx[y]):k.isLinux&&d.linux&&Object.keys(d.linux).forEach(y=>d[y]=d.linux[y]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,d,f,c)}async resolveAnyAsync(I,o,f){return this.resolveAnyBase(I,o,f)}async resolveAnyMap(I,o,f){const c=new Map;return{newConfig:await this.resolveAnyBase(I,o,f,c),resolvedVariables:c}}resolveWithInteractionReplace(I,o,f,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,o,f,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,o){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,o)}recursiveResolve(I,o,f,c,d){if(S.isString(f))return this.resolveString(I,o,f,c,d);if(S.isArray(f))return f.map(y=>this.recursiveResolve(I,o,y,c,d));if(S.isObject(f)){let y=Object.create(null);return Object.keys(f).forEach(w=>{const v=this.resolveString(I,o,w,c,d);y[v]=this.recursiveResolve(I,o,f[w],c,d)}),y}return f}resolveString(I,o,f,c,d){return f.replace(C.VARIABLE_REGEXP,(w,v)=>{if(v.includes(C.VARIABLE_LHS))return w;let l=this.evaluateSingleVariable(I,w,v,o,c);return d&&d.set(v,l),l!==w&&S.isString(l)&&l.match(C.VARIABLE_REGEXP)&&(l=this.resolveString(I,o,l,c,d)),l})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,o,f,c,d){let y;const w=f.split(":");w.length>1&&(f=w[0],y=w[1]);const v=()=>{const m=this._context.getFilePath();if(m)return m;throw new Error(_.localize(0,null,o))},l=()=>{const m=v();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error(_.localize(1,null,o,g.basename(m)))},h=()=>{if(y){const m=this._context.getFolderUri(y);if(m)return m;throw new Error(_.localize(2,null,o,y))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error(_.localize(3,null,o)):new Error(_.localize(4,null,o))};switch(f){case"env":if(y){if(I){const m=I[k.isWindows?y.toLowerCase():y];if(S.isString(m))return m}return""}throw new Error(_.localize(5,null,o));case"config":if(y){const m=this._context.getConfigurationValue(c,y);if(S.isUndefinedOrNull(m))throw new Error(_.localize(6,null,o,y));if(S.isObject(m))throw new Error(_.localize(7,null,o,y));return m}throw new Error(_.localize(8,null,o));case"command":return this.resolveFromMap(o,y,d,"command");case"input":return this.resolveFromMap(o,y,d,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return D.normalizeDriveLetter(this.fsPath(h()));case"cwd":return c||y?D.normalizeDriveLetter(this.fsPath(h())):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(h()));case"lineNumber":const m=this._context.getLineNumber();if(m)return m;throw new Error(_.localize(9,null,o));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error(_.localize(10,null,o));case"file":return v();case"fileWorkspaceFolder":return l();case"relativeFile":return c||y?g.relative(this.fsPath(h()),v()):v();case"relativeFileDirname":const n=g.dirname(v());if(c||y){const b=g.relative(this.fsPath(h()),n);return b.length===0?".":b}return n;case"fileDirname":return g.dirname(v());case"fileExtname":return g.extname(v());case"fileBasename":return g.basename(v());case"fileBasenameNoExtension":const s=g.basename(v());return s.slice(0,s.length-g.extname(s).length);case"fileDirnameBasename":return g.basename(g.dirname(v()));case"execPath":const r=this._context.getExecPath();return r||o;case"execInstallFolder":const u=this._context.getAppRoot();return u||o;case"pathSeparator":return g.sep;default:try{const b=y?`${f}:${y}`:f;return this.resolveFromMap(o,b,d,void 0)}catch(b){return o}}}}resolveFromMap(I,o,f,c){if(o&&f){const d=c===void 0?f[o]:f[c+":"+o];if(typeof d=="string")return d;throw new Error(_.localize(11,null,I))}return I}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[165],_e([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=g.createDecorator("editorGroupsService");var T;(function(o){o[o.UP=0]="UP",o[o.DOWN=1]="DOWN",o[o.LEFT=2]="LEFT",o[o.RIGHT=3]="RIGHT"})(T=e.GroupDirection||(e.GroupDirection={}));var S;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(S=e.GroupOrientation||(e.GroupOrientation={}));var E;(function(o){o[o.FIRST=0]="FIRST",o[o.LAST=1]="LAST",o[o.NEXT=2]="NEXT",o[o.PREVIOUS=3]="PREVIOUS"})(E=e.GroupLocation||(e.GroupLocation={}));var k;(function(o){o[o.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",o[o.EVEN=1]="EVEN",o[o.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(o){o[o.COPY_EDITORS=0]="COPY_EDITORS",o[o.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));var _;(function(o){o[o.CREATION_TIME=0]="CREATION_TIME",o[o.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",o[o.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(_=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(o){o[o.GROUP_ACTIVE=0]="GROUP_ACTIVE",o[o.GROUP_INDEX=1]="GROUP_INDEX",o[o.EDITOR_OPEN=2]="EDITOR_OPEN",o[o.EDITOR_CLOSE=3]="EDITOR_CLOSE",o[o.EDITOR_MOVE=4]="EDITOR_MOVE",o[o.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",o[o.EDITOR_LABEL=6]="EDITOR_LABEL",o[o.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",o[o.EDITOR_PIN=8]="EDITOR_PIN",o[o.EDITOR_STICKY=9]="EDITOR_STICKY",o[o.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(C=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(o){o[o.NEW_EDITOR=1]="NEW_EDITOR",o[o.MOVE_EDITOR=2]="MOVE_EDITOR",o[o.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function I(o){return o.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(we[166],_e([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=g.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(we[9],_e([0,1,17,80,222,54,24,10,2,31,58,139,90,68,166,6]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var y;(function(ve){function ye(z){const{selectionStartLineNumber:xe,selectionStartColumn:Te,positionLineNumber:Re,positionColumn:it}=z,ot=new d.Position(xe-1,Te-1),tt=new d.Position(Re-1,it-1);return new d.Selection(ot,tt)}ve.to=ye;function ae(z){const{anchor:xe,active:Te}=z;return{selectionStartLineNumber:xe.line+1,selectionStartColumn:xe.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}ve.from=ae})(y=e.Selection||(e.Selection={}));var w;(function(ve){function ye(z){if(!z)return;const{start:xe,end:Te}=z;return{startLineNumber:xe.line+1,startColumn:xe.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}ve.from=ye;function ae(z){if(!z)return;const{startLineNumber:xe,startColumn:Te,endLineNumber:Re,endColumn:it}=z;return new d.Range(xe-1,Te-1,Re-1,it-1)}ve.to=ae})(w=e.Range||(e.Range={}));var v;(function(ve){function ye(ae){switch(ae){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 4:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}ve.to=ye})(v=e.TokenType||(e.TokenType={}));var l;(function(ve){function ye(z){return new d.Position(z.lineNumber-1,z.column-1)}ve.to=ye;function ae(z){return{lineNumber:z.line+1,column:z.character+1}}ve.from=ae})(l=e.Position||(e.Position={}));var h;(function(ve){function ye(z){switch(z){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}ve.from=ye;function ae(z){switch(z){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}ve.to=ae})(h=e.DiagnosticTag||(e.DiagnosticTag={}));var m;(function(ve){function ye(z){let xe;return z.code&&(D.isString(z.code)||D.isNumber(z.code)?xe=String(z.code):xe={value:String(z.code.value),target:z.code.target}),Object.assign(Object.assign({},w.from(z.range)),{message:z.message,source:z.source,code:xe,severity:n.from(z.severity),relatedInformation:z.relatedInformation&&z.relatedInformation.map(t.from),tags:Array.isArray(z.tags)?g.coalesce(z.tags.map(h.from)):void 0})}ve.from=ye;function ae(z){var xe;const Te=new d.Diagnostic(w.to(z),z.message,n.to(z.severity));return Te.source=z.source,Te.code=D.isString(z.code)?z.code:(xe=z.code)===null||xe===void 0?void 0:xe.value,Te.relatedInformation=z.relatedInformation&&z.relatedInformation.map(t.to),Te.tags=z.tags&&g.coalesce(z.tags.map(h.to)),Te}ve.to=ae})(m=e.Diagnostic||(e.Diagnostic={}));var t;(function(ve){function ye(z){return Object.assign(Object.assign({},w.from(z.location.range)),{message:z.message,resource:z.location.uri})}ve.from=ye;function ae(z){return new d.DiagnosticRelatedInformation(new d.Location(z.resource,w.to(z)),z.message)}ve.to=ae})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(ve){function ye(z){switch(z){case d.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}ve.from=ye;function ae(z){switch(z){case o.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}ve.to=ae})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(ve){function ye(z){return typeof z=="number"&&z>=d.ViewColumn.One?z-1:z===d.ViewColumn.Beside?c.SIDE_GROUP:c.ACTIVE_GROUP}ve.from=ye;function ae(z){if(typeof z=="number"&&z>=0)return z+1;throw new Error("invalid 'EditorGroupColumn'")}ve.to=ae})(s=e.ViewColumn||(e.ViewColumn={}));function r(ve){return typeof ve.range!="undefined"}function u(ve){return ve.length===0?!0:!!r(ve[0])}e.isDecorationOptionsArr=u;var b;(function(ve){function ye(it){return it.map(ve.from)}ve.fromMany=ye;function ae(it){return it&&typeof it=="object"&&typeof it.language=="string"&&typeof it.value=="string"}function z(it){let ot;if(ae(it)){const{language:pt,value:wt}=it;ot={value:"```"+pt+`
`+wt+"\n```\n"}}else d.MarkdownString.isMarkdownString(it)?ot={value:it.value,isTrusted:it.isTrusted,supportThemeIcons:it.supportThemeIcons}:typeof it=="string"?ot={value:it}:ot={value:""};const tt=Object.create(null);ot.uris=tt;const vt=pt=>{try{let wt=_.URI.parse(pt,!0);wt=wt.with({query:xe(wt.query,tt)}),tt[pt]=wt}catch(wt){}return""},gt=new S.Renderer;return gt.link=vt,gt.image=pt=>vt(T.parseHrefAndDimensions(pt).href),S(ot.value,{renderer:gt}),ot}ve.from=z;function xe(it,ot){if(!it)return it;let tt;try{tt=E.parse(it)}catch(gt){}if(!tt)return it;let vt=!1;return tt=k.cloneAndChange(tt,gt=>{if(_.URI.isUri(gt)){const pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[pt]=gt,vt=!0,pt}else return}),vt?JSON.stringify(tt):it}function Te(it){const ot=new d.MarkdownString(it.value,it.supportThemeIcons);return ot.isTrusted=it.isTrusted,ot}ve.to=Te;function Re(it){if(!!it)return typeof it=="string"?it:ve.from(it)}ve.fromStrict=Re})(b=e.MarkdownString||(e.MarkdownString={}));function p(ve){return u(ve)?ve.map(ye=>({range:w.from(ye.range),hoverMessage:Array.isArray(ye.hoverMessage)?b.fromMany(ye.hoverMessage):ye.hoverMessage?b.from(ye.hoverMessage):void 0,renderOptions:ye.renderOptions})):ve.map(ye=>({range:w.from(ye)}))}e.fromRangeOrRangeWithMessage=p;function P(ve){return typeof ve=="undefined"?ve:typeof ve=="string"?_.URI.file(ve):ve}e.pathOrURIToURI=P;var A;(function(ve){function ye(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?P(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}ve.from=ye})(A=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var a;(function(ve){function ye(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?P(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?A.from(ae.before):void 0,after:ae.after?A.from(ae.after):void 0}}ve.from=ye})(a=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(ve){function ye(ae){if(typeof ae=="undefined")return ae;switch(ae){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}ve.from=ye})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var M;(function(ve){function ye(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?R.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?a.from(ae.light):void 0,dark:ae.dark?a.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?P(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?A.from(ae.before):void 0,after:ae.after?A.from(ae.after):void 0}}ve.from=ye})(M=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var H;(function(ve){function ye(z){return{text:z.newText,eol:z.newEol&&V.from(z.newEol),range:w.from(z.range)}}ve.from=ye;function ae(z){const xe=new d.TextEdit(w.to(z.range),z.text);return xe.newEol=typeof z.eol=="undefined"?void 0:V.to(z.eol),xe}ve.to=ae})(H=e.TextEdit||(e.TextEdit={}));var ue;(function(ve){function ye(z,xe,Te){var Re,it;const ot={edits:[]};if(z instanceof d.WorkspaceEdit)for(let tt of z._allEntries())if(tt._type===1)ot.edits.push({_type:1,oldUri:tt.from,newUri:tt.to,options:tt.options,metadata:tt.metadata});else if(tt._type===2){const vt=xe==null?void 0:xe.getDocument(tt.uri);ot.edits.push({_type:2,resource:tt.uri,edit:H.from(tt.edit),modelVersionId:vt==null?void 0:vt.version,metadata:tt.metadata})}else tt._type===3?ot.edits.push({_type:3,metadata:tt.metadata,resource:tt.uri,edit:tt.edit,notebookMetadata:tt.notebookMetadata,notebookVersionId:(Re=Te==null?void 0:Te.getNotebookDocument(tt.uri,!0))===null||Re===void 0?void 0:Re.apiNotebook.version}):tt._type===5&&ot.edits.push({_type:3,metadata:tt.metadata,resource:tt.uri,notebookVersionId:(it=Te==null?void 0:Te.getNotebookDocument(tt.uri,!0))===null||it===void 0?void 0:it.apiNotebook.version,edit:{editType:1,index:tt.index,count:tt.count,cells:tt.cells.map(O.from)}});return ot}ve.from=ye;function ae(z){const xe=new d.WorkspaceEdit;for(const Te of z.edits)Te.edit?xe.replace(_.URI.revive(Te.resource),w.to(Te.edit.range),Te.edit.text):xe.renameFile(_.URI.revive(Te.oldUri),_.URI.revive(Te.newUri),Te.options);return xe}ve.to=ae})(ue=e.WorkspaceEdit||(e.WorkspaceEdit={}));var fe;(function(ve){const ye=Object.create(null);ye[d.SymbolKind.File]=0,ye[d.SymbolKind.Module]=1,ye[d.SymbolKind.Namespace]=2,ye[d.SymbolKind.Package]=3,ye[d.SymbolKind.Class]=4,ye[d.SymbolKind.Method]=5,ye[d.SymbolKind.Property]=6,ye[d.SymbolKind.Field]=7,ye[d.SymbolKind.Constructor]=8,ye[d.SymbolKind.Enum]=9,ye[d.SymbolKind.Interface]=10,ye[d.SymbolKind.Function]=11,ye[d.SymbolKind.Variable]=12,ye[d.SymbolKind.Constant]=13,ye[d.SymbolKind.String]=14,ye[d.SymbolKind.Number]=15,ye[d.SymbolKind.Boolean]=16,ye[d.SymbolKind.Array]=17,ye[d.SymbolKind.Object]=18,ye[d.SymbolKind.Key]=19,ye[d.SymbolKind.Null]=20,ye[d.SymbolKind.EnumMember]=21,ye[d.SymbolKind.Struct]=22,ye[d.SymbolKind.Event]=23,ye[d.SymbolKind.Operator]=24,ye[d.SymbolKind.TypeParameter]=25;function ae(xe){return typeof ye[xe]=="number"?ye[xe]:6}ve.from=ae;function z(xe){for(const Te in ye)if(ye[Te]===xe)return Number(Te);return d.SymbolKind.Property}ve.to=z})(fe=e.SymbolKind||(e.SymbolKind={}));var Y;(function(ve){function ye(z){switch(z){case d.SymbolTag.Deprecated:return 1}}ve.from=ye;function ae(z){switch(z){case 1:return d.SymbolTag.Deprecated}}ve.to=ae})(Y=e.SymbolTag||(e.SymbolTag={}));var j;(function(ve){function ye(z){return{name:z.name,kind:fe.from(z.kind),tags:z.tags&&z.tags.map(Y.from),containerName:z.containerName,location:W.from(z.location)}}ve.from=ye;function ae(z){const xe=new d.SymbolInformation(z.name,fe.to(z.kind),z.containerName,W.to(z.location));return xe.tags=z.tags&&z.tags.map(Y.to),xe}ve.to=ae})(j=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Z;(function(ve){function ye(z){var xe,Te;const Re={name:z.name||"!!MISSING: name!!",detail:z.detail,range:w.from(z.range),selectionRange:w.from(z.selectionRange),kind:fe.from(z.kind),tags:(Te=(xe=z.tags)===null||xe===void 0?void 0:xe.map(Y.from))!==null&&Te!==void 0?Te:[]};return z.children&&(Re.children=z.children.map(ye)),Re}ve.from=ye;function ae(z){const xe=new d.DocumentSymbol(z.name,z.detail,fe.to(z.kind),w.to(z.range),w.to(z.selectionRange));return g.isNonEmptyArray(z.tags)&&(xe.tags=z.tags.map(Y.to)),z.children&&(xe.children=z.children.map(ae)),xe}ve.to=ae})(Z=e.DocumentSymbol||(e.DocumentSymbol={}));var L;(function(ve){function ye(ae){const z=new d.CallHierarchyItem(fe.to(ae.kind),ae.name,ae.detail||"",_.URI.revive(ae.uri),w.to(ae.range),w.to(ae.selectionRange));return z._sessionId=ae._sessionId,z._itemId=ae._itemId,z}ve.to=ye})(L=e.CallHierarchyItem||(e.CallHierarchyItem={}));var q;(function(ve){function ye(ae){return new d.CallHierarchyIncomingCall(L.to(ae.from),ae.fromRanges.map(z=>w.to(z)))}ve.to=ye})(q=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var N;(function(ve){function ye(ae){return new d.CallHierarchyOutgoingCall(L.to(ae.to),ae.fromRanges.map(z=>w.to(z)))}ve.to=ye})(N=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var W;(function(ve){function ye(z){return{range:z.range&&w.from(z.range),uri:z.uri}}ve.from=ye;function ae(z){return new d.Location(_.URI.revive(z.uri),w.to(z.range))}ve.to=ae})(W=e.location||(e.location={}));var U;(function(ve){function ye(z){const xe=z,Te=z;return{originSelectionRange:xe.originSelectionRange?w.from(xe.originSelectionRange):void 0,uri:xe.targetUri?xe.targetUri:Te.uri,range:w.from(xe.targetRange?xe.targetRange:Te.range),targetSelectionRange:xe.targetSelectionRange?w.from(xe.targetSelectionRange):void 0}}ve.from=ye;function ae(z){return{targetUri:_.URI.revive(z.uri),targetRange:w.to(z.range),targetSelectionRange:z.targetSelectionRange?w.to(z.targetSelectionRange):void 0,originSelectionRange:z.originSelectionRange?w.to(z.originSelectionRange):void 0}}ve.to=ae})(U=e.DefinitionLink||(e.DefinitionLink={}));var B;(function(ve){function ye(z){return{range:w.from(z.range),contents:b.fromMany(z.contents)}}ve.from=ye;function ae(z){return new d.Hover(z.contents.map(b.to),w.to(z.range))}ve.to=ae})(B=e.Hover||(e.Hover={}));var J;(function(ve){function ye(z){return{range:w.from(z.range),expression:z.expression}}ve.from=ye;function ae(z){return new d.EvaluatableExpression(w.to(z.range),z.expression)}ve.to=ae})(J=e.EvaluatableExpression||(e.EvaluatableExpression={}));var he;(function(ve){function ye(z){if(z instanceof d.InlineValueText)return{type:"text",range:w.from(z.range),text:z.text};if(z instanceof d.InlineValueVariableLookup)return{type:"variable",range:w.from(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};if(z instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(z.range),expression:z.expression};throw new Error("Unknown 'InlineValue' type")}ve.from=ye;function ae(z){switch(z.type){case"text":return{range:w.to(z.range),text:z.text};case"variable":return{range:w.to(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};case"expression":return{range:w.to(z.range),expression:z.expression}}}ve.to=ae})(he=e.InlineValue||(e.InlineValue={}));var De;(function(ve){function ye(z){return{frameId:z.frameId,stoppedLocation:w.from(z.stoppedLocation)}}ve.from=ye;function ae(z){return new d.InlineValueContext(z.frameId,w.to(z.stoppedLocation))}ve.to=ae})(De=e.InlineValueContext||(e.InlineValueContext={}));var Oe;(function(ve){function ye(z){return{range:w.from(z.range),kind:z.kind}}ve.from=ye;function ae(z){return new d.DocumentHighlight(w.to(z.range),z.kind)}ve.to=ae})(Oe=e.DocumentHighlight||(e.DocumentHighlight={}));var Me;(function(ve){function ye(ae){switch(ae){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}ve.to=ye})(Me=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var He;(function(ve){function ye(ae){return{triggerKind:Me.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}ve.to=ye})(He=e.CompletionContext||(e.CompletionContext={}));var Ye;(function(ve){function ye(z){switch(z){case d.CompletionItemTag.Deprecated:return 1}}ve.from=ye;function ae(z){switch(z){case 1:return d.CompletionItemTag.Deprecated}}ve.to=ae})(Ye=e.CompletionItemTag||(e.CompletionItemTag={}));var qe;(function(ve){const ye=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function ae(Te){var Re;return(Re=ye.get(Te))!==null&&Re!==void 0?Re:9}ve.from=ae;const z=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function xe(Te){var Re;return(Re=z.get(Te))!==null&&Re!==void 0?Re:d.CompletionItemKind.Property}ve.to=xe})(qe=e.CompletionItemKind||(e.CompletionItemKind={}));var Xe;(function(ve){function ye(ae,z){var xe;const Te=new d.CompletionItem(typeof ae.label=="string"?ae.label:ae.label.name);return typeof ae.label!="string"&&(Te.label2=ae.label),Te.insertText=ae.insertText,Te.kind=qe.to(ae.kind),Te.tags=(xe=ae.tags)===null||xe===void 0?void 0:xe.map(Ye.to),Te.detail=ae.detail,Te.documentation=T.isMarkdownString(ae.documentation)?b.to(ae.documentation):ae.documentation,Te.sortText=ae.sortText,Te.filterText=ae.filterText,Te.preselect=ae.preselect,Te.commitCharacters=ae.commitCharacters,C.Range.isIRange(ae.range)?Te.range=w.to(ae.range):typeof ae.range=="object"&&(Te.range={inserting:w.to(ae.range.insert),replacing:w.to(ae.range.replace)}),Te.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Te.insertText=new d.SnippetString(ae.insertText):(Te.insertText=ae.insertText,Te.textEdit=Te.range instanceof d.Range?new d.TextEdit(Te.range,Te.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Te.additionalTextEdits=ae.additionalTextEdits.map(Re=>H.to(Re))),Te.command=z&&ae.command?z.fromInternal(ae.command):void 0,Te}ve.to=ye})(Xe=e.CompletionItem||(e.CompletionItem={}));var $;(function(ve){function ye(z){return{label:z.label,documentation:z.documentation?b.fromStrict(z.documentation):void 0}}ve.from=ye;function ae(z){return{label:z.label,documentation:T.isMarkdownString(z.documentation)?b.to(z.documentation):z.documentation}}ve.to=ae})($=e.ParameterInformation||(e.ParameterInformation={}));var G;(function(ve){function ye(z){return{label:z.label,documentation:z.documentation?b.fromStrict(z.documentation):void 0,parameters:Array.isArray(z.parameters)?z.parameters.map($.from):[],activeParameter:z.activeParameter}}ve.from=ye;function ae(z){return{label:z.label,documentation:T.isMarkdownString(z.documentation)?b.to(z.documentation):z.documentation,parameters:Array.isArray(z.parameters)?z.parameters.map($.to):[],activeParameter:z.activeParameter}}ve.to=ae})(G=e.SignatureInformation||(e.SignatureInformation={}));var te;(function(ve){function ye(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(G.from):[]}}ve.from=ye;function ae(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(G.to):[]}}ve.to=ae})(te=e.SignatureHelp||(e.SignatureHelp={}));var re;(function(ve){function ye(z){var xe;return{text:z.text,position:l.from(z.position),kind:K.from((xe=z.kind)!==null&&xe!==void 0?xe:d.InlayHintKind.Other),whitespaceBefore:z.whitespaceBefore,whitespaceAfter:z.whitespaceAfter}}ve.from=ye;function ae(z){const xe=new d.InlayHint(z.text,l.to(z.position),K.to(z.kind));return xe.whitespaceAfter=z.whitespaceAfter,xe.whitespaceBefore=z.whitespaceBefore,xe}ve.to=ae})(re=e.InlayHint||(e.InlayHint={}));var K;(function(ve){function ye(z){return z}ve.from=ye;function ae(z){return z}ve.to=ae})(K=e.InlayHintKind||(e.InlayHintKind={}));var oe;(function(ve){function ye(z){return{range:w.from(z.range),url:z.target,tooltip:z.tooltip}}ve.from=ye;function ae(z){let xe;if(z.url)try{xe=typeof z.url=="string"?_.URI.parse(z.url,!0):_.URI.revive(z.url)}catch(Te){}return new d.DocumentLink(w.to(z.range),xe)}ve.to=ae})(oe=e.DocumentLink||(e.DocumentLink={}));var me;(function(ve){function ye(z){const xe=new d.ColorPresentation(z.label);return z.textEdit&&(xe.textEdit=H.to(z.textEdit)),z.additionalTextEdits&&(xe.additionalTextEdits=z.additionalTextEdits.map(Te=>H.to(Te))),xe}ve.to=ye;function ae(z){return{label:z.label,textEdit:z.textEdit?H.from(z.textEdit):void 0,additionalTextEdits:z.additionalTextEdits?z.additionalTextEdits.map(xe=>H.from(xe)):void 0}}ve.from=ae})(me=e.ColorPresentation||(e.ColorPresentation={}));var Ae;(function(ve){function ye(z){return new d.Color(z[0],z[1],z[2],z[3])}ve.to=ye;function ae(z){return[z.red,z.green,z.blue,z.alpha]}ve.from=ae})(Ae=e.Color||(e.Color={}));var $e;(function(ve){function ye(z){return{range:w.from(z.range)}}ve.from=ye;function ae(z){return new d.SelectionRange(w.to(z.range))}ve.to=ae})($e=e.SelectionRange||(e.SelectionRange={}));var pe;(function(ve){function ye(ae){switch(ae){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}ve.to=ye})(pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ge;(function(ve){function ye(z){switch(z){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}ve.from=ye;function ae(z){switch(z){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}ve.to=ae})(Ge=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var V;(function(ve){function ye(z){if(z===d.EndOfLine.CRLF)return 1;if(z===d.EndOfLine.LF)return 0}ve.from=ye;function ae(z){if(z===1)return d.EndOfLine.CRLF;if(z===0)return d.EndOfLine.LF}ve.to=ae})(V=e.EndOfLine||(e.EndOfLine={}));var ie;(function(ve){function ye(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ve.from=ye})(ie=e.ProgressLocation||(e.ProgressLocation={}));var ge;(function(ve){function ye(ae){const z={start:ae.start+1,end:ae.end+1};return ae.kind&&(z.kind=Fe.from(ae.kind)),z}ve.from=ye})(ge=e.FoldingRange||(e.FoldingRange={}));var Fe;(function(ve){function ye(ae){if(ae)switch(ae){case d.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}ve.from=ye})(Fe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ne;(function(ve){function ye(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?w.from(ae.selection):void 0,override:typeof ae.override=="boolean"?I.EditorOverride.DISABLED:void 0}}ve.from=ye})(Ne=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Qe;(function(ve){function ye(z){return z instanceof d.RelativePattern||typeof z=="string"?z:ae(z)?new d.RelativePattern(z.base,z.pattern):z}ve.from=ye;function ae(z){const xe=z;return xe&&typeof xe.base=="string"&&typeof xe.pattern=="string"}})(Qe=e.GlobPattern||(e.GlobPattern={}));var Ee;(function(ve){function ye(ae){if(ae){if(Array.isArray(ae))return ae.map(ye);if(typeof ae=="string")return ae;{const z=ae;return{language:z.language,scheme:z.scheme,pattern:typeof z.pattern=="undefined"?void 0:Qe.from(z.pattern),exclusive:z.exclusive}}}else return}ve.from=ye})(Ee=e.LanguageSelector||(e.LanguageSelector={}));var be;(function(ve){function ye(z){return{start:z.start,end:z.end}}ve.from=ye;function ae(z){return new d.NotebookRange(z.start,z.end)}ve.to=ae})(be=e.NotebookRange||(e.NotebookRange={}));var Ce;(function(ve){function ye(z){return{timing:typeof z.runStartTime=="number"&&typeof z.runEndTime=="number"?{startTime:z.runStartTime,endTime:z.runEndTime}:void 0,executionOrder:z.executionOrder,success:z.lastRunSuccess}}ve.to=ye;function ae(z){var xe,Te;return{lastRunSuccess:z.success,runStartTime:(xe=z.timing)===null||xe===void 0?void 0:xe.startTime,runEndTime:(Te=z.timing)===null||Te===void 0?void 0:Te.endTime,executionOrder:z.executionOrder}}ve.from=ae})(Ce=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var se;(function(ve){function ye(z){switch(z){case d.NotebookCellKind.Markup:return f.CellKind.Markup;case d.NotebookCellKind.Code:default:return f.CellKind.Code}}ve.from=ye;function ae(z){switch(z){case f.CellKind.Markup:return d.NotebookCellKind.Markup;case f.CellKind.Code:default:return d.NotebookCellKind.Code}}ve.to=ae})(se=e.NotebookCellKind||(e.NotebookCellKind={}));var de;(function(ve){function ye(z){var xe;const Te={metadata:(xe=z.metadata)!==null&&xe!==void 0?xe:Object.create(null),cells:[]};for(let Re of z.cells)d.NotebookCellData.validate(Re),Te.cells.push(O.from(Re));return Te}ve.from=ye;function ae(z){const xe=new d.NotebookData(z.cells.map(O.to));return D.isEmptyObject(z.metadata)||(xe.metadata=z.metadata),xe}ve.to=ae})(de=e.NotebookData||(e.NotebookData={}));var O;(function(ve){function ye(z){var xe;return{cellKind:se.from(z.kind),language:z.languageId,mime:z.mime,source:z.value,metadata:z.metadata,internalMetadata:Ce.from((xe=z.executionSummary)!==null&&xe!==void 0?xe:{}),outputs:z.outputs?z.outputs.map(le.from):[]}}ve.from=ye;function ae(z){return new d.NotebookCellData(se.to(z.cellKind),z.source,z.language,z.mime,z.outputs?z.outputs.map(le.to):void 0,z.metadata,z.internalMetadata?Ce.to(z.internalMetadata):void 0)}ve.to=ae})(O=e.NotebookCellData||(e.NotebookCellData={}));var Q;(function(ve){function ye(z){return{mime:z.mime,valueBytes:Array.from(z.data)}}ve.from=ye;function ae(z){return new d.NotebookCellOutputItem(new Uint8Array(z.valueBytes),z.mime)}ve.to=ae})(Q=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var le;(function(ve){function ye(z){return{outputId:z.id,items:z.items.map(Q.from),metadata:z.metadata}}ve.from=ye;function ae(z){const xe=z.items.map(Q.to);return new d.NotebookCellOutput(xe,z.outputId,z.metadata)}ve.to=ae})(le=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ke;(function(ve){function ye(Te){if(Te!=null){if(Te instanceof d.RelativePattern||typeof Te=="string")return Te;if(xe(Te))return new d.RelativePattern(Te.base,Te.pattern);if(z(Te))return{include:Qe.from(Te.include)||void 0,exclude:Qe.from(Te.exclude)||void 0}}}ve.from=ye;function ae(Te){return typeof Te=="string"?Te:xe(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}ve.to=ae;function z(Te){const Re=Te,it=Qe.from(Re.include);if(!(it&&it instanceof d.RelativePattern||typeof it=="string"))return!1;const ot=Qe.from(Re.exclude);return!!(ot&&ot instanceof d.RelativePattern||typeof ot=="string")}function xe(Te){const Re=Te;return Re&&typeof Re.base=="string"&&typeof Re.pattern=="string"}})(ke=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Pe;(function(ve){function ye(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?A.from(ae.top):void 0}}ve.from=ye})(Pe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ue;(function(ve){function ye(ae,z,xe){const Te=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:z.toInternal(Te,xe),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}ve.from=ye})(Ue=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var We;(function(ve){function ye(ae){var z,xe,Te;return{transientOutputs:(z=ae==null?void 0:ae.transientOutputs)!==null&&z!==void 0?z:!1,transientCellMetadata:(xe=ae==null?void 0:ae.transientCellMetadata)!==null&&xe!==void 0?xe:{},transientDocumentMetadata:(Te=ae==null?void 0:ae.transientDocumentMetadata)!==null&&Te!==void 0?Te:{}}}ve.from=ye})(We=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ze;(function(ve){function ye(z){return{uri:z.uri,provides:z.provides}}ve.from=ye;function ae(z){return new d.NotebookRendererScript(_.URI.revive(z.uri),z.provides)}ve.to=ae})(Ze=e.NotebookRendererScript||(e.NotebookRendererScript={}));var rt;(function(ve){function ye(z){return{message:b.fromStrict(z.message)||"",severity:z.severity,expectedOutput:z.expectedOutput,actualOutput:z.actualOutput,location:z.location?W.from(z.location):void 0}}ve.from=ye;function ae(z){const xe=new d.TestMessage(typeof z.message=="string"?z.message:b.to(z.message));return xe.severity=z.severity,xe.actualOutput=z.actualOutput,xe.expectedOutput=z.expectedOutput,xe}ve.to=ae})(rt=e.TestMessage||(e.TestMessage={}));var Ke;(function(ve){function ye(Te){var Re,it;return{extId:Te.id,label:Te.label,uri:Te.uri,range:w.from(Te.range)||null,debuggable:(Re=Te.debuggable)!==null&&Re!==void 0?Re:!1,description:Te.description||null,runnable:(it=Te.runnable)!==null&&it!==void 0?it:!0,error:Te.error&&b.fromStrict(Te.error)||null}}ve.from=ye;function ae(Te){return{extId:Te.id,label:Te.label,uri:Te.uri,range:w.from(Te.range)||null,debuggable:!1,description:Te.description||null,error:null,runnable:!0}}ve.fromResultSnapshot=ae;function z(Te){return{id:Te.extId,label:Te.label,uri:_.URI.revive(Te.uri),range:w.to(Te.range||void 0),addChild:()=>{},dispose:()=>{},status:d.TestItemStatus.Pending,data:void 0,debuggable:Te.debuggable,description:Te.description||void 0,runnable:Te.runnable}}ve.toPlain=z;function xe(Te){const Re=new d.TestItemImpl(Te.extId,Te.label,_.URI.revive(Te.uri),void 0);return Re.range=w.to(Te.range||void 0),Re.debuggable=Te.debuggable,Re.description=Te.description||void 0,Re.runnable=Te.runnable,Re}ve.to=xe})(Ke=e.TestItem||(e.TestItem={}));var Je;(function(ve){const ye=(z,xe)=>Object.assign(Object.assign({},Ke.toPlain(z.item)),{taskStates:z.tasks.map(Te=>({state:Te.state,duration:Te.duration,messages:Te.messages.map(rt.to)})),children:z.children.map(Te=>xe.get(Te)).filter(D.isDefined).map(Te=>ye(Te,xe))});function ae(z){const xe=[],Te=new Map;for(const Re of z.items)Te.set(Re.item.extId,Re),Re.direct&&xe.push(Re);return{completedAt:z.completedAt,results:xe.map(Re=>ye(Re,Te))}}ve.to=ae})(Je=e.TestResults||(e.TestResults={}));var ft;(function(ve){function ye(ae){switch(ae){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}ve.to=ye})(ft=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(we[167],_e([0,1,2,11,6,9,51]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(C,i,I,o={timeout:1500,errors:3}){this._logService=C,this._documents=i,this._mainThreadBulkEdits=I,this._thresholds=o,this._callbacks=new k.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(i,I,o)=>{const c={dispose:this._callbacks.push([i,I,C])};return Array.isArray(o)&&o.push(c),c}}async $participateInSave(C,i){const I=g.URI.revive(C);let o=!1;const f=setTimeout(()=>o=!0,this._thresholds.timeout),c=[];try{for(let d of[...this._callbacks]){if(o)break;const y=this._documents.getDocument(I),w=await this._deliverEventAsyncAndBlameBadListeners(d,{document:y,reason:E.TextDocumentSaveReason.to(i)});c.push(w)}}finally{clearTimeout(f)}return c}_deliverEventAsyncAndBlameBadListeners([C,i,I],o){const f=this._badListeners.get(C);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,C,i,o).then(()=>!0,c=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const d=this._badListeners.get(C);this._badListeners.set(C,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,i,I,o){const f=[],c=Date.now(),{document:d,reason:y}=o,{version:w}=d,v=Object.freeze({document:d,reason:y,waitUntil(l){if(Object.isFrozen(f))throw T.illegalState("waitUntil can not be called async");f.push(Promise.resolve(l))}});try{i.apply(I,[v])}catch(l){return Promise.reject(l)}return Object.freeze(f),new Promise((l,h)=>{const m=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(m),l(t)}).catch(t=>{clearTimeout(m),h(t)})}).then(l=>{const h={edits:[]};for(const m of l)if(Array.isArray(m)&&m.every(t=>t instanceof S.TextEdit))for(const{newText:t,newEol:n,range:s}of m)h.edits.push({_type:2,resource:d.uri,edit:{range:s&&E.Range.from(s),text:t,eol:n&&E.EndOfLine.from(n)}});if(h.edits.length!==0)return w===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(we[168],_e([0,1,3,12,27,2,9,6]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{constructor(I,o,f,c,d){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,f&&(this._config+=1),c&&(this._config+=2),d&&(this._config+=4);const y=S.parse(o),w=I(v=>{if(!f)for(let l of v.created){const h=E.URI.revive(l);y(h.fsPath)&&this._onDidCreate.fire(h)}if(!c)for(let l of v.changed){const h=E.URI.revive(l);y(h.fsPath)&&this._onDidChange.fire(h)}if(!d)for(let l of v.deleted){const h=E.URI.revive(l);y(h.fsPath)&&this._onDidDelete.fire(h)}});this._disposable=D.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(I,o,f){this._logService=o,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new T.AsyncEmitter,this._onWillCreateFile=new T.AsyncEmitter,this._onWillDeleteFile=new T.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,o,f,c){return new _(this._onFileSystemEvent.event,I,o,f,c)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,o){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:o.map(f=>({oldUri:E.URI.revive(f.source),newUri:E.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:o.map(f=>E.URI.revive(f.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:o.map(f=>E.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,o){return(f,c,d)=>{const y=function(v){f.call(c,v)};return y.extension=I,o.event(y,void 0,d)}}async $onWillRunFileOperation(I,o,f,c){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:o.map(d=>({oldUri:E.URI.revive(d.source),newUri:E.URI.revive(d.target)}))},f,c);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:o.map(d=>E.URI.revive(d.target))},f,c);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:o.map(d=>E.URI.revive(d.target))},f,c)}}async _fireWillEvent(I,o,f,c){const d=new Set,y=[];if(await I.fireAsync(o,c,async(v,l)=>{var h;const m=Date.now(),t=await Promise.resolve(v);t instanceof D.WorkspaceEdit&&(y.push(t),d.add((h=l.extension.displayName)!==null&&h!==void 0?h:l.extension.identifier.value)),Date.now()-m>f&&this._logService.warn("SLOW file-participant",l.extension.identifier)}),c.isCancellationRequested||y.length===0)return;const w={edits:[]};for(let v of y){let{edits:l}=k.WorkspaceEdit.from(v,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(l)}return{edit:w,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=C}),define(we[169],_e([0,1,16,24,2,9,6,68]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(o,f,c,d){this.start=o,this.deletedCount=f,this.deletedItems=c,this.items=d}static asApiEvents(o){return o.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(c=>c.apiCell)}))}}class C{constructor(o,f,c){var d,y,w;this.notebook=o,this._extHostDocument=f,this._cellData=c,this.handle=c.handle,this.uri=S.URI.revive(c.uri),this.cellKind=c.cellKind,this._outputs=c.outputs.map(E.NotebookCellOutput.to),this._internalMetadata=(d=c.internalMetadata)!==null&&d!==void 0?d:{},this._metadata=(y=c.metadata)!==null&&y!==void 0?y:{},this._previousResult=E.NotebookCellExecutionSummary.to((w=c.internalMetadata)!==null&&w!==void 0?w:{})}static asModelAddData(o,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:o}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const o=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return o.notebook.getCellIndex(o)},notebook:o.notebook.apiNotebook,kind:E.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return o._mime},set mime(c){o._mime=c},get outputs(){return o._outputs.slice(0)},get metadata(){return o._metadata},get executionSummary(){return o._previousResult}})}return this._apiCell}setOutputs(o){this._outputs=o.map(E.NotebookCellOutput.to)}setOutputItems(o,f,c){const d=c.map(E.NotebookCellOutputItem.to),y=this._outputs.find(w=>w.id===o);y&&(f||(y.items.length=0),y.items.push(...d))}setMetadata(o){this._metadata=o}setInternalMetadata(o){this._internalMetadata=o,this._previousResult=E.NotebookCellExecutionSummary.to(o)}setMime(o){}}e.ExtHostCell=C;class i{constructor(o,f,c,d,y,w){var v;this._proxy=o,this._textDocumentsAndEditors=f,this._textDocuments=c,this._emitter=d,this.uri=y,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=(v=w.metadata)!==null&&v!==void 0?v:Object.create(null),this._spliceNotebookCells([[0,0,w.cells]],!0),this._versionId=w.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const o=this;this._notebook={get uri(){return o.uri},get version(){return o._versionId},get notebookType(){return o._notebookType},get isDirty(){return o._isDirty},get isUntitled(){return o.uri.scheme===g.Schemas.untitled},get isClosed(){return o._disposed},get metadata(){return o._metadata},get cellCount(){return o._cells.length},cellAt(f){return f=o._validateIndex(f),o._cells[f].apiCell},getCells(f){return(f?o._getCells(f):o._cells).map(d=>d.apiCell)},save(){return o._save()}}}return this._notebook}updateBackup(o){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=o}disposeBackup(){var o;(o=this._backup)===null||o===void 0||o.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(o){o.metadata&&(this._metadata=Object.assign(Object.assign({},this._metadata),o.metadata))}acceptDirty(o){this._isDirty=o}acceptModelChanged(o,f){this._versionId=o.versionId,this._isDirty=f;for(const c of o.rawEvents)c.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1):c.kind===D.NotebookCellsChangeType.Move?this._moveCell(c.index,c.newIdx):c.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(c.index,c.outputs):c.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems):c.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(c.index,c.language):c.kind===D.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(c.index,c.mime):c.kind===D.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(c.index,c.metadata):c.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(c.index,c.internalMetadata)}_validateIndex(o){return o=o|0,o<0?0:o>=this._cells.length?this._cells.length-1:o}_validateRange(o){let f=o.start|0,c=o.end|0;return f<0&&(f=0),c>this._cells.length&&(c=this._cells.length),o.with({start:f,end:c})}_getCells(o){o=this._validateRange(o);const f=[];for(let c=o.start;c<o.end;c++)f.push(this._cells[c]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(o,f){if(this._disposed)return;const c=[],d=[],y=[];o.reverse().forEach(w=>{const l=w[2].map(t=>{const n=new C(this,this._textDocumentsAndEditors,t);return f||d.push(C.asModelAddData(this.apiNotebook,t)),n}),h=new _(w[0],w[1],[],l),m=this._cells.splice(w[0],w[1],...l);for(const t of m)y.push(t.uri),h.deletedItems.push(t.apiCell);c.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:y}),f||this._emitter.emitModelChange(T.deepFreeze({document:this.apiNotebook,changes:_.asApiEvents(c)}))}_moveCell(o,f){const c=this._cells.splice(o,1);this._cells.splice(f,0,...c);const d=[new _(o,1,c.map(y=>y.apiCell),[]),new _(f,0,[],c)];this._emitter.emitModelChange(T.deepFreeze({document:this.apiNotebook,changes:_.asApiEvents(d)}))}_setCellOutputs(o,f){const c=this._cells[o];c.setOutputs(f),this._emitter.emitCellOutputsChange(T.deepFreeze({document:this.apiNotebook,cells:[c.apiCell]}))}_setCellOutputItems(o,f,c,d){const y=this._cells[o];y.setOutputItems(f,c,d),this._emitter.emitCellOutputsChange(T.deepFreeze({document:this.apiNotebook,cells:[y.apiCell]}))}_changeCellLanguage(o,f){const c=this._cells[o];c.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(c.uri,f)}_changeCellMime(o,f){const c=this._cells[o];c.apiCell.mime=f}_changeCellMetadata(o,f){const c=this._cells[o],d=c.apiCell.metadata;c.setMetadata(f);const y=c.apiCell.metadata;T.equals(d,y)||this._emitter.emitCellMetadataChange(T.deepFreeze({document:this.apiNotebook,cell:c.apiCell}))}_changeCellInternalMetadata(o,f){var c;const d=this._cells[o],y=d.internalMetadata;if(d.setInternalMetadata(f),y.runState!==f.runState){const w=(c=f.runState)!==null&&c!==void 0?c:k.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange(T.deepFreeze({document:this.apiNotebook,cell:d.apiCell,state:w}))}}getCellFromApiCell(o){return this._cells.find(f=>f.apiCell===o)}getCellFromIndex(o){return this._cells[o]}getCell(o){return this._cells.find(f=>f.handle===o)}getCellIndex(o){return this._cells.indexOf(o)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(we[97],_e([0,1,6,9,11]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class E{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,C){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:C})}replaceCells(_,C,i){this._throwIfFinalized(),!(_===C&&i.length===0)&&this._collectedEdits.push({editType:1,index:_,count:C-_,cells:i.map(T.NotebookCellData.from)})}}class k{constructor(_,C,i,I,o,f){this.id=_,this._proxy=C,this.notebookData=i,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=o,this._visibleRanges=I,this._viewColumn=f}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(C){if(!Array.isArray(C)||!C.every(g.NotebookRange.isNotebookRange))throw S.illegalArgument("selections");_._selections=C,_._trySetSelections(C)},get visibleRanges(){return _._visibleRanges},revealRange(C,i){_._proxy.$tryRevealRange(_.id,T.NotebookRange.from(C),i??g.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(C){const i=new E(this.document.version);return C(i),_._applyEdit(i.finalize())},setDecorations(C,i){return _.setDecorations(C,i)}},k.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(T.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const C=[];let i=-1;for(let I=0;I<_.cellEdits.length;I++){if(i<0){C.push(_.cellEdits[I]),i++;continue}const f=C[i],c=_.cellEdits[I];if(f.editType===1&&c.editType===1&&f.index===c.index){f.cells.push(..._.cellEdits[I].cells),f.count+=_.cellEdits[I].count;continue}C.push(_.cellEdits[I]),i++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,C)}setDecorations(_,C){if(!(C.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return C.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,T.NotebookRange.from(C),_.key)}}e.ExtHostNotebookEditor=k,k.apiEditorsToExtHost=new WeakMap}),define(we[170],_e([0,1,9,149,130,18,48]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,o,f){const c=this._handles++,{title:d,location:y,cancellable:w}=o,v={label:S.localize(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(c,{location:g.ProgressLocation.from(y),title:d,source:v,cancellable:w},I),this._withProgress(c,f,!!w)}_withProgress(I,o,f){let c;f&&(c=new E.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,c));const d=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),c&&c.dispose()};let y;try{y=o(new C(this._proxy,I),f&&c?c.token:E.CancellationToken.None)}catch(w){throw d(I),w}return y.then(w=>d(I),w=>d(I)),y}$acceptProgressCanceled(I){const o=this._mapHandleToCancellationSource.get(I);o&&(o.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=D;function _(i,I){return i.message=I.message,typeof I.increment=="number"&&(typeof i.increment=="number"?i.increment+=I.increment:i.increment=I.increment),i}class C extends T.Progress{constructor(I,o){super(f=>this.throttledReport(f));this._proxy=I,this._handle=o}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}Ve([k.throttle(100,(i,I)=>_(i,I),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(we[98],_e([0,1,39,11,50,9,6]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(o,f,c){const d=D._Keys.nextId();o.$registerTextEditorDecorationType(f.identifier,d,E.DecorationRenderOptions.from(c)),this.value=Object.freeze({key:d,dispose(){o.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=D,D._Keys=new S.IdGenerator("TextEditorDecorationType");class _{constructor(o,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=o,this._documentVersionId=o.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(o,f){this._throwIfFinalized();let c=null;if(o instanceof k.Position)c=new k.Range(o,o);else if(o instanceof k.Range)c=o;else throw new Error("Unrecognized location");this._pushEdit(c,f,!1)}insert(o,f){this._throwIfFinalized(),this._pushEdit(new k.Range(o,o),f,!0)}delete(o){this._throwIfFinalized();let f=null;if(o instanceof k.Range)f=o;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(o,f,c){const d=this._document.validateRange(o);this._collectedEdits.push({range:d,text:f,forceMoveMarkers:c})}setEndOfLine(o){if(this._throwIfFinalized(),o!==k.EndOfLine.LF&&o!==k.EndOfLine.CRLF)throw T.illegalArgument("endOfLine");this._setEndOfLine=o}}e.TextEditorEdit=_;class C{constructor(o,f,c,d){this._proxy=o,this._id=f,this._accept(c),this._logService=d;const y=this;this.value={get tabSize(){return y._tabSize},set tabSize(w){y._setTabSize(w)},get insertSpaces(){return y._insertSpaces},set insertSpaces(w){y._setInsertSpaces(w)},get cursorStyle(){return y._cursorStyle},set cursorStyle(w){y._setCursorStyle(w)},get lineNumbers(){return y._lineNumbers},set lineNumbers(w){y._setLineNumbers(w)}}}_accept(o){this._tabSize=o.tabSize,this._insertSpaces=o.insertSpaces,this._cursorStyle=o.cursorStyle,this._lineNumbers=E.TextEditorLineNumbersStyle.to(o.lineNumbers)}_validateTabSize(o){if(o==="auto")return"auto";if(typeof o=="number"){const f=Math.floor(o);return f>0?f:null}if(typeof o=="string"){const f=parseInt(o,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(o){const f=this._validateTabSize(o);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(o){return o==="auto"?"auto":o==="false"?!1:Boolean(o)}_setInsertSpaces(o){const f=this._validateInsertSpaces(o);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(o){this._cursorStyle!==o&&(this._cursorStyle=o,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:o})))}_setLineNumbers(o){this._lineNumbers!==o&&(this._lineNumbers=o,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:E.TextEditorLineNumbersStyle.from(o)})))}assign(o){const f={};let c=!1;if(typeof o.tabSize!="undefined"){const d=this._validateTabSize(o.tabSize);d==="auto"?(c=!0,f.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,c=!0,f.tabSize=d)}if(typeof o.insertSpaces!="undefined"){const d=this._validateInsertSpaces(o.insertSpaces);d==="auto"?(c=!0,f.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,c=!0,f.insertSpaces=d)}typeof o.cursorStyle!="undefined"&&this._cursorStyle!==o.cursorStyle&&(this._cursorStyle=o.cursorStyle,c=!0,f.cursorStyle=o.cursorStyle),typeof o.lineNumbers!="undefined"&&this._lineNumbers!==o.lineNumbers&&(this._lineNumbers=o.lineNumbers,c=!0,f.lineNumbers=E.TextEditorLineNumbersStyle.from(o.lineNumbers)),c&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(o){o.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=C;class i{constructor(o,f,c,d,y,w,v,l){this.id=o,this._proxy=f,this._logService=c,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=y,this._options=new C(this._proxy,this.id,w,c),this._visibleRanges=v,this._viewColumn=l;const h=this;this.value=Object.freeze({get document(){return d.getValue()},set document(m){throw T.readonly("document")},get selection(){return h._selections&&h._selections[0]},set selection(m){if(!(m instanceof k.Selection))throw T.illegalArgument("selection");h._selections=[m],h._trySetSelection()},get selections(){return h._selections},set selections(m){if(!Array.isArray(m)||m.some(t=>!(t instanceof k.Selection)))throw T.illegalArgument("selections");h._selections=m,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(m){throw T.readonly("visibleRanges")},get options(){return h._options.value},set options(m){h._disposed||h._options.assign(m)},get viewColumn(){return h._viewColumn},set viewColumn(m){throw T.readonly("viewColumn")},edit(m,t={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new _(d.getValue(),t);return m(n),h._applyEdit(n)},insertSnippet(m,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=h._selections.map(r=>E.Range.from(r));else if(t instanceof k.Position){const{lineNumber:r,column:u}=E.Position.from(t);s=[{startLineNumber:r,startColumn:u,endLineNumber:r,endColumn:u}]}else if(t instanceof k.Range)s=[E.Range.from(t)];else{s=[];for(const r of t)if(r instanceof k.Range)s.push(E.Range.from(r));else{const{lineNumber:u,column:b}=E.Position.from(r);s.push({startLineNumber:u,startColumn:b,endLineNumber:u,endColumn:b})}}return f.$tryInsertSnippet(o,m.value,s,n)},setDecorations(m,t){const n=t.length===0;n&&!h._hasDecorationsForKey.has(m.key)||(n?h._hasDecorationsForKey.delete(m.key):h._hasDecorationsForKey.add(m.key),h._runOnProxy(()=>{if(E.isDecorationOptionsArr(t))return f.$trySetDecorations(o,m.key,E.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let r=0,u=t.length;r<u;r++){const b=t[r];s[4*r]=b.start.line+1,s[4*r+1]=b.start.character+1,s[4*r+2]=b.end.line+1,s[4*r+3]=b.end.character+1}return f.$trySetDecorationsFast(o,m.key,s)}}))},revealRange(m,t){h._runOnProxy(()=>f.$tryRevealRange(o,E.Range.from(m),t||k.TextEditorRevealType.Default))},show(m){f.$tryShowEditor(o,E.ViewColumn.from(m))},hide(){f.$tryHideEditor(o)}})}dispose(){g.ok(!this._disposed),this._disposed=!0}_acceptOptions(o){g.ok(!this._disposed),this._options._accept(o)}_acceptVisibleRanges(o){g.ok(!this._disposed),this._visibleRanges=o}_acceptViewColumn(o){g.ok(!this._disposed),this._viewColumn=o}_acceptSelections(o){g.ok(!this._disposed),this._selections=o}async _trySetSelection(){const o=this._selections.map(E.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,o)),this.value}_applyEdit(o){const f=o.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const c=f.edits.map(y=>y.range);c.sort((y,w)=>y.end.line===w.end.line?y.end.character===w.end.character?y.start.line===w.start.line?y.start.character-w.start.character:y.start.line-w.start.line:y.end.character-w.end.character:y.end.line-w.end.line);for(let y=0,w=c.length-1;y<w;y++){const v=c[y].end;if(c[y+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=f.edits.map(y=>({range:E.Range.from(y.range),text:y.text,forceMoveMarkers:y.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,d,{setEndOfLine:typeof f.setEndOfLine=="number"?E.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(o){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):o().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=i}),define(we[171],_e([0,1,133,25,2,3,7,12,6,10,17,9,18]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(y,w){if(C.isString(y))return{label:y};if(y&&typeof y=="object"&&typeof y.label=="string"){let v;return Array.isArray(y.highlights)&&(v=y.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),v=v.length?v:void 0),{label:y.label,highlights:v}}}class c{constructor(w,v,l){this._proxy=w,this.commands=v,this.logService=l,this.treeViews=new Map;function h(m){return m&&m.$treeViewId&&m.$treeItemHandle}v.registerArgumentProcessor({processArgument:m=>h(m)?this.convertArgument(m):Array.isArray(m)&&m.length>0?m.map(t=>h(t)?this.convertArgument(t):t):m})}registerTreeDataProvider(w,v,l){const h=this.createTreeView(w,{treeDataProvider:v},l);return{dispose:()=>h.dispose()}}createTreeView(w,v,l){if(!v||!v.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=v.dragAndDropController!==void 0,m=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!v.showCollapseAll,canSelectMany:!!v.canSelectMany,canDragAndDrop:h}),t=this.createExtHostTreeView(w,v,l);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(n){t.message=n},get title(){return t.title},set title(n){t.title=n},get description(){return t.description},set description(n){t.description=n},reveal:(n,s)=>t.reveal(n,s),dispose:async()=>{await m,this.treeViews.delete(w),t.dispose()}}}$getChildren(w,v){const l=this.treeViews.get(w);return l?l.getChildren(v):Promise.reject(new Error(g.localize(0,null,w)))}$onDrop(w,v,l){const h=this.treeViews.get(w);return h?h.onDrop(v,l):Promise.reject(new Error(g.localize(1,null,w)))}async $hasResolve(w){const v=this.treeViews.get(w);if(!v)throw new Error(g.localize(2,null,w));return v.hasResolve}$resolve(w,v,l){const h=this.treeViews.get(w);if(!h)throw new Error(g.localize(3,null,w));return h.resolveTreeItem(v,l)}$setExpanded(w,v,l){const h=this.treeViews.get(w);if(!h)throw new Error(g.localize(4,null,w));h.setExpanded(v,l)}$setSelection(w,v){const l=this.treeViews.get(w);if(!l)throw new Error(g.localize(5,null,w));l.setSelection(v)}$setVisible(w,v){const l=this.treeViews.get(w);if(!l)throw new Error(g.localize(6,null,w));l.setVisible(v)}createExtHostTreeView(w,v,l){const h=new d(w,v,this._proxy,this.commands.converter,this.logService,l);return this.treeViews.set(w,h),h}convertArgument(w){const v=this.treeViews.get(w.$treeViewId);return v?v.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=c;class d extends k.Disposable{constructor(w,v,l,h,m,t){super();if(this.viewId=w,this.proxy=l,this.commands=h,this.logService=m,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new E.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new E.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new E.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new E.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new E.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new o.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const u of t.contributes.views[r])u.id===w&&(this._title=u.name);this.dataProvider=v.treeDataProvider,this.dndController=v.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(r=>this._onDidChangeData.fire({message:!1,element:r}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let n,s;this._register(E.Event.debounce(this._onDidChangeData.event,(r,u)=>(r||(r={message:!1,elements:[]}),u.element!==!1&&(n||(n=new Promise(b=>s=b),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(u.element)?r.elements.push(...u.element):r.elements.push(u.element)),u.message&&(r.message=!0),r),200,!0)(({message:r,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=s;return n=null,this.refresh(u).then(()=>b())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!C.isUndefinedOrNull(w))}getChildren(w){const v=w?this.getExtensionElement(w):void 0;if(w&&!v)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const l=this.getChildrenNodes(w);return(l?Promise.resolve(l):this.fetchChildrenNodes(v)).then(h=>h.map(m=>m.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,v){v=v||{select:!0,focus:!1};const l=C.isUndefinedOrNull(v.select)?!0:v.select,h=C.isUndefinedOrNull(v.focus)?!1:v.focus,m=C.isUndefinedOrNull(v.expand)?!1:v.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(s=>s.item)},{select:l,focus:h,expand:m})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:l,focus:h,expand:m})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,v){const l=this.getExtensionElement(w);l&&(v?this._onDidExpandElement.fire(Object.freeze({element:l})):this._onDidCollapseElement.fire(Object.freeze({element:l})))}setSelection(w){i.equals(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(w,v){const l=w.map(m=>this.getExtensionElement(m)).filter(m=>!C.isUndefinedOrNull(m)),h=this.getExtensionElement(v);return l&&h?D.asPromise(()=>{var m;return(m=this.dndController)===null||m===void 0?void 0:m.onDrop(l,h)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,v){var l;if(!this.dataProvider.resolveTreeItem)return;const h=this.elements.get(w);if(h){const m=this.nodes.get(h);if(m){const t=(l=await this.dataProvider.resolveTreeItem(m.extensionItem,h,v))!==null&&l!==void 0?l:m.extensionItem;return m.item.tooltip=this.getTooltip(t.tooltip),m.item.command=this.getCommand(m.disposableStore,t.command),m.item}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(v=>v?this.resolveUnknownParentChain(v).then(l=>this.resolveTreeNode(v,l[l.length-1]).then(h=>(l.push(h),l))):Promise.resolve([]))}resolveParent(w){const v=this.nodes.get(w);return v?Promise.resolve(v.parent?this.elements.get(v.parent.item.handle):void 0):D.asPromise(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,v){const l=this.nodes.get(w);return l?Promise.resolve(l):D.asPromise(()=>this.dataProvider.getTreeItem(w)).then(h=>this.createHandle(w,h,v,!0)).then(h=>this.getChildren(v?v.item.handle:void 0).then(()=>{const m=this.getExtensionElement(h);if(m){const t=this.nodes.get(m);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${h}`)}))}getChildrenNodes(w){if(w){let v;if(typeof w=="string"){const l=this.getExtensionElement(w);v=l?this.nodes.get(l):void 0}else v=w;return v&&v.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const v=new o.CancellationTokenSource(this._refreshCancellationSource.token);try{const l=w?this.nodes.get(w):void 0,h=await this.dataProvider.getChildren(w);if(v.token.isCancellationRequested)return[];const m=await Promise.all(i.coalesce(h||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!v.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,l):null}));return v.token.isCancellationRequested?[]:i.coalesce(m)}finally{v.dispose()}}refresh(w){if(w.some(l=>!l))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new o.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const l=this.getHandlesToRefresh(w);if(l.length)return this.refreshHandles(l)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const v=new Set,l=w.map(m=>this.nodes.get(m));for(const m of l)if(m&&!v.has(m.item.handle)){let t=m;for(;t&&t.parent&&l.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&v.add(m.item.handle)}const h=[];return v.forEach(m=>{const t=this.elements.get(m);if(t){const n=this.nodes.get(t);n&&(!n.parent||!v.has(n.parent.item.handle))&&h.push(m)}}),h}refreshHandles(w){const v={};return Promise.all(w.map(l=>this.refreshNode(l).then(h=>{h&&(v[l]=h.item)}))).then(()=>Object.keys(v).length?this.proxy.$refresh(this.viewId,v):void 0)}refreshNode(w){const v=this.getExtensionElement(w);if(v){const l=this.nodes.get(v);if(l)return this.clearChildren(v),D.asPromise(()=>this.dataProvider.getTreeItem(v)).then(h=>{if(h){const m=this.createTreeNode(v,h,l.parent);return this.updateNodeCache(v,m,l,l.parent),l.dispose(),m}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,v,l){const h=this.createTreeNode(w,v,l);if(v.id&&this.elements.has(h.item.handle))throw new Error(g.localize(7,null,v.id));return this.addNodeToCache(w,h),this.addNodeToParentCache(h,l),h}getTooltip(w){return _.MarkdownString.isMarkdownString(w)?I.MarkdownString.from(w):w}getCommand(w,v){return v?this.commands.toInternal(v,w):void 0}createTreeNode(w,v,l){const h=new k.DisposableStore,m=this.createHandle(w,v,l),t=this.getLightIconPath(v);return{item:{handle:m,parentHandle:l?l.item.handle:void 0,label:f(v.label,this.extension),description:v.description,resourceUri:v.resourceUri,tooltip:this.getTooltip(v.tooltip),command:this.getCommand(h,v.command),contextValue:v.contextValue,icon:t,iconDark:this.getDarkIconPath(v)||t,themeIcon:this.getThemeIcon(v),collapsibleState:C.isUndefinedOrNull(v.collapsibleState)?_.TreeItemCollapsibleState.None:v.collapsibleState,accessibilityInformation:v.accessibilityInformation},extensionItem:v,parent:l,children:void 0,disposableStore:h,dispose(){h.dispose()}}}getThemeIcon(w){return w.iconPath instanceof _.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:v,label:l,resourceUri:h},m,t){if(v)return`${d.ID_HANDLE_PREFIX}/${v}`;const n=f(l,this.extension),s=m?m.item.handle:d.LABEL_HANDLE_PREFIX;let r=n?n.label:h?T.basename(h):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const u=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,b=this.getChildrenNodes(m)||[];let p,P=0;do{if(p=`${s}/${P}:${r}`,t||!this.elements.has(p)||u===p)break;P++}while(P<=b.length);return p}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof _.ThemeIcon))return typeof w.iconPath=="string"||S.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof _.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return S.URI.isUri(w)?w:S.URI.file(w)}addNodeToCache(w,v){this.elements.set(v.item.handle,w),this.nodes.set(w,v)}updateNodeCache(w,v,l,h){this.elements.delete(v.item.handle),this.nodes.delete(w),v.item.handle!==l.item.handle&&this.elements.delete(l.item.handle),this.addNodeToCache(w,v);const m=this.getChildrenNodes(h)||[],t=m.filter(n=>n.item.handle===l.item.handle)[0];t&&m.splice(m.indexOf(t),1,v)}addNodeToParentCache(w,v){v?(v.children||(v.children=[]),v.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const v=this.nodes.get(w);if(v){if(v.children)for(const l of v.children){const h=this.elements.get(l.item.handle);h&&this.clear(h)}v.children=void 0}}else this.clearAll()}clear(w){const v=this.nodes.get(w);if(v){if(v.children)for(const l of v.children){const h=this.elements.get(l.item.handle);h&&this.clear(h)}this.nodes.delete(w),this.elements.delete(v.item.handle),v.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}d.LABEL_HANDLE_PREFIX="0",d.ID_HANDLE_PREFIX="1"}),define(we[172],_e([0,1,17,12,18,3,40,10,64,9,6,96]),function(ee,e,g,T,S,E,k,D,_,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class o{constructor(){this.testIdsToInternal=new Map}getTestById(v,l){if(l!==void 0){const h=this.testIdsToInternal.get(l),m=h==null?void 0:h.get(v);if(m)return[h,m]}return g.mapFind(this.testIdsToInternal.values(),h=>{const m=h.get(v);return m&&[h,m]})}createForHierarchy(){return new y(this.createIdMap(c++))}createIdMap(v){const l=new d(v);return this.testIdsToInternal.set(l.id,l),{object:l,dispose:()=>this.testIdsToInternal.delete(l.id)}}}e.OwnedTestCollection=o;var f;(function(w){w[w.Disconnected=0]="Disconnected",w[w.IsChild=1]="IsChild",w[w.IsParent=2]="IsParent",w[w.IsSame=3]="IsSame"})(f=e.TestPosition||(e.TestPosition={}));let c=0;class d{constructor(v){this.id=v,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(v){if(this.map.has(v.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${v.item.extId}`);this.map.set(v.item.extId,v),v.parent||this._roots.add(v)}has(v){return this.map.has(v)}delete(v){const l=this.map.get(v);return l?(this.map.delete(v),this._roots.delete(l),!0):!1}get(v){return this.map.get(v)}comparePositions(v,l){const h=typeof v=="string"?this.map.get(v):v,m=typeof l=="string"?this.map.get(l):l;if(!h||!m)return 0;if(h===m)return 3;for(let t=this.map.get(m.parent);t;t=this.map.get(t.parent))if(t===h)return 1;for(let t=this.map.get(h.parent);t;t=this.map.get(t.parent))if(t===m)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=d;class y{constructor(v){this.testIdToInternal=v,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new T.RunOnceScheduler(()=>this.flushDiff(),200),this.diffOpEmitter=new E.Emitter,this.onDidGenerateDiff=this.diffOpEmitter.event}get treeId(){return this.testIdToInternal.object.id}get roots(){return k.Iterable.filter(this.testItemToInternal.values(),v=>v.parent===null)}addRoot(v,l){this.addItem(v,l,null)}getTestByReference(v){return this.testItemToInternal.get(v)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){const l=this.diff[this.diff.length-1];if(l&&v[0]===1){if(l[0]===1&&l[1].extId===v[1].extId){I.applyTestItemUpdate(l[1],v[1]);return}if(l[0]===0&&l[1].item.extId===v[1].extId){I.applyTestItemUpdate(l[1],v[1]);return}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,l){var h;const m=this.testIdToInternal.object.get(v);if(!!m){if((m.expandLevels===void 0||l>m.expandLevels)&&(m.expandLevels=l),m.expand===1){const t=this.refreshChildren(m);return t.isSettled?this.expandChildren(m,l-1):t.p.then(()=>this.expandChildren(m,l-1))}else if(m.expand===3)return((h=m.initialExpand)===null||h===void 0?void 0:h.isSettled)===!1?m.initialExpand.p.then(()=>this.expandChildren(m,l-1)):this.expandChildren(m,l-1)}}dispose(){var v;for(const l of this.testItemToInternal.values())(v=l.discoverCts)===null||v===void 0||v.dispose(!0),_.getPrivateApiFor(l.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(v,l){const h=v==null?void 0:v.actual.id;switch(l[0]){case 2:this.pushDiff([4,h]);break;case 1:this.removeItem(v);break;case 0:this.addItem(l[1],v.src.controller,v);break;case 3:const[m,t,n]=l;switch(t){case"status":this.updateExpandability(v);break;case"range":this.pushDiff([1,{extId:h,item:{range:C.Range.from(n)}}]);break;case"error":this.pushDiff([1,{extId:h,item:{error:C.MarkdownString.fromStrict(n)||null}}]);break;default:this.pushDiff([1,{extId:h,item:{[t]:n??null}}]);break}break;default:D.assertNever(l[0])}}addItem(v,l,h){if(!(v instanceof i.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${v.id} did not`);if(this.testItemToInternal.has(v))throw new Error(`Attempted to add a single TestItem ${v.id} multiple times to the tree`);if(this.testIdToInternal.object.has(v.id))throw new Error(`Attempted to insert a duplicate test item ID ${v.id}`);const m=h?h.item.extId:null,t=v.resolveHandler?1:0,n=h?h.expandLevels:1,s={controller:l,tree:this.testIdToInternal.object.id},r={actual:v,parent:m,item:C.TestItem.from(v),expandLevels:n?n-1:void 0,expand:0,src:s};this.testIdToInternal.object.add(r),this.testItemToInternal.set(v,r),this.pushDiff([0,{parent:m,src:s,expand:t,item:r.item}]);const u=_.getPrivateApiFor(v);u.bus.event(this.onTestItemEvent.bind(this,r)),this.updateExpandability(r);for(const b of u.children.values())this.testItemToInternal.has(b)||this.addItem(b,l,r)}updateExpandability(v){var l;let h;v.actual.resolveHandler?v.actual.status===i.TestItemStatus.Pending?h=v.discoverCts?2:1:((l=v.initialExpand)===null||l===void 0||l.complete(),h=3):h=0,h!==v.expand&&(v.expand=h,this.pushDiff([1,{extId:v.actual.id,expand:h}]),h===1&&v.expandLevels!==void 0&&this.refreshChildren(v))}expandChildren(v,l){if(l<0)return;const h=[...v.actual.children.values()].map(m=>this.expand(m.id,l)).filter(T.isThenable);if(h.length)return Promise.all(h).then(()=>{})}refreshChildren(v){if(v.discoverCts&&v.discoverCts.dispose(!0),!v.actual.resolveHandler){const l=new T.DeferredPromise;return l.complete(),l}return v.expand=2,v.discoverCts=new S.CancellationTokenSource,this.pushExpandStateUpdate(v),v.initialExpand=new T.DeferredPromise,v.actual.resolveHandler(v.discoverCts.token),v.initialExpand}pushExpandStateUpdate(v){this.pushDiff([1,{extId:v.actual.id,expand:v.expand}])}removeItem(v){var l;this.pushDiff([2,v.actual.id]);const h=[v];for(;h.length;){const m=h.pop();if(!!m){(l=m.discoverCts)===null||l===void 0||l.dispose(!0),this.testIdToInternal.object.delete(m.item.extId),this.testItemToInternal.delete(m.actual);for(const t of m.actual.children.values())h.push(this.testIdToInternal.object.get(t.id))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}reviveDiff(){this.flushDiff();const v=[];for(const{parent:l,src:h,expand:m,item:t}of this.testItemToInternal.values())v.push([0,{parent:l,src:h,expand:m,item:t}]);return v}}e.SingleUseTestCollection=y}),define(we[173],_e([0,1,4,144]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=g.refineServiceDecorator(T.IEnvironmentService)}),define(we[174],_e([0,1,26,3,14]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class E{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=E;class k{constructor(i){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let I of i.activationEvents)I==="onUri"&&(I=`onUri:${g.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(i)}}keepOnly(i){const I=new Set;i.forEach(o=>I.add(g.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>I.has(g.ExtensionIdentifier.toKey(o.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,I){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const o=k._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(o.map(f=>f.identifier)),I.length>0){const f=new Set;I.forEach(c=>f.add(g.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>!f.has(g.ExtensionIdentifier.toKey(c.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new E(o)}static _findLoopingExtensions(i){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(y){this._nodesSet.has(y)||(this._nodesSet.add(y),this._nodesArr.push(y))}addArc(y,w){this.addNode(y),this.addNode(w),this._arcs.has(y)?this._arcs.get(y).push(w):this._arcs.set(y,[w])}getArcs(y){return this._arcs.has(y)?this._arcs.get(y):[]}hasOnlyGoodArcs(y,w){const v=I.getArcs(y);for(let l=0;l<v.length;l++)if(!w.has(v[l]))return!1;return!0}getNodes(){return this._nodesArr}};let o=new Map;for(let y of i){const w=g.ExtensionIdentifier.toKey(y.identifier);if(o.set(w,y),y.extensionDependencies)for(let v of y.extensionDependencies){const l=g.ExtensionIdentifier.toKey(v);I.addArc(w,l)}}let f=new Set;I.getNodes().filter(y=>I.getArcs(y).length===0).forEach(y=>f.add(y));let c=I.getNodes().filter(y=>!f.has(y)),d;do{d=!1;for(let y=0;y<c.length;y++){const w=c[y];I.hasOnlyGoodArcs(w,f)&&(c.splice(y,1),y--,f.add(w),d=!0)}}while(d);return c.map(y=>o.get(y))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const I=this._activationMap.get(i);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const I=this._extensionsMap.get(g.ExtensionIdentifier.toKey(i));return I||void 0}}e.ExtensionDescriptionRegistry=k;var D;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(D||(D={}));function _(C,i){const I=C.isBuiltin?0:C.isUnderDevelopment?2:1,o=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(I!==o)return I-o;const f=S.posix.basename(C.extensionLocation.path),c=S.posix.basename(i.extensionLocation.path);return f<c?-1:f>c?1:0}}),define(we[175],_e([0,1,23]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var T;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(T=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var S;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(S=e.MessageType||(e.MessageType={}));function E(D){const _=g.VSBuffer.alloc(1);switch(D){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=E;function k(D,_){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=k}),define(we[29],_e([0,1,3,2,4,26,145]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new E.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=S.createDecorator("extensionService");class D{constructor(v){this.dependency=v}}e.MissingExtensionDependency=D;var _;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(_=e.ExtensionHostKind||(e.ExtensionHostKind={}));class C{constructor(v,l,h,m){this.codeLoadingTime=v,this.activateCallTime=l,this.activateResolvedTime=h,this.activationReason=m}}e.ActivationTimes=C;class i{constructor(v,l){this.description=v,this.value=l}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var I;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function o(w){w.enableProposedApi||f(w)}e.checkProposedApiEnabled=o;function f(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=f;function c(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:k.getGalleryExtensionId(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=c;function d(w,v){return Object.assign(Object.assign({identifier:new E.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!!v,extensionLocation:w.location},w.manifest),{uuid:w.identifier.uuid})}e.toExtensionDescription=d;class y{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(v){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(v){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(v){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(v){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(v,l){return Promise.resolve()}_onWillActivateExtension(v){}_onDidActivateExtension(v,l,h,m,t){}_onDidActivateExtensionError(v,l){}_onExtensionRuntimeError(v,l){}_onExtensionHostExit(v){}}e.NullExtensionService=y}),define(we[176],_e([0,1,26,29,15]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const E=Promise.resolve(void 0);class k{constructor(c,d,y,w){this.startup=c,this.codeLoadingTime=d,this.activateCallTime=y,this.activateResolvedTime=w}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class D{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,d){return c===-1||d===-1?-1:d-c}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class _{constructor(c,d,y,w,v,l){this.activationFailed=c,this.activationFailedError=d,this.activationTimes=y,this.module=w,this.exports=v,this.subscriptions=l}}e.ActivatedExtension=_;class C extends _{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class i extends _{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class I extends _{constructor(c){super(!0,c,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let o=class{constructor(c,d,y,w,v){this._logService=v,this._registry=c,this._resolvedExtensionsSet=new Set,d.forEach(l=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,y.forEach(l=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(l),l)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(c){const d=g.ExtensionIdentifier.toKey(c);return this._activatedExtensions.has(d)}getActivatedExtension(c){const d=g.ExtensionIdentifier.toKey(c),y=this._activatedExtensions.get(d);if(!y)throw new Error("Extension `"+c.value+"` is not known or not activated");return y}activateByEvent(c,d){if(this._alreadyActivatedEvents[c])return E;const y=this._registry.getExtensionDescriptionsForActivationEvent(c);return this._activateExtensions(y.map(w=>({id:w.identifier,reason:{startup:d,extensionId:w.identifier,activationEvent:c}}))).then(()=>{this._alreadyActivatedEvents[c]=!0})}activateById(c,d){const y=this._registry.getExtensionDescription(c);if(!y)throw new Error("Extension `"+c+"` is not known");return this._activateExtensions([{id:y.identifier,reason:d}])}_handleActivateRequest(c,d,y){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(c.id))){d[g.ExtensionIdentifier.toKey(c.id)]=c;return}const w=this._registry.getExtensionDescription(c.id);if(!w){const h=new Error(`Cannot activate unknown extension '${c.id.value}'`);this._host.onExtensionActivationError(c.id,h,new T.MissingExtensionDependency(c.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(c.id),new I(h));return}const v=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let l=!0;for(let h=0,m=v.length;h<m;h++){const t=v[h];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(t)))continue;const n=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(t));if(n&&!n.activationFailed)continue;if(n&&n.activationFailed){const b=w.displayName||w.identifier.value,p=this._registry.getExtensionDescription(t),P=p&&p.displayName||t,A=new Error(`Cannot activate the '${b}' extension because its dependency '${P}' failed to activate`);A.detail=n.activationFailedError,this._host.onExtensionActivationError(w.identifier,A,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(w.identifier),new I(A));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(t))){l=!1,d[g.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(t)),reason:c.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){l=!1,d[g.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:c.reason};continue}const r=w.displayName||w.identifier.value,u=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,u,new T.MissingExtensionDependency(t)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(w.identifier),new I(u));return}l?d[g.ExtensionIdentifier.toKey(w.identifier)]=c:y.push(c)}_activateExtensions(c){if(c.length===0||(c=c.filter(v=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(v.id))),c.length===0))return Promise.resolve(void 0);const d=Object.create(null),y=[];for(let v=0,l=c.length;v<l;v++)this._handleActivateRequest(c[v],d,y);for(let v=0,l=y.length;v<l;v++){const h=g.ExtensionIdentifier.toKey(y[v].id);d[h]&&delete d[h]}const w=Object.keys(d).map(v=>d[v]);return y.length===0?Promise.all(w.map(v=>this._activateExtension(v.id,v.reason))).then(v=>{}):this._activateExtensions(w).then(v=>this._activateExtensions(y))}_activateExtension(c,d){const y=g.ExtensionIdentifier.toKey(c);if(this._activatedExtensions.has(y))return Promise.resolve(void 0);const w=this._activatingExtensions.get(y);if(w)return w;const v=this._host.actualActivateExtension(c,d).then(void 0,l=>{const h=new Error;return l&&l.name&&(h.name=l.name),l&&l.message?h.message=`Activating extension '${c.value}' failed: ${l.message}.`:h.message=`Activating extension '${c.value}' failed: ${l}.`,l&&l.stack&&(h.stack=l.stack),this._host.onExtensionActivationError(c,h,null),this._logService.error(`Activating extension ${c.value} failed due to an error:`),this._logService.error(l),new I(l)}).then(l=>{this._activatedExtensions.set(y,l),this._activatingExtensions.delete(y)});return this._activatingExtensions.set(y,v),v}};o=Ve([ze(4,S.ILogService)],o),e.ExtensionsActivator=o}),define(we[177],_e([0,1,11]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class T{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((E,k)=>{this._actualOk=E,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(E){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=E,this._actual&&this._actualOk(E))}resolveErr(E){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=E,this._actual?this._actualErr(E):g.onUnexpectedError(E))}then(E,k){return this._ensureActual().then(E,k)}catch(E){return this._ensureActual().then(void 0,E)}finally(E){return this._ensureActual().finally(E)}}e.LazyPromise=T}),define(we[99],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(_,C){this.isMain=_,this.sid=C,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const T=[];function S(D){const _=new g(!0,D);return T[_.nid]=_,_}e.createMainContextProxyIdentifier=S;function E(D){const _=new g(!1,D);return T[_.nid]=_,_}e.createExtHostContextProxyIdentifier=E;function k(D){return T[D].sid}e.getStringIdentifierForProxy=k}),define(we[5],_e([0,1,54,2,99]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var E;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(E=e.UIKind||(e.UIKind={}));var k;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var o;(function(l){l.name="$ident";function h(t,n){return Object.defineProperty(t,l.name,{value:n,enumerable:!0}),t}l.mixin=h;function m(t){return t[l.name]}l.of=m})(o=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(h){return h._id=f._n++,h}}e.IdObject=f,f._n=0;var c;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n",l.label2="o"})(c=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var d;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(d=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var y;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(y=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(l){if(l&&l.edits)for(const h of l.edits)typeof h.resource=="object"?h.resource=T.URI.revive(h.resource):(h.newUri=T.URI.revive(h.newUri),h.oldUri=T.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=g.revive(h.metadata));return l}e.reviveWorkspaceEditDto=w;var v;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:S.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:S.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:S.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:S.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:S.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:S.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:S.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:S.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:S.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:S.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:S.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:S.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:S.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:S.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:S.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:S.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:S.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:S.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:S.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:S.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:S.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:S.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:S.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:S.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:S.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:S.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:S.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:S.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:S.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:S.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:S.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:S.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:S.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:S.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:S.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:S.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:S.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:S.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:S.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:S.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:S.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:S.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:S.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:S.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:S.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:S.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:S.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadNotebookDocuments:S.createMainContextProxyIdentifier("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:S.createMainContextProxyIdentifier("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:S.createMainContextProxyIdentifier("MainThreadNotebookKernels"),MainThreadNotebookRenderers:S.createMainContextProxyIdentifier("MainThreadNotebookRenderers"),MainThreadTheming:S.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:S.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:S.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:S.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:S.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:S.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:S.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:S.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:S.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:S.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:S.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:S.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:S.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:S.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:S.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:S.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:S.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:S.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:S.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:S.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:S.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:S.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:S.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:S.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:S.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:S.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:S.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:S.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:S.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:S.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:S.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:S.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:S.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:S.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:S.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:S.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:S.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:S.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:S.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:S.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:S.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:S.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:S.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostNotebookDocuments:S.createMainContextProxyIdentifier("ExtHostNotebookDocuments"),ExtHostNotebookEditors:S.createMainContextProxyIdentifier("ExtHostNotebookEditors"),ExtHostNotebookKernels:S.createMainContextProxyIdentifier("ExtHostNotebookKernels"),ExtHostNotebookRenderers:S.createMainContextProxyIdentifier("ExtHostNotebookRenderers"),ExtHostTheming:S.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:S.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:S.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:S.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:S.createMainContextProxyIdentifier("ExtHostTesting"),ExtHostTelemetry:S.createMainContextProxyIdentifier("ExtHostTelemetry")}}),define(we[69],_e([0,1,5,3,4]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class E{constructor(D){this._onDidChangePassword=new T.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,_){return this._proxy.$getPassword(D,_)}store(D,_,C){return this._proxy.$setPassword(D,_,C)}delete(D,_){return this._proxy.$deletePassword(D,_)}}e.ExtHostSecretState=E,e.IExtHostSecretState=S.createDecorator("IExtHostSecretState")}),define(we[70],_e([0,1,4,15,5,13]),function(ee,e,g,T,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=g.createDecorator("IExtHostApiDeprecationService");let k=class{constructor(_,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(S.MainContext.MainThreadTelemetry)}report(_,C,i){const I=this.getUsageKey(_,C);this._reportedUsages.has(I)||(this._reportedUsages.add(I),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:_}))}getUsageKey(_,C){return`${_}-${C.identifier.value}`}};k=Ve([ze(0,E.IExtHostRpcService),ze(1,T.ILogService)],k),e.ExtHostApiDeprecationService=k,e.NullApiDeprecationService=Object.freeze(new class{report(D,_,C){}})}),define(we[178],_e([0,1,3,5,6,26]),function(ee,e,g,T,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class k{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new g.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(_,C,i,I={}){const o=E.ExtensionIdentifier.toKey(_.identifier),f=this._inFlightRequests.get(o)||[],c=[...i].sort().join(" ");let d=f.find(y=>y.scopes===c);if(d)return d.result;{const y=this._getSession(_,o,C,i,I);d={scopes:c,result:y},f.push(d),this._inFlightRequests.set(o,f);try{await y}finally{const w=f.findIndex(v=>v.scopes===c);w>-1&&(f.splice(w),this._inFlightRequests.set(o,f))}return y}}async _getSession(_,C,i,I,o={}){await this._proxy.$ensureProvider(i);const f=_.displayName||_.name;return this._proxy.$getSession(i,I,C,f,o)}async removeSession(_,C){const i=this._authenticationProviders.get(_);return i?i.provider.removeSession(C):this._proxy.$removeSession(_,C)}registerAuthenticationProvider(_,C,i,I){var o;if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:C,provider:i,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(c=>c.id===_)||this._providers.push({id:_,label:C});const f=i.onDidChangeSessions(c=>{var d,y,w;this._proxy.$sendDidChangeSessions(_,{added:(d=c.added)!==null&&d!==void 0?d:[],changed:(y=c.changed)!==null&&y!==void 0?y:[],removed:(w=c.removed)!==null&&w!==void 0?w:[]})});return this._proxy.$registerAuthenticationProvider(_,C,(o=I==null?void 0:I.supportsMultipleAccounts)!==null&&o!==void 0?o:!1),new S.Disposable(()=>{f.dispose(),this._authenticationProviders.delete(_);const c=this._providers.findIndex(d=>d.id===_);c>-1&&this._providers.splice(c),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,C){const i=this._authenticationProviders.get(_);if(i)return Promise.resolve(i.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,C){const i=this._authenticationProviders.get(_);if(i)return Promise.resolve(i.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,C){const i=this._authenticationProviders.get(_);if(i)return Promise.resolve(i.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,C){return this._onDidChangeSessions.fire({provider:{id:_,label:C}}),Promise.resolve()}$onDidChangeAuthenticationProviders(_,C){return _.forEach(i=>{this._providers.some(I=>I.id===i.id)||this._providers.push(i)}),C.forEach(i=>{const I=this._providers.findIndex(o=>o.id===i.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:_,removed:C}),Promise.resolve()}}e.ExtHostAuthentication=k}),define(we[179],_e([0,1,5,13,9]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let E=class{constructor(D,_){this._extHostDocumentsAndEditors=_,this._proxy=D.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const _=S.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};E=Ve([ze(0,T.IExtHostRpcService)],E),e.ExtHostBulkEdits=E}),define(we[180],_e([0,1,5]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(E){const k=E.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(D){return k.$writeText(D)}})}}e.ExtHostClipboard=T}),define(we[71],_e([0,1,10,6,9,24,5,17,15,54,31,35,2,7,4,13]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let y=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(k.MainContext.MainThreadCommands),this._logService=n,this.converter=new w(this,s=>{const r=this._apiCommands.get(s);return(r==null?void 0:r.result)===l.Void?r:void 0},n),this._argumentProcessors=[{processArgument(s){return C.revive(s)}},{processArgument(s){return E.cloneAndChange(s,function(r){if(i.Range.isIRange(r))return S.Range.to(r);if(I.Position.isIPosition(r))return S.Position.to(r);if(i.Range.isIRange(r.range)&&o.URI.isUri(r.uri))return S.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...s)=>{const r=t.args.map((b,p)=>{if(!b.validate(s[p]))throw new Error(`Invalid argument '${b.name}' when running '${t.id}', received: ${s[p]}`);return b.convert(s[p])}),u=await this.executeCommand(t.internalId,...r);return t.result.convert(u,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new T.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,s,r,u){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:s,thisArg:r,description:u}),t&&this._proxy.$registerCommand(n),new T.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,s){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const r=E.cloneAndChange(n,function(u){if(u instanceof T.Position)return S.Position.from(u);if(u instanceof T.Range)return S.Range.from(u);if(u instanceof T.Location)return S.location.from(u);if(T.NotebookRange.isNotebookRange(u))return S.NotebookRange.from(u);if(!Array.isArray(u))return u});try{const u=await this._proxy.$executeCommand(t,r,s);return C.revive(u)}catch(u){if(u instanceof Error&&u.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw u}}}async _executeContributedCommand(t,n){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:r,thisArg:u,description:b}=s;if(b)for(let p=0;p<b.args.length;p++)try{g.validateConstraint(n[p],b.args[p].constraint)}catch(P){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${b.args[p].name}' - ${b.args[p].description}`)}try{return await r.apply(u,n)}catch(p){if(t===this.converter.delegatingCommandId){const P=this.converter.getActualCommand(...n);P&&(t=P.command)}throw this._logService.error(p,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(s=>this._argumentProcessors.reduce((r,u)=>u.processArgument(r),s)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(s=>s[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,s]of this._commands){let{description:r}=s;r&&(t[n]=r)}return Promise.resolve(t)}};y=Ve([ze(0,d.IExtHostRpcService),ze(1,_.ILogService)],y),e.ExtHostCommands=y,e.IExtHostCommands=c.createDecorator("IExtHostCommands");class w{constructor(t,n,s){this._commands=t,this._lookupApiCommand=n,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const r=this._lookupApiCommand(t.command);if(r)s.id=r.internalId,s.arguments=r.args.map((u,b)=>u.convert(t.arguments&&t.arguments[b]));else if(D.isNonEmptyArray(t.arguments)){const u=++this._cachIdPool;this._cache.set(u,t),n.add(f.toDisposable(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),s.$ident=u,s.id=this.delegatingCommandId,s.arguments=[u],this._logService.trace("CommandsConverter#CREATE",t.command,u)}return s}fromInternal(t){const n=k.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class v{constructor(t,n,s,r){this.name=t,this.description=n,this.validate=s,this.convert=r}optional(){return new v(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new v(t??this.name,n??this.description,this.validate,this.convert)}}e.ApiCommandArgument=v,v.Uri=new v("uri","Uri of a text document",m=>o.URI.isUri(m),m=>m),v.Position=new v("position","A position in a text document",m=>T.Position.isPosition(m),S.Position.from),v.Range=new v("range","A range in a text document",m=>T.Range.isRange(m),S.Range.from),v.Selection=new v("selection","A selection in a text document",m=>T.Selection.isSelection(m),S.Selection.from),v.Number=new v("number","",m=>typeof m=="number",m=>m),v.String=new v("string","",m=>typeof m=="string",m=>m),v.CallHierarchyItem=new v("item","A call hierarchy item",m=>m instanceof T.CallHierarchyItem,S.CallHierarchyItem.to);class l{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=l,l.Void=new l("no result",m=>m);class h{constructor(t,n,s,r,u){this.id=t,this.internalId=n,this.description=s,this.args=r,this.result=u}}e.ApiCommand=h}),define(we[181],_e([0,1,9,6,58,71,17,86]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new E.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",i(g.DocumentHighlight.to))),new E.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(o,f)=>{if(k.isFalsyOrEmpty(o))return;class c extends T.SymbolInformation{static to(y){const w=new c(y.name,g.SymbolKind.to(y.kind),y.containerName||"",new T.Location(f[0],g.Range.to(y.range)));return w.detail=y.detail,w.range=w.location.range,w.selectionRange=g.Range.to(y.selectionRange),w.children=y.children?y.children.map(c.to):[],w}}return o.map(c.to)})),new E.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new E.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range,new E.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new E.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,new E.ApiCommandArgument("ch","Trigger character",o=>typeof o=="string",o=>o),new E.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new E.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new E.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new E.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new E.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new E.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location-instances.",i(g.location.to))),new E.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Hover-instances.",i(g.Hover.to))),new E.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("position","A position in a text document",o=>Array.isArray(o)&&o.every(f=>T.Position.isPosition(f)),o=>o.map(g.Position.from))],new E.ApiCommandResult("A promise that resolves to an array of ranges.",o=>o.map(f=>{let c;for(const d of f.reverse())c=new T.SelectionRange(g.Range.to(d),c);return c}))),new E.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[E.ApiCommandArgument.String.with("query","Search string")],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",o=>{const f=[];if(Array.isArray(o))for(let c of o)f.push(...c[1].map(g.WorkspaceSymbol.to));return f})),new E.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(g.CallHierarchyItem.to))),new E.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(g.CallHierarchyIncomingCall.to))),new E.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(g.CallHierarchyOutgoingCall.to))),new E.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("newName","The new symbol name")],new E.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",o=>{if(!!o){if(o.rejectReason)throw new Error(o.rejectReason);return g.WorkspaceEdit.to(o)}})),new E.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new E.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",o=>o.map(g.DocumentLink.to))),new E.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new T.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const f=D.decodeSemanticTokensDto(o);if(f.type==="full")return new T.SemanticTokens(f.data,void 0)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new T.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const f=D.decodeSemanticTokensDto(o);if(f.type==="full")return new T.SemanticTokens(f.data,void 0)})),new E.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new E.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(o,f,c)=>{if(!o)return new T.CompletionList([]);const d=o.suggestions.map(y=>g.CompletionItem.to(y,c));return new T.CompletionList(d,o.incomplete)})),new E.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new E.ApiCommandResult("A promise that resolves to SignatureHelp.",o=>{if(o)return g.SignatureHelp.to(o)})),new E.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new E.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(o,f,c)=>i(d=>new T.CodeLens(g.Range.to(d.range),d.command&&c.fromInternal(d.command)))(o))),new E.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",o=>T.Range.isRange(o),o=>T.Selection.isSelection(o)?g.Selection.from(o):g.Range.from(o)),E.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new E.ApiCommandResult("A promise that resolves to an array of Command-instances.",(o,f,c)=>i(d=>{if(d._isSynthetic){if(!d.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(d.command)}else{const y=new T.CodeAction(d.title,d.kind?new T.CodeActionKind(d.kind):void 0);return d.edit&&(y.edit=g.WorkspaceEdit.to(d.edit)),d.command&&(y.command=c.fromInternal(d.command)),y.isPreferred=d.isPreferred,y}})(o))),new E.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",o=>o?o.map(f=>new T.ColorInformation(g.Range.to(f.range),g.Color.to(f.color))):[])),new E.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new E.ApiCommandArgument("color","The color to show and insert",o=>o instanceof T.Color,g.Color.from),new E.ApiCommandArgument("context","Context object with uri and range",o=>!0,o=>({uri:o.uri,range:g.Range.from(o.range)}))],new E.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",o=>o?o.map(g.ColorPresentation.to):[])),new E.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of Inlay objects",o=>o.map(g.InlayHint.to))),new E.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new E.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",i(o=>({viewType:o.viewType,displayName:o.displayName,options:{transientOutputs:o.options.transientOutputs,transientCellMetadata:o.options.transientCellMetadata,transientDocumentMetadata:o.options.transientDocumentMetadata},filenamePattern:o.filenamePattern.map(f=>g.NotebookExclusiveDocumentPattern.to(f))})))),new E.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of InlineValue objects",o=>o.map(g.InlineValue.to))),new E.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[g.ViewColumn.from(o.viewColumn),g.TextEditorOpenOptions.from(o)])).optional(),E.ApiCommandArgument.String.with("label","").optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[E.ApiCommandArgument.Uri.with("resource","Resource to open"),E.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[g.ViewColumn.from(o.viewColumn),g.TextEditorOpenOptions.from(o)])).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[E.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),E.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),E.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="object",o=>o&&[g.ViewColumn.from(o.viewColumn),g.TextEditorOpenOptions.from(o)]).optional()],E.ApiCommandResult.Void)];class C{static register(f){_.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=C;function i(o){return f=>{if(Array.isArray(f))return f.map(o)}}function I(o){if(!Array.isArray(o))return;const f=[];for(const c of o)S.isLocationLink(c)?f.push(g.DefinitionLink.to(c)):f.push(g.location.to(c));return f}}),define(we[182],_e([0,1,12,48,3,7,2,58,26,9,6,5]),function(ee,e,g,T,S,E,k,D,_,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class o{constructor(h,m,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=h.getProxy(I.MainContext.MainThreadComments),m.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const s=this._commentControllers.get(n.handle);return s||n}else if(n&&n.$mid===7){const s=this._commentControllers.get(n.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.commentThreadHandle);return r||n}else if(n&&n.$mid===8){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);return r?{thread:r,text:n.text}:n}else if(n&&n.$mid===9){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let u=n.commentUniqueId,b=r.getCommentByUniqueId(u);return b||n}else if(n&&n.$mid===10){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let u=n.text,b=n.commentUniqueId,p=r.getCommentByUniqueId(b);return p?(p.body=u,p):n}return n}})}createCommentController(h,m,t){const n=o.handlePool++,s=new c(h,n,this._proxy,m,t);this._commentControllers.set(s.handle,s);const r=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(h.identifier))||[];return r.push(s),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(h.identifier),r),s}$createCommentThreadTemplate(h,m,t){const n=this._commentControllers.get(h);!n||n.$createCommentThreadTemplate(m,t)}async $updateCommentThreadTemplate(h,m,t){const n=this._commentControllers.get(h);!n||n.$updateCommentThreadTemplate(m,t)}$deleteCommentThread(h,m){const t=this._commentControllers.get(h);t&&t.$deleteCommentThread(m)}$provideCommentingRanges(h,m,t){const n=this._commentControllers.get(h);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(k.URI.revive(m));return g.asPromise(()=>n.commentingRangeProvider.provideCommentingRanges(s,t)).then(r=>r?r.map(u=>C.Range.from(u)):void 0)}$toggleReaction(h,m,t,n,s){const r=this._commentControllers.get(h);return!r||!r.reactionHandler?Promise.resolve(void 0):g.asPromise(()=>{const u=r.getCommentThread(m);if(u){const b=u.getCommentByUniqueId(n.uniqueIdInThread);if(r!==void 0&&b&&r.reactionHandler)return r.reactionHandler(b,w(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=o,o.handlePool=0;class f{constructor(h,m,t,n,s,r,u){this._proxy=h,this._commentController=m,this._id=t,this._uri=n,this._range=s,this._comments=r,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new E.MutableDisposable,this._acceptInputDisposables.value=new E.DisposableStore,this._id===void 0&&(this._id=`${m.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,C.Range.from(this._range),u),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(h){this._id=h}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(h){h.isEqual(this._range)||(this._range=h,this.modifications.range=h,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(h){this._canReply!==h&&(this._canReply=h,this.modifications.canReply=h,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(h){this._label=h,this.modifications.label=h,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(h){this._contextValue=h,this.modifications.contextValue=h,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(h){this._comments=h,this.modifications.comments=h,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(h){this._collapseState=h,this.modifications.collapsibleState=h,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new E.DisposableStore);const h=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),m={};h("range")&&(m.range=C.Range.from(this._range)),h("label")&&(m.label=this.label),h("contextValue")&&(m.contextValue=this.contextValue),h("comments")&&(m.comments=this._comments.map(t=>d(this,this._commentController,t,this._commentsMap))),h("collapsibleState")&&(m.collapseState=v(this._collapseState)),h("canReply")&&(m.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,m)}getCommentByUniqueId(h){for(let m of this._commentsMap){let t=m[0],n=m[1];if(h===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(h=>h.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}f._handlePool=0,Ve([T.debounce(100)],f.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=f;class c{constructor(h,m,t,n,s){this._extension=h,this._handle=m,this._proxy=t,this._id=n,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(h){this._reactionHandler=h,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this._options}set options(h){this._options=h,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(h,m,t,n){if(typeof h=="string"){const s=new f(this._proxy,this,h,m,t,n,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new f(this._proxy,this,void 0,h,m,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(h,m){const t=new f(this._proxy,this,void 0,k.URI.revive(h),C.Range.to(m),[],this._extension.identifier);return t.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(h,m){let t=this._threads.get(h);t&&(t.range=C.Range.to(m))}$deleteCommentThread(h){let m=this._threads.get(h);m&&m.dispose(),this._threads.delete(h)}getCommentThread(h){return this._threads.get(h)}dispose(){this._threads.forEach(h=>{h.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function d(l,h,m,t){let n=t.get(m);n||(n=++l.commentHandle,t.set(m,n));const s=m.author&&m.author.iconPath?m.author.iconPath.toString():void 0;return{mode:m.mode,contextValue:m.contextValue,uniqueIdInThread:n,body:C.MarkdownString.from(m.body),userName:m.author.name,userIconPath:s,label:m.label,commentReactions:m.reactions?m.reactions.map(r=>y(r)):void 0}}function y(l){return{label:l.label,iconPath:l.iconPath?C.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function w(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?k.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function v(l){if(l!==void 0)switch(l){case i.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}}),define(we[100],_e([0,1,2,5,6,4,13,15,17,8,14]),function(ee,e,g,T,S,E,k,D,_,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class yi{constructor(f,c){this._logService=c,this._provider=new Map,this._proxy=f.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,c){const d=yi._handlePool++;this._provider.set(d,{provider:f,extensionId:c}),this._proxy.$registerDecorationProvider(d,c.value);const y=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(d,null);return}let v=_.asArray(w);if(v.length<=yi._maxEventSize){this._proxy.$onDidChange(d,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",c.value,v.length);const l=v.map(t=>({uri:t,rank:C.count(t.path,"/")})),h=_.groupBy(l,(t,n)=>t.rank-n.rank||C.compare(t.uri.path,n.uri.path));let m=[];e:for(let t of h){let n;for(let s of t){let r=i.dirname(s.uri.path);if(n!==r&&(n=r,m.push(s.uri)>=yi._maxEventSize))break e}}this._proxy.$onDidChange(d,m)});return new S.Disposable(()=>{y==null||y.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(f,c,d){if(!this._provider.has(f))return Object.create(null);const y=Object.create(null),{provider:w,extensionId:v}=this._provider.get(f);return await Promise.all(c.map(async l=>{try{const{uri:h,id:m}=l,t=await Promise.resolve(w.provideFileDecoration(g.URI.revive(h),d));if(!t)return;try{S.FileDecoration.validate(t),y[m]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${v.value}': ${n}`)}}catch(h){this._logService.error(h)}})),y}};I._handlePool=0,I._maxEventSize=250,I=Ve([ze(0,k.IExtHostRpcService),ze(1,D.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=E.createDecorator("IExtHostDecorations")}),define(we[183],_e([0,1,128,90,2,5,6,9,3,15,22]),function(ee,e,g,T,S,E,k,D,_,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(c,d,y,w,v){this._name=c,this._owner=d,this._maxDiagnosticsPerFile=y,this._proxy=w,this._onDidChangeDiagnostics=v,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,d){if(!c){this.clear();return}this._checkDisposed();let y=[];if(S.URI.isUri(c)){if(!d){this.delete(c);return}this._data.set(c,d.slice()),y=[c]}else if(Array.isArray(c)){y=[];let v;c=[...c].sort(I._compareIndexedTuplesByUri);for(const l of c){const[h,m]=l;if((!v||h.toString()!==v.toString())&&(v&&this._data.get(v).length===0&&this._data.delete(v),v=h,y.push(h),this._data.set(h,[])),m){const t=this._data.get(h);t&&t.push(...m)}else{const t=this._data.get(h);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(y),!this._proxy)return;const w=[];for(let v of y){let l=[];const h=this._data.get(v);if(h)if(h.length>this._maxDiagnosticsPerFile){l=[];const m=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of h)if(n.severity===m[t]&&l.push(D.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;l.push({severity:T.MarkerSeverity.Info,message:g.localize(0,null,h.length-this._maxDiagnosticsPerFile),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=h.map(m=>D.Diagnostic.from(m));w.push([v,l])}this._proxy.$changeMany(this._owner,w)}delete(c){this._checkDisposed(),this._onDidChangeDiagnostics.fire([c]),this._data.delete(c),this._proxy&&this._proxy.$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(c,d){this._checkDisposed();for(let y of this._data.keys())c.apply(d,[y,this.get(y),this])}get(c){this._checkDisposed();const d=this._data.get(c);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(this._data.get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,d){return c[0].toString()<d[0].toString()?-1:c[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=I;let o=class jt{constructor(c,d){this._logService=d,this._collections=new Map,this._onDidChangeDiagnostics=new _.Emitter,this.onDidChangeDiagnostics=_.Event.map(_.Event.debounce(this._onDidChangeDiagnostics.event,jt._debouncer,50),jt._mapper),this._proxy=c.getProxy(E.MainContext.MainThreadDiagnostics)}static _debouncer(c,d){return c?c.concat(d):d}static _mapper(c){const d=new i.ResourceMap;for(const y of c)d.set(y,y);return{uris:Object.freeze(Array.from(d.values()))}}createDiagnosticCollection(c,d){const{_collections:y,_proxy:w,_onDidChangeDiagnostics:v,_logService:l}=this,h=new class{$changeMany(n,s){w.$changeMany(n,s),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,n,s.length===0?"CLEARING":s)}$clear(n){w.$clear(n),l.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,n)}dispose(){w.dispose()}};let m;if(!d)d="_generated_diagnostic_collection_name_#"+jt._idPool++,m=d;else if(!y.has(d))m=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do m=d+jt._idPool++;while(y.has(m))}return new class extends I{constructor(){super(d,m,jt._maxDiagnosticsPerFile,h,v);y.set(m,this)}dispose(){super.dispose(),y.delete(m)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const d=new Map,y=[];for(const w of this._collections.values())w.forEach((v,l)=>{let h=d.get(v.toString());typeof h=="undefined"&&(h=y.length,d.set(v.toString(),h),y.push([v,[]])),y[h][1]=y[h][1].concat(...l)});return y}}_getDiagnostics(c){let d=[];for(let y of this._collections.values())y.has(c)&&(d=d.concat(y.get(c)));return d}$acceptMarkersChange(c){if(!this._mirrorCollection){const d="_generated_mirror",y=new I(d,d,jt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(d,y),this._mirrorCollection=y}for(const[d,y]of c)this._mirrorCollection.set(S.URI.revive(d),y.map(D.Diagnostic.to))}};o._idPool=0,o._maxDiagnosticsPerFile=1e3,o=Ve([ze(1,C.ILogService)],o),e.ExtHostDiagnostics=o}),define(we[184],_e([0,1,2,5]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(k){this._proxy=k.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(k){return this._proxy.$showOpenDialog(k).then(D=>D?D.map(_=>g.URI.revive(_)):void 0)}showSaveDialog(k){return this._proxy.$showSaveDialog(k).then(D=>D?g.URI.revive(D):void 0)}}e.ExtHostDialogs=S}),define(we[185],_e([0,1,11,2,6,5,16,18,8]),function(ee,e,g,T,S,E,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(I,o,f){this._documentsAndEditors=o,this._logService=f,this._documentContentProviders=new Map,this._proxy=I.getProxy(E.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,o){if(Object.keys(k.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const f=C._handlePool++;this._documentContentProviders.set(f,o),this._proxy.$registerTextContentProvider(f,I);let c;return typeof o.onDidChange=="function"&&(c=o.onDidChange(d=>{if(d.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(f,d).then(y=>{if(!y&&typeof y!="string")return;const w=this._documentsAndEditors.getDocument(d);if(!w)return;const v=_.splitLines(y);if(!w.equalLines(v))return this._proxy.$onVirtualDocumentChange(d,y)},g.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),c&&(c.dispose(),c=void 0)})}$provideTextDocumentContent(I,o){const f=this._documentContentProviders.get(I);return f?Promise.resolve(f.provideTextDocumentContent(T.URI.revive(o),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${o.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(we[186],_e([0,1,3,7,2,5,95,9,10,24]),function(ee,e,g,T,S,E,k,D,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(o,f){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new T.DisposableStore,this._documentLoader=new Map,this._proxy=o.getProxy(E.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const d of c)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const d of c)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(o){if(!o)return;const f=this._documentsAndEditors.getDocument(o);if(f)return f}getDocument(o){const f=this.getDocumentData(o);if(!(f==null?void 0:f.document))throw new Error(`Unable to retrieve document from URI '${o}'`);return f.document}ensureDocumentData(o){const f=this._documentsAndEditors.getDocument(o);if(f)return Promise.resolve(f);let c=this._documentLoader.get(o.toString());return c||(c=this._proxy.$tryOpenDocument(o).then(d=>{this._documentLoader.delete(o.toString());const y=S.URI.revive(d);return _.assertIsDefined(this._documentsAndEditors.getDocument(y))},d=>(this._documentLoader.delete(o.toString()),Promise.reject(d))),this._documentLoader.set(o.toString(),c)),c}createDocumentData(o){return this._proxy.$tryCreateDocument(o).then(f=>S.URI.revive(f))}$acceptModelModeChanged(o,f){const c=S.URI.revive(o),d=this._documentsAndEditors.getDocument(c);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(f),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(o){const f=S.URI.revive(o),c=this._documentsAndEditors.getDocument(f);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(o,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(o,f){const c=S.URI.revive(o),d=this._documentsAndEditors.getDocument(c);if(!d)throw new Error("unknown document");d._acceptIsDirty(f),this._onDidChangeDocument.fire({document:d.document,contentChanges:[]})}$acceptModelChanged(o,f,c){const d=S.URI.revive(o),y=this._documentsAndEditors.getDocument(d);if(!y)throw new Error("unknown document");y._acceptIsDirty(c),y.onEvents(f),this._onDidChangeDocument.fire(C.deepFreeze({document:y.document,contentChanges:f.changes.map(w=>({range:D.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text}))}))}setWordDefinitionFor(o,f){k.setWordDefinitionFor(o,f)}}e.ExtHostDocuments=i}),define(we[36],_e([0,1,39,3,7,2,4,5,95,13,98,9,15,22,16,40,108]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o,f,c,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let v=class{constructor(h,m){this._extHostRpc=h,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new T.Emitter,this._onDidRemoveDocuments=new T.Emitter,this._onDidChangeVisibleTextEditors=new T.Emitter,this._onDidChangeActiveTextEditor=new T.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const m=[],t=[],n=[];if(h.removedDocuments)for(const s of h.removedDocuments){const r=E.URI.revive(s),u=this._documents.get(r);(u==null?void 0:u.unref())&&(this._documents.delete(r),m.push(u.value))}if(h.addedDocuments)for(const s of h.addedDocuments){const r=E.URI.revive(s.uri);let u=this._documents.get(r);if(u&&r.scheme!==c.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);u||(u=new w(new _.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),r,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(r,u),t.push(u.value)),u.ref()}if(h.removedEditors)for(const s of h.removedEditors){const r=this._editors.get(s);this._editors.delete(s),r&&n.push(r)}if(h.addedEditors)for(const s of h.addedEditors){const r=E.URI.revive(s.documentUri);g.ok(this._documents.has(r),`document '${r}' does not exist`),g.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const u=this._documents.get(r).value,b=new i.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new y.Lazy(()=>u.document),s.selections.map(I.Selection.to),s.options,s.visibleRanges.map(p=>I.Range.to(p)),typeof s.editorPosition=="number"?I.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,b)}h.newActiveEditor!==void 0&&(g.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),S.dispose(m),S.dispose(n),h.removedDocuments&&this._onDidRemoveDocuments.fire(m),h.addedDocuments&&this._onDidAddDocuments.fire(t),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){var m;return(m=this._documents.get(h))===null||m===void 0?void 0:m.value}allDocuments(){return d.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return h?m:m==null?void 0:m.value}allEditors(){return[...this._editors.values()]}};v=Ve([ze(0,C.IExtHostRpcService),ze(1,o.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=k.createDecorator("IExtHostDocumentsAndEditors")}),define(we[187],_e([0,1,2,5,7,6,9,118,8,23]),function(ee,e,g,T,S,E,k,D,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const c=this._schemes.indexOf(f);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),c=[];let d,y,w=14,v=14;for(const l of f){let h=d?_.commonPrefixLength(d,l):0;for(h===0?y=1:y=v;h<l.length;h++)h+1===l.length?(w=v,v=9):v+=1,c.push([y,l.toUpperCase().charCodeAt(h),v]),c.push([y,l.toLowerCase().charCodeAt(h),v]),y=v;d=l,v=w}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new D.StateMachine(c)}}provideDocumentLinks(f){this._initStateMachine();const c=[],d=D.LinkComputer.computeLinks({getLineContent(y){return f.lineAt(y-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const y of d){const w=k.DocumentLink.to(y);w.target&&c.push(w)}return c}}class I{constructor(f,c){this._extHostLanguageFeatures=c,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=f.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){var f;(f=this._linkProviderRegistration)===null||f===void 0||f.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,c,d,y={},w){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const v=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(v,d),this._enableProposedApi.set(v,w??!1);let l=2;y.isCaseSensitive&&(l+=1024),y.isReadonly&&(l+=2048),typeof d.copy=="function"&&(l+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&(l+=4),this._proxy.$registerFileSystemProvider(v,c,l).catch(m=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${c}`),console.error(m)});const h=d.onDidChangeFile(m=>{const t=[];for(const n of m){let{uri:s,type:r}=n;if(s.scheme!==c)continue;let u;switch(r){case E.FileChangeType.Changed:u=0;break;case E.FileChangeType.Created:u=1;break;case E.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:u})}this._proxy.$onFileSystemChange(v,t)});return S.toDisposable(()=>{h.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(v),this._enableProposedApi.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(f,c){const{type:d,ctime:y,mtime:w,size:v,permissions:l}=f;return c?{type:d,ctime:y,mtime:w,size:v,permissions:l}:{type:d,ctime:y,mtime:w,size:v}}$stat(f,c){return Promise.resolve(this._getFsProvider(f).stat(g.URI.revive(c))).then(d=>{var y;return I._asIStat(d,(y=this._enableProposedApi.get(f))!==null&&y!==void 0?y:!1)})}$readdir(f,c){return Promise.resolve(this._getFsProvider(f).readDirectory(g.URI.revive(c)))}$readFile(f,c){return Promise.resolve(this._getFsProvider(f).readFile(g.URI.revive(c))).then(d=>C.VSBuffer.wrap(d))}$writeFile(f,c,d,y){return Promise.resolve(this._getFsProvider(f).writeFile(g.URI.revive(c),d.buffer,y))}$delete(f,c,d){return Promise.resolve(this._getFsProvider(f).delete(g.URI.revive(c),d))}$rename(f,c,d,y){return Promise.resolve(this._getFsProvider(f).rename(g.URI.revive(c),g.URI.revive(d),y))}$copy(f,c,d,y){const w=this._getFsProvider(f);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(g.URI.revive(c),g.URI.revive(d),y))}$mkdir(f,c){return Promise.resolve(this._getFsProvider(f).createDirectory(g.URI.revive(c)))}$watch(f,c,d,y){const w=this._getFsProvider(f).watch(g.URI.revive(d),y);this._watches.set(c,w)}$unwatch(f,c){const d=this._watches.get(c);d&&(d.dispose(),this._watches.delete(c))}$open(f,c,d){const y=this._getFsProvider(f);if(!y.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(y.open(g.URI.revive(c),d))}$close(f,c){const d=this._getFsProvider(f);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(c))}$read(f,c,d,y){const w=this._getFsProvider(f);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const v=C.VSBuffer.alloc(y);return Promise.resolve(w.read(c,d,v.buffer,0,y)).then(l=>v.slice(0,l))}$write(f,c,d,y){const w=this._getFsProvider(f);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(c,d,y.buffer,0,y.byteLength))}_getFsProvider(f){const c=this._fsProvider.get(f);if(!c){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return c}}e.ExtHostFileSystem=I}),define(we[72],_e([0,1,5,59,6,23,4,13,46]),function(ee,e,g,T,S,E,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class Ut{constructor(I,o){const f=I.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(c){return f.$stat(c).catch(Ut._handleError)},readDirectory(c){return f.$readdir(c).catch(Ut._handleError)},createDirectory(c){return f.$mkdir(c).catch(Ut._handleError)},async readFile(c){return f.$readFile(c).then(d=>d.buffer).catch(Ut._handleError)},writeFile(c,d){return f.$writeFile(c,E.VSBuffer.wrap(d)).catch(Ut._handleError)},delete(c,d){return f.$delete(c,Object.assign({recursive:!1,useTrash:!1},d)).catch(Ut._handleError)},rename(c,d,y){return f.$rename(c,d,Object.assign({overwrite:!1},y)).catch(Ut._handleError)},copy(c,d,y){return f.$copy(c,d,Object.assign({overwrite:!1},y)).catch(Ut._handleError)},isWritableFileSystem(c){const d=o.getCapabilities(c);if(typeof d=="number")return!(d&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new S.FileSystemError(String(I));if(I.name==="ENOPRO")throw S.FileSystemError.Unavailable(I.message);switch(I.name){case T.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(I.message);case T.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(I.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(I.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(I.message);case T.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(I.message);case T.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(I.message);default:throw new S.FileSystemError(I.message,I.name)}}};C=Ve([ze(0,D.IExtHostRpcService),ze(1,_.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=k.createDecorator("IExtHostConsumerFileSystem")}),define(we[188],_e([0,1,7,5]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(k){this._handlePool=0,this._proxy=k.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,k),g.toDisposable(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=S}),define(we[189],_e([0,1,2,24,9,6,12,5,8,31,17,10,115,7,86,50,62,52,11,3]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o,f,c,d,y,w,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class h{constructor($,G){this._documents=$,this._provider=G}provideDocumentSymbols($,G){const te=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentSymbols(te,G)).then(re=>{if(!i.isFalsyOrEmpty(re))return re[0]instanceof E.DocumentSymbol?re.map(S.DocumentSymbol.from):h._asDocumentSymbolTree(re)})}static _asDocumentSymbolTree($){var G;$=$.slice(0).sort((K,oe)=>{let me=K.location.range.start.compareTo(oe.location.range.start);return me===0&&(me=oe.location.range.end.compareTo(K.location.range.end)),me});const te=[],re=[];for(const K of $){const oe={name:K.name||"!!MISSING: name!!",kind:S.SymbolKind.from(K.kind),tags:((G=K.tags)===null||G===void 0?void 0:G.map(S.SymbolTag.from))||[],detail:"",containerName:K.containerName,range:S.Range.from(K.location.range),selectionRange:S.Range.from(K.location.range),children:[]};for(;;){if(re.length===0){re.push(oe),te.push(oe);break}const me=re[re.length-1];if(C.Range.containsRange(me.range,oe.range)&&!C.Range.equalsRange(me.range,oe.range)){me.children&&me.children.push(oe),re.push(oe);break}re.pop()}}return te}}class m{constructor($,G,te){this._documents=$,this._commands=G,this._provider=te,this._cache=new y.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,G){const te=this._documents.getDocument($),re=await this._provider.provideCodeLenses(te,G);if(!re||G.isCancellationRequested)return;const K=this._cache.add(re),oe=new f.DisposableStore;this._disposables.set(K,oe);const me={cacheId:K,lenses:[]};for(let Ae=0;Ae<re.length;Ae++)me.lenses.push({cacheId:[K,Ae],range:S.Range.from(re[Ae].range),command:this._commands.toInternal(re[Ae].command,oe)});return me}async resolveCodeLens($,G){var te;const re=$.cacheId&&this._cache.get(...$.cacheId);if(!re)return;let K;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?K=re:K=await this._provider.resolveCodeLens(re,G),K||(K=re),G.isCancellationRequested)return;const oe=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!oe)return $.command=this._commands.toInternal((te=K.command)!==null&&te!==void 0?te:m._badCmd,oe),$}releaseCodeLenses($){var G;(G=this._disposables.get($))===null||G===void 0||G.dispose(),this._disposables.delete($),this._cache.delete($)}}m._badCmd={command:"missing",title:"!!MISSING: command!!"};function t(Xe){return Array.isArray(Xe)?Xe.map(S.DefinitionLink.from):Xe?[S.DefinitionLink.from(Xe)]:[]}class n{constructor($,G){this._documents=$,this._provider=G}provideDefinition($,G,te){const re=this._documents.getDocument($),K=S.Position.to(G);return k.asPromise(()=>this._provider.provideDefinition(re,K,te)).then(t)}}class s{constructor($,G){this._documents=$,this._provider=G}provideDeclaration($,G,te){const re=this._documents.getDocument($),K=S.Position.to(G);return k.asPromise(()=>this._provider.provideDeclaration(re,K,te)).then(t)}}class r{constructor($,G){this._documents=$,this._provider=G}provideImplementation($,G,te){const re=this._documents.getDocument($),K=S.Position.to(G);return k.asPromise(()=>this._provider.provideImplementation(re,K,te)).then(t)}}class u{constructor($,G){this._documents=$,this._provider=G}provideTypeDefinition($,G,te){const re=this._documents.getDocument($),K=S.Position.to(G);return k.asPromise(()=>this._provider.provideTypeDefinition(re,K,te)).then(t)}}class b{constructor($,G){this._documents=$,this._provider=G}provideHover($,G,te){const re=this._documents.getDocument($),K=S.Position.to(G);return k.asPromise(()=>this._provider.provideHover(re,K,te)).then(oe=>{if(!(!oe||i.isFalsyOrEmpty(oe.contents)))return oe.range||(oe.range=re.getWordRangeAtPosition(K)),oe.range||(oe.range=new E.Range(K,K)),S.Hover.from(oe)})}}class p{constructor($,G){this._documents=$,this._provider=G}provideEvaluatableExpression($,G,te){const re=this._documents.getDocument($),K=S.Position.to(G);return k.asPromise(()=>this._provider.provideEvaluatableExpression(re,K,te)).then(oe=>{if(oe)return S.EvaluatableExpression.from(oe)})}}class P{constructor($,G){this._documents=$,this._provider=G}provideInlineValues($,G,te,re){const K=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideInlineValues(K,S.Range.to(G),S.InlineValueContext.to(te),re)).then(oe=>{if(Array.isArray(oe))return oe.map(me=>S.InlineValue.from(me))})}}class A{constructor($,G){this._documents=$,this._provider=G}provideDocumentHighlights($,G,te){const re=this._documents.getDocument($),K=S.Position.to(G);return k.asPromise(()=>this._provider.provideDocumentHighlights(re,K,te)).then(oe=>{if(Array.isArray(oe))return oe.map(S.DocumentHighlight.from)})}}class a{constructor($,G){this._documents=$,this._provider=G}provideLinkedEditingRanges($,G,te){const re=this._documents.getDocument($),K=S.Position.to(G);return k.asPromise(()=>this._provider.provideLinkedEditingRanges(re,K,te)).then(oe=>{if(oe&&Array.isArray(oe.ranges))return{ranges:i.coalesce(oe.ranges.map(S.Range.from)),wordPattern:oe.wordPattern}})}}class R{constructor($,G){this._documents=$,this._provider=G}provideReferences($,G,te,re){const K=this._documents.getDocument($),oe=S.Position.to(G);return k.asPromise(()=>this._provider.provideReferences(K,oe,te,re)).then(me=>{if(Array.isArray(me))return me.map(S.location.from)})}}class M{constructor($,G,te,re,K,oe,me){this._documents=$,this._commands=G,this._diagnostics=te,this._provider=re,this._logService=K,this._extension=oe,this._apiDeprecation=me,this._cache=new y.Cache("CodeAction"),this._disposables=new Map}provideCodeActions($,G,te,re){const K=this._documents.getDocument($),oe=o.Selection.isISelection(G)?S.Selection.to(G):S.Range.to(G),me=[];for(const $e of this._diagnostics.getDiagnostics($))if(oe.intersection($e.range)&&me.push($e)>M._maxCodeActionsPerFile)break;const Ae={diagnostics:me,only:te.only?new E.CodeActionKind(te.only):void 0,triggerKind:S.CodeActionTriggerKind.to(te.trigger)};return k.asPromise(()=>this._provider.provideCodeActions(K,oe,Ae,re)).then($e=>{var pe;if(!i.isNonEmptyArray($e)||re.isCancellationRequested)return;const Ge=this._cache.add($e),V=new f.DisposableStore;this._disposables.set(Ge,V);const ie=[];for(let ge=0;ge<$e.length;ge++){const Fe=$e[ge];!Fe||(M._isCommand(Fe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ie.push({_isSynthetic:!0,title:Fe.title,command:this._commands.toInternal(Fe,V)})):(Ae.only&&(Fe.kind?Ae.only.contains(Fe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action is of kind '${Fe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ie.push({cacheId:[Ge,ge],title:Fe.title,command:Fe.command&&this._commands.toInternal(Fe.command,V),diagnostics:Fe.diagnostics&&Fe.diagnostics.map(S.Diagnostic.from),edit:Fe.edit&&S.WorkspaceEdit.from(Fe.edit),kind:Fe.kind&&Fe.kind.value,isPreferred:Fe.isPreferred,disabled:(pe=Fe.disabled)===null||pe===void 0?void 0:pe.reason})))}return{cacheId:Ge,actions:ie}})}async resolveCodeAction($,G){var te;const[re,K]=$,oe=this._cache.get(re,K);if(!oe||M._isCommand(oe)||!this._provider.resolveCodeAction)return;const me=(te=await this._provider.resolveCodeAction(oe,G))!==null&&te!==void 0?te:oe;return(me==null?void 0:me.edit)?S.WorkspaceEdit.from(me.edit):void 0}releaseCodeActions($){var G;(G=this._disposables.get($))===null||G===void 0||G.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}M._maxCodeActionsPerFile=1e3;class H{constructor($,G){this._documents=$,this._provider=G}provideDocumentFormattingEdits($,G,te){const re=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentFormattingEdits(re,G,te)).then(K=>{if(Array.isArray(K))return K.map(S.TextEdit.from)})}}class ue{constructor($,G){this._documents=$,this._provider=G}provideDocumentRangeFormattingEdits($,G,te,re){const K=this._documents.getDocument($),oe=S.Range.to(G);return k.asPromise(()=>this._provider.provideDocumentRangeFormattingEdits(K,oe,te,re)).then(me=>{if(Array.isArray(me))return me.map(S.TextEdit.from)})}}class fe{constructor($,G){this._documents=$,this._provider=G,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits($,G,te,re,K){const oe=this._documents.getDocument($),me=S.Position.to(G);return k.asPromise(()=>this._provider.provideOnTypeFormattingEdits(oe,me,te,re,K)).then(Ae=>{if(Array.isArray(Ae))return Ae.map(S.TextEdit.from)})}}class Y{constructor($,G){this._provider=$,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols($,G){const te=D.IdObject.mixin({symbols:[]});return k.asPromise(()=>this._provider.provideWorkspaceSymbols($,G)).then(re=>{if(i.isNonEmptyArray(re))for(const K of re){if(!K)continue;if(!K.name){this._logService.warn("INVALID SymbolInformation, lacks name",K);continue}const oe=D.IdObject.mixin(S.WorkspaceSymbol.from(K));this._symbolCache.set(oe._id,K),te.symbols.push(oe)}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol($,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return $;const te=this._symbolCache.get($._id);if(te){const re=await k.asPromise(()=>this._provider.resolveWorkspaceSymbol(te,G));return re&&T.mixin($,S.WorkspaceSymbol.from(re),!0)}}releaseWorkspaceSymbols($){const G=this._resultCache.get($);if(G){for(let[te,re]=G;te<=re;te++)this._symbolCache.delete(te);this._resultCache.delete($)}}}class j{constructor($,G,te){this._documents=$,this._provider=G,this._logService=te}static supportsResolving($){return typeof $.prepareRename=="function"}provideRenameEdits($,G,te,re){const K=this._documents.getDocument($),oe=S.Position.to(G);return k.asPromise(()=>this._provider.provideRenameEdits(K,oe,te,re)).then(me=>{if(!!me)return S.WorkspaceEdit.from(me)},me=>{const Ae=j._asMessage(me);return Ae?{rejectReason:Ae,edits:void 0}:Promise.reject(me)})}resolveRenameLocation($,G,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const re=this._documents.getDocument($),K=S.Position.to(G);return k.asPromise(()=>this._provider.prepareRename(re,K,te)).then(oe=>{let me,Ae;if(E.Range.isRange(oe)?(me=oe,Ae=re.getText(oe)):I.isObject(oe)&&(me=oe.range,Ae=oe.placeholder),!!me){if(me.start.line>K.line||me.end.line<K.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(me),text:Ae}}},oe=>{const me=j._asMessage(oe);return me?{rejectReason:me,range:void 0,text:void 0}:Promise.reject(oe)})}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class Z{constructor($,G){this.resultId=$,this.tokens=G}}class L{constructor($,G){this._documents=$,this._provider=G,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens($,G,te){const re=this._documents.getDocument($),K=G!==0?this._previousResults.get(G):null;return k.asPromise(()=>K&&typeof K.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(re,K.resultId,te):this._provider.provideDocumentSemanticTokens(re,te)).then(oe=>(K&&this._previousResults.delete(G),oe?(oe=L._fixProvidedSemanticTokens(oe),this._send(L._convertToEdits(K,oe),oe)):null))}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return L._isSemanticTokens($)?L._isCorrectSemanticTokens($)?$:new E.SemanticTokens(new Uint32Array($.data),$.resultId):L._isSemanticTokensEdits($)?L._isCorrectSemanticTokensEdits($)?$:new E.SemanticTokensEdits($.edits.map(G=>new E.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const G of $.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,G){if(!L._isSemanticTokens(G)||!$||!$.tokens)return G;const te=$.tokens,re=te.length,K=G.data,oe=K.length;let me=0;const Ae=Math.min(re,oe);for(;me<Ae&&te[me]===K[me];)me++;if(me===re&&me===oe)return new E.SemanticTokensEdits([],G.resultId);let $e=0;const pe=Ae-me;for(;$e<pe&&te[re-$e-1]===K[oe-$e-1];)$e++;return new E.SemanticTokensEdits([{start:me,deleteCount:re-me-$e,data:K.subarray(me,oe-$e)}],G.resultId)}_send($,G){if(L._isSemanticTokens($)){const te=this._nextResultId++;return this._previousResults.set(te,new Z($.resultId,$.data)),c.encodeSemanticTokensDto({id:te,type:"full",data:$.data})}if(L._isSemanticTokensEdits($)){const te=this._nextResultId++;return L._isSemanticTokens(G)?this._previousResults.set(te,new Z(G.resultId,G.data)):this._previousResults.set(te,new Z($.resultId)),c.encodeSemanticTokensDto({id:te,type:"delta",deltas:($.edits||[]).map(re=>({start:re.start,deleteCount:re.deleteCount,data:re.data}))})}return null}}e.DocumentSemanticTokensAdapter=L;class q{constructor($,G){this._documents=$,this._provider=G}provideDocumentRangeSemanticTokens($,G,te){const re=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentRangeSemanticTokens(re,S.Range.to(G),te)).then(K=>K?this._send(K):null)}_send($){return c.encodeSemanticTokensDto({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=q;class N{constructor($,G,te,re,K){this._documents=$,this._commands=G,this._provider=te,this._apiDeprecation=re,this._extension=K,this._cache=new y.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,G,te,re){const K=this._documents.getDocument($),oe=S.Position.to(G),me=K.getWordRangeAtPosition(oe)||new E.Range(oe,oe),Ae=me.with({end:oe}),$e=new w.StopWatch(!0),pe=await k.asPromise(()=>this._provider.provideCompletionItems(K,oe,re,S.CompletionContext.to(te)));if(!pe||re.isCancellationRequested)return;const Ge=Array.isArray(pe)?new E.CompletionList(pe):pe,V=N.supportsResolving(this._provider)?this._cache.add(Ge.items):this._cache.add([]),ie=new f.DisposableStore;this._disposables.set(V,ie);const ge=[],Fe={x:V,b:ge,a:{replace:S.Range.from(me),insert:S.Range.from(Ae)},c:Ge.isIncomplete||void 0,d:$e.elapsed()};for(let Ne=0;Ne<Ge.items.length;Ne++){const Qe=Ge.items[Ne],Ee=this._convertCompletionItem(Qe,[V,Ne],Ae,me);ge.push(Ee)}return Fe}async resolveCompletionItem($,G){if(typeof this._provider.resolveCompletionItem!="function")return;const te=this._cache.get(...$);if(!te)return;const re=await k.asPromise(()=>this._provider.resolveCompletionItem(te,G));if(!!re)return this._convertCompletionItem(re,$)}releaseCompletionItems($){var G;(G=this._disposables.get($))===null||G===void 0||G.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,G,te,re){var K;const oe=this._disposables.get(G[0]);if(!oe)throw Error("DisposableStore is missing...");const me={x:G,a:(K=$.label)!==null&&K!==void 0?K:"",o:$.label2,b:$.kind!==void 0?S.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(S.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:S.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(S.TextEdit.from),m:this._commands.toInternal($.command,oe)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),me.h=$.textEdit.newText):typeof $.insertText=="string"?me.h=$.insertText:$.insertText instanceof E.SnippetString&&(me.h=$.insertText.value,me.i|=4);let Ae;return $.textEdit?Ae=$.textEdit.range:$.range&&(Ae=$.range),E.Range.isRange(Ae)?me.j=S.Range.from(Ae):Ae&&(!(te==null?void 0:te.isEqual(Ae.inserting))||!(re==null?void 0:re.isEqual(Ae.replacing)))&&(me.j={insert:S.Range.from(Ae.inserting),replace:S.Range.from(Ae.replacing)}),me}}class W{constructor($,G,te){this._documents=$,this._provider=G,this._commands=te,this._cache=new y.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions($,G,te,re){const K=this._documents.getDocument($),oe=S.Position.to(G),me=await k.asPromise(()=>this._provider.provideInlineCompletionItems(K,oe,te,re));if(!me||re.isCancellationRequested)return;const Ae=I.isArray(me)?{items:me}:me,$e=this._cache.add(Ae.items);let pe;return{pid:$e,items:Ae.items.map((Ge,V)=>{let ie;return Ge.command&&(pe||(pe=new f.DisposableStore,this._disposables.set($e,pe)),ie=this._commands.toInternal(Ge.command,pe)),{text:Ge.text,range:Ge.range?S.Range.from(Ge.range):void 0,command:ie,idx:V}})}}disposeCompletions($){this._cache.delete($);const G=this._disposables.get($);G&&G.clear(),this._disposables.delete($)}handleDidShowCompletionItem($,G){const te=this._cache.get($,G);te&&U.get(this._provider).fireOnDidShowCompletionItem({completionItem:te})}}class U{constructor(){this._onDidShowCompletionItemEmitter=new l.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get($){let G=U.map.get($);return G||(G=new U,U.map.set($,G)),G}fireOnDidShowCompletionItem($){this._onDidShowCompletionItemEmitter.fire($)}}e.InlineCompletionController=U,U.map=new WeakMap;class B{constructor($,G){this._documents=$,this._provider=G,this._cache=new y.Cache("SignatureHelp")}provideSignatureHelp($,G,te,re){const K=this._documents.getDocument($),oe=S.Position.to(G),me=this.reviveContext(te);return k.asPromise(()=>this._provider.provideSignatureHelp(K,oe,re,me)).then(Ae=>{if(Ae){const $e=this._cache.add([Ae]);return Object.assign(Object.assign({},S.SignatureHelp.from(Ae)),{id:$e})}})}reviveContext($){let G;if($.activeSignatureHelp){const te=S.SignatureHelp.to($.activeSignatureHelp),re=this._cache.get($.activeSignatureHelp.id,0);re?(G=re,G.activeSignature=te.activeSignature,G.activeParameter=te.activeParameter):G=te}return Object.assign(Object.assign({},$),{activeSignatureHelp:G})}releaseSignatureHelp($){this._cache.delete($)}}class J{constructor($,G){this._documents=$,this._provider=G}provideInlayHints($,G,te){const re=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideInlayHints(re,S.Range.to(G),te)).then(K=>K?{hints:K.map(S.InlayHint.from)}:void 0)}}class he{constructor($,G){this._documents=$,this._provider=G,this._cache=new y.Cache("DocumentLink")}async provideLinks($,G){const te=this._documents.getDocument($),re=await k.asPromise(()=>this._provider.provideDocumentLinks(te,G));if(!(!Array.isArray(re)||re.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:re.filter(he._validateLink).map(S.DocumentLink.from)};{const K=this._cache.add(re),oe={links:[],id:K};for(let me=0;me<re.length;me++){if(!he._validateLink(re[me]))continue;const Ae=S.DocumentLink.from(re[me]);Ae.cacheId=[K,me],oe.links.push(Ae)}return oe}}}static _validateLink($){return $.target&&$.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink($,G){if(typeof this._provider.resolveDocumentLink!="function")return;const te=this._cache.get(...$);if(!te)return;const re=await k.asPromise(()=>this._provider.resolveDocumentLink(te,G));if(!(!re||!he._validateLink(re)))return S.DocumentLink.from(re)}releaseLinks($){this._cache.delete($)}}class De{constructor($,G){this._documents=$,this._provider=G}provideColors($,G){const te=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentColors(te,G)).then(re=>Array.isArray(re)?re.map(oe=>({color:S.Color.from(oe.color),range:S.Range.from(oe.range)})):[])}provideColorPresentations($,G,te){const re=this._documents.getDocument($),K=S.Range.to(G.range),oe=S.Color.to(G.color);return k.asPromise(()=>this._provider.provideColorPresentations(oe,{document:re,range:K},te)).then(me=>{if(!!Array.isArray(me))return me.map(S.ColorPresentation.from)})}}class Oe{constructor($,G){this._documents=$,this._provider=G}provideFoldingRanges($,G,te){const re=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideFoldingRanges(re,G,te)).then(K=>{if(!!Array.isArray(K))return K.map(S.FoldingRange.from)})}}class Me{constructor($,G,te){this._documents=$,this._provider=G,this._logService=te}provideSelectionRanges($,G,te){const re=this._documents.getDocument($),K=G.map(S.Position.to);return k.asPromise(()=>this._provider.provideSelectionRanges(re,K,te)).then(oe=>{if(!i.isNonEmptyArray(oe))return[];if(oe.length!==K.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const me=[];for(let Ae=0;Ae<K.length;Ae++){const $e=[];me.push($e);let pe=K[Ae],Ge=oe[Ae];for(;;){if(!Ge.range.contains(pe))throw new Error("INVALID selection range, must contain the previous range");if($e.push(S.SelectionRange.from(Ge)),!Ge.parent)break;pe=Ge.range,Ge=Ge.parent}}return me})}}class He{constructor($,G){this._documents=$,this._provider=G,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession($,G,te){const re=this._documents.getDocument($),K=S.Position.to(G),oe=await this._provider.prepareCallHierarchy(re,K,te);if(!oe)return;const me=this._idPool.nextId();return this._cache.set(me,new Map),Array.isArray(oe)?oe.map(Ae=>this._cacheAndConvertItem(me,Ae)):[this._cacheAndConvertItem(me,oe)]}async provideCallsTo($,G,te){const re=this._itemFromCache($,G);if(!re)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyIncomingCalls(re,te);if(!!K)return K.map(oe=>({from:this._cacheAndConvertItem($,oe.from),fromRanges:oe.fromRanges.map(me=>S.Range.from(me))}))}async provideCallsFrom($,G,te){const re=this._itemFromCache($,G);if(!re)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyOutgoingCalls(re,te);if(!!K)return K.map(oe=>({to:this._cacheAndConvertItem($,oe.to),fromRanges:oe.fromRanges.map(me=>S.Range.from(me))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,G){var te;const re=this._cache.get($),K={_sessionId:$,_itemId:re.size.toString(36),name:G.name,detail:G.detail,kind:S.SymbolKind.from(G.kind),uri:G.uri,range:S.Range.from(G.range),selectionRange:S.Range.from(G.selectionRange),tags:(te=G.tags)===null||te===void 0?void 0:te.map(S.SymbolTag.from)};return re.set(K._itemId,G),K}_itemFromCache($,G){const te=this._cache.get($);return te==null?void 0:te.get(G)}}class Ye{constructor($,G){this.adapter=$,this.extension=G}}class qe{constructor($,G,te,re,K,oe,me){this._adapter=new Map,this._uriTransformer=G,this._proxy=$.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=re,this._diagnostics=K,this._logService=oe,this._apiDeprecation=me}_transformDocumentSelector($){return i.coalesce(i.asArray($).map(G=>this._doTransformDocumentSelector(G)))}_doTransformDocumentSelector($){if(typeof $=="string")return{$serialized:!0,language:$};if($)return{$serialized:!0,language:$.language,scheme:this._transformScheme($.scheme),pattern:typeof $.pattern=="undefined"?void 0:S.GlobPattern.from($.pattern),exclusive:$.exclusive}}_transformScheme($){return this._uriTransformer&&typeof $=="string"?this._uriTransformer.transformOutgoingScheme($):$}_createDisposable($){return new E.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return qe._handlePool++}_withAdapter($,G,te,re,K=!1){const oe=this._adapter.get($);if(!oe)return Promise.resolve(re);if(oe.adapter instanceof G){let me;oe.extension&&(me=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${G.name}'`));const Ae=te(oe.adapter,oe.extension),$e=oe.extension;return $e&&Promise.resolve(Ae).then(()=>this._logService.trace(`[${$e.identifier.value}] provider DONE after ${Date.now()-me}ms`),pe=>{K&&pe instanceof v.CancellationError||(this._logService.error(`[${$e.identifier.value}] provider FAILED`),this._logService.error(pe))}),Ae}return Promise.reject(new Error("no adapter found"))}_addNewAdapter($,G){const te=this._nextHandle();return this._adapter.set(te,new Ye($,G)),te}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,G,te,re){const K=this._addNewAdapter(new h(this._documents,te),$),oe=re&&re.label||qe._extLabel($);return this._proxy.$registerDocumentSymbolProvider(K,this._transformDocumentSelector(G),oe),this._createDisposable(K)}$provideDocumentSymbols($,G,te){return this._withAdapter($,h,re=>re.provideDocumentSymbols(g.URI.revive(G),te),void 0)}registerCodeLensProvider($,G,te){const re=this._nextHandle(),K=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(re,new Ye(new m(this._documents,this._commands.converter,te),$)),this._proxy.$registerCodeLensSupport(re,this._transformDocumentSelector(G),K);let oe=this._createDisposable(re);if(K!==void 0){const me=te.onDidChangeCodeLenses(Ae=>this._proxy.$emitCodeLensEvent(K));oe=E.Disposable.from(oe,me)}return oe}$provideCodeLenses($,G,te){return this._withAdapter($,m,re=>re.provideCodeLenses(g.URI.revive(G),te),void 0)}$resolveCodeLens($,G,te){return this._withAdapter($,m,re=>re.resolveCodeLens(G,te),void 0)}$releaseCodeLenses($,G){this._withAdapter($,m,te=>Promise.resolve(te.releaseCodeLenses(G)),void 0)}registerDefinitionProvider($,G,te){const re=this._addNewAdapter(new n(this._documents,te),$);return this._proxy.$registerDefinitionSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideDefinition($,G,te,re){return this._withAdapter($,n,K=>K.provideDefinition(g.URI.revive(G),te,re),[])}registerDeclarationProvider($,G,te){const re=this._addNewAdapter(new s(this._documents,te),$);return this._proxy.$registerDeclarationSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideDeclaration($,G,te,re){return this._withAdapter($,s,K=>K.provideDeclaration(g.URI.revive(G),te,re),[])}registerImplementationProvider($,G,te){const re=this._addNewAdapter(new r(this._documents,te),$);return this._proxy.$registerImplementationSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideImplementation($,G,te,re){return this._withAdapter($,r,K=>K.provideImplementation(g.URI.revive(G),te,re),[])}registerTypeDefinitionProvider($,G,te){const re=this._addNewAdapter(new u(this._documents,te),$);return this._proxy.$registerTypeDefinitionSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideTypeDefinition($,G,te,re){return this._withAdapter($,u,K=>K.provideTypeDefinition(g.URI.revive(G),te,re),[])}registerHoverProvider($,G,te,re){const K=this._addNewAdapter(new b(this._documents,te),$);return this._proxy.$registerHoverProvider(K,this._transformDocumentSelector(G)),this._createDisposable(K)}$provideHover($,G,te,re){return this._withAdapter($,b,K=>K.provideHover(g.URI.revive(G),te,re),void 0)}registerEvaluatableExpressionProvider($,G,te,re){const K=this._addNewAdapter(new p(this._documents,te),$);return this._proxy.$registerEvaluatableExpressionProvider(K,this._transformDocumentSelector(G)),this._createDisposable(K)}$provideEvaluatableExpression($,G,te,re){return this._withAdapter($,p,K=>K.provideEvaluatableExpression(g.URI.revive(G),te,re),void 0)}registerInlineValuesProvider($,G,te,re){const K=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new P(this._documents,te),$);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(G),K);let me=this._createDisposable(oe);if(K!==void 0){const Ae=te.onDidChangeInlineValues($e=>this._proxy.$emitInlineValuesEvent(K));me=E.Disposable.from(me,Ae)}return me}$provideInlineValues($,G,te,re,K){return this._withAdapter($,P,oe=>oe.provideInlineValues(g.URI.revive(G),te,re,K),void 0)}registerDocumentHighlightProvider($,G,te){const re=this._addNewAdapter(new A(this._documents,te),$);return this._proxy.$registerDocumentHighlightProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideDocumentHighlights($,G,te,re){return this._withAdapter($,A,K=>K.provideDocumentHighlights(g.URI.revive(G),te,re),void 0)}registerLinkedEditingRangeProvider($,G,te){const re=this._addNewAdapter(new a(this._documents,te),$);return this._proxy.$registerLinkedEditingRangeProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideLinkedEditingRanges($,G,te,re){return this._withAdapter($,a,async K=>{const oe=await K.provideLinkedEditingRanges(g.URI.revive(G),te,re);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?qe._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider($,G,te){const re=this._addNewAdapter(new R(this._documents,te),$);return this._proxy.$registerReferenceSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideReferences($,G,te,re,K){return this._withAdapter($,R,oe=>oe.provideReferences(g.URI.revive(G),te,re,K),void 0)}registerCodeActionProvider($,G,te,re){var K,oe;const me=new f.DisposableStore,Ae=this._addNewAdapter(new M(this._documents,this._commands.converter,this._diagnostics,te,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(Ae,this._transformDocumentSelector(G),{providedKinds:(K=re==null?void 0:re.providedCodeActionKinds)===null||K===void 0?void 0:K.map($e=>$e.value),documentation:(oe=re==null?void 0:re.documentation)===null||oe===void 0?void 0:oe.map($e=>({kind:$e.kind.value,command:this._commands.converter.toInternal($e.command,me)}))},qe._extLabel($),Boolean(te.resolveCodeAction)),me.add(this._createDisposable(Ae)),me}$provideCodeActions($,G,te,re,K){return this._withAdapter($,M,oe=>oe.provideCodeActions(g.URI.revive(G),te,re,K),void 0)}$resolveCodeAction($,G,te){return this._withAdapter($,M,re=>re.resolveCodeAction(G,te),void 0)}$releaseCodeActions($,G){this._withAdapter($,M,te=>Promise.resolve(te.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider($,G,te){const re=this._addNewAdapter(new H(this._documents,te),$);return this._proxy.$registerDocumentFormattingSupport(re,this._transformDocumentSelector(G),$.identifier,$.displayName||$.name),this._createDisposable(re)}$provideDocumentFormattingEdits($,G,te,re){return this._withAdapter($,H,K=>K.provideDocumentFormattingEdits(g.URI.revive(G),te,re),void 0)}registerDocumentRangeFormattingEditProvider($,G,te){const re=this._addNewAdapter(new ue(this._documents,te),$);return this._proxy.$registerRangeFormattingSupport(re,this._transformDocumentSelector(G),$.identifier,$.displayName||$.name),this._createDisposable(re)}$provideDocumentRangeFormattingEdits($,G,te,re,K){return this._withAdapter($,ue,oe=>oe.provideDocumentRangeFormattingEdits(g.URI.revive(G),te,re,K),void 0)}registerOnTypeFormattingEditProvider($,G,te,re){const K=this._addNewAdapter(new fe(this._documents,te),$);return this._proxy.$registerOnTypeFormattingSupport(K,this._transformDocumentSelector(G),re,$.identifier),this._createDisposable(K)}$provideOnTypeFormattingEdits($,G,te,re,K,oe){return this._withAdapter($,fe,me=>me.provideOnTypeFormattingEdits(g.URI.revive(G),te,re,K,oe),void 0)}registerWorkspaceSymbolProvider($,G){const te=this._addNewAdapter(new Y(G,this._logService),$);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols($,G,te){return this._withAdapter($,Y,re=>re.provideWorkspaceSymbols(G,te),{symbols:[]})}$resolveWorkspaceSymbol($,G,te){return this._withAdapter($,Y,re=>re.resolveWorkspaceSymbol(G,te),void 0)}$releaseWorkspaceSymbols($,G){this._withAdapter($,Y,te=>te.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider($,G,te){const re=this._addNewAdapter(new j(this._documents,te,this._logService),$);return this._proxy.$registerRenameSupport(re,this._transformDocumentSelector(G),j.supportsResolving(te)),this._createDisposable(re)}$provideRenameEdits($,G,te,re,K){return this._withAdapter($,j,oe=>oe.provideRenameEdits(g.URI.revive(G),te,re,K),void 0)}$resolveRenameLocation($,G,te,re){return this._withAdapter($,j,K=>K.resolveRenameLocation(g.URI.revive(G),te,re),void 0)}registerDocumentSemanticTokensProvider($,G,te,re){const K=this._nextHandle(),oe=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(K,new Ye(new L(this._documents,te),$)),this._proxy.$registerDocumentSemanticTokensProvider(K,this._transformDocumentSelector(G),re,oe);let me=this._createDisposable(K);if(oe){const Ae=te.onDidChangeSemanticTokens($e=>this._proxy.$emitDocumentSemanticTokensEvent(oe));me=E.Disposable.from(me,Ae)}return me}$provideDocumentSemanticTokens($,G,te,re){return this._withAdapter($,L,K=>K.provideDocumentSemanticTokens(g.URI.revive(G),te,re),null,!0)}$releaseDocumentSemanticTokens($,G){this._withAdapter($,L,te=>te.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider($,G,te,re){const K=this._addNewAdapter(new q(this._documents,te),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(K,this._transformDocumentSelector(G),re),this._createDisposable(K)}$provideDocumentRangeSemanticTokens($,G,te,re){return this._withAdapter($,q,K=>K.provideDocumentRangeSemanticTokens(g.URI.revive(G),te,re),null,!0)}registerCompletionItemProvider($,G,te,re){const K=this._addNewAdapter(new N(this._documents,this._commands.converter,te,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(K,this._transformDocumentSelector(G),re,N.supportsResolving(te),`${$.identifier.value}(${re.join("")})`),this._createDisposable(K)}$provideCompletionItems($,G,te,re,K){return this._withAdapter($,N,oe=>oe.provideCompletionItems(g.URI.revive(G),te,re,K),void 0)}$resolveCompletionItem($,G,te){return this._withAdapter($,N,re=>re.resolveCompletionItem(G,te),void 0)}$releaseCompletionItems($,G){this._withAdapter($,N,te=>te.releaseCompletionItems(G),void 0)}registerInlineCompletionsProvider($,G,te){const re=this._addNewAdapter(new W(this._documents,te,this._commands.converter),$);return this._proxy.$registerInlineCompletionsSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideInlineCompletions($,G,te,re,K){return this._withAdapter($,W,oe=>oe.provideInlineCompletions(g.URI.revive(G),te,re,K),void 0)}$handleInlineCompletionDidShow($,G,te){this._withAdapter($,W,async re=>{re.handleDidShowCompletionItem(G,te)},void 0)}$freeInlineCompletionsList($,G){this._withAdapter($,W,async te=>{te.disposeCompletions(G)},void 0)}registerSignatureHelpProvider($,G,te,re){const K=Array.isArray(re)?{triggerCharacters:re,retriggerCharacters:[]}:re,oe=this._addNewAdapter(new B(this._documents,te),$);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(G),K),this._createDisposable(oe)}$provideSignatureHelp($,G,te,re,K){return this._withAdapter($,B,oe=>oe.provideSignatureHelp(g.URI.revive(G),te,re,K),void 0)}$releaseSignatureHelp($,G){this._withAdapter($,B,te=>te.releaseSignatureHelp(G),void 0)}registerInlayHintsProvider($,G,te){const re=typeof te.onDidChangeInlayHints=="function"?this._nextHandle():void 0,K=this._addNewAdapter(new J(this._documents,te),$);this._proxy.$registerInlayHintsProvider(K,this._transformDocumentSelector(G),re);let oe=this._createDisposable(K);if(re!==void 0){const me=te.onDidChangeInlayHints(Ae=>this._proxy.$emitInlayHintsEvent(re));oe=E.Disposable.from(oe,me)}return oe}$provideInlayHints($,G,te,re){return this._withAdapter($,J,K=>K.provideInlayHints(g.URI.revive(G),te,re),void 0)}registerDocumentLinkProvider($,G,te){const re=this._addNewAdapter(new he(this._documents,te),$);return this._proxy.$registerDocumentLinkProvider(re,this._transformDocumentSelector(G),typeof te.resolveDocumentLink=="function"),this._createDisposable(re)}$provideDocumentLinks($,G,te){return this._withAdapter($,he,re=>re.provideLinks(g.URI.revive(G),te),void 0)}$resolveDocumentLink($,G,te){return this._withAdapter($,he,re=>re.resolveLink(G,te),void 0)}$releaseDocumentLinks($,G){this._withAdapter($,he,te=>te.releaseLinks(G),void 0)}registerColorProvider($,G,te){const re=this._addNewAdapter(new De(this._documents,te),$);return this._proxy.$registerDocumentColorProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideDocumentColors($,G,te){return this._withAdapter($,De,re=>re.provideColors(g.URI.revive(G),te),[])}$provideColorPresentations($,G,te,re){return this._withAdapter($,De,K=>K.provideColorPresentations(g.URI.revive(G),te,re),void 0)}registerFoldingRangeProvider($,G,te){const re=this._nextHandle(),K=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(re,new Ye(new Oe(this._documents,te),$)),this._proxy.$registerFoldingRangeProvider(re,this._transformDocumentSelector(G),K);let oe=this._createDisposable(re);if(K!==void 0){const me=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(K));oe=E.Disposable.from(oe,me)}return oe}$provideFoldingRanges($,G,te,re){return this._withAdapter($,Oe,K=>K.provideFoldingRanges(g.URI.revive(G),te,re),void 0)}registerSelectionRangeProvider($,G,te){const re=this._addNewAdapter(new Me(this._documents,te,this._logService),$);return this._proxy.$registerSelectionRangeProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideSelectionRanges($,G,te,re){return this._withAdapter($,Me,K=>K.provideSelectionRanges(g.URI.revive(G),te,re),[])}registerCallHierarchyProvider($,G,te){const re=this._addNewAdapter(new He(this._documents,te),$);return this._proxy.$registerCallHierarchyProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$prepareCallHierarchy($,G,te,re){return this._withAdapter($,He,K=>Promise.resolve(K.prepareSession(g.URI.revive(G),te,re)),void 0)}$provideCallHierarchyIncomingCalls($,G,te,re){return this._withAdapter($,He,K=>K.provideCallsTo(G,te,re),void 0)}$provideCallHierarchyOutgoingCalls($,G,te,re){return this._withAdapter($,He,K=>K.provideCallsFrom(G,te,re),void 0)}$releaseCallHierarchy($,G){this._withAdapter($,He,te=>Promise.resolve(te.releaseSession(G)),void 0)}static _serializeRegExp($){return{pattern:$.source,flags:_.regExpFlags($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:qe._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:qe._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?qe._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?qe._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:qe._serializeRegExp($.beforeText),afterText:$.afterText?qe._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?qe._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(qe._serializeOnEnterRule)}setLanguageConfiguration($,G,te){let{wordPattern:re}=te;if(re&&_.regExpLeadsToEndlessLoop(re))throw new Error(`Invalid language configuration: wordPattern '${re}' is not allowed to match the empty string.`);re?this._documents.setWordDefinitionFor(G,re):this._documents.setWordDefinitionFor(G,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const K=this._nextHandle(),oe={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?qe._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?qe._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?qe._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(K,G,oe),this._createDisposable(K)}$setWordDefinitions($){for(const G of $)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=qe,qe._handlePool=0}),define(we[190],_e([0,1,5,9,6]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(D,_){this._proxy=D.getProxy(g.MainContext.MainThreadLanguages),this._documents=_}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(D,_){await this._proxy.$changeLanguage(D,_);const C=this._documents.getDocumentData(D);if(!C)throw new Error(`document '${D.toString}' NOT found`);return C.document}async tokenAtPosition(D,_){var C;const i=D.version,I=T.Position.from(_),o=await this._proxy.$tokensAtPosition(D.uri,I),f={type:S.StandardTokenType.Other,range:(C=D.getWordRangeAtPosition(_))!==null&&C!==void 0?C:new S.Range(_.line,_.character,_.line,_.character)};if(!o)return f;const c={range:T.Range.to(o.range),type:T.TokenType.to(o.type)};return!c.range.contains(_)||i!==D.version?f:c}}e.ExtHostLanguages=E}),define(we[191],_e([0,1,5,15,29]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function E(D){return D&&D.title}let k=class{constructor(_,C){this._logService=C,this._proxy=_.getProxy(g.MainContext.MainThreadMessageService)}showMessage(_,C,i,I,o){const f={extension:_};let c;typeof I=="string"||E(I)?c=[I,...o]:(f.modal=I==null?void 0:I.modal,f.useCustom=I==null?void 0:I.useCustom,f.detail=I==null?void 0:I.detail,c=o),f.useCustom&&S.checkProposedApiEnabled(_);const d=[];for(let y=0;y<c.length;y++){const w=c[y];if(typeof w=="string")d.push({title:w,handle:y,isCloseAffordance:!1});else if(typeof w=="object"){let{title:v,isCloseAffordance:l}=w;d.push({title:v,isCloseAffordance:!!l,handle:y})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(C,i,f,d).then(y=>{if(typeof y=="number")return c[y]})}};k=Ve([ze(1,T.ILogService)],k),e.ExtHostMessageService=k}),define(we[192],_e([0,1,23,3,53,7,22,8,10,2,62,5,9,6,169,97]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class y{constructor(v,l,h,m,t){this._textDocumentsAndEditors=h,this._textDocuments=m,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new T.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new T.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new T.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new T.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new i.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=v.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=v.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=v.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=l.converter,l.registerArgumentProcessor({processArgument:n=>{var s;if(n&&n.$mid===12){const r=(s=n.notebookEditor)===null||s===void 0?void 0:s.notebookUri,u=n.cell.handle,b=this._documents.get(r),p=b==null?void 0:b.getCell(u);if(p)return p.apiCell}return n}})}get activeNotebookEditor(){var v;return(v=this._activeNotebookEditor)===null||v===void 0?void 0:v.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(v=>v.apiEditor)}getEditorById(v){const l=this._editors.get(v);if(!l)throw new Error(`unknown text editor: ${v}. known editors: ${[...this._editors.keys()]} `);return l}getIdByEditor(v){for(const[l,h]of this._editors)if(h.apiEditor===v)return l}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(v,l){const h=this._documents.get(v);if(!h&&!l)throw new Error(`NO notebook document for '${v}'`);return h}_getProviderData(v){const l=this._notebookContentProviders.get(v);if(!l)throw new Error(`NO provider for '${v}'`);return l}registerNotebookContentProvider(v,l,h,m,t){if(D.isFalsyOrWhitespace(l))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(l))throw new Error(`Notebook provider for '${l}' already registered`);this._notebookContentProviders.set(l,{extension:v,provider:h});let n;return h.onDidChangeNotebookContentOptions&&(n=h.onDidChangeNotebookContentOptions(()=>{const s=o.NotebookDocumentContentOptions.from(h.options);this._notebookProxy.$updateNotebookProviderOptions(l,s)})),this._notebookProxy.$registerNotebookProvider({id:v.identifier,location:v.extensionLocation},l,o.NotebookDocumentContentOptions.from(m),y._convertNotebookRegistrationData(v,t)),new f.Disposable(()=>{n==null||n.dispose(),this._notebookContentProviders.delete(l),this._notebookProxy.$unregisterNotebookProvider(l)})}static _convertNotebookRegistrationData(v,l){if(!l)return;const h=l.filenamePattern.map(m=>o.NotebookExclusiveDocumentPattern.from(m)).filter(m=>m!==void 0);if(l.filenamePattern&&!h){console.warn(`Notebook content provider view options file name pattern is invalid ${l.filenamePattern}`);return}return{extension:v.identifier,providerDisplayName:v.displayName||v.name,displayName:l.displayName,filenamePattern:h,exclusive:l.exclusive||!1}}registerNotebookCellStatusBarItemProvider(v,l,h){const m=y._notebookStatusBarItemProviderHandlePool++,t=typeof h.onDidChangeCellStatusBarItems=="function"?y._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(m,h),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(m,t,l);let n;return t!==void 0&&(n=h.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(t))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(m),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(m,t),n&&n.dispose()})}async createNotebookDocument(v){const l=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:v.viewType,content:v.content&&o.NotebookData.from(v.content)});return C.URI.revive(l)}async openNotebookDocument(v){const l=this._documents.get(v);if(l)return l.apiNotebook;const h=await this._notebookDocumentsProxy.$tryOpenNotebook(v),m=this._documents.get(C.URI.revive(h));return _.assertIsDefined(m==null?void 0:m.apiNotebook)}async showNotebookDocument(v,l){var h;C.URI.isUri(v)&&(v=await this.openNotebookDocument(v));let m;typeof l=="object"?m={position:o.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selections:l.selections&&l.selections.map(o.NotebookRange.from),pinned:typeof l.preview=="boolean"?!l.preview:void 0}:m={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(v.uri,v.notebookType,m),n=t&&((h=this._editors.get(t))===null||h===void 0?void 0:h.apiEditor);if(n)return n;throw t?new Error(`Could NOT open editor for "${v.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${v.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(v,l,h,m){const t=this._notebookStatusBarItemProviders.get(v),n=C.URI.revive(l),s=this._documents.get(n);if(!s||!t)return;const r=s.getCellFromIndex(h);if(!r)return;const u=await t.provideCellStatusBarItems(r.apiCell,m);if(!u)return;const b=new E.DisposableStore,p=this._statusBarCache.add([b]),A=(Array.isArray(u)?u:[u]).map(a=>o.NotebookStatusBarItem.from(a,this._commandsConverter,b));return{cacheId:p,items:A}}$releaseNotebookCellStatusBarItems(v){this._statusBarCache.delete(v)}registerNotebookSerializer(v,l,h,m,t){if(D.isFalsyOrWhitespace(l))throw new Error("viewType cannot be empty or just whitespace");const n=this._handlePool++;return this._notebookSerializer.set(n,h),this._notebookProxy.$registerNotebookSerializer(n,{id:v.identifier,location:v.extensionLocation},l,o.NotebookDocumentContentOptions.from(m),y._convertNotebookRegistrationData(v,t)),E.toDisposable(()=>{this._notebookProxy.$unregisterNotebookSerializer(n)})}async $dataToNotebook(v,l,h){const m=this._notebookSerializer.get(v);if(!m)throw new Error("NO serializer found");const t=await m.deserializeNotebook(l.buffer,h);return o.NotebookData.from(t)}async $notebookToData(v,l,h){const m=this._notebookSerializer.get(v);if(!m)throw new Error("NO serializer found");const t=await m.serializeNotebook(o.NotebookData.to(l),h);return g.VSBuffer.wrap(t)}async $openNotebook(v,l,h,m,t){var n;const{provider:s}=this._getProviderData(v),r=await s.openNotebook(C.URI.revive(l),{backupId:h,untitledDocumentData:m==null?void 0:m.buffer},t);return{metadata:(n=r.metadata)!==null&&n!==void 0?n:Object.create(null),cells:r.cells.map(o.NotebookCellData.from)}}async $saveNotebook(v,l,h){const m=this.getNotebookDocument(C.URI.revive(l)),{provider:t}=this._getProviderData(v);return await t.saveNotebook(m.apiNotebook,h),!0}async $saveNotebookAs(v,l,h,m){const t=this.getNotebookDocument(C.URI.revive(l)),{provider:n}=this._getProviderData(v);return await n.saveNotebookAs(C.URI.revive(h),t.apiNotebook,m),!0}async $backupNotebook(v,l,h){var m;const t=this.getNotebookDocument(C.URI.revive(l)),n=this._getProviderData(v),s=(m=this._extensionStoragePaths.workspaceValue(n.extension))!==null&&m!==void 0?m:this._extensionStoragePaths.globalValue(n.extension),r=String(S.hash([t.uri.toString(),this._backupIdPool++])),u=C.URI.joinPath(s,r),b=await n.provider.backupNotebook(t.apiNotebook,{destination:u},h);return t.updateBackup(b),b.id}_createExtHostEditor(v,l,h){if(this._editors.has(l))throw new Error(`editor with id ALREADY EXSIST: ${l}`);const m=new d.ExtHostNotebookEditor(l,this._notebookEditorsProxy,v,h.visibleRanges.map(o.NotebookRange.to),h.selections.map(o.NotebookRange.to),typeof h.viewColumn=="number"?o.ViewColumn.to(h.viewColumn):void 0);this._editors.set(l,m)}$acceptDocumentAndEditorsDelta(v){var l,h,m;if(v.removedDocuments)for(const n of v.removedDocuments){const s=C.URI.revive(n),r=this._documents.get(s);r&&(r.dispose(),this._documents.delete(s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(u=>u.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const u of this._editors.values())u.notebookData.uri.toString()===s.toString()&&this._editors.delete(u.id)}if(v.addedDocuments){const n=[];for(const s of v.addedDocuments){const r=C.URI.revive(s.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const u=this,b=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(p){u._onDidChangeNotebookCells.fire(p)},emitCellOutputsChange(p){u._onDidChangeCellOutputs.fire(p)},emitCellMetadataChange(p){u._onDidChangeCellMetadata.fire(p)},emitCellExecutionStateChange(p){u._onDidChangeCellExecutionState.fire(p)}},r,s);n.push(...s.cells.map(p=>c.ExtHostCell.asModelAddData(b.apiNotebook,p))),(l=this._documents.get(r))===null||l===void 0||l.dispose(),this._documents.set(r,b),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:n}),this._onDidOpenNotebookDocument.fire(b.apiNotebook)}}if(v.addedEditors)for(const n of v.addedEditors){if(this._editors.has(n.id))return;const s=C.URI.revive(n.documentUri),r=this._documents.get(s);r&&this._createExtHostEditor(r,n.id,n)}const t=[];if(v.removedEditors)for(const n of v.removedEditors){const s=this._editors.get(n);s&&(this._editors.delete(n),((h=this._activeNotebookEditor)===null||h===void 0?void 0:h.id)===s.id&&(this._activeNotebookEditor=void 0),t.push(s))}if(v.visibleEditors){this._visibleNotebookEditors=v.visibleEditors.map(s=>this._editors.get(s)).filter(s=>!!s);const n=new Set;this._visibleNotebookEditors.forEach(s=>n.add(s.id));for(const s of this._editors.values()){const r=n.has(s.id);s._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(s=>s).filter(s=>s.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}v.newActiveEditor===null?this._activeNotebookEditor=void 0:v.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(v.newActiveEditor)),v.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((m=this._activeNotebookEditor)===null||m===void 0?void 0:m.apiEditor)}}e.ExtHostNotebookController=y,y._notebookStatusBarItemProviderHandlePool=0}),define(we[193],_e([0,1,3,50,15,5,13,9]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(I,o){const f=_._Keys.nextId();I.$registerNotebookEditorDecorationType(f,D.NotebookDecorationRenderOptions.from(o)),this.value={key:f,dispose(){I.$removeNotebookEditorDecorationType(f)}}}}_._Keys=new T.IdGenerator("NotebookEditorDecorationType");let C=class{constructor(I,o,f){this._logService=I,this._extHostRpc=o,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new _(this._extHostRpc.getProxy(E.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,o){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,o);const f=this._notebooksAndEditors.getEditorById(I);o.visibleRanges&&f._acceptVisibleRanges(o.visibleRanges.ranges.map(D.NotebookRange.to)),o.selections&&f._acceptSelections(o.selections.selections.map(D.NotebookRange.to)),o.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),o.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const o in I)this._notebooksAndEditors.getEditorById(o)._acceptViewColumn(D.ViewColumn.to(I[o]))}};C=Ve([ze(0,S.ILogService),ze(1,k.IExtHostRpcService)],C),e.ExtHostNotebookEditors=C}),define(we[194],_e([0,1,3,7,5,26,2,9,67,22,12,68,18,17,15,6,29]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o,f,c,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(t,n,s,r){this._initData=n,this._extHostNotebook=s,this._logService=r,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(S.MainContext.MainThreadNotebookKernels)}createNotebookController(t,n,s,r,u,b){for(let N of this._kernelData.values())if(N.controller.id===n&&E.ExtensionIdentifier.equals(t.identifier,N.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const p=this._handlePool++,P=this;this._logService.trace(`NotebookController[${p}], CREATED by ${t.identifier.value}, ${n}`);const A=()=>console.warn(`NO execute handler from notebook controller '${ue.id}' of extension: '${t.identifier}'`);let a=!1;const R=new T.DisposableStore,M=new g.Emitter,H=new g.Emitter,ue={id:`${t.identifier.value}/${n}`,notebookType:s,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:r||t.identifier.value,preloads:b?b.map(D.NotebookRendererScript.from):[]};let fe=u??A,Y;this._proxy.$addKernel(p,ue).catch(N=>{console.log(N),a=!0});let j=0;const Z=()=>{if(a)return;const N=++j;Promise.resolve().then(()=>{N===j&&this._proxy.$updateKernel(p,ue)})},L=new C.ResourceMap,q={get id(){return n},get notebookType(){return ue.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return ue.label},set label(N){var W;ue.label=(W=N??t.displayName)!==null&&W!==void 0?W:t.name,Z()},get detail(){var N;return(N=ue.detail)!==null&&N!==void 0?N:""},set detail(N){ue.detail=N,Z()},get description(){var N;return(N=ue.description)!==null&&N!==void 0?N:""},set description(N){ue.description=N,Z()},get supportedLanguages(){return ue.supportedLanguages},set supportedLanguages(N){ue.supportedLanguages=N,Z()},get supportsExecutionOrder(){var N;return(N=ue.supportsExecutionOrder)!==null&&N!==void 0?N:!1},set supportsExecutionOrder(N){ue.supportsExecutionOrder=N,Z()},get rendererScripts(){return ue.preloads?ue.preloads.map(D.NotebookRendererScript.to):[]},get executeHandler(){return fe},set executeHandler(N){fe=N??A},get interruptHandler(){return Y},set interruptHandler(N){Y=N,ue.supportsInterrupt=Boolean(N),Z()},createNotebookCellExecution(N){if(a)throw new Error("notebook controller is DISPOSED");if(!L.has(N.notebook.uri))throw P._logService.trace(`NotebookController[${p}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(L.keys()).map(W=>W.toString())),new Error(`notebook controller is NOT associated to notebook: ${N.notebook.uri.toString()}`);return P._createNotebookCellExecution(N)},dispose:()=>{a||(this._logService.trace(`NotebookController[${p}], DISPOSED`),a=!0,this._kernelData.delete(p),R.dispose(),M.dispose(),H.dispose(),this._proxy.$removeKernel(p))},updateNotebookAffinity(N,W){P._proxy.$updateNotebookPriority(p,N.uri,W)},onDidReceiveMessage:H.event,postMessage(N,W){return y.checkProposedApiEnabled(t),P._proxy.$postMessage(p,W&&P._extHostNotebook.getIdByEditor(W),N)},asWebviewUri(N){return y.checkProposedApiEnabled(t),_.asWebviewUri(N,P._initData.remote)}};return this._kernelData.set(p,{extensionId:t.identifier,controller:q,onDidReceiveMessage:H,onDidChangeSelection:M,associatedNotebooks:L}),q}$acceptNotebookAssociation(t,n,s){const r=this._kernelData.get(t);if(r){const u=this._extHostNotebook.getNotebookDocument(k.URI.revive(n));s?r.associatedNotebooks.set(u.uri,!0):r.associatedNotebooks.delete(u.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,u.uri.toString(),s),r.onDidChangeSelection.fire({selected:s,notebook:u.apiNotebook})}}async $executeCells(t,n,s){const r=this._kernelData.get(t);if(!r)return;const u=this._extHostNotebook.getNotebookDocument(k.URI.revive(n)),b=[];for(let p of s){const P=u.getCell(p);P&&b.push(P.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,u.uri.toString(),b.length),await r.controller.executeHandler.call(r.controller,b,u.apiNotebook,r.controller)}catch(p){this._logService.error(`NotebookController[${t}] execute cells FAILED`,p),console.error(p)}}async $cancelCells(t,n,s){var r;const u=this._kernelData.get(t);if(!u)return;const b=this._extHostNotebook.getNotebookDocument(k.URI.revive(n));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,b.apiNotebook);else for(let p of s){const P=b.getCell(p);P&&((r=this._activeExecutions.get(P.uri))===null||r===void 0||r.cancel())}}$acceptKernelMessageFromRenderer(t,n,s){const r=this._kernelData.get(t);if(!r)return;const u=this._extHostNotebook.getEditorById(n);r.onDidReceiveMessage.fire(Object.freeze({editor:u.apiEditor,message:s}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const r=new l(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,r);const u=r.onDidChangeState(()=>{r.state===v.Resolved&&(r.dispose(),u.dispose(),this._activeExecutions.delete(s.uri))});return r.asApiObject()}};w=Ve([ze(3,c.ILogService)],w),e.ExtHostNotebookKernels=w;var v;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(v||(v={}));class l extends T.Disposable{constructor(t,n,s){super();this._document=t,this._cell=n,this._proxy=s,this._onDidChangeState=new g.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=v.Init,this._tokenSource=this._register(new o.CancellationTokenSource),this._collector=new h(10,r=>this.applyEdits(r)),this._executionOrder=n.internalMetadata.executionOrder,this.mixinMetadata({runState:I.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===v.Init)throw new Error("Must call start before modifying cell output");if(this._state===v.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let n=this._cell;if(t&&(n=this._document.getCellFromApiCell(t)),!n)throw new Error("INVALID cell");return n.handle}validateAndConvertOutputs(t){return t.map(n=>{const s=d.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return s===n.items?D.NotebookCellOutput.from(n):D.NotebookCellOutput.from({items:s,id:n.id,metadata:n.metadata})})}async updateOutputs(t,n,s){const r=this.cellIndexToHandle(n),u=this.validateAndConvertOutputs(f.asArray(t));return this.applyEditSoon({editType:2,handle:r,append:s,outputs:u})}async updateOutputItems(t,n,s){return t=d.NotebookCellOutput.ensureUniqueMimeTypes(f.asArray(t),!0),this.applyEditSoon({editType:7,items:t.map(D.NotebookCellOutputItem.from),outputId:n.id,append:s})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(s){t._executionOrder=s,t.mixinMetadata({executionOrder:s})},start(s){if(t._state===v.Resolved||t._state===v.Started)throw new Error("Cannot call start again");t._state=v.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:I.NotebookCellExecutionState.Executing,runStartTime:s??null})},end(s,r){if(t._state===v.Resolved)throw new Error("Cannot call resolve twice");t._state=v.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:s??null,runEndTime:r??null})},clearOutput(s){return t.verifyStateForOutput(),t.updateOutputs([],s,!1)},appendOutput(s,r){return t.verifyStateForOutput(),t.updateOutputs(s,r,!0)},replaceOutput(s,r){return t.verifyStateForOutput(),t.updateOutputs(s,r,!1)},appendOutputItems(s,r){return t.verifyStateForOutput(),t.updateOutputItems(s,r,!0)},replaceOutputItems(s,r){return t.verifyStateForOutput(),t.updateOutputItems(s,r,!1)}})}}class h{constructor(t,n){this.delay=t,this.callback=n,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=i.timeout(this.delay).then(()=>{this.waitPromise=void 0;const n=this.batch;return this.batch=[],this.callback(n)})),this.waitPromise}}}),define(we[195],_e([0,1,3,5,97]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class E{constructor(D,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,_,C){var i;const I=this._extHostNotebook.getEditorById(D);(i=this._rendererMessageEmitters.get(_))===null||i===void 0||i.fire({editor:I.apiEditor,message:C})}createRendererMessaging(D){return{onDidReceiveMessage:(...C)=>this.getOrCreateEmitterFor(D).event(...C),postMessage:(C,i)=>{const I=S.ExtHostNotebookEditor.apiEditorsToExtHost.get(C);if(!I)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(I.id,D,i)}}}getOrCreateEmitterFor(D){let _=this._rendererMessageEmitters.get(D);return _||(_=new g.Emitter({onLastListenerRemove:()=>{_==null||_.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,_),_)}}e.ExtHostNotebookRenderers=E}),define(we[101],_e([0,1,5,3,7,23,4,13]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class _ extends S.Disposable{constructor(c,d,y,w){super();this._onDidAppend=this._register(new T.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=c,this._proxy=w,this._id=w.$register(this.name,d,y),this._disposed=!1,this._offset=0}get name(){return this._name}append(c){this.validate(),this._offset+=c?E.VSBuffer.fromString(c).byteLength:0}update(){this._id.then(c=>this._proxy.$update(c))}appendLine(c){this.validate(),this.append(c+`
`)}clear(){this.validate();const c=this._offset;this._id.then(d=>this._proxy.$clear(d,c))}show(c,d){this.validate(),this._id.then(y=>this._proxy.$reveal(y,!!(typeof c=="boolean"?c:d)))}hide(){this.validate(),this._id.then(c=>this._proxy.$close(c))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(c=>this._proxy.$dispose(c)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=_;class C extends _{constructor(c,d){super(c,!1,void 0,d)}append(c){super.append(c),this._id.then(d=>this._proxy.$append(d,c)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=C;class i extends _{constructor(c,d,y){super(c,!0,d,y)}append(c){throw new Error("Not supported")}}class I{constructor(c,d){this.name=c,this._channel=d}append(c){this._channel.then(d=>d.append(c))}appendLine(c){this._channel.then(d=>d.appendLine(c))}clear(){this._channel.then(c=>c.clear())}show(c,d){this._channel.then(y=>y.show(c,d))}hide(){this._channel.then(c=>c.hide())}dispose(){this._channel.then(c=>c.dispose())}}e.LazyOutputChannel=I;let o=class{constructor(c){this._proxy=c.getProxy(g.MainContext.MainThreadOutputService)}$setVisibleChannel(c){}createOutputChannel(c){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");return new C(c,this._proxy)}createOutputChannelFromLogFile(c,d){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if(!d)throw new Error("illegal argument `file`. must not be falsy");return new i(c,d,this._proxy)}};o=Ve([ze(0,D.IExtHostRpcService)],o),e.ExtHostOutputService=o,e.IExtHostOutputService=k.createDecorator("IExtHostOutputService")}),define(we[196],_e([0,1,12,18,3,7,5,2,6,11,17,42]),function(ee,e,g,T,S,E,k,D,_,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function o(f,c,d){const y=f.getProxy(k.MainContext.MainThreadQuickOpen);class w{constructor(r,u){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=u}showQuickPick(r,u,b,p=T.CancellationToken.None){this._onDidSelectItem=void 0;const P=Promise.resolve(r),A=++this._instances,a=y.$show(A,{title:b==null?void 0:b.title,placeHolder:b==null?void 0:b.placeHolder,matchOnDescription:b==null?void 0:b.matchOnDescription,matchOnDetail:b==null?void 0:b.matchOnDetail,ignoreFocusLost:b==null?void 0:b.ignoreFocusOut,canPickMany:b==null?void 0:b.canPickMany},p),R={},M=a.then(()=>R);return Promise.race([M,P]).then(H=>{if(H!==R)return P.then(ue=>{const fe=[];for(let Y=0;Y<ue.length;Y++){const j=ue[Y];let Z,L,q,N,W;typeof j=="string"?Z=j:(Z=j.label,L=j.description,q=j.detail,N=j.picked,W=j.alwaysShow),fe.push({label:Z,description:L,handle:Y,detail:q,picked:N,alwaysShow:W})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=Y=>{b.onDidSelectItem(ue[Y])}),y.$setItems(A,fe),a.then(Y=>{if(typeof Y=="number")return ue[Y];if(Array.isArray(Y))return Y.map(j=>ue[j])})})}).then(void 0,H=>{if(!C.isPromiseCanceledError(H))return y.$setError(A,H),Promise.reject(H)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,u=T.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,y.$input(r,typeof this._validateInput=="function",u).then(void 0,b=>{if(!C.isPromiseCanceledError(b))return Promise.reject(b)})}$validateInput(r){return this._validateInput?g.asPromise(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,u=T.CancellationToken.None){const b=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!b)return;const p=await this._workspace.getWorkspaceFolders2();if(!!p)return p.find(P=>P.uri.toString()===b.uri.toString())}createQuickPick(r,u){const b=new t(r,u,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(r){const u=new n(r,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}$onDidChangeValue(r,u){const b=this._sessions.get(r);b&&b._fireDidChangeValue(u)}$onDidAccept(r){const u=this._sessions.get(r);u&&u._fireDidAccept()}$onDidChangeActive(r,u){const b=this._sessions.get(r);b instanceof t&&b._fireDidChangeActive(u)}$onDidChangeSelection(r,u){const b=this._sessions.get(r);b instanceof t&&b._fireDidChangeSelection(u)}$onDidTriggerButton(r,u){const b=this._sessions.get(r);b&&b._fireDidTriggerButton(u)}$onDidHide(r){const u=this._sessions.get(r);u&&u._fireDidHide()}}class v{constructor(r,u){this._extensionId=r,this._onDidDispose=u,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new S.Emitter,this._onDidChangeValueEmitter=new S.Emitter,this._onDidTriggerButtonEmitter=new S.Emitter,this._onDidHideEmitter=new S.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((u,b)=>{const p=u===_.QuickInputButtons.Back?-1:b;this._handlesToButtons.set(p,u)}),this.update({buttons:r.map((u,b)=>({iconPath:l(u.iconPath),tooltip:u.tooltip,handle:u===_.QuickInputButtons.Back?-1:b}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const u=this._handlesToButtons.get(r);u&&this._onDidTriggerButtonEmitter.fire(u)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=E.dispose(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),y.$dispose(this._id))}update(r){if(!this._disposed){for(const u of Object.keys(r)){const b=r[u];this._pendingUpdate[u]=b===void 0?null:b}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){y.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function l(s){if(s instanceof _.ThemeIcon)return{id:s.id};const r=m(s),u=h(s);return{dark:typeof r=="string"?D.URI.file(r):r,light:typeof u=="string"?D.URI.file(u):u}}function h(s){return typeof s=="object"&&"light"in s?s.light:s}function m(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends v{constructor(r,u,b){super(r,b);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new S.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new S.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((u,b)=>{this._handlesToItems.set(b,u),this._itemsToHandles.set(u,b)}),this.update({items:r.map((u,b)=>({label:u.label,description:u.description,handle:b,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(u=>this._itemsToHandles.has(u)),this.update({activeItems:this._activeItems.map(u=>this._itemsToHandles.get(u))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(u=>this._itemsToHandles.has(u)),this.update({selectedItems:this._selectedItems.map(u=>this._itemsToHandles.get(u))})}_fireDidChangeActive(r){const u=i.coalesce(r.map(b=>this._handlesToItems.get(b)));this._activeItems=u,this._onDidChangeActiveEmitter.fire(u)}_fireDidChangeSelection(r){const u=i.coalesce(r.map(b=>this._handlesToItems.get(b)));this._selectedItems=u,this._onDidChangeSelectionEmitter.fire(u)}}class n extends v{constructor(r,u){super(r,u);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?I.default.Error:I.default.Ignore})}}return new w(c,d)}e.createExtHostQuickOpen=o}),define(we[197],_e([0,1,2,3,48,7,12,5,17,112,15,26,29]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(r){if(r)return typeof r.iconPath=="string"?g.URI.file(r.iconPath):r.iconPath}function c(r,u){if(!r.iconPath&&!u.iconPath)return 0;if(r.iconPath){if(!u.iconPath)return 1}else return-1;const b=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,p=typeof u.iconPath=="string"?u.iconPath:u.iconPath.fsPath;return C.comparePaths(b,p)}function d(r,u){let b=0;if(r.strikeThrough!==u.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==u.faded)return r.faded?1:-1;if(r.tooltip!==u.tooltip)return(r.tooltip||"").localeCompare(u.tooltip||"");if(b=c(r,u),b!==0)return b;if(r.light&&u.light)b=c(r.light,u.light);else{if(r.light)return 1;if(u.light)return-1}if(b!==0)return b;if(r.dark&&u.dark)b=c(r.dark,u.dark);else{if(r.dark)return 1;if(u.dark)return-1}return b}function y(r,u){if(r.command!==u.command)return r.command<u.command?-1:1;if(r.title!==u.title)return r.title<u.title?-1:1;if(r.tooltip!==u.tooltip){if(r.tooltip!==void 0&&u.tooltip!==void 0)return r.tooltip<u.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(r.arguments===u.arguments)return 0;if(r.arguments)if(u.arguments){if(r.arguments.length!==u.arguments.length)return r.arguments.length-u.arguments.length}else return 1;else return-1;for(let b=0;b<r.arguments.length;b++){const p=r.arguments[b],P=u.arguments[b];if(p!==P)return p<P?-1:1}return 0}function w(r,u){let b=C.comparePaths(r.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(b!==0)return b;if(r.command&&u.command)b=y(r.command,u.command);else{if(r.command)return 1;if(u.command)return-1}if(b!==0)return b;if(r.decorations&&u.decorations)b=d(r.decorations,u.decorations);else{if(r.decorations)return 1;if(u.decorations)return-1}return b}function v(r,u){for(let b=0;b<r.length;b++)if(r[b]!==u[b])return!1;return!0}function l(r,u){return r.command===u.command&&r.title===u.title&&r.tooltip===u.tooltip&&(r.arguments&&u.arguments?v(r.arguments,u.arguments):r.arguments===u.arguments)}function h(r,u){return _.equals(r,u,l)}class m{constructor(u,b,p){this._extension=u,this._proxy=b,this._sourceControlHandle=p,this._value="",this._onDidChange=new T.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(u){this._proxy.$setInputBoxValue(this._sourceControlHandle,u),this.updateValue(u)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(u){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,u),this._placeholder=u}get validateInput(){return o.checkProposedApiEnabled(this._extension),this._validateInput}set validateInput(u){if(o.checkProposedApiEnabled(this._extension),u&&typeof u!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=u,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!u)}get visible(){return this._visible}set visible(u){u=!!u,this._visible!==u&&(this._visible=u,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,u))}focus(){o.checkProposedApiEnabled(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(u,b){o.checkProposedApiEnabled(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,u,b)}$onInputBoxValueChange(u){this.updateValue(u)}updateValue(u){this._value=u,this._onDidChange.fire(u)}}e.ExtHostSCMInputBox=m;class t{constructor(u,b,p,P,A){this._proxy=u,this._commands=b,this._sourceControlHandle=p,this._id=P,this._label=A,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new T.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(u){this._label=u,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,u)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(u){this._hideWhenEmpty=u,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(u){this._resourceStates=[...u],this._onDidUpdateResourceStates.fire()}getResourceState(u){return this._resourceStatesMap.get(u)}$executeResourceCommand(u,b){const p=this._resourceStatesCommandsMap.get(u);return p?k.asPromise(()=>this._commands.executeCommand(p.command,...p.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var u;const b=[...this._resourceStates].sort(w),P=_.sortedDiff(this._resourceSnapshot,b,w).map(R=>{const M=R.toInsert.map(H=>{const ue=this._resourceHandlePool++;this._resourceStatesMap.set(ue,H);const fe=H.resourceUri,Y=f(H.decorations),j=H.decorations&&f(H.decorations.light)||Y,Z=H.decorations&&f(H.decorations.dark)||Y,L=[];let q;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"){const he=new E.DisposableStore;q=this._commands.converter.toInternal(H.command,he),this._resourceStatesDisposablesMap.set(ue,he)}else this._resourceStatesCommandsMap.set(ue,H.command);j&&L.push(j),Z&&Z.toString()!==(j==null?void 0:j.toString())&&L.push(Z);const N=H.decorations&&H.decorations.tooltip||"",W=H.decorations&&!!H.decorations.strikeThrough,U=H.decorations&&!!H.decorations.faded,B=H.contextValue||"";return{rawResource:[ue,fe,L,N,W,U,B,q],handle:ue}});return{start:R.start,deleteCount:R.deleteCount,toInsert:M}}),A=P.map(({start:R,deleteCount:M,toInsert:H})=>[R,M,H.map(ue=>ue.rawResource)]),a=P.reverse();for(const{start:R,deleteCount:M,toInsert:H}of a){const ue=H.map(Y=>Y.handle),fe=this._handlesSnapshot.splice(R,M,...ue);for(const Y of fe)this._resourceStatesMap.delete(Y),this._resourceStatesCommandsMap.delete(Y),(u=this._resourceStatesDisposablesMap.get(Y))===null||u===void 0||u.dispose(),this._resourceStatesDisposablesMap.delete(Y)}return this._resourceSnapshot=b,A}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(u,b,p,P,A,a){this._proxy=b,this._commands=p,this._id=P,this._label=A,this._rootUri=a,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new E.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new E.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new T.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new m(u,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,P,A,a)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(u){this._count!==u&&(this._count=u,this._proxy.$updateSourceControl(this.handle,{count:u}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(u){this._quickDiffProvider=u,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!u})}get commitTemplate(){return this._commitTemplate}set commitTemplate(u){u!==this._commitTemplate&&(this._commitTemplate=u,this._proxy.$updateSourceControl(this.handle,{commitTemplate:u}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(u){this._acceptInputDisposables.value=new E.DisposableStore,this._acceptInputCommand=u;const b=this._commands.converter.toInternal(u,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:b})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(u){if(this._statusBarCommands&&u&&h(this._statusBarCommands,u))return;this._statusBarDisposables.value=new E.DisposableStore,this._statusBarCommands=u;const b=(u||[]).map(p=>this._commands.converter.toInternal(p,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(u,b){const p=new t(this._proxy,this._commands,this.handle,u,b),P=T.Event.once(p.onDidDispose)(()=>this.createdResourceGroups.delete(p));return this.createdResourceGroups.set(p,P),this.eventuallyAddResourceGroups(),p}eventuallyAddResourceGroups(){const u=[],b=[];for(const[p,P]of this.createdResourceGroups){P.dispose();const A=p.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(p),this.eventuallyUpdateResourceStates()});T.Event.once(p.onDidDispose)(()=>{this.updatedResourceGroups.delete(p),A.dispose(),this._groups.delete(p.handle),this._proxy.$unregisterGroup(this.handle,p.handle)}),u.push([p.handle,p.id,p.label,p.features]);const a=p._takeResourceStateSnapshot();a.length>0&&b.push([p.handle,a]),this._groups.set(p.handle,p)}this._proxy.$registerGroups(this.handle,u,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const u=[];this.updatedResourceGroups.forEach(b=>{const p=b._takeResourceStateSnapshot();p.length!==0&&u.push([b.handle,p])}),u.length>0&&this._proxy.$spliceResourceStates(this.handle,u),this.updatedResourceGroups.clear()}getResourceGroup(u){return this._groups.get(u)}setSelectionState(u){this._selected=u,this._onDidChangeSelection.fire(u)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(u=>u.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,Ve([S.debounce(100)],n.prototype,"eventuallyAddResourceGroups",null),Ve([S.debounce(100)],n.prototype,"eventuallyUpdateResourceStates",null);let s=class Oi{constructor(u,b,p){this._commands=b,this.logService=p,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new T.Emitter,this._proxy=u.getProxy(D.MainContext.MainThreadSCM),this._telemetry=u.getProxy(D.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const A=this._sourceControls.get(P.sourceControlHandle);if(!A)return P;const a=A.getResourceGroup(P.groupHandle);return a?a.getResourceState(P.handle):P}else if(P&&P.$mid===4){const A=this._sourceControls.get(P.sourceControlHandle);return A?A.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const A=this._sourceControls.get(P.handle);return A||P}return P}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(u,b,p,P){this.logService.trace("ExtHostSCM#createSourceControl",u.identifier.value,b,p,P),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const A=Oi._handlePool++,a=new n(u,this._proxy,this._commands,b,p,P);this._sourceControls.set(A,a);const R=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(u.identifier))||[];return R.push(a),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(u.identifier),R),a}getLastInputBox(u){this.logService.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const b=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(u.identifier)),p=b&&b[b.length-1];return p&&p.inputBox}$provideOriginalResource(u,b,p){const P=g.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",u,P.toString());const A=this._sourceControls.get(u);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):k.asPromise(()=>A.quickDiffProvider.provideOriginalResource(P,p)).then(a=>a||null)}$onInputBoxValueChange(u,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",u);const p=this._sourceControls.get(u);return p&&p.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(u,b,p,P){this.logService.trace("ExtHostSCM#$executeResourceCommand",u,b,p);const A=this._sourceControls.get(u);if(!A)return Promise.resolve(void 0);const a=A.getResourceGroup(b);return a?a.$executeResourceCommand(p,P):Promise.resolve(void 0)}$validateInput(u,b,p){this.logService.trace("ExtHostSCM#$validateInput",u);const P=this._sourceControls.get(u);return!P||!P.inputBox.validateInput?Promise.resolve(void 0):k.asPromise(()=>P.inputBox.validateInput(b,p)).then(A=>A?Promise.resolve([A.message,A.type]):Promise.resolve(void 0))}$setSelectedSourceControl(u){var b,p;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&((b=this._sourceControls.get(u))===null||b===void 0||b.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((p=this._sourceControls.get(this._selectedSourceControlHandle))===null||p===void 0||p.setSelectionState(!1)),this._selectedSourceControlHandle=u,Promise.resolve(void 0)}};s._handlePool=0,s=Ve([ze(2,i.ILogService)],s),e.ExtHostSCM=s});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Be=this&&this.__classPrivateFieldGet||function(ee,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[198],_e([0,1,6,5,131,7,9]),function(ee,e,g,T,S,E,k){"use strict";var D,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class C{constructor(f,c,d,y,w=g.StatusBarAlignment.Left,v){D.set(this,void 0),_.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new E.DisposableStore,nt(this,D,f,"f"),nt(this,_,c,"f"),this._entryId=C.ID_GEN++,this._extension=d,this._id=y,this._alignment=w,this._priority=v}get id(){var f;return(f=this._id)!==null&&f!==void 0?f:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get tooltip2(){return this._tooltip2}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var f;return(f=this._command)===null||f===void 0?void 0:f.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set tooltip2(f){this._tooltip2=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!C.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){var c;((c=this._command)===null||c===void 0?void 0:c.fromApi)!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Be(this,_,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Be(this,_,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,D,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var f;this._timeoutHandle=void 0;let c;this._extension?this._id?c=`${this._extension.identifier.value}.${this._id}`:c=this._extension.identifier.value:c=this._id;let d;this._name?d=this._name:d=S.localize(0,null,this._extension.displayName||this._extension.name);let y=this._color;this._backgroundColor&&(y=C.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const w=this._tooltip2!==void 0?k.MarkdownString.fromStrict(this._tooltip2):this.tooltip;Be(this,D,"f").$setEntry(this._entryId,c,d,this._text,w,(f=this._command)===null||f===void 0?void 0:f.internal,y,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=C,D=new WeakMap,_=new WeakMap,C.ID_GEN=0,C.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")]]);class i{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=S.localize(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const c={message:f};return this._messages.unshift(c),this._update(),new g.Disposable(()=>{const d=this._messages.indexOf(c);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(f,c){this._proxy=f.getProxy(T.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new i(this)}createStatusBarEntry(f,c,d,y){return new C(this._proxy,this._commands,f,c,d,y)}setStatusBarMessage(f,c){const d=this._statusMessage.setMessage(f);let y;return typeof c=="number"?y=setTimeout(()=>d.dispose(),c):typeof c!="undefined"&&c.then(()=>d.dispose(),()=>d.dispose()),new g.Disposable(()=>{d.dispose(),clearTimeout(y)})}}e.ExtHostStatusBar=I}),define(we[73],_e([0,1,5,3,4]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class E{constructor(D){this._onDidChangeStorage=new T.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,_){this._proxy.$registerExtensionStorageKeysToSync(D,_)}getValue(D,_,C){return this._proxy.$getValue(D,_).then(i=>i||C)}setValue(D,_,C){return this._proxy.$setValue(D,_,C)}$acceptValue(D,_,C){this._onDidChangeStorage.fire({shared:D,key:_,value:C})}}e.ExtHostStorage=E,e.IExtHostStorage=S.createDecorator("IExtHostStorage")}),define(we[74],_e([0,1,4,28,15,72,2]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=g.createDecorator("IExtensionStoragePaths");let D=class{constructor(C,i,I){var o;this._logService=i,this._extHostFileSystem=I,this._workspace=(o=C.workspace)!==null&&o!==void 0?o:void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(f=>this._value=f)}async _getOrCreateWorkspaceStoragePath(){var C;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,I=k.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(o){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(k.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(C=k.URI.revive(this._workspace.configuration))===null||C===void 0?void 0:C.toString(),name:this._workspace.name},void 0,2))),I}catch(o){this._logService.error("[ExtHostStorage]",o);return}}workspaceValue(C){if(this._value)return k.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return k.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}};D=Ve([ze(0,T.IExtHostInitDataService),ze(1,S.ILogService),ze(2,E.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(we[37],_e([0,1,3,5,4,2,13,7,6,132,11,163,18,34,152,10]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=S.createDecorator("IExtHostTerminalService");class y{constructor(s,r,u,b){this._proxy=s,this._id=r,this._creationOptions=u,this._name=b,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(P=>this._pidPromiseComplete=P);const p=this;this.value={get name(){return p._name||""},get processId(){return p._pidPromise},get creationOptions(){return p._creationOptions},get exitStatus(){return p._exitStatus},sendText(P,A=!0){p._checkDisposed(),p._proxy.$sendText(p._id,P,A)},show(P){p._checkDisposed(),p._proxy.$show(p._id,P)},hide(){p._checkDisposed(),p._proxy.$hide(p._id)},dispose(){p._disposed||(p._disposed=!0,p._proxy.$dispose(p._id))},get dimensions(){if(!(p._cols===void 0||p._rows===void 0))return{columns:p._cols,rows:p._rows}}}}async create(s,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:s.name,shellPath:d.withNullAsUndefined(s.shellPath),shellArgs:d.withNullAsUndefined(s.shellArgs),cwd:d.withNullAsUndefined(s.cwd),env:d.withNullAsUndefined(s.env),icon:d.withNullAsUndefined(t(s.iconPath)),initialText:d.withNullAsUndefined(s.message),strictEnv:d.withNullAsUndefined(s.strictEnv),hideFromUser:d.withNullAsUndefined(s.hideFromUser),isFeatureTerminal:d.withNullAsUndefined(r==null?void 0:r.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:d.withNullAsUndefined(r==null?void 0:r.useShellEnvironment),isSplitTerminal:d.withNullAsUndefined(r==null?void 0:r.isSplitTerminal)})}async createExtensionTerminal(s,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:r,isSplitTerminal:s}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(s){this._name=s}setExitCode(s){this._exitStatus=Object.freeze({code:s})}setDimensions(s,r){return s===this._cols&&r===this._rows||s===0||r===0?!1:(this._cols=s,this._rows=r,!0)}_setProcessId(s){this._pidPromiseComplete?(this._pidPromiseComplete(s),this._pidPromiseComplete=void 0):this._pidPromise.then(r=>{r!==s&&(this._pidPromise=Promise.resolve(s))})}}e.ExtHostTerminal=y;class w{constructor(s){this._pty=s,this.id=0,this.shouldPersist=!1,this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new g.Emitter,this._onProcessTitleChanged=new g.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new g.Emitter,this._onProcessShellTypeChanged=new g.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(s){this._pty.handleInput&&this._pty.handleInput(s)}resize(s,r){this._pty.setDimensions&&this._pty.setDimensions({columns:s,rows:r})}async processBinary(s){}acknowledgeDataEvent(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this._pty.onDidWrite(r=>this._onProcessData.fire(r)),this._pty.onDidClose&&this._pty.onDidClose((r=void 0)=>{this._onProcessExit.fire(r===void 0?void 0:r)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r&&{cols:r.columns,rows:r.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(r=>this._onProcessTitleChanged.fire(r)),this._pty.open(s||void 0),this._pty.setDimensions&&s&&this._pty.setDimensions(s),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=w;let v=1,l=class extends D.Disposable{constructor(s,r){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this._onDidOpenTerminal=new g.Emitter,this._onDidChangeActiveTerminal=new g.Emitter,this._onDidChangeTerminalDimensions=new g.Emitter,this._proxy=r.getProxy(T.MainContext.MainThreadTerminalService),this._bufferer=new c.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(s),this._register({dispose:()=>{for(const[u,b]of this._terminalProcesses)b.shutdown(!0)}})}get activeTerminal(){var s;return(s=this._activeTerminal)===null||s===void 0?void 0:s.value}get terminals(){return this._terminals.map(s=>s.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(s){const r=s?this._defaultAutomationProfile:this._defaultProfile;return(r==null?void 0:r.path)||""}getDefaultShellArgs(s){const r=s?this._defaultAutomationProfile:this._defaultProfile;return(r==null?void 0:r.args)||[]}createExtensionTerminal(s,r){const u=new y(this._proxy,f.generateUuid(),s,s.name),b=new w(s.pty);return u.createExtensionTerminal(r==null?void 0:r.isSplitTerminal,t(s.iconPath)).then(p=>{const P=this._setupExtHostProcessListeners(p,b);this._terminalProcessDisposables[p]=P}),this._terminals.push(u),u.value}attachPtyToTerminal(s,r){if(!this._getTerminalById(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const b=new w(r),p=this._setupExtHostProcessListeners(s,b);this._terminalProcessDisposables[s]=p}async $acceptActiveTerminalChanged(s){const r=this._activeTerminal;if(s===null){this._activeTerminal=void 0,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const u=this._getTerminalById(s);u&&(this._activeTerminal=u,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(s,r){const u=this._getTerminalById(s);u&&this._onDidWriteTerminalData.fire({terminal:u.value,data:r})}async $acceptTerminalDimensions(s,r,u){const b=this._getTerminalById(s);b&&b.setDimensions(r,u)&&this._onDidChangeTerminalDimensions.fire({terminal:b.value,dimensions:b.value.dimensions})}async $acceptTerminalMaximumDimensions(s,r,u){var b;(b=this._terminalProcesses.get(s))===null||b===void 0||b.resize(r,u)}async $acceptTerminalTitleChange(s,r){const u=this._getTerminalById(s);u&&(u.name=r)}async $acceptTerminalClosed(s,r){const u=this._getTerminalObjectIndexById(this._terminals,s);if(u!==null){const b=this._terminals.splice(u,1)[0];b.setExitCode(r),this._onDidCloseTerminal.fire(b.value)}}$acceptTerminalOpened(s,r,u,b){if(r){const A=this._getTerminalObjectIndexById(this._terminals,r);if(A!==null){this._terminals[A]._id=s,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const p={name:b.name,shellPath:b.executable,shellArgs:b.args,cwd:typeof b.cwd=="string"?b.cwd:E.URI.revive(b.cwd),env:b.env,hideFromUser:b.hideFromUser},P=new y(this._proxy,s,p,u);this._terminals.push(P),this._onDidOpenTerminal.fire(P.value),P.isOpen=!0}async $acceptTerminalProcessId(s,r){const u=this._getTerminalById(s);u&&u._setProcessId(r)}async $startExtensionTerminal(s,r){const u=this._getTerminalById(s);if(!u)return{message:C.localize(0,null,s)};u.isOpen||await new Promise(p=>{const P=this.onDidOpenTerminal(async A=>{A===u.value&&(P.dispose(),p())})});const b=this._terminalProcesses.get(s);b?b.startSendingEvents(r):this._extensionTerminalAwaitingStart[s]={initialDimensions:r}}_setupExtHostProcessListeners(s,r){const u=new D.DisposableStore;u.add(r.onProcessReady(p=>this._proxy.$sendProcessReady(s,p.pid,p.cwd))),u.add(r.onProcessTitleChanged(p=>this._proxy.$sendProcessTitle(s,p))),this._bufferer.startBuffering(s,r.onProcessData),u.add(r.onProcessExit(p=>this._onProcessExit(s,p))),r.onProcessOverrideDimensions&&u.add(r.onProcessOverrideDimensions(p=>this._proxy.$sendOverrideDimensions(s,p))),this._terminalProcesses.set(s,r);const b=this._extensionTerminalAwaitingStart[s];return b&&r instanceof w&&(r.startSendingEvents(b.initialDimensions),delete this._extensionTerminalAwaitingStart[s]),u}$acceptProcessAckDataEvent(s,r){var u;(u=this._terminalProcesses.get(s))===null||u===void 0||u.acknowledgeDataEvent(r)}$acceptProcessInput(s,r){var u;(u=this._terminalProcesses.get(s))===null||u===void 0||u.input(r)}$acceptProcessResize(s,r,u){var b;try{(b=this._terminalProcesses.get(s))===null||b===void 0||b.resize(r,u)}catch(p){if(p.code!=="EPIPE"&&p.code!=="ERR_IPC_CHANNEL_CLOSED")throw p}}$acceptProcessShutdown(s,r){var u;(u=this._terminalProcesses.get(s))===null||u===void 0||u.shutdown(r)}$acceptProcessRequestInitialCwd(s){var r;(r=this._terminalProcesses.get(s))===null||r===void 0||r.getInitialCwd().then(u=>this._proxy.$sendProcessInitialCwd(s,u))}$acceptProcessRequestCwd(s){var r;(r=this._terminalProcesses.get(s))===null||r===void 0||r.getCwd().then(u=>this._proxy.$sendProcessCwd(s,u))}$acceptProcessRequestLatency(s){return s}registerLinkProvider(s){return this._linkProviders.add(s),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(s),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(s,r,u){if(this._profileProviders.has(r))throw new Error(`Terminal profile provider "${r}" already registered`);return this._profileProviders.set(r,u),this._proxy.$registerProfileProvider(r,s.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(r),this._proxy.$unregisterProfileProvider(r)})}async $createContributedProfileTerminal(s,r){var u;const b=new o.CancellationTokenSource().token,p=await((u=this._profileProviders.get(s))===null||u===void 0?void 0:u.provideTerminalProfile(b));if(!b.isCancellationRequested){if(!p||!("options"in p))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in p.options){this.createExtensionTerminal(p.options,{isSplitTerminal:r});return}this.createTerminalFromOptions(p.options,{isSplitTerminal:r})}}async $provideLinks(s,r){const u=this._getTerminalById(s);if(!u)return[];this._terminalLinkCache.delete(s);const b=this._terminalLinkCancellationSource.get(s);b&&b.dispose(!0);const p=new o.CancellationTokenSource;this._terminalLinkCancellationSource.set(s,p);const P=[],A={terminal:u.value,line:r},a=[];for(const H of this._linkProviders)a.push(new Promise(async ue=>{p.token.onCancellationRequested(()=>ue({provider:H,links:[]}));const fe=await H.provideTerminalLinks(A,p.token)||[];p.token.isCancellationRequested||ue({provider:H,links:fe})}));const R=await Promise.all(a);if(p.token.isCancellationRequested)return[];const M=new Map;for(const H of R)H&&H.links.length>0&&P.push(...H.links.map(ue=>{const fe={id:v++,startIndex:ue.startIndex,length:ue.length,label:ue.tooltip};return M.set(fe.id,{provider:H.provider,link:ue}),fe}));return this._terminalLinkCache.set(s,M),P}$activateLink(s,r){var u;const b=(u=this._terminalLinkCache.get(s))===null||u===void 0?void 0:u.get(r);!b||b.provider.handleTerminalLink(b.link)}_onProcessExit(s,r){this._bufferer.stopBuffering(s),this._terminalProcesses.delete(s),delete this._extensionTerminalAwaitingStart[s];const u=this._terminalProcessDisposables[s];u&&(u.dispose(),delete this._terminalProcessDisposables[s]),this._proxy.$sendProcessExit(s,r)}_getTerminalById(s){return this._getTerminalObjectById(this._terminals,s)}_getTerminalObjectById(s,r){const u=this._getTerminalObjectIndexById(s,r);return u!==null?s[u]:null}_getTerminalObjectIndexById(s,r){let u=null;return s.some((b,p)=>b._id===r?(u=p,!0):!1),u}getEnvironmentVariableCollection(s){let r=this._environmentVariableCollections.get(s.identifier.value);return r||(r=new h,this._setEnvironmentVariableCollection(s.identifier.value,r)),r}_syncEnvironmentVariableCollection(s,r){const u=I.serializeEnvironmentVariableCollection(r.map);this._proxy.$setEnvironmentVariableCollection(s,r.persistent,u.length===0?void 0:u)}$initEnvironmentVariableCollections(s){s.forEach(r=>{const u=r[0],b=new h(r[1]);this._setEnvironmentVariableCollection(u,b)})}$acceptDefaultProfile(s,r){this._defaultProfile=s,this._defaultAutomationProfile=r}_setEnvironmentVariableCollection(s,r){this._environmentVariableCollections.set(s,r),r.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(s,r)})}};l=Ve([ze(1,k.IExtHostRpcService)],l),e.BaseExtHostTerminalService=l;class h{constructor(s){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(s)}get persistent(){return this._persistent}set persistent(s){this._persistent=s,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(s,r){this._setIfDiffers(s,{value:r,type:_.EnvironmentVariableMutatorType.Replace})}append(s,r){this._setIfDiffers(s,{value:r,type:_.EnvironmentVariableMutatorType.Append})}prepend(s,r){this._setIfDiffers(s,{value:r,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(s,r){const u=this.map.get(s);(!u||u.value!==r.value||u.type!==r.type)&&(this.map.set(s,r),this._onDidChangeCollection.fire())}get(s){return this.map.get(s)}forEach(s,r){this.map.forEach((u,b)=>s.call(r,b,u,this))}delete(s){this.map.delete(s),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=h;let m=class extends l{constructor(s){super(!1,s)}createTerminal(s,r,u){throw new i.NotSupportedError}createTerminalFromOptions(s,r){throw new i.NotSupportedError}};m=Ve([ze(0,k.IExtHostRpcService)],m),e.WorkerExtHostTerminalService=m;function t(n){if(!!n)return"id"in n?{id:n.id,color:n.color}:n}}),define(we[199],_e([0,1,3,17,5,98,9,6]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(i,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(o=>this._onDidChangeVisibleTextEditors.fire(o)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(o=>this._onDidChangeActiveTextEditor.fire(o))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const I=this._extHostDocumentsAndEditors.allEditors();return i?I:I.map(o=>o.value)}async showTextDocument(i,I,o){let f;typeof I=="number"?f={position:k.ViewColumn.from(I),preserveFocus:o}:typeof I=="object"?f={position:k.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?k.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:f={preserveFocus:!1};const c=await this._proxy.$tryShowTextDocument(i.uri,f),d=c&&this._extHostDocumentsAndEditors.getEditor(c);if(d)return d.value;throw c?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i,I){return new E.TextEditorDecorationType(this._proxy,i,I).value}$acceptEditorPropertiesChanged(i,I){const o=this._extHostDocumentsAndEditors.getEditor(i);if(!o)throw new Error("unknown text editor");if(I.options&&o._acceptOptions(I.options),I.selections){const f=I.selections.selections.map(k.Selection.to);o._acceptSelections(f)}if(I.visibleRanges){const f=T.coalesce(I.visibleRanges.map(k.Range.to));o._acceptVisibleRanges(f)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:o.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:k.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const f=D.TextEditorSelectionChangeKind.fromValue(I.selections.source),c=I.selections.selections.map(k.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:o.value,selections:c,kind:f})}if(I.visibleRanges){const f=T.coalesce(I.visibleRanges.map(k.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:o.value,visibleRanges:f})}}$acceptEditorPositionData(i){for(const I in i){const o=this._extHostDocumentsAndEditors.getEditor(I);if(!o)throw new Error("Unknown text editor");const f=k.ViewColumn.to(i[I]);o.value.viewColumn!==f&&(o._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:o.value,viewColumn:f}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=_});var Si=this&&this.__rest||function(ee,e){var g={};for(var T in ee)Object.prototype.hasOwnProperty.call(ee,T)&&e.indexOf(T)<0&&(g[T]=ee[T]);if(ee!=null&&typeof Object.getOwnPropertySymbols=="function")for(var S=0,T=Object.getOwnPropertySymbols(ee);S<T.length;S++)e.indexOf(T[S])<0&&Object.prototype.propertyIsEnumerable.call(ee,T[S])&&(g[T[S]]=ee[T[S]]);return g};define(we[200],_e([0,1,2,4,5,7,6]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=T.createDecorator("IExtHostTimeline");class D{constructor(i,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(S.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:o=>{var f,c;if(o&&o.$mid===11){const d=o.uri===void 0?void 0:g.URI.revive(o.uri);return(c=(f=this._itemsBySourceAndUriMap.get(o.source))===null||f===void 0?void 0:f.get(_(d)))===null||c===void 0?void 0:c.get(o.handle)}return o}})}async $getTimeline(i,I,o,f,c){const d=this._providers.get(i);return d==null?void 0:d.provideTimeline(g.URI.revive(I),o,f,c)}registerTimelineProvider(i,I,o,f){const c=new E.DisposableStore,d=this.convertTimelineItem(I.id,f,c).bind(this);let y;I.onDidChange&&(y=I.onDidChange(v=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},v),{id:I.id})),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:i,onDidChange:void 0,async provideTimeline(v,l,h,m){var t;(m==null?void 0:m.resetCache)&&(c.clear(),(t=w.get(I.id))===null||t===void 0||t.clear());const n=await I.provideTimeline(v,l,h);if(n==null)return;const s=d(v,m);return Object.assign(Object.assign({},n),{source:I.id,items:n.items.map(s)})},dispose(){var v;for(const l of w.values())(v=l.get(I.id))===null||v===void 0||v.clear();y==null||y.dispose(),c.dispose()}}))}convertTimelineItem(i,I,o){return(f,c)=>{let d;if(c==null?void 0:c.cacheResults){let y=this._itemsBySourceAndUriMap.get(i);y===void 0&&(y=new Map,this._itemsBySourceAndUriMap.set(i,y));const w=_(f);d=y.get(w),d===void 0&&(d=new Map,y.set(w,d))}return y=>{var w,v;const{iconPath:l}=y,h=Si(y,["iconPath"]),m=`${i}|${(w=y.id)!==null&&w!==void 0?w:y.timestamp}`;d==null||d.set(m,y);let t,n,s;return y.iconPath&&(l instanceof k.ThemeIcon?s={id:l.id}:g.URI.isUri(l)?(t=l,n=l):{light:t,dark:n}=l),Object.assign(Object.assign({},h),{id:(v=h.id)!==null&&v!==void 0?v:void 0,handle:m,source:i,command:y.command?I.toInternal(y.command,o):void 0,icon:t,iconDark:n,themeIcon:s,accessibilityInformation:y.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),E.toDisposable(()=>{var o;for(const f of this._itemsBySourceAndUriMap.values())(o=f.get(i.id))===null||o===void 0||o.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=D;function _(C){return C==null?void 0:C.toString()}}),define(we[201],_e([0,1,7,16,2,5]),function(ee,e,g,T,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{constructor(_){this._openers=new Map,this._proxy=_.getProxy(E.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,C,i,I){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const o=I.schemes.find(f=>!k.supportedSchemes.has(f));if(o)throw new Error(`Scheme '${o}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,i),this._proxy.$registerUriOpener(C,I.schemes,_,I.label),g.toDisposable(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(_,C,i){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener with id: ${_}`);const o=S.URI.revive(C);return I.canOpenExternalUri(o,i)}async $openUri(_,C,i){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener id: '${_}'`);return I.openExternalUri(S.URI.revive(C.resolvedUri),{sourceUri:S.URI.revive(C.sourceUri)},i)}}e.ExtHostUriOpeners=k,k.supportedSchemes=new Set([T.Schemas.http,T.Schemas.https])}),define(we[202],_e([0,1,5,2,7,11,26]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(C,i){if(this.handles.has(k.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const I=D.HandlePool++;return this.handles.add(k.ExtensionIdentifier.toKey(C)),this.handlers.set(I,i),this._proxy.$registerUriHandler(I,C),S.toDisposable(()=>{this.handles.delete(k.ExtensionIdentifier.toKey(C)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(C,i){const I=this.handlers.get(C);if(!I)return Promise.resolve(void 0);try{I.handleUri(T.URI.revive(i))}catch(o){E.onUnexpectedError(o)}return Promise.resolve(void 0)}async createAppUri(C){return T.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=D,D.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Be=this&&this.__classPrivateFieldGet||function(ee,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[47],_e([0,1,3,2,140,158,67,5]),function(ee,e,g,T,S,E,k,D){"use strict";var _,C,i,I,o,f,c,d,y,w,v,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(p,P,A,a,R,M,H){_.set(this,void 0),C.set(this,void 0),i.set(this,void 0),I.set(this,void 0),o.set(this,void 0),f.set(this,void 0),c.set(this,""),d.set(this,void 0),y.set(this,!1),w.set(this,!1),v.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new g.Emitter),this._onDidDispose=Be(this,l,"f").event,nt(this,_,p,"f"),nt(this,C,P,"f"),nt(this,d,A,"f"),nt(this,I,a,"f"),nt(this,o,R,"f"),nt(this,f,M,"f"),nt(this,v,m(M),"f"),nt(this,i,H,"f")}dispose(){nt(this,y,!0,"f"),Be(this,l,"f").fire(),Be(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return nt(this,w,!0,"f"),k.asWebviewUri(p,Be(this,I,"f").remote)}get cspSource(){return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,c,"f")}set html(p){this.assertNotDisposed(),Be(this,c,"f")!==p&&(nt(this,c,p,"f"),!Be(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(nt(this,w,!0,"f"),Be(this,i,"f").report("Webview vscode-resource: uris",Be(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,C,"f").$setHtml(Be(this,_,"f"),p))}get options(){return this.assertNotDisposed(),Be(this,d,"f")}set options(p){this.assertNotDisposed(),Be(this,C,"f").$setOptions(Be(this,_,"f"),s(Be(this,f,"f"),Be(this,o,"f"),p)),nt(this,d,p,"f")}async postMessage(p){if(Be(this,y,"f"))return!1;const P=E.serializeWebviewMessage(p,{serializeBuffersForPostMessage:Be(this,v,"f")});return Be(this,C,"f").$postMessage(Be(this,_,"f"),P.message,...P.buffers)}assertNotDisposed(){if(Be(this,y,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=h,_=new WeakMap,C=new WeakMap,i=new WeakMap,I=new WeakMap,o=new WeakMap,f=new WeakMap,c=new WeakMap,d=new WeakMap,y=new WeakMap,w=new WeakMap,v=new WeakMap,l=new WeakMap;function m(b){try{const p=S.normalizeVersion(S.parseVersion(b.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=57}catch(p){return!1}}e.shouldSerializeBuffersForPostMessage=m;class t{constructor(p,P,A,a,R){this.initData=P,this.workspace=A,this._logService=a,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=p.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(p,P,...A){const a=this.getWebview(p);if(a){const{message:R}=E.deserializeWebviewMessage(P,A);a._onMessageEmitter.fire(R)}}$onMissingCsp(p,P){this._logService.warn(`${P} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,P,A){const a=new h(p,this._webviewProxy,r(P),this.initData,this.workspace,A,this._deprecationService);return this._webviews.set(p,a),a._onDidDispose(()=>{this._webviews.delete(p)}),a}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=t;function n(b){return{id:b.identifier,location:b.extensionLocation}}e.toExtensionData=n;function s(b,p,P){return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,portMapping:P.portMapping,localResourceRoots:P.localResourceRoots||u(b,p)}}e.serializeWebviewOptions=s;function r(b){var p;return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,portMapping:b.portMapping,localResourceRoots:(p=b.localResourceRoots)===null||p===void 0?void 0:p.map(P=>T.URI.from(P))}}e.reviveOptions=r;function u(b,p){return[...((p==null?void 0:p.getWorkspaceFolders())||[]).map(P=>P.uri),b.extensionLocation]}}),define(we[203],_e([0,1,18,53,7,16,25,2,9,47,62,5,6]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=h(this.document.uri)+this._backupCounter++;return k.joinPath(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class c{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,s){const r=this.key(t,n.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const u=new f(n,s);return this._documents.set(r,u),u}delete(t,n){const s=this.key(t,n.uri);this._documents.delete(s)}key(t,n){return`${t}@@@${n}`}}var d;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(d||(d={}));class y{constructor(){this._providers=new Map}addTextProvider(t,n,s){return this.add(0,t,n,s)}addCustomProvider(t,n,s){return this.add(1,t,n,s)}get(t){return this._providers.get(t)}add(t,n,s,r){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:s,provider:r}),new o.Disposable(()=>this._providers.delete(n))}}class w{constructor(t,n,s,r,u){this._extHostDocuments=n,this._extensionStoragePaths=s,this._extHostWebview=r,this._extHostWebviewPanels=u,this._editorProviders=new y,this._documents=new c,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,s,r){const u=new S.DisposableStore;return v(s)?(u.add(this._editorProviders.addTextProvider(n,t,s)),this._proxy.$registerTextEditorProvider(C.toExtensionData(t),n,r.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},C.shouldSerializeBuffersForPostMessage(t))):(u.add(this._editorProviders.addCustomProvider(n,t,s)),this.supportEditing(s)&&u.add(s.onDidChangeCustomDocument(b=>{const p=this.getCustomDocumentEntry(n,b.document.uri);if(l(b)){const P=p.addEdit(b);this._proxy.$onDidEdit(b.document.uri,n,P,b.label)}else this._proxy.$onContentChange(b.document.uri,n)})),this._proxy.$registerCustomEditorProvider(C.toExtensionData(t),n,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,C.shouldSerializeBuffersForPostMessage(t))),o.Disposable.from(u,new o.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,s,r,u){var b;const p=this._editorProviders.get(n);if(!p)throw new Error(`No provider found for '${n}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${n}'`);const P=D.URI.revive(t),A=await p.provider.openCustomDocument(P,{backupId:s,untitledDocumentData:r==null?void 0:r.buffer},u);let a;return this.supportEditing(p.provider)&&this._extensionStoragePaths&&(a=(b=this._extensionStoragePaths.workspaceValue(p.extension))!==null&&b!==void 0?b:this._extensionStoragePaths.globalValue(p.extension)),this._documents.add(n,A,a),{editable:this.supportEditing(p.provider)}}async $disposeCustomDocument(t,n){const s=this._editorProviders.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${n}'`);const r=D.URI.revive(t),{document:u}=this.getCustomDocumentEntry(n,r);this._documents.delete(n,u),u.dispose()}async $resolveWebviewEditor(t,n,s,r,u,b){const p=this._editorProviders.get(s);if(!p)throw new Error(`No provider found for '${s}'`);const P=_.ViewColumn.to(u),A=this._extHostWebview.createNewWebview(n,r.webviewOptions,p.extension),a=this._extHostWebviewPanels.createNewWebviewPanel(n,s,r.title,P,r.panelOptions,A),R=D.URI.revive(t);switch(p.type){case 1:{const{document:M}=this.getCustomDocumentEntry(s,R);return p.provider.resolveCustomEditor(M,a,b)}case 0:{const M=this._extHostDocuments.getDocument(R);return p.provider.resolveCustomTextEditor(M,a,b)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,s){this.getCustomDocumentEntry(n,t).disposeEdits(s)}async $onMoveCustomEditor(t,n,s){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const u=this._extHostWebviewPanels.getWebviewPanel(t);if(!u)throw new Error("No webview found");const b=D.URI.revive(n),p=this._extHostDocuments.getDocument(b);await r.provider.moveCustomTextEditor(p,u,g.CancellationToken.None)}async $undo(t,n,s,r){return this.getCustomDocumentEntry(n,t).undo(s,r)}async $redo(t,n,s,r){return this.getCustomDocumentEntry(n,t).redo(s,r)}async $revert(t,n,s){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(r.document,s),r.disposeBackup()}async $onSave(t,n,s){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(r.document,s),r.disposeBackup()}async $onSaveAs(t,n,s,r){const u=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(u.document,D.URI.revive(s),r)}async $backup(t,n,s){const r=this.getCustomDocumentEntry(n,t),b=await this.getCustomEditorProvider(n).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},s);return r.updateBackup(b),b.id}getCustomDocumentEntry(t,n){const s=this._documents.get(t,D.URI.revive(n));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const n=this._editorProviders.get(t),s=n==null?void 0:n.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function v(m){return typeof m.resolveCustomTextEditor=="function"}function l(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function h(m){const t=m.scheme===E.Schemas.file||m.scheme===E.Schemas.untitled?m.fsPath:m.toString();return T.hash(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Be=this&&this.__classPrivateFieldGet||function(ee,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[204],_e([0,1,3,7,2,34,9,47,5,6]),function(ee,e,g,T,S,E,k,D,_,C){"use strict";var i,I,o,f,c,d,y,w,v,l,h,m,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends T.Disposable{constructor(b,p,P,A,a,R,M){super();i.set(this,void 0),I.set(this,void 0),o.set(this,void 0),f.set(this,void 0),c.set(this,void 0),d.set(this,void 0),y.set(this,void 0),w.set(this,void 0),v.set(this,!0),l.set(this,!0),h.set(this,!1),m.set(this,this._register(new g.Emitter)),this.onDidDispose=Be(this,m,"f").event,t.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=Be(this,t,"f").event,nt(this,i,b,"f"),nt(this,I,p,"f"),nt(this,o,P,"f"),nt(this,c,R,"f"),nt(this,w,a,"f"),nt(this,d,A,"f"),nt(this,f,M,"f")}dispose(){Be(this,h,"f")||(nt(this,h,!0,"f"),Be(this,m,"f").fire(),Be(this,I,"f").$disposeWebview(Be(this,i,"f")),Be(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,f,"f")}get viewType(){return this.assertNotDisposed(),Be(this,o,"f")}get title(){return this.assertNotDisposed(),Be(this,d,"f")}set title(b){this.assertNotDisposed(),Be(this,d,"f")!==b&&(nt(this,d,b,"f"),Be(this,I,"f").$setTitle(Be(this,i,"f"),b))}get iconPath(){return this.assertNotDisposed(),Be(this,y,"f")}set iconPath(b){this.assertNotDisposed(),Be(this,y,"f")!==b&&(nt(this,y,b,"f"),Be(this,I,"f").$setIconPath(Be(this,i,"f"),S.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return Be(this,c,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,w,"f")=="number"&&Be(this,w,"f")<0))return Be(this,w,"f")}get active(){return this.assertNotDisposed(),Be(this,l,"f")}get visible(){return this.assertNotDisposed(),Be(this,v,"f")}_updateViewState(b){Be(this,h,"f")||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(nt(this,l,b.active,"f"),nt(this,v,b.visible,"f"),nt(this,w,b.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(b,p){this.assertNotDisposed(),Be(this,I,"f").$reveal(Be(this,i,"f"),{viewColumn:b?k.ViewColumn.from(b):void 0,preserveFocus:!!p})}assertNotDisposed(){if(Be(this,h,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,I=new WeakMap,o=new WeakMap,f=new WeakMap,c=new WeakMap,d=new WeakMap,y=new WeakMap,w=new WeakMap,v=new WeakMap,l=new WeakMap,h=new WeakMap,m=new WeakMap,t=new WeakMap;class s{constructor(b,p,P){this.webviews=p,this.workspace=P,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=b.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return E.generateUuid()}createWebviewPanel(b,p,P,A,a={}){const R=typeof A=="object"?A.viewColumn:A,M={viewColumn:k.ViewColumn.from(R),preserveFocus:typeof A=="object"&&!!A.preserveFocus},H=D.shouldSerializeBuffersForPostMessage(b),ue=s.newHandle();this._proxy.$createWebviewPanel(D.toExtensionData(b),ue,p,{title:P,panelOptions:r(a),webviewOptions:D.serializeWebviewOptions(b,this.workspace,a),serializeBuffersForPostMessage:H},M);const fe=this.webviews.createNewWebview(ue,a,b);return this.createNewWebviewPanel(ue,p,P,R,a,fe)}$onDidChangeWebviewPanelViewStates(b){const p=Object.keys(b);p.sort((P,A)=>{const a=b[P],R=b[A];return a.active?1:R.active?-1:+a.visible-+R.visible});for(const P of p){const A=this.getWebviewPanel(P);if(!A)continue;const a=b[P];A._updateViewState({active:a.active,visible:a.visible,viewColumn:k.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(b){const p=this.getWebviewPanel(b);p==null||p.dispose(),this._webviewPanels.delete(b),this.webviews.deleteWebview(b)}registerWebviewPanelSerializer(b,p,P){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:P,extension:b}),this._proxy.$registerSerializer(p,{serializeBuffersForPostMessage:D.shouldSerializeBuffersForPostMessage(b)}),new C.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(b,p,P,A){const a=this._serializers.get(p);if(!a)throw new Error(`No serializer found for '${p}'`);const{serializer:R,extension:M}=a,H=this.webviews.createNewWebview(b,P.webviewOptions,M),ue=this.createNewWebviewPanel(b,p,P.title,A,P.panelOptions,H);await R.deserializeWebviewPanel(ue,P.state)}createNewWebviewPanel(b,p,P,A,a,R){const M=new n(b,this._proxy,p,P,A,a,R);return this._webviewPanels.set(b,M),M}getWebviewPanel(b){return this._webviewPanels.get(b)}}e.ExtHostWebviewPanels=s;function r(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Be=this&&this.__classPrivateFieldGet||function(ee,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[205],_e([0,1,3,7,47,5,6]),function(ee,e,g,T,S,E,k){"use strict";var D,_,C,i,I,o,f,c,d,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends T.Disposable{constructor(h,m,t,n,s,r){super();D.set(this,void 0),_.set(this,void 0),C.set(this,void 0),i.set(this,void 0),I.set(this,!1),o.set(this,void 0),f.set(this,void 0),c.set(this,void 0),d.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=Be(this,d,"f").event,y.set(this,this._register(new g.Emitter)),this.onDidDispose=Be(this,y,"f").event,nt(this,C,t,"f"),nt(this,f,n,"f"),nt(this,D,h,"f"),nt(this,_,m,"f"),nt(this,i,s,"f"),nt(this,o,r,"f")}dispose(){Be(this,I,"f")||(nt(this,I,!0,"f"),Be(this,y,"f").fire(),Be(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,f,"f")}set title(h){this.assertNotDisposed(),Be(this,f,"f")!==h&&(nt(this,f,h,"f"),Be(this,_,"f").$setWebviewViewTitle(Be(this,D,"f"),h))}get description(){return this.assertNotDisposed(),Be(this,c,"f")}set description(h){this.assertNotDisposed(),Be(this,c,"f")!==h&&(nt(this,c,h,"f"),Be(this,_,"f").$setWebviewViewDescription(Be(this,D,"f"),h))}get visible(){return Be(this,o,"f")}get webview(){return Be(this,i,"f")}get viewType(){return Be(this,C,"f")}_setVisible(h){h===Be(this,o,"f")||Be(this,I,"f")||(nt(this,o,h,"f"),Be(this,d,"f").fire())}show(h){this.assertNotDisposed(),Be(this,_,"f").$show(Be(this,D,"f"),!!h)}assertNotDisposed(){if(Be(this,I,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,_=new WeakMap,C=new WeakMap,i=new WeakMap,I=new WeakMap,o=new WeakMap,f=new WeakMap,c=new WeakMap,d=new WeakMap,y=new WeakMap;class v{constructor(h,m){this._extHostWebview=m,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=h.getProxy(E.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(h,m,t,n){if(this._viewProviders.has(m))throw new Error(`View provider for '${m}' already registered`);return this._viewProviders.set(m,{provider:t,extension:h}),this._proxy.$registerWebviewViewProvider(S.toExtensionData(h),m,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new k.Disposable(()=>{this._viewProviders.delete(m),this._proxy.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(h,m,t,n,s){const r=this._viewProviders.get(m);if(!r)throw new Error(`No view provider found for '${m}'`);const{provider:u,extension:b}=r,p=this._extHostWebview.createNewWebview(h,{},b),P=new w(h,this._proxy,m,t,p,!0);this._webviewViews.set(h,P),await u.resolveWebviewView(P,{state:n},s)}async $onDidChangeWebviewViewVisibility(h,m){this.getWebviewView(h)._setVisible(m)}async $disposeWebviewView(h){const m=this.getWebviewView(h);this._webviewViews.delete(h),m.dispose(),this._extHostWebview.deleteWebview(h)}getWebviewView(h){const m=this._webviewViews.get(h);if(!m)throw new Error("No webview found");return m}}e.ExtHostWebviewViews=v}),define(we[102],_e([0,1,3,5,2,16,8,4,13]),function(ee,e,g,T,S,E,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class Ui{constructor(I){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ui.InitialState,this._proxy=I.getProxy(T.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(o=>this.$onDidChangeWindowFocus(o))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,o){let f;if(typeof I=="string"){f=I;try{I=S.URI.parse(I)}catch(c){return Promise.reject(`Invalid uri - '${I}'`)}}return k.isFalsyOrWhitespace(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===E.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,f,o)}async asExternalUri(I,o){if(k.isFalsyOrWhitespace(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(I,o);return S.URI.from(f)}};C.InitialState={focused:!0},C=Ve([ze(0,_.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=D.createDecorator("IExtHostWindow")}),define(we[206],_e([0,1,15,5,28,13]),function(ee,e,g,T,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends g.AbstractLogger{constructor(_,C){super();this._proxy=_.getProxy(T.MainContext.MainThreadLog),this._logFile=C.logFile.toJSON(),this.setLevel(C.logLevel)}$setLevel(_){this.setLevel(_)}trace(_,...C){this.getLevel()<=g.LogLevel.Trace&&this._proxy.$log(this._logFile,g.LogLevel.Trace,Array.from(arguments))}debug(_,...C){this.getLevel()<=g.LogLevel.Debug&&this._proxy.$log(this._logFile,g.LogLevel.Debug,Array.from(arguments))}info(_,...C){this.getLevel()<=g.LogLevel.Info&&this._proxy.$log(this._logFile,g.LogLevel.Info,Array.from(arguments))}warn(_,...C){this.getLevel()<=g.LogLevel.Warning&&this._proxy.$log(this._logFile,g.LogLevel.Warning,Array.from(arguments))}error(_,...C){this.getLevel()<=g.LogLevel.Error&&this._proxy.$log(this._logFile,g.LogLevel.Error,Array.from(arguments))}critical(_,...C){this.getLevel()<=g.LogLevel.Critical&&this._proxy.$log(this._logFile,g.LogLevel.Critical,Array.from(arguments))}flush(){}};k=Ve([ze(0,E.IExtHostRpcService),ze(1,S.IExtHostInitDataService)],k),e.ExtHostLogService=k}),define(we[207],_e([0,1,12,18,11,3,7,113,177,99,23]),function(ee,e,g,T,S,E,k,D,_,C,i){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function o(r,u){try{return JSON.stringify(r,u)}catch(b){return"null"}}function f(r,u){return JSON.stringify(r,u)}function c(r){return r?(u,b)=>b&&b.$mid===1?r.transformOutgoing(b):b:null}var d;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var y;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(y=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},v=Symbol.for("rpcProtocol"),l=Symbol.for("rpcProxy");class h extends k.Disposable{constructor(u,b=null,p=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new E.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=u,this._logger=b,this._uriTransformer=p,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let P=0,A=C.ProxyIdentifier.count;P<A;P++)this._locals[P]=null,this._proxies[P]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(P=>this._receiveOneMessage(P))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(u=>{this._pendingRPCReplies[u].resolveErr(S.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(u){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(u){this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(u){this._responsiveState!==u&&(this._responsiveState=u,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(u){return this._uriTransformer?D.transformIncomingURIs(u,this._uriTransformer):u}getProxy(u){const{nid:b,sid:p}=u;return this._proxies[b]||(this._proxies[b]=this._createProxy(b,p)),this._proxies[b]}_createProxy(u,b){let p={get:(P,A)=>(typeof A=="string"&&!P[A]&&A.charCodeAt(0)===36&&(P[A]=(...a)=>this._remoteCall(u,A,a)),A===l?b:P[A])};return new Proxy(Object.create(null),p)}set(u,b){return this._locals[u.nid]=b,b}assertRegistered(u){for(let b=0,p=u.length;b<p;b++){const P=u[b];if(!this._locals[P.nid])throw new Error(`Missing actor ${P.sid} (isMain: ${P.isMain})`)}}_receiveOneMessage(u){if(this._isDisposed)return;const b=u.byteLength,p=m.read(u,0),P=p.readUInt8(),A=p.readUInt32();switch(P){case 1:case 2:{let{rpcId:a,method:R,args:M}=t.deserializeRequestJSONArgs(p);this._uriTransformer&&(M=D.transformIncomingURIs(M,this._uriTransformer)),this._receiveRequest(b,A,a,R,M,P===2);break}case 3:case 4:{let{rpcId:a,method:R,args:M}=t.deserializeRequestMixedArgs(p);this._uriTransformer&&(M=D.transformIncomingURIs(M,this._uriTransformer)),this._receiveRequest(b,A,a,R,M,P===4);break}case 5:{this._logger&&this._logger.logIncoming(b,A,0,"ack"),this._onDidReceiveAcknowledge(A);break}case 6:{this._receiveCancel(b,A);break}case 7:{this._receiveReply(b,A,void 0);break}case 9:{let a=t.deserializeReplyOKJSON(p);this._uriTransformer&&(a=D.transformIncomingURIs(a,this._uriTransformer)),this._receiveReply(b,A,a);break}case 8:{let a=t.deserializeReplyOKVSBuffer(p);this._receiveReply(b,A,a);break}case 10:{let a=t.deserializeReplyErrError(p);this._uriTransformer&&(a=D.transformIncomingURIs(a,this._uriTransformer)),this._receiveReplyErr(b,A,a);break}case 11:{this._receiveReplyErr(b,A,void 0);break}default:console.error("received unexpected message"),console.error(u)}}_receiveRequest(u,b,p,P,A,a){this._logger&&this._logger.logIncoming(u,b,1,`receiveRequest ${C.getStringIdentifierForProxy(p)}.${P}(`,A);const R=String(b);let M,H;if(a){const fe=new T.CancellationTokenSource;A.push(fe.token),M=this._invokeHandler(p,P,A),H=()=>fe.cancel()}else M=this._invokeHandler(p,P,A),H=w;this._cancelInvokedHandlers[R]=H;const ue=t.serializeAcknowledged(b);this._logger&&this._logger.logOutgoing(ue.byteLength,b,1,"ack"),this._protocol.send(ue),M.then(fe=>{delete this._cancelInvokedHandlers[R];const Y=t.serializeReplyOK(b,fe,this._uriReplacer);this._logger&&this._logger.logOutgoing(Y.byteLength,b,1,"reply:",fe),this._protocol.send(Y)},fe=>{delete this._cancelInvokedHandlers[R];const Y=t.serializeReplyErr(b,fe);this._logger&&this._logger.logOutgoing(Y.byteLength,b,1,"replyErr:",fe),this._protocol.send(Y)})}_receiveCancel(u,b){this._logger&&this._logger.logIncoming(u,b,1,"receiveCancel");const p=String(b);this._cancelInvokedHandlers[p]&&this._cancelInvokedHandlers[p]()}_receiveReply(u,b,p){this._logger&&this._logger.logIncoming(u,b,0,"receiveReply:",p);const P=String(b);if(!this._pendingRPCReplies.hasOwnProperty(P))return;const A=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P],A.resolveOk(p)}_receiveReplyErr(u,b,p){this._logger&&this._logger.logIncoming(u,b,0,"receiveReplyErr:",p);const P=String(b);if(!this._pendingRPCReplies.hasOwnProperty(P))return;const A=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P];let a;p&&(p.$isError?(a=new Error,a.name=p.name,a.message=p.message,a.stack=p.stack):a=p),A.resolveErr(a)}_invokeHandler(u,b,p){try{return Promise.resolve(this._doInvokeHandler(u,b,p))}catch(P){return Promise.reject(P)}}_doInvokeHandler(u,b,p){const P=this._locals[u];if(!P)throw new Error("Unknown actor "+C.getStringIdentifierForProxy(u));let A=P[b];if(typeof A!="function")throw new Error("Unknown method "+b+" on actor "+C.getStringIdentifierForProxy(u));return A.apply(P,p)}_remoteCall(u,b,p){if(this._isDisposed)return Promise.reject(S.canceled());let P=null;if(p.length>0&&T.CancellationToken.isCancellationToken(p[p.length-1])&&(P=p.pop()),P&&P.isCancellationRequested)return Promise.reject(S.canceled());const A=t.serializeRequestArguments(p,this._uriReplacer),a=++this._lastMessageId,R=String(a),M=new _.LazyPromise;P&&P.onCancellationRequested(()=>{const ue=t.serializeCancel(a);this._logger&&this._logger.logOutgoing(ue.byteLength,a,0,"cancel"),this._protocol.send(t.serializeCancel(a))}),this._pendingRPCReplies[R]=M,this._onWillSendRequest(a);const H=t.serializeRequest(a,u,b,A,!!P);return this._logger&&this._logger.logOutgoing(H.byteLength,a,0,`request: ${C.getStringIdentifierForProxy(u)}.${b}(`,p),this._protocol.send(H),M}}e.RPCProtocol=h,I=v,h.UNRESPONSIVE_TIME=3*1e3;class m{constructor(u,b){this._buff=u,this._offset=b}static alloc(u,b,p){let P=new m(i.VSBuffer.alloc(p+1+4),0);return P.writeUInt8(u),P.writeUInt32(b),P}static read(u,b){return new m(u,b)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(u){this._buff.writeUInt8(u,this._offset),this._offset+=1}readUInt8(){const u=this._buff.readUInt8(this._offset);return this._offset+=1,u}writeUInt32(u){this._buff.writeUInt32BE(u,this._offset),this._offset+=4}readUInt32(){const u=this._buff.readUInt32BE(this._offset);return this._offset+=4,u}static sizeShortString(u){return 1+u.byteLength}writeShortString(u){this._buff.writeUInt8(u.byteLength,this._offset),this._offset+=1,this._buff.set(u,this._offset),this._offset+=u.byteLength}readShortString(){const u=this._buff.readUInt8(this._offset);this._offset+=1;const p=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,p}static sizeLongString(u){return 4+u.byteLength}writeLongString(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readLongString(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,p}writeBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}static sizeVSBuffer(u){return 4+u.byteLength}writeVSBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readVSBuffer(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const b=this._buff.slice(this._offset,this._offset+u);return this._offset+=u,b}static sizeMixedArray(u,b){let p=0;p+=1;for(let P=0,A=u.length;P<A;P++){const a=u[P],R=b[P];switch(p+=1,R){case 1:p+=this.sizeLongString(a);break;case 2:p+=this.sizeVSBuffer(a);break;case 3:break}}return p}writeMixedArray(u,b){this._buff.writeUInt8(u.length,this._offset),this._offset+=1;for(let p=0,P=u.length;p<P;p++){const A=u[p];switch(b[p]){case 1:this.writeUInt8(1),this.writeLongString(A);break;case 2:this.writeUInt8(2),this.writeVSBuffer(A);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const u=this._buff.readUInt8(this._offset);this._offset+=1;let b=new Array(u);for(let p=0;p<u;p++)switch(this.readUInt8()){case 1:b[p]=this.readLongString();break;case 2:b[p]=this.readVSBuffer();break;case 3:b[p]=void 0;break}return b}}class t{static _arrayContainsBufferOrUndefined(u){for(let b=0,p=u.length;b<p;b++)if(u[b]instanceof i.VSBuffer||typeof u[b]=="undefined")return!0;return!1}static serializeRequestArguments(u,b){if(this._arrayContainsBufferOrUndefined(u)){let p=[],P=[];for(let A=0,a=u.length;A<a;A++){const R=u[A];R instanceof i.VSBuffer?(p[A]=R,P[A]=2):typeof R=="undefined"?(p[A]=i.VSBuffer.alloc(0),P[A]=3):(p[A]=i.VSBuffer.fromString(f(R,b)),P[A]=1)}return{type:"mixed",args:p,argsType:P}}return{type:"simple",args:f(u,b)}}static serializeRequest(u,b,p,P,A){return P.type==="mixed"?this._requestMixedArgs(u,b,p,P.args,P.argsType,A):this._requestJSONArgs(u,b,p,P.args,A)}static _requestJSONArgs(u,b,p,P,A){const a=i.VSBuffer.fromString(p),R=i.VSBuffer.fromString(P);let M=0;M+=m.sizeUInt8(),M+=m.sizeShortString(a),M+=m.sizeLongString(R);let H=m.alloc(A?2:1,u,M);return H.writeUInt8(b),H.writeShortString(a),H.writeLongString(R),H.buffer}static deserializeRequestJSONArgs(u){const b=u.readUInt8(),p=u.readShortString(),P=u.readLongString();return{rpcId:b,method:p,args:JSON.parse(P)}}static _requestMixedArgs(u,b,p,P,A,a){const R=i.VSBuffer.fromString(p);let M=0;M+=m.sizeUInt8(),M+=m.sizeShortString(R),M+=m.sizeMixedArray(P,A);let H=m.alloc(a?4:3,u,M);return H.writeUInt8(b),H.writeShortString(R),H.writeMixedArray(P,A),H.buffer}static deserializeRequestMixedArgs(u){const b=u.readUInt8(),p=u.readShortString(),P=u.readMixedArray(),A=new Array(P.length);for(let a=0,R=P.length;a<R;a++){const M=P[a];typeof M=="string"?A[a]=JSON.parse(M):A[a]=M}return{rpcId:b,method:p,args:A}}static serializeAcknowledged(u){return m.alloc(5,u,0).buffer}static serializeCancel(u){return m.alloc(6,u,0).buffer}static serializeReplyOK(u,b,p){return typeof b=="undefined"?this._serializeReplyOKEmpty(u):b instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(u,b):this._serializeReplyOKJSON(u,o(b,p))}static _serializeReplyOKEmpty(u){return m.alloc(7,u,0).buffer}static _serializeReplyOKVSBuffer(u,b){let p=0;p+=m.sizeVSBuffer(b);let P=m.alloc(8,u,p);return P.writeVSBuffer(b),P.buffer}static deserializeReplyOKVSBuffer(u){return u.readVSBuffer()}static _serializeReplyOKJSON(u,b){const p=i.VSBuffer.fromString(b);let P=0;P+=m.sizeLongString(p);let A=m.alloc(9,u,P);return A.writeLongString(p),A.buffer}static deserializeReplyOKJSON(u){const b=u.readLongString();return JSON.parse(b)}static serializeReplyErr(u,b){return b?this._serializeReplyErrEror(u,b):this._serializeReplyErrEmpty(u)}static _serializeReplyErrEror(u,b){const p=i.VSBuffer.fromString(o(S.transformErrorForSerialization(b),null));let P=0;P+=m.sizeLongString(p);let A=m.alloc(10,u,P);return A.writeLongString(p),A.buffer}static deserializeReplyErrError(u){const b=u.readLongString();return JSON.parse(b)}static _serializeReplyErrEmpty(u){return m.alloc(11,u,0).buffer}}var n;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var s;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(s||(s={}))}),define(we[208],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const g=function(E){const k=D=>{self.removeEventListener("message",k);const _=D.data;Object.defineProperties(self,{postMessage:{value(C,i){_.postMessage(C,i)}},onmessage:{get(){return _.onmessage},set(C){_.onmessage=C}}}),_.addEventListener("message",C=>{self.dispatchEvent(new MessageEvent("message",{data:C.data}))}),_.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(E)};self.addEventListener("message",k)}.toString();class T extends EventTarget{constructor(E,k,D){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const _=`((${g})('${k}'))`,C=new Blob([_],{type:"application/javascript"}),i=URL.createObjectURL(C),I=new MessageChannel,o=i,f={type:"_newWorker",id:o,port:I.port2,url:i,options:D};E(f,[I.port2]),this.postMessage=I.port1.postMessage.bind(I.port1),this.terminate=()=>{const c={type:"_terminateWorker",id:o};I.port1.postMessage(c),URL.revokeObjectURL(i),I.port1.close(),I.port2.close()},Object.defineProperties(this,{onmessage:{get(){return I.port1.onmessage},set(c){I.port1.onmessage=c}},onmessageerror:{get(){return I.port1.onmessageerror},set(c){I.port1.onmessageerror=c}}}),I.port1.addEventListener("messageerror",c=>{const d=new MessageEvent("messageerror",{data:c.data});this.dispatchEvent(d)}),I.port1.addEventListener("message",c=>{const d=new MessageEvent("message",{data:c.data});this.dispatchEvent(d)}),I.port1.start()}}e.NestedWorker=T}),define(we[209],_e([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=g.createDecorator("remoteAgentService")}),define(we[210],_e([0,1,16,14,21,2,4,93,45,173,209]),function(ee,e,g,T,S,E,k,D,_,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=k.createDecorator("pathService");let I=class xi{constructor(f,c,d,y){this.localUserHome=f,this.remoteAgentService=c,this.environmentService=d,this.contextService=y,this.resolveOS=(async()=>{const w=await this.remoteAgentService.getEnvironment();return(w==null?void 0:w.os)||S.OS})(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(w==null?void 0:w.userHome)||f})()}get defaultUriScheme(){return xi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,c){if(f.remoteAuthority)return g.Schemas.vscodeRemote;const d=D.getVirtualWorkspaceScheme(c.getWorkspace());if(d)return d;const y=c.getWorkspace().folders[0];if(y)return y.uri.scheme;const w=c.getWorkspace().configuration;return w?w.scheme:g.Schemas.file}async userHome(f){return(f==null?void 0:f.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?T.win32:T.posix)}async fileURI(f){let c="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const y=f.indexOf("/",2);y===-1?(c=f.substring(2),f="/"):(c=f.substring(2,y),f=f.substring(y)||"/")}return E.URI.from({scheme:g.Schemas.file,authority:c,path:f,query:"",fragment:""})}};I=Ve([ze(1,i.IRemoteAgentService),ze(2,C.IWorkbenchEnvironmentService),ze(3,_.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(we[103],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(k,D){this.line=k,this.character=D}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,D){return new g(0,0)}with(k){return new g(0,0)}}e.Position=g;class T{constructor(k,D,_,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(k,D),this.end=new g(_,C)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new T(0,0,0,0)}with(k){return new T(0,0,0,0)}}e.Range=T;var S;(function(E){E[E.Information=1]="Information",E[E.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[38],_e([0,1,17,27,24,43,8,4,14,11,103]),function(ee,e,g,T,S,E,k,D,_,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",o=" characters skipped \u27EB",f=(I.length+o.length+5)*2;e.ISearchService=D.createDecorator("searchService");var c;(function(L){L[L.file=0]="file",L[L.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(L){L[L.File=1]="File",L[L.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function y(L){return!!L.preview}e.resultIsMatch=y;function w(L){return!!L.resource}e.isFileMatch=w;function v(L){return!!L.message}e.isProgressMessage=v;var l;(function(L){L[L.Normal=0]="Normal",L[L.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class h{constructor(q){this.resource=q,this.results=[]}}e.FileMatch=h;class m{constructor(q,N,W){this.ranges=N;const U=Array.isArray(N)?N:[N];if(W&&W.matchLines===1&&t(U)){q=k.getNLines(q,W.matchLines);let B="",J=0,he=0;const De=Math.floor(W.charsPerLine/5),Oe=[];for(const Me of U){const He=Math.max(Me.startColumn-De,0),Ye=Me.startColumn+W.charsPerLine;if(He>he+De+f){const qe=I+(He-he)+o;B+=qe+q.slice(He,Ye),J+=He-(he+qe.length)}else B+=q.slice(he,Ye);Oe.push(new s(0,Me.startColumn-J,Me.endColumn-J)),he=Ye}this.preview={text:B,matches:Array.isArray(this.ranges)?Oe:Oe[0]}}else{const B=Array.isArray(N)?N[0].startLineNumber:N.startLineNumber;this.preview={text:q,matches:g.mapArrayOrNot(N,J=>new n(J.startLineNumber-B,J.startColumn,J.endLineNumber-B,J.endColumn))}}}}e.TextSearchMatch=m;function t(L){const q=L[0].startLineNumber;for(const N of L)if(N.startLineNumber!==q||N.endLineNumber!==q)return!1;return!0}class n{constructor(q,N,W,U){this.startLineNumber=q,this.startColumn=N,this.endLineNumber=W,this.endColumn=U}}e.SearchRange=n;class s extends n{constructor(q,N,W){super(q,N,q,W)}}e.OneLineRange=s;var r;(function(L){L.Default="default",L.FileNames="fileNames",L.Type="type",L.Modified="modified",L.CountDescending="countDescending",L.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function u(L,q=!0){const N=L&&L.files&&L.files.exclude,W=q&&L&&L.search&&L.search.exclude;if(!N&&!W)return;if(!N||!W)return N||W;let U=Object.create(null);return U=S.mixin(U,S.deepClone(N)),U=S.mixin(U,S.deepClone(W),!0),U}e.getExcludes=u;function b(L,q){return L.excludePattern&&T.match(L.excludePattern,q)?!1:L.includePattern||L.usingSearchPaths?L.includePattern&&T.match(L.includePattern,q)?!0:L.usingSearchPaths?!!L.folderQueries&&L.folderQueries.some(N=>{const W=N.folder.fsPath;if(E.isEqualOrParent(q,W)){const U=_.relative(W,q);return!N.includePattern||!!T.match(N.includePattern,U)}else return!1}):!1:!0}e.pathIncludedInQuery=b;var p;(function(L){L[L.unknownEncoding=1]="unknownEncoding",L[L.regexParseError=2]="regexParseError",L[L.globParseError=3]="globParseError",L[L.invalidLiteral=4]="invalidLiteral",L[L.rgProcessError=5]="rgProcessError",L[L.other=6]="other",L[L.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(q,N){super(q);this.code=N}}e.SearchError=P;function A(L){const q=L.message;if(C.isPromiseCanceledError(L))return new P(q,p.canceled);try{const N=JSON.parse(q);return new P(N.message,N.code)}catch(N){return new P(q,p.other)}}e.deserializeSearchError=A;function a(L){const q={message:L.message,code:L.code};return new Error(JSON.stringify(q))}e.serializeSearchError=a;function R(L){return L.type==="error"?!0:L.type==="success"}e.isSerializedSearchComplete=R;function M(L){return L.type==="success"}e.isSerializedSearchSuccess=M;function H(L){return!!L.path}e.isSerializedFileMatch=H;function ue(L,q){const N=L.searchPath?L.searchPath:L.relativePath;return k.fuzzyContains(N,q)}e.isFilePatternMatch=ue;class fe{constructor(q){this.path=q,this.results=[]}addMatch(q){this.results.push(q)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=fe;function Y(L,q){const N=Object.assign(Object.assign({},L||{}),q||{});return Object.keys(N).filter(W=>{const U=N[W];return typeof U=="boolean"&&U})}e.resolvePatternsForProvider=Y;class j{constructor(q,N){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},q.excludePattern||{}),N.excludePattern||{}),this._parsedExcludeExpression=T.parse(this._excludeExpression);let W=q.includePattern;N.includePattern&&(W?W=Object.assign(Object.assign({},W),N.includePattern):W=N.includePattern),W&&(this._parsedIncludeExpression=T.parse(W))}includedInQuerySync(q,N,W){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(q,N,W)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(q,N,W))}includedInQuery(q,N,W){return Promise.resolve(this._parsedExcludeExpression(q,N,W)).then(B=>!!B).then(B=>B?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(q,N,W)).then(J=>!!J):Promise.resolve(!0)).then(B=>B)}hasSiblingExcludeClauses(){return Z(this._excludeExpression)}}e.QueryGlobTester=j;function Z(L){for(const q in L)if(typeof L[q]!="boolean")return!0;return!1}}),define(we[30],_e([0,1,17,12,18,3,22,16,77,25,8,10,2,134,4,15,147,45,46,28,13,6,38,5]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o,f,c,d,y,w,v,l,h,m,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(R,M,H){return new C.ExtUri(ue=>p(ue,H)).isEqual(R,M)}function r(R,M,H){return s(R.uri,M.uri,H)?0:i.compare(R.uri.toString(),M.uri.toString())}function u(R,M,H){return R.index!==M.index?R.index<M.index?-1:1:s(R.uri,M.uri,H)?i.compare(R.name,M.name):i.compare(R.uri.toString(),M.uri.toString())}function b(R,M,H,ue){const fe=R.slice(0).sort((j,Z)=>H(j,Z,ue)),Y=M.slice(0).sort((j,Z)=>H(j,Z,ue));return g.delta(fe,Y,(j,Z)=>H(j,Z,ue))}function p(R,M){const H=M.getCapabilities(R.scheme);return!(H&&H&1024)}class P extends w.Workspace{constructor(M,H,ue,fe,Y,j){super(M,ue.map(Z=>new w.WorkspaceFolder(Z)),fe,j);this._name=H,this._isUntitled=Y,this._workspaceFolders=[],this._structure=k.TernarySearchTree.forUris(j),ue.forEach(Z=>{this._workspaceFolders.push(Z),this._structure.set(Z.uri,Z)})}static toExtHostWorkspace(M,H,ue,fe){if(!M)return{workspace:null,added:[],removed:[]};const{id:Y,name:j,folders:Z,configuration:L,isUntitled:q}=M,N=[],W=H;H?Z.forEach((he,De)=>{const Oe=o.URI.revive(he.uri),Me=P._findFolder(ue||H,Oe,fe);Me?(Me.name=he.name,Me.index=he.index,N.push(Me)):N.push({uri:Oe,name:he.name,index:De})}):N.push(...Z.map(({uri:he,name:De,index:Oe})=>({uri:o.URI.revive(he),name:De,index:Oe}))),N.sort((he,De)=>he.index<De.index?-1:1);const U=new P(Y,j,N,L?o.URI.revive(L):null,!!q,he=>p(he,fe)),{added:B,removed:J}=b(W?W.workspaceFolders:[],U.workspaceFolders,r,fe);return{workspace:U,added:B,removed:J}}static _findFolder(M,H,ue){for(let fe=0;fe<M.folders.length;fe++){const Y=M.workspaceFolders[fe];if(s(Y.uri,H,ue))return Y}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(M,H){return H&&this._structure.get(M)&&(M=C.dirname(M)),this._structure.findSubstr(M)}resolveWorkspaceFolder(M){return this._structure.get(M)}}let A=class{constructor(M,H,ue,fe){this._onDidChangeWorkspace=new E.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new E.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=fe,this._extHostFileSystemInfo=ue,this._requestIdProvider=new _.Counter,this._barrier=new T.Barrier,this._proxy=M.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=M.getProxy(n.MainContext.MainThreadMessageService);const Y=H.workspace;this._confirmedWorkspace=Y?new P(Y.id,Y.name,[],Y.configuration?o.URI.revive(Y.configuration):null,!!Y.isUntitled,j=>p(j,ue)):void 0}$initializeWorkspace(M,H){this._trusted=H,this.$acceptWorkspaceData(M),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?o.URI.from({scheme:D.Schemas.untitled,path:C.basename(C.dirname(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(M,H,ue,...fe){const Y=[];if(Array.isArray(fe)&&fe.forEach(N=>{o.URI.isUri(N.uri)&&!Y.some(W=>s(W.uri,N.uri,this._extHostFileSystemInfo))&&Y.push({uri:N.uri,name:N.name||C.basenameOrAuthority(N.uri)})}),this._unconfirmedWorkspace||[H,ue].some(N=>typeof N!="number"||N<0)||ue===0&&Y.length===0)return!1;const j=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(H+ue>j.length)return!1;const Z=j.slice(0);Z.splice(H,ue,...Y.map(N=>({uri:N.uri,name:N.name||C.basenameOrAuthority(N.uri),index:void 0})));for(let N=0;N<Z.length;N++){const W=Z[N];if(Z.some((U,B)=>B!==N&&s(W.uri,U.uri,this._extHostFileSystemInfo)))return!1}Z.forEach((N,W)=>N.index=W);const{added:L,removed:q}=b(j,Z,u,this._extHostFileSystemInfo);if(L.length===0&&q.length===0)return!1;if(this._proxy){const N=M.displayName||M.name;this._proxy.$updateWorkspaceFolders(N,H,ue,Y).then(void 0,W=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(y.Severity.Error,f.localize(0,null,N,W.toString()),{extension:M},[])})}return this.trySetWorkspaceFolders(Z),!0}getWorkspaceFolder(M,H){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,H)}async getWorkspaceFolder2(M,H){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,H)}async resolveWorkspaceFolder(M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(M)}getPath(){if(!this._actualWorkspace)return;const{folders:M}=this._actualWorkspace;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,H){let ue,fe="";if(typeof M=="string"?(ue=o.URI.file(M),fe=M):typeof M!="undefined"&&(ue=M,fe=M.fsPath),!ue)return fe;const Y=this.getWorkspaceFolder(ue,!0);if(!Y)return fe;typeof H=="undefined"&&this._actualWorkspace&&(H=this._actualWorkspace.folders.length>1);let j=C.relativePath(Y.uri,ue);return H&&Y.name&&(j=`${Y.name}/${j}`),j}trySetWorkspaceFolders(M){this._actualWorkspace&&(this._unconfirmedWorkspace=P.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:M,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:H,added:ue,removed:fe}=P.toExtHostWorkspace(M,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=H||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ue,removed:fe}))}findFiles(M,H,ue,fe,Y=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${fe.value}, entryPoint: findFiles`);let j;if(H===null?j=!1:H&&(typeof H=="string"?j=H:j=H.pattern),Y&&Y.isCancellationRequested)return Promise.resolve([]);const{includePattern:Z,folder:L}=a(M);return this._proxy.$startFileSearch(I.withUndefinedAsNull(Z),I.withUndefinedAsNull(L),I.withUndefinedAsNull(j),I.withUndefinedAsNull(ue),Y).then(q=>Array.isArray(q)?q.map(N=>o.URI.revive(N)):[])}async findTextInFiles(M,H,ue,fe,Y=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${fe.value}, entryPoint: findTextInFiles`);const j=this._requestIdProvider.getNext(),Z=typeof H.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:H.previewOptions,{includePattern:L,folder:q}=a(H.include),N=typeof H.exclude=="string"?H.exclude:H.exclude?H.exclude.pattern:void 0,W={ignoreSymlinks:typeof H.followSymlinks=="boolean"?!H.followSymlinks:void 0,disregardIgnoreFiles:typeof H.useIgnoreFiles=="boolean"?!H.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof H.useGlobalIgnoreFiles=="boolean"?!H.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof H.useDefaultExcludes=="boolean"?!H.useDefaultExcludes:!0,fileEncoding:H.encoding,maxResults:H.maxResults,previewOptions:Z,afterContext:H.afterContext,beforeContext:H.beforeContext,includePattern:L,excludePattern:N},U=!1;if(this._activeSearchCallbacks[j]=B=>{if(U)return;const J=o.URI.revive(B.resource);B.results.forEach(he=>{t.resultIsMatch(he)?ue({uri:J,preview:{text:he.preview.text,matches:g.mapArrayOrNot(he.preview.matches,De=>new m.Range(De.startLineNumber,De.startColumn,De.endLineNumber,De.endColumn))},ranges:g.mapArrayOrNot(he.ranges,De=>new m.Range(De.startLineNumber,De.startColumn,De.endLineNumber,De.endColumn))}):ue({uri:J,text:he.text,lineNumber:he.lineNumber})})},Y.isCancellationRequested)return{};try{const B=await this._proxy.$startTextSearch(M,I.withUndefinedAsNull(q),W,j,Y);return delete this._activeSearchCallbacks[j],B||{}}catch(B){throw delete this._activeSearchCallbacks[j],B}}$handleTextSearchResult(M,H){this._activeSearchCallbacks[H]&&this._activeSearchCallbacks[H](M)}saveAll(M){return this._proxy.$saveAll(M)}resolveProxy(M){return this._proxy.$resolveProxy(M)}get trusted(){return this._trusted}requestWorkspaceTrust(M){return this._proxy.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};A=Ve([ze(0,h.IExtHostRpcService),ze(1,l.IExtHostInitDataService),ze(2,v.IExtHostFileSystemInfo),ze(3,d.ILogService)],A),e.ExtHostWorkspace=A,e.IExtHostWorkspace=c.createDecorator("IExtHostWorkspace");function a(R){let M,H;return R&&(typeof R=="string"?M=R:(M=R.pattern,H=R.baseFolder||o.URI.file(R.base))),{includePattern:M,folder:H}}}),define(we[32],_e([0,1,24,3,30,5,6,151,61,10,12,4,13,15,2]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(n,s){if(s){const r=s.split(".");let u=n;for(let b=0;u&&b<r.length;b++)u=u[r[b]];return u}}function y(n){return n instanceof c.URI}function w(n){return n&&n.uri instanceof c.URI&&n.languageId&&typeof n.languageId=="string"}function v(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function l(n){return n&&n.uri instanceof c.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function h(n){if(y(n))return{resource:n};if(w(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(v(n))return{overrideIdentifier:n.languageId};if(l(n))return{resource:n.uri};if(n===null)return{resource:null}}let m=class{constructor(s,r,u){this._proxy=s.getProxy(E.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=u,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,r){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(s,r))}};m=Ve([ze(0,o.IExtHostRpcService),ze(1,S.IExtHostWorkspace),ze(2,f.ILogService)],m),e.ExtHostConfiguration=m;class t{constructor(s,r,u,b){this._onDidChangeConfiguration=new T.Emitter,this._proxy=s,this._logService=b,this._extHostWorkspace=r,this._configuration=D.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,r){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,u))}getConfiguration(s,r,u){const b=h(r)||{},p=this._toReadonlyValue(s?d(this._configuration.getValue(void 0,b,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,b,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,b,u==null?void 0:u.identifier);function P(a){if(a==null)return null;if(typeof a=="boolean")return a?1:4;switch(a){case k.ConfigurationTarget.Global:return 1;case k.ConfigurationTarget.Workspace:return 4;case k.ConfigurationTarget.WorkspaceFolder:return 5}}const A={has(a){return typeof d(p,a)!="undefined"},get:(a,R)=>{this._validateConfigurationAccess(s?`${s}.${a}`:a,b,u==null?void 0:u.identifier);let M=d(p,a);if(typeof M=="undefined")M=R;else{let H;const ue=(fe,Y)=>{let j;const Z=()=>{H=H||g.deepClone(p),j=j||d(H,Y)};return C.isObject(fe)?new Proxy(fe,{get:(L,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return Z(),()=>j;if(H)return j=j||d(H,Y),j[q];const N=L[q];return typeof q=="string"?ue(N,`${Y}.${q}`):N},set:(L,q,N)=>(Z(),j&&(j[q]=N),!0),deleteProperty:(L,q)=>(Z(),j&&delete j[q],!0),defineProperty:(L,q,N)=>(Z(),j&&Object.defineProperty(j,q,N),!0)}):fe};M=ue(M,a)}return M},update:(a,R,M,H)=>{a=s?`${s}.${a}`:a;const ue=P(M);return R!==void 0?this._proxy.$updateConfigurationOption(ue,a,R,b,H):this._proxy.$removeConfigurationOption(ue,a,b,H)},inspect:a=>{var R,M,H,ue,fe,Y,j,Z;a=s?`${s}.${a}`:a;const L=g.deepClone(this._configuration.inspect(a,b,this._extHostWorkspace.workspace));if(L)return{key:a,defaultValue:(R=L.default)===null||R===void 0?void 0:R.value,globalValue:(M=L.user)===null||M===void 0?void 0:M.value,workspaceValue:(H=L.workspace)===null||H===void 0?void 0:H.value,workspaceFolderValue:(ue=L.workspaceFolder)===null||ue===void 0?void 0:ue.value,defaultLanguageValue:(fe=L.default)===null||fe===void 0?void 0:fe.override,globalLanguageValue:(Y=L.user)===null||Y===void 0?void 0:Y.override,workspaceLanguageValue:(j=L.workspace)===null||j===void 0?void 0:j.override,workspaceFolderLanguageValue:(Z=L.workspaceFolder)===null||Z===void 0?void 0:Z.override,languageIds:L.overrideIdentifiers}}};return typeof p=="object"&&g.mixin(A,p,!1),Object.freeze(A)}_toReadonlyValue(s){const r=u=>C.isObject(u)?new Proxy(u,{get:(b,p)=>r(b[p]),set:(b,p,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(b,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(b,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:b=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return r(s)}_validateConfigurationAccess(s,r,u){const b=_.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),p=u?`[${u.value}] `:"";if(b===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(b===3){(r==null?void 0:r.resource)&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,r){const u=new D.ConfigurationChangeEvent(s,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(b,p)=>u.affectsConfiguration(b,h(p))})}_toMap(s){return s.reduce((r,u)=>(r.set(u[0],u[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=I.createDecorator("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Be=this&&this.__classPrivateFieldGet||function(ee,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[104],_e([0,1,2,12,3,5,6,30,36,32,18,37,13,28,4,16,21,15,70,162,11]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o,f,c,d,y,w,v,l,h){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(fe){function Y(Z){if(Z!=null)return Z}fe.from=Y;function j(Z){if(Z!=null)return Z}fe.to=j})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(fe){function Y(Z){if(Z!=null)return Z}fe.from=Y;function j(Z){if(Z!=null)return Z}fe.to=j})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(fe){function Y(Z){if(Z!=null)return Z}fe.from=Y;function j(Z){if(Z!=null)return Z}fe.to=j})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(fe){function Y(L){if(L){const q=L;return q&&!!q.process}else return!1}fe.is=Y;function j(L){if(L==null)return;const q={process:L.process,args:L.args};return L.options&&(q.options=s.from(L.options)),q}fe.from=j;function Z(L){if(L!=null)return new k.ProcessExecution(L.process,L.args,L.options)}fe.to=Z})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function(fe){function Y(Z){if(Z!=null)return Z}fe.from=Y;function j(Z){if(Z!=null)return Z}fe.to=j})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var b;(function(fe){function Y(L){if(L){const q=L;return q&&(!!q.commandLine||!!q.command)}else return!1}fe.is=Y;function j(L){if(L==null)return;const q={};return L.commandLine!==void 0?q.commandLine=L.commandLine:(q.command=L.command,q.args=L.args),L.options&&(q.options=u.from(L.options)),q}fe.from=j;function Z(L){if(!(L==null||L.command===void 0&&L.commandLine===void 0))return L.commandLine?new k.ShellExecution(L.commandLine,L.options):new k.ShellExecution(L.command,L.args?L.args:[],L.options)}fe.to=Z})(b=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var p;(function(fe){function Y(L){if(L){let q=L;return q&&q.customExecution==="customExecution"}else return!1}fe.is=Y;function j(L){return{customExecution:"customExecution"}}fe.from=j;function Z(L,q){return q.get(L)}fe.to=Z})(p=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var P;(function(fe){function Y(j,Z){let L;return j.scope!==void 0&&typeof j.scope!="number"?L=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===k.TaskScope.Workspace&&Z&&Z.workspaceFile?L=Z.workspaceFile:L=l.USER_TASKS_GROUP_KEY),{id:j._id,workspaceFolder:L}}fe.from=Y})(P=e.TaskHandleDTO||(e.TaskHandleDTO={}));var A;(function(fe){function Y(L,q){if(L==null)return[];const N=[];for(let W of L){const U=j(W,q);U&&N.push(U)}return N}fe.fromMany=Y;function j(L,q){if(L==null)return;let N;L.execution instanceof k.ProcessExecution?N=r.from(L.execution):L.execution instanceof k.ShellExecution?N=b.from(L.execution):L.execution&&L.execution instanceof k.CustomExecution&&(N=p.from(L.execution));const W=t.from(L.definition);let U;if(L.scope?typeof L.scope=="number"?U=L.scope:U=L.scope.uri:U=k.TaskScope.Workspace,!W||!U)return;const B=L.group?L.group.id:void 0;return{_id:L._id,definition:W,name:L.name,source:{extensionId:q.identifier.value,label:L.source,scope:U},execution:N,isBackground:L.isBackground,group:B,presentationOptions:n.from(L.presentationOptions),problemMatchers:L.problemMatchers,hasDefinedMatchers:L.hasDefinedMatchers,runOptions:L.runOptions?L.runOptions:{reevaluateOnRerun:!0},detail:L.detail}}fe.from=j;async function Z(L,q,N){if(L==null)return;let W;r.is(L.execution)?W=r.to(L.execution):b.is(L.execution)?W=b.to(L.execution):p.is(L.execution)&&(W=p.to(L._id,N));const U=t.to(L.definition);let B;if(L.source&&(L.source.scope!==void 0?typeof L.source.scope=="number"?B=L.source.scope:B=await q.resolveWorkspaceFolder(g.URI.revive(L.source.scope)):B=k.TaskScope.Workspace),!U||!B)return;const J=new k.Task(U,B,L.name,L.source.label,W,L.problemMatchers);return L.isBackground!==void 0&&(J.isBackground=L.isBackground),L.group!==void 0&&(J.group=k.TaskGroup.from(L.group)),L.presentationOptions&&(J.presentationOptions=n.to(L.presentationOptions)),L._id&&(J._id=L._id),L.detail&&(J.detail=L.detail),J}fe.to=Z})(A=e.TaskDTO||(e.TaskDTO={}));var a;(function(fe){function Y(Z){return Z}fe.from=Y;function j(Z){if(!!Z)return Object.assign(Object.create(null),Z)}fe.to=j})(a=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(Y,j,Z){this._id=j,this._task=Z,m.set(this,void 0),nt(this,m,Y,"f")}get task(){return this._task}terminate(){Be(this,m,"f").terminateTask(this)}fireDidStartProcess(Y){}fireDidEndProcess(Y){}}m=new WeakMap;var M;(function(fe){function Y(j){return{id:j._id,task:void 0}}fe.from=Y})(M=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let H=class{constructor(Y,j,Z,L,q,N,W,U){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=Y.getProxy(E.MainContext.MainThreadTask),this._workspaceProvider=Z,this._editorService=L,this._configurationService=q,this._terminalService=N,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=W,this._deprecationService=U,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(Y,j,Z){if(!Z)return new k.Disposable(()=>{});const L=this.nextHandle();return this._handlers.set(L,{type:j,provider:Z,extension:Y}),this._proxy.$registerTaskProvider(L,j),new k.Disposable(()=>{this._handlers.delete(L),this._proxy.$unregisterTaskProvider(L)})}registerTaskSystem(Y,j){this._proxy.$registerTaskSystem(Y,j)}fetchTasks(Y){return this._proxy.$fetchTasks(a.from(Y)).then(async j=>{const Z=[];for(let L of j){const q=await A.to(L,this._workspaceProvider,this._providedCustomExecutions2);q&&Z.push(q)}return Z})}get taskExecutions(){const Y=[];return this._taskExecutions.forEach(j=>Y.push(j)),Y}terminateTask(Y){if(!(Y instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(Y._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(Y,j,Z){const L=this._providedCustomExecutions2.get(Y.id);if(L){if(this._activeCustomExecutions2.get(Y.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(Y.id,L),this._terminalService.attachPtyToTerminal(j,await L.callback(Z))}this._lastStartedTask=Y.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(Y)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(Y){const j=await this.getTaskExecution(Y);this._taskExecutionPromises.delete(Y.id),this._taskExecutions.delete(Y.id),this.customExecutionComplete(Y),this._onDidTerminateTask.fire({execution:j})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(Y){const j=await this.getTaskExecution(Y.id);this._onDidTaskProcessStarted.fire({execution:j,processId:Y.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(Y){const j=await this.getTaskExecution(Y.id);this._onDidTaskProcessEnded.fire({execution:j,exitCode:Y.exitCode})}$provideTasks(Y,j){const Z=this._handlers.get(Y);if(!Z)return Promise.reject(new Error("no handler found"));const L=[],q=T.asPromise(()=>Z.provider.provideTasks(i.CancellationToken.None)).then(N=>this.provideTasksInternal(j,L,Z,N));return new Promise(N=>{q.then(W=>{Promise.all(L).then(()=>{N(W)})})})}async $resolveTask(Y,j){const Z=this._handlers.get(Y);if(!Z)return Promise.reject(new Error("no handler found"));if(j.definition.type!==Z.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${Z.type}].`);const L=await A.to(j,this._workspaceProvider,this._providedCustomExecutions2);if(!L)throw new Error("Unexpected: Task cannot be resolved.");const q=await Z.provider.resolveTask(L,i.CancellationToken.None);if(!q)return;this.checkDeprecation(q,Z);const N=A.from(q,Z.extension);if(!N)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==L.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(N.execution)&&await this.addCustomExecution(N,q,!0),await this.resolveTaskInternal(N)}nextHandle(){return this._handleCounter++}async addCustomExecution(Y,j,Z){const L=await this._proxy.$createTaskId(Y);!Z&&!this._providedCustomExecutions2.has(L)&&this._notProvidedCustomExecutions.add(L),this._providedCustomExecutions2.set(L,j.execution)}async getTaskExecution(Y,j){if(typeof Y=="string"){const q=this._taskExecutionPromises.get(Y);if(!q)throw new Error("Unexpected: The specified task is missing an execution");return q}let Z=this._taskExecutionPromises.get(Y.id);if(Z)return Z;const L=new Promise(async(q,N)=>{const W=j||await A.to(Y.task,this._workspaceProvider,this._providedCustomExecutions2);W?q(new R(this,Y.id,W)):N("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(Y.id,L),L.then(q=>(this._taskExecutions.set(Y.id,q),q),q=>Promise.reject(q))}checkDeprecation(Y,j){Y._deprecated&&this._deprecationService.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(Y){this._activeCustomExecutions2.get(Y.id)&&this._activeCustomExecutions2.delete(Y.id),this._notProvidedCustomExecutions.has(Y.id)&&this._lastStartedTask!==Y.id&&(this._providedCustomExecutions2.delete(Y.id),this._notProvidedCustomExecutions.delete(Y.id));let Z=this._notProvidedCustomExecutions.values(),L=Z.next();for(;!L.done;)!this._activeCustomExecutions2.has(L.value)&&this._lastStartedTask!==L.value&&(this._providedCustomExecutions2.delete(L.value),this._notProvidedCustomExecutions.delete(L.value)),L=Z.next()}};H=Ve([ze(0,o.IExtHostRpcService),ze(1,f.IExtHostInitDataService),ze(2,D.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,C.IExtHostConfiguration),ze(5,I.IExtHostTerminalService),ze(6,w.ILogService),ze(7,v.IExtHostApiDeprecationService)],H),e.ExtHostTaskBase=H;let ue=class extends H{constructor(Y,j,Z,L,q,N,W,U){super(Y,j,Z,L,q,N,W,U);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:y.PlatformToString(0)})}async executeTask(Y,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const Z=A.from(j,Y);if(Z===void 0)throw new Error("Task is not valid");if(p.is(Z.execution))await this.addCustomExecution(Z,j,!1);else throw new h.NotSupportedError;const L=await this.getTaskExecution(await this._proxy.$getTaskExecution(Z),j);return this._proxy.$executeTask(Z).catch(q=>{throw new Error(q)}),L}provideTasksInternal(Y,j,Z,L){const q=[];if(L)for(let N of L){this.checkDeprecation(N,Z),(!N.definition||!Y[N.definition.type])&&this._logService.warn(`The task [${N.source}, ${N.name}] uses an undefined task type. The task will be ignored in the future.`);const W=A.from(N,Z.extension);W&&p.is(W.execution)?(q.push(W),j.push(this.addCustomExecution(W,N,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:q,extension:Z.extension}}async resolveTaskInternal(Y){if(p.is(Y.execution))return Y;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(Y,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(Y,j,Z){}};ue=Ve([ze(0,o.IExtHostRpcService),ze(1,f.IExtHostInitDataService),ze(2,D.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,C.IExtHostConfiguration),ze(5,I.IExtHostTerminalService),ze(6,w.ILogService),ze(7,v.IExtHostApiDeprecationService)],ue),e.WorkerExtHostTask=ue,e.IExtHostTask=c.createDecorator("IExtHostTask")});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Be=this&&this.__classPrivateFieldGet||function(ee,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(ee):T?T.value:e.get(ee)},Si=this&&this.__rest||function(ee,e){var g={};for(var T in ee)Object.prototype.hasOwnProperty.call(ee,T)&&e.indexOf(T)<0&&(g[T]=ee[T]);if(ee!=null&&typeof Object.getOwnPropertySymbols=="function")for(var S=0,T=Object.getOwnPropertySymbols(ee);S<T.length;S++)e.indexOf(T[S])<0&&Object.prototype.propertyIsEnumerable.call(ee,T[S])&&(g[T[S]]=ee[T[S]]);return g};define(we[211],_e([0,1,17,12,23,18,3,49,40,7,24,10,2,34,4,5,36,13,64,9,6,30,172,96]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o,f,c,d,y,w,v,l,h,m,t,n){"use strict";var s,r,u,b,p;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let P=class{constructor(U,B,J){this.resultsChangedEmitter=new k.Emitter,this.controllers=new q,this.ownedTests=new t.OwnedTestCollection,this.mainThreadSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=U.getProxy(d.MainContext.MainThreadTesting),this.subscriptions=B.createInstance(N,this.ownedTests,this.controllers),this.runTracker=new a(this.proxy),this.workspaceObservers=new j(this.proxy),this.textDocumentObservers=new Z(this.proxy,J)}registerTestController(U,B){const J=f.generateUuid(),he=this.controllers.register(J,B);return this.proxy.$registerTestController(J),C.toDisposable(()=>{he.dispose(),this.proxy.$unregisterTestController(J)})}createTextDocumentTestObserver(U){return this.textDocumentObservers.checkout(U.uri)}createWorkspaceTestObserver(U){return this.workspaceObservers.checkout(U.uri)}async runTests(U,B=E.CancellationToken.None){const J=he=>he.map(this.getInternalTestForReference,this).filter(I.isDefined).map(De=>({src:De.src,testId:De.item.extId}));await this.proxy.$runTests({exclude:U.exclude?J(U.exclude).map(he=>he.testId):void 0,tests:J(U.tests),debug:U.debug},B)}createTestRun(U,B,J=!0){return this.runTracker.createTestRun(U,B,J)}$publishTestResults(U){this.results=Object.freeze(U.map(B=>i.deepFreeze(l.TestResults.to(B))).concat(this.results).sort((B,J)=>J.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(U,B){const J=o.URI.revive(B),{disposable:he,info:De}=await this.subscriptions.subscribeToTests(U,J);this.mainThreadSubscriptions.set(L(U,J),he),De&&(this.proxy.$publishDiff(U,J,De.collection.reviveDiff()),De.collection.onDidGenerateDiff(Oe=>this.proxy.$publishDiff(U,J,Oe)),De.initialSubscribeP.then(()=>De.collection.pushDiff([3,-1])))}async $expandTest(U,B){const J=this.subscriptions.getCollectionById(U.src.tree);J&&(await J.expand(U.testId,B<0?Infinity:B),J.flushDiff())}$unsubscribeFromTests(U,B){var J;const he=o.URI.revive(B),De=L(U,he);(J=this.mainThreadSubscriptions.get(De))===null||J===void 0||J.dispose(),this.mainThreadSubscriptions.delete(De)}$acceptDiff(U,B,J){U===1?this.textDocumentObservers.acceptDiff(o.URI.revive(B),J):this.workspaceObservers.acceptDiff(o.URI.revive(B),J)}async $runTestsForProvider(U,B){const J=this.controllers.get(U.tests[0].src.controller);if(!J)return;const he=U.tests.map(({testId:He,src:Ye})=>this.ownedTests.getTestById(He,Ye==null?void 0:Ye.tree)).filter(I.isDefined).map(([He,Ye])=>Ye),De=U.excludeExtIds.map(He=>this.ownedTests.getTestById(He)).filter(I.isDefined).filter(([He,Ye])=>he.some(qe=>He.comparePositions(qe,Ye)===1));if(!he.length)return;const Oe={tests:he.map(He=>H.unwrap(He.actual)),exclude:De.map(([,He])=>H.unwrap(He.actual)),debug:U.debug},Me=this.runTracker.prepareForMainThreadTestRun(Oe,R.fromInternal(U),B);try{await J.runTests(Oe,B)}finally{Me.isRunning&&!B.isCancellationRequested&&await k.Event.toPromise(Me.onEnd),this.runTracker.cancelRunById(U.runId)}}$cancelExtensionTestRun(U){U===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(U)}$lookupTest(U){const B=this.ownedTests.getTestById(U.testId);if(!B)return Promise.resolve(void 0);const J=B[1],{actual:he,discoverCts:De,expandLevels:Oe}=J,Me=Si(J,["actual","discoverCts","expandLevels"]);return Promise.resolve(Me)}getInternalTestForReference(U){var B,J;return(J=(B=this.workspaceObservers.getMirroredTestDataByReference(U))!==null&&B!==void 0?B:this.subscriptions.getCollectionTestByReference(U))!==null&&J!==void 0?J:this.textDocumentObservers.getMirroredTestDataByReference(U)}};P=Ve([ze(0,w.IExtHostRpcService),ze(1,c.IInstantiationService),ze(2,y.IExtHostDocumentsAndEditors)],P),e.ExtHostTesting=P;class A extends C.Disposable{constructor(U,B,J){super();this.dto=U,this.proxy=B,this.task=new Set,this.sharedTestIds=new Set,this.endEmitter=this._register(new k.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new E.CancellationTokenSource(J)),this._register(this.cts.token.onCancellationRequested(()=>{for(const he of this.task)he.end()}))}get isRunning(){return this.task.size>0}get id(){return this.dto.id}createRun(U){const B=new M(U,this.cts.token,this.dto,this.sharedTestIds,this.proxy,()=>{this.task.delete(B),this.isRunning||this.dispose()});return this.task.add(B),B}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}}class a{constructor(U){this.proxy=U,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(U,B,J){return this.getTracker(U,B,J)}cancelRunById(U){for(const B of this.tracked.values())if(B.id===U){B.dispose();return}}cancelAllRuns(){for(const U of this.tracked.values())U.dispose()}createTestRun(U,B,J){var he,De;const Oe=this.tracked.get(U);if(Oe)return Oe.createRun(B);const Me=R.fromPublic(U);this.proxy.$startedExtensionTestRun({debug:U.debug,exclude:(De=(he=U.exclude)===null||he===void 0?void 0:he.map(Ye=>Ye.id))!==null&&De!==void 0?De:[],id:Me.id,tests:U.tests.map(Ye=>Ye.id),persist:J});const He=this.getTracker(U,Me);return He.onEnd(()=>this.proxy.$finishedExtensionTestRun(Me.id)),He.createRun(B)}getTracker(U,B,J){const he=new A(B,this.proxy,J);return this.tracked.set(U,he),he.onEnd(()=>this.tracked.delete(U)),he}}e.TestRunCoordinator=a;class R{constructor(U,B,J){this.id=U,this.include=B,this.exclude=J}static fromPublic(U){var B,J;return new R(f.generateUuid(),new Set(U.tests.map(he=>he.id)),new Set((J=(B=U.exclude)===null||B===void 0?void 0:B.map(he=>he.id))!==null&&J!==void 0?J:_.Iterable.empty()))}static fromInternal(U){return new R(U.runId,new Set(U.tests.map(B=>B.testId)),new Set(U.excludeExtIds))}isIncluded(U){for(let B=U;B;B=B.parent){if(this.include.has(B.id))return!0;if(this.exclude.has(B.id))return!1}return!0}}e.TestRunDto=R;class M{constructor(U,B,J,he,De,Oe){this.name=U,this.token=B,s.set(this,void 0),r.set(this,void 0),u.set(this,void 0),b.set(this,void 0),p.set(this,!1),this.taskId=f.generateUuid(),nt(this,b,Oe,"f"),nt(this,s,De,"f"),nt(this,r,J,"f"),nt(this,u,he,"f"),De.$startedTestRunTask(J.id,{id:this.taskId,name:U,running:!0})}setState(U,B,J){!Be(this,p,"f")&&Be(this,r,"f").isIncluded(U)&&(this.ensureTestIsKnown(U),Be(this,s,"f").$updateTestStateInRun(Be(this,r,"f").id,this.taskId,U.id,B,J))}appendMessage(U,B){!Be(this,p,"f")&&Be(this,r,"f").isIncluded(U)&&(this.ensureTestIsKnown(U),Be(this,s,"f").$appendTestMessageInRun(Be(this,r,"f").id,this.taskId,U.id,l.TestMessage.from(B)))}appendOutput(U){Be(this,p,"f")||Be(this,s,"f").$appendOutputToRun(Be(this,r,"f").id,this.taskId,S.VSBuffer.fromString(U))}end(){Be(this,p,"f")||(nt(this,p,!0,"f"),Be(this,s,"f").$finishedTestRunTask(Be(this,r,"f").id,this.taskId),Be(this,b,"f").call(this))}ensureTestIsKnown(U){const B=Be(this,u,"f");if(B.has(U.id))return;const J=[];for(;J.unshift(l.TestItem.from(U)),!(B.has(U.id)||(B.add(U.id),!U.parent));)U=U.parent;Be(this,s,"f").$addTestsToRun(Be(this,r,"f").id,J)}}s=new WeakMap,r=new WeakMap,u=new WeakMap,b=new WeakMap,p=new WeakMap;class H extends h.TestItemImpl{constructor(U,B,J){super(U.id,U.label,U.uri,void 0);if(this.actual=U,this.filterDocument=B,this.wrappedParent=J,this.disposable=new C.DisposableStore,!(U instanceof h.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${U.id} did not`);this.debuggable=U.debuggable,this.runnable=U.runnable,this.description=U.description,this.error=U.error,this.status=U.status,this.range=U.range;const he=v.getPrivateApiFor(this),De=v.getPrivateApiFor(U);this.disposable.add(De.bus.event(Oe=>{switch(Oe[0]){case 3:this[Oe[1]]=Oe[2];break;case 0:const Me=H.getWrapperForTestItem(Oe[1],this.filterDocument,this);v.getPrivateApiFor(Me).parent=U,Me.refreshMatch();break;case 1:this.dispose();break;default:he.bus.fire(Oe)}}))}static removeFilter(U){this.wrapperMap.delete(U)}static getWrapperForTestItem(U,B,J){let he=this.wrapperMap.get(B);if(he==null?void 0:he.has(U))return he.get(U);he||(he=new WeakMap,this.wrapperMap.set(B,he));const De=new H(U,B,J);return he.set(U,De),De}static unwrap(U){return U instanceof H?U.actual:U}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var U,B;if(this.disposed)return!1;const J=this._cachedMatchesFilter;for(const De of this.actual.children.values()){const Oe=H.getWrapperForTestItem(De,this.filterDocument,this);Oe.hasNodeMatchingFilter?this.children.has(Oe.id)||this.addChild(Oe):Oe.hide()}const he=this.children.size>0||((U=this.actual.uri)===null||U===void 0?void 0:U.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=he,he!==J&&((B=this.wrappedParent)===null||B===void 0?void 0:B._cachedMatchesFilter)!==void 0&&this.wrappedParent.refreshMatch(),this._cachedMatchesFilter}hide(){this.wrappedParent&&v.getPrivateApiFor(this.wrappedParent).children.delete(this.id),v.getPrivateApiFor(this).bus.fire([1])}dispose(){var U;if(!this.disposed){this.disposed=!0,this.disposable.dispose(),this.hide(),(U=this.wrappedParent)===null||U===void 0||U.refreshMatch();for(const B of this.children.values())B.dispose()}}}e.TestItemFilteredWrapper=H,H.wrapperMap=new WeakMap;class ue extends n.IncrementalChangeCollector{constructor(U){super();this.emitter=U,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(U){this.added.add(U)}update(U){Object.assign(U.revived,l.TestItem.toPlain(U.item)),this.added.has(U)||this.updated.add(U)}remove(U){if(this.added.has(U)){this.added.delete(U);return}if(this.updated.delete(U),U.parent&&this.alreadyRemoved.has(U.parent)){this.alreadyRemoved.add(U.item.extId);return}this.removed.add(U)}getChangeEvent(){const{added:U,updated:B,removed:J}=this;return{get added(){return[...U].map(he=>he.revived)},get updated(){return[...B].map(he=>he.revived)},get removed(){return[...J].map(he=>he.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class fe extends n.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new k.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(U){let B=[];for(const J of U){const he=this.items.get(J);he&&B.push(he.revived)}return B}getMirroredTestDataById(U){return this.items.get(U)}getMirroredTestDataByReference(U){return this.items.get(U.id)}createItem(U,B){return Object.assign(Object.assign({},U),{revived:l.TestItem.toPlain(U.item),depth:B?B.depth+1:0,children:new Set})}createChangeCollector(){return new ue(this.changeEmitter)}}e.MirroredTestCollection=fe;class Y{constructor(){this.resources=new Map}checkout(U){var B,J;const he=U.toString(),De=(B=this.resources.get(he))!==null&&B!==void 0?B:this.createObserverData(U);return(J=De.pendingDeletion)===null||J===void 0||J.dispose(),De.observers++,{onDidChangeTest:De.tests.onDidChangeTests,onDidDiscoverInitialTests:new k.Emitter().event,get tests(){return De.tests.rootTestItems},dispose:D.once(()=>{--De.observers||(De.pendingDeletion=this.eventuallyDispose(U))})}}getMirroredTestDataByReference(U){for(const{tests:B}of this.resources.values()){const J=B.getMirroredTestDataByReference(U);if(J)return J}}eventuallyDispose(U){return T.disposableTimeout(()=>this.unlisten(U),10*1e3)}createObserverData(U){const B=new fe,J=this.listen(U,De=>B.apply(De)),he={observers:0,tests:B,listener:J};return this.resources.set(U.toString(),he),he}unlisten(U){var B;const J=U.toString(),he=this.resources.get(J);he&&(he.observers=-1,(B=he.pendingDeletion)===null||B===void 0||B.dispose(),he.listener.dispose(),this.resources.delete(J))}}class j extends Y{constructor(U){super();this.proxy=U,this.diffListeners=new Map}acceptDiff(U,B){var J;(J=this.diffListeners.get(U.toString()))===null||J===void 0||J(B)}listen(U,B){this.proxy.$subscribeToDiffs(0,U);const J=U.toString();return this.diffListeners.set(J,B),C.toDisposable(()=>{this.proxy.$unsubscribeFromDiffs(0,U),this.diffListeners.delete(J)})}}class Z extends Y{constructor(U,B){super();this.proxy=U,this.documents=B,this.diffListeners=new Map}acceptDiff(U,B){var J;(J=this.diffListeners.get(U.toString()))===null||J===void 0||J(B)}listen(U,B){if(!this.documents.getDocument(U))return C.toDisposable(()=>{});const he=U.toString();return this.diffListeners.set(he,B),this.proxy.$subscribeToDiffs(1,U),C.toDisposable(()=>{this.proxy.$unsubscribeFromDiffs(1,U),this.diffListeners.delete(he)})}}const L=(W,U)=>`${W}:${U.toString()}`;class q extends C.Disposable{constructor(){super(...arguments);this.registeredEmitter=this._register(new k.Emitter),this.unregisteredEmitter=this._register(new k.Emitter),this.value=new Map,this.onRegistered=this.registeredEmitter.event}register(U,B){return this.value.set(U,B),this.registeredEmitter.fire({controller:B,controllerId:U}),C.toDisposable(()=>{this.value.delete(U),this.unregisteredEmitter.fire({controller:B,controllerId:U})})}get(U){return this.value.get(U)}[Symbol.iterator](){return this.value[Symbol.iterator]()}}let N=class extends C.Disposable{constructor(U,B,J,he){super();this.ownedTests=U,this.controllers=B,this.documents=J,this.workspace=he,this.subs=new Map,this._register(B.onRegistered(({controller:De,controllerId:Oe})=>{const Me=[...this.subs.values()];setTimeout(()=>{for(const{subscribeFn:He}of Me)He(Oe,De)},0)}))}getCollectionById(U){return g.mapFind(this.subs.values(),B=>B.collection.treeId===U?B.collection:void 0)}getCollectionTestByReference(U){return g.mapFind(this.subs.values(),B=>B.collection.getTestByReference(U))}async createDefaultDocumentTestRoot(U,B,J,he){if(!U)return;const{disposable:De,info:Oe}=await this.subscribeToTests(0,U.uri);if(!Oe)return;const Me=_.Iterable.find(Oe.collection.roots,Ye=>Ye.src.controller===J);if(!Me)return;const He=H.getWrapperForTestItem(Me.actual,B);return Oe.collection.expand(Me.actual.id,Infinity),He.refreshMatch(),he.onCancellationRequested(()=>{H.removeFilter(B),He.dispose(),De.dispose()}),He}async subscribeToTests(U,B){const J=L(U,B),he=this.subs.get(J);if(he)return he.listeners++,{disposable:this.getUnsubscriber(J),info:he};const De=new E.CancellationTokenSource;let Oe;if(U===1){let G=this.documents.getDocument(B);if(!G){const te=new C.DisposableStore;G=await new Promise(re=>{te.add(T.disposableTimeout(()=>re(void 0),5e3)),te.add(this.documents.onDidAddDocuments(K=>{const oe=K.find(me=>me.document.uri.toString()===B.toString());oe&&re(oe)}))}).finally(()=>te.dispose())}if(G){const te=await this.workspace.getWorkspaceFolder2(B,!1);Oe=(re,K)=>re.createDocumentTestRoot?re.createDocumentTestRoot(G.document,De.token):this.createDefaultDocumentTestRoot(te,G.document,K,De.token)}}else{const G=await this.workspace.getWorkspaceFolder2(B,!1);G&&(Oe=te=>te.createWorkspaceTestRoot(G,De.token))}if(!Oe)return{disposable:C.toDisposable(()=>{}),info:void 0};const Me=async(G,te)=>{try{const re=await Oe(te,G);re&&Ye.addRoot(re,G)}catch(re){console.error(re)}},He=new C.DisposableStore,Ye=He.add(this.ownedTests.createForHierarchy());He.add(C.toDisposable(()=>De.dispose(!0)));const qe=[];for(const[G,te]of this.controllers)qe.push(Me(G,te));const Xe=Promise.all(qe).then(()=>{}),$={store:He,listeners:1,initialSubscribeP:Xe,collection:Ye,subscribeFn:Me};return this.subs.set(J,$),{disposable:this.getUnsubscriber(J),info:$}}getUnsubscriber(U){return C.toDisposable(()=>{const B=this.subs.get(U);B&&--B.listeners==0&&(B.store.dispose(),this.subs.delete(U))})}};N=Ve([ze(2,y.IExtHostDocumentsAndEditors),ze(3,m.IExtHostWorkspace)],N)}),define(we[212],_e([0,1,17,76,27,81,22,16,14,25,8,10,2,116,136,91,45,165,210,38]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o,f,c,d,y,w,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(P,A,a,R){this.configurationService=P,this.workspaceContextService=A,this.editorGroupsService=a,this.pathService=R}text(P,A,a={}){P=this.getContentPattern(P,a);const R=this.configurationService.getValue(),M=A&&A.some(ue=>!this.configurationService.getValue({resource:ue}).search.useRipgrep),H=this.commonQuery(A==null?void 0:A.map(y.toWorkspaceFolder),a);return Object.assign(Object.assign({},H),{type:2,contentPattern:P,previewOptions:a.previewOptions,maxFileSize:a.maxFileSize,usePCRE2:R.search.usePCRE2||M||!1,beforeContext:a.beforeContext,afterContext:a.afterContext,userDisabledExcludesAndIgnoreFiles:a.disregardExcludeSettings&&a.disregardIgnoreFiles})}getContentPattern(P,A){const a=this.configurationService.getValue();P.isRegExp&&(P.pattern=P.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},P),{wordSeparators:a.editor.wordSeparators});return this.isCaseSensitive(P,A)&&(R.isCaseSensitive=!0),this.isMultiline(P)&&(R.isMultiline=!0),R}file(P,A={}){const a=this.commonQuery(P,A);return Object.assign(Object.assign({},a),{type:1,filePattern:A.filePattern?A.filePattern.trim():A.filePattern,exists:A.exists,sortByScore:A.sortByScore,cacheKey:A.cacheKey})}handleIncludeExclude(P,A){return P?(P=Array.isArray(P)?P.map(r):r(P),A?this.parseSearchPaths(P):{pattern:t(...Array.isArray(P)?P:[P])}):{}}commonQuery(P=[],A={}){const a=this.handleIncludeExclude(A.includePattern,A.expandPatterns),R=this.handleIncludeExclude(A.excludePattern,A.expandPatterns),M=P.length>1,H=(a.searchPaths&&a.searchPaths.length?a.searchPaths.map(Y=>this.getFolderQueryForSearchPath(Y,A,R)):P.map(Y=>this.getFolderQueryForRoot(Y,A,R,M))).filter(Y=>!!Y),ue={_reason:A._reason,folderQueries:H,usingSearchPaths:!!(a.searchPaths&&a.searchPaths.length),extraFileResources:A.extraFileResources,excludePattern:R.pattern,includePattern:a.pattern,onlyOpenEditors:A.onlyOpenEditors,maxResults:A.maxResults};if(A.onlyOpenEditors){const j=g.coalesce(g.flatten(this.editorGroupsService.groups.map(L=>L.editors.map(q=>q.resource)))).filter(L=>l.pathIncludedInQuery(ue,L.fsPath)),Z=this.commonQueryFromFileList(j);return Object.assign(Object.assign({},ue),Z)}const fe=A.extraFileResources&&A.extraFileResources.filter(Y=>l.pathIncludedInQuery(ue,Y.fsPath));return ue.extraFileResources=fe&&fe.length?fe:void 0,ue}commonQueryFromFileList(P){const A=[],a=new k.ResourceMap,R={};let M=!1;return P.forEach(H=>{var ue,fe;if(H.scheme===D.Schemas.walkThrough)return;if(C.isAbsolutePath(H)){const j=(fe=(ue=this.workspaceContextService.getWorkspaceFolder(H))===null||ue===void 0?void 0:ue.uri)!==null&&fe!==void 0?fe:H.with({path:_.dirname(H.fsPath)});let Z=a.get(j);Z||(M=!0,Z={folder:j,includePattern:{}},A.push(Z),a.set(j,Z));const L=_.relative(j.fsPath,H.fsPath);I.assertIsDefined(Z.includePattern)[L.replace(/\\/g,"/")]=!0}else H.fsPath&&(M=!0,R[H.fsPath]=!0)}),{folderQueries:A,includePattern:R,usingSearchPaths:!0,excludePattern:M?void 0:{"**/*":!0}}}isCaseSensitive(P,A){if(A.isSmartCase){if(P.isRegExp){if(i.containsUppercaseCharacter(P.pattern,!0))return!0}else if(i.containsUppercaseCharacter(P.pattern))return!0}return!!P.isCaseSensitive}isMultiline(P){return P.isMultiline||P.isRegExp&&f.isMultilineRegexSource(P.pattern)||P.pattern.indexOf(`
`)>=0?!0:!!P.isMultiline}parseSearchPaths(P){const A=Z=>_.isAbsolute(Z)||/^\.\.?([\/\\]|$)/.test(Z),R=(Array.isArray(P)?P:n(P)).map(Z=>{const L=this.pathService.resolvedUserHome;return L?E.untildify(Z,L.scheme===D.Schemas.file?L.fsPath:L.path):Z}),M=T.groupBy(R,Z=>A(Z)?"searchPaths":"exprSegments"),H=(M.exprSegments||[]).map(Z=>i.rtrim(Z,"/")).map(Z=>i.rtrim(Z,"\\")).map(Z=>(Z[0]==="."&&(Z="*"+Z),s(Z))),ue={},fe=this.expandSearchPathPatterns(M.searchPaths||[]);fe&&fe.length&&(ue.searchPaths=fe);const Y=g.flatten(H),j=t(...Y);return j&&(ue.pattern=j),ue}getExcludesForFolder(P,A){return A.disregardExcludeSettings?void 0:l.getExcludes(P,!A.disregardSearchExcludeSettings)}expandSearchPathPatterns(P){if(!P||!P.length)return[];const A=g.flatten(P.map(R=>{let{pathPortion:M,globPortion:H}=m(R);H&&(H=u(H));const ue=this.expandOneSearchPath(M);return g.flatten(ue.map(fe=>this.resolveOneSearchPathPattern(fe,H)))})),a=new Map;return A.forEach(R=>{const M=R.searchPath.toString(),H=a.get(M);H?R.pattern&&(H.pattern=H.pattern||{},H.pattern[R.pattern]=!0):a.set(M,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(a.values())}expandOneSearchPath(P){if(_.isAbsolute(P)){const A=this.workspaceContextService.getWorkspace().folders;return A[0]&&A[0].uri.scheme!==D.Schemas.file?[{searchPath:A[0].uri.with({path:P})}]:[{searchPath:o.URI.file(_.normalize(P))}]}if(this.workspaceContextService.getWorkbenchState()===2){const A=this.workspaceContextService.getWorkspace().folders[0].uri;if(P=r(P),P.startsWith("../")||P===".."){const R=_.posix.resolve(A.path,P);return[{searchPath:A.with({path:R})}]}const a=u(P);return[{searchPath:A,pattern:a}]}else{if(P==="./"||P===".\\")return[];{const A=P.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(M=>{const H=A.match(new RegExp(`^${i.escapeRegExpCharacters(M.name)}(?:/(.*)|$)`));return H?{match:H,folder:M}:null}).filter(I.isDefined);if(R.length)return R.map(M=>{const H=M.match[1];return{searchPath:M.folder.uri,pattern:H&&u(H)}});{const M=P.match(/\.[\/\\](.+)[\/\\]?/),H=M?M[1]:P,ue=c.localize(0,null,H);throw new Error(ue)}}}}resolveOneSearchPathPattern(P,A){const a=P.pattern&&A?`${P.pattern}/${A}`:P.pattern||A,R=[{searchPath:P.searchPath,pattern:a}];return a&&!a.endsWith("**")&&R.push({searchPath:P.searchPath,pattern:a+"/**"}),R}getFolderQueryForSearchPath(P,A,a){const R=this.getFolderQueryForRoot(y.toWorkspaceFolder(P.searchPath),A,a,!1);return R?Object.assign(Object.assign({},R),{includePattern:P.pattern}):null}getFolderQueryForRoot(P,A,a,R){let M;const H=o.URI.isUri(P)?P:P.uri;if(a.searchPaths){const Z=a.searchPaths.filter(L=>C.isEqual(L.searchPath,H))[0];if(Z&&!Z.pattern)return null;Z&&(M=Z.pattern)}const ue=this.configurationService.getValue({resource:H}),fe=this.getExcludesForFolder(ue,A),Y=Object.assign(Object.assign({},fe||{}),M||{}),j=o.URI.isUri(P)?C.basename(P):P.name;return{folder:H,folderName:R?j:void 0,excludePattern:Object.keys(Y).length>0?Y:void 0,fileEncoding:ue.files&&ue.files.encoding,disregardIgnoreFiles:typeof A.disregardIgnoreFiles=="boolean"?A.disregardIgnoreFiles:!ue.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof A.disregardGlobalIgnoreFiles=="boolean"?A.disregardGlobalIgnoreFiles:!ue.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof A.ignoreSymlinks=="boolean"?A.ignoreSymlinks:!ue.search.followSymlinks}}};h=Ve([ze(0,d.IConfigurationService),ze(1,y.IWorkspaceContextService),ze(2,w.IEditorGroupsService),ze(3,v.IPathService)],h),e.QueryBuilder=h;function m(p){const P=p.match(/[\*\{\}\(\)\[\]\?]/);if(P){const A=P.index,a=p.substr(0,A).match(/[/|\\][^/\\]*$/);if(a){let R=p.substr(0,a.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:p.substr((a.index||0)+1)}}}return{pathPortion:p}}function t(...p){return p.length?p.reduce((P,A)=>(P[A]=!0,P),Object.create(null)):void 0}function n(p){return S.splitGlobAware(p,",").map(P=>P.trim()).filter(P=>!!P.length)}function s(p){return[`**/${p}/**`,`**/${p}`].map(A=>A.replace(/\*\*\/\*\*/g,"**"))}function r(p){return p.replace(/\\/g,"/")}function u(p){return r(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function b(p,P){p=g.distinct(p,R=>R.toString());const A=[],a=P.getWorkspace();return p&&p.forEach(R=>{let M;if(P.getWorkbenchState()===2)M=C.relativePath(a.folders[0].uri,R),M&&M!=="."&&(M="./"+M);else{const H=P.getWorkspaceFolder(R);if(H){const ue=H.name;if(a.folders.filter(Y=>Y.name===ue).length===1){const Y=C.relativePath(H.uri,R);Y===""?M=`./${H.name}`:M=`./${H.name}/${Y}`}else M=R.fsPath}}M&&A.push(M)}),A}e.resolveResourcesForSearchIncludes=b}),define(we[213],_e([0,1,25,2,18,11,4,212,38,45]),function(ee,e,g,T,S,E,k,D,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function I(d,y){const w=y.activationEvents;if(!w)return Promise.resolve(void 0);const v=[],l=[];for(const r of w)if(/^workspaceContains:/.test(r)){const u=r.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||d.forceUsingSearch?l.push(u):v.push(u)}if(v.length===0&&l.length===0)return Promise.resolve(void 0);let h;const m=new Promise((r,u)=>{h=r}),t=r=>h({activationEvent:r}),n=Promise.all(v.map(r=>o(d,r,t))).then(()=>{}),s=f(d,y.identifier,l,t);return Promise.all([n,s]).then(()=>{h(void 0)}),m}e.checkActivateWorkspaceContainsExtension=I;async function o(d,y,w){for(const v of d.folders)if(await d.exists(g.joinPath(T.URI.revive(v),y))){w(`workspaceContains:${y}`);return}}async function f(d,y,w,v){if(w.length===0)return Promise.resolve(void 0);const l=new S.CancellationTokenSource,h=d.checkExists(d.folders,w,l.token),m=setTimeout(async()=>{l.cancel(),v(`workspaceContainsTimeout:${w.join(",")}`)},i);let t=!1;try{t=await h}catch(n){E.isPromiseCanceledError(n)||E.onUnexpectedError(n)}l.dispose(),clearTimeout(m),t&&v(`workspaceContains:${w.join(",")}`)}function c(d,y,w,v){const l=d.get(k.IInstantiationService),h=d.get(_.ISearchService),t=l.createInstance(D.QueryBuilder).file(y.map(n=>C.toWorkspaceFolder(T.URI.revive(n))),{_reason:"checkExists",includePattern:w,exists:!0});return h.fileSearch(t,v).then(n=>!!n.limitHit,n=>E.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=c});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Be=this&&this.__classPrivateFieldGet||function(ee,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[33],_e([0,1,129,14,75,25,12,7,22,2,15,5,32,176,73,30,29,174,11,26,23,153,6,92,4,28,74,13,60,65,37,3,213,69,155]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o,f,c,d,y,w,v,l,h,m,t,n,s,r,u,b,p,P,A,a,R,M,H){"use strict";var ue,fe,Y;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=s.createDecorator("IHostUtils");let j=class Bi extends D.Disposable{constructor(N,W,U,B,J,he,De,Oe,Me,He){super();this._onDidChangeRemoteConnectionData=this._register(new a.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=W,this._extHostContext=U,this._initData=De,this._extHostWorkspace=B,this._extHostConfiguration=J,this._logService=he,this._extHostTunnelService=Me,this._extHostTerminalService=He,this._disposables=new D.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new k.Barrier,this._readyToStartExtensionHost=new k.Barrier,this._readyToRunExtensions=new k.Barrier,this._eagerExtensionsActivated=new k.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new c.ExtHostStorage(this._extHostContext),this._secretState=new M.ExtHostSecretState(this._extHostContext),this._storagePath=Oe,this._instaService=N.createChild(new p.ServiceCollection([c.IExtHostStorage,this._storage],[M.IExtHostSecretState,this._secretState]));const Ye=new Set;this._initData.hostExtensions.forEach(qe=>Ye.add(l.ExtensionIdentifier.toKey(qe))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(qe,Xe,$)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(qe,v.transformErrorForSerialization(Xe),$)},actualActivateExtension:async(qe,Xe)=>{if(Ye.has(l.ExtensionIdentifier.toKey(qe)))return await this._mainThreadExtensionsProxy.$activateExtension(qe,Xe),new f.HostExtension;const $=this._registry.getExtensionDescription(qe);return this._activateExtension($,Xe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(N){v.onUnexpectedError(N)}}async deactivateAll(){let N=[];try{N=this._registry.getAllExtensionDescriptions().map(J=>J.identifier).filter(J=>this.isActivated(J)).map(J=>this._deactivate(J))}catch(W){}await Promise.all(N)}isActivated(N){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(N):!1}_activateByEvent(N,W){return this._activator.activateByEvent(N,W)}_activateById(N,W){return this._activator.activateById(N,W)}activateByIdWithErrors(N,W){return this._activateById(N,W).then(()=>{const U=this._activator.getActivatedExtension(N);if(U.activationFailed)return Promise.reject(U.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(N=>this._registry)}getExtensionExports(N){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(N).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const N=_.TernarySearchTree.forPaths(),W=this._registry.getAllExtensionDescriptions().map(U=>{if(!!this._getEntryPoint(U))return this._hostUtils.realpath(U.extensionLocation.fsPath).then(B=>N.set(C.URI.file(B).fsPath,U))});this._extensionPathIndex=Promise.all(W).then(()=>N)}return this._extensionPathIndex}_deactivate(N){let W=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(N))return W;const U=this._activator.getActivatedExtension(N);if(!U)return W;try{typeof U.module.deactivate=="function"&&(W=Promise.resolve(U.module.deactivate()).then(void 0,B=>(this._logService.error(B),Promise.resolve(void 0))))}catch(B){this._logService.error(B)}try{D.dispose(U.subscriptions)}catch(B){this._logService.error(B)}return W}async _activateExtension(N,W){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier),this._doActivateExtension(N,W).then(U=>{const B=U.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(N.identifier,B.codeLoadingTime,B.activateCallTime,B.activateResolvedTime,W),this._logExtensionActivationTimes(N,W,"success",B),U},U=>{throw this._logExtensionActivationTimes(N,W,"failure"),U})}_logExtensionActivationTimes(N,W,U,B){const J=Z(N,W);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},J),B||{}),{outcome:U}))}_doActivateExtension(N,W){const U=Z(N,W);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",U);const B=this._getEntryPoint(N);if(!B)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${N.identifier.value} ${JSON.stringify(W)}`),this._logService.flush();const J=new f.ExtensionActivationTimesBuilder(W.startup);return Promise.all([this._loadCommonJSModule(N.identifier,E.joinPath(N.extensionLocation,B),J),this._loadExtensionContext(N)]).then(he=>(S.mark(`code/extHost/willActivateExtension/${N.identifier.value}`),Bi._callActivate(this._logService,N.identifier,he[0],he[1],J))).then(he=>(S.mark(`code/extHost/didActivateExtension/${N.identifier.value}`),he))}_loadExtensionContext(N){const W=new m.ExtensionGlobalMemento(N,this._storage),U=new m.ExtensionMemento(N.identifier.value,!1,this._storage),B=new H.ExtensionSecrets(N,this._secretState),J=N.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,he=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${N.identifier.value}`),Promise.all([W.whenReady,U.whenReady,this._storagePath.whenReady]).then(()=>{const De=this;let Oe;return Object.freeze({globalState:W,workspaceState:U,secrets:B,subscriptions:[],get extensionUri(){return N.extensionLocation},get extensionPath(){return N.extensionLocation.fsPath},asAbsolutePath(Me){return T.join(N.extensionLocation.fsPath,Me)},get storagePath(){var Me;return(Me=De._storagePath.workspaceValue(N))===null||Me===void 0?void 0:Me.fsPath},get globalStoragePath(){return De._storagePath.globalValue(N).fsPath},get logPath(){return T.join(De._initData.logsLocation.fsPath,N.identifier.value)},get logUri(){return C.URI.joinPath(De._initData.logsLocation,N.identifier.value)},get storageUri(){return De._storagePath.workspaceValue(N)},get globalStorageUri(){return De._storagePath.globalValue(N)},get extensionMode(){return J},get extension(){return Oe===void 0&&(Oe=new L(De,N.identifier,N,he)),Oe},get extensionRuntime(){return y.checkProposedApiEnabled(N),De.extensionRuntime},get environmentVariableCollection(){return De._extHostTerminalService.getEnvironmentVariableCollection(N)}})})}static _callActivate(N,W,U,B,J){return U=U||{activate:void 0,deactivate:void 0},this._callActivateOptional(N,W,U,B,J).then(he=>new f.ActivatedExtension(!1,null,J.build(),U,he,B.subscriptions))}static _callActivateOptional(N,W,U,B,J){if(typeof U.activate=="function")try{J.activateCallStart(),N.trace(`ExtensionService#_callActivateOptional ${W.value}`);const he=typeof global=="object"?global:self,De=U.activate.apply(he,[B]);return J.activateCallStop(),J.activateResolveStart(),Promise.resolve(De).then(Oe=>(J.activateResolveStop(),Oe))}catch(he){return Promise.reject(he)}else return Promise.resolve(U)}_activateOneStartupFinished(N,W){this._activateById(N.identifier,{startup:!1,extensionId:N.identifier,activationEvent:W}).then(void 0,U=>{this._logService.error(U)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const N of this._registry.getAllExtensionDescriptions())if(N.activationEvents)for(const W of N.activationEvents)W==="onStartupFinished"&&this._activateOneStartupFinished(N,W)}_handleEagerExtensions(){const N=this._activateByEvent("*",!0).then(void 0,J=>{this._logService.error(J)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(J=>this._handleWorkspaceContainsEagerExtensions(J.added)));const W=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],U=this._handleWorkspaceContainsEagerExtensions(W),B=Promise.all([N,U]).then(()=>{});return Promise.race([B,k.timeout(1e4)]).then(()=>{this._activateAllStartupFinished()}),B}_handleWorkspaceContainsEagerExtensions(N){return N.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(W=>this._handleWorkspaceContainsEagerExtension(N,W))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(N,W){if(this.isActivated(W.identifier))return;const U=!this._initData.remote.isRemote&&!!this._initData.remote.authority,B={folders:N.map(he=>he.uri),forceUsingSearch:U,exists:he=>this._hostUtils.exists(he.fsPath),checkExists:(he,De,Oe)=>this._mainThreadWorkspaceProxy.$checkExists(he,De,Oe)},J=await R.checkActivateWorkspaceContainsExtension(B,W);if(!!J)return this._activateById(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:J.activationEvent}).then(void 0,he=>this._logService.error(he))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(N){throw console.error(N),N}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:N,extensionTestsLocationURI:W}=this._initData.environment;if(!N||!W)throw new Error(g.localize(0,null));const U=await this._loadCommonJSModule(null,W,new f.ExtensionActivationTimesBuilder(!1));if(!U||typeof U.run!="function")throw new Error(g.localize(1,null,W.toString()));return new Promise((B,J)=>{const he=(Me,He)=>{Me?J(Me):B(typeof He=="number"&&He>0?1:0)},De=E.originalFSPath(W),Oe=U.run(De,he);Oe&&Oe.then&&Oe.then(()=>{B(0)}).catch(Me=>{J(Me.toString())})})}async $extensionTestsExit(N){this._logService.info(`extension host terminating: test runner requested exit with code ${N}`),this._logService.info(`exiting with code ${N}`),this._logService.flush(),this._hostUtils.exit(N)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(N,W){return this._resolvers[N]=W,D.toDisposable(()=>{delete this._resolvers[N]})}async _activateAndGetResolver(N){const W=N.indexOf("+");if(W===-1)throw new Error("Not an authority that can be resolved!");const U=N.substr(0,W);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${U}`,!1),{authorityPrefix:U,resolver:this._resolvers[U]}}async $resolveAuthority(N,W){const{authorityPrefix:U,resolver:B}=await this._activateAndGetResolver(N);if(!B)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${U}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(B)),S.mark(`code/extHost/willResolveAuthority/${U}`);const J=await B.resolve(N,{resolveAttempt:W});S.mark(`code/extHost/didResolveAuthorityOK/${U}`);const he={authority:N,host:J.host,port:J.port,connectionToken:J.connectionToken},De={extensionHostEnv:J.extensionHostEnv,isTrusted:J.isTrusted};return{type:"ok",value:{authority:he,options:De,tunnelInformation:{environmentTunnels:J.environmentTunnels}}}}catch(J){if(S.mark(`code/extHost/didResolveAuthorityError/${U}`),J instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:J._code,message:J._message,detail:J._detail}};throw J}}async $getCanonicalURI(N,W){const{authorityPrefix:U,resolver:B}=await this._activateAndGetResolver(N);if(!B)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${U}`);const J=C.URI.revive(W);if(typeof B.getCanonicalURI=="undefined")return J;const he=await k.asPromise(()=>B.getCanonicalURI(J));return he||J}$startExtensionHost(N){return this._registry.keepOnly(N),this._startExtensionHost()}$activateByEvent(N,W){return W===1?this._activateByEvent(N,!1):this._readyToRunExtensions.wait().then(U=>this._activateByEvent(N,!1))}async $activate(N,W){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(N)?(await this._activateById(N,W),!0):!1}async $deltaExtensions(N,W){N.forEach(B=>B.extensionLocation=C.URI.revive(B.extensionLocation));const U=await this.getExtensionPathIndex();return await Promise.all(W.map(async B=>{const J=this._registry.getExtensionDescription(B);if(!J)return;const he=await this._hostUtils.realpath(J.extensionLocation.fsPath);U.delete(C.URI.file(he).fsPath)})),await Promise.all(N.map(async B=>{const J=await this._hostUtils.realpath(B.extensionLocation.fsPath);U.set(C.URI.file(J).fsPath,B)})),this._registry.deltaExtensions(N,W),Promise.resolve(void 0)}async $test_latency(N){return N}async $test_up(N){return N.byteLength}async $test_down(N){let W=h.VSBuffer.alloc(N),U=Math.random()%256;for(let B=0;B<N;B++)W.writeUInt8(U,B);return W}async $updateRemoteConnectionData(N){this._remoteConnectionData=N,this._onDidChangeRemoteConnectionData.fire()}};j=Ve([ze(0,s.IInstantiationService),ze(1,e.IHostUtils),ze(2,b.IExtHostRpcService),ze(3,d.IExtHostWorkspace),ze(4,o.IExtHostConfiguration),ze(5,i.ILogService),ze(6,r.IExtHostInitDataService),ze(7,u.IExtensionStoragePaths),ze(8,P.IExtHostTunnelService),ze(9,A.IExtHostTerminalService)],j),e.AbstractExtHostExtensionService=j;function Z(q,N){return{id:q.identifier.value,name:q.name,extensionVersion:q.version,publisherDisplayName:q.publisher,activationEvents:q.activationEvents?q.activationEvents.join(","):null,isBuiltin:q.isBuiltin,reason:N.activationEvent,reasonId:N.extensionId.value}}e.IExtHostExtensionService=s.createDecorator("IExtHostExtensionService");class L{constructor(N,W,U,B){ue.set(this,void 0),fe.set(this,void 0),Y.set(this,void 0),nt(this,ue,N,"f"),nt(this,fe,W,"f"),nt(this,Y,U.identifier,"f"),this.id=U.identifier.value,this.extensionUri=U.extensionLocation,this.extensionPath=T.normalize(E.originalFSPath(U.extensionLocation)),this.packageJSON=U,this.extensionKind=B}get isActive(){return Be(this,ue,"f").isActivated(Be(this,Y,"f"))}get exports(){if(this.packageJSON.api!=="none")return Be(this,ue,"f").getExtensionExports(Be(this,Y,"f"))}activate(){return Be(this,ue,"f").activateByIdWithErrors(Be(this,Y,"f"),{startup:!1,extensionId:Be(this,fe,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=L,ue=new WeakMap,fe=new WeakMap,Y=new WeakMap}),define(we[105],_e([0,1,14,2,3,12,5,6,160,30,33,36,164,32,161,13,4,10,41,63]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o,f,c,d,y,w,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=y.createDecorator("IExtHostDebugService");let h=class{constructor(p,P,A,a,R,M){this._workspaceService=P,this._extensionService=A,this._editorsService=a,this._configurationService=R,this._editorTabs=M,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new S.Emitter,this._onDidTerminateDebugSession=new S.Emitter,this._onDidChangeActiveDebugSession=new S.Emitter,this._onDidReceiveDebugSessionCustomEvent=new S.Emitter,this._debugServiceProxy=p.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new S.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(H=>{H.onDidChange(ue=>{this.registerAllDebugTypes(H)}),this.registerAllDebugTypes(H)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(p,P){const A=p;if(typeof A.sourceReference=="number"&&A.sourceReference>0){let a=`debug:${encodeURIComponent(A.path||"")}`,R="?";return P&&(a+=`${R}session=${encodeURIComponent(P.id)}`,R="&"),a+=`${R}ref=${A.sourceReference}`,T.URI.parse(a)}else{if(A.path)return T.URI.file(A.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(p){const P=[];for(const A of p.getAllExtensionDescriptions())if(A.contributes){const a=A.contributes.debuggers;if(a&&a.length>0)for(const R of a)c.isDebuggerMainContribution(R)&&P.push(R.type)}this._debugServiceProxy.$registerDebugTypes(P)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const p=[];return this._breakpoints.forEach(P=>p.push(P)),p}addBreakpoints(p){this.startBreakpoints();const P=p.filter(R=>{const M=R.id;return this._breakpoints.has(M)?!1:(this._breakpoints.set(M,R),!0)});this.fireBreakpointChanges(P,[],[]);const A=[],a=new Map;for(const R of P)if(R instanceof D.SourceBreakpoint){let M=a.get(R.location.uri.toString());M||(M={type:"sourceMulti",uri:R.location.uri,lines:[]},a.set(R.location.uri.toString(),M),A.push(M)),M.lines.push({id:R.id,enabled:R.enabled,condition:R.condition,hitCondition:R.hitCondition,logMessage:R.logMessage,line:R.location.range.start.line,character:R.location.range.start.character})}else R instanceof D.FunctionBreakpoint&&A.push({type:"function",id:R.id,enabled:R.enabled,hitCondition:R.hitCondition,logMessage:R.logMessage,condition:R.condition,functionName:R.functionName});return this._debugServiceProxy.$registerBreakpoints(A)}removeBreakpoints(p){this.startBreakpoints();const P=p.filter(M=>this._breakpoints.delete(M.id));this.fireBreakpointChanges([],P,[]);const A=P.filter(M=>M instanceof D.SourceBreakpoint).map(M=>M.id),a=P.filter(M=>M instanceof D.FunctionBreakpoint).map(M=>M.id),R=P.filter(M=>M instanceof D.DataBreakpoint).map(M=>M.id);return this._debugServiceProxy.$unregisterBreakpoints(A,a,R)}startDebugging(p,P,A){return this._debugServiceProxy.$startDebugging(p?p.uri:void 0,P,{parentSessionID:A.parentSession?A.parentSession.id:void 0,repl:A.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:A.noDebug,compact:A.compact})}stopDebugging(p){return this._debugServiceProxy.$stopDebugging(p?p.id:void 0)}registerDebugConfigurationProvider(p,P,A){if(!P)return new D.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:p,handle:a,provider:P}),this._debugServiceProxy.$registerDebugConfigurationProvider(p,A,!!P.provideDebugConfigurations,!!P.resolveDebugConfiguration,!!P.resolveDebugConfigurationWithSubstitutedVariables,a),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(R=>R.provider!==P),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(p,P,A){if(!A)return new D.Disposable(()=>{});if(!this.definesDebugType(p,P))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${P}' debugger.`);if(this.getAdapterDescriptorFactoryByType(P))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:P,handle:a,factory:A}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(P,a),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(R=>R.factory!==A),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(p,P){if(!P)return new D.Disposable(()=>{});const A=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:p,handle:A,factory:P}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==P)})}async $runInTerminal(p,P){return Promise.resolve(void 0)}async $substituteVariables(p,P){if(!this._variableResolver){const[R,M]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(R||[],this._editorsService,M)}let A;const a=await this.getFolder(p);return a&&(A={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(A,P)}createDebugAdapter(p,P){if(p.type==="implementation")return new r(p.implementation)}createSignService(){}async $startDASession(p,P){const A=this,a=await this.getSession(P);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const M=this.convertToDto(R),H=this.createDebugAdapter(M,a);if(!H)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const ue=H;return this._debugAdapters.set(p,ue),this.getDebugAdapterTrackers(a).then(fe=>(fe&&this._debugAdaptersTrackers.set(p,fe),ue.onMessage(async Y=>{if(Y.type==="request"&&Y.command==="handshake"){const j=Y,Z={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign(j.arguments.value);Z.body={signature:L},ue.sendResponse(Z)}else throw new Error("no signer")}catch(L){Z.success=!1,Z.message=L.message,ue.sendResponse(Z)}}else fe&&fe.onDidSendMessage&&fe.onDidSendMessage(Y),Y=c.convertToVSCPaths(Y,!0),A._debugServiceProxy.$acceptDAMessage(p,Y)}),ue.onError(Y=>{fe&&fe.onError&&fe.onError(Y),this._debugServiceProxy.$acceptDAError(p,Y.name,Y.message,Y.stack)}),ue.onExit(Y=>{fe&&fe.onExit&&fe.onExit(w.withNullAsUndefined(Y),void 0),this._debugServiceProxy.$acceptDAExit(p,w.withNullAsUndefined(Y),void 0)}),fe&&fe.onWillStartSession&&fe.onWillStartSession(),ue.startSession()))})}$sendDAMessage(p,P){P=c.convertToDAPaths(P,!1);const A=this._debugAdaptersTrackers.get(p);A&&A.onWillReceiveMessage&&A.onWillReceiveMessage(P);const a=this._debugAdapters.get(p);a&&a.sendMessage(P)}$stopDASession(p){const P=this._debugAdaptersTrackers.get(p);this._debugAdaptersTrackers.delete(p),P&&P.onWillStopSession&&P.onWillStopSession();const A=this._debugAdapters.get(p);return this._debugAdapters.delete(p),A?A.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(p){const P=[],A=[],a=[];if(p.added)for(const R of p.added){const M=R.id;if(M&&!this._breakpoints.has(M)){let H;if(R.type==="function")H=new D.FunctionBreakpoint(R.functionName,R.enabled,R.condition,R.hitCondition,R.logMessage);else if(R.type==="data")H=new D.DataBreakpoint(R.label,R.dataId,R.canPersist,R.enabled,R.hitCondition,R.condition,R.logMessage);else{const ue=T.URI.revive(R.uri);H=new D.SourceBreakpoint(new D.Location(ue,new D.Position(R.line,R.character)),R.enabled,R.condition,R.hitCondition,R.logMessage)}H._id=M,this._breakpoints.set(M,H),P.push(H)}}if(p.removed)for(const R of p.removed){const M=this._breakpoints.get(R);M&&(this._breakpoints.delete(R),A.push(M))}if(p.changed){for(const R of p.changed)if(R.id){const M=this._breakpoints.get(R.id);if(M){if(M instanceof D.FunctionBreakpoint&&R.type==="function"){const H=M;H.enabled=R.enabled,H.condition=R.condition,H.hitCondition=R.hitCondition,H.logMessage=R.logMessage,H.functionName=R.functionName}else if(M instanceof D.SourceBreakpoint&&R.type==="source"){const H=M;H.enabled=R.enabled,H.condition=R.condition,H.hitCondition=R.hitCondition,H.logMessage=R.logMessage,H.location=new D.Location(T.URI.revive(R.uri),new D.Position(R.line,R.character))}a.push(M)}}}this.fireBreakpointChanges(P,A,a)}$provideDebugConfigurations(p,P,A){return E.asPromise(async()=>{const a=this.getConfigProviderByHandle(p);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const R=await this.getFolder(P);return a.provideDebugConfigurations(R,A)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(p,P,A,a){return E.asPromise(async()=>{const R=this.getConfigProviderByHandle(p);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const M=await this.getFolder(P);return R.resolveDebugConfiguration(M,A,a)})}$resolveDebugConfigurationWithSubstitutedVariables(p,P,A,a){return E.asPromise(async()=>{const R=this.getConfigProviderByHandle(p);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const M=await this.getFolder(P);return R.resolveDebugConfigurationWithSubstitutedVariables(M,A,a)})}async $provideDebugAdapter(p,P){const A=this.getAdapterDescriptorFactoryByHandle(p);if(!A)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(P);return this.getAdapterDescriptor(A,a).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(R)})}async $acceptDebugSessionStarted(p){const P=await this.getSession(p);this._onDidStartDebugSession.fire(P)}async $acceptDebugSessionTerminated(p){const P=await this.getSession(p);P&&(this._onDidTerminateDebugSession.fire(P),this._debugSessions.delete(P.id))}async $acceptDebugSessionActiveChanged(p){this._activeDebugSession=p?await this.getSession(p):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(p,P){const A=await this.getSession(p);A&&A._acceptNameChanged(P)}async $acceptDebugSessionCustomEvent(p,P){const a={session:await this.getSession(p),event:P.event,body:P.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(p){if(p instanceof D.DebugAdapterExecutable)return{type:"executable",command:p.command,args:p.args,options:p.options};if(p instanceof D.DebugAdapterServer)return{type:"server",port:p.port,host:p.host};if(p instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:p.path};if(p instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:p.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(p){const P=this._adapterFactories.filter(A=>A.type===p);if(P.length>0)return P[0].factory}getAdapterDescriptorFactoryByHandle(p){const P=this._adapterFactories.filter(A=>A.handle===p);if(P.length>0)return P[0].factory}getConfigProviderByHandle(p){const P=this._configProviders.filter(A=>A.handle===p);if(P.length>0)return P[0].provider}definesDebugType(p,P){if(p.contributes){const A=p.contributes.debuggers;if(A&&A.length>0){for(const a of A)if(a.label&&a.type&&a.type===P)return!0}}return!1}getDebugAdapterTrackers(p){const A=p.configuration.type,a=this._trackerFactories.filter(R=>R.type===A||R.type==="*").map(R=>E.asPromise(()=>R.factory.createDebugAdapterTracker(p)).then(M=>M,M=>null));return Promise.race([Promise.all(a).then(R=>{const M=R.filter(H=>!!H);if(M.length>0)return new s(M)}),new Promise((R,M)=>{const H=setTimeout(()=>{clearTimeout(H),M(new Error("timeout"))},1e3)})]).catch(R=>{})}async getAdapterDescriptor(p,P){const A=P.configuration.debugServer;if(typeof A=="number")return Promise.resolve(new D.DebugAdapterServer(A));if(p){const R=await this._extensionService.getExtensionRegistry();return E.asPromise(()=>p.createDebugAdapterDescriptor(P,this.daExecutableFromPackage(P,R))).then(M=>{if(M)return M})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(P,a))}daExecutableFromPackage(p,P){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(p,P,A){(p.length>0||P.length>0||A.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:p,removed:P,changed:A}))}async getSession(p){if(p)if(typeof p=="string"){const P=this._debugSessions.get(p);if(P)return P}else{let P=this._debugSessions.get(p.id);if(!P){const A=await this.getFolder(p.folderUri),a=p.parent?this._debugSessions.get(p.parent):void 0;P=new m(this._debugServiceProxy,p.id,p.type,p.name,A,p.configuration,a),this._debugSessions.set(P.id,P),this._debugServiceProxy.$sessionCached(P.id)}return P}throw new Error("cannot find session")}getFolder(p){if(p){const P=T.URI.revive(p);return this._workspaceService.resolveWorkspaceFolder(P)}return Promise.resolve(void 0)}};h=Ve([ze(0,d.IExtHostRpcService),ze(1,C.IExtHostWorkspace),ze(2,i.IExtHostExtensionService),ze(3,I.IExtHostDocumentsAndEditors),ze(4,f.IExtHostConfiguration),ze(5,l.IExtHostEditorTabs)],h),e.ExtHostDebugServiceBase=h;class m{constructor(p,P,A,a,R,M,H){this._debugServiceProxy=p,this._id=P,this._type=A,this._name=a,this._workspaceFolder=R,this._configuration=M,this._parentSession=H}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(p){this._name=p,this._debugServiceProxy.$setDebugSessionName(this._id,p)}get parentSession(){return this._parentSession}_acceptNameChanged(p){this._name=p}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(p,P){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,p,P)}getDebugProtocolBreakpoint(p){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,p.id)}}e.ExtHostDebugSession=m;class t{constructor(p){this.value=Object.freeze({append(P){p.$appendDebugConsole(P)},appendLine(P){this.append(P+`
`)}})}}e.ExtHostDebugConsole=t;class n extends o.AbstractVariableResolverService{constructor(p,P,A,a,R){function M(){if(P){const H=P.activeEditor();if(H)return H.document.uri;const ue=a.tabs.filter(fe=>fe.isActive);if(ue.length>0)return ue[0].resource}}super({getFolderUri:H=>{const ue=p.filter(fe=>fe.name===H);if(ue&&ue.length>0)return ue[0].uri},getWorkspaceFolderCount:()=>p.length,getConfigurationValue:(H,ue)=>A.getConfiguration(void 0,H).get(ue),getAppRoot:()=>v.cwd(),getExecPath:()=>v.env.VSCODE_EXEC_PATH,getFilePath:()=>{const H=M();if(H)return g.normalize(H.fsPath)},getWorkspaceFolderPathForFile:()=>{if(R){const H=M();if(H){const ue=R.getWorkspaceFolder(H);if(ue)return g.normalize(ue.uri.fsPath)}}},getSelectedText:()=>{if(P){const H=P.activeEditor();if(H&&!H.selection.isEmpty)return H.document.getText(H.selection)}},getLineNumber:()=>{if(P){const H=P.activeEditor();if(H)return String(H.selection.end.line+1)}}},void 0,Promise.resolve(v.env))}}e.ExtHostVariableResolverService=n;class s{constructor(p){this.trackers=p}onWillStartSession(){this.trackers.forEach(p=>p.onWillStartSession?p.onWillStartSession():void 0)}onWillReceiveMessage(p){this.trackers.forEach(P=>P.onWillReceiveMessage?P.onWillReceiveMessage(p):void 0)}onDidSendMessage(p){this.trackers.forEach(P=>P.onDidSendMessage?P.onDidSendMessage(p):void 0)}onWillStopSession(){this.trackers.forEach(p=>p.onWillStopSession?p.onWillStopSession():void 0)}onError(p){this.trackers.forEach(P=>P.onError?P.onError(p):void 0)}onExit(p,P){this.trackers.forEach(A=>A.onExit?A.onExit(p,P):void 0)}}class r extends _.AbstractDebugAdapter{constructor(p){super();this.implementation=p,p.onDidSendMessage(P=>{this.acceptMessage(P)})}startSession(){return Promise.resolve(void 0)}sendMessage(p){this.implementation.handleMessage(p)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends h{constructor(p,P,A,a,R,M){super(p,P,A,a,R,M)}createVariableResolver(p,P,A){return new n(p,P,A,this._editorTabs)}};u=Ve([ze(0,d.IExtHostRpcService),ze(1,C.IExtHostWorkspace),ze(2,i.IExtHostExtensionService),ze(3,I.IExtHostDocumentsAndEditors),ze(4,f.IExtHostConfiguration),ze(5,l.IExtHostEditorTabs)],u),e.WorkerExtHostDebugService=u}),define(we[214],_e([0,1,75,2,5,32,29,26,13,28,4,33,41,15]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(l,h,m,t,n,s,r){this._apiFactory=l,this._extensionRegistry=h,this._instaService=m,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=s,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const l=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,h,this._extensionRegistry,l,this._logService)),this.register(this._instaService.createInstance(y)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,h,this._initData.environment.appUriScheme))}register(l){if(Array.isArray(l.nodeModuleName))for(let h of l.nodeModuleName)this._factories.set(h,l);else this._factories.set(l.nodeModuleName,l);typeof l.alternativeModuleName=="function"&&this._alternatives.push(h=>l.alternativeModuleName(h))}};c=Ve([ze(2,i.IInstantiationService),ze(3,E.IExtHostConfiguration),ze(4,I.IExtHostExtensionService),ze(5,C.IExtHostInitDataService),ze(6,f.ILogService)],c),e.RequireInterceptor=c;class d{constructor(l,h,m,t,n){this._apiFactory=l,this._extensionPaths=h,this._extensionRegistry=m,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(l,h){const m=this._extensionPaths.findSubstr(h.fsPath);if(m){let t=this._extApiImpl.get(D.ExtensionIdentifier.toKey(m.identifier));return t||(t=this._apiFactory(m,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(m.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,s)=>t+=`	${s} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(k.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let y=class{constructor(l,h){this.nodeModuleName="keytar";const{environment:m}=h,t=l.getProxy(S.MainContext.MainThreadKeytar);if(m.appRoot){let n=m.appRoot.fsPath;o.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,s)=>t.$getPassword(n,s),setPassword:(n,s,r)=>t.$setPassword(n,s,r),deletePassword:(n,s)=>t.$deletePassword(n,s),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(l,h){return this._impl}alternativeModuleName(l){const h=l.length;if(h<=7||!this.alternativeNames)return;const m=h-7;if((l.charAt(m)==="/"||l.charAt(m)==="\\")&&l.endsWith("keytar")&&(l=l.replace(/\\/g,"/"),this.alternativeNames.has(l)))return"keytar"}};y=Ve([ze(0,_.IExtHostRpcService),ze(1,C.IExtHostInitDataService)],y);let w=class{constructor(l,h,m){this._extensionPaths=l,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=m.getProxy(S.MainContext.MainThreadTelemetry);const t=m.getProxy(S.MainContext.MainThreadWindow);this._impl=(n,s)=>{const r=T.URI.parse(n);return s?this.callOriginal(n,s):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,n,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,n,{}):this.callOriginal(n,s)}}load(l,h,m){const t=this._extensionPaths.findSubstr(h.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=m(l),this._impl}callOriginal(l,h){return this.sendNoForwardTelemetry(),this._original(l,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=Ve([ze(2,_.IExtHostRpcService)],w)}),define(we[215],_e([0,1,12,11,75,7,2,5,207,15,57,60,28,146,13,66,33,37]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o,f,c,d,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class v{constructor(h,m,t,n){this._disposables=new E.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new _.RPCProtocol(h,null,n),m=v._transform(m,this._rpcProtocol);const s=new I.ServiceCollection(...i.getSingletonServiceDescriptors());s.set(o.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},m)),s.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),s.set(d.IURITransformerService,new d.URITransformerService(n)),s.set(y.IHostUtils,t);const r=new f.InstantiationService(s,!0),u=r.invokeFunction(A=>A.get(w.IExtHostTerminalService));this._disposables.add(u),this._logService=r.invokeFunction(A=>A.get(C.ILogService)),S.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",m),this._extensionService=r.invokeFunction(A=>A.get(y.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const b=new WeakMap;this._extensionService.getExtensionPathIndex().then(A=>{Error.prepareStackTrace=(a,R)=>{let M="",H,ue;for(const fe of R)M+=`
	at ${fe.toString()}`,ue=fe.getFileName(),!H&&ue&&(H=A.findSubstr(ue));return b.set(a,H),`${a.name||"Error"}: ${a.message||""}${M}`}});const p=this._rpcProtocol.getProxy(D.MainContext.MainThreadExtensionService),P=this._rpcProtocol.getProxy(D.MainContext.MainThreadErrors);T.setUnexpectedErrorHandler(A=>{const a=T.transformErrorForSerialization(A),R=b.get(A);R?p.$onExtensionRuntimeError(R.identifier,a):P.$onUnexpectedError(a)})}terminate(h){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${h}`),this._logService.flush(),this._disposables.dispose(),T.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const m=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([g.timeout(4e3),m]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(h,m){h.extensions.forEach(n=>n.extensionLocation=k.URI.revive(m.transformIncomingURIs(n.extensionLocation))),h.environment.appRoot=k.URI.revive(m.transformIncomingURIs(h.environment.appRoot));const t=h.environment.extensionDevelopmentLocationURI;return t&&(h.environment.extensionDevelopmentLocationURI=t.map(n=>k.URI.revive(m.transformIncomingURIs(n)))),h.environment.extensionTestsLocationURI=k.URI.revive(m.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=k.URI.revive(m.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=k.URI.revive(m.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=k.URI.revive(m.transformIncomingURIs(h.logsLocation)),h.logFile=k.URI.revive(m.transformIncomingURIs(h.logFile)),h.workspace=m.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=v}),define(we[216],_e([0,1,14,18,56,27,25,52,38]),function(ee,e,g,T,S,E,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(o,f,c){this.config=o,this.provider=f,this.sessionToken=c,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=o.filePattern,this.includePattern=o.includePattern&&E.parse(o.includePattern),this.maxResults=o.maxResults||void 0,this.exists=o.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=o.excludePattern&&E.parse(o.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(o=>o.cancel()),this.activeCancellationTokens=new Set}search(o){const f=this.config.folderQueries||[];return new Promise((c,d)=>{const y=w=>{this.resultCount++,o(w)};if(this.isCanceled)return c({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const v=w.toString(),l=g.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,l)||this.matchFile(y,{base:w,basename:l})}),Promise.all(f.map(w=>this.searchInFolder(w,y))).then(w=>{c({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{d(new Error(S.toErrorMessage(w)))})})}async searchInFolder(o,f){const c=new T.CancellationTokenSource,d=this.getSearchOptionsForFolder(o),y=this.initDirectoryTree(),w=new _.QueryGlobTester(this.config,o),v=!w.hasSiblingExcludeClauses();let l;try{this.activeCancellationTokens.add(c),l=D.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,c.token),m=l.elapsed(),t=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(n=>{const s=g.posix.relative(o.folder.path,n.path);if(v){const r=g.basename(n.path);this.matchFile(f,{base:o.folder,relativePath:s,basename:r});return}this.addDirectoryEntries(y,o.folder,s,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(y,w,f),{providerTime:m,postProcessTime:t.elapsed()})}finally{c.dispose(),this.activeCancellationTokens.delete(c)}}getSearchOptionsForFolder(o){const f=_.resolvePatternsForProvider(this.config.includePattern,o.includePattern),c=_.resolvePatternsForProvider(this.config.excludePattern,o.excludePattern);return{folder:o.folder,excludes:c,includes:f,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}addDirectoryEntries({pathToEntries:o},f,c,d){if(c===this.filePattern){const w=g.basename(this.filePattern);this.matchFile(d,{base:f,relativePath:this.filePattern,basename:w})}function y(w){const v=g.basename(w),l=g.dirname(w);let h=o[l];h||(h=o[l]=[],y(l)),h.push({base:f,relativePath:w,basename:v})}y(c)}matchDirectoryTree({rootEntries:o,pathToEntries:f},c,d){const y=this,w=this.filePattern;function v(l){const h=E.hasSiblingFn(()=>l.map(m=>m.basename));for(let m=0,t=l.length;m<t;m++){const n=l[m],{relativePath:s,basename:r}=n;if(!c.includedInQuerySync(s,r,w!==r?h:void 0))continue;const u=f[s];if(u)v(u);else{if(s===w)continue;y.matchFile(d,n)}if(y.isLimitHit)break}}v(o)}matchFile(o,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||o(f))}}class i{constructor(){this.sessions=new Map}fileSearch(o,f,c,d){const y=this.getSessionTokenSource(o.cacheKey),w=new C(o,f,y&&y.token);let v=0;const l=h=>{v+=h.length,c(h.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(w,i.BATCH_SIZE,l,d).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:h.stats}}))}clearCache(o){const f=this.getSessionTokenSource(o);f&&f.cancel()}getSessionTokenSource(o){if(!!o)return this.sessions.has(o)||this.sessions.set(o,new T.CancellationTokenSource),this.sessions.get(o)}rawMatchToSearchItem(o){return o.relativePath?{resource:k.joinPath(o.base,o.relativePath)}:{resource:o.base}}doSearch(o,f,c,d){d.onCancellationRequested(()=>{o.cancel()});const y=v=>{v&&(w.push(v),f>0&&w.length>=f&&(c(w),w=[]))};let w=[];return o.search(y).then(v=>(w.length&&c(w),v),v=>(w.length&&c(w),Promise.reject(v)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(we[217],_e([0,1,14,17,18,56,25,27,2,38,16,10]),function(ee,e,g,T,S,E,k,D,_,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class o{constructor(l,h,m){this.query=l,this.provider=h,this.fileUtils=m,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(l,h){const m=this.query.folderQueries||[],t=new S.CancellationTokenSource;return h.onCancellationRequested(()=>t.cancel()),new Promise((n,s)=>{this.collector=new c(l);let r=!1;const u=(b,p)=>{if(!r&&!this.isLimitHit){const P=this.resultSize(b);y(b)&&typeof this.query.maxResults=="number"&&this.resultCount+P>this.query.maxResults&&(this.isLimitHit=!0,r=!0,t.cancel(),b=this.trimResultToSize(b,this.query.maxResults-this.resultCount));const A=this.resultSize(b);this.resultCount+=A,(A>0||!y(b))&&this.collector.add(b,p)}};Promise.all(m.map((b,p)=>this.searchInFolder(b,P=>u(P,p),t.token))).then(b=>{t.dispose(),this.collector.flush();const p=b.some(P=>!!P&&!!P.limitHit);n({limitHit:this.isLimitHit||p,messages:T.flatten(b.map(P=>(P==null?void 0:P.message)?I.isArray(P.message)?P.message:[P.message]:[])),stats:{type:"textSearchProvider"}})},b=>{t.dispose();const p=E.toErrorMessage(b);s(new Error(p))})})}resultSize(l){return y(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,h){const m=Array.isArray(l.ranges)?l.ranges:[l.ranges],t=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:m.slice(0,h),preview:{matches:t.slice(0,h),text:l.preview.text},uri:l.uri}}async searchInFolder(l,h,m){const t=new C.QueryGlobTester(this.query,l),n=[],s={report:b=>{if(!this.validateProviderResult(b))return;const p=l.folder.scheme===i.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(k.dirname(b.uri))):void 0,P=k.relativePath(l.folder,b.uri);P&&n.push(t.includedInQuery(P,g.basename(P),p).then(A=>{A&&h(b)}))}},r=this.getSearchOptionsForFolder(l),u=await this.provider.provideTextSearchResults(f(this.query.contentPattern),r,s,m);return await Promise.all(n),u}validateProviderResult(l){if(y(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(l){const h=C.resolvePatternsForProvider(this.query.includePattern,l.includePattern),m=C.resolvePatternsForProvider(this.query.excludePattern,l.excludePattern),t={folder:_.URI.from(l.folder),excludes:m,includes:h,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=o;function f(v){return{isCaseSensitive:v.isCaseSensitive||!1,isRegExp:v.isRegExp||!1,isWordMatch:v.isWordMatch||!1,isMultiline:v.isMultiline||!1,pattern:v.pattern}}class c{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,h=>this.sendItems(h))}add(l,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!k.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(d(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=c;function d(v){return y(v)?{preview:{matches:T.mapArrayOrNot(v.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:v.preview.text},ranges:T.mapArrayOrNot(v.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:v.text,lineNumber:v.lineNumber}}function y(v){return!!v.preview}e.extensionResultIsMatch=y;class w{constructor(l,h){this.maxBatchSize=l,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,h){!l||this.addItemToBatch(l,h)}addItems(l,h){!l||this.addItemsToBatch(l,h)}addItemToBatch(l,h){this.batch.push(l),this.batchSize+=h,this.onUpdate()}addItemsToBatch(l,h){this.batch=this.batch.concat(l),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(we[106],_e([0,1,7,5,4,216,13,66,15,2,217]),function(ee,e,g,T,S,E,k,D,_,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=S.createDecorator("IExtHostSearch");let I=class{constructor(d,y,w){this.extHostRpc=d,this._uriTransformer=y,this._logService=w,this._proxy=this.extHostRpc.getProxy(T.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new E.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,y){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const w=this._handlePool++;return this._textSearchProvider.set(w,y),this._proxy.$registerTextSearchProvider(w,this._transformScheme(d)),g.toDisposable(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(d,y){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const w=this._handlePool++;return this._fileSearchProvider.set(w,y),this._proxy.$registerFileSearchProvider(w,this._transformScheme(d)),g.toDisposable(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(d,y,w,v){const l=o(w),h=this._fileSearchProvider.get(d);if(h)return this._fileSearchManager.fileSearch(l,h,m=>{this._proxy.$handleFileMatch(d,y,m.map(t=>t.resource))},v);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,y,w,v){const l=this._textSearchProvider.get(d);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const h=o(w);return this.createTextSearchManager(h,l).search(t=>this._proxy.$handleTextMatch(d,y,t),v)}createTextSearchManager(d,y){return new i.TextSearchManager(d,y,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};I=Ve([ze(0,k.IExtHostRpcService),ze(1,D.IURITransformerService),ze(2,_.ILogService)],I),e.ExtHostSearch=I;function o(c){return Object.assign(Object.assign({},c),{folderQueries:c.folderQueries&&c.folderQueries.map(f),extraFileResources:c.extraFileResources&&c.extraFileResources.map(d=>C.URI.revive(d))})}e.reviveQuery=o;function f(c){return Object.assign(Object.assign({},c),{folder:C.URI.revive(c.folder)})}}),define(we[218],_e([0,1,18,11,3,42,2,123,84,117,55,59,5,181,180,71,182,32,183,184,185,167,186,36,33,187,168,189,190,191,101,170,196,197,198,73,37,199,171,9,6,202,47,102,30,29,76,159,188,93,4,100,104,105,106,15,66,13,28,192,157,65,70,178,200,156,74,72,205,203,204,179,46,211,201,69,63,94,194,103,195,16,148,193,154]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o,f,c,d,y,w,v,l,h,m,t,n,s,r,u,b,p,P,A,a,R,M,H,ue,fe,Y,j,Z,L,q,N,W,U,B,J,he,De,Oe,Me,He,Ye,qe,Xe,$,G,te,re,K,oe,me,Ae,$e,pe,Ge,V,ie,ge,Fe,Ne,Qe,Ee,be,Ce,se,de,O,Q,le,ke,Pe,Ue,We,Ze){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function rt(Ke){const Je=Ke.get(re.IExtHostInitDataService),ft=Ke.get(Ee.IExtHostFileSystemInfo),ve=Ke.get(ie.IExtHostConsumerFileSystem),ye=Ke.get(s.IExtHostExtensionService),ae=Ke.get(U.IExtHostWorkspace),z=Ke.get(O.IExtHostTelemetry),xe=Ke.get(w.IExtHostConfiguration),Te=Ke.get(G.IURITransformerService),Re=Ke.get(te.IExtHostRpcService),it=Ke.get(ue.IExtHostStorage),ot=Ke.get(V.IExtensionStoragePaths),tt=Ke.get($.ILogService),vt=Ke.get(me.IExtHostTunnelService),gt=Ke.get(Ae.IExtHostApiDeprecationService),pt=Ke.get(W.IExtHostWindow),wt=Ke.get(se.IExtHostSecretState),Tt=Ke.get(de.IExtHostEditorTabs);Re.set(o.ExtHostContext.ExtHostFileSystemInfo,ft),Re.set(o.ExtHostContext.ExtHostLogService,tt),Re.set(o.ExtHostContext.ExtHostWorkspace,ae),Re.set(o.ExtHostContext.ExtHostConfiguration,xe),Re.set(o.ExtHostContext.ExtHostExtensionService,ye),Re.set(o.ExtHostContext.ExtHostStorage,it),Re.set(o.ExtHostContext.ExtHostTunnelService,vt),Re.set(o.ExtHostContext.ExtHostWindow,pt),Re.set(o.ExtHostContext.ExtHostSecretState,wt),Re.set(o.ExtHostContext.ExtHostTelemetry,z),Re.set(o.ExtHostContext.ExtHostEditorTabs,Tt);const Pt=Re.set(o.ExtHostContext.ExtHostDecorations,Ke.get(He.IExtHostDecorations)),Et=Re.set(o.ExtHostContext.ExtHostDocumentsAndEditors,Ke.get(n.IExtHostDocumentsAndEditors)),ut=Re.set(o.ExtHostContext.ExtHostCommands,Ke.get(d.IExtHostCommands)),mt=Re.set(o.ExtHostContext.ExtHostTerminalService,Ke.get(fe.IExtHostTerminalService)),_t=Re.set(o.ExtHostContext.ExtHostDebugService,Ke.get(qe.IExtHostDebugService)),Ft=Re.set(o.ExtHostContext.ExtHostSearch,Ke.get(Xe.IExtHostSearch)),yt=Re.set(o.ExtHostContext.ExtHostTask,Ke.get(Ye.IExtHostTask)),Zt=Re.set(o.ExtHostContext.ExtHostOutputService,Ke.get(A.IExtHostOutputService)),qt=Re.set(o.ExtHostContext.ExtHostUrls,new q.ExtHostUrls(Re)),St=Re.set(o.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(Re,Et)),ei=Re.set(o.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(Re,Et,tt)),ti=Re.set(o.ExtHostContext.ExtHostDocumentSaveParticipant,new m.ExtHostDocumentSaveParticipant(tt,St,Re.getProxy(o.MainContext.MainThreadBulkEdits))),ht=Re.set(o.ExtHostContext.ExtHostNotebook,new K.ExtHostNotebookController(Re,ut,Et,St,ot)),Gt=Re.set(o.ExtHostContext.ExtHostNotebookDocuments,new Ze.ExtHostNotebookDocuments(tt,ht)),$t=Re.set(o.ExtHostContext.ExtHostNotebookEditors,new We.ExtHostNotebookEditors(tt,Re,ht)),Di=Re.set(o.ExtHostContext.ExtHostNotebookKernels,new Q.ExtHostNotebookKernels(Re,Je,ht,tt)),ii=Re.set(o.ExtHostContext.ExtHostNotebookRenderers,new ke.ExtHostNotebookRenderers(Re,ht)),Ct=Re.set(o.ExtHostContext.ExtHostEditors,new Y.ExtHostEditors(Re,Et)),Kt=Re.set(o.ExtHostContext.ExtHostTreeViews,new j.ExtHostTreeViews(Re.getProxy(o.MainContext.MainThreadTreeViews),ut,tt)),ni=Re.set(o.ExtHostContext.ExtHostEditorInsets,new he.ExtHostEditorInsets(Re.getProxy(o.MainContext.MainThreadEditorInsets),Ct,Je)),Qt=Re.set(o.ExtHostContext.ExtHostDiagnostics,new v.ExtHostDiagnostics(Re,tt)),ct=Re.set(o.ExtHostContext.ExtHostLanguageFeatures,new b.ExtHostLanguageFeatures(Re,Te,St,ut,Qt,tt,gt)),ri=Re.set(o.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Re,ct)),Mt=Re.set(o.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(Re,tt,Et)),Wt=Re.set(o.ExtHostContext.ExtHostQuickOpen,R.createExtHostQuickOpen(Re,ae,ut)),gi=Re.set(o.ExtHostContext.ExtHostSCM,new M.ExtHostSCM(Re,ut,tt)),Ci=Re.set(o.ExtHostContext.ExtHostComments,new y.ExtHostComments(Re,ut,St)),pi=Re.set(o.ExtHostContext.ExtHostProgress,new a.ExtHostProgress(Re.getProxy(o.MainContext.MainThreadProgress))),si=Re.set(o.ExtHostContext.ExtHosLabelService,new De.ExtHostLabelService(Re)),Yt=Re.set(o.ExtHostContext.ExtHostTheming,new oe.ExtHostTheming(Re)),xt=Re.set(o.ExtHostContext.ExtHostAuthentication,new $e.ExtHostAuthentication(Re)),ki=Re.set(o.ExtHostContext.ExtHostTimeline,new pe.ExtHostTimeline(Re,ut)),oi=Re.set(o.ExtHostContext.ExtHostWebviews,new N.ExtHostWebviews(Re,{remote:Je.remote},ae,tt,gt)),ai=Re.set(o.ExtHostContext.ExtHostWebviewPanels,new Ne.ExtHostWebviewPanels(Re,oi,ae)),Jt=Re.set(o.ExtHostContext.ExtHostCustomEditors,new Fe.ExtHostCustomEditors(Re,St,ot,oi,ai)),Ii=Re.set(o.ExtHostContext.ExtHostWebviewViews,new ge.ExtHostWebviewViews(Re,oi)),Lt=Re.set(o.ExtHostContext.ExtHostTesting,new be.ExtHostTesting(Re,Ke.get(Me.IInstantiationService),Et)),li=Re.set(o.ExtHostContext.ExtHostUriOpeners,new Ce.ExtHostUriOpeners(Re)),Pi=J.values(o.ExtHostContext);Re.assertRegistered(Pi);const Ht=new Qe.ExtHostBulkEdits(Re,Et),Nt=new c.ExtHostClipboard(Re),ui=new P.ExtHostMessageService(Re,tt),It=new l.ExtHostDialogs(Re),zt=new H.ExtHostStatusBar(Re,ut.converter),ci=new p.ExtHostLanguages(Re,St);return f.ExtHostApiCommands.register(ut),function(Le,di,vi){const dt=function(){let X=!Le.isUnderDevelopment;function ce(Ie){X||(tt.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function Ie(st){if(Array.isArray(st))st.forEach(Ie);else if(typeof st=="string")ce(st);else{const bt=st;typeof bt.scheme=="undefined"&&ce(st),!Le.enableProposedApi&&typeof bt.exclusive=="boolean"&&B.throwProposedApiError(Le)}return st}}(),Ai={getSession(X,ce,Ie){return xt.getSession(Le,X,ce,Ie)},get onDidChangeSessions(){return xt.onDidChangeSessions},registerAuthenticationProvider(X,ce,Ie,st){return xt.registerAuthenticationProvider(X,ce,Ie,st)},get onDidChangeAuthenticationProviders(){return B.checkProposedApiEnabled(Le),xt.onDidChangeAuthenticationProviders},get providers(){return B.checkProposedApiEnabled(Le),xt.providers},logout(X,ce){return B.checkProposedApiEnabled(Le),xt.removeSession(X,ce)}},Ti={registerCommand(X,ce,Ie){return ut.registerCommand(!0,X,ce,Ie)},registerTextEditorCommand(X,ce,Ie){return ut.registerCommand(!0,X,(...st)=>{const bt=Ct.getActiveTextEditor();if(!bt){tt.warn("Cannot execute "+X+" because there is no active text editor.");return}return bt.edit(x=>{ce.apply(Ie,[bt,x,...st])}).then(x=>{x||tt.warn("Edits from command "+X+" were not applied.")},x=>{tt.warn("An error occurred while running command "+X,x)})})},registerDiffInformationCommand:(X,ce,Ie)=>(B.checkProposedApiEnabled(Le),ut.registerCommand(!0,X,async(...st)=>{const bt=Et.activeEditor(!0);if(!bt){tt.warn("Cannot execute "+X+" because there is no active text editor.");return}const x=await Ct.getDiffInformation(bt.id);ce.apply(Ie,[x,...st])})),executeCommand(X,...ce){return ut.executeCommand(X,...ce)},getCommands(X=!1){return ut.getCommands(X)}},Xt={get machineId(){return Je.telemetryInfo.machineId},get sessionId(){return Je.telemetryInfo.sessionId},get language(){return Je.environment.appLanguage},get appName(){return Je.environment.appName},get appRoot(){var X,ce;return(ce=(X=Je.environment.appRoot)===null||X===void 0?void 0:X.fsPath)!==null&&ce!==void 0?ce:""},get uriScheme(){return Je.environment.appUriScheme},get clipboard(){return Nt.value},get shell(){return mt.getDefaultShell(!1)},get isTelemetryEnabled(){return z.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return z.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(Je.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,ce){return pt.openUri(X,{allowTunneling:!!Je.remote.authority,allowContributedOpeners:ce==null?void 0:ce.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===Je.environment.appUriScheme)return qt.createAppUri(X);const ce=Ue.matchesScheme(X,Pe.Schemas.http)||Ue.matchesScheme(X,Pe.Schemas.https);ce||B.checkProposedApiEnabled(Le);try{return await pt.asExternalUri(X,{allowTunneling:!!Je.remote.authority})}catch(Ie){if(ce)return X;throw Ie}},get remoteName(){return Oe.getRemoteName(Je.remote.authority)},get uiKind(){return Je.uiKind}};Je.environment.extensionTestsLocationURI||Object.freeze(Xt);const bi=Je.remote.isRemote?L.ExtensionKind.Workspace:L.ExtensionKind.UI,hi={registerTestController(X){return B.checkProposedApiEnabled(Le),Lt.registerTestController(Le.identifier.value,X)},createDocumentTestObserver(X){return B.checkProposedApiEnabled(Le),Lt.createTextDocumentTestObserver(X)},createWorkspaceTestObserver(X){return B.checkProposedApiEnabled(Le),Lt.createWorkspaceTestObserver(X)},runTests(X){return B.checkProposedApiEnabled(Le),Lt.runTests(X)},createTestItem(X,ce){return new L.TestItemImpl(X.id,X.label,X.uri,ce)},createTestRun(X,ce,Ie){return B.checkProposedApiEnabled(Le),Lt.createTestRun(X,ce,Ie)},get onDidChangeTestResults(){return B.checkProposedApiEnabled(Le),Lt.onResultsChanged},get testResults(){return B.checkProposedApiEnabled(Le),Lt.results}};hi.createTestRunTask=hi.createTestRun;const Ri={getExtension(X){const ce=di.getExtensionDescription(X);if(ce)return new s.Extension(ye,Le.identifier,ce,bi)},get all(){return di.getAllExtensionDescriptions().map(X=>new s.Extension(ye,Le.identifier,X,bi))},get onDidChange(){return di.onDidChange}},Fi={createDiagnosticCollection(X){return Qt.createDiagnosticCollection(Le.identifier,X)},get onDidChangeDiagnostics(){return Qt.onDidChangeDiagnostics},getDiagnostics:X=>Qt.getDiagnostics(X),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(X,ce){return ci.changeLanguage(X.uri,ce)},match(X,ce){return i.score(Z.LanguageSelector.from(X),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(X,ce,Ie){return ct.registerCodeActionProvider(Le,dt(X),ce,Ie)},registerCodeLensProvider(X,ce){return ct.registerCodeLensProvider(Le,dt(X),ce)},registerDefinitionProvider(X,ce){return ct.registerDefinitionProvider(Le,dt(X),ce)},registerDeclarationProvider(X,ce){return ct.registerDeclarationProvider(Le,dt(X),ce)},registerImplementationProvider(X,ce){return ct.registerImplementationProvider(Le,dt(X),ce)},registerTypeDefinitionProvider(X,ce){return ct.registerTypeDefinitionProvider(Le,dt(X),ce)},registerHoverProvider(X,ce){return ct.registerHoverProvider(Le,dt(X),ce,Le.identifier)},registerEvaluatableExpressionProvider(X,ce){return ct.registerEvaluatableExpressionProvider(Le,dt(X),ce,Le.identifier)},registerInlineValuesProvider(X,ce){return ct.registerInlineValuesProvider(Le,dt(X),ce,Le.identifier)},registerDocumentHighlightProvider(X,ce){return ct.registerDocumentHighlightProvider(Le,dt(X),ce)},registerLinkedEditingRangeProvider(X,ce){return ct.registerLinkedEditingRangeProvider(Le,dt(X),ce)},registerReferenceProvider(X,ce){return ct.registerReferenceProvider(Le,dt(X),ce)},registerRenameProvider(X,ce){return ct.registerRenameProvider(Le,dt(X),ce)},registerDocumentSymbolProvider(X,ce,Ie){return ct.registerDocumentSymbolProvider(Le,dt(X),ce,Ie)},registerWorkspaceSymbolProvider(X){return ct.registerWorkspaceSymbolProvider(Le,X)},registerDocumentFormattingEditProvider(X,ce){return ct.registerDocumentFormattingEditProvider(Le,dt(X),ce)},registerDocumentRangeFormattingEditProvider(X,ce){return ct.registerDocumentRangeFormattingEditProvider(Le,dt(X),ce)},registerOnTypeFormattingEditProvider(X,ce,Ie,...st){return ct.registerOnTypeFormattingEditProvider(Le,dt(X),ce,[Ie].concat(st))},registerDocumentSemanticTokensProvider(X,ce,Ie){return ct.registerDocumentSemanticTokensProvider(Le,dt(X),ce,Ie)},registerDocumentRangeSemanticTokensProvider(X,ce,Ie){return ct.registerDocumentRangeSemanticTokensProvider(Le,dt(X),ce,Ie)},registerSignatureHelpProvider(X,ce,Ie,...st){return typeof Ie=="object"?ct.registerSignatureHelpProvider(Le,dt(X),ce,Ie):ct.registerSignatureHelpProvider(Le,dt(X),ce,typeof Ie=="undefined"?[]:[Ie,...st])},registerCompletionItemProvider(X,ce,...Ie){return ct.registerCompletionItemProvider(Le,dt(X),ce,Ie)},registerInlineCompletionItemProvider(X,ce){return B.checkProposedApiEnabled(Le),ct.registerInlineCompletionsProvider(Le,dt(X),ce)},registerDocumentLinkProvider(X,ce){return ct.registerDocumentLinkProvider(Le,dt(X),ce)},registerColorProvider(X,ce){return ct.registerColorProvider(Le,dt(X),ce)},registerFoldingRangeProvider(X,ce){return ct.registerFoldingRangeProvider(Le,dt(X),ce)},registerSelectionRangeProvider(X,ce){return ct.registerSelectionRangeProvider(Le,X,ce)},registerCallHierarchyProvider(X,ce){return ct.registerCallHierarchyProvider(Le,X,ce)},setLanguageConfiguration:(X,ce)=>ct.setLanguageConfiguration(Le,X,ce),getTokenInformationAtPosition(X,ce){return B.checkProposedApiEnabled(Le),ci.tokenAtPosition(X,ce)},registerInlayHintsProvider(X,ce){return B.checkProposedApiEnabled(Le),ct.registerInlayHintsProvider(Le,X,ce)}},Mi={get activeTextEditor(){return Ct.getActiveTextEditor()},get visibleTextEditors(){return Ct.getVisibleTextEditors()},get activeTerminal(){return mt.activeTerminal},get terminals(){return mt.terminals},async showTextDocument(X,ce,Ie){const st=await(k.URI.isUri(X)?Promise.resolve(wi.openTextDocument(X)):Promise.resolve(X));return Ct.showTextDocument(st,ce,Ie)},createTextEditorDecorationType(X){return Ct.createTextEditorDecorationType(Le,X)},onDidChangeActiveTextEditor(X,ce,Ie){return Ct.onDidChangeActiveTextEditor(X,ce,Ie)},onDidChangeVisibleTextEditors(X,ce,Ie){return Ct.onDidChangeVisibleTextEditors(X,ce,Ie)},onDidChangeTextEditorSelection(X,ce,Ie){return Ct.onDidChangeTextEditorSelection(X,ce,Ie)},onDidChangeTextEditorOptions(X,ce,Ie){return Ct.onDidChangeTextEditorOptions(X,ce,Ie)},onDidChangeTextEditorVisibleRanges(X,ce,Ie){return Ct.onDidChangeTextEditorVisibleRanges(X,ce,Ie)},onDidChangeTextEditorViewColumn(X,ce,Ie){return Ct.onDidChangeTextEditorViewColumn(X,ce,Ie)},onDidCloseTerminal(X,ce,Ie){return mt.onDidCloseTerminal(X,ce,Ie)},onDidOpenTerminal(X,ce,Ie){return mt.onDidOpenTerminal(X,ce,Ie)},onDidChangeActiveTerminal(X,ce,Ie){return mt.onDidChangeActiveTerminal(X,ce,Ie)},onDidChangeTerminalDimensions(X,ce,Ie){return B.checkProposedApiEnabled(Le),mt.onDidChangeTerminalDimensions(X,ce,Ie)},onDidWriteTerminalData(X,ce,Ie){return B.checkProposedApiEnabled(Le),mt.onDidWriteTerminalData(X,ce,Ie)},get state(){return pt.state},onDidChangeWindowState(X,ce,Ie){return pt.onDidChangeWindowState(X,ce,Ie)},showInformationMessage(X,...ce){return ui.showMessage(Le,E.default.Info,X,ce[0],ce.slice(1))},showWarningMessage(X,...ce){return ui.showMessage(Le,E.default.Warning,X,ce[0],ce.slice(1))},showErrorMessage(X,...ce){return ui.showMessage(Le,E.default.Error,X,ce[0],ce.slice(1))},showQuickPick(X,ce,Ie){return Wt.showQuickPick(X,!!Le.enableProposedApi,ce,Ie)},showWorkspaceFolderPick(X){return Wt.showWorkspaceFolderPick(X)},showInputBox(X,ce){return Wt.showInput(X,ce)},showOpenDialog(X){return It.showOpenDialog(X)},showSaveDialog(X){return It.showSaveDialog(X)},createStatusBarItem(X,ce,Ie){let st,bt,x;return typeof X=="string"?(st=X,bt=ce,x=Ie):(bt=X,x=ce),zt.createStatusBarEntry(Le,st,bt,x)},setStatusBarMessage(X,ce){return zt.setStatusBarMessage(X,ce)},withScmProgress(X){return gt.report("window.withScmProgress",Le,"Use 'withProgress' instead."),pi.withProgress(Le,{location:L.ProgressLocation.SourceControl},(ce,Ie)=>X({report(st){}}))},withProgress(X,ce){return pi.withProgress(Le,X,ce)},createOutputChannel(X){return Zt.createOutputChannel(X)},createWebviewPanel(X,ce,Ie,st){return ai.createWebviewPanel(Le,X,ce,Ie,st)},createWebviewTextEditorInset(X,ce,Ie,st){return B.checkProposedApiEnabled(Le),ni.createWebviewEditorInset(X,ce,Ie,st,Le)},createTerminal(X,ce,Ie){return typeof X=="object"?"pty"in X?mt.createExtensionTerminal(X):mt.createTerminalFromOptions(X):mt.createTerminal(X,ce,Ie)},registerTerminalLinkProvider(X){return mt.registerLinkProvider(X)},registerTerminalProfileProvider(X,ce){return mt.registerProfileProvider(Le,X,ce)},registerTreeDataProvider(X,ce){return Kt.registerTreeDataProvider(X,ce,Le)},createTreeView(X,ce){return Kt.createTreeView(X,ce,Le)},registerWebviewPanelSerializer:(X,ce)=>ai.registerWebviewPanelSerializer(Le,X,ce),registerCustomEditorProvider:(X,ce,Ie={})=>Jt.registerCustomEditorProvider(Le,X,ce,Ie),registerFileDecorationProvider(X){return Pt.registerFileDecorationProvider(X,Le.identifier)},registerUriHandler(X){return qt.registerUriHandler(Le.identifier,X)},createQuickPick(){return Wt.createQuickPick(Le.identifier,!!Le.enableProposedApi)},createInputBox(){return Wt.createInputBox(Le.identifier)},get activeColorTheme(){return Yt.activeColorTheme},onDidChangeActiveColorTheme(X,ce,Ie){return Yt.onDidChangeActiveColorTheme(X,ce,Ie)},registerWebviewViewProvider(X,ce,Ie){return Ii.registerWebviewViewProvider(Le,X,ce,Ie==null?void 0:Ie.webviewOptions)},get activeNotebookEditor(){return B.checkProposedApiEnabled(Le),ht.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,ce,Ie){return B.checkProposedApiEnabled(Le),ht.onDidChangeActiveNotebookEditor(X,ce,Ie)},get visibleNotebookEditors(){return B.checkProposedApiEnabled(Le),ht.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return B.checkProposedApiEnabled(Le),ht.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,ce,Ie){return B.checkProposedApiEnabled(Le),$t.onDidChangeNotebookEditorSelection(X,ce,Ie)},onDidChangeNotebookEditorVisibleRanges(X,ce,Ie){return B.checkProposedApiEnabled(Le),$t.onDidChangeNotebookEditorVisibleRanges(X,ce,Ie)},showNotebookDocument(X,ce){return B.checkProposedApiEnabled(Le),ht.showNotebookDocument(X,ce)},registerExternalUriOpener(X,ce,Ie){return B.checkProposedApiEnabled(Le),li.registerExternalUriOpener(Le.identifier,X,ce,Ie)},get openEditors(){return B.checkProposedApiEnabled(Le),Tt.tabs},get onDidChangeOpenEditors(){return B.checkProposedApiEnabled(Le),Tt.onDidChangeTabs},getInlineCompletionItemController(X){return B.checkProposedApiEnabled(Le),b.InlineCompletionController.get(X)}},wi={get rootPath(){return gt.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ae.getPath()},set rootPath(X){throw T.readonly()},getWorkspaceFolder(X){return ae.getWorkspaceFolder(X)},get workspaceFolders(){return ae.getWorkspaceFolders()},get name(){return ae.name},set name(X){throw T.readonly()},get workspaceFile(){return ae.workspaceFile},set workspaceFile(X){throw T.readonly()},updateWorkspaceFolders:(X,ce,...Ie)=>ae.updateWorkspaceFolders(Le,X,ce||0,...Ie),onDidChangeWorkspaceFolders:function(X,ce,Ie){return ae.onDidChangeWorkspace(X,ce,Ie)},asRelativePath:(X,ce)=>ae.getRelativePath(X,ce),findFiles:(X,ce,Ie,st)=>ae.findFiles(Z.GlobPattern.from(X),Z.GlobPattern.from(ce),Ie,Le.identifier,st),findTextInFiles:(X,ce,Ie,st)=>{let bt,x;return typeof ce=="object"?(bt=ce,x=Ie):(bt={},x=ce,st=Ie),ae.findTextInFiles(X,bt||{},x,Le.identifier,st)},saveAll:X=>ae.saveAll(X),applyEdit(X){return Ht.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,ce,Ie,st)=>Mt.createFileSystemWatcher(Z.GlobPattern.from(X),ce,Ie,st),get textDocuments(){return St.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw T.readonly()},openTextDocument(X){let ce;const Ie=X;if(typeof X=="string")ce=Promise.resolve(k.URI.file(X));else if(k.URI.isUri(X))ce=Promise.resolve(X);else if(!Ie||typeof Ie=="object")ce=St.createDocumentData(Ie);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(st=>St.ensureDocumentData(st).then(bt=>bt.document))},onDidOpenTextDocument:(X,ce,Ie)=>St.onDidAddDocument(X,ce,Ie),onDidCloseTextDocument:(X,ce,Ie)=>St.onDidRemoveDocument(X,ce,Ie),onDidChangeTextDocument:(X,ce,Ie)=>St.onDidChangeDocument(X,ce,Ie),onDidSaveTextDocument:(X,ce,Ie)=>St.onDidSaveDocument(X,ce,Ie),onWillSaveTextDocument:(X,ce,Ie)=>ti.getOnWillSaveTextDocumentEvent(Le)(X,ce,Ie),get notebookDocuments(){return ht.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,ce){let Ie;if(k.URI.isUri(X))Ie=X,await ht.openNotebookDocument(X);else if(typeof X=="string")Ie=k.URI.revive(await ht.createNotebookDocument({viewType:X,content:ce}));else throw new Error("Invalid arguments");return ht.getNotebookDocument(Ie).apiNotebook},get onDidOpenNotebookDocument(){return ht.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return ht.onDidCloseNotebookDocument},registerNotebookSerializer(X,ce,Ie,st){return ht.registerNotebookSerializer(Le,X,ce,Ie,Le.enableProposedApi?st:void 0)},registerNotebookContentProvider:(X,ce,Ie,st)=>(B.checkProposedApiEnabled(Le),ht.registerNotebookContentProvider(Le,X,ce,Ie,Le.enableProposedApi?st:void 0)),onDidChangeConfiguration:(X,ce,Ie)=>vi.onDidChangeConfiguration(X,ce,Ie),getConfiguration(X,ce){return ce=arguments.length===1?void 0:ce,vi.getConfiguration(X,ce,Le)},registerTextDocumentContentProvider(X,ce){return ei.registerTextDocumentContentProvider(X,ce)},registerTaskProvider:(X,ce)=>(gt.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Le,X,ce)),registerFileSystemProvider(X,ce,Ie){return ri.registerFileSystemProvider(Le.identifier,X,ce,Ie,Le.enableProposedApi)},get fs(){return ve.value},registerFileSearchProvider:(X,ce)=>(B.checkProposedApiEnabled(Le),Ft.registerFileSearchProvider(X,ce)),registerTextSearchProvider:(X,ce)=>(B.checkProposedApiEnabled(Le),Ft.registerTextSearchProvider(X,ce)),registerRemoteAuthorityResolver:(X,ce)=>(B.checkProposedApiEnabled(Le),ye.registerRemoteAuthorityResolver(X,ce)),registerResourceLabelFormatter:X=>(B.checkProposedApiEnabled(Le),si.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,ce,Ie)=>Mt.onDidCreateFile(X,ce,Ie),onDidDeleteFiles:(X,ce,Ie)=>Mt.onDidDeleteFile(X,ce,Ie),onDidRenameFiles:(X,ce,Ie)=>Mt.onDidRenameFile(X,ce,Ie),onWillCreateFiles:(X,ce,Ie)=>Mt.getOnWillCreateFileEvent(Le)(X,ce,Ie),onWillDeleteFiles:(X,ce,Ie)=>Mt.getOnWillDeleteFileEvent(Le)(X,ce,Ie),onWillRenameFiles:(X,ce,Ie)=>Mt.getOnWillRenameFileEvent(Le)(X,ce,Ie),openTunnel:X=>(B.checkProposedApiEnabled(Le),vt.openTunnel(Le,X).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return B.checkProposedApiEnabled(Le),vt.getTunnels()},onDidChangeTunnels:(X,ce,Ie)=>(B.checkProposedApiEnabled(Le),vt.onDidChangeTunnels(X,ce,Ie)),registerPortAttributesProvider:(X,ce)=>(B.checkProposedApiEnabled(Le),vt.registerPortsAttributesProvider(X,ce)),registerTimelineProvider:(X,ce)=>(B.checkProposedApiEnabled(Le),ki.registerTimelineProvider(X,ce,Le.identifier,ut.converter)),get isTrusted(){return ae.trusted},requestWorkspaceTrust:X=>(B.checkProposedApiEnabled(Le),ae.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,ce,Ie)=>ae.onDidGrantWorkspaceTrust(X,ce,Ie)},_i={get inputBox(){return gt.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),gi.getLastInputBox(Le)},createSourceControl(X,ce,Ie){return gi.createSourceControl(Le,X,ce,Ie)}},Ei={createCommentController(X,ce){return Ci.createCommentController(Le,X,ce)}},Bt={get activeDebugSession(){return _t.activeDebugSession},get activeDebugConsole(){return _t.activeDebugConsole},get breakpoints(){return _t.breakpoints},onDidStartDebugSession(X,ce,Ie){return _t.onDidStartDebugSession(X,ce,Ie)},onDidTerminateDebugSession(X,ce,Ie){return _t.onDidTerminateDebugSession(X,ce,Ie)},onDidChangeActiveDebugSession(X,ce,Ie){return _t.onDidChangeActiveDebugSession(X,ce,Ie)},onDidReceiveDebugSessionCustomEvent(X,ce,Ie){return _t.onDidReceiveDebugSessionCustomEvent(X,ce,Ie)},onDidChangeBreakpoints(X,ce,Ie){return _t.onDidChangeBreakpoints(X,ce,Ie)},registerDebugConfigurationProvider(X,ce,Ie){return _t.registerDebugConfigurationProvider(X,ce,Ie||L.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,ce){return _t.registerDebugAdapterDescriptorFactory(Le,X,ce)},registerDebugAdapterTrackerFactory(X,ce){return _t.registerDebugAdapterTrackerFactory(X,ce)},startDebugging(X,ce,Ie){return!Ie||typeof Ie=="object"&&"configuration"in Ie?_t.startDebugging(X,ce,{parentSession:Ie}):_t.startDebugging(X,ce,Ie||{})},stopDebugging(X){return _t.stopDebugging(X)},addBreakpoints(X){return _t.addBreakpoints(X)},removeBreakpoints(X){return _t.removeBreakpoints(X)},asDebugSourceUri(X,ce){return _t.asDebugSourceUri(X,ce)}},Vt={registerTaskProvider:(X,ce)=>yt.registerTaskProvider(Le,X,ce),fetchTasks:X=>yt.fetchTasks(X),executeTask:X=>yt.executeTask(Le,X),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(X,ce,Ie)=>yt.onDidStartTask(X,ce,Ie),onDidEndTask:(X,ce,Ie)=>yt.onDidEndTask(X,ce,Ie),onDidStartTaskProcess:(X,ce,Ie)=>yt.onDidStartTaskProcess(X,ce,Ie),onDidEndTaskProcess:(X,ce,Ie)=>yt.onDidEndTaskProcess(X,ce,Ie)},Li={createNotebookController(X,ce,Ie,st,bt){return Di.createNotebookController(Le,X,ce,Ie,st,Le.enableProposedApi?bt:void 0)},registerNotebookCellStatusBarItemProvider:(X,ce)=>ht.registerNotebookCellStatusBarItemProvider(Le,X,ce),get onDidSaveNotebookDocument(){return B.checkProposedApiEnabled(Le),Gt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(X){return B.checkProposedApiEnabled(Le),$t.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return B.checkProposedApiEnabled(Le),ii.createRendererMessaging(X)},onDidChangeNotebookDocumentMetadata(X,ce,Ie){return B.checkProposedApiEnabled(Le),Gt.onDidChangeNotebookDocumentMetadata(X,ce,Ie)},onDidChangeNotebookCells(X,ce,Ie){return B.checkProposedApiEnabled(Le),ht.onDidChangeNotebookCells(X,ce,Ie)},onDidChangeNotebookCellExecutionState(X,ce,Ie){return B.checkProposedApiEnabled(Le),ht.onDidChangeNotebookCellExecutionState(X,ce,Ie)},onDidChangeCellOutputs(X,ce,Ie){return B.checkProposedApiEnabled(Le),ht.onDidChangeCellOutputs(X,ce,Ie)},onDidChangeCellMetadata(X,ce,Ie){return B.checkProposedApiEnabled(Le),ht.onDidChangeCellMetadata(X,ce,Ie)},createConcatTextDocument(X,ce){return B.checkProposedApiEnabled(Le),new Ge.ExtHostNotebookConcatDocument(ht,St,X,ce)}};return{version:Je.version,authentication:Ai,commands:Ti,comments:Ei,debug:Bt,env:Xt,extensions:Ri,languages:Fi,notebooks:Li,scm:_i,tasks:Vt,test:hi,window:Mi,workspace:wi,Breakpoint:L.Breakpoint,CallHierarchyIncomingCall:L.CallHierarchyIncomingCall,CallHierarchyItem:L.CallHierarchyItem,CallHierarchyOutgoingCall:L.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:o.CandidatePortSource,CodeAction:L.CodeAction,CodeActionKind:L.CodeActionKind,CodeActionTriggerKind:L.CodeActionTriggerKind,CodeLens:L.CodeLens,Color:L.Color,ColorInformation:L.ColorInformation,ColorPresentation:L.ColorPresentation,ColorThemeKind:L.ColorThemeKind,CommentMode:L.CommentMode,CommentThreadCollapsibleState:L.CommentThreadCollapsibleState,CompletionItem:L.CompletionItem,CompletionItemKind:L.CompletionItemKind,CompletionItemTag:L.CompletionItemTag,CompletionList:L.CompletionList,CompletionTriggerKind:L.CompletionTriggerKind,ConfigurationTarget:L.ConfigurationTarget,CustomExecution:L.CustomExecution,DebugAdapterExecutable:L.DebugAdapterExecutable,DebugAdapterInlineImplementation:L.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:L.DebugAdapterNamedPipeServer,DebugAdapterServer:L.DebugAdapterServer,DebugConfigurationProviderTriggerKind:L.DebugConfigurationProviderTriggerKind,DebugConsoleMode:L.DebugConsoleMode,DecorationRangeBehavior:L.DecorationRangeBehavior,Diagnostic:L.Diagnostic,DiagnosticRelatedInformation:L.DiagnosticRelatedInformation,DiagnosticSeverity:L.DiagnosticSeverity,DiagnosticTag:L.DiagnosticTag,Disposable:L.Disposable,DocumentHighlight:L.DocumentHighlight,DocumentHighlightKind:L.DocumentHighlightKind,DocumentLink:L.DocumentLink,DocumentSymbol:L.DocumentSymbol,EndOfLine:L.EndOfLine,EnvironmentVariableMutatorType:L.EnvironmentVariableMutatorType,EvaluatableExpression:L.EvaluatableExpression,InlineValueText:L.InlineValueText,InlineValueVariableLookup:L.InlineValueVariableLookup,InlineValueEvaluatableExpression:L.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:L.InlineCompletionTriggerKind,EventEmitter:S.Emitter,ExtensionKind:L.ExtensionKind,ExtensionMode:L.ExtensionMode,ExternalUriOpenerPriority:L.ExternalUriOpenerPriority,FileChangeType:L.FileChangeType,FileDecoration:L.FileDecoration,FileSystemError:L.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:L.FoldingRange,FoldingRangeKind:L.FoldingRangeKind,FunctionBreakpoint:L.FunctionBreakpoint,InlineCompletionItem:L.InlineSuggestion,InlineCompletionList:L.InlineSuggestions,Hover:L.Hover,IndentAction:C.IndentAction,Location:L.Location,MarkdownString:L.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:L.ParameterInformation,PortAutoForwardAction:L.PortAutoForwardAction,Position:L.Position,ProcessExecution:L.ProcessExecution,ProgressLocation:L.ProgressLocation,QuickInputButtons:L.QuickInputButtons,Range:L.Range,RelativePattern:L.RelativePattern,Selection:L.Selection,SelectionRange:L.SelectionRange,SemanticTokens:L.SemanticTokens,SemanticTokensBuilder:L.SemanticTokensBuilder,SemanticTokensEdit:L.SemanticTokensEdit,SemanticTokensEdits:L.SemanticTokensEdits,SemanticTokensLegend:L.SemanticTokensLegend,ShellExecution:L.ShellExecution,ShellQuoting:L.ShellQuoting,SignatureHelp:L.SignatureHelp,SignatureHelpTriggerKind:L.SignatureHelpTriggerKind,SignatureInformation:L.SignatureInformation,SnippetString:L.SnippetString,SourceBreakpoint:L.SourceBreakpoint,StandardTokenType:L.StandardTokenType,StatusBarAlignment:L.StatusBarAlignment,SymbolInformation:L.SymbolInformation,SymbolKind:L.SymbolKind,SymbolTag:L.SymbolTag,Task:L.Task,TaskGroup:L.TaskGroup,TaskPanelKind:L.TaskPanelKind,TaskRevealKind:L.TaskRevealKind,TaskScope:L.TaskScope,TerminalLink:L.TerminalLink,TerminalProfile:L.TerminalProfile,TextDocumentSaveReason:L.TextDocumentSaveReason,TextEdit:L.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:L.TextEditorLineNumbersStyle,TextEditorRevealType:L.TextEditorRevealType,TextEditorSelectionChangeKind:L.TextEditorSelectionChangeKind,ThemeColor:L.ThemeColor,ThemeIcon:L.ThemeIcon,TreeItem:L.TreeItem,TreeItemCollapsibleState:L.TreeItemCollapsibleState,UIKind:o.UIKind,Uri:k.URI,ViewColumn:L.ViewColumn,WorkspaceEdit:L.WorkspaceEdit,InlayHint:L.InlayHint,InlayHintKind:L.InlayHintKind,RemoteAuthorityResolverError:L.RemoteAuthorityResolverError,ResolvedAuthority:L.ResolvedAuthority,SourceControlInputBoxValidationType:L.SourceControlInputBoxValidationType,ExtensionRuntime:L.ExtensionRuntime,TimelineItem:L.TimelineItem,NotebookRange:L.NotebookRange,NotebookCellKind:L.NotebookCellKind,NotebookCellExecutionState:L.NotebookCellExecutionState,NotebookCellData:L.NotebookCellData,NotebookData:L.NotebookData,NotebookRendererScript:L.NotebookRendererScript,NotebookCellStatusBarAlignment:L.NotebookCellStatusBarAlignment,NotebookEditorRevealType:L.NotebookEditorRevealType,NotebookCellOutput:L.NotebookCellOutput,NotebookCellOutputItem:L.NotebookCellOutputItem,NotebookCellStatusBarItem:L.NotebookCellStatusBarItem,NotebookControllerAffinity:L.NotebookControllerAffinity,PortAttributes:L.PortAttributes,LinkedEditingRanges:L.LinkedEditingRanges,TestItemStatus:L.TestItemStatus,TestResultState:L.TestResultState,TestMessage:L.TestMessage,TextSearchCompleteMessageType:le.TextSearchCompleteMessageType,TestMessageSeverity:L.TestMessageSeverity,WorkspaceTrustState:L.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=rt}),define(we[219],_e([0,1,57,101,30,100,32,71,36,37,104,105,106,74,73,65,70,102,72,46,69,94,63]),function(ee,e,g,T,S,E,k,D,_,C,i,I,o,f,c,d,y,w,v,l,h,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),g.registerSingleton(f.IExtensionStoragePaths,f.ExtensionStoragePaths),g.registerSingleton(y.IExtHostApiDeprecationService,y.ExtHostApiDeprecationService),g.registerSingleton(D.IExtHostCommands,D.ExtHostCommands),g.registerSingleton(k.IExtHostConfiguration,k.ExtHostConfiguration),g.registerSingleton(v.IExtHostConsumerFileSystem,v.ExtHostConsumerFileSystem),g.registerSingleton(I.IExtHostDebugService,I.WorkerExtHostDebugService),g.registerSingleton(E.IExtHostDecorations,E.ExtHostDecorations),g.registerSingleton(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),g.registerSingleton(l.IExtHostFileSystemInfo,l.ExtHostFileSystemInfo),g.registerSingleton(T.IExtHostOutputService,T.ExtHostOutputService),g.registerSingleton(o.IExtHostSearch,o.ExtHostSearch),g.registerSingleton(c.IExtHostStorage,c.ExtHostStorage),g.registerSingleton(i.IExtHostTask,i.WorkerExtHostTask),g.registerSingleton(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),g.registerSingleton(d.IExtHostTunnelService,d.ExtHostTunnelService),g.registerSingleton(w.IExtHostWindow,w.ExtHostWindow),g.registerSingleton(S.IExtHostWorkspace,S.ExtHostWorkspace),g.registerSingleton(h.IExtHostSecretState,h.ExtHostSecretState),g.registerSingleton(m.IExtHostTelemetry,m.ExtHostTelemetry),g.registerSingleton(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(we[220],_e([0,1,218,33,214,6,12,5]),function(ee,e,g,T,S,E,k,D){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var C;(function(c){var d;const y=(d=self.trustedTypes)===null||d===void 0?void 0:d.createPolicy("TrustedFunctionWorkaround",{createScript:(v,...l)=>{l.forEach(n=>{var s;if(!((s=self.trustedTypes)===null||s===void 0?void 0:s.isScript(n)))throw new Error("TrustedScripts only, please")});const h=l.slice(0,-1).join(","),m=l.pop().toString();return`(function anonymous(${h}) {
${m}
})`}});function w(...v){return y?self.eval(y.createScript("",...v)):new Function(...v)}c.create=w})(C||(C={}));class i extends S.RequireInterceptor{_installInterceptor(){}getModule(d,y){for(let w of this._alternatives){let v=w(d);if(v){d=v;break}}if(this._factories.has(d))return this._factories.get(d).load(d,y,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends T.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=E.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const d=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);f(d,this._initData.environment.isExtensionDevelopmentDebug);const y=this._instaService.invokeFunction(g.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(i,y,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(d){return d.browser}async _loadCommonJSModule(d,y,w){var v,l,h,m,t,n,s,r;y=y.with({path:o(y.path,".js")}),d&&performance.mark(`code/extHost/willFetchExtensionCode/${d.value}`);const u=await fetch(y.toString(!0));if(d&&performance.mark(`code/extHost/didFetchExtensionCode/${d.value}`),u.status!==200)throw new Error(u.statusText);const b=await u.text(),p=`${y.toString(!0)}#vscode-extension`,P=`${b}
//# sourceURL=${p}`;let A;try{A=C.create((l=(v=I._ttpExtensionScripts)===null||v===void 0?void 0:v.createScript("module"))!==null&&l!==void 0?l:"module",(m=(h=I._ttpExtensionScripts)===null||h===void 0?void 0:h.createScript("exports"))!==null&&m!==void 0?m:"exports",(n=(t=I._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&n!==void 0?n:"require",(r=(s=I._ttpExtensionScripts)===null||s===void 0?void 0:s.createScript(P))!==null&&r!==void 0?r:P)}catch(H){throw console.error(d?`Loading code for extension ${d.value} failed: ${H.message}`:`Loading code failed: ${H.message}`),console.error(`${y.toString(!0)}${typeof H.line=="number"?` line ${H.line}`:""}${typeof H.column=="number"?` column ${H.column}`:""}`),console.error(H),H}const a={},R={exports:a},M=H=>{const ue=this._fakeModules.getModule(H,y);if(ue===void 0)throw new Error(`Cannot load module '${H}'`);return ue};try{return w.codeLoadingStart(),d&&performance.mark(`code/extHost/willLoadExtensionCode/${d.value}`),A(R,a,M),R.exports!==a?R.exports:a}finally{d&&performance.mark(`code/extHost/didLoadExtensionCode/${d.value}`),w.codeLoadingStop()}}async $setRemoteEnvironment(d){throw new Error("Not supported")}async _waitForDebuggerAttachment(d=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const y=Date.now()+d;for(;Date.now()<y&&!("__jsDebugIsReady"in globalThis);)await k.timeout(10)}}e.ExtHostExtensionService=I,I._ttpExtensionScripts=(_=self.trustedTypes)===null||_===void 0?void 0:_.createPolicy("ExtensionScripts",{createScript:c=>c});function o(c,d){return c.endsWith(d)?c:c+d}function f(c,d){y("info","log"),y("log","log"),y("warn","warn"),y("error","error");function y(l,h){const m=console[l];console[l]=function(){c.$logExtensionHostMessage({type:"__$console",severity:h,arguments:v(arguments)}),d&&m.apply(console,arguments)}}const w=1e5;function v(l){const h=[],m=[];if(l.length)for(let t=0;t<l.length;t++){if(typeof l[t]=="undefined")l[t]="undefined";else if(l[t]instanceof Error){const n=l[t];n.stack?l[t]=n.stack:l[t]=n.toString()}m.push(l[t])}try{const t=JSON.stringify(m,function(n,s){if(s&&typeof s=="object"){if(h.indexOf(s)!==-1)return"[Circular]";h.push(s)}return s});return t.length>w?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(we[221],_e([0,1,57,15,33,220,206]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),g.registerSingleton(S.IExtHostExtensionService,E.ExtHostExtensionService),g.registerSingleton(T.ILogService,k.ExtHostLogService)}),define(we[223],_e([0,1,23,3,175,215,208,14,75,219,221]),function(ee,e,g,T,S,E,k,D,_){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0});const i=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const I=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const y=(C=self.trustedTypes)===null||C===void 0?void 0:C.createPolicy("extensionHostWorker",{createScriptURL:v=>v}),w=self.Worker;Worker=function(v,l){const h=`importScripts('${v}');`;l=l||{},l.name=l.name||D.basename(v.toString());const m=new Blob([h],{type:"application/javascript"}),t=URL.createObjectURL(m);return new w(y?y.createScriptURL(t):t,l)}}else self.Worker=class extends k.NestedWorker{constructor(y,w){super(I,y,Object.assign({name:D.basename(y.toString())},w))}};const o=new class{exit(y){i()}async exists(y){return!0}async realpath(y){return y}};class f{constructor(){const w=new MessageChannel,v=new T.Emitter;let l=!1;I(w.port2,[w.port2]),w.port1.onmessage=h=>{const{data:m}=h;if(!(m instanceof ArrayBuffer)){console.warn("UNKNOWN data received",m);return}const t=g.VSBuffer.wrap(new Uint8Array(m,0,m.byteLength));if(S.isMessageOfType(t,2)){l=!0,d("received terminate message from renderer");return}v.fire(t)},this.protocol={onMessage:v.event,send:h=>{if(!l){const m=h.buffer.buffer.slice(h.buffer.byteOffset,h.buffer.byteOffset+h.buffer.byteLength);w.port1.postMessage(m,[m])}}}}}function c(y){return new Promise(w=>{const v=y.onMessage(l=>{v.dispose();const h=JSON.parse(l.toString());y.send(S.createMessageOfType(0)),w({protocol:y,initData:h})});y.send(S.createMessageOfType(1))})}let d=y=>i();(function(){const w=new f;_.mark("code/extHost/willConnectToRenderer"),c(w.protocol).then(v=>{_.mark("code/extHost/didWaitForInitData");const l=new E.ExtensionHostMain(v.protocol,v.initData,o,null);d=h=>l.terminate(h)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7dea6d7402b55671410a129661cad24b55aed9f4/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
